/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["exports","require","vs/base/common/lifecycle","vs/base/common/event","vs/base/browser/dom","vs/base/common/platform","vs/base/common/errors","vs/base/common/types","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/async","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/strings","vs/nls","vs/base/common/arrays","vs/base/browser/keyboardEvent","vs/base/common/uri","vs/base/browser/browser","vs/base/common/codicons","vs/base/common/themables","vs/base/browser/mouseEvent","vs/base/browser/ui/widget","vs/base/browser/event","vs/base/common/path","vs/base/browser/touch","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/cancellation","vs/base/common/network","vs/base/parts/sandbox/electron-sandbox/globals","vs/base/common/lazy","vs/base/common/buffer","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/actions","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/browser/ui/list/listWidget","vs/platform/instantiation/common/instantiation","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/range","vs/base/common/scrollable","vs/base/common/symbols","vs/base/common/objects","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/common/htmlContent","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/iframe","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/assert","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/map","vs/base/common/marked/marked","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/hash","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/iconLabel/iconLabelHover","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/browser/canIUse","vs/base/common/process","vs/base/common/extpath","vs/base/common/mime","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/browser/markdownRenderer","vs/base/browser/ui/iconLabel/iconLabelHover","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/common/mainProcessService","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/native/electron-sandbox/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],$e=function(re){for(var t=[],N=0,O=re.length;N<O;N++)t[N]=be[re[N]];return t};/*! @license DOMPurify 3.0.5 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/3.0.5/LICENSE */const{entries:Bt,setPrototypeOf:jt,isFrozen:Yt,getPrototypeOf:Qt,getOwnPropertyDescriptor:Xt}=Object;let{freeze:tt,seal:ut,create:Jt}=Object,{apply:St,construct:Ft}=typeof Reflect<"u"&&Reflect;St||(St=function(t,N,O){return t.apply(N,O)}),tt||(tt=function(t){return t}),ut||(ut=function(t){return t}),Ft||(Ft=function(t,N){return new t(...N)});const Zt=rt(Array.prototype.forEach),Ht=rt(Array.prototype.pop),mt=rt(Array.prototype.push),wt=rt(String.prototype.toLowerCase),Ot=rt(String.prototype.toString),ei=rt(String.prototype.match),ht=rt(String.prototype.replace),ti=rt(String.prototype.indexOf),ii=rt(String.prototype.trim),st=rt(RegExp.prototype.test),bt=ni(TypeError);function rt(re){return function(t){for(var N=arguments.length,O=new Array(N>1?N-1:0),i=1;i<N;i++)O[i-1]=arguments[i];return St(re,t,O)}}function ni(re){return function(){for(var t=arguments.length,N=new Array(t),O=0;O<t;O++)N[O]=arguments[O];return Ft(re,N)}}function Be(re,t,N){var O;N=(O=N)!==null&&O!==void 0?O:wt,jt&&jt(re,null);let i=t.length;for(;i--;){let j=t[i];if(typeof j=="string"){const A=N(j);A!==j&&(Yt(t)||(t[i]=A),j=A)}re[j]=!0}return re}function gt(re){const t=Jt(null);for(const[N,O]of Bt(re))t[N]=O;return t}function vt(re,t){for(;re!==null;){const O=Xt(re,t);if(O){if(O.get)return rt(O.get);if(typeof O.value=="function")return rt(O.value)}re=Qt(re)}function N(O){return console.warn("fallback value for",O),null}return N}const zt=tt(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),Pt=tt(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),Lt=tt(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feDropShadow","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feImage","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),si=tt(["animate","color-profile","cursor","discard","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),Tt=tt(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover","mprescripts"]),ri=tt(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Ut=tt(["#text"]),_t=tt(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","nonce","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),It=tt(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","transform-origin","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),qt=tt(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),Dt=tt(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),oi=ut(/\{\{[\w\W]*|[\w\W]*\}\}/gm),li=ut(/<%[\w\W]*|[\w\W]*%>/gm),ai=ut(/\${[\w\W]*}/gm),ui=ut(/^data-[\-\w.\u00B7-\uFFFF]/),hi=ut(/^aria-[\-\w]+$/),Wt=ut(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|sms|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),ci=ut(/^(?:\w+script|data):/i),fi=ut(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),Vt=ut(/^html$/i);var xt=Object.freeze({__proto__:null,MUSTACHE_EXPR:oi,ERB_EXPR:li,TMPLIT_EXPR:ai,DATA_ATTR:ui,ARIA_ATTR:hi,IS_ALLOWED_URI:Wt,IS_SCRIPT_OR_DATA:ci,ATTR_WHITESPACE:fi,DOCTYPE_NAME:Vt});const di=()=>typeof window>"u"?null:window,gi=function(t,N){if(typeof t!="object"||typeof t.createPolicy!="function")return null;let O=null;const i="data-tt-policy-suffix";N&&N.hasAttribute(i)&&(O=N.getAttribute(i));const j="dompurify"+(O?"#"+O:"");try{return t.createPolicy(j,{createHTML(A){return A},createScriptURL(A){return A}})}catch{return console.warn("TrustedTypes policy "+j+" could not be created."),null}};function Kt(){let re=arguments.length>0&&arguments[0]!==void 0?arguments[0]:di();const t=Pe=>Kt(Pe);if(t.version="3.0.5",t.removed=[],!re||!re.document||re.document.nodeType!==9)return t.isSupported=!1,t;const N=re.document,O=N.currentScript;let{document:i}=re;const{DocumentFragment:j,HTMLTemplateElement:A,Node:y,Element:o,NodeFilter:u,NamedNodeMap:g=re.NamedNodeMap||re.MozNamedAttrMap,HTMLFormElement:L,DOMParser:r,trustedTypes:l}=re,e=o.prototype,a=vt(e,"cloneNode"),n=vt(e,"nextSibling"),h=vt(e,"childNodes"),s=vt(e,"parentNode");if(typeof A=="function"){const Pe=i.createElement("template");Pe.content&&Pe.content.ownerDocument&&(i=Pe.content.ownerDocument)}let v,D="";const{implementation:E,createNodeIterator:f,createDocumentFragment:C,getElementsByTagName:T}=i,{importNode:P}=N;let m={};t.isSupported=typeof Bt=="function"&&typeof s=="function"&&E&&E.createHTMLDocument!==void 0;const{MUSTACHE_EXPR:$,ERB_EXPR:F,TMPLIT_EXPR:R,DATA_ATTR:B,ARIA_ATTR:M,IS_SCRIPT_OR_DATA:z,ATTR_WHITESPACE:te}=xt;let{IS_ALLOWED_URI:ne}=xt,se=null;const ce=Be({},[...zt,...Pt,...Lt,...Tt,...Ut]);let ue=null;const ae=Be({},[..._t,...It,...qt,...Dt]);let pe=Object.seal(Object.create(null,{tagNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},attributeNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},allowCustomizedBuiltInElements:{writable:!0,configurable:!1,enumerable:!0,value:!1}})),Oe=null,Te=null,Me=!0,fe=!0,ie=!1,K=!0,U=!1,ee=!1,J=!1,S=!1,_=!1,d=!1,p=!1,H=!0,Q=!1;const q="user-content-";let x=!0,W=!1,c={},k=null;const b=Be({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]);let w=null;const I=Be({},["audio","video","img","source","image","track"]);let V=null;const Z=Be({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),oe="http://www.w3.org/1998/Math/MathML",ge="http://www.w3.org/2000/svg",we="http://www.w3.org/1999/xhtml";let Ae=we,Ee=!1,ve=null;const Le=Be({},[oe,ge,we],Ot);let Fe;const Ke=["application/xhtml+xml","text/html"],je="text/html";let Ie,Ge=null;const G=i.createElement("form"),le=function(he){return he instanceof RegExp||he instanceof Function},me=function(he){if(!(Ge&&Ge===he)){if((!he||typeof he!="object")&&(he={}),he=gt(he),Fe=Ke.indexOf(he.PARSER_MEDIA_TYPE)===-1?Fe=je:Fe=he.PARSER_MEDIA_TYPE,Ie=Fe==="application/xhtml+xml"?Ot:wt,se="ALLOWED_TAGS"in he?Be({},he.ALLOWED_TAGS,Ie):ce,ue="ALLOWED_ATTR"in he?Be({},he.ALLOWED_ATTR,Ie):ae,ve="ALLOWED_NAMESPACES"in he?Be({},he.ALLOWED_NAMESPACES,Ot):Le,V="ADD_URI_SAFE_ATTR"in he?Be(gt(Z),he.ADD_URI_SAFE_ATTR,Ie):Z,w="ADD_DATA_URI_TAGS"in he?Be(gt(I),he.ADD_DATA_URI_TAGS,Ie):I,k="FORBID_CONTENTS"in he?Be({},he.FORBID_CONTENTS,Ie):b,Oe="FORBID_TAGS"in he?Be({},he.FORBID_TAGS,Ie):{},Te="FORBID_ATTR"in he?Be({},he.FORBID_ATTR,Ie):{},c="USE_PROFILES"in he?he.USE_PROFILES:!1,Me=he.ALLOW_ARIA_ATTR!==!1,fe=he.ALLOW_DATA_ATTR!==!1,ie=he.ALLOW_UNKNOWN_PROTOCOLS||!1,K=he.ALLOW_SELF_CLOSE_IN_ATTR!==!1,U=he.SAFE_FOR_TEMPLATES||!1,ee=he.WHOLE_DOCUMENT||!1,_=he.RETURN_DOM||!1,d=he.RETURN_DOM_FRAGMENT||!1,p=he.RETURN_TRUSTED_TYPE||!1,S=he.FORCE_BODY||!1,H=he.SANITIZE_DOM!==!1,Q=he.SANITIZE_NAMED_PROPS||!1,x=he.KEEP_CONTENT!==!1,W=he.IN_PLACE||!1,ne=he.ALLOWED_URI_REGEXP||Wt,Ae=he.NAMESPACE||we,pe=he.CUSTOM_ELEMENT_HANDLING||{},he.CUSTOM_ELEMENT_HANDLING&&le(he.CUSTOM_ELEMENT_HANDLING.tagNameCheck)&&(pe.tagNameCheck=he.CUSTOM_ELEMENT_HANDLING.tagNameCheck),he.CUSTOM_ELEMENT_HANDLING&&le(he.CUSTOM_ELEMENT_HANDLING.attributeNameCheck)&&(pe.attributeNameCheck=he.CUSTOM_ELEMENT_HANDLING.attributeNameCheck),he.CUSTOM_ELEMENT_HANDLING&&typeof he.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements=="boolean"&&(pe.allowCustomizedBuiltInElements=he.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements),U&&(fe=!1),d&&(_=!0),c&&(se=Be({},[...Ut]),ue=[],c.html===!0&&(Be(se,zt),Be(ue,_t)),c.svg===!0&&(Be(se,Pt),Be(ue,It),Be(ue,Dt)),c.svgFilters===!0&&(Be(se,Lt),Be(ue,It),Be(ue,Dt)),c.mathMl===!0&&(Be(se,Tt),Be(ue,qt),Be(ue,Dt))),he.ADD_TAGS&&(se===ce&&(se=gt(se)),Be(se,he.ADD_TAGS,Ie)),he.ADD_ATTR&&(ue===ae&&(ue=gt(ue)),Be(ue,he.ADD_ATTR,Ie)),he.ADD_URI_SAFE_ATTR&&Be(V,he.ADD_URI_SAFE_ATTR,Ie),he.FORBID_CONTENTS&&(k===b&&(k=gt(k)),Be(k,he.FORBID_CONTENTS,Ie)),x&&(se["#text"]=!0),ee&&Be(se,["html","head","body"]),se.table&&(Be(se,["tbody"]),delete Oe.tbody),he.TRUSTED_TYPES_POLICY){if(typeof he.TRUSTED_TYPES_POLICY.createHTML!="function")throw bt('TRUSTED_TYPES_POLICY configuration option must provide a "createHTML" hook.');if(typeof he.TRUSTED_TYPES_POLICY.createScriptURL!="function")throw bt('TRUSTED_TYPES_POLICY configuration option must provide a "createScriptURL" hook.');v=he.TRUSTED_TYPES_POLICY,D=v.createHTML("")}else v===void 0&&(v=gi(l,O)),v!==null&&typeof D=="string"&&(D=v.createHTML(""));tt&&tt(he),Ge=he}},De=Be({},["mi","mo","mn","ms","mtext"]),Ce=Be({},["foreignobject","desc","title","annotation-xml"]),Re=Be({},["title","style","font","a","script"]),He=Be({},Pt);Be(He,Lt),Be(He,si);const Ye=Be({},Tt);Be(Ye,ri);const Qe=function(he){let ye=s(he);(!ye||!ye.tagName)&&(ye={namespaceURI:Ae,tagName:"template"});const Ne=wt(he.tagName),Ue=wt(ye.tagName);return ve[he.namespaceURI]?he.namespaceURI===ge?ye.namespaceURI===we?Ne==="svg":ye.namespaceURI===oe?Ne==="svg"&&(Ue==="annotation-xml"||De[Ue]):!!He[Ne]:he.namespaceURI===oe?ye.namespaceURI===we?Ne==="math":ye.namespaceURI===ge?Ne==="math"&&Ce[Ue]:!!Ye[Ne]:he.namespaceURI===we?ye.namespaceURI===ge&&!Ce[Ue]||ye.namespaceURI===oe&&!De[Ue]?!1:!Ye[Ne]&&(Re[Ne]||!He[Ne]):!!(Fe==="application/xhtml+xml"&&ve[he.namespaceURI]):!1},We=function(he){mt(t.removed,{element:he});try{he.parentNode.removeChild(he)}catch{he.remove()}},_e=function(he,ye){try{mt(t.removed,{attribute:ye.getAttributeNode(he),from:ye})}catch{mt(t.removed,{attribute:null,from:ye})}if(ye.removeAttribute(he),he==="is"&&!ue[he])if(_||d)try{We(ye)}catch{}else try{ye.setAttribute(he,"")}catch{}},et=function(he){let ye,Ne;if(S)he="<remove></remove>"+he;else{const nt=ei(he,/^[\r\n\t ]+/);Ne=nt&&nt[0]}Fe==="application/xhtml+xml"&&Ae===we&&(he='<html xmlns="http://www.w3.org/1999/xhtml"><head></head><body>'+he+"</body></html>");const Ue=v?v.createHTML(he):he;if(Ae===we)try{ye=new r().parseFromString(Ue,Fe)}catch{}if(!ye||!ye.documentElement){ye=E.createDocument(Ae,"template",null);try{ye.documentElement.innerHTML=Ee?D:Ue}catch{}}const Xe=ye.body||ye.documentElement;return he&&Ne&&Xe.insertBefore(i.createTextNode(Ne),Xe.childNodes[0]||null),Ae===we?T.call(ye,ee?"html":"body")[0]:ee?ye.documentElement:Xe},it=function(he){return f.call(he.ownerDocument||he,he,u.SHOW_ELEMENT|u.SHOW_COMMENT|u.SHOW_TEXT,null,!1)},ft=function(he){return he instanceof L&&(typeof he.nodeName!="string"||typeof he.textContent!="string"||typeof he.removeChild!="function"||!(he.attributes instanceof g)||typeof he.removeAttribute!="function"||typeof he.setAttribute!="function"||typeof he.namespaceURI!="string"||typeof he.insertBefore!="function"||typeof he.hasChildNodes!="function")},ct=function(he){return typeof y=="object"?he instanceof y:he&&typeof he=="object"&&typeof he.nodeType=="number"&&typeof he.nodeName=="string"},ot=function(he,ye,Ne){m[he]&&Zt(m[he],Ue=>{Ue.call(t,ye,Ne,Ge)})},yt=function(he){let ye;if(ot("beforeSanitizeElements",he,null),ft(he))return We(he),!0;const Ne=Ie(he.nodeName);if(ot("uponSanitizeElement",he,{tagName:Ne,allowedTags:se}),he.hasChildNodes()&&!ct(he.firstElementChild)&&(!ct(he.content)||!ct(he.content.firstElementChild))&&st(/<[/\w]/g,he.innerHTML)&&st(/<[/\w]/g,he.textContent))return We(he),!0;if(!se[Ne]||Oe[Ne]){if(!Oe[Ne]&&At(Ne)&&(pe.tagNameCheck instanceof RegExp&&st(pe.tagNameCheck,Ne)||pe.tagNameCheck instanceof Function&&pe.tagNameCheck(Ne)))return!1;if(x&&!k[Ne]){const Ue=s(he)||he.parentNode,Xe=h(he)||he.childNodes;if(Xe&&Ue){const nt=Xe.length;for(let Ve=nt-1;Ve>=0;--Ve)Ue.insertBefore(a(Xe[Ve],!0),n(he))}}return We(he),!0}return he instanceof o&&!Qe(he)||(Ne==="noscript"||Ne==="noembed"||Ne==="noframes")&&st(/<\/no(script|embed|frames)/i,he.innerHTML)?(We(he),!0):(U&&he.nodeType===3&&(ye=he.textContent,ye=ht(ye,$," "),ye=ht(ye,F," "),ye=ht(ye,R," "),he.textContent!==ye&&(mt(t.removed,{element:he.cloneNode()}),he.textContent=ye)),ot("afterSanitizeElements",he,null),!1)},Et=function(he,ye,Ne){if(H&&(ye==="id"||ye==="name")&&(Ne in i||Ne in G))return!1;if(!(fe&&!Te[ye]&&st(B,ye))){if(!(Me&&st(M,ye))){if(!ue[ye]||Te[ye]){if(!(At(he)&&(pe.tagNameCheck instanceof RegExp&&st(pe.tagNameCheck,he)||pe.tagNameCheck instanceof Function&&pe.tagNameCheck(he))&&(pe.attributeNameCheck instanceof RegExp&&st(pe.attributeNameCheck,ye)||pe.attributeNameCheck instanceof Function&&pe.attributeNameCheck(ye))||ye==="is"&&pe.allowCustomizedBuiltInElements&&(pe.tagNameCheck instanceof RegExp&&st(pe.tagNameCheck,Ne)||pe.tagNameCheck instanceof Function&&pe.tagNameCheck(Ne))))return!1}else if(!V[ye]){if(!st(ne,ht(Ne,te,""))){if(!((ye==="src"||ye==="xlink:href"||ye==="href")&&he!=="script"&&ti(Ne,"data:")===0&&w[he])){if(!(ie&&!st(z,ht(Ne,te,"")))){if(Ne)return!1}}}}}}return!0},At=function(he){return he.indexOf("-")>0},kt=function(he){let ye,Ne,Ue,Xe;ot("beforeSanitizeAttributes",he,null);const{attributes:nt}=he;if(!nt)return;const Ve={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:ue};for(Xe=nt.length;Xe--;){ye=nt[Xe];const{name:lt,namespaceURI:$t}=ye;if(Ne=lt==="value"?ye.value:ii(ye.value),Ue=Ie(lt),Ve.attrName=Ue,Ve.attrValue=Ne,Ve.keepAttr=!0,Ve.forceKeepAttr=void 0,ot("uponSanitizeAttribute",he,Ve),Ne=Ve.attrValue,Ve.forceKeepAttr||(_e(lt,he),!Ve.keepAttr))continue;if(!K&&st(/\/>/i,Ne)){_e(lt,he);continue}U&&(Ne=ht(Ne,$," "),Ne=ht(Ne,F," "),Ne=ht(Ne,R," "));const Nt=Ie(he.nodeName);if(Et(Nt,Ue,Ne)){if(Q&&(Ue==="id"||Ue==="name")&&(_e(lt,he),Ne=q+Ne),v&&typeof l=="object"&&typeof l.getAttributeType=="function"&&!$t)switch(l.getAttributeType(Nt,Ue)){case"TrustedHTML":{Ne=v.createHTML(Ne);break}case"TrustedScriptURL":{Ne=v.createScriptURL(Ne);break}}try{$t?he.setAttributeNS($t,lt,Ne):he.setAttribute(lt,Ne),Ht(t.removed)}catch{}}}ot("afterSanitizeAttributes",he,null)},Rt=function Pe(he){let ye;const Ne=it(he);for(ot("beforeSanitizeShadowDOM",he,null);ye=Ne.nextNode();)ot("uponSanitizeShadowNode",ye,null),!yt(ye)&&(ye.content instanceof j&&Pe(ye.content),kt(ye));ot("afterSanitizeShadowDOM",he,null)};return t.sanitize=function(Pe){let he=arguments.length>1&&arguments[1]!==void 0?arguments[1]:{},ye,Ne,Ue,Xe;if(Ee=!Pe,Ee&&(Pe="<!-->"),typeof Pe!="string"&&!ct(Pe))if(typeof Pe.toString=="function"){if(Pe=Pe.toString(),typeof Pe!="string")throw bt("dirty is not a string, aborting")}else throw bt("toString is not a function");if(!t.isSupported)return Pe;if(J||me(he),t.removed=[],typeof Pe=="string"&&(W=!1),W){if(Pe.nodeName){const lt=Ie(Pe.nodeName);if(!se[lt]||Oe[lt])throw bt("root node is forbidden and cannot be sanitized in-place")}}else if(Pe instanceof y)ye=et("<!---->"),Ne=ye.ownerDocument.importNode(Pe,!0),Ne.nodeType===1&&Ne.nodeName==="BODY"||Ne.nodeName==="HTML"?ye=Ne:ye.appendChild(Ne);else{if(!_&&!U&&!ee&&Pe.indexOf("<")===-1)return v&&p?v.createHTML(Pe):Pe;if(ye=et(Pe),!ye)return _?null:p?D:""}ye&&S&&We(ye.firstChild);const nt=it(W?Pe:ye);for(;Ue=nt.nextNode();)yt(Ue)||(Ue.content instanceof j&&Rt(Ue.content),kt(Ue));if(W)return Pe;if(_){if(d)for(Xe=C.call(ye.ownerDocument);ye.firstChild;)Xe.appendChild(ye.firstChild);else Xe=ye;return(ue.shadowroot||ue.shadowrootmode)&&(Xe=P.call(N,Xe,!0)),Xe}let Ve=ee?ye.outerHTML:ye.innerHTML;return ee&&se["!doctype"]&&ye.ownerDocument&&ye.ownerDocument.doctype&&ye.ownerDocument.doctype.name&&st(Vt,ye.ownerDocument.doctype.name)&&(Ve="<!DOCTYPE "+ye.ownerDocument.doctype.name+`>
`+Ve),U&&(Ve=ht(Ve,$," "),Ve=ht(Ve,F," "),Ve=ht(Ve,R," ")),v&&p?v.createHTML(Ve):Ve},t.setConfig=function(Pe){me(Pe),J=!0},t.clearConfig=function(){Ge=null,J=!1},t.isValidAttribute=function(Pe,he,ye){Ge||me({});const Ne=Ie(Pe),Ue=Ie(he);return Et(Ne,Ue,ye)},t.addHook=function(Pe,he){typeof he=="function"&&(m[Pe]=m[Pe]||[],mt(m[Pe],he))},t.removeHook=function(Pe){if(m[Pe])return Ht(m[Pe])},t.removeHooks=function(Pe){m[Pe]&&(m[Pe]=[])},t.removeAllHooks=function(){m={}},t}var mi=Kt();define("vs/base/browser/dompurify/dompurify",function(){return mi}),define(be[39],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nP=t.$mP=void 0;class N{constructor(A){this.domNode=A,this.a="",this.b="",this.c="",this.d="",this.e="",this.f="",this.g="",this.h="",this.i="",this.j="",this.k="",this.l="",this.m="",this.n="",this.o="",this.p="",this.q="",this.r="",this.s="",this.t="",this.u="",this.v="",this.w="",this.x="",this.y="",this.z="",this.A=!1,this.B="none",this.C=""}setMaxWidth(A){const y=O(A);this.a!==y&&(this.a=y,this.domNode.style.maxWidth=this.a)}setWidth(A){const y=O(A);this.b!==y&&(this.b=y,this.domNode.style.width=this.b)}setHeight(A){const y=O(A);this.c!==y&&(this.c=y,this.domNode.style.height=this.c)}setTop(A){const y=O(A);this.d!==y&&(this.d=y,this.domNode.style.top=this.d)}setLeft(A){const y=O(A);this.e!==y&&(this.e=y,this.domNode.style.left=this.e)}setBottom(A){const y=O(A);this.f!==y&&(this.f=y,this.domNode.style.bottom=this.f)}setRight(A){const y=O(A);this.g!==y&&(this.g=y,this.domNode.style.right=this.g)}setPaddingTop(A){const y=O(A);this.h!==y&&(this.h=y,this.domNode.style.paddingTop=this.h)}setPaddingLeft(A){const y=O(A);this.i!==y&&(this.i=y,this.domNode.style.paddingLeft=this.i)}setPaddingBottom(A){const y=O(A);this.j!==y&&(this.j=y,this.domNode.style.paddingBottom=this.j)}setPaddingRight(A){const y=O(A);this.k!==y&&(this.k=y,this.domNode.style.paddingRight=this.k)}setFontFamily(A){this.l!==A&&(this.l=A,this.domNode.style.fontFamily=this.l)}setFontWeight(A){this.m!==A&&(this.m=A,this.domNode.style.fontWeight=this.m)}setFontSize(A){const y=O(A);this.n!==y&&(this.n=y,this.domNode.style.fontSize=this.n)}setFontStyle(A){this.o!==A&&(this.o=A,this.domNode.style.fontStyle=this.o)}setFontFeatureSettings(A){this.p!==A&&(this.p=A,this.domNode.style.fontFeatureSettings=this.p)}setFontVariationSettings(A){this.q!==A&&(this.q=A,this.domNode.style.fontVariationSettings=this.q)}setTextDecoration(A){this.r!==A&&(this.r=A,this.domNode.style.textDecoration=this.r)}setLineHeight(A){const y=O(A);this.s!==y&&(this.s=y,this.domNode.style.lineHeight=this.s)}setLetterSpacing(A){const y=O(A);this.t!==y&&(this.t=y,this.domNode.style.letterSpacing=this.t)}setClassName(A){this.u!==A&&(this.u=A,this.domNode.className=this.u)}toggleClassName(A,y){this.domNode.classList.toggle(A,y),this.u=this.domNode.className}setDisplay(A){this.v!==A&&(this.v=A,this.domNode.style.display=this.v)}setPosition(A){this.w!==A&&(this.w=A,this.domNode.style.position=this.w)}setVisibility(A){this.x!==A&&(this.x=A,this.domNode.style.visibility=this.x)}setColor(A){this.y!==A&&(this.y=A,this.domNode.style.color=this.y)}setBackgroundColor(A){this.z!==A&&(this.z=A,this.domNode.style.backgroundColor=this.z)}setLayerHinting(A){this.A!==A&&(this.A=A,this.domNode.style.transform=this.A?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(A){this.C!==A&&(this.C=A,this.domNode.style.boxShadow=A)}setContain(A){this.B!==A&&(this.B=A,this.domNode.style.contain=this.B)}setAttribute(A,y){this.domNode.setAttribute(A,y)}removeAttribute(A){this.domNode.removeAttribute(A)}appendChild(A){this.domNode.appendChild(A.domNode)}removeChild(A){this.domNode.removeChild(A.domNode)}}t.$mP=N;function O(j){return typeof j=="number"?`${j}px`:j}function i(j){return new N(j)}t.$nP=i}),define(be[66],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$YN=void 0;let N=!1,O=null;function i(A){if(!A.parent||A.parent===A)return null;try{const y=A.location,o=A.parent.location;if(y.origin!=="null"&&o.origin!=="null"&&y.origin!==o.origin)return N=!0,null}catch{return N=!0,null}return A.parent}class j{static getSameOriginWindowChain(){if(!O){O=[];let y=window,o;do o=i(y),o?O.push({window:y,iframeElement:y.frameElement||null}):O.push({window:y,iframeElement:null}),y=o;while(y)}return O.slice(0)}static hasDifferentOriginAncestor(){return O||this.getSameOriginWindowChain(),N}static getPositionOfChildWindowRelativeToAncestorWindow(y,o){if(!o||y===o)return{top:0,left:0};let u=0,g=0;const L=this.getSameOriginWindowChain();for(const r of L){if(u+=r.window.scrollY,g+=r.window.scrollX,r.window===o||!r.iframeElement)break;const l=r.iframeElement.getBoundingClientRect();u+=l.top,g+=l.left}return{top:u,left:g}}}t.$YN=j}),define(be[67],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$WP=t.$VP=t.$UP=t.ListDragOverEffect=void 0;var N;(function(j){j[j.Copy=0]="Copy",j[j.Move=1]="Move"})(N||(t.ListDragOverEffect=N={})),t.$UP={reject(){return{accept:!1}},accept(){return{accept:!0}}};class O extends Error{constructor(A,y){super(`ListError [${A}] ${y}`)}}t.$VP=O;class i{constructor(){this.c=new WeakMap}getHeight(A){return this.c.get(A)??this.d(A)}setDynamicHeight(A,y){y>0&&this.c.set(A,y)}}t.$WP=i}),define(be[68],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$TP=void 0;class N{constructor(i){this.a=i}splice(i,j,A){this.a.forEach(y=>y.splice(i,j,A))}}t.$TP=N}),define(be[40],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sP=void 0;const N=20;class O{constructor(j,A,y,o,u,g){this.a=Math.round(A),this.b=Math.round(y),this.c=Math.round(j),this.d=o,this.e=u,this.f=g,this.g=0,this.h=!1,this.i=0,this.j=0,this.k=0,this.m()}clone(){return new O(this.c,this.a,this.b,this.d,this.e,this.f)}setVisibleSize(j){const A=Math.round(j);return this.d!==A?(this.d=A,this.m(),!0):!1}setScrollSize(j){const A=Math.round(j);return this.e!==A?(this.e=A,this.m(),!0):!1}setScrollPosition(j){const A=Math.round(j);return this.f!==A?(this.f=A,this.m(),!0):!1}setScrollbarSize(j){this.a=Math.round(j)}setOppositeScrollbarSize(j){this.b=Math.round(j)}static l(j,A,y,o,u){const g=Math.max(0,y-j),L=Math.max(0,g-2*A),r=o>0&&o>y;if(!r)return{computedAvailableSize:Math.round(g),computedIsNeeded:r,computedSliderSize:Math.round(L),computedSliderRatio:0,computedSliderPosition:0};const l=Math.round(Math.max(N,Math.floor(y*L/o))),e=(L-l)/(o-y),a=u*e;return{computedAvailableSize:Math.round(g),computedIsNeeded:r,computedSliderSize:Math.round(l),computedSliderRatio:e,computedSliderPosition:Math.round(a)}}m(){const j=O.l(this.b,this.c,this.d,this.e,this.f);this.g=j.computedAvailableSize,this.h=j.computedIsNeeded,this.i=j.computedSliderSize,this.j=j.computedSliderRatio,this.k=j.computedSliderPosition}getArrowSize(){return this.c}getScrollPosition(){return this.f}getRectangleLargeSize(){return this.g}getRectangleSmallSize(){return this.a}isNeeded(){return this.h}getSliderSize(){return this.i}getSliderPosition(){return this.k}getDesiredScrollPositionFromOffset(j){if(!this.h)return 0;const A=j-this.c-this.i/2;return Math.round(A/this.j)}getDesiredScrollPositionFromOffsetPaged(j){if(!this.h)return 0;const A=j-this.c;let y=this.f;return A<this.k?y-=this.d:y+=this.d,y}getDesiredScrollPositionFromDelta(j){if(!this.h)return 0;const A=this.k+j;return Math.round(A/this.j)}}t.$sP=O}),define(be[24],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$PR=t.$OR=t.$NR=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.ObjectTreeElementCollapseState=t.TreeVisibility=void 0;var N;(function(o){o[o.Hidden=0]="Hidden",o[o.Visible=1]="Visible",o[o.Recurse=2]="Recurse"})(N||(t.TreeVisibility=N={}));var O;(function(o){o[o.Expanded=0]="Expanded",o[o.Collapsed=1]="Collapsed",o[o.PreserveOrExpanded=2]="PreserveOrExpanded",o[o.PreserveOrCollapsed=3]="PreserveOrCollapsed"})(O||(t.ObjectTreeElementCollapseState=O={}));var i;(function(o){o[o.Unknown=0]="Unknown",o[o.Twistie=1]="Twistie",o[o.Element=2]="Element",o[o.Filter=3]="Filter"})(i||(t.TreeMouseEventTarget=i={}));var j;(function(o){o[o.Down=0]="Down",o[o.Up=1]="Up"})(j||(t.TreeDragOverBubble=j={})),t.$NR={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown(o=!1){return{accept:!0,bubble:0,autoExpand:o}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:0}},acceptCopyBubbleDown(o=!1){return{accept:!0,bubble:0,effect:0,autoExpand:o}}};class A extends Error{constructor(u,g){super(`TreeError [${u}] ${g}`)}}t.$OR=A;class y{constructor(u){this.a=u,this.b=new WeakMap}map(u){let g=this.b.get(u);return g||(g=this.a(u),this.b.set(u,g)),g}}t.$PR=y}),define(be[69],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$L=t.$K=t.$J=t.$I=void 0;function N(A,y){const o=Object.create(null);for(const u of A){const g=y(u);let L=o[g];L||(L=o[g]=[]),L.push(u)}return o}t.$I=N;function O(A,y){const o=[],u=[];for(const g of A)y.has(g)||o.push(g);for(const g of y)A.has(g)||u.push(g);return{removed:o,added:u}}t.$J=O;function i(A,y){const o=[],u=[];for(const[g,L]of A)y.has(g)||o.push(L);for(const[g,L]of y)A.has(g)||u.push(L);return{removed:o,added:u}}t.$K=i;class j{constructor(){this.a=new Map}add(y,o){let u=this.a.get(y);u||(u=new Set,this.a.set(y,u)),u.add(o)}delete(y,o){const u=this.a.get(y);u&&(u.delete(o),u.size===0&&this.a.delete(y))}forEach(y,o){const u=this.a.get(y);u&&u.forEach(o)}get(y){const o=this.a.get(y);return o||new Set}}t.$L=j}),define(be[70],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ds=t.$cs=t.$bs=t.$as=void 0;function N(y,o){const u=Math.pow(10,o);return Math.round(y*u)/u}class O{constructor(o,u,g,L=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,o))|0,this.g=Math.min(255,Math.max(0,u))|0,this.b=Math.min(255,Math.max(0,g))|0,this.a=N(Math.max(Math.min(1,L),0),3)}static equals(o,u){return o.r===u.r&&o.g===u.g&&o.b===u.b&&o.a===u.a}}t.$as=O;class i{constructor(o,u,g,L){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,o),0)|0,this.s=N(Math.max(Math.min(1,u),0),3),this.l=N(Math.max(Math.min(1,g),0),3),this.a=N(Math.max(Math.min(1,L),0),3)}static equals(o,u){return o.h===u.h&&o.s===u.s&&o.l===u.l&&o.a===u.a}static fromRGBA(o){const u=o.r/255,g=o.g/255,L=o.b/255,r=o.a,l=Math.max(u,g,L),e=Math.min(u,g,L);let a=0,n=0;const h=(e+l)/2,s=l-e;if(s>0){switch(n=Math.min(h<=.5?s/(2*h):s/(2-2*h),1),l){case u:a=(g-L)/s+(g<L?6:0);break;case g:a=(L-u)/s+2;break;case L:a=(u-g)/s+4;break}a*=60,a=Math.round(a)}return new i(a,n,h,r)}static i(o,u,g){return g<0&&(g+=1),g>1&&(g-=1),g<1/6?o+(u-o)*6*g:g<1/2?u:g<2/3?o+(u-o)*(2/3-g)*6:o}static toRGBA(o){const u=o.h/360,{s:g,l:L,a:r}=o;let l,e,a;if(g===0)l=e=a=L;else{const n=L<.5?L*(1+g):L+g-L*g,h=2*L-n;l=i.i(h,n,u+1/3),e=i.i(h,n,u),a=i.i(h,n,u-1/3)}return new O(Math.round(l*255),Math.round(e*255),Math.round(a*255),r)}}t.$bs=i;class j{constructor(o,u,g,L){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,o),0)|0,this.s=N(Math.max(Math.min(1,u),0),3),this.v=N(Math.max(Math.min(1,g),0),3),this.a=N(Math.max(Math.min(1,L),0),3)}static equals(o,u){return o.h===u.h&&o.s===u.s&&o.v===u.v&&o.a===u.a}static fromRGBA(o){const u=o.r/255,g=o.g/255,L=o.b/255,r=Math.max(u,g,L),l=Math.min(u,g,L),e=r-l,a=r===0?0:e/r;let n;return e===0?n=0:r===u?n=((g-L)/e%6+6)%6:r===g?n=(L-u)/e+2:n=(u-g)/e+4,new j(Math.round(n*60),a,r,o.a)}static toRGBA(o){const{h:u,s:g,v:L,a:r}=o,l=L*g,e=l*(1-Math.abs(u/60%2-1)),a=L-l;let[n,h,s]=[0,0,0];return u<60?(n=l,h=e):u<120?(n=e,h=l):u<180?(h=l,s=e):u<240?(h=e,s=l):u<300?(n=e,s=l):u<=360&&(n=l,s=e),n=Math.round((n+a)*255),h=Math.round((h+a)*255),s=Math.round((s+a)*255),new O(n,h,s,r)}}t.$cs=j;class A{static fromHex(o){return A.Format.CSS.parseHex(o)||A.red}static equals(o,u){return!o&&!u?!0:!o||!u?!1:o.equals(u)}get hsla(){return this.i?this.i:i.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:j.fromRGBA(this.rgba)}constructor(o){if(o)if(o instanceof O)this.rgba=o;else if(o instanceof i)this.i=o,this.rgba=i.toRGBA(o);else if(o instanceof j)this.j=o,this.rgba=j.toRGBA(o);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(o){return!!o&&O.equals(this.rgba,o.rgba)&&i.equals(this.hsla,o.hsla)&&j.equals(this.hsva,o.hsva)}getRelativeLuminance(){const o=A.k(this.rgba.r),u=A.k(this.rgba.g),g=A.k(this.rgba.b),L=.2126*o+.7152*u+.0722*g;return N(L,4)}static k(o){const u=o/255;return u<=.03928?u/12.92:Math.pow((u+.055)/1.055,2.4)}getContrastRatio(o){const u=this.getRelativeLuminance(),g=o.getRelativeLuminance();return u>g?(u+.05)/(g+.05):(g+.05)/(u+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(o){const u=this.getRelativeLuminance(),g=o.getRelativeLuminance();return u>g}isDarkerThan(o){const u=this.getRelativeLuminance(),g=o.getRelativeLuminance();return u<g}lighten(o){return new A(new i(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*o,this.hsla.a))}darken(o){return new A(new i(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*o,this.hsla.a))}transparent(o){const{r:u,g,b:L,a:r}=this.rgba;return new A(new O(u,g,L,r*o))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new A(new O(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(o){const u=o.rgba,g=this.rgba.a,L=u.a,r=g+L*(1-g);if(r<1e-6)return A.transparent;const l=this.rgba.r*g/r+u.r*L*(1-g)/r,e=this.rgba.g*g/r+u.g*L*(1-g)/r,a=this.rgba.b*g/r+u.b*L*(1-g)/r;return new A(new O(l,e,a,r))}makeOpaque(o){if(this.isOpaque()||o.rgba.a!==1)return this;const{r:u,g,b:L,a:r}=this.rgba;return new A(new O(o.rgba.r-r*(o.rgba.r-u),o.rgba.g-r*(o.rgba.g-g),o.rgba.b-r*(o.rgba.b-L),1))}flatten(...o){const u=o.reduceRight((g,L)=>A.o(L,g));return A.o(this,u)}static o(o,u){const g=1-o.rgba.a;return new A(new O(g*u.rgba.r+o.rgba.a*o.rgba.r,g*u.rgba.g+o.rgba.a*o.rgba.g,g*u.rgba.b+o.rgba.a*o.rgba.b))}toString(){return this.u||(this.u=A.Format.CSS.format(this)),this.u}static getLighterColor(o,u,g){if(o.isLighterThan(u))return o;g=g||.5;const L=o.getRelativeLuminance(),r=u.getRelativeLuminance();return g=g*(r-L)/r,o.lighten(g)}static getDarkerColor(o,u,g){if(o.isDarkerThan(u))return o;g=g||.5;const L=o.getRelativeLuminance(),r=u.getRelativeLuminance();return g=g*(L-r)/L,o.darken(g)}static{this.white=new A(new O(255,255,255,1))}static{this.black=new A(new O(0,0,0,1))}static{this.red=new A(new O(255,0,0,1))}static{this.blue=new A(new O(0,0,255,1))}static{this.green=new A(new O(0,255,0,1))}static{this.cyan=new A(new O(0,255,255,1))}static{this.lightgrey=new A(new O(211,211,211,1))}static{this.transparent=new A(new O(0,0,0,0))}}t.$ds=A,function(y){let o;(function(u){let g;(function(L){function r(f){return f.rgba.a===1?`rgb(${f.rgba.r}, ${f.rgba.g}, ${f.rgba.b})`:y.Format.CSS.formatRGBA(f)}L.formatRGB=r;function l(f){return`rgba(${f.rgba.r}, ${f.rgba.g}, ${f.rgba.b}, ${+f.rgba.a.toFixed(2)})`}L.formatRGBA=l;function e(f){return f.hsla.a===1?`hsl(${f.hsla.h}, ${(f.hsla.s*100).toFixed(2)}%, ${(f.hsla.l*100).toFixed(2)}%)`:y.Format.CSS.formatHSLA(f)}L.formatHSL=e;function a(f){return`hsla(${f.hsla.h}, ${(f.hsla.s*100).toFixed(2)}%, ${(f.hsla.l*100).toFixed(2)}%, ${f.hsla.a.toFixed(2)})`}L.formatHSLA=a;function n(f){const C=f.toString(16);return C.length!==2?"0"+C:C}function h(f){return`#${n(f.rgba.r)}${n(f.rgba.g)}${n(f.rgba.b)}`}L.formatHex=h;function s(f,C=!1){return C&&f.rgba.a===1?y.Format.CSS.formatHex(f):`#${n(f.rgba.r)}${n(f.rgba.g)}${n(f.rgba.b)}${n(Math.round(f.rgba.a*255))}`}L.formatHexA=s;function v(f){return f.isOpaque()?y.Format.CSS.formatHex(f):y.Format.CSS.formatRGBA(f)}L.format=v;function D(f){const C=f.length;if(C===0||f.charCodeAt(0)!==35)return null;if(C===7){const T=16*E(f.charCodeAt(1))+E(f.charCodeAt(2)),P=16*E(f.charCodeAt(3))+E(f.charCodeAt(4)),m=16*E(f.charCodeAt(5))+E(f.charCodeAt(6));return new y(new O(T,P,m,1))}if(C===9){const T=16*E(f.charCodeAt(1))+E(f.charCodeAt(2)),P=16*E(f.charCodeAt(3))+E(f.charCodeAt(4)),m=16*E(f.charCodeAt(5))+E(f.charCodeAt(6)),$=16*E(f.charCodeAt(7))+E(f.charCodeAt(8));return new y(new O(T,P,m,$/255))}if(C===4){const T=E(f.charCodeAt(1)),P=E(f.charCodeAt(2)),m=E(f.charCodeAt(3));return new y(new O(16*T+T,16*P+P,16*m+m))}if(C===5){const T=E(f.charCodeAt(1)),P=E(f.charCodeAt(2)),m=E(f.charCodeAt(3)),$=E(f.charCodeAt(4));return new y(new O(16*T+T,16*P+P,16*m+m,(16*$+$)/255))}return null}L.parseHex=D;function E(f){switch(f){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(g=u.CSS||(u.CSS={}))})(o=y.Format||(y.Format={}))}(A||(t.$ds=A={}))}),define(be[25],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Vg=t.$Ug=t.$Tg=void 0;function N(A){return(y,o,u)=>{let g=null,L=null;if(typeof u.value=="function"?(g="value",L=u.value):typeof u.get=="function"&&(g="get",L=u.get),!L)throw new Error("not supported");u[g]=A(L,o)}}function O(A,y,o){let u=null,g=null;if(typeof o.value=="function"?(u="value",g=o.value,g.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof o.get=="function"&&(u="get",g=o.get),!g)throw new Error("not supported");const L=`$memoize$${y}`;o[u]=function(...r){return this.hasOwnProperty(L)||Object.defineProperty(this,L,{configurable:!1,enumerable:!1,writable:!1,value:g.apply(this,r)}),this[L]}}t.$Tg=O;function i(A,y,o){return N((u,g)=>{const L=`$debounce$${g}`,r=`$debounce$result$${g}`;return function(...l){this[r]||(this[r]=o?o():void 0),clearTimeout(this[L]),y&&(this[r]=y(this[r],...l),l=[this[r]]),this[L]=setTimeout(()=>{u.apply(this,l),this[r]=o?o():void 0},A)}})}t.$Ug=i;function j(A,y,o){return N((u,g)=>{const L=`$throttle$timer$${g}`,r=`$throttle$result$${g}`,l=`$throttle$lastRun$${g}`,e=`$throttle$pending$${g}`;return function(...a){if(this[r]||(this[r]=o?o():void 0),(this[l]===null||this[l]===void 0)&&(this[l]=-Number.MAX_VALUE),y&&(this[r]=y(this[r],...a)),this[e])return;const n=this[l]+A;n<=Date.now()?(this[l]=Date.now(),u.apply(this,[this[r]]),this[r]=o?o():void 0):(this[e]=!0,this[L]=setTimeout(()=>{this[e]=!1,this[l]=Date.now(),u.apply(this,[this[r]]),this[r]=o?o():void 0},n-Date.now()))}})}t.$Vg=j}),define(be[71],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ru=void 0;class N{constructor(i,j,A,y){this.originalStart=i,this.originalLength=j,this.modifiedStart=A,this.modifiedLength=y}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$ru=N}),define(be[6],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bb=t.$ab=t.$_=t.$$=t.$0=t.$9=t.$8=t.$7=t.$6=t.$5=t.$4=t.$3=t.$2=t.$1=t.$Z=t.$Y=t.$X=t.setUnexpectedErrorHandler=t.$V=t.$U=void 0;class N{constructor(){this.b=[],this.a=function(C){setTimeout(()=>{throw C.stack?D.isErrorNoTelemetry(C)?new D(C.message+`

`+C.stack):new Error(C.message+`

`+C.stack):C},0)}}addListener(C){return this.b.push(C),()=>{this.d(C)}}c(C){this.b.forEach(T=>{T(C)})}d(C){this.b.splice(this.b.indexOf(C),1)}setUnexpectedErrorHandler(C){this.a=C}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(C){this.a(C),this.c(C)}onUnexpectedExternalError(C){this.a(C)}}t.$U=N,t.$V=new N;function O(f){t.$V.setUnexpectedErrorHandler(f)}t.setUnexpectedErrorHandler=O;function i(f){if(!f||typeof f!="object")return!1;const C=f;return C.code==="EPIPE"&&C.syscall?.toUpperCase()==="WRITE"}t.$X=i;function j(f){u(f)||t.$V.onUnexpectedError(f)}t.$Y=j;function A(f){u(f)||t.$V.onUnexpectedExternalError(f)}t.$Z=A;function y(f){if(f instanceof Error){const{name:C,message:T}=f,P=f.stacktrace||f.stack;return{$isError:!0,name:C,message:T,stack:P,noTelemetry:D.isErrorNoTelemetry(f)}}return f}t.$1=y;const o="Canceled";function u(f){return f instanceof g?!0:f instanceof Error&&f.name===o&&f.message===o}t.$2=u;class g extends Error{constructor(){super(o),this.name=this.message}}t.$3=g;function L(){const f=new Error(o);return f.name=f.message,f}t.$4=L;function r(f){return f?new Error(`Illegal argument: ${f}`):new Error("Illegal argument")}t.$5=r;function l(f){return f?new Error(`Illegal state: ${f}`):new Error("Illegal state")}t.$6=l;function e(f){return f?new Error(`readonly property '${f} cannot be changed'`):new Error("readonly property cannot be changed")}t.$7=e;function a(f){const C=new Error(`${f} has been disposed`);return C.name="DISPOSED",C}t.$8=a;function n(f){return f?f.message?f.message:f.stack?f.stack.split(`
`)[0]:String(f):"Error"}t.$9=n;class h extends Error{constructor(C){super("NotImplemented"),C&&(this.message=C)}}t.$0=h;class s extends Error{constructor(C){super("NotSupported"),C&&(this.message=C)}}t.$$=s;class v extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$_=v;class D extends Error{constructor(C){super(C),this.name="CodeExpectedError"}static fromError(C){if(C instanceof D)return C;const T=new D;return T.message=C.message,T.stack=C.stack,T}static isErrorNoTelemetry(C){return C.name==="CodeExpectedError"}}t.$ab=D;class E extends Error{constructor(C){super(C||"An unexpected bug occurred."),Object.setPrototypeOf(this,E.prototype)}}t.$bb=E}),define(be[13],$e([1,0,6]),function(re,t,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Vf=t.$Uf=t.$Tf=t.$Sf=t.$Rf=t.$Qf=t.$Pf=t.$Of=t.$Nf=t.$Mf=t.$Lf=t.CompareResult=t.$Kf=t.$Jf=t.$If=t.$Hf=t.$Gf=t.$Ff=t.$Ef=t.$Df=t.$Cf=t.$Bf=t.$Af=t.$zf=t.$yf=t.$xf=t.$wf=t.$vf=t.$uf=t.$tf=t.$sf=t.$rf=t.$qf=t.$pf=t.$of=t.$nf=t.$mf=t.$lf=t.$kf=t.$jf=t.$if=t.top=t.$gf=t.$ff=t.$ef=t.$df=t.$cf=t.$bf=t.$af=t.$_e=t.$$e=t.$0e=t.$9e=void 0;function O(c,k=0){return c[c.length-(1+k)]}t.$9e=O;function i(c){if(c.length===0)throw new Error("Invalid tail call");return[c.slice(0,c.length-1),c[c.length-1]]}t.$0e=i;function j(c,k,b=(w,I)=>w===I){if(c===k)return!0;if(!c||!k||c.length!==k.length)return!1;for(let w=0,I=c.length;w<I;w++)if(!b(c[w],k[w]))return!1;return!0}t.$$e=j;function A(c,k){const b=c.length-1;k<b&&(c[k]=c[b]),c.pop()}t.$_e=A;function y(c,k,b){return o(c.length,w=>b(c[w],k))}t.$af=y;function o(c,k){let b=0,w=c-1;for(;b<=w;){const I=(b+w)/2|0,V=k(I);if(V<0)b=I+1;else if(V>0)w=I-1;else return I}return-(b+1)}t.$bf=o;function u(c,k){let b=0,w=c.length;if(w===0)return 0;for(;b<w;){const I=Math.floor((b+w)/2);k(c[I])?w=I:b=I+1}return b}t.$cf=u;function g(c,k,b){if(c=c|0,c>=k.length)throw new TypeError("invalid index");const w=k[Math.floor(k.length*Math.random())],I=[],V=[],Z=[];for(const oe of k){const ge=b(oe,w);ge<0?I.push(oe):ge>0?V.push(oe):Z.push(oe)}return c<I.length?g(c,I,b):c<I.length+Z.length?Z[0]:g(c-(I.length+Z.length),V,b)}t.$df=g;function L(c,k){const b=[];let w;for(const I of c.slice(0).sort(k))!w||k(w[0],I)!==0?(w=[I],b.push(w)):w.push(I);return b}t.$ef=L;function r(c,k,b){const w=[];function I(oe,ge,we){if(ge===0&&we.length===0)return;const Ae=w[w.length-1];Ae&&Ae.start+Ae.deleteCount===oe?(Ae.deleteCount+=ge,Ae.toInsert.push(...we)):w.push({start:oe,deleteCount:ge,toInsert:we})}let V=0,Z=0;for(;;){if(V===c.length){I(V,0,k.slice(Z));break}if(Z===k.length){I(V,c.length-V,[]);break}const oe=c[V],ge=k[Z],we=b(oe,ge);we===0?(V+=1,Z+=1):we<0?(I(V,1,[]),V+=1):we>0&&(I(V,0,[ge]),Z+=1)}return w}t.$ff=r;function l(c,k,b){const w=r(c,k,b),I=[],V=[];for(const Z of w)I.push(...c.slice(Z.start,Z.start+Z.deleteCount)),V.push(...Z.toInsert);return{removed:I,added:V}}t.$gf=l;function e(c,k,b){if(b===0)return[];const w=c.slice(0,b).sort(k);return n(c,k,w,b,c.length),w}t.top=e;function a(c,k,b,w,I){return b===0?Promise.resolve([]):new Promise((V,Z)=>{(async()=>{const oe=c.length,ge=c.slice(0,b).sort(k);for(let we=b,Ae=Math.min(b+w,oe);we<oe;we=Ae,Ae=Math.min(Ae+w,oe)){if(we>b&&await new Promise(Ee=>setTimeout(Ee)),I&&I.isCancellationRequested)throw new N.$3;n(c,k,ge,we,Ae)}return ge})().then(V,Z)})}t.$if=a;function n(c,k,b,w,I){for(const V=b.length;w<I;w++){const Z=c[w];if(k(Z,b[V-1])<0){b.pop();const oe=u(b,ge=>k(Z,ge)<0);b.splice(oe,0,Z)}}}function h(c){return c.filter(k=>!!k)}t.$jf=h;function s(c){let k=0;for(let b=0;b<c.length;b++)c[b]&&(c[k]=c[b],k+=1);c.length=k}t.$kf=s;function v(c,k,b){c.splice(b,0,c.splice(k,1)[0])}t.$lf=v;function D(c){return!Array.isArray(c)||c.length===0}t.$mf=D;function E(c){return Array.isArray(c)&&c.length>0}t.$nf=E;function f(c,k=b=>b){const b=new Set;return c.filter(w=>{const I=k(w);return b.has(I)?!1:(b.add(I),!0)})}t.$of=f;function C(c){const k=new Set;return b=>{const w=c(b);return k.has(w)?!1:(k.add(w),!0)}}t.$pf=C;function T(c,k){const b=P(c,k);if(b!==-1)return c[b]}t.$qf=T;function P(c,k){for(let b=c.length-1;b>=0;b--){const w=c[b];if(k(w))return b}return-1}t.$rf=P;function m(c,k){return c.length>0?c[0]:k}t.$sf=m;function $(c,k){return c.length>0?c[c.length-1]:k}t.$tf=$;function F(c,k,b=(w,I)=>w===I){let w=0;for(let I=0,V=Math.min(c.length,k.length);I<V&&b(c[I],k[I]);I++)w++;return w}t.$uf=F;function R(c){return[].concat(...c)}t.$vf=R;function B(c,k){let b=typeof k=="number"?c:0;typeof k=="number"?b=c:(b=0,k=c);const w=[];if(b<=k)for(let I=b;I<k;I++)w.push(I);else for(let I=b;I>k;I--)w.push(I);return w}t.$wf=B;function M(c,k,b){return c.reduce((w,I)=>(w[k(I)]=b?b(I):I,w),Object.create(null))}t.$xf=M;function z(c,k){return c.push(k),()=>te(c,k)}t.$yf=z;function te(c,k){const b=c.indexOf(k);if(b>-1)return c.splice(b,1),k}t.$zf=te;function ne(c,k,b){const w=c.slice(0,k),I=c.slice(k);return w.concat(b,I)}t.$Af=ne;function se(c,k){let b;if(typeof k=="number"){let w=k;b=()=>{const I=Math.sin(w++)*179426549;return I-Math.floor(I)}}else b=Math.random;for(let w=c.length-1;w>0;w-=1){const I=Math.floor(b()*(w+1)),V=c[w];c[w]=c[I],c[I]=V}}t.$Bf=se;function ce(c,k){const b=c.indexOf(k);b>-1&&(c.splice(b,1),c.unshift(k))}t.$Cf=ce;function ue(c,k){const b=c.indexOf(k);b>-1&&(c.splice(b,1),c.push(k))}t.$Df=ue;function ae(c,k){for(const b of k)c.push(b)}t.$Ef=ae;function pe(c,k){return Array.isArray(c)?c.map(k):k(c)}t.$Ff=pe;function Oe(c){return Array.isArray(c)?c:[c]}t.$Gf=Oe;function Te(c){return c[Math.floor(Math.random()*c.length)]}t.$Hf=Te;function Me(c,k){for(const b of c){const w=k(b);if(w!==void 0)return w}}t.$If=Me;function fe(c,k,b){const w=K(c,k),I=c.length,V=b.length;c.length=I+V;for(let Z=I-1;Z>=w;Z--)c[Z+V]=c[Z];for(let Z=0;Z<V;Z++)c[Z+w]=b[Z]}t.$Jf=fe;function ie(c,k,b,w){const I=K(c,k),V=c.splice(I,b);return fe(c,I,w),V}t.$Kf=ie;function K(c,k){return k<0?Math.max(k+c.length,0):Math.min(k,c.length)}var U;(function(c){function k(V){return V<0}c.isLessThan=k;function b(V){return V<=0}c.isLessThanOrEqual=b;function w(V){return V>0}c.isGreaterThan=w;function I(V){return V===0}c.isNeitherLessOrGreaterThan=I,c.greaterThan=1,c.lessThan=-1,c.neitherLessOrGreaterThan=0})(U||(t.CompareResult=U={}));function ee(c,k){return(b,w)=>k(c(b),c(w))}t.$Lf=ee;function J(...c){return(k,b)=>{for(const w of c){const I=w(k,b);if(!U.isNeitherLessOrGreaterThan(I))return I}return U.neitherLessOrGreaterThan}}t.$Mf=J;const S=(c,k)=>c-k;t.$Nf=S;const _=(c,k)=>(0,t.$Nf)(c?1:0,k?1:0);t.$Of=_;function d(c){return(k,b)=>-c(k,b)}t.$Pf=d;function p(c,k){if(c.length===0)return;let b=c[0];for(let w=1;w<c.length;w++){const I=c[w];k(I,b)>0&&(b=I)}return b}t.$Qf=p;function H(c,k){if(c.length===0)return;let b=c[0];for(let w=1;w<c.length;w++){const I=c[w];k(I,b)>=0&&(b=I)}return b}t.$Rf=H;function Q(c,k){return p(c,(b,w)=>-k(b,w))}t.$Sf=Q;function q(c,k){if(c.length===0)return-1;let b=0;for(let w=1;w<c.length;w++){const I=c[w];k(I,c[b])>0&&(b=w)}return b}t.$Tf=q;class x{constructor(k){this.f=k,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(k){let b=this.c;for(;b<this.f.length&&k(this.f[b]);)b++;const w=b===this.c?null:this.f.slice(this.c,b);return this.c=b,w}takeFromEndWhile(k){let b=this.d;for(;b>=0&&k(this.f[b]);)b--;const w=b===this.d?null:this.f.slice(b+1,this.d+1);return this.d=b,w}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const k=this.f[this.c];return this.c++,k}removeLast(){const k=this.f[this.d];return this.d--,k}takeCount(k){const b=this.f.slice(this.c,this.c+k);return this.c+=k,b}}t.$Uf=x;class W{static{this.empty=new W(k=>{})}constructor(k){this.iterate=k}forEach(k){this.iterate(b=>(k(b),!0))}toArray(){const k=[];return this.iterate(b=>(k.push(b),!0)),k}filter(k){return new W(b=>this.iterate(w=>k(w)?b(w):!0))}map(k){return new W(b=>this.iterate(w=>b(k(w))))}some(k){let b=!1;return this.iterate(w=>(b=k(w),!b)),b}findFirst(k){let b;return this.iterate(w=>k(w)?(b=w,!1):!0),b}findLast(k){let b;return this.iterate(w=>(k(w)&&(b=w),!0)),b}findLastMaxBy(k){let b,w=!0;return this.iterate(I=>((w||U.isGreaterThan(k(I,b)))&&(w=!1,b=I),!0)),b}}t.$Vf=W}),define(be[72],$e([1,0,6]),function(re,t,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zb=t.$yb=t.$xb=t.$wb=t.ok=void 0;function O(o,u){if(!o)throw new Error(u?`Assertion failed (${u})`:"Assertion Failed")}t.ok=O;function i(o,u="Unreachable"){throw new Error(u)}t.$wb=i;function j(o){if(!o)throw new N.$bb("Assertion Failed")}t.$xb=j;function A(o){if(!o()){debugger;o(),(0,N.$Y)(new N.$bb("Assertion Failed"))}}t.$yb=A;function y(o,u){let g=0;for(;g<o.length-1;){const L=o[g],r=o[g+1];if(!u(L,r))return!1;g++}return!0}t.$zb=y}),define(be[41],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cb=void 0;function N(O){const i=this;let j=!1,A;return function(){return j||(j=!0,A=O.apply(i,arguments)),A}}t.$cb=N}),define(be[73],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$RL=t.$QL=void 0;class N{constructor(i){this.a=i,this.b=0}nextId(){return this.a+ ++this.b}}t.$QL=N,t.$RL=new N("id#")}),define(be[26],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var N;(function(O){function i(D){return D&&typeof D=="object"&&typeof D[Symbol.iterator]=="function"}O.is=i;const j=Object.freeze([]);function A(){return j}O.empty=A;function*y(D){yield D}O.single=y;function o(D){return i(D)?D:y(D)}O.wrap=o;function u(D){return D||j}O.from=u;function g(D){return!D||D[Symbol.iterator]().next().done===!0}O.isEmpty=g;function L(D){return D[Symbol.iterator]().next().value}O.first=L;function r(D,E){for(const f of D)if(E(f))return!0;return!1}O.some=r;function l(D,E){for(const f of D)if(E(f))return f}O.find=l;function*e(D,E){for(const f of D)E(f)&&(yield f)}O.filter=e;function*a(D,E){let f=0;for(const C of D)yield E(C,f++)}O.map=a;function*n(...D){for(const E of D)for(const f of E)yield f}O.concat=n;function h(D,E,f){let C=f;for(const T of D)C=E(C,T);return C}O.reduce=h;function*s(D,E,f=D.length){for(E<0&&(E+=D.length),f<0?f+=D.length:f>D.length&&(f=D.length);E<f;E++)yield D[E]}O.slice=s;function v(D,E=Number.POSITIVE_INFINITY){const f=[];if(E===0)return[f,D];const C=D[Symbol.iterator]();for(let T=0;T<E;T++){const P=C.next();if(P.done)return[f,O.empty()];f.push(P.value)}return[f,{[Symbol.iterator](){return C}}]}O.consume=v})(N||(t.Iterable=N={}))}),define(be[42],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mq=t.KeyMod=t.KeyCodeUtils=t.$lq=t.$kq=t.$jq=t.$iq=t.$hq=t.ScanCode=t.KeyCode=void 0;var N;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(N||(t.KeyCode=N={}));var O;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(O||(t.ScanCode=O={}));class i{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(a,n){this._keyCodeToStr[a]=n,this._strToKeyCode[n.toLowerCase()]=a}keyCodeToStr(a){return this._keyCodeToStr[a]}strToKeyCode(a){return this._strToKeyCode[a.toLowerCase()]||0}}const j=new i,A=new i,y=new i;t.$hq=new Array(230),t.$iq={};const o=[],u=Object.create(null),g=Object.create(null);t.$jq={lowerCaseToEnum:e=>g[e]||0,toEnum:e=>u[e]||0,toString:e=>o[e]||"None"},t.$kq=[],t.$lq=[];for(let e=0;e<=193;e++)t.$kq[e]=-1;for(let e=0;e<=132;e++)t.$lq[e]=-1;(function(){const e="",a=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],n=[],h=[];for(const s of a){const[v,D,E,f,C,T,P,m,$]=s;if(h[D]||(h[D]=!0,o[D]=E,u[E]=D,g[E.toLowerCase()]=D,v&&(t.$kq[D]=f,f!==0&&f!==3&&f!==5&&f!==4&&f!==6&&f!==57&&(t.$lq[f]=D))),!n[f]){if(n[f]=!0,!C)throw new Error(`String representation missing for key code ${f} around scan code ${E}`);j.define(f,C),A.define(f,m||C),y.define(f,$||m||C)}T&&(t.$hq[T]=f),P&&(t.$iq[P]=f)}t.$lq[3]=46})();var L;(function(e){function a(E){return j.keyCodeToStr(E)}e.toString=a;function n(E){return j.strToKeyCode(E)}e.fromString=n;function h(E){return A.keyCodeToStr(E)}e.toUserSettingsUS=h;function s(E){return y.keyCodeToStr(E)}e.toUserSettingsGeneral=s;function v(E){return A.strToKeyCode(E)||y.strToKeyCode(E)}e.fromUserSettings=v;function D(E){if(E>=98&&E<=113)return null;switch(E){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return j.keyCodeToStr(E)}e.toElectronAccelerator=D})(L||(t.KeyCodeUtils=L={}));var r;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(r||(t.KeyMod=r={}));function l(e,a){const n=(a&65535)<<16>>>0;return(e|n)>>>0}t.$mq=l}),define(be[74],$e([1,0,6]),function(re,t,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tq=t.$sq=t.$rq=t.$qq=t.$pq=t.$oq=t.$nq=void 0;var O;(function(L){L[L.CtrlCmd=2048]="CtrlCmd",L[L.Shift=1024]="Shift",L[L.Alt=512]="Alt",L[L.WinCtrl=256]="WinCtrl",L[L.KeyCode=255]="KeyCode"})(O||(O={}));function i(L,r){if(typeof L=="number"){if(L===0)return null;const l=(L&65535)>>>0,e=(L&4294901760)>>>16;return e!==0?new o([j(l,r),j(e,r)]):new o([j(l,r)])}else{const l=[];for(let e=0;e<L.length;e++)l.push(j(L[e],r));return new o(l)}}t.$nq=i;function j(L,r){const l=!!(L&2048),e=!!(L&256),a=r===2?e:l,n=!!(L&1024),h=!!(L&512),s=r===2?l:e,v=L&255;return new A(a,n,h,s,v)}t.$oq=j;class A{constructor(r,l,e,a,n){this.ctrlKey=r,this.shiftKey=l,this.altKey=e,this.metaKey=a,this.keyCode=n}equals(r){return r instanceof A&&this.ctrlKey===r.ctrlKey&&this.shiftKey===r.shiftKey&&this.altKey===r.altKey&&this.metaKey===r.metaKey&&this.keyCode===r.keyCode}getHashCode(){const r=this.ctrlKey?"1":"0",l=this.shiftKey?"1":"0",e=this.altKey?"1":"0",a=this.metaKey?"1":"0";return`K${r}${l}${e}${a}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toKeybinding(){return new o([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.$pq=A;class y{constructor(r,l,e,a,n){this.ctrlKey=r,this.shiftKey=l,this.altKey=e,this.metaKey=a,this.scanCode=n}equals(r){return r instanceof y&&this.ctrlKey===r.ctrlKey&&this.shiftKey===r.shiftKey&&this.altKey===r.altKey&&this.metaKey===r.metaKey&&this.scanCode===r.scanCode}getHashCode(){const r=this.ctrlKey?"1":"0",l=this.shiftKey?"1":"0",e=this.altKey?"1":"0",a=this.metaKey?"1":"0";return`S${r}${l}${e}${a}${this.scanCode}`}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}t.$qq=y;class o{constructor(r){if(r.length===0)throw(0,N.$5)("chords");this.chords=r}getHashCode(){let r="";for(let l=0,e=this.chords.length;l<e;l++)l!==0&&(r+=";"),r+=this.chords[l].getHashCode();return r}equals(r){if(r===null||this.chords.length!==r.chords.length)return!1;for(let l=0;l<this.chords.length;l++)if(!this.chords[l].equals(r.chords[l]))return!1;return!0}}t.$rq=o;class u{constructor(r,l,e,a,n,h){this.ctrlKey=r,this.shiftKey=l,this.altKey=e,this.metaKey=a,this.keyLabel=n,this.keyAriaLabel=h}}t.$sq=u;class g{}t.$tq=g}),define(be[30],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$T=void 0;class N{constructor(i){this.d=i,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(i){this.c=i}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$T=N}),define(be[2],$e([1,0,41,26]),function(re,t,N,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tb=t.$sb=t.$rb=t.$qb=t.$pb=t.$ob=t.$nb=t.$mb=t.$lb=t.$kb=t.$jb=t.$ib=t.$hb=t.$gb=t.$fb=t.$eb=t.$db=void 0;const i=!1;let j=null;function A($){j=$}if(t.$db=A,i){const $="__is_disposable_tracked__";A(new class{trackDisposable(F){const R=new Error("Potentially leaked disposable").stack;setTimeout(()=>{F[$]||console.log(R)},3e3)}setParent(F,R){if(F&&F!==s.None)try{F[$]=!0}catch{}}markAsDisposed(F){if(F&&F!==s.None)try{F[$]=!0}catch{}}markAsSingleton(F){}})}function y($){return j?.trackDisposable($),$}function o($){j?.markAsDisposed($)}function u($,F){j?.setParent($,F)}function g($,F){if(j)for(const R of $)j.setParent(R,F)}function L($){return j?.markAsSingleton($),$}t.$eb=L;function r($){return typeof $.dispose=="function"&&$.dispose.length===0}t.$fb=r;function l($){if(O.Iterable.is($)){const F=[];for(const R of $)if(R)try{R.dispose()}catch(B){F.push(B)}if(F.length===1)throw F[0];if(F.length>1)throw new AggregateError(F,"Encountered errors while disposing of store");return Array.isArray($)?[]:$}else if($)return $.dispose(),$}t.$gb=l;function e($){for(const F of $)r(F)&&F.dispose();return[]}t.$hb=e;function a(...$){const F=n(()=>l($));return g($,F),F}t.$ib=a;function n($){const F=y({dispose:(0,N.$cb)(()=>{o(F),$()})});return F}t.$jb=n;class h{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,y(this)}dispose(){this.g||(o(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{l(this.f)}finally{this.f.clear()}}add(F){if(!F)return F;if(F===this)throw new Error("Cannot register a disposable on itself!");return u(F,this),this.g?h.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(F),F}}t.$kb=h;class s{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new h,y(this),u(this.q,this)}dispose(){o(this),this.q.dispose()}B(F){if(F===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(F)}}t.$lb=s;class v{constructor(){this.b=!1,y(this)}get value(){return this.b?void 0:this.a}set value(F){this.b||F===this.a||(this.a?.dispose(),F&&u(F,this),this.a=F)}clear(){this.value=void 0}dispose(){this.b=!0,o(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const F=this.a;return this.a=void 0,F&&u(F,null),F}}t.$mb=v;class D{constructor(F){this.b=F,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$nb=D;class E{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,y(this)}set(F){let R=F;return this.unset=()=>R=void 0,this.isset=()=>R!==void 0,this.dispose=()=>{R&&(R(),R=void 0,o(this))},this}}t.$ob=E;class f{constructor(){this.a=new Map}acquire(F,...R){let B=this.a.get(F);B||(B={counter:0,object:this.b(F,...R)},this.a.set(F,B));const{object:M}=B,z=(0,N.$cb)(()=>{--B.counter===0&&(this.c(F,B.object),this.a.delete(F))});return B.counter++,{object:M,dispose:z}}}t.$pb=f;class C{constructor(F){this.a=F}async acquire(F,...R){const B=this.a.acquire(F,...R);try{return{object:await B.object,dispose:()=>B.dispose()}}catch(M){throw B.dispose(),M}}}t.$qb=C;class T{constructor(F){this.object=F}dispose(){}}t.$rb=T;function P($){const F=new h;try{$(F)}finally{F.dispose()}}t.$sb=P;class m{constructor(){this.a=new Map,this.b=!1,y(this)}dispose(){o(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{l(this.a.values())}finally{this.a.clear()}}has(F){return this.a.has(F)}get(F){return this.a.get(F)}set(F,R,B=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),B||this.a.get(F)?.dispose(),this.a.set(F,R)}deleteAndDispose(F){this.a.get(F)?.dispose(),this.a.delete(F)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$tb=m}),define(be[43],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ub=void 0;class N{static{this.Undefined=new N(void 0)}constructor(j){this.element=j,this.next=N.Undefined,this.prev=N.Undefined}}class O{constructor(){this.a=N.Undefined,this.b=N.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===N.Undefined}clear(){let j=this.a;for(;j!==N.Undefined;){const A=j.next;j.prev=N.Undefined,j.next=N.Undefined,j=A}this.a=N.Undefined,this.b=N.Undefined,this.c=0}unshift(j){return this.d(j,!1)}push(j){return this.d(j,!0)}d(j,A){const y=new N(j);if(this.a===N.Undefined)this.a=y,this.b=y;else if(A){const u=this.b;this.b=y,y.prev=u,u.next=y}else{const u=this.a;this.a=y,y.next=u,u.prev=y}this.c+=1;let o=!1;return()=>{o||(o=!0,this.e(y))}}shift(){if(this.a!==N.Undefined){const j=this.a.element;return this.e(this.a),j}}pop(){if(this.b!==N.Undefined){const j=this.b.element;return this.e(this.b),j}}e(j){if(j.prev!==N.Undefined&&j.next!==N.Undefined){const A=j.prev;A.next=j.next,j.next.prev=A}else j.prev===N.Undefined&&j.next===N.Undefined?(this.a=N.Undefined,this.b=N.Undefined):j.next===N.Undefined?(this.b=this.b.prev,this.b.next=N.Undefined):j.prev===N.Undefined&&(this.a=this.a.next,this.a.prev=N.Undefined);this.c-=1}*[Symbol.iterator](){let j=this.a;for(;j!==N.Undefined;)yield j.element,j=j.next}}t.$ub=O}),define(be[75],$e([1,0]),function(re,t){"use strict";var N,O,i;Object.defineProperty(t,"__esModule",{value:!0}),t.$ri=t.$qi=t.$pi=t.Touch=t.$oi=t.$ni=t.$mi=t.$li=t.$ki=void 0;function j(a,n,h){let s=a.get(n);return s===void 0&&(s=h,a.set(n,s)),s}t.$ki=j;function A(a){const n=[];return a.forEach((h,s)=>{n.push(`${s} => ${h}`)}),`Map(${a.size}) {${n.join(", ")}}`}t.$li=A;function y(a){const n=[];return a.forEach(h=>{n.push(h)}),`Set(${a.size}) {${n.join(", ")}}`}t.$mi=y;class o{constructor(n,h){this.uri=n,this.value=h}}class u{static{this.a=n=>n.toString()}constructor(n,h){this[N]="ResourceMap",n instanceof u?(this.b=new Map(n.b),this.c=h??u.a):(this.b=new Map,this.c=n??u.a)}set(n,h){return this.b.set(this.c(n),new o(n,h)),this}get(n){return this.b.get(this.c(n))?.value}has(n){return this.b.has(this.c(n))}get size(){return this.b.size}clear(){this.b.clear()}delete(n){return this.b.delete(this.c(n))}forEach(n,h){typeof h<"u"&&(n=n.bind(h));for(const[s,v]of this.b)n(v.value,v.uri,this)}*values(){for(const n of this.b.values())yield n.value}*keys(){for(const n of this.b.values())yield n.uri}*entries(){for(const n of this.b.values())yield[n.uri,n.value]}*[(N=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.b)yield[n.uri,n.value]}}t.$ni=u;class g{constructor(n,h){this[O]="ResourceSet",!n||typeof n=="function"?this.a=new u(n):(this.a=new u(h),n.forEach(this.add,this))}get size(){return this.a.size}add(n){return this.a.set(n,n),this}clear(){this.a.clear()}delete(n){return this.a.delete(n)}forEach(n,h){this.a.forEach((s,v)=>n.call(h,v,v,this))}has(n){return this.a.has(n)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$oi=g;var L;(function(a){a[a.None=0]="None",a[a.AsOld=1]="AsOld",a[a.AsNew=2]="AsNew"})(L||(t.Touch=L={}));class r{constructor(){this[i]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(n){return this.a.has(n)}get(n,h=0){const s=this.a.get(n);if(s)return h!==0&&this.j(s,h),s.value}set(n,h,s=0){let v=this.a.get(n);if(v)v.value=h,s!==0&&this.j(v,s);else{switch(v={key:n,value:h,next:void 0,previous:void 0},s){case 0:this.h(v);break;case 1:this.g(v);break;case 2:this.h(v);break;default:this.h(v);break}this.a.set(n,v),this.d++}return this}delete(n){return!!this.remove(n)}remove(n){const h=this.a.get(n);if(h)return this.a.delete(n),this.i(h),this.d--,h.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const n=this.b;return this.a.delete(n.key),this.i(n),this.d--,n.value}forEach(n,h){const s=this.e;let v=this.b;for(;v;){if(h?n.bind(h)(v.value,v.key,this):n(v.value,v.key,this),this.e!==s)throw new Error("LinkedMap got modified during iteration.");v=v.next}}keys(){const n=this,h=this.e;let s=this.b;const v={[Symbol.iterator](){return v},next(){if(n.e!==h)throw new Error("LinkedMap got modified during iteration.");if(s){const D={value:s.key,done:!1};return s=s.next,D}else return{value:void 0,done:!0}}};return v}values(){const n=this,h=this.e;let s=this.b;const v={[Symbol.iterator](){return v},next(){if(n.e!==h)throw new Error("LinkedMap got modified during iteration.");if(s){const D={value:s.value,done:!1};return s=s.next,D}else return{value:void 0,done:!0}}};return v}entries(){const n=this,h=this.e;let s=this.b;const v={[Symbol.iterator](){return v},next(){if(n.e!==h)throw new Error("LinkedMap got modified during iteration.");if(s){const D={value:[s.key,s.value],done:!1};return s=s.next,D}else return{value:void 0,done:!0}}};return v}[(i=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(n){if(n>=this.size)return;if(n===0){this.clear();return}let h=this.b,s=this.size;for(;h&&s>n;)this.a.delete(h.key),h=h.next,s--;this.b=h,this.d=s,h&&(h.previous=void 0),this.e++}g(n){if(!this.b&&!this.c)this.c=n;else if(this.b)n.next=this.b,this.b.previous=n;else throw new Error("Invalid list");this.b=n,this.e++}h(n){if(!this.b&&!this.c)this.b=n;else if(this.c)n.previous=this.c,this.c.next=n;else throw new Error("Invalid list");this.c=n,this.e++}i(n){if(n===this.b&&n===this.c)this.b=void 0,this.c=void 0;else if(n===this.b){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this.b=n.next}else if(n===this.c){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this.c=n.previous}else{const h=n.next,s=n.previous;if(!h||!s)throw new Error("Invalid list");h.previous=s,s.next=h}n.next=void 0,n.previous=void 0,this.e++}j(n,h){if(!this.b||!this.c)throw new Error("Invalid list");if(!(h!==1&&h!==2)){if(h===1){if(n===this.b)return;const s=n.next,v=n.previous;n===this.c?(v.next=void 0,this.c=v):(s.previous=v,v.next=s),n.previous=void 0,n.next=this.b,this.b.previous=n,this.b=n,this.e++}else if(h===2){if(n===this.c)return;const s=n.next,v=n.previous;n===this.b?(s.previous=void 0,this.b=s):(s.previous=v,v.next=s),n.next=void 0,n.previous=this.c,this.c.next=n,this.c=n,this.e++}}}toJSON(){const n=[];return this.forEach((h,s)=>{n.push([s,h])}),n}fromJSON(n){this.clear();for(const[h,s]of n)this.set(h,s)}}t.$pi=r;class l extends r{constructor(n,h=1){super(),this.k=n,this.l=Math.min(Math.max(0,h),1)}get limit(){return this.k}set limit(n){this.k=n,this.m()}get ratio(){return this.l}set ratio(n){this.l=Math.min(Math.max(0,n),1),this.m()}get(n,h=2){return super.get(n,h)}peek(n){return super.get(n,0)}set(n,h){return super.set(n,h,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}t.$qi=l;class e{constructor(){this.a=new Map}add(n){return this.a.set(n,(this.a.get(n)||0)+1),this}delete(n){let h=this.a.get(n)||0;return h===0?!1:(h--,h===0?this.a.delete(n):this.a.set(n,h),!0)}has(n){return this.a.has(n)}}t.$ri=e}),function(re,t){typeof define=="function"&&define.amd?define(be[76],$e([0]),t):typeof exports=="object"&&typeof module<"u"?t(exports):(re=typeof globalThis<"u"?globalThis:re||self,t(re.marked={}))}(this,function(re){"use strict";function t(q,x){for(var W=0;W<x.length;W++){var c=x[W];c.enumerable=c.enumerable||!1,c.configurable=!0,"value"in c&&(c.writable=!0),Object.defineProperty(q,c.key,c)}}function N(q,x,W){return x&&t(q.prototype,x),W&&t(q,W),Object.defineProperty(q,"prototype",{writable:!1}),q}function O(q,x){if(q){if(typeof q=="string")return i(q,x);var W=Object.prototype.toString.call(q).slice(8,-1);if(W==="Object"&&q.constructor&&(W=q.constructor.name),W==="Map"||W==="Set")return Array.from(q);if(W==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(W))return i(q,x)}}function i(q,x){(x==null||x>q.length)&&(x=q.length);for(var W=0,c=new Array(x);W<x;W++)c[W]=q[W];return c}function j(q,x){var W=typeof Symbol<"u"&&q[Symbol.iterator]||q["@@iterator"];if(W)return(W=W.call(q)).next.bind(W);if(Array.isArray(q)||(W=O(q))||x&&q&&typeof q.length=="number"){W&&(q=W);var c=0;return function(){return c>=q.length?{done:!0}:{done:!1,value:q[c++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}re.defaults=A();function y(q){re.defaults=q}var o=/[&<>"']/,u=/[&<>"']/g,g=/[<>"']|&(?!#?\w+;)/,L=/[<>"']|&(?!#?\w+;)/g,r={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},l=function(x){return r[x]};function e(q,x){if(x){if(o.test(q))return q.replace(u,l)}else if(g.test(q))return q.replace(L,l);return q}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function n(q){return q.replace(a,function(x,W){return W=W.toLowerCase(),W==="colon"?":":W.charAt(0)==="#"?W.charAt(1)==="x"?String.fromCharCode(parseInt(W.substring(2),16)):String.fromCharCode(+W.substring(1)):""})}var h=/(^|[^\[])\^/g;function s(q,x){q=typeof q=="string"?q:q.source,x=x||"";var W={replace:function(k,b){return b=b.source||b,b=b.replace(h,"$1"),q=q.replace(k,b),W},getRegex:function(){return new RegExp(q,x)}};return W}var v=/[^\w:]/g,D=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function E(q,x,W){if(q){var c;try{c=decodeURIComponent(n(W)).replace(v,"").toLowerCase()}catch{return null}if(c.indexOf("javascript:")===0||c.indexOf("vbscript:")===0||c.indexOf("data:")===0)return null}x&&!D.test(W)&&(W=m(x,W));try{W=encodeURI(W).replace(/%25/g,"%")}catch{return null}return W}var f={},C=/^[^:]+:\/*[^/]*$/,T=/^([^:]+:)[\s\S]*$/,P=/^([^:]+:\/*[^/]*)[\s\S]*$/;function m(q,x){f[" "+q]||(C.test(q)?f[" "+q]=q+"/":f[" "+q]=B(q,"/",!0)),q=f[" "+q];var W=q.indexOf(":")===-1;return x.substring(0,2)==="//"?W?x:q.replace(T,"$1")+x:x.charAt(0)==="/"?W?x:q.replace(P,"$1")+x:q+x}var $={exec:function(){}};function F(q){for(var x=1,W,c;x<arguments.length;x++){W=arguments[x];for(c in W)Object.prototype.hasOwnProperty.call(W,c)&&(q[c]=W[c])}return q}function R(q,x){var W=q.replace(/\|/g,function(b,w,I){for(var V=!1,Z=w;--Z>=0&&I[Z]==="\\";)V=!V;return V?"|":" |"}),c=W.split(/ \|/),k=0;if(c[0].trim()||c.shift(),c.length>0&&!c[c.length-1].trim()&&c.pop(),c.length>x)c.splice(x);else for(;c.length<x;)c.push("");for(;k<c.length;k++)c[k]=c[k].trim().replace(/\\\|/g,"|");return c}function B(q,x,W){var c=q.length;if(c===0)return"";for(var k=0;k<c;){var b=q.charAt(c-k-1);if(b===x&&!W)k++;else if(b!==x&&W)k++;else break}return q.slice(0,c-k)}function M(q,x){if(q.indexOf(x[1])===-1)return-1;for(var W=q.length,c=0,k=0;k<W;k++)if(q[k]==="\\")k++;else if(q[k]===x[0])c++;else if(q[k]===x[1]&&(c--,c<0))return k;return-1}function z(q){q&&q.sanitize&&!q.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function te(q,x){if(x<1)return"";for(var W="";x>1;)x&1&&(W+=q),x>>=1,q+=q;return W+q}function ne(q,x,W,c){var k=x.href,b=x.title?e(x.title):null,w=q[1].replace(/\\([\[\]])/g,"$1");if(q[0].charAt(0)!=="!"){c.state.inLink=!0;var I={type:"link",raw:W,href:k,title:b,text:w,tokens:c.inlineTokens(w)};return c.state.inLink=!1,I}return{type:"image",raw:W,href:k,title:b,text:e(w)}}function se(q,x){var W=q.match(/^(\s+)(?:```)/);if(W===null)return x;var c=W[1];return x.split(`
`).map(function(k){var b=k.match(/^\s+/);if(b===null)return k;var w=b[0];return w.length>=c.length?k.slice(c.length):k}).join(`
`)}var ce=function(){function q(W){this.options=W||re.defaults}var x=q.prototype;return x.space=function(c){var k=this.rules.block.newline.exec(c);if(k&&k[0].length>0)return{type:"space",raw:k[0]}},x.code=function(c){var k=this.rules.block.code.exec(c);if(k){var b=k[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:k[0],codeBlockStyle:"indented",text:this.options.pedantic?b:B(b,`
`)}}},x.fences=function(c){var k=this.rules.block.fences.exec(c);if(k){var b=k[0],w=se(b,k[3]||"");return{type:"code",raw:b,lang:k[2]?k[2].trim():k[2],text:w}}},x.heading=function(c){var k=this.rules.block.heading.exec(c);if(k){var b=k[2].trim();if(/#$/.test(b)){var w=B(b,"#");(this.options.pedantic||!w||/ $/.test(w))&&(b=w.trim())}return{type:"heading",raw:k[0],depth:k[1].length,text:b,tokens:this.lexer.inline(b)}}},x.hr=function(c){var k=this.rules.block.hr.exec(c);if(k)return{type:"hr",raw:k[0]}},x.blockquote=function(c){var k=this.rules.block.blockquote.exec(c);if(k){var b=k[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:k[0],tokens:this.lexer.blockTokens(b,[]),text:b}}},x.list=function(c){var k=this.rules.block.list.exec(c);if(k){var b,w,I,V,Z,oe,ge,we,Ae,Ee,ve,Le,Fe=k[1].trim(),Ke=Fe.length>1,je={type:"list",raw:"",ordered:Ke,start:Ke?+Fe.slice(0,-1):"",loose:!1,items:[]};Fe=Ke?"\\d{1,9}\\"+Fe.slice(-1):"\\"+Fe,this.options.pedantic&&(Fe=Ke?Fe:"[*+-]");for(var Ie=new RegExp("^( {0,3}"+Fe+")((?:[	 ][^\\n]*)?(?:\\n|$))");c&&(Le=!1,!(!(k=Ie.exec(c))||this.rules.block.hr.test(c)));){if(b=k[0],c=c.substring(b.length),we=k[2].split(`
`,1)[0],Ae=c.split(`
`,1)[0],this.options.pedantic?(V=2,ve=we.trimLeft()):(V=k[2].search(/[^ ]/),V=V>4?1:V,ve=we.slice(V),V+=k[1].length),oe=!1,!we&&/^ *$/.test(Ae)&&(b+=Ae+`
`,c=c.substring(Ae.length+1),Le=!0),!Le)for(var Ge=new RegExp("^ {0,"+Math.min(3,V-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),G=new RegExp("^ {0,"+Math.min(3,V-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),le=new RegExp("^ {0,"+Math.min(3,V-1)+"}(?:```|~~~)"),me=new RegExp("^ {0,"+Math.min(3,V-1)+"}#");c&&(Ee=c.split(`
`,1)[0],we=Ee,this.options.pedantic&&(we=we.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(le.test(we)||me.test(we)||Ge.test(we)||G.test(c)));){if(we.search(/[^ ]/)>=V||!we.trim())ve+=`
`+we.slice(V);else if(!oe)ve+=`
`+we;else break;!oe&&!we.trim()&&(oe=!0),b+=Ee+`
`,c=c.substring(Ee.length+1)}je.loose||(ge?je.loose=!0:/\n *\n *$/.test(b)&&(ge=!0)),this.options.gfm&&(w=/^\[[ xX]\] /.exec(ve),w&&(I=w[0]!=="[ ] ",ve=ve.replace(/^\[[ xX]\] +/,""))),je.items.push({type:"list_item",raw:b,task:!!w,checked:I,loose:!1,text:ve}),je.raw+=b}je.items[je.items.length-1].raw=b.trimRight(),je.items[je.items.length-1].text=ve.trimRight(),je.raw=je.raw.trimRight();var De=je.items.length;for(Z=0;Z<De;Z++){this.lexer.state.top=!1,je.items[Z].tokens=this.lexer.blockTokens(je.items[Z].text,[]);var Ce=je.items[Z].tokens.filter(function(He){return He.type==="space"}),Re=Ce.every(function(He){for(var Ye=He.raw.split(""),Qe=0,We=j(Ye),_e;!(_e=We()).done;){var et=_e.value;if(et===`
`&&(Qe+=1),Qe>1)return!0}return!1});!je.loose&&Ce.length&&Re&&(je.loose=!0,je.items[Z].loose=!0)}return je}},x.html=function(c){var k=this.rules.block.html.exec(c);if(k){var b={type:"html",raw:k[0],pre:!this.options.sanitizer&&(k[1]==="pre"||k[1]==="script"||k[1]==="style"),text:k[0]};if(this.options.sanitize){var w=this.options.sanitizer?this.options.sanitizer(k[0]):e(k[0]);b.type="paragraph",b.text=w,b.tokens=this.lexer.inline(w)}return b}},x.def=function(c){var k=this.rules.block.def.exec(c);if(k){k[3]&&(k[3]=k[3].substring(1,k[3].length-1));var b=k[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:b,raw:k[0],href:k[2],title:k[3]}}},x.table=function(c){var k=this.rules.block.table.exec(c);if(k){var b={type:"table",header:R(k[1]).map(function(ge){return{text:ge}}),align:k[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:k[3]&&k[3].trim()?k[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(b.header.length===b.align.length){b.raw=k[0];var w=b.align.length,I,V,Z,oe;for(I=0;I<w;I++)/^ *-+: *$/.test(b.align[I])?b.align[I]="right":/^ *:-+: *$/.test(b.align[I])?b.align[I]="center":/^ *:-+ *$/.test(b.align[I])?b.align[I]="left":b.align[I]=null;for(w=b.rows.length,I=0;I<w;I++)b.rows[I]=R(b.rows[I],b.header.length).map(function(ge){return{text:ge}});for(w=b.header.length,V=0;V<w;V++)b.header[V].tokens=this.lexer.inline(b.header[V].text);for(w=b.rows.length,V=0;V<w;V++)for(oe=b.rows[V],Z=0;Z<oe.length;Z++)oe[Z].tokens=this.lexer.inline(oe[Z].text);return b}}},x.lheading=function(c){var k=this.rules.block.lheading.exec(c);if(k)return{type:"heading",raw:k[0],depth:k[2].charAt(0)==="="?1:2,text:k[1],tokens:this.lexer.inline(k[1])}},x.paragraph=function(c){var k=this.rules.block.paragraph.exec(c);if(k){var b=k[1].charAt(k[1].length-1)===`
`?k[1].slice(0,-1):k[1];return{type:"paragraph",raw:k[0],text:b,tokens:this.lexer.inline(b)}}},x.text=function(c){var k=this.rules.block.text.exec(c);if(k)return{type:"text",raw:k[0],text:k[0],tokens:this.lexer.inline(k[0])}},x.escape=function(c){var k=this.rules.inline.escape.exec(c);if(k)return{type:"escape",raw:k[0],text:e(k[1])}},x.tag=function(c){var k=this.rules.inline.tag.exec(c);if(k)return!this.lexer.state.inLink&&/^<a /i.test(k[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(k[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(k[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(k[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:k[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(k[0]):e(k[0]):k[0]}},x.link=function(c){var k=this.rules.inline.link.exec(c);if(k){var b=k[2].trim();if(!this.options.pedantic&&/^</.test(b)){if(!/>$/.test(b))return;var w=B(b.slice(0,-1),"\\");if((b.length-w.length)%2===0)return}else{var I=M(k[2],"()");if(I>-1){var V=k[0].indexOf("!")===0?5:4,Z=V+k[1].length+I;k[2]=k[2].substring(0,I),k[0]=k[0].substring(0,Z).trim(),k[3]=""}}var oe=k[2],ge="";if(this.options.pedantic){var we=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(oe);we&&(oe=we[1],ge=we[3])}else ge=k[3]?k[3].slice(1,-1):"";return oe=oe.trim(),/^</.test(oe)&&(this.options.pedantic&&!/>$/.test(b)?oe=oe.slice(1):oe=oe.slice(1,-1)),ne(k,{href:oe&&oe.replace(this.rules.inline._escapes,"$1"),title:ge&&ge.replace(this.rules.inline._escapes,"$1")},k[0],this.lexer)}},x.reflink=function(c,k){var b;if((b=this.rules.inline.reflink.exec(c))||(b=this.rules.inline.nolink.exec(c))){var w=(b[2]||b[1]).replace(/\s+/g," ");if(w=k[w.toLowerCase()],!w||!w.href){var I=b[0].charAt(0);return{type:"text",raw:I,text:I}}return ne(b,w,b[0],this.lexer)}},x.emStrong=function(c,k,b){b===void 0&&(b="");var w=this.rules.inline.emStrong.lDelim.exec(c);if(w&&!(w[3]&&b.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var I=w[1]||w[2]||"";if(!I||I&&(b===""||this.rules.inline.punctuation.exec(b))){var V=w[0].length-1,Z,oe,ge=V,we=0,Ae=w[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Ae.lastIndex=0,k=k.slice(-1*c.length+V);(w=Ae.exec(k))!=null;)if(Z=w[1]||w[2]||w[3]||w[4]||w[5]||w[6],!!Z){if(oe=Z.length,w[3]||w[4]){ge+=oe;continue}else if((w[5]||w[6])&&V%3&&!((V+oe)%3)){we+=oe;continue}if(ge-=oe,!(ge>0)){if(oe=Math.min(oe,oe+ge+we),Math.min(V,oe)%2){var Ee=c.slice(1,V+w.index+oe);return{type:"em",raw:c.slice(0,V+w.index+oe+1),text:Ee,tokens:this.lexer.inlineTokens(Ee)}}var ve=c.slice(2,V+w.index+oe-1);return{type:"strong",raw:c.slice(0,V+w.index+oe+1),text:ve,tokens:this.lexer.inlineTokens(ve)}}}}}},x.codespan=function(c){var k=this.rules.inline.code.exec(c);if(k){var b=k[2].replace(/\n/g," "),w=/[^ ]/.test(b),I=/^ /.test(b)&&/ $/.test(b);return w&&I&&(b=b.substring(1,b.length-1)),b=e(b,!0),{type:"codespan",raw:k[0],text:b}}},x.br=function(c){var k=this.rules.inline.br.exec(c);if(k)return{type:"br",raw:k[0]}},x.del=function(c){var k=this.rules.inline.del.exec(c);if(k)return{type:"del",raw:k[0],text:k[2],tokens:this.lexer.inlineTokens(k[2])}},x.autolink=function(c,k){var b=this.rules.inline.autolink.exec(c);if(b){var w,I;return b[2]==="@"?(w=e(this.options.mangle?k(b[1]):b[1]),I="mailto:"+w):(w=e(b[1]),I=w),{type:"link",raw:b[0],text:w,href:I,tokens:[{type:"text",raw:w,text:w}]}}},x.url=function(c,k){var b;if(b=this.rules.inline.url.exec(c)){var w,I;if(b[2]==="@")w=e(this.options.mangle?k(b[0]):b[0]),I="mailto:"+w;else{var V;do V=b[0],b[0]=this.rules.inline._backpedal.exec(b[0])[0];while(V!==b[0]);w=e(b[0]),b[1]==="www."?I="http://"+w:I=w}return{type:"link",raw:b[0],text:w,href:I,tokens:[{type:"text",raw:w,text:w}]}}},x.inlineText=function(c,k){var b=this.rules.inline.text.exec(c);if(b){var w;return this.lexer.state.inRawBlock?w=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(b[0]):e(b[0]):b[0]:w=e(this.options.smartypants?k(b[0]):b[0]),{type:"text",raw:b[0],text:w}}},q}(),ue={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:$,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};ue._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,ue._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,ue.def=s(ue.def).replace("label",ue._label).replace("title",ue._title).getRegex(),ue.bullet=/(?:[*+-]|\d{1,9}[.)])/,ue.listItemStart=s(/^( *)(bull) */).replace("bull",ue.bullet).getRegex(),ue.list=s(ue.list).replace(/bull/g,ue.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+ue.def.source+")").getRegex(),ue._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",ue._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,ue.html=s(ue.html,"i").replace("comment",ue._comment).replace("tag",ue._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ue.paragraph=s(ue._paragraph).replace("hr",ue.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ue._tag).getRegex(),ue.blockquote=s(ue.blockquote).replace("paragraph",ue.paragraph).getRegex(),ue.normal=F({},ue),ue.gfm=F({},ue.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),ue.gfm.table=s(ue.gfm.table).replace("hr",ue.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ue._tag).getRegex(),ue.gfm.paragraph=s(ue._paragraph).replace("hr",ue.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",ue.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ue._tag).getRegex(),ue.pedantic=F({},ue.normal,{html:s(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",ue._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:$,paragraph:s(ue.normal._paragraph).replace("hr",ue.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",ue.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ae={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:$,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:$,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ae._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ae.punctuation=s(ae.punctuation).replace(/punctuation/g,ae._punctuation).getRegex(),ae.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ae.escapedEmSt=/\\\*|\\_/g,ae._comment=s(ue._comment).replace("(?:-->|$)","-->").getRegex(),ae.emStrong.lDelim=s(ae.emStrong.lDelim).replace(/punct/g,ae._punctuation).getRegex(),ae.emStrong.rDelimAst=s(ae.emStrong.rDelimAst,"g").replace(/punct/g,ae._punctuation).getRegex(),ae.emStrong.rDelimUnd=s(ae.emStrong.rDelimUnd,"g").replace(/punct/g,ae._punctuation).getRegex(),ae._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ae._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ae._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ae.autolink=s(ae.autolink).replace("scheme",ae._scheme).replace("email",ae._email).getRegex(),ae._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ae.tag=s(ae.tag).replace("comment",ae._comment).replace("attribute",ae._attribute).getRegex(),ae._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ae._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ae._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ae.link=s(ae.link).replace("label",ae._label).replace("href",ae._href).replace("title",ae._title).getRegex(),ae.reflink=s(ae.reflink).replace("label",ae._label).replace("ref",ue._label).getRegex(),ae.nolink=s(ae.nolink).replace("ref",ue._label).getRegex(),ae.reflinkSearch=s(ae.reflinkSearch,"g").replace("reflink",ae.reflink).replace("nolink",ae.nolink).getRegex(),ae.normal=F({},ae),ae.pedantic=F({},ae.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:s(/^!?\[(label)\]\((.*?)\)/).replace("label",ae._label).getRegex(),reflink:s(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ae._label).getRegex()}),ae.gfm=F({},ae.normal,{escape:s(ae.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ae.gfm.url=s(ae.gfm.url,"i").replace("email",ae.gfm._extended_email).getRegex(),ae.breaks=F({},ae.gfm,{br:s(ae.br).replace("{2,}","*").getRegex(),text:s(ae.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function pe(q){return q.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Oe(q){var x="",W,c,k=q.length;for(W=0;W<k;W++)c=q.charCodeAt(W),Math.random()>.5&&(c="x"+c.toString(16)),x+="&#"+c+";";return x}var Te=function(){function q(W){this.tokens=[],this.tokens.links=Object.create(null),this.options=W||re.defaults,this.options.tokenizer=this.options.tokenizer||new ce,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var c={block:ue.normal,inline:ae.normal};this.options.pedantic?(c.block=ue.pedantic,c.inline=ae.pedantic):this.options.gfm&&(c.block=ue.gfm,this.options.breaks?c.inline=ae.breaks:c.inline=ae.gfm),this.tokenizer.rules=c}q.lex=function(c,k){var b=new q(k);return b.lex(c)},q.lexInline=function(c,k){var b=new q(k);return b.inlineTokens(c)};var x=q.prototype;return x.lex=function(c){c=c.replace(/\r\n|\r/g,`
`),this.blockTokens(c,this.tokens);for(var k;k=this.inlineQueue.shift();)this.inlineTokens(k.src,k.tokens);return this.tokens},x.blockTokens=function(c,k){var b=this;k===void 0&&(k=[]),this.options.pedantic?c=c.replace(/\t/g,"    ").replace(/^ +$/gm,""):c=c.replace(/^( *)(\t+)/gm,function(ge,we,Ae){return we+"    ".repeat(Ae.length)});for(var w,I,V,Z;c;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ge){return(w=ge.call({lexer:b},c,k))?(c=c.substring(w.raw.length),k.push(w),!0):!1}))){if(w=this.tokenizer.space(c)){c=c.substring(w.raw.length),w.raw.length===1&&k.length>0?k[k.length-1].raw+=`
`:k.push(w);continue}if(w=this.tokenizer.code(c)){c=c.substring(w.raw.length),I=k[k.length-1],I&&(I.type==="paragraph"||I.type==="text")?(I.raw+=`
`+w.raw,I.text+=`
`+w.text,this.inlineQueue[this.inlineQueue.length-1].src=I.text):k.push(w);continue}if(w=this.tokenizer.fences(c)){c=c.substring(w.raw.length),k.push(w);continue}if(w=this.tokenizer.heading(c)){c=c.substring(w.raw.length),k.push(w);continue}if(w=this.tokenizer.hr(c)){c=c.substring(w.raw.length),k.push(w);continue}if(w=this.tokenizer.blockquote(c)){c=c.substring(w.raw.length),k.push(w);continue}if(w=this.tokenizer.list(c)){c=c.substring(w.raw.length),k.push(w);continue}if(w=this.tokenizer.html(c)){c=c.substring(w.raw.length),k.push(w);continue}if(w=this.tokenizer.def(c)){c=c.substring(w.raw.length),I=k[k.length-1],I&&(I.type==="paragraph"||I.type==="text")?(I.raw+=`
`+w.raw,I.text+=`
`+w.raw,this.inlineQueue[this.inlineQueue.length-1].src=I.text):this.tokens.links[w.tag]||(this.tokens.links[w.tag]={href:w.href,title:w.title});continue}if(w=this.tokenizer.table(c)){c=c.substring(w.raw.length),k.push(w);continue}if(w=this.tokenizer.lheading(c)){c=c.substring(w.raw.length),k.push(w);continue}if(V=c,this.options.extensions&&this.options.extensions.startBlock&&function(){var ge=1/0,we=c.slice(1),Ae=void 0;b.options.extensions.startBlock.forEach(function(Ee){Ae=Ee.call({lexer:this},we),typeof Ae=="number"&&Ae>=0&&(ge=Math.min(ge,Ae))}),ge<1/0&&ge>=0&&(V=c.substring(0,ge+1))}(),this.state.top&&(w=this.tokenizer.paragraph(V))){I=k[k.length-1],Z&&I.type==="paragraph"?(I.raw+=`
`+w.raw,I.text+=`
`+w.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=I.text):k.push(w),Z=V.length!==c.length,c=c.substring(w.raw.length);continue}if(w=this.tokenizer.text(c)){c=c.substring(w.raw.length),I=k[k.length-1],I&&I.type==="text"?(I.raw+=`
`+w.raw,I.text+=`
`+w.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=I.text):k.push(w);continue}if(c){var oe="Infinite loop on byte: "+c.charCodeAt(0);if(this.options.silent){console.error(oe);break}else throw new Error(oe)}}return this.state.top=!0,k},x.inline=function(c,k){return k===void 0&&(k=[]),this.inlineQueue.push({src:c,tokens:k}),k},x.inlineTokens=function(c,k){var b=this;k===void 0&&(k=[]);var w,I,V,Z=c,oe,ge,we;if(this.tokens.links){var Ae=Object.keys(this.tokens.links);if(Ae.length>0)for(;(oe=this.tokenizer.rules.inline.reflinkSearch.exec(Z))!=null;)Ae.includes(oe[0].slice(oe[0].lastIndexOf("[")+1,-1))&&(Z=Z.slice(0,oe.index)+"["+te("a",oe[0].length-2)+"]"+Z.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(oe=this.tokenizer.rules.inline.blockSkip.exec(Z))!=null;)Z=Z.slice(0,oe.index)+"["+te("a",oe[0].length-2)+"]"+Z.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(oe=this.tokenizer.rules.inline.escapedEmSt.exec(Z))!=null;)Z=Z.slice(0,oe.index)+"++"+Z.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;c;)if(ge||(we=""),ge=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ve){return(w=ve.call({lexer:b},c,k))?(c=c.substring(w.raw.length),k.push(w),!0):!1}))){if(w=this.tokenizer.escape(c)){c=c.substring(w.raw.length),k.push(w);continue}if(w=this.tokenizer.tag(c)){c=c.substring(w.raw.length),I=k[k.length-1],I&&w.type==="text"&&I.type==="text"?(I.raw+=w.raw,I.text+=w.text):k.push(w);continue}if(w=this.tokenizer.link(c)){c=c.substring(w.raw.length),k.push(w);continue}if(w=this.tokenizer.reflink(c,this.tokens.links)){c=c.substring(w.raw.length),I=k[k.length-1],I&&w.type==="text"&&I.type==="text"?(I.raw+=w.raw,I.text+=w.text):k.push(w);continue}if(w=this.tokenizer.emStrong(c,Z,we)){c=c.substring(w.raw.length),k.push(w);continue}if(w=this.tokenizer.codespan(c)){c=c.substring(w.raw.length),k.push(w);continue}if(w=this.tokenizer.br(c)){c=c.substring(w.raw.length),k.push(w);continue}if(w=this.tokenizer.del(c)){c=c.substring(w.raw.length),k.push(w);continue}if(w=this.tokenizer.autolink(c,Oe)){c=c.substring(w.raw.length),k.push(w);continue}if(!this.state.inLink&&(w=this.tokenizer.url(c,Oe))){c=c.substring(w.raw.length),k.push(w);continue}if(V=c,this.options.extensions&&this.options.extensions.startInline&&function(){var ve=1/0,Le=c.slice(1),Fe=void 0;b.options.extensions.startInline.forEach(function(Ke){Fe=Ke.call({lexer:this},Le),typeof Fe=="number"&&Fe>=0&&(ve=Math.min(ve,Fe))}),ve<1/0&&ve>=0&&(V=c.substring(0,ve+1))}(),w=this.tokenizer.inlineText(V,pe)){c=c.substring(w.raw.length),w.raw.slice(-1)!=="_"&&(we=w.raw.slice(-1)),ge=!0,I=k[k.length-1],I&&I.type==="text"?(I.raw+=w.raw,I.text+=w.text):k.push(w);continue}if(c){var Ee="Infinite loop on byte: "+c.charCodeAt(0);if(this.options.silent){console.error(Ee);break}else throw new Error(Ee)}}return k},N(q,null,[{key:"rules",get:function(){return{block:ue,inline:ae}}}]),q}(),Me=function(){function q(W){this.options=W||re.defaults}var x=q.prototype;return x.code=function(c,k,b){var w=(k||"").match(/\S*/)[0];if(this.options.highlight){var I=this.options.highlight(c,w);I!=null&&I!==c&&(b=!0,c=I)}return c=c.replace(/\n$/,"")+`
`,w?'<pre><code class="'+this.options.langPrefix+e(w,!0)+'">'+(b?c:e(c,!0))+`</code></pre>
`:"<pre><code>"+(b?c:e(c,!0))+`</code></pre>
`},x.blockquote=function(c){return`<blockquote>
`+c+`</blockquote>
`},x.html=function(c){return c},x.heading=function(c,k,b,w){if(this.options.headerIds){var I=this.options.headerPrefix+w.slug(b);return"<h"+k+' id="'+I+'">'+c+"</h"+k+`>
`}return"<h"+k+">"+c+"</h"+k+`>
`},x.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},x.list=function(c,k,b){var w=k?"ol":"ul",I=k&&b!==1?' start="'+b+'"':"";return"<"+w+I+`>
`+c+"</"+w+`>
`},x.listitem=function(c){return"<li>"+c+`</li>
`},x.checkbox=function(c){return"<input "+(c?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},x.paragraph=function(c){return"<p>"+c+`</p>
`},x.table=function(c,k){return k&&(k="<tbody>"+k+"</tbody>"),`<table>
<thead>
`+c+`</thead>
`+k+`</table>
`},x.tablerow=function(c){return`<tr>
`+c+`</tr>
`},x.tablecell=function(c,k){var b=k.header?"th":"td",w=k.align?"<"+b+' align="'+k.align+'">':"<"+b+">";return w+c+("</"+b+`>
`)},x.strong=function(c){return"<strong>"+c+"</strong>"},x.em=function(c){return"<em>"+c+"</em>"},x.codespan=function(c){return"<code>"+c+"</code>"},x.br=function(){return this.options.xhtml?"<br/>":"<br>"},x.del=function(c){return"<del>"+c+"</del>"},x.link=function(c,k,b){if(c=E(this.options.sanitize,this.options.baseUrl,c),c===null)return b;var w='<a href="'+e(c)+'"';return k&&(w+=' title="'+k+'"'),w+=">"+b+"</a>",w},x.image=function(c,k,b){if(c=E(this.options.sanitize,this.options.baseUrl,c),c===null)return b;var w='<img src="'+c+'" alt="'+b+'"';return k&&(w+=' title="'+k+'"'),w+=this.options.xhtml?"/>":">",w},x.text=function(c){return c},q}(),fe=function(){function q(){}var x=q.prototype;return x.strong=function(c){return c},x.em=function(c){return c},x.codespan=function(c){return c},x.del=function(c){return c},x.html=function(c){return c},x.text=function(c){return c},x.link=function(c,k,b){return""+b},x.image=function(c,k,b){return""+b},x.br=function(){return""},q}(),ie=function(){function q(){this.seen={}}var x=q.prototype;return x.serialize=function(c){return c.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},x.getNextSafeSlug=function(c,k){var b=c,w=0;if(this.seen.hasOwnProperty(b)){w=this.seen[c];do w++,b=c+"-"+w;while(this.seen.hasOwnProperty(b))}return k||(this.seen[c]=w,this.seen[b]=0),b},x.slug=function(c,k){k===void 0&&(k={});var b=this.serialize(c);return this.getNextSafeSlug(b,k.dryrun)},q}(),K=function(){function q(W){this.options=W||re.defaults,this.options.renderer=this.options.renderer||new Me,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new fe,this.slugger=new ie}q.parse=function(c,k){var b=new q(k);return b.parse(c)},q.parseInline=function(c,k){var b=new q(k);return b.parseInline(c)};var x=q.prototype;return x.parse=function(c,k){k===void 0&&(k=!0);var b="",w,I,V,Z,oe,ge,we,Ae,Ee,ve,Le,Fe,Ke,je,Ie,Ge,G,le,me,De=c.length;for(w=0;w<De;w++){if(ve=c[w],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ve.type]&&(me=this.options.extensions.renderers[ve.type].call({parser:this},ve),me!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ve.type))){b+=me||"";continue}switch(ve.type){case"space":continue;case"hr":{b+=this.renderer.hr();continue}case"heading":{b+=this.renderer.heading(this.parseInline(ve.tokens),ve.depth,n(this.parseInline(ve.tokens,this.textRenderer)),this.slugger);continue}case"code":{b+=this.renderer.code(ve.text,ve.lang,ve.escaped);continue}case"table":{for(Ae="",we="",Z=ve.header.length,I=0;I<Z;I++)we+=this.renderer.tablecell(this.parseInline(ve.header[I].tokens),{header:!0,align:ve.align[I]});for(Ae+=this.renderer.tablerow(we),Ee="",Z=ve.rows.length,I=0;I<Z;I++){for(ge=ve.rows[I],we="",oe=ge.length,V=0;V<oe;V++)we+=this.renderer.tablecell(this.parseInline(ge[V].tokens),{header:!1,align:ve.align[V]});Ee+=this.renderer.tablerow(we)}b+=this.renderer.table(Ae,Ee);continue}case"blockquote":{Ee=this.parse(ve.tokens),b+=this.renderer.blockquote(Ee);continue}case"list":{for(Le=ve.ordered,Fe=ve.start,Ke=ve.loose,Z=ve.items.length,Ee="",I=0;I<Z;I++)Ie=ve.items[I],Ge=Ie.checked,G=Ie.task,je="",Ie.task&&(le=this.renderer.checkbox(Ge),Ke?Ie.tokens.length>0&&Ie.tokens[0].type==="paragraph"?(Ie.tokens[0].text=le+" "+Ie.tokens[0].text,Ie.tokens[0].tokens&&Ie.tokens[0].tokens.length>0&&Ie.tokens[0].tokens[0].type==="text"&&(Ie.tokens[0].tokens[0].text=le+" "+Ie.tokens[0].tokens[0].text)):Ie.tokens.unshift({type:"text",text:le}):je+=le),je+=this.parse(Ie.tokens,Ke),Ee+=this.renderer.listitem(je,G,Ge);b+=this.renderer.list(Ee,Le,Fe);continue}case"html":{b+=this.renderer.html(ve.text);continue}case"paragraph":{b+=this.renderer.paragraph(this.parseInline(ve.tokens));continue}case"text":{for(Ee=ve.tokens?this.parseInline(ve.tokens):ve.text;w+1<De&&c[w+1].type==="text";)ve=c[++w],Ee+=`
`+(ve.tokens?this.parseInline(ve.tokens):ve.text);b+=k?this.renderer.paragraph(Ee):Ee;continue}default:{var Ce='Token with "'+ve.type+'" type was not found.';if(this.options.silent){console.error(Ce);return}else throw new Error(Ce)}}}return b},x.parseInline=function(c,k){k=k||this.renderer;var b="",w,I,V,Z=c.length;for(w=0;w<Z;w++){if(I=c[w],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[I.type]&&(V=this.options.extensions.renderers[I.type].call({parser:this},I),V!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(I.type))){b+=V||"";continue}switch(I.type){case"escape":{b+=k.text(I.text);break}case"html":{b+=k.html(I.text);break}case"link":{b+=k.link(I.href,I.title,this.parseInline(I.tokens,k));break}case"image":{b+=k.image(I.href,I.title,I.text);break}case"strong":{b+=k.strong(this.parseInline(I.tokens,k));break}case"em":{b+=k.em(this.parseInline(I.tokens,k));break}case"codespan":{b+=k.codespan(I.text);break}case"br":{b+=k.br();break}case"del":{b+=k.del(this.parseInline(I.tokens,k));break}case"text":{b+=k.text(I.text);break}default:{var oe='Token with "'+I.type+'" type was not found.';if(this.options.silent){console.error(oe);return}else throw new Error(oe)}}}return b},q}();function U(q,x,W){if(typeof q>"u"||q===null)throw new Error("marked(): input parameter is undefined or null");if(typeof q!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(q)+", string expected");if(typeof x=="function"&&(W=x,x=null),x=F({},U.defaults,x||{}),z(x),W){var c=x.highlight,k;try{k=Te.lex(q,x)}catch(Z){return W(Z)}var b=function(oe){var ge;if(!oe)try{x.walkTokens&&U.walkTokens(k,x.walkTokens),ge=K.parse(k,x)}catch(we){oe=we}return x.highlight=c,oe?W(oe):W(null,ge)};if(!c||c.length<3||(delete x.highlight,!k.length))return b();var w=0;U.walkTokens(k,function(Z){Z.type==="code"&&(w++,setTimeout(function(){c(Z.text,Z.lang,function(oe,ge){if(oe)return b(oe);ge!=null&&ge!==Z.text&&(Z.text=ge,Z.escaped=!0),w--,w===0&&b()})},0))}),w===0&&b();return}function I(Z){if(Z.message+=`
Please report this to https://github.com/markedjs/marked.`,x.silent)return"<p>An error occurred:</p><pre>"+e(Z.message+"",!0)+"</pre>";throw Z}try{var V=Te.lex(q,x);if(x.walkTokens){if(x.async)return Promise.all(U.walkTokens(V,x.walkTokens)).then(function(){return K.parse(V,x)}).catch(I);U.walkTokens(V,x.walkTokens)}return K.parse(V,x)}catch(Z){I(Z)}}U.options=U.setOptions=function(q){return F(U.defaults,q),y(U.defaults),U},U.getDefaults=A,U.defaults=re.defaults,U.use=function(){for(var q=arguments.length,x=new Array(q),W=0;W<q;W++)x[W]=arguments[W];var c=F.apply(void 0,[{}].concat(x)),k=U.defaults.extensions||{renderers:{},childTokens:{}},b;x.forEach(function(w){if(w.extensions&&(b=!0,w.extensions.forEach(function(V){if(!V.name)throw new Error("extension name required");if(V.renderer){var Z=k.renderers?k.renderers[V.name]:null;Z?k.renderers[V.name]=function(){for(var oe=arguments.length,ge=new Array(oe),we=0;we<oe;we++)ge[we]=arguments[we];var Ae=V.renderer.apply(this,ge);return Ae===!1&&(Ae=Z.apply(this,ge)),Ae}:k.renderers[V.name]=V.renderer}if(V.tokenizer){if(!V.level||V.level!=="block"&&V.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");k[V.level]?k[V.level].unshift(V.tokenizer):k[V.level]=[V.tokenizer],V.start&&(V.level==="block"?k.startBlock?k.startBlock.push(V.start):k.startBlock=[V.start]:V.level==="inline"&&(k.startInline?k.startInline.push(V.start):k.startInline=[V.start]))}V.childTokens&&(k.childTokens[V.name]=V.childTokens)})),w.renderer&&function(){var V=U.defaults.renderer||new Me,Z=function(we){var Ae=V[we];V[we]=function(){for(var Ee=arguments.length,ve=new Array(Ee),Le=0;Le<Ee;Le++)ve[Le]=arguments[Le];var Fe=w.renderer[we].apply(V,ve);return Fe===!1&&(Fe=Ae.apply(V,ve)),Fe}};for(var oe in w.renderer)Z(oe);c.renderer=V}(),w.tokenizer&&function(){var V=U.defaults.tokenizer||new ce,Z=function(we){var Ae=V[we];V[we]=function(){for(var Ee=arguments.length,ve=new Array(Ee),Le=0;Le<Ee;Le++)ve[Le]=arguments[Le];var Fe=w.tokenizer[we].apply(V,ve);return Fe===!1&&(Fe=Ae.apply(V,ve)),Fe}};for(var oe in w.tokenizer)Z(oe);c.tokenizer=V}(),w.walkTokens){var I=U.defaults.walkTokens;c.walkTokens=function(V){var Z=[];return Z.push(w.walkTokens.call(this,V)),I&&(Z=Z.concat(I.call(this,V))),Z}}b&&(c.extensions=k),U.setOptions(c)})},U.walkTokens=function(q,x){for(var W=[],c=function(){var I=b.value;switch(W=W.concat(x.call(U,I)),I.type){case"table":{for(var V=j(I.header),Z;!(Z=V()).done;){var oe=Z.value;W=W.concat(U.walkTokens(oe.tokens,x))}for(var ge=j(I.rows),we;!(we=ge()).done;)for(var Ae=we.value,Ee=j(Ae),ve;!(ve=Ee()).done;){var Le=ve.value;W=W.concat(U.walkTokens(Le.tokens,x))}break}case"list":{W=W.concat(U.walkTokens(I.items,x));break}default:U.defaults.extensions&&U.defaults.extensions.childTokens&&U.defaults.extensions.childTokens[I.type]?U.defaults.extensions.childTokens[I.type].forEach(function(Fe){W=W.concat(U.walkTokens(I[Fe],x))}):I.tokens&&(W=W.concat(U.walkTokens(I.tokens,x)))}},k=j(q),b;!(b=k()).done;)c();return W},U.parseInline=function(q,x){if(typeof q>"u"||q===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof q!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(q)+", string expected");x=F({},U.defaults,x||{}),z(x);try{var W=Te.lexInline(q,x);return x.walkTokens&&U.walkTokens(W,x.walkTokens),K.parseInline(W,x)}catch(c){if(c.message+=`
Please report this to https://github.com/markedjs/marked.`,x.silent)return"<p>An error occurred:</p><pre>"+e(c.message+"",!0)+"</pre>";throw c}},U.Parser=K,U.parser=K.parse,U.Renderer=Me,U.TextRenderer=fe,U.Lexer=Te,U.lexer=Te.lex,U.Tokenizer=ce,U.Slugger=ie,U.parse=U;var ee=U.options,J=U.setOptions,S=U.use,_=U.walkTokens,d=U.parseInline,p=U,H=K.parse,Q=Te.lex;re.Lexer=Te,re.Parser=K,re.Renderer=Me,re.Slugger=ie,re.TextRenderer=fe,re.Tokenizer=ce,re.getDefaults=A,re.lexer=Q,re.marked=U,re.options=ee,re.parse=p,re.parseInline=d,re.parser=H,re.setOptions=J,re.use=S,re.walkTokens=_,Object.defineProperty(re,"__esModule",{value:!0})}),define(be[77],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8Q=void 0;class N{constructor(i,j=0,A=i.length,y=j-1){this.a=i,this.b=j,this.c=A,this.d=y}current(){return this.d===this.b-1||this.d===this.c?null:this.a[this.d]}next(){return this.d=Math.min(this.d+1,this.c),this.current()}previous(){return this.d=Math.max(this.d-1,this.b-1),this.current()}first(){return this.d=this.b,this.current()}last(){return this.d=this.c-1,this.current()}}t.$8Q=N}),define(be[78],$e([1,0,77]),function(re,t,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0Q=t.$9Q=void 0;class O{constructor(A=[],y=10){this.h(A),this.b=y,this.d()}getHistory(){return this.j}add(A){this.a.delete(A),this.a.add(A),this.d()}next(){return this.c.next()}previous(){return this.g()!==0?this.c.previous():null}current(){return this.c.current()}first(){return this.c.first()}last(){return this.c.last()}isFirst(){return this.g()===0}isLast(){return this.g()>=this.j.length-1}isNowhere(){return this.c.current()===null}has(A){return this.a.has(A)}clear(){this.h([]),this.d()}d(){this.f();const A=this.j;this.c=new N.$8Q(A,0,A.length,A.length)}f(){const A=this.j;A.length>this.b&&this.h(A.slice(A.length-this.b))}g(){const A=this.c.current();return A?this.j.indexOf(A):-1}h(A){this.a=new Set;for(const y of A)this.a.add(y)}get j(){const A=[];return this.a.forEach(y=>A.push(y)),A}}t.$9Q=O;class i{constructor(A,y=10){if(this.g=y,A.length<1)throw new Error("not supported");this.f=1,this.b=this.c=this.d={value:A[0],previous:void 0,next:void 0},this.a=new Set([A[0]]);for(let o=1;o<A.length;o++)this.add(A[o])}add(A){const y={value:A,previous:this.c,next:void 0};for(this.c.next=y,this.c=y,this.d=this.c,this.f++,this.a.has(A)?this.h(A):this.a.add(A);this.f>this.g;)this.a.delete(this.b.value),this.b=this.b.next,this.b.previous=void 0,this.f--}replaceLast(A){if(this.c.value===A)return A;const y=this.c.value;return this.a.delete(y),this.c.value=A,this.a.has(A)?this.h(A):this.a.add(A),y}isAtEnd(){return this.d===this.c}current(){return this.d.value}previous(){return this.d.previous&&(this.d=this.d.previous),this.d.value}next(){return this.d.next&&(this.d=this.d.next),this.d.value}has(A){return this.a.has(A)}resetCursor(){return this.d=this.c,this.d.value}*[Symbol.iterator](){let A=this.b;for(;A;)yield A.value,A=A.next}h(A){let y=this.b;for(;y!==this.c;)y.value===A&&(y===this.b?(this.b=this.b.next,this.b.previous=void 0):(y.previous.next=y.next,y.next.previous=y.previous),this.f--),y=y.next}}t.$0Q=i}),define(be[44],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yl=t.$xl=t.$wl=t.rot=t.$ul=void 0;function N(y,o,u){return Math.min(Math.max(y,o),u)}t.$ul=N;function O(y,o){return(o+y%o)%o}t.rot=O;class i{constructor(){this.a=0}getNext(){return this.a++}}t.$wl=i;class j{constructor(){this.a=1,this.b=0}update(o){return this.b=this.b+(o-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}t.$xl=j;class A{constructor(o){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(o),this.c.fill(0,0,o)}update(o){const u=this.c[this.d];return this.c[this.d]=o,this.d=(this.d+1)%this.c.length,this.e-=u,this.e+=o,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}t.$yl=A}),define(be[45],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var N;(function(O){function i(o,u){if(o.start>=u.end||u.start>=o.end)return{start:0,end:0};const g=Math.max(o.start,u.start),L=Math.min(o.end,u.end);return L-g<=0?{start:0,end:0}:{start:g,end:L}}O.intersect=i;function j(o){return o.end-o.start<=0}O.isEmpty=j;function A(o,u){return!j(i(o,u))}O.intersects=A;function y(o,u){const g=[],L={start:o.start,end:Math.min(u.start,o.end)},r={start:Math.max(u.end,o.start),end:o.end};return j(L)||g.push(L),j(r)||g.push(r),g}O.relativeComplement=y})(N||(t.Range=N={}))}),define(be[79],$e([1,0,45]),function(re,t,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1P=t.$ZP=t.$YP=t.$XP=void 0;function O(o,u){const g=[];for(const L of u){if(o.start>=L.range.end)continue;if(o.end<L.range.start)break;const r=N.Range.intersect(o,L.range);N.Range.isEmpty(r)||g.push({range:r,size:L.size})}return g}t.$XP=O;function i({start:o,end:u},g){return{start:o+g,end:u+g}}t.$YP=i;function j(o){const u=[];let g=null;for(const L of o){const r=L.range.start,l=L.range.end,e=L.size;if(g&&e===g.size){g.range.end=l;continue}g={range:{start:r,end:l},size:e},u.push(g)}return u}t.$ZP=j;function A(...o){return j(o.reduce((u,g)=>u.concat(g),[]))}class y{get paddingTop(){return this.c}set paddingTop(u){this.b=this.b+u-this.c,this.c=u}constructor(u){this.a=[],this.b=0,this.c=0,this.c=u??0,this.b=this.c}splice(u,g,L=[]){const r=L.length-g,l=O({start:0,end:u},this.a),e=O({start:u+g,end:Number.POSITIVE_INFINITY},this.a).map(n=>({range:i(n.range,r),size:n.size})),a=L.map((n,h)=>({range:{start:u+h,end:u+h+1},size:n.size}));this.a=A(l,a,e),this.b=this.c+this.a.reduce((n,h)=>n+h.size*(h.range.end-h.range.start),0)}get count(){const u=this.a.length;return u?this.a[u-1].range.end:0}get size(){return this.b}indexAt(u){if(u<0)return-1;if(u<this.c)return 0;let g=0,L=this.c;for(const r of this.a){const l=r.range.end-r.range.start,e=L+l*r.size;if(u<e)return g+Math.floor((u-L)/r.size);g+=l,L=e}return g}indexAfter(u){return Math.min(this.indexAt(u)+1,this.count)}positionAt(u){if(u<0)return-1;let g=0,L=0;for(const r of this.a){const l=r.range.end-r.range.start,e=L+l;if(u<e)return this.c+g+(u-L)*r.size;g+=l*r.size,L=e}return-1}}t.$1P=y}),define(be[80],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ac=void 0;const N=globalThis.performance&&typeof globalThis.performance.now=="function";class O{static create(j){return new O(j)}constructor(j){this.c=N&&j===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$ac=O}),define(be[3],$e([1,0,6,41,2,43,80]),function(re,t,N,O,i,j,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=t.$fc=t.$ec=t.$dc=t.$cc=t.Event=void 0;const y=!1,o=!1;var u;(function(B){B.None=()=>i.$lb.None;function M(W){if(o){const{onDidAddListener:c}=W,k=e.create();let b=0;W.onDidAddListener=()=>{++b===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),k.print()),c?.()}}}function z(W,c){return Te(W,()=>{},0,void 0,!0,void 0,c)}B.defer=z;function te(W){return(c,k=null,b)=>{let w=!1,I;return I=W(V=>{if(!w)return I?I.dispose():w=!0,c.call(k,V)},null,b),w&&I.dispose(),I}}B.once=te;function ne(W,c,k){return Oe((b,w=null,I)=>W(V=>b.call(w,c(V)),null,I),k)}B.map=ne;function se(W,c,k){return Oe((b,w=null,I)=>W(V=>{c(V),b.call(w,V)},null,I),k)}B.forEach=se;function ce(W,c,k){return Oe((b,w=null,I)=>W(V=>c(V)&&b.call(w,V),null,I),k)}B.filter=ce;function ue(W){return W}B.signal=ue;function ae(...W){return(c,k=null,b)=>(0,i.$ib)(...W.map(w=>w(I=>c.call(k,I),null,b)))}B.any=ae;function pe(W,c,k,b){let w=k;return ne(W,I=>(w=c(w,I),w),b)}B.reduce=pe;function Oe(W,c){let k;const b={onWillAddFirstListener(){k=W(w.fire,w)},onDidRemoveLastListener(){k?.dispose()}};c||M(b);const w=new v(b);return c?.add(w),w.event}function Te(W,c,k=100,b=!1,w=!1,I,V){let Z,oe,ge,we=0,Ae;const Ee={leakWarningThreshold:I,onWillAddFirstListener(){Z=W(Le=>{we++,oe=c(oe,Le),b&&!ge&&(ve.fire(oe),oe=void 0),Ae=()=>{const Fe=oe;oe=void 0,ge=void 0,(!b||we>1)&&ve.fire(Fe),we=0},typeof k=="number"?(clearTimeout(ge),ge=setTimeout(Ae,k)):ge===void 0&&(ge=0,queueMicrotask(Ae))})},onWillRemoveListener(){w&&we>0&&Ae?.()},onDidRemoveLastListener(){Ae=void 0,Z.dispose()}};V||M(Ee);const ve=new v(Ee);return V?.add(ve),ve.event}B.debounce=Te;function Me(W,c=0,k){return B.debounce(W,(b,w)=>b?(b.push(w),b):[w],c,void 0,!0,void 0,k)}B.accumulate=Me;function fe(W,c=(b,w)=>b===w,k){let b=!0,w;return ce(W,I=>{const V=b||!c(I,w);return b=!1,w=I,V},k)}B.latch=fe;function ie(W,c,k){return[B.filter(W,c,k),B.filter(W,b=>!c(b),k)]}B.split=ie;function K(W,c=!1,k=[]){let b=k.slice(),w=W(Z=>{b?b.push(Z):V.fire(Z)});const I=()=>{b?.forEach(Z=>V.fire(Z)),b=null},V=new v({onWillAddFirstListener(){w||(w=W(Z=>V.fire(Z)))},onDidAddFirstListener(){b&&(c?setTimeout(I):I())},onDidRemoveLastListener(){w&&w.dispose(),w=null}});return V.event}B.buffer=K;class U{constructor(c){this.event=c,this.d=new i.$kb}map(c){return new U(ne(this.event,c,this.d))}forEach(c){return new U(se(this.event,c,this.d))}filter(c){return new U(ce(this.event,c,this.d))}reduce(c,k){return new U(pe(this.event,c,k,this.d))}latch(){return new U(fe(this.event,void 0,this.d))}debounce(c,k=100,b=!1,w=!1,I){return new U(Te(this.event,c,k,b,w,I,this.d))}on(c,k,b){return this.event(c,k,b)}once(c,k,b){return te(this.event)(c,k,b)}dispose(){this.d.dispose()}}function ee(W){return new U(W)}B.chain=ee;function J(W,c,k=b=>b){const b=(...Z)=>V.fire(k(...Z)),w=()=>W.on(c,b),I=()=>W.removeListener(c,b),V=new v({onWillAddFirstListener:w,onDidRemoveLastListener:I});return V.event}B.fromNodeEventEmitter=J;function S(W,c,k=b=>b){const b=(...Z)=>V.fire(k(...Z)),w=()=>W.addEventListener(c,b),I=()=>W.removeEventListener(c,b),V=new v({onWillAddFirstListener:w,onDidRemoveLastListener:I});return V.event}B.fromDOMEventEmitter=S;function _(W){return new Promise(c=>te(W)(c))}B.toPromise=_;function d(W){const c=new v;return W.then(k=>{c.fire(k)},()=>{c.fire(void 0)}).finally(()=>{c.dispose()}),c.event}B.fromPromise=d;function p(W,c){return c(void 0),W(k=>c(k))}B.runAndSubscribe=p;function H(W,c){let k=null;function b(I){k?.dispose(),k=new i.$kb,c(I,k)}b(void 0);const w=W(I=>b(I));return(0,i.$jb)(()=>{w.dispose(),k?.dispose()})}B.runAndSubscribeWithStore=H;class Q{constructor(c,k){this._observable=c,this.d=0,this.f=!1;const b={onWillAddFirstListener:()=>{c.addObserver(this)},onDidRemoveLastListener:()=>{c.removeObserver(this)}};k||M(b),this.emitter=new v(b),k&&k.add(this.emitter)}beginUpdate(c){this.d++}handlePossibleChange(c){}handleChange(c,k){this.f=!0}endUpdate(c){this.d--,this.d===0&&(this._observable.reportChanges(),this.f&&(this.f=!1,this.emitter.fire(this._observable.get())))}}function q(W,c){return new Q(W,c).emitter.event}B.fromObservable=q;function x(W){return c=>{let k=0,b=!1;const w={beginUpdate(){k++},endUpdate(){k--,k===0&&(W.reportChanges(),b&&(b=!1,c()))},handlePossibleChange(){},handleChange(){b=!0}};return W.addObserver(w),W.reportChanges(),{dispose(){W.removeObserver(w)}}}}B.fromObservableLight=x})(u||(t.Event=u={}));class g{static{this.all=new Set}static{this.d=0}constructor(M){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${M}_${g.d++}`,g.all.add(this)}start(M){this.f=new A.$ac,this.listenerCount=M}stop(){if(this.f){const M=this.f.elapsed();this.durations.push(M),this.elapsedOverall+=M,this.invocationCount+=1,this.f=void 0}}}t.$cc=g;let L=-1;function r(B){const M=L;return L=B,{dispose(){L=M}}}t.$dc=r;class l{constructor(M,z=Math.random().toString(18).slice(2,5)){this.threshold=M,this.name=z,this.f=0}dispose(){this.d?.clear()}check(M,z){const te=this.threshold;if(te<=0||z<te)return;this.d||(this.d=new Map);const ne=this.d.get(M.value)||0;if(this.d.set(M.value,ne+1),this.f-=1,this.f<=0){this.f=te*.5;let se,ce=0;for(const[ue,ae]of this.d)(!se||ce<ae)&&(se=ue,ce=ae);console.warn(`[${this.name}] potential listener LEAK detected, having ${z} listeners already. MOST frequent listener (${ce}):`),console.warn(se)}return()=>{const se=this.d.get(M.value)||0;this.d.set(M.value,se-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(M){this.value=M}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let a=0;class n{constructor(M){this.value=M,this.id=a++}}const h=2,s=(B,M)=>{if(B instanceof n)M(B);else for(let z=0;z<B.length;z++){const te=B[z];te&&M(te)}};class v{constructor(M){this.u=0,this.d=M,this.f=L>0||this.d?.leakWarningThreshold?new l(this.d?.leakWarningThreshold??L):void 0,this.g=this.d?._profName?new g(this.d._profName):void 0,this.t=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.t?.current===this&&this.t.reset(),this.q){if(y){const M=this.q;queueMicrotask(()=>{s(M,z=>z.stack?.print())})}this.q=void 0,this.u=0}this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.m??=(M,z,te)=>{if(this.f&&this.u>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),i.$lb.None;if(this.j)return i.$lb.None;z&&(M=M.bind(z));const ne=new n(M);let se,ce;this.f&&this.u>=Math.ceil(this.f.threshold*.2)&&(ne.stack=e.create(),se=this.f.check(ne.stack,this.u+1)),y&&(ne.stack=ce??e.create()),this.q?this.q instanceof n?(this.t??=new E,this.q=[this.q,ne]):this.q.push(ne):(this.d?.onWillAddFirstListener?.(this),this.q=ne,this.d?.onDidAddFirstListener?.(this)),this.u++;const ue=(0,i.$jb)(()=>{se?.(),this.v(ne)});return te instanceof i.$kb?te.add(ue):Array.isArray(te)&&te.push(ue),ue},this.m}v(M){if(this.d?.onWillRemoveListener?.(this),!this.q)return;if(this.u===1){this.q=void 0,this.d?.onDidRemoveLastListener?.(this),this.u=0;return}const z=this.q,te=z.indexOf(M);if(te===-1)throw console.log("disposed?",this.j),console.log("size?",this.u),console.log("arr?",JSON.stringify(this.q)),new Error("Attempted to dispose unknown listener");this.u--,z[te]=void 0;const ne=this.t.current===this;if(this.u*h<=z.length){let se=0;for(let ce=0;ce<z.length;ce++)z[ce]?z[se++]=z[ce]:ne&&(this.t.end--,se<this.t.i&&this.t.i--);z.length=se}}w(M,z){if(!M)return;const te=this.d?.onListenerError||N.$Y;if(!te){M.value(z);return}try{M.value(z)}catch(ne){te(ne)}}x(M){const z=M.current.q;for(;M.i<M.end;)this.w(z[M.i++],M.value);M.reset()}fire(M){if(this.t?.current&&(this.x(this.t),this.g?.stop()),this.g?.start(this.u),this.q)if(this.q instanceof n)this.w(this.q,M);else{const z=this.t;z.enqueue(this,M,this.q.length),this.x(z)}this.g?.stop()}hasListeners(){return this.u>0}}t.$ec=v;const D=()=>new E;t.$fc=D;class E{constructor(){this.i=-1,this.end=0}enqueue(M,z,te){this.i=0,this.end=te,this.current=M,this.value=z}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class f extends v{async fireAsync(M,z,te){if(this.q)for(this.h||(this.h=new j.$ub),s(this.q,ne=>this.h.push([ne.value,M]));this.h.size>0&&!z.isCancellationRequested;){const[ne,se]=this.h.shift(),ce=[],ue={...se,token:z,waitUntil:ae=>{if(Object.isFrozen(ce))throw new Error("waitUntil can NOT be called asynchronous");te&&(ae=te(ae,ne)),ce.push(ae)}};try{ne(ue)}catch(ae){(0,N.$Y)(ae);continue}Object.freeze(ce),await Promise.allSettled(ce).then(ae=>{for(const pe of ae)pe.status==="rejected"&&(0,N.$Y)(pe.reason)})}}}t.$gc=f;class C extends v{get isPaused(){return this.h!==0}constructor(M){super(M),this.h=0,this.s=new j.$ub,this.y=M?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.y){if(this.s.size>0){const M=Array.from(this.s);this.s.clear(),super.fire(this.y(M))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(M){this.u&&(this.h!==0?this.s.push(M):super.fire(M))}}t.$hc=C;class T extends C{constructor(M){super(M),this.k=M.delay??100}fire(M){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(M)}}t.$ic=T;class P extends v{constructor(M){super(M),this.h=[],this.k=M?.merge}fire(M){this.hasListeners()&&(this.h.push(M),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(z=>super.fire(z)),this.h=[]}))}}t.$jc=P;class m{constructor(){this.f=!1,this.g=[],this.d=new v({onWillAddFirstListener:()=>this.h(),onDidRemoveLastListener:()=>this.j()})}get event(){return this.d.event}add(M){const z={event:M,listener:null};this.g.push(z),this.f&&this.k(z);const te=()=>{this.f&&this.m(z);const ne=this.g.indexOf(z);this.g.splice(ne,1)};return(0,i.$jb)((0,O.$cb)(te))}h(){this.f=!0,this.g.forEach(M=>this.k(M))}j(){this.f=!1,this.g.forEach(M=>this.m(M))}k(M){M.listener=M.event(z=>this.d.fire(z))}m(M){M.listener&&M.listener.dispose(),M.listener=null}dispose(){this.d.dispose()}}t.$kc=m;class ${constructor(M,z,te,ne){this.d=new i.$kb;const se=this.d.add(new m),ce=this.d.add(new i.$tb);function ue(ae){ce.set(ae,se.add(ne(ae)))}for(const ae of M)ue(ae);this.d.add(z(ae=>{ue(ae)})),this.d.add(te(ae=>{ce.deleteAndDispose(ae)})),this.event=se.event}dispose(){this.d.dispose()}}t.$lc=$;class F{constructor(){this.d=[]}wrapEvent(M){return(z,te,ne)=>M(se=>{const ce=this.d[this.d.length-1];ce?ce.push(()=>z.call(te,se)):z.call(te,se)},void 0,ne)}bufferEvents(M){const z=[];this.d.push(z);const te=M();return this.d.pop(),z.forEach(ne=>ne()),te}}t.$mc=F;class R{constructor(){this.d=!1,this.f=u.None,this.g=i.$lb.None,this.h=new v({onDidAddFirstListener:()=>{this.d=!0,this.g=this.f(this.h.fire,this.h)},onDidRemoveLastListener:()=>{this.d=!1,this.g.dispose()}}),this.event=this.h.event}set input(M){this.f=M,this.d&&(this.g.dispose(),this.g=M(this.h.fire,this.h))}dispose(){this.g.dispose(),this.h.dispose()}}t.$nc=R}),define(be[16],$e([1,0,3,2]),function(re,t,N,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$WN=t.$VN=t.$UN=t.$TN=t.$SN=t.$RN=t.$QN=t.$PN=t.$ON=t.$NN=t.$MN=t.$LN=t.$KN=t.$JN=t.$IN=t.$HN=t.$GN=t.$FN=void 0;class i{constructor(){this.a=0,this.b=1,this.c=!1,this.d=new N.$ec,this.onDidChangeFullscreen=this.d.event}static{this.INSTANCE=new i}getZoomLevel(){return this.a}setZoomLevel(D){this.a!==D&&(this.a=D)}getZoomFactor(){return this.b}setZoomFactor(D){this.b=D}setFullscreen(D){this.c!==D&&(this.c=D,this.d.fire())}isFullscreen(){return this.c}}class j extends O.$lb{constructor(){super(),this.a=this.B(new N.$ec),this.onDidChange=this.a.event,this.b=()=>this.f(!0),this.c=null,this.f(!1)}f(D){this.c?.removeEventListener("change",this.b),this.c=window.matchMedia(`(resolution: ${window.devicePixelRatio}dppx)`),this.c.addEventListener("change",this.b),D&&this.a.fire()}}class A extends O.$lb{get value(){return this.b}constructor(){super(),this.a=this.B(new N.$ec),this.onDidChange=this.a.event,this.b=this.c();const D=this.B(new j);this.B(D.onDidChange(()=>{this.b=this.c(),this.a.fire(this.b)}))}c(){const D=document.createElement("canvas").getContext("2d"),E=window.devicePixelRatio||1,f=D.webkitBackingStorePixelRatio||D.mozBackingStorePixelRatio||D.msBackingStorePixelRatio||D.oBackingStorePixelRatio||D.backingStorePixelRatio||1;return E/f}}class y{constructor(){this.a=null}b(){return this.a||(this.a=(0,O.$eb)(new A)),this.a}get value(){return this.b().value}get onDidChange(){return this.b().onDidChange}}function o(v,D){typeof v=="string"&&(v=window.matchMedia(v)),v.addEventListener("change",D)}t.$FN=o,t.$GN=new y;function u(v){i.INSTANCE.setZoomLevel(v)}t.$HN=u;function g(){return i.INSTANCE.getZoomLevel()}t.$IN=g;function L(){return i.INSTANCE.getZoomFactor()}t.$JN=L;function r(v){i.INSTANCE.setZoomFactor(v)}t.$KN=r;function l(v){i.INSTANCE.setFullscreen(v)}t.$LN=l;function e(){return i.INSTANCE.isFullscreen()}t.$MN=e,t.$NN=i.INSTANCE.onDidChangeFullscreen;const a=navigator.userAgent;t.$ON=a.indexOf("Firefox")>=0,t.$PN=a.indexOf("AppleWebKit")>=0,t.$QN=a.indexOf("Chrome")>=0,t.$RN=!t.$QN&&a.indexOf("Safari")>=0,t.$SN=!t.$QN&&!t.$RN&&t.$PN,t.$TN=a.indexOf("Electron/")>=0,t.$UN=a.indexOf("Android")>=0;let n=!1;if(window.matchMedia){const v=window.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),D=window.matchMedia("(display-mode: fullscreen)");n=v.matches,o(v,({matches:E})=>{n&&D.matches||(n=E)})}function h(){return n}t.$VN=h;function s(){return navigator?.windowControlsOverlay?.visible}t.$WN=s}),define(be[21],$e([1,0,3]),function(re,t,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$PP=void 0;class O{get event(){return this.a.event}constructor(j,A,y){const o=u=>this.a.fire(u);this.a=new N.$ec({onWillAddFirstListener:()=>j.addEventListener(A,o,y),onDidRemoveLastListener:()=>j.removeEventListener(A,o,y)})}dispose(){this.a.dispose()}}t.$PP=O}),define(be[27],$e([1,0,3]),function(re,t,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oc=t.CancellationToken=void 0;const O=Object.freeze(function(y,o){const u=setTimeout(y.bind(o),0);return{dispose(){clearTimeout(u)}}});var i;(function(y){function o(u){return u===y.None||u===y.Cancelled||u instanceof j?!0:!u||typeof u!="object"?!1:typeof u.isCancellationRequested=="boolean"&&typeof u.onCancellationRequested=="function"}y.isCancellationToken=o,y.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:N.Event.None}),y.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:O})})(i||(t.CancellationToken=i={}));class j{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?O:(this.b||(this.b=new N.$ec),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class A{constructor(o){this.a=void 0,this.b=void 0,this.b=o&&o.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new j),this.a}cancel(){this.a?this.a instanceof j&&this.a.cancel():this.a=i.Cancelled}dispose(o=!1){o&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof j&&this.a.dispose():this.a=i.None}}t.$oc=A}),define(be[81],$e([1,0,27]),function(re,t,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$id=t.$hd=t.$gd=void 0;class O{constructor(y){this.b=y,this.a=null}get(){if(this.a)return this.a;const y=new N.$oc,o=this.b(y.token);return this.a={promise:o,dispose:()=>{this.a=null,y.cancel(),y.dispose()}},this.a}}t.$gd=O;class i{constructor(y){this.c=y,this.a=void 0,this.b=void 0}get(y){const o=JSON.stringify(y);return this.b!==o&&(this.b=o,this.a=this.c(y)),this.a}}t.$hd=i;class j{get cachedValues(){return this.a}constructor(y){this.b=y,this.a=new Map}get(y){if(this.a.has(y))return this.a.get(y);const o=this.b(y);return this.a.set(y,o),o}}t.$id=j}),define(be[46],$e([1,0,3,2]),function(re,t,N,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Gr=t.$Fr=t.$Er=t.$Dr=t.ScrollbarVisibility=void 0;var i;(function(l){l[l.Auto=1]="Auto",l[l.Hidden=2]="Hidden",l[l.Visible=3]="Visible"})(i||(t.ScrollbarVisibility=i={}));class j{constructor(e,a,n,h,s,v,D){this.c=e,this._scrollStateBrand=void 0,this.c&&(a=a|0,n=n|0,h=h|0,s=s|0,v=v|0,D=D|0),this.rawScrollLeft=h,this.rawScrollTop=D,a<0&&(a=0),h+a>n&&(h=n-a),h<0&&(h=0),s<0&&(s=0),D+s>v&&(D=v-s),D<0&&(D=0),this.width=a,this.scrollWidth=n,this.scrollLeft=h,this.height=s,this.scrollHeight=v,this.scrollTop=D}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,a){return new j(this.c,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,a?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,a?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new j(this.c,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,a){const n=this.width!==e.width,h=this.scrollWidth!==e.scrollWidth,s=this.scrollLeft!==e.scrollLeft,v=this.height!==e.height,D=this.scrollHeight!==e.scrollHeight,E=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:a,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:n,scrollWidthChanged:h,scrollLeftChanged:s,heightChanged:v,scrollHeightChanged:D,scrollTopChanged:E}}}t.$Dr=j;class A extends O.$lb{constructor(e){super(),this._scrollableBrand=void 0,this.i=this.B(new N.$ec),this.onScroll=this.i.event,this.c=e.smoothScrollDuration,this.f=e.scheduleAtNextAnimationFrame,this.g=new j(e.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(e){this.c=e}validateScrollPosition(e){return this.g.withScrollPosition(e)}getScrollDimensions(){return this.g}setScrollDimensions(e,a){const n=this.g.withScrollDimensions(e,a);this.k(n,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(e){const a=this.g.withScrollPosition(e);this.h&&(this.h.dispose(),this.h=null),this.k(a,!1)}setScrollPositionSmooth(e,a){if(this.c===0)return this.setScrollPositionNow(e);if(this.h){e={scrollLeft:typeof e.scrollLeft>"u"?this.h.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this.h.to.scrollTop:e.scrollTop};const n=this.g.withScrollPosition(e);if(this.h.to.scrollLeft===n.scrollLeft&&this.h.to.scrollTop===n.scrollTop)return;let h;a?h=new g(this.h.from,n,this.h.startTime,this.h.duration):h=this.h.combine(this.g,n,this.c),this.h.dispose(),this.h=h}else{const n=this.g.withScrollPosition(e);this.h=g.start(this.g,n,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.j())})}hasPendingScrollAnimation(){return!!this.h}j(){if(!this.h)return;const e=this.h.tick(),a=this.g.withScrollPosition(e);if(this.k(a,!0),!!this.h){if(e.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.j())})}}k(e,a){const n=this.g;n.equals(e)||(this.g=e,this.i.fire(this.g.createScrollEvent(n,a)))}}t.$Er=A;class y{constructor(e,a,n){this.scrollLeft=e,this.scrollTop=a,this.isDone=n}}t.$Fr=y;function o(l,e){const a=e-l;return function(n){return l+a*r(n)}}function u(l,e,a){return function(n){return n<a?l(n/a):e((n-a)/(1-a))}}class g{constructor(e,a,n,h){this.from=e,this.to=a,this.duration=h,this.startTime=n,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(e,a,n){if(Math.abs(e-a)>2.5*n){let s,v;return e<a?(s=e+.75*n,v=a-.75*n):(s=e-.75*n,v=a+.75*n),u(o(e,s),o(v,a),.33)}return o(e,a)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(e){const a=(e-this.startTime)/this.duration;if(a<1){const n=this.c(a),h=this.d(a);return new y(n,h,!1)}return new y(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,a,n){return g.start(e,a,n)}static start(e,a,n){n=n+10;const h=Date.now()-10;return new g(e,a,h,n)}}t.$Gr=g;function L(l){return Math.pow(l,3)}function r(l){return 1-L(1-l)}}),define(be[82],$e([1,0,6,2]),function(re,t,N,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Dc=t.$Cc=t.$Bc=t.$Ac=t.$zc=t.$yc=t.$xc=t.$wc=t.$vc=t.$uc=t.$tc=t.$sc=t.$rc=t.$qc=t.$pc=void 0;function i(D){const E=D;return E?typeof E.read=="function":!1}t.$pc=i;function j(D){const E=D;return E?[E.on,E.pause,E.resume,E.destroy].every(f=>typeof f=="function"):!1}t.$qc=j;function A(D){const E=D;return E?j(E.stream)&&Array.isArray(E.buffer)&&typeof E.ended=="boolean":!1}t.$rc=A;function y(D,E){return new o(D,E)}t.$sc=y;class o{constructor(E,f){this.e=E,this.f=f,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(E){if(!this.a.destroyed){if(this.a.flowing)this.g(E);else if(this.b.data.push(E),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(f=>this.d.push(f))}}error(E){this.a.destroyed||(this.a.flowing?this.h(E):this.b.error.push(E))}end(E){this.a.destroyed||(typeof E<"u"&&this.write(E),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(E){this.c.data.slice(0).forEach(f=>f(E))}h(E){this.c.error.length===0?(0,N.$Y)(E):this.c.error.slice(0).forEach(f=>f(E))}i(){this.c.end.slice(0).forEach(E=>E())}on(E,f){if(!this.a.destroyed)switch(E){case"data":this.c.data.push(f),this.resume();break;case"end":this.c.end.push(f),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(f),this.a.flowing&&this.k();break}}removeListener(E,f){if(this.a.destroyed)return;let C;switch(E){case"data":C=this.c.data;break;case"end":C=this.c.end;break;case"error":C=this.c.error;break}if(C){const T=C.indexOf(f);T>=0&&C.splice(T,1)}}j(){if(this.b.data.length>0){const E=this.e(this.b.data);this.g(E),this.b.data.length=0;const f=[...this.d];this.d.length=0,f.forEach(C=>C())}}k(){if(this.c.error.length>0){for(const E of this.b.error)this.h(E);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function u(D,E){const f=[];let C;for(;(C=D.read())!==null;)f.push(C);return E(f)}t.$tc=u;function g(D,E,f){const C=[];let T;for(;(T=D.read())!==null&&C.length<f;)C.push(T);return T===null&&C.length>0?E(C):{read:()=>{if(C.length>0)return C.shift();if(typeof T<"u"){const P=T;return T=void 0,P}return D.read()}}}t.$uc=g;function L(D,E){return new Promise((f,C)=>{const T=[];r(D,{onData:P=>{E&&T.push(P)},onError:P=>{E?C(P):f(void 0)},onEnd:()=>{f(E?E(T):void 0)}})})}t.$vc=L;function r(D,E,f){D.on("error",C=>{f?.isCancellationRequested||E.onError(C)}),D.on("end",()=>{f?.isCancellationRequested||E.onEnd()}),D.on("data",C=>{f?.isCancellationRequested||E.onData(C)})}t.$wc=r;function l(D,E){return new Promise((f,C)=>{const T=new O.$kb,P=[],m=R=>{if(P.push(R),P.length>E)return T.dispose(),D.pause(),f({stream:D,buffer:P,ended:!1})},$=R=>C(R),F=()=>f({stream:D,buffer:P,ended:!0});T.add((0,O.$jb)(()=>D.removeListener("error",$))),D.on("error",$),T.add((0,O.$jb)(()=>D.removeListener("end",F))),D.on("end",F),T.add((0,O.$jb)(()=>D.removeListener("data",m))),D.on("data",m)})}t.$xc=l;function e(D,E){const f=y(E);return f.end(D),f}t.$yc=e;function a(){const D=y(()=>{throw new Error("not supported")});return D.end(),D}t.$zc=a;function n(D){let E=!1;return{read:()=>E?null:(E=!0,D)}}t.$Ac=n;function h(D,E,f){const C=y(f);return r(D,{onData:T=>C.write(E.data(T)),onError:T=>C.error(E.error?E.error(T):T),onEnd:()=>C.end()}),C}t.$Bc=h;function s(D,E,f){let C=!1;return{read:()=>{const T=E.read();return C?T:(C=!0,T!==null?f([D,T]):D)}}}t.$Cc=s;function v(D,E,f){let C=!1;const T=y(f);return r(E,{onData:P=>C?T.write(P):(C=!0,T.write(f([D,P]))),onError:P=>T.error(P),onEnd:()=>{C||(C=!0,T.write(D)),T.end()}}),T}t.$Dc=v}),define(be[31],$e([1,0,30,82]),function(re,t,N,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Yc=t.$Xc=t.$Wc=t.$Vc=t.$Uc=t.$Tc=t.$Sc=t.$Rc=t.$Qc=t.$Pc=t.$Oc=t.$Nc=t.$Mc=t.$Lc=t.$Kc=t.$Jc=t.$Ic=t.$Hc=t.$Gc=t.$Fc=t.$Ec=void 0;const i=typeof Buffer<"u",j=new N.$T(()=>new Uint8Array(256));let A,y;class o{static alloc(z){return i?new o(Buffer.allocUnsafe(z)):new o(new Uint8Array(z))}static wrap(z){return i&&!Buffer.isBuffer(z)&&(z=Buffer.from(z.buffer,z.byteOffset,z.byteLength)),new o(z)}static fromString(z,te){return!(te?.dontUseNodeBuffer||!1)&&i?new o(Buffer.from(z)):(A||(A=new TextEncoder),new o(A.encode(z)))}static fromByteArray(z){const te=o.alloc(z.length);for(let ne=0,se=z.length;ne<se;ne++)te.buffer[ne]=z[ne];return te}static concat(z,te){if(typeof te>"u"){te=0;for(let ce=0,ue=z.length;ce<ue;ce++)te+=z[ce].byteLength}const ne=o.alloc(te);let se=0;for(let ce=0,ue=z.length;ce<ue;ce++){const ae=z[ce];ne.set(ae,se),se+=ae.byteLength}return ne}constructor(z){this.buffer=z,this.byteLength=this.buffer.byteLength}clone(){const z=o.alloc(this.byteLength);return z.set(this),z}toString(){return i?this.buffer.toString():(y||(y=new TextDecoder),y.decode(this.buffer))}slice(z,te){return new o(this.buffer.subarray(z,te))}set(z,te){if(z instanceof o)this.buffer.set(z.buffer,te);else if(z instanceof Uint8Array)this.buffer.set(z,te);else if(z instanceof ArrayBuffer)this.buffer.set(new Uint8Array(z),te);else if(ArrayBuffer.isView(z))this.buffer.set(new Uint8Array(z.buffer,z.byteOffset,z.byteLength),te);else throw new Error("Unknown argument 'array'")}readUInt32BE(z){return r(this.buffer,z)}writeUInt32BE(z,te){l(this.buffer,z,te)}readUInt32LE(z){return e(this.buffer,z)}writeUInt32LE(z,te){a(this.buffer,z,te)}readUInt8(z){return n(this.buffer,z)}writeUInt8(z,te){h(this.buffer,z,te)}indexOf(z,te=0){return u(this.buffer,z instanceof o?z.buffer:z,te)}}t.$Ec=o;function u(M,z,te=0){const ne=z.byteLength,se=M.byteLength;if(ne===0)return 0;if(ne===1)return M.indexOf(z[0]);if(ne>se-te)return-1;const ce=j.value;ce.fill(z.length);for(let Oe=0;Oe<z.length;Oe++)ce[z[Oe]]=z.length-Oe-1;let ue=te+z.length-1,ae=ue,pe=-1;for(;ue<se;)if(M[ue]===z[ae]){if(ae===0){pe=ue;break}ue--,ae--}else ue+=Math.max(z.length-ae,ce[M[ue]]),ae=z.length-1;return pe}t.$Fc=u;function g(M,z){return M[z+0]<<0>>>0|M[z+1]<<8>>>0}t.$Gc=g;function L(M,z,te){M[te+0]=z&255,z=z>>>8,M[te+1]=z&255}t.$Hc=L;function r(M,z){return M[z]*2**24+M[z+1]*2**16+M[z+2]*2**8+M[z+3]}t.$Ic=r;function l(M,z,te){M[te+3]=z,z=z>>>8,M[te+2]=z,z=z>>>8,M[te+1]=z,z=z>>>8,M[te]=z}t.$Jc=l;function e(M,z){return M[z+0]<<0>>>0|M[z+1]<<8>>>0|M[z+2]<<16>>>0|M[z+3]<<24>>>0}t.$Kc=e;function a(M,z,te){M[te+0]=z&255,z=z>>>8,M[te+1]=z&255,z=z>>>8,M[te+2]=z&255,z=z>>>8,M[te+3]=z&255}t.$Lc=a;function n(M,z){return M[z]}t.$Mc=n;function h(M,z,te){M[te]=z}t.$Nc=h;function s(M){return O.$tc(M,z=>o.concat(z))}t.$Oc=s;function v(M){return O.$Ac(M)}t.$Pc=v;function D(M){return O.$vc(M,z=>o.concat(z))}t.$Qc=D;async function E(M){return M.ended?o.concat(M.buffer):o.concat([...M.buffer,await D(M.stream)])}t.$Rc=E;function f(M){return O.$yc(M,z=>o.concat(z))}t.$Sc=f;function C(M){return O.$Bc(M,{data:z=>typeof z=="string"?o.fromString(z):o.wrap(z)},z=>o.concat(z))}t.$Tc=C;function T(M){return O.$sc(z=>o.concat(z),M)}t.$Uc=T;function P(M,z){return O.$Cc(M,z,te=>o.concat(te))}t.$Vc=P;function m(M,z){return O.$Dc(M,z,te=>o.concat(te))}t.$Wc=m;function $(M){let z=0,te=0,ne=0;const se=new Uint8Array(Math.floor(M.length/4*3)),ce=ae=>{switch(te){case 3:se[ne++]=z|ae,te=0;break;case 2:se[ne++]=z|ae>>>2,z=ae<<6,te=3;break;case 1:se[ne++]=z|ae>>>4,z=ae<<4,te=2;break;default:z=ae<<2,te=1}};for(let ae=0;ae<M.length;ae++){const pe=M.charCodeAt(ae);if(pe>=65&&pe<=90)ce(pe-65);else if(pe>=97&&pe<=122)ce(pe-97+26);else if(pe>=48&&pe<=57)ce(pe-48+52);else if(pe===43||pe===45)ce(62);else if(pe===47||pe===95)ce(63);else{if(pe===61)break;throw new SyntaxError(`Unexpected base64 character ${M[ae]}`)}}const ue=ne;for(;te>0;)ce(0);return o.wrap(se).slice(0,ue)}t.$Xc=$;const F="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",R="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function B({buffer:M},z=!0,te=!1){const ne=te?R:F;let se="";const ce=M.byteLength%3;let ue=0;for(;ue<M.byteLength-ce;ue+=3){const ae=M[ue+0],pe=M[ue+1],Oe=M[ue+2];se+=ne[ae>>>2],se+=ne[(ae<<4|pe>>>4)&63],se+=ne[(pe<<2|Oe>>>6)&63],se+=ne[Oe&63]}if(ce===1){const ae=M[ue+0];se+=ne[ae>>>2],se+=ne[ae<<4&63],z&&(se+="==")}else if(ce===2){const ae=M[ue+0],pe=M[ue+1];se+=ne[ae>>>2],se+=ne[(ae<<4|pe>>>4)&63],se+=ne[pe<<2&63],z&&(se+="=")}return se}t.$Yc=B}),define(be[11],$e([1,0,81,30]),function(re,t,N,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$he=t.$ge=t.$fe=t.$ee=t.GraphemeBreakType=t.$de=t.$ce=t.$be=t.$ae=t.$_d=t.$$d=t.$0d=t.$9d=t.$8d=t.$7d=t.$6d=t.$5d=t.$4d=t.$3d=t.$2d=t.$1d=t.$Zd=t.$Yd=t.$Xd=t.$Wd=t.$Vd=t.$Ud=t.$Td=t.$Sd=t.$Rd=t.$Qd=t.$Pd=t.$Od=t.$Nd=t.$Md=t.$Ld=t.$Kd=t.$Jd=t.$Id=t.$Hd=t.$Gd=t.$Fd=t.$Ed=t.$Dd=t.$Cd=t.$Bd=t.$Ad=t.$zd=t.$yd=t.$xd=t.$wd=t.$vd=t.$ud=t.$td=t.$sd=t.$rd=t.$qd=t.$pd=t.$od=t.$nd=t.$md=t.$ld=void 0;function i(G){return!G||typeof G!="string"?!0:G.trim().length===0}t.$ld=i;const j=/{(\d+)}/g;function A(G,...le){return le.length===0?G:G.replace(j,function(me,De){const Ce=parseInt(De,10);return isNaN(Ce)||Ce<0||Ce>=le.length?me:le[Ce]})}t.$md=A;const y=/{([^}]+)}/g;function o(G,le){return G.replace(y,(me,De)=>le[De]??me)}t.$nd=o;function u(G){return G.replace(/[<>&]/g,function(le){switch(le){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return le}})}t.$od=u;function g(G){return G.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.$pd=g;function L(G,le){let me=0;const De=le.charCodeAt(0);for(let Ce=G.length-1;Ce>=0;Ce--)G.charCodeAt(Ce)===De&&me++;return me}t.$qd=L;function r(G,le,me="\u2026"){return G.length<=le?G:`${G.substr(0,le)}${me}`}t.$rd=r;function l(G,le=" "){const me=e(G,le);return a(me,le)}t.$sd=l;function e(G,le){if(!G||!le)return G;const me=le.length;if(me===0||G.length===0)return G;let De=0;for(;G.indexOf(le,De)===De;)De=De+me;return G.substring(De)}t.$td=e;function a(G,le){if(!G||!le)return G;const me=le.length,De=G.length;if(me===0||De===0)return G;let Ce=De,Re=-1;for(;Re=G.lastIndexOf(le,Ce-1),!(Re===-1||Re+me!==Ce);){if(Re===0)return"";Ce=Re}return G.substring(0,Ce)}t.$ud=a;function n(G){return G.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.$vd=n;function h(G){return G.replace(/\*/g,"")}t.$wd=h;function s(G,le,me={}){if(!G)throw new Error("Cannot create regex from empty string");le||(G=g(G)),me.wholeWord&&(/\B/.test(G.charAt(0))||(G="\\b"+G),/\B/.test(G.charAt(G.length-1))||(G=G+"\\b"));let De="";return me.global&&(De+="g"),me.matchCase||(De+="i"),me.multiline&&(De+="m"),me.unicode&&(De+="u"),new RegExp(G,De)}t.$xd=s;function v(G){return G.source==="^"||G.source==="^$"||G.source==="$"||G.source==="^\\s*$"?!1:!!(G.exec("")&&G.lastIndex===0)}t.$yd=v;function D(G){return G.split(/\r\n|\r|\n/)}t.$zd=D;function E(G){for(let le=0,me=G.length;le<me;le++){const De=G.charCodeAt(le);if(De!==32&&De!==9)return le}return-1}t.$Ad=E;function f(G,le=0,me=G.length){for(let De=le;De<me;De++){const Ce=G.charCodeAt(De);if(Ce!==32&&Ce!==9)return G.substring(le,De)}return G.substring(le,me)}t.$Bd=f;function C(G,le=G.length-1){for(let me=le;me>=0;me--){const De=G.charCodeAt(me);if(De!==32&&De!==9)return me}return-1}t.$Cd=C;function T(G,le,me){const De=[];let Ce=0;for(const Re of G.matchAll(le)){if(De.push(G.slice(Ce,Re.index)),Re.index===void 0)throw new Error("match.index should be defined");Ce=Re.index+Re[0].length,De.push(me(Re[0],...Re.slice(1),Re.index,G,Re.groups))}return De.push(G.slice(Ce)),Promise.all(De).then(Re=>Re.join(""))}t.$Dd=T;function P(G,le){return G<le?-1:G>le?1:0}t.$Ed=P;function m(G,le,me=0,De=G.length,Ce=0,Re=le.length){for(;me<De&&Ce<Re;me++,Ce++){const Qe=G.charCodeAt(me),We=le.charCodeAt(Ce);if(Qe<We)return-1;if(Qe>We)return 1}const He=De-me,Ye=Re-Ce;return He<Ye?-1:He>Ye?1:0}t.$Fd=m;function $(G,le){return F(G,le,0,G.length,0,le.length)}t.$Gd=$;function F(G,le,me=0,De=G.length,Ce=0,Re=le.length){for(;me<De&&Ce<Re;me++,Ce++){let Qe=G.charCodeAt(me),We=le.charCodeAt(Ce);if(Qe===We)continue;if(Qe>=128||We>=128)return m(G.toLowerCase(),le.toLowerCase(),me,De,Ce,Re);B(Qe)&&(Qe-=32),B(We)&&(We-=32);const _e=Qe-We;if(_e!==0)return _e}const He=De-me,Ye=Re-Ce;return He<Ye?-1:He>Ye?1:0}t.$Hd=F;function R(G){return G>=48&&G<=57}t.$Id=R;function B(G){return G>=97&&G<=122}t.$Jd=B;function M(G){return G>=65&&G<=90}t.$Kd=M;function z(G,le){return G.length===le.length&&F(G,le)===0}t.$Ld=z;function te(G,le){const me=le.length;return le.length>G.length?!1:F(G,le,0,me)===0}t.$Md=te;function ne(G,le){const me=Math.min(G.length,le.length);let De;for(De=0;De<me;De++)if(G.charCodeAt(De)!==le.charCodeAt(De))return De;return me}t.$Nd=ne;function se(G,le){const me=Math.min(G.length,le.length);let De;const Ce=G.length-1,Re=le.length-1;for(De=0;De<me;De++)if(G.charCodeAt(Ce-De)!==le.charCodeAt(Re-De))return De;return me}t.$Od=se;function ce(G){return 55296<=G&&G<=56319}t.$Pd=ce;function ue(G){return 56320<=G&&G<=57343}t.$Qd=ue;function ae(G,le){return(G-55296<<10)+(le-56320)+65536}t.$Rd=ae;function pe(G,le,me){const De=G.charCodeAt(me);if(ce(De)&&me+1<le){const Ce=G.charCodeAt(me+1);if(ue(Ce))return ae(De,Ce)}return De}t.$Sd=pe;function Oe(G,le){const me=G.charCodeAt(le-1);if(ue(me)&&le>1){const De=G.charCodeAt(le-2);if(ce(De))return ae(De,me)}return me}class Te{get offset(){return this.e}constructor(le,me=0){this.c=le,this.d=le.length,this.e=me}setOffset(le){this.e=le}prevCodePoint(){const le=Oe(this.c,this.e);return this.e-=le>=65536?2:1,le}nextCodePoint(){const le=pe(this.c,this.d,this.e);return this.e+=le>=65536?2:1,le}eol(){return this.e>=this.d}}t.$Td=Te;class Me{get offset(){return this.c.offset}constructor(le,me=0){this.c=new Te(le,me)}nextGraphemeLength(){const le=Ee.getInstance(),me=this.c,De=me.offset;let Ce=le.getGraphemeBreakType(me.nextCodePoint());for(;!me.eol();){const Re=me.offset,He=le.getGraphemeBreakType(me.nextCodePoint());if(we(Ce,He)){me.setOffset(Re);break}Ce=He}return me.offset-De}prevGraphemeLength(){const le=Ee.getInstance(),me=this.c,De=me.offset;let Ce=le.getGraphemeBreakType(me.prevCodePoint());for(;me.offset>0;){const Re=me.offset,He=le.getGraphemeBreakType(me.prevCodePoint());if(we(He,Ce)){me.setOffset(Re);break}Ce=He}return De-me.offset}eol(){return this.c.eol()}}t.$Ud=Me;function fe(G,le){return new Me(G,le).nextGraphemeLength()}t.$Vd=fe;function ie(G,le){return new Me(G,le).prevGraphemeLength()}t.$Wd=ie;function K(G,le){le>0&&ue(G.charCodeAt(le))&&le--;const me=le+fe(G,le);return[me-ie(G,me),me]}t.$Xd=K;function U(G){const le=new Me(G);let me=0;for(;!le.eol();)me++,le.nextGraphemeLength();return me}t.$Yd=U;let ee;function J(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function S(G){return ee||(ee=J()),ee.test(G)}t.$Zd=S;const _=/^[\t\n\r\x20-\x7E]*$/;function d(G){return _.test(G)}t.$1d=d,t.$2d=/[\u2028\u2029]/;function p(G){return t.$2d.test(G)}t.$3d=p;function H(G){return G>=11904&&G<=55215||G>=63744&&G<=64255||G>=65281&&G<=65374}t.$4d=H;function Q(G){return G>=127462&&G<=127487||G===8986||G===8987||G===9200||G===9203||G>=9728&&G<=10175||G===11088||G===11093||G>=127744&&G<=128591||G>=128640&&G<=128764||G>=128992&&G<=129008||G>=129280&&G<=129535||G>=129648&&G<=129782}t.$5d=Q;function q(G,le){if(G.length<le)return G;const me=/\b/g;let De=0;for(;me.test(G)&&!(G.length-me.lastIndex<le);)De=me.lastIndex,me.lastIndex+=1;return G.substring(De).replace(/^\s/,"")}t.$6d=q;const x=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,W=/\x1b\].*?\x07/g;function c(G){return G&&(G=G.replace(x,"").replace(W,"")),G}t.$7d=c,t.$8d=String.fromCharCode(65279);function k(G){return!!(G&&G.length>0&&G.charCodeAt(0)===65279)}t.$9d=k;function b(G){return k(G)?G.substr(1):G}t.$0d=b;function w(G,le){if(!G||!le||G.length<le.length)return!1;const me=le.length,De=G.toLowerCase();let Ce=0,Re=-1;for(;Ce<me;){const He=De.indexOf(le[Ce],Re+1);if(He<0)return!1;Re=He,Ce++}return!0}t.$$d=w;function I(G,le=!1){return G?(le&&(G=G.replace(/\\./g,"")),G.toLowerCase()!==G):!1}t.$_d=I;function V(G){return G.charAt(0).toUpperCase()+G.slice(1)}t.$ae=V;function Z(G,le=1){if(le===0)return"";let me=-1;do me=G.indexOf(`
`,me+1),le--;while(le>0&&me>=0);return me===-1?G:(G[me-1]==="\r"&&me--,G.substr(0,me))}t.$be=Z;function oe(G){return G=G%(2*26),G<26?String.fromCharCode(97+G):String.fromCharCode(65+G-26)}t.$ce=oe;function ge(G){return Ee.getInstance().getGraphemeBreakType(G)}t.$de=ge;function we(G,le){return G===0?le!==5&&le!==7:G===2&&le===3?!1:G===4||G===2||G===3||le===4||le===2||le===3?!0:!(G===8&&(le===8||le===9||le===11||le===12)||(G===11||G===9)&&(le===9||le===10)||(G===12||G===10)&&le===10||le===5||le===13||le===7||G===1||G===13&&le===14||G===6&&le===6)}var Ae;(function(G){G[G.Other=0]="Other",G[G.Prepend=1]="Prepend",G[G.CR=2]="CR",G[G.LF=3]="LF",G[G.Control=4]="Control",G[G.Extend=5]="Extend",G[G.Regional_Indicator=6]="Regional_Indicator",G[G.SpacingMark=7]="SpacingMark",G[G.L=8]="L",G[G.V=9]="V",G[G.T=10]="T",G[G.LV=11]="LV",G[G.LVT=12]="LVT",G[G.ZWJ=13]="ZWJ",G[G.Extended_Pictographic=14]="Extended_Pictographic"})(Ae||(t.GraphemeBreakType=Ae={}));class Ee{static{this.c=null}static getInstance(){return Ee.c||(Ee.c=new Ee),Ee.c}constructor(){this.d=ve()}getGraphemeBreakType(le){if(le<32)return le===10?3:le===13?2:4;if(le<127)return 0;const me=this.d,De=me.length/3;let Ce=1;for(;Ce<=De;)if(le<me[3*Ce])Ce=2*Ce;else if(le>me[3*Ce+1])Ce=2*Ce+1;else return me[3*Ce+2];return 0}}function ve(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Le(G,le){if(G===0)return 0;const me=Fe(G,le);if(me!==void 0)return me;const De=new Te(le,G);return De.prevCodePoint(),De.offset}t.$ee=Le;function Fe(G,le){const me=new Te(le,G);let De=me.prevCodePoint();for(;Ke(De)||De===65039||De===8419;){if(me.offset===0)return;De=me.prevCodePoint()}if(!Q(De))return;let Ce=me.offset;return Ce>0&&me.prevCodePoint()===8205&&(Ce=me.offset),Ce}function Ke(G){return 127995<=G&&G<=127999}var je;(function(G){G[G.zwj=8205]="zwj",G[G.emojiVariantSelector=65039]="emojiVariantSelector",G[G.enclosingKeyCap=8419]="enclosingKeyCap"})(je||(je={})),t.$fe="\xA0";class Ie{static{this.c=new O.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new N.$hd(le=>{function me(_e){const et=new Map;for(let it=0;it<_e.length;it+=2)et.set(_e[it],_e[it+1]);return et}function De(_e,et){const it=new Map(_e);for(const[ft,ct]of et)it.set(ft,ct);return it}function Ce(_e,et){if(!_e)return et;const it=new Map;for(const[ft,ct]of _e)et.has(ft)&&it.set(ft,ct);return it}const Re=this.c.value;let He=le.filter(_e=>!_e.startsWith("_")&&_e in Re);He.length===0&&(He=["_default"]);let Ye;for(const _e of He){const et=me(Re[_e]);Ye=Ce(Ye,et)}const Qe=me(Re._common),We=De(Qe,Ye);return new Ie(We)})}static getInstance(le){return Ie.d.get(Array.from(le))}static{this.e=new O.$T(()=>Object.keys(Ie.c.value).filter(le=>!le.startsWith("_")))}static getLocales(){return Ie.e.value}constructor(le){this.f=le}isAmbiguous(le){return this.f.has(le)}getPrimaryConfusable(le){return this.f.get(le)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$ge=Ie;class Ge{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ge.c())),this.d}static isInvisibleCharacter(le){return Ge.e().has(le)}static get codePoints(){return Ge.e()}}t.$he=Ge}),define(be[32],$e([1,0,75,11]),function(re,t,N,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zj=t.$yj=t.$xj=t.$wj=t.FuzzyScore=t.$vj=t.$uj=t.$tj=t.$sj=t.$rj=t.$qj=t.$pj=t.$oj=t.$nj=t.$mj=t.$lj=t.$kj=t.or=void 0;function i(...b){return function(w,I){for(let V=0,Z=b.length;V<Z;V++){const oe=b[V](w,I);if(oe)return oe}return null}}t.or=i,t.$kj=j.bind(void 0,!1),t.$lj=j.bind(void 0,!0);function j(b,w,I){if(!I||I.length<w.length)return null;let V;return b?V=O.$Md(I,w):V=I.indexOf(w)===0,V?w.length>0?[{start:0,end:w.length}]:[]:null}function A(b,w){const I=w.toLowerCase().indexOf(b.toLowerCase());return I===-1?null:[{start:I,end:I+b.length}]}t.$mj=A;function y(b,w){return o(b.toLowerCase(),w.toLowerCase(),0,0)}t.$nj=y;function o(b,w,I,V){if(I===b.length)return[];if(V===w.length)return null;if(b[I]===w[V]){let Z=null;return(Z=o(b,w,I+1,V+1))?h({start:V,end:V+1},Z):null}return o(b,w,I,V+1)}function u(b){return 97<=b&&b<=122}function g(b){return 65<=b&&b<=90}t.$oj=g;function L(b){return 48<=b&&b<=57}function r(b){return b===32||b===9||b===10||b===13}const l=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(b=>l.add(b.charCodeAt(0)));function e(b){return r(b)||l.has(b)}function a(b,w){return b===w||e(b)&&e(w)}function n(b){return u(b)||g(b)||L(b)}function h(b,w){return w.length===0?w=[b]:b.end===w[0].start?w[0].start=b.start:w.unshift(b),w}function s(b,w){for(let I=w;I<b.length;I++){const V=b.charCodeAt(I);if(g(V)||L(V)||I>0&&!n(b.charCodeAt(I-1)))return I}return b.length}function v(b,w,I,V){if(I===b.length)return[];if(V===w.length)return null;if(b[I]!==w[V].toLowerCase())return null;{let Z=null,oe=V+1;for(Z=v(b,w,I+1,V+1);!Z&&(oe=s(w,oe))<w.length;)Z=v(b,w,I+1,oe),oe++;return Z===null?null:h({start:V,end:V+1},Z)}}function D(b){let w=0,I=0,V=0,Z=0,oe=0;for(let ve=0;ve<b.length;ve++)oe=b.charCodeAt(ve),g(oe)&&w++,u(oe)&&I++,n(oe)&&V++,L(oe)&&Z++;const ge=w/b.length,we=I/b.length,Ae=V/b.length,Ee=Z/b.length;return{upperPercent:ge,lowerPercent:we,alphaPercent:Ae,numericPercent:Ee}}function E(b){const{upperPercent:w,lowerPercent:I}=b;return I===0&&w>.6}function f(b){const{upperPercent:w,lowerPercent:I,alphaPercent:V,numericPercent:Z}=b;return I>.2&&w<.8&&V>.6&&Z<.2}function C(b){let w=0,I=0,V=0,Z=0;for(let oe=0;oe<b.length;oe++)V=b.charCodeAt(oe),g(V)&&w++,u(V)&&I++,r(V)&&Z++;return(w===0||I===0)&&Z===0?b.length<=30:w<=5}function T(b,w){if(!w||(w=w.trim(),w.length===0)||!C(b)||w.length>60)return null;const I=D(w);if(!f(I)){if(!E(I))return null;w=w.toLowerCase()}let V=null,Z=0;for(b=b.toLowerCase();Z<w.length&&(V=v(b,w,0,Z))===null;)Z=s(w,Z+1);return V}t.$pj=T;function P(b,w,I=!1){if(!w||w.length===0)return null;let V=null,Z=0;for(b=b.toLowerCase(),w=w.toLowerCase();Z<w.length&&(V=m(b,w,0,Z,I))===null;)Z=$(w,Z+1);return V}t.$qj=P;function m(b,w,I,V,Z){if(I===b.length)return[];if(V===w.length)return null;if(a(b.charCodeAt(I),w.charCodeAt(V))){let oe=null,ge=V+1;if(oe=m(b,w,I+1,V+1,Z),!Z)for(;!oe&&(ge=$(w,ge))<w.length;)oe=m(b,w,I+1,ge,Z),ge++;return oe?b.charCodeAt(I)!==w.charCodeAt(V)?oe:h({start:V,end:V+1},oe):null}else return null}function $(b,w){for(let I=w;I<b.length;I++)if(e(b.charCodeAt(I))||I>0&&e(b.charCodeAt(I-1)))return I;return b.length}const F=i(t.$lj,T,A),R=i(t.$lj,T,y),B=new N.$qi(1e4);function M(b,w,I=!1){if(typeof b!="string"||typeof w!="string")return null;let V=B.get(b);V||(V=new RegExp(O.$vd(b),"i"),B.set(b,V));const Z=V.exec(w);return Z?[{start:Z.index,end:Z.index+Z[0].length}]:I?R(b,w):F(b,w)}t.$rj=M;function z(b,w){const I=H(b,b.toLowerCase(),0,w,w.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return I?ne(I):null}t.$sj=z;function te(b,w,I,V,Z,oe){const ge=Math.min(13,b.length);for(;I<ge;I++){const we=H(b,w,I,V,Z,oe,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(we)return we}return[0,oe]}t.$tj=te;function ne(b){if(typeof b>"u")return[];const w=[],I=b[1];for(let V=b.length-1;V>1;V--){const Z=b[V]+I,oe=w[w.length-1];oe&&oe.end===Z?oe.end=Z+1:w.push({start:Z,end:Z+1})}return w}t.$uj=ne;const se=128;function ce(){const b=[],w=[];for(let I=0;I<=se;I++)w[I]=0;for(let I=0;I<=se;I++)b.push(w.slice(0));return b}function ue(b){const w=[];for(let I=0;I<=b;I++)w[I]=0;return w}const ae=ue(2*se),pe=ue(2*se),Oe=ce(),Te=ce(),Me=ce(),fe=!1;function ie(b,w,I,V,Z){function oe(we,Ae,Ee=" "){for(;we.length<Ae;)we=Ee+we;return we}let ge=` |   |${V.split("").map(we=>oe(we,3)).join("|")}
`;for(let we=0;we<=I;we++)we===0?ge+=" |":ge+=`${w[we-1]}|`,ge+=b[we].slice(0,Z+1).map(Ae=>oe(Ae.toString(),3)).join("|")+`
`;return ge}function K(b,w,I,V){b=b.substr(w),I=I.substr(V),console.log(ie(Te,b,b.length,I,I.length)),console.log(ie(Me,b,b.length,I,I.length)),console.log(ie(Oe,b,b.length,I,I.length))}function U(b,w){if(w<0||w>=b.length)return!1;const I=b.codePointAt(w);switch(I){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!O.$5d(I)}}function ee(b,w){if(w<0||w>=b.length)return!1;switch(b.charCodeAt(w)){case 32:case 9:return!0;default:return!1}}function J(b,w,I){return w[b]!==I[b]}function S(b,w,I,V,Z,oe,ge=!1){for(;w<I&&Z<oe;)b[w]===V[Z]&&(ge&&(ae[w]=Z),w+=1),Z+=1;return w===I}t.$vj=S;var _;(function(b){b[b.Diag=1]="Diag",b[b.Left=2]="Left",b[b.LeftLeft=3]="LeftLeft"})(_||(_={}));var d;(function(b){b.Default=[-100,0];function w(I){return!I||I.length===2&&I[0]===-100&&I[1]===0}b.isDefault=w})(d||(t.FuzzyScore=d={}));class p{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(w,I){this.firstMatchCanBeWeak=w,this.boostFullMatch=I}}t.$wj=p;function H(b,w,I,V,Z,oe,ge=p.default){const we=b.length>se?se:b.length,Ae=V.length>se?se:V.length;if(I>=we||oe>=Ae||we-I>Ae-oe||!S(w,I,we,Z,oe,Ae,!0))return;Q(we,Ae,I,oe,w,Z);let Ee=1,ve=1,Le=I,Fe=oe;const Ke=[!1];for(Ee=1,Le=I;Le<we;Ee++,Le++){const le=ae[Le],me=pe[Le],De=Le+1<we?pe[Le+1]:Ae;for(ve=le-oe+1,Fe=le;Fe<De;ve++,Fe++){let Ce=Number.MIN_SAFE_INTEGER,Re=!1;Fe<=me&&(Ce=q(b,w,Le,I,V,Z,Fe,Ae,oe,Oe[Ee-1][ve-1]===0,Ke));let He=0;Ce!==Number.MAX_SAFE_INTEGER&&(Re=!0,He=Ce+Te[Ee-1][ve-1]);const Ye=Fe>le,Qe=Ye?Te[Ee][ve-1]+(Oe[Ee][ve-1]>0?-5:0):0,We=Fe>le+1&&Oe[Ee][ve-1]>0,_e=We?Te[Ee][ve-2]+(Oe[Ee][ve-2]>0?-5:0):0;if(We&&(!Ye||_e>=Qe)&&(!Re||_e>=He))Te[Ee][ve]=_e,Me[Ee][ve]=3,Oe[Ee][ve]=0;else if(Ye&&(!Re||Qe>=He))Te[Ee][ve]=Qe,Me[Ee][ve]=2,Oe[Ee][ve]=0;else if(Re)Te[Ee][ve]=He,Me[Ee][ve]=1,Oe[Ee][ve]=Oe[Ee-1][ve-1]+1;else throw new Error("not possible")}}if(fe&&K(b,I,V,oe),!Ke[0]&&!ge.firstMatchCanBeWeak)return;Ee--,ve--;const je=[Te[Ee][ve],oe];let Ie=0,Ge=0;for(;Ee>=1;){let le=ve;do{const me=Me[Ee][le];if(me===3)le=le-2;else if(me===2)le=le-1;else break}while(le>=1);Ie>1&&w[I+Ee-1]===Z[oe+ve-1]&&!J(le+oe-1,V,Z)&&Ie+1>Oe[Ee][le]&&(le=ve),le===ve?Ie++:Ie=1,Ge||(Ge=le),Ee--,ve=le-1,je.push(ve)}Ae===we&&ge.boostFullMatch&&(je[0]+=2);const G=Ge-we;return je[0]-=G,je}t.$xj=H;function Q(b,w,I,V,Z,oe){let ge=b-1,we=w-1;for(;ge>=I&&we>=V;)Z[ge]===oe[we]&&(pe[ge]=we,ge--),we--}function q(b,w,I,V,Z,oe,ge,we,Ae,Ee,ve){if(w[I]!==oe[ge])return Number.MIN_SAFE_INTEGER;let Le=1,Fe=!1;return ge===I-V?Le=b[I]===Z[ge]?7:5:J(ge,Z,oe)&&(ge===0||!J(ge-1,Z,oe))?(Le=b[I]===Z[ge]?7:5,Fe=!0):U(oe,ge)&&(ge===0||!U(oe,ge-1))?Le=5:(U(oe,ge-1)||ee(oe,ge-1))&&(Le=5,Fe=!0),Le>1&&I===V&&(ve[0]=!0),Fe||(Fe=J(ge,Z,oe)||U(oe,ge-1)||ee(oe,ge-1)),I===V?ge>Ae&&(Le-=Fe?3:5):Ee?Le+=Fe?2:0:Le+=Fe?0:1,ge+1===we&&(Le-=Fe?3:5),Le}function x(b,w,I,V,Z,oe,ge){return c(b,w,I,V,Z,oe,!0,ge)}t.$yj=x;function W(b,w,I,V,Z,oe,ge){return c(b,w,I,V,Z,oe,!1,ge)}t.$zj=W;function c(b,w,I,V,Z,oe,ge,we){let Ae=H(b,w,I,V,Z,oe,we);if(Ae&&!ge)return Ae;if(b.length>=3){const Ee=Math.min(7,b.length-1);for(let ve=I+1;ve<Ee;ve++){const Le=k(b,ve);if(Le){const Fe=H(Le,Le.toLowerCase(),I,V,Z,oe,we);Fe&&(Fe[0]-=3,(!Ae||Fe[0]>Ae[0])&&(Ae=Fe))}}}return Ae}function k(b,w){if(w+1>=b.length)return;const I=b[w],V=b[w+1];if(I!==V)return b.slice(0,w)+V+I+b.slice(w+2)}}),define(be[83],$e([1,0,11]),function(re,t,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ji=t.$ii=t.$hi=t.$gi=t.$fi=t.$ei=t.$di=void 0;function O(h){return i(h,0)}t.$di=O;function i(h,s){switch(typeof h){case"object":return h===null?j(349,s):Array.isArray(h)?o(h,s):u(h,s);case"string":return y(h,s);case"boolean":return A(h,s);case"number":return j(h,s);case"undefined":return j(937,s);default:return j(617,s)}}t.$ei=i;function j(h,s){return(s<<5)-s+h|0}t.$fi=j;function A(h,s){return j(h?433:863,s)}function y(h,s){s=j(149417,s);for(let v=0,D=h.length;v<D;v++)s=j(h.charCodeAt(v),s);return s}t.$gi=y;function o(h,s){return s=j(104579,s),h.reduce((v,D)=>i(D,v),s)}function u(h,s){return s=j(181387,s),Object.keys(h).sort().reduce((v,D)=>(v=y(D,v),i(h[D],v)),s)}class g{constructor(){this.g=0}get value(){return this.g}hash(s){return this.g=i(s,this.g),this.g}}t.$hi=g;var L;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(L||(L={}));function r(h,s,v=32){const D=v-s,E=~((1<<D)-1);return(h<<s|(E&h)>>>D)>>>0}function l(h,s=0,v=h.byteLength,D=0){for(let E=0;E<v;E++)h[s+E]=D}function e(h,s,v="0"){for(;h.length<s;)h=v+h;return h}function a(h,s=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(v=>v.toString(16).padStart(2,"0")).join(""):e((h>>>0).toString(16),s/4)}t.$ii=a;class n{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(s){const v=s.length;if(v===0)return;const D=this.p;let E=this.r,f=this.u,C,T;for(f!==0?(C=f,T=-1,f=0):(C=s.charCodeAt(0),T=0);;){let P=C;if(N.$Pd(C))if(T+1<v){const m=s.charCodeAt(T+1);N.$Qd(m)?(T++,P=N.$Rd(C,m)):P=65533}else{f=C;break}else N.$Qd(C)&&(P=65533);if(E=this.w(D,E,P),T++,T<v)C=s.charCodeAt(T);else break}this.r=E,this.u=f}w(s,v,D){return D<128?s[v++]=D:D<2048?(s[v++]=192|(D&1984)>>>6,s[v++]=128|(D&63)>>>0):D<65536?(s[v++]=224|(D&61440)>>>12,s[v++]=128|(D&4032)>>>6,s[v++]=128|(D&63)>>>0):(s[v++]=240|(D&1835008)>>>18,s[v++]=128|(D&258048)>>>12,s[v++]=128|(D&4032)>>>6,s[v++]=128|(D&63)>>>0),v>=64&&(this.y(),v-=64,this.t+=64,s[0]=s[64+0],s[1]=s[64+1],s[2]=s[64+2]),v}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),a(this.h)+a(this.l)+a(this.m)+a(this.n)+a(this.o)}x(){this.p[this.r++]=128,l(this.p,this.r),this.r>56&&(this.y(),l(this.p));const s=8*this.t;this.q.setUint32(56,Math.floor(s/4294967296),!1),this.q.setUint32(60,s%4294967296,!1),this.y()}y(){const s=n.g,v=this.q;for(let F=0;F<64;F+=4)s.setUint32(F,v.getUint32(F,!1),!1);for(let F=64;F<320;F+=4)s.setUint32(F,r(s.getUint32(F-12,!1)^s.getUint32(F-32,!1)^s.getUint32(F-56,!1)^s.getUint32(F-64,!1),1),!1);let D=this.h,E=this.l,f=this.m,C=this.n,T=this.o,P,m,$;for(let F=0;F<80;F++)F<20?(P=E&f|~E&C,m=1518500249):F<40?(P=E^f^C,m=1859775393):F<60?(P=E&f|E&C|f&C,m=2400959708):(P=E^f^C,m=3395469782),$=r(D,5)+P+T+m+s.getUint32(F*4,!1)&4294967295,T=C,C=f,f=r(E,30),E=D,D=$;this.h=this.h+D&4294967295,this.l=this.l+E&4294967295,this.m=this.m+f&4294967295,this.n=this.n+C&4294967295,this.o=this.o+T&4294967295}}t.$ji=n}),define(be[84],$e([1,0,71,83]),function(re,t,N,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uu=t.$tu=t.$su=void 0;class i{constructor(r){this.a=r}getElements(){const r=this.a,l=new Int32Array(r.length);for(let e=0,a=r.length;e<a;e++)l[e]=r.charCodeAt(e);return l}}t.$su=i;function j(L,r,l){return new g(new i(L),new i(r)).ComputeDiff(l).changes}t.$tu=j;class A{static Assert(r,l){if(!r)throw new Error(l)}}class y{static Copy(r,l,e,a,n){for(let h=0;h<n;h++)e[a+h]=r[l+h]}static Copy2(r,l,e,a,n){for(let h=0;h<n;h++)e[a+h]=r[l+h]}}var o;(function(L){L[L.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(o||(o={}));class u{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new N.$ru(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(r,l){this.b=Math.min(this.b,r),this.c=Math.min(this.c,l),this.d++}AddModifiedElement(r,l){this.b=Math.min(this.b,r),this.c=Math.min(this.c,l),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class g{constructor(r,l,e=null){this.a=e,this.b=r,this.c=l;const[a,n,h]=g.o(r),[s,v,D]=g.o(l);this.d=h&&D,this.e=a,this.f=n,this.g=s,this.h=v,this.k=[],this.m=[]}static n(r){return r.length>0&&typeof r[0]=="string"}static o(r){const l=r.getElements();if(g.n(l)){const e=new Int32Array(l.length);for(let a=0,n=l.length;a<n;a++)e[a]=(0,O.$gi)(l[a],0);return[l,e,!0]}return l instanceof Int32Array?[[],l,!1]:[[],new Int32Array(l),!1]}p(r,l){return this.f[r]!==this.h[l]?!1:this.d?this.e[r]===this.g[l]:!0}q(r,l){if(!this.p(r,l))return!1;const e=g.r(this.b,r),a=g.r(this.c,l);return e===a}static r(r,l){return typeof r.getStrictElement=="function"?r.getStrictElement(l):null}s(r,l){return this.f[r]!==this.f[l]?!1:this.d?this.e[r]===this.e[l]:!0}u(r,l){return this.h[r]!==this.h[l]?!1:this.d?this.g[r]===this.g[l]:!0}ComputeDiff(r){return this.v(0,this.f.length-1,0,this.h.length-1,r)}v(r,l,e,a,n){const h=[!1];let s=this.w(r,l,e,a,h);return n&&(s=this.z(s)),{quitEarly:h[0],changes:s}}w(r,l,e,a,n){for(n[0]=!1;r<=l&&e<=a&&this.p(r,e);)r++,e++;for(;l>=r&&a>=e&&this.p(l,a);)l--,a--;if(r>l||e>a){let f;return e<=a?(A.Assert(r===l+1,"originalStart should only be one more than originalEnd"),f=[new N.$ru(r,0,e,a-e+1)]):r<=l?(A.Assert(e===a+1,"modifiedStart should only be one more than modifiedEnd"),f=[new N.$ru(r,l-r+1,e,0)]):(A.Assert(r===l+1,"originalStart should only be one more than originalEnd"),A.Assert(e===a+1,"modifiedStart should only be one more than modifiedEnd"),f=[]),f}const h=[0],s=[0],v=this.y(r,l,e,a,h,s,n),D=h[0],E=s[0];if(v!==null)return v;if(!n[0]){const f=this.w(r,D,e,E,n);let C=[];return n[0]?C=[new N.$ru(D+1,l-(D+1)+1,E+1,a-(E+1)+1)]:C=this.w(D+1,l,E+1,a,n),this.H(f,C)}return[new N.$ru(r,l-r+1,e,a-e+1)]}x(r,l,e,a,n,h,s,v,D,E,f,C,T,P,m,$,F,R){let B=null,M=null,z=new u,te=l,ne=e,se=T[0]-$[0]-a,ce=-1073741824,ue=this.k.length-1;do{const ae=se+r;ae===te||ae<ne&&D[ae-1]<D[ae+1]?(f=D[ae+1],P=f-se-a,f<ce&&z.MarkNextChange(),ce=f,z.AddModifiedElement(f+1,P),se=ae+1-r):(f=D[ae-1]+1,P=f-se-a,f<ce&&z.MarkNextChange(),ce=f-1,z.AddOriginalElement(f,P+1),se=ae-1-r),ue>=0&&(D=this.k[ue],r=D[0],te=1,ne=D.length-1)}while(--ue>=-1);if(B=z.getReverseChanges(),R[0]){let ae=T[0]+1,pe=$[0]+1;if(B!==null&&B.length>0){const Oe=B[B.length-1];ae=Math.max(ae,Oe.getOriginalEnd()),pe=Math.max(pe,Oe.getModifiedEnd())}M=[new N.$ru(ae,C-ae+1,pe,m-pe+1)]}else{z=new u,te=h,ne=s,se=T[0]-$[0]-v,ce=1073741824,ue=F?this.m.length-1:this.m.length-2;do{const ae=se+n;ae===te||ae<ne&&E[ae-1]>=E[ae+1]?(f=E[ae+1]-1,P=f-se-v,f>ce&&z.MarkNextChange(),ce=f+1,z.AddOriginalElement(f+1,P+1),se=ae+1-n):(f=E[ae-1],P=f-se-v,f>ce&&z.MarkNextChange(),ce=f,z.AddModifiedElement(f+1,P+1),se=ae-1-n),ue>=0&&(E=this.m[ue],n=E[0],te=1,ne=E.length-1)}while(--ue>=-1);M=z.getChanges()}return this.H(B,M)}y(r,l,e,a,n,h,s){let v=0,D=0,E=0,f=0,C=0,T=0;r--,e--,n[0]=0,h[0]=0,this.k=[],this.m=[];const P=l-r+(a-e),m=P+1,$=new Int32Array(m),F=new Int32Array(m),R=a-e,B=l-r,M=r-e,z=l-a,ne=(B-R)%2===0;$[R]=r,F[B]=l,s[0]=!1;for(let se=1;se<=P/2+1;se++){let ce=0,ue=0;E=this.J(R-se,se,R,m),f=this.J(R+se,se,R,m);for(let pe=E;pe<=f;pe+=2){pe===E||pe<f&&$[pe-1]<$[pe+1]?v=$[pe+1]:v=$[pe-1]+1,D=v-(pe-R)-M;const Oe=v;for(;v<l&&D<a&&this.p(v+1,D+1);)v++,D++;if($[pe]=v,v+D>ce+ue&&(ce=v,ue=D),!ne&&Math.abs(pe-B)<=se-1&&v>=F[pe])return n[0]=v,h[0]=D,Oe<=F[pe]&&1447>0&&se<=1447+1?this.x(R,E,f,M,B,C,T,z,$,F,v,l,n,D,a,h,ne,s):null}const ae=(ce-r+(ue-e)-se)/2;if(this.a!==null&&!this.a(ce,ae))return s[0]=!0,n[0]=ce,h[0]=ue,ae>0&&1447>0&&se<=1447+1?this.x(R,E,f,M,B,C,T,z,$,F,v,l,n,D,a,h,ne,s):(r++,e++,[new N.$ru(r,l-r+1,e,a-e+1)]);C=this.J(B-se,se,B,m),T=this.J(B+se,se,B,m);for(let pe=C;pe<=T;pe+=2){pe===C||pe<T&&F[pe-1]>=F[pe+1]?v=F[pe+1]-1:v=F[pe-1],D=v-(pe-B)-z;const Oe=v;for(;v>r&&D>e&&this.p(v,D);)v--,D--;if(F[pe]=v,ne&&Math.abs(pe-R)<=se&&v<=$[pe])return n[0]=v,h[0]=D,Oe>=$[pe]&&1447>0&&se<=1447+1?this.x(R,E,f,M,B,C,T,z,$,F,v,l,n,D,a,h,ne,s):null}if(se<=1447){let pe=new Int32Array(f-E+2);pe[0]=R-E+1,y.Copy2($,E,pe,1,f-E+1),this.k.push(pe),pe=new Int32Array(T-C+2),pe[0]=B-C+1,y.Copy2(F,C,pe,1,T-C+1),this.m.push(pe)}}return this.x(R,E,f,M,B,C,T,z,$,F,v,l,n,D,a,h,ne,s)}z(r){for(let l=0;l<r.length;l++){const e=r[l],a=l<r.length-1?r[l+1].originalStart:this.f.length,n=l<r.length-1?r[l+1].modifiedStart:this.h.length,h=e.originalLength>0,s=e.modifiedLength>0;for(;e.originalStart+e.originalLength<a&&e.modifiedStart+e.modifiedLength<n&&(!h||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!s||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const D=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!D)break;e.originalStart++,e.modifiedStart++}const v=[null];if(l<r.length-1&&this.I(r[l],r[l+1],v)){r[l]=v[0],r.splice(l+1,1),l--;continue}}for(let l=r.length-1;l>=0;l--){const e=r[l];let a=0,n=0;if(l>0){const f=r[l-1];a=f.originalStart+f.originalLength,n=f.modifiedStart+f.modifiedLength}const h=e.originalLength>0,s=e.modifiedLength>0;let v=0,D=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let f=1;;f++){const C=e.originalStart-f,T=e.modifiedStart-f;if(C<a||T<n||h&&!this.s(C,C+e.originalLength)||s&&!this.u(T,T+e.modifiedLength))break;const m=(C===a&&T===n?5:0)+this.G(C,e.originalLength,T,e.modifiedLength);m>D&&(D=m,v=f)}e.originalStart-=v,e.modifiedStart-=v;const E=[null];if(l>0&&this.I(r[l-1],r[l],E)){r[l-1]=E[0],r.splice(l,1),l++;continue}}if(this.d)for(let l=1,e=r.length;l<e;l++){const a=r[l-1],n=r[l],h=n.originalStart-a.originalStart-a.originalLength,s=a.originalStart,v=n.originalStart+n.originalLength,D=v-s,E=a.modifiedStart,f=n.modifiedStart+n.modifiedLength,C=f-E;if(h<5&&D<20&&C<20){const T=this.A(s,D,E,C,h);if(T){const[P,m]=T;(P!==a.originalStart+a.originalLength||m!==a.modifiedStart+a.modifiedLength)&&(a.originalLength=P-a.originalStart,a.modifiedLength=m-a.modifiedStart,n.originalStart=P+h,n.modifiedStart=m+h,n.originalLength=v-n.originalStart,n.modifiedLength=f-n.modifiedStart)}}}return r}A(r,l,e,a,n){if(l<n||a<n)return null;const h=r+l-n+1,s=e+a-n+1;let v=0,D=0,E=0;for(let f=r;f<h;f++)for(let C=e;C<s;C++){const T=this.B(f,C,n);T>0&&T>v&&(v=T,D=f,E=C)}return v>0?[D,E]:null}B(r,l,e){let a=0;for(let n=0;n<e;n++){if(!this.p(r+n,l+n))return 0;a+=this.e[r+n].length}return a}C(r){return r<=0||r>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[r])}D(r,l){if(this.C(r)||this.C(r-1))return!0;if(l>0){const e=r+l;if(this.C(e-1)||this.C(e))return!0}return!1}E(r){return r<=0||r>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[r])}F(r,l){if(this.E(r)||this.E(r-1))return!0;if(l>0){const e=r+l;if(this.E(e-1)||this.E(e))return!0}return!1}G(r,l,e,a){const n=this.D(r,l)?1:0,h=this.F(e,a)?1:0;return n+h}H(r,l){const e=[];if(r.length===0||l.length===0)return l.length>0?l:r;if(this.I(r[r.length-1],l[0],e)){const a=new Array(r.length+l.length-1);return y.Copy(r,0,a,0,r.length-1),a[r.length-1]=e[0],y.Copy(l,1,a,r.length,l.length-1),a}else{const a=new Array(r.length+l.length);return y.Copy(r,0,a,0,r.length),y.Copy(l,0,a,r.length,l.length),a}}I(r,l,e){if(A.Assert(r.originalStart<=l.originalStart,"Left change is not less than or equal to right change"),A.Assert(r.modifiedStart<=l.modifiedStart,"Left change is not less than or equal to right change"),r.originalStart+r.originalLength>=l.originalStart||r.modifiedStart+r.modifiedLength>=l.modifiedStart){const a=r.originalStart;let n=r.originalLength;const h=r.modifiedStart;let s=r.modifiedLength;return r.originalStart+r.originalLength>=l.originalStart&&(n=l.originalStart+l.originalLength-r.originalStart),r.modifiedStart+r.modifiedLength>=l.modifiedStart&&(s=l.modifiedStart+l.modifiedLength-r.modifiedStart),e[0]=new N.$ru(a,n,h,s),!0}else return e[0]=null,!1}J(r,l,e,a){if(r>=0&&r<a)return r;const n=e,h=a-e-1,s=l%2===0;if(r<0){const v=n%2===0;return s===v?0:1}else{const v=h%2===0;return s===v?a-1:a-2}}}t.$uu=g}),define(be[47],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bc=void 0,t.$bc=Symbol("MicrotaskDelay")}),define(be[85],$e([1,0,13,11]),function(re,t,N,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vh=t.$uh=t.$th=t.$sh=t.$rh=void 0;class i{constructor(){this.b="",this.c=0}reset(l){return this.b=l,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(l){const e=l.charCodeAt(0),a=this.b.charCodeAt(this.c);return e-a}value(){return this.b[this.c]}}t.$rh=i;class j{constructor(l=!0){this.e=l}reset(l){return this.b=l,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let l=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(l)this.c++;else break;else l=!1;return this}cmp(l){return this.e?(0,O.$Fd)(l,this.b,0,l.length,this.c,this.d):(0,O.$Hd)(l,this.b,0,l.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}t.$sh=j;class A{constructor(l=!0,e=!0){this.f=l,this.g=e}reset(l){this.d=0,this.e=0,this.b=l,this.c=l.length;for(let e=l.length-1;e>=0;e--,this.c--){const a=this.b.charCodeAt(e);if(!(a===47||this.f&&a===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let l=!0;for(;this.e<this.c;this.e++){const e=this.b.charCodeAt(this.e);if(e===47||this.f&&e===92)if(l)this.d++;else break;else l=!1}return this}cmp(l){return this.g?(0,O.$Fd)(l,this.b,0,l.length,this.d,this.e):(0,O.$Hd)(l,this.b,0,l.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}t.$th=A;var y;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(y||(y={}));class o{constructor(l,e){this.f=l,this.g=e,this.d=[],this.e=0}reset(l){return this.c=l,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(l)),this.b.reset(l.path),this.b.value()&&this.d.push(3)),this.g(l)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(l){if(this.d[this.e]===1)return(0,O.$Gd)(l,this.c.scheme);if(this.d[this.e]===2)return(0,O.$Gd)(l,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(l);if(this.d[this.e]===4)return(0,O.$Ed)(l,this.c.query);if(this.d[this.e]===5)return(0,O.$Ed)(l,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}t.$uh=o;class u{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const l=this.right;return this.right=l.left,l.left=this,this.updateHeight(),l.updateHeight(),l}rotateRight(){const l=this.left;return this.left=l.right,l.right=this,this.updateHeight(),l.updateHeight(),l}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var g;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(g||(g={}));class L{static forUris(l=()=>!1,e=()=>!1){return new L(new o(l,e))}static forPaths(l=!1){return new L(new A(void 0,!l))}static forStrings(){return new L(new i)}static forConfigKeys(){return new L(new j)}constructor(l){this.b=l}clear(){this.c=void 0}fill(l,e){if(e){const a=e.slice(0);(0,N.$Bf)(a);for(const n of a)this.set(n,l)}else{const a=l.slice(0);(0,N.$Bf)(a);for(const n of a)this.set(n[0],n[1])}}set(l,e){const a=this.b.reset(l);let n;this.c||(this.c=new u,this.c.segment=a.value());const h=[];for(n=this.c;;){const v=a.cmp(n.segment);if(v>0)n.left||(n.left=new u,n.left.segment=a.value()),h.push([-1,n]),n=n.left;else if(v<0)n.right||(n.right=new u,n.right.segment=a.value()),h.push([1,n]),n=n.right;else if(a.hasNext())a.next(),n.mid||(n.mid=new u,n.mid.segment=a.value()),h.push([0,n]),n=n.mid;else break}const s=n.value;n.value=e,n.key=l;for(let v=h.length-1;v>=0;v--){const D=h[v][1];D.updateHeight();const E=D.balanceFactor();if(E<-1||E>1){const f=h[v][0],C=h[v+1][0];if(f===1&&C===1)h[v][1]=D.rotateLeft();else if(f===-1&&C===-1)h[v][1]=D.rotateRight();else if(f===1&&C===-1)D.right=h[v+1][1]=h[v+1][1].rotateRight(),h[v][1]=D.rotateLeft();else if(f===-1&&C===1)D.left=h[v+1][1]=h[v+1][1].rotateLeft(),h[v][1]=D.rotateRight();else throw new Error;if(v>0)switch(h[v-1][0]){case-1:h[v-1][1].left=h[v][1];break;case 1:h[v-1][1].right=h[v][1];break;case 0:h[v-1][1].mid=h[v][1];break}else this.c=h[0][1]}}return s}get(l){return this.d(l)?.value}d(l){const e=this.b.reset(l);let a=this.c;for(;a;){const n=e.cmp(a.segment);if(n>0)a=a.left;else if(n<0)a=a.right;else if(e.hasNext())e.next(),a=a.mid;else break}return a}has(l){const e=this.d(l);return!(e?.value===void 0&&e?.mid===void 0)}delete(l){return this.e(l,!1)}deleteSuperstr(l){return this.e(l,!0)}e(l,e){const a=this.b.reset(l),n=[];let h=this.c;for(;h;){const s=a.cmp(h.segment);if(s>0)n.push([-1,h]),h=h.left;else if(s<0)n.push([1,h]),h=h.right;else if(a.hasNext())a.next(),n.push([0,h]),h=h.mid;else break}if(h){if(e?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const s=this.f(h.right);if(s.key){const{key:v,value:D,segment:E}=s;this.e(s.key,!1),h.key=v,h.value=D,h.segment=E}}else{const s=h.left??h.right;if(n.length>0){const[v,D]=n[n.length-1];switch(v){case-1:D.left=s;break;case 0:D.mid=s;break;case 1:D.right=s;break}}else this.c=s}for(let s=n.length-1;s>=0;s--){const v=n[s][1];v.updateHeight();const D=v.balanceFactor();if(D>1?(v.right.balanceFactor()>=0||(v.right=v.right.rotateRight()),n[s][1]=v.rotateLeft()):D<-1&&(v.left.balanceFactor()<=0||(v.left=v.left.rotateLeft()),n[s][1]=v.rotateRight()),s>0)switch(n[s-1][0]){case-1:n[s-1][1].left=n[s][1];break;case 1:n[s-1][1].right=n[s][1];break;case 0:n[s-1][1].mid=n[s][1];break}else this.c=n[0][1]}}}f(l){for(;l.left;)l=l.left;return l}findSubstr(l){const e=this.b.reset(l);let a=this.c,n;for(;a;){const h=e.cmp(a.segment);if(h>0)a=a.left;else if(h<0)a=a.right;else if(e.hasNext())e.next(),n=a.value||n,a=a.mid;else break}return a&&a.value||n}findSuperstr(l){return this.g(l,!1)}g(l,e){const a=this.b.reset(l);let n=this.c;for(;n;){const h=a.cmp(n.segment);if(h>0)n=n.left;else if(h<0)n=n.right;else if(a.hasNext())a.next(),n=n.mid;else return n.mid?this.h(n.mid):e?n.value:void 0}}hasElementOrSubtree(l){return this.g(l,!0)!==void 0}forEach(l){for(const[e,a]of this)l(a,e)}*[Symbol.iterator](){yield*this.h(this.c)}h(l){const e=[];return this.j(l,e),e[Symbol.iterator]()}j(l,e){l&&(l.left&&this.j(l.left,e),l.value&&e.push([l.key,l.value]),l.mid&&this.j(l.mid,e),l.right&&this.j(l.right,e))}_isBalanced(){const l=e=>{if(!e)return!0;const a=e.balanceFactor();return a<-1||a>1?!1:l(e.left)&&l(e.right)};return l(this.c)}}t.$vh=L}),define(be[7],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ze=t.$ye=t.$xe=t.$we=t.$ve=t.$ue=t.$te=t.$se=t.$re=t.$qe=t.$pe=t.$oe=t.$ne=t.$me=t.$le=t.$ke=t.$je=t.$ie=void 0;function N(E){return typeof E=="string"}t.$ie=N;function O(E){return Array.isArray(E)&&E.every(f=>N(f))}t.$je=O;function i(E){return typeof E=="object"&&E!==null&&!Array.isArray(E)&&!(E instanceof RegExp)&&!(E instanceof Date)}t.$ke=i;function j(E){const f=Object.getPrototypeOf(Uint8Array);return typeof E=="object"&&E instanceof f}t.$le=j;function A(E){return typeof E=="number"&&!isNaN(E)}t.$me=A;function y(E){return!!E&&typeof E[Symbol.iterator]=="function"}t.$ne=y;function o(E){return E===!0||E===!1}t.$oe=o;function u(E){return typeof E>"u"}t.$pe=u;function g(E){return!L(E)}t.$qe=g;function L(E){return u(E)||E===null}t.$re=L;function r(E,f){if(!E)throw new Error(f?`Unexpected type, expected '${f}'`:"Unexpected type")}t.$se=r;function l(E){if(L(E))throw new Error("Assertion Failed: argument is undefined or null");return E}t.$te=l;function e(...E){const f=[];for(let C=0;C<E.length;C++){const T=E[C];if(L(T))throw new Error(`Assertion Failed: argument at index ${C} is undefined or null`);f.push(T)}return f}t.$ue=e;const a=Object.prototype.hasOwnProperty;function n(E){if(!i(E))return!1;for(const f in E)if(a.call(E,f))return!1;return!0}t.$ve=n;function h(E){return typeof E=="function"}t.$we=h;function s(...E){return E.length>0&&E.every(h)}t.$xe=s;function v(E,f){const C=Math.min(E.length,f.length);for(let T=0;T<C;T++)D(E[T],f[T])}t.$ye=v;function D(E,f){if(N(f)){if(typeof E!==f)throw new Error(`argument does not match constraint: typeof ${f}`)}else if(h(f)){try{if(E instanceof f)return}catch{}if(!L(E)&&E.constructor===f||f.length===1&&f.call(void 0,E)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.$ze=D}),define(be[17],$e([1,0,7]),function(re,t,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Cj=t.$Bj=t.$Aj=void 0;const O=Object.create(null);function i(y,o){if((0,N.$ie)(o)){const u=O[o];if(u===void 0)throw new Error(`${y} references an unknown codicon: ${o}`);o=u}return O[y]=o,{id:y}}function j(){return O}t.$Aj=j;function A(){return Object.values(t.$Cj)}t.$Bj=A,t.$Cj={add:i("add",6e4),plus:i("plus",6e4),gistNew:i("gist-new",6e4),repoCreate:i("repo-create",6e4),lightbulb:i("lightbulb",60001),lightBulb:i("light-bulb",60001),repo:i("repo",60002),repoDelete:i("repo-delete",60002),gistFork:i("gist-fork",60003),repoForked:i("repo-forked",60003),gitPullRequest:i("git-pull-request",60004),gitPullRequestAbandoned:i("git-pull-request-abandoned",60004),recordKeys:i("record-keys",60005),keyboard:i("keyboard",60005),tag:i("tag",60006),tagAdd:i("tag-add",60006),tagRemove:i("tag-remove",60006),gitPullRequestLabel:i("git-pull-request-label",60006),person:i("person",60007),personFollow:i("person-follow",60007),personOutline:i("person-outline",60007),personFilled:i("person-filled",60007),gitBranch:i("git-branch",60008),gitBranchCreate:i("git-branch-create",60008),gitBranchDelete:i("git-branch-delete",60008),sourceControl:i("source-control",60008),mirror:i("mirror",60009),mirrorPublic:i("mirror-public",60009),star:i("star",60010),starAdd:i("star-add",60010),starDelete:i("star-delete",60010),starEmpty:i("star-empty",60010),comment:i("comment",60011),commentAdd:i("comment-add",60011),alert:i("alert",60012),warning:i("warning",60012),search:i("search",60013),searchSave:i("search-save",60013),logOut:i("log-out",60014),signOut:i("sign-out",60014),logIn:i("log-in",60015),signIn:i("sign-in",60015),eye:i("eye",60016),eyeUnwatch:i("eye-unwatch",60016),eyeWatch:i("eye-watch",60016),circleFilled:i("circle-filled",60017),primitiveDot:i("primitive-dot",60017),closeDirty:i("close-dirty",60017),debugBreakpoint:i("debug-breakpoint",60017),debugBreakpointDisabled:i("debug-breakpoint-disabled",60017),debugHint:i("debug-hint",60017),primitiveSquare:i("primitive-square",60018),edit:i("edit",60019),pencil:i("pencil",60019),info:i("info",60020),issueOpened:i("issue-opened",60020),gistPrivate:i("gist-private",60021),gitForkPrivate:i("git-fork-private",60021),lock:i("lock",60021),mirrorPrivate:i("mirror-private",60021),close:i("close",60022),removeClose:i("remove-close",60022),x:i("x",60022),repoSync:i("repo-sync",60023),sync:i("sync",60023),clone:i("clone",60024),desktopDownload:i("desktop-download",60024),beaker:i("beaker",60025),microscope:i("microscope",60025),vm:i("vm",60026),deviceDesktop:i("device-desktop",60026),file:i("file",60027),fileText:i("file-text",60027),more:i("more",60028),ellipsis:i("ellipsis",60028),kebabHorizontal:i("kebab-horizontal",60028),mailReply:i("mail-reply",60029),reply:i("reply",60029),organization:i("organization",60030),organizationFilled:i("organization-filled",60030),organizationOutline:i("organization-outline",60030),newFile:i("new-file",60031),fileAdd:i("file-add",60031),newFolder:i("new-folder",60032),fileDirectoryCreate:i("file-directory-create",60032),trash:i("trash",60033),trashcan:i("trashcan",60033),history:i("history",60034),clock:i("clock",60034),folder:i("folder",60035),fileDirectory:i("file-directory",60035),symbolFolder:i("symbol-folder",60035),logoGithub:i("logo-github",60036),markGithub:i("mark-github",60036),github:i("github",60036),terminal:i("terminal",60037),console:i("console",60037),repl:i("repl",60037),zap:i("zap",60038),symbolEvent:i("symbol-event",60038),error:i("error",60039),stop:i("stop",60039),variable:i("variable",60040),symbolVariable:i("symbol-variable",60040),array:i("array",60042),symbolArray:i("symbol-array",60042),symbolModule:i("symbol-module",60043),symbolPackage:i("symbol-package",60043),symbolNamespace:i("symbol-namespace",60043),symbolObject:i("symbol-object",60043),symbolMethod:i("symbol-method",60044),symbolFunction:i("symbol-function",60044),symbolConstructor:i("symbol-constructor",60044),symbolBoolean:i("symbol-boolean",60047),symbolNull:i("symbol-null",60047),symbolNumeric:i("symbol-numeric",60048),symbolNumber:i("symbol-number",60048),symbolStructure:i("symbol-structure",60049),symbolStruct:i("symbol-struct",60049),symbolParameter:i("symbol-parameter",60050),symbolTypeParameter:i("symbol-type-parameter",60050),symbolKey:i("symbol-key",60051),symbolText:i("symbol-text",60051),symbolReference:i("symbol-reference",60052),goToFile:i("go-to-file",60052),symbolEnum:i("symbol-enum",60053),symbolValue:i("symbol-value",60053),symbolRuler:i("symbol-ruler",60054),symbolUnit:i("symbol-unit",60054),activateBreakpoints:i("activate-breakpoints",60055),archive:i("archive",60056),arrowBoth:i("arrow-both",60057),arrowDown:i("arrow-down",60058),arrowLeft:i("arrow-left",60059),arrowRight:i("arrow-right",60060),arrowSmallDown:i("arrow-small-down",60061),arrowSmallLeft:i("arrow-small-left",60062),arrowSmallRight:i("arrow-small-right",60063),arrowSmallUp:i("arrow-small-up",60064),arrowUp:i("arrow-up",60065),bell:i("bell",60066),bold:i("bold",60067),book:i("book",60068),bookmark:i("bookmark",60069),debugBreakpointConditionalUnverified:i("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:i("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:i("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:i("debug-breakpoint-data-unverified",60072),debugBreakpointData:i("debug-breakpoint-data",60073),debugBreakpointDataDisabled:i("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:i("debug-breakpoint-log-unverified",60074),debugBreakpointLog:i("debug-breakpoint-log",60075),debugBreakpointLogDisabled:i("debug-breakpoint-log-disabled",60075),briefcase:i("briefcase",60076),broadcast:i("broadcast",60077),browser:i("browser",60078),bug:i("bug",60079),calendar:i("calendar",60080),caseSensitive:i("case-sensitive",60081),check:i("check",60082),checklist:i("checklist",60083),chevronDown:i("chevron-down",60084),dropDownButton:i("drop-down-button",60084),chevronLeft:i("chevron-left",60085),chevronRight:i("chevron-right",60086),chevronUp:i("chevron-up",60087),chromeClose:i("chrome-close",60088),chromeMaximize:i("chrome-maximize",60089),chromeMinimize:i("chrome-minimize",60090),chromeRestore:i("chrome-restore",60091),circle:i("circle",60092),circleOutline:i("circle-outline",60092),debugBreakpointUnverified:i("debug-breakpoint-unverified",60092),circleSlash:i("circle-slash",60093),circuitBoard:i("circuit-board",60094),clearAll:i("clear-all",60095),clippy:i("clippy",60096),closeAll:i("close-all",60097),cloudDownload:i("cloud-download",60098),cloudUpload:i("cloud-upload",60099),code:i("code",60100),collapseAll:i("collapse-all",60101),colorMode:i("color-mode",60102),commentDiscussion:i("comment-discussion",60103),compareChanges:i("compare-changes",60157),creditCard:i("credit-card",60105),dash:i("dash",60108),dashboard:i("dashboard",60109),database:i("database",60110),debugContinue:i("debug-continue",60111),debugDisconnect:i("debug-disconnect",60112),debugPause:i("debug-pause",60113),debugRestart:i("debug-restart",60114),debugStart:i("debug-start",60115),debugStepInto:i("debug-step-into",60116),debugStepOut:i("debug-step-out",60117),debugStepOver:i("debug-step-over",60118),debugStop:i("debug-stop",60119),debug:i("debug",60120),deviceCameraVideo:i("device-camera-video",60121),deviceCamera:i("device-camera",60122),deviceMobile:i("device-mobile",60123),diffAdded:i("diff-added",60124),diffIgnored:i("diff-ignored",60125),diffModified:i("diff-modified",60126),diffRemoved:i("diff-removed",60127),diffRenamed:i("diff-renamed",60128),diff:i("diff",60129),discard:i("discard",60130),editorLayout:i("editor-layout",60131),emptyWindow:i("empty-window",60132),exclude:i("exclude",60133),extensions:i("extensions",60134),eyeClosed:i("eye-closed",60135),fileBinary:i("file-binary",60136),fileCode:i("file-code",60137),fileMedia:i("file-media",60138),filePdf:i("file-pdf",60139),fileSubmodule:i("file-submodule",60140),fileSymlinkDirectory:i("file-symlink-directory",60141),fileSymlinkFile:i("file-symlink-file",60142),fileZip:i("file-zip",60143),files:i("files",60144),filter:i("filter",60145),flame:i("flame",60146),foldDown:i("fold-down",60147),foldUp:i("fold-up",60148),fold:i("fold",60149),folderActive:i("folder-active",60150),folderOpened:i("folder-opened",60151),gear:i("gear",60152),gift:i("gift",60153),gistSecret:i("gist-secret",60154),gist:i("gist",60155),gitCommit:i("git-commit",60156),gitCompare:i("git-compare",60157),gitMerge:i("git-merge",60158),githubAction:i("github-action",60159),githubAlt:i("github-alt",60160),globe:i("globe",60161),grabber:i("grabber",60162),graph:i("graph",60163),gripper:i("gripper",60164),heart:i("heart",60165),home:i("home",60166),horizontalRule:i("horizontal-rule",60167),hubot:i("hubot",60168),inbox:i("inbox",60169),issueClosed:i("issue-closed",60324),issueReopened:i("issue-reopened",60171),issues:i("issues",60172),italic:i("italic",60173),jersey:i("jersey",60174),json:i("json",60175),bracket:i("bracket",60175),kebabVertical:i("kebab-vertical",60176),key:i("key",60177),law:i("law",60178),lightbulbAutofix:i("lightbulb-autofix",60179),linkExternal:i("link-external",60180),link:i("link",60181),listOrdered:i("list-ordered",60182),listUnordered:i("list-unordered",60183),liveShare:i("live-share",60184),loading:i("loading",60185),location:i("location",60186),mailRead:i("mail-read",60187),mail:i("mail",60188),markdown:i("markdown",60189),megaphone:i("megaphone",60190),mention:i("mention",60191),milestone:i("milestone",60192),gitPullRequestMilestone:i("git-pull-request-milestone",60192),mortarBoard:i("mortar-board",60193),move:i("move",60194),multipleWindows:i("multiple-windows",60195),mute:i("mute",60196),noNewline:i("no-newline",60197),note:i("note",60198),octoface:i("octoface",60199),openPreview:i("open-preview",60200),package_:i("package",60201),paintcan:i("paintcan",60202),pin:i("pin",60203),play:i("play",60204),run:i("run",60204),plug:i("plug",60205),preserveCase:i("preserve-case",60206),preview:i("preview",60207),project:i("project",60208),pulse:i("pulse",60209),question:i("question",60210),quote:i("quote",60211),radioTower:i("radio-tower",60212),reactions:i("reactions",60213),references:i("references",60214),refresh:i("refresh",60215),regex:i("regex",60216),remoteExplorer:i("remote-explorer",60217),remote:i("remote",60218),remove:i("remove",60219),replaceAll:i("replace-all",60220),replace:i("replace",60221),repoClone:i("repo-clone",60222),repoForcePush:i("repo-force-push",60223),repoPull:i("repo-pull",60224),repoPush:i("repo-push",60225),report:i("report",60226),requestChanges:i("request-changes",60227),rocket:i("rocket",60228),rootFolderOpened:i("root-folder-opened",60229),rootFolder:i("root-folder",60230),rss:i("rss",60231),ruby:i("ruby",60232),saveAll:i("save-all",60233),saveAs:i("save-as",60234),save:i("save",60235),screenFull:i("screen-full",60236),screenNormal:i("screen-normal",60237),searchStop:i("search-stop",60238),server:i("server",60240),settingsGear:i("settings-gear",60241),settings:i("settings",60242),shield:i("shield",60243),smiley:i("smiley",60244),sortPrecedence:i("sort-precedence",60245),splitHorizontal:i("split-horizontal",60246),splitVertical:i("split-vertical",60247),squirrel:i("squirrel",60248),starFull:i("star-full",60249),starHalf:i("star-half",60250),symbolClass:i("symbol-class",60251),symbolColor:i("symbol-color",60252),symbolCustomColor:i("symbol-customcolor",60252),symbolConstant:i("symbol-constant",60253),symbolEnumMember:i("symbol-enum-member",60254),symbolField:i("symbol-field",60255),symbolFile:i("symbol-file",60256),symbolInterface:i("symbol-interface",60257),symbolKeyword:i("symbol-keyword",60258),symbolMisc:i("symbol-misc",60259),symbolOperator:i("symbol-operator",60260),symbolProperty:i("symbol-property",60261),wrench:i("wrench",60261),wrenchSubaction:i("wrench-subaction",60261),symbolSnippet:i("symbol-snippet",60262),tasklist:i("tasklist",60263),telescope:i("telescope",60264),textSize:i("text-size",60265),threeBars:i("three-bars",60266),thumbsdown:i("thumbsdown",60267),thumbsup:i("thumbsup",60268),tools:i("tools",60269),triangleDown:i("triangle-down",60270),triangleLeft:i("triangle-left",60271),triangleRight:i("triangle-right",60272),triangleUp:i("triangle-up",60273),twitter:i("twitter",60274),unfold:i("unfold",60275),unlock:i("unlock",60276),unmute:i("unmute",60277),unverified:i("unverified",60278),verified:i("verified",60279),versions:i("versions",60280),vmActive:i("vm-active",60281),vmOutline:i("vm-outline",60282),vmRunning:i("vm-running",60283),watch:i("watch",60284),whitespace:i("whitespace",60285),wholeWord:i("whole-word",60286),window:i("window",60287),wordWrap:i("word-wrap",60288),zoomIn:i("zoom-in",60289),zoomOut:i("zoom-out",60290),listFilter:i("list-filter",60291),listFlat:i("list-flat",60292),listSelection:i("list-selection",60293),selection:i("selection",60293),listTree:i("list-tree",60294),debugBreakpointFunctionUnverified:i("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:i("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:i("debug-breakpoint-function-disabled",60296),debugStackframeActive:i("debug-stackframe-active",60297),circleSmallFilled:i("circle-small-filled",60298),debugStackframeDot:i("debug-stackframe-dot",60298),debugStackframe:i("debug-stackframe",60299),debugStackframeFocused:i("debug-stackframe-focused",60299),debugBreakpointUnsupported:i("debug-breakpoint-unsupported",60300),symbolString:i("symbol-string",60301),debugReverseContinue:i("debug-reverse-continue",60302),debugStepBack:i("debug-step-back",60303),debugRestartFrame:i("debug-restart-frame",60304),callIncoming:i("call-incoming",60306),callOutgoing:i("call-outgoing",60307),menu:i("menu",60308),expandAll:i("expand-all",60309),feedback:i("feedback",60310),gitPullRequestReviewer:i("git-pull-request-reviewer",60310),groupByRefType:i("group-by-ref-type",60311),ungroupByRefType:i("ungroup-by-ref-type",60312),account:i("account",60313),gitPullRequestAssignee:i("git-pull-request-assignee",60313),bellDot:i("bell-dot",60314),debugConsole:i("debug-console",60315),library:i("library",60316),output:i("output",60317),runAll:i("run-all",60318),syncIgnored:i("sync-ignored",60319),pinned:i("pinned",60320),githubInverted:i("github-inverted",60321),debugAlt:i("debug-alt",60305),serverProcess:i("server-process",60322),serverEnvironment:i("server-environment",60323),pass:i("pass",60324),stopCircle:i("stop-circle",60325),playCircle:i("play-circle",60326),record:i("record",60327),debugAltSmall:i("debug-alt-small",60328),vmConnect:i("vm-connect",60329),cloud:i("cloud",60330),merge:i("merge",60331),exportIcon:i("export",60332),graphLeft:i("graph-left",60333),magnet:i("magnet",60334),notebook:i("notebook",60335),redo:i("redo",60336),checkAll:i("check-all",60337),pinnedDirty:i("pinned-dirty",60338),passFilled:i("pass-filled",60339),circleLargeFilled:i("circle-large-filled",60340),circleLarge:i("circle-large",60341),circleLargeOutline:i("circle-large-outline",60341),combine:i("combine",60342),gather:i("gather",60342),table:i("table",60343),variableGroup:i("variable-group",60344),typeHierarchy:i("type-hierarchy",60345),typeHierarchySub:i("type-hierarchy-sub",60346),typeHierarchySuper:i("type-hierarchy-super",60347),gitPullRequestCreate:i("git-pull-request-create",60348),runAbove:i("run-above",60349),runBelow:i("run-below",60350),notebookTemplate:i("notebook-template",60351),debugRerun:i("debug-rerun",60352),workspaceTrusted:i("workspace-trusted",60353),workspaceUntrusted:i("workspace-untrusted",60354),workspaceUnspecified:i("workspace-unspecified",60355),terminalCmd:i("terminal-cmd",60356),terminalDebian:i("terminal-debian",60357),terminalLinux:i("terminal-linux",60358),terminalPowershell:i("terminal-powershell",60359),terminalTmux:i("terminal-tmux",60360),terminalUbuntu:i("terminal-ubuntu",60361),terminalBash:i("terminal-bash",60362),arrowSwap:i("arrow-swap",60363),copy:i("copy",60364),personAdd:i("person-add",60365),filterFilled:i("filter-filled",60366),wand:i("wand",60367),debugLineByLine:i("debug-line-by-line",60368),inspect:i("inspect",60369),layers:i("layers",60370),layersDot:i("layers-dot",60371),layersActive:i("layers-active",60372),compass:i("compass",60373),compassDot:i("compass-dot",60374),compassActive:i("compass-active",60375),azure:i("azure",60376),issueDraft:i("issue-draft",60377),gitPullRequestClosed:i("git-pull-request-closed",60378),gitPullRequestDraft:i("git-pull-request-draft",60379),debugAll:i("debug-all",60380),debugCoverage:i("debug-coverage",60381),runErrors:i("run-errors",60382),folderLibrary:i("folder-library",60383),debugContinueSmall:i("debug-continue-small",60384),beakerStop:i("beaker-stop",60385),graphLine:i("graph-line",60386),graphScatter:i("graph-scatter",60387),pieChart:i("pie-chart",60388),bracketDot:i("bracket-dot",60389),bracketError:i("bracket-error",60390),lockSmall:i("lock-small",60391),azureDevops:i("azure-devops",60392),verifiedFilled:i("verified-filled",60393),newLine:i("newline",60394),layout:i("layout",60395),layoutActivitybarLeft:i("layout-activitybar-left",60396),layoutActivitybarRight:i("layout-activitybar-right",60397),layoutPanelLeft:i("layout-panel-left",60398),layoutPanelCenter:i("layout-panel-center",60399),layoutPanelJustify:i("layout-panel-justify",60400),layoutPanelRight:i("layout-panel-right",60401),layoutPanel:i("layout-panel",60402),layoutSidebarLeft:i("layout-sidebar-left",60403),layoutSidebarRight:i("layout-sidebar-right",60404),layoutStatusbar:i("layout-statusbar",60405),layoutMenubar:i("layout-menubar",60406),layoutCentered:i("layout-centered",60407),layoutSidebarRightOff:i("layout-sidebar-right-off",60416),layoutPanelOff:i("layout-panel-off",60417),layoutSidebarLeftOff:i("layout-sidebar-left-off",60418),target:i("target",60408),indent:i("indent",60409),recordSmall:i("record-small",60410),errorSmall:i("error-small",60411),arrowCircleDown:i("arrow-circle-down",60412),arrowCircleLeft:i("arrow-circle-left",60413),arrowCircleRight:i("arrow-circle-right",60414),arrowCircleUp:i("arrow-circle-up",60415),heartFilled:i("heart-filled",60420),map:i("map",60421),mapFilled:i("map-filled",60422),circleSmall:i("circle-small",60423),bellSlash:i("bell-slash",60424),bellSlashDot:i("bell-slash-dot",60425),commentUnresolved:i("comment-unresolved",60426),gitPullRequestGoToChanges:i("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:i("git-pull-request-new-changes",60428),searchFuzzy:i("search-fuzzy",60429),commentDraft:i("comment-draft",60430),send:i("send",60431),sparkle:i("sparkle",60432),insert:i("insert",60433),mic:i("mic",60434),dialogError:i("dialog-error","error"),dialogWarning:i("dialog-warning","warning"),dialogInfo:i("dialog-info","info"),dialogClose:i("dialog-close","close"),treeItemExpanded:i("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:i("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:i("tree-filter-on-type-off","list-selection"),treeFilterClear:i("tree-filter-clear","close"),treeItemLoading:i("tree-item-loading","loading"),menuSelection:i("menu-selection","check"),menuSubmenu:i("menu-submenu","chevron-right"),menuBarMore:i("menubar-more","more"),scrollbarButtonLeft:i("scrollbar-button-left","triangle-left"),scrollbarButtonRight:i("scrollbar-button-right","triangle-right"),scrollbarButtonUp:i("scrollbar-button-up","triangle-up"),scrollbarButtonDown:i("scrollbar-button-down","triangle-down"),toolBarMore:i("toolbar-more","more"),quickInputBack:i("quick-input-back","arrow-left")}}),define(be[48],$e([1,0,7]),function(re,t,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Tm=t.$Sm=t.$Rm=t.$Qm=t.$Pm=t.$Om=t.$Nm=t.$Mm=t.$Lm=t.$Km=t.$Jm=t.$Im=void 0;function O(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const s=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([v,D])=>{s[v]=D&&typeof D=="object"?O(D):D}),s}t.$Im=O;function i(h){if(!h||typeof h!="object")return h;const s=[h];for(;s.length>0;){const v=s.shift();Object.freeze(v);for(const D in v)if(j.call(v,D)){const E=v[D];typeof E=="object"&&!Object.isFrozen(E)&&!(0,N.$le)(E)&&s.push(E)}}return h}t.$Jm=i;const j=Object.prototype.hasOwnProperty;function A(h,s){return y(h,s,new Set)}t.$Km=A;function y(h,s,v){if((0,N.$re)(h))return h;const D=s(h);if(typeof D<"u")return D;if(Array.isArray(h)){const E=[];for(const f of h)E.push(y(f,s,v));return E}if((0,N.$ke)(h)){if(v.has(h))throw new Error("Cannot clone recursive data-structure");v.add(h);const E={};for(const f in h)j.call(h,f)&&(E[f]=y(h[f],s,v));return v.delete(h),E}return h}function o(h,s,v=!0){return(0,N.$ke)(h)?((0,N.$ke)(s)&&Object.keys(s).forEach(D=>{D in h?v&&((0,N.$ke)(h[D])&&(0,N.$ke)(s[D])?o(h[D],s[D],v):h[D]=s[D]):h[D]=s[D]}),h):s}t.$Lm=o;function u(h,s){if(h===s)return!0;if(h==null||s===null||s===void 0||typeof h!=typeof s||typeof h!="object"||Array.isArray(h)!==Array.isArray(s))return!1;let v,D;if(Array.isArray(h)){if(h.length!==s.length)return!1;for(v=0;v<h.length;v++)if(!u(h[v],s[v]))return!1}else{const E=[];for(D in h)E.push(D);E.sort();const f=[];for(D in s)f.push(D);if(f.sort(),!u(E,f))return!1;for(v=0;v<E.length;v++)if(!u(h[E[v]],s[E[v]]))return!1}return!0}t.$Mm=u;function g(h){const s=new Set;return JSON.stringify(h,(v,D)=>{if((0,N.$ke)(D)||Array.isArray(D)){if(s.has(D))return"[Circular]";s.add(D)}return D})}t.$Nm=g;function L(h,s){const v=Object.create(null);return!h||!s||Object.keys(s).forEach(E=>{const f=h[E],C=s[E];u(f,C)||(v[E]=C)}),v}t.$Om=L;function r(h,s){const v=s.toLowerCase(),D=Object.keys(h).find(E=>E.toLowerCase()===v);return D?h[D]:h[s]}t.$Pm=r;function l(h,s){const v=Object.create(null);for(const[D,E]of Object.entries(h))s(D,E)&&(v[D]=E);return v}t.$Qm=l;function e(h){let s=[];for(;Object.prototype!==h;)s=s.concat(Object.getOwnPropertyNames(h)),h=Object.getPrototypeOf(h);return s}t.$Rm=e;function a(h){const s=[];for(const v of e(h))typeof h[v]=="function"&&s.push(v);return s}t.$Sm=a;function n(h,s){const v=E=>function(){const f=Array.prototype.slice.call(arguments,0);return s(E,f)},D={};for(const E of h)D[E]=v(E);return D}t.$Tm=n}),define(be[18],$e([1,0,17]),function(re,t,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ThemeIcon=t.$Dj=t.ThemeColor=void 0;var O;(function(A){function y(o){return o&&typeof o=="object"&&typeof o.id=="string"}A.isThemeColor=y})(O||(t.ThemeColor=O={}));function i(A){return{id:A}}t.$Dj=i;var j;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const y=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function o(s){const v=y.exec(s.id);if(!v)return o(N.$Cj.error);const[,D,E]=v,f=["codicon","codicon-"+D];return E&&f.push("codicon-modifier-"+E.substring(1)),f}A.asClassNameArray=o;function u(s){return o(s).join(" ")}A.asClassName=u;function g(s){return"."+o(s).join(".")}A.asCSSSelector=g;function L(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color>"u"||O.isThemeColor(s.color))}A.isThemeIcon=L;const r=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function l(s){const v=r.exec(s);if(!v)return;const[,D]=v;return{id:D}}A.fromString=l;function e(s){return{id:s}}A.fromId=e;function a(s,v){let D=s.id;const E=D.lastIndexOf("~");return E!==-1&&(D=D.substring(0,E)),v&&(D=`${D}~${v}`),{id:D}}A.modify=a;function n(s){const v=s.id.lastIndexOf("~");if(v!==-1)return s.id.substring(v+1)}A.getModifier=n;function h(s,v){return s.id===v.id&&s.color?.id===v.color?.id}A.isEqual=h})(j||(t.ThemeIcon=j={}))}),define(be[33],$e([1,0,32,11,18]),function(re,t,N,O,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Jj=t.$Ij=t.$Hj=t.$Gj=t.$Fj=t.$Ej=void 0;const j="$(",A=new RegExp(`\\$\\(${i.ThemeIcon.iconNameExpression}(?:${i.ThemeIcon.iconModifierExpression})?\\)`,"g"),y=new RegExp(`(\\\\)?${A.source}`,"g");function o(h){return h.replace(y,(s,v)=>v?s:`\\${s}`)}t.$Ej=o;const u=new RegExp(`\\\\${A.source}`,"g");function g(h){return h.replace(u,s=>`\\${s}`)}t.$Fj=g;const L=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function r(h){return h.indexOf(j)===-1?h:h.replace(L,(s,v,D,E)=>D?s:v||E||"")}t.$Gj=r;function l(h){return h?h.replace(/\$\((.*?)\)/g,(s,v)=>` ${v} `).trim():""}t.$Hj=l;const e=new RegExp(`\\$\\(${i.ThemeIcon.iconNameCharacter}+\\)`,"g");function a(h){e.lastIndex=0;let s="";const v=[];let D=0;for(;;){const E=e.lastIndex,f=e.exec(h),C=h.substring(E,f?.index);if(C.length>0){s+=C;for(let T=0;T<C.length;T++)v.push(D)}if(!f)break;D+=f[0].length}return{text:s,iconOffsets:v}}t.$Ij=a;function n(h,s,v=!1){const{text:D,iconOffsets:E}=s;if(!E||E.length===0)return(0,N.$rj)(h,D,v);const f=(0,O.$td)(D," "),C=D.length-f.length,T=(0,N.$rj)(h,f,v);if(T)for(const P of T){const m=E[P.start+C]+C;P.start+=m,P.end+=m}return T}t.$Jj=n}),define(be[86],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vS=t.$uS=void 0,t.$uS="vscode:contextmenu",t.$vS="vscode:onCloseContextMenu"}),define(be[87],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$CS=void 0;class N{constructor(i,j){this.a=i,this.onMessage=j}send(i){try{this.a.send("vscode:message",i.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}t.$CS=N}),define(be[49],$e([8]),{}),define(be[88],$e([8]),{}),define(be[89],$e([8]),{}),define(be[90],$e([8]),{}),define(be[91],$e([1,0,89,90]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})}),define(be[92],$e([8]),{}),define(be[93],$e([8]),{}),define(be[94],$e([8]),{}),define(be[95],$e([8]),{}),define(be[96],$e([8]),{}),define(be[97],$e([8]),{}),define(be[98],$e([8]),{}),define(be[99],$e([8]),{}),define(be[100],$e([8]),{}),define(be[101],$e([12,10]),function(re,t){return re.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define(be[102],$e([12,10]),function(re,t){return re.create("vs/base/browser/ui/findinput/findInput",t)}),define(be[103],$e([12,10]),function(re,t){return re.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define(be[104],$e([12,10]),function(re,t){return re.create("vs/base/browser/ui/iconLabel/iconLabelHover",t)}),define(be[105],$e([12,10]),function(re,t){return re.create("vs/base/browser/ui/inputbox/inputBox",t)}),define(be[106],$e([12,10]),function(re,t){return re.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define(be[107],$e([12,10]),function(re,t){return re.create("vs/base/browser/ui/tree/abstractTree",t)}),define(be[108],$e([12,10]),function(re,t){return re.create("vs/base/common/actions",t)}),define(be[34],$e([1,0,3,2,108]),function(re,t,N,O,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_h=t.$$h=t.$0h=t.$9h=t.$8h=t.$7h=void 0;class j extends O.$lb{constructor(r,l="",e="",a=!0,n){super(),this.h=this.B(new N.$ec),this.onDidChange=this.h.event,this.w=!0,this.j=r,this.m=l,this.u=e,this.w=a,this.C=n}get id(){return this.j}get label(){return this.m}set label(r){this.D(r)}D(r){this.m!==r&&(this.m=r,this.h.fire({label:r}))}get tooltip(){return this.n||""}set tooltip(r){this.F(r)}F(r){this.n!==r&&(this.n=r,this.h.fire({tooltip:r}))}get class(){return this.u}set class(r){this.G(r)}G(r){this.u!==r&&(this.u=r,this.h.fire({class:r}))}get enabled(){return this.w}set enabled(r){this.H(r)}H(r){this.w!==r&&(this.w=r,this.h.fire({enabled:r}))}get checked(){return this.z}set checked(r){this.I(r)}I(r){this.z!==r&&(this.z=r,this.h.fire({checked:r}))}async run(r,l){this.C&&await this.C(r)}}t.$7h=j;class A extends O.$lb{constructor(){super(...arguments),this.f=this.B(new N.$ec),this.onWillRun=this.f.event,this.k=this.B(new N.$ec),this.onDidRun=this.k.event}async run(r,l){if(!r.enabled)return;this.f.fire({action:r});let e;try{await this.l(r,l)}catch(a){e=a}this.k.fire({action:r,error:e})}async l(r,l){await r.run(l)}}t.$8h=A;class y{constructor(){this.id=y.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...r){let l=[];for(const e of r)e.length&&(l.length?l=[...l,new y,...e]:l=e);return l}static{this.ID="vs.actions.separator"}async run(){}}t.$9h=y;class o{get actions(){return this.a}constructor(r,l,e,a){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=r,this.label=l,this.class=a,this.a=e}async run(){}}t.$0h=o;class u extends j{static{this.ID="vs.actions.empty"}constructor(){super(u.ID,i.localize(0,null),void 0,!1)}}t.$$h=u;function g(L){return{id:L.id,label:L.label,class:void 0,enabled:L.enabled??!0,checked:L.checked??!1,run:async()=>L.run(),tooltip:L.label}}t.$_h=g}),define(be[109],$e([12,10]),function(re,t){return re.create("vs/base/common/platform",t)}),define(be[5],$e([1,0,109]),function(re,t,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$H=t.$G=t.$F=t.$E=t.$D=t.$C=t.OS=t.OperatingSystem=t.$A=t.$z=t.$y=t.$x=t.$w=t.Language=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.$h=t.Platform=t.$g=t.$f=void 0,t.$f="en";let O=!1,i=!1,j=!1,A=!1,y=!1,o=!1,u=!1,g=!1,L=!1,r=!1,l,e=t.$f,a=t.$f,n,h;t.$g=typeof self=="object"?self:typeof global=="object"?global:{};let s;typeof t.$g.vscode<"u"&&typeof t.$g.vscode.process<"u"?s=t.$g.vscode.process:typeof process<"u"&&(s=process);const v=typeof s?.versions?.electron=="string",D=v&&s?.type==="renderer";if(typeof navigator=="object"&&!D)h=navigator.userAgent,O=h.indexOf("Windows")>=0,i=h.indexOf("Macintosh")>=0,g=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,j=h.indexOf("Linux")>=0,r=h?.indexOf("Mobi")>=0,o=!0,l=N.getConfiguredDefaultLocale(N.localize(0,null))||t.$f,e=l,a=navigator.language;else if(typeof s=="object"){O=s.platform==="win32",i=s.platform==="darwin",j=s.platform==="linux",A=j&&!!s.env.SNAP&&!!s.env.SNAP_REVISION,u=v,L=!!s.env.CI||!!s.env.BUILD_ARTIFACTSTAGINGDIRECTORY,l=t.$f,e=t.$f;const R=s.env.VSCODE_NLS_CONFIG;if(R)try{const B=JSON.parse(R),M=B.availableLanguages["*"];l=B.locale,a=B.osLocale,e=M||t.$f,n=B._translationsConfigFile}catch{}y=!0}else console.error("Unable to resolve platform.");var E;(function(R){R[R.Web=0]="Web",R[R.Mac=1]="Mac",R[R.Linux=2]="Linux",R[R.Windows=3]="Windows"})(E||(t.Platform=E={}));function f(R){switch(R){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.$h=f;let C=0;i?C=1:O?C=3:j&&(C=2),t.$i=O,t.$j=i,t.$k=j,t.$l=A,t.$m=y,t.$n=u,t.$o=o,t.$p=o&&typeof t.$g.importScripts=="function",t.$q=g,t.$r=r,t.$s=L,t.$t=C,t.$u=h,t.$v=e;var T;(function(R){function B(){return t.$v}R.value=B;function M(){return t.$v.length===2?t.$v==="en":t.$v.length>=3?t.$v[0]==="e"&&t.$v[1]==="n"&&t.$v[2]==="-":!1}R.isDefaultVariant=M;function z(){return t.$v==="en"}R.isDefault=z})(T||(t.Language=T={})),t.$w=l,t.$x=a,t.$y=n,t.$z=typeof t.$g.postMessage=="function"&&!t.$g.importScripts,t.$A=(()=>{if(t.$z){const R=[];t.$g.addEventListener("message",M=>{if(M.data&&M.data.vscodeScheduleAsyncWork)for(let z=0,te=R.length;z<te;z++){const ne=R[z];if(ne.id===M.data.vscodeScheduleAsyncWork){R.splice(z,1),ne.callback();return}}});let B=0;return M=>{const z=++B;R.push({id:z,callback:M}),t.$g.postMessage({vscodeScheduleAsyncWork:z},"*")}}return R=>setTimeout(R)})();var P;(function(R){R[R.Windows=1]="Windows",R[R.Macintosh=2]="Macintosh",R[R.Linux=3]="Linux"})(P||(t.OperatingSystem=P={})),t.OS=i||g?2:O?1:3;let m=!0,$=!1;function F(){if(!$){$=!0;const R=new Uint8Array(2);R[0]=1,R[1]=2,m=new Uint16Array(R.buffer)[0]===(2<<8)+1}return m}t.$C=F,t.$D=!!(t.$u&&t.$u.indexOf("Chrome")>=0),t.$E=!!(t.$u&&t.$u.indexOf("Firefox")>=0),t.$F=!!(!t.$D&&t.$u&&t.$u.indexOf("Safari")>=0),t.$G=!!(t.$u&&t.$u.indexOf("Edg/")>=0),t.$H=!!(t.$u&&t.$u.indexOf("Android")>=0)}),define(be[110],$e([1,0,16,5]),function(re,t,N,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$XN=t.KeyboardSupport=void 0;var i;(function(j){j[j.Always=0]="Always",j[j.FullScreen=1]="FullScreen",j[j.None=2]="None"})(i||(t.KeyboardSupport=i={})),t.$XN={clipboard:{writeText:O.$m||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:O.$m||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:(()=>O.$m||N.$VN()?0:navigator.keyboard||N.$RN?1:2)(),touch:"ontouchstart"in window||navigator.maxTouchPoints>0,pointerEvents:window.PointerEvent&&("ontouchstart"in window||window.navigator.maxTouchPoints>0||navigator.maxTouchPoints>0)}}),define(be[14],$e([1,0,16,42,74,5]),function(re,t,N,O,i,j){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5N=t.$4N=t.$3N=void 0;function A(e){if(e.charCode){const n=String.fromCharCode(e.charCode).toUpperCase();return O.KeyCodeUtils.fromString(n)}const a=e.keyCode;if(a===3)return 7;if(N.$ON)switch(a){case 59:return 85;case 60:if(j.$k)return 97;break;case 61:return 86;case 107:return 109;case 109:return 111;case 173:return 88;case 224:if(j.$j)return 57;break}else if(N.$PN){if(j.$j&&a===93)return 57;if(!j.$j&&a===92)return 57}return O.$hq[a]||0}const y=j.$j?256:2048,o=512,u=1024,g=j.$j?2048:256;function L(e){const a=[];return e.ctrlKey&&a.push("ctrl"),e.shiftKey&&a.push("shift"),e.altKey&&a.push("alt"),e.metaKey&&a.push("meta"),`modifiers: [${a.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}t.$3N=L;function r(e){const a=[];return e.ctrlKey&&a.push("ctrl"),e.shiftKey&&a.push("shift"),e.altKey&&a.push("alt"),e.metaKey&&a.push("meta"),`modifiers: [${a.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${O.KeyCodeUtils.toString(e.keyCode)}')`}t.$4N=r;class l{constructor(a){this._standardKeyboardEventBrand=!0;const n=a;this.browserEvent=n,this.target=n.target,this.ctrlKey=n.ctrlKey,this.shiftKey=n.shiftKey,this.altKey=n.altKey,this.metaKey=n.metaKey,this.altGraphKey=n.getModifierState("AltGraph"),this.keyCode=A(n),this.code=n.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this.a=this.c(),this.b=this.d()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeyCodeChord(){return this.b}equals(a){return this.a===a}c(){let a=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(a=this.keyCode);let n=0;return this.ctrlKey&&(n|=y),this.altKey&&(n|=o),this.shiftKey&&(n|=u),this.metaKey&&(n|=g),n|=a,n}d(){let a=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(a=this.keyCode),new i.$pq(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,a)}}t.$5N=l}),define(be[19],$e([1,0,16,66,5]),function(re,t,N,O,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2N=t.$1N=t.$ZN=void 0;class j{constructor(u){this.timestamp=Date.now(),this.browserEvent=u,this.leftButton=u.button===0,this.middleButton=u.button===1,this.rightButton=u.button===2,this.buttons=u.buttons,this.target=u.target,this.detail=u.detail||1,u.type==="dblclick"&&(this.detail=2),this.ctrlKey=u.ctrlKey,this.shiftKey=u.shiftKey,this.altKey=u.altKey,this.metaKey=u.metaKey,typeof u.pageX=="number"?(this.posx=u.pageX,this.posy=u.pageY):(this.posx=u.clientX+document.body.scrollLeft+document.documentElement.scrollLeft,this.posy=u.clientY+document.body.scrollTop+document.documentElement.scrollTop);const g=O.$YN.getPositionOfChildWindowRelativeToAncestorWindow(window,u.view);this.posx-=g.left,this.posy-=g.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.$ZN=j;class A extends j{constructor(u){super(u),this.dataTransfer=u.dataTransfer}}t.$1N=A;class y{constructor(u,g=0,L=0){if(this.browserEvent=u||null,this.target=u?u.target||u.targetNode||u.srcElement:null,this.deltaY=L,this.deltaX=g,u){const r=u,l=u;if(typeof r.wheelDeltaY<"u")this.deltaY=r.wheelDeltaY/120;else if(typeof l.VERTICAL_AXIS<"u"&&l.axis===l.VERTICAL_AXIS)this.deltaY=-l.detail/3;else if(u.type==="wheel"){const e=u;e.deltaMode===e.DOM_DELTA_LINE?N.$ON&&!i.$j?this.deltaY=-u.deltaY/3:this.deltaY=-u.deltaY:this.deltaY=-u.deltaY/40}if(typeof r.wheelDeltaX<"u")N.$RN&&i.$i?this.deltaX=-(r.wheelDeltaX/120):this.deltaX=r.wheelDeltaX/120;else if(typeof l.HORIZONTAL_AXIS<"u"&&l.axis===l.HORIZONTAL_AXIS)this.deltaX=-u.detail/3;else if(u.type==="wheel"){const e=u;e.deltaMode===e.DOM_DELTA_LINE?N.$ON&&!i.$j?this.deltaX=-u.deltaX/3:this.deltaX=-u.deltaX:this.deltaX=-u.deltaX/40}this.deltaY===0&&this.deltaX===0&&u.wheelDelta&&(this.deltaY=u.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.$2N=y}),define(be[111],$e([1,0,5]),function(re,t,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3c=t.$2c=t.env=t.cwd=void 0;let O;if(typeof N.$g.vscode<"u"&&typeof N.$g.vscode.process<"u"){const i=N.$g.vscode.process;O={get platform(){return i.platform},get arch(){return i.arch},get env(){return i.env},cwd(){return i.cwd()}}}else typeof process<"u"?O={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:O={get platform(){return N.$i?"win32":N.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=O.cwd,t.env=O.env,t.$2c=O.platform,t.$3c=O.arch}),define(be[22],$e([1,0,111]),function(re,t,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fd=t.sep=t.$dd=t.$cd=t.$bd=t.$ad=t.$_c=t.$$c=t.$0c=t.$9c=t.$8c=t.$7c=t.$6c=t.$5c=t.$4c=void 0;const O=65,i=97,j=90,A=122,y=46,o=47,u=92,g=58,L=63;class r extends Error{constructor(C,T,P){let m;typeof T=="string"&&T.indexOf("not ")===0?(m="must not be",T=T.replace(/^not /,"")):m="must be";const $=C.indexOf(".")!==-1?"property":"argument";let F=`The "${C}" ${$} ${m} of type ${T}`;F+=`. Received type ${typeof P}`,super(F),this.code="ERR_INVALID_ARG_TYPE"}}function l(f,C){if(f===null||typeof f!="object")throw new r(C,"Object",f)}function e(f,C){if(typeof f!="string")throw new r(C,"string",f)}const a=N.$2c==="win32";function n(f){return f===o||f===u}function h(f){return f===o}function s(f){return f>=O&&f<=j||f>=i&&f<=A}function v(f,C,T,P){let m="",$=0,F=-1,R=0,B=0;for(let M=0;M<=f.length;++M){if(M<f.length)B=f.charCodeAt(M);else{if(P(B))break;B=o}if(P(B)){if(!(F===M-1||R===1))if(R===2){if(m.length<2||$!==2||m.charCodeAt(m.length-1)!==y||m.charCodeAt(m.length-2)!==y){if(m.length>2){const z=m.lastIndexOf(T);z===-1?(m="",$=0):(m=m.slice(0,z),$=m.length-1-m.lastIndexOf(T)),F=M,R=0;continue}else if(m.length!==0){m="",$=0,F=M,R=0;continue}}C&&(m+=m.length>0?`${T}..`:"..",$=2)}else m.length>0?m+=`${T}${f.slice(F+1,M)}`:m=f.slice(F+1,M),$=M-F-1;F=M,R=0}else B===y&&R!==-1?++R:R=-1}return m}function D(f,C){l(C,"pathObject");const T=C.dir||C.root,P=C.base||`${C.name||""}${C.ext||""}`;return T?T===C.root?`${T}${P}`:`${T}${f}${P}`:P}t.$4c={resolve(...f){let C="",T="",P=!1;for(let m=f.length-1;m>=-1;m--){let $;if(m>=0){if($=f[m],e($,"path"),$.length===0)continue}else C.length===0?$=N.cwd():($=N.env[`=${C}`]||N.cwd(),($===void 0||$.slice(0,2).toLowerCase()!==C.toLowerCase()&&$.charCodeAt(2)===u)&&($=`${C}\\`));const F=$.length;let R=0,B="",M=!1;const z=$.charCodeAt(0);if(F===1)n(z)&&(R=1,M=!0);else if(n(z))if(M=!0,n($.charCodeAt(1))){let te=2,ne=te;for(;te<F&&!n($.charCodeAt(te));)te++;if(te<F&&te!==ne){const se=$.slice(ne,te);for(ne=te;te<F&&n($.charCodeAt(te));)te++;if(te<F&&te!==ne){for(ne=te;te<F&&!n($.charCodeAt(te));)te++;(te===F||te!==ne)&&(B=`\\\\${se}\\${$.slice(ne,te)}`,R=te)}}}else R=1;else s(z)&&$.charCodeAt(1)===g&&(B=$.slice(0,2),R=2,F>2&&n($.charCodeAt(2))&&(M=!0,R=3));if(B.length>0)if(C.length>0){if(B.toLowerCase()!==C.toLowerCase())continue}else C=B;if(P){if(C.length>0)break}else if(T=`${$.slice(R)}\\${T}`,P=M,M&&C.length>0)break}return T=v(T,!P,"\\",n),P?`${C}\\${T}`:`${C}${T}`||"."},normalize(f){e(f,"path");const C=f.length;if(C===0)return".";let T=0,P,m=!1;const $=f.charCodeAt(0);if(C===1)return h($)?"\\":f;if(n($))if(m=!0,n(f.charCodeAt(1))){let R=2,B=R;for(;R<C&&!n(f.charCodeAt(R));)R++;if(R<C&&R!==B){const M=f.slice(B,R);for(B=R;R<C&&n(f.charCodeAt(R));)R++;if(R<C&&R!==B){for(B=R;R<C&&!n(f.charCodeAt(R));)R++;if(R===C)return`\\\\${M}\\${f.slice(B)}\\`;R!==B&&(P=`\\\\${M}\\${f.slice(B,R)}`,T=R)}}}else T=1;else s($)&&f.charCodeAt(1)===g&&(P=f.slice(0,2),T=2,C>2&&n(f.charCodeAt(2))&&(m=!0,T=3));let F=T<C?v(f.slice(T),!m,"\\",n):"";return F.length===0&&!m&&(F="."),F.length>0&&n(f.charCodeAt(C-1))&&(F+="\\"),P===void 0?m?`\\${F}`:F:m?`${P}\\${F}`:`${P}${F}`},isAbsolute(f){e(f,"path");const C=f.length;if(C===0)return!1;const T=f.charCodeAt(0);return n(T)||C>2&&s(T)&&f.charCodeAt(1)===g&&n(f.charCodeAt(2))},join(...f){if(f.length===0)return".";let C,T;for(let $=0;$<f.length;++$){const F=f[$];e(F,"path"),F.length>0&&(C===void 0?C=T=F:C+=`\\${F}`)}if(C===void 0)return".";let P=!0,m=0;if(typeof T=="string"&&n(T.charCodeAt(0))){++m;const $=T.length;$>1&&n(T.charCodeAt(1))&&(++m,$>2&&(n(T.charCodeAt(2))?++m:P=!1))}if(P){for(;m<C.length&&n(C.charCodeAt(m));)m++;m>=2&&(C=`\\${C.slice(m)}`)}return t.$4c.normalize(C)},relative(f,C){if(e(f,"from"),e(C,"to"),f===C)return"";const T=t.$4c.resolve(f),P=t.$4c.resolve(C);if(T===P||(f=T.toLowerCase(),C=P.toLowerCase(),f===C))return"";let m=0;for(;m<f.length&&f.charCodeAt(m)===u;)m++;let $=f.length;for(;$-1>m&&f.charCodeAt($-1)===u;)$--;const F=$-m;let R=0;for(;R<C.length&&C.charCodeAt(R)===u;)R++;let B=C.length;for(;B-1>R&&C.charCodeAt(B-1)===u;)B--;const M=B-R,z=F<M?F:M;let te=-1,ne=0;for(;ne<z;ne++){const ce=f.charCodeAt(m+ne);if(ce!==C.charCodeAt(R+ne))break;ce===u&&(te=ne)}if(ne!==z){if(te===-1)return P}else{if(M>z){if(C.charCodeAt(R+ne)===u)return P.slice(R+ne+1);if(ne===2)return P.slice(R+ne)}F>z&&(f.charCodeAt(m+ne)===u?te=ne:ne===2&&(te=3)),te===-1&&(te=0)}let se="";for(ne=m+te+1;ne<=$;++ne)(ne===$||f.charCodeAt(ne)===u)&&(se+=se.length===0?"..":"\\..");return R+=te,se.length>0?`${se}${P.slice(R,B)}`:(P.charCodeAt(R)===u&&++R,P.slice(R,B))},toNamespacedPath(f){if(typeof f!="string"||f.length===0)return f;const C=t.$4c.resolve(f);if(C.length<=2)return f;if(C.charCodeAt(0)===u){if(C.charCodeAt(1)===u){const T=C.charCodeAt(2);if(T!==L&&T!==y)return`\\\\?\\UNC\\${C.slice(2)}`}}else if(s(C.charCodeAt(0))&&C.charCodeAt(1)===g&&C.charCodeAt(2)===u)return`\\\\?\\${C}`;return f},dirname(f){e(f,"path");const C=f.length;if(C===0)return".";let T=-1,P=0;const m=f.charCodeAt(0);if(C===1)return n(m)?f:".";if(n(m)){if(T=P=1,n(f.charCodeAt(1))){let R=2,B=R;for(;R<C&&!n(f.charCodeAt(R));)R++;if(R<C&&R!==B){for(B=R;R<C&&n(f.charCodeAt(R));)R++;if(R<C&&R!==B){for(B=R;R<C&&!n(f.charCodeAt(R));)R++;if(R===C)return f;R!==B&&(T=P=R+1)}}}}else s(m)&&f.charCodeAt(1)===g&&(T=C>2&&n(f.charCodeAt(2))?3:2,P=T);let $=-1,F=!0;for(let R=C-1;R>=P;--R)if(n(f.charCodeAt(R))){if(!F){$=R;break}}else F=!1;if($===-1){if(T===-1)return".";$=T}return f.slice(0,$)},basename(f,C){C!==void 0&&e(C,"ext"),e(f,"path");let T=0,P=-1,m=!0,$;if(f.length>=2&&s(f.charCodeAt(0))&&f.charCodeAt(1)===g&&(T=2),C!==void 0&&C.length>0&&C.length<=f.length){if(C===f)return"";let F=C.length-1,R=-1;for($=f.length-1;$>=T;--$){const B=f.charCodeAt($);if(n(B)){if(!m){T=$+1;break}}else R===-1&&(m=!1,R=$+1),F>=0&&(B===C.charCodeAt(F)?--F===-1&&(P=$):(F=-1,P=R))}return T===P?P=R:P===-1&&(P=f.length),f.slice(T,P)}for($=f.length-1;$>=T;--$)if(n(f.charCodeAt($))){if(!m){T=$+1;break}}else P===-1&&(m=!1,P=$+1);return P===-1?"":f.slice(T,P)},extname(f){e(f,"path");let C=0,T=-1,P=0,m=-1,$=!0,F=0;f.length>=2&&f.charCodeAt(1)===g&&s(f.charCodeAt(0))&&(C=P=2);for(let R=f.length-1;R>=C;--R){const B=f.charCodeAt(R);if(n(B)){if(!$){P=R+1;break}continue}m===-1&&($=!1,m=R+1),B===y?T===-1?T=R:F!==1&&(F=1):T!==-1&&(F=-1)}return T===-1||m===-1||F===0||F===1&&T===m-1&&T===P+1?"":f.slice(T,m)},format:D.bind(null,"\\"),parse(f){e(f,"path");const C={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return C;const T=f.length;let P=0,m=f.charCodeAt(0);if(T===1)return n(m)?(C.root=C.dir=f,C):(C.base=C.name=f,C);if(n(m)){if(P=1,n(f.charCodeAt(1))){let te=2,ne=te;for(;te<T&&!n(f.charCodeAt(te));)te++;if(te<T&&te!==ne){for(ne=te;te<T&&n(f.charCodeAt(te));)te++;if(te<T&&te!==ne){for(ne=te;te<T&&!n(f.charCodeAt(te));)te++;te===T?P=te:te!==ne&&(P=te+1)}}}}else if(s(m)&&f.charCodeAt(1)===g){if(T<=2)return C.root=C.dir=f,C;if(P=2,n(f.charCodeAt(2))){if(T===3)return C.root=C.dir=f,C;P=3}}P>0&&(C.root=f.slice(0,P));let $=-1,F=P,R=-1,B=!0,M=f.length-1,z=0;for(;M>=P;--M){if(m=f.charCodeAt(M),n(m)){if(!B){F=M+1;break}continue}R===-1&&(B=!1,R=M+1),m===y?$===-1?$=M:z!==1&&(z=1):$!==-1&&(z=-1)}return R!==-1&&($===-1||z===0||z===1&&$===R-1&&$===F+1?C.base=C.name=f.slice(F,R):(C.name=f.slice(F,$),C.base=f.slice(F,R),C.ext=f.slice($,R))),F>0&&F!==P?C.dir=f.slice(0,F-1):C.dir=C.root,C},sep:"\\",delimiter:";",win32:null,posix:null};const E=(()=>{if(a){const f=/\\/g;return()=>{const C=N.cwd().replace(f,"/");return C.slice(C.indexOf("/"))}}return()=>N.cwd()})();t.$5c={resolve(...f){let C="",T=!1;for(let P=f.length-1;P>=-1&&!T;P--){const m=P>=0?f[P]:E();e(m,"path"),m.length!==0&&(C=`${m}/${C}`,T=m.charCodeAt(0)===o)}return C=v(C,!T,"/",h),T?`/${C}`:C.length>0?C:"."},normalize(f){if(e(f,"path"),f.length===0)return".";const C=f.charCodeAt(0)===o,T=f.charCodeAt(f.length-1)===o;return f=v(f,!C,"/",h),f.length===0?C?"/":T?"./":".":(T&&(f+="/"),C?`/${f}`:f)},isAbsolute(f){return e(f,"path"),f.length>0&&f.charCodeAt(0)===o},join(...f){if(f.length===0)return".";let C;for(let T=0;T<f.length;++T){const P=f[T];e(P,"path"),P.length>0&&(C===void 0?C=P:C+=`/${P}`)}return C===void 0?".":t.$5c.normalize(C)},relative(f,C){if(e(f,"from"),e(C,"to"),f===C||(f=t.$5c.resolve(f),C=t.$5c.resolve(C),f===C))return"";const T=1,P=f.length,m=P-T,$=1,F=C.length-$,R=m<F?m:F;let B=-1,M=0;for(;M<R;M++){const te=f.charCodeAt(T+M);if(te!==C.charCodeAt($+M))break;te===o&&(B=M)}if(M===R)if(F>R){if(C.charCodeAt($+M)===o)return C.slice($+M+1);if(M===0)return C.slice($+M)}else m>R&&(f.charCodeAt(T+M)===o?B=M:M===0&&(B=0));let z="";for(M=T+B+1;M<=P;++M)(M===P||f.charCodeAt(M)===o)&&(z+=z.length===0?"..":"/..");return`${z}${C.slice($+B)}`},toNamespacedPath(f){return f},dirname(f){if(e(f,"path"),f.length===0)return".";const C=f.charCodeAt(0)===o;let T=-1,P=!0;for(let m=f.length-1;m>=1;--m)if(f.charCodeAt(m)===o){if(!P){T=m;break}}else P=!1;return T===-1?C?"/":".":C&&T===1?"//":f.slice(0,T)},basename(f,C){C!==void 0&&e(C,"ext"),e(f,"path");let T=0,P=-1,m=!0,$;if(C!==void 0&&C.length>0&&C.length<=f.length){if(C===f)return"";let F=C.length-1,R=-1;for($=f.length-1;$>=0;--$){const B=f.charCodeAt($);if(B===o){if(!m){T=$+1;break}}else R===-1&&(m=!1,R=$+1),F>=0&&(B===C.charCodeAt(F)?--F===-1&&(P=$):(F=-1,P=R))}return T===P?P=R:P===-1&&(P=f.length),f.slice(T,P)}for($=f.length-1;$>=0;--$)if(f.charCodeAt($)===o){if(!m){T=$+1;break}}else P===-1&&(m=!1,P=$+1);return P===-1?"":f.slice(T,P)},extname(f){e(f,"path");let C=-1,T=0,P=-1,m=!0,$=0;for(let F=f.length-1;F>=0;--F){const R=f.charCodeAt(F);if(R===o){if(!m){T=F+1;break}continue}P===-1&&(m=!1,P=F+1),R===y?C===-1?C=F:$!==1&&($=1):C!==-1&&($=-1)}return C===-1||P===-1||$===0||$===1&&C===P-1&&C===T+1?"":f.slice(C,P)},format:D.bind(null,"/"),parse(f){e(f,"path");const C={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return C;const T=f.charCodeAt(0)===o;let P;T?(C.root="/",P=1):P=0;let m=-1,$=0,F=-1,R=!0,B=f.length-1,M=0;for(;B>=P;--B){const z=f.charCodeAt(B);if(z===o){if(!R){$=B+1;break}continue}F===-1&&(R=!1,F=B+1),z===y?m===-1?m=B:M!==1&&(M=1):m!==-1&&(M=-1)}if(F!==-1){const z=$===0&&T?1:$;m===-1||M===0||M===1&&m===F-1&&m===$+1?C.base=C.name=f.slice(z,F):(C.name=f.slice(z,m),C.base=f.slice(z,F),C.ext=f.slice(m,F))}return $>0?C.dir=f.slice(0,$-1):T&&(C.dir="/"),C},sep:"/",delimiter:":",win32:null,posix:null},t.$5c.win32=t.$4c.win32=t.$4c,t.$5c.posix=t.$4c.posix=t.$5c,t.$6c=a?t.$4c.normalize:t.$5c.normalize,t.$7c=a?t.$4c.isAbsolute:t.$5c.isAbsolute,t.$8c=a?t.$4c.join:t.$5c.join,t.$9c=a?t.$4c.resolve:t.$5c.resolve,t.$0c=a?t.$4c.relative:t.$5c.relative,t.$$c=a?t.$4c.dirname:t.$5c.dirname,t.$_c=a?t.$4c.basename:t.$5c.basename,t.$ad=a?t.$4c.extname:t.$5c.extname,t.$bd=a?t.$4c.format:t.$5c.format,t.$cd=a?t.$4c.parse:t.$5c.parse,t.$dd=a?t.$4c.toNamespacedPath:t.$5c.toNamespacedPath,t.sep=a?t.$4c.sep:t.$5c.sep,t.$fd=a?t.$4c.delimiter:t.$5c.delimiter}),define(be[112],$e([1,0,22,5,11,7]),function(re,t,N,O,i,j){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Pe=t.$Oe=t.$Ne=t.$Me=t.$Le=t.$Ke=t.$Je=t.$Ie=t.$He=t.$Ge=t.$Fe=t.$Ee=t.$De=t.$Ce=t.$Be=t.$Ae=void 0;function A($){return $===47||$===92}t.$Ae=A;function y($){return $.replace(/[\\/]/g,N.$5c.sep)}t.$Be=y;function o($){return $.indexOf("/")===-1&&($=y($)),/^[a-zA-Z]:(\/|$)/.test($)&&($="/"+$),$}t.$Ce=o;function u($,F=N.$5c.sep){if(!$)return"";const R=$.length,B=$.charCodeAt(0);if(A(B)){if(A($.charCodeAt(1))&&!A($.charCodeAt(2))){let z=3;const te=z;for(;z<R&&!A($.charCodeAt(z));z++);if(te!==z&&!A($.charCodeAt(z+1))){for(z+=1;z<R;z++)if(A($.charCodeAt(z)))return $.slice(0,z+1).replace(/[\\/]/g,F)}}return F}else if(h(B)&&$.charCodeAt(1)===58)return A($.charCodeAt(2))?$.slice(0,2)+F:$.slice(0,2);let M=$.indexOf("://");if(M!==-1){for(M+=3;M<R;M++)if(A($.charCodeAt(M)))return $.slice(0,M+1)}return""}t.$De=u;function g($){if(!O.$i||!$||$.length<5)return!1;let F=$.charCodeAt(0);if(F!==92||(F=$.charCodeAt(1),F!==92))return!1;let R=2;const B=R;for(;R<$.length&&(F=$.charCodeAt(R),F!==92);R++);return!(B===R||(F=$.charCodeAt(R+1),isNaN(F)||F===92))}t.$Ee=g;const L=/[\\/:\*\?"<>\|]/g,r=/[\\/]/g,l=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function e($,F=O.$i){const R=F?L:r;return!(!$||$.length===0||/^\s+$/.test($)||(R.lastIndex=0,R.test($))||F&&l.test($)||$==="."||$===".."||F&&$[$.length-1]==="."||F&&$.length!==$.trim().length||$.length>255)}t.$Fe=e;function a($,F,R){const B=$===F;return!R||B?B:!$||!F?!1:(0,i.$Ld)($,F)}t.$Ge=a;function n($,F,R,B=N.sep){if($===F)return!0;if(!$||!F||F.length>$.length)return!1;if(R){if(!(0,i.$Md)($,F))return!1;if(F.length===$.length)return!0;let z=F.length;return F.charAt(F.length-1)===B&&z--,$.charAt(z)===B}return F.charAt(F.length-1)!==B&&(F+=B),$.indexOf(F)===0}t.$He=n;function h($){return $>=65&&$<=90||$>=97&&$<=122}t.$Ie=h;function s($,F){return O.$i&&$.endsWith(":")&&($+=N.sep),(0,N.$7c)($)||($=(0,N.$8c)(F,$)),$=(0,N.$6c)($),O.$i?($=(0,i.$ud)($,N.sep),$.endsWith(":")&&($+=N.sep)):($=(0,i.$ud)($,N.sep),$||($=N.sep)),$}t.$Je=s;function v($){const F=(0,N.$6c)($);return O.$i?$.length>3?!1:D(F)&&($.length===2||F.charCodeAt(2)===92):F===N.$5c.sep}t.$Ke=v;function D($,F=O.$i){return F?h($.charCodeAt(0))&&$.charCodeAt(1)===58:!1}t.$Le=D;function E($,F=O.$i){return D($,F)?$[0]:void 0}t.$Me=E;function f($,F,R){return F.length>$.length?-1:$===F?0:(R&&($=$.toLowerCase(),F=F.toLowerCase()),$.indexOf(F))}t.$Ne=f;function C($){const F=$.split(":");let R,B,M;for(const z of F){const te=Number(z);(0,j.$me)(te)?B===void 0?B=te:M===void 0&&(M=te):R=R?[R,z].join(":"):z}if(!R)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:R,line:B!==void 0?B:void 0,column:M!==void 0?M:B!==void 0?1:void 0}}t.$Oe=C;const T="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",P="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function m($,F,R=8){let B="";for(let z=0;z<R;z++){let te;z===0&&O.$i&&!F&&(R===3||R===4)?te=P:te=T,B+=te.charAt(Math.floor(Math.random()*te.length))}let M;return F?M=`${F}-${B}`:M=B,$?(0,N.$8c)($,M):M}t.$Pe=m}),define(be[113],$e([1,0,22]),function(re,t,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Cr=t.$Br=t.$Ar=t.$zr=t.$yr=void 0,t.$yr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const O={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},i={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function j(g){const L=(0,N.$ad)(g),r=O[L.toLowerCase()];return r!==void 0?r:A(g)}t.$zr=j;function A(g){const L=(0,N.$ad)(g);return i[L.toLowerCase()]}t.$Ar=A;function y(g){for(const L in i)if(i[L]===g)return L}t.$Br=y;const o=/^(.+)\/(.+?)(;.+)?$/;function u(g,L){const r=o.exec(g);return r?`${r[1].toLowerCase()}/${r[2].toLowerCase()}${r[3]??""}`:L?void 0:g}t.$Cr=u}),define(be[15],$e([1,0,22,5]),function(re,t,N,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Se=t.$Re=t.URI=void 0;const i=/^\w[\w\d+.-]*$/,j=/^\//,A=/^\/\//;function y(P,m){if(!P.scheme&&m)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${P.authority}", path: "${P.path}", query: "${P.query}", fragment: "${P.fragment}"}`);if(P.scheme&&!i.test(P.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(P.path){if(P.authority){if(!j.test(P.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(P.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function o(P,m){return!P&&!m?"file":P}function u(P,m){switch(P){case"https":case"http":case"file":m?m[0]!==L&&(m=L+m):m=L;break}return m}const g="",L="/",r=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class l{static isUri(m){return m instanceof l?!0:m?typeof m.authority=="string"&&typeof m.fragment=="string"&&typeof m.path=="string"&&typeof m.query=="string"&&typeof m.scheme=="string"&&typeof m.fsPath=="string"&&typeof m.with=="function"&&typeof m.toString=="function":!1}constructor(m,$,F,R,B,M=!1){typeof m=="object"?(this.scheme=m.scheme||g,this.authority=m.authority||g,this.path=m.path||g,this.query=m.query||g,this.fragment=m.fragment||g):(this.scheme=o(m,M),this.authority=$||g,this.path=u(this.scheme,F||g),this.query=R||g,this.fragment=B||g,y(this,M))}get fsPath(){return D(this,!1)}with(m){if(!m)return this;let{scheme:$,authority:F,path:R,query:B,fragment:M}=m;return $===void 0?$=this.scheme:$===null&&($=g),F===void 0?F=this.authority:F===null&&(F=g),R===void 0?R=this.path:R===null&&(R=g),B===void 0?B=this.query:B===null&&(B=g),M===void 0?M=this.fragment:M===null&&(M=g),$===this.scheme&&F===this.authority&&R===this.path&&B===this.query&&M===this.fragment?this:new n($,F,R,B,M)}static parse(m,$=!1){const F=r.exec(m);return F?new n(F[2]||g,T(F[4]||g),T(F[5]||g),T(F[7]||g),T(F[9]||g),$):new n(g,g,g,g,g)}static file(m){let $=g;if(O.$i&&(m=m.replace(/\\/g,L)),m[0]===L&&m[1]===L){const F=m.indexOf(L,2);F===-1?($=m.substring(2),m=L):($=m.substring(2,F),m=m.substring(F)||L)}return new n("file",$,m,g,g)}static from(m,$){return new n(m.scheme,m.authority,m.path,m.query,m.fragment,$)}static joinPath(m,...$){if(!m.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let F;return O.$i&&m.scheme==="file"?F=l.file(N.$4c.join(D(m,!0),...$)).path:F=N.$5c.join(m.path,...$),m.with({path:F})}toString(m=!1){return E(this,m)}toJSON(){return this}static revive(m){if(m){if(m instanceof l)return m;{const $=new n(m);return $._formatted=m.external??null,$._fsPath=m._sep===a?m.fsPath??null:null,$}}else return m}}t.URI=l;function e(P){return!P||typeof P!="object"?!1:typeof P.scheme=="string"&&(typeof P.authority=="string"||typeof P.authority>"u")&&(typeof P.path=="string"||typeof P.path>"u")&&(typeof P.query=="string"||typeof P.query>"u")&&(typeof P.fragment=="string"||typeof P.fragment>"u")}t.$Re=e;const a=O.$i?1:void 0;class n extends l{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=D(this,!1)),this._fsPath}toString(m=!1){return m?E(this,!0):(this._formatted||(this._formatted=E(this,!1)),this._formatted)}toJSON(){const m={$mid:1};return this._fsPath&&(m.fsPath=this._fsPath,m._sep=a),this._formatted&&(m.external=this._formatted),this.path&&(m.path=this.path),this.scheme&&(m.scheme=this.scheme),this.authority&&(m.authority=this.authority),this.query&&(m.query=this.query),this.fragment&&(m.fragment=this.fragment),m}}const h={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function s(P,m,$){let F,R=-1;for(let B=0;B<P.length;B++){const M=P.charCodeAt(B);if(M>=97&&M<=122||M>=65&&M<=90||M>=48&&M<=57||M===45||M===46||M===95||M===126||m&&M===47||$&&M===91||$&&M===93||$&&M===58)R!==-1&&(F+=encodeURIComponent(P.substring(R,B)),R=-1),F!==void 0&&(F+=P.charAt(B));else{F===void 0&&(F=P.substr(0,B));const z=h[M];z!==void 0?(R!==-1&&(F+=encodeURIComponent(P.substring(R,B)),R=-1),F+=z):R===-1&&(R=B)}}return R!==-1&&(F+=encodeURIComponent(P.substring(R))),F!==void 0?F:P}function v(P){let m;for(let $=0;$<P.length;$++){const F=P.charCodeAt($);F===35||F===63?(m===void 0&&(m=P.substr(0,$)),m+=h[F]):m!==void 0&&(m+=P[$])}return m!==void 0?m:P}function D(P,m){let $;return P.authority&&P.path.length>1&&P.scheme==="file"?$=`//${P.authority}${P.path}`:P.path.charCodeAt(0)===47&&(P.path.charCodeAt(1)>=65&&P.path.charCodeAt(1)<=90||P.path.charCodeAt(1)>=97&&P.path.charCodeAt(1)<=122)&&P.path.charCodeAt(2)===58?m?$=P.path.substr(1):$=P.path[1].toLowerCase()+P.path.substr(2):$=P.path,O.$i&&($=$.replace(/\//g,"\\")),$}t.$Se=D;function E(P,m){const $=m?v:s;let F="",{scheme:R,authority:B,path:M,query:z,fragment:te}=P;if(R&&(F+=R,F+=":"),(B||R==="file")&&(F+=L,F+=L),B){let ne=B.indexOf("@");if(ne!==-1){const se=B.substr(0,ne);B=B.substr(ne+1),ne=se.lastIndexOf(":"),ne===-1?F+=$(se,!1,!1):(F+=$(se.substr(0,ne),!1,!1),F+=":",F+=$(se.substr(ne+1),!1,!0)),F+="@"}B=B.toLowerCase(),ne=B.lastIndexOf(":"),ne===-1?F+=$(B,!1,!0):(F+=$(B.substr(0,ne),!1,!0),F+=B.substr(ne))}if(M){if(M.length>=3&&M.charCodeAt(0)===47&&M.charCodeAt(2)===58){const ne=M.charCodeAt(1);ne>=65&&ne<=90&&(M=`/${String.fromCharCode(ne+32)}:${M.substr(3)}`)}else if(M.length>=2&&M.charCodeAt(1)===58){const ne=M.charCodeAt(0);ne>=65&&ne<=90&&(M=`${String.fromCharCode(ne+32)}:${M.substr(2)}`)}F+=$(M,!0,!1)}return z&&(F+="?",F+=$(z,!1,!1)),te&&(F+="#",F+=m?te:s(te,!1,!1)),F}function f(P){try{return decodeURIComponent(P)}catch{return P.length>3?P.substr(0,3)+f(P.substr(3)):P}}const C=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function T(P){return P.match(C)?P.replace(C,m=>f(m)):P}}),define(be[50],$e([1,0,31,15]),function(re,t,N,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Yg=t.$Xg=t.$Wg=void 0;function i(o){return JSON.stringify(o,A)}t.$Wg=i;function j(o){let u=JSON.parse(o);return u=y(u),u}t.$Xg=j;function A(o,u){return u instanceof RegExp?{$mid:2,source:u.source,flags:u.flags}:u}function y(o,u=0){if(!o||u>200)return o;if(typeof o=="object"){switch(o.$mid){case 1:return O.URI.revive(o);case 2:return new RegExp(o.source,o.flags);case 16:return new Date(o.source)}if(o instanceof N.$Ec||o instanceof Uint8Array)return o;if(Array.isArray(o))for(let g=0;g<o.length;++g)o[g]=y(o[g],u+1);else for(const g in o)Object.hasOwnProperty.call(o,g)&&(o[g]=y(o[g],u+1))}return o}t.$Yg=y}),define(be[28],$e([1,0,6,5,15]),function(re,t,N,O,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.$1e=t.$Ze=t.$Ye=t.$Xe=t.$We=t.$Ve=t.$Ue=t.$Te=t.Schemas=void 0;var j;(function(u){u.inMemory="inmemory",u.vscode="vscode",u.internal="private",u.walkThrough="walkThrough",u.walkThroughSnippet="walkThroughSnippet",u.http="http",u.https="https",u.file="file",u.mailto="mailto",u.untitled="untitled",u.data="data",u.command="command",u.vscodeRemote="vscode-remote",u.vscodeRemoteResource="vscode-remote-resource",u.vscodeManagedRemoteResource="vscode-managed-remote-resource",u.vscodeUserData="vscode-userdata",u.vscodeCustomEditor="vscode-custom-editor",u.vscodeNotebookCell="vscode-notebook-cell",u.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",u.vscodeNotebookCellOutput="vscode-notebook-cell-output",u.vscodeInteractiveInput="vscode-interactive-input",u.vscodeSettings="vscode-settings",u.vscodeWorkspaceTrust="vscode-workspace-trust",u.vscodeTerminal="vscode-terminal",u.vscodeChatSesssion="vscode-chat-editor",u.webviewPanel="webview-panel",u.vscodeWebview="vscode-webview",u.extension="extension",u.vscodeFileResource="vscode-file",u.tmp="tmp",u.vsls="vsls",u.vscodeSourceControl="vscode-scm"})(j||(t.Schemas=j={})),t.$Te="vscode-tkn",t.$Ue="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${j.vscodeRemoteResource}`}setPreferredWebSchema(g){this.d=g}setDelegate(g){this.e=g}setServerRootPath(g){this.f=`${g}/${j.vscodeRemoteResource}`}set(g,L,r){this.a[g]=L,this.b[g]=r}setConnectionToken(g,L){this.c[g]=L}getPreferredWebSchema(){return this.d}rewrite(g){if(this.e)try{return this.e(g)}catch(n){return N.$Y(n),g}const L=g.authority;let r=this.a[L];r&&r.indexOf(":")!==-1&&r.indexOf("[")===-1&&(r=`[${r}]`);const l=this.b[L],e=this.c[L];let a=`path=${encodeURIComponent(g.path)}`;return typeof e=="string"&&(a+=`&${t.$Ue}=${encodeURIComponent(e)}`),i.URI.from({scheme:O.$o?this.d:j.vscodeRemoteResource,authority:`${r}:${l}`,path:this.f,query:a})}}t.$Ve=new A,t.$We="vs/../../extensions",t.$Xe="vs/../../node_modules",t.$Ye="vs/../../node_modules.asar",t.$Ze="vs/../../node_modules.asar.unpacked";class y{static{this.a="vscode-app"}asBrowserUri(g){const L=this.b(g,re);return this.uriToBrowserUri(L)}uriToBrowserUri(g){return g.scheme===j.vscodeRemote?t.$Ve.rewrite(g):g.scheme===j.file&&(O.$m||O.$p&&O.$g.origin===`${j.vscodeFileResource}://${y.a}`)?g.with({scheme:j.vscodeFileResource,authority:g.authority||y.a,query:null,fragment:null}):g}asFileUri(g){const L=this.b(g,re);return this.uriToFileUri(L)}uriToFileUri(g){return g.scheme===j.vscodeFileResource?g.with({scheme:j.file,authority:g.authority!==y.a?g.authority:null,query:null,fragment:null}):g}b(g,L){return i.URI.isUri(g)?g:i.URI.parse(L.toUrl(g))}}t.$1e=new y;var o;(function(u){const g=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);u.CoopAndCoep=Object.freeze(g.get("3"));const L="vscode-coi";function r(e){let a;typeof e=="string"?a=new URL(e).searchParams:e instanceof URL?a=e.searchParams:i.URI.isUri(e)&&(a=new URL(e.toString(!0)).searchParams);const n=a?.get(L);if(n)return g.get(n)}u.getHeadersFromQuery=r;function l(e,a,n){if(!globalThis.crossOriginIsolated)return;const h=a&&n?"3":n?"2":"1";e instanceof URLSearchParams?e.set(L,h):e[L]=h}u.addSearchParam=l})(o||(t.COI=o={}))}),define(be[35],$e([1,0,112,28,22,5,11,15]),function(re,t,N,O,i,j,A,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gg=t.DataUri=t.$fg=t.$eg=t.$dg=t.$cg=t.$bg=t.$ag=t.$_f=t.$$f=t.$0f=t.$9f=t.$8f=t.$7f=t.$6f=t.$5f=t.$4f=t.$3f=t.$2f=t.$1f=t.$Zf=t.$Yf=t.$Xf=t.$Wf=void 0;function o(l){return(0,y.$Se)(l,!0)}t.$Wf=o;class u{constructor(e){this.a=e}compare(e,a,n=!1){return e===a?0:(0,A.$Ed)(this.getComparisonKey(e,n),this.getComparisonKey(a,n))}isEqual(e,a,n=!1){return e===a?!0:!e||!a?!1:this.getComparisonKey(e,n)===this.getComparisonKey(a,n)}getComparisonKey(e,a=!1){return e.with({path:this.a(e)?e.path.toLowerCase():void 0,fragment:a?null:void 0}).toString()}ignorePathCasing(e){return this.a(e)}isEqualOrParent(e,a,n=!1){if(e.scheme===a.scheme){if(e.scheme===O.Schemas.file)return N.$He(o(e),o(a),this.a(e))&&e.query===a.query&&(n||e.fragment===a.fragment);if((0,t.$bg)(e.authority,a.authority))return N.$He(e.path,a.path,this.a(e),"/")&&e.query===a.query&&(n||e.fragment===a.fragment)}return!1}joinPath(e,...a){return y.URI.joinPath(e,...a)}basenameOrAuthority(e){return(0,t.$6f)(e)||e.authority}basename(e){return i.$5c.basename(e.path)}extname(e){return i.$5c.extname(e.path)}dirname(e){if(e.path.length===0)return e;let a;return e.scheme===O.Schemas.file?a=y.URI.file(i.$$c(o(e))).path:(a=i.$5c.dirname(e.path),e.authority&&a.length&&a.charCodeAt(0)!==47&&(console.error(`dirname("${e.toString})) resulted in a relative path`),a="/")),e.with({path:a})}normalizePath(e){if(!e.path.length)return e;let a;return e.scheme===O.Schemas.file?a=y.URI.file(i.$6c(o(e))).path:a=i.$5c.normalize(e.path),e.with({path:a})}relativePath(e,a){if(e.scheme!==a.scheme||!(0,t.$bg)(e.authority,a.authority))return;if(e.scheme===O.Schemas.file){const s=i.$0c(o(e),o(a));return j.$i?N.$Be(s):s}let n=e.path||"/";const h=a.path||"/";if(this.a(e)){let s=0;for(const v=Math.min(n.length,h.length);s<v&&!(n.charCodeAt(s)!==h.charCodeAt(s)&&n.charAt(s).toLowerCase()!==h.charAt(s).toLowerCase());s++);n=h.substr(0,s)+n.substr(s)}return i.$5c.relative(n,h)}resolvePath(e,a){if(e.scheme===O.Schemas.file){const n=y.URI.file(i.$9c(o(e),a));return e.with({authority:n.authority,path:n.path})}return a=N.$Ce(a),e.with({path:i.$5c.resolve(e.path,a)})}isAbsolutePath(e){return!!e.path&&e.path[0]==="/"}isEqualAuthority(e,a){return e===a||e!==void 0&&a!==void 0&&(0,A.$Ld)(e,a)}hasTrailingPathSeparator(e,a=i.sep){if(e.scheme===O.Schemas.file){const n=o(e);return n.length>N.$De(n).length&&n[n.length-1]===a}else{const n=e.path;return n.length>1&&n.charCodeAt(n.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,a=i.sep){return(0,t.$cg)(e,a)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,a=i.sep){let n=!1;if(e.scheme===O.Schemas.file){const h=o(e);n=h!==void 0&&h.length===N.$De(h).length&&h[h.length-1]===a}else{a="/";const h=e.path;n=h.length===1&&h.charCodeAt(h.length-1)===47}return!n&&!(0,t.$cg)(e,a)?e.with({path:e.path+"/"}):e}}t.$Xf=u,t.$Yf=new u(()=>!1),t.$Zf=new u(l=>l.scheme===O.Schemas.file?!j.$k:!0),t.$1f=new u(l=>!0),t.$2f=t.$Yf.isEqual.bind(t.$Yf),t.$3f=t.$Yf.isEqualOrParent.bind(t.$Yf),t.$4f=t.$Yf.getComparisonKey.bind(t.$Yf),t.$5f=t.$Yf.basenameOrAuthority.bind(t.$Yf),t.$6f=t.$Yf.basename.bind(t.$Yf),t.$7f=t.$Yf.extname.bind(t.$Yf),t.$8f=t.$Yf.dirname.bind(t.$Yf),t.$9f=t.$Yf.joinPath.bind(t.$Yf),t.$0f=t.$Yf.normalizePath.bind(t.$Yf),t.$$f=t.$Yf.relativePath.bind(t.$Yf),t.$_f=t.$Yf.resolvePath.bind(t.$Yf),t.$ag=t.$Yf.isAbsolutePath.bind(t.$Yf),t.$bg=t.$Yf.isEqualAuthority.bind(t.$Yf),t.$cg=t.$Yf.hasTrailingPathSeparator.bind(t.$Yf),t.$dg=t.$Yf.removeTrailingPathSeparator.bind(t.$Yf),t.$eg=t.$Yf.addTrailingPathSeparator.bind(t.$Yf);function g(l,e){const a=[];for(let n=0;n<l.length;n++){const h=e(l[n]);l.some((s,v)=>v===n?!1:(0,t.$3f)(h,e(s)))||a.push(l[n])}return a}t.$fg=g;var L;(function(l){l.META_DATA_LABEL="label",l.META_DATA_DESCRIPTION="description",l.META_DATA_SIZE="size",l.META_DATA_MIME="mime";function e(a){const n=new Map;a.path.substring(a.path.indexOf(";")+1,a.path.lastIndexOf(";")).split(";").forEach(v=>{const[D,E]=v.split(":");D&&E&&n.set(D,E)});const s=a.path.substring(0,a.path.indexOf(";"));return s&&n.set(l.META_DATA_MIME,s),n}l.parseMetaData=e})(L||(t.DataUri=L={}));function r(l,e,a){if(e){let n=l.path;return n&&n[0]!==i.$5c.sep&&(n=i.$5c.sep+n),l.with({scheme:a,authority:e,path:n})}return l.with({scheme:a})}t.$gg=r}),define(be[9],$e([1,0,27,6,3,2,35,5,47]),function(re,t,N,O,i,j,A,y,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Sg=t.$Rg=t.$Qg=t.Promises=t.$Pg=t.$Og=t.$Ng=t.$Mg=t.$Lg=t.$Kg=t.$Jg=t.$Ig=t.$Hg=t.$Gg=t.$Fg=t.$Eg=t.$Dg=t.$Cg=t.$Bg=t.$Ag=t.$zg=t.$yg=t.$xg=t.$wg=t.$vg=t.$ug=t.$tg=t.$sg=t.$rg=t.$qg=t.$pg=t.$og=t.$ng=t.$mg=t.$lg=t.$kg=t.$jg=t.$ig=t.$hg=void 0;function u(d){return!!d&&typeof d.then=="function"}t.$hg=u;function g(d){const p=new N.$oc,H=d(p.token),Q=new Promise((q,x)=>{const W=p.token.onCancellationRequested(()=>{W.dispose(),p.dispose(),x(new O.$3)});Promise.resolve(H).then(c=>{W.dispose(),p.dispose(),q(c)},c=>{W.dispose(),p.dispose(),x(c)})});return new class{cancel(){p.cancel()}then(q,x){return Q.then(q,x)}catch(q){return this.then(void 0,q)}finally(q){return Q.finally(q)}}}t.$ig=g;function L(d,p,H){return new Promise((Q,q)=>{const x=p.onCancellationRequested(()=>{x.dispose(),Q(H)});d.then(Q,q).finally(()=>x.dispose())})}t.$jg=L;function r(d,p){return new Promise((H,Q)=>{const q=p.onCancellationRequested(()=>{q.dispose(),Q(new O.$3)});d.then(H,Q).finally(()=>q.dispose())})}t.$kg=r;async function l(d){let p=-1;const H=d.map((Q,q)=>Q.then(x=>(p=q,x)));try{return await Promise.race(H)}finally{d.forEach((Q,q)=>{q!==p&&Q.cancel()})}}t.$lg=l;function e(d,p,H){let Q;const q=setTimeout(()=>{Q?.(void 0),H?.()},p);return Promise.race([d.finally(()=>clearTimeout(q)),new Promise(x=>Q=x)])}t.$mg=e;function a(d){return new Promise((p,H)=>{const Q=d();u(Q)?Q.then(p,H):p(Q)})}t.$ng=a;class n{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(p){if(this.f)throw new Error("Throttler is disposed");if(this.a){if(this.d=p,!this.b){const H=()=>{if(this.b=null,this.f)return;const Q=this.queue(this.d);return this.d=null,Q};this.b=new Promise(Q=>{this.a.then(H,H).then(Q)})}return new Promise((H,Q)=>{this.b.then(H,Q)})}return this.a=p(),new Promise((H,Q)=>{this.a.then(q=>{this.a=null,H(q)},q=>{this.a=null,Q(q)})})}dispose(){this.f=!0}}t.$og=n;class h{constructor(){this.a=Promise.resolve(null)}queue(p){return this.a=this.a.then(()=>p(),()=>p())}}t.$pg=h;class s{constructor(){this.a=new Map}queue(p,H){const q=(this.a.get(p)??Promise.resolve()).catch(()=>{}).then(H).finally(()=>{this.a.get(p)===q&&this.a.delete(p)});return this.a.set(p,q),q}}t.$qg=s;const v=(d,p)=>{let H=!0;const Q=setTimeout(()=>{H=!1,p()},d);return{isTriggered:()=>H,dispose:()=>{clearTimeout(Q),H=!1}}},D=d=>{let p=!0;return queueMicrotask(()=>{p&&(p=!1,d())}),{isTriggered:()=>p,dispose:()=>{p=!1}}};class E{constructor(p){this.defaultDelay=p,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(p,H=this.defaultDelay){this.g=p,this.h(),this.b||(this.b=new Promise((q,x)=>{this.d=q,this.f=x}).then(()=>{if(this.b=null,this.d=null,this.g){const q=this.g;return this.g=null,q()}}));const Q=()=>{this.a=null,this.d?.(null)};return this.a=H===o.$bc?D(Q):v(H,Q),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new O.$3),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}t.$rg=E;class f{constructor(p){this.a=new E(p),this.b=new n}trigger(p,H){return this.a.trigger(()=>this.b.queue(p),H)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}t.$sg=f;class C{constructor(){this.a=!1,this.b=new Promise((p,H)=>{this.d=p})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}t.$tg=C;class T extends C{constructor(p){super(),this.f=setTimeout(()=>this.open(),p)}open(){clearTimeout(this.f),super.open()}}t.$ug=T;function P(d,p){return p?new Promise((H,Q)=>{const q=setTimeout(()=>{x.dispose(),H()},d),x=p.onCancellationRequested(()=>{clearTimeout(q),x.dispose(),Q(new O.$3)})}):g(H=>P(d,H))}t.$vg=P;function m(d,p=0){const H=setTimeout(d,p);return(0,j.$jb)(()=>clearTimeout(H))}t.$wg=m;function $(d){const p=[];let H=0;const Q=d.length;function q(){return H<Q?d[H++]():null}function x(W){W!=null&&p.push(W);const c=q();return c?c.then(x):Promise.resolve(p)}return Promise.resolve(null).then(x)}t.$xg=$;function F(d,p=Q=>!!Q,H=null){let Q=0;const q=d.length,x=()=>{if(Q>=q)return Promise.resolve(H);const W=d[Q++];return Promise.resolve(W()).then(k=>p(k)?Promise.resolve(k):x())};return x()}t.$yg=F;function R(d,p=Q=>!!Q,H=null){if(d.length===0)return Promise.resolve(H);let Q=d.length;const q=()=>{Q=-1;for(const x of d)x.cancel?.()};return new Promise((x,W)=>{for(const c of d)c.then(k=>{--Q>=0&&p(k)?(q(),x(k)):Q===0&&x(H)}).catch(k=>{--Q>=0&&(q(),W(k))})})}t.$zg=R;class B{constructor(p){this.a=0,this.d=p,this.f=[],this.b=0,this.g=new i.$ec}get onDrained(){return this.g.event}get size(){return this.a}queue(p){return this.a++,new Promise((H,Q)=>{this.f.push({factory:p,c:H,e:Q}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const p=this.f.shift();this.b++;const H=p.factory();H.then(p.c,p.e),H.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}t.$Ag=B;class M extends B{constructor(){super(1)}}t.$Bg=M;class z{constructor(){this.a=new Me,this.b=0}queue(p){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,p())):this.a.run(this.b++,p())}}t.$Cg=z;class te{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const p=new K;return this.b.add(p),p.p}d(){for(const[,p]of this.a)if(p.size>0)return!1;return!0}queueFor(p,H=A.$Yf){const Q=H.getComparisonKey(p);let q=this.a.get(Q);return q||(q=new M,i.Event.once(q.onDrained)(()=>{q?.dispose(),this.a.delete(Q),this.f()}),this.a.set(Q,q)),q}f(){this.d()&&this.g()}g(){for(const p of this.b)p.complete();this.b.clear()}dispose(){for(const[,p]of this.a)p.dispose();this.a.clear(),this.g()}}t.$Dg=te;class ne{constructor(p,H){this.a=-1,typeof p=="function"&&typeof H=="number"&&this.setIfNotSet(p,H)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(p,H){this.cancel(),this.a=setTimeout(()=>{this.a=-1,p()},H)}setIfNotSet(p,H){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,p()},H))}}t.$Eg=ne;class se{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(p,H){this.cancel(),this.a=setInterval(()=>{p()},H)}}t.$Fg=se;class ce{constructor(p,H){this.b=-1,this.a=p,this.d=H,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(p=this.d){this.cancel(),this.b=setTimeout(this.f,p)}get delay(){return this.d}set delay(p){this.d=p}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}t.$Gg=ce;class ue{constructor(p,H){H%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${H}ms is not a multiple of 1000ms.`),this.a=p,this.b=H,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(p=this.b){p%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${p}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(p/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}t.$Hg=ue;class ae extends ce{constructor(p,H){super(p,H),this.j=[]}work(p){this.j.push(p),this.isScheduled()||this.schedule()}h(){const p=this.j;this.j=[],this.a?.(p)}dispose(){this.j=[],super.dispose()}}t.$Ig=ae;class pe extends j.$lb{constructor(p,H){super(),this.g=p,this.h=H,this.a=[],this.b=this.B(new j.$mb),this.f=!1}get pending(){return this.a.length}work(p){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+p.length>this.g.maxBufferedWork)return!1}else if(this.pending+p.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const H of p)this.a.push(H);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ce(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}t.$Jg=pe,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?t.$Kg=d=>{(0,y.$A)(()=>{if(p)return;const H=Date.now()+15;d(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,H-Date.now())}}))});let p=!1;return{dispose(){p||(p=!0)}}}:t.$Kg=(d,p)=>{const H=requestIdleCallback(d,typeof p=="number"?{timeout:p}:void 0);let Q=!1;return{dispose(){Q||(Q=!0,cancelIdleCallback(H))}}}}();class Oe{constructor(p){this.d=!1,this.a=()=>{try{this.f=p()}catch(H){this.g=H}finally{this.d=!0}},this.b=(0,t.$Kg)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}t.$Lg=Oe;async function Te(d,p,H){let Q;for(let q=0;q<H;q++)try{return await d()}catch(x){Q=x,await P(p)}throw Q}t.$Mg=Te;class Me{isRunning(p){return typeof p=="number"?this.a?.taskId===p:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(p,H,Q){return this.a={taskId:p,cancel:()=>Q?.(),promise:H},H.then(()=>this.d(p),()=>this.d(p)),H}d(p){this.a&&p===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const p=this.b;this.b=void 0,p.run().then(p.promiseResolve,p.promiseReject)}}queue(p){if(this.b)this.b.run=p;else{let H,Q;const q=new Promise((x,W)=>{H=x,Q=W});this.b={run:p,promise:q,promiseResolve:H,promiseReject:Q}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}t.$Ng=Me;class fe{constructor(p,H=()=>Date.now()){this.d=p,this.f=H,this.a=0,this.b=0}increment(){const p=this.f();return p-this.a>this.d&&(this.a=p,this.b=0),this.b++,this.b}}t.$Og=fe;var ie;(function(d){d[d.Resolved=0]="Resolved",d[d.Rejected=1]="Rejected"})(ie||(ie={}));class K{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((p,H)=>{this.a=p,this.b=H})}complete(p){return new Promise(H=>{this.a(p),this.d={outcome:0,value:p},H()})}error(p){return new Promise(H=>{this.b(p),this.d={outcome:1,value:p},H()})}cancel(){return this.error(new O.$3)}}t.$Pg=K;var U;(function(d){async function p(Q){let q;const x=await Promise.all(Q.map(W=>W.then(c=>c,c=>{q||(q=c)})));if(typeof q<"u")throw q;return x}d.settled=p;function H(Q){return new Promise(async(q,x)=>{try{await Q(q,x)}catch(W){x(W)}})}d.withAsyncBody=H})(U||(t.Promises=U={}));var ee;(function(d){d[d.Initial=0]="Initial",d[d.DoneOK=1]="DoneOK",d[d.DoneError=2]="DoneError"})(ee||(ee={}));class J{static fromArray(p){return new J(H=>{H.emitMany(p)})}static fromPromise(p){return new J(async H=>{H.emitMany(await p)})}static fromPromises(p){return new J(async H=>{await Promise.all(p.map(async Q=>H.emitOne(await Q)))})}static merge(p){return new J(async H=>{await Promise.all(p.map(async Q=>{for await(const q of Q)H.emitOne(q)}))})}static{this.EMPTY=J.fromArray([])}constructor(p){this.a=0,this.b=[],this.d=null,this.f=new i.$ec,queueMicrotask(async()=>{const H={emitOne:Q=>this.g(Q),emitMany:Q=>this.h(Q),reject:Q=>this.k(Q)};try{await Promise.resolve(p(H)),this.j()}catch(Q){this.k(Q)}finally{H.emitOne=void 0,H.emitMany=void 0,H.reject=void 0}})}[Symbol.asyncIterator](){let p=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(p<this.b.length)return{done:!1,value:this.b[p++]};if(this.a===1)return{done:!0,value:void 0};await i.Event.toPromise(this.f.event)}while(!0)}}}static map(p,H){return new J(async Q=>{for await(const q of p)Q.emitOne(H(q))})}map(p){return J.map(this,p)}static filter(p,H){return new J(async Q=>{for await(const q of p)H(q)&&Q.emitOne(q)})}filter(p){return J.filter(this,p)}static coalesce(p){return J.filter(p,H=>!!H)}coalesce(){return J.coalesce(this)}static async toPromise(p){const H=[];for await(const Q of p)H.push(Q);return H}toPromise(){return J.toPromise(this)}g(p){this.a===0&&(this.b.push(p),this.f.fire())}h(p){this.a===0&&(this.b=this.b.concat(p),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(p){this.a===0&&(this.a=2,this.d=p,this.f.fire())}}t.$Qg=J;class S extends J{constructor(p,H){super(H),this.l=p}cancel(){this.l.cancel()}}t.$Rg=S;function _(d){const p=new N.$oc,H=d(p.token);return new S(p,async Q=>{const q=p.token.onCancellationRequested(()=>{q.dispose(),p.dispose(),Q.reject(new O.$3)});try{for await(const x of H){if(p.token.isCancellationRequested)return;Q.emitOne(x)}q.dispose(),p.dispose()}catch(x){q.dispose(),p.dispose(),Q.reject(x)}})}t.$Sg=_}),define(be[4],$e([1,0,16,110,14,19,9,6,3,114,2,28,5,15]),function(re,t,N,O,i,j,A,y,o,u,g,L,r,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.h=t.$gP=t.$fP=t.$eP=t.$dP=t.$cP=t.$bP=t.$aP=t.$_O=t.DetectedFullscreenMode=t.$$O=t.$0O=t.$9O=t.$8O=t.$7O=t.$6O=t.$5O=t.$4O=t.$3O=t.$2O=t.$1O=t.$ZO=t.$YO=t.$XO=t.$WO=t.$VO=t.$UO=t.$=t.Namespace=t.$SO=t.$RO=t.$QO=t.$PO=t.$OO=t.$NO=t.$MO=t.$LO=t.$KO=t.$JO=t.$IO=t.$HO=t.$GO=t.$FO=t.$EO=t.$DO=t.$CO=t.$BO=t.$AO=t.$zO=t.$yO=t.$xO=t.$wO=t.$vO=t.$uO=t.$tO=t.$sO=t.$rO=t.$qO=t.$pO=t.$oO=t.$nO=t.$mO=t.$lO=t.$kO=t.$jO=t.$iO=t.$hO=t.$gO=t.$fO=t.$eO=t.$dO=t.$cO=t.$bO=t.$aO=t.$_N=t.$$N=t.$0N=t.$9N=t.$8N=t.$7N=t.$6N=void 0;function e(X){for(;X.firstChild;)X.firstChild.remove()}t.$6N=e;function a(X){return X?.isConnected??!1}t.$7N=a;class n{constructor(Y,de,ke,Se){this.f=Y,this.g=de,this.d=ke,this.j=Se||!1,this.f.addEventListener(this.g,this.d,this.j)}dispose(){this.d&&(this.f.removeEventListener(this.g,this.d,this.j),this.f=null,this.d=null)}}function h(X,Y,de,ke){return new n(X,Y,de,ke)}t.$8N=h;function s(X){return function(Y){return X(new j.$ZN(Y))}}function v(X){return function(Y){return X(new i.$5N(Y))}}const D=function(Y,de,ke,Se){let qe=ke;return de==="click"||de==="mousedown"?qe=s(ke):(de==="keydown"||de==="keypress"||de==="keyup")&&(qe=v(ke)),h(Y,de,qe,Se)};t.$9N=D;const E=function(Y,de,ke){const Se=s(de);return C(Y,Se,ke)};t.$0N=E;const f=function(Y,de,ke){const Se=s(de);return P(Y,Se,ke)};t.$$N=f;function C(X,Y,de){return h(X,r.$q&&O.$XN.pointerEvents?t.$JO.POINTER_DOWN:t.$JO.MOUSE_DOWN,Y,de)}t.$_N=C;function T(X,Y,de){return h(X,r.$q&&O.$XN.pointerEvents?t.$JO.POINTER_MOVE:t.$JO.MOUSE_MOVE,Y,de)}t.$aO=T;function P(X,Y,de){return h(X,r.$q&&O.$XN.pointerEvents?t.$JO.POINTER_UP:t.$JO.MOUSE_UP,Y,de)}t.$bO=P;class m{constructor(Y,de=0){this.d=Y,this.priority=de,this.f=!1}dispose(){this.f=!0}execute(){if(!this.f)try{this.d()}catch(Y){(0,y.$Y)(Y)}}static sort(Y,de){return de.priority-Y.priority}}(function(){let X=[],Y=null,de=!1,ke=!1;const Se=()=>{for(de=!1,Y=X,X=[],ke=!0;Y.length>0;)Y.sort(m.sort),Y.shift().execute();ke=!1};t.$dO=(qe,ze=0)=>{const Ze=new m(qe,ze);return X.push(Ze),de||(de=!0,requestAnimationFrame(Se)),Ze},t.$cO=(qe,ze)=>{if(ke){const Ze=new m(qe,ze);return Y.push(Ze),Ze}else return(0,t.$dO)(qe,ze)}})();function $(X){return(0,t.$dO)(X,1e4)}t.$eO=$;function F(X){return(0,t.$dO)(X,-1e4)}t.$fO=F;const R=8,B=function(X,Y){return Y};class M extends g.$lb{constructor(Y,de,ke,Se=B,qe=R){super();let ze=null,Ze=0;const at=this.B(new A.$Eg),Je=()=>{Ze=new Date().getTime(),ke(ze),ze=null};this.B(h(Y,de,pt=>{ze=Se(ze,pt);const Ct=new Date().getTime()-Ze;Ct>=qe?(at.cancel(),Je()):at.setIfNotSet(Je,qe-Ct)}))}}function z(X,Y,de,ke,Se){return new M(X,Y,de,ke,Se)}t.$gO=z;function te(X){return document.defaultView.getComputedStyle(X,null)}t.$hO=te;function ne(X){if(X!==document.body)return new ce(X.clientWidth,X.clientHeight);if(r.$q&&window.visualViewport)return new ce(window.visualViewport.width,window.visualViewport.height);if(window.innerWidth&&window.innerHeight)return new ce(window.innerWidth,window.innerHeight);if(document.body&&document.body.clientWidth&&document.body.clientHeight)return new ce(document.body.clientWidth,document.body.clientHeight);if(document.documentElement&&document.documentElement.clientWidth&&document.documentElement.clientHeight)return new ce(document.documentElement.clientWidth,document.documentElement.clientHeight);throw new Error("Unable to figure out browser width and height")}t.$iO=ne;class se{static d(Y,de){return parseFloat(de)||0}static f(Y,de,ke){const Se=te(Y),qe=Se?Se.getPropertyValue(de):"0";return se.d(Y,qe)}static getBorderLeftWidth(Y){return se.f(Y,"border-left-width","borderLeftWidth")}static getBorderRightWidth(Y){return se.f(Y,"border-right-width","borderRightWidth")}static getBorderTopWidth(Y){return se.f(Y,"border-top-width","borderTopWidth")}static getBorderBottomWidth(Y){return se.f(Y,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(Y){return se.f(Y,"padding-left","paddingLeft")}static getPaddingRight(Y){return se.f(Y,"padding-right","paddingRight")}static getPaddingTop(Y){return se.f(Y,"padding-top","paddingTop")}static getPaddingBottom(Y){return se.f(Y,"padding-bottom","paddingBottom")}static getMarginLeft(Y){return se.f(Y,"margin-left","marginLeft")}static getMarginTop(Y){return se.f(Y,"margin-top","marginTop")}static getMarginRight(Y){return se.f(Y,"margin-right","marginRight")}static getMarginBottom(Y){return se.f(Y,"margin-bottom","marginBottom")}}class ce{static{this.None=new ce(0,0)}constructor(Y,de){this.width=Y,this.height=de}with(Y=this.width,de=this.height){return Y!==this.width||de!==this.height?new ce(Y,de):this}static is(Y){return typeof Y=="object"&&typeof Y.height=="number"&&typeof Y.width=="number"}static lift(Y){return Y instanceof ce?Y:new ce(Y.width,Y.height)}static equals(Y,de){return Y===de?!0:!Y||!de?!1:Y.width===de.width&&Y.height===de.height}}t.$jO=ce;function ue(X){let Y=X.offsetParent,de=X.offsetTop,ke=X.offsetLeft;for(;(X=X.parentNode)!==null&&X!==document.body&&X!==document.documentElement;){de-=X.scrollTop;const Se=x(X)?null:te(X);Se&&(ke-=Se.direction!=="rtl"?X.scrollLeft:-X.scrollLeft),X===Y&&(ke+=se.getBorderLeftWidth(X),de+=se.getBorderTopWidth(X),de+=X.offsetTop,ke+=X.offsetLeft,Y=X.offsetParent)}return{left:ke,top:de}}t.$kO=ue;function ae(X,Y,de){typeof Y=="number"&&(X.style.width=`${Y}px`),typeof de=="number"&&(X.style.height=`${de}px`)}t.$lO=ae;function pe(X,Y,de,ke,Se,qe="absolute"){typeof Y=="number"&&(X.style.top=`${Y}px`),typeof de=="number"&&(X.style.right=`${de}px`),typeof ke=="number"&&(X.style.bottom=`${ke}px`),typeof Se=="number"&&(X.style.left=`${Se}px`),X.style.position=qe}t.$mO=pe;function Oe(X){const Y=X.getBoundingClientRect();return{left:Y.left+window.scrollX,top:Y.top+window.scrollY,width:Y.width,height:Y.height}}t.$nO=Oe;function Te(X){let Y=X,de=1;do{const ke=te(Y).zoom;ke!=null&&ke!=="1"&&(de*=ke),Y=Y.parentElement}while(Y!==null&&Y!==document.documentElement);return de}t.$oO=Te;function Me(X){const Y=se.getMarginLeft(X)+se.getMarginRight(X);return X.offsetWidth+Y}t.$pO=Me;function fe(X){const Y=se.getBorderLeftWidth(X)+se.getBorderRightWidth(X),de=se.getPaddingLeft(X)+se.getPaddingRight(X);return X.offsetWidth-Y-de}t.$qO=fe;function ie(X){const Y=se.getMarginLeft(X)+se.getMarginRight(X);return X.scrollWidth+Y}t.$rO=ie;function K(X){const Y=se.getBorderTopWidth(X)+se.getBorderBottomWidth(X),de=se.getPaddingTop(X)+se.getPaddingBottom(X);return X.offsetHeight-Y-de}t.$sO=K;function U(X){const Y=se.getMarginTop(X)+se.getMarginBottom(X);return X.offsetHeight+Y}t.$tO=U;function ee(X,Y){if(X===null)return 0;const de=ue(X),ke=ue(Y);return de.left-ke.left}function J(X,Y){const de=Y.map(Se=>Math.max(ie(Se),Me(Se))+ee(Se,X)||0);return Math.max(...de)}t.$uO=J;function S(X,Y){for(;X;){if(X===Y)return!0;X=X.parentNode}return!1}t.$vO=S;const _="parentFlowToElementId";function d(X,Y){X.dataset[_]=Y.id}t.$wO=d;function p(X){const Y=X.dataset[_];return typeof Y=="string"?document.getElementById(Y):null}function H(X,Y){let de=X;for(;de;){if(de===Y)return!0;if(de instanceof HTMLElement){const ke=p(de);if(ke){de=ke;continue}}de=de.parentNode}return!1}t.$xO=H;function Q(X,Y,de){for(;X&&X.nodeType===X.ELEMENT_NODE;){if(X.classList.contains(Y))return X;if(de){if(typeof de=="string"){if(X.classList.contains(de))return null}else if(X===de)return null}X=X.parentNode}return null}t.$yO=Q;function q(X,Y,de){return!!Q(X,Y,de)}t.$zO=q;function x(X){return X&&!!X.host&&!!X.mode}t.$AO=x;function W(X){return!!c(X)}t.$BO=W;function c(X){for(;X.parentNode;){if(X===document.body)return null;X=X.parentNode}return x(X)?X:null}t.$CO=c;function k(){let X=document.activeElement;for(;X?.shadowRoot;)X=X.shadowRoot.activeElement;return X}t.$DO=k;function b(X=document.getElementsByTagName("head")[0],Y){const de=document.createElement("style");return de.type="text/css",de.media="screen",Y?.(de),X.appendChild(de),de}t.$EO=b;function w(X=document.getElementsByTagName("head")[0]){const Y=document.createElement("meta");return X.appendChild(Y),Y}t.$FO=w;let I=null;function V(){return I||(I=b()),I}function Z(X){return X?.sheet?.rules?X.sheet.rules:X?.sheet?.cssRules?X.sheet.cssRules:[]}function oe(X,Y,de=V()){!de||!Y||de.sheet.insertRule(X+"{"+Y+"}",0)}t.$GO=oe;function ge(X,Y=V()){if(!Y)return;const de=Z(Y),ke=[];for(let Se=0;Se<de.length;Se++)de[Se].selectorText.indexOf(X)!==-1&&ke.push(Se);for(let Se=ke.length-1;Se>=0;Se--)Y.sheet.deleteRule(ke[Se])}t.$HO=ge;function we(X){return typeof HTMLElement=="object"?X instanceof HTMLElement:X&&typeof X=="object"&&X.nodeType===1&&typeof X.nodeName=="string"}t.$IO=we,t.$JO={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:N.$PN?"webkitAnimationStart":"animationstart",ANIMATION_END:N.$PN?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:N.$PN?"webkitAnimationIteration":"animationiteration"};function Ae(X){const Y=X;return!!(Y&&typeof Y.preventDefault=="function"&&typeof Y.stopPropagation=="function")}t.$KO=Ae,t.$LO={stop:(X,Y)=>(X.preventDefault(),Y&&X.stopPropagation(),X)};function Ee(X){const Y=[];for(let de=0;X&&X.nodeType===X.ELEMENT_NODE;de++)Y[de]=X.scrollTop,X=X.parentNode;return Y}t.$MO=Ee;function ve(X,Y){for(let de=0;X&&X.nodeType===X.ELEMENT_NODE;de++)X.scrollTop!==Y[de]&&(X.scrollTop=Y[de]),X=X.parentNode}t.$NO=ve;class Le extends g.$lb{static l(Y){const de=c(Y),ke=de?de.activeElement:document.activeElement;return S(ke,Y)}constructor(Y){super(),this.f=this.B(new o.$ec),this.onDidFocus=this.f.event,this.g=this.B(new o.$ec),this.onDidBlur=this.g.event;let de=Le.l(Y),ke=!1;const Se=()=>{ke=!1,de||(de=!0,this.f.fire())},qe=()=>{de&&(ke=!0,window.setTimeout(()=>{ke&&(ke=!1,de=!1,this.g.fire())},0))};this.j=()=>{Le.l(Y)!==de&&(de?qe():Se())},this.B(h(Y,t.$JO.FOCUS,Se,!0)),this.B(h(Y,t.$JO.BLUR,qe,!0)),this.B(h(Y,t.$JO.FOCUS_IN,()=>this.j())),this.B(h(Y,t.$JO.FOCUS_OUT,()=>this.j()))}refreshState(){this.j()}}function Fe(X){return new Le(X)}t.$OO=Fe;function Ke(X,Y){return X.after(Y),Y}t.$PO=Ke;function je(X,...Y){if(X.append(...Y),Y.length===1&&typeof Y[0]!="string")return Y[0]}t.$QO=je;function Ie(X,Y){return X.insertBefore(Y,X.firstChild),Y}t.$RO=Ie;function Ge(X,...Y){X.innerText="",je(X,...Y)}t.$SO=Ge;const G=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var le;(function(X){X.HTML="http://www.w3.org/1999/xhtml",X.SVG="http://www.w3.org/2000/svg"})(le||(t.Namespace=le={}));function me(X,Y,de,...ke){const Se=G.exec(Y);if(!Se)throw new Error("Bad use of emmet");const qe=Se[1]||"div";let ze;return X!==le.HTML?ze=document.createElementNS(X,qe):ze=document.createElement(qe),Se[3]&&(ze.id=Se[3]),Se[4]&&(ze.className=Se[4].replace(/\./g," ").trim()),de&&Object.entries(de).forEach(([Ze,at])=>{typeof at>"u"||(/^on\w+$/.test(Ze)?ze[Ze]=at:Ze==="selected"?at&&ze.setAttribute(Ze,"true"):ze.setAttribute(Ze,at))}),ze.append(...ke),ze}function De(X,Y,...de){return me(le.HTML,X,Y,...de)}t.$=De,De.SVG=function(X,Y,...de){return me(le.SVG,X,Y,...de)};function Ce(X,Y){const de=[];return X.forEach((ke,Se)=>{Se>0&&(Y instanceof Node?de.push(Y.cloneNode()):de.push(document.createTextNode(Y))),de.push(ke)}),de}t.$UO=Ce;function Re(X,...Y){X?He(...Y):Ye(...Y)}t.$VO=Re;function He(...X){for(const Y of X)Y.style.display="",Y.removeAttribute("aria-hidden")}t.$WO=He;function Ye(...X){for(const Y of X)Y.style.display="none",Y.setAttribute("aria-hidden","true")}t.$XO=Ye;function Qe(X,Y){for(;X&&X.nodeType===X.ELEMENT_NODE;){if(X instanceof HTMLElement&&X.hasAttribute(Y))return X;X=X.parentNode}return null}function We(X){!X||!X.hasAttribute("tabIndex")||(document.activeElement===X&&Qe(X.parentElement,"tabIndex")?.focus(),X.removeAttribute("tabindex"))}t.$YO=We;function _e(X){return Y=>{Y.preventDefault(),Y.stopPropagation(),X(Y)}}t.$ZO=_e;function et(){return new Promise(X=>{document.readyState==="complete"||document&&document.body!==null?X(void 0):window.addEventListener("DOMContentLoaded",X,!1)})}t.$1O=et;function it(X){const Y=window.devicePixelRatio*X;return Math.max(1,Math.floor(Y))/window.devicePixelRatio}t.$2O=it;function ft(X){window.open(X,"_blank","noopener")}t.$3O=ft;const ct=780,ot=640;function yt(X){const Y=Math.floor(window.screenLeft+window.innerWidth/2-ct/2),de=Math.floor(window.screenTop+window.innerHeight/2-ot/2);window.open(X,"_blank",`width=${ct},height=${ot},top=${de},left=${Y}`)}t.$4O=yt;function Et(X,Y=!0){const de=window.open();return de?(Y&&(de.opener=null),de.location.href=X,!0):!1}t.$5O=Et;function At(X){const Y=()=>{X(),de=(0,t.$dO)(Y)};let de=(0,t.$dO)(Y);return(0,g.$jb)(()=>de.dispose())}t.$6O=At,L.$Ve.setPreferredWebSchema(/^https:/.test(window.location.href)?"https":"http");function kt(X){return X?`url('${L.$1e.uriToBrowserUri(X).toString(!0).replace(/'/g,"%27")}')`:"url('')"}t.$7O=kt;function Rt(X){return`'${X.replace(/'/g,"%27")}'`}t.$8O=Rt;function Pe(X,Y){if(X!==void 0){const de=X.match(/^\s*var\((.+)\)$/);if(de){const ke=de[1].split(",",2);return ke.length===2&&(Y=Pe(ke[1].trim(),Y)),`var(${ke[0]}, ${Y})`}return X}return Y}t.$9O=Pe;function he(X,Y){let de;if(l.URI.isUri(X))de=X.toString(!0);else{const Se=new Blob([X]);de=URL.createObjectURL(Se),setTimeout(()=>URL.revokeObjectURL(de))}const ke=document.createElement("a");document.body.appendChild(ke),ke.download=Y,ke.href=de,ke.click(),setTimeout(()=>document.body.removeChild(ke))}t.$0O=he;function ye(){return new Promise(X=>{const Y=document.createElement("input");document.body.appendChild(Y),Y.type="file",Y.multiple=!0,o.Event.once(o.Event.fromDOMEventEmitter(Y,"input"))(()=>{X(Y.files??void 0)}),Y.click(),setTimeout(()=>document.body.removeChild(Y))})}t.$$O=ye;var Ne;(function(X){X[X.DOCUMENT=1]="DOCUMENT",X[X.BROWSER=2]="BROWSER"})(Ne||(t.DetectedFullscreenMode=Ne={}));function Ue(){return document.fullscreenElement||document.webkitFullscreenElement||document.webkitIsFullScreen?{mode:Ne.DOCUMENT,guess:!1}:window.innerHeight===screen.height?{mode:Ne.BROWSER,guess:!1}:(r.$j||r.$k)&&window.outerHeight===screen.height&&window.outerWidth===screen.width?{mode:Ne.BROWSER,guess:!0}:null}t.$_O=Ue;function Xe(X,Y=!1){const de=document.createElement("a");return u.addHook("afterSanitizeAttributes",ke=>{for(const Se of["href","src"])if(ke.hasAttribute(Se)){const qe=ke.getAttribute(Se);if(Se==="href"&&qe.startsWith("#"))continue;if(de.href=qe,!X.includes(de.protocol.replace(/:$/,""))){if(Y&&Se==="src"&&de.href.startsWith("data:"))continue;ke.removeAttribute(Se)}}}),(0,g.$jb)(()=>{u.removeHook("afterSanitizeAttributes")})}t.$aP=Xe;const nt=[L.Schemas.http,L.Schemas.https,L.Schemas.command];t.$bP=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","source","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const Ve=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type","start"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function lt(X,Y){const de=Xe(nt);try{const ke=u.sanitize(Y,Ve);X.innerHTML=ke}finally{de.dispose()}}t.$cP=lt;function $t(X){const Y=new Uint16Array(X.length);for(let Se=0;Se<Y.length;Se++)Y[Se]=X.charCodeAt(Se);let de="";const ke=new Uint8Array(Y.buffer);for(let Se=0;Se<ke.length;Se++)de+=String.fromCharCode(ke[Se]);return de}function Nt(X){return btoa($t(X))}t.$dP=Nt;class dt extends o.$ec{constructor(){super(),this.s=new g.$kb,this.y={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this.s.add(h(window,"keydown",Y=>{if(Y.defaultPrevented)return;const de=new i.$5N(Y);if(!(de.keyCode===6&&Y.repeat)){if(Y.altKey&&!this.y.altKey)this.y.lastKeyPressed="alt";else if(Y.ctrlKey&&!this.y.ctrlKey)this.y.lastKeyPressed="ctrl";else if(Y.metaKey&&!this.y.metaKey)this.y.lastKeyPressed="meta";else if(Y.shiftKey&&!this.y.shiftKey)this.y.lastKeyPressed="shift";else if(de.keyCode!==6)this.y.lastKeyPressed=void 0;else return;this.y.altKey=Y.altKey,this.y.ctrlKey=Y.ctrlKey,this.y.metaKey=Y.metaKey,this.y.shiftKey=Y.shiftKey,this.y.lastKeyPressed&&(this.y.event=Y,this.fire(this.y))}},!0)),this.s.add(h(window,"keyup",Y=>{Y.defaultPrevented||(!Y.altKey&&this.y.altKey?this.y.lastKeyReleased="alt":!Y.ctrlKey&&this.y.ctrlKey?this.y.lastKeyReleased="ctrl":!Y.metaKey&&this.y.metaKey?this.y.lastKeyReleased="meta":!Y.shiftKey&&this.y.shiftKey?this.y.lastKeyReleased="shift":this.y.lastKeyReleased=void 0,this.y.lastKeyPressed!==this.y.lastKeyReleased&&(this.y.lastKeyPressed=void 0),this.y.altKey=Y.altKey,this.y.ctrlKey=Y.ctrlKey,this.y.metaKey=Y.metaKey,this.y.shiftKey=Y.shiftKey,this.y.lastKeyReleased&&(this.y.event=Y,this.fire(this.y)))},!0)),this.s.add(h(document.body,"mousedown",()=>{this.y.lastKeyPressed=void 0},!0)),this.s.add(h(document.body,"mouseup",()=>{this.y.lastKeyPressed=void 0},!0)),this.s.add(h(document.body,"mousemove",Y=>{Y.buttons&&(this.y.lastKeyPressed=void 0)},!0)),this.s.add(h(window,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this.y}get isModifierPressed(){return this.y.altKey||this.y.ctrlKey||this.y.metaKey||this.y.shiftKey}resetKeyStatus(){this.A(),this.fire(this.y)}A(){this.y={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return dt.z||(dt.z=new dt),dt.z}dispose(){super.dispose(),this.s.dispose()}}t.$eP=dt;function $i(X){const Y=document.cookie.match("(^|[^;]+)\\s*"+X+"\\s*=\\s*([^;]+)");return Y?Y.pop():void 0}t.$fP=$i;class pi extends g.$lb{constructor(Y,de){super(),this.j=Y,this.l=de,this.f=0,this.g=0,this.m()}m(){this.B(h(this.j,t.$JO.DRAG_ENTER,Y=>{this.f++,this.g=Y.timeStamp,this.l.onDragEnter(Y)})),this.B(h(this.j,t.$JO.DRAG_OVER,Y=>{Y.preventDefault(),this.l.onDragOver?.(Y,Y.timeStamp-this.g)})),this.B(h(this.j,t.$JO.DRAG_LEAVE,Y=>{this.f--,this.f===0&&(this.g=0,this.l.onDragLeave(Y))})),this.B(h(this.j,t.$JO.DRAG_END,Y=>{this.f=0,this.g=0,this.l.onDragEnd(Y)})),this.B(h(this.j,t.$JO.DROP,Y=>{this.f=0,this.g=0,this.l.onDrop(Y)}))}}t.$gP=pi;const wi=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function vi(X,...Y){let de,ke;Array.isArray(Y[0])?(de={},ke=Y[0]):(de=Y[0]||{},ke=Y[1]);const Se=wi.exec(X);if(!Se||!Se.groups)throw new Error("Bad use of h");const qe=Se.groups.tag||"div",ze=document.createElement(qe);Se.groups.id&&(ze.id=Se.groups.id);const Ze=[];if(Se.groups.class)for(const Je of Se.groups.class.split("."))Je!==""&&Ze.push(Je);if(de.className!==void 0)for(const Je of de.className.split("."))Je!==""&&Ze.push(Je);Ze.length>0&&(ze.className=Ze.join(" "));const at={};if(Se.groups.name&&(at[Se.groups.name]=ze),ke)for(const Je of ke)Je instanceof HTMLElement?ze.appendChild(Je):typeof Je=="string"?ze.append(Je):"root"in Je&&(Object.assign(at,Je),ze.appendChild(Je.root));for(const[Je,pt]of Object.entries(de))if(Je!=="className")if(Je==="style")for(const[Ct,Mt]of Object.entries(pt))ze.style.setProperty(Gt(Ct),typeof Mt=="number"?Mt+"px":""+Mt);else Je==="tabIndex"?ze.tabIndex=pt:ze.setAttribute(Gt(Je),pt.toString());return at.root=ze,at}t.h=vi;function Gt(X){return X.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}}),define(be[51],$e([1,0,4,2,113]),function(re,t,N,O,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kP=t.$jP=t.$iP=void 0;class j extends O.$lb{constructor(o,u){super(),this.B((0,N.$8N)(o,"dragover",g=>{g.preventDefault(),this.a||(this.a=setTimeout(()=>{u(),this.a=null},800))})),["dragleave","drop","dragend"].forEach(g=>{this.B((0,N.$8N)(o,g,()=>{this.b()}))})}b(){this.a&&(clearTimeout(this.a),this.a=null)}dispose(){super.dispose(),this.b()}}t.$iP=j,t.$jP={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:i.$yr.text,INTERNAL_URI_LIST:"application/vnd.code.uri-list"};function A(y,o,u,g,L){const r=document.createElement("div");r.className=u,r.textContent=o,L&&(r.style.color=L),g&&(r.style.background=g),y.dataTransfer&&(document.body.appendChild(r),y.dataTransfer.setDragImage(r,-10,-10),setTimeout(()=>document.body.removeChild(r),0))}t.$kP=A}),define(be[52],$e([1,0,4]),function(re,t,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$OP=t.$NP=t.$MP=void 0;function O(r,l={}){const e=j(l);return e.textContent=r,e}t.$MP=O;function i(r,l={}){const e=j(l);return o(e,u(r,!!l.renderCodeSegments),l.actionHandler,l.renderCodeSegments),e}t.$NP=i;function j(r){const l=r.inline?"span":"div",e=document.createElement(l);return r.className&&(e.className=r.className),e}t.$OP=j;class A{constructor(l){this.b=l,this.c=0}eos(){return this.c>=this.b.length}next(){const l=this.peek();return this.advance(),l}peek(){return this.b[this.c]}advance(){this.c++}}var y;(function(r){r[r.Invalid=0]="Invalid",r[r.Root=1]="Root",r[r.Text=2]="Text",r[r.Bold=3]="Bold",r[r.Italics=4]="Italics",r[r.Action=5]="Action",r[r.ActionClose=6]="ActionClose",r[r.Code=7]="Code",r[r.NewLine=8]="NewLine"})(y||(y={}));function o(r,l,e,a){let n;if(l.type===2)n=document.createTextNode(l.content||"");else if(l.type===3)n=document.createElement("b");else if(l.type===4)n=document.createElement("i");else if(l.type===7&&a)n=document.createElement("code");else if(l.type===5&&e){const h=document.createElement("a");e.disposables.add(N.$9N(h,"click",s=>{e.callback(String(l.index),s)})),n=h}else l.type===8?n=document.createElement("br"):l.type===1&&(n=r);n&&r!==n&&r.appendChild(n),n&&Array.isArray(l.children)&&l.children.forEach(h=>{o(n,h,e,a)})}function u(r,l){const e={type:1,children:[]};let a=0,n=e;const h=[],s=new A(r);for(;!s.eos();){let v=s.next();const D=v==="\\"&&L(s.peek(),l)!==0;if(D&&(v=s.next()),!D&&g(v,l)&&v===s.peek()){s.advance(),n.type===2&&(n=h.pop());const E=L(v,l);if(n.type===E||n.type===5&&E===6)n=h.pop();else{const f={type:E,children:[]};E===5&&(f.index=a,a++),n.children.push(f),h.push(n),n=f}}else if(v===`
`)n.type===2&&(n=h.pop()),n.children.push({type:8});else if(n.type!==2){const E={type:2,content:v};n.children.push(E),h.push(n),n=E}else n.content+=v}return n.type===2&&(n=h.pop()),h.length,e}function g(r,l){return L(r,l)!==0}function L(r,l){switch(r){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return l?7:0;default:return 0}}}),define(be[53],$e([1,0,4,2]),function(re,t,N,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oP=void 0;class i{constructor(){this.a=new O.$kb,this.b=null,this.c=null}dispose(){this.stopMonitoring(!1),this.a.dispose()}stopMonitoring(A,y){if(!this.isMonitoring())return;this.a.clear(),this.b=null;const o=this.c;this.c=null,A&&o&&o(y)}isMonitoring(){return!!this.b}startMonitoring(A,y,o,u,g){this.isMonitoring()&&this.stopMonitoring(!1),this.b=u,this.c=g;let L=A;try{A.setPointerCapture(y),this.a.add((0,O.$jb)(()=>{try{A.releasePointerCapture(y)}catch{}}))}catch{L=window}this.a.add(N.$8N(L,N.$JO.POINTER_MOVE,r=>{if(r.buttons!==o){this.stopMonitoring(!0);return}r.preventDefault(),this.b(r)})),this.a.add(N.$8N(L,N.$JO.POINTER_UP,r=>this.stopMonitoring(!0)))}}t.$oP=i});var xe=this&&this.__decorate||function(re,t,N,O){var i=arguments.length,j=i<3?t:O===null?O=Object.getOwnPropertyDescriptor(t,N):O,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")j=Reflect.decorate(re,t,N,O);else for(var y=re.length-1;y>=0;y--)(A=re[y])&&(j=(i<3?A(j):i>3?A(t,N,j):A(t,N))||j);return i>3&&j&&Object.defineProperty(t,N,j),j};define(be[23],$e([1,0,4,13,25,2,43]),function(re,t,N,O,i,j,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lP=t.EventType=void 0;var y;(function(u){u.Tap="-monaco-gesturetap",u.Change="-monaco-gesturechange",u.Start="-monaco-gesturestart",u.End="-monaco-gesturesend",u.Contextmenu="-monaco-gesturecontextmenu"})(y||(t.EventType=y={}));class o extends j.$lb{static{this.a=-.005}static{this.c=700}static{this.m=400}constructor(){super(),this.f=!1,this.g=new A.$ub,this.h=new A.$ub,this.k={},this.j=null,this.l=0,this.B(N.$8N(document,"touchstart",g=>this.n(g),{passive:!1})),this.B(N.$8N(document,"touchend",g=>this.p(g))),this.B(N.$8N(document,"touchmove",g=>this.v(g),{passive:!1}))}static addTarget(g){if(!o.isTouchDevice())return j.$lb.None;o.b||(o.b=new o);const L=o.b.g.push(g);return(0,j.$jb)(L)}static ignoreTarget(g){if(!o.isTouchDevice())return j.$lb.None;o.b||(o.b=new o);const L=o.b.h.push(g);return(0,j.$jb)(L)}static isTouchDevice(){return"ontouchstart"in window||navigator.maxTouchPoints>0}dispose(){this.j&&(this.j.dispose(),this.j=null),super.dispose()}n(g){const L=Date.now();this.j&&(this.j.dispose(),this.j=null);for(let r=0,l=g.targetTouches.length;r<l;r++){const e=g.targetTouches.item(r);this.k[e.identifier]={id:e.identifier,initialTarget:e.target,initialTimeStamp:L,initialPageX:e.pageX,initialPageY:e.pageY,rollingTimestamps:[L],rollingPageX:[e.pageX],rollingPageY:[e.pageY]};const a=this.r(y.Start,e.target);a.pageX=e.pageX,a.pageY=e.pageY,this.s(a)}this.f&&(g.preventDefault(),g.stopPropagation(),this.f=!1)}p(g){const L=Date.now(),r=Object.keys(this.k).length;for(let l=0,e=g.changedTouches.length;l<e;l++){const a=g.changedTouches.item(l);if(!this.k.hasOwnProperty(String(a.identifier))){console.warn("move of an UNKNOWN touch",a);continue}const n=this.k[a.identifier],h=Date.now()-n.initialTimeStamp;if(h<o.c&&Math.abs(n.initialPageX-O.$9e(n.rollingPageX))<30&&Math.abs(n.initialPageY-O.$9e(n.rollingPageY))<30){const s=this.r(y.Tap,n.initialTarget);s.pageX=O.$9e(n.rollingPageX),s.pageY=O.$9e(n.rollingPageY),this.s(s)}else if(h>=o.c&&Math.abs(n.initialPageX-O.$9e(n.rollingPageX))<30&&Math.abs(n.initialPageY-O.$9e(n.rollingPageY))<30){const s=this.r(y.Contextmenu,n.initialTarget);s.pageX=O.$9e(n.rollingPageX),s.pageY=O.$9e(n.rollingPageY),this.s(s)}else if(r===1){const s=O.$9e(n.rollingPageX),v=O.$9e(n.rollingPageY),D=O.$9e(n.rollingTimestamps)-n.rollingTimestamps[0],E=s-n.rollingPageX[0],f=v-n.rollingPageY[0],C=[...this.g].filter(T=>n.initialTarget instanceof Node&&T.contains(n.initialTarget));this.u(C,L,Math.abs(E)/D,E>0?1:-1,s,Math.abs(f)/D,f>0?1:-1,v)}this.s(this.r(y.End,n.initialTarget)),delete this.k[a.identifier]}this.f&&(g.preventDefault(),g.stopPropagation(),this.f=!1)}r(g,L){const r=document.createEvent("CustomEvent");return r.initEvent(g,!1,!0),r.initialTarget=L,r.tapCount=0,r}s(g){if(g.type===y.Tap){const L=new Date().getTime();let r=0;L-this.l>o.m?r=1:r=2,this.l=L,g.tapCount=r}else(g.type===y.Change||g.type===y.Contextmenu)&&(this.l=0);if(g.initialTarget instanceof Node){for(const L of this.h)if(L.contains(g.initialTarget))return;for(const L of this.g)L.contains(g.initialTarget)&&(L.dispatchEvent(g),this.f=!0)}}u(g,L,r,l,e,a,n,h){this.j=N.$dO(()=>{const s=Date.now(),v=s-L;let D=0,E=0,f=!0;r+=o.a*v,a+=o.a*v,r>0&&(f=!1,D=l*r*v),a>0&&(f=!1,E=n*a*v);const C=this.r(y.Change);C.translationX=D,C.translationY=E,g.forEach(T=>T.dispatchEvent(C)),f||this.u(g,s,r,l,e+D,a,n,h+E)})}v(g){const L=Date.now();for(let r=0,l=g.changedTouches.length;r<l;r++){const e=g.changedTouches.item(r);if(!this.k.hasOwnProperty(String(e.identifier))){console.warn("end of an UNKNOWN touch",e);continue}const a=this.k[e.identifier],n=this.r(y.Change,a.initialTarget);n.translationX=e.pageX-O.$9e(a.rollingPageX),n.translationY=e.pageY-O.$9e(a.rollingPageY),n.pageX=e.pageX,n.pageY=e.pageY,this.s(n),a.rollingPageX.length>3&&(a.rollingPageX.shift(),a.rollingPageY.shift(),a.rollingTimestamps.shift()),a.rollingPageX.push(e.pageX),a.rollingPageY.push(e.pageY),a.rollingTimestamps.push(L)}this.f&&(g.preventDefault(),g.stopPropagation(),this.f=!1)}}t.$lP=o,xe([i.$Tg],o,"isTouchDevice",null)}),define(be[54],$e([1,0,4,88]),function(re,t,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$SP=t.$RP=t.$QP=void 0;const O=2e4;let i,j,A,y,o;function u(l){i=document.createElement("div"),i.className="monaco-aria-container";const e=()=>{const n=document.createElement("div");return n.className="monaco-alert",n.setAttribute("role","alert"),n.setAttribute("aria-atomic","true"),i.appendChild(n),n};j=e(),A=e();const a=()=>{const n=document.createElement("div");return n.className="monaco-status",n.setAttribute("aria-live","polite"),n.setAttribute("aria-atomic","true"),i.appendChild(n),n};y=a(),o=a(),l.appendChild(i)}t.$QP=u;function g(l){i&&(j.textContent!==l?(N.$6N(A),r(j,l)):(N.$6N(j),r(A,l)))}t.$RP=g;function L(l){i&&(y.textContent!==l?(N.$6N(o),r(y,l)):(N.$6N(y),r(o,l)))}t.$SP=L;function r(l,e){N.$6N(l),e.length>O&&(e=e.substr(0,O)),l.textContent=e,l.style.visibility="hidden",l.style.visibility="visible"}}),define(be[115],$e([1,0,4,18]),function(re,t,N,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fQ=t.$eQ=void 0;const i=new RegExp(`(\\\\)?\\$\\((${O.ThemeIcon.iconNameExpression}(?:${O.ThemeIcon.iconModifierExpression})?)\\)`,"g");function j(y){const o=new Array;let u,g=0,L=0;for(;(u=i.exec(y))!==null;){L=u.index||0,g<L&&o.push(y.substring(g,L)),g=(u.index||0)+u[0].length;const[,r,l]=u;o.push(r?`$(${l})`:A({id:l}))}return g<y.length&&o.push(y.substring(g)),o}t.$eQ=j;function A(y){const o=N.$("span");return o.classList.add(...O.ThemeIcon.asClassNameArray(y)),o}t.$fQ=A}),define(be[116],$e([1,0,4]),function(re,t,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2P=void 0;function O(j){try{j.parentElement?.removeChild(j)}catch{}}class i{constructor(A){this.d=A,this.a=new Map,this.b=new Set,this.c=!1}alloc(A){let y=this.h(A).pop(),o=!1;if(y)o=this.b.has(y.domNode),o&&this.b.delete(y.domNode);else{const u=(0,N.$)(".monaco-list-row"),L=this.i(A).renderTemplate(u);y={domNode:u,templateId:A,templateData:L}}return{row:y,isReusingConnectedDomNode:o}}release(A){A&&this.f(A)}transact(A){if(this.c)throw new Error("Already in transaction");this.c=!0;try{A()}finally{for(const y of this.b)this.g(y);this.b.clear(),this.c=!1}}f(A){const{domNode:y,templateId:o}=A;y&&(this.c?this.b.add(y):this.g(y)),this.h(o).push(A)}g(A){A.classList.remove("scrolling"),O(A)}h(A){let y=this.a.get(A);return y||(y=[],this.a.set(A,y)),y}dispose(){this.a.forEach((A,y)=>{for(const o of A)this.i(y).disposeTemplate(o.templateData),o.templateData=null}),this.a.clear(),this.b.clear()}i(A){const y=this.d.get(A);if(!y)throw new Error(`No renderer found for ${A}`);return y}}t.$2P=i}),define(be[117],$e([1,0,9,2]),function(re,t,N,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tP=void 0;class i extends O.$lb{constructor(A,y,o){super(),this.a=A,this.b=y,this.c=o,this.f=null,this.j=!1,this.i=!1,this.g=!1,this.h=!1,this.k=this.B(new N.$Eg)}setVisibility(A){this.a!==A&&(this.a=A,this.m())}setShouldBeVisible(A){this.g=A,this.m()}l(){return this.a===2?!1:this.a===3?!0:this.g}m(){const A=this.l();this.h!==A&&(this.h=A,this.ensureVisibility())}setIsNeeded(A){this.i!==A&&(this.i=A,this.ensureVisibility())}setDomNode(A){this.f=A,this.f.setClassName(this.c),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this.i){this.p(!1);return}this.h?this.n():this.p(!0)}n(){this.j||(this.j=!0,this.k.setIfNotSet(()=>{this.f?.setClassName(this.b)},0))}p(A){this.k.cancel(),this.j&&(this.j=!1,this.f?.setClassName(this.c+(A?" fade":"")))}}t.$tP=i}),define(be[118],$e([1,0,4,23,13,3,2,5]),function(re,t,N,O,i,j,A,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mQ=void 0;class o extends A.$lb{constructor(g,L,r,l){super(),this.f=0,this.b=l||Object.create(null),this.c=[],this.a=document.createElement("select"),this.a.className="monaco-select-box",typeof this.b.ariaLabel=="string"&&this.a.setAttribute("aria-label",this.b.ariaLabel),typeof this.b.ariaDescription=="string"&&this.a.setAttribute("aria-description",this.b.ariaDescription),this.g=this.B(new j.$ec),this.h=r,this.i(),this.setOptions(g,L)}i(){this.B(O.$lP.addTarget(this.a)),[O.EventType.Tap].forEach(g=>{this.B(N.$8N(this.a,g,L=>{this.a.focus()}))}),this.B(N.$9N(this.a,"click",g=>{N.$LO.stop(g,!0)})),this.B(N.$9N(this.a,"change",g=>{this.a.title=g.target.value,this.g.fire({index:g.target.selectedIndex,selected:g.target.value})})),this.B(N.$9N(this.a,"keydown",g=>{let L=!1;y.$j?(g.keyCode===18||g.keyCode===16||g.keyCode===10)&&(L=!0):(g.keyCode===18&&g.altKey||g.keyCode===10||g.keyCode===3)&&(L=!0),L&&g.stopPropagation()}))}get onDidSelect(){return this.g.event}setOptions(g,L){(!this.c||!i.$$e(this.c,g))&&(this.c=g,this.a.options.length=0,this.c.forEach((r,l)=>{this.a.add(this.j(r.text,l,r.isDisabled))})),L!==void 0&&this.select(L)}select(g){this.c.length===0?this.f=0:g>=0&&g<this.c.length?this.f=g:g>this.c.length-1?this.select(this.c.length-1):this.f<0&&(this.f=0),this.a.selectedIndex=this.f,this.f<this.c.length&&typeof this.c[this.f].text=="string"?this.a.title=this.c[this.f].text:this.a.title=""}setAriaLabel(g){this.b.ariaLabel=g,this.a.setAttribute("aria-label",g)}focus(){this.a&&(this.a.tabIndex=0,this.a.focus())}blur(){this.a&&(this.a.tabIndex=-1,this.a.blur())}setFocusable(g){this.a.tabIndex=g?0:-1}render(g){g.classList.add("select-container"),g.appendChild(this.a),this.setOptions(this.c,this.f),this.applyStyles()}style(g){this.h=g,this.applyStyles()}applyStyles(){this.a&&(this.a.style.backgroundColor=this.h.selectBackground??"",this.a.style.color=this.h.selectForeground??"",this.a.style.borderColor=this.h.selectBorder??"")}j(g,L,r){const l=document.createElement("option");return l.value=g,l.text=g,l.disabled=!!r,l}}t.$mQ=o}),define(be[55],$e([1,0,24,13,9,47,84,3,26]),function(re,t,N,O,i,j,A,y,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$SR=t.$RR=t.$QR=void 0;function u(l){return typeof l=="object"&&"visibility"in l&&"data"in l}t.$QR=u;function g(l){switch(l){case!0:return 1;case!1:return 0;default:return l}}t.$RR=g;function L(l){return typeof l.collapsible=="boolean"}class r{constructor(e,a,n,h={}){this.o=e,this.p=a,this.rootRef=[],this.d=new y.$mc,this.f=new y.$ec,this.onDidChangeCollapseState=this.d.wrapEvent(this.f.event),this.g=new y.$ec,this.onDidChangeRenderNodeCount=this.d.wrapEvent(this.g.event),this.l=new y.$ec,this.onDidSplice=this.l.event,this.m=new i.$rg(j.$bc),this.h=typeof h.collapseByDefault>"u"?!1:h.collapseByDefault,this.j=h.filter,this.k=typeof h.autoExpandSingleChildren>"u"?!1:h.autoExpandSingleChildren,this.c={parent:void 0,element:n,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(e,a,n=o.Iterable.empty(),h={}){if(e.length===0)throw new N.$OR(this.o,"Invalid tree location");h.diffIdentityProvider?this.q(h.diffIdentityProvider,e,a,n,h):this.s(e,a,n,h)}q(e,a,n,h=o.Iterable.empty(),s,v=s.diffDepth??0){const{parentNode:D}=this.G(a);if(!D.lastDiffIds)return this.s(a,n,h,s);const E=[...h],f=a[a.length-1],C=new A.$uu({getElements:()=>D.lastDiffIds},{getElements:()=>[...D.children.slice(0,f),...E,...D.children.slice(f+n)].map(F=>e.getId(F.element).toString())}).ComputeDiff(!1);if(C.quitEarly)return D.lastDiffIds=void 0,this.s(a,n,E,s);const T=a.slice(0,-1),P=(F,R,B)=>{if(v>0)for(let M=0;M<B;M++)F--,R--,this.q(e,[...T,F,0],Number.MAX_SAFE_INTEGER,E[R].children,s,v-1)};let m=Math.min(D.children.length,f+n),$=E.length;for(const F of C.changes.sort((R,B)=>B.originalStart-R.originalStart))P(m,$,m-(F.originalStart+F.originalLength)),m=F.originalStart,$=F.modifiedStart-f,this.s([...T,m],F.originalLength,o.Iterable.slice(E,$,$+F.modifiedLength),s);P(m,$,m)}s(e,a,n=o.Iterable.empty(),{onDidCreateNode:h,onDidDeleteNode:s,diffIdentityProvider:v}){const{parentNode:D,listIndex:E,revealed:f,visible:C}=this.G(e),T=[],P=o.Iterable.map(n,ce=>this.w(ce,D,D.visible?1:0,f,T,h)),m=e[e.length-1],$=D.children.length>0;let F=0;for(let ce=m;ce>=0&&ce<D.children.length;ce--){const ue=D.children[ce];if(ue.visible){F=ue.visibleChildIndex;break}}const R=[];let B=0,M=0;for(const ce of P)R.push(ce),M+=ce.renderNodeCount,ce.visible&&(ce.visibleChildIndex=F+B++);const z=(0,O.$Kf)(D.children,m,a,R);v?D.lastDiffIds?(0,O.$Kf)(D.lastDiffIds,m,a,R.map(ce=>v.getId(ce.element).toString())):D.lastDiffIds=D.children.map(ce=>v.getId(ce.element).toString()):D.lastDiffIds=void 0;let te=0;for(const ce of z)ce.visible&&te++;if(te!==0)for(let ce=m+R.length;ce<D.children.length;ce++){const ue=D.children[ce];ue.visible&&(ue.visibleChildIndex-=te)}if(D.visibleChildrenCount+=B-te,f&&C){const ce=z.reduce((ue,ae)=>ue+(ae.visible?ae.renderNodeCount:0),0);this.B(D,M-ce),this.p.splice(E,ce,T)}if(z.length>0&&s){const ce=ue=>{s(ue),ue.children.forEach(ce)};z.forEach(ce)}this.l.fire({insertedNodes:R,deletedNodes:z});const ne=D.children.length>0;$!==ne&&this.setCollapsible(e.slice(0,-1),ne);let se=D;for(;se;){if(se.visibility===2){this.m.trigger(()=>this.refilter());break}se=se.parent}}rerender(e){if(e.length===0)throw new N.$OR(this.o,"Invalid tree location");const{node:a,listIndex:n,revealed:h}=this.F(e);a.visible&&h&&this.p.splice(n,1,[a])}updateElementHeight(e,a){if(e.length===0)throw new N.$OR(this.o,"Invalid tree location");const{listIndex:n}=this.F(e);this.p.updateElementHeight(n,a)}has(e){return this.D(e)}getListIndex(e){const{listIndex:a,visible:n,revealed:h}=this.F(e);return n&&h?a:-1}getListRenderCount(e){return this.E(e).renderNodeCount}isCollapsible(e){return this.E(e).collapsible}setCollapsible(e,a){const n=this.E(e);typeof a>"u"&&(a=!n.collapsible);const h={collapsible:a};return this.d.bufferEvents(()=>this.t(e,h))}isCollapsed(e){return this.E(e).collapsed}setCollapsed(e,a,n){const h=this.E(e);typeof a>"u"&&(a=!h.collapsed);const s={collapsed:a,recursive:n||!1};return this.d.bufferEvents(()=>this.t(e,s))}t(e,a){const{node:n,listIndex:h,revealed:s}=this.F(e),v=this.u(n,h,s,a);if(n!==this.c&&this.k&&v&&!L(a)&&n.collapsible&&!n.collapsed&&!a.recursive){let D=-1;for(let E=0;E<n.children.length;E++)if(n.children[E].visible)if(D>-1){D=-1;break}else D=E;D>-1&&this.t([...e,D],a)}return v}u(e,a,n,h){const s=this.v(e,h,!1);if(!n||!e.visible||!s)return s;const v=e.renderNodeCount,D=this.x(e),E=v-(a===-1?0:1);return this.p.splice(a+1,E,D.slice(1)),s}v(e,a,n){let h;if(e===this.c?h=!1:(L(a)?(h=e.collapsible!==a.collapsible,e.collapsible=a.collapsible):e.collapsible?(h=e.collapsed!==a.collapsed,e.collapsed=a.collapsed):h=!1,h&&this.f.fire({node:e,deep:n})),!L(a)&&a.recursive)for(const s of e.children)h=this.v(s,a,!0)||h;return h}expandTo(e){this.d.bufferEvents(()=>{let a=this.E(e);for(;a.parent;)a=a.parent,e=e.slice(0,e.length-1),a.collapsed&&this.t(e,{collapsed:!1,recursive:!1})})}refilter(){const e=this.c.renderNodeCount,a=this.z(this.c);this.p.splice(0,e,a),this.m.cancel()}w(e,a,n,h,s,v){const D={parent:a,element:e.element,children:[],depth:a.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof e.collapsible=="boolean"?e.collapsible:typeof e.collapsed<"u",collapsed:typeof e.collapsed>"u"?this.h:e.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},E=this.C(D,n);D.visibility=E,h&&s.push(D);const f=e.children||o.Iterable.empty(),C=h&&E!==0&&!D.collapsed;let T=0,P=1;for(const m of f){const $=this.w(m,D,E,C,s,v);D.children.push($),P+=$.renderNodeCount,$.visible&&($.visibleChildIndex=T++)}return D.collapsible=D.collapsible||D.children.length>0,D.visibleChildrenCount=T,D.visible=E===2?T>0:E===1,D.visible?D.collapsed||(D.renderNodeCount=P):(D.renderNodeCount=0,h&&s.pop()),v?.(D),D}x(e){const a=e.renderNodeCount,n=[];return this.y(e,n),this.B(e.parent,n.length-a),n}y(e,a){if(e.visible===!1)return 0;if(a.push(e),e.renderNodeCount=1,!e.collapsed)for(const n of e.children)e.renderNodeCount+=this.y(n,a);return this.g.fire(e),e.renderNodeCount}z(e){const a=e.renderNodeCount,n=[];return this.A(e,e.visible?1:0,n),this.B(e.parent,n.length-a),n}A(e,a,n,h=!0){let s;if(e!==this.c){if(s=this.C(e,a),s===0)return e.visible=!1,e.renderNodeCount=0,!1;h&&n.push(e)}const v=n.length;e.renderNodeCount=e===this.c?0:1;let D=!1;if(!e.collapsed||s!==0){let E=0;for(const f of e.children)D=this.A(f,s,n,h&&!e.collapsed)||D,f.visible&&(f.visibleChildIndex=E++);e.visibleChildrenCount=E}else e.visibleChildrenCount=0;return e!==this.c&&(e.visible=s===2?D:s===1,e.visibility=s),e.visible?e.collapsed||(e.renderNodeCount+=n.length-v):(e.renderNodeCount=0,h&&n.pop()),this.g.fire(e),e.visible}B(e,a){if(a!==0)for(;e;)e.renderNodeCount+=a,this.g.fire(e),e=e.parent}C(e,a){const n=this.j?this.j.filter(e.element,a):1;return typeof n=="boolean"?(e.filterData=void 0,n?1:0):u(n)?(e.filterData=n.data,g(n.visibility)):(e.filterData=void 0,g(n))}D(e,a=this.c){if(!e||e.length===0)return!0;const[n,...h]=e;return n<0||n>a.children.length?!1:this.D(h,a.children[n])}E(e,a=this.c){if(!e||e.length===0)return a;const[n,...h]=e;if(n<0||n>a.children.length)throw new N.$OR(this.o,"Invalid tree location");return this.E(h,a.children[n])}F(e){if(e.length===0)return{node:this.c,listIndex:-1,revealed:!0,visible:!1};const{parentNode:a,listIndex:n,revealed:h,visible:s}=this.G(e),v=e[e.length-1];if(v<0||v>a.children.length)throw new N.$OR(this.o,"Invalid tree location");const D=a.children[v];return{node:D,listIndex:n,revealed:h,visible:s&&D.visible}}G(e,a=this.c,n=0,h=!0,s=!0){const[v,...D]=e;if(v<0||v>a.children.length)throw new N.$OR(this.o,"Invalid tree location");for(let E=0;E<v;E++)n+=a.children[E].renderNodeCount;return h=h&&!a.collapsed,s=s&&a.visible,D.length===0?{parentNode:a,listIndex:n,revealed:h,visible:s}:this.G(D,a.children[v],n+1,h,s)}getNode(e=[]){return this.E(e)}getNodeLocation(e){const a=[];let n=e;for(;n.parent;)a.push(n.parent.children.indexOf(n)),n=n.parent;return a.reverse()}getParentNodeLocation(e){if(e.length!==0)return e.length===1?[]:(0,O.$0e)(e)[0]}getFirstElementChild(e){const a=this.E(e);if(a.children.length!==0)return a.children[0].element}getLastElementAncestor(e=[]){const a=this.E(e);if(a.children.length!==0)return this.H(a)}H(e){return e.children.length===0?e.element:this.H(e.children[e.children.length-1])}}t.$SR=r}),define(be[119],$e([1,0,55,24,26]),function(re,t,N,O,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$YR=void 0;class j{get size(){return this.d.size}constructor(y,o,u={}){this.k=y,this.rootRef=null,this.d=new Map,this.f=new Map,this.c=new N.$SR(y,o,null,u),this.onDidSplice=this.c.onDidSplice,this.onDidChangeCollapseState=this.c.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.c.onDidChangeRenderNodeCount,u.sorter&&(this.j={compare(g,L){return u.sorter.compare(g.element,L.element)}}),this.h=u.identityProvider}setChildren(y,o=i.Iterable.empty(),u={}){const g=this.o(y);this.l(g,this.m(o),u)}l(y,o=i.Iterable.empty(),u){const g=new Set,L=new Set,r=e=>{if(e.element===null)return;const a=e;if(g.add(a.element),this.d.set(a.element,a),this.h){const n=this.h.getId(a.element).toString();L.add(n),this.f.set(n,a)}u.onDidCreateNode?.(a)},l=e=>{if(e.element===null)return;const a=e;if(g.has(a.element)||this.d.delete(a.element),this.h){const n=this.h.getId(a.element).toString();L.has(n)||this.f.delete(n)}u.onDidDeleteNode?.(a)};this.c.splice([...y,0],Number.MAX_VALUE,o,{...u,onDidCreateNode:r,onDidDeleteNode:l})}m(y=i.Iterable.empty()){return this.j&&(y=[...y].sort(this.j.compare.bind(this.j))),i.Iterable.map(y,o=>{let u=this.d.get(o.element);if(!u&&this.h){const r=this.h.getId(o.element).toString();u=this.f.get(r)}if(!u){let r;return typeof o.collapsed>"u"?r=void 0:o.collapsed===O.ObjectTreeElementCollapseState.Collapsed||o.collapsed===O.ObjectTreeElementCollapseState.PreserveOrCollapsed?r=!0:o.collapsed===O.ObjectTreeElementCollapseState.Expanded||o.collapsed===O.ObjectTreeElementCollapseState.PreserveOrExpanded?r=!1:r=!!o.collapsed,{...o,children:this.m(o.children),collapsed:r}}const g=typeof o.collapsible=="boolean"?o.collapsible:u.collapsible;let L;return typeof o.collapsed>"u"||o.collapsed===O.ObjectTreeElementCollapseState.PreserveOrCollapsed||o.collapsed===O.ObjectTreeElementCollapseState.PreserveOrExpanded?L=u.collapsed:o.collapsed===O.ObjectTreeElementCollapseState.Collapsed?L=!0:o.collapsed===O.ObjectTreeElementCollapseState.Expanded?L=!1:L=!!o.collapsed,{...o,collapsible:g,collapsed:L,children:this.m(o.children)}})}rerender(y){const o=this.o(y);this.c.rerender(o)}updateElementHeight(y,o){const u=this.o(y);this.c.updateElementHeight(u,o)}resort(y=null,o=!0){if(!this.j)return;const u=this.o(y),g=this.c.getNode(u);this.l(u,this.n(g,o),{})}n(y,o,u=!0){let g=[...y.children];return(o||u)&&(g=g.sort(this.j.compare.bind(this.j))),i.Iterable.map(g,L=>({element:L.element,collapsible:L.collapsible,collapsed:L.collapsed,children:this.n(L,o,!1)}))}getFirstElementChild(y=null){const o=this.o(y);return this.c.getFirstElementChild(o)}getLastElementAncestor(y=null){const o=this.o(y);return this.c.getLastElementAncestor(o)}has(y){return this.d.has(y)}getListIndex(y){const o=this.o(y);return this.c.getListIndex(o)}getListRenderCount(y){const o=this.o(y);return this.c.getListRenderCount(o)}isCollapsible(y){const o=this.o(y);return this.c.isCollapsible(o)}setCollapsible(y,o){const u=this.o(y);return this.c.setCollapsible(u,o)}isCollapsed(y){const o=this.o(y);return this.c.isCollapsed(o)}setCollapsed(y,o,u){const g=this.o(y);return this.c.setCollapsed(g,o,u)}expandTo(y){const o=this.o(y);this.c.expandTo(o)}refilter(){this.c.refilter()}getNode(y=null){if(y===null)return this.c.getNode(this.c.rootRef);const o=this.d.get(y);if(!o)throw new O.$OR(this.k,`Tree element not found: ${y}`);return o}getNodeLocation(y){return y.element}getParentNodeLocation(y){if(y===null)throw new O.$OR(this.k,"Invalid getParentNodeLocation call");const o=this.d.get(y);if(!o)throw new O.$OR(this.k,`Tree element not found: ${y}`);const u=this.c.getNodeLocation(o),g=this.c.getParentNodeLocation(u);return this.c.getNode(g).element}o(y){if(y===null)return[];const o=this.d.get(y);if(!o)throw new O.$OR(this.k,`Tree element not found: ${y}`);return this.c.getNodeLocation(o)}}t.$YR=j}),define(be[20],$e([1,0,4,14,19,23,2]),function(re,t,N,O,i,j,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pP=void 0;class y extends A.$lb{f(u,g){this.B(N.$8N(u,N.$JO.CLICK,L=>g(new i.$ZN(L))))}j(u,g){this.B(N.$8N(u,N.$JO.MOUSE_DOWN,L=>g(new i.$ZN(L))))}k(u,g){this.B(N.$8N(u,N.$JO.MOUSE_OVER,L=>g(new i.$ZN(L))))}m(u,g){this.B(N.$8N(u,N.$JO.MOUSE_LEAVE,L=>g(new i.$ZN(L))))}p(u,g){this.B(N.$8N(u,N.$JO.KEY_DOWN,L=>g(new O.$5N(L))))}u(u,g){this.B(N.$8N(u,N.$JO.KEY_UP,L=>g(new O.$5N(L))))}z(u,g){this.B(N.$8N(u,N.$JO.INPUT,g))}C(u,g){this.B(N.$8N(u,N.$JO.BLUR,g))}D(u,g){this.B(N.$8N(u,N.$JO.FOCUS,g))}F(u,g){this.B(N.$8N(u,N.$JO.CHANGE,g))}G(u){return j.$lP.ignoreTarget(u)}}t.$pP=y}),define(be[36],$e([1,0,53,20,9,18,4]),function(re,t,N,O,i,j,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rP=t.$qP=void 0,t.$qP=11;class y extends O.$pP{constructor(u){super(),this.a=u.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=u.bgWidth+"px",this.bgDomNode.style.height=u.bgHeight+"px",typeof u.top<"u"&&(this.bgDomNode.style.top="0px"),typeof u.left<"u"&&(this.bgDomNode.style.left="0px"),typeof u.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof u.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=u.className,this.domNode.classList.add(...j.ThemeIcon.asClassNameArray(u.icon)),this.domNode.style.position="absolute",this.domNode.style.width=t.$qP+"px",this.domNode.style.height=t.$qP+"px",typeof u.top<"u"&&(this.domNode.style.top=u.top+"px"),typeof u.left<"u"&&(this.domNode.style.left=u.left+"px"),typeof u.bottom<"u"&&(this.domNode.style.bottom=u.bottom+"px"),typeof u.right<"u"&&(this.domNode.style.right=u.right+"px"),this.g=this.B(new N.$oP),this.B(A.$9N(this.bgDomNode,A.$JO.POINTER_DOWN,g=>this.h(g))),this.B(A.$9N(this.domNode,A.$JO.POINTER_DOWN,g=>this.h(g))),this.b=this.B(new i.$Fg),this.c=this.B(new i.$Eg)}h(u){if(!u.target||!(u.target instanceof Element))return;const g=()=>{this.b.cancelAndSet(()=>this.a(),1e3/24)};this.a(),this.b.cancel(),this.c.cancelAndSet(g,200),this.g.startMonitoring(u.target,u.pointerId,u.buttons,L=>{},()=>{this.b.cancel(),this.c.cancel()}),u.preventDefault()}}t.$rP=y}),define(be[56],$e([1,0,4,39,53,36,117,20,5]),function(re,t,N,O,i,j,A,y,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uP=void 0;const u=140;class g extends y.$pP{constructor(r){super(),this.g=r.lazyRender,this.a=r.host,this.b=r.scrollable,this.c=r.scrollByPage,this.h=r.scrollbarState,this.i=this.B(new A.$tP(r.visibility,"visible scrollbar "+r.extraScrollbarClassName,"invisible scrollbar "+r.extraScrollbarClassName)),this.i.setIsNeeded(this.h.isNeeded()),this.l=this.B(new i.$oP),this.n=!0,this.domNode=(0,O.$nP)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this.i.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this.B(N.$8N(this.domNode.domNode,N.$JO.POINTER_DOWN,l=>this.y(l)))}r(r){const l=this.B(new j.$rP(r));this.domNode.domNode.appendChild(l.bgDomNode),this.domNode.domNode.appendChild(l.domNode)}s(r,l,e,a){this.slider=(0,O.$nP)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(r),this.slider.setLeft(l),typeof e=="number"&&this.slider.setWidth(e),typeof a=="number"&&this.slider.setHeight(a),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this.B(N.$8N(this.slider.domNode,N.$JO.POINTER_DOWN,n=>{n.button===0&&(n.preventDefault(),this.I(n))})),this.f(this.slider.domNode,n=>{n.leftButton&&n.stopPropagation()})}t(r){return this.h.setVisibleSize(r)&&(this.i.setIsNeeded(this.h.isNeeded()),this.n=!0,this.g||this.render()),this.n}v(r){return this.h.setScrollSize(r)&&(this.i.setIsNeeded(this.h.isNeeded()),this.n=!0,this.g||this.render()),this.n}w(r){return this.h.setScrollPosition(r)&&(this.i.setIsNeeded(this.h.isNeeded()),this.n=!0,this.g||this.render()),this.n}beginReveal(){this.i.setShouldBeVisible(!0)}beginHide(){this.i.setShouldBeVisible(!1)}render(){this.n&&(this.n=!1,this.L(this.h.getRectangleLargeSize(),this.h.getRectangleSmallSize()),this.M(this.h.getSliderSize(),this.h.getArrowSize()+this.h.getSliderPosition()))}y(r){r.target===this.domNode.domNode&&this.H(r)}delegatePointerDown(r){const l=this.domNode.domNode.getClientRects()[0].top,e=l+this.h.getSliderPosition(),a=l+this.h.getSliderPosition()+this.h.getSliderSize(),n=this.O(r);e<=n&&n<=a?r.button===0&&(r.preventDefault(),this.I(r)):this.H(r)}H(r){let l,e;if(r.target===this.domNode.domNode&&typeof r.offsetX=="number"&&typeof r.offsetY=="number")l=r.offsetX,e=r.offsetY;else{const n=N.$nO(this.domNode.domNode);l=r.pageX-n.left,e=r.pageY-n.top}const a=this.N(l,e);this.J(this.c?this.h.getDesiredScrollPositionFromOffsetPaged(a):this.h.getDesiredScrollPositionFromOffset(a)),r.button===0&&(r.preventDefault(),this.I(r))}I(r){if(!r.target||!(r.target instanceof Element))return;const l=this.O(r),e=this.P(r),a=this.h.clone();this.slider.toggleClassName("active",!0),this.l.startMonitoring(r.target,r.pointerId,r.buttons,n=>{const h=this.P(n),s=Math.abs(h-e);if(o.$i&&s>u){this.J(a.getScrollPosition());return}const D=this.O(n)-l;this.J(a.getDesiredScrollPositionFromDelta(D))},()=>{this.slider.toggleClassName("active",!1),this.a.onDragEnd()}),this.a.onDragStart()}J(r){const l={};this.writeScrollPosition(l,r),this.b.setScrollPositionNow(l)}updateScrollbarSize(r){this.Q(r),this.h.setScrollbarSize(r),this.n=!0,this.g||this.render()}isNeeded(){return this.h.isNeeded()}}t.$uP=g}),define(be[120],$e([1,0,19,56,36,40,17]),function(re,t,N,O,i,j,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vP=void 0;class y extends O.$uP{constructor(u,g,L){const r=u.getScrollDimensions(),l=u.getCurrentScrollPosition();if(super({lazyRender:g.lazyRender,host:L,scrollbarState:new j.$sP(g.horizontalHasArrows?g.arrowSize:0,g.horizontal===2?0:g.horizontalScrollbarSize,g.vertical===2?0:g.verticalScrollbarSize,r.width,r.scrollWidth,l.scrollLeft),visibility:g.horizontal,extraScrollbarClassName:"horizontal",scrollable:u,scrollByPage:g.scrollByPage}),g.horizontalHasArrows){const e=(g.arrowSize-i.$qP)/2,a=(g.horizontalScrollbarSize-i.$qP)/2;this.r({className:"scra",icon:A.$Cj.scrollbarButtonLeft,top:a,left:e,bottom:void 0,right:void 0,bgWidth:g.arrowSize,bgHeight:g.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new N.$2N(null,1,0))}),this.r({className:"scra",icon:A.$Cj.scrollbarButtonRight,top:a,left:void 0,bottom:void 0,right:e,bgWidth:g.arrowSize,bgHeight:g.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new N.$2N(null,-1,0))})}this.s(Math.floor((g.horizontalScrollbarSize-g.horizontalSliderSize)/2),0,void 0,g.horizontalSliderSize)}M(u,g){this.slider.setWidth(u),this.slider.setLeft(g)}L(u,g){this.domNode.setWidth(u),this.domNode.setHeight(g),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(u){return this.n=this.v(u.scrollWidth)||this.n,this.n=this.w(u.scrollLeft)||this.n,this.n=this.t(u.width)||this.n,this.n}N(u,g){return u}O(u){return u.pageX}P(u){return u.pageY}Q(u){this.slider.setHeight(u)}writeScrollPosition(u,g){u.scrollLeft=g}updateOptions(u){this.updateScrollbarSize(u.horizontal===2?0:u.horizontalScrollbarSize),this.h.setOppositeScrollbarSize(u.vertical===2?0:u.verticalScrollbarSize),this.i.setVisibility(u.horizontal),this.c=u.scrollByPage}}t.$vP=y}),define(be[121],$e([1,0,19,56,36,40,17]),function(re,t,N,O,i,j,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wP=void 0;class y extends O.$uP{constructor(u,g,L){const r=u.getScrollDimensions(),l=u.getCurrentScrollPosition();if(super({lazyRender:g.lazyRender,host:L,scrollbarState:new j.$sP(g.verticalHasArrows?g.arrowSize:0,g.vertical===2?0:g.verticalScrollbarSize,0,r.height,r.scrollHeight,l.scrollTop),visibility:g.vertical,extraScrollbarClassName:"vertical",scrollable:u,scrollByPage:g.scrollByPage}),g.verticalHasArrows){const e=(g.arrowSize-i.$qP)/2,a=(g.verticalScrollbarSize-i.$qP)/2;this.r({className:"scra",icon:A.$Cj.scrollbarButtonUp,top:e,left:a,bottom:void 0,right:void 0,bgWidth:g.verticalScrollbarSize,bgHeight:g.arrowSize,onActivate:()=>this.a.onMouseWheel(new N.$2N(null,0,1))}),this.r({className:"scra",icon:A.$Cj.scrollbarButtonDown,top:void 0,left:a,bottom:e,right:void 0,bgWidth:g.verticalScrollbarSize,bgHeight:g.arrowSize,onActivate:()=>this.a.onMouseWheel(new N.$2N(null,0,-1))})}this.s(0,Math.floor((g.verticalScrollbarSize-g.verticalSliderSize)/2),g.verticalSliderSize,void 0)}M(u,g){this.slider.setHeight(u),this.slider.setTop(g)}L(u,g){this.domNode.setWidth(g),this.domNode.setHeight(u),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(u){return this.n=this.v(u.scrollHeight)||this.n,this.n=this.w(u.scrollTop)||this.n,this.n=this.t(u.height)||this.n,this.n}N(u,g){return g}O(u){return u.pageY}P(u){return u.pageX}Q(u){this.slider.setWidth(u)}writeScrollPosition(u,g){u.scrollTop=g}updateOptions(u){this.updateScrollbarSize(u.vertical===2?0:u.verticalScrollbarSize),this.h.setOppositeScrollbarSize(0),this.i.setVisibility(u.vertical),this.c=u.scrollByPage}}t.$wP=y}),define(be[57],$e([1,0,16,4,39,19,120,121,20,9,3,2,5,46,95]),function(re,t,N,O,i,j,A,y,o,u,g,L,r,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$BP=t.$AP=t.$zP=t.$yP=t.$xP=void 0;const e=500,a=50,n=!0;class h{constructor(P,m,$){this.timestamp=P,this.deltaX=m,this.deltaY=$,this.score=0}}class s{static{this.INSTANCE=new s}constructor(){this.a=5,this.b=[],this.c=-1,this.d=-1}isPhysicalMouseWheel(){if(this.c===-1&&this.d===-1)return!1;let P=1,m=0,$=1,F=this.d;do{const R=F===this.c?P:Math.pow(2,-$);if(P-=R,m+=this.b[F].score*R,F===this.c)break;F=(this.a+F-1)%this.a,$++}while(!0);return m<=.5}acceptStandardWheelEvent(P){const m=window.devicePixelRatio/(0,N.$JN)();r.$i||r.$k?this.accept(Date.now(),P.deltaX/m,P.deltaY/m):this.accept(Date.now(),P.deltaX,P.deltaY)}accept(P,m,$){const F=new h(P,m,$);F.score=this.f(F),this.c===-1&&this.d===-1?(this.b[0]=F,this.c=0,this.d=0):(this.d=(this.d+1)%this.a,this.d===this.c&&(this.c=(this.c+1)%this.a),this.b[this.d]=F)}f(P){if(Math.abs(P.deltaX)>0&&Math.abs(P.deltaY)>0)return 1;let m=.5;const $=this.c===-1&&this.d===-1?null:this.b[this.d];return(!this.g(P.deltaX)||!this.g(P.deltaY))&&(m+=.25),Math.min(Math.max(m,0),1)}g(P){return Math.abs(Math.round(P)-P)<.01}}t.$xP=s;class v extends o.$pP{get options(){return this.a}constructor(P,m,$){super(),this.I=this.B(new g.$ec),this.onScroll=this.I.event,this.J=this.B(new g.$ec),this.onWillScroll=this.J.event,P.style.overflow="hidden",this.a=C(m),this.b=$,this.B(this.b.onScroll(R=>{this.J.fire(R),this.N(R),this.I.fire(R)}));const F={onMouseWheel:R=>this.M(R),onDragStart:()=>this.P(),onDragEnd:()=>this.Q()};this.c=this.B(new y.$wP(this.b,this.a,F)),this.g=this.B(new A.$vP(this.b,this.a,F)),this.h=document.createElement("div"),this.h.className="monaco-scrollable-element "+this.a.className,this.h.setAttribute("role","presentation"),this.h.style.position="relative",this.h.style.overflow="hidden",this.h.appendChild(P),this.h.appendChild(this.g.domNode.domNode),this.h.appendChild(this.c.domNode.domNode),this.a.useShadows?(this.i=(0,i.$nP)(document.createElement("div")),this.i.setClassName("shadow"),this.h.appendChild(this.i.domNode),this.l=(0,i.$nP)(document.createElement("div")),this.l.setClassName("shadow"),this.h.appendChild(this.l.domNode),this.n=(0,i.$nP)(document.createElement("div")),this.n.setClassName("shadow"),this.h.appendChild(this.n.domNode)):(this.i=null,this.l=null,this.n=null),this.r=this.a.listenOnDomNode||this.h,this.s=[],this.L(this.a.handleMouseWheel),this.k(this.r,R=>this.S(R)),this.m(this.r,R=>this.R(R)),this.w=this.B(new u.$Eg),this.t=!1,this.v=!1,this.y=!0,this.H=!0}dispose(){this.s=(0,L.$gb)(this.s),super.dispose()}getDomNode(){return this.h}getOverviewRulerLayoutInfo(){return{parent:this.h,insertBefore:this.c.domNode.domNode}}delegateVerticalScrollbarPointerDown(P){this.c.delegatePointerDown(P)}getScrollDimensions(){return this.b.getScrollDimensions()}setScrollDimensions(P){this.b.setScrollDimensions(P,!1)}updateClassName(P){this.a.className=P,r.$j&&(this.a.className+=" mac"),this.h.className="monaco-scrollable-element "+this.a.className}updateOptions(P){typeof P.handleMouseWheel<"u"&&(this.a.handleMouseWheel=P.handleMouseWheel,this.L(this.a.handleMouseWheel)),typeof P.mouseWheelScrollSensitivity<"u"&&(this.a.mouseWheelScrollSensitivity=P.mouseWheelScrollSensitivity),typeof P.fastScrollSensitivity<"u"&&(this.a.fastScrollSensitivity=P.fastScrollSensitivity),typeof P.scrollPredominantAxis<"u"&&(this.a.scrollPredominantAxis=P.scrollPredominantAxis),typeof P.horizontal<"u"&&(this.a.horizontal=P.horizontal),typeof P.vertical<"u"&&(this.a.vertical=P.vertical),typeof P.horizontalScrollbarSize<"u"&&(this.a.horizontalScrollbarSize=P.horizontalScrollbarSize),typeof P.verticalScrollbarSize<"u"&&(this.a.verticalScrollbarSize=P.verticalScrollbarSize),typeof P.scrollByPage<"u"&&(this.a.scrollByPage=P.scrollByPage),this.g.updateOptions(this.a),this.c.updateOptions(this.a),this.a.lazyRender||this.O()}setRevealOnScroll(P){this.H=P}delegateScrollFromMouseWheelEvent(P){this.M(new j.$2N(P))}L(P){if(this.s.length>0!==P&&(this.s=(0,L.$gb)(this.s),P)){const $=F=>{this.M(new j.$2N(F))};this.s.push(O.$8N(this.r,O.$JO.MOUSE_WHEEL,$,{passive:!1}))}}M(P){if(P.browserEvent?.defaultPrevented)return;const m=s.INSTANCE;n&&m.acceptStandardWheelEvent(P);let $=!1;if(P.deltaY||P.deltaX){let R=P.deltaY*this.a.mouseWheelScrollSensitivity,B=P.deltaX*this.a.mouseWheelScrollSensitivity;this.a.scrollPredominantAxis&&(this.a.scrollYToX&&B+R===0?B=R=0:Math.abs(R)>=Math.abs(B)?B=0:R=0),this.a.flipAxes&&([R,B]=[B,R]);const M=!r.$j&&P.browserEvent&&P.browserEvent.shiftKey;(this.a.scrollYToX||M)&&!B&&(B=R,R=0),P.browserEvent&&P.browserEvent.altKey&&(B=B*this.a.fastScrollSensitivity,R=R*this.a.fastScrollSensitivity);const z=this.b.getFutureScrollPosition();let te={};if(R){const ne=a*R,se=z.scrollTop-(ne<0?Math.floor(ne):Math.ceil(ne));this.c.writeScrollPosition(te,se)}if(B){const ne=a*B,se=z.scrollLeft-(ne<0?Math.floor(ne):Math.ceil(ne));this.g.writeScrollPosition(te,se)}te=this.b.validateScrollPosition(te),(z.scrollLeft!==te.scrollLeft||z.scrollTop!==te.scrollTop)&&(n&&this.a.mouseWheelSmoothScroll&&m.isPhysicalMouseWheel()?this.b.setScrollPositionSmooth(te):this.b.setScrollPositionNow(te),$=!0)}let F=$;!F&&this.a.alwaysConsumeMouseWheel&&(F=!0),!F&&this.a.consumeMouseWheelIfScrollbarIsNeeded&&(this.c.isNeeded()||this.g.isNeeded())&&(F=!0),F&&(P.preventDefault(),P.stopPropagation())}N(P){this.y=this.g.onDidScroll(P)||this.y,this.y=this.c.onDidScroll(P)||this.y,this.a.useShadows&&(this.y=!0),this.H&&this.U(),this.a.lazyRender||this.O()}renderNow(){if(!this.a.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this.O()}O(){if(this.y&&(this.y=!1,this.g.render(),this.c.render(),this.a.useShadows)){const P=this.b.getCurrentScrollPosition(),m=P.scrollTop>0,$=P.scrollLeft>0,F=$?" left":"",R=m?" top":"",B=$||m?" top-left-corner":"";this.i.setClassName(`shadow${F}`),this.l.setClassName(`shadow${R}`),this.n.setClassName(`shadow${B}${R}${F}`)}}P(){this.t=!0,this.U()}Q(){this.t=!1,this.W()}R(P){this.v=!1,this.W()}S(P){this.v=!0,this.U()}U(){this.c.beginReveal(),this.g.beginReveal(),this.X()}W(){!this.v&&!this.t&&(this.c.beginHide(),this.g.beginHide())}X(){!this.v&&!this.t&&this.w.cancelAndSet(()=>this.W(),e)}}t.$yP=v;class D extends v{constructor(P,m){m=m||{},m.mouseWheelSmoothScroll=!1;const $=new l.$Er({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:F=>O.$dO(F)});super(P,m,$),this.B($)}setScrollPosition(P){this.b.setScrollPositionNow(P)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$zP=D;class E extends v{constructor(P,m,$){super(P,m,$)}setScrollPosition(P){P.reuseAnimation?this.b.setScrollPositionSmooth(P,P.reuseAnimation):this.b.setScrollPositionNow(P)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$AP=E;class f extends v{constructor(P,m){m=m||{},m.mouseWheelSmoothScroll=!1;const $=new l.$Er({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:F=>O.$dO(F)});super(P,m,$),this.B($),this.Y=P,this.onScroll(F=>{F.scrollTopChanged&&(this.Y.scrollTop=F.scrollTop),F.scrollLeftChanged&&(this.Y.scrollLeft=F.scrollLeft)}),this.scanDomNode()}setScrollPosition(P){this.b.setScrollPositionNow(P)}getScrollPosition(){return this.b.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this.Y.clientWidth,scrollWidth:this.Y.scrollWidth,height:this.Y.clientHeight,scrollHeight:this.Y.scrollHeight}),this.setScrollPosition({scrollLeft:this.Y.scrollLeft,scrollTop:this.Y.scrollTop})}}t.$BP=f;function C(T){const P={lazyRender:typeof T.lazyRender<"u"?T.lazyRender:!1,className:typeof T.className<"u"?T.className:"",useShadows:typeof T.useShadows<"u"?T.useShadows:!0,handleMouseWheel:typeof T.handleMouseWheel<"u"?T.handleMouseWheel:!0,flipAxes:typeof T.flipAxes<"u"?T.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof T.consumeMouseWheelIfScrollbarIsNeeded<"u"?T.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof T.alwaysConsumeMouseWheel<"u"?T.alwaysConsumeMouseWheel:!1,scrollYToX:typeof T.scrollYToX<"u"?T.scrollYToX:!1,mouseWheelScrollSensitivity:typeof T.mouseWheelScrollSensitivity<"u"?T.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof T.fastScrollSensitivity<"u"?T.fastScrollSensitivity:5,scrollPredominantAxis:typeof T.scrollPredominantAxis<"u"?T.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof T.mouseWheelSmoothScroll<"u"?T.mouseWheelSmoothScroll:!0,arrowSize:typeof T.arrowSize<"u"?T.arrowSize:11,listenOnDomNode:typeof T.listenOnDomNode<"u"?T.listenOnDomNode:null,horizontal:typeof T.horizontal<"u"?T.horizontal:1,horizontalScrollbarSize:typeof T.horizontalScrollbarSize<"u"?T.horizontalScrollbarSize:10,horizontalSliderSize:typeof T.horizontalSliderSize<"u"?T.horizontalSliderSize:0,horizontalHasArrows:typeof T.horizontalHasArrows<"u"?T.horizontalHasArrows:!1,vertical:typeof T.vertical<"u"?T.vertical:1,verticalScrollbarSize:typeof T.verticalScrollbarSize<"u"?T.verticalScrollbarSize:10,verticalHasArrows:typeof T.verticalHasArrows<"u"?T.verticalHasArrows:!1,verticalSliderSize:typeof T.verticalSliderSize<"u"?T.verticalSliderSize:0,scrollByPage:typeof T.scrollByPage<"u"?T.scrollByPage:!1};return P.horizontalSliderSize=typeof T.horizontalSliderSize<"u"?T.horizontalSliderSize:P.horizontalScrollbarSize,P.verticalSliderSize=typeof T.verticalSliderSize<"u"?T.verticalSliderSize:P.verticalScrollbarSize,r.$j&&(P.className+=" mac"),P}}),define(be[58],$e([1,0,51,4,21,23,57,13,9,25,3,2,45,46,79,116,6]),function(re,t,N,O,i,j,A,y,o,u,g,L,r,l,e,a,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6P=t.$5P=t.$4P=t.$3P=void 0;const h={CurrentDragAndDropData:void 0},s={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(P){return[P]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class v{get context(){return this.d}set context(m){this.d=m}constructor(m){this.elements=m}update(){}getData(){return this.elements}}t.$3P=v;class D{constructor(m){this.elements=m}update(){}getData(){return this.elements}}t.$4P=D;class E{constructor(){this.types=[],this.files=[]}update(m){if(m.types&&this.types.splice(0,this.types.length,...m.types),m.files){this.files.splice(0,this.files.length);for(let $=0;$<m.files.length;$++){const F=m.files.item($);F&&(F.size||F.type)&&this.files.push(F)}}}getData(){return{types:this.types,files:this.files}}}t.$5P=E;function f(P,m){return Array.isArray(P)&&Array.isArray(m)?(0,y.$$e)(P,m):P===m}class C{constructor(m){m?.getSetSize?this.getSetSize=m.getSetSize.bind(m):this.getSetSize=($,F,R)=>R,m?.getPosInSet?this.getPosInSet=m.getPosInSet.bind(m):this.getPosInSet=($,F)=>F+1,m?.getRole?this.getRole=m.getRole.bind(m):this.getRole=$=>"listitem",m?.isChecked?this.isChecked=m.isChecked.bind(m):this.isChecked=$=>{}}}class T{static{this.c=0}get contentHeight(){return this.g.size}get contentWidth(){return this.E??0}get onDidScroll(){return this.q.onScroll}get onWillScroll(){return this.q.onWillScroll}get containerDomNode(){return this.o}get scrollableElementDomNode(){return this.q.getDomNode()}get P(){return this.O}set P(m){if(m!==this.O){if(m&&this.B)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this.O=m,this.domNode.classList.toggle("horizontal-scrolling",this.O),this.O){for(const $ of this.d)this.Y($);this.V(),this.q.setScrollDimensions({width:(0,O.$qO)(this.domNode)}),this.o.style.width=`${Math.max(this.E||0,this.n)}px`}else this.u.cancel(),this.q.setScrollDimensions({width:this.n,scrollWidth:this.n}),this.o.style.width=""}}constructor(m,$,F,R=s){if(this.Q=$,this.domId=`list_id_${++T.c}`,this.j=new Map,this.n=0,this.s=0,this.t=null,this.u=new o.$rg(50),this.v=!1,this.x=L.$lb.None,this.y=0,this.G=!1,this.J=L.$lb.None,this.K=L.$lb.None,this.L=new L.$kb,this.M=new g.$ec,this.N=new g.$ec,this.onDidChangeContentHeight=g.Event.latch(this.M.event,void 0,this.L),this.onDidChangeContentWidth=g.Event.latch(this.N.event,void 0,this.L),this.O=!1,R.horizontalScrolling&&R.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.d=[],this.f=0,this.g=new e.$1P(R.paddingTop??0);for(const M of F)this.j.set(M.templateId,M);this.h=this.L.add(new a.$2P(this.j)),this.k=0,this.m=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof R.mouseSupport=="boolean"?R.mouseSupport:!0),this.O=R.horizontalScrolling??s.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this.O),this.C=typeof R.paddingBottom>"u"?0:R.paddingBottom,this.D=new C(R.accessibilityProvider),this.o=document.createElement("div"),this.o.className="monaco-list-rows",(R.transformOptimization??s.transformOptimization)&&(this.o.style.transform="translate3d(0px, 0px, 0px)",this.o.style.overflow="hidden",this.o.style.contain="strict"),this.L.add(j.$lP.addTarget(this.o)),this.p=new l.$Er({forceIntegerValues:!0,smoothScrollDuration:R.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:M=>(0,O.$dO)(M)}),this.q=this.L.add(new A.$AP(this.o,{alwaysConsumeMouseWheel:R.alwaysConsumeMouseWheel??s.alwaysConsumeMouseWheel,horizontal:1,vertical:R.verticalScrollMode??s.verticalScrollMode,useShadows:R.useShadows??s.useShadows,mouseWheelScrollSensitivity:R.mouseWheelScrollSensitivity,fastScrollSensitivity:R.fastScrollSensitivity,scrollByPage:R.scrollByPage},this.p)),this.domNode.appendChild(this.q.getDomNode()),m.appendChild(this.domNode),this.q.onScroll(this.gb,this,this.L),this.L.add((0,O.$8N)(this.o,j.EventType.Change,M=>this.hb(M))),this.L.add((0,O.$8N)(this.q.getDomNode(),"scroll",M=>M.target.scrollTop=0)),this.L.add((0,O.$8N)(this.domNode,"dragover",M=>this.jb(this.fb(M)))),this.L.add((0,O.$8N)(this.domNode,"drop",M=>this.lb(this.fb(M)))),this.L.add((0,O.$8N)(this.domNode,"dragleave",M=>this.kb(this.fb(M)))),this.L.add((0,O.$8N)(this.domNode,"dragend",M=>this.mb(M))),this.z=R.setRowLineHeight??s.setRowLineHeight,this.A=R.setRowHeight??s.setRowHeight,this.B=R.supportDynamicHeights??s.supportDynamicHeights,this.F=R.dnd??s.dnd,this.layout(R.initialSize?.height,R.initialSize?.width)}updateOptions(m){m.paddingBottom!==void 0&&(this.C=m.paddingBottom,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),m.smoothScrolling!==void 0&&this.p.setSmoothScrollDuration(m.smoothScrolling?125:0),m.horizontalScrolling!==void 0&&(this.P=m.horizontalScrolling);let $;if(m.scrollByPage!==void 0&&($={...$??{},scrollByPage:m.scrollByPage}),m.mouseWheelScrollSensitivity!==void 0&&($={...$??{},mouseWheelScrollSensitivity:m.mouseWheelScrollSensitivity}),m.fastScrollSensitivity!==void 0&&($={...$??{},fastScrollSensitivity:m.fastScrollSensitivity}),$&&this.q.updateOptions($),m.paddingTop!==void 0&&m.paddingTop!==this.g.paddingTop){const F=this.sb(this.k,this.m),R=m.paddingTop-this.g.paddingTop;this.g.paddingTop=m.paddingTop,this.W(F,Math.max(0,this.k+R),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.S(),this.B&&this.tb(this.k,this.m)}}delegateScrollFromMouseWheelEvent(m){this.q.delegateScrollFromMouseWheelEvent(m)}delegateVerticalScrollbarPointerDown(m){this.q.delegateVerticalScrollbarPointerDown(m)}updateElementHeight(m,$,F){if(m<0||m>=this.d.length)return;const R=this.d[m].size;if(typeof $>"u"){if(!this.B){console.warn("Dynamic heights not supported");return}this.d[m].lastDynamicHeightWidth=void 0,$=R+this.ub(m)}if(R===$)return;const B=this.sb(this.k,this.m);let M=0;m<B.start||F!==null&&F>m&&F<=B.end?M=$-R:M=0,this.g.splice(m,1,[{size:$}]),this.d[m].size=$,this.W(B,Math.max(0,this.k+M),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.S(),this.B&&this.tb(this.k,this.m)}splice(m,$,F=[]){if(this.v)throw new Error("Can't run recursive splices.");this.v=!0;try{return this.R(m,$,F)}finally{this.v=!1,this.M.fire(this.contentHeight)}}R(m,$,F=[]){const R=this.sb(this.k,this.m),B={start:m,end:m+$},M=r.Range.intersect(R,B),z=new Map;for(let ee=M.end-1;ee>=M.start;ee--){const J=this.d[ee];if(J.dragStartDisposable.dispose(),J.checkedDisposable.dispose(),J.row){let S=z.get(J.templateId);S||(S=[],z.set(J.templateId,S));const _=this.j.get(J.templateId);_&&_.disposeElement&&_.disposeElement(J.element,ee,J.row.templateData,J.size),S.push(J.row)}J.row=null}const te={start:m+$,end:this.d.length},ne=r.Range.intersect(te,R),se=r.Range.relativeComplement(te,R),ce=F.map(ee=>({id:String(this.f++),element:ee,templateId:this.Q.getTemplateId(ee),size:this.Q.getHeight(ee),width:void 0,hasDynamicHeight:!!this.Q.hasDynamicHeight&&this.Q.hasDynamicHeight(ee),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:L.$lb.None,checkedDisposable:L.$lb.None}));let ue;m===0&&$>=this.d.length?(this.g=new e.$1P(this.g.paddingTop),this.g.splice(0,0,ce),ue=this.d,this.d=ce):(this.g.splice(m,$,ce),ue=this.d.splice(m,$,...ce));const ae=F.length-$,pe=this.sb(this.k,this.m),Oe=(0,e.$YP)(ne,ae),Te=r.Range.intersect(pe,Oe);for(let ee=Te.start;ee<Te.end;ee++)this.Z(this.d[ee],ee);const Me=r.Range.relativeComplement(Oe,pe);for(const ee of Me)for(let J=ee.start;J<ee.end;J++)this.ab(J);const fe=se.map(ee=>(0,e.$YP)(ee,ae)),K=[{start:m,end:m+F.length},...fe].map(ee=>r.Range.intersect(pe,ee)),U=this.vb(K);for(const ee of K)for(let J=ee.start;J<ee.end;J++){const S=this.d[J],d=z.get(S.templateId)?.pop();this.X(J,U,d)}for(const ee of z.values())for(const J of ee)this.h.release(J);return this.S(),this.B&&this.tb(this.scrollTop,this.renderHeight),ue.map(ee=>ee.element)}S(){this.s=this.contentHeight,this.o.style.height=`${this.s}px`,this.t||(this.t=(0,O.$dO)(()=>{this.q.setScrollDimensions({scrollHeight:this.scrollHeight}),this.V(),this.t=null}))}U(){if(!this.P){this.u.cancel();return}this.u.trigger(()=>this.V())}V(){if(!this.P)return;let m=0;for(const $ of this.d)typeof $.width<"u"&&(m=Math.max(m,$.width));this.E=m,this.q.setScrollDimensions({scrollWidth:m===0?0:m+10}),this.N.fire(this.E)}updateWidth(m){if(!this.P||typeof this.E>"u")return;const $=this.d[m];this.Y($),typeof $.width<"u"&&$.width>this.E&&(this.E=$.width,this.q.setScrollDimensions({scrollWidth:this.E+10}),this.N.fire(this.E))}rerender(){if(this.B){for(const m of this.d)m.lastDynamicHeightWidth=void 0;this.tb(this.k,this.m)}}get length(){return this.d.length}get renderHeight(){return this.q.getScrollDimensions().height}get firstVisibleIndex(){const m=this.sb(this.k,this.m),$=this.g.positionAt(m.start),F=this.g.positionAt(m.start+1);return F!==-1&&(F-$)/2+$<this.scrollTop?m.start+1:m.start}get lastVisibleIndex(){return this.sb(this.k,this.m).end-1}element(m){return this.d[m].element}indexOf(m){return this.d.findIndex($=>$.element===m)}domElement(m){const $=this.d[m].row;return $&&$.domNode}elementHeight(m){return this.d[m].size}elementTop(m){return this.g.positionAt(m)}indexAt(m){return this.g.indexAt(m)}indexAfter(m){return this.g.indexAfter(m)}layout(m,$){const F={height:typeof m=="number"?m:(0,O.$sO)(this.domNode)};this.t&&(this.t.dispose(),this.t=null,F.scrollHeight=this.scrollHeight),this.q.setScrollDimensions(F),typeof $<"u"&&(this.n=$,this.B&&this.tb(this.scrollTop,this.renderHeight)),this.P&&this.q.setScrollDimensions({width:typeof $=="number"?$:(0,O.$qO)(this.domNode)})}W(m,$,F,R,B,M=!1){const z=this.sb($,F),te=r.Range.relativeComplement(z,m),ne=r.Range.relativeComplement(m,z),se=this.vb(te);if(M){const ce=r.Range.intersect(m,z);for(let ue=ce.start;ue<ce.end;ue++)this.Z(this.d[ue],ue)}this.h.transact(()=>{for(const ce of ne)for(let ue=ce.start;ue<ce.end;ue++)this.ab(ue);for(const ce of te)for(let ue=ce.start;ue<ce.end;ue++)this.X(ue,se)}),R!==void 0&&(this.o.style.left=`-${R}px`),this.o.style.top=`-${$}px`,this.P&&B!==void 0&&(this.o.style.width=`${Math.max(B,this.n)}px`),this.k=$,this.m=F}X(m,$,F){const R=this.d[m];let B=!1;if(!R.row)if(F)R.row=F;else{const se=this.h.alloc(R.templateId);R.row=se.row,B=se.isReusingConnectedDomNode}const M=this.D.getRole(R.element)||"listitem";R.row.domNode.setAttribute("role",M);const z=this.D.isChecked(R.element);if(typeof z=="boolean")R.row.domNode.setAttribute("aria-checked",String(!!z));else if(z){const se=ce=>R.row.domNode.setAttribute("aria-checked",String(!!ce));se(z.value),R.checkedDisposable=z.onDidChange(se)}(B||!R.row.domNode.parentElement)&&($?this.o.insertBefore(R.row.domNode,$):this.o.appendChild(R.row.domNode)),this.Z(R,m);const te=this.j.get(R.templateId);if(!te)throw new Error(`No renderer found for template id ${R.templateId}`);te?.renderElement(R.element,m,R.row.templateData,R.size);const ne=this.F.getDragURI(R.element);R.dragStartDisposable.dispose(),R.row.domNode.draggable=!!ne,ne&&(R.dragStartDisposable=(0,O.$8N)(R.row.domNode,"dragstart",se=>this.ib(R.element,ne,se))),this.P&&(this.Y(R),this.U())}Y(m){if(!m.row||!m.row.domNode)return;m.row.domNode.style.width="fit-content",m.width=(0,O.$qO)(m.row.domNode);const $=window.getComputedStyle(m.row.domNode);$.paddingLeft&&(m.width+=parseFloat($.paddingLeft)),$.paddingRight&&(m.width+=parseFloat($.paddingRight)),m.row.domNode.style.width=""}Z(m,$){m.row.domNode.style.top=`${this.elementTop($)}px`,this.A&&(m.row.domNode.style.height=`${m.size}px`),this.z&&(m.row.domNode.style.lineHeight=`${m.size}px`),m.row.domNode.setAttribute("data-index",`${$}`),m.row.domNode.setAttribute("data-last-element",$===this.length-1?"true":"false"),m.row.domNode.setAttribute("data-parity",$%2===0?"even":"odd"),m.row.domNode.setAttribute("aria-setsize",String(this.D.getSetSize(m.element,$,this.length))),m.row.domNode.setAttribute("aria-posinset",String(this.D.getPosInSet(m.element,$))),m.row.domNode.setAttribute("id",this.getElementDomId($)),m.row.domNode.classList.toggle("drop-target",m.dropTarget)}ab(m){const $=this.d[m];if($.dragStartDisposable.dispose(),$.checkedDisposable.dispose(),$.row){const F=this.j.get($.templateId);F&&F.disposeElement&&F.disposeElement($.element,m,$.row.templateData,$.size),this.h.release($.row),$.row=null}this.P&&this.U()}getScrollTop(){return this.q.getScrollPosition().scrollTop}setScrollTop(m,$){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),this.q.setScrollPosition({scrollTop:m,reuseAnimation:$})}getScrollLeft(){return this.q.getScrollPosition().scrollLeft}setScrollLeft(m){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollWidth:this.E})),this.q.setScrollPosition({scrollLeft:m})}get scrollTop(){return this.getScrollTop()}set scrollTop(m){this.setScrollTop(m)}get scrollHeight(){return this.s+(this.P?10:0)+this.C}get onMouseClick(){return g.Event.map(this.L.add(new i.$PP(this.domNode,"click")).event,m=>this.bb(m),this.L)}get onMouseDblClick(){return g.Event.map(this.L.add(new i.$PP(this.domNode,"dblclick")).event,m=>this.bb(m),this.L)}get onMouseMiddleClick(){return g.Event.filter(g.Event.map(this.L.add(new i.$PP(this.domNode,"auxclick")).event,m=>this.bb(m),this.L),m=>m.browserEvent.button===1,this.L)}get onMouseUp(){return g.Event.map(this.L.add(new i.$PP(this.domNode,"mouseup")).event,m=>this.bb(m),this.L)}get onMouseDown(){return g.Event.map(this.L.add(new i.$PP(this.domNode,"mousedown")).event,m=>this.bb(m),this.L)}get onMouseOver(){return g.Event.map(this.L.add(new i.$PP(this.domNode,"mouseover")).event,m=>this.bb(m),this.L)}get onMouseMove(){return g.Event.map(this.L.add(new i.$PP(this.domNode,"mousemove")).event,m=>this.bb(m),this.L)}get onMouseOut(){return g.Event.map(this.L.add(new i.$PP(this.domNode,"mouseout")).event,m=>this.bb(m),this.L)}get onContextMenu(){return g.Event.any(g.Event.map(this.L.add(new i.$PP(this.domNode,"contextmenu")).event,m=>this.bb(m),this.L),g.Event.map(this.L.add(new i.$PP(this.domNode,j.EventType.Contextmenu)).event,m=>this.eb(m),this.L))}get onTouchStart(){return g.Event.map(this.L.add(new i.$PP(this.domNode,"touchstart")).event,m=>this.db(m),this.L)}get onTap(){return g.Event.map(this.L.add(new i.$PP(this.o,j.EventType.Tap)).event,m=>this.eb(m),this.L)}bb(m){const $=this.rb(m.target||null),F=typeof $>"u"?void 0:this.d[$],R=F&&F.element;return{browserEvent:m,index:$,element:R}}db(m){const $=this.rb(m.target||null),F=typeof $>"u"?void 0:this.d[$],R=F&&F.element;return{browserEvent:m,index:$,element:R}}eb(m){const $=this.rb(m.initialTarget||null),F=typeof $>"u"?void 0:this.d[$],R=F&&F.element;return{browserEvent:m,index:$,element:R}}fb(m){const $=this.rb(m.target||null),F=typeof $>"u"?void 0:this.d[$],R=F&&F.element;return{browserEvent:m,index:$,element:R}}gb(m){try{const $=this.sb(this.k,this.m);this.W($,m.scrollTop,m.height,m.scrollLeft,m.scrollWidth),this.B&&this.tb(m.scrollTop,m.height,m.inSmoothScrolling)}catch($){throw console.error("Got bad scroll event:",m),$}}hb(m){m.preventDefault(),m.stopPropagation(),this.scrollTop-=m.translationY}ib(m,$,F){if(!F.dataTransfer)return;const R=this.F.getDragElements(m);if(F.dataTransfer.effectAllowed="copyMove",F.dataTransfer.setData(N.$jP.TEXT,$),F.dataTransfer.setDragImage){let B;this.F.getDragLabel&&(B=this.F.getDragLabel(R,F)),typeof B>"u"&&(B=String(R.length));const M=(0,O.$)(".monaco-drag-image");M.textContent=B;const te=(ne=>{for(;ne&&!ne.classList.contains("monaco-workbench");)ne=ne.parentElement;return ne||document.body})(this.domNode);te.appendChild(M),F.dataTransfer.setDragImage(M,-10,-10),setTimeout(()=>te.removeChild(M),0)}this.domNode.classList.add("dragging"),this.H=new v(R),h.CurrentDragAndDropData=new D(R),this.F.onDragStart?.(this.H,F)}jb(m){if(m.browserEvent.preventDefault(),this.K.dispose(),h.CurrentDragAndDropData&&h.CurrentDragAndDropData.getData()==="vscode-ui"||(this.ob(m.browserEvent),!m.browserEvent.dataTransfer))return!1;if(!this.H)if(h.CurrentDragAndDropData)this.H=h.CurrentDragAndDropData;else{if(!m.browserEvent.dataTransfer.types)return!1;this.H=new E}const $=this.F.onDragOver(this.H,m.element,m.index,m.browserEvent);if(this.G=typeof $=="boolean"?$:$.accept,!this.G)return this.I=void 0,this.J.dispose(),!1;m.browserEvent.dataTransfer.dropEffect=typeof $!="boolean"&&$.effect===0?"copy":"move";let F;if(typeof $!="boolean"&&$.feedback?F=$.feedback:typeof m.index>"u"?F=[-1]:F=[m.index],F=(0,y.$of)(F).filter(R=>R>=-1&&R<this.length).sort((R,B)=>R-B),F=F[0]===-1?[-1]:F,f(this.I,F))return!0;if(this.I=F,this.J.dispose(),F[0]===-1)this.domNode.classList.add("drop-target"),this.o.classList.add("drop-target"),this.J=(0,L.$jb)(()=>{this.domNode.classList.remove("drop-target"),this.o.classList.remove("drop-target")});else{for(const R of F){const B=this.d[R];B.dropTarget=!0,B.row?.domNode.classList.add("drop-target")}this.J=(0,L.$jb)(()=>{for(const R of F){const B=this.d[R];B.dropTarget=!1,B.row?.domNode.classList.remove("drop-target")}})}return!0}kb(m){this.K.dispose(),this.K=(0,o.$wg)(()=>this.nb(),100),this.H&&this.F.onDragLeave?.(this.H,m.element,m.index,m.browserEvent)}lb(m){if(!this.G)return;const $=this.H;this.qb(),this.nb(),this.domNode.classList.remove("dragging"),this.H=void 0,h.CurrentDragAndDropData=void 0,!(!$||!m.browserEvent.dataTransfer)&&(m.browserEvent.preventDefault(),$.update(m.browserEvent.dataTransfer),this.F.drop($,m.element,m.index,m.browserEvent))}mb(m){this.G=!1,this.qb(),this.nb(),this.domNode.classList.remove("dragging"),this.H=void 0,h.CurrentDragAndDropData=void 0,this.F.onDragEnd?.(m)}nb(){this.I=void 0,this.J.dispose(),this.J=L.$lb.None}ob(m){if(!this.w){const $=(0,O.$kO)(this.domNode).top;this.w=(0,O.$6O)(this.pb.bind(this,$))}this.x.dispose(),this.x=(0,o.$wg)(()=>{this.w&&(this.w.dispose(),this.w=void 0)},1e3),this.y=m.pageY}pb(m){if(this.y===void 0)return;const $=this.y-m,F=this.renderHeight-35;$<35?this.scrollTop+=Math.max(-14,Math.floor(.3*($-35))):$>F&&(this.scrollTop+=Math.min(14,Math.floor(.3*($-F))))}qb(){this.x.dispose(),this.w&&(this.w.dispose(),this.w=void 0)}rb(m){const $=this.q.getDomNode();let F=m;for(;F instanceof HTMLElement&&F!==this.o&&$.contains(F);){const R=F.getAttribute("data-index");if(R){const B=Number(R);if(!isNaN(B))return B}F=F.parentElement}}sb(m,$){return{start:this.g.indexAt(m),end:this.g.indexAfter(m+$-1)}}tb(m,$,F){const R=this.sb(m,$);let B,M;m===this.elementTop(R.start)?(B=R.start,M=0):R.end-R.start>1&&(B=R.start+1,M=this.elementTop(B)-m);let z=0;for(;;){const te=this.sb(m,$);let ne=!1;for(let se=te.start;se<te.end;se++){const ce=this.ub(se);ce!==0&&this.g.splice(se,1,[this.d[se]]),z+=ce,ne=ne||ce!==0}if(!ne){z!==0&&this.S();const se=r.Range.relativeComplement(R,te);for(const ue of se)for(let ae=ue.start;ae<ue.end;ae++)this.d[ae].row&&this.ab(ae);const ce=r.Range.relativeComplement(te,R);for(const ue of ce)for(let ae=ue.start;ae<ue.end;ae++){const pe=ae+1,Oe=pe<this.d.length?this.d[pe].row:null,Te=Oe?Oe.domNode:null;this.X(ae,Te)}for(let ue=te.start;ue<te.end;ue++)this.d[ue].row&&this.Z(this.d[ue],ue);if(typeof B=="number"){const ue=this.p.getFutureScrollPosition().scrollTop-m,ae=this.elementTop(B)-M+ue;this.setScrollTop(ae,F)}this.M.fire(this.contentHeight);return}}}ub(m){const $=this.d[m];if(this.Q.getDynamicHeight){const M=this.Q.getDynamicHeight($.element);if(M!==null){const z=$.size;return $.size=M,$.lastDynamicHeightWidth=this.n,M-z}}if(!$.hasDynamicHeight||$.lastDynamicHeightWidth===this.n||this.Q.hasDynamicHeight&&!this.Q.hasDynamicHeight($.element))return 0;const F=$.size;if($.row)return $.row.domNode.style.height="",$.size=$.row.domNode.offsetHeight,$.lastDynamicHeightWidth=this.n,$.size-F;const{row:R}=this.h.alloc($.templateId);R.domNode.style.height="",this.o.appendChild(R.domNode);const B=this.j.get($.templateId);if(!B)throw new n.$bb("Missing renderer for templateId: "+$.templateId);return B.renderElement($.element,m,R.templateData,void 0),$.size=R.domNode.offsetHeight,B.disposeElement?.($.element,m,R.templateData,void 0),this.Q.setDynamicHeight?.($.element,$.size),$.lastDynamicHeightWidth=this.n,this.o.removeChild(R.domNode),this.h.release(R),$.size-F}vb(m){const $=m[m.length-1];if(!$)return null;const F=this.d[$.end];return!F||!F.row?null:F.row.domNode}getElementDomId(m){return`${this.domId}_${m}`}dispose(){if(this.d){for(const m of this.d)if(m.row){const $=this.j.get(m.row.templateId);$&&($.disposeElement?.(m.element,-1,m.row.templateData,void 0),$.disposeTemplate(m.row.templateData))}this.d=[]}this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),(0,L.$gb)(this.L)}}t.$6P=T,xe([u.$Tg],T.prototype,"onMouseClick",null),xe([u.$Tg],T.prototype,"onMouseDblClick",null),xe([u.$Tg],T.prototype,"onMouseMiddleClick",null),xe([u.$Tg],T.prototype,"onMouseUp",null),xe([u.$Tg],T.prototype,"onMouseDown",null),xe([u.$Tg],T.prototype,"onMouseOver",null),xe([u.$Tg],T.prototype,"onMouseMove",null),xe([u.$Tg],T.prototype,"onMouseOut",null),xe([u.$Tg],T.prototype,"onContextMenu",null),xe([u.$Tg],T.prototype,"onTouchStart",null),xe([u.$Tg],T.prototype,"onTap",null)}),define(be[37],$e([1,0,4,21,14,23,54,68,13,9,70,25,3,32,2,44,5,7,67,58,19,94]),function(re,t,N,O,i,j,A,y,o,u,g,L,r,l,e,a,n,h,s,v,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dQ=t.$cQ=t.$bQ=t.$aQ=t.$_P=t.$$P=t.$0P=t.TypeNavigationMode=t.$9P=t.$8P=t.$7P=void 0;class E{constructor(S){this.d=S,this.c=[]}get templateId(){return`template:${this.d.name}`}renderTemplate(S){return S}renderElement(S,_,d){const p=this.c.findIndex(H=>H.templateData===d);if(p>=0){const H=this.c[p];this.d.unrender(d),H.index=_}else{const H={index:_,templateData:d};this.c.push(H)}this.d.renderIndex(_,d)}splice(S,_,d){const p=[];for(const H of this.c)H.index<S?p.push(H):H.index>=S+_&&p.push({index:H.index+d-_,templateData:H.templateData});this.c=p}renderIndexes(S){for(const{index:_,templateData:d}of this.c)S.indexOf(_)>-1&&this.d.renderIndex(_,d)}disposeTemplate(S){const _=this.c.findIndex(d=>d.templateData===S);_<0||this.c.splice(_,1)}}class f{get name(){return this.h}get renderer(){return new E(this)}constructor(S){this.h=S,this.c=0,this.d=[],this.f=[],this.g=new r.$ec,this.onChange=this.g.event}splice(S,_,d){_=Math.max(0,Math.min(_,this.c-S));const p=d.length-_,H=S+_,Q=[];let q=0;for(;q<this.f.length&&this.f[q]<S;)Q.push(this.f[q++]);for(let W=0;W<d.length;W++)d[W]&&Q.push(W+S);for(;q<this.f.length&&this.f[q]>=H;)Q.push(this.f[q++]+p);const x=this.c+p;if(this.f.length>0&&Q.length===0&&x>0){const W=this.f.find(c=>c>=S)??x-1;Q.push(Math.min(W,x-1))}this.renderer.splice(S,_,d.length),this.k(Q,Q),this.c=x}renderIndex(S,_){_.classList.toggle(this.h,this.contains(S))}unrender(S){S.classList.remove(this.h)}set(S,_){return this.k(S,[...S].sort(fe),_)}k(S,_,d){const p=this.d,H=this.f;this.d=S,this.f=_;const Q=Te(H,S);return this.renderer.renderIndexes(Q),this.g.fire({indexes:S,browserEvent:d}),p}get(){return this.d}contains(S){return(0,o.$af)(this.f,S,fe)>=0}dispose(){(0,e.$gb)(this.g)}}xe([L.$Tg],f.prototype,"renderer",null);class C extends f{constructor(S){super("selected"),this.l=S}renderIndex(S,_){super.renderIndex(S,_),this.l&&(this.contains(S)?_.setAttribute("aria-selected","true"):_.setAttribute("aria-selected","false"))}}class T{constructor(S,_,d){this.c=S,this.d=_,this.f=d}splice(S,_,d){if(!this.f)return this.c.splice(S,_,new Array(d.length).fill(!1));const p=this.c.get().map(q=>this.f.getId(this.d.element(q)).toString());if(p.length===0)return this.c.splice(S,_,new Array(d.length).fill(!1));const H=new Set(p),Q=d.map(q=>H.has(this.f.getId(q).toString()));this.c.splice(S,_,Q)}}function P(J){return J.tagName==="INPUT"||J.tagName==="TEXTAREA"}t.$7P=P;function m(J){return J.classList.contains("monaco-editor")?!0:J.classList.contains("monaco-list")||!J.parentElement?!1:m(J.parentElement)}t.$8P=m;function $(J){return J.tagName==="A"&&J.classList.contains("monaco-button")||J.tagName==="DIV"&&J.classList.contains("monaco-button-dropdown")?!0:J.classList.contains("monaco-list")||!J.parentElement?!1:$(J.parentElement)}t.$9P=$;class F{get f(){return this.c.add(r.Event.chain(this.c.add(new O.$PP(this.h.domNode,"keydown")).event).filter(S=>!P(S.target)).map(S=>new i.$5N(S)))}constructor(S,_,d){this.g=S,this.h=_,this.c=new e.$kb,this.d=new e.$kb,this.f.filter(p=>p.keyCode===3).on(this.k,this,this.c),this.f.filter(p=>p.keyCode===16).on(this.l,this,this.c),this.f.filter(p=>p.keyCode===18).on(this.o,this,this.c),this.f.filter(p=>p.keyCode===11).on(this.p,this,this.c),this.f.filter(p=>p.keyCode===12).on(this.q,this,this.c),this.f.filter(p=>p.keyCode===9).on(this.t,this,this.c),d.multipleSelectionSupport!==!1&&this.f.filter(p=>(n.$j?p.metaKey:p.ctrlKey)&&p.keyCode===31).on(this.s,this,this.d)}updateOptions(S){S.multipleSelectionSupport!==void 0&&(this.d.clear(),S.multipleSelectionSupport&&this.f.filter(_=>(n.$j?_.metaKey:_.ctrlKey)&&_.keyCode===31).on(this.s,this,this.d))}k(S){S.preventDefault(),S.stopPropagation(),this.g.setSelection(this.g.getFocus(),S.browserEvent)}l(S){S.preventDefault(),S.stopPropagation(),this.g.focusPrevious(1,!1,S.browserEvent);const _=this.g.getFocus()[0];this.g.setAnchor(_),this.g.reveal(_),this.h.domNode.focus()}o(S){S.preventDefault(),S.stopPropagation(),this.g.focusNext(1,!1,S.browserEvent);const _=this.g.getFocus()[0];this.g.setAnchor(_),this.g.reveal(_),this.h.domNode.focus()}p(S){S.preventDefault(),S.stopPropagation(),this.g.focusPreviousPage(S.browserEvent);const _=this.g.getFocus()[0];this.g.setAnchor(_),this.g.reveal(_),this.h.domNode.focus()}q(S){S.preventDefault(),S.stopPropagation(),this.g.focusNextPage(S.browserEvent);const _=this.g.getFocus()[0];this.g.setAnchor(_),this.g.reveal(_),this.h.domNode.focus()}s(S){S.preventDefault(),S.stopPropagation(),this.g.setSelection((0,o.$wf)(this.g.length),S.browserEvent),this.g.setAnchor(void 0),this.h.domNode.focus()}t(S){this.g.getSelection().length&&(S.preventDefault(),S.stopPropagation(),this.g.setSelection([],S.browserEvent),this.g.setAnchor(void 0),this.h.domNode.focus())}dispose(){this.c.dispose(),this.d.dispose()}}xe([L.$Tg],F.prototype,"f",null);var R;(function(J){J[J.Automatic=0]="Automatic",J[J.Trigger=1]="Trigger"})(R||(t.TypeNavigationMode=R={}));var B;(function(J){J[J.Idle=0]="Idle",J[J.Typing=1]="Typing"})(B||(B={})),t.$0P=new class{mightProducePrintableCharacter(J){return J.ctrlKey||J.metaKey||J.altKey?!1:J.keyCode>=31&&J.keyCode<=56||J.keyCode>=21&&J.keyCode<=30||J.keyCode>=98&&J.keyCode<=107||J.keyCode>=85&&J.keyCode<=95}};class M{constructor(S,_,d,p,H){this.o=S,this.p=_,this.q=d,this.s=p,this.t=H,this.c=!1,this.d=B.Idle,this.f=R.Automatic,this.g=!1,this.h=-1,this.k=new e.$kb,this.l=new e.$kb,this.updateOptions(S.options)}updateOptions(S){S.typeNavigationEnabled??!0?this.u():this.v(),this.f=S.typeNavigationMode??R.Automatic}trigger(){this.g=!this.g}u(){if(this.c)return;let S=!1;const _=this.k.add(r.Event.chain(this.k.add(new O.$PP(this.p.domNode,"keydown")).event)).filter(H=>!P(H.target)).filter(()=>this.f===R.Automatic||this.g).map(H=>new i.$5N(H)).filter(H=>S||this.s(H)).filter(H=>this.t.mightProducePrintableCharacter(H)).forEach(H=>N.$LO.stop(H,!0)).map(H=>H.browserEvent.key).event,d=r.Event.debounce(_,()=>null,800,void 0,void 0,void 0,this.k);r.Event.reduce(r.Event.any(_,d),(H,Q)=>Q===null?null:(H||"")+Q,void 0,this.k)(this.x,this,this.k),d(this.w,this,this.k),_(()=>S=!0,void 0,this.k),d(()=>S=!1,void 0,this.k),this.c=!0,this.g=!1}v(){this.c&&(this.k.clear(),this.c=!1,this.g=!1)}w(){const S=this.o.getFocus();if(S.length>0&&S[0]===this.h){const _=this.o.options.accessibilityProvider?.getAriaLabel(this.o.element(S[0]));_&&(0,A.$RP)(_)}this.h=-1}x(S){if(!S){this.d=B.Idle,this.g=!1;return}const _=this.o.getFocus(),d=_.length>0?_[0]:0,p=this.d===B.Idle?1:0;this.d=B.Typing;for(let H=0;H<this.o.length;H++){const Q=(d+H+p)%this.o.length,q=this.q.getKeyboardNavigationLabel(this.p.element(Q)),x=q&&q.toString();if(this.o.options.typeNavigationEnabled){if(typeof x<"u"){const W=(0,l.$lj)(S,x),c=(0,l.$sj)(S,x);if(c){const k=c[0].end-c[0].start;if(W||k>1&&c.length===1){this.h=d,this.o.setFocus([Q]),this.o.reveal(Q);return}}}}else if(typeof x>"u"||(0,l.$lj)(S,x)){this.h=d,this.o.setFocus([Q]),this.o.reveal(Q);return}}}dispose(){this.v(),this.k.dispose(),this.l.dispose()}}class z{constructor(S,_){this.d=S,this.f=_,this.c=new e.$kb,this.c.add(r.Event.chain(this.c.add(new O.$PP(_.domNode,"keydown")).event)).filter(p=>!P(p.target)).map(p=>new i.$5N(p)).filter(p=>p.keyCode===2&&!p.ctrlKey&&!p.metaKey&&!p.shiftKey&&!p.altKey).on(this.g,this,this.c)}g(S){if(S.target!==this.f.domNode)return;const _=this.d.getFocus();if(_.length===0)return;const d=this.f.domElement(_[0]);if(!d)return;const p=d.querySelector("[tabIndex]");if(!p||!(p instanceof HTMLElement)||p.tabIndex===-1)return;const H=window.getComputedStyle(p);H.visibility==="hidden"||H.display==="none"||(S.preventDefault(),S.stopPropagation(),p.focus())}dispose(){this.c.dispose()}}function te(J){return n.$j?J.browserEvent.metaKey:J.browserEvent.ctrlKey}t.$$P=te;function ne(J){return J.browserEvent.shiftKey}t.$_P=ne;function se(J){return J instanceof MouseEvent&&J.button===2}const ce={isSelectionSingleChangeEvent:te,isSelectionRangeChangeEvent:ne};class ue{constructor(S){this.k=S,this.f=new e.$kb,this.g=new r.$ec,this.onPointer=this.g.event,S.options.multipleSelectionSupport!==!1&&(this.c=this.k.options.multipleSelectionController||ce),this.d=typeof S.options.mouseSupport>"u"||!!S.options.mouseSupport,this.d&&(S.onMouseDown(this.s,this,this.f),S.onContextMenu(this.t,this,this.f),S.onMouseDblClick(this.v,this,this.f),S.onTouchStart(this.s,this,this.f),this.f.add(j.$lP.addTarget(S.getHTMLElement()))),r.Event.any(S.onMouseClick,S.onMouseMiddleClick,S.onTap)(this.u,this,this.f)}updateOptions(S){S.multipleSelectionSupport!==void 0&&(this.c=void 0,S.multipleSelectionSupport&&(this.c=this.k.options.multipleSelectionController||ce))}o(S){return this.c?this.c.isSelectionSingleChangeEvent(S):!1}p(S){return this.c?this.c.isSelectionRangeChangeEvent(S):!1}q(S){return this.o(S)||this.p(S)}s(S){m(S.browserEvent.target)||document.activeElement!==S.browserEvent.target&&this.k.domFocus()}t(S){if(P(S.browserEvent.target)||m(S.browserEvent.target))return;const _=typeof S.index>"u"?[]:[S.index];this.k.setFocus(_,S.browserEvent)}u(S){if(!this.d||P(S.browserEvent.target)||m(S.browserEvent.target)||S.browserEvent.isHandledByList)return;S.browserEvent.isHandledByList=!0;const _=S.index;if(typeof _>"u"){this.k.setFocus([],S.browserEvent),this.k.setSelection([],S.browserEvent),this.k.setAnchor(void 0);return}if(this.q(S))return this.w(S);this.k.setFocus([_],S.browserEvent),this.k.setAnchor(_),se(S.browserEvent)||this.k.setSelection([_],S.browserEvent),this.g.fire(S)}v(S){if(P(S.browserEvent.target)||m(S.browserEvent.target)||this.q(S)||S.browserEvent.isHandledByList)return;S.browserEvent.isHandledByList=!0;const _=this.k.getFocus();this.k.setSelection(_,S.browserEvent)}w(S){const _=S.index;let d=this.k.getAnchor();if(this.p(S)){typeof d>"u"&&(d=this.k.getFocus()[0]??_,this.k.setAnchor(d));const p=Math.min(d,_),H=Math.max(d,_),Q=(0,o.$wf)(p,H+1),q=this.k.getSelection(),x=Oe(Te(q,[d]),d);if(x.length===0)return;const W=Te(Q,Me(q,x));this.k.setSelection(W,S.browserEvent),this.k.setFocus([_],S.browserEvent)}else if(this.o(S)){const p=this.k.getSelection(),H=p.filter(Q=>Q!==_);this.k.setFocus([_]),this.k.setAnchor(_),p.length===H.length?this.k.setSelection([...H,_],S.browserEvent):this.k.setSelection(H,S.browserEvent)}}dispose(){this.f.dispose()}}t.$aQ=ue;class ae{constructor(S,_){this.c=S,this.d=_}style(S){const _=this.d&&`.${this.d}`,d=[];S.listBackground&&d.push(`.monaco-list${_} .monaco-list-rows { background: ${S.listBackground}; }`),S.listFocusBackground&&(d.push(`.monaco-list${_}:focus .monaco-list-row.focused { background-color: ${S.listFocusBackground}; }`),d.push(`.monaco-list${_}:focus .monaco-list-row.focused:hover { background-color: ${S.listFocusBackground}; }`)),S.listFocusForeground&&d.push(`.monaco-list${_}:focus .monaco-list-row.focused { color: ${S.listFocusForeground}; }`),S.listActiveSelectionBackground&&(d.push(`.monaco-list${_}:focus .monaco-list-row.selected { background-color: ${S.listActiveSelectionBackground}; }`),d.push(`.monaco-list${_}:focus .monaco-list-row.selected:hover { background-color: ${S.listActiveSelectionBackground}; }`)),S.listActiveSelectionForeground&&d.push(`.monaco-list${_}:focus .monaco-list-row.selected { color: ${S.listActiveSelectionForeground}; }`),S.listActiveSelectionIconForeground&&d.push(`.monaco-list${_}:focus .monaco-list-row.selected .codicon { color: ${S.listActiveSelectionIconForeground}; }`),S.listFocusAndSelectionBackground&&d.push(`
				.monaco-drag-image,
				.monaco-list${_}:focus .monaco-list-row.selected.focused { background-color: ${S.listFocusAndSelectionBackground}; }
			`),S.listFocusAndSelectionForeground&&d.push(`
				.monaco-drag-image,
				.monaco-list${_}:focus .monaco-list-row.selected.focused { color: ${S.listFocusAndSelectionForeground}; }
			`),S.listInactiveFocusForeground&&(d.push(`.monaco-list${_} .monaco-list-row.focused { color:  ${S.listInactiveFocusForeground}; }`),d.push(`.monaco-list${_} .monaco-list-row.focused:hover { color:  ${S.listInactiveFocusForeground}; }`)),S.listInactiveSelectionIconForeground&&d.push(`.monaco-list${_} .monaco-list-row.focused .codicon { color:  ${S.listInactiveSelectionIconForeground}; }`),S.listInactiveFocusBackground&&(d.push(`.monaco-list${_} .monaco-list-row.focused { background-color:  ${S.listInactiveFocusBackground}; }`),d.push(`.monaco-list${_} .monaco-list-row.focused:hover { background-color:  ${S.listInactiveFocusBackground}; }`)),S.listInactiveSelectionBackground&&(d.push(`.monaco-list${_} .monaco-list-row.selected { background-color:  ${S.listInactiveSelectionBackground}; }`),d.push(`.monaco-list${_} .monaco-list-row.selected:hover { background-color:  ${S.listInactiveSelectionBackground}; }`)),S.listInactiveSelectionForeground&&d.push(`.monaco-list${_} .monaco-list-row.selected { color: ${S.listInactiveSelectionForeground}; }`),S.listHoverBackground&&d.push(`.monaco-list${_}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${S.listHoverBackground}; }`),S.listHoverForeground&&d.push(`.monaco-list${_}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${S.listHoverForeground}; }`);const p=(0,N.$9O)(S.listFocusAndSelectionOutline,(0,N.$9O)(S.listSelectionOutline,S.listFocusOutline??""));p&&d.push(`.monaco-list${_}:focus .monaco-list-row.focused.selected { outline: 1px solid ${p}; outline-offset: -1px;}`),S.listFocusOutline&&d.push(`
				.monaco-drag-image,
				.monaco-list${_}:focus .monaco-list-row.focused { outline: 1px solid ${S.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${_}.last-focused .monaco-list-row.focused { outline: 1px solid ${S.listFocusOutline}; outline-offset: -1px; }
			`);const H=(0,N.$9O)(S.listSelectionOutline,S.listInactiveFocusOutline??"");H&&d.push(`.monaco-list${_} .monaco-list-row.focused.selected { outline: 1px dotted ${H}; outline-offset: -1px; }`),S.listSelectionOutline&&d.push(`.monaco-list${_} .monaco-list-row.selected { outline: 1px dotted ${S.listSelectionOutline}; outline-offset: -1px; }`),S.listInactiveFocusOutline&&d.push(`.monaco-list${_} .monaco-list-row.focused { outline: 1px dotted ${S.listInactiveFocusOutline}; outline-offset: -1px; }`),S.listHoverOutline&&d.push(`.monaco-list${_} .monaco-list-row:hover { outline: 1px dashed ${S.listHoverOutline}; outline-offset: -1px; }`),S.listDropBackground&&d.push(`
				.monaco-list${_}.drop-target,
				.monaco-list${_} .monaco-list-rows.drop-target,
				.monaco-list${_} .monaco-list-row.drop-target { background-color: ${S.listDropBackground} !important; color: inherit !important; }
			`),S.tableColumnsBorder&&d.push(`
				.monaco-table > .monaco-split-view2,
				.monaco-table > .monaco-split-view2 .monaco-sash.vertical::before,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${S.tableColumnsBorder};
				}

				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: transparent;
				}
			`),S.tableOddRowsBackgroundColor&&d.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${S.tableOddRowsBackgroundColor};
				}
			`),this.c.textContent=d.join(`
`)}}t.$bQ=ae,t.$cQ={listFocusBackground:"#7FB0D0",listActiveSelectionBackground:"#0E639C",listActiveSelectionForeground:"#FFFFFF",listActiveSelectionIconForeground:"#FFFFFF",listFocusAndSelectionOutline:"#90C2F9",listFocusAndSelectionBackground:"#094771",listFocusAndSelectionForeground:"#FFFFFF",listInactiveSelectionBackground:"#3F3F46",listInactiveSelectionIconForeground:"#FFFFFF",listHoverBackground:"#2A2D2E",listDropBackground:"#383B3D",treeIndentGuidesStroke:"#a9a9a9",treeInactiveIndentGuidesStroke:g.$ds.fromHex("#a9a9a9").transparent(.4).toString(),tableColumnsBorder:g.$ds.fromHex("#cccccc").transparent(.2).toString(),tableOddRowsBackgroundColor:g.$ds.fromHex("#cccccc").transparent(.04).toString(),listBackground:void 0,listFocusForeground:void 0,listInactiveSelectionForeground:void 0,listInactiveFocusForeground:void 0,listInactiveFocusBackground:void 0,listHoverForeground:void 0,listFocusOutline:void 0,listInactiveFocusOutline:void 0,listSelectionOutline:void 0,listHoverOutline:void 0};const pe={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){}}};function Oe(J,S){const _=J.indexOf(S);if(_===-1)return[];const d=[];let p=_-1;for(;p>=0&&J[p]===S-(_-p);)d.push(J[p--]);for(d.reverse(),p=_;p<J.length&&J[p]===S+(p-_);)d.push(J[p++]);return d}function Te(J,S){const _=[];let d=0,p=0;for(;d<J.length||p<S.length;)if(d>=J.length)_.push(S[p++]);else if(p>=S.length)_.push(J[d++]);else if(J[d]===S[p]){_.push(J[d]),d++,p++;continue}else J[d]<S[p]?_.push(J[d++]):_.push(S[p++]);return _}function Me(J,S){const _=[];let d=0,p=0;for(;d<J.length||p<S.length;)if(d>=J.length)_.push(S[p++]);else if(p>=S.length)_.push(J[d++]);else if(J[d]===S[p]){d++,p++;continue}else J[d]<S[p]?_.push(J[d++]):p++;return _}const fe=(J,S)=>J-S;class ie{constructor(S,_){this.c=S,this.d=_}get templateId(){return this.c}renderTemplate(S){return this.d.map(_=>_.renderTemplate(S))}renderElement(S,_,d,p){let H=0;for(const Q of this.d)Q.renderElement(S,_,d[H++],p)}disposeElement(S,_,d,p){let H=0;for(const Q of this.d)Q.disposeElement?.(S,_,d[H],p),H+=1}disposeTemplate(S){let _=0;for(const d of this.d)d.disposeTemplate(S[_++])}}class K{constructor(S){this.c=S,this.templateId="a18n"}renderTemplate(S){return S}renderElement(S,_,d){const p=this.c.getAriaLabel(S);p?d.setAttribute("aria-label",p):d.removeAttribute("aria-label");const H=this.c.getAriaLevel&&this.c.getAriaLevel(S);typeof H=="number"?d.setAttribute("aria-level",`${H}`):d.removeAttribute("aria-level")}disposeTemplate(S){}}class U{constructor(S,_){this.c=S,this.d=_}getDragElements(S){const _=this.c.getSelectedElements();return _.indexOf(S)>-1?_:[S]}getDragURI(S){return this.d.getDragURI(S)}getDragLabel(S,_){if(this.d.getDragLabel)return this.d.getDragLabel(S,_)}onDragStart(S,_){this.d.onDragStart?.(S,_)}onDragOver(S,_,d,p){return this.d.onDragOver(S,_,d,p)}onDragLeave(S,_,d,p){this.d.onDragLeave?.(S,_,d,p)}onDragEnd(S){this.d.onDragEnd?.(S)}drop(S,_,d,p){this.d.drop(S,_,d,p)}}class ee{get onDidChangeFocus(){return r.Event.map(this.g.wrapEvent(this.c.onChange),S=>this.G(S),this.y)}get onDidChangeSelection(){return r.Event.map(this.g.wrapEvent(this.d.onChange),S=>this.G(S),this.y)}get domId(){return this.k.domId}get onDidScroll(){return this.k.onDidScroll}get onMouseClick(){return this.k.onMouseClick}get onMouseDblClick(){return this.k.onMouseDblClick}get onMouseMiddleClick(){return this.k.onMouseMiddleClick}get onPointer(){return this.w.onPointer}get onMouseUp(){return this.k.onMouseUp}get onMouseDown(){return this.k.onMouseDown}get onMouseOver(){return this.k.onMouseOver}get onMouseMove(){return this.k.onMouseMove}get onMouseOut(){return this.k.onMouseOut}get onTouchStart(){return this.k.onTouchStart}get onTap(){return this.k.onTap}get onContextMenu(){let S=!1;const _=this.y.add(r.Event.chain(this.y.add(new O.$PP(this.k.domNode,"keydown")).event)).map(H=>new i.$5N(H)).filter(H=>S=H.keyCode===58||H.shiftKey&&H.keyCode===68).map(H=>N.$LO.stop(H,!0)).filter(()=>!1).event,d=this.y.add(r.Event.chain(this.y.add(new O.$PP(this.k.domNode,"keyup")).event)).forEach(()=>S=!1).map(H=>new i.$5N(H)).filter(H=>H.keyCode===58||H.shiftKey&&H.keyCode===68).map(H=>N.$LO.stop(H,!0)).map(({browserEvent:H})=>{const Q=this.getFocus(),q=Q.length?Q[0]:void 0,x=typeof q<"u"?this.k.element(q):void 0,W=typeof q<"u"?this.k.domElement(q):this.k.domNode;return{index:q,element:x,anchor:W,browserEvent:H}}).event,p=this.y.add(r.Event.chain(this.k.onContextMenu)).filter(H=>!S).map(({element:H,index:Q,browserEvent:q})=>({element:H,index:Q,anchor:new D.$ZN(q),browserEvent:q})).event;return r.Event.any(_,d,p)}get onKeyDown(){return this.y.add(new O.$PP(this.k.domNode,"keydown")).event}get onKeyUp(){return this.y.add(new O.$PP(this.k.domNode,"keyup")).event}get onKeyPress(){return this.y.add(new O.$PP(this.k.domNode,"keypress")).event}get onDidFocus(){return r.Event.signal(this.y.add(new O.$PP(this.k.domNode,"focus",!0)).event)}get onDidBlur(){return r.Event.signal(this.y.add(new O.$PP(this.k.domNode,"blur",!0)).event)}constructor(S,_,d,p,H=pe){this.A=S,this.B=H,this.c=new f("focused"),this.f=new f("anchor"),this.g=new r.$mc,this.x="",this.y=new e.$kb,this.z=new r.$ec,this.onDidDispose=this.z.event;const Q=this.B.accessibilityProvider&&this.B.accessibilityProvider.getWidgetRole?this.B.accessibilityProvider?.getWidgetRole():"list";this.d=new C(Q!=="listbox");const q=[this.c.renderer,this.d.renderer];this.u=H.accessibilityProvider,this.u&&(q.push(new K(this.u)),this.u.onDidChangeActiveDescendant?.(this.I,this,this.y)),p=p.map(W=>new ie(W.templateId,[...q,W]));const x={...H,dnd:H.dnd&&new U(this,H.dnd)};if(this.k=this.C(_,d,p,x),this.k.domNode.setAttribute("role",Q),H.styleController)this.q=H.styleController(this.k.domId);else{const W=(0,N.$EO)(this.k.domNode);this.q=new ae(W,this.k.domId)}if(this.o=new y.$TP([new T(this.c,this.k,H.identityProvider),new T(this.d,this.k,H.identityProvider),new T(this.f,this.k,H.identityProvider),this.k]),this.y.add(this.c),this.y.add(this.d),this.y.add(this.f),this.y.add(this.k),this.y.add(this.z),this.y.add(new z(this,this.k)),(typeof H.keyboardSupport!="boolean"||H.keyboardSupport)&&(this.v=new F(this,this.k,H),this.y.add(this.v)),H.keyboardNavigationLabelProvider){const W=H.keyboardNavigationDelegate||t.$0P;this.t=new M(this,this.k,H.keyboardNavigationLabelProvider,H.keyboardNavigationEventFilter??(()=>!0),W),this.y.add(this.t)}this.w=this.D(H),this.y.add(this.w),this.onDidChangeFocus(this.H,this,this.y),this.onDidChangeSelection(this.J,this,this.y),this.u&&(this.ariaLabel=this.u.getWidgetAriaLabel()),this.B.multipleSelectionSupport!==!1&&this.k.domNode.setAttribute("aria-multiselectable","true")}C(S,_,d,p){return new v.$6P(S,_,d,p)}D(S){return new ue(this)}updateOptions(S={}){this.B={...this.B,...S},this.t?.updateOptions(this.B),this.B.multipleSelectionController!==void 0&&(this.B.multipleSelectionSupport?this.k.domNode.setAttribute("aria-multiselectable","true"):this.k.domNode.removeAttribute("aria-multiselectable")),this.w.updateOptions(S),this.v?.updateOptions(S),this.k.updateOptions(S)}get options(){return this.B}splice(S,_,d=[]){if(S<0||S>this.k.length)throw new s.$VP(this.A,`Invalid start index: ${S}`);if(_<0)throw new s.$VP(this.A,`Invalid delete count: ${_}`);_===0&&d.length===0||this.g.bufferEvents(()=>this.o.splice(S,_,d))}updateWidth(S){this.k.updateWidth(S)}updateElementHeight(S,_){this.k.updateElementHeight(S,_,null)}rerender(){this.k.rerender()}element(S){return this.k.element(S)}indexOf(S){return this.k.indexOf(S)}get length(){return this.k.length}get contentHeight(){return this.k.contentHeight}get contentWidth(){return this.k.contentWidth}get onDidChangeContentHeight(){return this.k.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.k.onDidChangeContentWidth}get scrollTop(){return this.k.getScrollTop()}set scrollTop(S){this.k.setScrollTop(S)}get scrollLeft(){return this.k.getScrollLeft()}set scrollLeft(S){this.k.setScrollLeft(S)}get scrollHeight(){return this.k.scrollHeight}get renderHeight(){return this.k.renderHeight}get firstVisibleIndex(){return this.k.firstVisibleIndex}get lastVisibleIndex(){return this.k.lastVisibleIndex}get ariaLabel(){return this.x}set ariaLabel(S){this.x=S,this.k.domNode.setAttribute("aria-label",S)}domFocus(){this.k.domNode.focus({preventScroll:!0})}layout(S,_){this.k.layout(S,_)}triggerTypeNavigation(){this.t?.trigger()}setSelection(S,_){for(const d of S)if(d<0||d>=this.length)throw new s.$VP(this.A,`Invalid index ${d}`);this.d.set(S,_)}getSelection(){return this.d.get()}getSelectedElements(){return this.getSelection().map(S=>this.k.element(S))}setAnchor(S){if(typeof S>"u"){this.f.set([]);return}if(S<0||S>=this.length)throw new s.$VP(this.A,`Invalid index ${S}`);this.f.set([S])}getAnchor(){return(0,o.$sf)(this.f.get(),void 0)}getAnchorElement(){const S=this.getAnchor();return typeof S>"u"?void 0:this.element(S)}setFocus(S,_){for(const d of S)if(d<0||d>=this.length)throw new s.$VP(this.A,`Invalid index ${d}`);this.c.set(S,_)}focusNext(S=1,_=!1,d,p){if(this.length===0)return;const H=this.c.get(),Q=this.E(H.length>0?H[0]+S:0,_,p);Q>-1&&this.setFocus([Q],d)}focusPrevious(S=1,_=!1,d,p){if(this.length===0)return;const H=this.c.get(),Q=this.F(H.length>0?H[0]-S:0,_,p);Q>-1&&this.setFocus([Q],d)}async focusNextPage(S,_){let d=this.k.indexAt(this.k.getScrollTop()+this.k.renderHeight);d=d===0?0:d-1;const p=this.getFocus()[0];if(p!==d&&(p===void 0||d>p)){const H=this.F(d,!1,_);H>-1&&p!==H?this.setFocus([H],S):this.setFocus([d],S)}else{const H=this.k.getScrollTop();let Q=H+this.k.renderHeight;d>p&&(Q-=this.k.elementHeight(d)),this.k.setScrollTop(Q),this.k.getScrollTop()!==H&&(this.setFocus([]),await(0,u.$vg)(0),await this.focusNextPage(S,_))}}async focusPreviousPage(S,_){let d;const p=this.k.getScrollTop();p===0?d=this.k.indexAt(p):d=this.k.indexAfter(p-1);const H=this.getFocus()[0];if(H!==d&&(H===void 0||H>=d)){const Q=this.E(d,!1,_);Q>-1&&H!==Q?this.setFocus([Q],S):this.setFocus([d],S)}else{const Q=p;this.k.setScrollTop(p-this.k.renderHeight),this.k.getScrollTop()!==Q&&(this.setFocus([]),await(0,u.$vg)(0),await this.focusPreviousPage(S,_))}}focusLast(S,_){if(this.length===0)return;const d=this.F(this.length-1,!1,_);d>-1&&this.setFocus([d],S)}focusFirst(S,_){this.focusNth(0,S,_)}focusNth(S,_,d){if(this.length===0)return;const p=this.E(S,!1,d);p>-1&&this.setFocus([p],_)}E(S,_=!1,d){for(let p=0;p<this.length;p++){if(S>=this.length&&!_)return-1;if(S=S%this.length,!d||d(this.element(S)))return S;S++}return-1}F(S,_=!1,d){for(let p=0;p<this.length;p++){if(S<0&&!_)return-1;if(S=(this.length+S%this.length)%this.length,!d||d(this.element(S)))return S;S--}return-1}getFocus(){return this.c.get()}getFocusedElements(){return this.getFocus().map(S=>this.k.element(S))}reveal(S,_){if(S<0||S>=this.length)throw new s.$VP(this.A,`Invalid index ${S}`);const d=this.k.getScrollTop(),p=this.k.elementTop(S),H=this.k.elementHeight(S);if((0,h.$me)(_)){const Q=H-this.k.renderHeight;this.k.setScrollTop(Q*(0,a.$ul)(_,0,1)+p)}else{const Q=p+H,q=d+this.k.renderHeight;p<d&&Q>=q||(p<d||Q>=q&&H>=this.k.renderHeight?this.k.setScrollTop(p):Q>=q&&this.k.setScrollTop(Q-this.k.renderHeight))}}getRelativeTop(S){if(S<0||S>=this.length)throw new s.$VP(this.A,`Invalid index ${S}`);const _=this.k.getScrollTop(),d=this.k.elementTop(S),p=this.k.elementHeight(S);if(d<_||d+p>_+this.k.renderHeight)return null;const H=p-this.k.renderHeight;return Math.abs((_-d)/H)}isDOMFocused(){return this.k.domNode===document.activeElement}getHTMLElement(){return this.k.domNode}getElementID(S){return this.k.getElementDomId(S)}style(S){this.q.style(S)}G({indexes:S,browserEvent:_}){return{indexes:S,elements:S.map(d=>this.k.element(d)),browserEvent:_}}H(){const S=this.c.get();this.k.domNode.classList.toggle("element-focused",S.length>0),this.I()}I(){const S=this.c.get();if(S.length>0){let _;this.u?.getActiveDescendantId&&(_=this.u.getActiveDescendantId(this.k.element(S[0]))),this.k.domNode.setAttribute("aria-activedescendant",_||this.k.getElementDomId(S[0]))}else this.k.domNode.removeAttribute("aria-activedescendant")}J(){const S=this.d.get();this.k.domNode.classList.toggle("selection-none",S.length===0),this.k.domNode.classList.toggle("selection-single",S.length===1),this.k.domNode.classList.toggle("selection-multiple",S.length>1)}dispose(){this.z.fire(),this.y.dispose(),this.z.dispose()}}t.$dQ=ee,xe([L.$Tg],ee.prototype,"onDidChangeFocus",null),xe([L.$Tg],ee.prototype,"onDidChangeSelection",null),xe([L.$Tg],ee.prototype,"onContextMenu",null),xe([L.$Tg],ee.prototype,"onKeyDown",null),xe([L.$Tg],ee.prototype,"onKeyUp",null),xe([L.$Tg],ee.prototype,"onKeyPress",null),xe([L.$Tg],ee.prototype,"onDidFocus",null),xe([L.$Tg],ee.prototype,"onDidBlur",null)}),define(be[59],$e([1,0,6,33,35,11,15]),function(re,t,N,O,i,j,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Rj=t.$Qj=t.$Pj=t.$Oj=t.$Nj=t.$Mj=t.$Lj=t.$Kj=t.MarkdownStringTextNewlineStyle=void 0;var y;(function(n){n[n.Paragraph=0]="Paragraph",n[n.Break=1]="Break"})(y||(t.MarkdownStringTextNewlineStyle=y={}));class o{constructor(h="",s=!1){if(this.value=h,typeof this.value!="string")throw(0,N.$5)("value");typeof s=="boolean"?(this.isTrusted=s,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=s.isTrusted??void 0,this.supportThemeIcons=s.supportThemeIcons??!1,this.supportHtml=s.supportHtml??!1)}appendText(h,s=0){return this.value+=r(this.supportThemeIcons?(0,O.$Ej)(h):h).replace(/([ \t]+)/g,(v,D)=>"&nbsp;".repeat(D.length)).replace(/\>/gm,"\\>").replace(/\n/g,s===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,s){return this.value+="\n```",this.value+=h,this.value+=`
`,this.value+=s,this.value+="\n```\n",this}appendLink(h,s,v){return this.value+="[",this.value+=this.c(s,"]"),this.value+="](",this.value+=this.c(String(h),")"),v&&(this.value+=` "${this.c(this.c(v,'"'),")")}"`),this.value+=")",this}c(h,s){const v=new RegExp((0,j.$pd)(s),"g");return h.replace(v,(D,E)=>h.charAt(E-1)!=="\\"?`\\${D}`:D)}}t.$Kj=o;function u(n){return g(n)?!n.value:Array.isArray(n)?n.every(u):!0}t.$Lj=u;function g(n){return n instanceof o?!0:n&&typeof n=="object"?typeof n.value=="string"&&(typeof n.isTrusted=="boolean"||typeof n.isTrusted=="object"||n.isTrusted===void 0)&&(typeof n.supportThemeIcons=="boolean"||n.supportThemeIcons===void 0):!1}t.$Mj=g;function L(n,h){return n===h?!0:!n||!h?!1:n.value===h.value&&n.isTrusted===h.isTrusted&&n.supportThemeIcons===h.supportThemeIcons&&n.supportHtml===h.supportHtml&&(n.baseUri===h.baseUri||!!n.baseUri&&!!h.baseUri&&(0,i.$2f)(A.URI.from(n.baseUri),A.URI.from(h.baseUri)))}t.$Nj=L;function r(n){return n.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}t.$Oj=r;function l(n){return n.replace(/"/g,"&quot;")}t.$Pj=l;function e(n){return n&&n.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}t.$Qj=e;function a(n){const h=[],s=n.split("|").map(D=>D.trim());n=s[0];const v=s[1];if(v){const D=/height=(\d+)/.exec(v),E=/width=(\d+)/.exec(v),f=D?D[1]:"",C=E?E[1]:"",T=isFinite(parseInt(C)),P=isFinite(parseInt(f));T&&h.push(`width="${C}"`),P&&h.push(`height="${f}"`)}return{href:n,dimensions:h}}t.$Rj=a}),define(be[122],$e([1,0,4,114,21,52,14,19,115,6,3,59,33,73,30,2,76,50,28,48,35,11,15]),function(re,t,N,O,i,j,A,y,o,u,g,L,r,l,e,a,n,h,s,v,D,E,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kQ=t.$jQ=t.$iQ=t.$hQ=t.$gQ=void 0;const C=Object.freeze({image:(U,ee,J)=>{let S=[],_=[];return U&&({href:U,dimensions:S}=(0,L.$Rj)(U),_.push(`src="${(0,L.$Pj)(U)}"`)),J&&_.push(`alt="${(0,L.$Pj)(J)}"`),ee&&_.push(`title="${(0,L.$Pj)(ee)}"`),S.length&&(_=_.concat(S)),"<img "+_.join(" ")+">"},paragraph:U=>`<p>${U}</p>`,link:(U,ee,J)=>typeof U!="string"?"":(U===J&&(J=(0,L.$Qj)(J)),ee=typeof ee=="string"?(0,L.$Pj)((0,L.$Qj)(ee)):"",U=(0,L.$Qj)(U),U=U.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${U}" title="${ee||U}">${J}</a>`)});function T(U,ee={},J={}){const S=new a.$kb;let _=!1;const d=(0,j.$OP)(ee),p=function(w){let I;try{I=(0,h.$Xg)(decodeURIComponent(w))}catch{}return I?(I=(0,v.$Km)(I,V=>{if(U.uris&&U.uris[V])return f.URI.revive(U.uris[V])}),encodeURIComponent(JSON.stringify(I))):w},H=function(w,I){const V=U.uris&&U.uris[w];let Z=f.URI.revive(V);return I?w.startsWith(s.Schemas.data+":")?w:(Z||(Z=f.URI.parse(w)),s.$1e.uriToBrowserUri(Z).toString(!0)):!Z||f.URI.parse(w).toString()===Z.toString()?w:(Z.query&&(Z=Z.with({query:p(Z.query)})),Z.toString())},Q=new n.marked.Renderer;Q.image=C.image,Q.link=C.link,Q.paragraph=C.paragraph;const q=[],x=[];if(ee.codeBlockRendererSync?Q.code=(w,I)=>{const V=l.$RL.nextId(),Z=ee.codeBlockRendererSync(P(I),w);return x.push([V,Z]),`<div class="code" data-code="${V}">${(0,E.$od)(w)}</div>`}:ee.codeBlockRenderer&&(Q.code=(w,I)=>{const V=l.$RL.nextId(),Z=ee.codeBlockRenderer(P(I),w);return q.push(Z.then(oe=>[V,oe])),`<div class="code" data-code="${V}">${(0,E.$od)(w)}</div>`}),ee.actionHandler){const w=function(Z){let oe=Z.target;if(!(oe.tagName!=="A"&&(oe=oe.parentElement,!oe||oe.tagName!=="A")))try{let ge=oe.dataset.href;ge&&(U.baseUri&&(ge=m(f.URI.from(U.baseUri),ge)),ee.actionHandler.callback(ge,Z))}catch(ge){(0,u.$Y)(ge)}finally{Z.preventDefault()}},I=ee.actionHandler.disposables.add(new i.$PP(d,"click")),V=ee.actionHandler.disposables.add(new i.$PP(d,"auxclick"));ee.actionHandler.disposables.add(g.Event.any(I.event,V.event)(Z=>{const oe=new y.$ZN(Z);!oe.leftButton&&!oe.middleButton||w(oe)})),ee.actionHandler.disposables.add(N.$8N(d,"keydown",Z=>{const oe=new A.$5N(Z);!oe.equals(10)&&!oe.equals(3)||w(oe)}))}U.supportHtml||(J.sanitizer=w=>(U.isTrusted?w.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?w:"",J.sanitize=!0,J.silent=!0),J.renderer=Q;let W=U.value??"";W.length>1e5&&(W=`${W.substr(0,1e5)}\u2026`),U.supportThemeIcons&&(W=(0,r.$Fj)(W));let c;if(ee.fillInIncompleteTokens){const w={...n.marked.defaults,...J},I=n.marked.lexer(W,w),V=se(I);c=n.marked.parser(V,w)}else c=n.marked.parse(W,J);U.supportThemeIcons&&(c=(0,o.$eQ)(c).map(I=>typeof I=="string"?I:I.outerHTML).join(""));const b=new DOMParser().parseFromString($(U,c),"text/html");if(b.body.querySelectorAll("img").forEach(w=>{const I=w.getAttribute("src");if(I){let V=I;try{U.baseUri&&(V=m(f.URI.from(U.baseUri),V))}catch{}w.src=H(V,!0)}}),b.body.querySelectorAll("a").forEach(w=>{const I=w.getAttribute("href");if(w.setAttribute("href",""),!I||/^data:|javascript:/i.test(I)||/^command:/i.test(I)&&!U.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(I))w.replaceWith(...w.childNodes);else{let V=H(I,!1);U.baseUri&&(V=m(f.URI.from(U.baseUri),I)),w.dataset.href=V}}),d.innerHTML=$(U,b.body.innerHTML),q.length>0)Promise.all(q).then(w=>{if(_)return;const I=new Map(w),V=d.querySelectorAll("div[data-code]");for(const Z of V){const oe=I.get(Z.dataset.code??"");oe&&N.$SO(Z,oe)}ee.asyncRenderCallback?.()});else if(x.length>0){const w=new Map(x),I=d.querySelectorAll("div[data-code]");for(const V of I){const Z=w.get(V.dataset.code??"");Z&&N.$SO(V,Z)}}if(ee.asyncRenderCallback)for(const w of d.getElementsByTagName("img")){const I=S.add(N.$8N(w,"load",()=>{I.dispose(),ee.asyncRenderCallback()}))}return{element:d,dispose:()=>{_=!0,S.dispose()}}}t.$gQ=T;function P(U){if(!U)return"";const ee=U.split(/[\s+|:|,|\{|\?]/,1);return ee.length?ee[0]:U}function m(U,ee){return/^\w[\w\d+.-]*:/.test(ee)?ee:U.path.endsWith("/")?(0,D.$_f)(U,ee).toString():(0,D.$_f)((0,D.$8f)(U),ee).toString()}function $(U,ee){const{config:J,allowedSchemes:S}=F(U);O.addHook("uponSanitizeAttribute",(d,p)=>{if(p.attrName==="style"||p.attrName==="class"){if(d.tagName==="SPAN"){if(p.attrName==="style"){p.keepAttr=/^(color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?(background-color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?$/.test(p.attrValue);return}else if(p.attrName==="class"){p.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(p.attrValue);return}}p.keepAttr=!1;return}});const _=N.$aP(S);try{return O.sanitize(ee,{...J,RETURN_TRUSTED_TYPE:!0})}finally{O.removeHook("uponSanitizeAttribute"),_.dispose()}}t.$hQ=["align","autoplay","alt","class","controls","data-code","data-href","height","href","loop","muted","playsinline","poster","src","style","target","title","width","start"];function F(U){const ee=[s.Schemas.http,s.Schemas.https,s.Schemas.mailto,s.Schemas.data,s.Schemas.file,s.Schemas.vscodeFileResource,s.Schemas.vscodeRemote,s.Schemas.vscodeRemoteResource];return U.isTrusted&&ee.push(s.Schemas.command),{config:{ALLOWED_TAGS:[...N.$bP],ALLOWED_ATTR:t.$hQ,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:ee}}function R(U){return typeof U=="string"?U:B(U)}t.$iQ=R;function B(U){let ee=U.value??"";ee.length>1e5&&(ee=`${ee.substr(0,1e5)}\u2026`);const J=n.marked.parse(ee,{renderer:z.value}).replace(/&(#\d+|[a-zA-Z]+);/g,S=>M.get(S)??S);return $({isTrusted:!1},J).toString()}t.$jQ=B;const M=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),z=new e.$T(()=>{const U=new n.marked.Renderer;return U.code=ee=>ee,U.blockquote=ee=>ee,U.html=ee=>"",U.heading=(ee,J,S)=>ee+`
`,U.hr=()=>"",U.list=(ee,J)=>ee,U.listitem=ee=>ee+`
`,U.paragraph=ee=>ee+`
`,U.table=(ee,J)=>ee+J+`
`,U.tablerow=ee=>ee,U.tablecell=(ee,J)=>ee+" ",U.strong=ee=>ee,U.em=ee=>ee,U.codespan=ee=>ee,U.br=()=>`
`,U.del=ee=>ee,U.image=(ee,J,S)=>"",U.text=ee=>ee,U.link=(ee,J,S)=>S,U});function te(U){let ee="";return U.forEach(J=>{ee+=J.raw}),ee}function ne(U){for(const ee of U.tokens)if(ee.type==="text"){const J=ee.raw.split(`
`),S=J[J.length-1];if(S.includes("`"))return ue(U);if(S.includes("**"))return Me(U);if(S.match(/\*\w/))return ae(U);if(S.match(/(^|\s)__\w/))return fe(U);if(S.match(/(^|\s)_\w/))return pe(U);if(S.match(/(^|\s)\[.*\]\(\w*/))return Oe(U);if(S.match(/(^|\s)\[\w/))return Te(U)}}function se(U){let ee,J;for(ee=0;ee<U.length;ee++){const S=U[ee];if(S.type==="paragraph"&&S.raw.match(/(\n|^)```/)){J=ce(U.slice(ee));break}if(S.type==="paragraph"&&S.raw.match(/(\n|^)\|/)){J=K(U.slice(ee));break}if(ee===U.length-1&&S.type==="paragraph"){const _=ne(S);if(_){J=[_];break}}}if(J){const S=[...U.slice(0,ee),...J];return S.links=U.links,S}return U}t.$kQ=se;function ce(U){const ee=te(U);return n.marked.lexer(ee+"\n```")}function ue(U){return ie(U,"`")}function ae(U){return ie(U,"*")}function pe(U){return ie(U,"_")}function Oe(U){return ie(U,")")}function Te(U){return ie(U,"](about:blank)")}function Me(U){return ie(U,"**")}function fe(U){return ie(U,"__")}function ie(U,ee){const J=te(Array.isArray(U)?U:[U]);return n.marked.lexer(J+ee)[0]}function K(U){const ee=te(U),J=ee.split(`
`);let S,_=!1;for(let d=0;d<J.length;d++){const p=J[d].trim();if(typeof S>"u"&&p.match(/^\s*\|/)){const H=p.match(/(\|[^\|]+)(?=\||$)/g);H&&(S=H.length)}else if(typeof S=="number")if(p.match(/^\s*\|/)){if(d!==J.length-1)return;_=!0}else return}if(typeof S=="number"&&S>0){const d=_?J.slice(0,-1).join(`
`):ee,p=!!d.match(/\|\s*$/),H=d+(p?"":"|")+`
|${" --- |".repeat(S)}`;return n.marked.lexer(H)}}}),define(be[123],$e([1,0,4,9,27,59,33,2,7,104]),function(re,t,N,O,i,j,A,y,o,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$GP=t.$FP=void 0;function g(l,e){(0,o.$ie)(e)?l.title=(0,A.$Gj)(e):e?.markdownNotSupportedFallback?l.title=e.markdownNotSupportedFallback:l.removeAttribute("title")}t.$FP=g;class L{constructor(e,a,n){this.c=e,this.d=a,this.f=n}async update(e,a,n){if(this.b&&(this.b.dispose(!0),this.b=void 0),this.isDisposed)return;let h;if(e===void 0||(0,o.$ie)(e)||e instanceof HTMLElement)h=e;else if(!(0,o.$we)(e.markdown))h=e.markdown??e.markdownNotSupportedFallback;else{this.a||this.g((0,u.localize)(0,null),a),this.b=new i.$oc;const s=this.b.token;if(h=await e.markdown(s),h===void 0&&(h=e.markdownNotSupportedFallback),this.isDisposed||s.isCancellationRequested)return}this.g(h,a,n)}g(e,a,n){const h=this.a;if(this.h(e)){const s={content:e,target:this.d,showPointer:this.c.placement==="element",hoverPosition:2,skipFadeInAnimation:!this.f||!!h,...n};this.a=this.c.showHover(s,a)}h?.dispose()}h(e){return e?(0,j.$Mj)(e)?!!e.value:!0:!1}get isDisposed(){return this.a?.isDisposed}dispose(){this.a?.dispose(),this.b?.dispose(!0),this.b=void 0}}function r(l,e,a,n){let h,s;const v=(T,P)=>{const m=s!==void 0;T&&(s?.dispose(),s=void 0),P&&(h?.dispose(),h=void 0),m&&l.onDidHideHover?.()},D=(T,P,m)=>new O.$Eg(async()=>{(!s||s.isDisposed)&&(s=new L(l,m||e,T>0),await s.update(a,P,n))},T),E=()=>{if(h)return;const T=new y.$kb,P=F=>v(!1,F.fromElement===e);T.add(N.$8N(e,N.$JO.MOUSE_LEAVE,P,!0));const m=()=>v(!0,!0);T.add(N.$8N(e,N.$JO.MOUSE_DOWN,m,!0));const $={targetElements:[e],dispose:()=>{}};if(l.placement===void 0||l.placement==="mouse"){const F=R=>{$.x=R.x+10,R.target instanceof HTMLElement&&R.target.classList.contains("action-label")&&v(!0,!0)};T.add(N.$8N(e,N.$JO.MOUSE_MOVE,F,!0))}T.add(D(l.delay,!1,$)),h=T},f=N.$8N(e,N.$JO.MOUSE_OVER,E,!0);return{show:T=>{v(!1,!0),D(0,T)},hide:()=>{v(!0,!0)},update:async(T,P)=>{a=T,await s?.update(a,void 0,P)},dispose:()=>{f.dispose(),v(!0,!0)}}}t.$GP=r}),define(be[124],$e([1,0,4,21,14,122,37,13,3,42,2,5,106,97]),function(re,t,N,O,i,j,A,y,o,u,g,L,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lQ=void 0;const l=N.$,e="selectOption.entry.template";class a{get templateId(){return e}renderTemplate(s){const v=Object.create(null);return v.root=s,v.text=N.$QO(s,l(".option-text")),v.detail=N.$QO(s,l(".option-detail")),v.decoratorRight=N.$QO(s,l(".option-decorator-right")),v}renderElement(s,v,D){const E=D,f=s.text,C=s.detail,T=s.decoratorRight,P=s.isDisabled;E.text.textContent=f,E.detail.textContent=C||"",E.decoratorRight.innerText=T||"",P?E.root.classList.add("option-disabled"):E.root.classList.remove("option-disabled")}disposeTemplate(s){}}class n extends g.$lb{static{this.a=32}static{this.b=2}static{this.c=3}constructor(s,v,D,E,f){super(),this.k=[],this.y=0,this.C=!1,this.F=!1,this.H=!1,this.f=!1,this.n=E,this.g=f||Object.create(null),typeof this.g.minBottomMargin!="number"?this.g.minBottomMargin=n.a:this.g.minBottomMargin<0&&(this.g.minBottomMargin=0),this.h=document.createElement("select"),this.h.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.g.ariaLabel=="string"&&this.h.setAttribute("aria-label",this.g.ariaLabel),typeof this.g.ariaDescription=="string"&&this.h.setAttribute("aria-description",this.g.ariaDescription),this.m=new o.$ec,this.B(this.m),this.J(),this.I(D),this.l=v||0,s&&this.setOptions(s,v),this.M()}getHeight(){return 22}getTemplateId(){return e}I(s){this.r=s,this.s=N.$(".monaco-select-box-dropdown-container"),this.s.classList.add("monaco-select-box-dropdown-padding"),this.D=N.$QO(this.s,l(".select-box-details-pane"));const v=N.$QO(this.s,l(".select-box-dropdown-container-width-control")),D=N.$QO(v,l(".width-control-div"));this.w=document.createElement("span"),this.w.className="option-text-width-control",N.$QO(D,this.w),this.z=0,this.t=N.$EO(this.s),this.s.setAttribute("draggable","true"),this.B(N.$8N(this.s,N.$JO.DRAG_START,E=>{N.$LO.stop(E,!0)}))}J(){this.B(N.$9N(this.h,"change",v=>{this.l=v.target.selectedIndex,this.m.fire({index:v.target.selectedIndex,selected:v.target.value}),this.k[this.l]&&this.k[this.l].text&&(this.h.title=this.k[this.l].text)})),this.B(N.$8N(this.h,N.$JO.CLICK,v=>{N.$LO.stop(v),this.f?this.R(!0):this.Q()})),this.B(N.$8N(this.h,N.$JO.MOUSE_DOWN,v=>{N.$LO.stop(v)}));let s;this.B(N.$8N(this.h,"touchstart",v=>{s=this.f})),this.B(N.$8N(this.h,"touchend",v=>{N.$LO.stop(v),s?this.R(!0):this.Q()})),this.B(N.$8N(this.h,N.$JO.KEY_DOWN,v=>{const D=new i.$5N(v);let E=!1;L.$j?(D.keyCode===18||D.keyCode===16||D.keyCode===10||D.keyCode===3)&&(E=!0):(D.keyCode===18&&D.altKey||D.keyCode===16&&D.altKey||D.keyCode===10||D.keyCode===3)&&(E=!0),E&&(this.Q(),N.$LO.stop(v,!0))}))}get onDidSelect(){return this.m.event}setOptions(s,v){y.$$e(this.k,s)||(this.k=s,this.h.options.length=0,this.C=!1,this.G=void 0,this.k.forEach((D,E)=>{this.h.add(this.P(D.text,E,D.isDisabled)),typeof D.description=="string"&&(this.C=!0)})),v!==void 0&&(this.select(v),this.y=this.l)}L(){this.u?.splice(0,this.u.length,this.k)}select(s){s>=0&&s<this.k.length?this.l=s:s>this.k.length-1?this.select(this.k.length-1):this.l<0&&(this.l=0),this.h.selectedIndex=this.l,this.k[this.l]&&this.k[this.l].text&&(this.h.title=this.k[this.l].text)}setAriaLabel(s){this.g.ariaLabel=s,this.h.setAttribute("aria-label",this.g.ariaLabel)}focus(){this.h&&(this.h.tabIndex=0,this.h.focus())}blur(){this.h&&(this.h.tabIndex=-1,this.h.blur())}setFocusable(s){this.h.tabIndex=s?0:-1}render(s){this.j=s,s.classList.add("select-container"),s.appendChild(this.h),this.N()}M(){const s=[];this.n.listFocusBackground&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.n.listFocusBackground} !important; }`),this.n.listFocusForeground&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.n.listFocusForeground} !important; }`),this.n.decoratorRightForeground&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.n.decoratorRightForeground}; }`),this.n.selectBackground&&this.n.selectBorder&&this.n.selectBorder!==this.n.selectBackground?(s.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.n.selectBorder} } `),s.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.n.selectBorder} } `),s.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.n.selectBorder} } `)):this.n.selectListBorder&&(s.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.n.selectListBorder} } `),s.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.n.selectListBorder} } `)),this.n.listHoverForeground&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.n.listHoverForeground} !important; }`),this.n.listHoverBackground&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.n.listHoverBackground} !important; }`),this.n.listFocusOutline&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.n.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.n.listHoverOutline&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.n.listHoverOutline} !important; outline-offset: -1.6px !important; }`),s.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),s.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.t.textContent=s.join(`
`)}N(){const s=this.n.selectBackground??"",v=this.n.selectForeground??"",D=this.n.selectBorder??"";this.h.style.backgroundColor=s,this.h.style.color=v,this.h.style.borderColor=D}O(){const s=this.n.selectBackground??"",v=N.$9O(this.n.selectListBackground,s);this.v.style.backgroundColor=v,this.D.style.backgroundColor=v;const D=this.n.focusBorder??"";this.s.style.outlineColor=D,this.s.style.outlineOffset="-1px",this.u.style(this.n)}P(s,v,D){const E=document.createElement("option");return E.value=s,E.text=s,E.disabled=!!D,E}Q(){this.D.innerText="",!(!this.r||this.f)&&(this.Y(this.s),this.L(),this.r.showContextView({getAnchor:()=>this.h,render:s=>this.S(s,!0),layout:()=>{this.W()},onHide:()=>{this.s.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.z},this.g.optionsAsChildren?this.j:void 0),this.f=!0,this.R(!1),this.r.showContextView({getAnchor:()=>this.h,render:s=>this.S(s),layout:()=>this.W(),onHide:()=>{this.s.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.z},this.g.optionsAsChildren?this.j:void 0),this.y=this.l,this.f=!0,this.h.setAttribute("aria-expanded","true"))}R(s){!this.r||!this.f||(this.f=!1,this.h.setAttribute("aria-expanded","false"),s&&this.h.focus(),this.r.hideContextView())}S(s,v){return s.appendChild(this.s),this.W(v),{dispose:()=>{try{s.removeChild(this.s)}catch{}}}}U(){let s=0;return this.k.forEach((v,D)=>{this.db(D),this.D.offsetHeight>s&&(s=this.D.offsetHeight)}),s}W(s){if(this.F)return!1;if(this.u){this.s.classList.add("visible");const v=N.$nO(this.h),D=getComputedStyle(this.h),E=parseFloat(D.getPropertyValue("--dropdown-padding-top"))+parseFloat(D.getPropertyValue("--dropdown-padding-bottom")),f=window.innerHeight-v.top-v.height-(this.g.minBottomMargin||0),C=v.top-n.b,T=this.h.offsetWidth,P=this.X(this.w),m=Math.max(P,Math.round(T)).toString()+"px";this.s.style.width=m,this.u.getHTMLElement().style.height="",this.u.layout();let $=this.u.contentHeight;this.C&&this.G===void 0&&(this.G=this.U());const F=this.C?this.G:0,R=$+E+F,B=Math.floor((f-E-F)/this.getHeight()),M=Math.floor((C-E-F)/this.getHeight());if(s)return v.top+v.height>window.innerHeight-22||v.top<n.b||B<1&&M<1?!1:(B<n.c&&M>B&&this.k.length>B?(this.z=1,this.s.removeChild(this.v),this.s.removeChild(this.D),this.s.appendChild(this.D),this.s.appendChild(this.v),this.D.classList.remove("border-top"),this.D.classList.add("border-bottom")):(this.z=0,this.s.removeChild(this.v),this.s.removeChild(this.D),this.s.appendChild(this.v),this.s.appendChild(this.D),this.D.classList.remove("border-bottom"),this.D.classList.add("border-top")),!0);if(v.top+v.height>window.innerHeight-22||v.top<n.b||this.z===0&&B<1||this.z===1&&M<1)return this.R(!0),!1;if(this.z===0){if(this.f&&B+M<1)return this.R(!0),!1;R>f&&($=B*this.getHeight())}else R>C&&($=M*this.getHeight());return this.u.layout($),this.u.domFocus(),this.u.length>0&&(this.u.setFocus([this.l||0]),this.u.reveal(this.u.getFocus()[0]||0)),this.C?(this.u.getHTMLElement().style.height=$+E+"px",this.s.style.height=""):this.s.style.height=$+E+"px",this.db(this.l),this.s.style.width=m,this.v.setAttribute("tabindex","0"),this.h.classList.add("synthetic-focus"),this.s.classList.add("synthetic-focus"),!0}else return!1}X(s){let v=0;if(s){let D=0,E=0;this.k.forEach((f,C)=>{const T=f.detail?f.detail.length:0,P=f.decoratorRight?f.decoratorRight.length:0,m=f.text.length+T+P;m>E&&(D=C,E=m)}),s.textContent=this.k[D].text+(this.k[D].decoratorRight?this.k[D].decoratorRight+" ":""),v=N.$pO(s)}return v}Y(s){if(this.u)return;this.v=N.$QO(s,l(".select-box-dropdown-list-container")),this.p=new a,this.u=new A.$dQ("SelectBoxCustom",this.v,this,[this.p],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:E=>{let f=E.text;return E.detail&&(f+=`. ${E.detail}`),E.decoratorRight&&(f+=`. ${E.decoratorRight}`),E.description&&(f+=`. ${E.description}`),f},getWidgetAriaLabel:()=>(0,r.localize)(0,null),getRole:()=>L.$j?"":"option",getWidgetRole:()=>"listbox"}}),this.g.ariaLabel&&(this.u.ariaLabel=this.g.ariaLabel);const v=this.B(new O.$PP(this.v,"keydown")),D=o.Event.chain(v.event).filter(()=>this.u.length>0).map(E=>new i.$5N(E));this.B(D.filter(E=>E.keyCode===3).on(E=>this.fb(E),this)),this.B(D.filter(E=>E.keyCode===2).on(E=>this.fb(E),this)),this.B(D.filter(E=>E.keyCode===9).on(E=>this.eb(E),this)),this.B(D.filter(E=>E.keyCode===16).on(E=>this.hb(E),this)),this.B(D.filter(E=>E.keyCode===18).on(E=>this.gb(E),this)),this.B(D.filter(E=>E.keyCode===12).on(this.jb,this)),this.B(D.filter(E=>E.keyCode===11).on(this.ib,this)),this.B(D.filter(E=>E.keyCode===14).on(this.kb,this)),this.B(D.filter(E=>E.keyCode===13).on(this.lb,this)),this.B(D.filter(E=>E.keyCode>=21&&E.keyCode<=56||E.keyCode>=85&&E.keyCode<=113).on(this.mb,this)),this.B(N.$8N(this.u.getHTMLElement(),N.$JO.POINTER_UP,E=>this.Z(E))),this.B(this.u.onMouseOver(E=>typeof E.index<"u"&&this.u.setFocus([E.index]))),this.B(this.u.onDidChangeFocus(E=>this.cb(E))),this.B(N.$8N(this.s,N.$JO.FOCUS_OUT,E=>{!this.f||N.$vO(E.relatedTarget,this.s)||this.ab()})),this.u.getHTMLElement().setAttribute("aria-label",this.g.ariaLabel||""),this.u.getHTMLElement().setAttribute("aria-expanded","true"),this.O()}Z(s){if(!this.u.length)return;N.$LO.stop(s);const v=s.target;if(!v||v.classList.contains("slider"))return;const D=v.closest(".monaco-list-row");if(!D)return;const E=Number(D.getAttribute("data-index")),f=D.classList.contains("option-disabled");E>=0&&E<this.k.length&&!f&&(this.l=E,this.select(this.l),this.u.setFocus([this.l]),this.u.reveal(this.u.getFocus()[0]),this.l!==this.y&&(this.y=this.l,this.m.fire({index:this.h.selectedIndex,selected:this.k[this.l].text}),this.k[this.l]&&this.k[this.l].text&&(this.h.title=this.k[this.l].text)),this.R(!0))}ab(){this.H||(this.l!==this.y&&this.select(this.y),this.R(!1))}bb(s,v){const D=f=>{for(let C=0;C<f.childNodes.length;C++){const T=f.childNodes.item(C);(T.tagName&&T.tagName.toLowerCase())==="img"?f.removeChild(T):D(T)}},E=(0,j.$gQ)({value:s,supportThemeIcons:!0},{actionHandler:v});return E.element.classList.add("select-box-description-markdown"),D(E.element),E.element}cb(s){!this.f||!this.C||this.db(s.indexes[0])}db(s){this.D.innerText="";const v=this.k[s],D=v?.description??"",E=v?.descriptionIsMarkdown??!1;if(D){if(E){const f=v.descriptionMarkdownActionHandler;this.D.appendChild(this.bb(D,f))}else this.D.innerText=D;this.D.style.display="block"}else this.D.style.display="none";this.F=!0,this.r.layout(),this.F=!1}eb(s){N.$LO.stop(s),this.select(this.y),this.R(!0)}fb(s){N.$LO.stop(s),this.l!==this.y&&(this.y=this.l,this.m.fire({index:this.h.selectedIndex,selected:this.k[this.l].text}),this.k[this.l]&&this.k[this.l].text&&(this.h.title=this.k[this.l].text)),this.R(!0)}gb(s){if(this.l<this.k.length-1){N.$LO.stop(s,!0);const v=this.k[this.l+1].isDisabled;if(v&&this.k.length>this.l+2)this.l+=2;else{if(v)return;this.l++}this.select(this.l),this.u.setFocus([this.l]),this.u.reveal(this.u.getFocus()[0])}}hb(s){this.l>0&&(N.$LO.stop(s,!0),this.k[this.l-1].isDisabled&&this.l>1?this.l-=2:this.l--,this.select(this.l),this.u.setFocus([this.l]),this.u.reveal(this.u.getFocus()[0]))}ib(s){N.$LO.stop(s),this.u.focusPreviousPage(),setTimeout(()=>{this.l=this.u.getFocus()[0],this.k[this.l].isDisabled&&this.l<this.k.length-1&&(this.l++,this.u.setFocus([this.l])),this.u.reveal(this.l),this.select(this.l)},1)}jb(s){N.$LO.stop(s),this.u.focusNextPage(),setTimeout(()=>{this.l=this.u.getFocus()[0],this.k[this.l].isDisabled&&this.l>0&&(this.l--,this.u.setFocus([this.l])),this.u.reveal(this.l),this.select(this.l)},1)}kb(s){N.$LO.stop(s),!(this.k.length<2)&&(this.l=0,this.k[this.l].isDisabled&&this.l>1&&this.l++,this.u.setFocus([this.l]),this.u.reveal(this.l),this.select(this.l))}lb(s){N.$LO.stop(s),!(this.k.length<2)&&(this.l=this.k.length-1,this.k[this.l].isDisabled&&this.l>1&&this.l--,this.u.setFocus([this.l]),this.u.reveal(this.l),this.select(this.l))}mb(s){const v=u.KeyCodeUtils.toString(s.keyCode);let D=-1;for(let E=0;E<this.k.length-1;E++)if(D=(E+this.l+1)%this.k.length,this.k[D].text.charAt(0).toUpperCase()===v&&!this.k[D].isDisabled){this.select(D),this.u.setFocus([D]),this.u.reveal(this.u.getFocus()[0]),N.$LO.stop(s);break}}dispose(){this.R(!1),super.dispose()}}t.$lQ=n}),define(be[125],$e([1,0,37,124,118,20,5,96]),function(re,t,N,O,i,j,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oQ=t.$nQ=void 0,t.$nQ={...N.$cQ,selectBackground:"#3C3C3C",selectForeground:"#F0F0F0",selectBorder:"#3C3C3C",decoratorRightForeground:void 0,selectListBackground:void 0,selectListBorder:void 0,focusBorder:void 0};class y extends j.$pP{constructor(u,g,L,r,l){super(),A.$j&&!l?.useCustomDrawn?this.a=new i.$mQ(u,g,r,l):this.a=new O.$lQ(u,g,L,r,l),this.B(this.a)}get onDidSelect(){return this.a.onDidSelect}setOptions(u,g){this.a.setOptions(u,g)}select(u){this.a.select(u)}setAriaLabel(u){this.a.setAriaLabel(u)}focus(){this.a.focus()}blur(){this.a.blur()}setFocusable(u){this.a.setFocusable(u)}render(u){this.a.render(u)}}t.$oQ=y}),define(be[60],$e([1,0,16,51,4,23,123,125,34,2,5,7,101,49]),function(re,t,N,O,i,j,A,y,o,u,g,L,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vQ=t.$uQ=t.$tQ=void 0;class l extends u.$lb{get action(){return this._action}constructor(h,s,v={}){super(),this.m=v,this._context=h||this,this._action=s,s instanceof o.$7h&&this.B(s.onDidChange(D=>{this.element&&this.t(D)}))}t(h){h.enabled!==void 0&&this.u(),h.checked!==void 0&&this.G(),h.class!==void 0&&this.F(),h.label!==void 0&&(this.w(),this.C()),h.tooltip!==void 0&&this.C()}get actionRunner(){return this.j||(this.j=this.B(new o.$8h)),this.j}set actionRunner(h){this.j=h}isEnabled(){return this._action.enabled}setActionContext(h){this._context=h}render(h){const s=this.element=h;this.B(j.$lP.addTarget(h));const v=this.m&&this.m.draggable;v&&(h.draggable=!0,N.$ON&&this.B((0,i.$8N)(h,i.$JO.DRAG_START,D=>D.dataTransfer?.setData(O.$jP.TEXT,this._action.label)))),this.B((0,i.$8N)(s,j.EventType.Tap,D=>this.onClick(D,!0))),this.B((0,i.$8N)(s,i.$JO.MOUSE_DOWN,D=>{v||i.$LO.stop(D,!0),this._action.enabled&&D.button===0&&s.classList.add("active")})),g.$j&&this.B((0,i.$8N)(s,i.$JO.CONTEXT_MENU,D=>{D.button===0&&D.ctrlKey===!0&&this.onClick(D)})),this.B((0,i.$8N)(s,i.$JO.CLICK,D=>{i.$LO.stop(D,!0),this.m&&this.m.isMenu||this.onClick(D)})),this.B((0,i.$8N)(s,i.$JO.DBLCLICK,D=>{i.$LO.stop(D,!0)})),[i.$JO.MOUSE_UP,i.$JO.MOUSE_OUT].forEach(D=>{this.B((0,i.$8N)(s,D,E=>{i.$LO.stop(E),s.classList.remove("active")}))})}onClick(h,s=!1){i.$LO.stop(h,!0);const v=L.$re(this._context)?this.m?.useEventAsContext?h:{preserveFocus:s}:this._context;this.actionRunner.run(this._action,v)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(h){this.element&&(this.element.tabIndex=h?0:-1)}get trapsArrowNavigation(){return!1}u(){}w(){}z(){return this.action.tooltip}C(){if(!this.element)return;const h=this.z()??"";this.D(),this.m.hoverDelegate?(this.element.title="",this.f?this.f.update(h):(this.f=(0,A.$GP)(this.m.hoverDelegate,this.element,h),this.q.add(this.f))):this.element.title=h}D(){if(this.element){const h=this.z()??"";this.element.setAttribute("aria-label",h)}}F(){}G(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}t.$tQ=l;class e extends l{constructor(h,s,v){super(h,s,v),this.m=v,this.m.icon=v.icon!==void 0?v.icon:!1,this.m.label=v.label!==void 0?v.label:!0,this.I=""}render(h){super.render(h),this.element&&(this.p=(0,i.$QO)(this.element,(0,i.$)("a.action-label"))),this.p&&this.p.setAttribute("role",this.J()),this.m.label&&this.m.keybinding&&this.element&&((0,i.$QO)(this.element,(0,i.$)("span.keybinding")).textContent=this.m.keybinding),this.F(),this.w(),this.C(),this.u(),this.G()}J(){return this._action.id===o.$9h.ID?"presentation":this.m.isMenu?"menuitem":"button"}focus(){this.p&&(this.p.tabIndex=0,this.p.focus())}isFocused(){return!!this.p&&this.p?.tabIndex===0}blur(){this.p&&(this.p.tabIndex=-1)}setFocusable(h){this.p&&(this.p.tabIndex=h?0:-1)}w(){this.m.label&&this.p&&(this.p.textContent=this.action.label)}z(){let h=null;return this.action.tooltip?h=this.action.tooltip:!this.m.label&&this.action.label&&this.m.icon&&(h=this.action.label,this.m.keybinding&&(h=r.localize(0,null,h,this.m.keybinding))),h??void 0}F(){this.I&&this.p&&this.p.classList.remove(...this.I.split(" ")),this.m.icon?(this.I=this.action.class,this.p&&(this.p.classList.add("codicon"),this.I&&this.p.classList.add(...this.I.split(" "))),this.u()):this.p?.classList.remove("codicon")}u(){this.action.enabled?(this.p&&(this.p.removeAttribute("aria-disabled"),this.p.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.p&&(this.p.setAttribute("aria-disabled","true"),this.p.classList.add("disabled")),this.element?.classList.add("disabled"))}D(){if(this.p){const h=this.z()??"";this.p.setAttribute("aria-label",h)}}G(){this.p&&(this.action.checked!==void 0?(this.p.classList.toggle("checked",this.action.checked),this.p.setAttribute("aria-checked",this.action.checked?"true":"false"),this.p.setAttribute("role","checkbox")):(this.p.classList.remove("checked"),this.p.setAttribute("aria-checked",""),this.p.setAttribute("role",this.J())))}}t.$uQ=e;class a extends l{constructor(h,s,v,D,E,f,C){super(h,s),this.b=new y.$oQ(v,D,E,f,C),this.b.setFocusable(!1),this.B(this.b),this.g()}setOptions(h,s){this.b.setOptions(h,s)}select(h){this.b.select(h)}g(){this.B(this.b.onDidSelect(h=>this.k(h.selected,h.index)))}k(h,s){this.actionRunner.run(this._action,this.n(h,s))}n(h,s){return h}setFocusable(h){this.b.setFocusable(h)}focus(){this.b?.focus()}blur(){this.b?.blur()}render(h){this.b.render(h)}}t.$vQ=a}),define(be[61],$e([1,0,4,14,60,34,3,2,7,49]),function(re,t,N,O,i,j,A,y,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$IP=t.$HP=t.ActionsOrientation=void 0;var u;(function(r){r[r.HORIZONTAL=0]="HORIZONTAL",r[r.VERTICAL=1]="VERTICAL"})(u||(t.ActionsOrientation=u={}));class g extends y.$lb{constructor(l,e={}){super(),this.g=this.B(new y.$kb),this.n=this.B(new y.$tb),this.t=!1,this.u=!0,this.w=this.B(new A.$ec),this.onDidBlur=this.w.event,this.y=this.B(new A.$ec({onWillAddFirstListener:()=>this.z=!0})),this.onDidCancel=this.y.event,this.z=!1,this.C=this.B(new A.$ec),this.onDidRun=this.C.event,this.D=this.B(new A.$ec),this.onWillRun=this.D.event,this.b=e,this.j=e.context??null,this.l=this.b.orientation??0,this.m={keyDown:this.b.triggerKeys?.keyDown??!1,keys:this.b.triggerKeys?.keys??[3,10]},this.b.actionRunner?this.f=this.b.actionRunner:(this.f=new j.$8h,this.g.add(this.f)),this.g.add(this.f.onDidRun(h=>this.C.fire(h))),this.g.add(this.f.onWillRun(h=>this.D.fire(h))),this.viewItems=[],this.r=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar",e.animated!==!1&&this.domNode.classList.add("animated");let a,n;switch(this.l){case 0:a=[15],n=[17];break;case 1:a=[16],n=[18],this.domNode.className+=" vertical";break}this.B(N.$8N(this.domNode,N.$JO.KEY_DOWN,h=>{const s=new O.$5N(h);let v=!0;const D=typeof this.r=="number"?this.viewItems[this.r]:void 0;a&&(s.equals(a[0])||s.equals(a[1]))?v=this.M():n&&(s.equals(n[0])||s.equals(n[1]))?v=this.L():s.equals(9)&&this.z?this.y.fire():s.equals(14)?v=this.I():s.equals(13)?v=this.J():s.equals(2)&&D instanceof i.$tQ&&D.trapsArrowNavigation?v=this.L():this.G(s)?this.m.keyDown?this.O(s):this.t=!0:v=!1,v&&(s.preventDefault(),s.stopPropagation())})),this.B(N.$8N(this.domNode,N.$JO.KEY_UP,h=>{const s=new O.$5N(h);this.G(s)?(!this.m.keyDown&&this.t&&(this.t=!1,this.O(s)),s.preventDefault(),s.stopPropagation()):(s.equals(2)||s.equals(1026))&&this.H()})),this.s=this.B(N.$OO(this.domNode)),this.B(this.s.onDidBlur(()=>{(N.$DO()===this.domNode||!N.$vO(N.$DO(),this.domNode))&&(this.w.fire(),this.p=this.r,this.r=void 0,this.t=!1)})),this.B(this.s.onDidFocus(()=>this.H())),this.v=document.createElement("ul"),this.v.className="actions-container",this.b.highlightToggledItems&&this.v.classList.add("highlight-toggled"),this.v.setAttribute("role",this.b.ariaRole||"toolbar"),this.b.ariaLabel&&this.v.setAttribute("aria-label",this.b.ariaLabel),this.domNode.appendChild(this.v),l.appendChild(this.domNode)}F(){this.length()>=2?this.v.setAttribute("role",this.b.ariaRole||"toolbar"):this.v.setAttribute("role","presentation")}setAriaLabel(l){l?this.v.setAttribute("aria-label",l):this.v.removeAttribute("aria-label")}setFocusable(l){if(this.u=l,this.u){const e=this.viewItems.find(a=>a instanceof i.$tQ&&a.isEnabled());e instanceof i.$tQ&&e.setFocusable(!0)}else this.viewItems.forEach(e=>{e instanceof i.$tQ&&e.setFocusable(!1)})}G(l){let e=!1;return this.m.keys.forEach(a=>{e=e||l.equals(a)}),e}H(){for(let l=0;l<this.v.children.length;l++){const e=this.v.children[l];if(N.$vO(N.$DO(),e)){this.r=l;break}}}get context(){return this.j}set context(l){this.j=l,this.viewItems.forEach(e=>e.setActionContext(l))}get actionRunner(){return this.f}set actionRunner(l){this.f=l,this.g.clear(),this.g.add(this.f.onDidRun(e=>this.C.fire(e))),this.g.add(this.f.onWillRun(e=>this.D.fire(e))),this.viewItems.forEach(e=>e.actionRunner=l)}getContainer(){return this.domNode}hasAction(l){return this.viewItems.findIndex(e=>e.action.id===l.id)!==-1}getAction(l){if(typeof l=="number")return this.viewItems[l]?.action;if(l instanceof HTMLElement){for(;l.parentElement!==this.v;){if(!l.parentElement)return;l=l.parentElement}for(let e=0;e<this.v.childNodes.length;e++)if(this.v.childNodes[e]===l)return this.viewItems[e].action}}push(l,e={}){const a=Array.isArray(l)?l:[l];let n=o.$me(e.index)?e.index:null;a.forEach(h=>{const s=document.createElement("li");s.className="action-item",s.setAttribute("role","presentation");let v;const D={hoverDelegate:this.b.hoverDelegate,...e};this.b.actionViewItemProvider&&(v=this.b.actionViewItemProvider(h,D)),v||(v=new i.$uQ(this.context,h,D)),this.b.allowContextMenu||this.n.set(v,N.$8N(s,N.$JO.CONTEXT_MENU,E=>{N.$LO.stop(E,!0)})),v.actionRunner=this.f,v.setActionContext(this.context),v.render(s),this.u&&v instanceof i.$tQ&&this.viewItems.length===0&&v.setFocusable(!0),n===null||n<0||n>=this.v.children.length?(this.v.appendChild(s),this.viewItems.push(v)):(this.v.insertBefore(s,this.v.children[n]),this.viewItems.splice(n,0,v),n++)}),typeof this.r=="number"&&this.focus(this.r),this.F()}getWidth(l){if(l>=0&&l<this.v.children.length){const e=this.v.children.item(l);if(e)return e.clientWidth}return 0}getHeight(l){if(l>=0&&l<this.v.children.length){const e=this.v.children.item(l);if(e)return e.clientHeight}return 0}pull(l){l>=0&&l<this.viewItems.length&&(this.v.removeChild(this.v.childNodes[l]),this.n.deleteAndDispose(this.viewItems[l]),(0,y.$gb)(this.viewItems.splice(l,1)),this.F())}clear(){this.isEmpty()||(this.viewItems=(0,y.$gb)(this.viewItems),this.n.clearAndDisposeAll(),N.$6N(this.v),this.F())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(l){let e=!1,a;if(l===void 0?e=!0:typeof l=="number"?a=l:typeof l=="boolean"&&(e=l),e&&typeof this.r>"u"){const n=this.viewItems.findIndex(h=>h.isEnabled());this.r=n===-1?void 0:n,this.N(void 0,void 0,!0)}else a!==void 0&&(this.r=a),this.N(void 0,void 0,!0)}I(){return this.r=this.length()-1,this.L(!0)}J(){return this.r=0,this.M(!0)}L(l){if(typeof this.r>"u")this.r=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const e=this.r;let a;do{if(!l&&this.b.preventLoopNavigation&&this.r+1>=this.viewItems.length)return this.r=e,!1;this.r=(this.r+1)%this.viewItems.length,a=this.viewItems[this.r]}while(this.r!==e&&(this.b.focusOnlyEnabledItems&&!a.isEnabled()||a.action.id===j.$9h.ID));return this.N(),!0}M(l){if(typeof this.r>"u")this.r=0;else if(this.viewItems.length<=1)return!1;const e=this.r;let a;do{if(this.r=this.r-1,this.r<0){if(!l&&this.b.preventLoopNavigation)return this.r=e,!1;this.r=this.viewItems.length-1}a=this.viewItems[this.r]}while(this.r!==e&&(this.b.focusOnlyEnabledItems&&!a.isEnabled()||a.action.id===j.$9h.ID));return this.N(!0),!0}N(l,e,a=!1){typeof this.r>"u"&&this.v.focus({preventScroll:e}),this.p!==void 0&&this.p!==this.r&&this.viewItems[this.p]?.blur();const n=this.r!==void 0&&this.viewItems[this.r];if(n){let h=!0;o.$we(n.focus)||(h=!1),this.b.focusOnlyEnabledItems&&o.$we(n.isEnabled)&&!n.isEnabled()&&(h=!1),n.action.id===j.$9h.ID&&(h=!1),h?(a||this.p!==this.r)&&(n.focus(l),this.p=this.r):(this.v.focus({preventScroll:e}),this.p=void 0)}}O(l){if(typeof this.r>"u")return;const e=this.viewItems[this.r];if(e instanceof i.$tQ){const a=e._context===null||e._context===void 0?l:e._context;this.run(e._action,a)}}async run(l,e){await this.f.run(l,e)}dispose(){this.j=void 0,this.viewItems=(0,y.$gb)(this.viewItems),this.getContainer().remove(),super.dispose()}}t.$HP=g;function L(r){if(!r.length)return r;let l=-1;for(let a=0;a<r.length;a++)if(r[a].id!==j.$9h.ID){l=a;break}if(l===-1)return[];r=r.slice(l);for(let a=r.length-1;a>=0&&r[a].id===j.$9h.ID;a--)r.splice(a,1);let e=!1;for(let a=r.length-1;a>=0;a--){const n=r[a].id===j.$9h.ID;n&&!e?r.splice(a,1):n?n&&(e=!1):e=!0}return r}t.$IP=L}),define(be[62],$e([1,0,4,21,52,61,54,57,20,3,78,48,105,93]),function(re,t,N,O,i,j,A,y,o,u,g,L,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$aR=t.$_Q=t.$$Q=t.MessageType=void 0;const l=N.$;var e;(function(h){h[h.INFO=1]="INFO",h[h.WARNING=2]="WARNING",h[h.ERROR=3]="ERROR"})(e||(t.MessageType=e={})),t.$$Q={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class a extends o.$pP{constructor(s,v,D){super(),this.s="idle",this.y=Number.POSITIVE_INFINITY,this.I=this.B(new u.$ec),this.onDidChange=this.I.event,this.J=this.B(new u.$ec),this.onDidHeightChange=this.J.event,this.a=v,this.g=D,this.h=null,this.i=this.g.placeholder||"",this.l=this.g.tooltip??(this.i||""),this.n=this.g.ariaLabel||"",this.g.validationOptions&&(this.r=this.g.validationOptions.validation),this.element=N.$QO(s,l(".monaco-inputbox.idle"));const E=this.g.flexibleHeight?"textarea":"input",f=N.$QO(this.element,l(".ibwrapper"));if(this.b=N.$QO(f,l(E+".input.empty")),this.b.setAttribute("autocorrect","off"),this.b.setAttribute("autocapitalize","off"),this.b.setAttribute("spellcheck","false"),this.D(this.b,()=>this.element.classList.add("synthetic-focus")),this.C(this.b,()=>this.element.classList.remove("synthetic-focus")),this.g.flexibleHeight){this.y=typeof this.g.flexibleMaxHeight=="number"?this.g.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.t=N.$QO(f,l("div.mirror")),this.t.innerText="\xA0",this.H=new y.$zP(this.element,{vertical:1}),this.g.flexibleWidth&&(this.b.setAttribute("wrap","off"),this.t.style.whiteSpace="pre",this.t.style.wordWrap="initial"),N.$QO(s,this.H.getDomNode()),this.B(this.H),this.B(this.H.onScroll(P=>this.b.scrollTop=P.scrollTop));const C=this.B(new O.$PP(document,"selectionchange")),T=u.Event.filter(C.event,()=>document.getSelection()?.anchorNode===f);this.B(T(this.N,this)),this.B(this.onDidHeightChange(this.N,this))}else this.b.type=this.g.type||"text",this.b.setAttribute("wrap","off");this.n&&this.b.setAttribute("aria-label",this.n),this.i&&!this.g.showPlaceholderOnFocus&&this.setPlaceHolder(this.i),this.l&&this.setTooltip(this.l),this.z(this.b,()=>this.R()),this.C(this.b,()=>this.L()),this.D(this.b,()=>this.M()),this.B(this.G(this.b)),setTimeout(()=>this.S(),0),this.g.actions&&(this.c=this.B(new j.$HP(this.element)),this.c.push(this.g.actions,{icon:!0,label:!1})),this.U()}L(){this.Q(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder","")}M(){this.P(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder",this.i||"")}setPlaceHolder(s){this.i=s,this.b.setAttribute("placeholder",s)}setTooltip(s){this.l=s,this.b.title=s}setAriaLabel(s){this.n=s,s?this.b.setAttribute("aria-label",this.n):this.b.removeAttribute("aria-label")}getAriaLabel(){return this.n}get mirrorElement(){return this.t}get inputElement(){return this.b}get value(){return this.b.value}set value(s){this.b.value!==s&&(this.b.value=s,this.R())}get step(){return this.b.step}set step(s){this.b.step=s}get height(){return typeof this.v=="number"?this.v:N.$tO(this.element)}focus(){this.b.focus()}blur(){this.b.blur()}hasFocus(){return document.activeElement===this.b}select(s=null){this.b.select(),s&&(this.b.setSelectionRange(s.start,s.end),s.end===this.b.value.length&&(this.b.scrollLeft=this.b.scrollWidth))}isSelectionAtEnd(){return this.b.selectionEnd===this.b.value.length&&this.b.selectionStart===this.b.selectionEnd}enable(){this.b.removeAttribute("disabled")}disable(){this.blur(),this.b.disabled=!0,this.Q()}setEnabled(s){s?this.enable():this.disable()}get width(){return N.$pO(this.b)}set width(s){if(this.g.flexibleHeight&&this.g.flexibleWidth){let v=0;if(this.t){const D=parseFloat(this.t.style.paddingLeft||"")||0,E=parseFloat(this.t.style.paddingRight||"")||0;v=D+E}this.b.style.width=s-v+"px"}else this.b.style.width=s+"px";this.t&&(this.t.style.width=s+"px")}set paddingRight(s){this.b.style.width=`calc(100% - ${s}px)`,this.t&&(this.t.style.paddingRight=s+"px")}N(){if(typeof this.w!="number"||typeof this.v!="number"||!this.H)return;const s=this.w,v=this.v,D=this.b.scrollTop;this.H.setScrollDimensions({scrollHeight:s,height:v}),this.H.setScrollPosition({scrollTop:D})}showMessage(s,v){if(this.s==="open"&&(0,L.$Mm)(this.h,s))return;this.h=s,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.O(s.type));const D=this.stylesForType(this.h.type);this.element.style.border=`1px solid ${N.$9O(D.border,"transparent")}`,this.h.content&&(this.hasFocus()||v)&&this.P()}hideMessage(){this.h=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this.Q(),this.U()}isInputValid(){return!!this.r&&!this.r(this.value)}validate(){let s=null;return this.r&&(s=this.r(this.value),s?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(s)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),s?.type}stylesForType(s){const v=this.g.inputBoxStyles;switch(s){case 1:return{border:v.inputValidationInfoBorder,background:v.inputValidationInfoBackground,foreground:v.inputValidationInfoForeground};case 2:return{border:v.inputValidationWarningBorder,background:v.inputValidationWarningBackground,foreground:v.inputValidationWarningForeground};default:return{border:v.inputValidationErrorBorder,background:v.inputValidationErrorBackground,foreground:v.inputValidationErrorForeground}}}O(s){switch(s){case 1:return"info";case 2:return"warning";default:return"error"}}P(){if(!this.a||!this.h)return;let s;const v=()=>s.style.width=N.$pO(this.element)+"px";this.a.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:E=>{if(!this.h)return null;s=N.$QO(E,l(".monaco-inputbox-container")),v();const f={inline:!0,className:"monaco-inputbox-message"},C=this.h.formatContent?(0,i.$NP)(this.h.content,f):(0,i.$MP)(this.h.content,f);C.classList.add(this.O(this.h.type));const T=this.stylesForType(this.h.type);return C.style.backgroundColor=T.background??"",C.style.color=T.foreground??"",C.style.border=T.border?`1px solid ${T.border}`:"",N.$QO(s,C),null},onHide:()=>{this.s="closed"},layout:v});let D;this.h.type===3?D=r.localize(0,null,this.h.content):this.h.type===2?D=r.localize(1,null,this.h.content):D=r.localize(2,null,this.h.content),A.$RP(D),this.s="open"}Q(){this.a&&(this.s==="open"&&this.a.hideContextView(),this.s="idle")}R(){this.I.fire(this.value),this.validate(),this.S(),this.b.classList.toggle("empty",!this.value),this.s==="open"&&this.a&&this.a.layout()}S(){if(!this.t)return;const s=this.value,D=s.charCodeAt(s.length-1)===10?" ":"";(s+D).replace(/\u000c/g,"")?this.t.textContent=s+D:this.t.innerText="\xA0",this.layout()}U(){const s=this.g.inputBoxStyles,v=s.inputBackground??"",D=s.inputForeground??"",E=s.inputBorder??"";this.element.style.backgroundColor=v,this.element.style.color=D,this.b.style.backgroundColor="inherit",this.b.style.color=D,this.element.style.border=`1px solid ${N.$9O(E,"transparent")}`}layout(){if(!this.t)return;const s=this.w;this.w=N.$tO(this.t),s!==this.w&&(this.v=Math.min(this.w,this.y),this.b.style.height=this.v+"px",this.J.fire(this.w))}insertAtCursor(s){const v=this.inputElement,D=v.selectionStart,E=v.selectionEnd,f=v.value;D!==null&&E!==null&&(this.value=f.substr(0,D)+s+f.substr(E),v.setSelectionRange(D+1,D+1),this.layout())}dispose(){this.Q(),this.h=null,this.c?.dispose(),super.dispose()}}t.$_Q=a;class n extends a{constructor(s,v,D){const E=r.localize(3,null),f=` or \u21C5 ${E}`,C=` (\u21C5 ${E})`;super(s,v,D),this.Y=this.B(new u.$ec),this.onDidFocus=this.Y.event,this.Z=this.B(new u.$ec),this.onDidBlur=this.Z.event,this.W=new g.$9Q(D.history,100);const T=()=>{if(D.showHistoryHint&&D.showHistoryHint()&&!this.i.endsWith(f)&&!this.i.endsWith(C)&&this.W.getHistory().length){const P=this.i.endsWith(")")?f:C,m=this.i+P;D.showPlaceholderOnFocus&&document.activeElement!==this.b?this.i=m:this.setPlaceHolder(m)}};this.X=new MutationObserver((P,m)=>{P.forEach($=>{$.target.textContent||T()})}),this.X.observe(this.b,{attributeFilter:["class"]}),this.D(this.b,()=>T()),this.C(this.b,()=>{const P=m=>{if(this.i.endsWith(m)){const $=this.i.slice(0,this.i.length-m.length);return D.showPlaceholderOnFocus?this.i=$:this.setPlaceHolder($),!0}else return!1};P(C)||P(f)})}dispose(){super.dispose(),this.X&&(this.X.disconnect(),this.X=void 0)}addToHistory(s){this.value&&(s||this.value!==this.cb())&&this.W.add(this.value)}prependHistory(s){const v=this.getHistory();this.clearHistory(),s.forEach(D=>{this.W.add(D)}),v.forEach(D=>{this.W.add(D)})}getHistory(){return this.W.getHistory()}isAtFirstInHistory(){return this.W.isFirst()}isAtLastInHistory(){return this.W.isLast()}isNowhereInHistory(){return this.W.isNowhere()}showNextValue(){this.W.has(this.value)||this.addToHistory();let s=this.eb();s&&(s=s===this.value?this.eb():s),this.value=s??"",A.$SP(this.value?this.value:r.localize(4,null))}showPreviousValue(){this.W.has(this.value)||this.addToHistory();let s=this.db();s&&(s=s===this.value?this.db():s),s&&(this.value=s,A.$SP(this.value))}clearHistory(){this.W.clear()}L(){super.L(),this.Z.fire()}M(){super.M(),this.Y.fire()}cb(){let s=this.W.current();return s||(s=this.W.last(),this.W.next()),s}db(){return this.W.previous()||this.W.first()}eb(){return this.W.next()}}t.$aR=n}),define(be[63],$e([1,0,60,20,17,18,3,98]),function(re,t,N,O,i,j,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sQ=t.$rQ=t.$qQ=t.$pQ=void 0,t.$pQ={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class y extends N.$tQ{constructor(L,r,l){super(L,r,l),this.a=this.B(new o({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.m.keybinding?`${this._action.label} (${this.m.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:l.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:l.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:l.toggleStyles?.inputActiveOptionForeground})),this.B(this.a.onChange(()=>this._action.checked=!!this.a&&this.a.checked))}render(L){this.element=L,this.element.appendChild(this.a.domNode)}u(){this.a&&(this.isEnabled()?this.a.enable():this.a.disable())}G(){this.a.checked=!!this._action.checked}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(L){this.a.domNode.tabIndex=L?0:-1}}t.$qQ=y;class o extends O.$pP{constructor(L){super(),this.a=this.B(new A.$ec),this.onChange=this.a.event,this.b=this.B(new A.$ec),this.onKeyDown=this.b.event,this.c=L,this.s=this.c.isChecked;const r=["monaco-custom-toggle"];this.c.icon&&(this.g=this.c.icon,r.push(...j.ThemeIcon.asClassNameArray(this.g))),this.c.actionClassName&&r.push(...this.c.actionClassName.split(" ")),this.s&&r.push("checked"),this.domNode=document.createElement("div"),this.domNode.title=this.c.title,this.domNode.classList.add(...r),this.c.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.setAttribute("aria-label",this.c.title),this.t(),this.f(this.domNode,l=>{this.enabled&&(this.checked=!this.s,this.a.fire(!1),l.preventDefault())}),this.B(this.G(this.domNode)),this.p(this.domNode,l=>{if(l.keyCode===10||l.keyCode===3){this.checked=!this.s,this.a.fire(!0),l.preventDefault(),l.stopPropagation();return}this.b.fire(l)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this.s}set checked(L){this.s=L,this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.classList.toggle("checked",this.s),this.t()}setIcon(L){this.g&&this.domNode.classList.remove(...j.ThemeIcon.asClassNameArray(this.g)),this.g=L,this.g&&this.domNode.classList.add(...j.ThemeIcon.asClassNameArray(this.g))}width(){return 2+2+2+16}t(){this.domNode&&(this.domNode.style.borderColor=this.s&&this.c.inputActiveOptionBorder||"",this.domNode.style.color=this.s&&this.c.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this.s&&this.c.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(L){this.domNode.title=L,this.domNode.setAttribute("aria-label",L)}}t.$rQ=o;class u extends O.$pP{constructor(L,r,l){super(),this.c=L,this.g=r,this.a=new o({title:this.c,isChecked:this.g,icon:i.$Cj.check,actionClassName:"monaco-checkbox",...t.$pQ}),this.domNode=this.a.domNode,this.b=l,this.h(),this.B(this.a.onChange(()=>this.h()))}get checked(){return this.a.checked}set checked(L){this.a.checked=L,this.h()}focus(){this.domNode.focus()}hasFocus(){return this.domNode===document.activeElement}h(){this.domNode.style.color=this.b.checkboxForeground||"",this.domNode.style.backgroundColor=this.b.checkboxBackground||"",this.domNode.style.borderColor=this.b.checkboxBorder||""}}t.$sQ=u}),define(be[126],$e([1,0,63,17,103]),function(re,t,N,O,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nR=t.$mR=t.$lR=void 0;const j=i.localize(0,null),A=i.localize(1,null),y=i.localize(2,null);class o extends N.$rQ{constructor(r){super({icon:O.$Cj.caseSensitive,title:j+r.appendTitle,isChecked:r.isChecked,inputActiveOptionBorder:r.inputActiveOptionBorder,inputActiveOptionForeground:r.inputActiveOptionForeground,inputActiveOptionBackground:r.inputActiveOptionBackground})}}t.$lR=o;class u extends N.$rQ{constructor(r){super({icon:O.$Cj.wholeWord,title:A+r.appendTitle,isChecked:r.isChecked,inputActiveOptionBorder:r.inputActiveOptionBorder,inputActiveOptionForeground:r.inputActiveOptionForeground,inputActiveOptionBackground:r.inputActiveOptionBackground})}}t.$mR=u;class g extends N.$rQ{constructor(r){super({icon:O.$Cj.regex,title:y+r.appendTitle,isChecked:r.isChecked,inputActiveOptionBorder:r.inputActiveOptionBorder,inputActiveOptionForeground:r.inputActiveOptionForeground,inputActiveOptionBackground:r.inputActiveOptionBackground})}}t.$nR=g}),define(be[127],$e([1,0,4,126,62,20,3,102,2,92]),function(re,t,N,O,i,j,A,y,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oR=void 0;const u=y.localize(0,null);class g extends j.$pP{static{this.OPTION_CHANGE="optionChange"}constructor(r,l,e){super(),this.i=!0,this.l=!1,this.n=new o.$kb,this.H=[],this.I=this.B(new A.$ec),this.onDidOptionChange=this.I.event,this.J=this.B(new A.$ec),this.onKeyDown=this.J.event,this.L=this.B(new A.$ec),this.onMouseDown=this.L.event,this.M=this.B(new A.$ec),this.onInput=this.M.event,this.N=this.B(new A.$ec),this.onKeyUp=this.N.event,this.O=this.B(new A.$ec),this.onCaseSensitiveKeyDown=this.O.event,this.P=this.B(new A.$ec),this.onRegexKeyDown=this.P.event,this.R=0,this.a=e.placeholder||"",this.b=e.validation,this.c=e.label||u,this.h=!!e.showCommonFindToggles;const a=e.appendCaseSensitiveLabel||"",n=e.appendWholeWordsLabel||"",h=e.appendRegexLabel||"",s=e.history||[],v=!!e.flexibleHeight,D=!!e.flexibleWidth,E=e.flexibleMaxHeight;if(this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this.B(new i.$aR(this.domNode,l,{placeholder:this.a||"",ariaLabel:this.c||"",validationOptions:{validation:this.b},history:s,showHistoryHint:e.showHistoryHint,flexibleHeight:v,flexibleWidth:D,flexibleMaxHeight:E,inputBoxStyles:e.inputBoxStyles})),this.h){this.v=this.B(new O.$nR({appendTitle:h,isChecked:!1,...e.toggleStyles})),this.B(this.v.onChange(C=>{this.I.fire(C),!C&&this.i&&this.inputBox.focus(),this.validate()})),this.B(this.v.onKeyDown(C=>{this.P.fire(C)})),this.w=this.B(new O.$mR({appendTitle:n,isChecked:!1,...e.toggleStyles})),this.B(this.w.onChange(C=>{this.I.fire(C),!C&&this.i&&this.inputBox.focus(),this.validate()})),this.y=this.B(new O.$lR({appendTitle:a,isChecked:!1,...e.toggleStyles})),this.B(this.y.onChange(C=>{this.I.fire(C),!C&&this.i&&this.inputBox.focus(),this.validate()})),this.B(this.y.onKeyDown(C=>{this.O.fire(C)}));const f=[this.y.domNode,this.w.domNode,this.v.domNode];this.p(this.domNode,C=>{if(C.equals(15)||C.equals(17)||C.equals(9)){const T=f.indexOf(document.activeElement);if(T>=0){let P=-1;C.equals(17)?P=(T+1)%f.length:C.equals(15)&&(T===0?P=f.length-1:P=T-1),C.equals(9)?(f[T].blur(),this.inputBox.focus()):P>=0&&f[P].focus(),N.$LO.stop(C,!0)}}})}this.s=document.createElement("div"),this.s.className="controls",this.s.style.display=this.h?"":"none",this.y&&this.s.append(this.y.domNode),this.w&&this.s.appendChild(this.w.domNode),this.v&&this.s.appendChild(this.v.domNode),this.setAdditionalToggles(e?.additionalToggles),this.s&&this.domNode.appendChild(this.s),r?.appendChild(this.domNode),this.B(N.$8N(this.inputBox.inputElement,"compositionstart",f=>{this.l=!0})),this.B(N.$8N(this.inputBox.inputElement,"compositionend",f=>{this.l=!1,this.M.fire()})),this.p(this.inputBox.inputElement,f=>this.J.fire(f)),this.u(this.inputBox.inputElement,f=>this.N.fire(f)),this.z(this.inputBox.inputElement,f=>this.M.fire()),this.j(this.inputBox.inputElement,f=>this.L.fire(f))}get isImeSessionInProgress(){return this.l}get onDidChange(){return this.inputBox.onDidChange}layout(r){this.inputBox.layout(),this.Q(r.collapsedFindWidget)}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.v?.enable(),this.w?.enable(),this.y?.enable();for(const r of this.H)r.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.v?.disable(),this.w?.disable(),this.y?.disable();for(const r of this.H)r.disable()}setFocusInputOnOptionClick(r){this.i=r}setEnabled(r){r?this.enable():this.disable()}setAdditionalToggles(r){for(const l of this.H)l.domNode.remove();this.H=[],this.n.dispose(),this.n=new o.$kb;for(const l of r??[])this.n.add(l),this.s.appendChild(l.domNode),this.n.add(l.onChange(e=>{this.I.fire(e),!e&&this.i&&this.inputBox.focus()})),this.H.push(l);this.H.length>0&&(this.s.style.display=""),this.Q()}Q(r=!1){r?this.inputBox.paddingRight=0:this.inputBox.paddingRight=(this.y?.width()??0)+(this.w?.width()??0)+(this.v?.width()??0)+this.H.reduce((l,e)=>l+e.width(),0)}clear(){this.S(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(r){this.inputBox.value!==r&&(this.inputBox.value=r)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.y?.checked??!1}setCaseSensitive(r){this.y&&(this.y.checked=r)}getWholeWords(){return this.w?.checked??!1}setWholeWords(r){this.w&&(this.w.checked=r)}getRegex(){return this.v?.checked??!1}setRegex(r){this.v&&(this.v.checked=r,this.validate())}focusOnCaseSensitive(){this.y?.focus()}focusOnRegex(){this.v?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this.R),this.R=1-this.R,this.domNode.classList.add("highlight-"+this.R)}validate(){this.inputBox.validate()}showMessage(r){this.inputBox.showMessage(r)}clearMessage(){this.inputBox.hideMessage()}S(){this.inputBox.hideMessage()}}t.$oR=g}),define(be[128],$e([1,0,4,21,14,61,127,62,58,37,63,55,24,34,13,9,17,18,69,3,32,2,44,7,107,99]),function(re,t,N,O,i,j,A,y,o,u,g,L,r,l,e,a,n,h,s,v,D,E,f,C,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$XR=t.TreeFindMatchType=t.TreeFindMode=t.$WR=t.$VR=t.RenderIndentGuides=t.$UR=t.$TR=void 0;class P extends o.$3P{set context(d){this.c.context=d}get context(){return this.c.context}constructor(d){super(d.elements.map(p=>p.element)),this.c=d}}function m(_){return _ instanceof o.$3P?new P(_):_}class ${constructor(d,p){this.c=d,this.d=p,this.b=E.$lb.None}getDragURI(d){return this.d.getDragURI(d.element)}getDragLabel(d,p){if(this.d.getDragLabel)return this.d.getDragLabel(d.map(H=>H.element),p)}onDragStart(d,p){this.d.onDragStart?.(m(d),p)}onDragOver(d,p,H,Q,q=!0){const x=this.d.onDragOver(m(d),p&&p.element,H,Q),W=this.a!==p;if(W&&(this.b.dispose(),this.a=p),typeof p>"u")return x;if(W&&typeof x!="boolean"&&x.autoExpand&&(this.b=(0,a.$wg)(()=>{const I=this.c(),V=I.getNodeLocation(p);I.isCollapsed(V)&&I.setCollapsed(V,!1),this.a=void 0},500)),typeof x=="boolean"||!x.accept||typeof x.bubble>"u"||x.feedback){if(!q){const I=typeof x=="boolean"?x:x.accept,V=typeof x=="boolean"?void 0:x.effect;return{accept:I,effect:V,feedback:[H]}}return x}if(x.bubble===1){const I=this.c(),V=I.getNodeLocation(p),Z=I.getParentNodeLocation(V),oe=I.getNode(Z),ge=Z&&I.getListIndex(Z);return this.onDragOver(d,oe,ge,Q,!1)}const c=this.c(),k=c.getNodeLocation(p),b=c.getListIndex(k),w=c.getListRenderCount(k);return{...x,feedback:(0,e.$wf)(b,b+w)}}drop(d,p,H,Q){this.b.dispose(),this.a=void 0,this.d.drop(m(d),p&&p.element,H,Q)}onDragEnd(d){this.d.onDragEnd?.(d)}}function F(_,d){return d&&{...d,identityProvider:d.identityProvider&&{getId(p){return d.identityProvider.getId(p.element)}},dnd:d.dnd&&new $(_,d.dnd),multipleSelectionController:d.multipleSelectionController&&{isSelectionSingleChangeEvent(p){return d.multipleSelectionController.isSelectionSingleChangeEvent({...p,element:p.element})},isSelectionRangeChangeEvent(p){return d.multipleSelectionController.isSelectionRangeChangeEvent({...p,element:p.element})}},accessibilityProvider:d.accessibilityProvider&&{...d.accessibilityProvider,getSetSize(p){const H=_(),Q=H.getNodeLocation(p),q=H.getParentNodeLocation(Q);return H.getNode(q).visibleChildrenCount},getPosInSet(p){return p.visibleChildIndex+1},isChecked:d.accessibilityProvider&&d.accessibilityProvider.isChecked?p=>d.accessibilityProvider.isChecked(p.element):void 0,getRole:d.accessibilityProvider&&d.accessibilityProvider.getRole?p=>d.accessibilityProvider.getRole(p.element):()=>"treeitem",getAriaLabel(p){return d.accessibilityProvider.getAriaLabel(p.element)},getWidgetAriaLabel(){return d.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:d.accessibilityProvider&&d.accessibilityProvider.getWidgetRole?()=>d.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:d.accessibilityProvider&&d.accessibilityProvider.getAriaLevel?p=>d.accessibilityProvider.getAriaLevel(p.element):p=>p.depth,getActiveDescendantId:d.accessibilityProvider.getActiveDescendantId&&(p=>d.accessibilityProvider.getActiveDescendantId(p.element))},keyboardNavigationLabelProvider:d.keyboardNavigationLabelProvider&&{...d.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(p){return d.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(p.element)}}}}class R{constructor(d){this.a=d}getHeight(d){return this.a.getHeight(d.element)}getTemplateId(d){return this.a.getTemplateId(d.element)}hasDynamicHeight(d){return!!this.a.hasDynamicHeight&&this.a.hasDynamicHeight(d.element)}setDynamicHeight(d,p){this.a.setDynamicHeight?.(d.element,p)}}t.$TR=R;class B{static lift(d){return d instanceof B?d:new B(d)}static empty(d=0){return new B({focus:[],selection:[],expanded:Object.create(null),scrollTop:d})}constructor(d){if(this.focus=new Set(d.focus),this.selection=new Set(d.selection),d.expanded instanceof Array){this.expanded=Object.create(null);for(const p of d.expanded)this.expanded[p]=1}else this.expanded=d.expanded;this.expanded=d.expanded,this.scrollTop=d.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.$UR=B;var M;(function(_){_.None="none",_.OnHover="onHover",_.Always="always"})(M||(t.RenderIndentGuides=M={}));class z{get elements(){return this.b}constructor(d,p=[]){this.b=p,this.a=new E.$kb,this.onDidChange=v.Event.forEach(d,H=>this.b=H,this.a)}dispose(){this.a.dispose()}}class te{static{this.a=8}constructor(d,p,H,Q,q,x={}){this.o=d,this.p=p,this.q=Q,this.s=q,this.b=new Map,this.c=new Map,this.d=te.a,this.f=!1,this.g=!1,this.j=new Set,this.k=E.$lb.None,this.m=new E.$kb,this.templateId=d.templateId,this.updateOptions(x),v.Event.map(H,W=>W.node)(this.u,this,this.m),d.onDidChangeTwistieState?.(this.t,this,this.m)}updateOptions(d={}){if(typeof d.indent<"u"){const p=(0,f.$ul)(d.indent,0,40);if(p!==this.d){this.d=p;for(const[H,Q]of this.c)this.v(H,Q)}}if(typeof d.renderIndentGuides<"u"){const p=d.renderIndentGuides!==M.None;if(p!==this.g){this.g=p;for(const[H,Q]of this.c)this.w(H,Q);if(this.k.dispose(),p){const H=new E.$kb;this.q.onDidChange(this.x,this,H),this.k=H,this.x(this.q.elements)}}}typeof d.hideTwistiesOfChildlessElements<"u"&&(this.f=d.hideTwistiesOfChildlessElements)}renderTemplate(d){const p=(0,N.$QO)(d,(0,N.$)(".monaco-tl-row")),H=(0,N.$QO)(p,(0,N.$)(".monaco-tl-indent")),Q=(0,N.$QO)(p,(0,N.$)(".monaco-tl-twistie")),q=(0,N.$QO)(p,(0,N.$)(".monaco-tl-contents")),x=this.o.renderTemplate(q);return{container:d,indent:H,twistie:Q,indentGuidesDisposable:E.$lb.None,templateData:x}}renderElement(d,p,H,Q){this.c.set(d,H),this.b.set(d.element,d),this.v(d,H),this.o.renderElement(d,p,H.templateData,Q)}disposeElement(d,p,H,Q){H.indentGuidesDisposable.dispose(),this.o.disposeElement?.(d,p,H.templateData,Q),typeof Q=="number"&&(this.c.delete(d),this.b.delete(d.element))}disposeTemplate(d){this.o.disposeTemplate(d.templateData)}t(d){const p=this.b.get(d);p&&this.u(p)}u(d){const p=this.c.get(d);p&&(this.x(this.q.elements),this.v(d,p))}v(d,p){const H=te.a+(d.depth-1)*this.d;p.twistie.style.paddingLeft=`${H}px`,p.indent.style.width=`${H+this.d-16}px`,d.collapsible?p.container.setAttribute("aria-expanded",String(!d.collapsed)):p.container.removeAttribute("aria-expanded"),p.twistie.classList.remove(...h.ThemeIcon.asClassNameArray(n.$Cj.treeItemExpanded));let Q=!1;this.o.renderTwistie&&(Q=this.o.renderTwistie(d.element,p.twistie)),d.collapsible&&(!this.f||d.visibleChildrenCount>0)?(Q||p.twistie.classList.add(...h.ThemeIcon.asClassNameArray(n.$Cj.treeItemExpanded)),p.twistie.classList.add("collapsible"),p.twistie.classList.toggle("collapsed",d.collapsed)):p.twistie.classList.remove("collapsible","collapsed"),this.w(d,p)}w(d,p){if((0,N.$6N)(p.indent),p.indentGuidesDisposable.dispose(),!this.g)return;const H=new E.$kb,Q=this.p();for(;;){const q=Q.getNodeLocation(d),x=Q.getParentNodeLocation(q);if(!x)break;const W=Q.getNode(x),c=(0,N.$)(".indent-guide",{style:`width: ${this.d}px`});this.j.has(W)&&c.classList.add("active"),p.indent.childElementCount===0?p.indent.appendChild(c):p.indent.insertBefore(c,p.indent.firstElementChild),this.s.add(W,c),H.add((0,E.$jb)(()=>this.s.delete(W,c))),d=W}p.indentGuidesDisposable=H}x(d){if(!this.g)return;const p=new Set,H=this.p();d.forEach(Q=>{const q=H.getNodeLocation(Q);try{const x=H.getParentNodeLocation(q);Q.collapsible&&Q.children.length>0&&!Q.collapsed?p.add(Q):x&&p.add(H.getNode(x))}catch{}}),this.j.forEach(Q=>{p.has(Q)||this.s.forEach(Q,q=>q.classList.remove("active"))}),p.forEach(Q=>{this.j.has(Q)||this.s.forEach(Q,q=>q.classList.add("active"))}),this.j=p}dispose(){this.c.clear(),this.b.clear(),this.k.dispose(),(0,E.$gb)(this.m)}}class ne{get totalCount(){return this.a}get matchCount(){return this.b}set pattern(d){this.c=d,this.d=d.toLowerCase()}constructor(d,p,H){this.g=d,this.j=p,this.k=H,this.a=0,this.b=0,this.c="",this.d="",this.f=new E.$kb,d.onWillRefilter(this.m,this,this.f)}filter(d,p){let H=1;if(this.k){const x=this.k.filter(d,p);if(typeof x=="boolean"?H=x?1:0:(0,L.$QR)(x)?H=(0,L.$RR)(x.visibility):H=x,H===0)return!1}if(this.a++,!this.c)return this.b++,{data:D.FuzzyScore.Default,visibility:H};const Q=this.j.getKeyboardNavigationLabel(d),q=Array.isArray(Q)?Q:[Q];for(const x of q){const W=x&&x.toString();if(typeof W>"u")return{data:D.FuzzyScore.Default,visibility:H};let c;if(this.g.findMatchType===pe.Contiguous){const k=W.toLowerCase().indexOf(this.d);if(k>-1){c=[Number.MAX_SAFE_INTEGER,0];for(let b=this.d.length;b>0;b--)c.push(k+b-1)}}else c=(0,D.$xj)(this.c,this.d,0,W,W.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(c)return this.b++,q.length===1?{data:c,visibility:H}:{data:{label:W,score:c},visibility:H}}return this.g.findMode===ae.Filter?typeof this.g.options.defaultFindVisibility=="number"?this.g.options.defaultFindVisibility:this.g.options.defaultFindVisibility?this.g.options.defaultFindVisibility(d):2:{data:D.FuzzyScore.Default,visibility:H}}m(){this.a=0,this.b=0}dispose(){(0,E.$gb)(this.f)}}class se extends g.$rQ{constructor(d){super({icon:n.$Cj.listFilter,title:(0,T.localize)(0,null),isChecked:d.isChecked??!1,inputActiveOptionBorder:d.inputActiveOptionBorder,inputActiveOptionForeground:d.inputActiveOptionForeground,inputActiveOptionBackground:d.inputActiveOptionBackground})}}t.$VR=se;class ce extends g.$rQ{constructor(d){super({icon:n.$Cj.searchFuzzy,title:(0,T.localize)(1,null),isChecked:d.isChecked??!1,inputActiveOptionBorder:d.inputActiveOptionBorder,inputActiveOptionForeground:d.inputActiveOptionForeground,inputActiveOptionBackground:d.inputActiveOptionBackground})}}t.$WR=ce;const ue={inputBoxStyles:y.$$Q,toggleStyles:g.$pQ,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var ae;(function(_){_[_.Highlight=0]="Highlight",_[_.Filter=1]="Filter"})(ae||(t.TreeFindMode=ae={}));var pe;(function(_){_[_.Fuzzy=0]="Fuzzy",_[_.Contiguous=1]="Contiguous"})(pe||(t.TreeFindMatchType=pe={}));class Oe extends E.$lb{set mode(d){this.b.checked=d===ae.Filter,this.f.inputBox.setPlaceHolder(d===ae.Filter?(0,T.localize)(2,null):(0,T.localize)(3,null))}set matchType(d){this.c.checked=d===pe.Fuzzy}get value(){return this.f.inputBox.value}set value(d){this.f.inputBox.value=d}constructor(d,p,H,Q,q,x){super(),this.p=p,this.a=(0,N.h)(".monaco-tree-type-filter",[(0,N.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,N.h)(".monaco-tree-type-filter-input@findInput"),(0,N.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.j=0,this.k=0,this.m=0,this._onDidDisable=new v.$ec,this.onDidDisable=this._onDidDisable.event,d.appendChild(this.a.root),this.B((0,E.$jb)(()=>d.removeChild(this.a.root)));const W=x?.styles??ue;W.listFilterWidgetBackground&&(this.a.root.style.backgroundColor=W.listFilterWidgetBackground),W.listFilterWidgetShadow&&(this.a.root.style.boxShadow=`0 0 8px 2px ${W.listFilterWidgetShadow}`),this.b=this.B(new se({...W.toggleStyles,isChecked:Q===ae.Filter})),this.c=this.B(new ce({...W.toggleStyles,isChecked:q===pe.Fuzzy})),this.onDidChangeMode=v.Event.map(this.b.onChange,()=>this.b.checked?ae.Filter:ae.Highlight,this.q),this.onDidChangeMatchType=v.Event.map(this.c.onChange,()=>this.c.checked?pe.Fuzzy:pe.Contiguous,this.q),this.f=this.B(new A.$oR(this.a.findInput,H,{label:(0,T.localize)(4,null),additionalToggles:[this.b,this.c],showCommonFindToggles:!1,inputBoxStyles:W.inputBoxStyles,toggleStyles:W.toggleStyles,history:x?.history})),this.g=this.B(new j.$HP(this.a.actionbar)),this.mode=Q;const c=this.B(new O.$PP(this.f.inputBox.inputElement,"keydown")),k=this.B(v.Event.chain(c.event)).map(V=>new i.$5N(V)).event;this.B(k(V=>{if(V.equals(3)){V.preventDefault(),V.stopPropagation(),this.f.inputBox.addToHistory(),this.p.domFocus();return}if(V.equals(18)){V.preventDefault(),V.stopPropagation(),this.f.inputBox.isAtLastInHistory()||this.f.inputBox.isNowhereInHistory()?(this.f.inputBox.addToHistory(),this.p.domFocus()):this.f.inputBox.showNextValue();return}if(V.equals(16)){V.preventDefault(),V.stopPropagation(),this.f.inputBox.showPreviousValue();return}}));const b=this.B(new l.$7h("close",(0,T.localize)(5,null),"codicon codicon-close",!0,()=>this.dispose()));this.g.push(b,{icon:!0,label:!1});const w=this.B(new O.$PP(this.a.grab,"mousedown"));this.B(w.event(V=>{const Z=new E.$kb,oe=Z.add(new O.$PP(window,"mousemove")),ge=Z.add(new O.$PP(window,"mouseup")),we=this.k,Ae=V.pageX,Ee=this.m,ve=V.pageY;this.a.grab.classList.add("grabbing");const Le=this.a.root.style.transition;this.a.root.style.transition="unset";const Fe=Ke=>{const je=Ke.pageX-Ae;this.k=we-je;const Ie=Ke.pageY-ve;this.m=Ee+Ie,this.layout()};Z.add(oe.event(Fe)),Z.add(ge.event(Ke=>{Fe(Ke),this.a.grab.classList.remove("grabbing"),this.a.root.style.transition=Le,Z.dispose()}))}));const I=this.B(v.Event.chain(this.B(new O.$PP(this.a.grab,"keydown")).event)).map(V=>new i.$5N(V)).event;this.B(I(V=>{let Z,oe;if(V.keyCode===15?Z=Number.POSITIVE_INFINITY:V.keyCode===17?Z=0:V.keyCode===10&&(Z=this.k===0?Number.POSITIVE_INFINITY:0),V.keyCode===16?oe=0:V.keyCode===18&&(oe=Number.POSITIVE_INFINITY),Z!==void 0&&(V.preventDefault(),V.stopPropagation(),this.k=Z,this.layout()),oe!==void 0){V.preventDefault(),V.stopPropagation(),this.m=oe;const ge=this.a.root.style.transition;this.a.root.style.transition="unset",this.layout(),setTimeout(()=>{this.a.root.style.transition=ge},0)}})),this.onDidChangeValue=this.f.onDidChange}getHistory(){return this.f.inputBox.getHistory()}focus(){this.f.focus()}select(){this.f.select(),this.f.inputBox.addToHistory(!0)}layout(d=this.j){this.j=d,this.k=(0,f.$ul)(this.k,0,Math.max(0,d-212)),this.a.root.style.right=`${this.k}px`,this.m=(0,f.$ul)(this.m,0,24),this.a.root.style.top=`${this.m}px`}showMessage(d){this.f.showMessage(d)}clearMessage(){this.f.clearMessage()}async dispose(){this._onDidDisable.fire(),this.a.root.classList.add("disabled"),await(0,a.$vg)(300),super.dispose()}}class Te{get pattern(){return this.b}get mode(){return this.d}set mode(d){d!==this.d&&(this.d=d,this.g&&(this.g.mode=this.d),this.t.refilter(),this.A(),this.k.fire(d))}get matchType(){return this.f}set matchType(d){d!==this.f&&(this.f=d,this.g&&(this.g.matchType=this.f),this.t.refilter(),this.A(),this.m.fire(d))}constructor(d,p,H,Q,q,x={}){this.t=d,this.u=H,this.v=Q,this.w=q,this.x=x,this.b="",this.c="",this.j=0,this.k=new v.$ec,this.onDidChangeMode=this.k.event,this.m=new v.$ec,this.onDidChangeMatchType=this.m.event,this.o=new v.$ec,this.onDidChangePattern=this.o.event,this.p=new v.$ec,this.onDidChangeOpenState=this.p.event,this.q=new E.$kb,this.s=new E.$kb,this.d=d.options.defaultFindMode??ae.Highlight,this.f=d.options.defaultFindMatchType??pe.Fuzzy,p.onDidSplice(this.z,this,this.s)}updateOptions(d={}){d.defaultFindMode!==void 0&&(this.mode=d.defaultFindMode),d.defaultFindMatchType!==void 0&&(this.matchType=d.defaultFindMatchType)}open(){if(this.g){this.g.focus(),this.g.select();return}this.g=new Oe(this.u.getHTMLElement(),this.t,this.w,this.mode,this.matchType,{...this.x,history:this.a}),this.q.add(this.g),this.g.onDidChangeValue(this.y,this,this.q),this.g.onDidChangeMode(d=>this.mode=d,void 0,this.q),this.g.onDidChangeMatchType(d=>this.matchType=d,void 0,this.q),this.g.onDidDisable(this.close,this,this.q),this.g.layout(this.j),this.g.focus(),this.g.value=this.c,this.g.select(),this.p.fire(!0)}close(){this.g&&(this.a=this.g.getHistory(),this.g=void 0,this.q.dispose(),this.q=new E.$kb,this.c=this.pattern,this.y(""),this.t.domFocus(),this.p.fire(!1))}y(d){this.b=d,this.o.fire(d),this.v.pattern=d,this.t.refilter(),d&&this.t.focusNext(0,!0,void 0,H=>!D.FuzzyScore.isDefault(H.filterData));const p=this.t.getFocus();if(p.length>0){const H=p[0];this.t.getRelativeTop(H)===null&&this.t.reveal(H,.5)}this.A()}z(){!this.g||this.pattern.length===0||(this.t.refilter(),this.A())}A(){const d=this.v.totalCount>0&&this.v.matchCount===0;this.pattern&&d?this.t.options.showNotFoundMessage??!0?this.g?.showMessage({type:2,content:(0,T.localize)(6,null)}):this.g?.showMessage({type:2}):this.g?.clearMessage()}shouldAllowFocus(d){return!this.g||!this.pattern||this.d===ae.Filter||this.v.totalCount>0&&this.v.matchCount<=1?!0:!D.FuzzyScore.isDefault(d.filterData)}layout(d){this.j=d,this.g?.layout(d)}dispose(){this.a=void 0,this.o.dispose(),this.q.dispose(),this.s.dispose()}}function Me(_){let d=r.TreeMouseEventTarget.Unknown;return(0,N.$zO)(_.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?d=r.TreeMouseEventTarget.Twistie:(0,N.$zO)(_.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?d=r.TreeMouseEventTarget.Element:(0,N.$zO)(_.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(d=r.TreeMouseEventTarget.Filter),{browserEvent:_.browserEvent,element:_.element?_.element.element:null,target:d}}function fe(_){return{element:_.element?_.element.element:null,browserEvent:_.browserEvent,anchor:_.anchor}}function ie(_,d){d(_),_.children.forEach(p=>ie(p,d))}class K{get f(){return this.d||(this.d=this.m()),this.d}constructor(d,p){this.g=d,this.j=p,this.a=[],this.c=new v.$ec,this.onDidChange=this.c.event}set(d,p){!p?.__forceEvent&&(0,e.$$e)(this.a,d)||this.k(d,!1,p)}k(d,p,H){if(this.a=[...d],this.b=void 0,this.d=void 0,!p){const Q=this;this.c.fire({get elements(){return Q.get()},browserEvent:H})}}get(){return this.b||(this.b=this.a.map(d=>d.element)),[...this.b]}getNodes(){return this.a}has(d){return this.f.has(d)}onDidModelSplice({insertedNodes:d,deletedNodes:p}){if(!this.j){const c=this.m(),k=b=>c.delete(b);p.forEach(b=>ie(b,k)),this.set([...c.values()]);return}const H=new Set,Q=c=>H.add(this.j.getId(c.element).toString());p.forEach(c=>ie(c,Q));const q=new Map,x=c=>q.set(this.j.getId(c.element).toString(),c);d.forEach(c=>ie(c,x));const W=[];for(const c of this.a){const k=this.j.getId(c.element).toString();if(!H.has(k))W.push(c);else{const w=q.get(k);w&&w.visible&&W.push(w)}}if(this.a.length>0&&W.length===0){const c=this.g();c&&W.push(c)}this.k(W,!0)}m(){const d=new Set;for(const p of this.a)d.add(p);return d}}class U extends u.$aQ{constructor(d,p){super(d),this.x=p}u(d){if((0,u.$9P)(d.browserEvent.target)||(0,u.$7P)(d.browserEvent.target)||(0,u.$8P)(d.browserEvent.target)||d.browserEvent.isHandledByList)return;const p=d.element;if(!p)return super.u(d);if(this.p(d)||this.o(d))return super.u(d);const H=d.browserEvent.target,Q=H.classList.contains("monaco-tl-twistie")||H.classList.contains("monaco-icon-label")&&H.classList.contains("folder-icon")&&d.browserEvent.offsetX<16;let q=!1;if(typeof this.x.expandOnlyOnTwistieClick=="function"?q=this.x.expandOnlyOnTwistieClick(p.element):q=!!this.x.expandOnlyOnTwistieClick,q&&!Q&&d.browserEvent.detail!==2)return super.u(d);if(!this.x.expandOnDoubleClick&&d.browserEvent.detail===2)return super.u(d);if(p.collapsible){const x=this.x.getNodeLocation(p),W=d.browserEvent.altKey;if(this.x.setFocus([x]),this.x.toggleCollapsed(x,W),q&&Q){d.browserEvent.isHandledByList=!0;return}}super.u(d)}v(d){d.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.x.expandOnDoubleClick||d.browserEvent.isHandledByList||super.v(d)}}class ee extends u.$dQ{constructor(d,p,H,Q,q,x,W,c){super(d,p,H,Q,c),this.p=q,this.s=x,this.K=W}D(d){return new U(this,d.tree)}splice(d,p,H=[]){if(super.splice(d,p,H),H.length===0)return;const Q=[],q=[];let x;H.forEach((W,c)=>{this.p.has(W)&&Q.push(d+c),this.s.has(W)&&q.push(d+c),this.K.has(W)&&(x=d+c)}),Q.length>0&&super.setFocus((0,e.$of)([...super.getFocus(),...Q])),q.length>0&&super.setSelection((0,e.$of)([...super.getSelection(),...q])),typeof x=="number"&&super.setAnchor(x)}setFocus(d,p,H=!1){super.setFocus(d,p),H||this.p.set(d.map(Q=>this.element(Q)),p)}setSelection(d,p,H=!1){super.setSelection(d,p),H||this.s.set(d.map(Q=>this.element(Q)),p)}setAnchor(d,p=!1){super.setAnchor(d),p||(typeof d>"u"?this.K.set([]):this.K.set([this.element(d)]))}}class J{get onDidScroll(){return this.j.onDidScroll}get onDidChangeFocus(){return this.w.wrapEvent(this.p.onDidChange)}get onDidChangeSelection(){return this.w.wrapEvent(this.q.onDidChange)}get onMouseClick(){return v.Event.map(this.j.onMouseClick,Me)}get onMouseDblClick(){return v.Event.filter(v.Event.map(this.j.onMouseDblClick,Me),d=>d.target!==r.TreeMouseEventTarget.Filter)}get onContextMenu(){return v.Event.map(this.j.onContextMenu,fe)}get onTap(){return v.Event.map(this.j.onTap,Me)}get onPointer(){return v.Event.map(this.j.onPointer,Me)}get onKeyDown(){return this.j.onKeyDown}get onKeyUp(){return this.j.onKeyUp}get onKeyPress(){return this.j.onKeyPress}get onDidFocus(){return this.j.onDidFocus}get onDidBlur(){return this.j.onDidBlur}get onDidChangeModel(){return v.Event.signal(this.o.onDidSplice)}get onDidChangeCollapseState(){return this.o.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.o.onDidChangeRenderNodeCount}get findMode(){return this.x?.mode??ae.Highlight}set findMode(d){this.x&&(this.x.mode=d)}get findMatchType(){return this.x?.matchType??pe.Fuzzy}set findMatchType(d){this.x&&(this.x.matchType=d)}get onDidChangeFindPattern(){return this.x?this.x.onDidChangePattern:v.Event.None}get expandOnDoubleClick(){return typeof this.E.expandOnDoubleClick>"u"?!0:this.E.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this.E.expandOnlyOnTwistieClick>"u"?!0:this.E.expandOnlyOnTwistieClick}get onDidDispose(){return this.j.onDidDispose}constructor(d,p,H,Q,q={}){this.D=d,this.E=q,this.w=new v.$mc,this.onDidChangeFindOpenState=v.Event.None,this.A=new E.$kb,this.B=new v.$ec,this.onWillRefilter=this.B.event,this.C=new v.$ec,this.onDidUpdateOptions=this.C.event;const x=new R(H),W=new v.$nc,c=new v.$nc,k=this.A.add(new z(c.event)),b=new s.$L;this.k=Q.map(V=>new te(V,()=>this.o,W.event,k,b,q));for(const V of this.k)this.A.add(V);let w;q.keyboardNavigationLabelProvider&&(w=new ne(this,q.keyboardNavigationLabelProvider,q.filter),q={...q,filter:w},this.A.add(w)),this.p=new K(()=>this.j.getFocusedElements()[0],q.identityProvider),this.q=new K(()=>this.j.getSelectedElements()[0],q.identityProvider),this.u=new K(()=>this.j.getAnchorElement(),q.identityProvider),this.j=new ee(d,p,x,this.k,this.p,this.q,this.u,{...F(()=>this.o,q),tree:this}),this.o=this.I(d,this.j,q),W.input=this.o.onDidChangeCollapseState;const I=v.Event.forEach(this.o.onDidSplice,V=>{this.w.bufferEvents(()=>{this.p.onDidModelSplice(V),this.q.onDidModelSplice(V)})},this.A);if(I(()=>null,null,this.A),c.input=v.Event.chain(v.Event.any(I,this.p.onDidChange,this.q.onDidChange)).debounce(()=>null,0).map(()=>{const V=new Set;for(const Z of this.p.getNodes())V.add(Z);for(const Z of this.q.getNodes())V.add(Z);return[...V.values()]}).event,q.keyboardSupport!==!1){const V=v.Event.chain(this.j.onKeyDown).filter(Z=>!(0,u.$7P)(Z.target)).map(Z=>new i.$5N(Z));V.filter(Z=>Z.keyCode===15).on(this.F,this,this.A),V.filter(Z=>Z.keyCode===17).on(this.G,this,this.A),V.filter(Z=>Z.keyCode===10).on(this.H,this,this.A)}if((q.findWidgetEnabled??!0)&&q.keyboardNavigationLabelProvider&&q.contextViewProvider){const V=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.x=new Te(this,this.o,this.j,w,q.contextViewProvider,V),this.y=Z=>this.x.shouldAllowFocus(Z),this.onDidChangeFindOpenState=this.x.onDidChangeOpenState,this.A.add(this.x),this.onDidChangeFindMode=this.x.onDidChangeMode,this.onDidChangeFindMatchType=this.x.onDidChangeMatchType}else this.onDidChangeFindMode=v.Event.None,this.onDidChangeFindMatchType=v.Event.None;this.z=(0,N.$EO)(this.j.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this.E.renderIndentGuides===M.Always)}updateOptions(d={}){this.E={...this.E,...d};for(const p of this.k)p.updateOptions(d);this.j.updateOptions(this.E),this.x?.updateOptions(d),this.C.fire(this.E),this.getHTMLElement().classList.toggle("always",this.E.renderIndentGuides===M.Always)}get options(){return this.E}updateWidth(d){const p=this.o.getListIndex(d);p!==-1&&this.j.updateWidth(p)}getHTMLElement(){return this.j.getHTMLElement()}get contentHeight(){return this.j.contentHeight}get contentWidth(){return this.j.contentWidth}get onDidChangeContentHeight(){return this.j.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.j.onDidChangeContentWidth}get scrollTop(){return this.j.scrollTop}set scrollTop(d){this.j.scrollTop=d}get scrollLeft(){return this.j.scrollLeft}set scrollLeft(d){this.j.scrollLeft=d}get scrollHeight(){return this.j.scrollHeight}get renderHeight(){return this.j.renderHeight}get firstVisibleElement(){const d=this.j.firstVisibleIndex;return d<0||d>=this.j.length?void 0:this.j.element(d).element}get lastVisibleElement(){const d=this.j.lastVisibleIndex;return this.j.element(d).element}get ariaLabel(){return this.j.ariaLabel}set ariaLabel(d){this.j.ariaLabel=d}get selectionSize(){return this.q.getNodes().length}domFocus(){this.j.domFocus()}isDOMFocused(){return this.getHTMLElement()===document.activeElement}layout(d,p){this.j.layout(d,p),(0,C.$me)(p)&&this.x?.layout(p)}style(d){const p=`.${this.j.domId}`,H=[];d.treeIndentGuidesStroke&&(H.push(`.monaco-list${p}:hover .monaco-tl-indent > .indent-guide, .monaco-list${p}.always .monaco-tl-indent > .indent-guide  { border-color: ${d.treeInactiveIndentGuidesStroke}; }`),H.push(`.monaco-list${p} .monaco-tl-indent > .indent-guide.active { border-color: ${d.treeIndentGuidesStroke}; }`)),this.z.textContent=H.join(`
`),this.j.style(d)}getParentElement(d){const p=this.o.getParentNodeLocation(d);return this.o.getNode(p).element}getFirstElementChild(d){return this.o.getFirstElementChild(d)}getNode(d){return this.o.getNode(d)}getNodeLocation(d){return this.o.getNodeLocation(d)}collapse(d,p=!1){return this.o.setCollapsed(d,!0,p)}expand(d,p=!1){return this.o.setCollapsed(d,!1,p)}toggleCollapsed(d,p=!1){return this.o.setCollapsed(d,void 0,p)}expandAll(){this.o.setCollapsed(this.o.rootRef,!1,!0)}collapseAll(){this.o.setCollapsed(this.o.rootRef,!0,!0)}isCollapsible(d){return this.o.isCollapsible(d)}setCollapsible(d,p){return this.o.setCollapsible(d,p)}isCollapsed(d){return this.o.isCollapsed(d)}triggerTypeNavigation(){this.j.triggerTypeNavigation()}openFind(){this.x?.open()}closeFind(){this.x?.close()}refilter(){this.B.fire(void 0),this.o.refilter()}setAnchor(d){if(typeof d>"u")return this.j.setAnchor(void 0);const p=this.o.getNode(d);this.u.set([p]);const H=this.o.getListIndex(d);H>-1&&this.j.setAnchor(H,!0)}getAnchor(){return(0,e.$sf)(this.u.get(),void 0)}setSelection(d,p){const H=d.map(q=>this.o.getNode(q));this.q.set(H,p);const Q=d.map(q=>this.o.getListIndex(q)).filter(q=>q>-1);this.j.setSelection(Q,p,!0)}getSelection(){return this.q.get()}setFocus(d,p){const H=d.map(q=>this.o.getNode(q));this.p.set(H,p);const Q=d.map(q=>this.o.getListIndex(q)).filter(q=>q>-1);this.j.setFocus(Q,p,!0)}focusNext(d=1,p=!1,H,Q=this.y){this.j.focusNext(d,p,H,Q)}focusPrevious(d=1,p=!1,H,Q=this.y){this.j.focusPrevious(d,p,H,Q)}focusNextPage(d,p=this.y){return this.j.focusNextPage(d,p)}focusPreviousPage(d,p=this.y){return this.j.focusPreviousPage(d,p)}focusLast(d,p=this.y){this.j.focusLast(d,p)}focusFirst(d,p=this.y){this.j.focusFirst(d,p)}getFocus(){return this.p.get()}reveal(d,p){this.o.expandTo(d);const H=this.o.getListIndex(d);H!==-1&&this.j.reveal(H,p)}getRelativeTop(d){const p=this.o.getListIndex(d);return p===-1?null:this.j.getRelativeTop(p)}getViewState(d=this.options.identityProvider){if(!d)throw new r.$OR(this.D,"Can't get tree view state without an identity provider");const p=x=>d.getId(x).toString(),H=B.empty(this.scrollTop);for(const x of this.getFocus())H.focus.add(p(x));for(const x of this.getSelection())H.selection.add(p(x));const Q=this.o.getNode(),q=[Q];for(;q.length>0;){const x=q.shift();x!==Q&&x.collapsible&&(H.expanded[p(x.element)]=x.collapsed?0:1),q.push(...x.children)}return H}F(d){d.preventDefault(),d.stopPropagation();const p=this.j.getFocusedElements();if(p.length===0)return;const H=p[0],Q=this.o.getNodeLocation(H);if(!this.o.setCollapsed(Q,!0)){const x=this.o.getParentNodeLocation(Q);if(!x)return;const W=this.o.getListIndex(x);this.j.reveal(W),this.j.setFocus([W])}}G(d){d.preventDefault(),d.stopPropagation();const p=this.j.getFocusedElements();if(p.length===0)return;const H=p[0],Q=this.o.getNodeLocation(H);if(!this.o.setCollapsed(Q,!1)){if(!H.children.some(c=>c.visible))return;const[x]=this.j.getFocus(),W=x+1;this.j.reveal(W),this.j.setFocus([W])}}H(d){d.preventDefault(),d.stopPropagation();const p=this.j.getFocusedElements();if(p.length===0)return;const H=p[0],Q=this.o.getNodeLocation(H),q=d.browserEvent.altKey;this.o.setCollapsed(Q,void 0,q)}navigate(d){return new S(this.j,this.o,d)}dispose(){(0,E.$gb)(this.A),this.j.dispose()}}t.$XR=J;class S{constructor(d,p,H){this.b=d,this.c=p,H?this.a=this.c.getListIndex(H):this.a=-1}current(){return this.a<0||this.a>=this.b.length?null:this.b.element(this.a).element}previous(){return this.a--,this.current()}next(){return this.a++,this.current()}first(){return this.a=0,this.current()}last(){return this.a=this.b.length-1,this.current()}}}),define(be[129],$e([1,0,128,119,24,26]),function(re,t,N,O,i,j){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9R=void 0;class A extends N.$XR{constructor(o,u,g,L,r,l={}){super(o,u,g,L,l),this.f=o,this.g=r,this.d=new Map,this.c=l.identityProvider}getInput(){return this.b}setInput(o,u){if(u&&!this.c)throw new i.$OR(this.f,"Can't restore tree view state without an identity provider");if(this.b=o,!o){this.d.clear(),this.o.setChildren(null,j.Iterable.empty());return}if(!u){this.m(o);return}const g=[],L=[],r=e=>{const a=this.c.getId(e).toString();return!u.expanded[a]},l=e=>{const a=this.c.getId(e.element).toString();u.focus.has(a)&&g.push(e.element),u.selection.has(a)&&L.push(e.element)};this.m(o,r,l),this.setFocus(g),this.setSelection(L),u&&typeof u.scrollTop=="number"&&(this.scrollTop=u.scrollTop)}updateChildren(o=this.b){if(typeof this.b>"u")throw new i.$OR(this.f,"Tree input not set");let u;this.c&&(u=g=>{const L=this.c.getId(g).toString(),r=this.d.get(L);if(r)return r.collapsed}),this.m(o,u)}resort(o=this.b,u=!0){this.o.resort(o===this.b?null:o,u)}refresh(o){if(o===void 0){this.j.rerender();return}this.o.rerender(o)}m(o,u,g){let L;if(this.c){const r=new Set,l=g;g=e=>{const a=this.c.getId(e.element).toString();r.add(a),this.d.set(a,e),l?.(e)},L=e=>{const a=this.c.getId(e.element).toString();r.has(a)||this.d.delete(a)}}this.o.setChildren(o===this.b?null:o,this.s(o,u).elements,{onDidCreateNode:g,onDidDeleteNode:L})}s(o,u){const g=[...this.g.getChildren(o)];return{elements:j.Iterable.map(g,r=>{const{elements:l,size:e}=this.s(r,u),a=this.g.hasChildren?this.g.hasChildren(r):void 0,n=e===0?void 0:u&&u(r);return{element:r,children:l,collapsible:a,collapsed:n}}),size:g.length}}I(o,u,g){return new O.$YR(o,u,g)}}t.$9R=A}),define(be[64],$e([1,0,13,9,31,27,25,6,3,2,50,11,7]),function(re,t,N,O,i,j,A,y,o,u,g,L,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$g=t.ProxyChannel=t.$0g=t.$9g=t.$8g=t.$7g=t.$6g=t.$5g=t.RequestInitiator=t.$4g=t.$3g=t.$2g=t.$1g=t.$Zg=void 0;var l;(function(fe){fe[fe.Promise=100]="Promise",fe[fe.PromiseCancel=101]="PromiseCancel",fe[fe.EventListen=102]="EventListen",fe[fe.EventDispose=103]="EventDispose"})(l||(l={}));function e(fe){switch(fe){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var a;(function(fe){fe[fe.Initialize=200]="Initialize",fe[fe.PromiseSuccess=201]="PromiseSuccess",fe[fe.PromiseError=202]="PromiseError",fe[fe.PromiseErrorObj=203]="PromiseErrorObj",fe[fe.EventFire=204]="EventFire"})(a||(a={}));function n(fe){switch(fe){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(fe){fe[fe.Uninitialized=0]="Uninitialized",fe[fe.Idle=1]="Idle"})(h||(h={}));function s(fe){let ie=0;for(let K=0;;K+=7){const U=fe.read(1);if(ie|=(U.buffer[0]&127)<<K,!(U.buffer[0]&128))return ie}}const v=T(0);function D(fe,ie){if(ie===0){fe.write(v);return}let K=0;for(let ee=ie;ee!==0;ee=ee>>>7)K++;const U=i.$Ec.alloc(K);for(let ee=0;ie!==0;ee++)U.buffer[ee]=ie&127,ie=ie>>>7,ie>0&&(U.buffer[ee]|=128);fe.write(U)}class E{constructor(ie){this.b=ie,this.a=0}read(ie){const K=this.b.slice(this.a,this.a+ie);return this.a+=K.byteLength,K}}t.$Zg=E;class f{constructor(){this.a=[]}get buffer(){return i.$Ec.concat(this.a)}write(ie){this.a.push(ie)}}t.$1g=f;var C;(function(fe){fe[fe.Undefined=0]="Undefined",fe[fe.String=1]="String",fe[fe.Buffer=2]="Buffer",fe[fe.VSBuffer=3]="VSBuffer",fe[fe.Array=4]="Array",fe[fe.Object=5]="Object",fe[fe.Int=6]="Int"})(C||(C={}));function T(fe){const ie=i.$Ec.alloc(1);return ie.writeUInt8(fe,0),ie}const P={Undefined:T(C.Undefined),String:T(C.String),Buffer:T(C.Buffer),VSBuffer:T(C.VSBuffer),Array:T(C.Array),Object:T(C.Object),Uint:T(C.Int)},m=typeof Buffer<"u";function $(fe,ie){if(typeof ie>"u")fe.write(P.Undefined);else if(typeof ie=="string"){const K=i.$Ec.fromString(ie);fe.write(P.String),D(fe,K.byteLength),fe.write(K)}else if(m&&Buffer.isBuffer(ie)){const K=i.$Ec.wrap(ie);fe.write(P.Buffer),D(fe,K.byteLength),fe.write(K)}else if(ie instanceof i.$Ec)fe.write(P.VSBuffer),D(fe,ie.byteLength),fe.write(ie);else if(Array.isArray(ie)){fe.write(P.Array),D(fe,ie.length);for(const K of ie)$(fe,K)}else if(typeof ie=="number"&&(ie|0)===ie)fe.write(P.Uint),D(fe,ie);else{const K=i.$Ec.fromString(JSON.stringify(ie));fe.write(P.Object),D(fe,K.byteLength),fe.write(K)}}t.$2g=$;function F(fe){switch(fe.read(1).readUInt8(0)){case C.Undefined:return;case C.String:return fe.read(s(fe)).toString();case C.Buffer:return fe.read(s(fe)).buffer;case C.VSBuffer:return fe.read(s(fe));case C.Array:{const K=s(fe),U=[];for(let ee=0;ee<K;ee++)U.push(F(fe));return U}case C.Object:return JSON.parse(fe.read(s(fe)).toString());case C.Int:return s(fe)}}t.$3g=F;class R{constructor(ie,K,U=null,ee=1e3){this.h=ie,this.j=K,this.k=U,this.l=ee,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(J=>this.q(J)),this.m({type:200})}registerChannel(ie,K){this.b.set(ie,K),setTimeout(()=>this.w(ie),0)}m(ie){switch(ie.type){case 200:{const K=this.o([ie.type]);this.k?.logOutgoing(K,0,1,n(ie.type));return}case 201:case 202:case 204:case 203:{const K=this.o([ie.type,ie.id],ie.data);this.k?.logOutgoing(K,ie.id,1,n(ie.type),ie.data);return}}}o(ie,K=void 0){const U=new f;return $(U,ie),$(U,K),this.p(U.buffer)}p(ie){try{return this.h.send(ie),ie.byteLength}catch{return 0}}q(ie){const K=new E(ie),U=F(K),ee=F(K),J=U[0];switch(J){case 100:return this.k?.logIncoming(ie.byteLength,U[1],1,`${e(J)}: ${U[2]}.${U[3]}`,ee),this.s({type:J,id:U[1],channelName:U[2],name:U[3],arg:ee});case 102:return this.k?.logIncoming(ie.byteLength,U[1],1,`${e(J)}: ${U[2]}.${U[3]}`,ee),this.t({type:J,id:U[1],channelName:U[2],name:U[3],arg:ee});case 101:return this.k?.logIncoming(ie.byteLength,U[1],1,`${e(J)}`),this.u({type:J,id:U[1]});case 103:return this.k?.logIncoming(ie.byteLength,U[1],1,`${e(J)}`),this.u({type:J,id:U[1]})}}s(ie){const K=this.b.get(ie.channelName);if(!K){this.v(ie);return}const U=new j.$oc;let ee;try{ee=K.call(this.j,ie.name,ie.arg,U.token)}catch(_){ee=Promise.reject(_)}const J=ie.id;ee.then(_=>{this.m({id:J,data:_,type:201}),this.d.delete(ie.id)},_=>{_ instanceof Error?this.m({id:J,data:{message:_.message,name:_.name,stack:_.stack?_.stack.split?_.stack.split(`
`):_.stack:void 0},type:202}):this.m({id:J,data:_,type:203}),this.d.delete(ie.id)});const S=(0,u.$jb)(()=>U.cancel());this.d.set(ie.id,S)}t(ie){const K=this.b.get(ie.channelName);if(!K){this.v(ie);return}const U=ie.id,J=K.listen(this.j,ie.name,ie.arg)(S=>this.m({id:U,data:S,type:204}));this.d.set(ie.id,J)}u(ie){const K=this.d.get(ie.id);K&&(K.dispose(),this.d.delete(ie.id))}v(ie){let K=this.g.get(ie.channelName);K||(K=[],this.g.set(ie.channelName,K));const U=setTimeout(()=>{console.error(`Unknown channel: ${ie.channelName}`),ie.type===100&&this.m({id:ie.id,data:{name:"Unknown channel",message:`Channel name '${ie.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);K.push({request:ie,timeoutTimer:U})}w(ie){const K=this.g.get(ie);if(K){for(const U of K)switch(clearTimeout(U.timeoutTimer),U.request.type){case 100:this.s(U.request);break;case 102:this.t(U.request);break}this.g.delete(ie)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,u.$gb)(this.d.values()),this.d.clear()}}t.$4g=R;var B;(function(fe){fe[fe.LocalSide=0]="LocalSide",fe[fe.OtherSide=1]="OtherSide"})(B||(t.RequestInitiator=B={}));class M{constructor(ie,K=null){this.l=ie,this.a=!1,this.b=h.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new o.$ec,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(U=>this.s(U)),this.j=K}getChannel(ie){const K=this;return{call(U,ee,J){return K.a?Promise.reject(new y.$3):K.m(ie,U,ee,J)},listen(U,ee){return K.a?o.Event.None:K.o(ie,U,ee)}}}m(ie,K,U,ee=j.CancellationToken.None){const J=this.g++,_={id:J,type:100,channelName:ie,name:K,arg:U};if(ee.isCancellationRequested)return Promise.reject(new y.$3);let d;return new Promise((H,Q)=>{if(ee.isCancellationRequested)return Q(new y.$3);const q=()=>{const k=b=>{switch(b.type){case 201:this.f.delete(J),H(b.data);break;case 202:{this.f.delete(J);const w=new Error(b.data.message);w.stack=Array.isArray(b.data.stack)?b.data.stack.join(`
`):b.data.stack,w.name=b.data.name,Q(w);break}case 203:this.f.delete(J),Q(b.data);break}};this.f.set(J,k),this.p(_)};let x=null;this.b===h.Idle?q():(x=(0,O.$ig)(k=>this.u()),x.then(()=>{x=null,q()}));const W=()=>{x?(x.cancel(),x=null):this.p({id:J,type:101}),Q(new y.$3)},c=ee.onCancellationRequested(W);d=(0,u.$ib)((0,u.$jb)(W),c),this.d.add(d)}).finally(()=>{this.d.delete(d)})}o(ie,K,U){const ee=this.g++,S={id:ee,type:102,channelName:ie,name:K,arg:U};let _=null;const d=new o.$ec({onWillAddFirstListener:()=>{_=(0,O.$ig)(H=>this.u()),_.then(()=>{_=null,this.d.add(d),this.p(S)})},onDidRemoveLastListener:()=>{_?(_.cancel(),_=null):(this.d.delete(d),this.p({id:ee,type:103}))}}),p=H=>d.fire(H.data);return this.f.set(ee,p),d.event}p(ie){switch(ie.type){case 100:case 102:{const K=this.q([ie.type,ie.id,ie.channelName,ie.name],ie.arg);this.j?.logOutgoing(K,ie.id,0,`${e(ie.type)}: ${ie.channelName}.${ie.name}`,ie.arg);return}case 101:case 103:{const K=this.q([ie.type,ie.id]);this.j?.logOutgoing(K,ie.id,0,e(ie.type));return}}}q(ie,K=void 0){const U=new f;return $(U,ie),$(U,K),this.r(U.buffer)}r(ie){try{return this.l.send(ie),ie.byteLength}catch{return 0}}s(ie){const K=new E(ie),U=F(K),ee=F(K),J=U[0];switch(J){case 200:return this.j?.logIncoming(ie.byteLength,0,0,n(J)),this.t({type:U[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(ie.byteLength,U[1],0,n(J),ee),this.t({type:U[0],id:U[1],data:ee})}}t(ie){if(ie.type===200){this.b=h.Idle,this.k.fire();return}this.f.get(ie.id)?.(ie)}get onDidInitializePromise(){return o.Event.toPromise(this.onDidInitialize)}u(){return this.b===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,u.$gb)(this.d.values()),this.d.clear()}}t.$5g=M,xe([A.$Tg],M.prototype,"onDidInitializePromise",null);class z{get connections(){const ie=[];return this.f.forEach(K=>ie.push(K)),ie}constructor(ie){this.a=new Map,this.f=new Set,this.g=new o.$ec,this.onDidAddConnection=this.g.event,this.h=new o.$ec,this.onDidRemoveConnection=this.h.event,ie(({protocol:K,onDidClientDisconnect:U})=>{o.Event.once(K.onMessage)(J=>{const S=new E(J),_=F(S),d=new R(K,_),p=new M(K);this.a.forEach((Q,q)=>d.registerChannel(q,Q));const H={channelServer:d,channelClient:p,ctx:_};this.f.add(H),this.g.fire(H),U(()=>{d.dispose(),p.dispose(),this.f.delete(H),this.h.fire(H)})})})}getChannel(ie,K){const U=this;return{call(ee,J,S){let _;if((0,r.$we)(K)){const p=(0,N.$Hf)(U.connections.filter(K));_=p?Promise.resolve(p):o.Event.toPromise(o.Event.filter(U.onDidAddConnection,K))}else _=K.routeCall(U,ee,J);const d=_.then(p=>p.channelClient.getChannel(ie));return ne(d).call(ee,J,S)},listen(ee,J){if((0,r.$we)(K))return U.j(ie,K,ee,J);const S=K.routeEvent(U,ee,J).then(_=>_.channelClient.getChannel(ie));return ne(S).listen(ee,J)}}}j(ie,K,U,ee){const J=this;let S=new u.$kb;const _=new o.$ec({onWillAddFirstListener:()=>{S=new u.$kb;const d=new o.$kc,p=new Map,H=q=>{const W=q.channelClient.getChannel(ie).listen(U,ee),c=d.add(W);p.set(q,c)},Q=q=>{const x=p.get(q);x&&(x.dispose(),p.delete(q))};J.connections.filter(K).forEach(H),o.Event.filter(J.onDidAddConnection,K)(H,void 0,S),J.onDidRemoveConnection(Q,void 0,S),d.event(_.fire,_,S),S.add(d)},onDidRemoveLastListener:()=>{S.dispose()}});return _.event}registerChannel(ie,K){this.a.set(ie,K),this.f.forEach(U=>{U.channelServer.registerChannel(ie,K)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}t.$6g=z;class te{constructor(ie,K,U=null){const ee=new f;$(ee,K),ie.send(ee.buffer),this.a=new M(ie,U),this.d=new R(ie,K,U)}getChannel(ie){return this.a.getChannel(ie)}registerChannel(ie,K){this.d.registerChannel(ie,K)}dispose(){this.a.dispose(),this.d.dispose()}}t.$7g=te;function ne(fe){return{call(ie,K,U){return fe.then(ee=>ee.call(ie,K,U))},listen(ie,K){const U=new o.$nc;return fe.then(ee=>U.input=ee.listen(ie,K)),U.event}}}t.$8g=ne;function se(fe){let ie=!1;return{call(K,U,ee){return ie?fe.call(K,U,ee):(0,O.$vg)(0).then(()=>ie=!0).then(()=>fe.call(K,U,ee))},listen(K,U){if(ie)return fe.listen(K,U);const ee=new o.$nc;return(0,O.$vg)(0).then(()=>ie=!0).then(()=>ee.input=fe.listen(K,U)),ee.event}}}t.$9g=se;class ce{constructor(ie){this.a=ie}routeCall(ie){return this.b(ie)}routeEvent(ie){return this.b(ie)}async b(ie){for(const K of ie.connections)if(await Promise.resolve(this.a(K.ctx)))return Promise.resolve(K);return await o.Event.toPromise(ie.onDidAddConnection),await this.b(ie)}}t.$0g=ce;var ue;(function(fe){function ie(J,S){const _=J,d=S&&S.disableMarshalling,p=new Map;for(const H in _)U(H)&&p.set(H,o.Event.buffer(_[H],!0));return new class{listen(H,Q,q){const x=p.get(Q);if(x)return x;if(ee(Q)){const W=_[Q];if(typeof W=="function")return W.call(_,q)}throw new y.$ab(`Event not found: ${Q}`)}call(H,Q,q){const x=_[Q];if(typeof x=="function"){if(!d&&Array.isArray(q))for(let W=0;W<q.length;W++)q[W]=(0,g.$Yg)(q[W]);return x.apply(_,q)}throw new y.$ab(`Method not found: ${Q}`)}}}fe.fromService=ie;function K(J,S){const _=S&&S.disableMarshalling;return new Proxy({},{get(d,p){if(typeof p=="string")return S?.properties?.has(p)?S.properties.get(p):ee(p)?function(H){return J.listen(p,H)}:U(p)?J.listen(p):async function(...H){let Q;S&&!(0,r.$re)(S.context)?Q=[S.context,...H]:Q=H;const q=await J.call(p,Q);return _?q:(0,g.$Yg)(q)};throw new y.$ab(`Property not found: ${String(p)}`)}})}fe.toService=K;function U(J){return J[0]==="o"&&J[1]==="n"&&L.$Kd(J.charCodeAt(2))}function ee(J){return/^onDynamic/.test(J)&&L.$Kd(J.charCodeAt(9))}})(ue||(t.ProxyChannel=ue={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function pe(fe){if(Array.isArray(fe))return fe;if(fe&&typeof fe=="object"&&typeof fe.toString=="function"){const ie=fe.toString();if(ie!=="[object Object]")return ie}return fe}function Oe(fe){return Array.isArray(fe)?fe.map(pe):pe(fe)}function Te(fe,ie,K,U,ee,J,S){S=Oe(S);const _=ae[ee],d=_[U%_.length];let p=[`%c[${fe}]%c[${String(ie).padStart(7," ")}]%c[len: ${String(K).padStart(5," ")}]%c${String(U).padStart(5," ")} - ${J}`,"color: darkgreen","color: grey","color: grey",`color: ${d}`];/\($/.test(J)?(p=p.concat(S),p.push(")")):p.push(S),console.log.apply(console,p)}class Me{constructor(ie,K){this.d=ie,this.f=K,this.a=0,this.b=0}logOutgoing(ie,K,U,ee,J){this.b+=ie,Te(this.d,this.b,ie,K,U,ee,J)}logIncoming(ie,K,U,ee,J){this.a+=ie,Te(this.f,this.a,ie,K,U,ee,J)}}t.$$g=Me}),define(be[29],$e([1,0,5]),function(re,t,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Q=t.$P=t.$O=t.$N=t.$M=void 0,t.$M=N.$g.vscode.ipcRenderer,t.$N=N.$g.vscode.ipcMessagePort,t.$O=N.$g.vscode.webFrame,t.$P=N.$g.vscode.process,t.$Q=N.$g.vscode.context}),define(be[130],$e([1,0,86,29]),function(re,t,N,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yS=void 0;let i=0;function j(y,o,u){const g=[],L=i++,r=`vscode:onContextMenu${L}`,l=(e,a,n)=>{g[a].click?.(n)};O.$M.once(r,l),O.$M.once(N.$vS,(e,a)=>{a===L&&(O.$M.removeListener(r,l),u?.())}),O.$M.send(N.$uS,L,y.map(e=>A(e,g)),r,o)}t.$yS=j;function A(y,o){const u={id:o.length,label:y.label,type:y.type,accelerator:y.accelerator,checked:y.checked,enabled:typeof y.enabled=="boolean"?y.enabled:!0,visible:typeof y.visible=="boolean"?y.visible:!0};return o.push(y),Array.isArray(y.submenu)&&(u.submenu=y.submenu.map(g=>A(g,o))),u}}),define(be[131],$e([1,0,31,3,64,87,29]),function(re,t,N,O,i,j,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$GS=void 0;class y extends i.$7g{static f(){const u=O.Event.fromNodeEventEmitter(A.$M,"vscode:message",(g,L)=>N.$Ec.wrap(L));return A.$M.send("vscode:hello"),new j.$CS(A.$M,u)}constructor(u){const g=y.f();super(g,u),this.b=g}dispose(){this.b.disconnect()}}t.$GS=y}),define(be[132],$e([12,10]),function(re,t){return re.create("vs/platform/files/common/files",t)}),define(be[133],$e([12,10]),function(re,t){return re.create("vs/platform/theme/common/iconRegistry",t)}),define(be[38],$e([1,0]),function(re,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qh=t.$ph=t.$oh=t._util=void 0;var N;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function y(o){return o[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=y})(N||(t._util=N={})),t.$oh=i("instantiationService");function O(A,y,o){y[N.DI_TARGET]===y?y[N.DI_DEPENDENCIES].push({id:A,index:o}):(y[N.DI_DEPENDENCIES]=[{id:A,index:o}],y[N.DI_TARGET]=y)}function i(A){if(N.serviceIds.has(A))return N.serviceIds.get(A);const y=function(o,u,g){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");O(y,o,g)};return y.toString=()=>A,N.serviceIds.set(A,y),y}t.$ph=i;function j(A){return A}t.$qh=j}),define(be[134],$e([1,0,38]),function(re,t,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8l=t.$7l=t.$6l=t.ID=void 0,t.ID="diagnosticsService",t.$6l=(0,N.$ph)(t.ID);function O(j){return!!j.hostName&&!!j.errorMessage}t.$7l=O;class i{async getPerformanceInfo(A,y){return{}}async getSystemInfo(A,y){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(A,y){return""}async getWorkspaceFileExtensions(A){return{extensions:[]}}async reportWorkspaceStats(A){}}t.$8l=i}),define(be[135],$e([1,0,85,22,11,7,15,132,38,5,28]),function(re,t,N,O,i,j,A,y,o,u,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ok=t.$nk=t.$mk=t.$lk=t.$kk=t.FileKind=t.$jk=t.$ik=t.$hk=t.$gk=t.$fk=t.$ek=t.$dk=t.FileOperationResult=t.$ck=t.$bk=t.$ak=t.$_j=t.$$j=t.FileChangeType=t.$0j=t.FileOperation=t.$9j=t.$8j=t.$7j=t.$6j=t.$5j=t.$4j=t.FileSystemProviderErrorCode=t.$3j=t.$2j=t.$1j=t.$Zj=t.$Yj=t.$Xj=t.$Wj=t.$Vj=t.$Uj=t.FileSystemProviderCapabilities=t.FilePermission=t.FileType=t.$Tj=t.$Sj=void 0,t.$Sj=(0,o.$ph)("fileService");function L(K){return K.create===!0}t.$Tj=L;var r;(function(K){K[K.Unknown=0]="Unknown",K[K.File=1]="File",K[K.Directory=2]="Directory",K[K.SymbolicLink=64]="SymbolicLink"})(r||(t.FileType=r={}));var l;(function(K){K[K.Readonly=1]="Readonly",K[K.Locked=2]="Locked"})(l||(t.FilePermission=l={}));var e;(function(K){K[K.None=0]="None",K[K.FileReadWrite=2]="FileReadWrite",K[K.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",K[K.FileReadStream=16]="FileReadStream",K[K.FileFolderCopy=8]="FileFolderCopy",K[K.PathCaseSensitive=1024]="PathCaseSensitive",K[K.Readonly=2048]="Readonly",K[K.Trash=4096]="Trash",K[K.FileWriteUnlock=8192]="FileWriteUnlock",K[K.FileAtomicRead=16384]="FileAtomicRead",K[K.FileAtomicWrite=32768]="FileAtomicWrite",K[K.FileAtomicDelete=65536]="FileAtomicDelete",K[K.FileClone=131072]="FileClone"})(e||(t.FileSystemProviderCapabilities=e={}));function a(K){return!!(K.capabilities&2)}t.$Uj=a;function n(K){return!!(K.capabilities&8)}t.$Vj=n;function h(K){return!!(K.capabilities&131072)}t.$Wj=h;function s(K){return!!(K.capabilities&4)}t.$Xj=s;function v(K){return!!(K.capabilities&16)}t.$Yj=v;function D(K){return a(K)?!!(K.capabilities&16384):!1}t.$Zj=D;function E(K){return a(K)?!!(K.capabilities&32768):!1}t.$1j=E;function f(K){return!!(K.capabilities&65536)}t.$2j=f;function C(K){return!!(K.capabilities&2048)}t.$3j=C;var T;(function(K){K.FileExists="EntryExists",K.FileNotFound="EntryNotFound",K.FileNotADirectory="EntryNotADirectory",K.FileIsADirectory="EntryIsADirectory",K.FileExceedsStorageQuota="EntryExceedsStorageQuota",K.FileTooLarge="EntryTooLarge",K.FileWriteLocked="EntryWriteLocked",K.NoPermissions="NoPermissions",K.Unavailable="Unavailable",K.Unknown="Unknown"})(T||(t.FileSystemProviderErrorCode=T={}));class P extends Error{static create(U,ee){const J=new P(U.toString(),ee);return F(J,ee),J}constructor(U,ee){super(U),this.code=ee}}t.$4j=P;function m(K,U){return P.create(K,U)}t.$5j=m;function $(K){return K||m((0,y.localize)(0,null),T.Unknown)}t.$6j=$;function F(K,U){return K.name=U?`${U} (FileSystemError)`:"FileSystemError",K}t.$7j=F;function R(K){if(!K)return T.Unknown;if(K instanceof P)return K.code;const U=/^(.+) \(FileSystemError\)$/.exec(K.name);if(!U)return T.Unknown;switch(U[1]){case T.FileExists:return T.FileExists;case T.FileIsADirectory:return T.FileIsADirectory;case T.FileNotADirectory:return T.FileNotADirectory;case T.FileNotFound:return T.FileNotFound;case T.FileTooLarge:return T.FileTooLarge;case T.FileWriteLocked:return T.FileWriteLocked;case T.NoPermissions:return T.NoPermissions;case T.Unavailable:return T.Unavailable}return T.Unknown}t.$8j=R;function B(K){if(K instanceof ce)return K.fileOperationResult;switch(R(K)){case T.FileNotFound:return 1;case T.FileIsADirectory:return 0;case T.FileNotADirectory:return 9;case T.FileWriteLocked:return 5;case T.NoPermissions:return 6;case T.FileExists:return 4;case T.FileTooLarge:return 7;default:return 10}}t.$9j=B;var M;(function(K){K[K.CREATE=0]="CREATE",K[K.DELETE=1]="DELETE",K[K.MOVE=2]="MOVE",K[K.COPY=3]="COPY",K[K.WRITE=4]="WRITE"})(M||(t.FileOperation=M={}));class z{constructor(U,ee,J){this.resource=U,this.operation=ee,this.target=J}isOperation(U){return this.operation===U}}t.$0j=z;var te;(function(K){K[K.UPDATED=0]="UPDATED",K[K.ADDED=1]="ADDED",K[K.DELETED=2]="DELETED"})(te||(t.FileChangeType=te={}));class ne{constructor(U,ee){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const J=new Map;for(const S of U){const _=J.get(S.type);switch(_?_.push([S.resource,S]):J.set(S.type,[[S.resource,S]]),S.type){case 1:this.rawAdded.push(S.resource);break;case 0:this.rawUpdated.push(S.resource);break;case 2:this.rawDeleted.push(S.resource);break}}for(const[S,_]of J)switch(S){case 1:this.a=N.$vh.forUris(()=>ee),this.a.fill(_);break;case 0:this.b=N.$vh.forUris(()=>ee),this.b.fill(_);break;case 2:this.c=N.$vh.forUris(()=>ee),this.c.fill(_);break}}contains(U,...ee){return this.d(U,{includeChildren:!1},...ee)}affects(U,...ee){return this.d(U,{includeChildren:!0},...ee)}d(U,ee,...J){if(!U)return!1;const S=J.length>0;return!!((!S||J.includes(1))&&(this.a?.get(U)||ee.includeChildren&&this.a?.findSuperstr(U))||(!S||J.includes(0))&&(this.b?.get(U)||ee.includeChildren&&this.b?.findSuperstr(U))||(!S||J.includes(2))&&(this.c?.findSubstr(U)||ee.includeChildren&&this.c?.findSuperstr(U)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}t.$$j=ne;function se(K,U,ee){return!K||!U||K===U||U.length>K.length?!1:(U.charAt(U.length-1)!==O.sep&&(U+=O.sep),ee?(0,i.$Md)(K,U):K.indexOf(U)===0)}t.$_j=se;class ce extends Error{constructor(U,ee,J){super(U),this.fileOperationResult=ee,this.options=J}}t.$ak=ce;class ue extends ce{constructor(U,ee,J,S){super(U,ee,S),this.fileOperationResult=ee,this.size=J}}t.$bk=ue;class ae extends ce{constructor(U,ee,J){super(U,2,J),this.stat=ee}}t.$ck=ae;var pe;(function(K){K[K.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",K[K.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",K[K.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",K[K.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",K[K.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",K[K.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",K[K.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",K[K.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",K[K.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",K[K.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",K[K.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(pe||(t.FileOperationResult=pe={})),t.$dk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.$ek={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.$fk="files.associations",t.$gk="files.exclude",t.$hk="files.readonlyInclude",t.$ik="files.readonlyExclude",t.$jk="files.readonlyFromPermissions";var Oe;(function(K){K[K.FILE=0]="FILE",K[K.FOLDER=1]="FOLDER",K[K.ROOT_FOLDER=2]="ROOT_FOLDER"})(Oe||(t.FileKind=Oe={})),t.$kk="";function Te(K){if(!(typeof K.size!="number"||typeof K.mtime!="number"))return K.mtime.toString(29)+K.size.toString(31)}t.$lk=Te;async function Me(K,U){if(!U.hasProvider(A.URI.from({scheme:K.scheme})))return new Promise(ee=>{const J=U.onDidChangeFileSystemProviderRegistrations(S=>{S.scheme===K.scheme&&S.added&&(J.dispose(),ee())})})}t.$mk=Me;class fe{static{this.KB=1024}static{this.MB=fe.KB*fe.KB}static{this.GB=fe.MB*fe.KB}static{this.TB=fe.GB*fe.KB}static formatSize(U){return(0,j.$me)(U)||(U=0),U<fe.KB?(0,y.localize)(1,null,U.toFixed(0)):U<fe.MB?(0,y.localize)(2,null,(U/fe.KB).toFixed(2)):U<fe.GB?(0,y.localize)(3,null,(U/fe.MB).toFixed(2)):U<fe.TB?(0,y.localize)(4,null,(U/fe.GB).toFixed(2)):(0,y.localize)(5,null,(U/fe.TB).toFixed(2))}}t.$nk=fe;function ie(K){const U=typeof K=="string"||K?.scheme===g.Schemas.vscodeRemote;return typeof K!="string"&&K?.scheme===g.Schemas.file?1024*fe.MB:U?10*fe.MB:u.$o?50*fe.MB:1024*fe.MB}t.$ok=ie}),define(be[136],$e([1,0,38]),function(re,t,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$F6b=t.$E6b=void 0,t.$E6b=(0,N.$ph)("mainProcessService");class O{constructor(j,A){this.a=j,this.b=A}getChannel(j){return this.a.getChannel(j,this.b)}registerChannel(j,A){this.a.registerChannel(j,A)}}t.$F6b=O}),define(be[137],$e([1,0,2,131]),function(re,t,N,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$G6b=void 0;class i extends N.$lb{constructor(A){super(),this.a=this.B(new O.$GS(`window:${A}`))}getChannel(A){return this.a.getChannel(A)}registerChannel(A,y){this.a.registerChannel(A,y)}}t.$G6b=i});var bi=this&&this.__param||function(re,t){return function(N,O){t(N,O,re)}};define(be[138],$e([1,0,64,136]),function(re,t,N,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$H6b=void 0;let i=class{constructor(A,y){return this.windowId=A,N.ProxyChannel.toService(y.getChannel("nativeHost"),{context:A,properties:(()=>{const o=new Map;return o.set("windowId",A),o})()})}};t.$H6b=i,t.$H6b=i=xe([bi(1,O.$E6b)],i)}),define(be[65],$e([1,0,72,7]),function(re,t,N,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Um=void 0;class i{constructor(){this.a=new Map}add(A,y){N.ok(O.$ie(A)),N.ok(O.$ke(y)),N.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,y)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}t.$Um=new i}),define(be[139],$e([1,0,3,65]),function(re,t,N,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Vm=void 0,t.$Vm={JSONContribution:"base.contributions.json"};function i(y){return y.length>0&&y.charAt(y.length-1)==="#"?y.substring(0,y.length-1):y}class j{constructor(){this.b=new N.$ec,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(o,u){this.a[i(o)]=u,this.b.fire(o)}notifySchemaChanged(o){this.b.fire(o)}getSchemaContributions(){return{schemas:this.a}}}const A=new j;O.$Um.add(t.$Vm.JSONContribution,A)}),define(be[140],$e([1,0,9,17,18,3,7,15,133,139,65]),function(re,t,N,O,i,j,A,y,o,u,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6u=t.$5u=t.$4u=t.$3u=t.$2u=t.$1u=t.$Zu=t.$Yu=t.IconFontDefinition=t.IconContribution=t.$Xu=void 0,t.$Xu={IconContribution:"base.contributions.icons"};var L;(function(D){function E(f,C){let T=f.defaults;for(;i.ThemeIcon.isThemeIcon(T);){const P=e.getIcon(T.id);if(!P)return;T=P.defaults}return T}D.getDefinition=E})(L||(t.IconContribution=L={}));var r;(function(D){function E(C){return{weight:C.weight,style:C.style,src:C.src.map(T=>({format:T.format,location:T.location.toString()}))}}D.toJSONObject=E;function f(C){const T=P=>(0,A.$ie)(P)?P:void 0;if(C&&Array.isArray(C.src)&&C.src.every(P=>(0,A.$ie)(P.format)&&(0,A.$ie)(P.location)))return{weight:T(C.weight),style:T(C.style),src:C.src.map(P=>({format:P.format,location:y.URI.parse(P.location)}))}}D.fromJSONObject=f})(r||(t.IconFontDefinition=r={}));class l{constructor(){this.a=new j.$ec,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,o.localize)(0,null)},fontCharacter:{type:"string",description:(0,o.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${i.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(E,f,C,T){const P=this.b[E];if(P){if(C&&!P.description){P.description=C,this.d.properties[E].markdownDescription=`${C} $(${E})`;const F=this.e.enum.indexOf(E);F!==-1&&(this.e.enumDescriptions[F]=C),this.a.fire()}return P}const m={id:E,description:C,defaults:f,deprecationMessage:T};this.b[E]=m;const $={$ref:"#/definitions/icons"};return T&&($.deprecationMessage=T),C&&($.markdownDescription=`${C}: $(${E})`),this.d.properties[E]=$,this.e.enum.push(E),this.e.enumDescriptions.push(C||""),this.a.fire(),{id:E}}deregisterIcon(E){delete this.b[E],delete this.d.properties[E];const f=this.e.enum.indexOf(E);f!==-1&&(this.e.enum.splice(f,1),this.e.enumDescriptions.splice(f,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(E=>this.b[E])}getIcon(E){return this.b[E]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(E,f){const C=this.f[E];return C||(this.f[E]=f,this.a.fire(),f)}deregisterIconFont(E){delete this.f[E]}getIconFont(E){return this.f[E]}toString(){const E=(P,m)=>P.id.localeCompare(m.id),f=P=>{for(;i.ThemeIcon.isThemeIcon(P.defaults);)P=this.b[P.defaults.id];return`codicon codicon-${P?P.id:""}`},C=[];C.push("| preview     | identifier                        | default codicon ID                | description"),C.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const T=Object.keys(this.b).map(P=>this.b[P]);for(const P of T.filter(m=>!!m.description).sort(E))C.push(`|<i class="${f(P)}"></i>|${P.id}|${i.ThemeIcon.isThemeIcon(P.defaults)?P.defaults.id:P.id}|${P.description||""}|`);C.push("| preview     | identifier                        "),C.push("| ----------- | --------------------------------- |");for(const P of T.filter(m=>!i.ThemeIcon.isThemeIcon(m.defaults)).sort(E))C.push(`|<i class="${f(P)}"></i>|${P.id}|`);return C.join(`
`)}}const e=new l;g.$Um.add(t.$Xu.IconContribution,e);function a(D,E,f,C){return e.registerIcon(D,E,f,C)}t.$Yu=a;function n(){return e}t.$Zu=n;function h(){const D=(0,O.$Aj)();for(const E in D){const f="\\"+D[E].toString(16);e.registerIcon(E,{fontCharacter:f})}}h(),t.$1u="vscode://schemas/icons";const s=g.$Um.as(u.$Vm.JSONContribution);s.registerSchema(t.$1u,e.getIconSchema());const v=new N.$Gg(()=>s.notifySchemaChanged(t.$1u),200);e.onDidChange(()=>{v.isScheduled()||v.schedule()}),t.$2u=a("widget-close",O.$Cj.close,(0,o.localize)(2,null)),t.$3u=a("goto-previous-location",O.$Cj.arrowUp,(0,o.localize)(3,null)),t.$4u=a("goto-next-location",O.$Cj.arrowDown,(0,o.localize)(4,null)),t.$5u=i.ThemeIcon.modify(O.$Cj.sync,"spin"),t.$6u=i.ThemeIcon.modify(O.$Cj.loading,"spin")}),define(be[141],$e([1,0,4,3,18,140]),function(re,t,N,O,i,j){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Zyb=t.$Yyb=void 0;function A(o){const u=new O.$ec,g=(0,j.$Zu)();return g.onDidChange(()=>u.fire()),o?.onDidProductIconThemeChange(()=>u.fire()),{onDidChange:u.event,getCSS(){const L=o?o.getProductIconTheme():new y,r={},l=a=>{const n=L.getIcon(a);if(!n)return;const h=n.font;return h?(r[h.id]=h.definition,`.codicon-${a.id}:before { content: '${n.fontCharacter}'; font-family: ${(0,N.$8O)(h.id)}; }`):`.codicon-${a.id}:before { content: '${n.fontCharacter}'; }`},e=[];for(const a of g.getIcons()){const n=l(a);n&&e.push(n)}for(const a in r){const n=r[a],h=n.weight?`font-weight: ${n.weight};`:"",s=n.style?`font-style: ${n.style};`:"",v=n.src.map(D=>`${(0,N.$7O)(D.location)} format('${D.format}')`).join(", ");e.push(`@font-face { src: ${v}; font-family: ${(0,N.$8O)(a)};${h}${s} font-display: block; }`)}return e.join(`
`)}}}t.$Yyb=A;class y{getIcon(u){const g=(0,j.$Zu)();let L=u.defaults;for(;i.ThemeIcon.isThemeIcon(L);){const r=g.getIcon(L.id);if(!r)return;L=r.defaults}return L}}t.$Zyb=y}),define(be[142],$e([1,0,5]),function(re,t,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$LD=t.$KD=t.$JD=t.$ID=t.$HD=t.$GD=t.$FD=t.$ED=void 0,t.$ED={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function O(g){return!!g.workspaceUri}t.$FD=O;function i(g){return!!g.folderUri}t.$GD=i;function j(g){return!!g.fileUri}t.$HD=j;function A(g){const L=y(g),r=g.getValue("window.menuBarVisibility");return r==="default"||L==="native"&&r==="compact"||N.$j&&N.$m?"classic":r}t.$ID=A;function y(g){if(N.$o)return"custom";const L=g.getValue("window");if(L){if(N.$j&&L.nativeTabs===!0||N.$j&&L.nativeFullScreen===!1)return"native";const e=L.titleBarStyle;if(e==="native"||e==="custom")return e}return N.$k?"native":"custom"}t.$JD=y;function o(g){return!(!N.$i||N.$o||y(g)==="native")}t.$KD=o;function u(g=0){return Math.pow(1.2,g)}t.$LD=u}),define(be[143],$e([1,0,16,29,142]),function(re,t,N,O,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$L6b=t.$K6b=t.$J6b=void 0;function j(o){O.$O.setZoomLevel(o),(0,N.$KN)((0,i.$LD)(o)),(0,N.$HN)(o)}t.$J6b=j;function A(){j((0,N.$IN)()+1)}t.$K6b=A;function y(){j((0,N.$IN)()-1)}t.$L6b=y}),define(be[144],$e([1,0,10,4,129,9,130,29,134,135,137,138,141,143,14,100,91]),function(re,t,N,O,i,j,A,y,o,u,g,L,r,l,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=void 0;const a=/\s--inspect(?:-brk|port)?=(?<port>\d+)?/,n=/\s--inspect-port=(?<port>\d+)/;class h{getHeight(B){return 22}getTemplateId(B){return P(B)?"process":C(B)?"machine":(0,o.$7l)(B)?"error":T(B)?"header":""}}class s{hasChildren(B){return(0,o.$7l)(B)?!1:P(B)?!!B.children?.length:!0}getChildren(B){return P(B)?B.children?B.children:[]:(0,o.$7l)(B)?[]:T(B)?B.processRoots.length>1?B.processRoots:[B.processRoots[0].rootProcess]:C(B)?[B.rootProcess]:[B.processes]}}class v{constructor(){this.templateId="header"}renderTemplate(B){const M=(0,O.$QO)(B,(0,O.$)(".row")),z=(0,O.$QO)(M,(0,O.$)(".nameLabel")),te=(0,O.$QO)(M,(0,O.$)(".cpu")),ne=(0,O.$QO)(M,(0,O.$)(".memory")),se=(0,O.$QO)(M,(0,O.$)(".pid"));return{name:z,CPU:te,memory:ne,PID:se}}renderElement(B,M,z,te){z.name.textContent=(0,N.localize)(0,null),z.CPU.textContent=(0,N.localize)(1,null),z.PID.textContent=(0,N.localize)(2,null),z.memory.textContent=(0,N.localize)(3,null)}disposeTemplate(B){}}class D{constructor(){this.templateId="machine"}renderTemplate(B){const M=Object.create(null),z=(0,O.$QO)(B,(0,O.$)(".row"));return M.name=(0,O.$QO)(z,(0,O.$)(".nameLabel")),M}renderElement(B,M,z,te){z.name.textContent=B.element.name}disposeTemplate(B){}}class E{constructor(){this.templateId="error"}renderTemplate(B){const M=Object.create(null),z=(0,O.$QO)(B,(0,O.$)(".row"));return M.name=(0,O.$QO)(z,(0,O.$)(".nameLabel")),M}renderElement(B,M,z,te){z.name.textContent=B.element.errorMessage}disposeTemplate(B){}}class f{constructor(B,M,z){this.a=B,this.b=M,this.c=z,this.templateId="process"}renderTemplate(B){const M=(0,O.$QO)(B,(0,O.$)(".row")),z=(0,O.$QO)(M,(0,O.$)(".nameLabel")),te=(0,O.$QO)(M,(0,O.$)(".cpu")),ne=(0,O.$QO)(M,(0,O.$)(".memory")),se=(0,O.$QO)(M,(0,O.$)(".pid"));return{name:z,CPU:te,PID:se,memory:ne}}renderElement(B,M,z,te){const{element:ne}=B,se=ne.pid.toFixed(0);let ce=ne.name;this.c.has(ne.pid)&&(ce=this.c.get(ne.pid)),z.name.textContent=ce,z.name.title=ne.cmd,z.CPU.textContent=ne.load.toFixed(0),z.PID.textContent=se,z.PID.parentElement.id=`pid-${se}`;const ue=this.a==="win32"?ne.mem:this.b*(ne.mem/100);z.memory.textContent=(ue/u.$nk.MB).toFixed(0)}disposeTemplate(B){}}function C(R){return!!R.name&&!!R.rootProcess}function T(R){return!!R.processRoots}function P(R){return!!R.pid}class m{constructor(B,M){this.f=M,this.b=new Map;const z=new g.$G6b(B);this.c=new L.$H6b(B,z),this.k(M.styles),this.g(M),y.$M.on("vscode:pidToNameResponse",(te,ne)=>{this.b=new Map;for(const[se,ce]of ne)this.b.set(se,ce)}),y.$M.on("vscode:listProcessesResponse",async(te,ne)=>{ne.forEach((se,ce)=>{P(se.rootProcess)&&(se.rootProcess.name=ce===0?`${this.f.applicationName} main`:"remote agent")}),this.d?(this.d.setInput({processes:{processRoots:ne}}),this.d.layout(window.innerHeight,window.innerWidth)):await this.h(ne),this.m(0)}),this.a=Date.now(),y.$M.send("vscode:pidToNameRequest"),y.$M.send("vscode:listProcesses")}g(B){document.onkeydown=M=>{const z=B.platform==="darwin"?M.metaKey:M.ctrlKey;z&&M.keyCode===87&&(M.stopPropagation(),M.preventDefault(),y.$M.send("vscode:closeProcessExplorer")),z&&M.keyCode===187&&(0,l.$K6b)(),z&&M.keyCode===189&&(0,l.$L6b)()}}async h(B){const M=document.getElementById("process-list");if(!M)return;const{totalmem:z}=await this.c.getOSStatistics(),te=[new f(this.f.platform,z,this.b),new v,new D,new E];this.d=new i.$9R("processExplorer",M,new h,te,new s,{identityProvider:{getId:ne=>P(ne)?ne.pid.toString():(0,o.$7l)(ne)?ne.hostName:T(ne)?"processes":C(ne)?ne.name:"header"}}),this.d.setInput({processes:{processRoots:B}}),this.d.layout(window.innerHeight,window.innerWidth),this.d.onKeyDown(ne=>{const se=new e.$5N(ne);if(se.keyCode===35&&se.altKey){const ce=this.n();Promise.all(ce.map(ue=>this.c.killProcess(ue,"SIGTERM"))).then(()=>this.d?.refresh())}}),this.d.onContextMenu(ne=>{P(ne.element)&&this.l(ne.element,!0)}),M.style.height=`${window.innerHeight}px`,window.addEventListener("resize",()=>{M.style.height=`${window.innerHeight}px`,this.d?.layout(window.innerHeight,window.innerWidth)})}i(B){const M=a.exec(B);return M&&M.groups.port!=="0"||B.indexOf("node ")>=0||B.indexOf("node.exe")>=0}j(B){const M={type:"node",request:"attach",name:`process ${B.pid}`};let z=a.exec(B.cmd);z?M.port=Number(z.groups.port):M.processId=String(B.pid),z=n.exec(B.cmd),z&&(M.port=Number(z.groups.port)),y.$M.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[M]})}k(B){const M=(0,O.$EO)(),z=[];B.listFocusBackground&&(z.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${B.listFocusBackground}; }`),z.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${B.listFocusBackground}; }`)),B.listFocusForeground&&z.push(`.monaco-list:focus .monaco-list-row.focused { color: ${B.listFocusForeground}; }`),B.listActiveSelectionBackground&&(z.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${B.listActiveSelectionBackground}; }`),z.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${B.listActiveSelectionBackground}; }`)),B.listActiveSelectionForeground&&z.push(`.monaco-list:focus .monaco-list-row.selected { color: ${B.listActiveSelectionForeground}; }`),B.listHoverBackground&&z.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${B.listHoverBackground}; }`),B.listHoverForeground&&z.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${B.listHoverForeground}; }`),B.listFocusOutline&&z.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${B.listFocusOutline}; outline-offset: -1px; }`),B.listHoverOutline&&z.push(`.monaco-list-row:hover { outline: 1px dashed ${B.listHoverOutline}; outline-offset: -1px; }`),B.scrollbarShadowColor&&z.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${B.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${B.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${B.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),B.scrollbarSliderBackgroundColor&&z.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${B.scrollbarSliderBackgroundColor};
				}
			`),B.scrollbarSliderHoverBackgroundColor&&z.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${B.scrollbarSliderHoverBackgroundColor};
				}
			`),B.scrollbarSliderActiveBackgroundColor&&z.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${B.scrollbarSliderActiveBackgroundColor};
				}
			`),M.textContent=z.join(`
`),B.color&&(document.body.style.color=B.color)}l(B,M){const z=[],te=Number(B.pid);M&&(z.push({accelerator:"Alt+E",label:(0,N.localize)(4,null),click:()=>{this.c.killProcess(te,"SIGTERM")}}),z.push({label:(0,N.localize)(5,null),click:()=>{this.c.killProcess(te,"SIGKILL")}}),z.push({type:"separator"})),z.push({label:(0,N.localize)(6,null),click:()=>{const ne=this.n();ne?.includes(te)||(ne.length=0,ne.push(te));const se=ne?.map(ce=>document.getElementById(`pid-${ce}`)).filter(ce=>!!ce);if(se){const ce=se.map(ue=>ue.innerText).filter(ue=>!!ue);this.c.writeClipboardText(ce.join(`
`))}}}),z.push({label:(0,N.localize)(7,null),click:()=>{const ne=document.getElementById("process-list");ne&&this.c.writeClipboardText(ne.innerText)}}),B&&M&&this.i(B.cmd)&&(z.push({type:"separator"}),z.push({label:(0,N.localize)(8,null),click:()=>{this.j(B)}})),(0,A.$yS)(z)}m(B){setTimeout(()=>{const M=Date.now(),z=B+M-this.a;this.a=M,z>1e3?(y.$M.send("vscode:pidToNameRequest"),y.$M.send("vscode:listProcesses")):this.m(z)},200)}n(){return this.d?.getSelection()?.map(B=>{if(!(!B||!("pid"in B)))return B.pid}).filter(B=>!!B)}}function $(){const R=(0,O.$EO)();R.id="codiconStyles";const B=(0,r.$Yyb)(void 0);function M(){R.textContent=B.getCSS()}const z=new j.$Gg(M,0);B.onDidChange(()=>z.schedule()),z.schedule()}function F(R){const B=R.data.platform==="win32"?"windows":R.data.platform==="linux"?"linux":"mac";document.body.classList.add(B),$(),(0,l.$J6b)(R.data.zoomLevel),new m(R.windowId,R.data)}t.startup=F})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/abd2f3db4bdb28f9e95536dfa84d8479f1eb312d/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
