/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ce=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/errors","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/base/common/uri","vs/base/common/types","vs/nls","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/environment/common/environment","vs/base/common/path","vs/platform/userDataProfile/common/userDataProfile","vs/platform/configuration/common/configuration","vs/platform/storage/common/storage","vs/base/common/arrays","vs/platform/telemetry/common/telemetry","vs/base/common/resources","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/network","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/strings","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/objects","vs/base/node/pfs","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/json","vs/base/common/map","os","vs/base/common/process","vs/base/common/errorMessage","vs/platform/userDataSync/common/abstractSynchronizer","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/base/common/stream","vs/base/parts/ipc/common/ipc","vs/platform/externalServices/common/serviceMachineId","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/ternarySearchTree","vs/base/common/extpath","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","fs","vs/base/common/semver/semver","vs/platform/files/common/watcher","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/stopwatch","net","vs/base/common/date","vs/base/common/marshalling","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/ipc/common/mainProcessService","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/decorators","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/severity","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/voiceRecognition/node/voiceRecognitionService","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/extensionManagement/node/extensionManagementService","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/assert","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/macAddress","vs/base/node/id","vs/base/node/nodeStreams","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/console","vs/amdX","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/code/node/sharedProcess/contrib/voiceTranscriber","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/node/sharedProcess/contrib/extensions","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","util","path","graceful-fs","https","yauzl","yazl","zlib","vs/code/node/sharedProcess/sharedProcessMain"],le=function(ie){for(var e=[],L=0,N=ie.length;L<N;L++)e[L]=ce[ie[L]];return e};define(ce[124],le([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S=e.$R=void 0,e.$R=!1;class L{static get(){const O=new Map,A=new Map,j=new Map,R=new Map;function S(u,d){u.has(d.detail)||u.set(d.detail,-d.timestamp)}function g(u,d){const p=u.get(d.detail);p&&(p>=0||u.set(d.detail,p+d.timestamp))}let C=[];typeof ie=="function"&&typeof ie.getStats=="function"&&(C=ie.getStats().slice(0).sort((u,d)=>u.timestamp-d.timestamp));for(const u of C)switch(u.type){case 10:S(O,u);break;case 11:case 12:g(O,u);break;case 21:S(A,u);break;case 22:g(A,u);break;case 33:S(j,u);break;case 34:g(j,u);break;case 31:S(R,u);break;case 32:g(R,u);break}let y=0;j.forEach(u=>y+=u);function $(u){const d=[];return u.forEach((p,c)=>d.push([c,p])),d}return{amdLoad:$(O),amdInvoke:$(A),nodeRequire:$(j),nodeEval:$(R),nodeRequireTotal:y}}static toMarkdownTable(O,A){let j="";const R=[];return O.forEach((S,g)=>{R[g]=S.length}),A.forEach(S=>{S.forEach((g,C)=>{typeof g>"u"&&(g=S[C]="-");const y=g.toString().length;R[C]=Math.max(y,R[C])})}),O.forEach((S,g)=>{j+=`| ${S+" ".repeat(R[g]-S.toString().length)} `}),j+=`|
`,O.forEach((S,g)=>{j+=`| ${"-".repeat(R[g])} `}),j+=`|
`,A.forEach(S=>{S.forEach((g,C)=>{typeof g<"u"&&(j+=`| ${g+" ".repeat(R[C]-g.toString().length)} `)}),j+=`|
`}),j}}e.$S=L}),define(ce[83],le([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vg=e.$Ug=e.$Tg=void 0;function L(j){return(R,S,g)=>{let C=null,y=null;if(typeof g.value=="function"?(C="value",y=g.value):typeof g.get=="function"&&(C="get",y=g.get),!y)throw new Error("not supported");g[C]=j(y,S)}}function N(j,R,S){let g=null,C=null;if(typeof S.value=="function"?(g="value",C=S.value,C.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(g="get",C=S.get),!C)throw new Error("not supported");const y=`$memoize$${R}`;S[g]=function(...$){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:C.apply(this,$)}),this[y]}}e.$Tg=N;function O(j,R,S){return L((g,C)=>{const y=`$debounce$${C}`,$=`$debounce$result$${C}`;return function(...u){this[$]||(this[$]=S?S():void 0),clearTimeout(this[y]),R&&(this[$]=R(this[$],...u),u=[this[$]]),this[y]=setTimeout(()=>{g.apply(this,u),this[$]=S?S():void 0},j)}})}e.$Ug=O;function A(j,R,S){return L((g,C)=>{const y=`$throttle$timer$${C}`,$=`$throttle$result$${C}`,u=`$throttle$lastRun$${C}`,d=`$throttle$pending$${C}`;return function(...p){if(this[$]||(this[$]=S?S():void 0),(this[u]===null||this[u]===void 0)&&(this[u]=-Number.MAX_VALUE),R&&(this[$]=R(this[$],...p)),this[d])return;const c=this[u]+j;c<=Date.now()?(this[u]=Date.now(),g.apply(this,[this[$]]),this[$]=S?S():void 0):(this[d]=!0,this[y]=setTimeout(()=>{this[d]=!1,this[u]=Date.now(),g.apply(this,[this[$]]),this[$]=S?S():void 0},c-Date.now()))}})}e.$Vg=A}),define(ce[8],le([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.$X=e.setUnexpectedErrorHandler=e.$V=e.$U=void 0;class L{constructor(){this.b=[],this.a=function(o){setTimeout(()=>{throw o.stack?w.isErrorNoTelemetry(o)?new w(o.message+`

`+o.stack):new Error(o.message+`

`+o.stack):o},0)}}addListener(o){return this.b.push(o),()=>{this.d(o)}}c(o){this.b.forEach(s=>{s(o)})}d(o){this.b.splice(this.b.indexOf(o),1)}setUnexpectedErrorHandler(o){this.a=o}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(o){this.a(o),this.c(o)}onUnexpectedExternalError(o){this.a(o)}}e.$U=L,e.$V=new L;function N(t){e.$V.setUnexpectedErrorHandler(t)}e.setUnexpectedErrorHandler=N;function O(t){if(!t||typeof t!="object")return!1;const o=t;return o.code==="EPIPE"&&o.syscall?.toUpperCase()==="WRITE"}e.$X=O;function A(t){g(t)||e.$V.onUnexpectedError(t)}e.$Y=A;function j(t){g(t)||e.$V.onUnexpectedExternalError(t)}e.$Z=j;function R(t){if(t instanceof Error){const{name:o,message:s}=t,n=t.stacktrace||t.stack;return{$isError:!0,name:o,message:s,stack:n,noTelemetry:w.isErrorNoTelemetry(t)}}return t}e.$1=R;const S="Canceled";function g(t){return t instanceof C?!0:t instanceof Error&&t.name===S&&t.message===S}e.$2=g;class C extends Error{constructor(){super(S),this.name=this.message}}e.$3=C;function y(){const t=new Error(S);return t.name=t.message,t}e.$4=y;function $(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}e.$5=$;function u(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}e.$6=u;function d(t){return t?new Error(`readonly property '${t} cannot be changed'`):new Error("readonly property cannot be changed")}e.$7=d;function p(t){const o=new Error(`${t} has been disposed`);return o.name="DISPOSED",o}e.$8=p;function c(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}e.$9=c;class h extends Error{constructor(o){super("NotImplemented"),o&&(this.message=o)}}e.$0=h;class f extends Error{constructor(o){super("NotSupported"),o&&(this.message=o)}}e.$$=f;class b extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$_=b;class w extends Error{constructor(o){super(o),this.name="CodeExpectedError"}static fromError(o){if(o instanceof w)return o;const s=new w;return s.message=o.message,s.stack=o.stack,s}static isErrorNoTelemetry(o){return o.name==="CodeExpectedError"}}e.$ab=w;class I extends Error{constructor(o){super(o||"An unexpected bug occurred."),Object.setPrototypeOf(this,I.prototype)}}e.$bb=I}),define(ce[20],le([0,1,8]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.CompareResult=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.top=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=void 0;function N(x,se=0){return x[x.length-(1+se)]}e.$9e=N;function O(x){if(x.length===0)throw new Error("Invalid tail call");return[x.slice(0,x.length-1),x[x.length-1]]}e.$0e=O;function A(x,se,te=(ue,de)=>ue===de){if(x===se)return!0;if(!x||!se||x.length!==se.length)return!1;for(let ue=0,de=x.length;ue<de;ue++)if(!te(x[ue],se[ue]))return!1;return!0}e.$$e=A;function j(x,se){const te=x.length-1;se<te&&(x[se]=x[te]),x.pop()}e.$_e=j;function R(x,se,te){return S(x.length,ue=>te(x[ue],se))}e.$af=R;function S(x,se){let te=0,ue=x-1;for(;te<=ue;){const de=(te+ue)/2|0,we=se(de);if(we<0)te=de+1;else if(we>0)ue=de-1;else return de}return-(te+1)}e.$bf=S;function g(x,se){let te=0,ue=x.length;if(ue===0)return 0;for(;te<ue;){const de=Math.floor((te+ue)/2);se(x[de])?ue=de:te=de+1}return te}e.$cf=g;function C(x,se,te){if(x=x|0,x>=se.length)throw new TypeError("invalid index");const ue=se[Math.floor(se.length*Math.random())],de=[],we=[],Ee=[];for(const Le of se){const je=te(Le,ue);je<0?de.push(Le):je>0?we.push(Le):Ee.push(Le)}return x<de.length?C(x,de,te):x<de.length+Ee.length?Ee[0]:C(x-(de.length+Ee.length),we,te)}e.$df=C;function y(x,se){const te=[];let ue;for(const de of x.slice(0).sort(se))!ue||se(ue[0],de)!==0?(ue=[de],te.push(ue)):ue.push(de);return te}e.$ef=y;function $(x,se,te){const ue=[];function de(Le,je,Me){if(je===0&&Me.length===0)return;const he=ue[ue.length-1];he&&he.start+he.deleteCount===Le?(he.deleteCount+=je,he.toInsert.push(...Me)):ue.push({start:Le,deleteCount:je,toInsert:Me})}let we=0,Ee=0;for(;;){if(we===x.length){de(we,0,se.slice(Ee));break}if(Ee===se.length){de(we,x.length-we,[]);break}const Le=x[we],je=se[Ee],Me=te(Le,je);Me===0?(we+=1,Ee+=1):Me<0?(de(we,1,[]),we+=1):Me>0&&(de(we,0,[je]),Ee+=1)}return ue}e.$ff=$;function u(x,se,te){const ue=$(x,se,te),de=[],we=[];for(const Ee of ue)de.push(...x.slice(Ee.start,Ee.start+Ee.deleteCount)),we.push(...Ee.toInsert);return{removed:de,added:we}}e.$gf=u;function d(x,se,te){if(te===0)return[];const ue=x.slice(0,te).sort(se);return c(x,se,ue,te,x.length),ue}e.top=d;function p(x,se,te,ue,de){return te===0?Promise.resolve([]):new Promise((we,Ee)=>{(async()=>{const Le=x.length,je=x.slice(0,te).sort(se);for(let Me=te,he=Math.min(te+ue,Le);Me<Le;Me=he,he=Math.min(he+ue,Le)){if(Me>te&&await new Promise(ge=>setTimeout(ge)),de&&de.isCancellationRequested)throw new L.$3;c(x,se,je,Me,he)}return je})().then(we,Ee)})}e.$if=p;function c(x,se,te,ue,de){for(const we=te.length;ue<de;ue++){const Ee=x[ue];if(se(Ee,te[we-1])<0){te.pop();const Le=g(te,je=>se(Ee,je)<0);te.splice(Le,0,Ee)}}}function h(x){return x.filter(se=>!!se)}e.$jf=h;function f(x){let se=0;for(let te=0;te<x.length;te++)x[te]&&(x[se]=x[te],se+=1);x.length=se}e.$kf=f;function b(x,se,te){x.splice(te,0,x.splice(se,1)[0])}e.$lf=b;function w(x){return!Array.isArray(x)||x.length===0}e.$mf=w;function I(x){return Array.isArray(x)&&x.length>0}e.$nf=I;function t(x,se=te=>te){const te=new Set;return x.filter(ue=>{const de=se(ue);return te.has(de)?!1:(te.add(de),!0)})}e.$of=t;function o(x){const se=new Set;return te=>{const ue=x(te);return se.has(ue)?!1:(se.add(ue),!0)}}e.$pf=o;function s(x,se){const te=n(x,se);if(te!==-1)return x[te]}e.$qf=s;function n(x,se){for(let te=x.length-1;te>=0;te--){const ue=x[te];if(se(ue))return te}return-1}e.$rf=n;function i(x,se){return x.length>0?x[0]:se}e.$sf=i;function r(x,se){return x.length>0?x[x.length-1]:se}e.$tf=r;function a(x,se,te=(ue,de)=>ue===de){let ue=0;for(let de=0,we=Math.min(x.length,se.length);de<we&&te(x[de],se[de]);de++)ue++;return ue}e.$uf=a;function v(x){return[].concat(...x)}e.$vf=v;function m(x,se){let te=typeof se=="number"?x:0;typeof se=="number"?te=x:(te=0,se=x);const ue=[];if(te<=se)for(let de=te;de<se;de++)ue.push(de);else for(let de=te;de>se;de--)ue.push(de);return ue}e.$wf=m;function l(x,se,te){return x.reduce((ue,de)=>(ue[se(de)]=te?te(de):de,ue),Object.create(null))}e.$xf=l;function E(x,se){return x.push(se),()=>D(x,se)}e.$yf=E;function D(x,se){const te=x.indexOf(se);if(te>-1)return x.splice(te,1),se}e.$zf=D;function T(x,se,te){const ue=x.slice(0,se),de=x.slice(se);return ue.concat(te,de)}e.$Af=T;function M(x,se){let te;if(typeof se=="number"){let ue=se;te=()=>{const de=Math.sin(ue++)*179426549;return de-Math.floor(de)}}else te=Math.random;for(let ue=x.length-1;ue>0;ue-=1){const de=Math.floor(te()*(ue+1)),we=x[ue];x[ue]=x[de],x[de]=we}}e.$Bf=M;function F(x,se){const te=x.indexOf(se);te>-1&&(x.splice(te,1),x.unshift(se))}e.$Cf=F;function V(x,se){const te=x.indexOf(se);te>-1&&(x.splice(te,1),x.push(se))}e.$Df=V;function Z(x,se){for(const te of se)x.push(te)}e.$Ef=Z;function J(x,se){return Array.isArray(x)?x.map(se):se(x)}e.$Ff=J;function Q(x){return Array.isArray(x)?x:[x]}e.$Gf=Q;function G(x){return x[Math.floor(Math.random()*x.length)]}e.$Hf=G;function X(x,se){for(const te of x){const ue=se(te);if(ue!==void 0)return ue}}e.$If=X;function W(x,se,te){const ue=B(x,se),de=x.length,we=te.length;x.length=de+we;for(let Ee=de-1;Ee>=ue;Ee--)x[Ee+we]=x[Ee];for(let Ee=0;Ee<we;Ee++)x[Ee+ue]=te[Ee]}e.$Jf=W;function q(x,se,te,ue){const de=B(x,se),we=x.splice(de,te);return W(x,de,ue),we}e.$Kf=q;function B(x,se){return se<0?Math.max(se+x.length,0):Math.min(se,x.length)}var _;(function(x){function se(we){return we<0}x.isLessThan=se;function te(we){return we<=0}x.isLessThanOrEqual=te;function ue(we){return we>0}x.isGreaterThan=ue;function de(we){return we===0}x.isNeitherLessOrGreaterThan=de,x.greaterThan=1,x.lessThan=-1,x.neitherLessOrGreaterThan=0})(_||(e.CompareResult=_={}));function oe(x,se){return(te,ue)=>se(x(te),x(ue))}e.$Lf=oe;function ae(...x){return(se,te)=>{for(const ue of x){const de=ue(se,te);if(!_.isNeitherLessOrGreaterThan(de))return de}return _.neitherLessOrGreaterThan}}e.$Mf=ae;const Y=(x,se)=>x-se;e.$Nf=Y;const U=(x,se)=>(0,e.$Nf)(x?1:0,se?1:0);e.$Of=U;function k(x){return(se,te)=>-x(se,te)}e.$Pf=k;function P(x,se){if(x.length===0)return;let te=x[0];for(let ue=1;ue<x.length;ue++){const de=x[ue];se(de,te)>0&&(te=de)}return te}e.$Qf=P;function z(x,se){if(x.length===0)return;let te=x[0];for(let ue=1;ue<x.length;ue++){const de=x[ue];se(de,te)>=0&&(te=de)}return te}e.$Rf=z;function H(x,se){return P(x,(te,ue)=>-se(te,ue))}e.$Sf=H;function ee(x,se){if(x.length===0)return-1;let te=0;for(let ue=1;ue<x.length;ue++){const de=x[ue];se(de,x[te])>0&&(te=ue)}return te}e.$Tf=ee;class ne{constructor(se){this.f=se,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(se){let te=this.c;for(;te<this.f.length&&se(this.f[te]);)te++;const ue=te===this.c?null:this.f.slice(this.c,te);return this.c=te,ue}takeFromEndWhile(se){let te=this.d;for(;te>=0&&se(this.f[te]);)te--;const ue=te===this.d?null:this.f.slice(te+1,this.d+1);return this.d=te,ue}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const se=this.f[this.c];return this.c++,se}removeLast(){const se=this.f[this.d];return this.d--,se}takeCount(se){const te=this.f.slice(this.c,this.c+se);return this.c+=se,te}}e.$Uf=ne;class fe{static{this.empty=new fe(se=>{})}constructor(se){this.iterate=se}forEach(se){this.iterate(te=>(se(te),!0))}toArray(){const se=[];return this.iterate(te=>(se.push(te),!0)),se}filter(se){return new fe(te=>this.iterate(ue=>se(ue)?te(ue):!0))}map(se){return new fe(te=>this.iterate(ue=>te(se(ue))))}some(se){let te=!1;return this.iterate(ue=>(te=se(ue),!te)),te}findFirst(se){let te;return this.iterate(ue=>se(ue)?(te=ue,!1):!0),te}findLast(se){let te;return this.iterate(ue=>(se(ue)&&(te=ue),!0)),te}findLastMaxBy(se){let te,ue=!0;return this.iterate(de=>((ue||_.isGreaterThan(se(de,te)))&&(ue=!1,te=de),!0)),te}}e.$Vf=fe}),define(ce[125],le([0,1,8]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zb=e.$yb=e.$xb=e.$wb=e.ok=void 0;function N(S,g){if(!S)throw new Error(g?`Assertion failed (${g})`:"Assertion Failed")}e.ok=N;function O(S,g="Unreachable"){throw new Error(g)}e.$wb=O;function A(S){if(!S)throw new L.$bb("Assertion Failed")}e.$xb=A;function j(S){if(!S()){debugger;S(),(0,L.$Y)(new L.$bb("Assertion Failed"))}}e.$yb=j;function R(S,g){let C=0;for(;C<S.length-1;){const y=S[C],$=S[C+1];if(!g(y,$))return!1;C++}return!0}e.$zb=R}),define(ce[84],le([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=void 0;function L(N){const O=this;let A=!1,j;return function(){return A||(A=!0,j=N.apply(O,arguments)),j}}e.$cb=L}),define(ce[59],le([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var L;(function(N){function O(w){return w&&typeof w=="object"&&typeof w[Symbol.iterator]=="function"}N.is=O;const A=Object.freeze([]);function j(){return A}N.empty=j;function*R(w){yield w}N.single=R;function S(w){return O(w)?w:R(w)}N.wrap=S;function g(w){return w||A}N.from=g;function C(w){return!w||w[Symbol.iterator]().next().done===!0}N.isEmpty=C;function y(w){return w[Symbol.iterator]().next().value}N.first=y;function $(w,I){for(const t of w)if(I(t))return!0;return!1}N.some=$;function u(w,I){for(const t of w)if(I(t))return t}N.find=u;function*d(w,I){for(const t of w)I(t)&&(yield t)}N.filter=d;function*p(w,I){let t=0;for(const o of w)yield I(o,t++)}N.map=p;function*c(...w){for(const I of w)for(const t of I)yield t}N.concat=c;function h(w,I,t){let o=t;for(const s of w)o=I(o,s);return o}N.reduce=h;function*f(w,I,t=w.length){for(I<0&&(I+=w.length),t<0?t+=w.length:t>w.length&&(t=w.length);I<t;I++)yield w[I]}N.slice=f;function b(w,I=Number.POSITIVE_INFINITY){const t=[];if(I===0)return[t,w];const o=w[Symbol.iterator]();for(let s=0;s<I;s++){const n=o.next();if(n.done)return[t,N.empty()];t.push(n.value)}return[t,{[Symbol.iterator](){return o}}]}N.consume=b})(L||(e.Iterable=L={}))}),define(ce[34],le([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=e.$Gm=e.$Fm=e.$Em=e.$Dm=e.$Cm=e.$Bm=e.$Am=e.$zm=e.$ym=e.$xm=e.$wm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var L;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(L||(e.ScanError=L={}));var N;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(N||(e.SyntaxKind=N={}));var O;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(O||(e.ParseErrorCode=O={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function j(t,o=!1){let s=0;const n=t.length;let i="",r=0,a=16,v=0;function m(V){let Z=0,J=0;for(;Z<V;){const Q=t.charCodeAt(s);if(Q>=48&&Q<=57)J=J*16+Q-48;else if(Q>=65&&Q<=70)J=J*16+Q-65+10;else if(Q>=97&&Q<=102)J=J*16+Q-97+10;else break;s++,Z++}return Z<V&&(J=-1),J}function l(V){s=V,i="",r=0,a=16,v=0}function E(){const V=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&g(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&g(t.charCodeAt(s)))for(s++;s<t.length&&g(t.charCodeAt(s));)s++;else return v=3,t.substring(V,s);let Z=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&g(t.charCodeAt(s))){for(s++;s<t.length&&g(t.charCodeAt(s));)s++;Z=s}else v=3;return t.substring(V,Z)}function D(){let V="",Z=s;for(;;){if(s>=n){V+=t.substring(Z,s),v=2;break}const J=t.charCodeAt(s);if(J===34){V+=t.substring(Z,s),s++;break}if(J===92){if(V+=t.substring(Z,s),s++,s>=n){v=2;break}switch(t.charCodeAt(s++)){case 34:V+='"';break;case 92:V+="\\";break;case 47:V+="/";break;case 98:V+="\b";break;case 102:V+="\f";break;case 110:V+=`
`;break;case 114:V+="\r";break;case 116:V+="	";break;case 117:{const G=m(4);G>=0?V+=String.fromCharCode(G):v=4;break}default:v=5}Z=s;continue}if(J>=0&&J<=31)if(S(J)){V+=t.substring(Z,s),v=2;break}else v=6;s++}return V}function T(){if(i="",v=0,r=s,s>=n)return r=n,a=17;let V=t.charCodeAt(s);if(R(V)){do s++,i+=String.fromCharCode(V),V=t.charCodeAt(s);while(R(V));return a=15}if(S(V))return s++,i+=String.fromCharCode(V),V===13&&t.charCodeAt(s)===10&&(s++,i+=`
`),a=14;switch(V){case 123:return s++,a=1;case 125:return s++,a=2;case 91:return s++,a=3;case 93:return s++,a=4;case 58:return s++,a=6;case 44:return s++,a=5;case 34:return s++,i=D(),a=10;case 47:{const Z=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<n&&!S(t.charCodeAt(s));)s++;return i=t.substring(Z,s),a=12}if(t.charCodeAt(s+1)===42){s+=2;const J=n-1;let Q=!1;for(;s<J;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,Q=!0;break}s++}return Q||(s++,v=1),i=t.substring(Z,s),a=13}return i+=String.fromCharCode(V),s++,a=16}case 45:if(i+=String.fromCharCode(V),s++,s===n||!g(t.charCodeAt(s)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return i+=E(),a=11;default:for(;s<n&&M(V);)s++,V=t.charCodeAt(s);if(r!==s){switch(i=t.substring(r,s),i){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return i+=String.fromCharCode(V),s++,a=16}}function M(V){if(R(V)||S(V))return!1;switch(V){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let V;do V=T();while(V>=12&&V<=15);return V}return{setPosition:l,getPosition:()=>s,scan:o?F:T,getToken:()=>a,getTokenValue:()=>i,getTokenOffset:()=>r,getTokenLength:()=>s-r,getTokenError:()=>v}}e.$wm=j;function R(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function S(t){return t===10||t===13||t===8232||t===8233}function g(t){return t>=48&&t<=57}var C;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(C||(C={}));function y(t,o){const s=[],n=new Object;let i;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function v(m,l,E,D){r.value=m,r.offset=l,r.length=E,r.type=D,r.colonOffset=void 0,i=r}try{b(t,{onObjectBegin:(m,l)=>{if(o<=m)throw n;i=void 0,a=o>m,s.push("")},onObjectProperty:(m,l,E)=>{if(o<l||(v(m,l,E,"property"),s[s.length-1]=m,o<=l+E))throw n},onObjectEnd:(m,l)=>{if(o<=m)throw n;i=void 0,s.pop()},onArrayBegin:(m,l)=>{if(o<=m)throw n;i=void 0,s.push(0)},onArrayEnd:(m,l)=>{if(o<=m)throw n;i=void 0,s.pop()},onLiteralValue:(m,l,E)=>{if(o<l||(v(m,l,E,I(m)),o<=l+E))throw n},onSeparator:(m,l,E)=>{if(o<=l)throw n;if(m===":"&&i&&i.type==="property")i.colonOffset=l,a=!1,i=void 0;else if(m===","){const D=s[s.length-1];typeof D=="number"?s[s.length-1]=D+1:(a=!0,s[s.length-1]=""),i=void 0}}})}catch(m){if(m!==n)throw m}return{path:s,previousNode:i,isAtPropertyKey:a,matches:m=>{let l=0;for(let E=0;l<m.length&&E<s.length;E++)if(m[l]===s[E]||m[l]==="*")l++;else if(m[l]!=="**")return!1;return l===m.length}}}e.$xm=y;function $(t,o=[],s=A.DEFAULT){let n=null,i=[];const r=[];function a(m){Array.isArray(i)?i.push(m):n!==null&&(i[n]=m)}return b(t,{onObjectBegin:()=>{const m={};a(m),r.push(i),i=m,n=null},onObjectProperty:m=>{n=m},onObjectEnd:()=>{i=r.pop()},onArrayBegin:()=>{const m=[];a(m),r.push(i),i=m,n=null},onArrayEnd:()=>{i=r.pop()},onLiteralValue:a,onError:(m,l,E)=>{o.push({error:m,offset:l,length:E})}},s),i[0]}e.$ym=$;function u(t,o=[],s=A.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function i(m){n.type==="property"&&(n.length=m-n.offset,n=n.parent)}function r(m){return n.children.push(m),m}b(t,{onObjectBegin:m=>{n=r({type:"object",offset:m,length:-1,parent:n,children:[]})},onObjectProperty:(m,l,E)=>{n=r({type:"property",offset:l,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:m,offset:l,length:E,parent:n})},onObjectEnd:(m,l)=>{n.length=m+l-n.offset,n=n.parent,i(m+l)},onArrayBegin:(m,l)=>{n=r({type:"array",offset:m,length:-1,parent:n,children:[]})},onArrayEnd:(m,l)=>{n.length=m+l-n.offset,n=n.parent,i(m+l)},onLiteralValue:(m,l,E)=>{r({type:I(m),offset:l,length:E,parent:n,value:m}),i(l+E)},onSeparator:(m,l,E)=>{n.type==="property"&&(m===":"?n.colonOffset=l:m===","&&i(l))},onError:(m,l,E)=>{o.push({error:m,offset:l,length:E})}},s);const v=n.children[0];return v&&delete v.parent,v}e.$zm=u;function d(t,o){if(!t)return;let s=t;for(const n of o)if(typeof n=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let i=!1;for(const r of s.children)if(Array.isArray(r.children)&&r.children[0].value===n){s=r.children[1],i=!0;break}if(!i)return}else{const i=n;if(s.type!=="array"||i<0||!Array.isArray(s.children)||i>=s.children.length)return;s=s.children[i]}return s}e.$Am=d;function p(t){if(!t.parent||!t.parent.children)return[];const o=p(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;o.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&o.push(s)}return o}e.$Bm=p;function c(t){switch(t.type){case"array":return t.children.map(c);case"object":{const o=Object.create(null);for(const s of t.children){const n=s.children[1];n&&(o[s.children[0].value]=c(n))}return o}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$Cm=c;function h(t,o,s=!1){return o>=t.offset&&o<t.offset+t.length||s&&o===t.offset+t.length}e.$Dm=h;function f(t,o,s=!1){if(h(t,o,s)){const n=t.children;if(Array.isArray(n))for(let i=0;i<n.length&&n[i].offset<=o;i++){const r=f(n[i],o,s);if(r)return r}return t}}e.$Em=f;function b(t,o,s=A.DEFAULT){const n=j(t,!1);function i(oe){return oe?()=>oe(n.getTokenOffset(),n.getTokenLength()):()=>!0}function r(oe){return oe?ae=>oe(ae,n.getTokenOffset(),n.getTokenLength()):()=>!0}const a=i(o.onObjectBegin),v=r(o.onObjectProperty),m=i(o.onObjectEnd),l=i(o.onArrayBegin),E=i(o.onArrayEnd),D=r(o.onLiteralValue),T=r(o.onSeparator),M=i(o.onComment),F=r(o.onError),V=s&&s.disallowComments,Z=s&&s.allowTrailingComma;function J(){for(;;){const oe=n.scan();switch(n.getTokenError()){case 4:Q(14);break;case 5:Q(15);break;case 3:Q(13);break;case 1:V||Q(11);break;case 2:Q(12);break;case 6:Q(16);break}switch(oe){case 12:case 13:V?Q(10):M();break;case 16:Q(1);break;case 15:case 14:break;default:return oe}}}function Q(oe,ae=[],Y=[]){if(F(oe),ae.length+Y.length>0){let U=n.getToken();for(;U!==17;){if(ae.indexOf(U)!==-1){J();break}else if(Y.indexOf(U)!==-1)break;U=J()}}}function G(oe){const ae=n.getTokenValue();return oe?D(ae):v(ae),J(),!0}function X(){switch(n.getToken()){case 11:{let oe=0;try{oe=JSON.parse(n.getTokenValue()),typeof oe!="number"&&(Q(2),oe=0)}catch{Q(2)}D(oe);break}case 7:D(null);break;case 8:D(!0);break;case 9:D(!1);break;default:return!1}return J(),!0}function W(){return n.getToken()!==10?(Q(3,[],[2,5]),!1):(G(!1),n.getToken()===6?(T(":"),J(),_()||Q(4,[],[2,5])):Q(5,[],[2,5]),!0)}function q(){a(),J();let oe=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(oe||Q(4,[],[]),T(","),J(),n.getToken()===2&&Z)break}else oe&&Q(6,[],[]);W()||Q(4,[],[2,5]),oe=!0}return m(),n.getToken()!==2?Q(7,[2],[]):J(),!0}function B(){l(),J();let oe=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(oe||Q(4,[],[]),T(","),J(),n.getToken()===4&&Z)break}else oe&&Q(6,[],[]);_()||Q(4,[],[4,5]),oe=!0}return E(),n.getToken()!==4?Q(8,[4],[]):J(),!0}function _(){switch(n.getToken()){case 3:return B();case 1:return q();case 10:return G(!0);default:return X()}}return J(),n.getToken()===17?s.allowEmptyContent?!0:(Q(4,[],[]),!1):_()?(n.getToken()!==17&&Q(9,[],[]),!0):(Q(4,[],[]),!1)}e.$Fm=b;function w(t,o){const s=j(t),n=[];let i,r=0,a;do switch(a=s.getPosition(),i=s.scan(),i){case 12:case 13:case 17:r!==a&&n.push(t.substring(r,a)),o!==void 0&&n.push(s.getTokenValue().replace(/[^\r\n]/g,o)),r=s.getPosition();break}while(i!==17);return n.join("")}e.$Gm=w;function I(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$Hm=I}),define(ce[41],le([0,1,34]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eS=e.$dS=e.$cS=e.$bS=void 0;function N(g,C,y){let $,u,d,p,c;if(C){for(p=C.offset,c=p+C.length,d=p;d>0&&!S(g,d-1);)d--;let a=c;for(;a<g.length&&!S(g,a);)a++;u=g.substring(d,a),$=j(u,y)}else u=g,$=0,d=0,p=0,c=g.length;const h=R(y,g);let f=!1,b=0,w;y.insertSpaces?w=A(" ",y.tabSize||4):w="	";const I=(0,L.$wm)(u,!1);let t=!1;function o(){return h+A(w,$+b)}function s(){let a=I.scan();for(f=!1;a===15||a===14;)f=f||a===14,a=I.scan();return t=a===16||I.getTokenError()!==0,a}const n=[];function i(a,v,m){!t&&v<c&&m>p&&g.substring(v,m)!==a&&n.push({offset:v,length:m-v,content:a})}let r=s();if(r!==17){const a=I.getTokenOffset()+d,v=A(w,$);i(v,d,a)}for(;r!==17;){let a=I.getTokenOffset()+I.getTokenLength()+d,v=s(),m="";for(;!f&&(v===12||v===13);){const E=I.getTokenOffset()+d;i(" ",a,E),a=I.getTokenOffset()+I.getTokenLength()+d,m=v===12?o():"",v=s()}if(v===2)r!==1&&(b--,m=o());else if(v===4)r!==3&&(b--,m=o());else{switch(r){case 3:case 1:b++,m=o();break;case 5:case 12:m=o();break;case 13:f?m=o():m=" ";break;case 6:m=" ";break;case 10:if(v===6){m="";break}case 7:case 8:case 9:case 11:case 2:case 4:v===12||v===13?m=" ":v!==5&&v!==17&&(t=!0);break;case 16:t=!0;break}f&&(v===12||v===13)&&(m=o())}const l=I.getTokenOffset()+d;i(m,a,l),r=v}return n}e.$bS=N;function O(g,C){const y=JSON.stringify(g,void 0,C.insertSpaces?C.tabSize||4:"	");return C.eol!==void 0?y.replace(/\r\n|\r|\n/g,C.eol):y}e.$cS=O;function A(g,C){let y="";for(let $=0;$<C;$++)y+=g;return y}function j(g,C){let y=0,$=0;const u=C.tabSize||4;for(;y<g.length;){const d=g.charAt(y);if(d===" ")$++;else if(d==="	")$+=u;else break;y++}return Math.floor($/u)}function R(g,C){for(let y=0;y<C.length;y++){const $=C.charAt(y);if($==="\r")return y+1<C.length&&C.charAt(y+1)===`
`?`\r
`:"\r";if($===`
`)return`
`}return g&&g.eol||`
`}e.$dS=R;function S(g,C){return`\r
`.indexOf(g.charAt(C))!==-1}e.$eS=S}),define(ce[85],le([0,1,34,41]),function(ie,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jS=e.$iS=e.$hS=e.$gS=e.$fS=void 0;function O(g,C,y){return A(g,C,void 0,y)}e.$fS=O;function A(g,C,y,$,u){const d=C.slice(),p=[],c=(0,L.$zm)(g,p);let h,f;for(;d.length>0&&(f=d.pop(),h=(0,L.$Am)(c,d),h===void 0&&y!==void 0);)typeof f=="string"?y={[f]:y}:y=[y];if(h)if(h.type==="object"&&typeof f=="string"&&Array.isArray(h.children)){const b=(0,L.$Am)(h,[f]);if(b!==void 0)if(y===void 0){if(!b.parent)throw new Error("Malformed AST");const w=h.children.indexOf(b.parent);let I,t=b.parent.offset+b.parent.length;if(w>0){const o=h.children[w-1];I=o.offset+o.length}else I=h.offset+1,h.children.length>1&&(t=h.children[1].offset);return j(g,{offset:I,length:t-I,content:""},$)}else return j(g,{offset:b.offset,length:b.length,content:JSON.stringify(y)},$);else{if(y===void 0)return[];const w=`${JSON.stringify(f)}: ${JSON.stringify(y)}`,I=u?u(h.children.map(o=>o.children[0].value)):h.children.length;let t;if(I>0){const o=h.children[I-1];t={offset:o.offset+o.length,length:0,content:","+w}}else h.children.length===0?t={offset:h.offset+1,length:0,content:w}:t={offset:h.offset+1,length:0,content:w+","};return j(g,t,$)}}else if(h.type==="array"&&typeof f=="number"&&Array.isArray(h.children))if(y!==void 0){const b=`${JSON.stringify(y)}`;let w;if(h.children.length===0||f===0)w={offset:h.offset+1,length:0,content:h.children.length===0?b:b+","};else{const I=f===-1||f>h.children.length?h.children.length:f,t=h.children[I-1];w={offset:t.offset+t.length,length:0,content:","+b}}return j(g,w,$)}else{const b=f,w=h.children[b];let I;if(h.children.length===1)I={offset:h.offset+1,length:h.length-2,content:""};else if(h.children.length-1===b){const t=h.children[b-1],o=t.offset+t.length,s=h.offset+h.length;I={offset:o,length:s-2-o,content:""}}else I={offset:w.offset,length:h.children[b+1].offset-w.offset,content:""};return j(g,I,$)}else throw new Error(`Can not add ${typeof f!="number"?"index":"property"} to parent of type ${h.type}`);else{if(y===void 0)throw new Error("Can not delete in empty document");return j(g,{offset:c?c.offset:0,length:c?c.length:0,content:JSON.stringify(y)},$)}}e.$gS=A;function j(g,C,y){let $=R(g,C),u=C.offset,d=C.offset+C.content.length;if(C.length===0||C.content.length===0){for(;u>0&&!(0,N.$eS)($,u-1);)u--;for(;d<$.length&&!(0,N.$eS)($,d);)d++}const p=(0,N.$bS)($,{offset:u,length:d-u},y);for(let h=p.length-1;h>=0;h--){const f=p[h];$=R($,f),u=Math.min(u,f.offset),d=Math.max(d,f.offset+f.length),d+=f.content.length-f.length}const c=g.length-($.length-d)-u;return[{offset:u,length:c,content:$.substring(u,d)}]}e.$hS=j;function R(g,C){return g.substring(0,C.offset)+C.content+g.substring(C.offset+C.length)}e.$iS=R;function S(g,C){const y=C.slice(0).sort((u,d)=>{const p=u.offset-d.offset;return p===0?u.length-d.length:p});let $=g.length;for(let u=y.length-1;u>=0;u--){const d=y[u];if(d.offset+d.length<=$)g=R(g,d);else throw new Error("Overlapping edit");$=d.offset}return g}e.$jS=S}),define(ce[86],le([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=void 0;class L{constructor(O){this.d=O,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(O){this.c=O}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$T=L}),define(ce[2],le([0,1,84,59]),function(ie,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tb=e.$sb=e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=e.$db=void 0;const O=!1;let A=null;function j(r){A=r}if(e.$db=j,O){const r="__is_disposable_tracked__";j(new class{trackDisposable(a){const v=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[r]||console.log(v)},3e3)}setParent(a,v){if(a&&a!==f.None)try{a[r]=!0}catch{}}markAsDisposed(a){if(a&&a!==f.None)try{a[r]=!0}catch{}}markAsSingleton(a){}})}function R(r){return A?.trackDisposable(r),r}function S(r){A?.markAsDisposed(r)}function g(r,a){A?.setParent(r,a)}function C(r,a){if(A)for(const v of r)A.setParent(v,a)}function y(r){return A?.markAsSingleton(r),r}e.$eb=y;function $(r){return typeof r.dispose=="function"&&r.dispose.length===0}e.$fb=$;function u(r){if(N.Iterable.is(r)){const a=[];for(const v of r)if(v)try{v.dispose()}catch(m){a.push(m)}if(a.length===1)throw a[0];if(a.length>1)throw new AggregateError(a,"Encountered errors while disposing of store");return Array.isArray(r)?[]:r}else if(r)return r.dispose(),r}e.$gb=u;function d(r){for(const a of r)$(a)&&a.dispose();return[]}e.$hb=d;function p(...r){const a=c(()=>u(r));return C(r,a),a}e.$ib=p;function c(r){const a=R({dispose:(0,L.$cb)(()=>{S(a),r()})});return a}e.$jb=c;class h{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,R(this)}dispose(){this.g||(S(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{u(this.f)}finally{this.f.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return g(a,this),this.g?h.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(a),a}}e.$kb=h;class f{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new h,R(this),g(this.q,this)}dispose(){S(this),this.q.dispose()}B(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(a)}}e.$lb=f;class b{constructor(){this.b=!1,R(this)}get value(){return this.b?void 0:this.a}set value(a){this.b||a===this.a||(this.a?.dispose(),a&&g(a,this),this.a=a)}clear(){this.value=void 0}dispose(){this.b=!0,S(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const a=this.a;return this.a=void 0,a&&g(a,null),a}}e.$mb=b;class w{constructor(a){this.b=a,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$nb=w;class I{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,R(this)}set(a){let v=a;return this.unset=()=>v=void 0,this.isset=()=>v!==void 0,this.dispose=()=>{v&&(v(),v=void 0,S(this))},this}}e.$ob=I;class t{constructor(){this.a=new Map}acquire(a,...v){let m=this.a.get(a);m||(m={counter:0,object:this.b(a,...v)},this.a.set(a,m));const{object:l}=m,E=(0,L.$cb)(()=>{--m.counter===0&&(this.c(a,m.object),this.a.delete(a))});return m.counter++,{object:l,dispose:E}}}e.$pb=t;class o{constructor(a){this.a=a}async acquire(a,...v){const m=this.a.acquire(a,...v);try{return{object:await m.object,dispose:()=>m.dispose()}}catch(l){throw m.dispose(),l}}}e.$qb=o;class s{constructor(a){this.object=a}dispose(){}}e.$rb=s;function n(r){const a=new h;try{r(a)}finally{a.dispose()}}e.$sb=n;class i{constructor(){this.a=new Map,this.b=!1,R(this)}dispose(){S(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{u(this.a.values())}finally{this.a.clear()}}has(a){return this.a.has(a)}get(a){return this.a.get(a)}set(a,v,m=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),m||this.a.get(a)?.dispose(),this.a.set(a,v)}deleteAndDispose(a){this.a.get(a)?.dispose(),this.a.delete(a)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$tb=i}),define(ce[87],le([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ub=void 0;class L{static{this.Undefined=new L(void 0)}constructor(A){this.element=A,this.next=L.Undefined,this.prev=L.Undefined}}class N{constructor(){this.a=L.Undefined,this.b=L.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===L.Undefined}clear(){let A=this.a;for(;A!==L.Undefined;){const j=A.next;A.prev=L.Undefined,A.next=L.Undefined,A=j}this.a=L.Undefined,this.b=L.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,j){const R=new L(A);if(this.a===L.Undefined)this.a=R,this.b=R;else if(j){const g=this.b;this.b=R,R.prev=g,g.next=R}else{const g=this.a;this.a=R,R.next=g,g.prev=R}this.c+=1;let S=!1;return()=>{S||(S=!0,this.e(R))}}shift(){if(this.a!==L.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==L.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==L.Undefined&&A.next!==L.Undefined){const j=A.prev;j.next=A.next,A.next.prev=j}else A.prev===L.Undefined&&A.next===L.Undefined?(this.a=L.Undefined,this.b=L.Undefined):A.next===L.Undefined?(this.b=this.b.prev,this.b.next=L.Undefined):A.prev===L.Undefined&&(this.a=this.a.next,this.a.prev=L.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==L.Undefined;)yield A.element,A=A.next}}e.$ub=N}),define(ce[35],le([0,1]),function(ie,e){"use strict";var L,N,O;Object.defineProperty(e,"__esModule",{value:!0}),e.$ri=e.$qi=e.$pi=e.Touch=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=void 0;function A(p,c,h){let f=p.get(c);return f===void 0&&(f=h,p.set(c,f)),f}e.$ki=A;function j(p){const c=[];return p.forEach((h,f)=>{c.push(`${f} => ${h}`)}),`Map(${p.size}) {${c.join(", ")}}`}e.$li=j;function R(p){const c=[];return p.forEach(h=>{c.push(h)}),`Set(${p.size}) {${c.join(", ")}}`}e.$mi=R;class S{constructor(c,h){this.uri=c,this.value=h}}class g{static{this.a=c=>c.toString()}constructor(c,h){this[L]="ResourceMap",c instanceof g?(this.b=new Map(c.b),this.c=h??g.a):(this.b=new Map,this.c=c??g.a)}set(c,h){return this.b.set(this.c(c),new S(c,h)),this}get(c){return this.b.get(this.c(c))?.value}has(c){return this.b.has(this.c(c))}get size(){return this.b.size}clear(){this.b.clear()}delete(c){return this.b.delete(this.c(c))}forEach(c,h){typeof h<"u"&&(c=c.bind(h));for(const[f,b]of this.b)c(b.value,b.uri,this)}*values(){for(const c of this.b.values())yield c.value}*keys(){for(const c of this.b.values())yield c.uri}*entries(){for(const c of this.b.values())yield[c.uri,c.value]}*[(L=Symbol.toStringTag,Symbol.iterator)](){for(const[,c]of this.b)yield[c.uri,c.value]}}e.$ni=g;class C{constructor(c,h){this[N]="ResourceSet",!c||typeof c=="function"?this.a=new g(c):(this.a=new g(h),c.forEach(this.add,this))}get size(){return this.a.size}add(c){return this.a.set(c,c),this}clear(){this.a.clear()}delete(c){return this.a.delete(c)}forEach(c,h){this.a.forEach((f,b)=>c.call(h,b,b,this))}has(c){return this.a.has(c)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$oi=C;var y;(function(p){p[p.None=0]="None",p[p.AsOld=1]="AsOld",p[p.AsNew=2]="AsNew"})(y||(e.Touch=y={}));class ${constructor(){this[O]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(c){return this.a.has(c)}get(c,h=0){const f=this.a.get(c);if(f)return h!==0&&this.j(f,h),f.value}set(c,h,f=0){let b=this.a.get(c);if(b)b.value=h,f!==0&&this.j(b,f);else{switch(b={key:c,value:h,next:void 0,previous:void 0},f){case 0:this.h(b);break;case 1:this.g(b);break;case 2:this.h(b);break;default:this.h(b);break}this.a.set(c,b),this.d++}return this}delete(c){return!!this.remove(c)}remove(c){const h=this.a.get(c);if(h)return this.a.delete(c),this.i(h),this.d--,h.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const c=this.b;return this.a.delete(c.key),this.i(c),this.d--,c.value}forEach(c,h){const f=this.e;let b=this.b;for(;b;){if(h?c.bind(h)(b.value,b.key,this):c(b.value,b.key,this),this.e!==f)throw new Error("LinkedMap got modified during iteration.");b=b.next}}keys(){const c=this,h=this.e;let f=this.b;const b={[Symbol.iterator](){return b},next(){if(c.e!==h)throw new Error("LinkedMap got modified during iteration.");if(f){const w={value:f.key,done:!1};return f=f.next,w}else return{value:void 0,done:!0}}};return b}values(){const c=this,h=this.e;let f=this.b;const b={[Symbol.iterator](){return b},next(){if(c.e!==h)throw new Error("LinkedMap got modified during iteration.");if(f){const w={value:f.value,done:!1};return f=f.next,w}else return{value:void 0,done:!0}}};return b}entries(){const c=this,h=this.e;let f=this.b;const b={[Symbol.iterator](){return b},next(){if(c.e!==h)throw new Error("LinkedMap got modified during iteration.");if(f){const w={value:[f.key,f.value],done:!1};return f=f.next,w}else return{value:void 0,done:!0}}};return b}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(c){if(c>=this.size)return;if(c===0){this.clear();return}let h=this.b,f=this.size;for(;h&&f>c;)this.a.delete(h.key),h=h.next,f--;this.b=h,this.d=f,h&&(h.previous=void 0),this.e++}g(c){if(!this.b&&!this.c)this.c=c;else if(this.b)c.next=this.b,this.b.previous=c;else throw new Error("Invalid list");this.b=c,this.e++}h(c){if(!this.b&&!this.c)this.b=c;else if(this.c)c.previous=this.c,this.c.next=c;else throw new Error("Invalid list");this.c=c,this.e++}i(c){if(c===this.b&&c===this.c)this.b=void 0,this.c=void 0;else if(c===this.b){if(!c.next)throw new Error("Invalid list");c.next.previous=void 0,this.b=c.next}else if(c===this.c){if(!c.previous)throw new Error("Invalid list");c.previous.next=void 0,this.c=c.previous}else{const h=c.next,f=c.previous;if(!h||!f)throw new Error("Invalid list");h.previous=f,f.next=h}c.next=void 0,c.previous=void 0,this.e++}j(c,h){if(!this.b||!this.c)throw new Error("Invalid list");if(!(h!==1&&h!==2)){if(h===1){if(c===this.b)return;const f=c.next,b=c.previous;c===this.c?(b.next=void 0,this.c=b):(f.previous=b,b.next=f),c.previous=void 0,c.next=this.b,this.b.previous=c,this.b=c,this.e++}else if(h===2){if(c===this.c)return;const f=c.next,b=c.previous;c===this.b?(f.previous=void 0,this.b=f):(f.previous=b,b.next=f),c.next=void 0,c.previous=this.c,this.c.next=c,this.c=c,this.e++}}}toJSON(){const c=[];return this.forEach((h,f)=>{c.push([f,h])}),c}fromJSON(c){this.clear();for(const[h,f]of c)this.set(h,f)}}e.$pi=$;class u extends ${constructor(c,h=1){super(),this.k=c,this.l=Math.min(Math.max(0,h),1)}get limit(){return this.k}set limit(c){this.k=c,this.m()}get ratio(){return this.l}set ratio(c){this.l=Math.min(Math.max(0,c),1),this.m()}get(c,h=2){return super.get(c,h)}peek(c){return super.get(c,0)}set(c,h){return super.set(c,h,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$qi=u;class d{constructor(){this.a=new Map}add(c){return this.a.set(c,(this.a.get(c)||0)+1),this}delete(c){let h=this.a.get(c)||0;return h===0?!1:(h--,h===0?this.a.delete(c):this.a.set(c,h),!0)}has(c){return this.a.has(c)}}e.$ri=d}),define(ce[88],le([0,1,35]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9k=e.$8k=e.$7k=void 0;const N=new L.$qi(1e4);function O(g){return S(g,"NFC",N)}e.$7k=O;const A=new L.$qi(1e4);function j(g){return S(g,"NFD",A)}e.$8k=j;const R=/[^\u0000-\u0080]/;function S(g,C,y){if(!g)return g;const $=y.get(g);if($)return $;let u;return R.test(g)?u=g.normalize(C):u=g,y.set(g,u),u}e.$9k=function(){const g=/[\u0300-\u036f]/g;return function(C){return j(C).replace(g,"")}}()}),function(){function ie(O){const A=[];typeof O=="number"&&A.push("code/timeOrigin",O);function j(S){A.push(S,Date.now())}function R(){const S=[];for(let g=0;g<A.length;g+=2)S.push({name:A[g],startTime:A[g+1]});return S}return{mark:j,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ie():{mark(O){performance.mark(O)},getMarks(){let O=performance.timeOrigin;typeof O!="number"&&(O=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(O)}];for(const j of performance.getEntriesByType("mark"))A.push({name:j.name,startTime:Math.round(O+j.startTime)});return A}};if(typeof process=="object"){const O=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ie(O)}else return console.trace("perf-util loaded in UNKNOWN environment"),ie()}function L(O){return O.MonacoPerformanceMarks||(O.MonacoPerformanceMarks=e()),O.MonacoPerformanceMarks}var N;typeof global=="object"?N=global:typeof self=="object"?N=self:N={},typeof define=="function"?define("vs/base/common/performance",[],function(){return L(N)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=L(N):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),N.perf=L(N))}(),function(ie,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var L=e();for(var N in L)(typeof exports=="object"?exports:ie)[N]=L[N]}}(typeof self<"u"?self:this,function(){return function(ie){var e={};function L(N){if(e[N])return e[N].exports;var O=e[N]={i:N,l:!1,exports:{}};return ie[N].call(O.exports,O,O.exports,L),O.l=!0,O.exports}return L.m=ie,L.c=e,L.d=function(N,O,A){L.o(N,O)||Object.defineProperty(N,O,{enumerable:!0,get:A})},L.r=function(N){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(N,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(N,"__esModule",{value:!0})},L.t=function(N,O){if(1&O&&(N=L(N)),8&O||4&O&&typeof N=="object"&&N&&N.__esModule)return N;var A=Object.create(null);if(L.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:N}),2&O&&typeof N!="string")for(var j in N)L.d(A,j,function(R){return N[R]}.bind(null,j));return A},L.n=function(N){var O=N&&N.__esModule?function(){return N.default}:function(){return N};return L.d(O,"a",O),O},L.o=function(N,O){return Object.prototype.hasOwnProperty.call(N,O)},L.p="",L(L.s=0)}([function(ie,e,L){(function(N){var O;e=ie.exports=Y,O=typeof N=="object"&&N.env&&N.env.NODE_DEBUG&&/\bsemver\b/i.test(N.env.NODE_DEBUG)?function(){var he=Array.prototype.slice.call(arguments,0);he.unshift("SEMVER"),console.log.apply(console,he)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,j=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],S=e.src=[],g=0,C=g++;S[C]="0|[1-9]\\d*";var y=g++;S[y]="[0-9]+";var $=g++;S[$]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var u=g++;S[u]="("+S[C]+")\\.("+S[C]+")\\.("+S[C]+")";var d=g++;S[d]="("+S[y]+")\\.("+S[y]+")\\.("+S[y]+")";var p=g++;S[p]="(?:"+S[C]+"|"+S[$]+")";var c=g++;S[c]="(?:"+S[y]+"|"+S[$]+")";var h=g++;S[h]="(?:-("+S[p]+"(?:\\."+S[p]+")*))";var f=g++;S[f]="(?:-?("+S[c]+"(?:\\."+S[c]+")*))";var b=g++;S[b]="[0-9A-Za-z-]+";var w=g++;S[w]="(?:\\+("+S[b]+"(?:\\."+S[b]+")*))";var I=g++,t="v?"+S[u]+S[h]+"?"+S[w]+"?";S[I]="^"+t+"$";var o="[v=\\s]*"+S[d]+S[f]+"?"+S[w]+"?",s=g++;S[s]="^"+o+"$";var n=g++;S[n]="((?:<|>)?=?)";var i=g++;S[i]=S[y]+"|x|X|\\*";var r=g++;S[r]=S[C]+"|x|X|\\*";var a=g++;S[a]="[v=\\s]*("+S[r]+")(?:\\.("+S[r]+")(?:\\.("+S[r]+")(?:"+S[h]+")?"+S[w]+"?)?)?";var v=g++;S[v]="[v=\\s]*("+S[i]+")(?:\\.("+S[i]+")(?:\\.("+S[i]+")(?:"+S[f]+")?"+S[w]+"?)?)?";var m=g++;S[m]="^"+S[n]+"\\s*"+S[a]+"$";var l=g++;S[l]="^"+S[n]+"\\s*"+S[v]+"$";var E=g++;S[E]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var D=g++;S[D]="(?:~>?)";var T=g++;S[T]="(\\s*)"+S[D]+"\\s+",R[T]=new RegExp(S[T],"g");var M=g++;S[M]="^"+S[D]+S[a]+"$";var F=g++;S[F]="^"+S[D]+S[v]+"$";var V=g++;S[V]="(?:\\^)";var Z=g++;S[Z]="(\\s*)"+S[V]+"\\s+",R[Z]=new RegExp(S[Z],"g");var J=g++;S[J]="^"+S[V]+S[a]+"$";var Q=g++;S[Q]="^"+S[V]+S[v]+"$";var G=g++;S[G]="^"+S[n]+"\\s*("+o+")$|^$";var X=g++;S[X]="^"+S[n]+"\\s*("+t+")$|^$";var W=g++;S[W]="(\\s*)"+S[n]+"\\s*("+o+"|"+S[a]+")",R[W]=new RegExp(S[W],"g");var q=g++;S[q]="^\\s*("+S[a]+")\\s+-\\s+("+S[a]+")\\s*$";var B=g++;S[B]="^\\s*("+S[v]+")\\s+-\\s+("+S[v]+")\\s*$";var _=g++;S[_]="(<|>)?=?\\s*\\*";for(var oe=0;oe<35;oe++)O(oe,S[oe]),R[oe]||(R[oe]=new RegExp(S[oe]));function ae(he,ge){if(he instanceof Y)return he;if(typeof he!="string"||he.length>A||!(ge?R[s]:R[I]).test(he))return null;try{return new Y(he,ge)}catch{return null}}function Y(he,ge){if(he instanceof Y){if(he.loose===ge)return he;he=he.version}else if(typeof he!="string")throw new TypeError("Invalid Version: "+he);if(he.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof Y))return new Y(he,ge);O("SemVer",he,ge),this.loose=ge;var be=he.trim().match(ge?R[s]:R[I]);if(!be)throw new TypeError("Invalid Version: "+he);if(this.raw=he,this.major=+be[1],this.minor=+be[2],this.patch=+be[3],this.major>j||this.major<0)throw new TypeError("Invalid major version");if(this.minor>j||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>j||this.patch<0)throw new TypeError("Invalid patch version");be[4]?this.prerelease=be[4].split(".").map(function(Se){if(/^[0-9]+$/.test(Se)){var Pe=+Se;if(Pe>=0&&Pe<j)return Pe}return Se}):this.prerelease=[],this.build=be[5]?be[5].split("."):[],this.format()}e.parse=ae,e.valid=function(he,ge){var be=ae(he,ge);return be?be.version:null},e.clean=function(he,ge){var be=ae(he.trim().replace(/^[=v]+/,""),ge);return be?be.version:null},e.SemVer=Y,Y.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Y.prototype.toString=function(){return this.version},Y.prototype.compare=function(he){return O("SemVer.compare",this.version,this.loose,he),he instanceof Y||(he=new Y(he,this.loose)),this.compareMain(he)||this.comparePre(he)},Y.prototype.compareMain=function(he){return he instanceof Y||(he=new Y(he,this.loose)),k(this.major,he.major)||k(this.minor,he.minor)||k(this.patch,he.patch)},Y.prototype.comparePre=function(he){if(he instanceof Y||(he=new Y(he,this.loose)),this.prerelease.length&&!he.prerelease.length)return-1;if(!this.prerelease.length&&he.prerelease.length)return 1;if(!this.prerelease.length&&!he.prerelease.length)return 0;var ge=0;do{var be=this.prerelease[ge],Se=he.prerelease[ge];if(O("prerelease compare",ge,be,Se),be===void 0&&Se===void 0)return 0;if(Se===void 0)return 1;if(be===void 0)return-1;if(be!==Se)return k(be,Se)}while(++ge)},Y.prototype.inc=function(he,ge){switch(he){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ge);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ge);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ge),this.inc("pre",ge);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ge),this.inc("pre",ge);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var be=this.prerelease.length;--be>=0;)typeof this.prerelease[be]=="number"&&(this.prerelease[be]++,be=-2);be===-1&&this.prerelease.push(0)}ge&&(this.prerelease[0]===ge?isNaN(this.prerelease[1])&&(this.prerelease=[ge,0]):this.prerelease=[ge,0]);break;default:throw new Error("invalid increment argument: "+he)}return this.format(),this.raw=this.version,this},e.inc=function(he,ge,be,Se){typeof be=="string"&&(Se=be,be=void 0);try{return new Y(he,be).inc(ge,Se).version}catch{return null}},e.diff=function(he,ge){if(ee(he,ge))return null;var be=ae(he),Se=ae(ge);if(be.prerelease.length||Se.prerelease.length){for(var Pe in be)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&be[Pe]!==Se[Pe])return"pre"+Pe;return"prerelease"}for(var Pe in be)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&be[Pe]!==Se[Pe])return Pe},e.compareIdentifiers=k;var U=/^[0-9]+$/;function k(he,ge){var be=U.test(he),Se=U.test(ge);return be&&Se&&(he=+he,ge=+ge),be&&!Se?-1:Se&&!be?1:he<ge?-1:he>ge?1:0}function P(he,ge,be){return new Y(he,be).compare(new Y(ge,be))}function z(he,ge,be){return P(he,ge,be)>0}function H(he,ge,be){return P(he,ge,be)<0}function ee(he,ge,be){return P(he,ge,be)===0}function ne(he,ge,be){return P(he,ge,be)!==0}function fe(he,ge,be){return P(he,ge,be)>=0}function x(he,ge,be){return P(he,ge,be)<=0}function se(he,ge,be,Se){var Pe;switch(ge){case"===":typeof he=="object"&&(he=he.version),typeof be=="object"&&(be=be.version),Pe=he===be;break;case"!==":typeof he=="object"&&(he=he.version),typeof be=="object"&&(be=be.version),Pe=he!==be;break;case"":case"=":case"==":Pe=ee(he,be,Se);break;case"!=":Pe=ne(he,be,Se);break;case">":Pe=z(he,be,Se);break;case">=":Pe=fe(he,be,Se);break;case"<":Pe=H(he,be,Se);break;case"<=":Pe=x(he,be,Se);break;default:throw new TypeError("Invalid operator: "+ge)}return Pe}function te(he,ge){if(he instanceof te){if(he.loose===ge)return he;he=he.value}if(!(this instanceof te))return new te(he,ge);O("comparator",he,ge),this.loose=ge,this.parse(he),this.semver===ue?this.value="":this.value=this.operator+this.semver.version,O("comp",this)}e.rcompareIdentifiers=function(he,ge){return k(ge,he)},e.major=function(he,ge){return new Y(he,ge).major},e.minor=function(he,ge){return new Y(he,ge).minor},e.patch=function(he,ge){return new Y(he,ge).patch},e.compare=P,e.compareLoose=function(he,ge){return P(he,ge,!0)},e.rcompare=function(he,ge,be){return P(ge,he,be)},e.sort=function(he,ge){return he.sort(function(be,Se){return e.compare(be,Se,ge)})},e.rsort=function(he,ge){return he.sort(function(be,Se){return e.rcompare(be,Se,ge)})},e.gt=z,e.lt=H,e.eq=ee,e.neq=ne,e.gte=fe,e.lte=x,e.cmp=se,e.Comparator=te;var ue={};function de(he,ge){if(he instanceof de)return he.loose===ge?he:new de(he.raw,ge);if(he instanceof te)return new de(he.value,ge);if(!(this instanceof de))return new de(he,ge);if(this.loose=ge,this.raw=he,this.set=he.split(/\s*\|\|\s*/).map(function(be){return this.parseRange(be.trim())},this).filter(function(be){return be.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+he);this.format()}function we(he){return!he||he.toLowerCase()==="x"||he==="*"}function Ee(he,ge,be,Se,Pe,Ue,Oe,Fe,Te,re,$e,me,pe){return((ge=we(be)?"":we(Se)?">="+be+".0.0":we(Pe)?">="+be+"."+Se+".0":">="+ge)+" "+(Fe=we(Te)?"":we(re)?"<"+(+Te+1)+".0.0":we($e)?"<"+Te+"."+(+re+1)+".0":me?"<="+Te+"."+re+"."+$e+"-"+me:"<="+Fe)).trim()}function Le(he,ge){for(var be=0;be<he.length;be++)if(!he[be].test(ge))return!1;if(ge.prerelease.length){for(be=0;be<he.length;be++)if(O(he[be].semver),he[be].semver!==ue&&he[be].semver.prerelease.length>0){var Se=he[be].semver;if(Se.major===ge.major&&Se.minor===ge.minor&&Se.patch===ge.patch)return!0}return!1}return!0}function je(he,ge,be){try{ge=new de(ge,be)}catch{return!1}return ge.test(he)}function Me(he,ge,be,Se){var Pe,Ue,Oe,Fe,Te;switch(he=new Y(he,Se),ge=new de(ge,Se),be){case">":Pe=z,Ue=x,Oe=H,Fe=">",Te=">=";break;case"<":Pe=H,Ue=fe,Oe=z,Fe="<",Te="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(je(he,ge,Se))return!1;for(var re=0;re<ge.set.length;++re){var $e=ge.set[re],me=null,pe=null;if($e.forEach(function(ke){ke.semver===ue&&(ke=new te(">=0.0.0")),me=me||ke,pe=pe||ke,Pe(ke.semver,me.semver,Se)?me=ke:Oe(ke.semver,pe.semver,Se)&&(pe=ke)}),me.operator===Fe||me.operator===Te||(!pe.operator||pe.operator===Fe)&&Ue(he,pe.semver)||pe.operator===Te&&Oe(he,pe.semver))return!1}return!0}te.prototype.parse=function(he){var ge=this.loose?R[G]:R[X],be=he.match(ge);if(!be)throw new TypeError("Invalid comparator: "+he);this.operator=be[1],this.operator==="="&&(this.operator=""),be[2]?this.semver=new Y(be[2],this.loose):this.semver=ue},te.prototype.toString=function(){return this.value},te.prototype.test=function(he){return O("Comparator.test",he,this.loose),this.semver===ue||(typeof he=="string"&&(he=new Y(he,this.loose)),se(he,this.operator,this.semver,this.loose))},te.prototype.intersects=function(he,ge){if(!(he instanceof te))throw new TypeError("a Comparator is required");var be;if(this.operator==="")return be=new de(he.value,ge),je(this.value,be,ge);if(he.operator==="")return be=new de(this.value,ge),je(he.semver,be,ge);var Se=!(this.operator!==">="&&this.operator!==">"||he.operator!==">="&&he.operator!==">"),Pe=!(this.operator!=="<="&&this.operator!=="<"||he.operator!=="<="&&he.operator!=="<"),Ue=this.semver.version===he.semver.version,Oe=!(this.operator!==">="&&this.operator!=="<="||he.operator!==">="&&he.operator!=="<="),Fe=se(this.semver,"<",he.semver,ge)&&(this.operator===">="||this.operator===">")&&(he.operator==="<="||he.operator==="<"),Te=se(this.semver,">",he.semver,ge)&&(this.operator==="<="||this.operator==="<")&&(he.operator===">="||he.operator===">");return Se||Pe||Ue&&Oe||Fe||Te},e.Range=de,de.prototype.format=function(){return this.range=this.set.map(function(he){return he.join(" ").trim()}).join("||").trim(),this.range},de.prototype.toString=function(){return this.range},de.prototype.parseRange=function(he){var ge=this.loose;he=he.trim(),O("range",he,ge);var be=ge?R[B]:R[q];he=he.replace(be,Ee),O("hyphen replace",he),he=he.replace(R[W],"$1$2$3"),O("comparator trim",he,R[W]),he=(he=(he=he.replace(R[T],"$1~")).replace(R[Z],"$1^")).split(/\s+/).join(" ");var Se=ge?R[G]:R[X],Pe=he.split(" ").map(function(Ue){return function(Oe,Fe){return O("comp",Oe),Oe=function(Te,re){return Te.trim().split(/\s+/).map(function($e){return function(me,pe){O("caret",me,pe);var ke=pe?R[Q]:R[J];return me.replace(ke,function(Re,Ce,Ie,Ae,De){var Ne;return O("caret",me,Re,Ce,Ie,Ae,De),we(Ce)?Ne="":we(Ie)?Ne=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":we(Ae)?Ne=Ce==="0"?">="+Ce+"."+Ie+".0 <"+Ce+"."+(+Ie+1)+".0":">="+Ce+"."+Ie+".0 <"+(+Ce+1)+".0.0":De?(O("replaceCaret pr",De),De.charAt(0)!=="-"&&(De="-"+De),Ne=Ce==="0"?Ie==="0"?">="+Ce+"."+Ie+"."+Ae+De+" <"+Ce+"."+Ie+"."+(+Ae+1):">="+Ce+"."+Ie+"."+Ae+De+" <"+Ce+"."+(+Ie+1)+".0":">="+Ce+"."+Ie+"."+Ae+De+" <"+(+Ce+1)+".0.0"):(O("no pr"),Ne=Ce==="0"?Ie==="0"?">="+Ce+"."+Ie+"."+Ae+" <"+Ce+"."+Ie+"."+(+Ae+1):">="+Ce+"."+Ie+"."+Ae+" <"+Ce+"."+(+Ie+1)+".0":">="+Ce+"."+Ie+"."+Ae+" <"+(+Ce+1)+".0.0"),O("caret return",Ne),Ne})}($e,re)}).join(" ")}(Oe,Fe),O("caret",Oe),Oe=function(Te,re){return Te.trim().split(/\s+/).map(function($e){return function(me,pe){var ke=pe?R[F]:R[M];return me.replace(ke,function(Re,Ce,Ie,Ae,De){var Ne;return O("tilde",me,Re,Ce,Ie,Ae,De),we(Ce)?Ne="":we(Ie)?Ne=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":we(Ae)?Ne=">="+Ce+"."+Ie+".0 <"+Ce+"."+(+Ie+1)+".0":De?(O("replaceTilde pr",De),De.charAt(0)!=="-"&&(De="-"+De),Ne=">="+Ce+"."+Ie+"."+Ae+De+" <"+Ce+"."+(+Ie+1)+".0"):Ne=">="+Ce+"."+Ie+"."+Ae+" <"+Ce+"."+(+Ie+1)+".0",O("tilde return",Ne),Ne})}($e,re)}).join(" ")}(Oe,Fe),O("tildes",Oe),Oe=function(Te,re){return O("replaceXRanges",Te,re),Te.split(/\s+/).map(function($e){return function(me,pe){me=me.trim();var ke=pe?R[l]:R[m];return me.replace(ke,function(Re,Ce,Ie,Ae,De,Ne){O("xRange",me,Re,Ce,Ie,Ae,De,Ne);var Be=we(Ie),qe=Be||we(Ae),Ve=qe||we(De);return Ce==="="&&Ve&&(Ce=""),Be?Re=Ce===">"||Ce==="<"?"<0.0.0":"*":Ce&&Ve?(qe&&(Ae=0),Ve&&(De=0),Ce===">"?(Ce=">=",qe?(Ie=+Ie+1,Ae=0,De=0):Ve&&(Ae=+Ae+1,De=0)):Ce==="<="&&(Ce="<",qe?Ie=+Ie+1:Ae=+Ae+1),Re=Ce+Ie+"."+Ae+"."+De):qe?Re=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":Ve&&(Re=">="+Ie+"."+Ae+".0 <"+Ie+"."+(+Ae+1)+".0"),O("xRange return",Re),Re})}($e,re)}).join(" ")}(Oe,Fe),O("xrange",Oe),Oe=function(Te,re){return O("replaceStars",Te,re),Te.trim().replace(R[_],"")}(Oe,Fe),O("stars",Oe),Oe}(Ue,ge)}).join(" ").split(/\s+/);return this.loose&&(Pe=Pe.filter(function(Ue){return!!Ue.match(Se)})),Pe=Pe.map(function(Ue){return new te(Ue,ge)})},de.prototype.intersects=function(he,ge){if(!(he instanceof de))throw new TypeError("a Range is required");return this.set.some(function(be){return be.every(function(Se){return he.set.some(function(Pe){return Pe.every(function(Ue){return Se.intersects(Ue,ge)})})})})},e.toComparators=function(he,ge){return new de(he,ge).set.map(function(be){return be.map(function(Se){return Se.value}).join(" ").trim().split(" ")})},de.prototype.test=function(he){if(!he)return!1;typeof he=="string"&&(he=new Y(he,this.loose));for(var ge=0;ge<this.set.length;ge++)if(Le(this.set[ge],he))return!0;return!1},e.satisfies=je,e.maxSatisfying=function(he,ge,be){var Se=null,Pe=null;try{var Ue=new de(ge,be)}catch{return null}return he.forEach(function(Oe){Ue.test(Oe)&&(Se&&Pe.compare(Oe)!==-1||(Pe=new Y(Se=Oe,be)))}),Se},e.minSatisfying=function(he,ge,be){var Se=null,Pe=null;try{var Ue=new de(ge,be)}catch{return null}return he.forEach(function(Oe){Ue.test(Oe)&&(Se&&Pe.compare(Oe)!==1||(Pe=new Y(Se=Oe,be)))}),Se},e.validRange=function(he,ge){try{return new de(he,ge).range||"*"}catch{return null}},e.ltr=function(he,ge,be){return Me(he,ge,"<",be)},e.gtr=function(he,ge,be){return Me(he,ge,">",be)},e.outside=Me,e.prerelease=function(he,ge){var be=ae(he,ge);return be&&be.prerelease.length?be.prerelease:null},e.intersects=function(he,ge,be){return he=new de(he,be),ge=new de(ge,be),he.intersects(ge)},e.coerce=function(he){if(he instanceof Y)return he;if(typeof he!="string")return null;var ge=he.match(R[E]);return ge==null?null:ae((ge[1]||"0")+"."+(ge[2]||"0")+"."+(ge[3]||"0"))}}).call(this,L(1))},function(ie,e){var L,N,O=ie.exports={};function A(){throw new Error("setTimeout has not been defined")}function j(){throw new Error("clearTimeout has not been defined")}function R(c){if(L===setTimeout)return setTimeout(c,0);if((L===A||!L)&&setTimeout)return L=setTimeout,setTimeout(c,0);try{return L(c,0)}catch{try{return L.call(null,c,0)}catch{return L.call(this,c,0)}}}(function(){try{L=typeof setTimeout=="function"?setTimeout:A}catch{L=A}try{N=typeof clearTimeout=="function"?clearTimeout:j}catch{N=j}})();var S,g=[],C=!1,y=-1;function $(){C&&S&&(C=!1,S.length?g=S.concat(g):y=-1,g.length&&u())}function u(){if(!C){var c=R($);C=!0;for(var h=g.length;h;){for(S=g,g=[];++y<h;)S&&S[y].run();y=-1,h=g.length}S=null,C=!1,function(f){if(N===clearTimeout)return clearTimeout(f);if((N===j||!N)&&clearTimeout)return N=clearTimeout,clearTimeout(f);try{N(f)}catch{try{return N.call(null,f)}catch{return N.call(this,f)}}}(c)}}function d(c,h){this.fun=c,this.array=h}function p(){}O.nextTick=function(c){var h=new Array(arguments.length-1);if(arguments.length>1)for(var f=1;f<arguments.length;f++)h[f-1]=arguments[f];g.push(new d(c,h)),g.length!==1||C||R(u)},d.prototype.run=function(){this.fun.apply(null,this.array)},O.title="browser",O.browser=!0,O.env={},O.argv=[],O.version="",O.versions={},O.on=p,O.addListener=p,O.once=p,O.off=p,O.removeListener=p,O.removeAllListeners=p,O.emit=p,O.prependListener=p,O.prependOnceListener=p,O.listeners=function(c){return[]},O.binding=function(c){throw new Error("process.binding is not supported")},O.cwd=function(){return"/"},O.chdir=function(c){throw new Error("process.chdir is not supported")},O.umask=function(){return 0}}])}),define(ce[126],le([0,1]),function(ie,e){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=void 0;class N{constructor(R,S,g){this.level=R,this.key=S,this.value=g,this.forward=[]}}const O=void 0;class A{constructor(R,S=2**16){this.comparator=R,this[L]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(S)|0),this.e=new N(this.c,O,O)}get size(){return this.f}clear(){this.e=new N(this.c,O,O)}has(R){return!!A.g(this,R,this.comparator)}get(R){return A.g(this,R,this.comparator)?.value}set(R,S){return A.h(this,R,S,this.comparator)&&(this.f+=1),this}delete(R){const S=A.k(this,R,this.comparator);return S&&(this.f-=1),S}forEach(R,S){let g=this.e.forward[0];for(;g;)R.call(S,g.value,g.key,this),g=g.forward[0]}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this.e.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this.e.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this.e.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",S=this.e.forward[0];for(;S;)R+=`node(${S.key}, ${S.value}, lvl:${S.level})`,S=S.forward[0];return R}static g(R,S,g){let C=R.e;for(let y=R.d-1;y>=0;y--)for(;C.forward[y]&&g(C.forward[y].key,S)<0;)C=C.forward[y];if(C=C.forward[0],C&&g(C.key,S)===0)return C}static h(R,S,g,C){const y=[];let $=R.e;for(let u=R.d-1;u>=0;u--){for(;$.forward[u]&&C($.forward[u].key,S)<0;)$=$.forward[u];y[u]=$}if($=$.forward[0],$&&C($.key,S)===0)return $.value=g,!1;{const u=A.j(R);if(u>R.d){for(let d=R.d;d<u;d++)y[d]=R.e;R.d=u}$=new N(u,S,g);for(let d=0;d<u;d++)$.forward[d]=y[d].forward[d],y[d].forward[d]=$;return!0}}static j(R,S=.5){let g=1;for(;Math.random()<S&&g<R.c;)g+=1;return g}static k(R,S,g){const C=[];let y=R.e;for(let $=R.d-1;$>=0;$--){for(;y.forward[$]&&g(y.forward[$].key,S)<0;)y=y.forward[$];C[$]=y}if(y=y.forward[0],!y||g(y.key,S)!==0)return!1;for(let $=0;$<R.d&&C[$].forward[$]===y;$++)C[$].forward[$]=y.forward[$];for(;R.d>0&&R.e.forward[R.d-1]===O;)R.d-=1;return!0}}e.$fr=A}),define(ce[60],le([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=void 0;const L=globalThis.performance&&typeof globalThis.performance.now=="function";class N{static create(A){return new N(A)}constructor(A){this.c=L&&A===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$ac=N}),define(ce[3],le([0,1,8,84,2,87,60]),function(ie,e,L,N,O,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=e.$dc=e.$cc=e.Event=void 0;const R=!1,S=!1;var g;(function(m){m.None=()=>O.$lb.None;function l(fe){if(S){const{onDidAddListener:x}=fe,se=d.create();let te=0;fe.onDidAddListener=()=>{++te===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),se.print()),x?.()}}}function E(fe,x){return G(fe,()=>{},0,void 0,!0,void 0,x)}m.defer=E;function D(fe){return(x,se=null,te)=>{let ue=!1,de;return de=fe(we=>{if(!ue)return de?de.dispose():ue=!0,x.call(se,we)},null,te),ue&&de.dispose(),de}}m.once=D;function T(fe,x,se){return Q((te,ue=null,de)=>fe(we=>te.call(ue,x(we)),null,de),se)}m.map=T;function M(fe,x,se){return Q((te,ue=null,de)=>fe(we=>{x(we),te.call(ue,we)},null,de),se)}m.forEach=M;function F(fe,x,se){return Q((te,ue=null,de)=>fe(we=>x(we)&&te.call(ue,we),null,de),se)}m.filter=F;function V(fe){return fe}m.signal=V;function Z(...fe){return(x,se=null,te)=>(0,O.$ib)(...fe.map(ue=>ue(de=>x.call(se,de),null,te)))}m.any=Z;function J(fe,x,se,te){let ue=se;return T(fe,de=>(ue=x(ue,de),ue),te)}m.reduce=J;function Q(fe,x){let se;const te={onWillAddFirstListener(){se=fe(ue.fire,ue)},onDidRemoveLastListener(){se?.dispose()}};x||l(te);const ue=new b(te);return x?.add(ue),ue.event}function G(fe,x,se=100,te=!1,ue=!1,de,we){let Ee,Le,je,Me=0,he;const ge={leakWarningThreshold:de,onWillAddFirstListener(){Ee=fe(Se=>{Me++,Le=x(Le,Se),te&&!je&&(be.fire(Le),Le=void 0),he=()=>{const Pe=Le;Le=void 0,je=void 0,(!te||Me>1)&&be.fire(Pe),Me=0},typeof se=="number"?(clearTimeout(je),je=setTimeout(he,se)):je===void 0&&(je=0,queueMicrotask(he))})},onWillRemoveListener(){ue&&Me>0&&he?.()},onDidRemoveLastListener(){he=void 0,Ee.dispose()}};we||l(ge);const be=new b(ge);return we?.add(be),be.event}m.debounce=G;function X(fe,x=0,se){return m.debounce(fe,(te,ue)=>te?(te.push(ue),te):[ue],x,void 0,!0,void 0,se)}m.accumulate=X;function W(fe,x=(te,ue)=>te===ue,se){let te=!0,ue;return F(fe,de=>{const we=te||!x(de,ue);return te=!1,ue=de,we},se)}m.latch=W;function q(fe,x,se){return[m.filter(fe,x,se),m.filter(fe,te=>!x(te),se)]}m.split=q;function B(fe,x=!1,se=[]){let te=se.slice(),ue=fe(Ee=>{te?te.push(Ee):we.fire(Ee)});const de=()=>{te?.forEach(Ee=>we.fire(Ee)),te=null},we=new b({onWillAddFirstListener(){ue||(ue=fe(Ee=>we.fire(Ee)))},onDidAddFirstListener(){te&&(x?setTimeout(de):de())},onDidRemoveLastListener(){ue&&ue.dispose(),ue=null}});return we.event}m.buffer=B;class _{constructor(x){this.event=x,this.d=new O.$kb}map(x){return new _(T(this.event,x,this.d))}forEach(x){return new _(M(this.event,x,this.d))}filter(x){return new _(F(this.event,x,this.d))}reduce(x,se){return new _(J(this.event,x,se,this.d))}latch(){return new _(W(this.event,void 0,this.d))}debounce(x,se=100,te=!1,ue=!1,de){return new _(G(this.event,x,se,te,ue,de,this.d))}on(x,se,te){return this.event(x,se,te)}once(x,se,te){return D(this.event)(x,se,te)}dispose(){this.d.dispose()}}function oe(fe){return new _(fe)}m.chain=oe;function ae(fe,x,se=te=>te){const te=(...Ee)=>we.fire(se(...Ee)),ue=()=>fe.on(x,te),de=()=>fe.removeListener(x,te),we=new b({onWillAddFirstListener:ue,onDidRemoveLastListener:de});return we.event}m.fromNodeEventEmitter=ae;function Y(fe,x,se=te=>te){const te=(...Ee)=>we.fire(se(...Ee)),ue=()=>fe.addEventListener(x,te),de=()=>fe.removeEventListener(x,te),we=new b({onWillAddFirstListener:ue,onDidRemoveLastListener:de});return we.event}m.fromDOMEventEmitter=Y;function U(fe){return new Promise(x=>D(fe)(x))}m.toPromise=U;function k(fe){const x=new b;return fe.then(se=>{x.fire(se)},()=>{x.fire(void 0)}).finally(()=>{x.dispose()}),x.event}m.fromPromise=k;function P(fe,x){return x(void 0),fe(se=>x(se))}m.runAndSubscribe=P;function z(fe,x){let se=null;function te(de){se?.dispose(),se=new O.$kb,x(de,se)}te(void 0);const ue=fe(de=>te(de));return(0,O.$jb)(()=>{ue.dispose(),se?.dispose()})}m.runAndSubscribeWithStore=z;class H{constructor(x,se){this._observable=x,this.d=0,this.f=!1;const te={onWillAddFirstListener:()=>{x.addObserver(this)},onDidRemoveLastListener:()=>{x.removeObserver(this)}};se||l(te),this.emitter=new b(te),se&&se.add(this.emitter)}beginUpdate(x){this.d++}handlePossibleChange(x){}handleChange(x,se){this.f=!0}endUpdate(x){this.d--,this.d===0&&(this._observable.reportChanges(),this.f&&(this.f=!1,this.emitter.fire(this._observable.get())))}}function ee(fe,x){return new H(fe,x).emitter.event}m.fromObservable=ee;function ne(fe){return x=>{let se=0,te=!1;const ue={beginUpdate(){se++},endUpdate(){se--,se===0&&(fe.reportChanges(),te&&(te=!1,x()))},handlePossibleChange(){},handleChange(){te=!0}};return fe.addObserver(ue),fe.reportChanges(),{dispose(){fe.removeObserver(ue)}}}}m.fromObservableLight=ne})(g||(e.Event=g={}));class C{static{this.all=new Set}static{this.d=0}constructor(l){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${l}_${C.d++}`,C.all.add(this)}start(l){this.f=new j.$ac,this.listenerCount=l}stop(){if(this.f){const l=this.f.elapsed();this.durations.push(l),this.elapsedOverall+=l,this.invocationCount+=1,this.f=void 0}}}e.$cc=C;let y=-1;function $(m){const l=y;return y=m,{dispose(){y=l}}}e.$dc=$;class u{constructor(l,E=Math.random().toString(18).slice(2,5)){this.threshold=l,this.name=E,this.f=0}dispose(){this.d?.clear()}check(l,E){const D=this.threshold;if(D<=0||E<D)return;this.d||(this.d=new Map);const T=this.d.get(l.value)||0;if(this.d.set(l.value,T+1),this.f-=1,this.f<=0){this.f=D*.5;let M,F=0;for(const[V,Z]of this.d)(!M||F<Z)&&(M=V,F=Z);console.warn(`[${this.name}] potential listener LEAK detected, having ${E} listeners already. MOST frequent listener (${F}):`),console.warn(M)}return()=>{const M=this.d.get(l.value)||0;this.d.set(l.value,M-1)}}}class d{static create(){return new d(new Error().stack??"")}constructor(l){this.value=l}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let p=0;class c{constructor(l){this.value=l,this.id=p++}}const h=2,f=(m,l)=>{if(m instanceof c)l(m);else for(let E=0;E<m.length;E++){const D=m[E];D&&l(D)}};class b{constructor(l){this.u=0,this.d=l,this.f=y>0||this.d?.leakWarningThreshold?new u(this.d?.leakWarningThreshold??y):void 0,this.g=this.d?._profName?new C(this.d._profName):void 0,this.t=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.t?.current===this&&this.t.reset(),this.q){if(R){const l=this.q;queueMicrotask(()=>{f(l,E=>E.stack?.print())})}this.q=void 0,this.u=0}this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.m??=(l,E,D)=>{if(this.f&&this.u>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),O.$lb.None;if(this.j)return O.$lb.None;E&&(l=l.bind(E));const T=new c(l);let M,F;this.f&&this.u>=Math.ceil(this.f.threshold*.2)&&(T.stack=d.create(),M=this.f.check(T.stack,this.u+1)),R&&(T.stack=F??d.create()),this.q?this.q instanceof c?(this.t??=new I,this.q=[this.q,T]):this.q.push(T):(this.d?.onWillAddFirstListener?.(this),this.q=T,this.d?.onDidAddFirstListener?.(this)),this.u++;const V=(0,O.$jb)(()=>{M?.(),this.v(T)});return D instanceof O.$kb?D.add(V):Array.isArray(D)&&D.push(V),V},this.m}v(l){if(this.d?.onWillRemoveListener?.(this),!this.q)return;if(this.u===1){this.q=void 0,this.d?.onDidRemoveLastListener?.(this),this.u=0;return}const E=this.q,D=E.indexOf(l);if(D===-1)throw console.log("disposed?",this.j),console.log("size?",this.u),console.log("arr?",JSON.stringify(this.q)),new Error("Attempted to dispose unknown listener");this.u--,E[D]=void 0;const T=this.t.current===this;if(this.u*h<=E.length){let M=0;for(let F=0;F<E.length;F++)E[F]?E[M++]=E[F]:T&&(this.t.end--,M<this.t.i&&this.t.i--);E.length=M}}w(l,E){if(!l)return;const D=this.d?.onListenerError||L.$Y;if(!D){l.value(E);return}try{l.value(E)}catch(T){D(T)}}x(l){const E=l.current.q;for(;l.i<l.end;)this.w(E[l.i++],l.value);l.reset()}fire(l){if(this.t?.current&&(this.x(this.t),this.g?.stop()),this.g?.start(this.u),this.q)if(this.q instanceof c)this.w(this.q,l);else{const E=this.t;E.enqueue(this,l,this.q.length),this.x(E)}this.g?.stop()}hasListeners(){return this.u>0}}e.$ec=b;const w=()=>new I;e.$fc=w;class I{constructor(){this.i=-1,this.end=0}enqueue(l,E,D){this.i=0,this.end=D,this.current=l,this.value=E}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends b{async fireAsync(l,E,D){if(this.q)for(this.h||(this.h=new A.$ub),f(this.q,T=>this.h.push([T.value,l]));this.h.size>0&&!E.isCancellationRequested;){const[T,M]=this.h.shift(),F=[],V={...M,token:E,waitUntil:Z=>{if(Object.isFrozen(F))throw new Error("waitUntil can NOT be called asynchronous");D&&(Z=D(Z,T)),F.push(Z)}};try{T(V)}catch(Z){(0,L.$Y)(Z);continue}Object.freeze(F),await Promise.allSettled(F).then(Z=>{for(const J of Z)J.status==="rejected"&&(0,L.$Y)(J.reason)})}}}e.$gc=t;class o extends b{get isPaused(){return this.h!==0}constructor(l){super(l),this.h=0,this.s=new A.$ub,this.y=l?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.y){if(this.s.size>0){const l=Array.from(this.s);this.s.clear(),super.fire(this.y(l))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(l){this.u&&(this.h!==0?this.s.push(l):super.fire(l))}}e.$hc=o;class s extends o{constructor(l){super(l),this.k=l.delay??100}fire(l){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(l)}}e.$ic=s;class n extends b{constructor(l){super(l),this.h=[],this.k=l?.merge}fire(l){this.hasListeners()&&(this.h.push(l),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(E=>super.fire(E)),this.h=[]}))}}e.$jc=n;class i{constructor(){this.f=!1,this.g=[],this.d=new b({onWillAddFirstListener:()=>this.h(),onDidRemoveLastListener:()=>this.j()})}get event(){return this.d.event}add(l){const E={event:l,listener:null};this.g.push(E),this.f&&this.k(E);const D=()=>{this.f&&this.m(E);const T=this.g.indexOf(E);this.g.splice(T,1)};return(0,O.$jb)((0,N.$cb)(D))}h(){this.f=!0,this.g.forEach(l=>this.k(l))}j(){this.f=!1,this.g.forEach(l=>this.m(l))}k(l){l.listener=l.event(E=>this.d.fire(E))}m(l){l.listener&&l.listener.dispose(),l.listener=null}dispose(){this.d.dispose()}}e.$kc=i;class r{constructor(l,E,D,T){this.d=new O.$kb;const M=this.d.add(new i),F=this.d.add(new O.$tb);function V(Z){F.set(Z,M.add(T(Z)))}for(const Z of l)V(Z);this.d.add(E(Z=>{V(Z)})),this.d.add(D(Z=>{F.deleteAndDispose(Z)})),this.event=M.event}dispose(){this.d.dispose()}}e.$lc=r;class a{constructor(){this.d=[]}wrapEvent(l){return(E,D,T)=>l(M=>{const F=this.d[this.d.length-1];F?F.push(()=>E.call(D,M)):E.call(D,M)},void 0,T)}bufferEvents(l){const E=[];this.d.push(E);const D=l();return this.d.pop(),E.forEach(T=>T()),D}}e.$mc=a;class v{constructor(){this.d=!1,this.f=g.None,this.g=O.$lb.None,this.h=new b({onDidAddFirstListener:()=>{this.d=!0,this.g=this.f(this.h.fire,this.h)},onDidRemoveLastListener:()=>{this.d=!1,this.g.dispose()}}),this.event=this.h.event}set input(l){this.f=l,this.d&&(this.g.dispose(),this.g=l(this.h.fire,this.h))}dispose(){this.g.dispose(),this.h.dispose()}}e.$nc=v}),define(ce[25],le([0,1,3]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oc=e.CancellationToken=void 0;const N=Object.freeze(function(R,S){const g=setTimeout(R.bind(S),0);return{dispose(){clearTimeout(g)}}});var O;(function(R){function S(g){return g===R.None||g===R.Cancelled||g instanceof A?!0:!g||typeof g!="object"?!1:typeof g.isCancellationRequested=="boolean"&&typeof g.onCancellationRequested=="function"}R.isCancellationToken=S,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:L.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:N})})(O||(e.CancellationToken=O={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?N:(this.b||(this.b=new L.$ec),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class j{constructor(S){this.a=void 0,this.b=void 0,this.b=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new A),this.a}cancel(){this.a?this.a instanceof A&&this.a.cancel():this.a=O.Cancelled}dispose(S=!1){S&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof A&&this.a.dispose():this.a=O.None}}e.$oc=j}),define(ce[127],le([0,1,25]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$id=e.$hd=e.$gd=void 0;class N{constructor(R){this.b=R,this.a=null}get(){if(this.a)return this.a;const R=new L.$oc,S=this.b(R.token);return this.a={promise:S,dispose:()=>{this.a=null,R.cancel(),R.dispose()}},this.a}}e.$gd=N;class O{constructor(R){this.c=R,this.a=void 0,this.b=void 0}get(R){const S=JSON.stringify(R);return this.b!==S&&(this.b=S,this.a=this.c(R)),this.a}}e.$hd=O;class A{get cachedValues(){return this.a}constructor(R){this.b=R,this.a=new Map}get(R){if(this.a.has(R))return this.a.get(R);const S=this.b(R);return this.a.set(R,S),S}}e.$id=A}),define(ce[42],le([0,1,8,2]),function(ie,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dc=e.$Cc=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=e.$wc=e.$vc=e.$uc=e.$tc=e.$sc=e.$rc=e.$qc=e.$pc=void 0;function O(w){const I=w;return I?typeof I.read=="function":!1}e.$pc=O;function A(w){const I=w;return I?[I.on,I.pause,I.resume,I.destroy].every(t=>typeof t=="function"):!1}e.$qc=A;function j(w){const I=w;return I?A(I.stream)&&Array.isArray(I.buffer)&&typeof I.ended=="boolean":!1}e.$rc=j;function R(w,I){return new S(w,I)}e.$sc=R;class S{constructor(I,t){this.e=I,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(I){if(!this.a.destroyed){if(this.a.flowing)this.g(I);else if(this.b.data.push(I),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(I){this.a.destroyed||(this.a.flowing?this.h(I):this.b.error.push(I))}end(I){this.a.destroyed||(typeof I<"u"&&this.write(I),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(I){this.c.data.slice(0).forEach(t=>t(I))}h(I){this.c.error.length===0?(0,L.$Y)(I):this.c.error.slice(0).forEach(t=>t(I))}i(){this.c.end.slice(0).forEach(I=>I())}on(I,t){if(!this.a.destroyed)switch(I){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(I,t){if(this.a.destroyed)return;let o;switch(I){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const s=o.indexOf(t);s>=0&&o.splice(s,1)}}j(){if(this.b.data.length>0){const I=this.e(this.b.data);this.g(I),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const I of this.b.error)this.h(I);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function g(w,I){const t=[];let o;for(;(o=w.read())!==null;)t.push(o);return I(t)}e.$tc=g;function C(w,I,t){const o=[];let s;for(;(s=w.read())!==null&&o.length<t;)o.push(s);return s===null&&o.length>0?I(o):{read:()=>{if(o.length>0)return o.shift();if(typeof s<"u"){const n=s;return s=void 0,n}return w.read()}}}e.$uc=C;function y(w,I){return new Promise((t,o)=>{const s=[];$(w,{onData:n=>{I&&s.push(n)},onError:n=>{I?o(n):t(void 0)},onEnd:()=>{t(I?I(s):void 0)}})})}e.$vc=y;function $(w,I,t){w.on("error",o=>{t?.isCancellationRequested||I.onError(o)}),w.on("end",()=>{t?.isCancellationRequested||I.onEnd()}),w.on("data",o=>{t?.isCancellationRequested||I.onData(o)})}e.$wc=$;function u(w,I){return new Promise((t,o)=>{const s=new N.$kb,n=[],i=v=>{if(n.push(v),n.length>I)return s.dispose(),w.pause(),t({stream:w,buffer:n,ended:!1})},r=v=>o(v),a=()=>t({stream:w,buffer:n,ended:!0});s.add((0,N.$jb)(()=>w.removeListener("error",r))),w.on("error",r),s.add((0,N.$jb)(()=>w.removeListener("end",a))),w.on("end",a),s.add((0,N.$jb)(()=>w.removeListener("data",i))),w.on("data",i)})}e.$xc=u;function d(w,I){const t=R(I);return t.end(w),t}e.$yc=d;function p(){const w=R(()=>{throw new Error("not supported")});return w.end(),w}e.$zc=p;function c(w){let I=!1;return{read:()=>I?null:(I=!0,w)}}e.$Ac=c;function h(w,I,t){const o=R(t);return $(w,{onData:s=>o.write(I.data(s)),onError:s=>o.error(I.error?I.error(s):s),onEnd:()=>o.end()}),o}e.$Bc=h;function f(w,I,t){let o=!1;return{read:()=>{const s=I.read();return o?s:(o=!0,s!==null?t([w,s]):w)}}}e.$Cc=f;function b(w,I,t){let o=!1;const s=R(t);return $(I,{onData:n=>o?s.write(n):(o=!0,s.write(t([w,n]))),onError:n=>s.error(n),onEnd:()=>{o||(o=!0,s.write(w)),s.end()}}),s}e.$Dc=b}),define(ce[14],le([0,1,86,42]),function(ie,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=e.$Fc=e.$Ec=void 0;const O=typeof Buffer<"u",A=new L.$T(()=>new Uint8Array(256));let j,R;class S{static alloc(E){return O?new S(Buffer.allocUnsafe(E)):new S(new Uint8Array(E))}static wrap(E){return O&&!Buffer.isBuffer(E)&&(E=Buffer.from(E.buffer,E.byteOffset,E.byteLength)),new S(E)}static fromString(E,D){return!(D?.dontUseNodeBuffer||!1)&&O?new S(Buffer.from(E)):(j||(j=new TextEncoder),new S(j.encode(E)))}static fromByteArray(E){const D=S.alloc(E.length);for(let T=0,M=E.length;T<M;T++)D.buffer[T]=E[T];return D}static concat(E,D){if(typeof D>"u"){D=0;for(let F=0,V=E.length;F<V;F++)D+=E[F].byteLength}const T=S.alloc(D);let M=0;for(let F=0,V=E.length;F<V;F++){const Z=E[F];T.set(Z,M),M+=Z.byteLength}return T}constructor(E){this.buffer=E,this.byteLength=this.buffer.byteLength}clone(){const E=S.alloc(this.byteLength);return E.set(this),E}toString(){return O?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(E,D){return new S(this.buffer.subarray(E,D))}set(E,D){if(E instanceof S)this.buffer.set(E.buffer,D);else if(E instanceof Uint8Array)this.buffer.set(E,D);else if(E instanceof ArrayBuffer)this.buffer.set(new Uint8Array(E),D);else if(ArrayBuffer.isView(E))this.buffer.set(new Uint8Array(E.buffer,E.byteOffset,E.byteLength),D);else throw new Error("Unknown argument 'array'")}readUInt32BE(E){return $(this.buffer,E)}writeUInt32BE(E,D){u(this.buffer,E,D)}readUInt32LE(E){return d(this.buffer,E)}writeUInt32LE(E,D){p(this.buffer,E,D)}readUInt8(E){return c(this.buffer,E)}writeUInt8(E,D){h(this.buffer,E,D)}indexOf(E,D=0){return g(this.buffer,E instanceof S?E.buffer:E,D)}}e.$Ec=S;function g(l,E,D=0){const T=E.byteLength,M=l.byteLength;if(T===0)return 0;if(T===1)return l.indexOf(E[0]);if(T>M-D)return-1;const F=A.value;F.fill(E.length);for(let Q=0;Q<E.length;Q++)F[E[Q]]=E.length-Q-1;let V=D+E.length-1,Z=V,J=-1;for(;V<M;)if(l[V]===E[Z]){if(Z===0){J=V;break}V--,Z--}else V+=Math.max(E.length-Z,F[l[V]]),Z=E.length-1;return J}e.$Fc=g;function C(l,E){return l[E+0]<<0>>>0|l[E+1]<<8>>>0}e.$Gc=C;function y(l,E,D){l[D+0]=E&255,E=E>>>8,l[D+1]=E&255}e.$Hc=y;function $(l,E){return l[E]*2**24+l[E+1]*2**16+l[E+2]*2**8+l[E+3]}e.$Ic=$;function u(l,E,D){l[D+3]=E,E=E>>>8,l[D+2]=E,E=E>>>8,l[D+1]=E,E=E>>>8,l[D]=E}e.$Jc=u;function d(l,E){return l[E+0]<<0>>>0|l[E+1]<<8>>>0|l[E+2]<<16>>>0|l[E+3]<<24>>>0}e.$Kc=d;function p(l,E,D){l[D+0]=E&255,E=E>>>8,l[D+1]=E&255,E=E>>>8,l[D+2]=E&255,E=E>>>8,l[D+3]=E&255}e.$Lc=p;function c(l,E){return l[E]}e.$Mc=c;function h(l,E,D){l[D]=E}e.$Nc=h;function f(l){return N.$tc(l,E=>S.concat(E))}e.$Oc=f;function b(l){return N.$Ac(l)}e.$Pc=b;function w(l){return N.$vc(l,E=>S.concat(E))}e.$Qc=w;async function I(l){return l.ended?S.concat(l.buffer):S.concat([...l.buffer,await w(l.stream)])}e.$Rc=I;function t(l){return N.$yc(l,E=>S.concat(E))}e.$Sc=t;function o(l){return N.$Bc(l,{data:E=>typeof E=="string"?S.fromString(E):S.wrap(E)},E=>S.concat(E))}e.$Tc=o;function s(l){return N.$sc(E=>S.concat(E),l)}e.$Uc=s;function n(l,E){return N.$Cc(l,E,D=>S.concat(D))}e.$Vc=n;function i(l,E){return N.$Dc(l,E,D=>S.concat(D))}e.$Wc=i;function r(l){let E=0,D=0,T=0;const M=new Uint8Array(Math.floor(l.length/4*3)),F=Z=>{switch(D){case 3:M[T++]=E|Z,D=0;break;case 2:M[T++]=E|Z>>>2,E=Z<<6,D=3;break;case 1:M[T++]=E|Z>>>4,E=Z<<4,D=2;break;default:E=Z<<2,D=1}};for(let Z=0;Z<l.length;Z++){const J=l.charCodeAt(Z);if(J>=65&&J<=90)F(J-65);else if(J>=97&&J<=122)F(J-97+26);else if(J>=48&&J<=57)F(J-48+52);else if(J===43||J===45)F(62);else if(J===47||J===95)F(63);else{if(J===61)break;throw new SyntaxError(`Unexpected base64 character ${l[Z]}`)}}const V=T;for(;D>0;)F(0);return S.wrap(M).slice(0,V)}e.$Xc=r;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function m({buffer:l},E=!0,D=!1){const T=D?v:a;let M="";const F=l.byteLength%3;let V=0;for(;V<l.byteLength-F;V+=3){const Z=l[V+0],J=l[V+1],Q=l[V+2];M+=T[Z>>>2],M+=T[(Z<<4|J>>>4)&63],M+=T[(J<<2|Q>>>6)&63],M+=T[Q&63]}if(F===1){const Z=l[V+0];M+=T[Z>>>2],M+=T[Z<<4&63],E&&(M+="==")}else if(F===2){const Z=l[V+0],J=l[V+1];M+=T[Z>>>2],M+=T[(Z<<4|J>>>4)&63],M+=T[J<<2&63],E&&(M+="=")}return M}e.$Yc=m}),define(ce[28],le([0,1,127,86]),function(ie,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$he=e.$ge=e.$fe=e.$ee=e.GraphemeBreakType=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.$Kd=e.$Jd=e.$Id=e.$Hd=e.$Gd=e.$Fd=e.$Ed=e.$Dd=e.$Cd=e.$Bd=e.$Ad=e.$zd=e.$yd=e.$xd=e.$wd=e.$vd=e.$ud=e.$td=e.$sd=e.$rd=e.$qd=e.$pd=e.$od=e.$nd=e.$md=e.$ld=void 0;function O(re){return!re||typeof re!="string"?!0:re.trim().length===0}e.$ld=O;const A=/{(\d+)}/g;function j(re,...$e){return $e.length===0?re:re.replace(A,function(me,pe){const ke=parseInt(pe,10);return isNaN(ke)||ke<0||ke>=$e.length?me:$e[ke]})}e.$md=j;const R=/{([^}]+)}/g;function S(re,$e){return re.replace(R,(me,pe)=>$e[pe]??me)}e.$nd=S;function g(re){return re.replace(/[<>&]/g,function($e){switch($e){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return $e}})}e.$od=g;function C(re){return re.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$pd=C;function y(re,$e){let me=0;const pe=$e.charCodeAt(0);for(let ke=re.length-1;ke>=0;ke--)re.charCodeAt(ke)===pe&&me++;return me}e.$qd=y;function $(re,$e,me="\u2026"){return re.length<=$e?re:`${re.substr(0,$e)}${me}`}e.$rd=$;function u(re,$e=" "){const me=d(re,$e);return p(me,$e)}e.$sd=u;function d(re,$e){if(!re||!$e)return re;const me=$e.length;if(me===0||re.length===0)return re;let pe=0;for(;re.indexOf($e,pe)===pe;)pe=pe+me;return re.substring(pe)}e.$td=d;function p(re,$e){if(!re||!$e)return re;const me=$e.length,pe=re.length;if(me===0||pe===0)return re;let ke=pe,Re=-1;for(;Re=re.lastIndexOf($e,ke-1),!(Re===-1||Re+me!==ke);){if(Re===0)return"";ke=Re}return re.substring(0,ke)}e.$ud=p;function c(re){return re.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$vd=c;function h(re){return re.replace(/\*/g,"")}e.$wd=h;function f(re,$e,me={}){if(!re)throw new Error("Cannot create regex from empty string");$e||(re=C(re)),me.wholeWord&&(/\B/.test(re.charAt(0))||(re="\\b"+re),/\B/.test(re.charAt(re.length-1))||(re=re+"\\b"));let pe="";return me.global&&(pe+="g"),me.matchCase||(pe+="i"),me.multiline&&(pe+="m"),me.unicode&&(pe+="u"),new RegExp(re,pe)}e.$xd=f;function b(re){return re.source==="^"||re.source==="^$"||re.source==="$"||re.source==="^\\s*$"?!1:!!(re.exec("")&&re.lastIndex===0)}e.$yd=b;function w(re){return re.split(/\r\n|\r|\n/)}e.$zd=w;function I(re){for(let $e=0,me=re.length;$e<me;$e++){const pe=re.charCodeAt($e);if(pe!==32&&pe!==9)return $e}return-1}e.$Ad=I;function t(re,$e=0,me=re.length){for(let pe=$e;pe<me;pe++){const ke=re.charCodeAt(pe);if(ke!==32&&ke!==9)return re.substring($e,pe)}return re.substring($e,me)}e.$Bd=t;function o(re,$e=re.length-1){for(let me=$e;me>=0;me--){const pe=re.charCodeAt(me);if(pe!==32&&pe!==9)return me}return-1}e.$Cd=o;function s(re,$e,me){const pe=[];let ke=0;for(const Re of re.matchAll($e)){if(pe.push(re.slice(ke,Re.index)),Re.index===void 0)throw new Error("match.index should be defined");ke=Re.index+Re[0].length,pe.push(me(Re[0],...Re.slice(1),Re.index,re,Re.groups))}return pe.push(re.slice(ke)),Promise.all(pe).then(Re=>Re.join(""))}e.$Dd=s;function n(re,$e){return re<$e?-1:re>$e?1:0}e.$Ed=n;function i(re,$e,me=0,pe=re.length,ke=0,Re=$e.length){for(;me<pe&&ke<Re;me++,ke++){const Ae=re.charCodeAt(me),De=$e.charCodeAt(ke);if(Ae<De)return-1;if(Ae>De)return 1}const Ce=pe-me,Ie=Re-ke;return Ce<Ie?-1:Ce>Ie?1:0}e.$Fd=i;function r(re,$e){return a(re,$e,0,re.length,0,$e.length)}e.$Gd=r;function a(re,$e,me=0,pe=re.length,ke=0,Re=$e.length){for(;me<pe&&ke<Re;me++,ke++){let Ae=re.charCodeAt(me),De=$e.charCodeAt(ke);if(Ae===De)continue;if(Ae>=128||De>=128)return i(re.toLowerCase(),$e.toLowerCase(),me,pe,ke,Re);m(Ae)&&(Ae-=32),m(De)&&(De-=32);const Ne=Ae-De;if(Ne!==0)return Ne}const Ce=pe-me,Ie=Re-ke;return Ce<Ie?-1:Ce>Ie?1:0}e.$Hd=a;function v(re){return re>=48&&re<=57}e.$Id=v;function m(re){return re>=97&&re<=122}e.$Jd=m;function l(re){return re>=65&&re<=90}e.$Kd=l;function E(re,$e){return re.length===$e.length&&a(re,$e)===0}e.$Ld=E;function D(re,$e){const me=$e.length;return $e.length>re.length?!1:a(re,$e,0,me)===0}e.$Md=D;function T(re,$e){const me=Math.min(re.length,$e.length);let pe;for(pe=0;pe<me;pe++)if(re.charCodeAt(pe)!==$e.charCodeAt(pe))return pe;return me}e.$Nd=T;function M(re,$e){const me=Math.min(re.length,$e.length);let pe;const ke=re.length-1,Re=$e.length-1;for(pe=0;pe<me;pe++)if(re.charCodeAt(ke-pe)!==$e.charCodeAt(Re-pe))return pe;return me}e.$Od=M;function F(re){return 55296<=re&&re<=56319}e.$Pd=F;function V(re){return 56320<=re&&re<=57343}e.$Qd=V;function Z(re,$e){return(re-55296<<10)+($e-56320)+65536}e.$Rd=Z;function J(re,$e,me){const pe=re.charCodeAt(me);if(F(pe)&&me+1<$e){const ke=re.charCodeAt(me+1);if(V(ke))return Z(pe,ke)}return pe}e.$Sd=J;function Q(re,$e){const me=re.charCodeAt($e-1);if(V(me)&&$e>1){const pe=re.charCodeAt($e-2);if(F(pe))return Z(pe,me)}return me}class G{get offset(){return this.e}constructor($e,me=0){this.c=$e,this.d=$e.length,this.e=me}setOffset($e){this.e=$e}prevCodePoint(){const $e=Q(this.c,this.e);return this.e-=$e>=65536?2:1,$e}nextCodePoint(){const $e=J(this.c,this.d,this.e);return this.e+=$e>=65536?2:1,$e}eol(){return this.e>=this.d}}e.$Td=G;class X{get offset(){return this.c.offset}constructor($e,me=0){this.c=new G($e,me)}nextGraphemeLength(){const $e=ge.getInstance(),me=this.c,pe=me.offset;let ke=$e.getGraphemeBreakType(me.nextCodePoint());for(;!me.eol();){const Re=me.offset,Ce=$e.getGraphemeBreakType(me.nextCodePoint());if(Me(ke,Ce)){me.setOffset(Re);break}ke=Ce}return me.offset-pe}prevGraphemeLength(){const $e=ge.getInstance(),me=this.c,pe=me.offset;let ke=$e.getGraphemeBreakType(me.prevCodePoint());for(;me.offset>0;){const Re=me.offset,Ce=$e.getGraphemeBreakType(me.prevCodePoint());if(Me(Ce,ke)){me.setOffset(Re);break}ke=Ce}return pe-me.offset}eol(){return this.c.eol()}}e.$Ud=X;function W(re,$e){return new X(re,$e).nextGraphemeLength()}e.$Vd=W;function q(re,$e){return new X(re,$e).prevGraphemeLength()}e.$Wd=q;function B(re,$e){$e>0&&V(re.charCodeAt($e))&&$e--;const me=$e+W(re,$e);return[me-q(re,me),me]}e.$Xd=B;function _(re){const $e=new X(re);let me=0;for(;!$e.eol();)me++,$e.nextGraphemeLength();return me}e.$Yd=_;let oe;function ae(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Y(re){return oe||(oe=ae()),oe.test(re)}e.$Zd=Y;const U=/^[\t\n\r\x20-\x7E]*$/;function k(re){return U.test(re)}e.$1d=k,e.$2d=/[\u2028\u2029]/;function P(re){return e.$2d.test(re)}e.$3d=P;function z(re){return re>=11904&&re<=55215||re>=63744&&re<=64255||re>=65281&&re<=65374}e.$4d=z;function H(re){return re>=127462&&re<=127487||re===8986||re===8987||re===9200||re===9203||re>=9728&&re<=10175||re===11088||re===11093||re>=127744&&re<=128591||re>=128640&&re<=128764||re>=128992&&re<=129008||re>=129280&&re<=129535||re>=129648&&re<=129782}e.$5d=H;function ee(re,$e){if(re.length<$e)return re;const me=/\b/g;let pe=0;for(;me.test(re)&&!(re.length-me.lastIndex<$e);)pe=me.lastIndex,me.lastIndex+=1;return re.substring(pe).replace(/^\s/,"")}e.$6d=ee;const ne=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,fe=/\x1b\].*?\x07/g;function x(re){return re&&(re=re.replace(ne,"").replace(fe,"")),re}e.$7d=x,e.$8d=String.fromCharCode(65279);function se(re){return!!(re&&re.length>0&&re.charCodeAt(0)===65279)}e.$9d=se;function te(re){return se(re)?re.substr(1):re}e.$0d=te;function ue(re,$e){if(!re||!$e||re.length<$e.length)return!1;const me=$e.length,pe=re.toLowerCase();let ke=0,Re=-1;for(;ke<me;){const Ce=pe.indexOf($e[ke],Re+1);if(Ce<0)return!1;Re=Ce,ke++}return!0}e.$$d=ue;function de(re,$e=!1){return re?($e&&(re=re.replace(/\\./g,"")),re.toLowerCase()!==re):!1}e.$_d=de;function we(re){return re.charAt(0).toUpperCase()+re.slice(1)}e.$ae=we;function Ee(re,$e=1){if($e===0)return"";let me=-1;do me=re.indexOf(`
`,me+1),$e--;while($e>0&&me>=0);return me===-1?re:(re[me-1]==="\r"&&me--,re.substr(0,me))}e.$be=Ee;function Le(re){return re=re%(2*26),re<26?String.fromCharCode(97+re):String.fromCharCode(65+re-26)}e.$ce=Le;function je(re){return ge.getInstance().getGraphemeBreakType(re)}e.$de=je;function Me(re,$e){return re===0?$e!==5&&$e!==7:re===2&&$e===3?!1:re===4||re===2||re===3||$e===4||$e===2||$e===3?!0:!(re===8&&($e===8||$e===9||$e===11||$e===12)||(re===11||re===9)&&($e===9||$e===10)||(re===12||re===10)&&$e===10||$e===5||$e===13||$e===7||re===1||re===13&&$e===14||re===6&&$e===6)}var he;(function(re){re[re.Other=0]="Other",re[re.Prepend=1]="Prepend",re[re.CR=2]="CR",re[re.LF=3]="LF",re[re.Control=4]="Control",re[re.Extend=5]="Extend",re[re.Regional_Indicator=6]="Regional_Indicator",re[re.SpacingMark=7]="SpacingMark",re[re.L=8]="L",re[re.V=9]="V",re[re.T=10]="T",re[re.LV=11]="LV",re[re.LVT=12]="LVT",re[re.ZWJ=13]="ZWJ",re[re.Extended_Pictographic=14]="Extended_Pictographic"})(he||(e.GraphemeBreakType=he={}));class ge{static{this.c=null}static getInstance(){return ge.c||(ge.c=new ge),ge.c}constructor(){this.d=be()}getGraphemeBreakType($e){if($e<32)return $e===10?3:$e===13?2:4;if($e<127)return 0;const me=this.d,pe=me.length/3;let ke=1;for(;ke<=pe;)if($e<me[3*ke])ke=2*ke;else if($e>me[3*ke+1])ke=2*ke+1;else return me[3*ke+2];return 0}}function be(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Se(re,$e){if(re===0)return 0;const me=Pe(re,$e);if(me!==void 0)return me;const pe=new G($e,re);return pe.prevCodePoint(),pe.offset}e.$ee=Se;function Pe(re,$e){const me=new G($e,re);let pe=me.prevCodePoint();for(;Ue(pe)||pe===65039||pe===8419;){if(me.offset===0)return;pe=me.prevCodePoint()}if(!H(pe))return;let ke=me.offset;return ke>0&&me.prevCodePoint()===8205&&(ke=me.offset),ke}function Ue(re){return 127995<=re&&re<=127999}var Oe;(function(re){re[re.zwj=8205]="zwj",re[re.emojiVariantSelector=65039]="emojiVariantSelector",re[re.enclosingKeyCap=8419]="enclosingKeyCap"})(Oe||(Oe={})),e.$fe="\xA0";class Fe{static{this.c=new N.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new L.$hd($e=>{function me(Ne){const Be=new Map;for(let qe=0;qe<Ne.length;qe+=2)Be.set(Ne[qe],Ne[qe+1]);return Be}function pe(Ne,Be){const qe=new Map(Ne);for(const[Ve,xe]of Be)qe.set(Ve,xe);return qe}function ke(Ne,Be){if(!Ne)return Be;const qe=new Map;for(const[Ve,xe]of Ne)Be.has(Ve)&&qe.set(Ve,xe);return qe}const Re=this.c.value;let Ce=$e.filter(Ne=>!Ne.startsWith("_")&&Ne in Re);Ce.length===0&&(Ce=["_default"]);let Ie;for(const Ne of Ce){const Be=me(Re[Ne]);Ie=ke(Ie,Be)}const Ae=me(Re._common),De=pe(Ae,Ie);return new Fe(De)})}static getInstance($e){return Fe.d.get(Array.from($e))}static{this.e=new N.$T(()=>Object.keys(Fe.c.value).filter($e=>!$e.startsWith("_")))}static getLocales(){return Fe.e.value}constructor($e){this.f=$e}isAmbiguous($e){return this.f.has($e)}getPrimaryConfusable($e){return this.f.get($e)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$ge=Fe;class Te{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Te.c())),this.d}static isInvisibleCharacter($e){return Te.e().has($e)}static get codePoints(){return Te.e()}}e.$he=Te}),define(ce[51],le([0,1,28]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=void 0;function N(h){return O(h,0)}e.$di=N;function O(h,f){switch(typeof h){case"object":return h===null?A(349,f):Array.isArray(h)?S(h,f):g(h,f);case"string":return R(h,f);case"boolean":return j(h,f);case"number":return A(h,f);case"undefined":return A(937,f);default:return A(617,f)}}e.$ei=O;function A(h,f){return(f<<5)-f+h|0}e.$fi=A;function j(h,f){return A(h?433:863,f)}function R(h,f){f=A(149417,f);for(let b=0,w=h.length;b<w;b++)f=A(h.charCodeAt(b),f);return f}e.$gi=R;function S(h,f){return f=A(104579,f),h.reduce((b,w)=>O(w,b),f)}function g(h,f){return f=A(181387,f),Object.keys(h).sort().reduce((b,w)=>(b=R(w,b),O(h[w],b)),f)}class C{constructor(){this.g=0}get value(){return this.g}hash(f){return this.g=O(f,this.g),this.g}}e.$hi=C;var y;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(y||(y={}));function $(h,f,b=32){const w=b-f,I=~((1<<w)-1);return(h<<f|(I&h)>>>w)>>>0}function u(h,f=0,b=h.byteLength,w=0){for(let I=0;I<b;I++)h[f+I]=w}function d(h,f,b="0"){for(;h.length<f;)h=b+h;return h}function p(h,f=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(b=>b.toString(16).padStart(2,"0")).join(""):d((h>>>0).toString(16),f/4)}e.$ii=p;class c{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(f){const b=f.length;if(b===0)return;const w=this.p;let I=this.r,t=this.u,o,s;for(t!==0?(o=t,s=-1,t=0):(o=f.charCodeAt(0),s=0);;){let n=o;if(L.$Pd(o))if(s+1<b){const i=f.charCodeAt(s+1);L.$Qd(i)?(s++,n=L.$Rd(o,i)):n=65533}else{t=o;break}else L.$Qd(o)&&(n=65533);if(I=this.w(w,I,n),s++,s<b)o=f.charCodeAt(s);else break}this.r=I,this.u=t}w(f,b,w){return w<128?f[b++]=w:w<2048?(f[b++]=192|(w&1984)>>>6,f[b++]=128|(w&63)>>>0):w<65536?(f[b++]=224|(w&61440)>>>12,f[b++]=128|(w&4032)>>>6,f[b++]=128|(w&63)>>>0):(f[b++]=240|(w&1835008)>>>18,f[b++]=128|(w&258048)>>>12,f[b++]=128|(w&4032)>>>6,f[b++]=128|(w&63)>>>0),b>=64&&(this.y(),b-=64,this.t+=64,f[0]=f[64+0],f[1]=f[64+1],f[2]=f[64+2]),b}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),p(this.h)+p(this.l)+p(this.m)+p(this.n)+p(this.o)}x(){this.p[this.r++]=128,u(this.p,this.r),this.r>56&&(this.y(),u(this.p));const f=8*this.t;this.q.setUint32(56,Math.floor(f/4294967296),!1),this.q.setUint32(60,f%4294967296,!1),this.y()}y(){const f=c.g,b=this.q;for(let a=0;a<64;a+=4)f.setUint32(a,b.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)f.setUint32(a,$(f.getUint32(a-12,!1)^f.getUint32(a-32,!1)^f.getUint32(a-56,!1)^f.getUint32(a-64,!1),1),!1);let w=this.h,I=this.l,t=this.m,o=this.n,s=this.o,n,i,r;for(let a=0;a<80;a++)a<20?(n=I&t|~I&o,i=1518500249):a<40?(n=I^t^o,i=1859775393):a<60?(n=I&t|I&o|t&o,i=2400959708):(n=I^t^o,i=3395469782),r=$(w,5)+n+s+i+f.getUint32(a*4,!1)&4294967295,s=o,o=t,t=$(I,30),I=w,w=r;this.h=this.h+w&4294967295,this.l=this.l+I&4294967295,this.m=this.m+t&4294967295,this.n=this.n+o&4294967295,this.o=this.o+s&4294967295}}e.$ji=c}),define(ce[89],le([0,1,28]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var N;(function(O){O[O.Ignore=0]="Ignore",O[O.Info=1]="Info",O[O.Warning=2]="Warning",O[O.Error=3]="Error"})(N||(N={})),function(O){const A="error",j="warning",R="warn",S="info",g="ignore";function C($){return $?L.$Ld(A,$)?O.Error:L.$Ld(j,$)||L.$Ld(R,$)?O.Warning:L.$Ld(S,$)?O.Info:O.Ignore:O.Ignore}O.fromValue=C;function y($){switch($){case O.Error:return A;case O.Warning:return j;case O.Info:return S;default:return g}}O.toString=y}(N||(N={})),e.default=N}),define(ce[128],le([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bc=void 0,e.$bc=Symbol("MicrotaskDelay")}),define(ce[47],le([0,1,20,28]),function(ie,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vh=e.$uh=e.$th=e.$sh=e.$rh=void 0;class O{constructor(){this.b="",this.c=0}reset(u){return this.b=u,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(u){const d=u.charCodeAt(0),p=this.b.charCodeAt(this.c);return d-p}value(){return this.b[this.c]}}e.$rh=O;class A{constructor(u=!0){this.e=u}reset(u){return this.b=u,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let u=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(u)this.c++;else break;else u=!1;return this}cmp(u){return this.e?(0,N.$Fd)(u,this.b,0,u.length,this.c,this.d):(0,N.$Hd)(u,this.b,0,u.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$sh=A;class j{constructor(u=!0,d=!0){this.f=u,this.g=d}reset(u){this.d=0,this.e=0,this.b=u,this.c=u.length;for(let d=u.length-1;d>=0;d--,this.c--){const p=this.b.charCodeAt(d);if(!(p===47||this.f&&p===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let u=!0;for(;this.e<this.c;this.e++){const d=this.b.charCodeAt(this.e);if(d===47||this.f&&d===92)if(u)this.d++;else break;else u=!1}return this}cmp(u){return this.g?(0,N.$Fd)(u,this.b,0,u.length,this.d,this.e):(0,N.$Hd)(u,this.b,0,u.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$th=j;var R;(function($){$[$.Scheme=1]="Scheme",$[$.Authority=2]="Authority",$[$.Path=3]="Path",$[$.Query=4]="Query",$[$.Fragment=5]="Fragment"})(R||(R={}));class S{constructor(u,d){this.f=u,this.g=d,this.d=[],this.e=0}reset(u){return this.c=u,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new j(!1,!this.f(u)),this.b.reset(u.path),this.b.value()&&this.d.push(3)),this.g(u)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(u){if(this.d[this.e]===1)return(0,N.$Gd)(u,this.c.scheme);if(this.d[this.e]===2)return(0,N.$Gd)(u,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(u);if(this.d[this.e]===4)return(0,N.$Ed)(u,this.c.query);if(this.d[this.e]===5)return(0,N.$Ed)(u,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$uh=S;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const u=this.right;return this.right=u.left,u.left=this,this.updateHeight(),u.updateHeight(),u}rotateRight(){const u=this.left;return this.left=u.right,u.right=this,this.updateHeight(),u.updateHeight(),u}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var C;(function($){$[$.Left=-1]="Left",$[$.Mid=0]="Mid",$[$.Right=1]="Right"})(C||(C={}));class y{static forUris(u=()=>!1,d=()=>!1){return new y(new S(u,d))}static forPaths(u=!1){return new y(new j(void 0,!u))}static forStrings(){return new y(new O)}static forConfigKeys(){return new y(new A)}constructor(u){this.b=u}clear(){this.c=void 0}fill(u,d){if(d){const p=d.slice(0);(0,L.$Bf)(p);for(const c of p)this.set(c,u)}else{const p=u.slice(0);(0,L.$Bf)(p);for(const c of p)this.set(c[0],c[1])}}set(u,d){const p=this.b.reset(u);let c;this.c||(this.c=new g,this.c.segment=p.value());const h=[];for(c=this.c;;){const b=p.cmp(c.segment);if(b>0)c.left||(c.left=new g,c.left.segment=p.value()),h.push([-1,c]),c=c.left;else if(b<0)c.right||(c.right=new g,c.right.segment=p.value()),h.push([1,c]),c=c.right;else if(p.hasNext())p.next(),c.mid||(c.mid=new g,c.mid.segment=p.value()),h.push([0,c]),c=c.mid;else break}const f=c.value;c.value=d,c.key=u;for(let b=h.length-1;b>=0;b--){const w=h[b][1];w.updateHeight();const I=w.balanceFactor();if(I<-1||I>1){const t=h[b][0],o=h[b+1][0];if(t===1&&o===1)h[b][1]=w.rotateLeft();else if(t===-1&&o===-1)h[b][1]=w.rotateRight();else if(t===1&&o===-1)w.right=h[b+1][1]=h[b+1][1].rotateRight(),h[b][1]=w.rotateLeft();else if(t===-1&&o===1)w.left=h[b+1][1]=h[b+1][1].rotateLeft(),h[b][1]=w.rotateRight();else throw new Error;if(b>0)switch(h[b-1][0]){case-1:h[b-1][1].left=h[b][1];break;case 1:h[b-1][1].right=h[b][1];break;case 0:h[b-1][1].mid=h[b][1];break}else this.c=h[0][1]}}return f}get(u){return this.d(u)?.value}d(u){const d=this.b.reset(u);let p=this.c;for(;p;){const c=d.cmp(p.segment);if(c>0)p=p.left;else if(c<0)p=p.right;else if(d.hasNext())d.next(),p=p.mid;else break}return p}has(u){const d=this.d(u);return!(d?.value===void 0&&d?.mid===void 0)}delete(u){return this.e(u,!1)}deleteSuperstr(u){return this.e(u,!0)}e(u,d){const p=this.b.reset(u),c=[];let h=this.c;for(;h;){const f=p.cmp(h.segment);if(f>0)c.push([-1,h]),h=h.left;else if(f<0)c.push([1,h]),h=h.right;else if(p.hasNext())p.next(),c.push([0,h]),h=h.mid;else break}if(h){if(d?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const f=this.f(h.right);if(f.key){const{key:b,value:w,segment:I}=f;this.e(f.key,!1),h.key=b,h.value=w,h.segment=I}}else{const f=h.left??h.right;if(c.length>0){const[b,w]=c[c.length-1];switch(b){case-1:w.left=f;break;case 0:w.mid=f;break;case 1:w.right=f;break}}else this.c=f}for(let f=c.length-1;f>=0;f--){const b=c[f][1];b.updateHeight();const w=b.balanceFactor();if(w>1?(b.right.balanceFactor()>=0||(b.right=b.right.rotateRight()),c[f][1]=b.rotateLeft()):w<-1&&(b.left.balanceFactor()<=0||(b.left=b.left.rotateLeft()),c[f][1]=b.rotateRight()),f>0)switch(c[f-1][0]){case-1:c[f-1][1].left=c[f][1];break;case 1:c[f-1][1].right=c[f][1];break;case 0:c[f-1][1].mid=c[f][1];break}else this.c=c[0][1]}}}f(u){for(;u.left;)u=u.left;return u}findSubstr(u){const d=this.b.reset(u);let p=this.c,c;for(;p;){const h=d.cmp(p.segment);if(h>0)p=p.left;else if(h<0)p=p.right;else if(d.hasNext())d.next(),c=p.value||c,p=p.mid;else break}return p&&p.value||c}findSuperstr(u){return this.g(u,!1)}g(u,d){const p=this.b.reset(u);let c=this.c;for(;c;){const h=p.cmp(c.segment);if(h>0)c=c.left;else if(h<0)c=c.right;else if(p.hasNext())p.next(),c=c.mid;else return c.mid?this.h(c.mid):d?c.value:void 0}}hasElementOrSubtree(u){return this.g(u,!0)!==void 0}forEach(u){for(const[d,p]of this)u(p,d)}*[Symbol.iterator](){yield*this.h(this.c)}h(u){const d=[];return this.j(u,d),d[Symbol.iterator]()}j(u,d){u&&(u.left&&this.j(u.left,d),u.value&&d.push([u.key,u.value]),u.mid&&this.j(u.mid,d),u.right&&this.j(u.right,d))}_isBalanced(){const u=d=>{if(!d)return!0;const p=d.balanceFactor();return p<-1||p>1?!1:u(d.left)&&u(d.right)};return u(this.c)}}e.$vh=y}),define(ce[11],le([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=void 0;function L(I){return typeof I=="string"}e.$ie=L;function N(I){return Array.isArray(I)&&I.every(t=>L(t))}e.$je=N;function O(I){return typeof I=="object"&&I!==null&&!Array.isArray(I)&&!(I instanceof RegExp)&&!(I instanceof Date)}e.$ke=O;function A(I){const t=Object.getPrototypeOf(Uint8Array);return typeof I=="object"&&I instanceof t}e.$le=A;function j(I){return typeof I=="number"&&!isNaN(I)}e.$me=j;function R(I){return!!I&&typeof I[Symbol.iterator]=="function"}e.$ne=R;function S(I){return I===!0||I===!1}e.$oe=S;function g(I){return typeof I>"u"}e.$pe=g;function C(I){return!y(I)}e.$qe=C;function y(I){return g(I)||I===null}e.$re=y;function $(I,t){if(!I)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$se=$;function u(I){if(y(I))throw new Error("Assertion Failed: argument is undefined or null");return I}e.$te=u;function d(...I){const t=[];for(let o=0;o<I.length;o++){const s=I[o];if(y(s))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);t.push(s)}return t}e.$ue=d;const p=Object.prototype.hasOwnProperty;function c(I){if(!O(I))return!1;for(const t in I)if(p.call(I,t))return!1;return!0}e.$ve=c;function h(I){return typeof I=="function"}e.$we=h;function f(...I){return I.length>0&&I.every(h)}e.$xe=f;function b(I,t){const o=Math.min(I.length,t.length);for(let s=0;s<o;s++)w(I[s],t[s])}e.$ye=b;function w(I,t){if(L(t)){if(typeof I!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(h(t)){try{if(I instanceof t)return}catch{}if(!y(I)&&I.constructor===t||t.length===1&&t.call(void 0,I)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$ze=w}),define(ce[30],le([0,1,11]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tm=e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=e.$Km=e.$Jm=e.$Im=void 0;function N(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const f=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([b,w])=>{f[b]=w&&typeof w=="object"?N(w):w}),f}e.$Im=N;function O(h){if(!h||typeof h!="object")return h;const f=[h];for(;f.length>0;){const b=f.shift();Object.freeze(b);for(const w in b)if(A.call(b,w)){const I=b[w];typeof I=="object"&&!Object.isFrozen(I)&&!(0,L.$le)(I)&&f.push(I)}}return h}e.$Jm=O;const A=Object.prototype.hasOwnProperty;function j(h,f){return R(h,f,new Set)}e.$Km=j;function R(h,f,b){if((0,L.$re)(h))return h;const w=f(h);if(typeof w<"u")return w;if(Array.isArray(h)){const I=[];for(const t of h)I.push(R(t,f,b));return I}if((0,L.$ke)(h)){if(b.has(h))throw new Error("Cannot clone recursive data-structure");b.add(h);const I={};for(const t in h)A.call(h,t)&&(I[t]=R(h[t],f,b));return b.delete(h),I}return h}function S(h,f,b=!0){return(0,L.$ke)(h)?((0,L.$ke)(f)&&Object.keys(f).forEach(w=>{w in h?b&&((0,L.$ke)(h[w])&&(0,L.$ke)(f[w])?S(h[w],f[w],b):h[w]=f[w]):h[w]=f[w]}),h):f}e.$Lm=S;function g(h,f){if(h===f)return!0;if(h==null||f===null||f===void 0||typeof h!=typeof f||typeof h!="object"||Array.isArray(h)!==Array.isArray(f))return!1;let b,w;if(Array.isArray(h)){if(h.length!==f.length)return!1;for(b=0;b<h.length;b++)if(!g(h[b],f[b]))return!1}else{const I=[];for(w in h)I.push(w);I.sort();const t=[];for(w in f)t.push(w);if(t.sort(),!g(I,t))return!1;for(b=0;b<I.length;b++)if(!g(h[I[b]],f[I[b]]))return!1}return!0}e.$Mm=g;function C(h){const f=new Set;return JSON.stringify(h,(b,w)=>{if((0,L.$ke)(w)||Array.isArray(w)){if(f.has(w))return"[Circular]";f.add(w)}return w})}e.$Nm=C;function y(h,f){const b=Object.create(null);return!h||!f||Object.keys(f).forEach(I=>{const t=h[I],o=f[I];g(t,o)||(b[I]=o)}),b}e.$Om=y;function $(h,f){const b=f.toLowerCase(),w=Object.keys(h).find(I=>I.toLowerCase()===b);return w?h[w]:h[f]}e.$Pm=$;function u(h,f){const b=Object.create(null);for(const[w,I]of Object.entries(h))f(w,I)&&(b[w]=I);return b}e.$Qm=u;function d(h){let f=[];for(;Object.prototype!==h;)f=f.concat(Object.getOwnPropertyNames(h)),h=Object.getPrototypeOf(h);return f}e.$Rm=d;function p(h){const f=[];for(const b of d(h))typeof h[b]=="function"&&f.push(b);return f}e.$Sm=p;function c(h,f){const b=I=>function(){const t=Array.prototype.slice.call(arguments,0);return f(I,t)},w={};for(const I of h)w[I]=b(I);return w}e.$Tm=c}),define(ce[32],le([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3e=e.$2e=void 0;const L=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function N(O){return L.test(O)}e.$2e=N,e.$3e=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let O;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?O=crypto.getRandomValues.bind(crypto):O=function(R){for(let S=0;S<R.length;S++)R[S]=Math.floor(Math.random()*256);return R};const A=new Uint8Array(16),j=[];for(let R=0;R<256;R++)j.push(R.toString(16).padStart(2,"0"));return function(){O(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let S=0,g="";return g+=j[A[S++]],g+=j[A[S++]],g+=j[A[S++]],g+=j[A[S++]],g+="-",g+=j[A[S++]],g+=j[A[S++]],g+="-",g+=j[A[S++]],g+=j[A[S++]],g+="-",g+=j[A[S++]],g+=j[A[S++]],g+="-",g+=j[A[S++]],g+=j[A[S++]],g+=j[A[S++]],g+=j[A[S++]],g+=j[A[S++]],g+=j[A[S++]],g}}()}),define(ce[129],le([0,1,36]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tm=void 0;const N=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function O(j){const R=j.replace(/\-/g,":").toLowerCase();return!N.has(R)}function A(){const j=(0,L.networkInterfaces)();for(const R in j){const S=j[R];if(S){for(const{mac:g}of S)if(O(g))return g}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$tm=A}),define(ce[130],le([0,1,36,47,32,129]),function(ie,e,L,N,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vm=e.$um=void 0,e.$um=new class{c(g){return this.a||(this.a=N.$vh.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(g)}value(){if(this.b===void 0){let g=0,C=0;const y=(0,L.networkInterfaces)();for(const $ in y){const u=y[$];if(u)for(const{mac:d,internal:p}of u)p||(C+=1,this.c(d.toUpperCase())&&(g+=1))}this.b=C>0?g/C:0}return this.b}};let j;async function R(g){return j||(j=(async()=>await S(g)||O.$3e())()),j}e.$vm=R;async function S(g){try{const C=await new Promise(($,u)=>{ie(["crypto"],$,u)}),y=(0,A.$tm)();return C.createHash("sha256").update(y,"utf8").digest("hex")}catch(C){g(C);return}}}),define(ce[131],le([0,1,266,14]),function(ie,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sS=void 0;class O extends L.Transform{constructor(j){if(super(),typeof j=="number")this.b=j,this.c=1;else{const R=Buffer.isBuffer(j)?j:Buffer.from(j);this.b=R.length===1?R[0]:R,this.c=R.length}}_transform(j,R,S){this.a?this.a=Buffer.concat([this.a,j]):this.a=j;let g=0;for(;g<this.a.length;){const C=typeof this.b=="number"?this.a.indexOf(this.b,g):(0,N.$Fc)(this.a,this.b,g);if(C===-1)break;this.push(this.a.slice(g,C+this.c)),g=C+this.c}this.a=g===this.a.length?void 0:this.a.slice(g),S()}_flush(j){this.a&&this.push(this.a),j()}}e.$sS=O}),define(ce[132],le([0,1,61]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7e=e.$6e=e.$5e=void 0;function N(R,S,g,C=1){let y=!1;return new Promise($=>{const u=setTimeout(()=>{if(!y)return y=!0,$(0)},g);O(R,S,C,d=>{if(!y)return y=!0,clearTimeout(u),$(d)})})}e.$5e=N;function O(R,S,g,C){if(S===0)return C(0);const y=new L.Socket;y.once("connect",()=>(j(y),O(R+g,S-1,g,C))),y.once("data",()=>{}),y.once("error",$=>(j(y),$.code!=="ECONNREFUSED"?O(R+g,S-1,g,C):C(R))),y.connect(R,"127.0.0.1")}e.$6e={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(R,S,g,C="127.0.0.1"){let y=!1,$,u=1;const d=L.createServer({pauseOnConnect:!0});function p(c,h){y||(y=!0,d.removeAllListeners(),d.close(),$&&clearTimeout($),h(c))}return new Promise(c=>{$=setTimeout(()=>{p(0,c)},g),d.on("listening",()=>{p(R,c)}),d.on("error",h=>{h&&(h.code==="EADDRINUSE"||h.code==="EACCES")&&u<S?(R++,u++,d.listen(R,C)):p(0,c)}),d.on("close",()=>{p(0,c)}),d.listen(R,C)})}e.$7e=A;function j(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(S){console.error(S)}}}),define(ce[133],le([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IS=void 0;function L(N){return!!N.parentPort}e.$IS=L}),define(ce[134],le([12,9]),function(ie,e){return ie.create("vs/base/common/date",e)}),define(ce[62],le([0,1,134]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=e.$Sl=void 0;const N=60,O=N*60,A=O*24,j=A*7,R=A*30,S=A*365;function g(y,$,u,d){typeof y!="number"&&(y=y.getTime());const p=Math.round((new Date().getTime()-y)/1e3);if(p<-30)return(0,L.localize)(0,null,g(new Date().getTime()+p*1e3,!1));if(!d&&p<30)return(0,L.localize)(1,null);let c;return p<N?(c=p,$?c===1?u?(0,L.localize)(2,null,c):(0,L.localize)(3,null,c):u?(0,L.localize)(4,null,c):(0,L.localize)(5,null,c):c===1?u?(0,L.localize)(6,null,c):(0,L.localize)(7,null,c):u?(0,L.localize)(8,null,c):(0,L.localize)(9,null,c)):p<O?(c=Math.floor(p/N),$?c===1?u?(0,L.localize)(10,null,c):(0,L.localize)(11,null,c):u?(0,L.localize)(12,null,c):(0,L.localize)(13,null,c):c===1?u?(0,L.localize)(14,null,c):(0,L.localize)(15,null,c):u?(0,L.localize)(16,null,c):(0,L.localize)(17,null,c)):p<A?(c=Math.floor(p/O),$?c===1?u?(0,L.localize)(18,null,c):(0,L.localize)(19,null,c):u?(0,L.localize)(20,null,c):(0,L.localize)(21,null,c):c===1?u?(0,L.localize)(22,null,c):(0,L.localize)(23,null,c):u?(0,L.localize)(24,null,c):(0,L.localize)(25,null,c)):p<j?(c=Math.floor(p/A),$?c===1?(0,L.localize)(26,null,c):(0,L.localize)(27,null,c):c===1?(0,L.localize)(28,null,c):(0,L.localize)(29,null,c)):p<R?(c=Math.floor(p/j),$?c===1?u?(0,L.localize)(30,null,c):(0,L.localize)(31,null,c):u?(0,L.localize)(32,null,c):(0,L.localize)(33,null,c):c===1?u?(0,L.localize)(34,null,c):(0,L.localize)(35,null,c):u?(0,L.localize)(36,null,c):(0,L.localize)(37,null,c)):p<S?(c=Math.floor(p/R),$?c===1?u?(0,L.localize)(38,null,c):(0,L.localize)(39,null,c):u?(0,L.localize)(40,null,c):(0,L.localize)(41,null,c):c===1?u?(0,L.localize)(42,null,c):(0,L.localize)(43,null,c):u?(0,L.localize)(44,null,c):(0,L.localize)(45,null,c)):(c=Math.floor(p/S),$?c===1?u?(0,L.localize)(46,null,c):(0,L.localize)(47,null,c):u?(0,L.localize)(48,null,c):(0,L.localize)(49,null,c):c===1?u?(0,L.localize)(50,null,c):(0,L.localize)(51,null,c):u?(0,L.localize)(52,null,c):(0,L.localize)(53,null,c))}e.$Sl=g;function C(y){return y.getFullYear()+"-"+String(y.getMonth()+1).padStart(2,"0")+"-"+String(y.getDate()).padStart(2,"0")+"T"+String(y.getHours()).padStart(2,"0")+":"+String(y.getMinutes()).padStart(2,"0")+":"+String(y.getSeconds()).padStart(2,"0")+"."+(y.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$Tl=C}),define(ce[135],le([12,9]),function(ie,e){return ie.create("vs/base/common/errorMessage",e)}),define(ce[38],le([0,1,20,11,135]),function(ie,e,L,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ci=e.$bi=e.$ai=void 0;function A(y,$){return $&&(y.stack||y.stacktrace)?O.localize(0,null,R(y),j(y.stack)||j(y.stacktrace)):R(y)}function j(y){return Array.isArray(y)?y.join(`
`):y}function R(y){return y.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${y.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?O.localize(1,null,y.message):y.message||O.localize(2,null)}function S(y=null,$=!1){if(!y)return O.localize(3,null);if(Array.isArray(y)){const u=L.$jf(y),d=S(u[0],$);return u.length>1?O.localize(4,null,d,u.length):d}if(N.$ie(y))return y;if(y.detail){const u=y.detail;if(u.error)return A(u.error,$);if(u.exception)return A(u.exception,$)}return y.stack?A(y,$):y.message?y.message:O.localize(5,null)}e.$ai=S;function g(y){const $=y;return $ instanceof Error&&Array.isArray($.actions)}e.$bi=g;function C(y,$){let u;return typeof y=="string"?u=new Error(y):u=y,u.actions=$,u}e.$ci=C}),define(ce[136],le([12,9]),function(ie,e){return ie.create("vs/base/common/jsonErrorMessages",e)}),define(ce[137],le([0,1,136]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dp=void 0;function N(O){switch(O){case 1:return(0,L.localize)(0,null);case 2:return(0,L.localize)(1,null);case 3:return(0,L.localize)(2,null);case 4:return(0,L.localize)(3,null);case 5:return(0,L.localize)(4,null);case 6:return(0,L.localize)(5,null);case 7:return(0,L.localize)(6,null);case 8:return(0,L.localize)(7,null);case 9:return(0,L.localize)(8,null);default:return""}}e.$dp=N}),define(ce[138],le([12,9]),function(ie,e){return ie.create("vs/base/common/platform",e)}),define(ce[6],le([0,1,138]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H=e.$G=e.$F=e.$E=e.$D=e.$C=e.OS=e.OperatingSystem=e.$A=e.$z=e.$y=e.$x=e.$w=e.Language=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=e.$f=void 0,e.$f="en";let N=!1,O=!1,A=!1,j=!1,R=!1,S=!1,g=!1,C=!1,y=!1,$=!1,u,d=e.$f,p=e.$f,c,h;e.$g=typeof self=="object"?self:typeof global=="object"?global:{};let f;typeof e.$g.vscode<"u"&&typeof e.$g.vscode.process<"u"?f=e.$g.vscode.process:typeof process<"u"&&(f=process);const b=typeof f?.versions?.electron=="string",w=b&&f?.type==="renderer";if(typeof navigator=="object"&&!w)h=navigator.userAgent,N=h.indexOf("Windows")>=0,O=h.indexOf("Macintosh")>=0,C=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=h.indexOf("Linux")>=0,$=h?.indexOf("Mobi")>=0,S=!0,u=L.getConfiguredDefaultLocale(L.localize(0,null))||e.$f,d=u,p=navigator.language;else if(typeof f=="object"){N=f.platform==="win32",O=f.platform==="darwin",A=f.platform==="linux",j=A&&!!f.env.SNAP&&!!f.env.SNAP_REVISION,g=b,y=!!f.env.CI||!!f.env.BUILD_ARTIFACTSTAGINGDIRECTORY,u=e.$f,d=e.$f;const v=f.env.VSCODE_NLS_CONFIG;if(v)try{const m=JSON.parse(v),l=m.availableLanguages["*"];u=m.locale,p=m.osLocale,d=l||e.$f,c=m._translationsConfigFile}catch{}R=!0}else console.error("Unable to resolve platform.");var I;(function(v){v[v.Web=0]="Web",v[v.Mac=1]="Mac",v[v.Linux=2]="Linux",v[v.Windows=3]="Windows"})(I||(e.Platform=I={}));function t(v){switch(v){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=t;let o=0;O?o=1:N?o=3:A&&(o=2),e.$i=N,e.$j=O,e.$k=A,e.$l=j,e.$m=R,e.$n=g,e.$o=S,e.$p=S&&typeof e.$g.importScripts=="function",e.$q=C,e.$r=$,e.$s=y,e.$t=o,e.$u=h,e.$v=d;var s;(function(v){function m(){return e.$v}v.value=m;function l(){return e.$v.length===2?e.$v==="en":e.$v.length>=3?e.$v[0]==="e"&&e.$v[1]==="n"&&e.$v[2]==="-":!1}v.isDefaultVariant=l;function E(){return e.$v==="en"}v.isDefault=E})(s||(e.Language=s={})),e.$w=u,e.$x=p,e.$y=c,e.$z=typeof e.$g.postMessage=="function"&&!e.$g.importScripts,e.$A=(()=>{if(e.$z){const v=[];e.$g.addEventListener("message",l=>{if(l.data&&l.data.vscodeScheduleAsyncWork)for(let E=0,D=v.length;E<D;E++){const T=v[E];if(T.id===l.data.vscodeScheduleAsyncWork){v.splice(E,1),T.callback();return}}});let m=0;return l=>{const E=++m;v.push({id:E,callback:l}),e.$g.postMessage({vscodeScheduleAsyncWork:E},"*")}}return v=>setTimeout(v)})();var n;(function(v){v[v.Windows=1]="Windows",v[v.Macintosh=2]="Macintosh",v[v.Linux=3]="Linux"})(n||(e.OperatingSystem=n={})),e.OS=O||C?2:N?1:3;let i=!0,r=!1;function a(){if(!r){r=!0;const v=new Uint8Array(2);v[0]=1,v[1]=2,i=new Uint16Array(v.buffer)[0]===(2<<8)+1}return i}e.$C=a,e.$D=!!(e.$u&&e.$u.indexOf("Chrome")>=0),e.$E=!!(e.$u&&e.$u.indexOf("Firefox")>=0),e.$F=!!(!e.$D&&e.$u&&e.$u.indexOf("Safari")>=0),e.$G=!!(e.$u&&e.$u.indexOf("Edg/")>=0),e.$H=!!(e.$u&&e.$u.indexOf("Android")>=0)}),define(ce[37],le([0,1,6]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=e.$2c=e.env=e.cwd=void 0;let N;if(typeof L.$g.vscode<"u"&&typeof L.$g.vscode.process<"u"){const O=L.$g.vscode.process;N={get platform(){return O.platform},get arch(){return O.arch},get env(){return O.env},cwd(){return O.cwd()}}}else typeof process<"u"?N={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:N={get platform(){return L.$i?"win32":L.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=N.cwd,e.env=N.env,e.$2c=N.platform,e.$3c=N.arch}),define(ce[16],le([0,1,37]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fd=e.sep=e.$dd=e.$cd=e.$bd=e.$ad=e.$_c=e.$$c=e.$0c=e.$9c=e.$8c=e.$7c=e.$6c=e.$5c=e.$4c=void 0;const N=65,O=97,A=90,j=122,R=46,S=47,g=92,C=58,y=63;class $ extends Error{constructor(o,s,n){let i;typeof s=="string"&&s.indexOf("not ")===0?(i="must not be",s=s.replace(/^not /,"")):i="must be";const r=o.indexOf(".")!==-1?"property":"argument";let a=`The "${o}" ${r} ${i} of type ${s}`;a+=`. Received type ${typeof n}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function u(t,o){if(t===null||typeof t!="object")throw new $(o,"Object",t)}function d(t,o){if(typeof t!="string")throw new $(o,"string",t)}const p=L.$2c==="win32";function c(t){return t===S||t===g}function h(t){return t===S}function f(t){return t>=N&&t<=A||t>=O&&t<=j}function b(t,o,s,n){let i="",r=0,a=-1,v=0,m=0;for(let l=0;l<=t.length;++l){if(l<t.length)m=t.charCodeAt(l);else{if(n(m))break;m=S}if(n(m)){if(!(a===l-1||v===1))if(v===2){if(i.length<2||r!==2||i.charCodeAt(i.length-1)!==R||i.charCodeAt(i.length-2)!==R){if(i.length>2){const E=i.lastIndexOf(s);E===-1?(i="",r=0):(i=i.slice(0,E),r=i.length-1-i.lastIndexOf(s)),a=l,v=0;continue}else if(i.length!==0){i="",r=0,a=l,v=0;continue}}o&&(i+=i.length>0?`${s}..`:"..",r=2)}else i.length>0?i+=`${s}${t.slice(a+1,l)}`:i=t.slice(a+1,l),r=l-a-1;a=l,v=0}else m===R&&v!==-1?++v:v=-1}return i}function w(t,o){u(o,"pathObject");const s=o.dir||o.root,n=o.base||`${o.name||""}${o.ext||""}`;return s?s===o.root?`${s}${n}`:`${s}${t}${n}`:n}e.$4c={resolve(...t){let o="",s="",n=!1;for(let i=t.length-1;i>=-1;i--){let r;if(i>=0){if(r=t[i],d(r,"path"),r.length===0)continue}else o.length===0?r=L.cwd():(r=L.env[`=${o}`]||L.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==o.toLowerCase()&&r.charCodeAt(2)===g)&&(r=`${o}\\`));const a=r.length;let v=0,m="",l=!1;const E=r.charCodeAt(0);if(a===1)c(E)&&(v=1,l=!0);else if(c(E))if(l=!0,c(r.charCodeAt(1))){let D=2,T=D;for(;D<a&&!c(r.charCodeAt(D));)D++;if(D<a&&D!==T){const M=r.slice(T,D);for(T=D;D<a&&c(r.charCodeAt(D));)D++;if(D<a&&D!==T){for(T=D;D<a&&!c(r.charCodeAt(D));)D++;(D===a||D!==T)&&(m=`\\\\${M}\\${r.slice(T,D)}`,v=D)}}}else v=1;else f(E)&&r.charCodeAt(1)===C&&(m=r.slice(0,2),v=2,a>2&&c(r.charCodeAt(2))&&(l=!0,v=3));if(m.length>0)if(o.length>0){if(m.toLowerCase()!==o.toLowerCase())continue}else o=m;if(n){if(o.length>0)break}else if(s=`${r.slice(v)}\\${s}`,n=l,l&&o.length>0)break}return s=b(s,!n,"\\",c),n?`${o}\\${s}`:`${o}${s}`||"."},normalize(t){d(t,"path");const o=t.length;if(o===0)return".";let s=0,n,i=!1;const r=t.charCodeAt(0);if(o===1)return h(r)?"\\":t;if(c(r))if(i=!0,c(t.charCodeAt(1))){let v=2,m=v;for(;v<o&&!c(t.charCodeAt(v));)v++;if(v<o&&v!==m){const l=t.slice(m,v);for(m=v;v<o&&c(t.charCodeAt(v));)v++;if(v<o&&v!==m){for(m=v;v<o&&!c(t.charCodeAt(v));)v++;if(v===o)return`\\\\${l}\\${t.slice(m)}\\`;v!==m&&(n=`\\\\${l}\\${t.slice(m,v)}`,s=v)}}}else s=1;else f(r)&&t.charCodeAt(1)===C&&(n=t.slice(0,2),s=2,o>2&&c(t.charCodeAt(2))&&(i=!0,s=3));let a=s<o?b(t.slice(s),!i,"\\",c):"";return a.length===0&&!i&&(a="."),a.length>0&&c(t.charCodeAt(o-1))&&(a+="\\"),n===void 0?i?`\\${a}`:a:i?`${n}\\${a}`:`${n}${a}`},isAbsolute(t){d(t,"path");const o=t.length;if(o===0)return!1;const s=t.charCodeAt(0);return c(s)||o>2&&f(s)&&t.charCodeAt(1)===C&&c(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let o,s;for(let r=0;r<t.length;++r){const a=t[r];d(a,"path"),a.length>0&&(o===void 0?o=s=a:o+=`\\${a}`)}if(o===void 0)return".";let n=!0,i=0;if(typeof s=="string"&&c(s.charCodeAt(0))){++i;const r=s.length;r>1&&c(s.charCodeAt(1))&&(++i,r>2&&(c(s.charCodeAt(2))?++i:n=!1))}if(n){for(;i<o.length&&c(o.charCodeAt(i));)i++;i>=2&&(o=`\\${o.slice(i)}`)}return e.$4c.normalize(o)},relative(t,o){if(d(t,"from"),d(o,"to"),t===o)return"";const s=e.$4c.resolve(t),n=e.$4c.resolve(o);if(s===n||(t=s.toLowerCase(),o=n.toLowerCase(),t===o))return"";let i=0;for(;i<t.length&&t.charCodeAt(i)===g;)i++;let r=t.length;for(;r-1>i&&t.charCodeAt(r-1)===g;)r--;const a=r-i;let v=0;for(;v<o.length&&o.charCodeAt(v)===g;)v++;let m=o.length;for(;m-1>v&&o.charCodeAt(m-1)===g;)m--;const l=m-v,E=a<l?a:l;let D=-1,T=0;for(;T<E;T++){const F=t.charCodeAt(i+T);if(F!==o.charCodeAt(v+T))break;F===g&&(D=T)}if(T!==E){if(D===-1)return n}else{if(l>E){if(o.charCodeAt(v+T)===g)return n.slice(v+T+1);if(T===2)return n.slice(v+T)}a>E&&(t.charCodeAt(i+T)===g?D=T:T===2&&(D=3)),D===-1&&(D=0)}let M="";for(T=i+D+1;T<=r;++T)(T===r||t.charCodeAt(T)===g)&&(M+=M.length===0?"..":"\\..");return v+=D,M.length>0?`${M}${n.slice(v,m)}`:(n.charCodeAt(v)===g&&++v,n.slice(v,m))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const o=e.$4c.resolve(t);if(o.length<=2)return t;if(o.charCodeAt(0)===g){if(o.charCodeAt(1)===g){const s=o.charCodeAt(2);if(s!==y&&s!==R)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(f(o.charCodeAt(0))&&o.charCodeAt(1)===C&&o.charCodeAt(2)===g)return`\\\\?\\${o}`;return t},dirname(t){d(t,"path");const o=t.length;if(o===0)return".";let s=-1,n=0;const i=t.charCodeAt(0);if(o===1)return c(i)?t:".";if(c(i)){if(s=n=1,c(t.charCodeAt(1))){let v=2,m=v;for(;v<o&&!c(t.charCodeAt(v));)v++;if(v<o&&v!==m){for(m=v;v<o&&c(t.charCodeAt(v));)v++;if(v<o&&v!==m){for(m=v;v<o&&!c(t.charCodeAt(v));)v++;if(v===o)return t;v!==m&&(s=n=v+1)}}}}else f(i)&&t.charCodeAt(1)===C&&(s=o>2&&c(t.charCodeAt(2))?3:2,n=s);let r=-1,a=!0;for(let v=o-1;v>=n;--v)if(c(t.charCodeAt(v))){if(!a){r=v;break}}else a=!1;if(r===-1){if(s===-1)return".";r=s}return t.slice(0,r)},basename(t,o){o!==void 0&&d(o,"ext"),d(t,"path");let s=0,n=-1,i=!0,r;if(t.length>=2&&f(t.charCodeAt(0))&&t.charCodeAt(1)===C&&(s=2),o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let a=o.length-1,v=-1;for(r=t.length-1;r>=s;--r){const m=t.charCodeAt(r);if(c(m)){if(!i){s=r+1;break}}else v===-1&&(i=!1,v=r+1),a>=0&&(m===o.charCodeAt(a)?--a===-1&&(n=r):(a=-1,n=v))}return s===n?n=v:n===-1&&(n=t.length),t.slice(s,n)}for(r=t.length-1;r>=s;--r)if(c(t.charCodeAt(r))){if(!i){s=r+1;break}}else n===-1&&(i=!1,n=r+1);return n===-1?"":t.slice(s,n)},extname(t){d(t,"path");let o=0,s=-1,n=0,i=-1,r=!0,a=0;t.length>=2&&t.charCodeAt(1)===C&&f(t.charCodeAt(0))&&(o=n=2);for(let v=t.length-1;v>=o;--v){const m=t.charCodeAt(v);if(c(m)){if(!r){n=v+1;break}continue}i===-1&&(r=!1,i=v+1),m===R?s===-1?s=v:a!==1&&(a=1):s!==-1&&(a=-1)}return s===-1||i===-1||a===0||a===1&&s===i-1&&s===n+1?"":t.slice(s,i)},format:w.bind(null,"\\"),parse(t){d(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const s=t.length;let n=0,i=t.charCodeAt(0);if(s===1)return c(i)?(o.root=o.dir=t,o):(o.base=o.name=t,o);if(c(i)){if(n=1,c(t.charCodeAt(1))){let D=2,T=D;for(;D<s&&!c(t.charCodeAt(D));)D++;if(D<s&&D!==T){for(T=D;D<s&&c(t.charCodeAt(D));)D++;if(D<s&&D!==T){for(T=D;D<s&&!c(t.charCodeAt(D));)D++;D===s?n=D:D!==T&&(n=D+1)}}}}else if(f(i)&&t.charCodeAt(1)===C){if(s<=2)return o.root=o.dir=t,o;if(n=2,c(t.charCodeAt(2))){if(s===3)return o.root=o.dir=t,o;n=3}}n>0&&(o.root=t.slice(0,n));let r=-1,a=n,v=-1,m=!0,l=t.length-1,E=0;for(;l>=n;--l){if(i=t.charCodeAt(l),c(i)){if(!m){a=l+1;break}continue}v===-1&&(m=!1,v=l+1),i===R?r===-1?r=l:E!==1&&(E=1):r!==-1&&(E=-1)}return v!==-1&&(r===-1||E===0||E===1&&r===v-1&&r===a+1?o.base=o.name=t.slice(a,v):(o.name=t.slice(a,r),o.base=t.slice(a,v),o.ext=t.slice(r,v))),a>0&&a!==n?o.dir=t.slice(0,a-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const I=(()=>{if(p){const t=/\\/g;return()=>{const o=L.cwd().replace(t,"/");return o.slice(o.indexOf("/"))}}return()=>L.cwd()})();e.$5c={resolve(...t){let o="",s=!1;for(let n=t.length-1;n>=-1&&!s;n--){const i=n>=0?t[n]:I();d(i,"path"),i.length!==0&&(o=`${i}/${o}`,s=i.charCodeAt(0)===S)}return o=b(o,!s,"/",h),s?`/${o}`:o.length>0?o:"."},normalize(t){if(d(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===S,s=t.charCodeAt(t.length-1)===S;return t=b(t,!o,"/",h),t.length===0?o?"/":s?"./":".":(s&&(t+="/"),o?`/${t}`:t)},isAbsolute(t){return d(t,"path"),t.length>0&&t.charCodeAt(0)===S},join(...t){if(t.length===0)return".";let o;for(let s=0;s<t.length;++s){const n=t[s];d(n,"path"),n.length>0&&(o===void 0?o=n:o+=`/${n}`)}return o===void 0?".":e.$5c.normalize(o)},relative(t,o){if(d(t,"from"),d(o,"to"),t===o||(t=e.$5c.resolve(t),o=e.$5c.resolve(o),t===o))return"";const s=1,n=t.length,i=n-s,r=1,a=o.length-r,v=i<a?i:a;let m=-1,l=0;for(;l<v;l++){const D=t.charCodeAt(s+l);if(D!==o.charCodeAt(r+l))break;D===S&&(m=l)}if(l===v)if(a>v){if(o.charCodeAt(r+l)===S)return o.slice(r+l+1);if(l===0)return o.slice(r+l)}else i>v&&(t.charCodeAt(s+l)===S?m=l:l===0&&(m=0));let E="";for(l=s+m+1;l<=n;++l)(l===n||t.charCodeAt(l)===S)&&(E+=E.length===0?"..":"/..");return`${E}${o.slice(r+m)}`},toNamespacedPath(t){return t},dirname(t){if(d(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===S;let s=-1,n=!0;for(let i=t.length-1;i>=1;--i)if(t.charCodeAt(i)===S){if(!n){s=i;break}}else n=!1;return s===-1?o?"/":".":o&&s===1?"//":t.slice(0,s)},basename(t,o){o!==void 0&&d(o,"ext"),d(t,"path");let s=0,n=-1,i=!0,r;if(o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let a=o.length-1,v=-1;for(r=t.length-1;r>=0;--r){const m=t.charCodeAt(r);if(m===S){if(!i){s=r+1;break}}else v===-1&&(i=!1,v=r+1),a>=0&&(m===o.charCodeAt(a)?--a===-1&&(n=r):(a=-1,n=v))}return s===n?n=v:n===-1&&(n=t.length),t.slice(s,n)}for(r=t.length-1;r>=0;--r)if(t.charCodeAt(r)===S){if(!i){s=r+1;break}}else n===-1&&(i=!1,n=r+1);return n===-1?"":t.slice(s,n)},extname(t){d(t,"path");let o=-1,s=0,n=-1,i=!0,r=0;for(let a=t.length-1;a>=0;--a){const v=t.charCodeAt(a);if(v===S){if(!i){s=a+1;break}continue}n===-1&&(i=!1,n=a+1),v===R?o===-1?o=a:r!==1&&(r=1):o!==-1&&(r=-1)}return o===-1||n===-1||r===0||r===1&&o===n-1&&o===s+1?"":t.slice(o,n)},format:w.bind(null,"/"),parse(t){d(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const s=t.charCodeAt(0)===S;let n;s?(o.root="/",n=1):n=0;let i=-1,r=0,a=-1,v=!0,m=t.length-1,l=0;for(;m>=n;--m){const E=t.charCodeAt(m);if(E===S){if(!v){r=m+1;break}continue}a===-1&&(v=!1,a=m+1),E===R?i===-1?i=m:l!==1&&(l=1):i!==-1&&(l=-1)}if(a!==-1){const E=r===0&&s?1:r;i===-1||l===0||l===1&&i===a-1&&i===r+1?o.base=o.name=t.slice(E,a):(o.name=t.slice(E,i),o.base=t.slice(E,a),o.ext=t.slice(i,a))}return r>0?o.dir=t.slice(0,r-1):s&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$5c.win32=e.$4c.win32=e.$4c,e.$5c.posix=e.$4c.posix=e.$5c,e.$6c=p?e.$4c.normalize:e.$5c.normalize,e.$7c=p?e.$4c.isAbsolute:e.$5c.isAbsolute,e.$8c=p?e.$4c.join:e.$5c.join,e.$9c=p?e.$4c.resolve:e.$5c.resolve,e.$0c=p?e.$4c.relative:e.$5c.relative,e.$$c=p?e.$4c.dirname:e.$5c.dirname,e.$_c=p?e.$4c.basename:e.$5c.basename,e.$ad=p?e.$4c.extname:e.$5c.extname,e.$bd=p?e.$4c.format:e.$5c.format,e.$cd=p?e.$4c.parse:e.$5c.parse,e.$dd=p?e.$4c.toNamespacedPath:e.$5c.toNamespacedPath,e.sep=p?e.$4c.sep:e.$5c.sep,e.$fd=p?e.$4c.delimiter:e.$5c.delimiter}),define(ce[48],le([0,1,16,6,28,11]),function(ie,e,L,N,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=void 0;function j(r){return r===47||r===92}e.$Ae=j;function R(r){return r.replace(/[\\/]/g,L.$5c.sep)}e.$Be=R;function S(r){return r.indexOf("/")===-1&&(r=R(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.$Ce=S;function g(r,a=L.$5c.sep){if(!r)return"";const v=r.length,m=r.charCodeAt(0);if(j(m)){if(j(r.charCodeAt(1))&&!j(r.charCodeAt(2))){let E=3;const D=E;for(;E<v&&!j(r.charCodeAt(E));E++);if(D!==E&&!j(r.charCodeAt(E+1))){for(E+=1;E<v;E++)if(j(r.charCodeAt(E)))return r.slice(0,E+1).replace(/[\\/]/g,a)}}return a}else if(h(m)&&r.charCodeAt(1)===58)return j(r.charCodeAt(2))?r.slice(0,2)+a:r.slice(0,2);let l=r.indexOf("://");if(l!==-1){for(l+=3;l<v;l++)if(j(r.charCodeAt(l)))return r.slice(0,l+1)}return""}e.$De=g;function C(r){if(!N.$i||!r||r.length<5)return!1;let a=r.charCodeAt(0);if(a!==92||(a=r.charCodeAt(1),a!==92))return!1;let v=2;const m=v;for(;v<r.length&&(a=r.charCodeAt(v),a!==92);v++);return!(m===v||(a=r.charCodeAt(v+1),isNaN(a)||a===92))}e.$Ee=C;const y=/[\\/:\*\?"<>\|]/g,$=/[\\/]/g,u=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(r,a=N.$i){const v=a?y:$;return!(!r||r.length===0||/^\s+$/.test(r)||(v.lastIndex=0,v.test(r))||a&&u.test(r)||r==="."||r===".."||a&&r[r.length-1]==="."||a&&r.length!==r.trim().length||r.length>255)}e.$Fe=d;function p(r,a,v){const m=r===a;return!v||m?m:!r||!a?!1:(0,O.$Ld)(r,a)}e.$Ge=p;function c(r,a,v,m=L.sep){if(r===a)return!0;if(!r||!a||a.length>r.length)return!1;if(v){if(!(0,O.$Md)(r,a))return!1;if(a.length===r.length)return!0;let E=a.length;return a.charAt(a.length-1)===m&&E--,r.charAt(E)===m}return a.charAt(a.length-1)!==m&&(a+=m),r.indexOf(a)===0}e.$He=c;function h(r){return r>=65&&r<=90||r>=97&&r<=122}e.$Ie=h;function f(r,a){return N.$i&&r.endsWith(":")&&(r+=L.sep),(0,L.$7c)(r)||(r=(0,L.$8c)(a,r)),r=(0,L.$6c)(r),N.$i?(r=(0,O.$ud)(r,L.sep),r.endsWith(":")&&(r+=L.sep)):(r=(0,O.$ud)(r,L.sep),r||(r=L.sep)),r}e.$Je=f;function b(r){const a=(0,L.$6c)(r);return N.$i?r.length>3?!1:w(a)&&(r.length===2||a.charCodeAt(2)===92):a===L.$5c.sep}e.$Ke=b;function w(r,a=N.$i){return a?h(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.$Le=w;function I(r,a=N.$i){return w(r,a)?r[0]:void 0}e.$Me=I;function t(r,a,v){return a.length>r.length?-1:r===a?0:(v&&(r=r.toLowerCase(),a=a.toLowerCase()),r.indexOf(a))}e.$Ne=t;function o(r){const a=r.split(":");let v,m,l;for(const E of a){const D=Number(E);(0,A.$me)(D)?m===void 0?m=D:l===void 0&&(l=D):v=v?[v,E].join(":"):E}if(!v)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:v,line:m!==void 0?m:void 0,column:l!==void 0?l:m!==void 0?1:void 0}}e.$Oe=o;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",n="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function i(r,a,v=8){let m="";for(let E=0;E<v;E++){let D;E===0&&N.$i&&!a&&(v===3||v===4)?D=n:D=s,m+=D.charAt(Math.floor(Math.random()*D.length))}let l;return a?l=`${a}-${m}`:l=m,r?(0,L.$8c)(r,l):l}e.$Pe=i}),define(ce[139],le([0,1,16]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cr=e.$Br=e.$Ar=e.$zr=e.$yr=void 0,e.$yr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const N={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},O={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(C){const y=(0,L.$ad)(C),$=N[y.toLowerCase()];return $!==void 0?$:j(C)}e.$zr=A;function j(C){const y=(0,L.$ad)(C);return O[y.toLowerCase()]}e.$Ar=j;function R(C){for(const y in O)if(O[y]===C)return y}e.$Br=R;const S=/^(.+)\/(.+?)(;.+)?$/;function g(C,y){const $=S.exec(C);return $?`${$[1].toLowerCase()}/${$[2].toLowerCase()}${$[3]??""}`:y?void 0:C}e.$Cr=g}),define(ce[90],le([0,1,6]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gl=e.$fl=e.TerminateResponseCode=e.Source=void 0;var N;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(N||(e.Source=N={}));var O;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(O||(e.TerminateResponseCode=O={}));function A(R,...S){const g=S.reduce(($,u)=>($[u]=!0,$),{}),C=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter($=>!g[$]).forEach($=>{for(let u=0;u<C.length;u++)if($.search(C[u])!==-1){delete R[$];break}})}e.$fl=A;function j(R){R&&(delete R.DEBUG,L.$j&&delete R.DYLD_LIBRARY_PATH,L.$k&&delete R.LD_PRELOAD)}e.$gl=j}),define(ce[10],le([0,1,16,6]),function(ie,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Se=e.$Re=e.URI=void 0;const O=/^\w[\w\d+.-]*$/,A=/^\//,j=/^\/\//;function R(n,i){if(!n.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!O.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!A.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(j.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(n,i){return!n&&!i?"file":n}function g(n,i){switch(n){case"https":case"http":case"file":i?i[0]!==y&&(i=y+i):i=y;break}return i}const C="",y="/",$=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class u{static isUri(i){return i instanceof u?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}constructor(i,r,a,v,m,l=!1){typeof i=="object"?(this.scheme=i.scheme||C,this.authority=i.authority||C,this.path=i.path||C,this.query=i.query||C,this.fragment=i.fragment||C):(this.scheme=S(i,l),this.authority=r||C,this.path=g(this.scheme,a||C),this.query=v||C,this.fragment=m||C,R(this,l))}get fsPath(){return w(this,!1)}with(i){if(!i)return this;let{scheme:r,authority:a,path:v,query:m,fragment:l}=i;return r===void 0?r=this.scheme:r===null&&(r=C),a===void 0?a=this.authority:a===null&&(a=C),v===void 0?v=this.path:v===null&&(v=C),m===void 0?m=this.query:m===null&&(m=C),l===void 0?l=this.fragment:l===null&&(l=C),r===this.scheme&&a===this.authority&&v===this.path&&m===this.query&&l===this.fragment?this:new c(r,a,v,m,l)}static parse(i,r=!1){const a=$.exec(i);return a?new c(a[2]||C,s(a[4]||C),s(a[5]||C),s(a[7]||C),s(a[9]||C),r):new c(C,C,C,C,C)}static file(i){let r=C;if(N.$i&&(i=i.replace(/\\/g,y)),i[0]===y&&i[1]===y){const a=i.indexOf(y,2);a===-1?(r=i.substring(2),i=y):(r=i.substring(2,a),i=i.substring(a)||y)}return new c("file",r,i,C,C)}static from(i,r){return new c(i.scheme,i.authority,i.path,i.query,i.fragment,r)}static joinPath(i,...r){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return N.$i&&i.scheme==="file"?a=u.file(L.$4c.join(w(i,!0),...r)).path:a=L.$5c.join(i.path,...r),i.with({path:a})}toString(i=!1){return I(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof u)return i;{const r=new c(i);return r._formatted=i.external??null,r._fsPath=i._sep===p?i.fsPath??null:null,r}}else return i}}e.URI=u;function d(n){return!n||typeof n!="object"?!1:typeof n.scheme=="string"&&(typeof n.authority=="string"||typeof n.authority>"u")&&(typeof n.path=="string"||typeof n.path>"u")&&(typeof n.query=="string"||typeof n.query>"u")&&(typeof n.fragment=="string"||typeof n.fragment>"u")}e.$Re=d;const p=N.$i?1:void 0;class c extends u{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=w(this,!1)),this._fsPath}toString(i=!1){return i?I(this,!0):(this._formatted||(this._formatted=I(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=p),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const h={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function f(n,i,r){let a,v=-1;for(let m=0;m<n.length;m++){const l=n.charCodeAt(m);if(l>=97&&l<=122||l>=65&&l<=90||l>=48&&l<=57||l===45||l===46||l===95||l===126||i&&l===47||r&&l===91||r&&l===93||r&&l===58)v!==-1&&(a+=encodeURIComponent(n.substring(v,m)),v=-1),a!==void 0&&(a+=n.charAt(m));else{a===void 0&&(a=n.substr(0,m));const E=h[l];E!==void 0?(v!==-1&&(a+=encodeURIComponent(n.substring(v,m)),v=-1),a+=E):v===-1&&(v=m)}}return v!==-1&&(a+=encodeURIComponent(n.substring(v))),a!==void 0?a:n}function b(n){let i;for(let r=0;r<n.length;r++){const a=n.charCodeAt(r);a===35||a===63?(i===void 0&&(i=n.substr(0,r)),i+=h[a]):i!==void 0&&(i+=n[r])}return i!==void 0?i:n}function w(n,i){let r;return n.authority&&n.path.length>1&&n.scheme==="file"?r=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?i?r=n.path.substr(1):r=n.path[1].toLowerCase()+n.path.substr(2):r=n.path,N.$i&&(r=r.replace(/\//g,"\\")),r}e.$Se=w;function I(n,i){const r=i?b:f;let a="",{scheme:v,authority:m,path:l,query:E,fragment:D}=n;if(v&&(a+=v,a+=":"),(m||v==="file")&&(a+=y,a+=y),m){let T=m.indexOf("@");if(T!==-1){const M=m.substr(0,T);m=m.substr(T+1),T=M.lastIndexOf(":"),T===-1?a+=r(M,!1,!1):(a+=r(M.substr(0,T),!1,!1),a+=":",a+=r(M.substr(T+1),!1,!0)),a+="@"}m=m.toLowerCase(),T=m.lastIndexOf(":"),T===-1?a+=r(m,!1,!0):(a+=r(m.substr(0,T),!1,!0),a+=m.substr(T))}if(l){if(l.length>=3&&l.charCodeAt(0)===47&&l.charCodeAt(2)===58){const T=l.charCodeAt(1);T>=65&&T<=90&&(l=`/${String.fromCharCode(T+32)}:${l.substr(3)}`)}else if(l.length>=2&&l.charCodeAt(1)===58){const T=l.charCodeAt(0);T>=65&&T<=90&&(l=`${String.fromCharCode(T+32)}:${l.substr(2)}`)}a+=r(l,!0,!1)}return E&&(a+="?",a+=r(E,!1,!1)),D&&(a+="#",a+=i?D:f(D,!1,!1)),a}function t(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+t(n.substr(3)):n}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(n){return n.match(o)?n.replace(o,i=>t(i)):n}}),define(ce[140],le([0,1,10]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Gp=e.$Fp=e.$Ep=void 0;function N(g){const C=g;return C&&typeof C.type=="string"&&typeof C.severity=="string"}e.$Ep=N;function O(g){const C=[];let y;try{const $=JSON.parse(g.arguments),u=$[$.length-1];u&&u.__$stack&&($.pop(),y=u.__$stack),C.push(...$)}catch{C.push("Unable to log remote console arguments",g.arguments)}return{args:C,stack:y}}e.$Fp=O;function A(g){if(typeof g!="string")return A(O(g).stack);const C=g;if(C){const y=j(C),$=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(y||"");if($&&$.length===4)return{uri:L.URI.file($[1]),line:Number($[2]),column:Number($[3])}}}e.$Gp=A;function j(g){if(!g)return g;const C=g.indexOf(`
`);return C===-1?g:g.substring(0,C)}function R(g,C){const{args:y,stack:$}=O(g),u=typeof y[0]=="string"&&y.length===1;let d=j($);d&&(d=`(${d.trim()})`);let p=[];if(typeof y[0]=="string"?d&&u?p=[`%c[${C}] %c${y[0]} %c${d}`,S("blue"),S(""),S("grey")]:p=[`%c[${C}] %c${y[0]}`,S("blue"),S(""),...y.slice(1)]:p=[`%c[${C}]%`,S("blue"),...y],d&&!u&&p.push(d),typeof console[g.severity]!="function")throw new Error("Unknown console method");console[g.severity].apply(console,p)}e.log=R;function S(g){return`color: ${g}`}}),define(ce[63],le([0,1,14,10]),function(ie,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yg=e.$Xg=e.$Wg=void 0;function O(S){return JSON.stringify(S,j)}e.$Wg=O;function A(S){let g=JSON.parse(S);return g=R(g),g}e.$Xg=A;function j(S,g){return g instanceof RegExp?{$mid:2,source:g.source,flags:g.flags}:g}function R(S,g=0){if(!S||g>200)return S;if(typeof S=="object"){switch(S.$mid){case 1:return N.URI.revive(S);case 2:return new RegExp(S.source,S.flags);case 16:return new Date(S.source)}if(S instanceof L.$Ec||S instanceof Uint8Array)return S;if(Array.isArray(S))for(let C=0;C<S.length;++C)S[C]=R(S[C],g+1);else for(const C in S)Object.hasOwnProperty.call(S,C)&&(S[C]=R(S[C],g+1))}return S}e.$Yg=R}),define(ce[26],le([0,1,8,6,10]),function(ie,e,L,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.Schemas=void 0;var A;(function(g){g.inMemory="inmemory",g.vscode="vscode",g.internal="private",g.walkThrough="walkThrough",g.walkThroughSnippet="walkThroughSnippet",g.http="http",g.https="https",g.file="file",g.mailto="mailto",g.untitled="untitled",g.data="data",g.command="command",g.vscodeRemote="vscode-remote",g.vscodeRemoteResource="vscode-remote-resource",g.vscodeManagedRemoteResource="vscode-managed-remote-resource",g.vscodeUserData="vscode-userdata",g.vscodeCustomEditor="vscode-custom-editor",g.vscodeNotebookCell="vscode-notebook-cell",g.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",g.vscodeNotebookCellOutput="vscode-notebook-cell-output",g.vscodeInteractiveInput="vscode-interactive-input",g.vscodeSettings="vscode-settings",g.vscodeWorkspaceTrust="vscode-workspace-trust",g.vscodeTerminal="vscode-terminal",g.vscodeChatSesssion="vscode-chat-editor",g.webviewPanel="webview-panel",g.vscodeWebview="vscode-webview",g.extension="extension",g.vscodeFileResource="vscode-file",g.tmp="tmp",g.vsls="vsls",g.vscodeSourceControl="vscode-scm"})(A||(e.Schemas=A={})),e.$Te="vscode-tkn",e.$Ue="tkn";class j{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${A.vscodeRemoteResource}`}setPreferredWebSchema(C){this.d=C}setDelegate(C){this.e=C}setServerRootPath(C){this.f=`${C}/${A.vscodeRemoteResource}`}set(C,y,$){this.a[C]=y,this.b[C]=$}setConnectionToken(C,y){this.c[C]=y}getPreferredWebSchema(){return this.d}rewrite(C){if(this.e)try{return this.e(C)}catch(c){return L.$Y(c),C}const y=C.authority;let $=this.a[y];$&&$.indexOf(":")!==-1&&$.indexOf("[")===-1&&($=`[${$}]`);const u=this.b[y],d=this.c[y];let p=`path=${encodeURIComponent(C.path)}`;return typeof d=="string"&&(p+=`&${e.$Ue}=${encodeURIComponent(d)}`),O.URI.from({scheme:N.$o?this.d:A.vscodeRemoteResource,authority:`${$}:${u}`,path:this.f,query:p})}}e.$Ve=new j,e.$We="vs/../../extensions",e.$Xe="vs/../../node_modules",e.$Ye="vs/../../node_modules.asar",e.$Ze="vs/../../node_modules.asar.unpacked";class R{static{this.a="vscode-app"}asBrowserUri(C){const y=this.b(C,ie);return this.uriToBrowserUri(y)}uriToBrowserUri(C){return C.scheme===A.vscodeRemote?e.$Ve.rewrite(C):C.scheme===A.file&&(N.$m||N.$p&&N.$g.origin===`${A.vscodeFileResource}://${R.a}`)?C.with({scheme:A.vscodeFileResource,authority:C.authority||R.a,query:null,fragment:null}):C}asFileUri(C){const y=this.b(C,ie);return this.uriToFileUri(y)}uriToFileUri(C){return C.scheme===A.vscodeFileResource?C.with({scheme:A.file,authority:C.authority!==R.a?C.authority:null,query:null,fragment:null}):C}b(C,y){return O.URI.isUri(C)?C:O.URI.parse(y.toUrl(C))}}e.$1e=new R;var S;(function(g){const C=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);g.CoopAndCoep=Object.freeze(C.get("3"));const y="vscode-coi";function $(d){let p;typeof d=="string"?p=new URL(d).searchParams:d instanceof URL?p=d.searchParams:O.URI.isUri(d)&&(p=new URL(d.toString(!0)).searchParams);const c=p?.get(y);if(c)return C.get(c)}g.getHeadersFromQuery=$;function u(d,p,c){if(!globalThis.crossOriginIsolated)return;const h=p&&c?"3":c?"2":"1";d instanceof URLSearchParams?d.set(y,h):d[y]=h}g.addSearchParam=u})(S||(e.COI=S={}))}),define(ce[141],le([0,1,124,26,6,10]),function(ie,e,L,N,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2C=void 0;class j{constructor($,u,d){this.id=$,this.dependencies=u,this.callback=d}}class R{static{this.INSTANCE=new R}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=($,u,d)=>{typeof $!="string"&&(d=u,u=$,$=null),(typeof u!="object"||!Array.isArray(u))&&(d=u,u=null),this.c.push(new j($,u,d))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL($){if($.startsWith(window.location.origin)||$.startsWith("vscode-file://vscode-app"))return $;throw new Error(`[trusted_script_src] Invalid script url: ${$}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL($){return $}})))}async load($){this.g();const u=await(this.a?this.i($):this.b?this.h($):this.j($));if(!u)throw new Error(`Did not receive a define call from script ${$}`);if(Array.isArray(u.dependencies)&&u.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${$}. The dependencies are: ${u.dependencies.join(", ")}`);return typeof u.callback=="function"?u.callback([]):u.callback}h($){return new Promise((u,d)=>{const p=document.createElement("script");p.setAttribute("async","async"),p.setAttribute("type","text/javascript");const c=()=>{p.removeEventListener("load",h),p.removeEventListener("error",f)},h=b=>{c(),u(this.c.pop())},f=b=>{c(),d(b)};p.addEventListener("load",h),p.addEventListener("error",f),this.f&&($=this.f.createScriptURL($)),p.setAttribute("src",$),document.getElementsByTagName("head")[0].appendChild(p)})}i($){return new Promise((u,d)=>{try{this.f&&($=this.f.createScriptURL($)),importScripts($),u(this.c.pop())}catch(p){d(p)}})}async j($){try{const u=globalThis._VSCODE_NODE_MODULES.fs,d=globalThis._VSCODE_NODE_MODULES.vm,p=globalThis._VSCODE_NODE_MODULES.module,c=A.URI.parse($).fsPath,h=u.readFileSync(c).toString(),f=p.wrap(h.replace(/^#!.*/,""));return new d.Script(f).runInThisContext().apply(),this.c.pop()}catch(u){throw u}}}const S=new Map;let g={};typeof globalThis.require=="object"&&(g=globalThis.require.paths??{});async function C(y,$,u){if(L.$R){u===void 0&&(u=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),g[y]&&(y=g[y]);const d=`${y}/${$}`;if(S.has(d))return S.get(d);let p;if(/^\w[\w\d+.-]*:\/\//.test(d))p=d;else{const b=`${u&&!O.$o?N.$Ye:N.$Xe}/${d}`;p=N.$1e.asBrowserUri(b).toString(!0)}const c=R.INSTANCE.load(p);return S.set(d,c),c}else return await new Promise((d,p)=>{ie([y],d,p)})}e.$2C=C}),define(ce[22],le([0,1,48,26,16,6,28,10]),function(ie,e,L,N,O,A,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gg=e.DataUri=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=void 0;function S(u){return(0,R.$Se)(u,!0)}e.$Wf=S;class g{constructor(d){this.a=d}compare(d,p,c=!1){return d===p?0:(0,j.$Ed)(this.getComparisonKey(d,c),this.getComparisonKey(p,c))}isEqual(d,p,c=!1){return d===p?!0:!d||!p?!1:this.getComparisonKey(d,c)===this.getComparisonKey(p,c)}getComparisonKey(d,p=!1){return d.with({path:this.a(d)?d.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(d){return this.a(d)}isEqualOrParent(d,p,c=!1){if(d.scheme===p.scheme){if(d.scheme===N.Schemas.file)return L.$He(S(d),S(p),this.a(d))&&d.query===p.query&&(c||d.fragment===p.fragment);if((0,e.$bg)(d.authority,p.authority))return L.$He(d.path,p.path,this.a(d),"/")&&d.query===p.query&&(c||d.fragment===p.fragment)}return!1}joinPath(d,...p){return R.URI.joinPath(d,...p)}basenameOrAuthority(d){return(0,e.$6f)(d)||d.authority}basename(d){return O.$5c.basename(d.path)}extname(d){return O.$5c.extname(d.path)}dirname(d){if(d.path.length===0)return d;let p;return d.scheme===N.Schemas.file?p=R.URI.file(O.$$c(S(d))).path:(p=O.$5c.dirname(d.path),d.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),p="/")),d.with({path:p})}normalizePath(d){if(!d.path.length)return d;let p;return d.scheme===N.Schemas.file?p=R.URI.file(O.$6c(S(d))).path:p=O.$5c.normalize(d.path),d.with({path:p})}relativePath(d,p){if(d.scheme!==p.scheme||!(0,e.$bg)(d.authority,p.authority))return;if(d.scheme===N.Schemas.file){const f=O.$0c(S(d),S(p));return A.$i?L.$Be(f):f}let c=d.path||"/";const h=p.path||"/";if(this.a(d)){let f=0;for(const b=Math.min(c.length,h.length);f<b&&!(c.charCodeAt(f)!==h.charCodeAt(f)&&c.charAt(f).toLowerCase()!==h.charAt(f).toLowerCase());f++);c=h.substr(0,f)+c.substr(f)}return O.$5c.relative(c,h)}resolvePath(d,p){if(d.scheme===N.Schemas.file){const c=R.URI.file(O.$9c(S(d),p));return d.with({authority:c.authority,path:c.path})}return p=L.$Ce(p),d.with({path:O.$5c.resolve(d.path,p)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,p){return d===p||d!==void 0&&p!==void 0&&(0,j.$Ld)(d,p)}hasTrailingPathSeparator(d,p=O.sep){if(d.scheme===N.Schemas.file){const c=S(d);return c.length>L.$De(c).length&&c[c.length-1]===p}else{const c=d.path;return c.length>1&&c.charCodeAt(c.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,p=O.sep){return(0,e.$cg)(d,p)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,p=O.sep){let c=!1;if(d.scheme===N.Schemas.file){const h=S(d);c=h!==void 0&&h.length===L.$De(h).length&&h[h.length-1]===p}else{p="/";const h=d.path;c=h.length===1&&h.charCodeAt(h.length-1)===47}return!c&&!(0,e.$cg)(d,p)?d.with({path:d.path+"/"}):d}}e.$Xf=g,e.$Yf=new g(()=>!1),e.$Zf=new g(u=>u.scheme===N.Schemas.file?!A.$k:!0),e.$1f=new g(u=>!0),e.$2f=e.$Yf.isEqual.bind(e.$Yf),e.$3f=e.$Yf.isEqualOrParent.bind(e.$Yf),e.$4f=e.$Yf.getComparisonKey.bind(e.$Yf),e.$5f=e.$Yf.basenameOrAuthority.bind(e.$Yf),e.$6f=e.$Yf.basename.bind(e.$Yf),e.$7f=e.$Yf.extname.bind(e.$Yf),e.$8f=e.$Yf.dirname.bind(e.$Yf),e.$9f=e.$Yf.joinPath.bind(e.$Yf),e.$0f=e.$Yf.normalizePath.bind(e.$Yf),e.$$f=e.$Yf.relativePath.bind(e.$Yf),e.$_f=e.$Yf.resolvePath.bind(e.$Yf),e.$ag=e.$Yf.isAbsolutePath.bind(e.$Yf),e.$bg=e.$Yf.isEqualAuthority.bind(e.$Yf),e.$cg=e.$Yf.hasTrailingPathSeparator.bind(e.$Yf),e.$dg=e.$Yf.removeTrailingPathSeparator.bind(e.$Yf),e.$eg=e.$Yf.addTrailingPathSeparator.bind(e.$Yf);function C(u,d){const p=[];for(let c=0;c<u.length;c++){const h=d(u[c]);u.some((f,b)=>b===c?!1:(0,e.$3f)(h,d(f)))||p.push(u[c])}return p}e.$fg=C;var y;(function(u){u.META_DATA_LABEL="label",u.META_DATA_DESCRIPTION="description",u.META_DATA_SIZE="size",u.META_DATA_MIME="mime";function d(p){const c=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(b=>{const[w,I]=b.split(":");w&&I&&c.set(w,I)});const f=p.path.substring(0,p.path.indexOf(";"));return f&&c.set(u.META_DATA_MIME,f),c}u.parseMetaData=d})(y||(e.DataUri=y={}));function $(u,d,p){if(d){let c=u.path;return c&&c[0]!==O.$5c.sep&&(c=O.$5c.sep+c),u.with({scheme:p,authority:d,path:c})}return u.with({scheme:p})}e.$gg=$}),define(ce[5],le([0,1,25,8,3,2,22,6,128]),function(ie,e,L,N,O,A,j,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sg=e.$Rg=e.$Qg=e.Promises=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=void 0;function g(k){return!!k&&typeof k.then=="function"}e.$hg=g;function C(k){const P=new L.$oc,z=k(P.token),H=new Promise((ee,ne)=>{const fe=P.token.onCancellationRequested(()=>{fe.dispose(),P.dispose(),ne(new N.$3)});Promise.resolve(z).then(x=>{fe.dispose(),P.dispose(),ee(x)},x=>{fe.dispose(),P.dispose(),ne(x)})});return new class{cancel(){P.cancel()}then(ee,ne){return H.then(ee,ne)}catch(ee){return this.then(void 0,ee)}finally(ee){return H.finally(ee)}}}e.$ig=C;function y(k,P,z){return new Promise((H,ee)=>{const ne=P.onCancellationRequested(()=>{ne.dispose(),H(z)});k.then(H,ee).finally(()=>ne.dispose())})}e.$jg=y;function $(k,P){return new Promise((z,H)=>{const ee=P.onCancellationRequested(()=>{ee.dispose(),H(new N.$3)});k.then(z,H).finally(()=>ee.dispose())})}e.$kg=$;async function u(k){let P=-1;const z=k.map((H,ee)=>H.then(ne=>(P=ee,ne)));try{return await Promise.race(z)}finally{k.forEach((H,ee)=>{ee!==P&&H.cancel()})}}e.$lg=u;function d(k,P,z){let H;const ee=setTimeout(()=>{H?.(void 0),z?.()},P);return Promise.race([k.finally(()=>clearTimeout(ee)),new Promise(ne=>H=ne)])}e.$mg=d;function p(k){return new Promise((P,z)=>{const H=k();g(H)?H.then(P,z):P(H)})}e.$ng=p;class c{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(P){if(this.f)throw new Error("Throttler is disposed");if(this.a){if(this.d=P,!this.b){const z=()=>{if(this.b=null,this.f)return;const H=this.queue(this.d);return this.d=null,H};this.b=new Promise(H=>{this.a.then(z,z).then(H)})}return new Promise((z,H)=>{this.b.then(z,H)})}return this.a=P(),new Promise((z,H)=>{this.a.then(ee=>{this.a=null,z(ee)},ee=>{this.a=null,H(ee)})})}dispose(){this.f=!0}}e.$og=c;class h{constructor(){this.a=Promise.resolve(null)}queue(P){return this.a=this.a.then(()=>P(),()=>P())}}e.$pg=h;class f{constructor(){this.a=new Map}queue(P,z){const ee=(this.a.get(P)??Promise.resolve()).catch(()=>{}).then(z).finally(()=>{this.a.get(P)===ee&&this.a.delete(P)});return this.a.set(P,ee),ee}}e.$qg=f;const b=(k,P)=>{let z=!0;const H=setTimeout(()=>{z=!1,P()},k);return{isTriggered:()=>z,dispose:()=>{clearTimeout(H),z=!1}}},w=k=>{let P=!0;return queueMicrotask(()=>{P&&(P=!1,k())}),{isTriggered:()=>P,dispose:()=>{P=!1}}};class I{constructor(P){this.defaultDelay=P,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(P,z=this.defaultDelay){this.g=P,this.h(),this.b||(this.b=new Promise((ee,ne)=>{this.d=ee,this.f=ne}).then(()=>{if(this.b=null,this.d=null,this.g){const ee=this.g;return this.g=null,ee()}}));const H=()=>{this.a=null,this.d?.(null)};return this.a=z===S.$bc?w(H):b(z,H),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new N.$3),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$rg=I;class t{constructor(P){this.a=new I(P),this.b=new c}trigger(P,z){return this.a.trigger(()=>this.b.queue(P),z)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$sg=t;class o{constructor(){this.a=!1,this.b=new Promise((P,z)=>{this.d=P})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$tg=o;class s extends o{constructor(P){super(),this.f=setTimeout(()=>this.open(),P)}open(){clearTimeout(this.f),super.open()}}e.$ug=s;function n(k,P){return P?new Promise((z,H)=>{const ee=setTimeout(()=>{ne.dispose(),z()},k),ne=P.onCancellationRequested(()=>{clearTimeout(ee),ne.dispose(),H(new N.$3)})}):C(z=>n(k,z))}e.$vg=n;function i(k,P=0){const z=setTimeout(k,P);return(0,A.$jb)(()=>clearTimeout(z))}e.$wg=i;function r(k){const P=[];let z=0;const H=k.length;function ee(){return z<H?k[z++]():null}function ne(fe){fe!=null&&P.push(fe);const x=ee();return x?x.then(ne):Promise.resolve(P)}return Promise.resolve(null).then(ne)}e.$xg=r;function a(k,P=H=>!!H,z=null){let H=0;const ee=k.length,ne=()=>{if(H>=ee)return Promise.resolve(z);const fe=k[H++];return Promise.resolve(fe()).then(se=>P(se)?Promise.resolve(se):ne())};return ne()}e.$yg=a;function v(k,P=H=>!!H,z=null){if(k.length===0)return Promise.resolve(z);let H=k.length;const ee=()=>{H=-1;for(const ne of k)ne.cancel?.()};return new Promise((ne,fe)=>{for(const x of k)x.then(se=>{--H>=0&&P(se)?(ee(),ne(se)):H===0&&ne(z)}).catch(se=>{--H>=0&&(ee(),fe(se))})})}e.$zg=v;class m{constructor(P){this.a=0,this.d=P,this.f=[],this.b=0,this.g=new O.$ec}get onDrained(){return this.g.event}get size(){return this.a}queue(P){return this.a++,new Promise((z,H)=>{this.f.push({factory:P,c:z,e:H}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const P=this.f.shift();this.b++;const z=P.factory();z.then(P.c,P.e),z.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Ag=m;class l extends m{constructor(){super(1)}}e.$Bg=l;class E{constructor(){this.a=new X,this.b=0}queue(P){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,P())):this.a.run(this.b++,P())}}e.$Cg=E;class D{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const P=new B;return this.b.add(P),P.p}d(){for(const[,P]of this.a)if(P.size>0)return!1;return!0}queueFor(P,z=j.$Yf){const H=z.getComparisonKey(P);let ee=this.a.get(H);return ee||(ee=new l,O.Event.once(ee.onDrained)(()=>{ee?.dispose(),this.a.delete(H),this.f()}),this.a.set(H,ee)),ee}f(){this.d()&&this.g()}g(){for(const P of this.b)P.complete();this.b.clear()}dispose(){for(const[,P]of this.a)P.dispose();this.a.clear(),this.g()}}e.$Dg=D;class T{constructor(P,z){this.a=-1,typeof P=="function"&&typeof z=="number"&&this.setIfNotSet(P,z)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(P,z){this.cancel(),this.a=setTimeout(()=>{this.a=-1,P()},z)}setIfNotSet(P,z){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,P()},z))}}e.$Eg=T;class M{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(P,z){this.cancel(),this.a=setInterval(()=>{P()},z)}}e.$Fg=M;class F{constructor(P,z){this.b=-1,this.a=P,this.d=z,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(P=this.d){this.cancel(),this.b=setTimeout(this.f,P)}get delay(){return this.d}set delay(P){this.d=P}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Gg=F;class V{constructor(P,z){z%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${z}ms is not a multiple of 1000ms.`),this.a=P,this.b=z,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(P=this.b){P%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${P}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(P/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Hg=V;class Z extends F{constructor(P,z){super(P,z),this.j=[]}work(P){this.j.push(P),this.isScheduled()||this.schedule()}h(){const P=this.j;this.j=[],this.a?.(P)}dispose(){this.j=[],super.dispose()}}e.$Ig=Z;class J extends A.$lb{constructor(P,z){super(),this.g=P,this.h=z,this.a=[],this.b=this.B(new A.$mb),this.f=!1}get pending(){return this.a.length}work(P){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+P.length>this.g.maxBufferedWork)return!1}else if(this.pending+P.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const z of P)this.a.push(z);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new F(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Jg=J,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$Kg=k=>{(0,R.$A)(()=>{if(P)return;const z=Date.now()+15;k(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,z-Date.now())}}))});let P=!1;return{dispose(){P||(P=!0)}}}:e.$Kg=(k,P)=>{const z=requestIdleCallback(k,typeof P=="number"?{timeout:P}:void 0);let H=!1;return{dispose(){H||(H=!0,cancelIdleCallback(z))}}}}();class Q{constructor(P){this.d=!1,this.a=()=>{try{this.f=P()}catch(z){this.g=z}finally{this.d=!0}},this.b=(0,e.$Kg)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$Lg=Q;async function G(k,P,z){let H;for(let ee=0;ee<z;ee++)try{return await k()}catch(ne){H=ne,await n(P)}throw H}e.$Mg=G;class X{isRunning(P){return typeof P=="number"?this.a?.taskId===P:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(P,z,H){return this.a={taskId:P,cancel:()=>H?.(),promise:z},z.then(()=>this.d(P),()=>this.d(P)),z}d(P){this.a&&P===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const P=this.b;this.b=void 0,P.run().then(P.promiseResolve,P.promiseReject)}}queue(P){if(this.b)this.b.run=P;else{let z,H;const ee=new Promise((ne,fe)=>{z=ne,H=fe});this.b={run:P,promise:ee,promiseResolve:z,promiseReject:H}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Ng=X;class W{constructor(P,z=()=>Date.now()){this.d=P,this.f=z,this.a=0,this.b=0}increment(){const P=this.f();return P-this.a>this.d&&(this.a=P,this.b=0),this.b++,this.b}}e.$Og=W;var q;(function(k){k[k.Resolved=0]="Resolved",k[k.Rejected=1]="Rejected"})(q||(q={}));class B{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((P,z)=>{this.a=P,this.b=z})}complete(P){return new Promise(z=>{this.a(P),this.d={outcome:0,value:P},z()})}error(P){return new Promise(z=>{this.b(P),this.d={outcome:1,value:P},z()})}cancel(){return this.error(new N.$3)}}e.$Pg=B;var _;(function(k){async function P(H){let ee;const ne=await Promise.all(H.map(fe=>fe.then(x=>x,x=>{ee||(ee=x)})));if(typeof ee<"u")throw ee;return ne}k.settled=P;function z(H){return new Promise(async(ee,ne)=>{try{await H(ee,ne)}catch(fe){ne(fe)}})}k.withAsyncBody=z})(_||(e.Promises=_={}));var oe;(function(k){k[k.Initial=0]="Initial",k[k.DoneOK=1]="DoneOK",k[k.DoneError=2]="DoneError"})(oe||(oe={}));class ae{static fromArray(P){return new ae(z=>{z.emitMany(P)})}static fromPromise(P){return new ae(async z=>{z.emitMany(await P)})}static fromPromises(P){return new ae(async z=>{await Promise.all(P.map(async H=>z.emitOne(await H)))})}static merge(P){return new ae(async z=>{await Promise.all(P.map(async H=>{for await(const ee of H)z.emitOne(ee)}))})}static{this.EMPTY=ae.fromArray([])}constructor(P){this.a=0,this.b=[],this.d=null,this.f=new O.$ec,queueMicrotask(async()=>{const z={emitOne:H=>this.g(H),emitMany:H=>this.h(H),reject:H=>this.k(H)};try{await Promise.resolve(P(z)),this.j()}catch(H){this.k(H)}finally{z.emitOne=void 0,z.emitMany=void 0,z.reject=void 0}})}[Symbol.asyncIterator](){let P=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(P<this.b.length)return{done:!1,value:this.b[P++]};if(this.a===1)return{done:!0,value:void 0};await O.Event.toPromise(this.f.event)}while(!0)}}}static map(P,z){return new ae(async H=>{for await(const ee of P)H.emitOne(z(ee))})}map(P){return ae.map(this,P)}static filter(P,z){return new ae(async H=>{for await(const ee of P)z(ee)&&H.emitOne(ee)})}filter(P){return ae.filter(this,P)}static coalesce(P){return ae.filter(P,z=>!!z)}coalesce(){return ae.coalesce(this)}static async toPromise(P){const z=[];for await(const H of P)z.push(H);return z}toPromise(){return ae.toPromise(this)}g(P){this.a===0&&(this.b.push(P),this.f.fire())}h(P){this.a===0&&(this.b=this.b.concat(P),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(P){this.a===0&&(this.a=2,this.d=P,this.f.fire())}}e.$Qg=ae;class Y extends ae{constructor(P,z){super(z),this.l=P}cancel(){this.l.cancel()}}e.$Rg=Y;function U(k){const P=new L.$oc,z=k(P.token);return new Y(P,async H=>{const ee=P.token.onCancellationRequested(()=>{ee.dispose(),P.dispose(),H.reject(new N.$3)});try{for await(const ne of z){if(P.token.isCancellationRequested)return;H.emitOne(ne)}ee.dispose(),P.dispose()}catch(ne){ee.dispose(),P.dispose(),H.reject(ne)}})}e.$Sg=U}),define(ce[91],le([0,1,20,5,48,35,16,6,28]),function(ie,e,L,N,O,A,j,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=void 0;function g(){return Object.create(null)}e.$_i=g,e.$aj="**",e.$bj="/";const C="[/\\\\]",y="[^/\\\\]",$=/\//g;function u(X,W){switch(X){case 0:return"";case 1:return`${y}*?`;default:return`(?:${C}|${y}+${C}${W?`|${C}${y}+`:""})*?`}}function d(X,W){if(!X)return[];const q=[];let B=!1,_=!1,oe="";for(const ae of X){switch(ae){case W:if(!B&&!_){q.push(oe),oe="";continue}break;case"{":B=!0;break;case"}":B=!1;break;case"[":_=!0;break;case"]":_=!1;break}oe+=ae}return oe&&q.push(oe),q}e.$cj=d;function p(X){if(!X)return"";let W="";const q=d(X,e.$bj);if(q.every(B=>B===e.$aj))W=".*";else{let B=!1;q.forEach((_,oe)=>{if(_===e.$aj){if(B)return;W+=u(2,oe===q.length-1)}else{let ae=!1,Y="",U=!1,k="";for(const P of _){if(P!=="}"&&ae){Y+=P;continue}if(U&&(P!=="]"||!k)){let z;P==="-"?z=P:(P==="^"||P==="!")&&!k?z="^":P===e.$bj?z="":z=(0,S.$pd)(P),k+=z;continue}switch(P){case"{":ae=!0;continue;case"[":U=!0;continue;case"}":{const H=`(?:${d(Y,",").map(ee=>p(ee)).join("|")})`;W+=H,ae=!1,Y="";break}case"]":{W+="["+k+"]",U=!1,k="";break}case"?":W+=y;continue;case"*":W+=u(1);continue;default:W+=(0,S.$pd)(P)}}oe<q.length-1&&(q[oe+1]!==e.$aj||oe+2<q.length)&&(W+=C)}B=_===e.$aj})}return W}const c=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,f=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,b=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,w=/^\*\*((\/[\w\.-]+)+)\/?$/,I=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new A.$qi(1e4),o=function(){return!1},s=function(){return null};function n(X,W){if(!X)return s;let q;typeof X!="string"?q=X.pattern:q=X,q=q.trim();const B=`${q}_${!!W.trimForExclusions}`;let _=t.get(B);if(_)return i(_,X);let oe;return c.test(q)?_=a(q.substr(4),q):(oe=h.exec(r(q,W)))?_=v(oe[1],q):(W.trimForExclusions?b:f).test(q)?_=m(q,W):(oe=w.exec(r(q,W)))?_=l(oe[1].substr(1),q,!0):(oe=I.exec(r(q,W)))?_=l(oe[1],q,!1):_=E(q),t.set(B,_),i(_,X)}function i(X,W){if(typeof W=="string")return X;const q=function(B,_){return(0,O.$He)(B,W.base,!R.$k)?X((0,S.$td)(B.substr(W.base.length),j.sep),_):null};return q.allBasenames=X.allBasenames,q.allPaths=X.allPaths,q.basenames=X.basenames,q.patterns=X.patterns,q}function r(X,W){return W.trimForExclusions&&X.endsWith("/**")?X.substr(0,X.length-2):X}function a(X,W){return function(q,B){return typeof q=="string"&&q.endsWith(X)?W:null}}function v(X,W){const q=`/${X}`,B=`\\${X}`,_=function(ae,Y){return typeof ae!="string"?null:Y?Y===X?W:null:ae===X||ae.endsWith(q)||ae.endsWith(B)?W:null},oe=[X];return _.basenames=oe,_.patterns=[W],_.allBasenames=oe,_}function m(X,W){const q=Q(X.slice(1,-1).split(",").map(Y=>n(Y,W)).filter(Y=>Y!==s),X),B=q.length;if(!B)return s;if(B===1)return q[0];const _=function(Y,U){for(let k=0,P=q.length;k<P;k++)if(q[k](Y,U))return X;return null},oe=q.find(Y=>!!Y.allBasenames);oe&&(_.allBasenames=oe.allBasenames);const ae=q.reduce((Y,U)=>U.allPaths?Y.concat(U.allPaths):Y,[]);return ae.length&&(_.allPaths=ae),_}function l(X,W,q){const B=j.sep===j.$5c.sep,_=B?X:X.replace($,j.sep),oe=j.sep+_,ae=j.$5c.sep+X;let Y;return q?Y=function(U,k){return typeof U=="string"&&(U===_||U.endsWith(oe)||!B&&(U===X||U.endsWith(ae)))?W:null}:Y=function(U,k){return typeof U=="string"&&(U===_||!B&&U===X)?W:null},Y.allPaths=[(q?"*/":"./")+X],Y}function E(X){try{const W=new RegExp(`^${p(X)}$`);return function(q){return W.lastIndex=0,typeof q=="string"&&W.test(q)?X:null}}catch{return s}}function D(X,W,q){return!X||typeof W!="string"?!1:T(X)(W,void 0,q)}e.$dj=D;function T(X,W={}){if(!X)return o;if(typeof X=="string"||M(X)){const q=n(X,W);if(q===s)return o;const B=function(_,oe){return!!q(_,oe)};return q.allBasenames&&(B.allBasenames=q.allBasenames),q.allPaths&&(B.allPaths=q.allPaths),B}return Z(X,W)}e.$ej=T;function M(X){const W=X;return W?typeof W.base=="string"&&typeof W.pattern=="string":!1}e.$fj=M;function F(X){return X.allBasenames||[]}e.$gj=F;function V(X){return X.allPaths||[]}e.$hj=V;function Z(X,W){const q=Q(Object.getOwnPropertyNames(X).map(Y=>J(Y,X[Y],W)).filter(Y=>Y!==s)),B=q.length;if(!B)return s;if(!q.some(Y=>!!Y.requiresSiblings)){if(B===1)return q[0];const Y=function(P,z){let H;for(let ee=0,ne=q.length;ee<ne;ee++){const fe=q[ee](P,z);if(typeof fe=="string")return fe;(0,N.$hg)(fe)&&(H||(H=[]),H.push(fe))}return H?(async()=>{for(const ee of H){const ne=await ee;if(typeof ne=="string")return ne}return null})():null},U=q.find(P=>!!P.allBasenames);U&&(Y.allBasenames=U.allBasenames);const k=q.reduce((P,z)=>z.allPaths?P.concat(z.allPaths):P,[]);return k.length&&(Y.allPaths=k),Y}const _=function(Y,U,k){let P,z;for(let H=0,ee=q.length;H<ee;H++){const ne=q[H];ne.requiresSiblings&&k&&(U||(U=(0,j.$_c)(Y)),P||(P=U.substr(0,U.length-(0,j.$ad)(Y).length)));const fe=ne(Y,U,P,k);if(typeof fe=="string")return fe;(0,N.$hg)(fe)&&(z||(z=[]),z.push(fe))}return z?(async()=>{for(const H of z){const ee=await H;if(typeof ee=="string")return ee}return null})():null},oe=q.find(Y=>!!Y.allBasenames);oe&&(_.allBasenames=oe.allBasenames);const ae=q.reduce((Y,U)=>U.allPaths?Y.concat(U.allPaths):Y,[]);return ae.length&&(_.allPaths=ae),_}function J(X,W,q){if(W===!1)return s;const B=n(X,q);if(B===s)return s;if(typeof W=="boolean")return B;if(W){const _=W.when;if(typeof _=="string"){const oe=(ae,Y,U,k)=>{if(!k||!B(ae,Y))return null;const P=_.replace("$(basename)",()=>U),z=k(P);return(0,N.$hg)(z)?z.then(H=>H?X:null):z?X:null};return oe.requiresSiblings=!0,oe}}return B}function Q(X,W){const q=X.filter(Y=>!!Y.basenames);if(q.length<2)return X;const B=q.reduce((Y,U)=>{const k=U.basenames;return k?Y.concat(k):Y},[]);let _;if(W){_=[];for(let Y=0,U=B.length;Y<U;Y++)_.push(W)}else _=q.reduce((Y,U)=>{const k=U.patterns;return k?Y.concat(k):Y},[]);const oe=function(Y,U){if(typeof Y!="string")return null;if(!U){let P;for(P=Y.length;P>0;P--){const z=Y.charCodeAt(P-1);if(z===47||z===92)break}U=Y.substr(P)}const k=B.indexOf(U);return k!==-1?_[k]:null};oe.basenames=B,oe.patterns=_,oe.allBasenames=B;const ae=X.filter(Y=>!Y.basenames);return ae.push(oe),ae}function G(X,W){return(0,L.$$e)(X,W,(q,B)=>typeof q=="string"&&typeof B=="string"?q===B:typeof q!="string"&&typeof B!="string"?q.base===B.base&&q.pattern===B.pattern:!1)}e.$ij=G}),define(ce[92],le([0,1,14,10]),function(ie,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=e.$rm=e.$qm=e.$pm=e.$om=void 0;function O(y){return y.toJSON()}class A{constructor($){this.a=$}transformIncoming($){const u=this.a.transformIncoming($);return u===$?$:O(N.URI.from(u))}transformOutgoing($){const u=this.a.transformOutgoing($);return u===$?$:O(N.URI.from(u))}transformOutgoingURI($){const u=this.a.transformOutgoing($);return u===$?$:N.URI.from(u)}transformOutgoingScheme($){return this.a.transformOutgoingScheme($)}}e.$om=A,e.$pm=new class{transformIncoming(y){return y}transformOutgoing(y){return y}transformOutgoingURI(y){return y}transformOutgoingScheme(y){return y}};function j(y,$,u){if(!y||u>200)return null;if(typeof y=="object"){if(y instanceof N.URI)return $.transformOutgoing(y);for(const d in y)if(Object.hasOwnProperty.call(y,d)){const p=j(y[d],$,u+1);p!==null&&(y[d]=p)}}return null}function R(y,$){const u=j(y,$,0);return u===null?y:u}e.$qm=R;function S(y,$,u,d){if(!y||d>200)return null;if(typeof y=="object"){if(y.$mid===1)return u?N.URI.revive($.transformIncoming(y)):$.transformIncoming(y);if(y instanceof L.$Ec)return null;for(const p in y)if(Object.hasOwnProperty.call(y,p)){const c=S(y[p],$,u,d+1);c!==null&&(y[p]=c)}}return null}function g(y,$){const u=S(y,$,!1,0);return u===null?y:u}e.$rm=g;function C(y,$){const u=S(y,$,!0,0);return u===null?y:u}e.$sm=C}),define(ce[31],le([0,1,52,36,267,5,48,88,16,6,22,10]),function(ie,e,L,N,O,A,j,R,S,g,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var $;(function(J){J[J.UNLINK=0]="UNLINK",J[J.MOVE=1]="MOVE"})($||(e.RimRafMode=$={}));async function u(J,Q=$.UNLINK,G){if((0,j.$Ke)(J))throw new Error("rimraf - will refuse to recursively delete root");return Q===$.UNLINK?p(J):d(J,G)}async function d(J,Q=(0,j.$Pe)((0,N.tmpdir)())){try{try{await L.promises.rename(J,Q)}catch(G){return G.code==="ENOENT"?void 0:p(J)}p(Q).catch(G=>{})}catch(G){if(G.code!=="ENOENT")throw G}}async function p(J){return(0,O.promisify)(L.rm)(J,{recursive:!0,force:!0,maxRetries:3})}function c(J){if((0,j.$Ke)(J))throw new Error("rimraf - will refuse to recursively delete root");L.rmSync(J,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=c;async function h(J,Q){return w(await(Q?f(J):(0,O.promisify)(L.readdir)(J)))}async function f(J){try{return await(0,O.promisify)(L.readdir)(J,{withFileTypes:!0})}catch(X){console.warn("[node.js fs] readdir with filetypes failed with error: ",X)}const Q=[],G=await h(J);for(const X of G){let W=!1,q=!1,B=!1;try{const _=await e.Promises.lstat((0,S.$8c)(J,X));W=_.isFile(),q=_.isDirectory(),B=_.isSymbolicLink()}catch(_){console.warn("[node.js fs] unexpected error from lstat after readdir: ",_)}Q.push({name:X,isFile:()=>W,isDirectory:()=>q,isSymbolicLink:()=>B})}return Q}function b(J){return w(L.readdirSync(J))}e.readdirSync=b;function w(J){return J.map(Q=>typeof Q=="string"?g.$j?(0,R.$7k)(Q):Q:(Q.name=g.$j?(0,R.$7k)(Q.name):Q.name,Q))}async function I(J){const Q=await h(J),G=[];for(const X of Q)await o.existsDirectory((0,S.$8c)(J,X))&&G.push(X);return G}function t(J,Q=1e3){return new Promise(G=>{let X=!1;const W=setInterval(()=>{X||(X=!0,L.access(J,q=>{X=!1,q&&(clearInterval(W),G(void 0))}))},Q)})}e.whenDeleted=t;var o;(function(J){async function Q(W){let q;try{if(q=await e.Promises.lstat(W),!q.isSymbolicLink())return{stat:q}}catch{}try{return{stat:await e.Promises.stat(W),symbolicLink:q?.isSymbolicLink()?{dangling:!1}:void 0}}catch(B){if(B.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};if(g.$i&&B.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(W)),symbolicLink:{dangling:!1}}}catch(_){if(_.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};throw _}throw B}}J.stat=Q;async function G(W){try{const{stat:q,symbolicLink:B}=await J.stat(W);return q.isFile()&&B?.dangling!==!0}catch{}return!1}J.existsFile=G;async function X(W){try{const{stat:q,symbolicLink:B}=await J.stat(W);return q.isDirectory()&&B?.dangling!==!0}catch{}return!1}J.existsDirectory=X})(o||(e.SymlinkSupport=o={}));const s=new A.$Dg;function n(J,Q,G){return s.queueFor(y.URI.file(J),C.$Zf).queue(()=>{const X=m(G);return new Promise((W,q)=>a(J,Q,X,B=>B?q(B):W()))})}let i=!0;function r(J){i=J}e.configureFlushOnWrite=r;function a(J,Q,G,X){if(!i)return L.writeFile(J,Q,{mode:G.mode,flag:G.flag},X);L.open(J,G.flag,G.mode,(W,q)=>{if(W)return X(W);L.writeFile(q,Q,B=>{if(B)return L.close(q,()=>X(B));L.fdatasync(q,_=>(_&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",_),r(!1)),L.close(q,oe=>X(oe))))})})}function v(J,Q,G){const X=m(G);if(!i)return L.writeFileSync(J,Q,{mode:X.mode,flag:X.flag});const W=L.openSync(J,X.flag,X.mode);try{L.writeFileSync(W,Q);try{L.fdatasyncSync(W)}catch(q){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",q),r(!1)}}finally{L.closeSync(W)}}e.writeFileSync=v;function m(J){return J?{mode:typeof J.mode=="number"?J.mode:438,flag:typeof J.flag=="string"?J.flag:"w"}:{mode:438,flag:"w"}}async function l(J,Q,G=6e4){if(J!==Q)try{g.$i&&typeof G=="number"?await E(J,Q,Date.now(),G):await(0,O.promisify)(L.rename)(J,Q)}catch(X){if(J.toLowerCase()!==Q.toLowerCase()&&X.code==="EXDEV"||J.endsWith("."))await D(J,Q,{preserveSymlinks:!1}),await u(J,$.MOVE);else throw X}}async function E(J,Q,G,X,W=0){try{return await(0,O.promisify)(L.rename)(J,Q)}catch(q){if(q.code!=="EACCES"&&q.code!=="EPERM"&&q.code!=="EBUSY")throw q;if(Date.now()-G>=X)throw console.error(`[node.js fs] rename failed after ${W} retries with error: ${q}`),q;if(W===0){let B=!1;try{const{stat:_}=await o.stat(Q);_.isFile()||(B=!0)}catch{}if(B)throw q}return await(0,A.$vg)(Math.min(100,W*10)),E(J,Q,G,X,W+1)}}async function D(J,Q,G){return M(J,Q,{root:{source:J,target:Q},options:G,handledSourcePaths:new Set})}const T=511;async function M(J,Q,G){if(G.handledSourcePaths.has(J))return;G.handledSourcePaths.add(J);const{stat:X,symbolicLink:W}=await o.stat(J);if(W){if(G.options.preserveSymlinks)try{return await Z(J,Q,G)}catch(q){console.warn("[node.js fs] copy of symlink failed: ",q)}if(W.dangling)return}return X.isDirectory()?F(J,Q,X.mode&T,G):V(J,Q,X.mode&T)}async function F(J,Q,G,X){await e.Promises.mkdir(Q,{recursive:!0,mode:G});const W=await h(J);for(const q of W)await M((0,S.$8c)(J,q),(0,S.$8c)(Q,q),X)}async function V(J,Q,G){await e.Promises.copyFile(J,Q),await e.Promises.chmod(Q,G)}async function Z(J,Q,G){let X=await e.Promises.readlink(J);(0,j.$He)(X,G.root.source,!g.$k)&&(X=(0,S.$8c)(G.root.target,X.substr(G.root.source.length+1))),await e.Promises.symlink(X,Q)}e.Promises=new class{get access(){return(0,O.promisify)(L.access)}get stat(){return(0,O.promisify)(L.stat)}get lstat(){return(0,O.promisify)(L.lstat)}get utimes(){return(0,O.promisify)(L.utimes)}get read(){return(J,Q,G,X,W)=>new Promise((q,B)=>{L.read(J,Q,G,X,W,(_,oe,ae)=>_?B(_):q({bytesRead:oe,buffer:ae}))})}get readFile(){return(0,O.promisify)(L.readFile)}get write(){return(J,Q,G,X,W)=>new Promise((q,B)=>{L.write(J,Q,G,X,W,(_,oe,ae)=>_?B(_):q({bytesWritten:oe,buffer:ae}))})}get appendFile(){return(0,O.promisify)(L.appendFile)}get fdatasync(){return(0,O.promisify)(L.fdatasync)}get truncate(){return(0,O.promisify)(L.truncate)}get copyFile(){return(0,O.promisify)(L.copyFile)}get open(){return(0,O.promisify)(L.open)}get close(){return(0,O.promisify)(L.close)}get symlink(){return(0,O.promisify)(L.symlink)}get readlink(){return(0,O.promisify)(L.readlink)}get chmod(){return(0,O.promisify)(L.chmod)}get mkdir(){return(0,O.promisify)(L.mkdir)}get unlink(){return(0,O.promisify)(L.unlink)}get rmdir(){return(0,O.promisify)(L.rmdir)}get realpath(){return(0,O.promisify)(L.realpath)}async exists(J){try{return await e.Promises.access(J),!0}catch{return!1}}get readdir(){return h}get readDirsInDir(){return I}get writeFile(){return n}get rm(){return u}get rename(){return l}get copy(){return D}}}),define(ce[142],le([0,1,52,16,6,28,31]),function(ie,e,L,N,O,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=e.$Np=e.$Mp=e.$Lp=void 0;function R($){if(O.$k)return $;const u=(0,N.$$c)($);if($===u)return $;const d=((0,N.$_c)($)||$).toLowerCase();try{const c=(0,j.readdirSync)(u).filter(h=>h.toLowerCase()===d);if(c.length===1){const h=R(u);if(h)return(0,N.$8c)(h,c[0])}else if(c.length>1){const h=c.indexOf(d);if(h>=0){const f=R(u);if(f)return(0,N.$8c)(f,c[h])}}}catch{}return null}e.$Lp=R;async function S($){if(O.$k)return $;const u=(0,N.$$c)($);if($===u)return $;const d=((0,N.$_c)($)||$).toLowerCase();try{const c=(await j.Promises.readdir(u)).filter(h=>h.toLowerCase()===d);if(c.length===1){const h=await S(u);if(h)return(0,N.$8c)(h,c[0])}else if(c.length>1){const h=c.indexOf(d);if(h>=0){const f=await S(u);if(f)return(0,N.$8c)(f,c[h])}}}catch{}return null}e.$Mp=S;async function g($){try{return await j.Promises.realpath($)}catch{const d=y($);return await j.Promises.access(d,L.constants.R_OK),d}}e.$Np=g;function C($){try{return L.realpathSync($)}catch{const d=y($);return L.accessSync(d,L.constants.R_OK),d}}e.$Op=C;function y($){return(0,A.$ud)((0,N.$6c)($),N.sep)}}),define(ce[143],le([0,1,16,6,37,90,11,31]),function(ie,e,L,N,O,A,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$il=e.$hl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function S(y=O.env){return y.comspec||"cmd.exe"}e.$hl=S;function g(y){let $=[],u=!1;const d=function(p){if(u){$.push(p);return}(!y.send(p,h=>{if(h&&console.error(h),u=!1,$.length>0){const f=$.slice(0);$=[],f.forEach(b=>d(b))}})||N.$i)&&(u=!0)};return{send:d}}e.$il=g;var C;(function(y){async function $(u,d,p){if(L.$7c(u))return u;if(d===void 0&&(d=O.cwd()),L.$$c(u)!=="."||(p===void 0&&j.$ie(O.env.PATH)&&(p=O.env.PATH.split(L.$fd)),p===void 0||p.length===0))return L.$8c(d,u);async function h(f){if(await R.Promises.exists(f)){let b;try{b=await R.Promises.stat(f)}catch(w){w.message.startsWith("EACCES")&&(b=await R.Promises.lstat(f))}return b?!b.isDirectory():!1}return!1}for(const f of p){let b;if(L.$7c(f)?b=L.$8c(f,u):b=L.$8c(d,f,u),await h(b))return b;let w=b+".com";if(await h(w)||(w=b+".exe",await h(w)))return w}return L.$8c(d,u)}y.findExecutable=$})(C||(e.win32=C={}))}),define(ce[144],le([0,1,64,26]),function(ie,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=void 0;function O(j){return new Promise((R,S)=>{let g;const C=new Map;function y(u,d,p,c,h){const f=C.get(d);if(u===j||f){const b={name:$(p),cmd:p,pid:u,ppid:d,load:c,mem:h};C.set(u,b),u===j&&(g=b),f&&(f.children||(f.children=[]),f.children.push(b),f.children.length>1&&(f.children=f.children.sort((w,I)=>w.pid-I.pid)))}}function $(u){const d=/--utility-sub-type=network/i,p=/--ms-enable-electron-run-as-node/i,c=/--crashes-directory/i,h=/\\pipe\\winpty-control/i,f=/conhost\.exe.+--headless/i,b=/--type=([a-zA-Z-]+)/;if(c.exec(u))return"electron-crash-reporter";if(h.exec(u))return"winpty-agent";if(f.exec(u))return"conpty-agent";let w=b.exec(u);if(w&&w.length===2)return w[1]==="renderer"?"window":w[1]==="utility"?d.exec(u)?"utility-network-service":"utility-process":w[1]==="extensionHost"?"extension-host":w[1];const I=/[a-zA-Z-]+\.js/g;let t="";do w=I.exec(u),w&&(t+=w+" ");while(w);return t&&u.indexOf("node ")<0&&u.indexOf("node.exe")<0?`electron-nodejs (${t})`:p.exec(u)?`electron-nodejs (${u})`:u}if(process.platform==="win32"){const u=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substring(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substring(5):d;new Promise((d,p)=>{ie(["@vscode/windows-process-tree"],d,p)}).then(d=>{d.getProcessList(j,p=>{if(!p){S(new Error(`Root process ${j} not found`));return}d.getProcessCpuUsage(p,c=>{const h=new Map;c.forEach(f=>{const b=u(f.commandLine||"");h.set(f.pid,{name:$(b),cmd:b,pid:f.pid,ppid:f.ppid,load:f.cpu||0,mem:f.memory||0})}),g=h.get(j),g?(h.forEach(f=>{const b=h.get(f.ppid);b&&(b.children||(b.children=[]),b.children.push(f))}),h.forEach(f=>{f.children&&(f.children=f.children.sort((b,w)=>b.pid-w.pid))}),R(g)):S(new Error(`Root process ${j} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let u=function(){let d=[g];const p=[];for(;d.length;){const h=d.shift();h&&(p.push(h.pid),h.children&&(d=d.concat(h.children)))}let c=JSON.stringify(N.$1e.asFileUri("vs/base/node/cpuUsage.sh").fsPath);c+=" "+p.join(" "),(0,L.exec)(c,{},(h,f,b)=>{if(h||b)S(h||new Error(b.toString()));else{const w=f.toString().split(`
`);for(let I=0;I<p.length;I++){const t=C.get(p[I]);t.load=parseFloat(w[I])}if(!g){S(new Error(`Root process ${j} not found`));return}R(g)}})};(0,L.exec)("which ps",{},(d,p,c)=>{if(d||c)if(process.platform!=="linux")S(d||new Error(c.toString()));else{const h=JSON.stringify(N.$1e.asFileUri("vs/base/node/ps.sh").fsPath);(0,L.exec)(h,{},(f,b,w)=>{f||w?S(f||new Error(w.toString())):(A(b,y),u())})}else{const h=p.toString().trim(),f="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,L.exec)(`${h} ${f}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(b,w,I)=>{b||I&&!I.includes("screen size is bogus")?S(b||new Error(I.toString())):(A(w,y),process.platform==="linux"?u():g?R(g):S(new Error(`Root process ${j} not found`)))})}})}})}e.$jr=O;function A(j,R){const S=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,g=j.toString().split(`
`);for(const C of g){const y=S.exec(C.trim());y&&y.length===6&&R(parseInt(y[1]),parseInt(y[2]),y[5],parseFloat(y[3]),parseFloat(y[4]))}}});var ye=this&&this.__decorate||function(ie,e,L,N){var O=arguments.length,A=O<3?e:N===null?N=Object.getOwnPropertyDescriptor(e,L):N,j;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(ie,e,L,N);else for(var R=ie.length-1;R>=0;R--)(j=ie[R])&&(A=(O<3?j(A):O>3?j(e,L,A):j(e,L))||A);return O>3&&A&&Object.defineProperty(e,L,A),A};define(ce[43],le([0,1,20,5,14,25,83,8,3,2,63,28,11]),function(ie,e,L,N,O,A,j,R,S,g,C,y,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$g=e.ProxyChannel=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.RequestInitiator=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=void 0;var u;(function(W){W[W.Promise=100]="Promise",W[W.PromiseCancel=101]="PromiseCancel",W[W.EventListen=102]="EventListen",W[W.EventDispose=103]="EventDispose"})(u||(u={}));function d(W){switch(W){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(W){W[W.Initialize=200]="Initialize",W[W.PromiseSuccess=201]="PromiseSuccess",W[W.PromiseError=202]="PromiseError",W[W.PromiseErrorObj=203]="PromiseErrorObj",W[W.EventFire=204]="EventFire"})(p||(p={}));function c(W){switch(W){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(W){W[W.Uninitialized=0]="Uninitialized",W[W.Idle=1]="Idle"})(h||(h={}));function f(W){let q=0;for(let B=0;;B+=7){const _=W.read(1);if(q|=(_.buffer[0]&127)<<B,!(_.buffer[0]&128))return q}}const b=s(0);function w(W,q){if(q===0){W.write(b);return}let B=0;for(let oe=q;oe!==0;oe=oe>>>7)B++;const _=O.$Ec.alloc(B);for(let oe=0;q!==0;oe++)_.buffer[oe]=q&127,q=q>>>7,q>0&&(_.buffer[oe]|=128);W.write(_)}class I{constructor(q){this.b=q,this.a=0}read(q){const B=this.b.slice(this.a,this.a+q);return this.a+=B.byteLength,B}}e.$Zg=I;class t{constructor(){this.a=[]}get buffer(){return O.$Ec.concat(this.a)}write(q){this.a.push(q)}}e.$1g=t;var o;(function(W){W[W.Undefined=0]="Undefined",W[W.String=1]="String",W[W.Buffer=2]="Buffer",W[W.VSBuffer=3]="VSBuffer",W[W.Array=4]="Array",W[W.Object=5]="Object",W[W.Int=6]="Int"})(o||(o={}));function s(W){const q=O.$Ec.alloc(1);return q.writeUInt8(W,0),q}const n={Undefined:s(o.Undefined),String:s(o.String),Buffer:s(o.Buffer),VSBuffer:s(o.VSBuffer),Array:s(o.Array),Object:s(o.Object),Uint:s(o.Int)},i=typeof Buffer<"u";function r(W,q){if(typeof q>"u")W.write(n.Undefined);else if(typeof q=="string"){const B=O.$Ec.fromString(q);W.write(n.String),w(W,B.byteLength),W.write(B)}else if(i&&Buffer.isBuffer(q)){const B=O.$Ec.wrap(q);W.write(n.Buffer),w(W,B.byteLength),W.write(B)}else if(q instanceof O.$Ec)W.write(n.VSBuffer),w(W,q.byteLength),W.write(q);else if(Array.isArray(q)){W.write(n.Array),w(W,q.length);for(const B of q)r(W,B)}else if(typeof q=="number"&&(q|0)===q)W.write(n.Uint),w(W,q);else{const B=O.$Ec.fromString(JSON.stringify(q));W.write(n.Object),w(W,B.byteLength),W.write(B)}}e.$2g=r;function a(W){switch(W.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return W.read(f(W)).toString();case o.Buffer:return W.read(f(W)).buffer;case o.VSBuffer:return W.read(f(W));case o.Array:{const B=f(W),_=[];for(let oe=0;oe<B;oe++)_.push(a(W));return _}case o.Object:return JSON.parse(W.read(f(W)).toString());case o.Int:return f(W)}}e.$3g=a;class v{constructor(q,B,_=null,oe=1e3){this.h=q,this.j=B,this.k=_,this.l=oe,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ae=>this.q(ae)),this.m({type:200})}registerChannel(q,B){this.b.set(q,B),setTimeout(()=>this.w(q),0)}m(q){switch(q.type){case 200:{const B=this.o([q.type]);this.k?.logOutgoing(B,0,1,c(q.type));return}case 201:case 202:case 204:case 203:{const B=this.o([q.type,q.id],q.data);this.k?.logOutgoing(B,q.id,1,c(q.type),q.data);return}}}o(q,B=void 0){const _=new t;return r(_,q),r(_,B),this.p(_.buffer)}p(q){try{return this.h.send(q),q.byteLength}catch{return 0}}q(q){const B=new I(q),_=a(B),oe=a(B),ae=_[0];switch(ae){case 100:return this.k?.logIncoming(q.byteLength,_[1],1,`${d(ae)}: ${_[2]}.${_[3]}`,oe),this.s({type:ae,id:_[1],channelName:_[2],name:_[3],arg:oe});case 102:return this.k?.logIncoming(q.byteLength,_[1],1,`${d(ae)}: ${_[2]}.${_[3]}`,oe),this.t({type:ae,id:_[1],channelName:_[2],name:_[3],arg:oe});case 101:return this.k?.logIncoming(q.byteLength,_[1],1,`${d(ae)}`),this.u({type:ae,id:_[1]});case 103:return this.k?.logIncoming(q.byteLength,_[1],1,`${d(ae)}`),this.u({type:ae,id:_[1]})}}s(q){const B=this.b.get(q.channelName);if(!B){this.v(q);return}const _=new A.$oc;let oe;try{oe=B.call(this.j,q.name,q.arg,_.token)}catch(U){oe=Promise.reject(U)}const ae=q.id;oe.then(U=>{this.m({id:ae,data:U,type:201}),this.d.delete(q.id)},U=>{U instanceof Error?this.m({id:ae,data:{message:U.message,name:U.name,stack:U.stack?U.stack.split?U.stack.split(`
`):U.stack:void 0},type:202}):this.m({id:ae,data:U,type:203}),this.d.delete(q.id)});const Y=(0,g.$jb)(()=>_.cancel());this.d.set(q.id,Y)}t(q){const B=this.b.get(q.channelName);if(!B){this.v(q);return}const _=q.id,ae=B.listen(this.j,q.name,q.arg)(Y=>this.m({id:_,data:Y,type:204}));this.d.set(q.id,ae)}u(q){const B=this.d.get(q.id);B&&(B.dispose(),this.d.delete(q.id))}v(q){let B=this.g.get(q.channelName);B||(B=[],this.g.set(q.channelName,B));const _=setTimeout(()=>{console.error(`Unknown channel: ${q.channelName}`),q.type===100&&this.m({id:q.id,data:{name:"Unknown channel",message:`Channel name '${q.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);B.push({request:q,timeoutTimer:_})}w(q){const B=this.g.get(q);if(B){for(const _ of B)switch(clearTimeout(_.timeoutTimer),_.request.type){case 100:this.s(_.request);break;case 102:this.t(_.request);break}this.g.delete(q)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,g.$gb)(this.d.values()),this.d.clear()}}e.$4g=v;var m;(function(W){W[W.LocalSide=0]="LocalSide",W[W.OtherSide=1]="OtherSide"})(m||(e.RequestInitiator=m={}));class l{constructor(q,B=null){this.l=q,this.a=!1,this.b=h.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new S.$ec,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(_=>this.s(_)),this.j=B}getChannel(q){const B=this;return{call(_,oe,ae){return B.a?Promise.reject(new R.$3):B.m(q,_,oe,ae)},listen(_,oe){return B.a?S.Event.None:B.o(q,_,oe)}}}m(q,B,_,oe=A.CancellationToken.None){const ae=this.g++,U={id:ae,type:100,channelName:q,name:B,arg:_};if(oe.isCancellationRequested)return Promise.reject(new R.$3);let k;return new Promise((z,H)=>{if(oe.isCancellationRequested)return H(new R.$3);const ee=()=>{const se=te=>{switch(te.type){case 201:this.f.delete(ae),z(te.data);break;case 202:{this.f.delete(ae);const ue=new Error(te.data.message);ue.stack=Array.isArray(te.data.stack)?te.data.stack.join(`
`):te.data.stack,ue.name=te.data.name,H(ue);break}case 203:this.f.delete(ae),H(te.data);break}};this.f.set(ae,se),this.p(U)};let ne=null;this.b===h.Idle?ee():(ne=(0,N.$ig)(se=>this.u()),ne.then(()=>{ne=null,ee()}));const fe=()=>{ne?(ne.cancel(),ne=null):this.p({id:ae,type:101}),H(new R.$3)},x=oe.onCancellationRequested(fe);k=(0,g.$ib)((0,g.$jb)(fe),x),this.d.add(k)}).finally(()=>{this.d.delete(k)})}o(q,B,_){const oe=this.g++,Y={id:oe,type:102,channelName:q,name:B,arg:_};let U=null;const k=new S.$ec({onWillAddFirstListener:()=>{U=(0,N.$ig)(z=>this.u()),U.then(()=>{U=null,this.d.add(k),this.p(Y)})},onDidRemoveLastListener:()=>{U?(U.cancel(),U=null):(this.d.delete(k),this.p({id:oe,type:103}))}}),P=z=>k.fire(z.data);return this.f.set(oe,P),k.event}p(q){switch(q.type){case 100:case 102:{const B=this.q([q.type,q.id,q.channelName,q.name],q.arg);this.j?.logOutgoing(B,q.id,0,`${d(q.type)}: ${q.channelName}.${q.name}`,q.arg);return}case 101:case 103:{const B=this.q([q.type,q.id]);this.j?.logOutgoing(B,q.id,0,d(q.type));return}}}q(q,B=void 0){const _=new t;return r(_,q),r(_,B),this.r(_.buffer)}r(q){try{return this.l.send(q),q.byteLength}catch{return 0}}s(q){const B=new I(q),_=a(B),oe=a(B),ae=_[0];switch(ae){case 200:return this.j?.logIncoming(q.byteLength,0,0,c(ae)),this.t({type:_[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(q.byteLength,_[1],0,c(ae),oe),this.t({type:_[0],id:_[1],data:oe})}}t(q){if(q.type===200){this.b=h.Idle,this.k.fire();return}this.f.get(q.id)?.(q)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}u(){return this.b===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,g.$gb)(this.d.values()),this.d.clear()}}e.$5g=l,ye([j.$Tg],l.prototype,"onDidInitializePromise",null);class E{get connections(){const q=[];return this.f.forEach(B=>q.push(B)),q}constructor(q){this.a=new Map,this.f=new Set,this.g=new S.$ec,this.onDidAddConnection=this.g.event,this.h=new S.$ec,this.onDidRemoveConnection=this.h.event,q(({protocol:B,onDidClientDisconnect:_})=>{S.Event.once(B.onMessage)(ae=>{const Y=new I(ae),U=a(Y),k=new v(B,U),P=new l(B);this.a.forEach((H,ee)=>k.registerChannel(ee,H));const z={channelServer:k,channelClient:P,ctx:U};this.f.add(z),this.g.fire(z),_(()=>{k.dispose(),P.dispose(),this.f.delete(z),this.h.fire(z)})})})}getChannel(q,B){const _=this;return{call(oe,ae,Y){let U;if((0,$.$we)(B)){const P=(0,L.$Hf)(_.connections.filter(B));U=P?Promise.resolve(P):S.Event.toPromise(S.Event.filter(_.onDidAddConnection,B))}else U=B.routeCall(_,oe,ae);const k=U.then(P=>P.channelClient.getChannel(q));return T(k).call(oe,ae,Y)},listen(oe,ae){if((0,$.$we)(B))return _.j(q,B,oe,ae);const Y=B.routeEvent(_,oe,ae).then(U=>U.channelClient.getChannel(q));return T(Y).listen(oe,ae)}}}j(q,B,_,oe){const ae=this;let Y=new g.$kb;const U=new S.$ec({onWillAddFirstListener:()=>{Y=new g.$kb;const k=new S.$kc,P=new Map,z=ee=>{const fe=ee.channelClient.getChannel(q).listen(_,oe),x=k.add(fe);P.set(ee,x)},H=ee=>{const ne=P.get(ee);ne&&(ne.dispose(),P.delete(ee))};ae.connections.filter(B).forEach(z),S.Event.filter(ae.onDidAddConnection,B)(z,void 0,Y),ae.onDidRemoveConnection(H,void 0,Y),k.event(U.fire,U,Y),Y.add(k)},onDidRemoveLastListener:()=>{Y.dispose()}});return U.event}registerChannel(q,B){this.a.set(q,B),this.f.forEach(_=>{_.channelServer.registerChannel(q,B)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.$6g=E;class D{constructor(q,B,_=null){const oe=new t;r(oe,B),q.send(oe.buffer),this.a=new l(q,_),this.d=new v(q,B,_)}getChannel(q){return this.a.getChannel(q)}registerChannel(q,B){this.d.registerChannel(q,B)}dispose(){this.a.dispose(),this.d.dispose()}}e.$7g=D;function T(W){return{call(q,B,_){return W.then(oe=>oe.call(q,B,_))},listen(q,B){const _=new S.$nc;return W.then(oe=>_.input=oe.listen(q,B)),_.event}}}e.$8g=T;function M(W){let q=!1;return{call(B,_,oe){return q?W.call(B,_,oe):(0,N.$vg)(0).then(()=>q=!0).then(()=>W.call(B,_,oe))},listen(B,_){if(q)return W.listen(B,_);const oe=new S.$nc;return(0,N.$vg)(0).then(()=>q=!0).then(()=>oe.input=W.listen(B,_)),oe.event}}}e.$9g=M;class F{constructor(q){this.a=q}routeCall(q){return this.b(q)}routeEvent(q){return this.b(q)}async b(q){for(const B of q.connections)if(await Promise.resolve(this.a(B.ctx)))return Promise.resolve(B);return await S.Event.toPromise(q.onDidAddConnection),await this.b(q)}}e.$0g=F;var V;(function(W){function q(ae,Y){const U=ae,k=Y&&Y.disableMarshalling,P=new Map;for(const z in U)_(z)&&P.set(z,S.Event.buffer(U[z],!0));return new class{listen(z,H,ee){const ne=P.get(H);if(ne)return ne;if(oe(H)){const fe=U[H];if(typeof fe=="function")return fe.call(U,ee)}throw new R.$ab(`Event not found: ${H}`)}call(z,H,ee){const ne=U[H];if(typeof ne=="function"){if(!k&&Array.isArray(ee))for(let fe=0;fe<ee.length;fe++)ee[fe]=(0,C.$Yg)(ee[fe]);return ne.apply(U,ee)}throw new R.$ab(`Method not found: ${H}`)}}}W.fromService=q;function B(ae,Y){const U=Y&&Y.disableMarshalling;return new Proxy({},{get(k,P){if(typeof P=="string")return Y?.properties?.has(P)?Y.properties.get(P):oe(P)?function(z){return ae.listen(P,z)}:_(P)?ae.listen(P):async function(...z){let H;Y&&!(0,$.$re)(Y.context)?H=[Y.context,...z]:H=z;const ee=await ae.call(P,H);return U?ee:(0,C.$Yg)(ee)};throw new R.$ab(`Property not found: ${String(P)}`)}})}W.toService=B;function _(ae){return ae[0]==="o"&&ae[1]==="n"&&y.$Kd(ae.charCodeAt(2))}function oe(ae){return/^onDynamic/.test(ae)&&y.$Kd(ae.charCodeAt(9))}})(V||(e.ProxyChannel=V={}));const Z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function J(W){if(Array.isArray(W))return W;if(W&&typeof W=="object"&&typeof W.toString=="function"){const q=W.toString();if(q!=="[object Object]")return q}return W}function Q(W){return Array.isArray(W)?W.map(J):J(W)}function G(W,q,B,_,oe,ae,Y){Y=Q(Y);const U=Z[oe],k=U[_%U.length];let P=[`%c[${W}]%c[${String(q).padStart(7," ")}]%c[len: ${String(B).padStart(5," ")}]%c${String(_).padStart(5," ")} - ${ae}`,"color: darkgreen","color: grey","color: grey",`color: ${k}`];/\($/.test(ae)?(P=P.concat(Y),P.push(")")):P.push(Y),console.log.apply(console,P)}class X{constructor(q,B){this.d=q,this.f=B,this.a=0,this.b=0}logOutgoing(q,B,_,oe,ae){this.b+=q,G(this.d,this.b,q,B,_,oe,ae)}logIncoming(q,B,_,oe,ae){this.a+=q,G(this.f,this.a,q,B,_,oe,ae)}}e.$$g=X}),define(ce[65],le([0,1,14,3,2,43]),function(ie,e,L,N,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dh=e.$ch=e.$bh=e.$ah=e.ProtocolConstants=e.$_g=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var j;(function(n){n.Created="created",n.Read="read",n.Write="write",n.Open="open",n.Error="error",n.Close="close",n.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",n.NodeEndReceived="nodeEndReceived",n.NodeEndSent="nodeEndSent",n.NodeDrainBegin="nodeDrainBegin",n.NodeDrainEnd="nodeDrainEnd",n.zlibInflateError="zlibInflateError",n.zlibInflateData="zlibInflateData",n.zlibInflateInitialWrite="zlibInflateInitialWrite",n.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",n.zlibInflateWrite="zlibInflateWrite",n.zlibInflateFlushFired="zlibInflateFlushFired",n.zlibDeflateError="zlibDeflateError",n.zlibDeflateData="zlibDeflateData",n.zlibDeflateWrite="zlibDeflateWrite",n.zlibDeflateFlushFired="zlibDeflateFlushFired",n.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",n.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",n.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",n.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",n.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",n.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",n.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",n.ProtocolHeaderRead="protocolHeaderRead",n.ProtocolMessageRead="protocolMessageRead",n.ProtocolHeaderWrite="protocolHeaderWrite",n.ProtocolMessageWrite="protocolMessageWrite",n.ProtocolWrite="protocolWrite"})(j||(e.SocketDiagnosticsEventType=j={}));var R;(function(n){n.enableDiagnostics=!1,n.records=[];const i=new WeakMap;let r=0;function a(m,l){if(!i.has(m)){const E=String(++r);i.set(m,E)}return i.get(m)}function v(m,l,E,D){if(!n.enableDiagnostics)return;const T=a(m,l);if(D instanceof L.$Ec||D instanceof Uint8Array||D instanceof ArrayBuffer||ArrayBuffer.isView(D)){const M=L.$Ec.alloc(D.byteLength);M.set(D),n.records.push({timestamp:Date.now(),id:T,label:l,type:E,buff:M})}else n.records.push({timestamp:Date.now(),id:T,label:l,type:E,data:D})}n.traceSocketEvent=v})(R||(e.SocketDiagnostics=R={}));var S;(function(n){n[n.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",n[n.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(S||(e.SocketCloseEventType=S={}));let g=null;function C(){return g||(g=L.$Ec.alloc(0)),g}class y{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(i){this.a.push(i),this.b+=i.byteLength}read(i){return this.c(i,!0)}peek(i){return this.c(i,!1)}c(i,r){if(i===0)return C();if(i>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===i){const l=this.a[0];return r&&(this.a.shift(),this.b-=i),l}if(this.a[0].byteLength>i){const l=this.a[0].slice(0,i);return r&&(this.a[0]=this.a[0].slice(i),this.b-=i),l}const a=L.$Ec.alloc(i);let v=0,m=0;for(;i>0;){const l=this.a[m];if(l.byteLength>i){const E=l.slice(0,i);a.set(E,v),v+=i,r&&(this.a[m]=l.slice(i),this.b-=i),i-=i}else a.set(l,v),v+=l.byteLength,r?(this.a.shift(),this.b-=l.byteLength):m++,i-=l.byteLength}return a}}e.$_g=y;var $;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest",n[n.Pause=7]="Pause",n[n.Resume=8]="Resume",n[n.KeepAlive=9]="KeepAlive"})($||($={}));function u(n){switch(n){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var d;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.TimeoutTime=2e4]="TimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",n[n.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(d||(e.ProtocolConstants=d={}));class p{constructor(i,r,a,v){this.type=i,this.id=r,this.ack=a,this.data=v,this.writtenTime=0}get size(){return this.data.byteLength}}class c extends O.$lb{constructor(i){super(),this.f=this.B(new N.$ec),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=i,this.b=!1,this.c=new y,this.B(this.a.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(i){if(!(!i||i.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(i);this.c.byteLength>=this.g.readLen;){const r=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=r.readUInt32BE(9),this.g.messageType=r.readUInt8(0),this.g.id=r.readUInt32BE(1),this.g.ack=r.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:u(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const a=this.g.messageType,v=this.g.id,m=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",r),this.f.fire(new p(a,v,m,r)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class h{constructor(i){this.k=null,this.a=!1,this.b=!1,this.c=i,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(i){if(this.a)return;i.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=L.$Ec.alloc(13);r.writeUInt8(i.type,0),r.writeUInt32BE(i.id,1),r.writeUInt32BE(i.ack,5),r.writeUInt32BE(i.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:u(i.type),id:i.id,ack:i.ack,messageSize:i.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",i.data),this.j(r,i.data)}g(i,r){const a=this.f===0;return this.d.push(i,r),this.f+=i.byteLength+r.byteLength,a}h(){const i=L.$Ec.concat(this.d,this.f);return this.d.length=0,this.f=0,i}j(i,r){this.g(i,r)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const i=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:i.byteLength}),this.c.write(i)}}class f extends O.$lb{constructor(i){super(),this.f=new N.$ec,this.onMessage=this.f.event,this.g=new N.$ec,this.onDidDispose=this.g.event,this.a=i,this.b=this.B(new h(this.a)),this.c=this.B(new c(this.a)),this.B(this.c.onMessage(r=>{r.type===1&&this.f.fire(r.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(i){this.b.write(new p(1,0,0,i))}}e.$ah=f;class b extends A.$7g{static fromSocket(i,r){return new b(new f(i),r)}get onDidDispose(){return this.b.onDidDispose}constructor(i,r,a=null){super(i,r,a),this.b=i}dispose(){super.dispose();const i=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),i.end()}}e.$bh=b;class w{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new N.$ec({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(i){this.b?this.d.length>0?this.d.push(i):this.a.fire(i):this.d.push(i)}flushBuffer(){this.d=[]}}e.$ch=w;class I{constructor(i){this.data=i,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let i=0,r=this.a;for(;r;)r=r.next,i++;return i}peek(){return this.a?this.a.data:null}toArray(){const i=[];let r=0,a=this.a;for(;a;)i[r++]=a.data,a=a.next;return i}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(i){const r=new I(i);if(!this.a){this.a=r,this.b=r;return}this.b.next=r,this.b=r}}class o{static{this.a=10}static{this.b=null}static getInstance(){return o.b||(o.b=new o),o.b}constructor(){this.c=[];const i=Date.now();for(let r=0;r<o.a;r++)this.c[r]=i-1e3*r;setInterval(()=>{for(let r=o.a;r>=1;r--)this.c[r]=this.c[r-1];this.c[0]=Date.now()},1e3)}d(){const i=Date.now(),r=(1+o.a)*1e3;let a=0;for(let v=0;v<o.a;v++)i-this.c[v]<=r&&a++;return 1-a/o.a}hasHighLoad(){return this.d()>=.5}}class s{get unacknowledgedCount(){return this.c-this.d}constructor(i){this.u=new w,this.onControlMessage=this.u.event,this.v=new w,this.onMessage=this.v.event,this.w=new w,this.onDidDispose=this.w.event,this.x=new w,this.onSocketClose=this.x.event,this.y=new w,this.onSocketTimeout=this.y.event,this.s=i.loadEstimator??o.getInstance(),this.t=i.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new O.$kb,this.o=i.socket,this.p=this.r.add(new h(this.o)),this.q=this.r.add(new c(this.o)),this.r.add(this.q.onMessage(r=>this.z(r))),this.r.add(this.o.onClose(r=>this.x.fire(r))),i.initialChunk&&this.q.acceptChunk(i.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const i=new p(5,0,0,C());this.p.write(i),this.p.flush()}sendPause(){const i=new p(7,0,0,C());this.p.write(i)}sendResume(){const i=new p(8,0,0,C());this.p.write(i)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(i,r){this.a=!0,this.r.dispose(),this.r=new O.$kb,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=i,this.p=this.r.add(new h(this.o)),this.q=this.r.add(new c(this.o)),this.r.add(this.q.onMessage(a=>this.z(a))),this.r.add(this.o.onClose(a=>this.x.fire(a))),this.q.acceptChunk(r)}endAcceptReconnection(){this.a=!1,this.h=this.g;const i=new p(3,0,this.h,C());this.p.write(i);const r=this.b.toArray();for(let a=0,v=r.length;a<v;a++)this.p.write(r[a]);this.B()}acceptDisconnect(){this.w.fire()}z(i){if(i.ack>this.d){this.d=i.ack;do{const r=this.b.peek();if(r&&r.id<=i.ack)this.b.pop();else break}while(!0)}switch(i.type){case 0:break;case 1:{if(i.id>this.g)if(i.id!==this.g+1){const r=Date.now();r-this.m>1e4&&(this.m=r,this.p.write(new p(6,0,0,C())))}else this.g=i.id,this.j=Date.now(),this.A(),this.v.fire(i.data);break}case 2:{this.u.fire(i.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const r=this.b.toArray();for(let a=0,v=r.length;a<v;a++)this.p.write(r[a]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(i){const r=++this.c;this.h=this.g;const a=new p(1,r,this.h,i);this.b.push(a),this.a||(this.p.write(a),this.B())}sendControl(i){const r=new p(2,0,0,i);this.p.write(r)}A(){if(this.g<=this.h||this.k)return;const i=Date.now()-this.j;if(i>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-i+5)}B(){if(this.c<=this.d||this.f||this.a)return;const i=this.b.peek(),r=Date.now()-i.writtenTime,a=Date.now()-this.q.lastReadTime,v=Date.now()-this.n;if(r>=2e4&&a>=2e4&&v>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:r,timeSinceLastReceivedSomeData:a});return}const m=Math.max(2e4-r,2e4-a,2e4-v,500);this.f=setTimeout(()=>{this.f=null,this.B()},m)}C(){if(this.g<=this.h)return;this.h=this.g;const i=new p(3,0,this.h,C());this.p.write(i)}D(){this.h=this.g;const i=new p(9,0,this.h,C());this.p.write(i)}}e.$dh=s}),define(ce[93],le([0,1,64,5,14,25,140,8,3,2,30,143,90,43]),function(ie,e,L,N,O,A,j,R,S,g,C,y,$,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jp=e.$Ip=void 0;class d extends u.$4g{constructor(h){super({send:f=>{try{process.send?.(f.buffer.toString("base64"))}catch{}},onMessage:S.Event.fromNodeEventEmitter(process,"message",f=>O.$Ec.wrap(Buffer.from(f,"base64")))},h),process.once("disconnect",()=>this.dispose())}}e.$Ip=d;class p{constructor(h,f){this.i=h,this.j=f,this.c=new Set,this.g=new Map,this.h=new S.$ec,this.onDidProcessExit=this.h.event;const b=f&&f.timeout?f.timeout:6e4;this.b=new N.$rg(b),this.d=null,this.f=null}getChannel(h){const f=this;return{call(b,w,I){return f.k(h,b,w,I)},listen(b,w){return f.l(h,b,w)}}}k(h,f,b,w=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(w.isCancellationRequested)return Promise.reject(R.$4());this.b.cancel();const I=this.n(h),t=(0,N.$ig)(n=>I.call(f,b,n)),o=w.onCancellationRequested(()=>t.cancel()),s=(0,g.$jb)(()=>t.cancel());return this.c.add(s),t.finally(()=>{o.dispose(),this.c.delete(s),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(h,f,b){if(!this.b)return S.Event.None;this.b.cancel();let w;const I=new S.$ec({onWillAddFirstListener:()=>{w=this.n(h).listen(f,b)(I.fire,I),this.c.add(w)},onDidRemoveLastListener:()=>{this.c.delete(w),w.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return I.event}get m(){if(!this.f){const h=this.j&&this.j.args?this.j.args:[],f=Object.create(null);f.env={...(0,C.$Im)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(f.env={...f.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(f.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(i=>!/^--inspect(-brk)?=/.test(i)).filter(i=>!i.startsWith("--vscode-"))),(0,$.$gl)(f.env),this.d=(0,L.fork)(this.i,h,f);const b=new S.$ec;S.Event.fromNodeEventEmitter(this.d,"message",i=>i)(i=>{if((0,j.$Ep)(i)){(0,j.log)(i,`IPC Library: ${this.j.serverName}`);return}b.fire(O.$Ec.wrap(Buffer.from(i,"base64")))});const I=this.j.useQueue?(0,y.$il)(this.d):this.d,t=i=>this.d&&this.d.connected&&I.send(i.buffer.toString("base64")),o=b.event,s={send:t,onMessage:o};this.f=new u.$5g(s);const n=()=>this.o();process.once("exit",n),this.d.on("error",i=>console.warn('IPC "'+this.j.serverName+'" errored with '+i)),this.d.on("exit",(i,r)=>{process.removeListener("exit",n),this.c.forEach(a=>(0,g.$gb)(a)),this.c.clear(),i!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+i+" and signal "+r),this.b?.cancel(),this.o(),this.h.fire({code:i,signal:r})})}return this.f}n(h){let f=this.g.get(h);return f||(f=this.m.getChannel(h),this.g.set(h,f)),f}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Jp=p}),define(ce[145],le([0,1,133,14,43,3,11,20]),function(ie,e,L,N,O,A,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KS=e.$JS=void 0;class S{constructor($){this.a=$,this.onMessage=A.Event.fromNodeEventEmitter(this.a,"message",u=>N.$Ec.wrap(u.data)),$.start()}send($){this.a.postMessage($.buffer)}disconnect(){this.a.close()}}class g extends O.$6g{static b($){(0,j.$se)((0,L.$IS)(process),"Electron Utility Process");const u=new A.$ec;return process.parentPort.on("message",d=>{if($?.handledClientConnection(d))return;const p=(0,R.$sf)(d.ports);p&&u.fire(p)}),A.Event.map(u.event,d=>({protocol:new S(d),onDidClientDisconnect:A.Event.fromNodeEventEmitter(d,"close")}))}constructor($){super(g.b($))}}e.$JS=g;function C(y,$,u){const d=p=>{p.data===$&&(y.removeListener("message",d),u())};y.on("message",d)}e.$KS=C}),define(ce[66],le([0,1,5,3,2,63,11]),function(ie,e,L,N,O,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jo=e.$Io=e.StorageState=e.$Ho=e.StorageHint=void 0;var R;(function($){$[$.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",$[$.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(R||(e.StorageHint=R={}));function S($){const u=$;return u?.changed instanceof Map||u?.deleted instanceof Set}e.$Ho=S;var g;(function($){$[$.None=0]="None",$[$.Initialized=1]="Initialized",$[$.Closed=2]="Closed"})(g||(e.StorageState=g={}));class C extends O.$lb{static{this.a=100}constructor(u,d=Object.create(null)){super(),this.m=u,this.n=d,this.b=this.B(new N.$hc),this.onDidChangeStorage=this.b.event,this.c=g.None,this.f=new Map,this.g=new L.$sg(C.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(u=>this.r(u)))}r(u){this.b.pause();try{u.changed?.forEach((d,p)=>this.s(p,d)),u.deleted?.forEach(d=>this.s(d,void 0))}finally{this.b.resume()}}s(u,d){if(this.c===g.Closed)return;let p=!1;(0,j.$re)(d)?p=this.f.delete(u):this.f.get(u)!==d&&(this.f.set(u,d),p=!0),p&&this.b.fire({key:u,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===g.None&&(this.c=g.Initialized,this.n.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(u,d){const p=this.f.get(u);return(0,j.$re)(p)?d:p}getBoolean(u,d){const p=this.get(u);return(0,j.$re)(p)?d:p==="true"}getNumber(u,d){const p=this.get(u);return(0,j.$re)(p)?d:parseInt(p,10)}getObject(u,d){const p=this.get(u);return(0,j.$re)(p)?d:(0,A.$Xg)(p)}async set(u,d,p=!1){if(this.c===g.Closed)return;if((0,j.$re)(d))return this.delete(u,p);const c=(0,j.$ke)(d)||Array.isArray(d)?(0,A.$Wg)(d):String(d);if(this.f.get(u)!==c)return this.f.set(u,c),this.j.set(u,c),this.h.delete(u),this.b.fire({key:u,external:p}),this.w()}async delete(u,d=!1){if(!(this.c===g.Closed||!this.f.delete(u)))return this.h.has(u)||this.h.add(u),this.j.delete(u),this.b.fire({key:u,external:d}),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=g.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const u={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(u).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(u){if(this.u)return this.w(u)}async w(u){return this.g.trigger(()=>this.v(),u)}async whenFlushed(){if(this.u)return new Promise(u=>this.l.push(u))}isInMemory(){return this.n.hint===R.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}e.$Io=C;class y{constructor(){this.onDidChangeItemsExternal=N.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(u){u.insert?.forEach((d,p)=>this.a.set(p,d)),u.delete?.forEach(d=>this.a.delete(d))}async close(){}}e.$Jo=y}),define(ce[146],le([12,9]),function(ie,e){return ie.create("vs/base/node/zip",e)}),define(ce[147],le([12,9]),function(ie,e){return ie.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ce[148],le([12,9]),function(ie,e){return ie.create("vs/platform/contextkey/common/contextkey",e)}),define(ce[149],le([12,9]),function(ie,e){return ie.create("vs/platform/contextkey/common/scanner",e)}),define(ce[150],le([12,9]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ce[151],le([12,9]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ce[152],le([12,9]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ce[153],le([12,9]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ce[154],le([12,9]),function(ie,e){return ie.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ce[155],le([12,9]),function(ie,e){return ie.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ce[156],le([12,9]),function(ie,e){return ie.create("vs/platform/extensions/common/extensionValidator",e)}),define(ce[157],le([12,9]),function(ie,e){return ie.create("vs/platform/files/common/fileService",e)}),define(ce[158],le([12,9]),function(ie,e){return ie.create("vs/platform/files/common/files",e)}),define(ce[159],le([12,9]),function(ie,e){return ie.create("vs/platform/files/common/io",e)}),define(ce[160],le([12,9]),function(ie,e){return ie.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ce[161],le([12,9]),function(ie,e){return ie.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ce[162],le([12,9]),function(ie,e){return ie.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(ce[163],le([12,9]),function(ie,e){return ie.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(ce[164],le([12,9]),function(ie,e){return ie.create("vs/platform/request/common/request",e)}),define(ce[165],le([12,9]),function(ie,e){return ie.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(ce[166],le([12,9]),function(ie,e){return ie.create("vs/platform/telemetry/common/telemetryService",e)}),define(ce[167],le([12,9]),function(ie,e){return ie.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ce[168],le([12,9]),function(ie,e){return ie.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(ce[169],le([12,9]),function(ie,e){return ie.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(ce[170],le([12,9]),function(ie,e){return ie.create("vs/platform/userDataSync/common/settingsSync",e)}),define(ce[171],le([12,9]),function(ie,e){return ie.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(ce[172],le([12,9]),function(ie,e){return ie.create("vs/platform/userDataSync/common/userDataSync",e)}),define(ce[173],le([12,9]),function(ie,e){return ie.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(ce[174],le([12,9]),function(ie,e){return ie.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(ce[175],le([12,9]),function(ie,e){return ie.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(ce[176],le([12,9]),function(ie,e){return ie.create("vs/platform/workspace/common/workspace",e)}),define(ce[177],le([0,1,8,149]),function(ie,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$si=e.TokenType=void 0;var O;(function(g){g[g.LParen=0]="LParen",g[g.RParen=1]="RParen",g[g.Neg=2]="Neg",g[g.Eq=3]="Eq",g[g.NotEq=4]="NotEq",g[g.Lt=5]="Lt",g[g.LtEq=6]="LtEq",g[g.Gt=7]="Gt",g[g.GtEq=8]="GtEq",g[g.RegexOp=9]="RegexOp",g[g.RegexStr=10]="RegexStr",g[g.True=11]="True",g[g.False=12]="False",g[g.In=13]="In",g[g.Not=14]="Not",g[g.And=15]="And",g[g.Or=16]="Or",g[g.Str=17]="Str",g[g.QuotedStr=18]="QuotedStr",g[g.Error=19]="Error",g[g.EOF=20]="EOF"})(O||(e.TokenType=O={}));function A(...g){switch(g.length){case 1:return(0,N.localize)(0,null,g[0]);case 2:return(0,N.localize)(1,null,g[0],g[1]);case 3:return(0,N.localize)(2,null,g[0],g[1],g[2]);default:return}}const j=(0,N.localize)(3,null),R=(0,N.localize)(4,null);class S{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(C){switch(C.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return C.isTripleEq?"===":"==";case 4:return C.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return C.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return C.lexeme;case 18:return C.lexeme;case 19:return C.lexeme;case 20:return"EOF";default:throw(0,L.$6)(`unhandled token type: ${JSON.stringify(C)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(C=>C.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(C){return this.c=C,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const y=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:y})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const y=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:y})}else this.h(126)?this.k(9):this.l(A("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(A("&&"));break;case 124:this.h(124)?this.k(16):this.l(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(C){return this.r()||this.c.charCodeAt(this.e)!==C?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(C){this.f.push({type:C,offset:this.d})}l(C){const y=this.d,$=this.c.substring(this.d,this.e),u={type:19,offset:this.d,lexeme:$};this.g.push({offset:y,lexeme:$,additionalInfo:C}),this.f.push(u)}n(){this.m.lastIndex=this.d;const C=this.m.exec(this.c);if(C){this.e=this.d+C[0].length;const y=this.c.substring(this.d,this.e),$=S.b.get(y);$?this.k($):this.f.push({type:17,lexeme:y,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(j);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let C=this.e,y=!1,$=!1;for(;;){if(C>=this.c.length){this.e=C,this.l(R);return}const d=this.c.charCodeAt(C);if(y)y=!1;else if(d===47&&!$){C++;break}else d===91?$=!0:d===92?y=!0:d===93&&($=!1);C++}for(;C<this.c.length&&S.a.has(this.c.charCodeAt(C));)C++;this.e=C;const u=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:u,offset:this.d})}r(){return this.e>=this.c.length}}e.$si=S}),define(ce[178],le([0,1,62,83,26,16,37,22,10]),function(ie,e,L,N,O,A,j,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xl=e.$Wl=e.$Vl=e.$Ul=void 0,e.$Ul=/^([^.]+\..+):(.+)$/;class g{get appRoot(){return(0,A.$$c)(O.$1e.asFileUri("").fsPath)}get userHome(){return S.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return S.URI.file((0,A.$8c)(this.userDataPath,"User"))}get tmpDir(){return S.URI.file(this.b.tmpDir)}get cacheHome(){return S.URI.file(this.userDataPath)}get stateResource(){return(0,R.$9f)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:O.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,R.$9f)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const u=(0,L.$Tl)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.$8c)(this.userDataPath,"logs",u)}return S.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.$9f)(S.URI.file((0,A.$8c)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,R.$9f)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,R.$9f)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,R.$9f)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const u=j.env.VSCODE_PORTABLE;return u?S.URI.file((0,A.$8c)(u,"argv.json")):(0,R.$9f)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return S.URI.file((0,A.$8c)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const u=this.args["builtin-extensions-dir"];return u?(0,A.$9c)(u):(0,A.$6c)((0,A.$8c)(O.$1e.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const u=this.args["extensions-download-dir"];return u?S.URI.file((0,A.$9c)(u)):S.URI.file((0,A.$8c)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const u=this.args["extensions-dir"];if(u)return(0,A.$9c)(u);const d=j.env.VSCODE_EXTENSIONS;if(d)return d;const p=j.env.VSCODE_PORTABLE;return p?(0,A.$8c)(p,"extensions"):(0,R.$9f)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const u=this.args.extensionDevelopmentPath;if(Array.isArray(u))return u.map(d=>/^[^:/?#]+?:\/\//.test(d)?S.URI.parse(d):S.URI.file((0,A.$6c)(d)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(u=>u==="ui"||u==="workspace"||u==="web"?u:"workspace")}get extensionTestsLocationURI(){const u=this.args.extensionTestsPath;if(u)return/^[^:/?#]+?:\/\//.test(u)?S.URI.parse(u):S.URI.file((0,A.$6c)(u))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const u=this.args["disable-extension"];if(u){if(typeof u=="string")return[u];if(Array.isArray(u)&&u.length>0)return u}return!1}get debugExtensionHost(){return C(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!j.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(u=>!e.$Ul.test(u))}get extensionLogLevel(){const u=[];for(const d of this.args.log||[]){const p=e.$Ul.exec(d);p&&p[1]&&p[2]&&u.push([p[1],p[2]])}return u.length?u:void 0}get serviceMachineIdResource(){return(0,R.$9f)(S.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get disableKeytar(){return!!this.args["disable-keytar"]}get policyFile(){if(this.args["__enable-file-policy"]){const u=j.env.VSCODE_PORTABLE;return u?S.URI.file((0,A.$8c)(u,"policy.json")):(0,R.$9f)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(u){this.args.continueOn=u}get args(){return this.a}constructor(u,d,p){this.a=u,this.b=d,this.c=p,this.editSessionId=this.args.editSessionId}}e.$Vl=g,ye([N.$Tg],g.prototype,"appRoot",null),ye([N.$Tg],g.prototype,"userHome",null),ye([N.$Tg],g.prototype,"userDataPath",null),ye([N.$Tg],g.prototype,"appSettingsHome",null),ye([N.$Tg],g.prototype,"tmpDir",null),ye([N.$Tg],g.prototype,"cacheHome",null),ye([N.$Tg],g.prototype,"stateResource",null),ye([N.$Tg],g.prototype,"userRoamingDataHome",null),ye([N.$Tg],g.prototype,"userDataSyncHome",null),ye([N.$Tg],g.prototype,"sync",null),ye([N.$Tg],g.prototype,"machineSettingsResource",null),ye([N.$Tg],g.prototype,"workspaceStorageHome",null),ye([N.$Tg],g.prototype,"localHistoryHome",null),ye([N.$Tg],g.prototype,"keyboardLayoutResource",null),ye([N.$Tg],g.prototype,"argvResource",null),ye([N.$Tg],g.prototype,"isExtensionDevelopment",null),ye([N.$Tg],g.prototype,"untitledWorkspacesHome",null),ye([N.$Tg],g.prototype,"builtinExtensionsPath",null),ye([N.$Tg],g.prototype,"extensionsPath",null),ye([N.$Tg],g.prototype,"extensionDevelopmentLocationURI",null),ye([N.$Tg],g.prototype,"extensionDevelopmentKind",null),ye([N.$Tg],g.prototype,"extensionTestsLocationURI",null),ye([N.$Tg],g.prototype,"debugExtensionHost",null),ye([N.$Tg],g.prototype,"logLevel",null),ye([N.$Tg],g.prototype,"extensionLogLevel",null),ye([N.$Tg],g.prototype,"serviceMachineIdResource",null),ye([N.$Tg],g.prototype,"disableTelemetry",null),ye([N.$Tg],g.prototype,"disableWorkspaceTrust",null),ye([N.$Tg],g.prototype,"disableKeytar",null),ye([N.$Tg],g.prototype,"policyFile",null);function C($,u){return y($["inspect-extensions"],$["inspect-brk-extensions"],5870,u,$.debugId,$.extensionEnvironment)}e.$Wl=C;function y($,u,d,p,c,h){const b=Number(u||$)||(p?null:d),w=b?!!u:!1;let I;if(h)try{I=JSON.parse(h)}catch{}return{port:b,break:w,debugId:c,env:I}}e.$Xl=y}),function(){"use strict";function ie(e,L,N){function O(j,R){const S=A(j,R),g=[S];return e.isAbsolute(S)||g.unshift(N),e.resolve(...g)}function A(j,R){process.env.VSCODE_DEV&&(R="code-oss-dev");const S=process.env.VSCODE_PORTABLE;if(S)return e.join(S,"user-data");let g=process.env.VSCODE_APPDATA;if(g)return e.join(g,R);const C=j["user-data-dir"];if(C)return C;switch(process.platform){case"win32":if(g=process.env.APPDATA,!g){const y=process.env.USERPROFILE;if(typeof y!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");g=e.join(y,"AppData","Roaming")}break;case"darwin":g=e.join(L.homedir(),"Library","Application Support");break;case"linux":g=process.env.XDG_CONFIG_HOME||e.join(L.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(g,R)}return{getUserDataPath:O}}if(typeof define=="function")define(ce[179],le([268,36,37]),function(e,L,N){return ie(e,L,N.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),L=require("os");module.exports=ie(e,L,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ce[180],le([0,1,36,178,179]),function(ie,e,L,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1l=e.$Zl=e.$Yl=void 0;class A extends N.$Vl{constructor(g,C){super(g,{homeDir:(0,L.homedir)(),tmpDir:(0,L.tmpdir)(),userDataDir:(0,O.getUserDataPath)(g,C.nameShort)},C)}}e.$Yl=A;function j(S,g){return(0,N.$Xl)(S["inspect-ptyhost"],S["inspect-brk-ptyhost"],5877,g,S.extensionEnvironment)}e.$Zl=j;function R(S,g){return(0,N.$Xl)(S["inspect-sharedprocess"],S["inspect-brk-sharedprocess"],5879,g,S.extensionEnvironment)}e.$1l=R}),define(ce[181],le([0,1,11,152]),function(ie,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ep=void 0;function O(j,R,S){try{A(j,R,S)}catch(g){console.error(g?.message??g)}return j}e.$ep=O;function A(j,R,S){const g=(C,y,$)=>{const u=C[y];if((0,L.$ie)(u)){const d=u,p=d.length;if(p>1&&d[0]==="%"&&d[p-1]==="%"){const c=d.substr(1,p-2);let h=R[c];h===void 0&&S&&(h=S[c]);const f=typeof h=="string"?h:h?.message,b=S?.[c],w=typeof b=="string"?b:b?.message;if(!f){w||console.warn(`[${j.name}]: ${(0,N.localize)(0,null,c)}`);return}if($&&(y==="title"||y==="category")&&w&&w!==f){const I={value:f,original:w};C[y]=I}else C[y]=f}}else if((0,L.$ke)(u))for(const d in u)u.hasOwnProperty(d)&&(d==="commands"?g(u,d,!0):g(u,d,$));else if(Array.isArray(u))for(let d=0;d<u.length;d++)g(u,d,$)};for(const C in j)j.hasOwnProperty(C)&&g(j,C)}}),define(ce[182],le([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y7b=e.$x7b=void 0;class L{constructor(A){this.a=A}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(A){return this.a.call("promptImportantExtensionsInstallNotification",[A])}promptWorkspaceRecommendations(A){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.$x7b=L;class N{constructor(A){this.a=A}listen(A,j){throw new Error(`Event not found: ${j}`)}call(A,j,R){switch(j){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(R[0])}throw new Error(`Call not found: ${j}`)}}e.$y7b=N}),define(ce[67],le([0,1,22,89,156,53]),function(ie,e,L,N,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=void 0;const j=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function S(h){return h=h.trim(),h==="*"||j.test(h)}e.$to=S;function g(h){if(!S(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const f=h.match(j);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.$uo=g;function C(h){if(!h)return null;const f=h.majorBase,b=h.majorMustEqual,w=h.minorBase;let I=h.minorMustEqual;const t=h.patchBase;let o=h.patchMustEqual;h.hasCaret&&(f===0||(I=!1),o=!1);let s=0;if(h.preRelease){const n=R.exec(h.preRelease);if(n){const[,i,r,a]=n;s=Date.UTC(Number(i),Number(r)-1,Number(a))}}return{majorBase:f,majorMustEqual:b,minorBase:w,minorMustEqual:I,patchBase:t,patchMustEqual:o,isMinimum:h.hasGreaterEquals,notBefore:s}}e.$vo=C;function y(h,f,b){let w;typeof h=="string"?w=C(g(h)):w=h;let I;f instanceof Date?I=f.getTime():typeof f=="string"&&(I=new Date(f).getTime());let t;if(typeof b=="string"?t=C(g(b)):t=b,!w||!t)return!1;const o=w.majorBase,s=w.minorBase,n=w.patchBase;let i=t.majorBase,r=t.minorBase,a=t.patchBase;const v=t.notBefore;let m=t.majorMustEqual,l=t.minorMustEqual,E=t.patchMustEqual;return t.isMinimum?o>i?!0:o<i?!1:s>r?!0:s<r||I&&I<v?!1:n>=a:(o===1&&i===0&&(!m||!l||!E)&&(i=1,r=0,a=0,m=!0,l=!1,E=!1),o<i?!1:o>i?!m:s<r?!1:s>r?!l:n<a?!1:n>a?!E:!(I&&I<v))}e.$wo=y;function $(h,f,b,w,I){const t=[];if(typeof w.publisher<"u"&&typeof w.publisher!="string")return t.push([N.default.Error,O.localize(0,null)]),t;if(typeof w.name!="string")return t.push([N.default.Error,O.localize(1,null,"name")]),t;if(typeof w.version!="string")return t.push([N.default.Error,O.localize(2,null,"version")]),t;if(!w.engines)return t.push([N.default.Error,O.localize(3,null,"engines")]),t;if(typeof w.engines.vscode!="string")return t.push([N.default.Error,O.localize(4,null,"engines.vscode")]),t;if(typeof w.extensionDependencies<"u"&&!c(w.extensionDependencies))return t.push([N.default.Error,O.localize(5,null,"extensionDependencies")]),t;if(typeof w.activationEvents<"u"){if(!c(w.activationEvents))return t.push([N.default.Error,O.localize(6,null,"activationEvents")]),t;if(typeof w.main>"u"&&typeof w.browser>"u")return t.push([N.default.Error,O.localize(7,null,"activationEvents","main","browser")]),t}if(typeof w.extensionKind<"u"&&typeof w.main>"u"&&t.push([N.default.Warning,O.localize(8,null,"extensionKind")]),typeof w.main<"u"){if(typeof w.main!="string")return t.push([N.default.Error,O.localize(9,null,"main")]),t;{const n=(0,L.$9f)(b,w.main);(0,L.$3f)(n,b)||t.push([N.default.Warning,O.localize(10,null,n.path,b.path)])}}if(typeof w.browser<"u"){if(typeof w.browser!="string")return t.push([N.default.Error,O.localize(11,null,"browser")]),t;{const n=(0,L.$9f)(b,w.browser);(0,L.$3f)(n,b)||t.push([N.default.Warning,O.localize(12,null,n.path,b.path)])}}if(!A.valid(w.version))return t.push([N.default.Error,O.localize(13,null)]),t;const o=[];if(!u(h,f,w,I,o))for(const n of o)t.push([N.default.Error,n]);return t}e.$xo=$;function u(h,f,b,w,I){return w||typeof b.main>"u"&&typeof b.browser>"u"?!0:p(h,f,b.engines.vscode,I)}e.$yo=u;function d(h,f,b){return h==="*"||p(f,b,h)}e.$zo=d;function p(h,f,b,w=[]){const I=C(g(b));if(!I)return w.push(O.localize(14,null,b)),!1;if(I.majorBase===0){if(!I.majorMustEqual||!I.minorMustEqual)return w.push(O.localize(15,null,b)),!1}else if(!I.majorMustEqual)return w.push(O.localize(16,null,b)),!1;return y(h,f,I)?!0:(w.push(O.localize(17,null,h,b)),!1)}function c(h){if(!Array.isArray(h))return!1;for(let f=0,b=h.length;f<b;f++)if(typeof h[f]!="string")return!1;return!0}}),define(ce[44],le([0,1,14,32]),function(ie,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$So=void 0;async function O(A,j,R){let S=R&&R.get("storage.serviceMachineId",-1)||null;if(S)return S;try{const C=(await j.readFile(A.serviceMachineIdResource)).value.toString();S=(0,N.$2e)(C)?C:null}catch{S=null}if(!S){S=(0,N.$3e)();try{await j.writeFile(A.serviceMachineIdResource,L.$Ec.fromString(S))}catch{}}return R?.store("storage.serviceMachineId",S,-1,1),S}e.$So=O}),define(ce[68],le([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mh=void 0;class L{constructor(O,A=[],j=!1){this.ctor=O,this.staticArguments=A,this.supportsDelayedInstantiation=j}}e.$mh=L}),define(ce[183],le([0,1,68]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$er=e.$dr=e.InstantiationType=void 0;const N=[];var O;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(O||(e.InstantiationType=O={}));function A(R,S,g){S instanceof L.$mh||(S=new L.$mh(S,[],!!g)),N.push([R,S])}e.$dr=A;function j(){return N}e.$er=j}),define(ce[184],le([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vp=e.$Up=void 0;class L{constructor(A,j){this.key=A,this.data=j,this.incoming=new Map,this.outgoing=new Map}}e.$Up=L;class N{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const j of this.a.values())j.outgoing.size===0&&A.push(j);return A}insertEdge(A,j){const R=this.lookupOrInsertNode(A),S=this.lookupOrInsertNode(j);R.outgoing.set(S.key,S),S.incoming.set(R.key,R)}removeNode(A){const j=this.b(A);this.a.delete(j);for(const R of this.a.values())R.outgoing.delete(j),R.incoming.delete(j)}lookupOrInsertNode(A){const j=this.b(A);let R=this.a.get(j);return R||(R=new L(j,A),this.a.set(j,R)),R}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[j,R]of this.a)A.push(`${j}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,j]of this.a){const R=new Set([A]),S=this.c(j,R);if(S)return S}}c(A,j){for(const[R,S]of A.outgoing){if(j.has(R))return[...j,R].join(" -> ");j.add(R);const g=this.c(S,j);if(g)return g;j.delete(R)}}}e.$Vp=N}),define(ce[4],le([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qh=e.$ph=e.$oh=e._util=void 0;var L;(function(j){j.serviceIds=new Map,j.DI_TARGET="$di$target",j.DI_DEPENDENCIES="$di$dependencies";function R(S){return S[j.DI_DEPENDENCIES]||[]}j.getServiceDependencies=R})(L||(e._util=L={})),e.$oh=O("instantiationService");function N(j,R,S){R[L.DI_TARGET]===R?R[L.DI_DEPENDENCIES].push({id:j,index:S}):(R[L.DI_DEPENDENCIES]=[{id:j,index:S}],R[L.DI_TARGET]=R)}function O(j){if(L.serviceIds.has(j))return L.serviceIds.get(j);const R=function(S,g,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");N(R,S,C)};return R.toString=()=>j,L.serviceIds.set(j,R),R}e.$ph=O;function A(j){return j}e.$qh=A}),define(ce[185],le([0,1,4]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$76b=void 0,e.$76b=(0,L.$ph)("checksumService")}),define(ce[18],le([0,1,11,10,4]),function(ie,e,L,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.ConfigurationTarget=e.$Xh=e.$Wh=e.$Vh=void 0,e.$Vh=(0,O.$ph)("configurationService");function A(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof N.URI)}e.$Wh=A;function j(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||Array.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof N.URI)}e.$Xh=j;var R;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.USER=2]="USER",h[h.USER_LOCAL=3]="USER_LOCAL",h[h.USER_REMOTE=4]="USER_REMOTE",h[h.WORKSPACE=5]="WORKSPACE",h[h.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",h[h.DEFAULT=7]="DEFAULT",h[h.MEMORY=8]="MEMORY"})(R||(e.ConfigurationTarget=R={}));function S(h){switch(h){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Yh=S;function g(h){return h.applicationValue!==void 0||h.userValue!==void 0||h.userLocalValue!==void 0||h.userRemoteValue!==void 0||h.workspaceValue!==void 0||h.workspaceFolderValue!==void 0}e.$Zh=g;function C(h,f){const b=Object.create(null);for(const w in h)y(b,w,h[w],f);return b}e.$1h=C;function y(h,f,b,w){const I=f.split("."),t=I.pop();let o=h;for(let s=0;s<I.length;s++){const n=I[s];let i=o[n];switch(typeof i){case"undefined":i=o[n]=Object.create(null);break;case"object":break;default:w(`Ignoring ${f} as ${I.slice(0,s+1).join(".")} is ${JSON.stringify(i)}`);return}o=i}if(typeof o=="object"&&o!==null)try{o[t]=b}catch{w(`Ignoring ${f} as ${I.join(".")} is ${JSON.stringify(o)}`)}else w(`Ignoring ${f} as ${I.join(".")} is ${JSON.stringify(o)}`)}e.$2h=y;function $(h,f){const b=f.split(".");u(h,b)}e.$3h=$;function u(h,f){const b=f.shift();if(f.length===0){delete h[b];return}if(Object.keys(h).indexOf(b)!==-1){const w=h[b];typeof w=="object"&&!Array.isArray(w)&&(u(w,f),Object.keys(w).length===0&&delete h[b])}}function d(h,f,b){function w(o,s){let n=o;for(const i of s){if(typeof n!="object"||n===null)return;n=n[i]}return n}const I=f.split("."),t=w(h,I);return typeof t>"u"?b:t}e.$4h=d;function p(h,f,b){Object.keys(f).forEach(w=>{w!=="__proto__"&&(w in h?L.$ke(h[w])&&L.$ke(f[w])?p(h[w],f[w],b):b&&(h[w]=f[w]):h[w]=f[w])})}e.$5h=p;function c(h){return h.replace(/[\[\]]/g,"")}e.$6h=c}),define(ce[94],le([0,1,6,28,177,4,148,8]),function(ie,e,L,N,O,A,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.ContextKeyExprType=e.$ti=void 0;const S=new Map;S.set("false",!1),S.set("true",!0),S.set("isMac",L.$j),S.set("isLinux",L.$k),S.set("isWindows",L.$i),S.set("isWeb",L.$o),S.set("isMacNative",L.$j&&!L.$o),S.set("isEdge",L.$G),S.set("isFirefox",L.$E),S.set("isChrome",L.$D),S.set("isSafari",L.$F);function g(U,k){if(S.get(U)!==void 0)throw(0,R.$5)("contextkey.setConstant(k, v) invoked with already set constant `k`");S.set(U,k)}e.$ti=g;const C=Object.prototype.hasOwnProperty;var y;(function(U){U[U.False=0]="False",U[U.True=1]="True",U[U.Defined=2]="Defined",U[U.Not=3]="Not",U[U.Equals=4]="Equals",U[U.NotEquals=5]="NotEquals",U[U.And=6]="And",U[U.Regex=7]="Regex",U[U.NotRegex=8]="NotRegex",U[U.Or=9]="Or",U[U.In=10]="In",U[U.NotIn=11]="NotIn",U[U.Greater=12]="Greater",U[U.GreaterEquals=13]="GreaterEquals",U[U.Smaller=14]="Smaller",U[U.SmallerEquals=15]="SmallerEquals"})(y||(e.ContextKeyExprType=y={}));const $={regexParsingWithErrorRecovery:!0},u=(0,j.localize)(0,null),d=(0,j.localize)(1,null),p=(0,j.localize)(2,null),c=(0,j.localize)(3,null),h=(0,j.localize)(4,null),f=(0,j.localize)(5,null),b=(0,j.localize)(6,null),w=(0,j.localize)(7,null);class I{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(k=$){this.k=k,this.d=new O.$si,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(k){if(k===""){this.h.push({message:u,offset:0,lexeme:"",additionalInfo:d});return}this.f=this.d.reset(k).scan(),this.g=0,this.h=[];try{const P=this.l();if(!this.E()){const z=this.D(),H=z.type===17?f:void 0;throw this.h.push({message:h,offset:z.offset,lexeme:O.$si.getLexeme(z),additionalInfo:H}),I.c}return P}catch(P){if(P!==I.c)throw P;return}}l(){return this.m()}m(){const k=[this.o()];for(;this.y(16);){const P=this.o();k.push(P)}return k.length===1?k[0]:t.or(...k)}o(){const k=[this.s()];for(;this.y(15);){const P=this.s();k.push(P)}return k.length===1?k[0]:t.and(...k)}s(){if(this.y(2)){const k=this.D();switch(k.type){case 11:return this.z(),i.INSTANCE;case 12:return this.z(),r.INSTANCE;case 0:{this.z();const P=this.l();return this.A(1,c),P?.negate()}case 17:return this.z(),D.create(k.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",k)}}return this.t()}t(){const k=this.D();switch(k.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const P=this.l();return this.A(1,c),P}case 17:{const P=k.lexeme;if(this.z(),this.y(9)){const H=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),H.type!==10)throw this.B("REGEX",H);const ee=H.lexeme,ne=ee.lastIndexOf("/"),fe=ne===ee.length-1?void 0:this.w(ee.substring(ne+1));let x;try{x=new RegExp(ee.substring(1,ne),fe)}catch{throw this.B("REGEX",H)}return J.create(P,x)}switch(H.type){case 10:case 19:{const ee=[H.lexeme];this.z();let ne=this.D(),fe=0;for(let de=0;de<H.lexeme.length;de++)H.lexeme.charCodeAt(de)===40?fe++:H.lexeme.charCodeAt(de)===41&&fe--;for(;!this.E()&&ne.type!==15&&ne.type!==16;){switch(ne.type){case 0:fe++;break;case 1:fe--;break;case 10:case 18:for(let de=0;de<ne.lexeme.length;de++)ne.lexeme.charCodeAt(de)===40?fe++:H.lexeme.charCodeAt(de)===41&&fe--}if(fe<0)break;ee.push(O.$si.getLexeme(ne)),this.z(),ne=this.D()}const x=ee.join(""),se=x.lastIndexOf("/"),te=se===x.length-1?void 0:this.w(x.substring(se+1));let ue;try{ue=new RegExp(x.substring(1,se),te)}catch{throw this.B("REGEX",H)}return t.regex(P,ue)}case 18:{const ee=H.lexeme;this.z();let ne=null;if(!(0,N.$ld)(ee)){const fe=ee.indexOf("/"),x=ee.lastIndexOf("/");if(fe!==x&&fe>=0){const se=ee.slice(fe+1,x),te=ee[x+1]==="i"?"i":"";try{ne=new RegExp(se,te)}catch{throw this.B("REGEX",H)}}}if(ne===null)throw this.B("REGEX",H);return J.create(P,ne)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,p);const H=this.u();return t.notIn(P,H)}switch(this.D().type){case 3:{this.z();const H=this.u();if(this.x().type===18)return t.equals(P,H);switch(H){case"true":return t.has(P);case"false":return t.not(P);default:return t.equals(P,H)}}case 4:{this.z();const H=this.u();if(this.x().type===18)return t.notEquals(P,H);switch(H){case"true":return t.not(P);case"false":return t.has(P);default:return t.notEquals(P,H)}}case 5:return this.z(),V.create(P,this.u());case 6:return this.z(),Z.create(P,this.u());case 7:return this.z(),M.create(P,this.u());case 8:return this.z(),F.create(P,this.u());case 13:return this.z(),t.in(P,this.u());default:return t.has(P)}}case 20:throw this.h.push({message:b,offset:k.offset,lexeme:"",additionalInfo:w}),I.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const k=this.D();switch(k.type){case 17:case 18:return this.z(),k.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(k){return k.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(k){return this.C(k)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(k,P){if(this.C(k))return this.z();throw this.B(P,this.D())}B(k,P,z){const H=(0,j.localize)(8,null,k,O.$si.getLexeme(P)),ee=P.offset,ne=O.$si.getLexeme(P);return this.h.push({message:H,offset:ee,lexeme:ne,additionalInfo:z}),I.c}C(k){return this.D().type===k}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$ui=I;class t{static false(){return i.INSTANCE}static true(){return r.INSTANCE}static has(k){return a.create(k)}static equals(k,P){return v.create(k,P)}static notEquals(k,P){return E.create(k,P)}static regex(k,P){return J.create(k,P)}static in(k,P){return m.create(k,P)}static notIn(k,P){return l.create(k,P)}static not(k){return D.create(k)}static and(...k){return X.create(k,null,!0)}static or(...k){return W.create(k,null,!0)}static greater(k,P){return M.create(k,P)}static greaterEquals(k,P){return F.create(k,P)}static smaller(k,P){return V.create(k,P)}static smallerEquals(k,P){return Z.create(k,P)}static{this.c=new I({regexParsingWithErrorRecovery:!1})}static deserialize(k){return k==null?void 0:this.c.parse(k)}}e.$vi=t;function o(U){const k=new I({regexParsingWithErrorRecovery:!1});return U.map(P=>(k.parse(P),k.lexingErrors.length>0?k.lexingErrors.map(z=>({errorMessage:z.additionalInfo?(0,j.localize)(9,null,z.additionalInfo):(0,j.localize)(10,null),offset:z.offset,length:z.lexeme.length})):k.parsingErrors.length>0?k.parsingErrors.map(z=>({errorMessage:z.additionalInfo?`${z.message}. ${z.additionalInfo}`:z.message,offset:z.offset,length:z.lexeme.length})):[]))}e.$wi=o;function s(U,k){const P=U?U.substituteConstants():void 0,z=k?k.substituteConstants():void 0;return!P&&!z?!0:!P||!z?!1:P.equals(z)}e.$xi=s;function n(U,k){return U.cmp(k)}class i{static{this.INSTANCE=new i}constructor(){this.type=0}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!1}serialize(){return"false"}keys(){return[]}map(k){return this}negate(){return r.INSTANCE}}e.$yi=i;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(k){return this.type-k.type}equals(k){return k.type===this.type}substituteConstants(){return this}evaluate(k){return!0}serialize(){return"true"}keys(){return[]}map(k){return this}negate(){return i.INSTANCE}}e.$zi=r;class a{static create(k,P=null){const z=S.get(k);return typeof z=="boolean"?z?r.INSTANCE:i.INSTANCE:new a(k,P)}constructor(k,P){this.key=k,this.c=P,this.type=2}cmp(k){return k.type!==this.type?this.type-k.type:B(this.key,k.key)}equals(k){return k.type===this.type?this.key===k.key:!1}substituteConstants(){const k=S.get(this.key);return typeof k=="boolean"?k?r.INSTANCE:i.INSTANCE:this}evaluate(k){return!!k.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(k){return k.mapDefined(this.key)}negate(){return this.c||(this.c=D.create(this.key,this)),this.c}}e.$Ai=a;class v{static create(k,P,z=null){if(typeof P=="boolean")return P?a.create(k,z):D.create(k,z);const H=S.get(k);return typeof H=="boolean"?P===(H?"true":"false")?r.INSTANCE:i.INSTANCE:new v(k,P,z)}constructor(k,P,z){this.c=k,this.d=P,this.f=z,this.type=4}cmp(k){return k.type!==this.type?this.type-k.type:_(this.c,this.d,k.c,k.d)}equals(k){return k.type===this.type?this.c===k.c&&this.d===k.d:!1}substituteConstants(){const k=S.get(this.c);if(typeof k=="boolean"){const P=k?"true":"false";return this.d===P?r.INSTANCE:i.INSTANCE}return this}evaluate(k){return k.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(k){return k.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=E.create(this.c,this.d,this)),this.f}}e.$Bi=v;class m{static create(k,P){return new m(k,P)}constructor(k,P){this.d=k,this.f=P,this.type=10,this.c=null}cmp(k){return k.type!==this.type?this.type-k.type:_(this.d,this.f,k.d,k.f)}equals(k){return k.type===this.type?this.d===k.d&&this.f===k.f:!1}substituteConstants(){return this}evaluate(k){const P=k.getValue(this.f),z=k.getValue(this.d);return Array.isArray(P)?P.includes(z):typeof z=="string"&&typeof P=="object"&&P!==null?C.call(P,z):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(k){return k.mapIn(this.d,this.f)}negate(){return this.c||(this.c=l.create(this.d,this.f)),this.c}}e.$Ci=m;class l{static create(k,P){return new l(k,P)}constructor(k,P){this.d=k,this.f=P,this.type=11,this.c=m.create(k,P)}cmp(k){return k.type!==this.type?this.type-k.type:this.c.cmp(k.c)}equals(k){return k.type===this.type?this.c.equals(k.c):!1}substituteConstants(){return this}evaluate(k){return!this.c.evaluate(k)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(k){return k.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Di=l;class E{static create(k,P,z=null){if(typeof P=="boolean")return P?D.create(k,z):a.create(k,z);const H=S.get(k);return typeof H=="boolean"?P===(H?"true":"false")?i.INSTANCE:r.INSTANCE:new E(k,P,z)}constructor(k,P,z){this.c=k,this.d=P,this.f=z,this.type=5}cmp(k){return k.type!==this.type?this.type-k.type:_(this.c,this.d,k.c,k.d)}equals(k){return k.type===this.type?this.c===k.c&&this.d===k.d:!1}substituteConstants(){const k=S.get(this.c);if(typeof k=="boolean"){const P=k?"true":"false";return this.d===P?i.INSTANCE:r.INSTANCE}return this}evaluate(k){return k.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(k){return k.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.$Ei=E;class D{static create(k,P=null){const z=S.get(k);return typeof z=="boolean"?z?i.INSTANCE:r.INSTANCE:new D(k,P)}constructor(k,P){this.c=k,this.d=P,this.type=3}cmp(k){return k.type!==this.type?this.type-k.type:B(this.c,k.c)}equals(k){return k.type===this.type?this.c===k.c:!1}substituteConstants(){const k=S.get(this.c);return typeof k=="boolean"?k?i.INSTANCE:r.INSTANCE:this}evaluate(k){return!k.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(k){return k.mapNot(this.c)}negate(){return this.d||(this.d=a.create(this.c,this)),this.d}}e.$Fi=D;function T(U,k){if(typeof U=="string"){const P=parseFloat(U);isNaN(P)||(U=P)}return typeof U=="string"||typeof U=="number"?k(U):i.INSTANCE}class M{static create(k,P,z=null){return T(P,H=>new M(k,H,z))}constructor(k,P,z){this.c=k,this.d=P,this.f=z,this.type=12}cmp(k){return k.type!==this.type?this.type-k.type:_(this.c,this.d,k.c,k.d)}equals(k){return k.type===this.type?this.c===k.c&&this.d===k.d:!1}substituteConstants(){return this}evaluate(k){return typeof this.d=="string"?!1:parseFloat(k.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(k){return k.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=Z.create(this.c,this.d,this)),this.f}}e.$Gi=M;class F{static create(k,P,z=null){return T(P,H=>new F(k,H,z))}constructor(k,P,z){this.c=k,this.d=P,this.f=z,this.type=13}cmp(k){return k.type!==this.type?this.type-k.type:_(this.c,this.d,k.c,k.d)}equals(k){return k.type===this.type?this.c===k.c&&this.d===k.d:!1}substituteConstants(){return this}evaluate(k){return typeof this.d=="string"?!1:parseFloat(k.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(k){return k.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$Hi=F;class V{static create(k,P,z=null){return T(P,H=>new V(k,H,z))}constructor(k,P,z){this.c=k,this.d=P,this.f=z,this.type=14}cmp(k){return k.type!==this.type?this.type-k.type:_(this.c,this.d,k.c,k.d)}equals(k){return k.type===this.type?this.c===k.c&&this.d===k.d:!1}substituteConstants(){return this}evaluate(k){return typeof this.d=="string"?!1:parseFloat(k.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(k){return k.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Ii=V;class Z{static create(k,P,z=null){return T(P,H=>new Z(k,H,z))}constructor(k,P,z){this.c=k,this.d=P,this.f=z,this.type=15}cmp(k){return k.type!==this.type?this.type-k.type:_(this.c,this.d,k.c,k.d)}equals(k){return k.type===this.type?this.c===k.c&&this.d===k.d:!1}substituteConstants(){return this}evaluate(k){return typeof this.d=="string"?!1:parseFloat(k.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(k){return k.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$Ji=Z;class J{static create(k,P){return new J(k,P)}constructor(k,P){this.d=k,this.f=P,this.type=7,this.c=null}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.d<k.d)return-1;if(this.d>k.d)return 1;const P=this.f?this.f.source:"",z=k.f?k.f.source:"";return P<z?-1:P>z?1:0}equals(k){if(k.type===this.type){const P=this.f?this.f.source:"",z=k.f?k.f.source:"";return this.d===k.d&&P===z}return!1}substituteConstants(){return this}evaluate(k){const P=k.getValue(this.d);return this.f?this.f.test(P):!1}serialize(){const k=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${k}`}keys(){return[this.d]}map(k){return k.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=Q.create(this)),this.c}}e.$Ki=J;class Q{static create(k){return new Q(k)}constructor(k){this.c=k,this.type=8}cmp(k){return k.type!==this.type?this.type-k.type:this.c.cmp(k.c)}equals(k){return k.type===this.type?this.c.equals(k.c):!1}substituteConstants(){return this}evaluate(k){return!this.c.evaluate(k)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(k){return new Q(this.c.map(k))}negate(){return this.c}}e.$Li=Q;function G(U){let k=null;for(let P=0,z=U.length;P<z;P++){const H=U[P].substituteConstants();if(U[P]!==H&&k===null){k=[];for(let ee=0;ee<P;ee++)k[ee]=U[ee]}k!==null&&(k[P]=H)}return k===null?U:k}class X{static create(k,P,z){return X.d(k,P,z)}constructor(k,P){this.expr=k,this.c=P,this.type=6}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let P=0,z=this.expr.length;P<z;P++){const H=n(this.expr[P],k.expr[P]);if(H!==0)return H}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let P=0,z=this.expr.length;P<z;P++)if(!this.expr[P].equals(k.expr[P]))return!1;return!0}return!1}substituteConstants(){const k=G(this.expr);return k===this.expr?this:X.create(k,this.c,!1)}evaluate(k){for(let P=0,z=this.expr.length;P<z;P++)if(!this.expr[P].evaluate(k))return!1;return!0}static d(k,P,z){const H=[];let ee=!1;for(const ne of k)if(ne){if(ne.type===1){ee=!0;continue}if(ne.type===0)return i.INSTANCE;if(ne.type===6){H.push(...ne.expr);continue}H.push(ne)}if(H.length===0&&ee)return r.INSTANCE;if(H.length!==0){if(H.length===1)return H[0];H.sort(n);for(let ne=1;ne<H.length;ne++)H[ne-1].equals(H[ne])&&(H.splice(ne,1),ne--);if(H.length===1)return H[0];for(;H.length>1;){const ne=H[H.length-1];if(ne.type!==9)break;H.pop();const fe=H.pop(),x=H.length===0,se=W.create(ne.expr.map(te=>X.create([te,fe],null,z)),null,x);se&&(H.push(se),H.sort(n))}if(H.length===1)return H[0];if(z){for(let ne=0;ne<H.length;ne++)for(let fe=ne+1;fe<H.length;fe++)if(H[ne].negate().equals(H[fe]))return i.INSTANCE;if(H.length===1)return H[0]}return new X(H,P)}}serialize(){return this.expr.map(k=>k.serialize()).join(" && ")}keys(){const k=[];for(const P of this.expr)k.push(...P.keys());return k}map(k){return new X(this.expr.map(P=>P.map(k)),null)}negate(){if(!this.c){const k=[];for(const P of this.expr)k.push(P.negate());this.c=W.create(k,this,!0)}return this.c}}e.$Mi=X;class W{static create(k,P,z){return W.d(k,P,z)}constructor(k,P){this.expr=k,this.c=P,this.type=9}cmp(k){if(k.type!==this.type)return this.type-k.type;if(this.expr.length<k.expr.length)return-1;if(this.expr.length>k.expr.length)return 1;for(let P=0,z=this.expr.length;P<z;P++){const H=n(this.expr[P],k.expr[P]);if(H!==0)return H}return 0}equals(k){if(k.type===this.type){if(this.expr.length!==k.expr.length)return!1;for(let P=0,z=this.expr.length;P<z;P++)if(!this.expr[P].equals(k.expr[P]))return!1;return!0}return!1}substituteConstants(){const k=G(this.expr);return k===this.expr?this:W.create(k,this.c,!1)}evaluate(k){for(let P=0,z=this.expr.length;P<z;P++)if(this.expr[P].evaluate(k))return!0;return!1}static d(k,P,z){let H=[],ee=!1;if(k){for(let ne=0,fe=k.length;ne<fe;ne++){const x=k[ne];if(x){if(x.type===0){ee=!0;continue}if(x.type===1)return r.INSTANCE;if(x.type===9){H=H.concat(x.expr);continue}H.push(x)}}if(H.length===0&&ee)return i.INSTANCE;H.sort(n)}if(H.length!==0){if(H.length===1)return H[0];for(let ne=1;ne<H.length;ne++)H[ne-1].equals(H[ne])&&(H.splice(ne,1),ne--);if(H.length===1)return H[0];if(z){for(let ne=0;ne<H.length;ne++)for(let fe=ne+1;fe<H.length;fe++)if(H[ne].negate().equals(H[fe]))return r.INSTANCE;if(H.length===1)return H[0]}return new W(H,P)}}serialize(){return this.expr.map(k=>k.serialize()).join(" || ")}keys(){const k=[];for(const P of this.expr)k.push(...P.keys());return k}map(k){return new W(this.expr.map(P=>P.map(k)),null)}negate(){if(!this.c){const k=[];for(const P of this.expr)k.push(P.negate());for(;k.length>1;){const P=k.shift(),z=k.shift(),H=[];for(const ee of Y(P))for(const ne of Y(z))H.push(X.create([ee,ne],null,!1));k.unshift(W.create(H,null,!1))}this.c=W.create(k,this,!0)}return this.c}}e.$Ni=W;class q extends a{static{this.d=[]}static all(){return q.d.values()}constructor(k,P,z){super(k,null),this.f=P,typeof z=="object"?q.d.push({...z,key:k}):z!==!0&&q.d.push({key:k,description:z,type:P!=null?typeof P:void 0})}bindTo(k){return k.createKey(this.key,this.f)}getValue(k){return k.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(k){return v.create(this.key,k)}notEqualsTo(k){return E.create(this.key,k)}}e.$Oi=q,e.$Pi=(0,A.$ph)("contextKeyService");function B(U,k){return U<k?-1:U>k?1:0}function _(U,k,P,z){return U<P?-1:U>P?1:k<z?-1:k>z?1:0}function oe(U,k){if(U.type===0||k.type===1)return!0;if(U.type===9)return k.type===9?ae(U.expr,k.expr):!1;if(k.type===9){for(const P of k.expr)if(oe(U,P))return!0;return!1}if(U.type===6){if(k.type===6)return ae(k.expr,U.expr);for(const P of U.expr)if(oe(P,k))return!0;return!1}return U.equals(k)}e.$Qi=oe;function ae(U,k){let P=0,z=0;for(;P<U.length&&z<k.length;){const H=U[P].cmp(k[z]);if(H<0)return!1;H===0&&P++,z++}return P===U.length}function Y(U){return U.type===9?U.expr:[U]}}),define(ce[95],le([0,1,4]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8l=e.$7l=e.$6l=e.ID=void 0,e.ID="diagnosticsService",e.$6l=(0,L.$ph)(e.ID);function N(A){return!!A.hostName&&!!A.errorMessage}e.$7l=N;class O{async getPerformanceInfo(j,R){return{}}async getSystemInfo(j,R){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(j,R){return""}async getWorkspaceFileExtensions(j){return{extensions:[]}}async reportWorkspaceStats(j){}}e.$8l=O}),define(ce[96],le([0,1,4]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vn=void 0,e.$vn=(0,L.$ph)("downloadService")}),define(ce[15],le([0,1,4]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xh=e.$wh=void 0,e.$wh=(0,L.$ph)("environmentService"),e.$xh=(0,L.$qh)(e.$wh)}),define(ce[29],le([0,1,151,4]),function(ie,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Rn=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=void 0,e.$En="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Fn=new RegExp(e.$En),e.$Gn="__web_extension",e.$Hn="skipWalkthrough",e.$In="extensionsSync",e.$Jn="dependecyOrPackExtensionInstall";function O(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Kn=O;function A(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Ln=A;function j(f,b){switch(f){case 3:return b==="x64"?"win32-x64":b==="ia32"?"win32-ia32":b==="arm64"?"win32-arm64":"unknown";case 2:return b==="x64"?"linux-x64":b==="arm64"?"linux-arm64":b==="arm"?"linux-armhf":"unknown";case"alpine":return b==="x64"?"alpine-x64":b==="arm64"?"alpine-arm64":"unknown";case 1:return b==="x64"?"darwin-x64":b==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Mn=j;function R(f,b){return b==="web"&&!f.includes("web")}e.$Nn=R;function S(f,b,w){return R(b,w)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===w?!0:g(w).includes(f)}e.$On=S;function g(f){switch(f){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$Pn=g;function C(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.$Qn=C;var y;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(y||(e.SortBy=y={}));var $;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})($||(e.SortOrder=$={}));var u;(function(f){f.Install="install",f.Uninstall="uninstall"})(u||(e.StatisticType=u={}));var d;(function(f){f[f.None=1]="None",f[f.Install=2]="Install",f[f.Update=3]="Update",f[f.Migrate=4]="Migrate"})(d||(e.InstallOperation=d={})),e.$Rn=(0,N.$ph)("extensionGalleryService");var p;(function(f){f.Unsupported="Unsupported",f.Deprecated="Deprecated",f.Malicious="Malicious",f.Incompatible="Incompatible",f.IncompatibleTargetPlatform="IncompatibleTargetPlatform",f.ReleaseVersionNotFound="ReleaseVersionNotFound",f.Invalid="Invalid",f.Download="Download",f.Extract="Extract",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Signature="Signature",f.Internal="Internal"})(p||(e.ExtensionManagementErrorCode=p={}));var c;(function(f){f.UnknownError="UnknownError",f.PackageIsInvalidZip="PackageIsInvalidZip",f.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(c||(e.ExtensionSignaturetErrorCode=c={}));class h extends Error{constructor(b,w){super(b),this.code=w,this.name=w}}e.$Sn=h,e.$Tn=(0,N.$ph)("extensionManagementService"),e.$Un="extensionsIdentifiers/disabled",e.$Vn="extensionsIdentifiers/enabled",e.$Wn=(0,N.$ph)("IGlobalExtensionEnablementService"),e.$Xn=(0,N.$ph)("IExtensionTipsService"),e.$Yn=(0,L.localize)(0,null),e.$Zn={value:e.$Yn,original:"Extensions"},e.$1n={value:(0,L.localize)(1,null),original:"Preferences"}}),define(ce[186],le([0,1,3,2,30,10,92,29]),function(ie,e,L,N,O,A,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3o=e.$2o=e.$1o=void 0;function S(c,h){return c?A.URI.revive(h?h.transformIncoming(c):c):void 0}function g(c,h){return h?h.transformOutgoingURI(c):c}function C(c,h){h=h||j.$pm;const f=c.manifest;return{...(0,j.$sm)({...c,manifest:void 0},h),manifest:f}}function y(c,h){return c?.profileLocation?(0,j.$sm)(c,h??j.$pm):c}function $(c,h){return h?(0,O.$Km)(c,f=>f instanceof A.URI?h.transformOutgoingURI(f):void 0):c}class u{constructor(h,f){this.a=h,this.b=f,this.onInstallExtension=L.Event.buffer(h.onInstallExtension,!0),this.onDidInstallExtensions=L.Event.buffer(h.onDidInstallExtensions,!0),this.onUninstallExtension=L.Event.buffer(h.onUninstallExtension,!0),this.onDidUninstallExtension=L.Event.buffer(h.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=L.Event.buffer(h.onDidUpdateExtensionMetadata,!0)}listen(h,f){const b=this.b(h);switch(f){case"onInstallExtension":return L.Event.map(this.onInstallExtension,w=>({...w,profileLocation:w.profileLocation?g(w.profileLocation,b):w.profileLocation}));case"onDidInstallExtensions":return L.Event.map(this.onDidInstallExtensions,w=>w.map(I=>({...I,local:I.local?$(I.local,b):I.local,profileLocation:I.profileLocation?g(I.profileLocation,b):I.profileLocation})));case"onUninstallExtension":return L.Event.map(this.onUninstallExtension,w=>({...w,profileLocation:w.profileLocation?g(w.profileLocation,b):w.profileLocation}));case"onDidUninstallExtension":return L.Event.map(this.onDidUninstallExtension,w=>({...w,profileLocation:w.profileLocation?g(w.profileLocation,b):w.profileLocation}));case"onDidUpdateExtensionMetadata":return L.Event.map(this.onDidUpdateExtensionMetadata,w=>$(w,b))}throw new Error("Invalid listen")}async call(h,f,b){const w=this.b(h);switch(f){case"zip":{const I=C(b[0],w),t=await this.a.zip(I);return g(t,w)}case"unzip":return this.a.unzip(S(b[0],w));case"install":return this.a.install(S(b[0],w),y(b[1],w));case"installFromLocation":return this.a.installFromLocation(S(b[0],w),S(b[1],w));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(b[0],S(b[1],w),S(b[2],w));case"getManifest":return this.a.getManifest(S(b[0],w));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(b[0]);case"installFromGallery":return this.a.installFromGallery(b[0],y(b[1],w));case"installGalleryExtensions":{const I=b[0];return this.a.installGalleryExtensions(I.map(({extension:t,options:o})=>({extension:t,options:y(o,w)??{}})))}case"uninstall":return this.a.uninstall(C(b[0],w),y(b[1],w));case"reinstallFromGallery":return this.a.reinstallFromGallery(C(b[0],w));case"getInstalled":return(await this.a.getInstalled(b[0],S(b[1],w))).map(t=>$(t,w));case"toggleAppliationScope":{const I=await this.a.toggleAppliationScope(C(b[0],w),S(b[1],w));return $(I,w)}case"copyExtensions":return this.a.copyExtensions(S(b[0],w),S(b[1],w));case"updateMetadata":{const I=await this.a.updateMetadata(C(b[0],w),b[1],S(b[2],w));return $(I,w)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(b[0],b[1],b[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$1o=u;class d extends N.$lb{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(h){super(),this.k=h,this.c=this.B(new L.$ec),this.f=this.B(new L.$ec),this.g=this.B(new L.$ec),this.h=this.B(new L.$ec),this.j=this.B(new L.$ec),this.B(this.k.listen("onInstallExtension")(f=>this.l(this.c,{...f,source:this.m(f.source)?A.URI.revive(f.source):f.source,profileLocation:A.URI.revive(f.profileLocation)}))),this.B(this.k.listen("onDidInstallExtensions")(f=>this.l(this.f,f.map(b=>({...b,local:b.local?C(b.local,null):b.local,source:this.m(b.source)?A.URI.revive(b.source):b.source,profileLocation:A.URI.revive(b.profileLocation)}))))),this.B(this.k.listen("onUninstallExtension")(f=>this.l(this.g,{...f,profileLocation:A.URI.revive(f.profileLocation)}))),this.B(this.k.listen("onDidUninstallExtension")(f=>this.l(this.h,{...f,profileLocation:A.URI.revive(f.profileLocation)}))),this.B(this.k.listen("onDidUpdateExtensionMetadata")(f=>this.j.fire(C(f,null))))}l(h,f){h.fire(f)}m(h){return h?typeof h.path=="string"&&typeof h.scheme=="string":!1}getTargetPlatform(){return this.n||(this.n=this.k.call("getTargetPlatform")),this.n}async canInstall(h){const f=await this.getTargetPlatform();return h.allTargetPlatforms.some(b=>(0,R.$On)(b,h.allTargetPlatforms,f))}zip(h){return Promise.resolve(this.k.call("zip",[h]).then(f=>A.URI.revive(f)))}unzip(h){return Promise.resolve(this.k.call("unzip",[h]))}install(h,f){return Promise.resolve(this.k.call("install",[h,f])).then(b=>C(b,null))}installFromLocation(h,f){return Promise.resolve(this.k.call("installFromLocation",[h,f])).then(b=>C(b,null))}async installExtensionsFromProfile(h,f,b){return(await this.k.call("installExtensionsFromProfile",[h,f,b])).map(I=>C(I,null))}getManifest(h){return Promise.resolve(this.k.call("getManifest",[h]))}installFromGallery(h,f){return Promise.resolve(this.k.call("installFromGallery",[h,f])).then(b=>C(b,null))}async installGalleryExtensions(h){return(await this.k.call("installGalleryExtensions",[h])).map(b=>({...b,local:b.local?C(b.local,null):b.local,source:this.m(b.source)?A.URI.revive(b.source):b.source,profileLocation:A.URI.revive(b.profileLocation)}))}uninstall(h,f){return Promise.resolve(this.k.call("uninstall",[h,f]))}reinstallFromGallery(h){return Promise.resolve(this.k.call("reinstallFromGallery",[h])).then(f=>C(f,null))}getInstalled(h=null,f){return Promise.resolve(this.k.call("getInstalled",[h,f])).then(b=>b.map(w=>C(w,null)))}updateMetadata(h,f,b){return Promise.resolve(this.k.call("updateMetadata",[h,f,b])).then(w=>C(w,null))}toggleAppliationScope(h,f){return this.k.call("toggleAppliationScope",[h,f]).then(b=>C(b,null))}copyExtensions(h,f){return this.k.call("copyExtensions",[h,f])}getExtensionsControlManifest(){return Promise.resolve(this.k.call("getExtensionsControlManifest"))}async download(h,f,b){const w=await this.k.call("download",[h,f,b]);return A.URI.revive(w)}async cleanUp(){return this.k.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$2o=d;class p{constructor(h){this.a=h}listen(h,f){throw new Error("Invalid listen")}call(h,f,b){switch(f){case"getConfigBasedTips":return this.a.getConfigBasedTips(A.URI.revive(b[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$3o=p}),define(ce[97],le([0,1,4]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yo=e.$Xo=void 0,e.$Xo=(0,L.$ph)("IExtensionSignatureVerificationService");class N{b(){return this.a||(this.a=new Promise((A,j)=>ie(["node-vsce-sign"],async R=>A(R),j))),this.a}async verify(A,j,R){let S;try{S=await this.b()}catch{return!1}return S.verify(A,j,R)}}e.$Yo=N}),define(ce[98],le([0,1,4]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2Tb=e.RecommendationsNotificationResult=e.$1Tb=e.RecommendationSource=void 0;var N;(function(j){j[j.FILE=1]="FILE",j[j.WORKSPACE=2]="WORKSPACE",j[j.EXE=3]="EXE"})(N||(e.RecommendationSource=N={}));function O(j){switch(j){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.$1Tb=O;var A;(function(j){j.Ignored="ignored",j.Cancelled="cancelled",j.TooMany="toomany",j.IncompatibleWindow="incompatibleWindow",j.Accepted="reacted"})(A||(e.RecommendationsNotificationResult=A={})),e.$2Tb=(0,L.$ph)("IExtensionRecommendationNotificationService")}),define(ce[13],le([0,1,47,16,28,11,10,158,4,6,26]),function(ie,e,L,N,O,A,j,R,S,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.FileKind=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.FileOperationResult=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.FileChangeType=e.$0j=e.FileOperation=e.$9j=e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.FileSystemProviderErrorCode=e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$Tj=e.$Sj=void 0,e.$Sj=(0,S.$ph)("fileService");function y(B){return B.create===!0}e.$Tj=y;var $;(function(B){B[B.Unknown=0]="Unknown",B[B.File=1]="File",B[B.Directory=2]="Directory",B[B.SymbolicLink=64]="SymbolicLink"})($||(e.FileType=$={}));var u;(function(B){B[B.Readonly=1]="Readonly",B[B.Locked=2]="Locked"})(u||(e.FilePermission=u={}));var d;(function(B){B[B.None=0]="None",B[B.FileReadWrite=2]="FileReadWrite",B[B.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",B[B.FileReadStream=16]="FileReadStream",B[B.FileFolderCopy=8]="FileFolderCopy",B[B.PathCaseSensitive=1024]="PathCaseSensitive",B[B.Readonly=2048]="Readonly",B[B.Trash=4096]="Trash",B[B.FileWriteUnlock=8192]="FileWriteUnlock",B[B.FileAtomicRead=16384]="FileAtomicRead",B[B.FileAtomicWrite=32768]="FileAtomicWrite",B[B.FileAtomicDelete=65536]="FileAtomicDelete",B[B.FileClone=131072]="FileClone"})(d||(e.FileSystemProviderCapabilities=d={}));function p(B){return!!(B.capabilities&2)}e.$Uj=p;function c(B){return!!(B.capabilities&8)}e.$Vj=c;function h(B){return!!(B.capabilities&131072)}e.$Wj=h;function f(B){return!!(B.capabilities&4)}e.$Xj=f;function b(B){return!!(B.capabilities&16)}e.$Yj=b;function w(B){return p(B)?!!(B.capabilities&16384):!1}e.$Zj=w;function I(B){return p(B)?!!(B.capabilities&32768):!1}e.$1j=I;function t(B){return!!(B.capabilities&65536)}e.$2j=t;function o(B){return!!(B.capabilities&2048)}e.$3j=o;var s;(function(B){B.FileExists="EntryExists",B.FileNotFound="EntryNotFound",B.FileNotADirectory="EntryNotADirectory",B.FileIsADirectory="EntryIsADirectory",B.FileExceedsStorageQuota="EntryExceedsStorageQuota",B.FileTooLarge="EntryTooLarge",B.FileWriteLocked="EntryWriteLocked",B.NoPermissions="NoPermissions",B.Unavailable="Unavailable",B.Unknown="Unknown"})(s||(e.FileSystemProviderErrorCode=s={}));class n extends Error{static create(_,oe){const ae=new n(_.toString(),oe);return a(ae,oe),ae}constructor(_,oe){super(_),this.code=oe}}e.$4j=n;function i(B,_){return n.create(B,_)}e.$5j=i;function r(B){return B||i((0,R.localize)(0,null),s.Unknown)}e.$6j=r;function a(B,_){return B.name=_?`${_} (FileSystemError)`:"FileSystemError",B}e.$7j=a;function v(B){if(!B)return s.Unknown;if(B instanceof n)return B.code;const _=/^(.+) \(FileSystemError\)$/.exec(B.name);if(!_)return s.Unknown;switch(_[1]){case s.FileExists:return s.FileExists;case s.FileIsADirectory:return s.FileIsADirectory;case s.FileNotADirectory:return s.FileNotADirectory;case s.FileNotFound:return s.FileNotFound;case s.FileTooLarge:return s.FileTooLarge;case s.FileWriteLocked:return s.FileWriteLocked;case s.NoPermissions:return s.NoPermissions;case s.Unavailable:return s.Unavailable}return s.Unknown}e.$8j=v;function m(B){if(B instanceof F)return B.fileOperationResult;switch(v(B)){case s.FileNotFound:return 1;case s.FileIsADirectory:return 0;case s.FileNotADirectory:return 9;case s.FileWriteLocked:return 5;case s.NoPermissions:return 6;case s.FileExists:return 4;case s.FileTooLarge:return 7;default:return 10}}e.$9j=m;var l;(function(B){B[B.CREATE=0]="CREATE",B[B.DELETE=1]="DELETE",B[B.MOVE=2]="MOVE",B[B.COPY=3]="COPY",B[B.WRITE=4]="WRITE"})(l||(e.FileOperation=l={}));class E{constructor(_,oe,ae){this.resource=_,this.operation=oe,this.target=ae}isOperation(_){return this.operation===_}}e.$0j=E;var D;(function(B){B[B.UPDATED=0]="UPDATED",B[B.ADDED=1]="ADDED",B[B.DELETED=2]="DELETED"})(D||(e.FileChangeType=D={}));class T{constructor(_,oe){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ae=new Map;for(const Y of _){const U=ae.get(Y.type);switch(U?U.push([Y.resource,Y]):ae.set(Y.type,[[Y.resource,Y]]),Y.type){case 1:this.rawAdded.push(Y.resource);break;case 0:this.rawUpdated.push(Y.resource);break;case 2:this.rawDeleted.push(Y.resource);break}}for(const[Y,U]of ae)switch(Y){case 1:this.a=L.$vh.forUris(()=>oe),this.a.fill(U);break;case 0:this.b=L.$vh.forUris(()=>oe),this.b.fill(U);break;case 2:this.c=L.$vh.forUris(()=>oe),this.c.fill(U);break}}contains(_,...oe){return this.d(_,{includeChildren:!1},...oe)}affects(_,...oe){return this.d(_,{includeChildren:!0},...oe)}d(_,oe,...ae){if(!_)return!1;const Y=ae.length>0;return!!((!Y||ae.includes(1))&&(this.a?.get(_)||oe.includeChildren&&this.a?.findSuperstr(_))||(!Y||ae.includes(0))&&(this.b?.get(_)||oe.includeChildren&&this.b?.findSuperstr(_))||(!Y||ae.includes(2))&&(this.c?.findSubstr(_)||oe.includeChildren&&this.c?.findSuperstr(_)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.$$j=T;function M(B,_,oe){return!B||!_||B===_||_.length>B.length?!1:(_.charAt(_.length-1)!==N.sep&&(_+=N.sep),oe?(0,O.$Md)(B,_):B.indexOf(_)===0)}e.$_j=M;class F extends Error{constructor(_,oe,ae){super(_),this.fileOperationResult=oe,this.options=ae}}e.$ak=F;class V extends F{constructor(_,oe,ae,Y){super(_,oe,Y),this.fileOperationResult=oe,this.size=ae}}e.$bk=V;class Z extends F{constructor(_,oe,ae){super(_,2,ae),this.stat=oe}}e.$ck=Z;var J;(function(B){B[B.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",B[B.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",B[B.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",B[B.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",B[B.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",B[B.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",B[B.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",B[B.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",B[B.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",B[B.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",B[B.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(J||(e.FileOperationResult=J={})),e.$dk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$ek={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$fk="files.associations",e.$gk="files.exclude",e.$hk="files.readonlyInclude",e.$ik="files.readonlyExclude",e.$jk="files.readonlyFromPermissions";var Q;(function(B){B[B.FILE=0]="FILE",B[B.FOLDER=1]="FOLDER",B[B.ROOT_FOLDER=2]="ROOT_FOLDER"})(Q||(e.FileKind=Q={})),e.$kk="";function G(B){if(!(typeof B.size!="number"||typeof B.mtime!="number"))return B.mtime.toString(29)+B.size.toString(31)}e.$lk=G;async function X(B,_){if(!_.hasProvider(j.URI.from({scheme:B.scheme})))return new Promise(oe=>{const ae=_.onDidChangeFileSystemProviderRegistrations(Y=>{Y.scheme===B.scheme&&Y.added&&(ae.dispose(),oe())})})}e.$mk=X;class W{static{this.KB=1024}static{this.MB=W.KB*W.KB}static{this.GB=W.MB*W.KB}static{this.TB=W.GB*W.KB}static formatSize(_){return(0,A.$me)(_)||(_=0),_<W.KB?(0,R.localize)(1,null,_.toFixed(0)):_<W.MB?(0,R.localize)(2,null,(_/W.KB).toFixed(2)):_<W.GB?(0,R.localize)(3,null,(_/W.MB).toFixed(2)):_<W.TB?(0,R.localize)(4,null,(_/W.GB).toFixed(2)):(0,R.localize)(5,null,(_/W.TB).toFixed(2))}}e.$nk=W;function q(B){const _=typeof B=="string"||B?.scheme===C.Schemas.vscodeRemote;return typeof B!="string"&&B?.scheme===C.Schemas.file?1024*W.MB:_?10*W.MB:g.$o?50*W.MB:1024*W.MB}e.$ok=q});var K=this&&this.__param||function(ie,e){return function(L,N){e(L,N,ie)}};define(ce[187],le([0,1,69,42,13]),function(ie,e,L,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$86b=void 0;let A=class{constructor(R){this.a=R}async checksum(R){const S=(await this.a.readFileStream(R)).value;return new Promise((g,C)=>{const y=(0,L.createHash)("md5");(0,N.$wc)(S,{onData:$=>y.update($.buffer),onError:$=>C($),onEnd:()=>g(y.digest("base64").replace(/=+$/,""))})})}};e.$86b=A,e.$86b=A=ye([K(0,O.$Sj)],A)}),define(ce[188],le([0,1,14,38,8,3,2,42,10,32,13]),function(ie,e,L,N,O,A,j,R,S,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RM=e.$QM=void 0,e.$QM="localFilesystem";class y extends j.$lb{constructor(u,d){super(),this.a=u,this.b=d,this.onDidChangeCapabilities=A.Event.None,this.f=this.B(new A.$ec),this.onDidChangeFile=this.f.event,this.g=this.B(new A.$ec),this.onDidWatchError=this.g.event,this.h=(0,g.$3e)(),this.i()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(u){return this.a.call("stat",[u])}readdir(u){return this.a.call("readdir",[u])}async readFile(u,d){const{buffer:p}=await this.a.call("readFile",[u,d]);return p}readFileStream(u,d,p){const c=(0,R.$sc)(f=>L.$Ec.concat(f.map(b=>L.$Ec.wrap(b))).buffer),h=this.a.listen("readFileStream",[u,d])(f=>{if(f instanceof L.$Ec)c.write(f.buffer);else{if(f==="end")c.end();else{let b;if(f instanceof Error)b=f;else{const w=f;b=(0,C.$5j)(w.message??(0,N.$ai)(w),w.code??C.FileSystemProviderErrorCode.Unknown)}c.error(b),c.end()}h.dispose()}});return p.onCancellationRequested(()=>{c.error((0,O.$4)()),c.end(),h.dispose()}),c}writeFile(u,d,p){return this.a.call("writeFile",[u,L.$Ec.wrap(d),p])}open(u,d){return this.a.call("open",[u,d])}close(u){return this.a.call("close",[u])}async read(u,d,p,c,h){const[f,b]=await this.a.call("read",[u,d,h]);return p.set(f.buffer.slice(0,b),c),b}write(u,d,p,c,h){return this.a.call("write",[u,d,L.$Ec.wrap(p),c,h])}mkdir(u){return this.a.call("mkdir",[u])}delete(u,d){return this.a.call("delete",[u,d])}rename(u,d,p){return this.a.call("rename",[u,d,p])}copy(u,d,p){return this.a.call("copy",[u,d,p])}cloneFile(u,d){return this.a.call("cloneFile",[u,d])}i(){this.B(this.a.listen("fileChange",[this.h])(u=>{if(Array.isArray(u)){const d=u;this.f.fire(d.map(p=>({resource:S.URI.revive(p.resource),type:p.type})))}else{const d=u;this.g.fire(d)}}))}watch(u,d){const p=(0,g.$3e)();return this.a.call("watch",[this.h,p,u,d]),(0,j.$jb)(()=>this.a.call("unwatch",[this.h,p]))}}e.$RM=y}),define(ce[99],le([0,1,14,8,159,13]),function(ie,e,L,N,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=void 0;async function j(C,y,$,u,d,p){let c;try{await R(C,y,$,u,d,p)}catch(h){c=h}finally{c&&d.errorTransformer&&(c=d.errorTransformer(c)),typeof c<"u"&&$.error(c),$.end()}}e.$tp=j;async function R(C,y,$,u,d,p){S(p);const c=await C.open(y,{create:!1});try{S(p);let h=0,f=0,b=d&&typeof d.length=="number"?d.length:void 0,w=L.$Ec.alloc(Math.min(d.bufferSize,typeof b=="number"?b:d.bufferSize)),I=d&&typeof d.position=="number"?d.position:0,t=0;do f=await C.read(c,I,w.buffer,t,w.byteLength-t),I+=f,t+=f,h+=f,typeof b=="number"&&(b-=f),t===w.byteLength&&(await $.write(u(w)),w=L.$Ec.alloc(Math.min(d.bufferSize,typeof b=="number"?b:d.bufferSize)),t=0);while(f>0&&(typeof b!="number"||b>0)&&S(p)&&g(h,d));if(t>0){let o=t;typeof b=="number"&&(o=Math.min(t,b)),$.write(u(w.slice(0,o)))}}catch(h){throw(0,A.$6j)(h)}finally{await C.close(c)}}function S(C){if(C.isCancellationRequested)throw(0,N.$4)();return!0}function g(C,y){if(typeof y?.limits?.size=="number"&&C>y.limits.size)throw(0,A.$5j)((0,O.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ce[54],le([0,1,91,2,16,6,10,13]),function(ie,e,L,N,O,A,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cp=e.$Bp=e.$Ap=e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=void 0;function S(h){return h.recursive===!0}e.$vp=S;class g extends N.$lb{static{this.a=5}constructor(f,b,w,I){super(),this.h=f,this.i=b,this.j=w,this.k=I,this.c=this.B(new N.$mb),this.f=void 0,this.g=0}m(){const f=new N.$kb;this.c.value=f,this.b=this.l(f),this.b.setVerboseLogging(this.j),f.add(this.b.onDidChangeFile(b=>this.h(b))),f.add(this.b.onDidLogMessage(b=>this.i(b))),f.add(this.b.onDidError(b=>this.n(b)))}n(f){this.k.restartOnError?this.g<g.a&&this.f?(this.r(`restarting watcher after error: ${f}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${f}`):this.r(f)}p(f){this.g++,this.m(),this.watch(f)}async watch(f){this.f=f,await this.b?.watch(f)}async setVerboseLogging(f){this.j=f,await this.b?.setVerboseLogging(f)}r(f){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${f}`})}s(f){this.i({type:"trace",message:`[File Watcher (${this.k.type})] ${f}`})}dispose(){return this.b=void 0,super.dispose()}}e.$wp=g;class C extends g{constructor(f,b,w){super(f,b,w,{type:"node.js",restartOnError:!1})}}e.$xp=C;class y extends g{constructor(f,b,w){super(f,b,w,{type:"universal",restartOnError:!0})}}e.$yp=y;function $(h){return h.map(f=>({type:f.type,resource:j.URI.file(f.path)}))}e.$zp=$;function u(h){const f=new c;for(const b of h)f.processEvent(b);return f.coalesce()}e.$Ap=u;function d(h,f){return typeof f=="string"&&!f.startsWith(L.$aj)&&!(0,O.$7c)(f)?{base:h,pattern:f}:f}e.$Bp=d;function p(h,f){const b=[];for(const w of f)b.push((0,L.$ej)(d(h,w)));return b}e.$Cp=p;class c{constructor(){this.a=new Set,this.b=new Map}c(f){return A.$k?f.path:f.path.toLowerCase()}processEvent(f){const b=this.b.get(this.c(f));let w=!1;if(b){const I=b.type,t=f.type;b.path!==f.path&&(f.type===2||f.type===1)?w=!0:I===1&&t===2?(this.b.delete(this.c(f)),this.a.delete(b)):I===2&&t===1?b.type=0:I===1&&t===0||(b.type=t)}else w=!0;w&&(this.a.add(f),this.b.set(this.c(f),f))}coalesce(){const f=[],b=[];return Array.from(this.a).filter(w=>w.type!==2?(f.push(w),!1):!0).sort((w,I)=>w.path.length-I.path.length).filter(w=>b.some(I=>(0,R.$_j)(w.path,I,!A.$k))?!1:(b.push(w.path),!0)).concat(f)}}}),define(ce[189],le([0,1,52,5,25,48,2,88,16,6,142,31,54]),function(ie,e,L,N,O,A,j,R,S,g,C,y,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qp=e.$Pp=void 0;class u extends j.$lb{static{this.a=100}static{this.b=75}constructor(c,h,f,b){super(),this.j=c,this.k=h,this.l=f,this.m=b,this.c=this.B(new N.$Jg({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},w=>this.k(w))),this.f=this.B(new N.$Ig(w=>this.u(w),u.b)),this.g=(0,$.$Cp)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,$.$Cp)(this.j.path,this.j.includes):void 0,this.i=new O.$oc,this.ready=this.n()}async n(){try{const c=await this.r(this.j);if(this.i.token.isCancellationRequested)return;const h=await y.Promises.stat(c);this.B(await this.s(c,h.isDirectory()))}catch(c){c.code!=="ENOENT"?this.w(c):this.z(c)}}async r(c){let h=c.path;try{h=await y.Promises.realpath(c.path),c.path===h&&(h=await(0,C.$Mp)(c.path)??c.path),c.path!==h&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${c.path}, real: ${h})`)}catch{}return h}async s(c,h){if(g.$j&&(0,A.$He)(c,"/Volumes/",!0))return this.w(`Refusing to watch ${c} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),j.$lb.None;const f=new O.$oc(this.i.token),b=new j.$kb;try{const w=(0,S.$_c)(c),I=(0,L.watch)(c);b.add((0,j.$jb)(()=>{I.removeAllListeners(),I.close()})),this.z(`Started watching: '${c}'`);const t=new Set;if(h)try{for(const s of await y.Promises.readdir(c))t.add(s)}catch(s){this.w(s)}const o=new Map;b.add((0,j.$jb)(()=>{for(const[,s]of o)s.dispose();o.clear()})),I.on("error",(s,n)=>{this.w(`Failed to watch ${c} for changes using fs.watch() (${s}, ${n})`),this.dispose()}),I.on("change",(s,n)=>{if(f.token.isCancellationRequested)return;this.z(`[raw] ["${s}"] ${n}`);let i="";if(n&&(i=n.toString(),g.$j&&(i=(0,R.$7k)(i))),!(!i||s!=="change"&&s!=="rename"))if(h)if(s==="rename"){o.get(i)?.dispose();const r=setTimeout(async()=>{if(o.delete(i),i===w&&!await y.Promises.exists(c)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const a=await this.v((0,S.$8c)(c,i));if(f.token.isCancellationRequested)return;let v;a?t.has(i)?v=0:(v=1,t.add(i)):(t.delete(i),v=2),this.t({path:(0,S.$8c)(this.j.path,i),type:v})},u.a);o.set(i,(0,j.$jb)(()=>clearTimeout(r)))}else{let r;t.has(i)?r=0:(r=1,t.add(i)),this.t({path:(0,S.$8c)(this.j.path,i),type:r})}else if(s==="rename"||i!==w){const r=setTimeout(async()=>{const a=await y.Promises.exists(c);f.token.isCancellationRequested||(a?(this.t({path:this.j.path,type:0},!0),b.add(await this.s(c,!1))):(this.t({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},u.a);b.clear(),b.add((0,j.$jb)(()=>clearTimeout(r)))}else this.t({path:this.j.path,type:0},!0)})}catch(w){await y.Promises.exists(c)&&!f.token.isCancellationRequested&&this.w(`Failed to watch ${c} for changes using fs.watch() (${w.toString()})`)}return(0,j.$jb)(()=>{f.dispose(!0),b.dispose()})}t(c,h=!1){this.i.token.isCancellationRequested||(this.m&&this.z(`${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.path}`),!h&&this.g.some(f=>f(c.path))?this.m&&this.z(` >> ignored (excluded) ${c.path}`):!h&&this.h&&this.h.length>0&&!this.h.some(f=>f(c.path))?this.m&&this.z(` >> ignored (not included) ${c.path}`):this.f.work(c))}u(c){const h=(0,$.$Ap)(c);if(h.length>0){if(this.m)for(const b of h)this.z(`>> normalized ${b.type===1?"[ADDED]":b.type===2?"[DELETED]":"[CHANGED]"} ${b.path}`);this.c.work(h)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${h[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${h.length}, most recent change: ${h[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async v(c){if(g.$k)return y.Promises.exists(c);try{const h=(0,S.$_c)(c);return(await y.Promises.readdir((0,S.$$c)(c))).some(b=>b===h)}catch(h){return this.z(h),!1}}setVerboseLogging(c){this.m=c}w(c){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${c}`})}y(c){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${c}`})}z(c){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${c}`})}dispose(){this.z(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}e.$Pp=u;async function d(p,c,h,f,b=512){const w=await y.Promises.open(p,"r"),I=Buffer.allocUnsafe(b),t=new O.$oc(f);let o,s=!1;const n={path:p,excludes:[],recursive:!1},i=new u(n,r=>{(async()=>{for(const{type:a}of r)if(a===0){if(s)return;s=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:v}=await y.Promises.read(w,I,0,b,null);if(!v||t.token.isCancellationRequested)break;c(I.slice(0,v))}}catch(v){o=new Error(v),t.dispose(!0)}finally{s=!1}}})()});return await i.ready,h(),new Promise((r,a)=>{t.token.onCancellationRequested(async()=>{i.dispose();try{await y.Promises.close(w)}catch(v){o=new Error(v)}o?a(o):r()})})}e.$Qp=d}),define(ce[190],le([0,1,3,91,2,6,189]),function(ie,e,L,N,O,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=void 0;class R extends O.$lb{constructor(){super(...arguments),this.a=this.B(new L.$ec),this.onDidChangeFile=this.a.event,this.b=this.B(new L.$ec),this.onDidLogMessage=this.b.event,this.onDidError=L.Event.None,this.c=new Map,this.f=!1}async watch(g){const C=this.i(g),y=C.filter(u=>{const d=this.c.get(u.path);return d?!(0,N.$ij)(d.request.excludes,u.excludes)||!(0,N.$ij)(d.request.includes,u.includes):!0}),$=Array.from(this.c.values()).filter(({request:u})=>!C.find(d=>d.path===u.path&&(0,N.$ij)(d.excludes,u.excludes)&&(0,N.$ij)(d.includes,u.includes))).map(({request:u})=>u.path);y.length&&this.j(`Request to start watching: ${y.map(u=>`${u.path} (excludes: ${u.excludes.length>0?u.excludes:"<none>"}, includes: ${u.includes&&u.includes.length>0?JSON.stringify(u.includes):"<all>"})`).join(",")}`),$.length&&this.j(`Request to stop watching: ${$.join(",")}`);for(const u of $)this.h(u);for(const u of y)this.g(u)}g(g){const C=new j.$Pp(g,$=>this.a.fire($),$=>this.b.fire($),this.f),y={request:g,instance:C};this.c.set(g.path,y)}async stop(){for(const[g]of this.c)this.h(g);this.c.clear()}h(g){const C=this.c.get(g);C&&(this.c.delete(g),C.instance.dispose())}i(g){const C=new Map;for(const y of g){const $=A.$k?y.path:y.path.toLowerCase();C.set($,y)}return Array.from(C.values())}async setVerboseLogging(g){this.f=g;for(const[,C]of this.c)C.instance.setVerboseLogging(g)}j(g){this.f&&this.b.fire({type:"trace",message:this.k(g)})}k(g,C){return C?`[File Watcher (node.js)] ${g} (path: ${C.request.path})`:`[File Watcher (node.js)] ${g}`}}e.$Rp=R}),define(ce[191],le([0,1,54,190]),function(ie,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=void 0;class O extends L.$xp{constructor(j,R,S){super(j,R,S),this.m()}l(){return new N.$Rp}}e.$Sp=O}),define(ce[192],le([0,1,26,43,93,54]),function(ie,e,L,N,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kp=void 0;class j extends A.$yp{constructor(S,g,C){super(S,g,C),this.m()}l(S){const g=S.add(new O.$Jp(L.$1e.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return S.add(g.onDidProcessExit(({code:C,signal:y})=>this.n(`terminated by itself with code ${C}, signal: ${y}`))),N.ProxyChannel.toService((0,N.$9g)(g.getChannel("watcher")))}}e.$Kp=j}),define(ce[70],le([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nh=void 0;class L{constructor(...O){this.a=new Map;for(const[A,j]of O)this.set(A,j)}set(O,A){const j=this.a.get(O);return this.a.set(O,A),j}has(O){return this.a.has(O)}get(O){return this.a.get(O)}}e.$nh=L}),define(ce[193],le([0,1,5,8,2,68,184,4,70,87]),function(ie,e,L,N,O,A,j,R,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=e.$Wp=void 0;const C=!1;class y extends Error{constructor(c){super("cyclic dependency between services"),this.message=c.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class ${constructor(c=new S.$nh,h=!1,f,b=C){this.f=c,this.g=h,this.h=f,this.i=b,this.o=new Set,this.f.set(R.$oh,this),this._globalGraph=b?f?._globalGraph??new j.$Vp(w=>w):void 0}createChild(c){return new $(c,this.g,this,this.i)}invokeFunction(c,...h){const f=d.traceInvocation(this.i,c);let b=!1;try{return c({get:I=>{if(b)throw(0,N.$6)("service accessor is only valid during the invocation of its target method");const t=this.m(I,f);if(!t)throw new Error(`[invokeFunction] unknown service '${I}'`);return t}},...h)}finally{b=!0,f.stop()}}createInstance(c,...h){let f,b;return c instanceof A.$mh?(f=d.traceCreation(this.i,c.ctor),b=this.j(c.ctor,c.staticArguments.concat(h),f)):(f=d.traceCreation(this.i,c),b=this.j(c,h,f)),f.stop(),b}j(c,h=[],f){const b=R._util.getServiceDependencies(c).sort((t,o)=>t.index-o.index),w=[];for(const t of b){const o=this.m(t.id,f);o||this.u(`[createInstance] ${c.name} depends on UNKNOWN service ${t.id}.`,!1),w.push(o)}const I=b.length>0?b[0].index:h.length;if(h.length!==I){console.trace(`[createInstance] First service dependency of ${c.name} at position ${I+1} conflicts with ${h.length} static arguments`);const t=I-h.length;t>0?h=h.concat(new Array(t)):h=h.slice(0,I)}return Reflect.construct(c,h.concat(w))}k(c,h){if(this.f.get(c)instanceof A.$mh)this.f.set(c,h);else if(this.h)this.h.k(c,h);else throw new Error("illegalState - setting UNKNOWN service instance")}l(c){const h=this.f.get(c);return!h&&this.h?this.h.l(c):h}m(c,h){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(c));const f=this.l(c);return f instanceof A.$mh?this.q(c,f,h.branch(c,!0)):(h.branch(c,!1),f)}q(c,h,f){if(this.o.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this.o.add(c);try{return this.r(c,h,f)}finally{this.o.delete(c)}}r(c,h,f){const b=new j.$Vp(t=>t.id.toString());let w=0;const I=[{id:c,desc:h,_trace:f}];for(;I.length;){const t=I.pop();if(b.lookupOrInsertNode(t),w++>1e3)throw new y(b);for(const o of R._util.getServiceDependencies(t.desc.ctor)){const s=this.l(o.id);if(s||this.u(`[createInstance] ${c} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(o.id)),s instanceof A.$mh){const n={id:o.id,desc:s,_trace:t._trace.branch(o.id,!0)};b.insertEdge(t,n),I.push(n)}}}for(;;){const t=b.roots();if(t.length===0){if(!b.isEmpty())throw new y(b);break}for(const{data:o}of t){if(this.l(o.id)instanceof A.$mh){const n=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,n)}b.removeNode(o)}}return this.l(c)}s(c,h,f=[],b,w){if(this.f.get(c)instanceof A.$mh)return this.t(c,h,f,b,w);if(this.h)return this.h.s(c,h,f,b,w);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}t(c,h,f=[],b,w){if(b){const I=new $(void 0,this.g,this,this.i);I.c=String(c);const t=new Map,o=new L.$Lg(()=>{const s=I.j(h,f,w);for(const[n,i]of t){const r=s[n];if(typeof r=="function")for(const a of i)r.apply(s,a)}return t.clear(),s});return new Proxy(Object.create(null),{get(s,n){if(!o.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let a=t.get(n);return a||(a=new g.$ub,t.set(n,a)),(m,l,E)=>{const D=a.push([m,l,E]);return(0,O.$jb)(D)}}if(n in s)return s[n];const i=o.value;let r=i[n];return typeof r!="function"||(r=r.bind(i),s[n]=r),r},set(s,n,i){return o.value[n]=i,!0},getPrototypeOf(s){return h.prototype}})}else return this.j(h,f,w)}u(c,h){if(h&&console.warn(c),this.g)throw new Error(c)}}e.$Wp=$;var u;(function(p){p[p.None=0]="None",p[p.Creation=1]="Creation",p[p.Invocation=2]="Invocation",p[p.Branch=3]="Branch"})(u||(u={}));class d{static{this.all=new Set}static{this.c=new class extends d{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(c,h){return c?new d(2,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):d.c}static traceCreation(c,h){return c?new d(1,h.name):d.c}static{this.f=0}constructor(c,h){this.type=c,this.name=h,this.g=Date.now(),this.h=[]}branch(c,h){const f=new d(3,c.toString());return this.h.push([c,h,f]),f}stop(){const c=Date.now()-this.g;d.f+=c;let h=!1;function f(w,I){const t=[],o=new Array(w+1).join("	");for(const[s,n,i]of I.h)if(n&&i){h=!0,t.push(`${o}CREATES -> ${s}`);const r=f(w+1,i);r&&t.push(r)}else t.push(`${o}uses -> ${s}`);return t.join(`
`)}const b=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${d.f.toFixed(2)}ms)`];(c>2||h)&&d.all.add(b.join(`
`))}}e.$Xp=d}),define(ce[71],le([0,1,4]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F6b=e.$E6b=void 0,e.$E6b=(0,L.$ph)("mainProcessService");class N{constructor(A,j){this.a=A,this.b=j}getChannel(A){return this.a.getChannel(A,this.b)}registerChannel(A,j){this.a.registerChannel(A,j)}}e.$F6b=N}),define(ce[72],le([0,1,25,2,6,161,29,4]),function(ie,e,L,N,O,A,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aq=e.$zq=e.$yq=void 0;function S(C){return C.tags.find(y=>y.startsWith("lp-"))?.split("lp-")[1]}e.$yq=S,e.$zq=(0,R.$ph)("languagePackService");let g=class extends N.$lb{constructor(y){super(),this.c=y}async getAvailableLanguages(){const y=new L.$oc;setTimeout(()=>y.cancel(),1e3);let $;try{$=await this.c.query({text:'category:"language packs"',pageSize:20},y.token)}catch{return[]}const d=$.firstPage.filter(p=>p.properties.localizedLanguages?.length&&p.tags.some(c=>c.startsWith("lp-"))).map(p=>{const c=p.properties.localizedLanguages?.[0],h=S(p);return{...this.f(h,c,p),extensionId:p.identifier.id,galleryExtension:p}});return d.push(this.f("en","English")),d}f(y,$,u){const d=$??y;let p;if(d!==y&&(p=`(${y})`),y.toLowerCase()===O.$v.toLowerCase()&&(p??="",p+=(0,A.localize)(0,null)),u?.installCount){p??="";const c=u.installCount;let h;c>1e6?h=`${Math.floor(c/1e5)/10}M`:c>1e3?h=`${Math.floor(c/1e3)}K`:h=String(c),p+=` $(cloud-download) ${h}`}return{id:y,label:d,description:p}}};e.$Aq=g,e.$Aq=g=ye([K(0,j.$Rn)],g)}),define(ce[194],le([0,1,2,72]),function(ie,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$46b=void 0;let O=class extends L.$lb{constructor(j){super(),this.a=j,this.b()}b(){this.a.update()}};e.$46b=O,e.$46b=O=ye([K(0,N.$zq)],O)}),define(ce[7],le([0,1,38,3,51,2,35,6,22,11,10,94,4]),function(ie,e,L,N,O,A,j,R,S,g,C,y,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.log=e.$Ui=e.LogLevel=e.$Ti=e.$Si=e.$Ri=void 0,e.$Ri=(0,$.$ph)("logService"),e.$Si=(0,$.$ph)("loggerService");function u(){return new Date().toISOString()}function d(m){return(0,g.$me)(m)}e.$Ti=d;var p;(function(m){m[m.Off=0]="Off",m[m.Trace=1]="Trace",m[m.Debug=2]="Debug",m[m.Info=3]="Info",m[m.Warning=4]="Warning",m[m.Error=5]="Error"})(p||(e.LogLevel=p={})),e.$Ui=p.Info;function c(m,l,E){switch(l){case p.Trace:m.trace(E);break;case p.Debug:m.debug(E);break;case p.Info:m.info(E);break;case p.Warning:m.warn(E);break;case p.Error:m.error(E);break;case p.Off:break;default:throw new Error(`Invalid log level ${l}`)}}e.log=c;function h(m,l=!1){let E="";for(let D=0;D<m.length;D++){let T=m[D];if(T instanceof Error&&(T=(0,L.$ai)(T,l)),typeof T=="object")try{T=JSON.stringify(T)}catch{}E+=(D>0?" ":"")+T}return E}class f extends A.$lb{constructor(){super(...arguments),this.b=e.$Ui,this.c=this.B(new N.$ec),this.onDidChangeLogLevel=this.c.event}setLevel(l){this.b!==l&&(this.b=l,this.c.fire(this.b))}getLevel(){return this.b}f(l){return this.b!==p.Off&&this.b<=l}}e.$Wi=f;class b extends f{constructor(l){super(),this.h=l}f(l){return this.h||super.f(l)}trace(l,...E){this.f(p.Trace)&&this.g(p.Trace,h([l,...E],!0))}debug(l,...E){this.f(p.Debug)&&this.g(p.Debug,h([l,...E]))}info(l,...E){this.f(p.Info)&&this.g(p.Info,h([l,...E]))}warn(l,...E){this.f(p.Warning)&&this.g(p.Warning,h([l,...E]))}error(l,...E){if(this.f(p.Error))if(l instanceof Error){const D=Array.prototype.slice.call(arguments);D[0]=l.stack,this.g(p.Error,h(D))}else this.g(p.Error,h([l,...E]))}flush(){}}e.$Xi=b;class w extends f{constructor(l=e.$Ui){super(),this.setLevel(l),this.g=!R.$i}trace(l,...E){this.f(p.Trace)&&(this.g?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,l,...E):console.log(`[main ${u()}]`,l,...E))}debug(l,...E){this.f(p.Debug)&&(this.g?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,l,...E):console.log(`[main ${u()}]`,l,...E))}info(l,...E){this.f(p.Info)&&(this.g?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,l,...E):console.log(`[main ${u()}]`,l,...E))}warn(l,...E){this.f(p.Warning)&&(this.g?console.warn(`\x1B[93m[main ${u()}]\x1B[0m`,l,...E):console.warn(`[main ${u()}]`,l,...E))}error(l,...E){this.f(p.Error)&&(this.g?console.error(`\x1B[91m[main ${u()}]\x1B[0m`,l,...E):console.error(`[main ${u()}]`,l,...E))}dispose(){}flush(){}}e.$Yi=w;class I extends f{constructor(l=e.$Ui,E=!0){super(),this.g=E,this.setLevel(l)}trace(l,...E){this.f(p.Trace)&&(this.g?console.log("%cTRACE","color: #888",l,...E):console.log(l,...E))}debug(l,...E){this.f(p.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",l,...E):console.log(l,...E))}info(l,...E){this.f(p.Info)&&(this.g?console.log("%c INFO","color: #33f",l,...E):console.log(l,...E))}warn(l,...E){this.f(p.Warning)&&(this.g?console.log("%c WARN","color: #993",l,...E):console.log(l,...E))}error(l,...E){this.f(p.Error)&&(this.g?console.log("%c  ERR","color: #f33",l,...E):console.error(l,...E))}dispose(){}flush(){}}e.$Zi=I;class t extends f{constructor(l,E=e.$Ui){super(),this.g=l,this.setLevel(E)}trace(l,...E){this.f(p.Trace)&&this.g.log(p.Trace,[this.h(l),...E])}debug(l,...E){this.f(p.Debug)&&this.g.log(p.Debug,[this.h(l),...E])}info(l,...E){this.f(p.Info)&&this.g.log(p.Info,[this.h(l),...E])}warn(l,...E){this.f(p.Warning)&&this.g.log(p.Warning,[this.h(l),...E])}error(l,...E){this.f(p.Error)&&this.g.log(p.Error,[this.h(l),...E])}h(l){return typeof l=="string"?l:(0,L.$ai)(l,this.f(p.Trace))}dispose(){}flush(){}}e.$1i=t;class o extends f{constructor(l){super(),this.g=l,l.length&&this.setLevel(l[0].getLevel())}setLevel(l){for(const E of this.g)E.setLevel(l);super.setLevel(l)}trace(l,...E){for(const D of this.g)D.trace(l,...E)}debug(l,...E){for(const D of this.g)D.debug(l,...E)}info(l,...E){for(const D of this.g)D.info(l,...E)}warn(l,...E){for(const D of this.g)D.warn(l,...E)}error(l,...E){for(const D of this.g)D.error(l,...E)}flush(){for(const l of this.g)l.flush()}dispose(){for(const l of this.g)l.dispose()}}e.$2i=o;class s extends A.$lb{constructor(l,E,D){if(super(),this.h=l,this.j=E,this.b=new j.$ni,this.c=this.B(new N.$ec),this.onDidChangeLoggers=this.c.event,this.f=this.B(new N.$ec),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new N.$ec),this.onDidChangeVisibility=this.g.event,D)for(const T of D)this.b.set(T.resource,{logger:void 0,info:T})}k(l){return(0,g.$ie)(l)?[...this.b.values()].find(E=>E.info.id===l):this.b.get(l)}getLogger(l){return this.k(l)?.logger}createLogger(l,E){const D=this.l(l),T=(0,g.$ie)(l)?l:E?.id??(0,O.$di)(D.toString()).toString(16);let M=this.b.get(D)?.logger;const F=E?.logLevel==="always"?p.Trace:E?.logLevel;M||(M=this.m(D,F??this.getLogLevel(D)??this.h,{...E,id:T}));const V={logger:M,info:{resource:D,id:T,logLevel:F,name:E?.name,hidden:E?.hidden,extensionId:E?.extensionId,when:E?.when}};return this.registerLogger(V.info),this.b.set(D,V),M}l(l){return(0,g.$ie)(l)?(0,S.$9f)(this.j,`${l}.log`):l}setLogLevel(l,E){if(C.URI.isUri(l)){const D=l,T=E,M=this.b.get(D);M&&T!==M.info.logLevel&&(M.info.logLevel=T===this.h?void 0:T,M.logger?.setLevel(T),this.b.set(M.info.resource,M),this.f.fire([D,T]))}else{this.h=l;for(const[D,T]of this.b.entries())this.b.get(D)?.info.logLevel===void 0&&T.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(l,E){const D=this.k(l);D&&E!==!D.info.hidden&&(D.info.hidden=!E,this.b.set(D.info.resource,D),this.g.fire([D.info.resource,E]))}getLogLevel(l){let E;return l&&(E=this.b.get(l)?.info.logLevel),E??this.h}registerLogger(l){const E=this.b.get(l.resource);E?E.info.hidden!==l.hidden&&this.setVisibility(l.resource,!l.hidden):(this.b.set(l.resource,{info:l,logger:void 0}),this.c.fire({added:[l],removed:[]}))}deregisterLogger(l){const E=this.b.get(l);E&&(E.logger&&E.logger.dispose(),this.b.delete(l),this.c.fire({added:[],removed:[E.info]}))}*getRegisteredLoggers(){for(const l of this.b.values())yield l.info}getRegisteredLogger(l){return this.b.get(l)?.info}dispose(){this.b.forEach(l=>l.logger?.dispose()),this.b.clear(),super.dispose()}}e.$3i=s;class n{constructor(){this.onDidChangeLogLevel=new N.$ec().event}setLevel(l){}getLevel(){return p.Info}trace(l,...E){}debug(l,...E){}info(l,...E){}warn(l,...E){}error(l,...E){}critical(l,...E){}dispose(){}flush(){}}e.$4i=n;class i extends n{}e.$5i=i;function r(m){if(m.verbose)return p.Trace;if(typeof m.logLevel=="string"){const l=v(m.logLevel.toLowerCase());if(l!==void 0)return l}return e.$Ui}e.$6i=r;function a(m){switch(m){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Off:return"off"}}e.$7i=a;function v(m){switch(m){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Error;case"off":return p.Off}}e.$8i=v,e.$9i=new y.$Oi("logLevel",a(p.Info))}),define(ce[195],le([0,1,5,8,2,22,31,15,7]),function(ie,e,L,N,O,A,j,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$56b=void 0;let g=class extends O.$lb{constructor(y,$){super(),this.a=y,this.b=$,this.B(new L.$Gg(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const y=(0,A.$6f)(this.a.logsHome),$=(0,A.$8f)(this.a.logsHome),p=(await j.Promises.readdir($.fsPath)).filter(h=>/^\d{8}T\d{6}$/.test(h)).sort().filter(h=>h!==y),c=p.slice(0,Math.max(0,p.length-9));c.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${c.join(", ")}'`),await Promise.all(c.map(h=>j.Promises.rm((0,A.$9f)($,h).fsPath))))}catch(y){(0,N.$Y)(y)}}};e.$56b=g,e.$56b=g=ye([K(0,R.$wh),K(1,S.$Ri)],g)}),define(ce[196],le([0,1,20,5,8,3,2,16,54,7]),function(ie,e,L,N,O,A,j,R,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=void 0;class C extends j.$lb{constructor($,u){super(),this.a=$,this.b=u,this.c=this.B(new A.$ec),this.onDidChangeFile=this.c.event,this.g=this.B(new A.$ec),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new N.$sg(0)),this.s=[],this.t=this.B(new N.$sg(0))}watch($,u){return u.recursive||this.b?.watcher?.forceUniversal?this.l($,u):this.u($,u)}l($,u){const d={path:this.C($),excludes:u.excludes,includes:u.includes,recursive:u.recursive},p=(0,L.$yf)(this.j,d);return this.m(),(0,j.$jb)(()=>{p(),this.m()})}m(){this.k.trigger(()=>this.n()).catch($=>(0,O.$Y)($))}n(){this.h||(this.h=this.B(this.p(u=>this.c.fire((0,S.$zp)(u)),u=>this.z(u),this.a.getLevel()===g.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===g.LogLevel.Trace)})));const $=this.b?.watcher?.recursive?.usePolling;if($===!0)for(const u of this.j)(0,S.$vp)(u)&&(u.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray($))for(const u of this.j)(0,S.$vp)(u)&&$.includes(u.path)&&(u.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u($,u){const d={path:this.C($),excludes:u.excludes,includes:u.includes,recursive:!1},p=(0,L.$yf)(this.s,d);return this.v(),(0,j.$jb)(()=>{p(),this.v()})}v(){this.t.trigger(()=>this.w()).catch($=>(0,O.$Y)($))}w(){return this.r||(this.r=this.B(this.y($=>this.c.fire((0,S.$zp)($)),$=>this.z($),this.a.getLevel()===g.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===g.LogLevel.Trace)}))),this.r.watch(this.s)}z($){$.type==="error"&&this.g.fire($.message),this.a[$.type]($.message)}C($){return(0,R.$6c)($.fsPath)}}e.$Dp=C}),define(ce[197],le([0,1,20,5,14,25,3,51,59,2,47,26,100,22,42,157,13,99,7,8]),function(ie,e,L,N,O,A,j,R,S,g,C,y,$,u,d,p,c,h,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$up=void 0;let w=class extends g.$lb{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new j.$ec),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new j.$ec),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new j.$ec),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new j.$ec),this.onDidRunOperation=this.m.event,this.R=this.B(new j.$ec),this.onDidFilesChange=this.R.event,this.S=this.B(new j.$ec),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new N.$Dg)}registerProvider(t,o){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,$.mark)(`code/registerFilesystem/${t}`);const s=new g.$kb;return this.h.set(t,o),this.c.fire({added:!0,scheme:t,provider:o}),s.add(o.onDidChangeFile(n=>this.R.fire(new c.$$j(n,!this.O(o))))),typeof o.onDidWatchError=="function"&&s.add(o.onDidWatchError(n=>this.S.fire(new Error(n)))),s.add(o.onDidChangeCapabilities(()=>this.g.fire({provider:o,scheme:t}))),(0,g.$jb)(()=>{this.c.fire({added:!1,scheme:t,provider:o}),this.h.delete(t),(0,g.$gb)(s)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const o=[];this.f.fire({scheme:t,join(s){o.push(s)}}),!this.h.has(t)&&await N.Promises.settled(o)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,o){const s=this.h.get(t.scheme);return!!(s&&s.capabilities&o)}listCapabilities(){return S.Iterable.map(this.h,([t,o])=>({scheme:t,capabilities:o.capabilities}))}async j(t){if(!(0,u.$ag)(t))throw new c.$ak((0,p.localize)(0,null,this.nb(t)),8);await this.activateProvider(t.scheme);const o=this.h.get(t.scheme);if(!o){const s=new b.$ab;throw s.message=(0,p.localize)(1,null,t.toString()),s}return o}async k(t){const o=await this.j(t);if((0,c.$Xj)(o)||(0,c.$Uj)(o)||(0,c.$Yj)(o))return o;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(t){const o=await this.j(t);if((0,c.$Xj)(o)||(0,c.$Uj)(o))return o;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,o){try{return await this.n(t,o)}catch(s){throw(0,c.$8j)(s)===c.FileSystemProviderErrorCode.FileNotFound?new c.$ak((0,p.localize)(2,null,this.nb(t)),1):(0,c.$6j)(s)}}async n(t,o){const s=await this.j(t),n=this.O(s),i=o?.resolveTo,r=o?.resolveSingleChildDescendants,a=o?.resolveMetadata,v=await s.stat(t);let m;return this.p(s,t,v,void 0,!!a,(l,E)=>(m||(m=C.$vh.forUris(()=>!n),m.set(t,!0),i&&m.fill(!0,i)),m.get(l.resource)||m.findSuperstr(l.resource.with({query:null,fragment:null}))?!0:l.isDirectory&&r?E===1:!1))}async p(t,o,s,n,i,r){const{providerExtUri:a}=this.N(t),v={resource:o,name:a.basename(o),isFile:(s.type&c.FileType.File)!==0,isDirectory:(s.type&c.FileType.Directory)!==0,isSymbolicLink:(s.type&c.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:!!((s.permissions??0)&c.FilePermission.Readonly)||!!(t.capabilities&2048),locked:!!((s.permissions??0)&c.FilePermission.Locked),etag:(0,c.$lk)({mtime:s.mtime,size:s.size}),children:void 0};if(v.isDirectory&&r(v,n)){try{const m=await t.readdir(o),l=await N.Promises.settled(m.map(async([E,D])=>{try{const T=a.joinPath(o,E),M=i?await t.stat(T):{type:D};return await this.p(t,T,M,m.length,i,r)}catch(T){return this.b.trace(T),null}}));v.children=(0,L.$jf)(l)}catch(m){this.b.trace(m),v.children=[]}return v}return v}async resolveAll(t){return N.Promises.settled(t.map(async o=>{try{return{stat:await this.n(o.resource,o.options),success:!0}}catch(s){return this.b.trace(s),{stat:void 0,success:!1}}}))}async stat(t){const o=await this.j(t),s=await o.stat(t);return this.p(o,t,s,void 0,!0,()=>!1)}async exists(t){const o=await this.j(t);try{return!!await o.stat(t)}catch{return!1}}async canCreateFile(t,o){try{await this.r(t,o)}catch(s){return s}return!0}async r(t,o){if(!o?.overwrite&&await this.exists(t))throw new c.$ak((0,p.localize)(3,null,this.nb(t)),3,o)}async createFile(t,o=O.$Ec.fromString(""),s){await this.r(t,s);const n=await this.writeFile(t,o);return this.m.fire(new c.$0j(t,0,n)),n}async writeFile(t,o,s){const n=this.lb(await this.l(t),t),{providerExtUri:i}=this.N(n);try{await this.s(n,t,s)||await this.P(n,i.dirname(t));let a;if((0,c.$Uj)(n)&&!(o instanceof O.$Ec))if((0,d.$qc)(o)){const v=await(0,d.$xc)(o,3);v.ended?a=O.$Ec.concat(v.buffer):a=v}else a=(0,d.$uc)(o,v=>O.$Ec.concat(v),3);else a=o;if(!(0,c.$Xj)(n)||(0,c.$Uj)(n)&&a instanceof O.$Ec)await this.cb(n,t,s,a);else{const v=a instanceof O.$Ec?(0,O.$Pc)(a):a;s?.atomic!==!1&&s?.atomic?.postfix?await this.Y(n,t,(0,u.$9f)((0,u.$8f)(t),`${(0,u.$6f)(t)}${s.atomic.postfix}`),s,v):await this.Z(n,t,s,v)}this.m.fire(new c.$0j(t,4))}catch(r){throw new c.$ak((0,p.localize)(4,null,this.nb(t),(0,c.$6j)(r).toString()),(0,c.$9j)(r),s)}return this.resolve(t,{resolveMetadata:!0})}async s(t,o,s){const n=!!s?.unlock;if(n&&!(t.capabilities&8192))throw new Error((0,p.localize)(5,null,this.nb(o)));if(!!s?.atomic){if(!(t.capabilities&32768))throw new Error((0,p.localize)(6,null,this.nb(o)));if(n)throw new Error((0,p.localize)(7,null,this.nb(o)))}let r;try{r=await t.stat(o)}catch{return}if(r.type&c.FileType.Directory)throw new c.$ak((0,p.localize)(8,null,this.nb(o)),0,s);if(this.mb(o,r),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==c.$kk&&typeof r.mtime=="number"&&typeof r.size=="number"&&s.mtime<r.mtime&&s.etag!==(0,c.$lk)({mtime:s.mtime,size:r.size}))throw new c.$ak((0,p.localize)(9,null),3,s);return r}async readFile(t,o,s){const n=await this.k(t);return o?.atomic?this.t(n,t,o,s):this.u(n,t,o,s)}async t(t,o,s,n){return new Promise((i,r)=>{this.X.queueFor(o,this.N(t).providerExtUri).queue(async()=>{try{const a=await this.u(t,o,s,n);i(a)}catch(a){r(a)}})})}async u(t,o,s,n){const i=await this.v(t,o,{...s,preferUnbuffered:!0},n);return{...i,value:await(0,O.$Qc)(i.value)}}async readFileStream(t,o,s){const n=await this.k(t);return this.v(n,t,o,s)}async v(t,o,s,n){const i=new A.$oc(n),r=this.F(o,s).then(v=>v,v=>{throw i.cancel(),v});let a;try{return typeof s?.etag=="string"&&s.etag!==c.$kk&&await r,s?.atomic&&(0,c.$Zj)(t)||!((0,c.$Xj)(t)||(0,c.$Yj)(t))||(0,c.$Uj)(t)&&s?.preferUnbuffered?a=this.D(t,o,s):(0,c.$Yj)(t)?a=this.z(t,o,i.token,s):a=this.C(t,o,i.token,s),{...await r,value:a}}catch(v){throw a&&await(0,d.$vc)(a),this.w(v,o,s)}}w(t,o,s){const n=(0,p.localize)(10,null,this.nb(o),(0,c.$6j)(t).toString());return t instanceof c.$ck?new c.$ck(n,t.stat,s):t instanceof c.$bk?new c.$bk(n,t.fileOperationResult,t.size,t.options):new c.$ak(n,(0,c.$9j)(t),s)}z(t,o,s,n=Object.create(null)){const i=t.readFileStream(o,n,s);return(0,d.$Bc)(i,{data:r=>r instanceof O.$Ec?r:O.$Ec.wrap(r),error:r=>this.w(r,o,n)},r=>O.$Ec.concat(r))}C(t,o,s,n=Object.create(null)){const i=(0,O.$Uc)();return(0,h.$tp)(t,o,i,r=>r,{...n,bufferSize:this.a,errorTransformer:r=>this.w(r,o,n)},s),i}D(t,o,s){const n=(0,d.$sc)(i=>O.$Ec.concat(i));return(async()=>{try{let i;s?.atomic&&(0,c.$Zj)(t)?i=await t.readFile(o,{atomic:!0}):i=await t.readFile(o),typeof s?.position=="number"&&(i=i.slice(s.position)),typeof s?.length=="number"&&(i=i.slice(0,s.length)),this.G(o,i.byteLength,s),n.end(O.$Ec.wrap(i))}catch(i){n.error(i),n.end()}})(),n}async F(t,o){const s=await this.resolve(t,{resolveMetadata:!0});if(s.isDirectory)throw new c.$ak((0,p.localize)(11,null,this.nb(t)),0,o);if(typeof o?.etag=="string"&&o.etag!==c.$kk&&o.etag===s.etag)throw new c.$ck((0,p.localize)(12,null),s,o);return this.G(t,s.size,o),s}G(t,o,s){if(typeof s?.limits?.size=="number"&&o>s.limits.size)throw new c.$bk((0,p.localize)(13,null,this.nb(t)),7,o,s)}async canMove(t,o,s){return this.H(t,o,"move",s)}async canCopy(t,o,s){return this.H(t,o,"copy",s)}async H(t,o,s,n){if(t.toString()!==o.toString())try{const i=s==="move"?this.lb(await this.l(t),t):await this.k(t),r=this.lb(await this.l(o),o);await this.M(i,t,r,o,s,n)}catch(i){return i}return!0}async move(t,o,s){const n=this.lb(await this.l(t),t),i=this.lb(await this.l(o),o),r=await this.I(n,t,i,o,"move",!!s),a=await this.resolve(o,{resolveMetadata:!0});return this.m.fire(new c.$0j(t,r==="move"?2:3,a)),a}async copy(t,o,s){const n=await this.k(t),i=this.lb(await this.l(o),o),r=await this.I(n,t,i,o,"copy",!!s),a=await this.resolve(o,{resolveMetadata:!0});return this.m.fire(new c.$0j(t,r==="copy"?3:2,a)),a}async I(t,o,s,n,i,r){if(o.toString()===n.toString())return i;const{exists:a,isSameResourceWithDifferentPathCase:v}=await this.M(t,o,s,n,i,r);if(a&&!v&&r&&await this.del(n,{recursive:!0}),await this.P(s,this.N(s).providerExtUri.dirname(n)),i==="copy"){if(t===s&&(0,c.$Vj)(t))await t.copy(o,n,{overwrite:r});else{const m=await this.resolve(o);m.isDirectory?await this.L(t,m,s,n):await this.J(t,o,s,n)}return i}else return t===s?(await t.rename(o,n,{overwrite:r}),i):(await this.I(t,o,s,n,"copy",r),await this.del(o,{recursive:!0}),"copy")}async J(t,o,s,n){if((0,c.$Xj)(t)&&(0,c.$Xj)(s))return this.eb(t,o,s,n);if((0,c.$Xj)(t)&&(0,c.$Uj)(s))return this.kb(t,o,s,n);if((0,c.$Uj)(t)&&(0,c.$Xj)(s))return this.ib(t,o,s,n);if((0,c.$Uj)(t)&&(0,c.$Uj)(s))return this.gb(t,o,s,n)}async L(t,o,s,n){await s.mkdir(n),Array.isArray(o.children)&&await N.Promises.settled(o.children.map(async i=>{const r=this.N(s).providerExtUri.joinPath(n,i.name);return i.isDirectory?this.L(t,await this.resolve(i.resource),s,r):this.J(t,i.resource,s,r)}))}async M(t,o,s,n,i,r){let a=!1;if(t===s){const{providerExtUri:m,isPathCaseSensitive:l}=this.N(t);if(l||(a=m.isEqual(o,n)),a&&i==="copy")throw new Error((0,p.localize)(14,null,this.nb(o),this.nb(n)));if(!a&&m.isEqualOrParent(n,o))throw new Error((0,p.localize)(15,null,this.nb(o),this.nb(n)))}const v=await this.exists(n);if(v&&!a){if(!r)throw new c.$ak((0,p.localize)(16,null,this.nb(o),this.nb(n)),4);if(t===s){const{providerExtUri:m}=this.N(t);if(m.isEqualOrParent(o,n))throw new Error((0,p.localize)(17,null,this.nb(o),this.nb(n)))}}return{exists:v,isSameResourceWithDifferentPathCase:a}}N(t){const o=this.O(t);return{providerExtUri:o?u.$Yf:u.$1f,isPathCaseSensitive:o}}O(t){return!!(t.capabilities&1024)}async createFolder(t){const o=this.lb(await this.j(t),t);await this.P(o,t);const s=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new c.$0j(t,0,s)),s}async P(t,o){const s=[],{providerExtUri:n}=this.N(t);for(;!n.isEqual(o,n.dirname(o));)try{if(!((await t.stat(o)).type&c.FileType.Directory))throw new Error((0,p.localize)(18,null,this.nb(o)));break}catch(i){if((0,c.$8j)(i)!==c.FileSystemProviderErrorCode.FileNotFound)throw i;s.push(n.basename(o)),o=n.dirname(o)}for(let i=s.length-1;i>=0;i--){o=n.joinPath(o,s[i]);try{await t.mkdir(o)}catch(r){if((0,c.$8j)(r)!==c.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(t,o){try{await this.Q(t,o)}catch(s){return s}return!0}async Q(t,o){const s=this.lb(await this.j(t),t),n=!!o?.useTrash;if(n&&!(s.capabilities&4096))throw new Error((0,p.localize)(19,null,this.nb(t)));const i=o?.atomic;if(i&&!(s.capabilities&65536))throw new Error((0,p.localize)(20,null,this.nb(t)));if(n&&i)throw new Error((0,p.localize)(21,null,this.nb(t)));let r;try{r=await s.stat(t)}catch{}if(r)this.mb(t,r);else throw new c.$ak((0,p.localize)(22,null,this.nb(t)),1);if(!!!o?.recursive){const v=await this.resolve(t);if(v.isDirectory&&Array.isArray(v.children)&&v.children.length>0)throw new Error((0,p.localize)(23,null,this.nb(t)))}return s}async del(t,o){const s=await this.Q(t,o),n=!!o?.useTrash,i=!!o?.recursive,r=o?.atomic??!1;await s.delete(t,{recursive:i,useTrash:n,atomic:r}),this.m.fire(new c.$0j(t,1))}async cloneFile(t,o){const s=await this.j(t),n=this.lb(await this.l(o),o);if(s===n&&this.N(s).providerExtUri.isEqual(t,o))return;if(s===n&&(0,c.$Wj)(s))return s.cloneFile(t,o);await this.P(n,this.N(n).providerExtUri.dirname(o));const i=this.X.queueFor(t,this.N(s).providerExtUri);return s===n&&(0,c.$Vj)(s)?i.queue(()=>s.copy(t,o,{overwrite:!0})):i.queue(()=>this.J(s,t,n,o))}watch(t,o={recursive:!1,excludes:[]}){const s=new g.$kb;let n=!1,i=()=>{n=!0};return s.add((0,g.$jb)(()=>i())),(async()=>{try{const r=await this.W(t,o);n?(0,g.$gb)(r):i=()=>(0,g.$gb)(r)}catch(r){this.b.error(r)}})(),s}async W(t,o){const s=await this.j(t),n=(0,R.$di)([this.N(s).providerExtUri.getComparisonKey(t),o]);let i=this.U.get(n);return i||(i={count:0,disposable:s.watch(t,o)},this.U.set(n,i)),i.count+=1,(0,g.$jb)(()=>{i&&(i.count--,i.count===0&&((0,g.$gb)(i.disposable),this.U.delete(n)))})}dispose(){super.dispose();for(const[,t]of this.U)(0,g.$gb)(t.disposable);this.U.clear()}async Y(t,o,s,n,i){await this.Z(t,s,n,i);try{await t.rename(s,o,{overwrite:!0})}catch(r){try{await t.delete(s,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw r}}async Z(t,o,s,n){return this.X.queueFor(o,this.N(t).providerExtUri).queue(async()=>{const i=await t.open(o,{create:!0,unlock:s?.unlock??!1});try{(0,d.$qc)(n)||(0,d.$rc)(n)?await this.$(t,i,n):await this.ab(t,i,n)}catch(r){throw(0,c.$6j)(r)}finally{await t.close(i)}})}async $(t,o,s){let n=0,i;if((0,d.$rc)(s)){if(s.buffer.length>0){const r=O.$Ec.concat(s.buffer);await this.bb(t,o,r,r.byteLength,n,0),n+=r.byteLength}if(s.ended)return;i=s.stream}else i=s;return new Promise((r,a)=>{(0,d.$wc)(i,{onData:async v=>{i.pause();try{await this.bb(t,o,v,v.byteLength,n,0)}catch(m){return a(m)}n+=v.byteLength,setTimeout(()=>i.resume())},onError:v=>a(v),onEnd:()=>r()})})}async ab(t,o,s){let n=0,i;for(;(i=s.read())!==null;)await this.bb(t,o,i,i.byteLength,n,0),n+=i.byteLength}async bb(t,o,s,n,i,r){let a=0;for(;a<n;){const v=await t.write(o,i+a,s.buffer,r+a,n-a);a+=v}}async cb(t,o,s,n){return this.X.queueFor(o,this.N(t).providerExtUri).queue(()=>this.db(t,o,s,n))}async db(t,o,s,n){let i;n instanceof O.$Ec?i=n:(0,d.$qc)(n)?i=await(0,O.$Qc)(n):(0,d.$rc)(n)?i=await(0,O.$Rc)(n):i=(0,O.$Oc)(n),await t.writeFile(o,i.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1,atomic:s?.atomic??!1})}async eb(t,o,s,n){return this.X.queueFor(n,this.N(s).providerExtUri).queue(()=>this.fb(t,o,s,n))}async fb(t,o,s,n){let i,r;try{i=await t.open(o,{create:!1}),r=await s.open(n,{create:!0,unlock:!1});const a=O.$Ec.alloc(this.a);let v=0,m=0,l=0;do l=await t.read(i,v,a.buffer,m,a.byteLength-m),await this.bb(s,r,a,l,v,m),v+=l,m+=l,m===a.byteLength&&(m=0);while(l>0)}catch(a){throw(0,c.$6j)(a)}finally{await N.Promises.settled([typeof i=="number"?t.close(i):Promise.resolve(),typeof r=="number"?s.close(r):Promise.resolve()])}}async gb(t,o,s,n){return this.X.queueFor(n,this.N(s).providerExtUri).queue(()=>this.hb(t,o,s,n))}async hb(t,o,s,n){return s.writeFile(n,await t.readFile(o),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async ib(t,o,s,n){return this.X.queueFor(n,this.N(s).providerExtUri).queue(()=>this.jb(t,o,s,n))}async jb(t,o,s,n){const i=await s.open(n,{create:!0,unlock:!1});try{const r=await t.readFile(o);await this.bb(s,i,O.$Ec.wrap(r),r.byteLength,0,0)}catch(r){throw(0,c.$6j)(r)}finally{await s.close(i)}}async kb(t,o,s,n){const i=await(0,O.$Qc)(this.C(t,o,A.CancellationToken.None));await this.cb(s,n,void 0,i)}lb(t,o){if(t.capabilities&2048)throw new c.$ak((0,p.localize)(24,null,this.nb(o)),6);return t}mb(t,o){if((o.permissions??0)&c.FilePermission.Readonly)throw new c.$ak((0,p.localize)(25,null,this.nb(t)),6)}nb(t){return t.scheme===y.Schemas.file?t.fsPath:t.toString(!0)}};e.$up=w,e.$up=w=ye([K(0,f.$Ri)],w)}),define(ce[198],le([0,1,52,269,5,35,14,3,48,2,16,6,22,42,31,160,13,99,196,38,192,191]),function(ie,e,L,N,O,A,j,R,S,g,C,y,$,u,d,p,c,h,f,b,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=void 0,(()=>{try{(0,N.gracefulify)(L)}catch(o){console.error(`Error enabling graceful-fs: ${(0,b.$ai)(o)}`)}})();class t extends f.$Dp{static{this.D=!1}constructor(s,n){super(s,n),this.onDidChangeCapabilities=R.Event.None,this.I=new A.$ni(i=>$.$Zf.getComparisonKey(i)),this.O=new Map,this.P=new Map,this.Q=new Map}get capabilities(){return this.F||(this.F=253982,y.$k&&(this.F|=1024)),this.F}async stat(s){try{const{stat:n,symbolicLink:i}=await d.SymlinkSupport.stat(this.C(s));return{type:this.H(n,i),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:c.FilePermission.Locked}}catch(n){throw this.ab(n)}}async G(s){try{return await this.stat(s)}catch{return}}async readdir(s){try{const n=await d.Promises.readdir(this.C(s),{withFileTypes:!0}),i=[];return await Promise.all(n.map(async r=>{try{let a;r.isSymbolicLink()?a=(await this.stat((0,$.$9f)(s,r.name))).type:a=this.H(r),i.push([r.name,a])}catch(a){this.a.trace(a)}})),i}catch(n){throw this.ab(n)}}H(s,n){let i;return n?.dangling?i=c.FileType.Unknown:s.isFile()?i=c.FileType.File:s.isDirectory()?i=c.FileType.Directory:i=c.FileType.Unknown,n&&(i|=c.FileType.SymbolicLink),i}async J(s){const n=this.C(s);this.L(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let i;for(;i=this.I.get(s);)this.L(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await i.wait();const r=new O.$tg;return this.I.set(s,r),this.L(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,g.$jb)(()=>{this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.I.get(s)===r&&(this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.I.delete(s)),this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),r.open()})}async readFile(s,n){let i;try{n?.atomic&&(this.L(`[Disk FileSystemProvider]: atomic read operation started (${this.C(s)})`),i=await this.J(s));const r=this.C(s);return await d.Promises.readFile(r)}catch(r){throw this.ab(r)}finally{i?.dispose()}}L(s){t.D&&this.a.trace(s)}readFileStream(s,n,i){const r=(0,u.$sc)(a=>j.$Ec.concat(a.map(v=>j.$Ec.wrap(v))).buffer);return(0,h.$tp)(this,s,r,a=>a.buffer,{...n,bufferSize:256*1024},i),r}async writeFile(s,n,i){return i?.atomic!==!1&&i?.atomic?.postfix?this.M(s,(0,$.$9f)((0,$.$8f)(s),`${(0,$.$6f)(s)}${i.atomic.postfix}`),n,i):this.N(s,n,i)}async M(s,n,i,r){await this.N(n,i,r);try{await this.rename(n,s,{overwrite:!0})}catch(a){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw a}}async N(s,n,i){let r;try{const a=this.C(s);if(!i.create||!i.overwrite){if(await d.Promises.exists(a)){if(!i.overwrite)throw(0,c.$5j)((0,p.localize)(0,null),c.FileSystemProviderErrorCode.FileExists)}else if(!i.create)throw(0,c.$5j)((0,p.localize)(1,null),c.FileSystemProviderErrorCode.FileNotFound)}r=await this.open(s,{create:!0,unlock:i.unlock}),await this.write(r,0,n,0,n.byteLength)}catch(a){throw await this.bb(s,a)}finally{typeof r=="number"&&await this.close(r)}}static{this.R=!0}static configureFlushOnWrite(s){t.R=s}async open(s,n){const i=this.C(s);let r;(0,c.$Tj)(n)&&(r=await this.J(s));let a;try{if((0,c.$Tj)(n)&&n.unlock)try{const{stat:m}=await d.SymlinkSupport.stat(i);m.mode&128||await d.Promises.chmod(i,m.mode|128)}catch(m){m.code!=="ENOENT"&&this.a.trace(m)}let v;if((0,c.$Tj)(n)){if(y.$i)try{await d.Promises.truncate(i,0),v="r+"}catch(m){m.code!=="ENOENT"&&this.a.trace(m)}v||(v="w")}else v="r";a=await d.Promises.open(i,v)}catch(v){throw r?.dispose(),(0,c.$Tj)(n)?await this.bb(s,v):this.ab(v)}if(this.O.set(a,0),(0,c.$Tj)(n)&&this.Q.set(a,s),r){const v=this.P.get(a);this.L(`[Disk FileSystemProvider]: open() - storing lock for handle ${a} (${i})`),this.P.set(a,r),v&&(this.L(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${a} (${i})`),v.dispose())}return a}async close(s){const n=this.P.get(s);try{if(this.O.delete(s),this.Q.delete(s)&&t.R)try{await d.Promises.fdatasync(s)}catch(i){t.configureFlushOnWrite(!1),this.a.error(i)}return await d.Promises.close(s)}catch(i){throw this.ab(i)}finally{n&&(this.P.get(s)===n&&(this.L(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${s}`),this.P.delete(s)),this.L(`[Disk FileSystemProvider]: close() - disposing lock for handle ${s}`),n.dispose())}}async read(s,n,i,r,a){const v=this.S(s,n);let m=null;try{m=(await d.Promises.read(s,i,r,a,v)).bytesRead}catch(l){throw this.ab(l)}finally{this.U(s,v,m)}return m}S(s,n){return n===this.O.get(s)?null:n}U(s,n,i){const r=this.O.get(s);typeof r=="number"&&(typeof n=="number"||(typeof i=="number"?this.O.set(s,r+i):this.O.delete(s)))}async write(s,n,i,r,a){return(0,O.$Mg)(()=>this.W(s,n,i,r,a),100,3)}async W(s,n,i,r,a){const v=this.S(s,n);let m=null;try{m=(await d.Promises.write(s,i,r,a,v)).bytesWritten}catch(l){throw await this.bb(this.Q.get(s),l)}finally{this.U(s,v,m)}return m}async mkdir(s){try{await d.Promises.mkdir(this.C(s))}catch(n){throw this.ab(n)}}async delete(s,n){try{const i=this.C(s);if(n.recursive){let r;n?.atomic!==!1&&n.atomic.postfix&&(r=(0,C.$8c)((0,C.$$c)(i),`${(0,C.$_c)(i)}${n.atomic.postfix}`)),await d.Promises.rm(i,d.RimRafMode.MOVE,r)}else try{await d.Promises.unlink(i)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let a=!1;try{const{stat:v,symbolicLink:m}=await d.SymlinkSupport.stat(i);a=v.isDirectory()&&!m}catch{}if(a)await d.Promises.rmdir(i);else throw r}else throw r}}catch(i){throw this.ab(i)}}async rename(s,n,i){const r=this.C(s),a=this.C(n);if(r!==a)try{await this.X(s,n,"move",i.overwrite),await d.Promises.rename(r,a)}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,p.localize)(2,null,(0,C.$_c)(r),(0,C.$_c)((0,C.$$c)(a)),v.toString()))),this.ab(v)}}async copy(s,n,i){const r=this.C(s),a=this.C(n);if(r!==a)try{await this.X(s,n,"copy",i.overwrite),await d.Promises.copy(r,a,{preserveSymlinks:!0})}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,p.localize)(3,null,(0,C.$_c)(r),(0,C.$_c)((0,C.$$c)(a)),v.toString()))),this.ab(v)}}async X(s,n,i,r){const a=this.C(s),v=this.C(n);let m=!1;if(!!(this.capabilities&1024)||(m=(0,S.$Ge)(a,v,!0)),m){if(i==="copy")throw(0,c.$5j)((0,p.localize)(4,null),c.FileSystemProviderErrorCode.FileExists);if(i==="move")return}const E=await this.G(s);if(!E)throw(0,c.$5j)((0,p.localize)(5,null),c.FileSystemProviderErrorCode.FileNotFound);const D=await this.G(n);if(D){if(!r)throw(0,c.$5j)((0,p.localize)(6,null),c.FileSystemProviderErrorCode.FileExists);E.type&c.FileType.File&&D.type&c.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(s,n){return this.Y(s,n,!1)}async Y(s,n,i){const r=this.C(s),a=this.C(n),v=!!(this.capabilities&1024);if((0,S.$Ge)(r,a,!v))return;const m=new g.$kb;try{const[l,E]=await Promise.all([this.J(s),this.J(n)]);m.add(l),m.add(E),i&&await d.Promises.mkdir((0,C.$$c)(a),{recursive:!0}),await d.Promises.copyFile(r,a)}catch(l){if(l.code==="ENOENT"&&!i)return this.Y(s,n,!0);throw this.ab(l)}finally{m.dispose()}}p(s,n,i){return new w.$Kp(r=>s(r),r=>n(r),i)}y(s,n,i){return new I.$Sp(r=>s(r),r=>n(r),i)}ab(s){if(s instanceof c.$4j)return s;let n=s,i;switch(s.code){case"ENOENT":i=c.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=c.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=c.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=c.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=c.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${s.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,i=c.FileSystemProviderErrorCode.Unknown;break;default:i=c.FileSystemProviderErrorCode.Unknown}return(0,c.$5j)(n,i)}async bb(s,n){let i=this.ab(n);if(s&&i.code===c.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await d.SymlinkSupport.stat(this.C(s));r.mode&128||(i=(0,c.$5j)(n,c.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return i}}e.$Tp=t}),define(ce[101],le([0,1,3,2,4,7]),function(ie,e,L,N,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v7b=e.$u7b=void 0,e.$u7b=(0,O.$ph)("sharedProcessLifecycleService");let j=class extends N.$lb{constructor(S){super(),this.b=S,this.a=this.B(new L.$ec),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};e.$v7b=j,e.$v7b=j=ye([K(0,A.$Ri)],j)}),define(ce[199],le([0,1,10,3,7,2]),function(ie,e,L,N,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=e.$Sq=e.$Rq=void 0;class j extends O.$3i{constructor(y,$,u,d,p){super($,u,d),this.n=y,this.p=p,this.B(p.listen("onDidChangeLogLevel",y)(c=>{(0,O.$Ti)(c)?super.setLogLevel(c):super.setLogLevel(L.URI.revive(c[0]),c[1])})),this.B(p.listen("onDidChangeVisibility",y)(([c,h])=>super.setVisibility(L.URI.revive(c),h))),this.B(p.listen("onDidChangeLoggers",y)(({added:c,removed:h})=>{for(const f of c)super.registerLogger({...f,resource:L.URI.revive(f.resource)});for(const f of h)super.deregisterLogger(f.resource)}))}createConsoleMainLogger(){return new O.$1i({log:(y,$)=>{this.p.call("consoleLog",[y,$])}})}registerLogger(y){super.registerLogger(y),this.p.call("registerLogger",[y,this.n])}deregisterLogger(y){super.deregisterLogger(y),this.p.call("deregisterLogger",[y,this.n])}setLogLevel(y,$){super.setLogLevel(y,$),this.p.call("setLogLevel",[y,$])}setVisibility(y,$){super.setVisibility(y,$),this.p.call("setVisibility",[this.l(y),$])}m(y,$,u){return new R(this.p,y,$,u,this.n)}static setLogLevel(y,$,u){return y.call("setLogLevel",[$,u])}}e.$Rq=j;class R extends O.$Xi{constructor(y,$,u,d,p){super(d?.logLevel==="always"),this.m=y,this.n=$,this.k=!1,this.l=[],this.setLevel(u),this.m.call("createLogger",[$,d,p]).then(()=>{this.r(this.l),this.k=!0})}g(y,$){const u=[[y,$]];this.k?this.r(u):this.l.push(...u)}r(y){this.m.call("log",[this.n,y])}}class S{constructor(y,$){this.a=y,this.b=$}listen(y,$){const u=this.b(y);switch($){case"onDidChangeLoggers":return N.Event.map(this.a.onDidChangeLoggers,d=>({added:[...d.added].map(p=>this.c(p,u)),removed:[...d.removed].map(p=>this.c(p,u))}));case"onDidChangeVisibility":return N.Event.map(this.a.onDidChangeVisibility,d=>[u.transformOutgoingURI(d[0]),d[1]]);case"onDidChangeLogLevel":return N.Event.map(this.a.onDidChangeLogLevel,d=>(0,O.$Ti)(d)?d:[u.transformOutgoingURI(d[0]),d[1]])}throw new Error(`Event not found: ${$}`)}async call(y,$,u){const d=this.b(y);switch($){case"setLogLevel":return(0,O.$Ti)(u[0])?this.a.setLogLevel(u[0]):this.a.setLogLevel(L.URI.revive(d.transformIncoming(u[0][0])),u[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(p=>this.c(p,d)))}throw new Error(`Call not found: ${$}`)}c(y,$){return{...y,resource:$.transformOutgoingURI(y.resource)}}}e.$Sq=S;class g extends A.$lb{constructor(y,$){super(),$.call("setLogLevel",[y.getLogLevel()]),this.B(y.onDidChangeLogLevel(u=>$.call("setLogLevel",[u]))),$.call("getRegisteredLoggers").then(u=>{for(const d of u)y.registerLogger({...d,resource:L.URI.revive(d.resource)})}),this.B($.listen("onDidChangeVisibility")(([u,d])=>y.setVisibility(L.URI.revive(u),d))),this.B($.listen("onDidChangeLoggers")(({added:u,removed:d})=>{for(const p of u)y.registerLogger({...p,resource:L.URI.revive(p.resource)});for(const p of d)y.deregisterLogger(p.resource)}))}}e.$Tq=g}),define(ce[200],le([0,1,2,7]),function(ie,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9M=void 0;class O extends L.$lb{constructor(j,R=[]){super(),this.a=new N.$2i([j,...R]),this.B(j.onDidChangeLogLevel(S=>this.setLevel(S)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(j){this.a.setLevel(j)}getLevel(){return this.a.getLevel()}trace(j,...R){this.a.trace(j,...R)}debug(j,...R){this.a.debug(j,...R)}info(j,...R){this.a.info(j,...R)}warn(j,...R){this.a.warn(j,...R)}error(j,...R){this.a.error(j,...R)}flush(){this.a.flush()}}e.$9M=O}),define(ce[55],le([0,1,4]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m5b=void 0,e.$m5b=(0,L.$ph)("nativeHostService")}),define(ce[56],le([0,1,3,59,2,4]),function(ie,e,L,N,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ym=e.$Xm=e.$Wm=void 0,e.$Wm=(0,A.$ph)("policy");class j extends O.$lb{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new L.$ec),this.onDidChange=this.h.event}async updatePolicyDefinitions(g){const C=Object.keys(this.f).length;return this.f={...g,...this.f},C!==Object.keys(this.f).length&&await this.i(g),N.Iterable.reduce(this.g.entries(),(y,[$,u])=>({...y,[$]:u}),{})}getPolicyValue(g){return this.g.get(g)}serialize(){return N.Iterable.reduce(Object.entries(this.f),(g,[C,y])=>({...g,[C]:{definition:y,value:this.g.get(C)}}),{})}}e.$Xm=j;class R{constructor(){this.onDidChange=L.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$Ym=R}),define(ce[201],le([0,1,3,2,56]),function(ie,e,L,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e6b=e.$d6b=void 0;class A{constructor(S){this.b=S,this.a=new N.$kb}listen(S,g){switch(g){case"onDidChange":return L.Event.map(this.b.onDidChange,C=>C.reduce((y,$)=>({...y,[$]:this.b.getPolicyValue($)??null}),{}),this.a)}throw new Error(`Event not found: ${g}`)}call(S,g,C){switch(g){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(C)}throw new Error(`Call not found: ${g}`)}dispose(){this.a.dispose()}}e.$d6b=A;class j extends O.$Xm{constructor(S,g){super(),this.a=g;for(const C in S){const{definition:y,value:$}=S[C];this.f[C]=y,$!==void 0&&this.g.set(C,$)}this.a.listen("onDidChange")(C=>{for(const y in C){const $=C[y];$===null?this.g.delete(y):this.g.set(y,$)}this.h.fire(Object.keys(C))})}async i(S){const g=await this.a.call("updatePolicyDefinitions",S);for(const C in g)this.g.set(C,g[C])}}e.$e6b=j}),define(ce[102],le([0,1,6,37]),function(ie,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let O;if(typeof L.$g.vscode<"u"&&typeof L.$g.vscode.context<"u"){const A=L.$g.vscode.context.configuration();if(A)O=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(O=globalThis._VSCODE_PRODUCT_JSON,N.env.VSCODE_DEV&&Object.assign(O,{nameShort:`${O.nameShort} Dev`,nameLong:`${O.nameLong} Dev`,dataFolderName:`${O.dataFolderName}-dev`,serverDataFolderName:O.serverDataFolderName?`${O.serverDataFolderName}-dev`:void 0}),!O.version){const A=globalThis._VSCODE_PACKAGE_JSON;Object.assign(O,{version:A.version})}}else O={},Object.keys(O).length===0&&Object.assign(O,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=O}),define(ce[23],le([0,1,4]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$i=e.$0i=void 0,e.$0i=(0,L.$ph)("productService"),e.$$i="vscode://schemas/vscode-product"}),define(ce[202],le([0,1,5,8,2,16,31,7,23]),function(ie,e,L,N,O,A,j,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$26b=void 0;let g=class extends O.$lb{constructor(y,$,u){super(),this.b=$,this.c=u,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,y&&this.B(new L.$Gg(()=>{this.f(y)},3e4)).schedule()}async f(y){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const $=Date.now(),u=(0,A.$$c)(y),d=(0,A.$_c)(y),p=await j.Promises.readdir(u);await Promise.all(p.map(async c=>{if(c===d)return;const h=(0,A.$8c)(u,c),f=await j.Promises.stat(h);if(f.isDirectory()&&$-f.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${c}.`),j.Promises.rm(h)}))}catch($){(0,N.$Y)($)}}};e.$26b=g,e.$26b=g=ye([K(1,S.$0i),K(2,R.$Ri)],g)}),define(ce[203],le([0,1,5,8,2,16,31,15,7,23]),function(ie,e,L,N,O,A,j,R,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$36b=void 0;let C=class extends O.$lb{constructor($,u,d){super(),this.b=$,this.c=u,this.f=d,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new L.$Gg(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const $=Object.create(null),u=JSON.parse(await j.Promises.readFile((0,A.$8c)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const f of Object.keys(u)){const b=u[f];$[`${b.hash}.${f}`]=!0}const d=(0,A.$8c)(this.b.userDataPath,"clp");if(!await j.Promises.exists(d))return;const c=await j.Promises.readdir(d);for(const f of c){if($[f]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${f}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${f}`),await j.Promises.rm((0,A.$8c)(d,f))}const h=Date.now();for(const f of Object.keys($)){const b=(0,A.$8c)(d,f),w=await j.Promises.readdir(b);for(const I of w){if(I==="tcf.json")continue;const t=(0,A.$8c)(b,I),o=await j.Promises.stat(t);o.isDirectory()&&h-o.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,A.$8c)(f,I)}`),await j.Promises.rm(t))}}}catch($){(0,N.$Y)($)}}};e.$36b=C,e.$36b=C=ye([K(0,R.$xh),K(1,S.$Ri),K(2,g.$0i)],C)}),define(ce[204],le([0,1,16,4]),function(ie,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.$qF=void 0,e.$qF=(0,N.$ph)("IV8InspectProfilingService");var O;(function(A){function j(S){return!!(S.samples&&S.timeDeltas)}A.isValidProfile=j;function R(S,g="noAbsolutePaths"){for(const C of S.nodes)C.callFrame&&C.callFrame.url&&((0,L.$7c)(C.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(C.callFrame.url))&&(C.callFrame.url=(0,L.$8c)(g,(0,L.$_c)(C.callFrame.url)));return S}A.rewriteAbsolutePaths=R})(O||(e.Utils=O={}))}),define(ce[205],le([0,1,32]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k7b=void 0;class N{constructor(){this.a=new Map}async startProfiling(A){const R=await(await new Promise((g,C)=>{ie(["v8-inspect-profiler"],g,C)})).startProfiling({port:A.port,checkForPaused:!0}),S=(0,L.$3e)();return this.a.set(S,R),S}async stopProfiling(A){const j=this.a.get(A);if(!j)throw new Error(`UNKNOWN session '${A}'`);const R=await j.stop();return this.a.delete(A),R.profile}}e.$k7b=N}),define(ce[40],le([0,1,125,11]),function(ie,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=void 0;class O{constructor(){this.a=new Map}add(j,R){L.ok(N.$ie(j)),L.ok(N.$ke(R)),L.ok(!this.a.has(j),"There is already an extension with this id"),this.a.set(j,R)}knows(j){return this.a.has(j)}as(j){return this.a.get(j)||null}}e.$Um=new O}),define(ce[103],le([0,1,3,40]),function(ie,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vm=void 0,e.$Vm={JSONContribution:"base.contributions.json"};function O(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class A{constructor(){this.b=new L.$ec,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(S,g){this.a[O(S)]=g,this.b.fire(S)}notifySchemaChanged(S){this.b.fire(S)}getSchemaContributions(){return{schemas:this.a}}}const j=new A;N.$Um.add(e.$Vm.JSONContribution,j)}),define(ce[49],le([0,1,20,3,11,147,18,103,40]),function(ie,e,L,N,O,A,j,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.ConfigurationScope=e.$Zm=e.EditPresentationTypes=void 0;var g;(function(I){I.Multiline="multilineText",I.Singleline="singlelineText"})(g||(e.EditPresentationTypes=g={})),e.$Zm={Configuration:"base.contributions.configuration"};var C;(function(I){I[I.APPLICATION=1]="APPLICATION",I[I.MACHINE=2]="MACHINE",I[I.WINDOW=3]="WINDOW",I[I.RESOURCE=4]="RESOURCE",I[I.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",I[I.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C||(e.ConfigurationScope=C={})),e.$1m={properties:{},patternProperties:{}},e.$2m={properties:{},patternProperties:{}},e.$3m={properties:{},patternProperties:{}},e.$4m={properties:{},patternProperties:{}},e.$5m={properties:{},patternProperties:{}},e.$6m={properties:{},patternProperties:{}},e.$7m="vscode://schemas/settings/resourceLanguage",e.$8m="vscode://schemas/settings/configurationDefaults";const y=S.$Um.as(R.$Vm.JSONContribution);class ${constructor(){this.h=new Set,this.i=new N.$ec,this.onDidSchemaChange=this.i.event,this.j=new N.$ec,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},y.registerSchema(e.$7m,this.g),this.v()}registerConfiguration(t,o=!0){this.registerConfigurations([t],o)}registerConfigurations(t,o=!0){const s=new Set;this.n(t,o,s),y.registerSchema(e.$7m,this.g),this.i.fire(),this.j.fire({properties:s})}deregisterConfigurations(t){const o=new Set;this.o(t,o),y.registerSchema(e.$7m,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:t,remove:o}){const s=new Set;this.o(o,s),this.n(t,!1,s),y.registerSchema(e.$7m,this.g),this.i.fire(),this.j.fire({properties:s})}registerDefaultConfigurations(t){const o=new Set;this.k(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(t,o){const s=[];for(const{overrides:n,source:i}of t)for(const r in n)if(o.add(r),e.$0m.test(r)){const a=this.a.get(r),v=a?.valuesSources??new Map;if(i)for(const D of Object.keys(n[r]))v.set(D,i);const m={...a?.value||{},...n[r]};this.a.set(r,{source:i,value:m,valuesSources:v});const l=(0,j.$6h)(r),E={type:"object",default:m,description:A.localize(1,null,l),$ref:e.$7m,defaultDefaultValue:m,source:O.$ie(i)?void 0:i,defaultValueSource:i};s.push(...p(r)),this.d[r]=E,this.b.properties[r]=E}else{this.a.set(r,{value:n[r],source:i});const a=this.d[r];a&&(this.w(r,a),this.r(r,a))}this.m(s)}deregisterDefaultConfigurations(t){const o=new Set;this.l(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(t,o){for(const{overrides:s,source:n}of t)for(const i in s){const r=this.a.get(i),a=O.$ie(n)?n:n?.id,v=O.$ie(r?.source)?r?.source:r?.source?.id;if(a===v)if(o.add(i),this.a.delete(i),e.$0m.test(i))delete this.d[i],delete this.b.properties[i];else{const m=this.d[i];m&&(this.w(i,m),this.r(i,m))}}this.u()}deltaConfiguration(t){let o=!1;const s=new Set;t.removedDefaults&&(this.l(t.removedDefaults,s),o=!0),t.addedDefaults&&(this.k(t.addedDefaults,s),o=!0),t.removedConfigurations&&this.o(t.removedConfigurations,s),t.addedConfigurations&&this.n(t.addedConfigurations,!1,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const o of t)this.h.add(o);this.u()}n(t,o,s){t.forEach(n=>{this.p(n,o,n.extensionInfo,n.restrictedProperties,void 0,s),this.c.push(n),this.q(n)})}o(t,o){const s=n=>{if(n.properties)for(const i in n.properties){o.add(i);const r=this.d[i];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[i],this.s(i,n.properties[i])}n.allOf?.forEach(i=>s(i))};for(const n of t){s(n);const i=this.c.indexOf(n);i!==-1&&this.c.splice(i,1)}}p(t,o=!0,s,n,i=3,r){i=O.$re(t.scope)?i:t.scope;const a=t.properties;if(a)for(const m in a){const l=a[m];if(o&&b(m,l)){delete a[m];continue}if(l.source=s,l.defaultDefaultValue=a[m].default,this.w(m,l),e.$0m.test(m)?l.scope=void 0:(l.scope=O.$re(l.scope)?i:l.scope,l.restricted=O.$re(l.restricted)?!!n?.includes(m):l.restricted),a[m].hasOwnProperty("included")&&!a[m].included){this.f[m]=a[m],delete a[m];continue}else this.d[m]=a[m],a[m].policy?.name&&this.e.set(a[m].policy.name,m);!a[m].deprecationMessage&&a[m].markdownDeprecationMessage&&(a[m].deprecationMessage=a[m].markdownDeprecationMessage),r.add(m)}const v=t.allOf;if(v)for(const m of v)this.p(m,o,s,n,i,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const o=s=>{const n=s.properties;if(n)for(const r in n)this.r(r,n[r]);s.allOf?.forEach(o)};o(t)}r(t,o){switch(e.$1m.properties[t]=o,o.scope){case 1:e.$2m.properties[t]=o;break;case 2:e.$3m.properties[t]=o;break;case 6:e.$4m.properties[t]=o;break;case 3:e.$5m.properties[t]=o;break;case 4:e.$6m.properties[t]=o;break;case 5:e.$6m.properties[t]=o,this.g.properties[t]=o;break}}s(t,o){switch(delete e.$1m.properties[t],o.scope){case 1:delete e.$2m.properties[t];break;case 2:delete e.$3m.properties[t];break;case 6:delete e.$4m.properties[t];break;case 3:delete e.$5m.properties[t];break;case 4:case 5:delete e.$6m.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const o=`[${t}]`,s={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.$7m};this.w(o,s),e.$1m.properties[o]=s,e.$2m.properties[o]=s,e.$3m.properties[o]=s,e.$4m.properties[o]=s,e.$5m.properties[o]=s,e.$6m.properties[o]=s}}v(){const t={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.$7m};e.$1m.patternProperties[e.$9m]=t,e.$2m.patternProperties[e.$9m]=t,e.$3m.patternProperties[e.$9m]=t,e.$4m.patternProperties[e.$9m]=t,e.$5m.patternProperties[e.$9m]=t,e.$6m.patternProperties[e.$9m]=t,this.i.fire()}w(t,o){const s=this.a.get(t);let n=s?.value,i=s?.source;O.$pe(n)&&(n=o.defaultDefaultValue,i=void 0),O.$pe(n)&&(n=h(o.type)),o.default=n,o.defaultValueSource=i}}const u="\\[([^\\]]+)\\]",d=new RegExp(u,"g");e.$9m=`^(${u})+$`,e.$0m=new RegExp(e.$9m);function p(I){const t=[];if(e.$0m.test(I)){let o=d.exec(I);for(;o?.length;){const s=o[1].trim();s&&t.push(s),o=d.exec(I)}}return(0,L.$of)(t)}e.$$m=p;function c(I){return I.reduce((t,o)=>`${t}[${o}]`,"")}e.$_m=c;function h(I){switch(Array.isArray(I)?I[0]:I){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$an=h;const f=new $;S.$Um.add(e.$Zm.Configuration,f);function b(I,t){return I.trim()?e.$0m.test(I)?A.localize(7,null,I):f.getConfigurationProperties()[I]!==void 0?A.localize(8,null,I):t.policy?.name&&f.getPolicyConfigurations().get(t.policy?.name)!==void 0?A.localize(9,null,I,t.policy?.name,f.getPolicyConfigurations().get(t.policy?.name)):null:A.localize(6,null)}e.$bn=b;function w(){const I=[],t=f.getConfigurationProperties();for(const o of Object.keys(t))I.push([o,t[o].scope]);return I.push(["launch",4]),I.push(["task",4]),I}e.$cn=w}),define(ce[73],le([0,1,20,3,34,2,35,30,11,10,18,49,40]),function(ie,e,L,N,O,A,j,R,S,g,C,y,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=void 0;function u(o){return Object.isFrozen(o)?o:R.$Jm(o)}class d{constructor(s={},n=[],i=[],r){this.b=s,this.c=n,this.d=i,this.raw=r,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const s=this.raw.map(n=>{if(n instanceof d)return n;const i=new p("");return i.parseRaw(n),i.configurationModel});this.f=s.reduce((n,i)=>i===n?i:n.merge(i),s[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,C.$4h)(this.contents,s):this.contents}inspect(s,n){const i=this.rawConfiguration.getValue(s),r=n?this.rawConfiguration.getOverrideValue(s,n):void 0,a=n?this.rawConfiguration.override(n).getValue(s):i;return{value:i,override:r,merged:a}}getOverrideValue(s,n){const i=this.i(n);return i?s?(0,C.$4h)(i,s):i:void 0}getKeysForOverrideIdentifier(s){const n=[];for(const i of this.overrides)i.identifiers.includes(s)&&n.push(...i.keys);return L.$of(n)}getAllOverrideIdentifiers(){const s=[];for(const n of this.overrides)s.push(...n.identifiers);return L.$of(s)}override(s){let n=this.a.get(s);return n||(n=this.g(s),this.a.set(s,n)),n}merge(...s){const n=R.$Im(this.contents),i=R.$Im(this.overrides),r=[...this.keys],a=this.raw?.length?[...this.raw]:[this];for(const v of s)if(a.push(...v.raw?.length?v.raw:[v]),!v.isEmpty()){this.h(n,v.contents);for(const m of v.overrides){const[l]=i.filter(E=>L.$$e(E.identifiers,m.identifiers));l?(this.h(l.contents,m.contents),l.keys.push(...m.keys),l.keys=L.$of(l.keys)):i.push(R.$Im(m))}for(const m of v.keys)r.indexOf(m)===-1&&r.push(m)}return new d(n,r,i,a.every(v=>v instanceof d)?void 0:a)}g(s){const n=this.i(s);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const i={};for(const r of L.$of([...Object.keys(this.contents),...Object.keys(n)])){let a=this.contents[r];const v=n[r];v&&(typeof a=="object"&&typeof v=="object"?(a=R.$Im(a),this.h(a,v)):a=v),i[r]=a}return new d(i,this.keys,this.overrides)}h(s,n){for(const i of Object.keys(n)){if(i in s&&S.$ke(s[i])&&S.$ke(n[i])){this.h(s[i],n[i]);continue}s[i]=R.$Im(n[i])}}i(s){let n=null,i=null;const r=a=>{a&&(i?this.h(i,a):i=R.$Im(a))};for(const a of this.overrides)a.identifiers.length===1&&a.identifiers[0]===s?n=a.contents:a.identifiers.includes(s)&&r(a.contents);return r(n),i}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,n){this.j(s,n,!0)}setValue(s,n){this.j(s,n,!1)}removeValue(s){const n=this.keys.indexOf(s);n!==-1&&(this.keys.splice(n,1),(0,C.$3h)(this.contents,s),y.$0m.test(s)&&this.overrides.splice(this.overrides.findIndex(i=>L.$$e(i.identifiers,(0,y.$$m)(s))),1))}j(s,n,i){(0,C.$2h)(this.contents,s,n,r=>console.error(r)),i=i||this.keys.indexOf(s)===-1,i&&this.keys.push(s),y.$0m.test(s)&&this.overrides.push({identifiers:(0,y.$$m)(s),keys:Object.keys(this.contents[s]),contents:(0,C.$1h)(this.contents[s],r=>console.error(r))})}}e.$dn=d;class p{constructor(s){this.f=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new d}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,n){if(!S.$re(s)){const i=this.g(s);this.parseRaw(i,n)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,n){this.a=s;const{contents:i,keys:r,overrides:a,restricted:v,hasExcludedProperties:m}=this.h(s,n);this.b=new d(i,r,a,m?[s]:void 0),this.c=v||[]}g(s){let n={},i=null,r=[];const a=[],v=[];function m(E){Array.isArray(r)?r.push(E):i!==null&&(r[i]=E)}const l={onObjectBegin:()=>{const E={};m(E),a.push(r),r=E,i=null},onObjectProperty:E=>{i=E},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{const E=[];m(E),a.push(r),r=E,i=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:m,onError:(E,D,T)=>{v.push({error:E,offset:D,length:T})}};if(s)try{O.$Fm(s,l),n=r[0]||{}}catch(E){console.error(`Error while parsing settings file ${this.f}: ${E}`),this.d=[E]}return n}h(s,n){const i=$.$Um.as(y.$Zm.Configuration).getConfigurationProperties(),r=this.i(s,i,!0,n);s=r.raw;const a=(0,C.$1h)(s,l=>console.error(`Conflict in settings file ${this.f}: ${l}`)),v=Object.keys(s),m=this.j(s,l=>console.error(`Conflict in settings file ${this.f}: ${l}`));return{contents:a,keys:v,overrides:m,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}i(s,n,i,r){let a=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:a};const v={},m=[];for(const l in s)if(y.$0m.test(l)&&i){const E=this.i(s[l],n,!1,r);v[l]=E.raw,a=a||E.hasExcludedProperties,m.push(...E.restricted)}else{const E=n[l],D=E?typeof E.scope<"u"?E.scope:3:void 0;E?.restricted&&m.push(l),!r.exclude?.includes(l)&&(r.include?.includes(l)||(D===void 0||r.scopes===void 0||r.scopes.includes(D))&&!(r.skipRestricted&&E?.restricted))?v[l]=s[l]:a=!0}return{raw:v,restricted:m,hasExcludedProperties:a}}j(s,n){const i=[];for(const r of Object.keys(s))if(y.$0m.test(r)){const a={};for(const v in s[r])a[v]=s[r][v];i.push({identifiers:(0,y.$$m)(r),keys:Object.keys(a),contents:(0,C.$1h)(a,n)})}return i}}e.$en=p;class c extends A.$lb{constructor(s,n,i,r){super(),this.c=s,this.f=n,this.g=r,this.b=this.B(new N.$ec),this.onDidChange=this.b.event,this.a=new p(this.c.toString()),this.B(this.g.watch(i.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(N.Event.any(N.Event.filter(this.g.onDidFilesChange,a=>a.contains(this.c)),N.Event.filter(this.g.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&i.isEqual(a.resource,s)))(()=>this.b.fire()))}async loadConfiguration(){try{const s=await this.g.readFile(this.c);return this.a.parse(s.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new d}}reparse(s){return s&&(this.f=s),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$fn=c;class h{constructor(s,n,i,r,a,v,m,l,E,D,T,M,F){this.a=s,this.b=n,this.c=i,this.overrideIdentifiers=r,this.d=a,this.f=v,this.g=m,this.h=l,this.i=E,this.j=D,this.k=T,this.l=M,this.m=F}get value(){return u(this.c)}n(s,n,i){const r=s.inspect(n,i);return{get value(){return u(r.value)},get override(){return u(r.override)},get merged(){return u(r.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class f{constructor(s,n,i,r,a=new d,v=new d,m=new j.$ni,l=new d,E=new j.$ni){this.c=s,this.d=n,this.f=i,this.g=r,this.h=a,this.i=v,this.j=m,this.l=l,this.m=E,this.a=null,this.b=new j.$ni,this.n=null}getValue(s,n,i){return this.q(s,n,i).getValue(s)}updateValue(s,n,i={}){let r;i.resource?(r=this.m.get(i.resource),r||(r=new d,this.m.set(i.resource,r))):r=this.l,n===void 0?r.removeValue(s):r.setValue(s,n),i.resource||(this.a=null)}inspect(s,n,i){const r=this.q(s,n,i),a=this.u(n.resource,i),v=n.resource?this.m.get(n.resource)||this.l:this.l,m=new Set;for(const l of r.overrides)for(const E of l.identifiers)r.getOverrideValue(s,E)!==void 0&&m.add(E);return new h(s,n,r.getValue(s),m.size?[...m]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,i?this.i:void 0,a||void 0,v)}keys(s){const n=this.u(void 0,s);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(s){this.c=s,this.a=null,this.b.clear()}updatePolicyConfiguration(s){this.d=s}updateApplicationConfiguration(s){this.f=s,this.a=null,this.b.clear()}updateLocalUserConfiguration(s){this.g=s,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(s){this.h=s,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(s){this.i=s,this.a=null,this.b.clear()}updateFolderConfiguration(s,n){this.j.set(s,n),this.b.delete(s)}deleteFolderConfiguration(s){this.p.delete(s),this.b.delete(s)}compareAndUpdateDefaultConfiguration(s,n){const i=[];if(!n){const{added:r,updated:a,removed:v}=I(this.c,s);n=[...r,...a,...v]}for(const r of n)for(const a of(0,y.$$m)(r)){const v=this.c.getKeysForOverrideIdentifier(a),m=s.getKeysForOverrideIdentifier(a),l=[...m.filter(E=>v.indexOf(E)===-1),...v.filter(E=>m.indexOf(E)===-1),...v.filter(E=>!R.$Mm(this.c.override(a).getValue(E),s.override(a).getValue(E)))];i.push([a,l])}return this.updateDefaultConfiguration(s),{keys:n,overrides:i}}compareAndUpdatePolicyConfiguration(s){const{added:n,updated:i,removed:r}=I(this.d,s),a=[...n,...i,...r];return a.length&&this.updatePolicyConfiguration(s),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:n,updated:i,removed:r,overrides:a}=I(this.applicationConfiguration,s),v=[...n,...i,...r];return v.length&&this.updateApplicationConfiguration(s),{keys:v,overrides:a}}compareAndUpdateLocalUserConfiguration(s){const{added:n,updated:i,removed:r,overrides:a}=I(this.localUserConfiguration,s),v=[...n,...i,...r];return v.length&&this.updateLocalUserConfiguration(s),{keys:v,overrides:a}}compareAndUpdateRemoteUserConfiguration(s){const{added:n,updated:i,removed:r,overrides:a}=I(this.remoteUserConfiguration,s),v=[...n,...i,...r];return v.length&&this.updateRemoteUserConfiguration(s),{keys:v,overrides:a}}compareAndUpdateWorkspaceConfiguration(s){const{added:n,updated:i,removed:r,overrides:a}=I(this.workspaceConfiguration,s),v=[...n,...i,...r];return v.length&&this.updateWorkspaceConfiguration(s),{keys:v,overrides:a}}compareAndUpdateFolderConfiguration(s,n){const i=this.p.get(s),{added:r,updated:a,removed:v,overrides:m}=I(i,n),l=[...r,...a,...v];return(l.length||!i)&&this.updateFolderConfiguration(s,n),{keys:l,overrides:m}}compareAndDeleteFolderConfiguration(s){const n=this.p.get(s);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:i,updated:r,removed:a,overrides:v}=I(n,void 0);return{keys:[...i,...r,...a],overrides:v}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(s,n,i){let r=this.r(n,i);return n.overrideIdentifier&&(r=r.override(n.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(s)!==void 0&&(r=r.merge(this.d)),r}r({resource:s},n){let i=this.s();if(n&&s){const r=n.getFolder(s);r&&(i=this.t(r.uri)||i);const a=this.m.get(s);a&&(i=i.merge(a))}return i}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(s){let n=this.b.get(s);if(!n){const i=this.s(),r=this.j.get(s);r?(n=i.merge(r),this.b.set(s,n)):n=i}return n}u(s,n){if(n&&s){const i=n.getFolder(s);if(i)return this.j.get(i.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((s,n)=>{const{contents:i,overrides:r,keys:a}=this.j.get(n);return s.push([n,{contents:i,overrides:r,keys:a}]),s},[])}}allKeys(){const s=new Set;return this.c.keys.forEach(n=>s.add(n)),this.userConfiguration.keys.forEach(n=>s.add(n)),this.i.keys.forEach(n=>s.add(n)),this.j.forEach(n=>n.keys.forEach(i=>s.add(i))),[...s.values()]}v(){const s=new Set;return this.c.getAllOverrideIdentifiers().forEach(n=>s.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>s.add(n)),this.i.getAllOverrideIdentifiers().forEach(n=>s.add(n)),this.j.forEach(n=>n.getAllOverrideIdentifiers().forEach(i=>s.add(i))),[...s.values()]}w(s){const n=new Set;return this.c.getKeysForOverrideIdentifier(s).forEach(i=>n.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(i=>n.add(i)),this.i.getKeysForOverrideIdentifier(s).forEach(i=>n.add(i)),this.j.forEach(i=>i.getKeysForOverrideIdentifier(s).forEach(r=>n.add(r))),[...n.values()]}static parse(s){const n=this.x(s.defaults),i=this.x(s.policy),r=this.x(s.application),a=this.x(s.user),v=this.x(s.workspace),m=s.folders.reduce((l,E)=>(l.set(g.URI.revive(E[0]),this.x(E[1])),l),new j.$ni);return new f(n,i,r,a,new d,v,m,new d,new j.$ni)}static x(s){return new d(s.contents,s.keys,s.overrides)}}e.$gn=f;function b(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const s=new Set,n=new Map;for(const r of o)r.keys.forEach(a=>s.add(a)),r.overrides.forEach(([a,v])=>{const m=(0,j.$ki)(n,a,new Set);v.forEach(l=>m.add(l))});const i=[];return n.forEach((r,a)=>i.push([a,[...r.values()]])),{keys:[...s.values()],overrides:i}}e.$hn=b;class w{constructor(s,n,i,r){this.change=s,this.f=n,this.g=i,this.h=r,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const a of s.keys)this.affectedKeys.add(a);for(const[,a]of s.overrides)for(const v of a)this.affectedKeys.add(v);this.d=this.a;for(const a of this.affectedKeys)this.d+=a+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=f.parse(this.f.data)),this.i}affectsConfiguration(s,n){const i=this.a+s,r=this.d.indexOf(i);if(r<0)return!1;const a=r+i.length;if(a>=this.d.length)return!1;const v=this.d.charCodeAt(a);if(v!==this.b&&v!==this.c)return!1;if(n){const m=this.previousConfiguration?this.previousConfiguration.getValue(s,n,this.f?.workspace):void 0,l=this.g.getValue(s,n,this.h);return!R.$Mm(m,l)}return!0}}e.$in=w;function I(o,s){const{added:n,removed:i,updated:r}=t(s?.rawConfiguration,o?.rawConfiguration),a=[],v=o?.getAllOverrideIdentifiers()||[],m=s?.getAllOverrideIdentifiers()||[];if(s){const l=m.filter(E=>!v.includes(E));for(const E of l)a.push([E,s.getKeysForOverrideIdentifier(E)])}if(o){const l=v.filter(E=>!m.includes(E));for(const E of l)a.push([E,o.getKeysForOverrideIdentifier(E)])}if(s&&o){for(const l of v)if(m.includes(l)){const E=t({contents:o.getOverrideValue(void 0,l)||{},keys:o.getKeysForOverrideIdentifier(l)},{contents:s.getOverrideValue(void 0,l)||{},keys:s.getKeysForOverrideIdentifier(l)});a.push([l,[...E.added,...E.removed,...E.updated]])}}return{added:n,removed:i,updated:r,overrides:a}}function t(o,s){const n=o?s?o.keys.filter(a=>s.keys.indexOf(a)===-1):[...o.keys]:[],i=s?o?s.keys.filter(a=>o.keys.indexOf(a)===-1):[...s.keys]:[],r=[];if(o&&s){for(const a of s.keys)if(o.keys.indexOf(a)!==-1){const v=(0,C.$4h)(s.contents,a),m=(0,C.$4h)(o.contents,a);R.$Mm(v,m)||r.push(a)}}return{added:n,removed:i,updated:r}}}),define(ce[206],le([0,1,20,3,2,30,11,73,49,7,56,40]),function(ie,e,L,N,O,A,j,R,S,g,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=e.$kn=e.$jn=void 0;class $ extends O.$lb{constructor(){super(...arguments),this.a=this.B(new N.$ec),this.onDidChangeConfiguration=this.a.event,this.b=new R.$dn}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(y.$Um.as(S.$Zm.Configuration).onDidUpdateConfiguration(({properties:c,defaultsOverrides:h})=>this.c(Array.from(c),h))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(c,h){this.h(c,y.$Um.as(S.$Zm.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:c})}f(){return{}}g(){this.b=new R.$dn;const c=y.$Um.as(S.$Zm.Configuration).getConfigurationProperties();this.h(Object.keys(c),c)}h(c,h){const f=this.f();for(const b of c){const w=f[b],I=h[b];w!==void 0?this.b.addValue(b,w):I?this.b.addValue(b,I.default):this.b.removeValue(b)}}}e.$jn=$;class u{constructor(){this.onDidChangeConfiguration=N.Event.None,this.configurationModel=new R.$dn}async initialize(){return this.configurationModel}}e.$kn=u;let d=class extends O.$lb{get configurationModel(){return this.b}constructor(c,h,f){super(),this.c=c,this.f=h,this.g=f,this.a=this.B(new N.$ec),this.onDidChangeConfiguration=this.a.event,this.b=new R.$dn}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(c=>this.i(c))),this.B(this.c.onDidChangeConfiguration(async({properties:c})=>this.j(await this.h(c),!0))),this.b}async h(c){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",c);const h={},f=[],b=y.$Um.as(S.$Zm.Configuration).getConfigurationProperties();for(const w of c){const I=b[w];if(!I){f.push(w);continue}if(I.policy){if(I.type!=="string"&&I.type!=="number"){this.g.warn(`Policy ${I.policy.name} has unsupported type ${I.type}`);continue}f.push(w),h[I.policy.name]={type:I.type}}}return(0,j.$ve)(h)||await this.f.updatePolicyDefinitions(h),f}i(c){this.g.trace("PolicyConfiguration#onDidChangePolicies",c);const h=y.$Um.as(S.$Zm.Configuration).getPolicyConfigurations(),f=(0,L.$jf)(c.map(b=>h.get(b)));this.j(f,!0)}j(c,h){this.g.trace("PolicyConfiguration#update",c);const f=y.$Um.as(S.$Zm.Configuration).getConfigurationProperties(),b=[],w=this.b.isEmpty();for(const I of c){const t=f[I]?.policy?.name;if(t){const o=this.f.getPolicyValue(t);(w?o!==void 0:!(0,A.$Mm)(this.b.getValue(I),o))&&b.push([I,o])}else this.b.getValue(I)!==void 0&&b.push([I,void 0])}if(b.length){this.g.trace("PolicyConfiguration#changed",b);const I=this.b;this.b=new R.$dn;for(const t of I.keys)this.b.setValue(t,I.getValue(t));for(const[t,o]of b)o===void 0?this.b.removeValue(t):this.b.setValue(t,o);h&&this.a.fire(this.b)}}};e.$ln=d,e.$ln=d=ye([K(1,C.$Wm),K(2,g.$Ri)],d)}),define(ce[207],le([0,1,5,3,2,22,18,73,206,56]),function(ie,e,L,N,O,A,j,R,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mn=void 0;class C extends O.$lb{constructor($,u,d,p){super(),this.i=$,this.h=this.B(new N.$ec),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new S.$jn),this.c=d instanceof g.$Ym?new S.$kn:this.B(new S.$ln(this.b,d,p)),this.f=this.B(new R.$fn(this.i,{},A.$Zf,u)),this.a=new R.$gn(this.b.configurationModel,this.c.configurationModel,new R.$dn,new R.$dn),this.g=this.B(new L.$Gg(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:c,properties:h})=>this.k(c,h))),this.B(this.c.onDidChangeConfiguration(c=>this.l(c))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[$,u,d]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new R.$gn($,u,new R.$dn,d)}getConfigurationData(){return this.a.toData()}getValue($,u){const d=typeof $=="string"?$:void 0,p=(0,j.$Wh)($)?$:(0,j.$Wh)(u)?u:{};return this.a.getValue(d,p,void 0)}updateValue($,u,d,p){return Promise.reject(new Error("not supported"))}inspect($){return this.a.inspect($,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const $=await this.f.loadConfiguration();this.j($)}j($){const u=this.a.toData(),d=this.a.compareAndUpdateLocalUserConfiguration($);this.m(d,u,2)}k($,u){const d=this.a.toData(),p=this.a.compareAndUpdateDefaultConfiguration($,u);this.m(p,d,7)}l($){const u=this.a.toData(),d=this.a.compareAndUpdatePolicyConfiguration($);this.m(d,u,7)}m($,u,d){const p=new R.$in($,{data:u},this.a);p.source=d,p.sourceConfig=this.n(d),this.h.fire(p)}n($){switch($){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$mn=C}),define(ce[208],le([0,1,14,3,2,65]),function(ie,e,L,N,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zjb=e.$Yjb=e.$Xjb=e.$Wjb=void 0;const j=(g,C,y)=>{const $=new Uint8Array(16);for(let p=0;p<16;p++)$[p]=Math.round(Math.random()*256);const u=(0,L.$Yc)(L.$Ec.wrap($));return[`GET ws://localhost${g}?${C}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${u}`].join(`\r
`)+`\r
\r
`};e.$Wjb=j,e.$Xjb=L.$Ec.fromString(`\r
\r
`);async function R(g,C,y,$,u){g.write(L.$Ec.fromString((0,e.$Wjb)(C,y,$)));const d=new O.$kb;try{return await new Promise((p,c)=>{let h;d.add(g.onData(f=>{h?h=L.$Ec.concat([h,f],h.byteLength+f.byteLength):h=f;const b=h.indexOf(e.$Xjb);if(b===-1)return;p(g),g.pauseData();const w=h.slice(b+e.$Xjb.byteLength);w.byteLength&&u.onData.fire(w)})),d.add(g.onClose(f=>c(f??new Error("socket closed")))),d.add(g.onEnd(()=>c(new Error("socket ended"))))})}catch(p){throw g.dispose(),p}finally{d.dispose()}}e.$Yjb=R;class S extends O.$lb{constructor(C,y){super(),this.g=C,this.a=this.B(new N.$hc),this.onData=(...$)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...$)),this.b=this.B(new N.$ec),this.onDidDispose=this.b.event,this.f=!1,this.B(y.onData),this.B(y.onData.event($=>this.a.fire($))),this.onClose=this.B(y.onClose).event,this.onEnd=this.B(y.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(C,y){A.SocketDiagnostics.traceSocketEvent(this,this.g,C,y)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$Zjb=S}),define(ce[209],le([0,1,8,4]),function(ie,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ak=e.$zk=e.RemoteAuthorityResolverErrorCode=e.$yk=e.$xk=e.RemoteConnectionType=e.$wk=void 0,e.$wk=(0,N.$ph)("remoteAuthorityResolverService");var O;(function(C){C[C.WebSocket=0]="WebSocket",C[C.Managed=1]="Managed"})(O||(e.RemoteConnectionType=O={}));class A{constructor(y){this.id=y,this.type=1}toString(){return`Managed(${this.id})`}}e.$xk=A;class j{constructor(y,$){this.host=y,this.port=$,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$yk=j;var R;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound",C.InvalidAuthority="InvalidAuthority"})(R||(e.RemoteAuthorityResolverErrorCode=R={}));class S extends L.$ab{static isNotAvailable(y){return y instanceof S&&y._code===R.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof S&&y._code===R.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof S&&y._code===R.NoResolverFound}static isInvalidAuthority(y){return y instanceof S&&y._code===R.InvalidAuthority}static isHandled(y){return y instanceof S&&y.isHandled}constructor(y,$=R.Unknown,u){super(y),this._message=y,this._code=$,this._detail=u,this.isHandled=$===R.NotAvailable&&u===!0,Object.setPrototypeOf(this,S.prototype)}}e.$zk=S;function g(C){const y=C.indexOf("+");return y===-1?C:C.substring(0,y)}e.$Ak=g}),define(ce[74],le([0,1,26]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.$Bk=void 0;function N(g){return g.scheme===L.Schemas.vscodeRemote?g.authority:void 0}e.$Bk=N;function O(g){if(!g)return;const C=g.indexOf("+");return C<0?g:g.substr(0,C)}e.$Ck=O;function A(g){return`/${g.quality??"oss"}-${g.commit??"dev"}`}e.$Dk=A;function j(g){const{host:C,port:y}=S(g);if(typeof y>"u")throw new Error("Remote authority doesn't contain a port!");return{host:C,port:y}}e.$Ek=j;function R(g,C){let{host:y,port:$}=S(g);return typeof $>"u"&&($=C),{host:y,port:$}}e.$Fk=R;function S(g){const C=g.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(C)return{host:C[1],port:parseInt(C[2],10)};const y=g.match(/^(\[[0-9a-z:]+\])$/);if(y)return{host:y[1],port:void 0};const $=g.match(/(.*):(\d+)$/);return $?{host:$[1],port:parseInt($[2],10)}:{host:g,port:void 0}}}),define(ce[45],le([0,1,28,4,74]),function(ie,e,L,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=e.$Ol=e.$Nl=e.$Ml=e.$Ll=e.$Kl=e.$Jl=e.$Il=e.TargetPlatform=e.ExtensionType=e.$Hl=e.$Gl=e.$Fl=e.$El=e.$Dl=e.$Cl=void 0,e.$Cl="extensions.user.cache",e.$Dl="extensions.builtin.cache",e.$El="undefined_publisher",e.$Fl=["ui","workspace","web"];function A(p){if(typeof p=="object"&&p!==null&&p.supported!==!0)return p.description}e.$Gl=A,e.$Hl=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var j;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(j||(e.ExtensionType=j={}));var R;(function(p){p.WIN32_X64="win32-x64",p.WIN32_IA32="win32-ia32",p.WIN32_ARM64="win32-arm64",p.LINUX_X64="linux-x64",p.LINUX_ARM64="linux-arm64",p.LINUX_ARMHF="linux-armhf",p.ALPINE_X64="alpine-x64",p.ALPINE_ARM64="alpine-arm64",p.DARWIN_X64="darwin-x64",p.DARWIN_ARM64="darwin-arm64",p.WEB="web",p.UNIVERSAL="universal",p.UNKNOWN="unknown",p.UNDEFINED="undefined"})(R||(e.TargetPlatform=R={}));class S{constructor(c){this.value=c,this._lower=c.toLowerCase()}static equals(c,h){if(typeof c>"u"||c===null)return typeof h>"u"||h===null;if(typeof h>"u"||h===null)return!1;if(typeof c=="string"||typeof h=="string"){const f=typeof c=="string"?c:c.value,b=typeof h=="string"?h:h.value;return L.$Ld(f,b)}return c._lower===h._lower}static toKey(c){return typeof c=="string"?c.toLowerCase():c._lower}}e.$Il=S;class g{get size(){return this.c.size}constructor(c){if(this.c=new Set,c)for(const h of c)this.add(h)}add(c){this.c.add(S.toKey(c))}delete(c){return this.c.delete(S.toKey(c))}has(c){return this.c.has(S.toKey(c))}}e.$Jl=g;class C{constructor(){this.c=new Map}clear(){this.c.clear()}delete(c){this.c.delete(S.toKey(c))}get(c){return this.c.get(S.toKey(c))}has(c){return this.c.has(S.toKey(c))}set(c,h){this.c.set(S.toKey(c),h)}values(){return this.c.values()}forEach(c){this.c.forEach(c)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Kl=C;function y(p){return $(p)}e.$Ll=y;function $(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}e.$Ml=$;function u(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}e.$Nl=u;function d(p,c){if(c){const h=`onResolveRemoteAuthority:${(0,O.$Ck)(c)}`;return!!p.activationEvents?.includes(h)}return!1}e.$Ol=d,e.$Pl=(0,N.$ph)("IBuiltinExtensionsScannerService")}),define(ce[210],le([0,1,2,45,13]),function(ie,e,L,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$np=void 0;class A extends L.$lb{constructor(R,S,g,C,y){super(),this.a=R,this.b=S,this.c=g,this.f=y,this.B(C.onDidInstallExtensions($=>this.g($))),this.B(C.onDidUninstallExtension($=>this.h($)))}g(R){for(const S of R)S.local&&this.invalidate(S.profileLocation)}h(R){R.error||this.invalidate(R.profileLocation)}async invalidate(R){if(R)for(const S of this.a.profiles)this.c.extUri.isEqual(S.extensionsResource,R)&&await this.i(S);else await this.i(this.a.defaultProfile)}async i(R){try{await this.b.del(this.c.extUri.joinPath(R.cacheHome,N.$Cl))}catch(S){(0,O.$9j)(S)!==1&&this.f.error(S)}}}e.$np=A}),define(ce[211],le([0,1,5,14,25,8,3,2,100,60,32,65,209,74]),function(ie,e,L,N,O,A,j,R,S,g,C,y,$,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uk=e.$Tk=e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.$Nk=e.PersistentConnectionEventType=e.$Mk=e.$Lk=e.$Kk=e.ConnectionType=void 0;const d=30*1e3;var p;(function(U){U[U.Management=1]="Management",U[U.ExtensionHost=2]="ExtensionHost",U[U.Tunnel=3]="Tunnel"})(p||(e.ConnectionType=p={}));function c(U){switch(U){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function h(U){const k=new O.$oc;return setTimeout(()=>k.cancel(),U),k.token}function f(U,k){if(U.isCancellationRequested||k.isCancellationRequested)return O.CancellationToken.Cancelled;const P=new O.$oc;return U.onCancellationRequested(()=>P.cancel()),k.onCancellationRequested(()=>P.cancel()),P.token}class b{get didTimeout(){return this.c==="timedout"}constructor(k){this.c="pending",this.d=new R.$kb,this.promise=new Promise((P,z)=>{this.f=P,this.g=z}),k.isCancellationRequested?this.h():this.d.add(k.onCancellationRequested(()=>this.h()))}registerDisposable(k){this.c==="pending"?this.d.add(k):k.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const k=new Error("Time limit reached");return k.code="ETIMEDOUT",k.syscall="connect",k}resolve(k){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(k))}reject(k){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(k))}}function w(U,k){const P=new b(k);return P.registerDisposable(U.onControlMessage(z=>{const H=JSON.parse(z.toString()),ee=q(H);ee?P.reject(ee):P.resolve(H)})),P.promise}function I(U,k,P,z,H,ee,ne,fe){const x=new b(fe),se=g.$ac.create(!1);return U.info(`Creating a socket (${ne})...`),S.mark(`code/willCreateSocket/${ee}`),k.connect(P,z,H,ne).then(te=>{x.didTimeout?(S.mark(`code/didCreateSocketError/${ee}`),U.info(`Creating a socket (${ne}) finished after ${se.elapsed()} ms, but this is too late and has timed out already.`),te?.dispose()):(S.mark(`code/didCreateSocketOK/${ee}`),U.info(`Creating a socket (${ne}) was successful after ${se.elapsed()} ms.`),x.resolve(te))},te=>{S.mark(`code/didCreateSocketError/${ee}`),U.info(`Creating a socket (${ne}) returned an error after ${se.elapsed()} ms.`),U.error(te),x.reject(te)}),x.promise}function t(U,k){const P=new b(k);return U.then(z=>{P.didTimeout||P.resolve(z)},z=>{P.didTimeout||P.reject(z)}),P.promise}async function o(U,k,P,z){const H=ae(U,k);U.logService.trace(`${H} 1/6. invoking socketFactory.connect().`);let ee;try{ee=await I(U.logService,U.remoteSocketFactoryService,U.connectTo,(0,u.$Dk)(U),`reconnectionToken=${U.reconnectionToken}&reconnection=${U.reconnectionProtocol?"true":"false"}`,c(k),`renderer-${c(k)}-${U.reconnectionToken}`,z)}catch(te){throw U.logService.error(`${H} socketFactory.connect() failed or timed out. Error:`),U.logService.error(te),te}U.logService.trace(`${H} 2/6. socketFactory.connect() was successful.`);let ne,fe;U.reconnectionProtocol?(U.reconnectionProtocol.beginAcceptReconnection(ee,null),ne=U.reconnectionProtocol,fe=!1):(ne=new y.$dh({socket:ee}),fe=!0),U.logService.trace(`${H} 3/6. sending AuthRequest control message.`);const x=await t(U.signService.createNewMessage((0,C.$3e)()),z),se={type:"auth",auth:U.connectionToken||"00000000000000000000",data:x.data};ne.sendControl(N.$Ec.fromString(JSON.stringify(se)));try{const te=await w(ne,f(z,h(1e4)));if(te.type!=="sign"||typeof te.data!="string"){const Ee=new Error("Unexpected handshake message");throw Ee.code="VSCODE_CONNECTION_ERROR",Ee}if(U.logService.trace(`${H} 4/6. received SignRequest control message.`),!await t(U.signService.validate(x,te.signedData),z)){const Ee=new Error("Refused to connect to unsupported server");throw Ee.code="VSCODE_CONNECTION_ERROR",Ee}const de=await t(U.signService.sign(te.data),z),we={type:"connectionType",commit:U.commit,signedData:de,desiredConnectionType:k};return P&&(we.args=P),U.logService.trace(`${H} 5/6. sending ConnectionTypeRequest control message.`),ne.sendControl(N.$Ec.fromString(JSON.stringify(we))),{protocol:ne,ownsProtocol:fe}}catch(te){throw te&&te.code==="ETIMEDOUT"&&(U.logService.error(`${H} the handshake timed out. Error:`),U.logService.error(te)),te&&te.code==="VSCODE_CONNECTION_ERROR"&&(U.logService.error(`${H} received error control message when negotiating connection. Error:`),U.logService.error(te)),fe&&W(ne),te}}async function s(U,k,P,z){const H=Date.now(),ee=ae(U,k),{protocol:ne,ownsProtocol:fe}=await o(U,k,P,z),x=new b(z);return x.registerDisposable(ne.onControlMessage(se=>{const te=JSON.parse(se.toString()),ue=q(te);ue?(U.logService.error(`${ee} received error control message when negotiating connection. Error:`),U.logService.error(ue),fe&&W(ne),x.reject(ue)):(U.reconnectionProtocol?.endAcceptReconnection(),U.logService.trace(`${ee} 6/6. handshake finished, connection is up and running after ${Y(H)}!`),x.resolve({protocol:ne,firstMessage:te}))})),x.promise}async function n(U,k){const{protocol:P}=await s(U,1,void 0,k);return{protocol:P}}async function i(U,k,P){const{protocol:z,firstMessage:H}=await s(U,2,k,P),ee=H&&H.debugPort;return{protocol:z,debugPort:ee}}async function r(U,k,P){const z=Date.now(),H=ae(U,3),{protocol:ee}=await o(U,3,k,P);return U.logService.trace(`${H} 6/6. handshake finished, connection is up and running after ${Y(z)}!`),ee}async function a(U,k,P){const{connectTo:z,connectionToken:H}=await U.addressProvider.getAddress();return{commit:U.commit,quality:U.quality,connectTo:z,connectionToken:H,reconnectionToken:k,reconnectionProtocol:P,remoteSocketFactoryService:U.remoteSocketFactoryService,signService:U.signService,logService:U.logService}}async function v(U,k,P){return l(U,async z=>{const{protocol:H}=await n(z,O.CancellationToken.None);return new G(U,k,P,z.reconnectionToken,H)})}e.$Kk=v;async function m(U,k){return l(U,async P=>{const{protocol:z,debugPort:H}=await i(P,k,O.CancellationToken.None);return new X(U,k,P.reconnectionToken,z,H)})}e.$Lk=m;async function l(U,k){for(let z=1;;z++)try{const H=(0,C.$3e)(),ee=await a(U,H,null);return await k(ee)}catch(H){if(z<5)U.logService.error(`[remote-connection][attempt ${z}] An error occurred in initial connection! Will retry... Error:`),U.logService.error(H);else throw U.logService.error(`[remote-connection][attempt ${z}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),U.logService.error(H),Q.triggerPermanentFailure(0,0,$.$zk.isHandled(H)),H}}async function E(U,k,P){const z=await a(U,(0,C.$3e)(),null);return await r(z,{host:k,port:P},O.CancellationToken.None)}e.$Mk=E;function D(U){return(0,L.$ig)(k=>new Promise((P,z)=>{const H=setTimeout(P,U*1e3);k.onCancellationRequested(()=>{clearTimeout(H),P()})}))}var T;(function(U){U[U.ConnectionLost=0]="ConnectionLost",U[U.ReconnectionWait=1]="ReconnectionWait",U[U.ReconnectionRunning=2]="ReconnectionRunning",U[U.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",U[U.ConnectionGain=4]="ConnectionGain"})(T||(e.PersistentConnectionEventType=T={}));class M{constructor(k,P){this.reconnectionToken=k,this.millisSinceLastIncomingData=P,this.type=0}}e.$Nk=M;class F{constructor(k,P,z,H){this.reconnectionToken=k,this.millisSinceLastIncomingData=P,this.durationSeconds=z,this.c=H,this.type=1}skipWait(){this.c.cancel()}}e.$Ok=F;class V{constructor(k,P,z){this.reconnectionToken=k,this.millisSinceLastIncomingData=P,this.attempt=z,this.type=2}}e.$Pk=V;class Z{constructor(k,P,z){this.reconnectionToken=k,this.millisSinceLastIncomingData=P,this.attempt=z,this.type=4}}e.$Qk=Z;class J{constructor(k,P,z,H){this.reconnectionToken=k,this.millisSinceLastIncomingData=P,this.attempt=z,this.handled=H,this.type=3}}e.$Rk=J;class Q extends R.$lb{static triggerPermanentFailure(k,P,z){this._permanentFailure=!0,this.f=k,this.g=P,this.h=z,this.i.forEach(H=>H.v(this.f,this.g,this.h))}static debugTriggerReconnection(){this.i.forEach(k=>k.s())}static debugPauseSocketWriting(){this.i.forEach(k=>k.w())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.i=[]}get k(){return this.c||Q._permanentFailure}constructor(k,P,z,H,ee){super(),this.n=k,this.p=P,this.reconnectionToken=z,this.protocol=H,this.r=ee,this.j=this.B(new j.$ec),this.onDidStateChange=this.j.event,this.c=!1,this.l=!1,this.m=!1,this.j.fire(new Z(this.reconnectionToken,0,0)),this.B(H.onSocketClose(ne=>{const fe=oe(this.n,this.reconnectionToken,!0);ne?ne.type===0?(this.p.logService.info(`${fe} received socket close event (hadError: ${ne.hadError}).`),ne.error&&this.p.logService.error(ne.error)):(this.p.logService.info(`${fe} received socket close event (wasClean: ${ne.wasClean}, code: ${ne.code}, reason: ${ne.reason}).`),ne.event&&this.p.logService.error(ne.event)):this.p.logService.info(`${fe} received socket close event.`),this.s()})),this.B(H.onSocketTimeout(ne=>{const fe=oe(this.n,this.reconnectionToken,!0);this.p.logService.info(`${fe} received socket timeout event (unacknowledgedMsgCount: ${ne.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ne.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ne.timeSinceLastReceivedSomeData}).`),this.s()})),Q.i.push(this),this.B((0,R.$jb)(()=>{const ne=Q.i.indexOf(this);ne>=0&&Q.i.splice(ne,1)})),this.k&&this.v(Q.f,Q.g,Q.h)}dispose(){super.dispose(),this.m=!0}async s(){if(!this.l)try{this.l=!0,await this.t()}finally{this.l=!1}}async t(){if(this.k||this.m)return;const k=oe(this.n,this.reconnectionToken,!0);this.p.logService.info(`${k} starting reconnecting loop. You can get more information with the trace log level.`),this.j.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const P=[0,5,5,10,10,10,10,10,30];let z=-1;do{z++;const H=z<P.length?P[z]:P[P.length-1];try{if(H>0){const ne=D(H);this.j.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),H,ne)),this.p.logService.info(`${k} waiting for ${H} seconds before reconnecting...`);try{await ne}catch{}}if(this.k){this.p.logService.error(`${k} permanent failure occurred while running the reconnecting loop.`);break}this.j.fire(new V(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),z+1)),this.p.logService.info(`${k} resolving connection...`);const ee=await a(this.p,this.reconnectionToken,this.protocol);this.p.logService.info(`${k} connecting to ${ee.connectTo}...`),await this.y(ee,h(d)),this.p.logService.info(`${k} reconnected!`),this.j.fire(new Z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),z+1));break}catch(ee){if(ee.code==="VSCODE_CONNECTION_ERROR"){this.p.logService.error(`${k} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.p.logService.error(ee),this.u(this.protocol.getMillisSinceLastIncomingData(),z+1,!1);break}if(z>360){this.p.logService.error(`${k} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.p.logService.error(ee),this.u(this.protocol.getMillisSinceLastIncomingData(),z+1,!1);break}if($.$zk.isTemporarilyNotAvailable(ee)){this.p.logService.info(`${k} A temporarily not available error occurred while trying to reconnect, will try again...`),this.p.logService.trace(ee);continue}if((ee.code==="ETIMEDOUT"||ee.code==="ENETUNREACH"||ee.code==="ECONNREFUSED"||ee.code==="ECONNRESET")&&ee.syscall==="connect"){this.p.logService.info(`${k} A network error occurred while trying to reconnect, will try again...`),this.p.logService.trace(ee);continue}if((0,A.$2)(ee)){this.p.logService.info(`${k} A promise cancelation error occurred while trying to reconnect, will try again...`),this.p.logService.trace(ee);continue}if(ee instanceof $.$zk){this.p.logService.error(`${k} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.p.logService.error(ee),this.u(this.protocol.getMillisSinceLastIncomingData(),z+1,$.$zk.isHandled(ee));break}this.p.logService.error(`${k} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.p.logService.error(ee),this.u(this.protocol.getMillisSinceLastIncomingData(),z+1,!1);break}}while(!this.k&&!this.m)}u(k,P,z){this.r?Q.triggerPermanentFailure(k,P,z):this.v(k,P,z)}v(k,P,z){this.j.fire(new J(this.reconnectionToken,k,P,z)),W(this.protocol)}w(){this.protocol.pauseSocketWriting()}}e.$Sk=Q;class G extends Q{constructor(k,P,z,H,ee){super(1,k,H,ee,!0),this.client=this.B(new y.$bh(ee,{remoteAuthority:P,clientId:z},k.ipcLogger))}async y(k,P){await n(k,P)}}e.$Tk=G;class X extends Q{constructor(k,P,z,H,ee){super(2,k,z,H,!1),this.z=P,this.debugPort=ee}async y(k,P){await i(k,this.z,P)}}e.$Uk=X;function W(U){try{U.acceptDisconnect();const k=U.getSocket();U.dispose(),k.dispose()}catch(k){(0,A.$Y)(k)}}function q(U){if(U&&U.type==="error"){const k=new Error(`Connection error: ${U.reason}`);return k.code="VSCODE_CONNECTION_ERROR",k}return null}function B(U,k){for(;U.length<k;)U+=" ";return U}function _(U,k){return`[remote-connection][${B(c(U),13)}][${k.substr(0,5)}\u2026]`}function oe(U,k,P){return`${_(U,k)}[${P?"reconnect":"initial"}]`}function ae(U,k){return`${oe(k,U.reconnectionToken,!!U.reconnectionProtocol)}[${U.connectTo}]`}function Y(U){return`${Date.now()-U} ms`}}),define(ce[104],le([0,1,2,4]),function(ie,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hk=e.$Gk=void 0,e.$Gk=(0,N.$ph)("remoteSocketFactoryService");class O{constructor(){this.a={}}register(j,R){return this.a[j]??=[],this.a[j].push(R),(0,L.$jb)(()=>{const S=this.a[j]?.indexOf(R);typeof S=="number"&&S>=0&&this.a[j]?.splice(S,1)})}b(j){return(this.a[j.type]||[]).find(S=>S.supports(j))}connect(j,R,S,g){const C=this.b(j);if(!C)throw new Error(`No socket factory found for ${j}`);return C.connect(j,R,S,g)}}e.$Hk=O}),define(ce[212],le([0,1,4]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i7b=e.$h7b=void 0,e.$h7b=(0,L.$ph)("sharedProcessTunnelService"),e.$i7b="sharedProcessTunnel"}),define(ce[105],le([0,1,4,162]),function(ie,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s7b=e.$r7b=e.$q7b=e.$p7b=e.$o7b=e.TunnelStates=e.$n7b=e.$m7b=void 0,e.$m7b=(0,L.$ph)("IRemoteTunnelService"),e.$n7b={active:!1};var O;(function(A){A.disconnected=j=>({type:"disconnected",onTokenFailed:j}),A.connected=(j,R)=>({type:"connected",info:j,serviceInstallFailed:R}),A.connecting=j=>({type:"connecting",progress:j}),A.uninitialized={type:"uninitialized"}})(O||(e.TunnelStates=O={})),e.$o7b="remote.tunnels.access",e.$p7b=e.$o7b+".hostNameOverride",e.$q7b=e.$o7b+".preventSleep",e.$r7b="remoteTunnelService",e.$s7b=(0,N.localize)(0,null)}),define(ce[57],le([0,1,14,8,2,164,49,4,7,40]),function(ie,e,L,N,O,A,j,R,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=void 0,e.$Ao=(0,R.$ph)("requestService");class C{constructor(I){this.b=I}toJSON(){if(!this.a){const I=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?I[t]="*****":I[t]=this.b[t];this.a=I}return this.a}}class y extends O.$lb{constructor(I){super(),this.b=0,this.a=I.createLogger("network",{name:(0,A.localize)(0,null),when:S.$9i.isEqualTo((0,S.$7i)(S.LogLevel.Trace)).serialize()})}async c(I,t,o){const s=`${I} #${++this.b}: ${t.url}`;this.a.trace(`${s} - begin`,t.type,new C(t.headers??{}));try{const n=await o();return this.a.trace(`${s} - end`,t.type,n.res.statusCode,n.res.headers),n}catch(n){throw this.a.error(`${s} - error`,t.type,(0,N.$9)(n)),n}}}e.$Bo=y;function $(w){return w.res.statusCode&&w.res.statusCode>=200&&w.res.statusCode<300||w.res.statusCode===1223}e.$Co=$;function u(w){return w.res.statusCode===204}async function d(w){return u(w)?null:(await(0,L.$Qc)(w.stream)).toString()}e.$Do=d;async function p(w){if(!$(w))throw new Error("Server returned "+w.res.statusCode);return d(w)}e.$Eo=p;async function c(w){if(!$(w))throw new Error("Server returned "+w.res.statusCode);if(u(w))return null;const t=(await(0,L.$Qc)(w.stream)).toString();try{return JSON.parse(t)}catch(o){throw o.message+=`:
`+t,o}}e.$Fo=c;function h(w){b(w)}e.$Go=h;let f;function b(w){const I=g.$Um.as(j.$Zm.Configuration),t=f;f={id:"http",order:15,title:(0,A.localize)(1,null),type:"object",scope:w,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null),(0,A.localize)(9,null)],default:"override",description:(0,A.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11,null),restricted:!0}}},I.updateConfigurations({add:[f],remove:t?[t]:[]})}b(1)}),define(ce[213],le([0,1,25,26,13,57]),function(ie,e,L,N,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lN=void 0;let j=class{constructor(S,g){this.a=S,this.b=g}async download(S,g,C=L.CancellationToken.None){if(S.scheme===N.Schemas.file||S.scheme===N.Schemas.vscodeRemote){await this.b.copy(S,g);return}const y={type:"GET",url:S.toString(!0)},$=await this.a.request(y,C);if($.res.statusCode===200)await this.b.writeFile(g,$.stream);else{const u=await(0,A.$Eo)($);throw new Error(`Expected 200, got back ${$.res.statusCode} instead.

${u}`)}}};e.$lN=j,e.$lN=j=ye([K(0,A.$Ao),K(1,O.$Sj)],j)}),define(ce[214],le([0,1,14,25]),function(ie,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=e.$Cq=void 0;class O{constructor(R){this.a=R}listen(R,S){throw new Error("Invalid listen")}call(R,S,g,C=N.CancellationToken.None){switch(S){case"request":return this.a.request(g[0],C).then(async({res:y,stream:$})=>{const u=await(0,L.$Qc)($);return[{statusCode:y.statusCode,headers:y.headers},u]});case"resolveProxy":return this.a.resolveProxy(g[0])}throw new Error("Invalid call")}}e.$Cq=O;class A{constructor(R){this.a=R}async request(R,S){const[g,C]=await this.a.call("request",[R],S);return{res:g,stream:(0,L.$Sc)(C)}}async resolveProxy(R){return this.a.call("resolveProxy",[R])}}e.$Dq=A}),define(ce[215],le([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N5b=e.$M5b=e.$L5b=void 0,e.$L5b={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$M5b={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$N5b={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(ce[216],le([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M1b=void 0;class L{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(O){try{const A=await this.c();if(A){const j=String(L.a++);return this.b.set(j,A),{id:j,data:A.createNewMessage(O)}}}catch{}return{id:"",data:O}}async validate(O,A){if(!O.id)return!0;const j=this.b.get(O.id);if(!j)return!1;this.b.delete(O.id);try{return j.validate(A)==="ok"}catch{return!1}finally{j.dispose?.()}}async sign(O){try{return await this.d(O)}catch{}return O}}e.$M1b=L}),define(ce[106],le([0,1,4]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jk=e.$Ik=void 0,e.$Ik="signService",e.$Jk=(0,L.$ph)(e.$Ik)}),define(ce[217],le([0,1,216]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A6b=void 0;class N extends L.$M1b{c(){return this.h().then(A=>new A.validator)}d(A){return this.h().then(j=>new j.signer().sign(A))}h(){return new Promise((A,j)=>ie(["vsda"],A,j))}}e.$A6b=N}),define(ce[75],le([0,1,3,2]),function(ie,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dzb=e.$Czb=e.$Bzb=e.$Azb=void 0;class O extends N.$lb{constructor(y,$,u){super(),this.a=y,this.b=$,this.c=u}async getItems(){const y={profile:this.b,workspace:this.c},$=await this.a.call("getItems",y);return new Map($)}updateItems(y){const $={profile:this.b,workspace:this.c};return y.insert&&($.insert=Array.from(y.insert.entries())),y.delete&&($.delete=Array.from(y.delete.values())),this.a.call("updateItems",$)}}class A extends O{constructor(y,$){super(y,$,void 0),this.f=this.B(new L.$ec),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(y=>this.h(y)))}h(y){(Array.isArray(y.changed)||Array.isArray(y.deleted))&&this.f.fire({changed:y.changed?new Map(y.changed):void 0,deleted:y.deleted?new Set(y.deleted):void 0})}}class j extends A{constructor(y){super(y,void 0)}async close(){this.dispose()}}e.$Azb=j;class R extends A{constructor(y,$){super(y,$)}async close(){this.dispose()}}e.$Bzb=R;class S extends O{constructor(y,$){super(y,void 0,$),this.onDidChangeItemsExternal=L.Event.None}async close(){this.dispose()}}e.$Czb=S;class g{constructor(y){this.a=y}isUsed(y){const $={payload:y,profile:void 0,workspace:void 0};return this.a.call("isUsed",$)}}e.$Dzb=g}),define(ce[107],le([0,1,6,37,32]),function(ie,e,L,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3n=e.$2n=void 0;function A(S){if(L.$t===2&&/^penguin(\.|$)/i.test(S))return"chromebook"}function j(S,g,C,y,$,u,d,p){const c=Object.create(null);c["common.machineId"]=u,c.sessionID=(0,O.$3e)()+Date.now(),c.commitHash=y,c.version=$,c["common.platformVersion"]=(S||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,L.$h)(L.$t),c["common.nodePlatform"]=N.$2c,c["common.nodeArch"]=C,c["common.product"]=p||"desktop",d&&(c["common.msftInternal"]=d);let h=0;const f=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-f,enumerable:!0},"common.sequence":{get:()=>h++,enumerable:!0}}),L.$l&&(c["common.snap"]="true");const b=A(g);return b&&(c["common.platformDetail"]=b),c}e.$2n=j;function R(S){const g=N.env.USERDNSDOMAIN;if(!g)return!1;const C=g.toLowerCase();return S.some(y=>C===y)}e.$3n=R}),define(ce[21],le([0,1,4]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$5k=e.$4k=e.$3k=e.$2k=e.$1k=e.$Zk=e.$Yk=e.$Xk=e.$Wk=e.$Vk=void 0,e.$Vk=(0,L.$ph)("telemetryService"),e.$Wk=(0,L.$ph)("customEndpointTelemetryService"),e.$Xk="telemetry.currentSessionDate",e.$Yk="telemetry.firstSessionDate",e.$Zk="telemetry.lastSessionDate",e.$1k="telemetry.machineId",e.$2k="telemetry",e.$3k="telemetry.telemetryLevel",e.$4k="telemetry.enableCrashReporter",e.$5k="telemetry.enableTelemetry";var N;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(N||(e.TelemetryLevel=N={}));var O;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(O||(e.TelemetryConfiguration=O={}))}),define(ce[218],le([0,1,36,5,34,26,16,6,10,130,31,144,95,13,23,21]),function(ie,e,L,N,O,A,j,R,S,g,C,y,$,u,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=e.$mr=e.$lr=e.$kr=void 0;const c=new Map;async function h(t,o){const s=`${t}::${o.join(":")}`,n=c.get(s);if(n)return n;const i=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],r=new Map,a=new Map,v=2e4;function m(E,D,T,M){const F=D.substring(E.length+1);return N.Promises.withAsyncBody(async V=>{let Z;try{Z=await C.Promises.readdir(D,{withFileTypes:!0})}catch{V();return}if(M.count>=v){M.count+=Z.length,M.maxReached=!0,V();return}let J=Z.length;if(J===0){V();return}let Q=Z;M.count+Z.length>v&&(M.maxReached=!0,J=v-M.count,Q=Z.slice(0,J)),M.count+=Z.length;for(const G of Q)if(G.isDirectory()){if(T.includes(G.name)||await m(E,(0,j.$8c)(D,G.name),T,M),--J===0){V();return}}else{const X=G.name.lastIndexOf(".");if(X>=0){const W=G.name.substring(X+1);W&&r.set(W,(r.get(W)??0)+1)}for(const W of i)W.relativePathPattern?.test(F)!==!1&&W.filePattern.test(G.name)&&a.set(W.tag,(a.get(W.tag)??0)+1);if(--J===0){V();return}}})}const l=N.Promises.withAsyncBody(async E=>{const D={count:0,maxReached:!1};await m(t,t,o,D);const T=await w(t);E({configFiles:f(a),fileTypes:f(r),fileCount:D.count,maxFilesReached:D.maxReached,launchConfigFiles:T})});return c.set(s,l),l}e.$kr=h;function f(t){return Array.from(t.entries(),([o,s])=>({name:o,count:s})).sort((o,s)=>s.count-o.count)}function b(){const t={os:`${L.type()} ${L.arch()} ${L.release()}`,memory:`${(L.totalmem()/u.$nk.GB).toFixed(2)}GB (${(L.freemem()/u.$nk.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(g.$um.value()*100)}%`},o=L.cpus();return o&&o.length>0&&(t.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),t}e.$lr=b;async function w(t){try{const o=new Map,s=(0,j.$8c)(t,".vscode","launch.json"),n=await C.Promises.readFile(s),i=[],r=(0,O.$ym)(n.toString(),i);if(i.length)return console.log(`Unable to parse ${s}`),[];if((0,O.$Hm)(r)==="object"&&r.configurations)for(const a of r.configurations){const v=a.type;v&&(o.has(v)?o.set(v,o.get(v)+1):o.set(v,1))}return f(o)}catch{return[]}}e.$mr=w;let I=class{constructor(o,s){this.c=o,this.d=s}f(o){const s=[];return s.push(`OS Version:       ${o.os}`),s.push(`CPUs:             ${o.cpus}`),s.push(`Memory (System):  ${o.memory}`),s.push(`VM:               ${o.vmHint}`),s.join(`
`)}g(o){const s=[];s.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),s.push(`OS Version:       ${L.type()} ${L.arch()} ${L.release()}`);const n=L.cpus();return n&&n.length>0&&s.push(`CPUs:             ${n[0].model} (${n.length} x ${n[0].speed})`),s.push(`Memory (System):  ${(L.totalmem()/u.$nk.GB).toFixed(2)}GB (${(L.freemem()/u.$nk.GB).toFixed(2)}GB free)`),R.$i||s.push(`Load (avg):       ${L.loadavg().map(i=>Math.round(i)).join(", ")}`),s.push(`VM:               ${Math.round(g.$um.value()*100)}%`),s.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${o.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.j(o.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(o,s){return Promise.all([(0,y.$jr)(o.mainPID),this.k(o)]).then(async n=>{let[i,r]=n,a=this.m(o,i);return s.forEach(v=>{if((0,$.$7l)(v))a+=`
${v.errorMessage}`,r+=`
${v.errorMessage}`;else if(a+=`

Remote: ${v.hostName}`,v.processes&&(a+=`
${this.m(o,v.processes)}`),v.workspaceMetadata){r+=`
|  Remote: ${v.hostName}`;for(const m of Object.keys(v.workspaceMetadata)){const l=v.workspaceMetadata[m];let E=`${l.fileCount} files`;l.maxFilesReached&&(E=`more than ${E}`),r+=`|    Folder (${m}): ${E}`,r+=this.h(l)}}}),{processInfo:a,workspaceInfo:r}})}async getSystemInfo(o,s){const{memory:n,vmHint:i,os:r,cpus:a}=b(),v={os:r,memory:n,cpus:a,vmHint:i,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:s};return R.$i||(v.load=`${L.loadavg().map(m=>Math.round(m)).join(", ")}`),R.$k&&(v.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(v)}async getDiagnostics(o,s){const n=[];return(0,y.$jr)(o.mainPID).then(async i=>(n.push(""),n.push(this.g(o)),n.push(""),n.push(this.m(o,i)),o.windows.some(r=>r.folderURIs&&r.folderURIs.length>0&&!r.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.k(o))),s.forEach(r=>{if((0,$.$7l)(r))n.push(`
${r.errorMessage}`);else if(n.push(`

`),n.push(`Remote:           ${r.hostName}`),n.push(this.f(r.machineInfo)),r.processes&&n.push(this.m(o,r.processes)),r.workspaceMetadata)for(const a of Object.keys(r.workspaceMetadata)){const v=r.workspaceMetadata[a];let m=`${v.fileCount} files`;v.maxFilesReached&&(m=`more than ${m}`),n.push(`Folder (${a}): ${m}`),n.push(this.h(v))}}),n.push(""),n.push(""),n.join(`
`)))}h(o){const s=[];let i=0;const r=(l,E)=>{const D=` ${l}(${E})`;i+D.length>60?(s.push(a),a="|                 ",i=a.length):i+=D.length,a+=D};let a="|      File types:";const v=10,m=o.fileTypes.length>v?v:o.fileTypes.length;for(let l=0;l<m;l++){const E=o.fileTypes[l];r(E.name,E.count)}if(s.push(a),o.configFiles.length>=0&&(a="|      Conf files:",i=0,o.configFiles.forEach(l=>{r(l.name,l.count)}),s.push(a)),o.launchConfigFiles.length>0){let l="|      Launch Configs:";o.launchConfigFiles.forEach(E=>{const D=E.count>1?` ${E.name}(${E.count})`:` ${E.name}`;l+=D}),s.push(l)}return s.join(`
`)}j(o){const s=Math.max(...Object.keys(o).map(n=>n.length));return Object.keys(o).map(n=>`${n}:  ${" ".repeat(s-n.length)}  ${o[n]}`).join(`
                  `)}k(o){const s=[],n=[];return o.windows.forEach(i=>{i.folderURIs.length===0||i.remoteAuthority||(s.push(`|  Window (${i.title})`),i.folderURIs.forEach(r=>{const a=S.URI.revive(r);if(a.scheme===A.Schemas.file){const v=a.fsPath;n.push(h(v,["node_modules",".git"]).then(m=>{let l=`${m.fileCount} files`;m.maxFilesReached&&(l=`more than ${l}`),s.push(`|    Folder (${(0,j.$_c)(v)}): ${l}`),s.push(this.h(m))}).catch(m=>{s.push(`|      Error: Unable to collect workspace stats for folder ${v} (${m.toString()})`)}))}else s.push(`|    Folder (${a.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(i=>s.join(`
`)).catch(i=>`Unable to collect workspace stats: ${i}`)}m(o,s){const n=new Map;o.windows.forEach(r=>n.set(r.pid,`window [${r.id}] (${r.title})`)),o.pidToNames.forEach(({pid:r,name:a})=>n.set(r,a));const i=[];return i.push("CPU %	Mem MB	   PID	Process"),s&&this.n(o.mainPID,n,i,s,0),i.join(`
`)}n(o,s,n,i,r){const a=r===0;let v;a?v=i.pid===o?`${this.d.applicationName} main`:"remote agent":s.has(i.pid)?v=s.get(i.pid):v=`${"  ".repeat(r)} ${i.name}`;const m=process.platform==="win32"?i.mem:L.totalmem()*(i.mem/100);n.push(`${i.load.toFixed(0).padStart(5," ")}	${(m/u.$nk.MB).toFixed(0).padStart(6," ")}	${i.pid.toFixed(0).padStart(6," ")}	${v}`),Array.isArray(i.children)&&i.children.forEach(l=>this.n(o,s,n,l,r+1))}async getWorkspaceFileExtensions(o){const s=new Set;for(const{uri:n}of o.folders){const i=S.URI.revive(n);if(i.scheme!==A.Schemas.file)continue;const r=i.fsPath;try{(await h(r,["node_modules",".git"])).fileTypes.forEach(v=>s.add(v.name))}catch{}}return{extensions:[...s]}}async reportWorkspaceStats(o){for(const{uri:s}of o.folders){const n=S.URI.revive(s);if(n.scheme!==A.Schemas.file)continue;const i=n.fsPath;try{const r=await h(i,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),r.fileTypes.forEach(a=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),r.launchConfigFiles.forEach(a=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),r.configFiles.forEach(a=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})})}catch{}}}};e.$nr=I,e.$nr=I=ye([K(0,p.$Vk),K(1,d.$0i)],I)}),define(ce[108],le([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R5b=e.$Q5b=void 0;class L{constructor(A){this.b=A}listen(A,j){throw new Error(`Event not found: ${j}`)}call(A,j,{eventName:R,data:S}){return this.b.forEach(g=>g.log(R,S)),Promise.resolve(null)}}e.$Q5b=L;class N{constructor(A){this.b=A}log(A,j){return this.b.call("log",{eventName:A,data:j}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$R5b=N}),define(ce[46],le([0,1,30,11,3,18,74,107,21]),function(ie,e,L,N,O,A,j,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=void 0;class g{constructor(i){this.value=i,this.isTrustedTelemetryValue=!0}}e.$4n=g;class C{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$5n=C,e.$6n=new C;class y{async publicLog(i,r,a){}async publicLogError(i,r,a){}}e.$7n=y,e.$8n="telemetry",e.$9n="extensionTelemetryLog",e.$0n={log:()=>null,flush:()=>Promise.resolve(null)};function $(n,i){return O.Event.debounce(i.onDidChangeConfiguration,(a,v)=>{const m=a?new Set([...a.affectedKeys,...v.affectedKeys]):v.affectedKeys;return{...v,affectedKeys:m}},1e3,!0)(a=>{a.source!==7&&n.publicLog2("updateConfiguration",{configurationSource:(0,A.$Yh)(a.source),configurationKeys:Array.from(a.affectedKeys)})})}e.$$n=$;function u(n,i){return!i.isBuilt&&!i.disableTelemetry?!0:!(i.disableTelemetry||!n.enableTelemetry||i.extensionTestsLocationURI)}e.$_n=u;function d(n,i){return!(i.isBuilt||i.disableTelemetry||n.enableTelemetry&&n.aiConfig?.ariaKey)}e.$ao=d;function p(n){const i=n.getValue(S.$3k),r=n.getValue(S.$4k);if(n.getValue(S.$5k)===!1||r===!1)return 0;switch(i??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$bo=p;function c(n){const i={},r={},a={};b(n,a);for(let v in a){v=v.length>150?v.substr(v.length-149):v;const m=a[v];typeof m=="number"?r[v]=m:typeof m=="boolean"?r[v]=m?1:0:typeof m=="string"?(m.length>8192&&console.warn(`Telemetry property: ${v} has been trimmed to 8192, the original length is ${m.length}`),i[v]=m.substring(0,8191)):typeof m<"u"&&m!==null&&(i[v]=m)}return{properties:i,measurements:r}}e.$co=c;const h=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function f(n){if(!n)return"none";const i=(0,j.$Ck)(n);return h.has(i)?i:"other"}e.$do=f;function b(n,i,r=0,a){if(n)for(const v of Object.getOwnPropertyNames(n)){const m=n[v],l=a?a+v:v;Array.isArray(m)?i[l]=(0,L.$Nm)(m):m instanceof Date?i[l]=m.toISOString():(0,N.$ke)(m)?r<2?b(m,i,r+1,l+"."):i[l]=(0,L.$Nm)(m):i[l]=m}}function w(n,i){const r=n.msftInternalDomains||[],a=i.getValue("telemetry.internalTesting");return(0,R.$3n)(r)||a}e.$eo=w;function I(n){return[n.appRoot,n.extensionsPath,n.userHome.fsPath,n.tmpDir.fsPath,n.userDataPath]}e.$fo=I;function t(n,i){if(!n||!n.includes("/")&&!n.includes("\\"))return n;let r=n;const a=[];for(const E of i)for(;;){const D=E.exec(n);if(!D)break;a.push([D.index,E.lastIndex])}const v=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,m=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(r="";;){const E=m.exec(n);if(!E)break;const D=a.some(([T,M])=>E.index<M&&T<m.lastIndex);!v.test(E[0])&&!D&&(r+=n.substring(l,E.index)+"<REDACTED: user-file-path>",l=m.lastIndex)}return l<n.length&&(r+=n.substr(l)),r}function o(n){if(!n)return n;const i=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of i)if(r.regex.test(n))return`<REDACTED: ${r.label}>`;return n}function s(n,i){return(0,L.$Km)(n,r=>{if(r instanceof g||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let a=r.replaceAll("%20"," ");a=t(a,i);for(const v of i)a=a.replace(v,"");return a=o(a),a}})}e.$go=s}),define(ce[33],le([0,1,28,29,45,6,10,8,37,46]),function(ie,e,L,N,O,A,j,R,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=void 0;function C(s,n){return s.uuid&&n.uuid?s.uuid===n.uuid:s.id===n.id?!0:(0,L.$Gd)(s.id,n.id)===0}e.$ho=C;const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class ${static create(n){const i=n.manifest?n.manifest.version:n.version,r=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new $(n.identifier,i,r)}static parse(n){const i=y.exec(n);return i&&i[1]&&i[2]?new $({id:i[1]},i[2],i[4]||void 0):null}constructor(n,i,r="undefined"){this.version=i,this.targetPlatform=r,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof $?C(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.$io=$;const u=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function d(s){const n=u.exec(s);return n&&n[1]?[c(n[1]),n[2]]:[c(s),void 0]}e.$jo=d;function p(s,n){return`${s}.${n}`}e.$ko=p;function c(s){return s.toLowerCase()}e.$lo=c;function h(s,n){return c(p(s??O.$El,n))}e.$mo=h;function f(s,n){const i=[],r=a=>{for(const v of i)if(v.some(m=>C(n(m),n(a))))return v;return null};for(const a of s){const v=r(a);v?v.push(a):i.push([a])}return i}e.$no=f;function b(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.$oo=b;function w(s){return{id:new g.$4n(s.identifier.id),name:new g.$4n(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.$po=w,e.$qo=new O.$Il("pprice.better-merge");function I(s,n){const i=[],r=n.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const a=r.shift();if(a&&i.every(v=>!C(v.identifier,{id:a}))){const v=s.filter(m=>C(m.identifier,{id:a}));v.length===1&&(i.push(v[0]),r.push(...v[0].manifest.extensionDependencies?.slice(0)??[]))}}return i}e.$ro=I;async function t(s,n){if(!A.$k)return!1;let i;try{i=(await s.readFile(j.URI.file("/etc/os-release"))).value.toString()}catch{try{i=(await s.readFile(j.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){n.debug("Error while getting the os-release file.",(0,R.$9)(a))}}return!!i&&(i.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(s,n){const i=await t(s,n),r=(0,N.$Mn)(i?"alpine":A.$t,S.$3c);return n.debug("ComputeTargetPlatform:",r),r}e.$so=o}),define(ce[219],le([0,1,20,2,22,10,13,23,5,3,16,6,37,33]),function(ie,e,L,N,O,A,j,R,S,g,C,y,$,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T3b=e.$S3b=void 0;let d=class extends N.$lb{constructor(b,w){super(),this.b=b,this.c=w,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,I])=>this.a.set(I.configPath,I))}getConfigBasedTips(b){return this.f(b)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(b){const w=[];for(const[I,t]of this.a)if(!(t.configScheme&&t.configScheme!==b.scheme))try{const o=(await this.b.readFile((0,O.$9f)(b,I))).value.toString();for(const[s,n]of Object.entries(t.recommendations))(!n.contentPattern||new RegExp(n.contentPattern,"mig").test(o))&&w.push({extensionId:s,extensionName:n.name,configName:t.configName,important:!!n.important,isExtensionPack:!!n.isExtensionPack,whenNotInstalled:n.whenNotInstalled})}catch{}return w}};e.$S3b=d,e.$S3b=d=ye([K(0,j.$Sj),K(1,R.$0i)],d);const p="extensionTips/promptedExecutableTips",c="extensionTips/lastPromptedMediumImpExeTime";class h extends d{constructor(b,w,I,t,o,s,n,i){super(n,i),this.m=b,this.n=w,this.r=I,this.s=t,this.t=o,this.u=s,this.g=new Map,this.h=new Map,this.j=new Map,this.k=new Map,this.l=new Map,i.exeBasedExtensionTips&&Object.entries(i.exeBasedExtensionTips).forEach(([r,a])=>{const v=[],m=[],l=[];Object.entries(a.recommendations).forEach(([E,D])=>{D.important?a.important?v.push({extensionId:E,extensionName:D.name,isExtensionPack:!!D.isExtensionPack}):m.push({extensionId:E,extensionName:D.name,isExtensionPack:!!D.isExtensionPack}):l.push({extensionId:E,extensionName:D.name,isExtensionPack:!!D.isExtensionPack})}),v.length&&this.g.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:v}),m.length&&this.h.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:m}),l.length&&this.j.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:l})}),(0,S.$vg)(3e3).then(async()=>{await this.v(),this.z(),this.C()})}async getImportantExecutableBasedTips(){const b=await this.L(this.g),w=await this.L(this.h);return[...b,...w]}getOtherExecutableBasedTips(){return this.L(this.j)}async v(){const b=await this.L(this.g),w=await this.L(this.h),I=await this.s.getInstalled();this.k=this.w(b,I),this.l=this.w(w,I)}w(b,w){const I=new Map;b.forEach(i=>I.set(i.extensionId.toLowerCase(),i));const{installed:t,uninstalled:o}=this.J([...I.keys()],w);for(const i of t){const r=I.get(i);r&&this.r.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:i,exeName:r.exeName})}for(const i of o){const r=I.get(i);r&&this.r.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:i,exeName:r.exeName})}const s=this.H(),n=new Map;for(const i of o){const r=I.get(i);if(r&&(!s[r.exeName]||!s[r.exeName].includes(r.extensionId))){let a=n.get(r.exeName);a||(a=[],n.set(r.exeName,a)),a.push(r)}}return n}z(){if(this.k.size===0)return;const[b,w]=[...this.k.entries()][0];this.D(w).then(I=>{switch(I){case"reacted":this.I(w[0].exeName,w);break;case"ignored":this.k.delete(b);break;case"incompatibleWindow":{const t=g.Event.once(g.Event.latch(g.Event.any(this.n.onDidOpenWindow,this.n.onDidFocusWindow)));this.B(t(()=>this.z()));break}case"toomany":{const t=this.B((0,S.$wg)(()=>{t.dispose(),this.z()},36e5));break}}})}C(){if(this.l.size===0)return;const b=this.F(),w=Date.now()-b,I=7*24*60*60*1e3;if(w<I){const s=this.B((0,S.$wg)(()=>{s.dispose(),this.C()},I-w));return}const[t,o]=[...this.l.entries()][0];this.D(o).then(s=>{switch(s){case"reacted":{this.G(Date.now()),this.l.delete(t),this.I(o[0].exeName,o);const n=this.B((0,S.$wg)(()=>{n.dispose(),this.C()},I));break}case"ignored":this.l.delete(t),this.C();break;case"incompatibleWindow":{const n=g.Event.once(g.Event.latch(g.Event.any(this.n.onDidOpenWindow,this.n.onDidFocusWindow)));this.B(n(()=>this.C()));break}case"toomany":{const n=this.B((0,S.$wg)(()=>{n.dispose(),this.C()},36e5));break}}})}async D(b){const w=await this.s.getInstalled(1),I=b.filter(t=>!t.whenNotInstalled||t.whenNotInstalled.every(o=>w.every(s=>!(0,u.$ho)(s.identifier,{id:o})))).map(({extensionId:t})=>t.toLowerCase());return this.u.promptImportantExtensionsInstallNotification({extensions:I,source:3,name:b[0].exeFriendlyName,searchValue:`@exe:"${b[0].exeName}"`})}F(){let b=this.t.getNumber(c,-1);return b||(b=Date.now(),this.G(b)),b}G(b){this.t.store(c,b,-1,1)}H(){return JSON.parse(this.t.get(p,-1,"{}"))}I(b,w){const I=this.H();I[b]=w.map(({extensionId:t})=>t.toLowerCase()),this.t.store(p,JSON.stringify(I),-1,0)}J(b,w){const I=[],t=[],o=w.reduce((s,n)=>(s.add(n.identifier.id.toLowerCase()),s),new Set);return b.forEach(s=>{o.has(s.toLowerCase())?I.push(s):t.push(s)}),{installed:I,uninstalled:t}}async L(b){const w=[],I=new Map;for(const t of b.keys()){const o=b.get(t);if(!o||!(0,L.$nf)(o.recommendations))continue;const s=[];y.$i?o.windowsPath&&s.push(o.windowsPath.replace("%USERPROFILE%",()=>$.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>$.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>$.env.ProgramFiles).replace("%APPDATA%",()=>$.env.APPDATA).replace("%WINDIR%",()=>$.env.WINDIR)):(s.push((0,C.$8c)("/usr/local/bin",t)),s.push((0,C.$8c)("/usr/bin",t)),s.push((0,C.$8c)(this.m.fsPath,t)));for(const n of s){let i=I.get(n);if(i===void 0&&(i=await this.b.exists(A.URI.file(n)),I.set(n,i)),i)for(const{extensionId:r,extensionName:a,isExtensionPack:v,whenNotInstalled:m}of o.recommendations)w.push({extensionId:r,extensionName:a,isExtensionPack:v,exeName:t,exeFriendlyName:o.exeFriendlyName,windowsPath:o.windowsPath,whenNotInstalled:m})}}return w}}e.$T3b=h}),define(ce[220],le([0,1,25,33]),function(ie,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fUb=void 0;async function O(A,j,R,S,g){try{const C=await A.getExtensionsControlManifest();if(!C.deprecated)return;const y=await A.getInstalled(1);for(const[$,u]of Object.entries(C.deprecated)){if(!u?.extension)continue;const{id:d,autoMigrate:p,preRelease:c}=u.extension;if(!p)continue;const h=y.find(b=>(0,N.$ho)(b.identifier,{id:$}));if(!h)continue;const f=(await j.getExtensions([{id:d,preRelease:c}],{targetPlatform:await A.getTargetPlatform(),compatible:!0},L.CancellationToken.None))[0];if(!f){g.info(`Skipping migrating '${h.identifier.id}' extension because, the comaptible target '${d}' extension is not found`);continue}try{g.info(`Migrating '${h.identifier.id}' extension to '${d}' extension...`);const b=!S.getDisabledExtensions().some(I=>(0,N.$ho)(I,h.identifier));await A.uninstall(h),g.info(`Uninstalled the unsupported extension '${h.identifier.id}'`);let w=y.find(I=>(0,N.$ho)(I.identifier,{id:d}));(!w||!w.isPreReleaseVersion&&b)&&(w=await A.installFromGallery(f,{installPreReleaseVersion:!0,isMachineScoped:h.isMachineScoped,operation:4}),g.info(`Installed the pre-release extension '${w.identifier.id}'`),b||(await S.disableExtension(w.identifier),g.info(`Disabled the pre-release extension '${w.identifier.id}' because the unsupported extension '${h.identifier.id}' is disabled`)),p.storage&&(R.addToMigrationList((0,N.$ko)(h.manifest.publisher,h.manifest.name),(0,N.$ko)(w.manifest.publisher,w.manifest.name)),g.info("Added pre-release extension to the storage migration list"))),g.info(`Migrated '${h.identifier.id}' extension to '${d}' extension.`)}catch(b){g.error(b)}}}catch(C){g.error(C)}}e.$fUb=O}),define(ce[221],le([0,1,3,2,35,33,45]),function(ie,e,L,N,O,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$op=void 0;class R extends N.$lb{constructor(g,C,y,$,u,d,p){super(),this.f=g,this.g=C,this.h=y,this.i=$,this.j=u,this.k=d,this.l=p,this.a=this.B(new L.$ec),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new N.$tb),this.m().then(null,c=>p.error(c))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles),this.n(),await this.z()}n(){this.B(this.h.onDidChangeProfiles(g=>this.p(g.added))),this.B(this.i.onAddExtensions(g=>this.r(g))),this.B(this.i.onDidAddExtensions(g=>this.s(g))),this.B(this.i.onRemoveExtensions(g=>this.t(g))),this.B(this.i.onDidRemoveExtensions(g=>this.u(g))),this.B(this.k.onDidFilesChange(g=>this.v(g)))}async p(g){try{g.length&&await Promise.all(g.map(C=>(this.c.set(C.id,(0,N.$ib)(this.k.watch(this.j.extUri.dirname(C.extensionsResource)),this.k.watch(C.extensionsResource))),this.y(C.extensionsResource))))}catch(C){throw this.l.error(C),C}}async r(g){for(const C of g.extensions)this.C(this.F(C.identifier,C.version),g.profileLocation)}async s(g){for(const C of g.extensions){const y=this.F(C.identifier,C.version);g.error?this.D(y,g.profileLocation):this.C(y,g.profileLocation)}}async t(g){for(const C of g.extensions)this.D(this.F(C.identifier,C.version),g.profileLocation)}async u(g){const C=[],y=[];for(const $ of g.extensions){const u=this.F($.identifier,$.version);g.error?this.C(u,g.profileLocation):(this.D(u,g.profileLocation),this.b.has(u)||(this.l.debug("Extension is removed from all profiles",$.identifier.id,$.version),y.push(this.f.scanInstalledExtensionAtLocation($.location).then(d=>{d?C.push(d):this.l.info("Extension not found at the location",$.location.toString())},d=>this.l.error(d)))))}try{await Promise.all(y),C.length&&await this.z(C)}catch($){this.l.error($)}}v(g){for(const C of this.h.profiles)g.contains(C.extensionsResource,0,1)&&this.w(C.extensionsResource)}async w(g){const C=[],y=[],$=await this.i.scanProfileExtensions(g),u=new Set,d=new Set;for(const[p,c]of this.b)c.has(g)&&d.add(p);for(const p of $){const c=this.F(p.identifier,p.version);u.add(c),d.has(c)||(C.push(p.identifier),this.C(c,g))}for(const p of d)if(!u.has(p)){const c=this.G(p);c&&(y.push(c.identifier),this.D(p,g))}(C.length||y.length)&&this.a.fire({added:C.length?{extensions:C,profileLocation:g}:void 0,removed:y.length?{extensions:y,profileLocation:g}:void 0})}async y(g){const C=await this.i.scanProfileExtensions(g);for(const y of C)this.C(this.F(y.identifier,y.version),g)}async z(g){g||(g=(await this.f.scanAllUserInstalledExtensions()).filter(y=>!this.b.has(this.F(y.identifier,y.manifest.version)))),g.length&&await this.f.markAsUninstalled(...g)}C(g,C){let y=this.b.get(g);y||this.b.set(g,y=new O.$oi($=>this.j.extUri.getComparisonKey($))),y.add(C)}D(g,C){const y=this.b.get(g);y&&y.delete(C),y?.size||this.b.delete(g)}F(g,C){return`${j.$Il.toKey(g.id)}@${C}`}G(g){const[C,y]=(0,A.$jo)(g);return y?{identifier:{id:C},version:y}:void 0}}e.$op=R}),define(ce[222],le([0,1,44,46]),function(ie,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$To=void 0;async function O(A,j,R,S,g,C,y){const $={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${j.nameShort})`};if((0,N.$_n)(j,R)&&(0,N.$bo)(S)===3){const u=await(0,L.$So)(R,g,C);$["X-Market-User-Id"]=u,$["VSCode-SessionId"]=y.machineId||u}return $}e.$To=O}),define(ce[223],le([0,1,69,20,5,2,26,16,31,15,29,33,7,72,10]),function(ie,e,L,N,O,A,j,R,S,g,C,y,$,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=void 0;let p=class extends u.$Aq{constructor(b,w,I,t){super(I),this.h=b,this.i=t,this.g=this.B(new c(w,t)),this.h.registerParticipant({postInstall:async o=>this.j(o),postUninstall:async o=>this.k(o)})}async getBuiltInExtensionTranslationsUri(b,w){const t=(await this.g.getLanguagePacks())[w];if(!t){this.i.warn(`No language pack found for ${w}`);return}const o=t.translations[b];return o?d.URI.file(o):void 0}async getInstalledLanguages(){const b=await this.g.getLanguagePacks(),w=Object.keys(b).map(I=>{const t=b[I];return{...this.f(I,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return w.push(this.f("en","English")),w.sort((I,t)=>I.label.localeCompare(t.label)),w}async j(b){b&&b.manifest&&b.manifest.contributes&&b.manifest.contributes.localizations&&b.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",b.identifier.id),await this.update())}async k(b){const w=await this.g.getLanguagePacks();Object.keys(w).some(I=>w[I]&&w[I].extensions.some(t=>(0,y.$ho)(t.extensionIdentifier,b.identifier)))&&(this.i.info("Removing language packs from the extension",b.identifier.id),await this.update())}async update(){const[b,w]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),I=await this.g.update(w);return!(0,N.$$e)(Object.keys(b),Object.keys(I))}};e.$Bq=p,e.$Bq=p=ye([K(0,C.$Tn),K(1,g.$xh),K(2,C.$Rn),K(3,$.$Ri)],p);let c=class extends A.$lb{constructor(b,w){super(),this.i=w,this.c={},this.f=(0,R.$8c)(b.userDataPath,"languagepacks.json"),this.g=new O.$Bg}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(b){return this.m(w=>{Object.keys(w).forEach(I=>delete w[I]),this.j(w,...b)}).then(()=>this.c)}j(b,...w){for(const I of w)I&&I.manifest&&I.manifest.contributes&&I.manifest.contributes.localizations&&I.manifest.contributes.localizations.length&&this.k(b,I);Object.keys(b).forEach(I=>this.l(b[I]))}k(b,w){const I=w.identifier,t=w.manifest.contributes&&w.manifest.contributes.localizations?w.manifest.contributes.localizations:[];for(const o of t)if(w.location.scheme===j.Schemas.file&&h(o)){let s=b[o.languageId];s||(s={hash:"",extensions:[],translations:{},label:o.localizedLanguageName??o.languageName},b[o.languageId]=s);const n=s.extensions.filter(i=>(0,y.$ho)(i.extensionIdentifier,I))[0];n?n.version=w.manifest.version:s.extensions.push({extensionIdentifier:I,version:w.manifest.version});for(const i of o.translations)s.translations[i.id]=(0,R.$8c)(w.location.fsPath,i.path)}}l(b){if(b){const w=(0,L.createHash)("md5");for(const I of b.extensions)w.update(I.extensionIdentifier.uuid||I.extensionIdentifier.id).update(I.version);b.hash=w.digest("hex")}}m(b=()=>null){return this.g.queue(()=>{let w=null;return S.Promises.readFile(this.f,"utf8").then(void 0,I=>I.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(I)).then(I=>{try{return JSON.parse(I)}catch{return{}}}).then(I=>(w=b(I),I)).then(I=>{for(const o of Object.keys(I))I[o]||delete I[o];this.c=I,this.h=!0;const t=JSON.stringify(this.c);return this.i.debug("Writing language packs",t),S.Promises.writeFile(this.f,t)}).then(()=>w,I=>this.i.error(I))})}};c=ye([K(0,g.$xh),K(1,$.$Ri)],c);function h(f){if(typeof f.languageId!="string"||!Array.isArray(f.translations)||f.translations.length===0)return!1;for(const b of f.translations)if(typeof b.id!="string"||typeof b.path!="string")return!1;return!(f.languageName&&typeof f.languageName!="string"||f.localizedLanguageName&&typeof f.localizedLanguageName!="string")}}),define(ce[224],le([0,1,141,8,30,46]),function(ie,e,L,N,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VM=void 0;const j="https://mobile.events.data.microsoft.com/OneCollector/1.0",R="https://mobile.events.data.microsoft.com/ping";async function S(C,y,$){const u=await(0,L.$2C)("@microsoft/1ds-core-js","dist/ms.core.js"),d=await(0,L.$2C)("@microsoft/1ds-post-js","dist/ms.post.js"),p=new u.AppInsightsCore,c=new d.PostChannel,h={instrumentationKey:C,endpointUrl:j,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[c]]};if($){h.extensionConfig={};const f={alwaysUseXhrOverride:!0,httpXHROverride:$};h.extensionConfig[c.identifier]=f}return p.initialize(h,[]),p.addTelemetryInitializer(f=>{y&&(f.ext=f.ext??{},f.ext.utc=f.ext.utc??{},f.ext.utc.flags=8462029)}),p}class g{constructor(y,$,u,d,p){this.e=y,this.f=$,this.g=u,this.h=p,this.c=j,this.d=R,this.g||(this.g={}),typeof d=="function"?this.a=d():this.a=d,this.b=null}i(y){if(this.a){if(typeof this.a!="string"){y(this.a);return}this.b||(this.b=S(this.a,this.e,this.h)),this.b.then($=>{y($)},$=>{(0,N.$Y)($),console.error($)})}}log(y,$){if(!this.a)return;$=(0,O.$Lm)($,this.g),$=(0,A.$co)($);const u=this.f+"/"+y;try{this.i(d=>{d.pluginVersionString=$?.properties.version??"Unknown",d.track({name:u,baseData:{name:u,properties:$?.properties,measurements:$?.measurements}})})}catch{}}flush(){return this.a?new Promise(y=>{this.i($=>{$.unload(!0,()=>{this.a=void 0,y(void 0)})})}):Promise.resolve(void 0)}}e.$VM=g}),define(ce[109],le([0,1,2,165,15,7,23,46]),function(ie,e,L,N,O,A,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h3b=void 0;let S=class extends L.$lb{constructor(C,y,$,u,d=""){super(),this.b=d;const p=y.getLogger(R.$8n);if(p)this.a=this.B(p);else{const h=(0,R.$ao)(u,$)?" (Not Sent)":"",f=()=>(0,R.$_n)(u,$)&&C.getLevel()===A.LogLevel.Trace;this.a=this.B(y.createLogger(R.$8n,{name:(0,N.localize)(0,null,h),hidden:!f()})),this.B(C.onDidChangeLogLevel(()=>y.setVisibility(R.$8n,f()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(C,y){this.a.trace(`${this.b}telemetry/${C}`,(0,R.$co)(y))}};e.$h3b=S,e.$h3b=S=ye([K(0,A.$Ri),K(1,A.$Si),K(2,O.$wh),K(3,j.$0i)],S)}),define(ce[110],le([0,1,2,30,6,28,166,18,49,102,23,40,21,46]),function(ie,e,L,N,O,A,j,R,S,g,C,y,$,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=void 0;let d=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(h,f,b){this.k=f,this.l=b,this.d={},this.i=new L.$kb,this.j=[],this.b=h.appenders,this.c=h.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=h.piiPaths||[],this.g=3,this.h=!!h.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const w of this.f)this.j.push(new RegExp((0,A.$pd)(w),"gi")),w.indexOf("\\")>=0&&this.j.push(new RegExp((0,A.$pd)(w.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(w=>{(w.affectsConfiguration($.$3k)||w.affectsConfiguration($.$5k)||w.affectsConfiguration($.$4k))&&this.m()}))}setExperimentProperty(h,f){this.d[h]=f}m(){let h=(0,u.$bo)(this.k);const f=this.l.enabledTelemetryLevels;if(f){this.h=this.sendErrorTelemetry?f.error:!1;const b=f.usage?3:f.error?2:0;h=Math.min(h,b)}this.g=h}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(h,f,b){this.g<f||(b=(0,N.$Lm)(b,this.d),b=(0,u.$go)(b,this.j),b=(0,N.$Lm)(b,this.c),this.b.forEach(w=>w.log(h,b)))}publicLog(h,f){this.n(h,3,f)}publicLog2(h,f){this.publicLog(h,f)}publicLogError(h,f){this.h&&this.n(h,2,f)}publicLogError2(h,f){this.publicLogError(h,f)}};e.$Hq=d,e.$Hq=d=ye([K(1,R.$Vh),K(2,C.$0i)],d);function p(){const c=(0,j.localize)(0,null,g.default.nameLong),h=g.default.privacyStatementUrl?(0,j.localize)(2,null,"https://aka.ms/vscode-telemetry",g.default.privacyStatementUrl):(0,j.localize)(1,null,"https://aka.ms/vscode-telemetry"),f=O.$o?"":(0,j.localize)(3,null),b=(0,j.localize)(4,null),w=(0,j.localize)(5,null),I=(0,j.localize)(6,null),t=(0,j.localize)(7,null),o=`
|       | ${b} | ${w} | ${I} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,s=(0,j.localize)(8,null);return`
${c} ${h} ${f}

&nbsp;

${t}
${o}

&nbsp;

${s}
`}y.$Um.as(S.$Zm.Configuration).registerConfiguration({id:$.$2k,order:1,type:"object",title:(0,j.localize)(9,null),properties:{[$.$3k]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,j.localize)(10,null),(0,j.localize)(11,null),(0,j.localize)(12,null),(0,j.localize)(13,null)],markdownDescription:p(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),y.$Um.as(S.$Zm.Configuration).registerConfiguration({id:$.$2k,order:110,type:"object",title:(0,j.localize)(14,null),properties:{[$.$5k]:{type:"boolean",markdownDescription:g.default.privacyStatementUrl?(0,j.localize)(16,null,g.default.nameLong,g.default.privacyStatementUrl):(0,j.localize)(15,null,g.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,j.localize)(17,null,`\`#${$.$3k}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ce[225],le([0,1,14,25,270,224]),function(ie,e,L,N,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WM=void 0;async function j(C,y){const $=await y.request(C,N.CancellationToken.None),u=(await(0,L.$Qc)($.stream)).toString(),d=$.res.statusCode??200;return{headers:$.res.headers,statusCode:d,responseData:u}}async function R(C){const y={method:C.type,headers:C.headers};return new Promise((u,d)=>{const p=O.request(C.url??"",y,c=>{c.on("data",function(h){u({headers:c.headers,statusCode:c.statusCode??200,responseData:h.toString()})}),c.on("error",function(h){d(h)})});p.write(C.data,c=>{c&&d(c)}),p.end()})}async function S(C,y,$){const u=typeof y.data=="string"?y.data:new TextDecoder().decode(y.data),d={type:"POST",headers:{...y.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(y.data).toString()},url:y.urlString,data:u};try{const p=C?await j(d,C):await R(d);$(p.statusCode,p.headers,p.responseData)}catch{$(0,{})}}class g extends A.$VM{constructor(y,$,u,d,p){const c={sendPOST:(h,f)=>{S(y,h,f)}};super($,u,d,p,c)}}e.$WM=g}),define(ce[226],le([0,1,26,93,18,15,7,23,21,108,109,110]),function(ie,e,L,N,O,A,j,R,S,g,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$96b=void 0;let $=class{constructor(d,p,c,h,f,b){this.b=d,this.c=p,this.d=c,this.e=h,this.f=f,this.g=b,this.a=new Map}h(d){if(!this.a.has(d.id)){const p=Object.create(null);p["common.vscodemachineid"]=this.c.machineId,p["common.vscodesessionid"]=this.c.sessionId;const c=[d.id,JSON.stringify(p),d.aiKey],f=new N.$Jp(L.$1e.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:c,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),b=[new g.$R5b(f),new C.$h3b(this.d,this.e,this.f,this.g,`[${d.id}] `)];this.a.set(d.id,new y.$Hq({appenders:b,sendErrorTelemetry:d.sendErrorTelemetry},this.b,this.g))}return this.a.get(d.id)}publicLog(d,p,c){this.h(d).publicLog(p,c)}publicLogError(d,p,c){this.h(d).publicLogError(p,c)}};e.$96b=$,e.$96b=$=ye([K(0,O.$Vh),K(1,S.$Vk),K(2,j.$Ri),K(3,j.$Si),K(4,A.$wh),K(5,R.$0i)],$)}),define(ce[76],le([0,1,3,18,4,7]),function(ie,e,L,N,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vz=e.$Uz=e.$Tz=e.$Sz=e.$Rz=e.$Qz=e.$Pz=e.$Oz=e.ProvidedOnAutoForward=e.$Nz=e.TunnelPrivacyId=e.TunnelProtocol=e.$Mz=e.$Lz=void 0,e.$Lz=(0,O.$ph)("tunnelService"),e.$Mz=(0,O.$ph)("sharedTunnelsService");var j;(function(c){c.Http="http",c.Https="https"})(j||(e.TunnelProtocol=j={}));var R;(function(c){c.ConstantPrivate="constantPrivate",c.Private="private",c.Public="public"})(R||(e.TunnelPrivacyId=R={}));function S(c){return!!c.forwardPort}e.$Nz=S;var g;(function(c){c[c.Notify=1]="Notify",c[c.OpenBrowser=2]="OpenBrowser",c[c.OpenPreview=3]="OpenPreview",c[c.Silent=4]="Silent",c[c.Ignore=5]="Ignore",c[c.OpenBrowserOnce=6]="OpenBrowserOnce"})(g||(e.ProvidedOnAutoForward=g={}));function C(c){if(c.scheme!=="http"&&c.scheme!=="https")return;const h=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(c.authority);if(h)return{address:h[1],port:+h[2]}}e.$Oz=C,e.$Pz=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function y(c){return e.$Pz.indexOf(c)>=0}e.$Qz=y,e.$Rz=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function $(c){return e.$Rz.indexOf(c)>=0}e.$Sz=$;function u(c,h,f,b){if(f===1)return!1;if(f===2&&$(h)){const w=/(\d+)\.(\d+)\.(\d+)/g.exec(b);if(w?.length===4&&parseInt(w[1])>=18)return!1}return c<1024}e.$Tz=u;class d{constructor(h,f,b){this.remoteAddress=h,this.localAddress=f,this.b=b,this.a=new L.$ec,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Uz=d;let p=class{constructor(h,f){this.j=h,this.k=f,this.a=new L.$ec,this.onTunnelOpened=this.a.event,this.b=new L.$ec,this.onTunnelClosed=this.b.event,this.c=new L.$ec,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const h=this.k.getValue("remote.localPortHost");return!h||h==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(h){return this.f=h,h?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(h){this.g=h.elevation,this.h=h.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const h=[],f=Array.from(this.e.values());for(const b of f){const w=Array.from(b.values());for(const I of w){const t=await I.value;t&&typeof t!="string"&&h.push(t)}}return h}async dispose(){for(const h of this.e.values()){for(const{value:f}of h.values())await f.then(b=>typeof b!="string"?b?.dispose():void 0);h.clear()}this.e.clear()}setEnvironmentTunnel(h,f,b,w,I){this.p(h,f,Promise.resolve({tunnelRemoteHost:h,tunnelRemotePort:f,localAddress:b,privacy:w,protocol:I,dispose:()=>Promise.resolve()}))}async getExistingTunnel(h,f){($(h)||y(h))&&(h=e.$Pz[0]);const b=this.r(h,f);if(b)return++b.refcount,b.value}openTunnel(h,f,b,w,I,t=!1,o,s){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${f}:${b} on local port ${I}.`);const n=this.f??h;if(!n)return;if(f||(f="localhost"),w||(w=this.l),this.f&&this.i.has(b)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const i=this.s(n,f,b,w,I,t,o,s);return i?i.then(r=>{if(r){if(typeof r=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(f,b),r}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(f,b);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const a=this.n(r);return(r.tunnelRemoteHost!==f||r.tunnelRemotePort!==b)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),o&&r.privacy!==o&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(a),a}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),i)}n(h){return{tunnelRemotePort:h.tunnelRemotePort,tunnelRemoteHost:h.tunnelRemoteHost,tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress,privacy:h.privacy,protocol:h.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${h.tunnelRemoteHost}:${h.tunnelRemotePort} `);const f=this.e.get(h.tunnelRemoteHost);if(f){const b=f.get(h.tunnelRemotePort);b&&(b.refcount--,await this.o(h.tunnelRemoteHost,h.tunnelRemotePort,b))}}}}async o(h,f,b){if(b.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${h}:${f}.`);const w=b.value.then(async I=>{I&&typeof I!="string"&&(await I.dispose(!0),this.b.fire({host:I.tunnelRemoteHost,port:I.tunnelRemotePort}))});return this.e.has(h)&&this.e.get(h).delete(f),w}}async closeTunnel(h,f){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${h}:${f} `);const b=this.e.get(h);if(b&&b.has(f)){const w=b.get(f);w.refcount=0,await this.o(h,f,w)}}p(h,f,b){this.e.has(h)||this.e.set(h,new Map),this.e.get(h).set(f,{refcount:1,value:b})}async q(h,f){const b=this.e.get(h);if(b){const w=b.get(f),I=w?await w.value:void 0;(!I||typeof I=="string")&&b.delete(f),b.size===0&&this.e.delete(h)}}r(h,f){const b=[h];y(h)?(b.push(...e.$Pz),b.push(...e.$Rz)):$(h)&&b.push(...e.$Rz);const w=b.map(I=>this.e.get(I));for(const I of w){const t=I?.get(f);if(t)return t}}canTunnel(h){return!!C(h)}t(h,f,b,w,I,t,o){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${f}:${b} on local port ${w}.`);const s=b;this.i.add(s);const n=w===void 0?b:w,i={elevationRequired:I?this.isPortPrivileged(n):!1},r={remoteAddress:{host:f,port:b},localAddressPort:w,privacy:t,public:t?t!==R.Private:void 0,protocol:o},a=h.forwardPort(r,i);return a?(this.p(f,b,a),a.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(s)})):this.i.delete(s),a}};e.$Vz=p,e.$Vz=p=ye([K(0,A.$Ri),K(1,N.$Vh)],p)}),define(ce[227],le([0,1,7,76,2,8,5]),function(ie,e,L,N,O,A,j){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$j7b=void 0;class S extends O.$lb{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new j.$Pg),this.b.p)}setAddress(y){this.a=y,this.b&&(this.b.complete(y),this.b=null)}setTunnel(y){this.B(y)}}let g=class extends O.$lb{static{R=this}static{this.a=0}constructor(y,$){super(),this.f=y,this.g=$,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(y=>y.dispose())}async createTunnel(){return{id:String(++R.a)}}async startTunnel(y,$,u,d,p,c,h){const f=new S,b=await Promise.resolve(this.f.openTunnel(y,f,u,d,p,c,h));if(!b||typeof b=="string")throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${u}:${d} (remote).`),f.dispose(),new Error("Could not create tunnel");if(this.c.has($))throw this.c.delete($),f.dispose(),await b.dispose(),(0,A.$4)();return f.setTunnel(b),this.b.set($,f),this.g.info(`[SharedProcessTunnelService] Created tunnel ${$}: ${b.localAddress} (local) to ${u}:${d} (remote).`),{tunnelLocalPort:b.tunnelLocalPort,localAddress:b.localAddress}}async setAddress(y,$){const u=this.b.get(y);u&&u.setAddress($)}async destroyTunnel(y){const $=this.b.get(y);if($){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${y}.`),this.b.delete(y),await $.dispose();return}this.c.add(y)}};e.$j7b=g,e.$j7b=g=R=ye([K(0,N.$Mz),K(1,L.$Ri)],g)}),define(ce[27],le([0,1,4]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pk=void 0,e.$pk=(0,L.$ph)("IUriIdentityService")}),define(ce[228],le([0,1,27,183,13,22,126,3,2]),function(ie,e,L,N,O,A,j,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=void 0;class g{static{this._clock=0}constructor($){this.uri=$,this.time=g._clock++}touch(){return this.time=g._clock++,this}}let C=class{constructor($){this.g=$,this.c=new S.$kb,this.f=2**16;const u=new Map,d=p=>{let c=u.get(p.scheme);return c===void 0&&(c=$.hasProvider(p)&&!this.g.hasCapability(p,1024),u.set(p.scheme,c)),c};this.c.add(R.Event.any($.onDidChangeFileSystemProviderRegistrations,$.onDidChangeFileSystemProviderCapabilities)(p=>{u.delete(p.scheme)})),this.extUri=new A.$Xf(d),this.d=new j.$fr((p,c)=>this.extUri.compare(p,c,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri($){this.g.hasProvider($)&&($=(0,A.$0f)($));const u=this.d.get($);return u?u.touch().uri.with({fragment:$.fragment}):(this.d.set($,new g($)),this.h(),$)}h(){if(this.d.size<this.f)return;const $=[...this.d.entries()].sort((d,p)=>d[1].time<p[1].time?1:d[1].time>p[1].time?-1:0);g._clock=0,this.d.clear();const u=this.f*.5;for(let d=0;d<u;d++)this.d.set($[d][0],$[d][1].touch())}};e.$gr=C,e.$gr=C=ye([K(0,O.$Sj)],C),(0,N.$dr)(L.$pk,C,1)}),define(ce[229],le([0,1,3,2,13,42,47,14]),function(ie,e,L,N,O,A,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D6b=void 0;class S extends N.$lb{get capabilities(){return this.f.capabilities&-5}constructor(C,y,$,u){super(),this.c=C,this.f=y,this.g=$,this.h=u,this.onDidChangeCapabilities=this.f.onDidChangeCapabilities,this.a=this.B(new L.$ec),this.onDidChangeFile=this.a.event,this.b=j.$vh.forUris(()=>!(this.capabilities&1024)),this.B(this.f.onDidChangeFile(d=>this.i(d)))}watch(C,y){this.b.set(C,C);const $=this.f.watch(this.j(C),y);return(0,N.$jb)(()=>{this.b.delete(C),$.dispose()})}stat(C){return this.f.stat(this.j(C))}mkdir(C){return this.f.mkdir(this.j(C))}rename(C,y,$){return this.f.rename(this.j(C),this.j(y),$)}readFile(C){return this.f.readFile(this.j(C),{atomic:!0})}readFileStream(C,y,$){const u=(0,A.$sc)(d=>R.$Ec.concat(d.map(p=>R.$Ec.wrap(p))).buffer);return(async()=>{try{const d=await this.readFile(C);u.end(d)}catch(d){u.error(d),u.end()}})(),u}readdir(C){return this.f.readdir(this.j(C))}writeFile(C,y,$){return this.f.writeFile(this.j(C),y,$)}delete(C,y){return this.f.delete(this.j(C),y)}copy(C,y,$){if((0,O.$Vj)(this.f))return this.f.copy(this.j(C),this.j(y),$);throw new Error("copy not supported")}i(C){const y=[];for(const $ of C){if($.resource.scheme!==this.c)continue;const u=this.k($.resource);this.b.findSubstr(u)&&y.push({resource:u,type:$.type})}y.length&&(this.h.debug("User data changed"),this.a.fire(y))}j(C){return C.with({scheme:this.c})}k(C){return C.with({scheme:this.g})}}e.$D6b=S}),define(ce[77],le([0,1,85]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hzb=e.$gzb=e.edit=void 0;function N(j,R,S,g){const C=(0,L.$gS)(j,R,S,g)[0];return C&&(j=j.substring(0,C.offset)+C.content+j.substring(C.offset+C.length)),j}e.edit=N;function O(j,R,S){let g=S;for(;g>=0;){if(j.charAt(g)===R.charAt(R.length-1)&&R.length===1)return g+1;if(g--,R.length===2&&g>=0&&j.charAt(g)===R.charAt(0))return g+2}return 0}e.$gzb=O;function A(j,R,S){let g=S;for(;g>=0;)if(j.charAt(g)===R.charAt(R.length-1)&&R.length===1||(g++,R.length===2&&g>=0&&j.charAt(g)===R.charAt(1)))return g;return j.length-1}e.$hzb=A}),define(ce[230],le([0,1,30,53,11]),function(ie,e,L,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$21b=void 0;function A(u,d,p,c,h,f){const b=[],w=[],I=[];if(!d){const V=u.filter(({identifier:Z})=>h.every(J=>J.toLowerCase()!==Z.id.toLowerCase()));return{local:{added:b,removed:w,updated:I},remote:V.length>0?{added:V,updated:[],removed:[],all:V}:null}}u=u.map(y),d=d.map(y),p=p?p.map(y):null;const t=new Map,o=V=>{V.uuid&&t.set(V.id.toLowerCase(),V.uuid)};u.forEach(({identifier:V})=>o(V)),d.forEach(({identifier:V})=>o(V)),p?.forEach(({identifier:V})=>o(V));const s=V=>{const Z=V.identifier.uuid||t.get(V.identifier.id.toLowerCase());return Z?`uuid:${Z}`:`id:${V.identifier.id.toLowerCase()}`},n=(V,Z)=>(V.set(s(Z),Z),V),i=u.reduce(n,new Map),r=d.reduce(n,new Map),a=d.reduce((V,Z)=>n(V,(0,L.$Im)(Z)),new Map),v=p?p.reduce(n,new Map):null,m=c.reduce(n,new Map),l=h.reduce((V,Z)=>{const J=t.get(Z.toLowerCase());return V.add(J?`uuid:${J}`:`id:${Z.toLowerCase()}`)},new Set),E=f?f.reduce((V,{id:Z,uuid:J})=>(J=J??t.get(Z.toLowerCase()),V.add(J?`uuid:${J}`:`id:${Z.toLowerCase()}`)),new Set):null,D=j(i,r,l,!1);if(D.added.size>0||D.removed.size>0||D.updated.size>0){const V=j(v,i,l,!1),Z=j(v,r,l,!0),J=(Q,G,X,W)=>{let q,B,_;return G.installed?(q=W.pinned,_=W.preRelease,q&&(B=W.version)):(q=X.pinned,_=X.preRelease,q&&(B=X.version)),q===void 0&&(q=G.pinned,q&&(B=G.version)),_===void 0&&(_=G.preRelease),{...W,installed:G.installed||X.installed,pinned:q,preRelease:_,version:B??(X.version&&(!G.installed||N.gt(X.version,G.version))?X.version:G.version),state:S(G,X,v?.get(Q))}};for(const Q of Z.removed.values()){const G=i.get(Q);if(!G)continue;const X=(0,O.$te)(v?.get(Q)),W=E&&!E.has(Q)&&X.installed;G.installed&&W?w.push(G.identifier):a.set(Q,G)}for(const Q of Z.added.values()){const G=(0,O.$te)(r.get(Q)),X=i.get(Q);if(X){if(D.updated.has(Q)){const W=J(Q,X,G,G);R(X,G,!1,!1)||I.push($(W,Q)),a.set(Q,W)}}else G.installed&&b.push($(G,Q))}for(const Q of Z.updated.values()){const G=(0,O.$te)(r.get(Q)),X=(0,O.$te)(v?.get(Q)),W=i.get(Q);if(W)if(E&&!E.has(Q)&&X.installed&&W.installed&&!G.installed)w.push(W.identifier);else{const B=J(Q,W,G,G);I.push($(B,Q)),a.set(Q,B)}else G.installed&&b.push($(G,Q))}for(const Q of V.added.values())Z.added.has(Q)||a.set(Q,(0,O.$te)(i.get(Q)));for(const Q of V.updated.values()){if(Z.removed.has(Q)||Z.updated.has(Q))continue;const G=(0,O.$te)(i.get(Q)),X=(0,O.$te)(r.get(Q));a.set(Q,J(Q,G,X,G))}for(const Q of V.removed.values())Z.updated.has(Q)||Z.removed.has(Q)||m.has(Q)||(0,O.$te)(r.get(Q)).installed&&E&&(E.has(Q)||!(0,O.$te)(v?.get(Q)).installed||a.delete(Q))}const T=[],M=j(r,a,new Set,!0),F=M.added.size>0||M.updated.size>0||M.removed.size>0;return F&&a.forEach((V,Z)=>T.push($(V,Z))),{local:{added:b,removed:w,updated:I},remote:F?{added:[...M.added].map(V=>a.get(V)),updated:[...M.updated].map(V=>a.get(V)),removed:[...M.removed].map(V=>r.get(V)),all:T}:null}}e.$21b=A;function j(u,d,p,c){const h=u?[...u.keys()].filter(t=>!p.has(t)):[],f=[...d.keys()].filter(t=>!p.has(t)),b=f.filter(t=>!h.includes(t)).reduce((t,o)=>(t.add(o),t),new Set),w=h.filter(t=>!f.includes(t)).reduce((t,o)=>(t.add(o),t),new Set),I=new Set;for(const t of h){if(w.has(t))continue;const o=u.get(t),s=d.get(t);(!s||!R(o,s,c,!0))&&I.add(t)}return{added:b,removed:w,updated:I}}function R(u,d,p,c){return!(u.disabled!==d.disabled||!!u.isApplicationScoped!=!!d.isApplicationScoped||c&&u.installed!==d.installed||u.installed&&d.installed&&(u.preRelease!==d.preRelease||u.pinned!==d.pinned||d.pinned&&u.version!==d.version)||!C(u.state,d.state)||p&&u.version!==d.version)}function S(u,d,p){const c=u.state,h=d.state,f=p?.state;if(!d.version||c&&N.gt(u.version,d.version))return c;if(h&&N.gt(d.version,u.version)||!c)return h;if(!h)return c;const b=(0,L.$Im)(c),w=f?g(f,h):{added:Object.keys(h).reduce((t,o)=>(t.add(o),t),new Set),removed:new Set,updated:new Set},I=f?g(f,c):{added:Object.keys(c).reduce((t,o)=>(t.add(o),t),new Set),removed:new Set,updated:new Set};for(const t of[...w.added.values(),...w.updated.values()])b[t]=h[t];for(const t of w.removed.values())I.updated.has(t)||delete b[t];return b}function g(u,d){const p=Object.keys(u),c=Object.keys(d),h=c.filter(w=>!p.includes(w)).reduce((w,I)=>(w.add(I),w),new Set),f=p.filter(w=>!c.includes(w)).reduce((w,I)=>(w.add(I),w),new Set),b=new Set;for(const w of p){if(f.has(w))continue;const I=u[w],t=d[w];(0,L.$Mm)(I,t)||b.add(w)}return{added:h,removed:f,updated:b}}function C(u={},d={}){const{added:p,removed:c,updated:h}=g(u,d);return p.size===0&&c.size===0&&h.size===0}function y(u){return{...u,disabled:!!u.disabled,installed:!!u.installed}}function $(u,d){const p={...u,identifier:{id:u.identifier.id,uuid:d.startsWith("uuid:")?d.substring(5):void 0},preRelease:!!u.preRelease,pinned:!!u.pinned};return u.disabled||delete p.disabled,u.installed||delete p.installed,u.state||delete p.state,u.isApplicationScoped||delete p.isApplicationScoped,p}}),define(ce[111],le([0,1,20,18,4]),function(ie,e,L,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dBb=e.$cBb=void 0,e.$cBb=(0,O.$ph)("IIgnoredExtensionsManagementService");let A=class{constructor(R){this.a=R}hasToNeverSyncExtension(R){return this.b().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.b().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,S){let g=[...this.a.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return g=g.filter(C=>C!==R&&C!==`-${R}`),S&&g.push(R.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",g.length?g:void 0,2)}updateSynchronizedExtensions(R,S){let g=[...this.a.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return g=g.filter(C=>C!==R&&C!==`-${R}`),S&&g.push(`-${R.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",g.length?g:void 0,2)}getIgnoredExtensions(R){const S=R.filter($=>$.isMachineScoped).map($=>$.identifier.id.toLowerCase()),g=this.b().map($=>$.toLowerCase()),C=[],y=[];if(Array.isArray(g))for(const $ of g)$.startsWith("-")?y.push($.substring(1)):C.push($);return(0,L.$of)([...S,...C].filter($=>!y.includes($)))}b(){let R=this.a.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.a.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(S=>S.toLowerCase())}};e.$dBb=A,e.$dBb=A=ye([K(0,N.$Vh)],A)}),define(ce[231],le([0,1,20,34,30,94,77]),function(ie,e,L,N,O,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$81b=void 0;function R(w){return(0,N.$ym)(w)||[]}async function S(w,I,t,o,s){const n=R(w),i=R(I),r=t?R(t):null,a=[...n,...i,...r||[]].map(J=>J.key),v=await s.resolveUserBindings(a),m=C(n,i,r,v);if(!m.hasLocalForwarded&&!m.hasRemoteForwarded)return{mergeContent:w,hasChanges:!1,hasConflicts:!1};if(!m.hasLocalForwarded&&m.hasRemoteForwarded)return{mergeContent:I,hasChanges:!0,hasConflicts:!1};if(m.hasLocalForwarded&&!m.hasRemoteForwarded)return{mergeContent:w,hasChanges:!0,hasConflicts:!1};const l=$(n),E=$(i),D=r?$(r):null,T=d(l,E,v),M=D?d(D,l,v):{added:[...l.keys()].reduce((J,Q)=>(J.add(Q),J),new Set),removed:new Set,updated:new Set},F=D?d(D,E,v):{added:[...E.keys()].reduce((J,Q)=>(J.add(Q),J),new Set),removed:new Set,updated:new Set},V=g(T,M,F);let Z=w;for(const J of V.removed.values())V.conflicts.has(J)||(Z=f(Z,J,o));for(const J of V.added.values()){if(V.conflicts.has(J))continue;const Q=E.get(J);if(Q.some(G=>G.command!==`-${J}`&&m.conflicts.has(v[G.key]))){V.conflicts.add(J);continue}Z=h(Z,Q,o)}for(const J of V.updated.values()){if(V.conflicts.has(J))continue;const Q=E.get(J);if(Q.some(G=>G.command!==`-${J}`&&m.conflicts.has(v[G.key]))){V.conflicts.add(J);continue}Z=b(Z,J,Q,o)}return{mergeContent:Z,hasChanges:!0,hasConflicts:V.conflicts.size>0}}e.$81b=S;function g(w,I,t){const o=new Set,s=new Set,n=new Set,i=new Set;for(const r of I.removed.values())t.updated.has(r)&&i.add(r);for(const r of t.removed.values())i.has(r)||(I.updated.has(r)?i.add(r):s.add(r));for(const r of I.added.values())i.has(r)||t.added.has(r)&&w.updated.has(r)&&i.add(r);for(const r of t.added.values())i.has(r)||(I.added.has(r)?w.updated.has(r)&&i.add(r):o.add(r));for(const r of I.updated.values())i.has(r)||t.updated.has(r)&&w.updated.has(r)&&i.add(r);for(const r of t.updated.values())i.has(r)||(I.updated.has(r)?w.updated.has(r)&&i.add(r):n.add(r));return{added:o,removed:s,updated:n,conflicts:i}}function C(w,I,t,o){const s=new Set,n=y(w,o),i=y(I,o),r=t?y(t,o):null,a=u(n,i);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:s,removed:s,updated:s,conflicts:s};const v=r?u(r,n):{added:[...n.keys()].reduce((M,F)=>(M.add(F),M),new Set),removed:new Set,updated:new Set};if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:s,removed:s,updated:s,conflicts:s};const m=r?u(r,i):{added:[...i.keys()].reduce((M,F)=>(M.add(F),M),new Set),removed:new Set,updated:new Set};if(m.added.size===0&&m.removed.size===0&&m.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:s,removed:s,updated:s,conflicts:s};const{added:l,removed:E,updated:D,conflicts:T}=g(a,v,m);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:l,removed:E,updated:D,conflicts:T}}function y(w,I){const t=new Map;for(const o of w){const s=I[o.key];let n=t.get(s);n||(n=[],t.set(s,n)),n.push(o)}return t}function $(w){const I=new Map;for(const t of w){const o=t.command[0]==="-"?t.command.substring(1):t.command;let s=I.get(o);s||(s=[],I.set(o,s)),s.push(t)}return I}function u(w,I){const t=[...w.keys()],o=[...I.keys()],s=o.filter(r=>!t.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),n=t.filter(r=>!o.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),i=new Set;for(const r of t){if(n.has(r))continue;const a=w.get(r).map(m=>({...m,key:r})),v=I.get(r).map(m=>({...m,key:r}));(0,L.$$e)(a,v,(m,l)=>c(m,l))||i.add(r)}return{added:s,removed:n,updated:i}}function d(w,I,t){const o=[...w.keys()],s=[...I.keys()],n=s.filter(a=>!o.includes(a)).reduce((a,v)=>(a.add(v),a),new Set),i=o.filter(a=>!s.includes(a)).reduce((a,v)=>(a.add(v),a),new Set),r=new Set;for(const a of o){if(i.has(a))continue;const v=w.get(a).map(l=>({...l,key:t[l.key]})),m=I.get(a).map(l=>({...l,key:t[l.key]}));p(v,m)||r.add(a)}return{added:n,removed:i,updated:r}}function p(w,I){return!(!(0,L.$$e)(w.filter(({command:t})=>t[0]!=="-"),I.filter(({command:t})=>t[0]!=="-"),(t,o)=>c(t,o))||!(0,L.$$e)(w.filter(({command:t})=>t[0]==="-"),I.filter(({command:t})=>t[0]==="-"),(t,o)=>c(t,o)))}function c(w,I){if(w.command!==I.command||w.key!==I.key)return!1;const t=A.$vi.deserialize(w.when),o=A.$vi.deserialize(I.when);return!(t&&!o||!t&&o||t&&o&&!t.equals(o)||!O.$Mm(w.args,I.args))}function h(w,I,t){for(const o of I)w=j.edit(w,[-1],o,t);return w}function f(w,I,t){const o=R(w);for(let s=o.length-1;s>=0;s--)(o[s].command===I||o[s].command===`-${I}`)&&(w=j.edit(w,[s],void 0,t));return w}function b(w,I,t,o){const s=R(w),n=s.findIndex(i=>i.command===I||i.command===`-${I}`);for(let i=s.length-1;i>=0;i--)(s[i].command===I||s[i].command===`-${I}`)&&(w=j.edit(w,[i],void 0,o));for(let i=t.length-1;i>=0;i--)w=j.edit(w,[n],t[i],o);return w}}),define(ce[232],le([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d2b=e.$c2b=void 0;function L(A,j,R){const S={},g={},C=new Set;if(!j)return{local:{added:S,updated:g,removed:[...C.values()]},remote:{added:A,updated:{},removed:[]},conflicts:[]};const y=N(A,j);if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{local:{added:S,updated:g,removed:[...C.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const $=N(R,A),u=N(R,j),d={},p={},c=new Set,h=new Set;for(const f of $.removed.values())u.updated.has(f)?S[f]=j[f]:c.add(f);for(const f of u.removed.values())h.has(f)||($.updated.has(f)?h.add(f):C.add(f));for(const f of $.updated.values())h.has(f)||(u.updated.has(f)?y.updated.has(f)&&h.add(f):p[f]=A[f]);for(const f of u.updated.values())h.has(f)||($.updated.has(f)?y.updated.has(f)&&h.add(f):A[f]!==void 0&&(g[f]=j[f]));for(const f of $.added.values())h.has(f)||(u.added.has(f)?y.updated.has(f)&&h.add(f):d[f]=A[f]);for(const f of u.added.values())h.has(f)||($.added.has(f)?y.updated.has(f)&&h.add(f):S[f]=j[f]);return{local:{added:S,removed:[...C.values()],updated:g},remote:{added:d,removed:[...c.values()],updated:p},conflicts:[...h.values()]}}e.$c2b=L;function N(A,j){const R=A?Object.keys(A):[],S=j?Object.keys(j):[],g=S.filter($=>!R.includes($)).reduce(($,u)=>($.add(u),$),new Set),C=R.filter($=>!S.includes($)).reduce(($,u)=>($.add(u),$),new Set),y=new Set;for(const $ of R){if(C.has($))continue;const u=A[$],d=j[$];u!==d&&y.add($)}return{added:g,removed:C,updated:y}}function O(A,j){const{added:R,removed:S,updated:g}=N(A,j);return R.size===0&&S.size===0&&g.size===0}e.$d2b=O}),define(ce[233],le([0,1,30]),function(ie,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W3b=void 0;function N(A,j,R,S){const g={added:[],removed:[],updated:[]};let C={added:[],removed:[],updated:[]};if(!j){const $=A.filter(({id:u})=>!S.includes(u));return $.length?C.added=$:C=null,{local:g,remote:C}}const y=O(A,j,S);if(y.added.length>0||y.removed.length>0||y.updated.length>0){const $=O(R,A,S),u=O(R,j,S);for(const d of u.removed){const p=A.find(c=>c.id===d);p&&g.removed.push(p)}for(const d of u.added){const p=j.find(c=>c.id===d);$.added.includes(d)?y.updated.includes(d)&&g.updated.push(p):g.added.push(p)}for(const d of u.updated)g.updated.push(j.find(p=>p.id===d));for(const d of $.added)u.added.includes(d)||C.added.push(A.find(p=>p.id===d));for(const d of $.updated)u.removed.includes(d)||u.updated.includes(d)||C.updated.push(A.find(p=>p.id===d));for(const d of $.removed){const p=j.find(c=>c.id===d);p&&C.removed.push(p)}}return C.added.length===0&&C.removed.length===0&&C.updated.length===0&&(C=null),{local:g,remote:C}}e.$W3b=N;function O(A,j,R){A=A?A.filter(({id:u})=>!R.includes(u)):[],j=j.filter(({id:u})=>!R.includes(u));const S=A.map(({id:u})=>u),g=j.map(({id:u})=>u),C=g.filter(u=>!S.includes(u)),y=S.filter(u=>!g.includes(u)),$=[];for(const{id:u,name:d,shortName:p,useDefaultFlags:c}of A){if(y.includes(u))continue;const h=j.find(f=>f.id===u);(!h||h.name!==d||h.shortName!==p||!(0,L.$Mm)(h.useDefaultFlags,c))&&$.push(u)}return{added:C,removed:y,updated:$}}}),define(ce[24],le([0,1,20,11,172,49,29,4,103,40]),function(ie,e,L,N,O,A,j,R,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hgb=e.$ggb=e.$fgb=e.$egb=e.$dgb=e.$cgb=e.$bgb=e.$agb=e.$_fb=e.$$fb=e.$0fb=e.MergeState=e.Change=e.SyncStatus=e.$9fb=e.$8fb=e.$7fb=e.UserDataSyncErrorCode=e.$6fb=e.$5fb=e.$4fb=e.$3fb=e.$2fb=e.$1fb=e.$Zfb=e.$Yfb=e.$Xfb=e.SyncResource=e.$Wfb=e.$Vfb=e.$Ufb=e.$Tfb=e.$Sfb=e.$Rfb=void 0;function C(){const i=g.$Um.as(A.$Zm.Configuration).getConfigurationProperties();return Object.keys(i).filter(r=>!!i[r].disallowSyncIgnore)}e.$Rfb=C;function y(){const i=g.$Um.as(A.$Zm.Configuration).getConfigurationProperties(),r=Object.keys(i).filter(m=>!!i[m].ignoreSync),a=Object.keys(i).filter(m=>i[m].scope===2||i[m].scope===6),v=C();return(0,L.$of)([...r,...a,...v])}e.$Sfb=y,e.$Tfb="settingsSync",e.$Ufb="settingsSync.keybindingsPerPlatform";function $(){const i="vscode://schemas/ignoredSettings",r=g.$Um.as(A.$Zm.Configuration);r.registerConfiguration({id:"settingsSync",order:30,title:(0,O.localize)(0,null),type:"object",properties:{[e.$Ufb]:{type:"boolean",description:(0,O.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,O.localize)(2,null),items:[{type:"string",pattern:j.$En,errorMessage:(0,O.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,O.localize)(4,null),default:[],scope:1,$ref:i,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const a=g.$Um.as(S.$Vm.JSONContribution),v=()=>{const m=C(),l=y(),E=Object.keys(A.$1m.properties).filter(M=>!l.includes(M)),D=l.filter(M=>!m.includes(M)),T={items:{type:"string",enum:[...E,...D.map(M=>`-${M}`)]}};a.registerSchema(i,T)};return r.onDidUpdateConfiguration(()=>v())}e.$Vfb=$;function u(i){return i&&(0,N.$ke)(i)&&(0,N.$ie)(i.id)&&Array.isArray(i.scopes)}e.$Wfb=u;var d;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState",i.Profiles="profiles",i.WorkspaceState="workspaceState"})(d||(e.SyncResource=d={})),e.$Xfb=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function p(i,...r){return i?[i,...r]:r}e.$Yfb=p;function c(i,r,a,v){return v.joinPath(a.userDataSyncHome,...p(i,r,`lastSync${r}.json`))}e.$Zfb=c,e.$1fb=(0,R.$ph)("IUserDataSyncStoreManagementService"),e.$2fb=(0,R.$ph)("IUserDataSyncStoreService"),e.$3fb=(0,R.$ph)("IUserDataSyncBackupStoreService"),e.$4fb="x-operation-id",e.$5fb="X-Execution-Id";function h(i){const r={};return r[e.$5fb]=i,r}e.$6fb=h;var f;(function(i){i.Unauthorized="Unauthorized",i.Forbidden="Forbidden",i.NotFound="NotFound",i.MethodNotFound="MethodNotFound",i.Conflict="Conflict",i.Gone="Gone",i.PreconditionFailed="PreconditionFailed",i.TooLarge="TooLarge",i.UpgradeRequired="UpgradeRequired",i.PreconditionRequired="PreconditionRequired",i.TooManyRequests="RemoteTooManyRequests",i.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",i.RequestFailed="RequestFailed",i.RequestCanceled="RequestCanceled",i.RequestTimeout="RequestTimeout",i.RequestProtocolNotSupported="RequestProtocolNotSupported",i.RequestPathNotEscaped="RequestPathNotEscaped",i.RequestHeadersNotObject="RequestHeadersNotObject",i.NoCollection="NoCollection",i.NoRef="NoRef",i.EmptyResponse="EmptyResponse",i.TurnedOff="TurnedOff",i.SessionExpired="SessionExpired",i.ServiceChanged="ServiceChanged",i.DefaultServiceChanged="DefaultServiceChanged",i.LocalTooManyProfiles="LocalTooManyProfiles",i.LocalTooManyRequests="LocalTooManyRequests",i.LocalPreconditionFailed="LocalPreconditionFailed",i.LocalInvalidContent="LocalInvalidContent",i.LocalError="LocalError",i.IncompatibleLocalContent="IncompatibleLocalContent",i.IncompatibleRemoteContent="IncompatibleRemoteContent",i.Unknown="Unknown"})(f||(e.UserDataSyncErrorCode=f={}));class b extends Error{constructor(r,a,v,m){super(r),this.code=a,this.resource=v,this.operationId=m,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.$7fb=b;class w extends b{constructor(r,a,v,m,l){super(r,v,void 0,l),this.url=a,this.serverCode=m}}e.$8fb=w;class I extends b{constructor(r,a){super(r,a)}}e.$9fb=I,function(i){function r(a){if(a instanceof i)return a;const v=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(a.name);if(v&&v[1]){const m=v[2]==="unknown"?void 0:v[2],l=v[3]==="unknown"?void 0:v[3];return new i(a.message,v[1],m,l)}return new i(a.message,"Unknown")}i.toUserDataSyncError=r}(b||(e.$7fb=b={}));var t;(function(i){i.Uninitialized="uninitialized",i.Idle="idle",i.Syncing="syncing",i.HasConflicts="hasConflicts"})(t||(e.SyncStatus=t={}));var o;(function(i){i[i.None=0]="None",i[i.Added=1]="Added",i[i.Modified=2]="Modified",i[i.Deleted=3]="Deleted"})(o||(e.Change=o={}));var s;(function(i){i.Preview="preview",i.Conflict="conflict",i.Accepted="accepted"})(s||(e.MergeState=s={})),e.$0fb="sync.store.url.type";function n(i){return`sync.enable.${i}`}e.$$fb=n,e.$_fb=(0,R.$ph)("IUserDataSyncEnablementService"),e.$agb=(0,R.$ph)("IUserDataSyncService"),e.$bgb=(0,R.$ph)("IUserDataSyncResourceProviderService"),e.$cgb=(0,R.$ph)("IUserDataAutoSyncService"),e.$dgb=(0,R.$ph)("IUserDataSyncUtilService"),e.$egb=(0,R.$ph)("IUserDataSyncLogService"),e.$fgb="userDataSync",e.$ggb="vscode-userdata-sync",e.$hgb="preview"}),define(ce[234],le([0,1,30,24]),function(ie,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yAb=void 0;function O(j,R,S,g,C){if(!R)return{remote:{added:Object.keys(j),removed:[],updated:[],all:Object.keys(j).length>0?j:null},local:{added:{},removed:[],updated:{}}};const y=A(j,R);if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const $=S?A(S,R):{added:Object.keys(R).reduce((f,b)=>(f.add(b),f),new Set),removed:new Set,updated:new Set},u=S?A(S,j):{added:Object.keys(j).reduce((f,b)=>(f.add(b),f),new Set),removed:new Set,updated:new Set},d={added:{},removed:[],updated:{}},p=L.$Im(R),c=!S;for(const f of u.added.values())f!==N.$0fb&&c&&$.added.has(f)||(p[f]=j[f]);for(const f of u.updated.values())p[f]=j[f];for(const f of u.removed.values())g.unregistered.includes(f)||delete p[f];for(const f of $.added.values()){const b=R[f];if(g.machine.includes(f)){C.info(`GlobalState: Skipped adding ${f} in local storage because it is declared as machine scoped.`);continue}if(S&&u.added.has(f))continue;const w=j[f];w&&w.value===b.value||f===N.$0fb&&c&&u.added.has(f)||(w?d.updated[f]=b:d.added[f]=b)}for(const f of $.updated.values()){const b=R[f];if(g.machine.includes(f)){C.info(`GlobalState: Skipped updating ${f} in local storage because it is declared as machine scoped.`);continue}if(u.updated.has(f)||u.removed.has(f))continue;const w=j[f];w&&w.value===b.value||(d.updated[f]=b)}for(const f of $.removed.values()){if(g.machine.includes(f)){C.trace(`GlobalState: Skipped removing ${f} in local storage because it is declared as machine scoped.`);continue}u.updated.has(f)||u.removed.has(f)||d.removed.push(f)}const h=A(R,p);return{local:d,remote:{added:[...h.added],updated:[...h.updated],removed:[...h.removed],all:h.added.size===0&&h.removed.size===0&&h.updated.size===0?null:p}}}e.$yAb=O;function A(j,R){const S=Object.keys(j),g=Object.keys(R),C=g.filter(u=>!S.includes(u)).reduce((u,d)=>(u.add(d),u),new Set),y=S.filter(u=>!g.includes(u)).reduce((u,d)=>(u.add(d),u),new Set),$=new Set;for(const u of S){if(y.has(u))continue;const d=j[u],p=R[u];L.$Mm(d,p)||$.add(u)}return{added:C,removed:y,updated:$}}}),define(ce[235],le([0,1,20,34,85,41,30,77,24]),function(ie,e,L,N,O,A,j,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nzb=e.$mzb=e.$lzb=e.$kzb=e.$jzb=e.$izb=void 0;function g(a,v,m){let l=[];m?l=y(m):l=C(v);const E=[],D=[...(0,S.$Rfb)()];if(Array.isArray(l))for(const T of l)T.startsWith("-")?D.push(T.substring(1)):E.push(T);return(0,L.$of)([...a,...E].filter(T=>!D.includes(T)))}e.$izb=g;function C(a){let v=a.inspect("settingsSync.ignoredSettings").userValue;return v!==void 0||(v=a.inspect("sync.ignoredSettings").userValue,v!==void 0)?v:a.getValue("settingsSync.ignoredSettings")||[]}function y(a){const v=(0,N.$ym)(a);return v?v["settingsSync.ignoredSettings"]||v["sync.ignoredSettings"]||[]:[]}function $(a,v){const m=(0,N.$ym)(a)||{};let l="{}";for(const E of Object.keys(m)){const D=(0,O.$gS)(l,[E],m[E],v);l=(0,O.$jS)(l,D)}return l}e.$jzb=$;function u(a,v,m,l){if(m.length){const E=r(v),D=(0,N.$ym)(v)||{},T=(0,N.$ym)(a);if(!T)return a;const M=[];for(const F of m){const V=D[F],Z=T[F];V===void 0?a=R.edit(a,[F],void 0,l):Z!==void 0?a=R.edit(a,[F],V,l):M.push(t(F,E))}M.sort((F,V)=>F.startOffset-V.startOffset),M.forEach(F=>a=f(F.setting.key,v,a,l))}return a}e.$kzb=u;function d(a,v,m,l,E,D){const T=u(a,v,l,D),M=m!==T,F=m!==v;if(!M&&!F)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(M&&!F)return{conflictsSettings:[],localContent:null,remoteContent:T,hasConflicts:!1};if(F&&!M)return{conflictsSettings:[],localContent:u(v,a,l,D),remoteContent:null,hasConflicts:!1};if(m===null&&c(a)){const P=p(a,v,l)?null:u(v,a,l,D);return{conflictsSettings:[],localContent:P,remoteContent:null,hasConflicts:!1}}let V=a,Z=v;const J=(0,N.$ym)(a),Q=(0,N.$ym)(v),G=m?(0,N.$ym)(m):null,X=l.reduce((P,z)=>(P.add(z),P),new Set),W=h(J,Q,X),q=h(G,J,X),B=h(G,Q,X),_=new Map,oe=new Set,ae=P=>{oe.add(P);const z=E.filter(({key:H})=>H===P)[0];z?(V=R.edit(V,[P],z.value,D),Z=R.edit(Z,[P],z.value,D)):_.set(P,{key:P,localValue:J[P],remoteValue:Q[P]})};for(const P of q.removed.values())B.updated.has(P)?ae(P):Z=R.edit(Z,[P],void 0,D);for(const P of B.removed.values())oe.has(P)||(q.updated.has(P)?ae(P):V=R.edit(V,[P],void 0,D));for(const P of q.updated.values())oe.has(P)||(B.updated.has(P)?W.updated.has(P)&&ae(P):Z=R.edit(Z,[P],J[P],D));for(const P of B.updated.values())oe.has(P)||(q.updated.has(P)?W.updated.has(P)&&ae(P):V=R.edit(V,[P],Q[P],D));for(const P of q.added.values())oe.has(P)||(B.added.has(P)?W.updated.has(P)&&ae(P):Z=f(P,V,Z,D));for(const P of B.added.values())oe.has(P)||(q.added.has(P)?W.updated.has(P)&&ae(P):V=f(P,Z,V,D));const Y=_.size>0||!p(V,Z,l),U=Y||!p(V,a,[]),k=Y||!p(Z,v,[]);return{localContent:U?V:null,remoteContent:k?Z:null,conflictsSettings:[..._.values()],hasConflicts:Y}}e.$lzb=d;function p(a,v,m){if(a===v)return!0;const l=(0,N.$ym)(a),E=(0,N.$ym)(v),D=m.reduce((F,V)=>(F.add(V),F),new Set),T=r(a).filter(F=>!(F.setting&&D.has(F.setting.key))),M=r(v).filter(F=>!(F.setting&&D.has(F.setting.key)));if(T.length!==M.length)return!1;for(let F=0;F<T.length;F++){const V=T[F],Z=M[F];if(V.setting&&Z.setting){if(V.setting.key!==Z.setting.key||!j.$Mm(l[V.setting.key],E[V.setting.key]))return!1}else if(!V.setting&&!Z.setting){if(V.value!==Z.value)return!1}else return!1}return!0}function c(a){return a?r(a).length===0:!0}e.$mzb=c;function h(a,v,m){const l=a?Object.keys(a).filter(F=>!m.has(F)):[],E=Object.keys(v).filter(F=>!m.has(F)),D=E.filter(F=>!l.includes(F)).reduce((F,V)=>(F.add(V),F),new Set),T=l.filter(F=>!E.includes(F)).reduce((F,V)=>(F.add(V),F),new Set),M=new Set;if(a)for(const F of l){if(T.has(F))continue;const V=a[F],Z=v[F];j.$Mm(V,Z)||M.add(F)}return{added:D,removed:T,updated:M}}function f(a,v,m,l){const E=(0,N.$ym)(v),D=r(v),T=r(m),M=b(a,D,T);return w(m,a,E[a],M,T,l)}e.$nzb=f;function b(a,v,m){const l=v.findIndex(D=>D.setting?.key===a),E=v[l-1];if(E){if(E.setting){const T=t(E.setting.key,m);if(T)return{index:m.indexOf(T),insertAfter:!0}}else{const T=o(l,v);if(T){const M=t(T.setting.key,m);if(M){const F=s(m.indexOf(M),m),V=n(v,T,v[l]);if(F){const Z=n(m,M,F),J=i(V,Z);return J?{index:m.indexOf(J),insertAfter:!0}:{index:m.indexOf(F),insertAfter:!1}}else{const Z=n(m,M,m[m.length-1]),J=i(V,Z);return J?{index:m.indexOf(J),insertAfter:!0}:{index:m.length-1,insertAfter:!0}}}}}const D=v[l+1];if(D)if(D.setting){const T=t(D.setting.key,m);if(T)return{index:m.indexOf(T),insertAfter:!1}}else{const T=s(l,v);if(T){const M=t(T.setting.key,m);if(M){const F=o(m.indexOf(M),m),V=n(v,v[l],T);if(F){const Z=n(m,F,M),J=i(V.reverse(),Z.reverse());return J?{index:m.indexOf(J),insertAfter:!1}:{index:m.indexOf(F),insertAfter:!0}}else{const Z=n(m,m[0],M),J=i(V.reverse(),Z.reverse());return J?{index:m.indexOf(J),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:m.length-1,insertAfter:!0}}function w(a,v,m,l,E,D){let T;return l.index===-1?T=(0,O.$gS)(a,[v],m,D):T=I(a,v,m,l,E,D).map(M=>(0,O.$hS)(a,M,D)[0]),(0,O.$jS)(a,T)}function I(a,v,m,l,E,D){const T=`${JSON.stringify(v)}: ${JSON.stringify(m)}`,M=(0,A.$dS)(D,a),F=E[l.index];if(l.insertAfter){const V=[];if(F.setting)V.push({offset:F.endOffset,length:0,content:","+T});else{const Z=s(l.index,E),J=o(l.index,E),Q=J?.setting?.commaOffset;J&&Q===void 0&&V.push({offset:J.endOffset,length:0,content:","});const G=Q!==void 0&&Q>F.endOffset;V.push({offset:G?Q+1:F.endOffset,length:0,content:Z?M+T+",":M+T})}return V}else{if(F.setting)return[{offset:F.startOffset,length:0,content:T+","}];const V=(E[l.index-1]&&!E[l.index-1].setting?M:"")+T+(s(l.index,E)?",":"")+M;return[{offset:F.startOffset,length:0,content:V}]}}function t(a,v){return v.filter(m=>m.setting?.key===a)[0]}function o(a,v){for(let m=a-1;m>=0;m--)if(v[m].setting)return v[m]}function s(a,v){for(let m=a+1;m<v.length;m++)if(v[m].setting)return v[m]}function n(a,v,m){const l=a.indexOf(v),E=a.indexOf(m);return a.filter((D,T)=>l<T&&T<E)}function i(a,v){if(a.length&&v.length){let m=0;for(;m<v.length&&m<a.length;m++)if(a[m].value!==v[m].value)return v[m-1];return v[m-1]}}function r(a){const v=[];let m=-1,l,E;const D={onObjectBegin:T=>{m++},onObjectProperty:(T,M,F)=>{m===0&&(l=M,E=T)},onObjectEnd:(T,M)=>{m--,m===0&&v.push({startOffset:l,endOffset:T+M,value:a.substring(l,T+M),setting:{key:E,commaOffset:void 0}})},onArrayBegin:(T,M)=>{m++},onArrayEnd:(T,M)=>{m--,m===0&&v.push({startOffset:l,endOffset:T+M,value:a.substring(l,T+M),setting:{key:E,commaOffset:void 0}})},onLiteralValue:(T,M,F)=>{m===0&&v.push({startOffset:l,endOffset:M+F,value:a.substring(l,M+F),setting:{key:E,commaOffset:void 0}})},onSeparator:(T,M,F)=>{if(m===0&&T===","){let V=v.length-1;for(;V>=0&&!v[V].setting;V--);const Z=v[V];Z&&v.splice(V,1,{startOffset:Z.startOffset,endOffset:Z.endOffset,value:Z.value,setting:{key:Z.setting.key,commaOffset:M}})}},onComment:(T,M)=>{m===0&&v.push({startOffset:T,endOffset:T+M,value:a.substring(T,T+M)})}};return(0,N.$Fm)(a,D),v}}),define(ce[78],le([0,1,3,2,4,24]),function(ie,e,L,N,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6yb=e.$5yb=void 0,e.$5yb=(0,O.$ph)("IUserDataSyncAccountService");let j=class extends N.$lb{get account(){return this.a}constructor(S,g){super(),this.g=S,this.h=g,this.b=this.B(new L.$ec),this.onDidChangeAccount=this.b.event,this.c=this.B(new L.$ec),this.onTokenFailed=this.c.event,this.f=!1,this.B(S.onTokenFailed(C=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f,C),this.updateAccount(void 0),C==="Forbidden"?this.c.fire(!0):this.c.fire(this.f),this.f=!0})),this.B(S.onTokenSucceed(()=>this.f=!1))}async updateAccount(S){(S&&this.a?S.token!==this.a.token||S.authenticationProviderId!==this.a.authenticationProviderId:S!==this.a)&&(this.a=S,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(S))}};e.$6yb=j,e.$6yb=j=ye([K(0,A.$2fb),K(1,A.$egb)],j)}),define(ce[236],le([0,1,2,10]),function(ie,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d7b=e.$c7b=e.$b7b=e.$a7b=e.$_6b=e.$$6b=e.$06b=void 0;class O{constructor($){this.a=$}listen($,u){switch(u){case"onError":return this.a.onError}throw new Error(`Event not found: ${u}`)}call($,u,d){switch(u){case"triggerSync":return this.a.triggerSync(d[0],d[1],d[2]);case"turnOn":return this.a.turnOn();case"turnOff":return this.a.turnOff(d[0])}throw new Error("Invalid call")}}e.$06b=O;class A{constructor($){this.a=$}listen($,u){throw new Error(`Event not found: ${u}`)}call($,u,d){switch(u){case"resolveDefaultIgnoredSettings":return this.a.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.a.resolveUserBindings(d[0]);case"resolveFormattingOptions":return this.a.resolveFormattingOptions(N.URI.revive(d[0]))}throw new Error("Invalid call")}}e.$$6b=A;class j{constructor($){this.a=$}async resolveDefaultIgnoredSettings(){return this.a.call("resolveDefaultIgnoredSettings")}async resolveUserBindings($){return this.a.call("resolveUserKeybindings",[$])}async resolveFormattingOptions($){return this.a.call("resolveFormattingOptions",[$])}}e.$_6b=j;class R{constructor($){this.a=$}listen($,u){switch(u){case"onDidChange":return this.a.onDidChange}throw new Error(`Event not found: ${u}`)}async call($,u,d){switch(u){case"getMachines":return this.a.getMachines();case"addCurrentMachine":return this.a.addCurrentMachine();case"removeCurrentMachine":return this.a.removeCurrentMachine();case"renameMachine":return this.a.renameMachine(d[0],d[1]);case"setEnablements":return this.a.setEnablements(d)}throw new Error("Invalid call")}}e.$a7b=R;class S{constructor($){this.a=$}listen($,u){switch(u){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`Event not found: ${u}`)}call($,u,d){switch(u){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(d)}throw new Error("Invalid call")}}e.$b7b=S;class g{constructor($){this.a=$}listen($,u){switch(u){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${u}`)}call($,u,d){switch(u){case"switch":return this.a.switch(d[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.$c7b=g;class C extends L.$lb{constructor($){super(),this.a=$,this.onDidChangeUserDataSyncStore=this.a.listen("onDidChangeUserDataSyncStore")}async switch($){return this.a.call("switch",[$])}async getPreviousUserDataSyncStore(){const $=await this.a.call("getPreviousUserDataSyncStore");return this.b($)}b($){return{url:N.URI.revive($.url),type:$.type,defaultUrl:N.URI.revive($.defaultUrl),insidersUrl:N.URI.revive($.insidersUrl),stableUrl:N.URI.revive($.stableUrl),canSwitch:$.canSwitch,authenticationProviders:$.authenticationProviders}}}e.$d7b=C}),define(ce[237],le([0,1,173,7,24]),function(ie,e,L,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eBb=void 0;let A=class extends N.$Wi{constructor(R){super(),this.g=this.B(R.createLogger(O.$fgb,{name:(0,L.localize)(0,null)}))}trace(R,...S){this.g.trace(R,...S)}debug(R,...S){this.g.debug(R,...S)}info(R,...S){this.g.info(R,...S)}warn(R,...S){this.g.warn(R,...S)}error(R,...S){this.g.error(R,...S)}flush(){this.g.flush()}};e.$eBb=A,e.$eBb=A=ye([K(0,N.$Si)],A)}),define(ce[112],le([0,1,7,4,23]),function(ie,e,L,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E7b=e.$D7b=void 0,e.$D7b=(0,N.$ph)("voiceRecognitionService");let A=class{constructor(R,S){this.a=R,this.b=S}async transcribe(R,S){this.a.info(`[voice] transcribe(${R.length}): Begin`);const g=process.env.VSCODE_VOICE_MODULE_PATH;if(!g||this.b.quality==="stable")throw this.a.error(`[voice] transcribe(${R.length}): Voice recognition not yet supported`),new Error("Voice recognition not yet supported!");const C=Date.now();this.a.info(`[voice] transcribe(${R.length}): Getting module from ${g}`);try{const y=ie.__$__nodeRequire(g),$=new AbortController;S.onCancellationRequested(()=>$.abort());const u=await y.transcribe({samplingRate:16e3,bitDepth:16,channelCount:1,channelData:R},{language:"en",suppressNonSpeechTokens:!0,signal:$.signal});return this.a.info(`[voice] transcribe(${R.length}): End (text: "${u}", took: ${Date.now()-C}ms)`),u}catch(y){throw this.a.error(`[voice] transcribe(${R.length}): Failed (error: "${y}", took: ${Date.now()-C}ms)`),y}}};e.$E7b=A,e.$E7b=A=ye([K(0,L.$Ri),K(1,O.$0i)],A)}),define(ce[238],le([0,1,2,112,7,25,5]),function(ie,e,L,N,O,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F7b=void 0;let R=class extends L.$lb{constructor(C,y,$){super(),this.a=C,this.b=y,this.c=$,this.f()}f(){this.B(this.a(C=>{this.B(new S(C,this.b,this.c))}))}};e.$F7b=R,e.$F7b=R=ye([K(1,N.$D7b),K(2,O.$Ri)],R);class S extends L.$lb{static{this.a=30*16e3*16*1/8}constructor(C,y,$){super(),this.f=C,this.g=y,this.h=$,this.b=new j.$Cg,this.c=void 0,this.i()}i(){this.h.info("[voice] transcriber: new connection");const C=new A.$oc;this.B((0,L.$jb)(()=>C.dispose(!0)));const y=$=>this.j($,C.token);this.f.on("message",y),this.B((0,L.$jb)(()=>this.f.off("message",y))),this.f.start(),this.B((0,L.$jb)(()=>this.f.close())),this.f.on("close",()=>{this.h.info("[voice] transcriber: closed connection"),C.dispose(!0)})}async j(C,y){if(!Array.isArray(C.data))return;const $=[];for(const d of C.data)d instanceof Float32Array&&$.push(d);const u=this.l(this.c?[this.c,...$]:$);if(u.length>S.a){this.h.warn("[voice] transcriber: refusing to accept more than 30s of audio data");return}this.c=u,this.b.queue(()=>this.k(y))}async k(C){if(C.isCancellationRequested)return;const y=this.c?.slice(0);if(!y)return;const $=await this.g.transcribe(y,C);C.isCancellationRequested||this.f.postMessage($)}l(C){const y=new Float32Array(C.reduce((u,d)=>u+d.length,0));let $=0;for(const u of C)y.set(u,$),$+=u.length;return y}}}),define(ce[239],le([0,1,5,3,2]),function(ie,e,L,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a6b=void 0;class A extends O.$lb{constructor({onDidOpenWindow:R,onDidFocusWindow:S,getActiveWindowId:g}){super(),this.a=this.B(new O.$kb),N.Event.latch(N.Event.any(R,S))(this.f,this,this.a),this.b=(0,L.$ig)(()=>g()),(async()=>{try{const y=await this.b;this.c=typeof this.c=="number"?this.c:y}catch{}finally{this.b=void 0}})()}f(R){this.b&&(this.b.cancel(),this.b=void 0),this.c=R}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$a6b=A}),define(ce[113],le([0,1,176,16,47,22,10,4,26]),function(ie,e,L,N,O,A,j,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.WorkbenchState=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=void 0,e.$yh=(0,R.$ph)("contextService");function g(n){const i=n;return typeof i?.id=="string"&&j.URI.isUri(i.uri)}e.$zh=g;function C(n){return typeof n?.id=="string"&&!g(n)&&!$(n)}e.$Ah=C,e.$Bh={id:"ext-dev"},e.$Ch={id:"empty-window"};function y(n,i){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,N.$_c)(n)}:i?e.$Bh:e.$Ch;const r=n;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.$Dh=y;function $(n){const i=n;return typeof i?.id=="string"&&j.URI.isUri(i.configPath)}e.$Eh=$;function u(n){const i=n;if(i?.uri)return{id:i.id,uri:j.URI.revive(i.uri)};const r=n;if(r?.configPath)return{id:r.id,configPath:j.URI.revive(r.configPath)};if(n?.id)return{id:n.id}}e.$Fh=u;var d;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(d||(e.WorkbenchState=d={}));function p(n){const i=n;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}e.$Gh=p;function c(n){const i=n;return!!(i&&typeof i=="object"&&j.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}e.$Hh=c;class h{constructor(i,r,a,v,m){this.h=i,this.j=a,this.k=v,this.l=m,this.c=O.$vh.forUris(this.l,()=>!0),this.folders=r}update(i){this.h=i.id,this.k=i.configuration,this.j=i.transient,this.l=i.l,this.folders=i.folders}get folders(){return this.g}set folders(i){this.g=i,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(i){this.k=i}getFolder(i){return i&&this.c.findSubstr(i)||null}n(){this.c=O.$vh.forUris(this.l,()=>!0);for(const i of this.folders)this.c.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ih=h;class f{constructor(i,r){this.raw=r,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,A.$9f)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Jh=f;function b(n){return new f({uri:n,index:0,name:(0,A.$5f)(n)},{uri:n.toString()})}e.$Kh=b,e.$Lh="code-workspace",e.$Mh=`.${e.$Lh}`,e.$Nh=[{name:(0,L.localize)(0,null),extensions:[e.$Lh]}],e.$Oh="workspace.json";function w(n,i){return A.$Zf.isEqualOrParent(n,i.untitledWorkspacesHome)}e.$Ph=w;function I(n){let i;return j.URI.isUri(n)?i=n:i=n.configuration,i?.scheme===S.Schemas.tmp}e.$Qh=I,e.$Rh="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(n){return n.id===e.$Rh}e.$Sh=t;function o(n,i){return!w(n,i)&&!I(n)}e.$Th=o;function s(n){return(typeof n=="string"?(0,N.$ad)(n):(0,A.$7f)(n))===e.$Mh}e.$Uh=s}),define(ce[17],le([0,1,51,3,2,22,10,167,15,13,4,7,113,35,27,5,32,28,11]),function(ie,e,L,N,O,A,j,R,S,g,C,y,$,u,d,p,c,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.ProfileResourceType=void 0;var b;(function(n){n.Settings="settings",n.Keybindings="keybindings",n.Snippets="snippets",n.Tasks="tasks",n.Extensions="extensions",n.GlobalState="globalState"})(b||(e.ProfileResourceType=b={}));function w(n){const i=n;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&j.URI.isUri(i.location)&&j.URI.isUri(i.globalStorageHome)&&j.URI.isUri(i.settingsResource)&&j.URI.isUri(i.keybindingsResource)&&j.URI.isUri(i.tasksResource)&&j.URI.isUri(i.snippetsHome)&&j.URI.isUri(i.extensionsResource))}e.$qk=w,e.$rk=(0,C.$ph)("IUserDataProfilesService");function I(n,i){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,location:j.URI.revive(n.location).with({scheme:i}),globalStorageHome:j.URI.revive(n.globalStorageHome).with({scheme:i}),settingsResource:j.URI.revive(n.settingsResource).with({scheme:i}),keybindingsResource:j.URI.revive(n.keybindingsResource).with({scheme:i}),tasksResource:j.URI.revive(n.tasksResource).with({scheme:i}),snippetsHome:j.URI.revive(n.snippetsHome).with({scheme:i}),extensionsResource:j.URI.revive(n.extensionsResource).with({scheme:i}),cacheHome:j.URI.revive(n.cacheHome).with({scheme:i}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.$sk=I;function t(n,i,r,a,v,m){return{id:n,name:i,location:r,isDefault:!1,shortName:v?.shortName,globalStorageHome:m&&v?.useDefaultFlags?.globalState?m.globalStorageHome:(0,A.$9f)(r,"globalStorage"),settingsResource:m&&v?.useDefaultFlags?.settings?m.settingsResource:(0,A.$9f)(r,"settings.json"),keybindingsResource:m&&v?.useDefaultFlags?.keybindings?m.keybindingsResource:(0,A.$9f)(r,"keybindings.json"),tasksResource:m&&v?.useDefaultFlags?.tasks?m.tasksResource:(0,A.$9f)(r,"tasks.json"),snippetsHome:m&&v?.useDefaultFlags?.snippets?m.snippetsHome:(0,A.$9f)(r,"snippets"),extensionsResource:m&&v?.useDefaultFlags?.extensions?m.extensionsResource:(0,A.$9f)(r,"extensions.json"),cacheHome:(0,A.$9f)(a,n),useDefaultFlags:v?.useDefaultFlags,isTransient:v?.transient}}e.$tk=t;let o=class extends O.$lb{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.v.profiles,...this.m.profiles]}constructor(i,r,a,v){super(),this.n=i,this.r=r,this.s=a,this.t=v,this.f=!0,this.h=this.B(new N.$ec),this.onDidChangeProfiles=this.h.event,this.i=this.B(new N.$ec),this.onWillCreateProfile=this.i.event,this.j=this.B(new N.$ec),this.onWillRemoveProfile=this.j.event,this.k=this.B(new N.$ec),this.onDidResetWorkspaces=this.k.event,this.l=new Map,this.m={profiles:[],workspaces:new u.$ni,emptyWindows:new Map},this.profilesHome=(0,A.$9f)(this.n.userRoamingDataHome,"profiles"),this.g=(0,A.$9f)(this.n.cacheHome,"CachedProfilesData")}init(){this.u=void 0}setEnablement(i){this.f!==i&&(this.u=void 0,this.f=i)}isEnabled(){return this.f}get v(){if(!this.u){const i=this.w(),r=[i];if(this.f)try{for(const m of this.J()){if(!m.name||!(0,f.$ie)(m.name)||!m.location){this.t.warn("Skipping the invalid stored profile",m.location||m.name);continue}r.push(t((0,A.$6f)(m.location),m.name,m.location,this.g,{shortName:m.shortName,useDefaultFlags:m.useDefaultFlags},i))}}catch(m){this.t.error(m)}const a=new u.$ni,v=new Map;if(r.length)try{const m=this.M();if(m.workspaces)for(const[l,E]of Object.entries(m.workspaces)){const D=j.URI.parse(l),T=r.find(M=>M.id===E);T&&a.set(D,T)}if(m.emptyWindows)for(const[l,E]of Object.entries(m.emptyWindows)){const D=r.find(T=>T.id===E);D&&v.set(l,D)}}catch(m){this.t.error(m)}this.u={profiles:r,workspaces:a,emptyWindows:v}}return this.u}w(){const i=t("__default__profile__",(0,R.localize)(0,null),this.n.userRoamingDataHome,this.g);return{...i,extensionsResource:this.O()??i.extensionsResource,isDefault:!0}}async createTransientProfile(i){const r="Temp",a=new RegExp(`${(0,h.$pd)(r)}\\s(\\d+)`);let v=0;for(const l of this.profiles){const E=a.exec(l.name),D=E?parseInt(E[1]):0;v=D>v?D:v}const m=`${r} ${v+1}`;return this.createProfile((0,L.$di)((0,c.$3e)()).toString(16),m,{transient:!0},i)}async createNamedProfile(i,r,a){return this.createProfile((0,L.$di)((0,c.$3e)()).toString(16),i,r,a)}async createProfile(i,r,a,v){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const m=await this.y(i,r,a);return v&&await this.setProfileForWorkspace(v,m),m}async y(i,r,a){if(!(0,f.$ie)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let v=this.l.get(r);return v||(v=(async()=>{try{const m=this.profiles.find(D=>D.name===r||D.id===i);if(m)return m;const l=t(i,r,(0,A.$9f)(this.profilesHome,i),this.g,a,this.defaultProfile);await this.r.createFolder(l.location);const E=[];return this.i.fire({profile:l,join(D){E.push(D)}}),await p.Promises.settled(E),this.D([l],[],[]),l}finally{this.l.delete(r)}})(),this.l.set(r,v)),v}async updateProfile(i,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let a=this.profiles.find(v=>v.id===i.id);if(!a)throw new Error(`Profile '${i.name}' does not exist`);return a=t(a.id,r.name??a.name,a.location,this.g,{shortName:r.shortName??a.shortName,transient:r.transient??a.isTransient,useDefaultFlags:r.useDefaultFlags??a.useDefaultFlags},this.defaultProfile),this.D([],[],[a]),a}async removeProfile(i){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(i.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(v=>v.id===i.id);if(!r)throw new Error(`Profile '${i.name}' does not exist`);const a=[];this.j.fire({profile:r,join(v){a.push(v)}});try{await Promise.allSettled(a)}catch(v){this.t.error(v)}for(const v of[...this.v.emptyWindows.keys()])r.id===this.v.emptyWindows.get(v)?.id&&this.v.emptyWindows.delete(v);for(const v of[...this.v.workspaces.keys()])r.id===this.v.workspaces.get(v)?.id&&this.v.workspaces.delete(v);this.H(),this.D([],[r],[]);try{await this.r.del(r.cacheHome,{recursive:!0})}catch(v){(0,g.$9j)(v)!==1&&this.t.error(v)}}async setProfileForWorkspace(i,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const a=this.profiles.find(v=>v.id===r.id);if(!a)throw new Error(`Profile '${r.name}' does not exist`);this.G(i,a)}unsetWorkspace(i,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.G(i,void 0,r)}async resetWorkspaces(){this.m.workspaces.clear(),this.m.emptyWindows.clear(),this.v.workspaces.clear(),this.v.emptyWindows.clear(),this.H(),this.k.fire()}async cleanUp(){if(this.f&&await this.r.exists(this.profilesHome)){const i=await this.r.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(r=>r.isDirectory&&this.profiles.every(a=>!this.s.extUri.isEqual(a.location,r.resource))).map(r=>this.r.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const i=this.m.profiles.filter(r=>!this.C(r));await Promise.allSettled(i.map(r=>this.removeProfile(r)))}getProfileForWorkspace(i){const r=this.z(i);return j.URI.isUri(r)?this.m.workspaces.get(r)??this.v.workspaces.get(r):this.m.emptyWindows.get(r)??this.v.emptyWindows.get(r)}z(i){return(0,$.$zh)(i)?i.uri:(0,$.$Eh)(i)?i.configPath:i.id}C(i){return!!([...this.m.emptyWindows.values()].some(r=>this.s.extUri.isEqual(r.location,i.location))||[...this.m.workspaces.values()].some(r=>this.s.extUri.isEqual(r.location,i.location))||[...this.v.emptyWindows.values()].some(r=>this.s.extUri.isEqual(r.location,i.location))||[...this.v.workspaces.values()].some(r=>this.s.extUri.isEqual(r.location,i.location)))}D(i,r,a){const v=[...this.profiles,...i],m=[];this.m.profiles=[];for(let l of v)l.isDefault||r.some(E=>l.id===E.id)||(l=a.find(E=>l.id===E.id)??l,l.isTransient?this.m.profiles.push(l):m.push({location:l.location,name:l.name,shortName:l.shortName,useDefaultFlags:l.useDefaultFlags}));this.L(m),this.u=void 0,this.F(i,r,a)}F(i,r,a){this.h.fire({added:i,removed:r,updated:a,all:this.profiles})}G(i,r,a){a=r?.isTransient?!0:a,a||this.G(i,void 0,!0);const v=this.z(i),m=a?this.m:this.v;j.URI.isUri(v)?(m.workspaces.delete(v),r&&m.workspaces.set(v,r)):(m.emptyWindows.delete(v),r&&m.emptyWindows.set(v,r)),a||this.H()}H(){const i={};for(const[a,v]of this.v.workspaces.entries())i[a.toString()]=v.id;const r={};for(const[a,v]of this.v.emptyWindows.entries())r[a.toString()]=v.id;this.N({workspaces:i,emptyWindows:r}),this.u=void 0}I(i){const r={},a=this.w();if(i.workspaces)for(const[m,l]of Object.entries(i.workspaces)){const E=j.URI.parse(l);r[m]=this.s.extUri.isEqual(E,a.location)?a.id:this.s.extUri.basename(E)}const v={};if(i.emptyWindows)for(const[m,l]of Object.entries(i.emptyWindows)){const E=j.URI.parse(l);v[m]=this.s.extUri.isEqual(E,a.location)?a.id:this.s.extUri.basename(E)}return{workspaces:r,emptyWindows:v}}J(){return[]}L(i){throw new Error("not implemented")}M(){return{}}N(i){throw new Error("not implemented")}O(){}};e.$uk=o,e.$uk=o=ye([K(0,S.$wh),K(1,g.$Sj),K(2,d.$pk),K(3,y.$Ri)],o);class s extends o{constructor(){super(...arguments),this.a=[],this.R={}}J(){return this.a}L(i){this.a=i}M(){return this.R}N(i){this.R=i}}e.$vk=s}),define(ce[240],le([0,1,5,2,17]),function(ie,e,L,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l7b=void 0;let A=class extends N.$lb{constructor(R){super(),this.B(new L.$Gg(()=>{R.cleanUp()},10*1e3)).schedule()}};e.$l7b=A,e.$l7b=A=ye([K(0,O.$rk)],A)}),define(ce[241],le([0,1,20,5,25,8,3,2,6,11,10,150,29,33,45,7,23,21,27,17]),function(ie,e,L,N,O,A,j,R,S,g,C,y,$,u,d,p,c,h,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_o=e.$$o=e.$0o=e.$9o=void 0;let w=class extends R.$lb{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}get onDidUpdateExtensionMetadata(){return this.s.event}constructor(i,r,a,v,m,l){super(),this.u=i,this.v=r,this.w=a,this.y=v,this.z=m,this.C=l,this.h=0,this.j=new Map,this.k=new Map,this.l=this.B(new j.$ec),this.m=this.B(new j.$ec),this.n=this.B(new j.$ec),this.p=this.B(new j.$ec),this.s=this.B(new j.$ec),this.t=[],this.B((0,R.$jb)(()=>{this.j.forEach(({task:E})=>E.cancel()),this.k.forEach(E=>E.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(i){const r=await this.getTargetPlatform();return i.allTargetPlatforms.some(a=>(0,$.$On)(a,i.allTargetPlatforms,r))}async installFromGallery(i,r={}){try{const v=(await this.installGalleryExtensions([{extension:i,options:r}])).find(({identifier:m})=>(0,u.$ho)(m,i.identifier));if(v?.local)return v?.local;throw v?.error?v.error:t(new Error(`Unknown error while installing extension ${i.identifier.id}`))}catch(a){throw t(a)}}async installGalleryExtensions(i){if(!this.u.isEnabled())throw new $.$Sn(y.localize(0,null),$.ExtensionManagementErrorCode.Internal);const r=[],a=[];await Promise.allSettled(i.map(async({extension:v,options:m})=>{try{const l=await this.J(v,!!m?.installGivenVersion,!!m?.installPreReleaseVersion);a.push({...l,options:m})}catch(l){r.push({identifier:v.identifier,operation:2,source:v,error:l})}})),a.length&&r.push(...await this.D(a));for(const v of r)v.error&&(this.y.error("Failed to install extension.",v.identifier.id),this.y.error(v.error),v.source&&!C.URI.isUri(v.source)&&o(this.v,"extensionGallery:install",{extensionData:(0,u.$po)(v.source),error:v.error}));return r}async uninstall(i,r={}){return this.y.trace("ExtensionManagementService#uninstall",i.identifier.id),this.M(i,r)}async toggleAppliationScope(i,r){if((0,d.$Ll)(i.manifest)||i.isBuiltin)return i;if(i.isApplicationScoped){let a=await this.updateMetadata(i,{isApplicationScoped:!1},this.C.defaultProfile.extensionsResource);this.w.extUri.isEqual(r,this.C.defaultProfile.extensionsResource)||(a=await this.X(i,this.C.defaultProfile.extensionsResource,r));for(const v of this.C.profiles){const m=(await this.getInstalled(1,v.extensionsResource)).find(l=>(0,u.$ho)(l.identifier,i.identifier));m?this.s.fire(m):this.p.fire({identifier:i.identifier,profileLocation:v.extensionsResource})}return a}else{const a=this.w.extUri.isEqual(r,this.C.defaultProfile.extensionsResource)?await this.updateMetadata(i,{isApplicationScoped:!0},this.C.defaultProfile.extensionsResource):await this.X(i,r,this.C.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.m.fire([{identifier:a.identifier,operation:2,local:a,profileLocation:this.C.defaultProfile.extensionsResource,applicationScoped:!0}]),a}}getExtensionsControlManifest(){const i=new Date().getTime();return(!this.g||i-this.h>1e3*60*5)&&(this.g=this.R(),this.h=i),this.g}registerParticipant(i){this.t.push(i)}async D(i){const r=[];return await Promise.allSettled(i.map(async a=>{try{const v=await this.F(a);r.push(...v)}catch(v){r.push({identifier:{id:(0,u.$mo)(a.manifest.publisher,a.manifest.name)},operation:2,source:a.extension,error:v})}})),this.m.fire(r),r}async F({manifest:i,extension:r,options:a}){const v=a.isApplicationScoped||a.isBuiltin||(0,d.$Ll)(i),m={...a,installOnlyNewlyAddedFromExtensionPack:C.URI.isUri(r)?a.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:v,profileLocation:v?this.C.defaultProfile.extensionsResource:a.profileLocation??this.S()},l=V=>`${u.$io.create(V).toString()}${m.profileLocation?`-${m.profileLocation.toString()}`:""}`;if(!C.URI.isUri(r)){const V=this.j.get(l(r));if(V)return this.y.info("Extensions is already requested to install",r.identifier.id),await V.task.waitUntilTaskIsFinished(),[]}const E=[],D=[],T=[],M=this.U(i,r,m);C.URI.isUri(r)||this.j.set(l(r),{task:M,waitingTasks:[]}),this.l.fire({identifier:M.identifier,source:r,profileLocation:m.profileLocation}),this.y.info("Installing extension:",M.identifier.id),E.push({task:M,manifest:i});let F=!1;try{if(m.donotIncludePackAndDependencies)this.y.info("Installing the extension without checking dependencies and pack",M.identifier.id);else try{const Z=await this.I(M.identifier,i,!!m.installOnlyNewlyAddedFromExtensionPack,!!m.installPreReleaseVersion,m.profileLocation),J=await this.getInstalled(void 0,m.profileLocation),Q={...m,donotIncludePackAndDependencies:!0,context:{...m.context,[$.$Jn]:!0}};for(const{gallery:G,manifest:X}of(0,L.$of)(Z,({gallery:W})=>W.identifier.id)){F=F||!!X.extensionDependencies?.some(B=>(0,u.$ho)({id:B},M.identifier));const W=l(G),q=this.j.get(W);if(q){if(this.G(M,q.task)){const B=q.task.identifier;this.y.info("Waiting for already requested installing extension",B.id,M.identifier.id),q.waitingTasks.push(M),D.push(j.Event.toPromise(j.Event.filter(this.onDidInstallExtensions,_=>_.some(oe=>(0,u.$ho)(oe.identifier,B)))).then(_=>{if(this.y.info("Finished waiting for already requested installing extension",B.id,M.identifier.id),!_.find(ae=>(0,u.$ho)(ae.identifier,B))?.local)throw new Error(`Extension ${B.id} is not installed`)}))}}else if(!J.some(({identifier:B})=>(0,u.$ho)(B,G.identifier))){const B=this.U(X,G,Q);this.j.set(W,{task:B,waitingTasks:[M]}),this.l.fire({identifier:B.identifier,source:G,profileLocation:m.profileLocation}),this.y.info("Installing extension:",B.identifier.id,M.identifier.id),E.push({task:B,manifest:X})}}}catch(Z){if(C.URI.isUri(M.source))(0,L.$nf)(i.extensionDependencies)&&this.y.warn("Cannot install dependencies of extension:",M.identifier.id,Z.message),(0,L.$nf)(i.extensionPack)&&this.y.warn("Cannot install packed extensions of extension:",M.identifier.id,Z.message);else throw this.y.error("Error while preparing to install dependencies and extension packs of the extension:",M.identifier.id),Z}const V=E.reduce((Z,{task:J,manifest:Q})=>(Z.set(J.identifier.id.toLowerCase(),{task:J,manifest:Q}),Z),new Map);for(;V.size;){let Z;const J=[...V.values()].filter(({manifest:Q})=>!Q.extensionDependencies?.some(G=>V.has(G.toLowerCase())));J.length?Z=V.size===1?J:J.filter(({task:Q})=>!(Q===M&&!F)):(this.y.info("Found extensions with circular dependencies",J.map(({task:Q})=>Q.identifier.id)),Z=[...V.values()]),await this.H(Z.map(async({task:Q})=>{const G=new Date().getTime();try{const X=await Q.run();if(await this.H(this.t.map(W=>W.postInstall(X,Q.source,m,O.CancellationToken.None))),!C.URI.isUri(Q.source)){const W=Q.operation===3,q=W?void 0:(new Date().getTime()-Q.source.lastUpdated)/1e3;if(o(this.v,W?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,u.$po)(Q.source),verificationStatus:Q.verificationStatus,duration:new Date().getTime()-G,durationSinceUpdate:q}),S.$o&&Q.operation!==3)try{await this.u.reportStatistic(X.manifest.publisher,X.manifest.name,X.manifest.version,"install")}catch{}}T.push({local:X,identifier:Q.identifier,operation:Q.operation,source:Q.source,context:Q.options.context,profileLocation:Q.profileLocation,applicationScoped:X.isApplicationScoped})}catch(X){throw C.URI.isUri(Q.source)||o(this.v,Q.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,u.$po)(Q.source),verificationStatus:Q.verificationStatus,duration:new Date().getTime()-G,error:X}),this.y.error("Error while installing the extension:",Q.identifier.id),X}finally{V.delete(Q.identifier.id.toLowerCase())}}))}return D.length&&await this.H(D),T.forEach(({identifier:Z})=>this.y.info("Extension installed successfully:",Z.id)),T}catch(V){if(E.forEach(({task:Z})=>Z.cancel()),T.length)try{const Z=await Promise.allSettled(T.map(({local:J})=>this.W(J,{versionOnly:!0,profileLocation:m.profileLocation}).run()));for(let J=0;J<Z.length;J++){const Q=Z[J],{identifier:G}=T[J];Q.status==="fulfilled"?this.y.info("Rollback: Uninstalled extension",G.id):this.y.warn("Rollback: Error while uninstalling extension",G.id,(0,A.$9)(Q.reason))}}catch(Z){this.y.warn("Error while rolling back extensions",(0,A.$9)(Z),T.map(({identifier:J})=>J.id))}return E.map(({task:Z})=>({identifier:Z.identifier,operation:2,source:Z.source,context:m.context,profileLocation:m.profileLocation,error:V}))}finally{for(const{task:V}of E)V.source&&!C.URI.isUri(V.source)&&this.j.delete(l(V.source))}}G(i,r){for(const[,{task:a,waitingTasks:v}]of this.j.entries())if(a===i&&(v.includes(r)||v.some(m=>this.G(m,r)))||a===r&&v[0]&&!this.G(i,v[0]))return!1;return!0}async H(i){const r=[],a=[],v=await Promise.allSettled(i);for(const m of v)m.status==="fulfilled"?r.push(m.value):a.push(m.reason);if(a.length)throw I(a);return r}async I(i,r,a,v,m){if(!this.u.isEnabled())return[];const l=await this.getInstalled(void 0,m),E=[],D=[],T=async(M,F)=>{E.push(M);const V=F.extensionDependencies||[],Z=[...V];if(F.extensionPack){const J=a?l.find(Q=>(0,u.$ho)(Q.identifier,M)):void 0;for(const Q of F.extensionPack)J&&J.manifest.extensionPack&&J.manifest.extensionPack.some(G=>(0,u.$ho)({id:G},{id:Q}))||Z.every(G=>!(0,u.$ho)({id:G},{id:Q}))&&Z.push(Q)}if(Z.length){const J=Z.filter(Q=>E.every(G=>!(0,u.$ho)(G,{id:Q})));if(J.length){const Q=await this.u.getExtensions(J.map(G=>({id:G,preRelease:v})),O.CancellationToken.None);for(const G of Q){if(E.find(q=>(0,u.$ho)(q,G.identifier)))continue;const X=V.some(q=>(0,u.$ho)({id:q},G.identifier));let W;try{W=await this.J(G,!1,v)}catch(q){if(X)throw q;this.y.info("Skipping the packed extension as it cannot be installed",G.identifier.id,(0,A.$9)(q));continue}D.push({gallery:W.extension,manifest:W.manifest}),await T(W.extension.identifier,W.manifest)}}}};return await T(i,r),D}async J(i,r,a){let v;const m=await this.getExtensionsControlManifest();if(m.malicious.some(D=>(0,u.$ho)(i.identifier,D)))throw new $.$Sn(y.localize(1,null,i.identifier.id),$.ExtensionManagementErrorCode.Malicious);const l=m.deprecated[i.identifier.id.toLowerCase()];if(l?.extension?.autoMigrate){if(this.y.info(`The '${i.identifier.id}' extension is deprecated, fetching the compatible '${l.extension.id}' extension instead.`),v=(await this.u.getExtensions([{id:l.extension.id,preRelease:l.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},O.CancellationToken.None))[0],!v)throw new $.$Sn(y.localize(2,null,i.identifier.id,l.extension.id),$.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(i)){const D=await this.getTargetPlatform();throw new $.$Sn(y.localize(3,null,i.identifier.id,this.z.nameLong,(0,$.$Kn)(D)),$.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(v=await this.L(i,r,a),!v)throw!a&&i.properties.isPreReleaseVersion&&(await this.u.getExtensions([i.identifier],O.CancellationToken.None))[0]?new $.$Sn(y.localize(4,null,i.identifier.id),$.ExtensionManagementErrorCode.ReleaseVersionNotFound):new $.$Sn(y.localize(5,null,i.identifier.id,this.z.nameLong,this.z.version),$.ExtensionManagementErrorCode.Incompatible)}this.y.info("Getting Manifest...",v.identifier.id);const E=await this.u.getManifest(v,O.CancellationToken.None);if(E===null)throw new $.$Sn(`Missing manifest for extension ${v.identifier.id}`,$.ExtensionManagementErrorCode.Invalid);if(E.version!==v.version)throw new $.$Sn(`Cannot install '${v.identifier.id}' extension because of version mismatch in Marketplace`,$.ExtensionManagementErrorCode.Invalid);return{extension:v,manifest:E}}async L(i,r,a){const v=await this.getTargetPlatform();let m=null;return!r&&i.hasPreReleaseVersion&&i.properties.isPreReleaseVersion!==a&&(m=(await this.u.getExtensions([{...i.identifier,preRelease:a}],{targetPlatform:v,compatible:!0},O.CancellationToken.None))[0]||null),!m&&await this.u.isExtensionCompatible(i,a,v)&&(m=i),m||(r?m=(await this.u.getExtensions([{...i.identifier,version:i.version}],{targetPlatform:v,compatible:!0},O.CancellationToken.None))[0]||null:m=await this.u.getCompatibleExtension(i,a,v)),m}async M(i,r){const a={...r,profileLocation:i.isApplicationScoped?this.C.defaultProfile.extensionsResource:r.profileLocation??this.S()},v=M=>`${M.id.toLowerCase()}${a.versionOnly?`-${i.manifest.version}`:""}${a.profileLocation?`@${a.profileLocation.toString()}`:""}`,m=this.k.get(v(i.identifier));if(m)return this.y.info("Extensions is already requested to uninstall",i.identifier.id),m.waitUntilTaskIsFinished();const l=M=>{const F=this.W(M,a);return this.k.set(v(F.extension.identifier),F),a.profileLocation?this.y.info("Uninstalling extension from the profile:",`${M.identifier.id}@${M.manifest.version}`,a.profileLocation.toString()):this.y.info("Uninstalling extension:",`${M.identifier.id}@${M.manifest.version}`),this.n.fire({identifier:M.identifier,profileLocation:a.profileLocation,applicationScoped:M.isApplicationScoped}),F},E=(M,F)=>{F?a.profileLocation?this.y.error("Failed to uninstall extension from the profile:",`${M.identifier.id}@${M.manifest.version}`,a.profileLocation.toString(),F.message):this.y.error("Failed to uninstall extension:",`${M.identifier.id}@${M.manifest.version}`,F.message):a.profileLocation?this.y.info("Successfully uninstalled extension from the profile",`${M.identifier.id}@${M.manifest.version}`,a.profileLocation.toString()):this.y.info("Successfully uninstalled extension:",`${M.identifier.id}@${M.manifest.version}`),o(this.v,"extensionGallery:uninstall",{extensionData:(0,u.$oo)(M),error:F}),this.p.fire({identifier:M.identifier,error:F?.code,profileLocation:a.profileLocation,applicationScoped:M.isApplicationScoped})},D=[],T=[];try{D.push(l(i));const M=await this.getInstalled(1,a.profileLocation);if(a.donotIncludePack)this.y.info("Uninstalling the extension without including packed extension",`${i.identifier.id}@${i.manifest.version}`);else{const F=this.P(i,M);for(const V of F)this.k.has(v(V.identifier))?this.y.info("Extensions is already requested to uninstall",V.identifier.id):D.push(l(V))}a.donotCheckDependents?this.y.info("Uninstalling the extension without checking dependents",`${i.identifier.id}@${i.manifest.version}`):this.N(D.map(F=>F.extension),M,i),await this.H(D.map(async F=>{try{if(await F.run(),await this.H(this.t.map(V=>V.postUninstall(F.extension,a,O.CancellationToken.None))),F.extension.identifier.uuid)try{await this.u.reportStatistic(F.extension.manifest.publisher,F.extension.manifest.name,F.extension.manifest.version,"uninstall")}catch{}E(F.extension)}catch(V){const Z=V instanceof $.$Sn?V:new $.$Sn((0,A.$9)(V),$.ExtensionManagementErrorCode.Internal);throw E(F.extension,Z),Z}finally{T.push(F)}}))}catch(M){const F=M instanceof $.$Sn?M:new $.$Sn((0,A.$9)(M),$.ExtensionManagementErrorCode.Internal);for(const V of D){try{V.cancel()}catch{}T.includes(V)||E(V.extension,F)}throw F}finally{for(const M of D)this.k.delete(v(M.extension.identifier))||this.y.warn("Uninstallation task is not found in the cache",M.extension.identifier.id)}}N(i,r,a){for(const v of i){const m=this.Q(v,r);if(m.length){const l=m.filter(E=>!i.some(D=>(0,u.$ho)(D.identifier,E.identifier)));if(l.length)throw new Error(this.O(v,l,a))}}}O(i,r,a){return a===i?r.length===1?y.localize(6,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?y.localize(7,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):y.localize(8,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?y.localize(9,null,a.manifest.displayName||a.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?y.localize(10,null,a.manifest.displayName||a.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):y.localize(11,null,a.manifest.displayName||a.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}P(i,r,a=[]){if(a.indexOf(i)!==-1)return[];a.push(i);const v=i.manifest.extensionPack?i.manifest.extensionPack:[];if(v.length){const m=r.filter(E=>!E.isBuiltin&&v.some(D=>(0,u.$ho)({id:D},E.identifier))),l=[];for(const E of m)l.push(...this.P(E,r,a));return[...m,...l]}return[]}Q(i,r){return r.filter(a=>a.manifest.extensionDependencies&&a.manifest.extensionDependencies.some(v=>(0,u.$ho)({id:v},i.identifier)))}async R(){try{this.y.trace("ExtensionManagementService.refreshReportedCache");const i=await this.u.getExtensionsControlManifest();return this.y.trace("ExtensionManagementService.refreshControlCache",i),i}catch{return this.y.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.$9o=w,e.$9o=w=ye([K(0,$.$Rn),K(1,h.$Vk),K(2,f.$pk),K(3,p.$Ri),K(4,c.$0i),K(5,b.$rk)],w);function I(n){const i=Array.isArray(n)?n:[n];return i.length===1?i[0]instanceof Error?i[0]:new Error(i[0]):i.reduce((r,a)=>new Error(`${r.message}${r.message?",":""}${a instanceof Error?a.message:a}`),new Error(""))}e.$0o=I;function t(n){if(n instanceof $.$Sn)return n;const i=new $.$Sn(n.message,$.ExtensionManagementErrorCode.Internal);return i.stack=n.stack,i}e.$$o=t;function o(n,i,{extensionData:r,verificationStatus:a,duration:v,error:m,durationSinceUpdate:l}){let E,D;(0,g.$qe)(a)&&(a===!0?a="Verified":(a===!1||(E=$.ExtensionManagementErrorCode.Signature,D=a),a="Unverified")),m&&(m instanceof $.$Sn?(E=m.code,m.code===$.ExtensionManagementErrorCode.Signature&&(D=m.message)):E=$.ExtensionManagementErrorCode.Internal),n.publicLog(i,{...r,verificationStatus:a,success:!m,duration:v,errorcode:E,errorcodeDetail:D,durationSinceUpdate:l})}class s{constructor(){this.d=new N.$tg}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,N.$ig)(i=>this.h(i))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,N.$ig)(i=>new Promise((r,a)=>{const v=i.onCancellationRequested(()=>{v.dispose(),a(new A.$3)})})),this.d.open()),this.g.cancel()}}e.$_o=s}),define(ce[50],le([0,1,5,14,2,3,35,10,29,33,13,4,7,17,27,11,8,21]),function(ie,e,L,N,O,A,j,R,S,g,C,y,$,u,d,p,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cp=e.$bp=e.$ap=e.ExtensionsProfileScanningErrorCode=void 0;var f;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(f||(e.ExtensionsProfileScanningErrorCode=f={}));class b extends Error{constructor(s,n){super(s),this.code=n}}e.$ap=b,e.$bp=(0,y.$ph)("IExtensionsProfileScannerService");let w=class extends O.$lb{constructor(s,n,i,r,a,v){super(),this.i=s,this.j=n,this.k=i,this.l=r,this.m=a,this.n=v,this.b=this.B(new A.$ec),this.onAddExtensions=this.b.event,this.c=this.B(new A.$ec),this.onDidAddExtensions=this.c.event,this.f=this.B(new A.$ec),this.onRemoveExtensions=this.f.event,this.g=this.B(new A.$ec),this.onDidRemoveExtensions=this.g.event,this.h=new j.$ni}scanProfileExtensions(s,n){return this.p(s,void 0,n)}async addExtensionsToProfile(s,n){const i=[],r=[];try{return await this.p(n,a=>{const v=[];for(const m of a)s.some(([l])=>(0,g.$ho)(l.identifier,m.identifier)&&l.manifest.version!==m.version)?i.push(m):v.push(m);for(const[m,l]of s){const E=v.findIndex(T=>(0,g.$ho)(T.identifier,m.identifier)&&T.version===m.manifest.version),D={identifier:m.identifier,version:m.manifest.version,location:m.location,metadata:l};E===-1?(r.push(D),v.push(D)):v.splice(E,1,D)}return r.length&&this.b.fire({extensions:r,profileLocation:n}),i.length&&this.f.fire({extensions:i,profileLocation:n}),v}),r.length&&this.c.fire({extensions:r,profileLocation:n}),i.length&&this.g.fire({extensions:i,profileLocation:n}),r}catch(a){throw r.length&&this.c.fire({extensions:r,error:a,profileLocation:n}),i.length&&this.g.fire({extensions:i,error:a,profileLocation:n}),a}}async updateMetadata(s,n){const i=[];return await this.p(n,r=>{const a=[];for(const v of r){const m=s.find(([l])=>(0,g.$ho)(l.identifier,v.identifier)&&l.manifest.version===v.version);m&&(v.metadata={...v.metadata,...m[1]},i.push(v)),a.push(v)}return a}),i}async removeExtensionFromProfile(s,n){const i=[];try{await this.p(n,r=>{const a=[];for(const v of r)(0,g.$ho)(v.identifier,s.identifier)?i.push(v):a.push(v);return i.length&&this.f.fire({extensions:i,profileLocation:n}),a}),i.length&&this.g.fire({extensions:i,profileLocation:n})}catch(r){throw i.length&&this.g.fire({extensions:i,error:r,profileLocation:n}),r}}async p(s,n,i){return this.w(s).queue(async()=>{let r=[],a;try{const v=await this.j.readFile(s);a=JSON.parse(v.value.toString().trim()||"[]")}catch(v){if((0,C.$9j)(v)!==1)throw v;if(this.l.extUri.isEqual(s,this.k.defaultProfile.extensionsResource)&&(a=await this.v()),!a&&i?.bailOutWhenFileNotFound)throw new b((0,c.$9)(v),"ERROR_PROFILE_NOT_FOUND")}if(a){Array.isArray(a)||this.r(s);let v=!1;for(const m of a){I(m)||this.r(s);let l;if((0,p.$ie)(m.relativeLocation)&&m.relativeLocation)l=this.t(m.relativeLocation);else if((0,p.$ie)(m.location))l=this.t(m.location),v=!0,m.relativeLocation=m.location,m.location=l.toJSON();else{l=R.URI.revive(m.location);const E=this.s(l);E&&(v=!0,m.relativeLocation=E)}r.push({identifier:m.identifier,location:l,version:m.version,metadata:m.metadata})}v&&await this.j.writeFile(s,N.$Ec.fromString(JSON.stringify(a)))}if(n){r=n(r);const v=r.map(m=>({identifier:m.identifier,version:m.version,location:m.location.toJSON(),relativeLocation:this.s(m.location),metadata:m.metadata}));await this.j.writeFile(s,N.$Ec.fromString(JSON.stringify(v)))}return r})}r(s){const n=new b(`Invalid extensions content in ${s.toString()}`,"ERROR_INVALID_CONTENT");throw this.m.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}s(s){return this.l.extUri.isEqual(this.l.extUri.dirname(s),this.i)?this.l.extUri.basename(s):void 0}t(s){return this.l.extUri.joinPath(this.i,s)}async v(){return this.u||(this.u=(async()=>{const s=this.l.extUri.joinPath(this.k.defaultProfile.location,"extensions.json"),n=this.l.extUri.joinPath(this.i,".init-default-profile-extensions");let i;try{i=(await this.j.readFile(s)).value.toString()}catch(a){if((0,C.$9j)(a)===1)return;throw a}this.n.info("Migrating extensions from old default profile location",s.toString());let r;try{const a=JSON.parse(i);Array.isArray(a)&&a.every(v=>I(v))?r=a:this.n.warn("Skipping migrating from old default profile locaiton: Found invalid data",a)}catch(a){this.n.error(a)}if(r)try{await this.j.createFile(this.k.defaultProfile.extensionsResource,N.$Ec.fromString(JSON.stringify(r)),{overwrite:!1}),this.n.info("Migrated extensions from old default profile location to new location",s.toString(),this.k.defaultProfile.extensionsResource.toString())}catch(a){if((0,C.$9j)(a)===3)this.n.info("Migration from old default profile location to new location is done by another window",s.toString(),this.k.defaultProfile.extensionsResource.toString());else throw a}try{await this.j.del(s)}catch(a){(0,C.$9j)(a)!==1&&this.n.error(a)}try{await this.j.del(n)}catch(a){(0,C.$9j)(a)!==1&&this.n.error(a)}return r})()),this.u}w(s){let n=this.h.get(s);return n||(n=new L.$Bg,this.h.set(s,n)),n}};e.$cp=w,e.$cp=w=ye([K(1,C.$Sj),K(2,u.$rk),K(3,d.$pk),K(4,h.$Vk),K(5,$.$Ri)],w);function I(o){return(0,p.$ke)(o)&&(0,S.$Qn)(o.identifier)&&(t(o.location)||(0,p.$ie)(o.location)&&o.location)&&((0,p.$pe)(o.relativeLocation)||(0,p.$ie)(o.relativeLocation))&&o.version&&(0,p.$ie)(o.version)}function t(o){return o?(0,p.$ie)(o.path)&&(0,p.$ie)(o.scheme):!1}}),define(ce[79],le([0,1,20,5,30,14,8,34,137,2,26,16,6,22,53,89,11,10,153,15,33,45,67,13,4,7,23,3,63,50,17,27,181]),function(ie,e,L,N,O,A,j,R,S,g,C,y,$,u,d,p,c,h,f,b,w,I,t,o,s,n,i,r,a,v,m,l,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jp=e.$ip=e.$hp=e.$gp=e.$fp=e.Translations=void 0;var D;(function(Q){function G(X,W){if(X===W)return!0;const q=Object.keys(X),B=new Set;for(const _ of Object.keys(W))B.add(_);if(q.length!==B.size)return!1;for(const _ of q){if(X[_]!==W[_])return!1;B.delete(_)}return B.size===0}Q.equals=G})(D||(e.Translations=D={})),e.$fp=(0,s.$ph)("IExtensionsScannerService");let T=class extends g.$lb{constructor(G,X,W,q,B,_,oe,ae,Y,U,k,P){super(),this.systemExtensionsLocation=G,this.userExtensionsLocation=X,this.l=W,this.m=q,this.n=B,this.r=_,this.s=oe,this.t=ae,this.u=Y,this.v=U,this.w=k,this.y=P,this.g=this.B(new r.$ec),this.onDidChangeCache=this.g.event,this.h=(0,u.$9f)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.y.createInstance(V,this.m,this.h)),this.j=this.B(this.y.createInstance(V,this.m,this.h)),this.k=this.B(this.y.createInstance(F,this.h)),this.C=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.z||(this.z=(0,w.$so)(this.s,this.t)),this.z}async scanAllExtensions(G,X,W){const[q,B]=await Promise.all([this.scanSystemExtensions(G),this.scanUserExtensions(X)]),_=W?await this.scanExtensionsUnderDevelopment(G,[...q,...B]):[];return this.G(q,B,_,await this.getTargetPlatform(),!0)}async scanSystemExtensions(G){const X=[];X.push(this.H(!!G.useCache,G.language)),X.push(this.I(G.language,!!G.checkControlFile));const[W,q]=await Promise.all(X);return this.F([...W,...q],0,G,!1)}async scanUserExtensions(G){const X=G.profileLocation??this.userExtensionsLocation;this.t.trace("Started scanning user extensions",X);const W=this.w.extUri.isEqual(G.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,q=await this.L(X,!!G.profileLocation,1,!G.includeUninstalled,G.language,!0,W),B=G.useCache&&!q.devMode&&q.excludeObsolete?this.j:this.k;let _;try{_=await B.scanExtensions(q)}catch(oe){if(oe instanceof v.$ap&&oe.code==="ERROR_PROFILE_NOT_FOUND")await this.D(),_=await B.scanExtensions(q);else throw oe}return _=await this.F(_,1,G,!0),this.t.trace("Scanned user extensions:",_.length),_}async scanExtensionsUnderDevelopment(G,X){if(this.u.isExtensionDevelopment&&this.u.extensionDevelopmentLocationURI){const W=(await Promise.all(this.u.extensionDevelopmentLocationURI.filter(q=>q.scheme===C.Schemas.file).map(async q=>{const B=await this.L(q,!1,1,!0,G.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(B)).map(oe=>(oe.type=X.find(ae=>(0,w.$ho)(ae.identifier,oe.identifier))?.type??oe.type,this.k.validate(oe,B)))}))).flat();return this.F(W,"development",G,!0)}return[]}async scanExistingExtension(G,X,W){const q=await this.L(G,!1,X,!0,W.language,!0,void 0),B=await this.k.scanExtension(q);return!B||!W.includeInvalid&&!B.isValid?null:B}async scanOneOrMultipleExtensions(G,X,W){const q=await this.L(G,!1,X,!0,W.language,!0,void 0),B=await this.k.scanOneOrMultipleExtensions(q);return this.F(B,X,W,!0)}async scanMetadata(G){const X=(0,u.$9f)(G,"package.json"),W=(await this.s.readFile(X)).value.toString();return JSON.parse(W).__metadata}async updateMetadata(G,X){const W=(0,u.$9f)(G,"package.json"),q=(await this.s.readFile(W)).value.toString(),B=JSON.parse(q);X.isMachineScoped=X.isMachineScoped||void 0,X.isBuiltin=X.isBuiltin||void 0,B.__metadata={...B.__metadata,...X},await this.s.writeFile((0,u.$9f)(G,"package.json"),A.$Ec.fromString(JSON.stringify(B,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.r.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(G){if(G instanceof v.$ap&&G.code==="ERROR_PROFILE_NOT_FOUND")await this.D();else throw G}}async D(){return this.C||(this.C=(async()=>{try{this.t.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const G=await this.scanUserExtensions({includeInvalid:!0});if(G.length)await this.r.addExtensionsToProfile(G.map(X=>[X,X.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.s.createFile(this.n.defaultProfile.extensionsResource,A.$Ec.fromString(JSON.stringify([])))}catch(X){(0,o.$9j)(X)!==1&&this.t.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,j.$9)(X))}this.t.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(G){this.t.error(G)}finally{this.C=void 0}})()),this.C}async F(G,X,W,q){return W.includeAllVersions||(G=this.G(X===0?G:void 0,X===1?G:void 0,X==="development"?G:void 0,await this.getTargetPlatform(),q)),W.includeInvalid||(G=G.filter(B=>B.isValid)),G.sort((B,_)=>{const oe=y.$_c(B.location.fsPath),ae=y.$_c(_.location.fsPath);return oe<ae?-1:oe>ae?1:0})}G(G,X,W,q,B){const _=(ae,Y,U)=>{if(ae.isValid&&!Y.isValid)return!1;if(ae.isValid===Y.isValid){if(B&&d.gt(ae.manifest.version,Y.manifest.version))return this.t.debug(`Skipping extension ${Y.location.path} with lower version ${Y.manifest.version} in favour of ${ae.location.path} with version ${ae.manifest.version}`),!1;if(d.eq(ae.manifest.version,Y.manifest.version)){if(ae.type===0)return this.t.debug(`Skipping extension ${Y.location.path} in favour of system extension ${ae.location.path} with same version`),!1;if(ae.targetPlatform===q)return this.t.debug(`Skipping extension ${Y.location.path} from different target platform ${Y.targetPlatform}`),!1}}return U?this.t.warn(`Overwriting user extension ${ae.location.path} with ${Y.location.path}.`):this.t.debug(`Overwriting user extension ${ae.location.path} with ${Y.location.path}.`),!0},oe=new I.$Kl;return G?.forEach(ae=>{const Y=oe.get(ae.identifier.id);(!Y||_(Y,ae,!1))&&oe.set(ae.identifier.id,ae)}),X?.forEach(ae=>{const Y=oe.get(ae.identifier.id);if(!Y&&G&&ae.type===0){this.t.debug(`Skipping obsolete system extension ${ae.location.path}.`);return}(!Y||_(Y,ae,!1))&&oe.set(ae.identifier.id,ae)}),W?.forEach(ae=>{const Y=oe.get(ae.identifier.id);(!Y||_(Y,ae,!0))&&oe.set(ae.identifier.id,ae),oe.set(ae.identifier.id,ae)}),[...oe.values()]}async H(G,X){this.t.trace("Started scanning system extensions");const W=await this.L(this.systemExtensionsLocation,!1,0,!0,X,!0,void 0),B=await(G&&!W.devMode?this.i:this.k).scanExtensions(W);return this.t.trace("Scanned system extensions:",B.length),B}async I(G,X){const W=this.u.isBuilt?[]:this.v.builtInExtensions;if(!W?.length)return[];this.t.trace("Started scanning dev system extensions");const q=X?await this.J():{},B=[],_=h.URI.file(y.$6c(y.$8c(C.$1e.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ae of W){const Y=q[ae.name]||"marketplace";switch(Y){case"disabled":break;case"marketplace":B.push((0,u.$9f)(_,ae.name));break;default:B.push(h.URI.file(Y));break}}const oe=await Promise.all(B.map(async ae=>this.k.scanExtension(await this.L(ae,!1,0,!0,G,!0,void 0))));return this.t.trace("Scanned dev system extensions:",oe.length),(0,L.$jf)(oe)}async J(){try{const G=await this.s.readFile(this.l);return JSON.parse(G.value.toString())}catch{return{}}}async L(G,X,W,q,B,_,oe){const ae=await this.f(B??$.$v),Y=await this.M(G),U=X&&!this.w.extUri.isEqual(G,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,k=U?await this.M(U):void 0;return new M(G,Y,U,k,X,oe,W,q,_,this.v.version,this.v.date,this.v.commit,!this.u.isBuilt,B,ae)}async M(G){try{const X=await this.s.stat(G);if(typeof X.mtime=="number")return X.mtime}catch{}}};e.$gp=T,e.$gp=T=ye([K(4,m.$rk),K(5,v.$bp),K(6,o.$Sj),K(7,n.$Ri),K(8,b.$wh),K(9,i.$0i),K(10,l.$pk),K(11,s.$oh)],T);class M{constructor(G,X,W,q,B,_,oe,ae,Y,U,k,P,z,H,ee){this.location=G,this.mtime=X,this.applicationExtensionslocation=W,this.applicationExtensionslocationMtime=q,this.profile=B,this.profileScanOptions=_,this.type=oe,this.excludeObsolete=ae,this.validate=Y,this.productVersion=U,this.productDate=k,this.productCommit=P,this.devMode=z,this.language=H,this.translations=ee}static createNlsConfiguration(G){return{language:G.language,pseudo:G.language==="pseudo",devMode:G.devMode,translations:G.translations}}static equals(G,X){return(0,u.$2f)(G.location,X.location)&&G.mtime===X.mtime&&(0,u.$2f)(G.applicationExtensionslocation,X.applicationExtensionslocation)&&G.applicationExtensionslocationMtime===X.applicationExtensionslocationMtime&&G.profile===X.profile&&O.$Mm(G.profileScanOptions,X.profileScanOptions)&&G.type===X.type&&G.excludeObsolete===X.excludeObsolete&&G.validate===X.validate&&G.productVersion===X.productVersion&&G.productDate===X.productDate&&G.productCommit===X.productCommit&&G.devMode===X.devMode&&G.language===X.language&&D.equals(G.translations,X.translations)}}e.$hp=M;let F=class extends g.$lb{constructor(G,X,W,q,B){super(),this.f=G,this.g=X,this.h=W,this.i=q,this.j=B}async scanExtensions(G){const X=G.profile?await this.l(G):await this.k(G);let W={};if(G.excludeObsolete&&G.type===1)try{const q=(await this.i.readFile(this.f)).value.toString();W=JSON.parse(q)}catch{}return(0,c.$ve)(W)?X:X.filter(q=>!W[w.$io.create(q).toString()])}async k(G){const X=await this.i.resolve(G.location);if(!X.children?.length)return[];const W=await Promise.all(X.children.map(async q=>{if(!q.isDirectory||G.type===1&&(0,u.$6f)(q.resource).indexOf(".")===0)return null;const B=new M(q.resource,G.mtime,G.applicationExtensionslocation,G.applicationExtensionslocationMtime,G.profile,G.profileScanOptions,G.type,G.excludeObsolete,G.validate,G.productVersion,G.productDate,G.productCommit,G.devMode,G.language,G.translations);return this.scanExtension(B)}));return(0,L.$jf)(W).sort((q,B)=>q.location.path<B.location.path?-1:1)}async l(G){let X=await this.m(G.location,()=>!0,G);if(G.applicationExtensionslocation&&!this.h.extUri.isEqual(G.location,G.applicationExtensionslocation)){X=X.filter(q=>!q.metadata?.isApplicationScoped);const W=await this.m(G.applicationExtensionslocation,q=>!!q.metadata?.isBuiltin||!!q.metadata?.isApplicationScoped,G);X.push(...W)}return X}async m(G,X,W){const q=await this.g.scanProfileExtensions(G,W.profileScanOptions);if(!q.length)return[];const B=await Promise.all(q.map(async _=>{if(X(_)){const oe=new M(_.location,W.mtime,W.applicationExtensionslocation,W.applicationExtensionslocationMtime,W.profile,W.profileScanOptions,W.type,W.excludeObsolete,W.validate,W.productVersion,W.productDate,W.productCommit,W.devMode,W.language,W.translations);return this.scanExtension(oe,_.metadata)}return null}));return(0,L.$jf)(B)}async scanOneOrMultipleExtensions(G){try{if(await this.i.exists((0,u.$9f)(G.location,"package.json"))){const X=await this.scanExtension(G);return X?[X]:[]}else return await this.scanExtensions(G)}catch(X){return this.j.error(`Error scanning extensions at ${G.location.path}:`,(0,j.$9)(X)),[]}}async scanExtension(G,X){try{let W=await this.scanExtensionManifest(G.location);if(W){W.publisher||(W.publisher=I.$El),X=X??W.__metadata,delete W.__metadata;const q=(0,w.$mo)(W.publisher,W.name),B=X?.id?{id:q,uuid:X.id}:{id:q},_=X?.isSystem?0:G.type,oe=_===0||!!X?.isBuiltin;W=await this.n(G.location,W,M.createNlsConfiguration(G));const ae={type:_,identifier:B,manifest:W,location:G.location,isBuiltin:oe,targetPlatform:X?.targetPlatform??"undefined",metadata:X,isValid:!0,validations:[]};return G.validate?this.validate(ae,G):ae}}catch(W){G.type!==0&&this.j.error(W)}return null}validate(G,X){let W=!0;const q=(0,t.$xo)(X.productVersion,X.productDate,X.location,G.manifest,G.isBuiltin);for(const[B,_]of q)B===p.default.Error&&(W=!1,this.j.error(this.u(X.location,_)));return G.isValid=W,G.validations=q,G}async scanExtensionManifest(G){const X=(0,u.$9f)(G,"package.json");let W;try{W=(await this.i.readFile(X)).value.toString()}catch(B){return(0,o.$9j)(B)!==1&&this.j.error(this.u(G,(0,f.localize)(0,null,X.path,B.message))),null}let q;try{q=JSON.parse(W)}catch{const _=[];(0,R.$ym)(W,_);for(const oe of _)this.j.error(this.u(G,(0,f.localize)(1,null,X.path,oe.offset,oe.length,(0,S.$dp)(oe.error))));return null}return(0,R.$Hm)(q)!=="object"?(this.j.error(this.u(G,(0,f.localize)(2,null,X.path))),null):q}async n(G,X,W){const q=await this.r(G,X,W);if(q)try{const B=[],_=await this.s(q.default,B);if(B.length>0)return B.forEach(ae=>{this.j.error(this.u(G,(0,f.localize)(3,null,q.default?.path,(0,S.$dp)(ae.error))))}),X;if((0,R.$Hm)(q)!=="object")return this.j.error(this.u(G,(0,f.localize)(4,null,q.default?.path))),X;const oe=q.values||Object.create(null);return(0,E.$ep)(X,oe,_)}catch{}return X}async r(G,X,W){const q=(0,u.$9f)(G,"package.nls.json"),B=(Y,U)=>{U.forEach(k=>{this.j.error(this.u(G,(0,f.localize)(5,null,Y?.path,(0,S.$dp)(k.error))))})},_=Y=>{this.j.error(this.u(G,(0,f.localize)(6,null,Y?.path)))},oe=`${X.publisher}.${X.name}`,ae=W.translations[oe];if(ae)try{const Y=h.URI.file(ae),U=(await this.i.readFile(Y)).value.toString(),k=[],P=(0,R.$ym)(U,k);return k.length>0?(B(Y,k),{values:void 0,default:q}):(0,R.$Hm)(P)!=="object"?(_(Y),{values:void 0,default:q}):{values:P.contents?P.contents.package:void 0,default:q}}catch{return{values:void 0,default:q}}else{if(!await this.i.exists(q))return;let U;try{U=await this.t(G,W)}catch{return}if(!U.localized)return{values:void 0,default:U.original};try{const k=(await this.i.readFile(U.localized)).value.toString(),P=[],z=(0,R.$ym)(k,P);return P.length>0?(B(U.localized,P),{values:void 0,default:U.original}):(0,R.$Hm)(z)!=="object"?(_(U.localized),{values:void 0,default:U.original}):{values:z,default:U.original}}catch{return{values:void 0,default:U.original}}}}async s(G,X){if(G)try{const W=(await this.i.readFile(G)).value.toString();return(0,R.$ym)(W,X)}catch{}}t(G,X){return new Promise((W,q)=>{const B=_=>{const oe=(0,u.$9f)(G,`package.nls.${_}.json`);this.i.exists(oe).then(ae=>{ae&&W({localized:oe,original:(0,u.$9f)(G,"package.nls.json")});const Y=_.lastIndexOf("-");Y===-1?W({localized:(0,u.$9f)(G,"package.nls.json"),original:null}):(_=_.substring(0,Y),B(_))})};if(X.devMode||X.pseudo||!X.language)return W({localized:(0,u.$9f)(G,"package.nls.json"),original:null});B(X.language)})}u(G,X){return`[${G.path}]: ${X}`}};F=ye([K(1,v.$bp),K(2,l.$pk),K(3,o.$Sj),K(4,n.$Ri)],F);let V=class extends F{constructor(G,X,W,q,B,_,oe){super(X,q,B,_,oe),this.z=G,this.C=W,this.w=this.B(new N.$sg(3e3)),this.y=this.B(new r.$ec),this.onDidChangeCache=this.y.event}async scanExtensions(G){const X=this.H(G),W=await this.D(X);if(this.v=G,W&&W.input&&M.equals(W.input,this.v))return this.j.debug("Using cached extensions scan result",G.location.toString()),this.w.trigger(()=>this.G()),W.result.map(B=>(B.location=h.URI.revive(B.location),B));const q=await super.scanExtensions(G);return await this.F(X,{input:G,result:q}),q}async D(G){try{const X=await this.i.readFile(G),W=JSON.parse(X.value.toString());return{result:W.result,input:(0,a.$Yg)(W.input)}}catch(X){this.j.debug("Error while reading the extension cache file:",G.path,(0,j.$9)(X))}return null}async F(G,X){try{await this.i.writeFile(G,A.$Ec.fromString(JSON.stringify(X)))}catch(W){this.j.debug("Error while writing the extension cache file:",G.path,(0,j.$9)(W))}}async G(){if(!this.v)return;const G=this.H(this.v),X=await this.D(G);if(!X)return;const W=X.result,q=JSON.parse(JSON.stringify(await super.scanExtensions(this.v)));if(!O.$Mm(q,W))try{this.j.info("Invalidating Cache",W,q),await this.i.del(G),this.y.fire()}catch(B){this.j.error(B)}}H(G){const X=this.I(G);return this.h.extUri.joinPath(X.cacheHome,G.type===0?I.$Dl:I.$Cl)}I(G){return G.type===0?this.C.defaultProfile:G.profile?this.h.extUri.isEqual(G.location,this.z.extensionsResource)?this.z:this.C.profiles.find(X=>this.h.extUri.isEqual(G.location,X.extensionsResource))??this.z:this.C.defaultProfile}};V=ye([K(2,m.$rk),K(3,v.$bp),K(4,l.$pk),K(5,o.$Sj),K(6,n.$Ri)],V);function Z(Q,G){const X=(0,w.$ko)(Q.manifest.publisher,Q.manifest.name);return{id:X,identifier:new I.$Il(X),isBuiltin:Q.type===0,isUserBuiltin:Q.type===1&&Q.isBuiltin,isUnderDevelopment:G,extensionLocation:Q.location,uuid:Q.identifier.uuid,targetPlatform:Q.targetPlatform,...Q.manifest}}e.$ip=Z;class J extends T{constructor(G,X,W,q,B,_,oe,ae,Y,U,k,P){super(G,X,(0,u.$9f)(W,".vscode-oss-dev","extensions","control.json"),q,B,_,oe,ae,Y,U,k,P),this.N=(async()=>{if($.$y)try{const z=await this.s.readFile(h.URI.file($.$y));return JSON.parse(z.value.toString())}catch{}return Object.create(null)})()}f(G){return this.N}}e.$jp=J}),define(ce[242],le([0,1,64,5,38,3,2,26,16,31,7,17]),function(ie,e,L,N,O,A,j,R,S,g,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lp=void 0;let $=class extends j.$lb{constructor(d,p){super(),this.b=d,this.f=p,this.a=new N.$Ag(5)}async postUninstall(d){const p=this.g(d,"uninstall");p&&(this.f.info(d.identifier.id,d.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(p.script,"uninstall",p.args,!0,d),this.f.info("Finished running post uninstall script",d.identifier.id,d.manifest.version)}catch(c){this.f.error("Failed to run post uninstall script",d.identifier.id,d.manifest.version),this.f.error(c)}}));try{await g.Promises.rm(this.j(d))}catch(c){this.f.error("Error while removing extension storage path",d.identifier.id),this.f.error(c)}}g(d,p){const c=`vscode:${p}`;if(d.location.scheme===R.Schemas.file&&d.manifest&&d.manifest.scripts&&typeof d.manifest.scripts[c]=="string"){const h=d.manifest.scripts[c].split(" ");return h.length<2||h[0]!=="node"||!h[1]?(this.f.warn(d.identifier.id,d.manifest.version,`${c} should be a node script`),null):{script:(0,S.$8c)(d.location.fsPath,h[1]),args:h.slice(2)||[]}}return null}h(d,p,c,h,f){return new Promise((b,w)=>{const I=this.i(d,p,c,f);let t;const o=s=>{t&&(clearTimeout(t),t=null),s?w(s):b(void 0)};I.on("error",s=>{o((0,O.$ai)(s)||"Unknown")}),I.on("exit",(s,n)=>{o(s?`post-${p} process exited with code ${s}`:void 0)}),h&&(t=setTimeout(()=>{t=null,I.kill(),w("timed out")},5e3))})}i(d,p,c,h){const f={silent:!0,execArgv:void 0},b=(0,L.fork)(d,[`--type=extension-post-${p}`,...c],f);b.stdout.setEncoding("utf8"),b.stderr.setEncoding("utf8");const w=A.Event.fromNodeEventEmitter(b.stdout,"data"),I=A.Event.fromNodeEventEmitter(b.stderr,"data");w(s=>this.f.info(h.identifier.id,h.manifest.version,`post-${p}`,s)),I(s=>this.f.error(h.identifier.id,h.manifest.version,`post-${p}`,s));const t=A.Event.any(A.Event.map(w,s=>({data:`%c${s}`,format:[""]})),A.Event.map(I,s=>({data:`%c${s}`,format:["color: red"]})));return A.Event.debounce(t,(s,n)=>s?{data:s.data+n.data,format:[...s.format,...n.format]}:{data:n.data,format:n.format},100)(s=>{console.group(h.identifier.id),console.log(s.data,...s.format),console.groupEnd()}),b}j(d){return(0,S.$8c)(this.b.defaultProfile.globalStorageHome.fsPath,d.identifier.id.toLowerCase())}};e.$lp=$,e.$lp=$=ye([K(0,y.$rk),K(1,C.$Ri)],$)}),define(ce[243],le([0,1,7,17,27,21,50,13,15,10]),function(ie,e,L,N,O,A,j,R,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8M=void 0;let C=class extends j.$cp{constructor($,u,d,p,c,h){super(g.URI.file($.extensionsPath),u,d,p,c,h)}};e.$8M=C,e.$8M=C=ye([K(0,S.$xh),K(1,R.$Sj),K(2,N.$rk),K(3,O.$pk),K(4,A.$Vk),K(5,L.$Ri)],C)}),define(ce[244],le([0,1,10,15,50,79,13,4,7,23,27,17]),function(ie,e,L,N,O,A,j,R,S,g,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f6b=void 0;let $=class extends A.$jp{constructor(d,p,c,h,f,b,w,I){super(L.URI.file(f.builtinExtensionsPath),L.URI.file(f.extensionsPath),f.userHome,d.defaultProfile,d,p,c,h,f,b,w,I)}};e.$f6b=$,e.$f6b=$=ye([K(0,y.$rk),K(1,O.$bp),K(2,j.$Sj),K(3,S.$Ri),K(4,N.$xh),K(5,g.$0i),K(6,C.$pk),K(7,R.$oh)],$)}),define(ce[19],le([0,1,5,3,2,100,11,66,4,17]),function(ie,e,L,N,O,A,j,R,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Mo=e.$Lo=e.$Ko=void 0,e.$Ko="__$__isNewStorageMarker",e.$Lo="__$__targetStorageMarker",e.$Mo=(0,S.$ph)("storageService");var C;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(C||(e.WillSaveStateReason=C={}));var y;(function(f){f[f.APPLICATION=-1]="APPLICATION",f[f.PROFILE=0]="PROFILE",f[f.WORKSPACE=1]="WORKSPACE"})(y||(e.StorageScope=y={}));var $;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})($||(e.StorageTarget=$={}));function u(f){const b=f.get(e.$Lo);if(b)try{return JSON.parse(b)}catch{}return Object.create(null)}e.$No=u;class d extends O.$lb{static{this.a=60*1e3}constructor(b={flushInterval:d.a}){super(),this.j=b,this.b=this.B(new N.$hc),this.c=this.B(new N.$hc),this.onDidChangeTarget=this.c.event,this.f=this.B(new N.$ec),this.onWillSaveState=this.f.event,this.h=this.B(new L.$Gg(()=>this.k(),this.j.flushInterval)),this.i=this.B(new O.$mb),this.v=void 0,this.y=void 0,this.C=void 0}onDidChangeValue(b,w,I){return N.Event.filter(this.b.event,t=>t.scope===b&&(w===void 0||t.key===w),I)}k(){this.i.value=(0,L.$Kg)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,O.$gb)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.J()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(b,w){const{key:I,external:t}=w;if(I===e.$Lo){switch(b){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:b})}else this.b.fire({scope:b,key:I,target:this.F(b)[I],external:t})}r(b){this.f.fire({reason:b})}get(b,w,I){return this.L(w)?.get(b,I)}getBoolean(b,w,I){return this.L(w)?.getBoolean(b,I)}getNumber(b,w,I){return this.L(w)?.getNumber(b,I)}getObject(b,w,I){return this.L(w)?.getObject(b,I)}storeAll(b,w){this.t(()=>{for(const I of b)this.store(I.key,I.value,I.scope,I.target,w)})}store(b,w,I,t,o=!1){if((0,j.$re)(w)){this.remove(b,I,o);return}this.t(()=>{this.u(b,I,t),this.L(I)?.set(b,w,o)})}remove(b,w,I=!1){this.t(()=>{this.u(b,w,void 0),this.L(w)?.delete(b,I)})}t(b){this.b.pause(),this.c.pause();try{b()}finally{this.b.resume(),this.c.resume()}}keys(b,w){const I=[],t=this.F(b);for(const o of Object.keys(t))t[o]===w&&I.push(o);return I}u(b,w,I,t=!1){const o=this.F(w);typeof I=="number"?o[b]!==I&&(o[b]=I,this.L(w)?.set(e.$Lo,JSON.stringify(o),t)):typeof o[b]=="number"&&(delete o[b],this.L(w)?.set(e.$Lo,JSON.stringify(o),t))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(b){switch(b){case-1:return this.D;case 0:return this.z;default:return this.w}}G(b){const w=this.L(b);return w?u(w):Object.create(null)}isNew(b){return this.getBoolean(e.$Ko,b)===!0}async flush(b=C.NONE){this.f.fire({reason:b});const w=this.L(-1),I=this.L(0),t=this.L(1);switch(b){case C.NONE:await L.Promises.settled([w?.whenFlushed()??Promise.resolve(),I?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case C.SHUTDOWN:await L.Promises.settled([w?.flush(0)??Promise.resolve(),I?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const b=this.L(-1)?.items??new Map,w=this.L(0)?.items??new Map,I=this.L(1)?.items??new Map;return h(b,w,I,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(b,w){return this.r(C.NONE),(0,g.$qk)(b)?this.N(b,w):this.O(b,w)}H(b,w){return!(b.id===w.id||p(w)&&p(b))}I(b,w,I){this.t(()=>{const t=new Set;for(const[o,s]of b)t.add(o),w.get(o)!==s&&this.n(I,{key:o,external:!0});for(const[o]of w.items)t.has(o)||this.n(I,{key:o,external:!0})})}}e.$Oo=d;function p(f){return f.isDefault||!!f.useDefaultFlags?.globalState}e.$Po=p;class c extends d{constructor(){super(),this.p=this.B(new R.$Io(new R.$Jo,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new R.$Io(new R.$Jo,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new R.$Io(new R.$Jo,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(b=>this.n(1,b))),this.B(this.P.onDidChangeStorage(b=>this.n(0,b))),this.B(this.p.onDidChangeStorage(b=>this.n(-1,b)))}L(b){switch(b){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(b){switch(b){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(b){return!1}}e.$Qo=c;async function h(f,b,w,I,t,o){const s=D=>{try{return JSON.parse(D)}catch{return D}},n=new Map,i=new Map;f.forEach((D,T)=>{n.set(T,D),i.set(T,s(D))});const r=new Map,a=new Map;b.forEach((D,T)=>{r.set(T,D),a.set(T,s(D))});const v=new Map,m=new Map;w.forEach((D,T)=>{v.set(T,D),m.set(T,s(D))}),console.group(I!==t?`Storage: Application (path: ${I})`:`Storage: Application & Profile (path: ${I}, default profile)`);const l=[];if(n.forEach((D,T)=>{l.push({key:T,value:D})}),console.table(l),console.groupEnd(),console.log(i),I!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const D=[];r.forEach((T,M)=>{D.push({key:M,value:T})}),console.table(D),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${o})`);const E=[];v.forEach((D,T)=>{E.push({key:T,value:D})}),console.table(E),console.groupEnd(),console.log(m)}e.$Ro=h}),define(ce[114],le([0,1,3,2,11,29,33,19]),function(ie,e,L,N,O,A,j,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4yb=e.$3yb=void 0;let S=class extends N.$lb{constructor(y,$){super(),this.a=new L.$ec,this.onDidChangeEnablement=this.a.event,this.b=this.B(new g(y)),this.B(this.b.onDidChange(u=>this.a.fire({extensions:u,source:"storage"}))),this.B($.onDidInstallExtensions(u=>u.forEach(({local:d,operation:p})=>{d&&p===4&&this.f(d.identifier)})))}async enableExtension(y,$){return this.f(y)?(this.a.fire({extensions:[y],source:$}),!0):!1}async disableExtension(y,$){return this.c(y)?(this.a.fire({extensions:[y],source:$}),!0):!1}getDisabledExtensions(){return this.h(A.$Un)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(y){const $=this.getDisabledExtensions();return $.every(u=>!(0,j.$ho)(u,y))?($.push(y),this.g($),!0):!1}f(y){const $=this.getDisabledExtensions();for(let u=0;u<$.length;u++){const d=$[u];if((0,j.$ho)(d,y))return $.splice(u,1),this.g($),!0}return!1}g(y){this.i(A.$Un,y)}h(y){return this.b.get(y,0)}i(y,$){this.b.set(y,$,0)}};e.$3yb=S,e.$3yb=S=ye([K(0,R.$Mo),K(1,A.$Tn)],S);class g extends N.$lb{constructor(y){super(),this.c=y,this.a=Object.create(null),this.b=this.B(new L.$ec),this.onDidChange=this.b.event,this.B(y.onDidChangeValue(0,void 0,this.B(new N.$kb))($=>this.f($)))}get(y,$){let u;return $===0?((0,O.$re)(this.a[y])&&(this.a[y]=this.g(y,$)),u=this.a[y]):u=this.g(y,$),JSON.parse(u)}set(y,$,u){const d=JSON.stringify($.map(({id:c,uuid:h})=>({id:c,uuid:h})));this.g(y,u)!==d&&(u===0&&($.length?this.a[y]=d:delete this.a[y]),this.h(y,$.length?d:void 0,u))}f(y){if(!(0,O.$re)(this.a[y.key])&&this.g(y.key,y.scope)!==this.a[y.key]){const u=this.get(y.key,y.scope);delete this.a[y.key];const d=this.get(y.key,y.scope),p=u.filter(h=>!d.some(f=>(0,j.$ho)(h,f))),c=d.filter(h=>!u.some(f=>(0,j.$ho)(f,h)));(p.length||c.length)&&this.b.fire([...p,...c])}}g(y,$){return this.c.get(y,$,"[]")}h(y,$,u){$?this.c.store(y,$,u,1):this.c.remove(y,u)}}e.$4yb=g}),define(ce[245],le([0,1,20,25,8,6,37,11,10,18,15,29,33,67,13,7,23,57,222,19,21,60]),function(ie,e,L,N,O,A,j,R,S,g,C,y,$,u,d,p,c,h,f,b,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wo=e.$Vo=e.$Uo=void 0;const t=A.$o?"web":(0,y.$Mn)(A.$t,j.$3c),o="X-Market-Search-Activity-Id";var s;(function(k){k[k.None=0]="None",k[k.IncludeVersions=1]="IncludeVersions",k[k.IncludeFiles=2]="IncludeFiles",k[k.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",k[k.IncludeSharedAccounts=8]="IncludeSharedAccounts",k[k.IncludeVersionProperties=16]="IncludeVersionProperties",k[k.ExcludeNonValidated=32]="ExcludeNonValidated",k[k.IncludeInstallationTargets=64]="IncludeInstallationTargets",k[k.IncludeAssetUri=128]="IncludeAssetUri",k[k.IncludeStatistics=256]="IncludeStatistics",k[k.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",k[k.Unpublished=4096]="Unpublished",k[k.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(s||(s={}));function n(...k){return String(k.reduce((P,z)=>P|z,0))}var i;(function(k){k[k.Tag=1]="Tag",k[k.ExtensionId=4]="ExtensionId",k[k.Category=5]="Category",k[k.ExtensionName=7]="ExtensionName",k[k.Target=8]="Target",k[k.Featured=9]="Featured",k[k.SearchText=10]="SearchText",k[k.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},m={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:s.None,criteria:[],assetTypes:[]};class l{constructor(P=m){this.d=P}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(P,z=this.d.pageSize){return new l({...this.d,pageNumber:P,pageSize:z})}withFilter(P,...z){const H=[...this.d.criteria,...z.length?z.map(ee=>({filterType:P,value:ee})):[{filterType:P}]];return new l({...this.d,criteria:H})}withSortBy(P){return new l({...this.d,sortBy:P})}withSortOrder(P){return new l({...this.d,sortOrder:P})}withFlags(...P){return new l({...this.d,flags:P.reduce((z,H)=>z|H,0)})}withAssetTypes(...P){return new l({...this.d,assetTypes:P})}withSource(P){return new l({...this.d,source:P})}get raw(){const{criteria:P,pageNumber:z,pageSize:H,sortBy:ee,sortOrder:ne,flags:fe,assetTypes:x}=this.d;return{filters:[{criteria:P,pageNumber:z,pageSize:H,sortBy:ee,sortOrder:ne}],assetTypes:x,flags:fe}}get searchText(){const P=this.d.criteria.filter(z=>z.filterType===i.SearchText)[0];return P&&P.value?P.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(P=>String(P.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function E(k,P){const z=(k||[]).filter(H=>H.statisticName===P)[0];return z?z.value:0}function D(k){const P="Microsoft.VisualStudio.Code.Translation.";return k.files.filter(H=>H.assetType.indexOf(P)===0).reduce((H,ee)=>{const ne=F(k,ee.assetType);return ne&&H.push([ee.assetType.substring(P.length),ne]),H},[])}function T(k){if(k.properties){const P=k.properties.filter(ee=>ee.key===r.Repository),z=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),H=P.filter(ee=>z.test(ee.value))[0];return H?{uri:H.value,fallbackUri:H.value}:null}return F(k,r.Repository)}function M(k){return{uri:`${k.fallbackAssetUri}/${r.VSIX}?redirect=true${k.targetPlatform?`&targetPlatform=${k.targetPlatform}`:""}`,fallbackUri:`${k.fallbackAssetUri}/${r.VSIX}${k.targetPlatform?`?targetPlatform=${k.targetPlatform}`:""}`}}function F(k,P){return k.files.filter(H=>H.assetType===P)[0]?{uri:`${k.assetUri}/${P}${k.targetPlatform?`?targetPlatform=${k.targetPlatform}`:""}`,fallbackUri:`${k.fallbackAssetUri}/${P}${k.targetPlatform?`?targetPlatform=${k.targetPlatform}`:""}`}:null}function V(k,P){const z=k.properties?k.properties.filter(ee=>ee.key===P):[],H=z.length>0&&z[0].value;return H?H.split(",").map(ee=>(0,$.$lo)(ee)):[]}function Z(k){const P=k.properties?k.properties.filter(z=>z.key===a.Engine):[];return P.length>0&&P[0].value||""}function J(k){const P=k.properties?k.properties.filter(z=>z.key===a.PreRelease):[];return P.length>0&&P[0].value==="true"}function Q(k){const P=k.properties?k.properties.filter(H=>H.key===a.LocalizedLanguages):[],z=P.length>0&&P[0].value||"";return z?z.split(","):[]}function G(k){return k.properties?.find(P=>P.key===a.SponsorLink)?.value}function X(k){return k.indexOf("preview")!==-1}function W(k){return k.targetPlatform?(0,y.$Ln)(k.targetPlatform):"undefined"}function q(k){const P=(0,L.$of)(k.versions.map(W)),z=!!k.tags?.includes(y.$Gn),H=P.indexOf("web");return z?H===-1&&P.push("web"):H!==-1&&P.splice(H,1),P}function B(k,P){const z=(0,y.$Pn)(P);for(let H=0;H<k.length;H++){const ee=k[H];if(ee.version===k[H-1]?.version){let ne=H;const fe=W(ee);if(fe===P)for(;ne>0&&k[ne-1].version===ee.version;)ne--;else if(z.includes(fe))for(;ne>0&&k[ne-1].version===ee.version&&W(k[ne-1])!==P;)ne--;ne!==H&&(k.splice(H,1),k.splice(ne,0,ee))}}return k}e.$Uo=B;function _(k,P,z){k.telemetryData={index:P,querySource:z,queryActivityId:k.queryContext?.[o]}}function oe(k,P,z,H){const ee=k.versions[0],ne={manifest:F(P,r.Manifest),readme:F(P,r.Details),changelog:F(P,r.Changelog),license:F(P,r.License),repository:T(P),download:M(P),icon:F(P,r.Icon),signature:F(P,r.Signature),coreTranslations:D(P)};return{identifier:{id:(0,$.$mo)(k.publisher.publisherName,k.extensionName),uuid:k.extensionId},name:k.extensionName,version:P.version,displayName:k.displayName,publisherId:k.publisher.publisherId,publisher:k.publisher.publisherName,publisherDisplayName:k.publisher.displayName,publisherDomain:k.publisher.domain?{link:k.publisher.domain,verified:!!k.publisher.isDomainVerified}:void 0,publisherSponsorLink:G(ee),description:k.shortDescription||"",installCount:E(k.statistics,"install"),rating:E(k.statistics,"averagerating"),ratingCount:E(k.statistics,"ratingcount"),categories:k.categories||[],tags:k.tags||[],releaseDate:Date.parse(k.releaseDate),lastUpdated:Date.parse(k.lastUpdated),allTargetPlatforms:z,assets:ne,properties:{dependencies:V(P,a.Dependency),extensionPack:V(P,a.ExtensionPack),engine:Z(P),localizedLanguages:Q(P),targetPlatform:W(P),isPreReleaseVersion:J(P)},hasPreReleaseVersion:J(ee),hasReleaseVersion:!0,preview:X(k.flags),isSigned:!!ne.signature,queryContext:H}}let ae=class{constructor(P,z,H,ee,ne,fe,x,se){this.k=z,this.l=H,this.n=ee,this.o=ne,this.q=fe,this.u=x,this.w=se;const te=x.extensionsGallery,ue=te?.servicePPEUrl&&se.getValue("_extensionsGallery.enablePPE");this.d=ue?te.servicePPEUrl:te?.serviceUrl,this.g=ue?void 0:te?.searchUrl,this.h=te?.controlUrl,this.j=(0,f.$To)(x.version,x,this.n,this.w,this.q,P,this.o)}x(P=""){return`${this.d}${P}`}isEnabled(){return!!this.d}async getExtensions(P,z,H){const ee=N.CancellationToken.isCancellationToken(z)?{}:z,ne=N.CancellationToken.isCancellationToken(z)?z:H,fe=[],x=[],se=[],te=[];let ue=!0;for(const Ee of P){Ee.uuid?x.push(Ee.uuid):fe.push(Ee.id);const Le=!!(Ee.version||Ee.preRelease);se.push({id:Ee.id,uuid:Ee.uuid,includePreRelease:Le}),Ee.version&&te.push({id:Ee.id,uuid:Ee.uuid,version:Ee.version}),ue=ue&&!!Ee.hasPreRelease&&!Le}if(!x.length&&!fe.length)return[];let de=new l().withPage(1,P.length);x.length&&(de=de.withFilter(i.ExtensionId,...x)),fe.length&&(de=de.withFilter(i.ExtensionName,...fe)),(ee.queryAllVersions||ue)&&(de=de.withFlags(de.flags,s.IncludeVersions)),ee.source&&(de=de.withSource(ee.source));const{extensions:we}=await this.z(de,{targetPlatform:ee.targetPlatform??t,includePreRelease:se,versions:te,compatible:!!ee.compatible},ne);return ee.source&&we.forEach((Ee,Le)=>_(Ee,Le,ee.source)),we}async getCompatibleExtension(P,z,H){if((0,y.$Nn)(P.allTargetPlatforms,H))return null;if(await this.isExtensionCompatible(P,z,H))return P;const ee=new l().withFlags(s.IncludeVersions).withPage(1,1).withFilter(i.ExtensionId,P.identifier.uuid),{extensions:ne}=await this.z(ee,{targetPlatform:H,compatible:!0,includePreRelease:z},N.CancellationToken.None);return ne[0]||null}async isExtensionCompatible(P,z,H){if(!(0,y.$On)(P.properties.targetPlatform,P.allTargetPlatforms,H)||!z&&P.properties.isPreReleaseVersion)return!1;let ee=P.properties.engine;if(!ee){const ne=await this.getManifest(P,N.CancellationToken.None);if(!ne)throw new Error("Manifest was not found");ee=ne.engines.vscode}return(0,u.$zo)(ee,this.u.version,this.u.date)}async y(P,z,H,ee,ne){if(!(0,y.$On)(W(P),ee,ne)||z!=="any"&&J(P)!==(z==="prerelease"))return!1;if(H)try{const fe=await this.E(P);if(!(0,u.$zo)(fe,this.u.version,this.u.date))return!1}catch(fe){return this.l.error(`Error while getting the engine for the version ${P.version}.`,(0,O.$9)(fe)),!1}return!0}async query(P,z){let H=P.text||"";const ee=P.pageSize??50;let ne=new l().withPage(1,ee);H?(H=H.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ue,de,we)=>(ne=ne.withFilter(i.Category,we||de),"")),H=H.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ue,de,we)=>(ne=ne.withFilter(i.Tag,we||de),"")),H=H.replace(/\bfeatured(\s+|\b|$)/g,()=>(ne=ne.withFilter(i.Featured),"")),H=H.trim(),H&&(H=H.length<200?H:H.substring(0,200),ne=ne.withFilter(i.SearchText,H)),ne=ne.withSortBy(0)):P.ids?ne=ne.withFilter(i.ExtensionId,...P.ids):P.names?ne=ne.withFilter(i.ExtensionName,...P.names):ne=ne.withSortBy(4),typeof P.sortBy=="number"&&(ne=ne.withSortBy(P.sortBy)),typeof P.sortOrder=="number"&&(ne=ne.withSortOrder(P.sortOrder)),P.source&&(ne=ne.withSource(P.source));const fe=async(ue,de)=>{const{extensions:we,total:Ee}=await this.z(ue,{targetPlatform:t,compatible:!1,includePreRelease:!!P.includePreRelease},de);return we.forEach((Le,je)=>_(Le,(ue.pageNumber-1)*ue.pageSize+je,P.source)),{extensions:we,total:Ee}},{extensions:x,total:se}=await fe(ne,z),te=async(ue,de)=>{if(de.isCancellationRequested)throw new O.$3;const{extensions:we}=await fe(ne.withPage(ue+1),de);return we};return{firstPage:x,total:se,pageSize:ne.pageSize,getPage:te}}async z(P,z,H){const ee=P.flags;P.flags&s.IncludeLatestVersionOnly&&P.flags&s.IncludeVersions&&(P=P.withFlags(P.flags&~s.IncludeVersions,s.IncludeLatestVersionOnly)),!(P.flags&s.IncludeLatestVersionOnly)&&!(P.flags&s.IncludeVersions)&&(P=P.withFlags(P.flags,s.IncludeLatestVersionOnly)),z.versions?.length&&(P=P.withFlags(P.flags&~s.IncludeLatestVersionOnly,s.IncludeVersions)),P=P.withFlags(P.flags,s.IncludeAssetUri,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeStatistics,s.IncludeVersionProperties);const{galleryExtensions:ne,total:fe,context:x}=await this.B(P,H);if(!(P.flags&s.IncludeLatestVersionOnly)){const de=[];for(const we of ne){const Ee=await this.A(we,z,x);Ee&&de.push(Ee)}return{extensions:de,total:fe}}const te=[],ue=new Map;for(let de=0;de<ne.length;de++){const we=ne[de],Ee={id:(0,$.$mo)(we.publisher.publisherName,we.extensionName),uuid:we.extensionId},Le=(0,R.$oe)(z.includePreRelease)?z.includePreRelease:!!z.includePreRelease.find(Me=>(0,$.$ho)(Me,Ee))?.includePreRelease;if(z.compatible&&(0,y.$Nn)(q(we),z.targetPlatform))continue;const je=await this.A(we,z,x);!je||je.properties.isPreReleaseVersion&&(!Le||!je.hasReleaseVersion)||!je.properties.isPreReleaseVersion&&je.properties.targetPlatform!==z.targetPlatform&&je.hasPreReleaseVersion?ue.set(we.extensionId,de):te.push([de,je])}if(ue.size){const de=new I.$ac,we=new l().withFlags(ee&~s.IncludeLatestVersionOnly,s.IncludeVersions).withPage(1,ue.size).withFilter(i.ExtensionId,...ue.keys()),{extensions:Ee}=await this.z(we,z,H);this.o.publicLog2("galleryService:additionalQuery",{duration:de.elapsed(),count:ue.size});for(const Le of Ee){const je=ue.get(Le.identifier.uuid);te.push([je,Le])}}return{extensions:te.sort((de,we)=>de[0]-we[0]).map(([,de])=>de),total:fe}}async A(P,z,H){const ee={id:(0,$.$mo)(P.publisher.publisherName,P.extensionName),uuid:P.extensionId},ne=z.versions?.find(te=>(0,$.$ho)(te,ee))?.version,fe=(0,R.$oe)(z.includePreRelease)?z.includePreRelease:!!z.includePreRelease.find(te=>(0,$.$ho)(te,ee))?.includePreRelease,x=q(P),se=B(P.versions,z.targetPlatform);if(z.compatible&&(0,y.$Nn)(x,z.targetPlatform))return null;for(let te=0;te<se.length;te++){const ue=se[te];if(!(ne&&ue.version!==ne)){if(await this.y(ue,fe?"any":"release",z.compatible,x,z.targetPlatform))return oe(P,ue,x,H);if(ne&&ue.version===ne)return null}}return ne||z.compatible?null:oe(P,P.versions[0],x)}async B(P,z){if(!this.isEnabled())throw new Error("No extension gallery service configured.");P=P.withFlags(P.flags,s.ExcludeNonValidated).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExcludeWithFlags,n(s.Unpublished));const H=await this.j,ee=JSON.stringify(P.raw),ne={...H,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ee.length)},fe=new I.$ac;let x,se,te=0;try{if(x=await this.k.request({type:"POST",url:this.g&&P.criteria.some(de=>de.filterType===i.SearchText)?this.g:this.x("/extensionquery"),data:ee,headers:ne},z),x.res.statusCode&&x.res.statusCode>=400&&x.res.statusCode<500)return{galleryExtensions:[],total:te};const ue=await(0,h.$Fo)(x);if(ue){const de=ue.results[0],we=de.extensions,Ee=de.resultMetadata&&de.resultMetadata.filter(Le=>Le.metadataType==="ResultCount")[0];return te=Ee&&Ee.metadataItems.filter(Le=>Le.name==="TotalCount")[0].count||0,{galleryExtensions:we,total:te,context:{[o]:x.res.headers.activityid}}}return{galleryExtensions:[],total:te}}catch(ue){throw se=ue,ue}finally{this.o.publicLog2("galleryService:query",{...P.telemetryData,requestBodySize:String(ee.length),duration:fe.elapsed(),success:!!x&&(0,h.$Co)(x),responseBodySize:x?.res.headers["Content-Length"],statusCode:x?String(x.res.statusCode):void 0,errorCode:se?(0,O.$2)(se)?"canceled":(0,O.$9)(se).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(te)})}}async reportStatistic(P,z,H,ee){if(!this.isEnabled())return;const ne=A.$o?this.x(`/itemName/${P}.${z}/version/${H}/statType/${ee==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${P}/extensions/${z}/${H}/stats?statType=${ee}`),fe=A.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",se={...await this.j,Accept:fe};try{await this.k.request({type:"POST",url:ne,headers:se},N.CancellationToken.None)}catch{}}async download(P,z,H){this.l.trace("ExtensionGalleryService#download",P.identifier.id);const ee=(0,$.$po)(P),ne=new Date().getTime(),fe=de=>this.o.publicLog("galleryService:downloadVSIX",{...ee,duration:de}),x=H===2?"install":H===3?"update":"",se=x?{uri:`${P.assets.download.uri}${S.URI.parse(P.assets.download.uri).query?"&":"?"}${x}=true`,fallbackUri:`${P.assets.download.fallbackUri}${S.URI.parse(P.assets.download.fallbackUri).query?"&":"?"}${x}=true`}:P.assets.download,te=P.queryContext?.[o]?{[o]:P.queryContext[o]}:void 0,ue=await this.D(se,te?{headers:te}:void 0);await this.q.writeFile(z,ue.stream),fe(new Date().getTime()-ne)}async downloadSignatureArchive(P,z){if(!P.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",P.identifier.id);const H=await this.D(P.assets.signature);await this.q.writeFile(z,H.stream)}async getReadme(P,z){if(P.assets.readme){const H=await this.D(P.assets.readme,{},z);return await(0,h.$Eo)(H)||""}return""}async getManifest(P,z){if(P.assets.manifest){const H=await this.D(P.assets.manifest,{},z),ee=await(0,h.$Eo)(H);return ee?JSON.parse(ee):null}return null}async C(P,z){const H=F(P,r.Manifest);if(!H)throw new Error("Manifest was not found");const ee={"Accept-Encoding":"gzip"},ne=await this.D(H,{headers:ee});return await(0,h.$Fo)(ne)}async getCoreTranslation(P,z){const H=P.assets.coreTranslations.filter(ee=>ee[0]===z.toUpperCase())[0];if(H){const ee=await this.D(H[1]),ne=await(0,h.$Eo)(ee);return ne?JSON.parse(ne):null}return null}async getChangelog(P,z){if(P.assets.changelog){const H=await this.D(P.assets.changelog,{},z);return await(0,h.$Eo)(H)||""}return""}async getAllCompatibleVersions(P,z,H){let ee=new l().withFlags(s.IncludeVersions,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1);P.identifier.uuid?ee=ee.withFilter(i.ExtensionId,P.identifier.uuid):ee=ee.withFilter(i.ExtensionName,P.identifier.id);const{galleryExtensions:ne}=await this.B(ee,N.CancellationToken.None);if(!ne.length)return[];const fe=q(ne[0]);if((0,y.$Nn)(fe,H))return[];const x=[];await Promise.all(ne[0].versions.map(async ue=>{try{await this.y(ue,z?"any":"release",!0,fe,H)&&x.push(ue)}catch{}}));const se=[],te=new Set;for(const ue of B(x,H))te.has(ue.version)||(te.add(ue.version),se.push({version:ue.version,date:ue.lastUpdated,isPreReleaseVersion:J(ue)}));return se}async D(P,z={},H=N.CancellationToken.None){const ee=await this.j,ne={type:"GET"},fe={...ee,...z.headers||{}};z={...z,...ne,headers:fe};const x=P.uri,se=P.fallbackUri,te={...z,url:x};try{const ue=await this.k.request(te,H);if(ue.res.statusCode===200)return ue;const de=await(0,h.$Eo)(ue);throw new Error(`Expected 200, got back ${ue.res.statusCode} instead.

${de}`)}catch(ue){if((0,O.$2)(ue))throw ue;const de=(0,O.$9)(ue);this.o.publicLog2("galleryService:cdnFallback",{url:x,message:de});const we={...z,url:se};return this.k.request(we,H)}}async E(P){let z=Z(P);if(!z){const H=await this.C(P,N.CancellationToken.None);if(!H)throw new Error("Manifest was not found");z=H.engines.vscode}return z}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const P=await this.k.request({type:"GET",url:this.h},N.CancellationToken.None);if(P.res.statusCode!==200)throw new Error("Could not get extensions report.");const z=await(0,h.$Fo)(P),H=[],ee={},ne=[];if(z){for(const fe of z.malicious)H.push({id:fe});if(z.migrateToPreRelease)for(const[fe,x]of Object.entries(z.migrateToPreRelease))(!x.engine||(0,u.$zo)(x.engine,this.u.version,this.u.date))&&(ee[fe.toLowerCase()]={disallowInstall:!0,extension:{id:x.id,displayName:x.displayName,autoMigrate:{storage:!!x.migrateStorage},preRelease:!0}});if(z.deprecated)for(const[fe,x]of Object.entries(z.deprecated))x&&(ee[fe.toLowerCase()]=(0,R.$oe)(x)?{}:x);if(z.search)for(const fe of z.search)ne.push(fe)}return{malicious:H,deprecated:ee,search:ne}}};ae=ye([K(1,h.$Ao),K(2,p.$Ri),K(3,C.$wh),K(4,w.$Vk),K(5,d.$Sj),K(6,c.$0i),K(7,g.$Vh)],ae);let Y=class extends ae{constructor(P,z,H,ee,ne,fe,x,se){super(P,z,H,ee,ne,fe,x,se)}};e.$Vo=Y,e.$Vo=Y=ye([K(0,b.$Mo),K(1,h.$Ao),K(2,p.$Ri),K(3,C.$wh),K(4,w.$Vk),K(5,d.$Sj),K(6,c.$0i),K(7,g.$Vh)],Y);let U=class extends ae{constructor(P,z,H,ee,ne,fe,x){super(void 0,P,z,H,ee,ne,fe,x)}};e.$Wo=U,e.$Wo=U=ye([K(0,h.$Ao),K(1,p.$Ri),K(2,C.$wh),K(3,w.$Vk),K(4,d.$Sj),K(5,c.$0i),K(6,g.$Vh)],U)}),define(ce[80],le([0,1,4,3,2,19,33,23,20,7,11]),function(ie,e,L,N,O,A,j,R,S,g,C){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$Jz=e.$Iz=void 0,e.$Iz=(0,L.$ph)("IExtensionStorageService");const $=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let u=class extends O.$lb{static{y=this}static{this.a=512*1024}static b(p){return`extensionKeys/${(0,j.$lo)(p.id)}@${p.version}`}static c(p){const c=$.exec(p);if(c&&c[1])return{id:c[1],version:c[2]}}static async removeOutdatedExtensionVersions(p,c){const h=await p.getInstalled(),f=[];for(const[b,w]of y.f(c)){const I=h.find(t=>(0,j.$ho)(t.identifier,{id:b}))?.manifest.version;for(const t of w)I!==t&&f.push(y.b({id:b,version:t}))}for(const b of f)c.remove(b,0)}static f(p){const c=new Map,h=p.keys(0,1);for(const f of h){const b=y.c(f);if(b){let w=c.get(b.id.toLowerCase());w||c.set(b.id.toLowerCase(),w=[]),w.push(b.version)}}return c}constructor(p,c,h){super(),this.i=p,this.j=c,this.k=h,this.g=this.B(new N.$ec),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=y.f(p),this.B(this.i.onDidChangeValue(0,void 0,this.B(new O.$kb))(f=>this.l(f)))}l(p){if(this.h.has(p.key.toLowerCase())){this.g.fire();return}const c=y.c(p.key);if(c){if(this.i.get(p.key,0)===void 0)this.h.delete(c.id.toLowerCase());else{let h=this.h.get(c.id.toLowerCase());h||this.h.set(c.id.toLowerCase(),h=[]),h.push(c.version),this.g.fire()}return}}m(p){if((0,C.$ie)(p))return p;const c=p.manifest?p.manifest.publisher:p.publisher,h=p.manifest?p.manifest.name:p.name;return(0,j.$ko)(c,h)}getExtensionState(p,c){const h=this.m(p),f=this.getExtensionStateRaw(p,c);if(f)try{return JSON.parse(f)}catch(b){this.k.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${h}, global: ${c}): ${b}`)}}getExtensionStateRaw(p,c){const h=this.m(p),f=this.i.get(h,c?0:1);return f&&f?.length>y.a&&this.k.warn(`[mainThreadStorage] large extension state detected (extensionId: ${h}, global: ${c}): ${f.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),f}setExtensionState(p,c,h){const f=this.m(p);c===void 0?this.i.remove(f,h?0:1):this.i.store(f,JSON.stringify(c),h?0:1,1)}setKeysForSync(p,c){this.i.store(y.b(p),JSON.stringify(c),0,1)}getKeysForSync(p){const c=this.j.extensionSyncedKeys?.[p.id.toLowerCase()],h=this.i.get(y.b(p),0),f=h?JSON.parse(h):void 0;return f&&c?(0,S.$of)([...f,...c]):f||c}addToMigrationList(p,c){if(p!==c){const h=this.n.filter(f=>!f.includes(p)&&!f.includes(c));h.push([p,c]),this.n=h}}getSourceExtensionToMigrate(p){const c=this.n.find(([,h])=>p===h);return c?c[0]:void 0}get n(){const p=this.i.get("extensionStorage.migrationList",-1,"[]");try{const c=JSON.parse(p);if(Array.isArray(c))return c}catch{}return[]}set n(p){p.length?this.i.store("extensionStorage.migrationList",JSON.stringify(p),-1,1):this.i.remove("extensionStorage.migrationList",-1)}};e.$Jz=u,e.$Jz=u=y=ye([K(0,A.$Mo),K(1,R.$0i),K(2,g.$Ri)],u)}),define(ce[246],le([0,1,29,13,23,15,98,55,19,21,219]),function(ie,e,L,N,O,A,j,R,S,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A7b=void 0;let y=class extends C.$T3b{constructor(u,d,p,c,h,f,b,w){super(u.userHome,h,d,p,c,f,b,w)}};e.$A7b=y,e.$A7b=y=ye([K(0,A.$xh),K(1,g.$Vk),K(2,L.$Tn),K(3,S.$Mo),K(4,R.$m5b),K(5,j.$2Tb),K(6,N.$Sj),K(7,O.$0i)],y)}),define(ce[247],le([0,1,105,3,21,15,2,7,16,64,23,6,5,101,18,163,36,19,11,131]),function(ie,e,L,N,O,A,j,R,S,g,C,y,$,u,d,p,c,h,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w7b=void 0;const w=[L.$p7b,L.$q7b],I="remoteTunnelSession",t="remoteTunnelIsService";let o=class extends j.$lb{constructor(r,a,v,m,l,E,D){super(),this.t=r,this.u=a,this.v=v,this.w=E,this.y=D,this.f=new N.$ec,this.onDidTokenFailed=this.f.event,this.g=new N.$ec,this.onDidChangeTunnelStatus=this.g.event,this.h=new N.$ec,this.onDidChangeMode=this.h.event,this.j=L.$n7b,this.s=!1,this.D=(T,M)=>{M?this.i.error(T):this.i.info(T)},this.i=this.B(m.createLogger(L.$r7b,{name:L.$s7b})),this.p=new $.$rg(100),this.B(this.i.onDidChangeLogLevel(T=>this.i.info("Log level changed to "+(0,R.$7i)(T)))),this.B(l.onWillShutdown(()=>{this.k?.cancel(),this.k=void 0,this.dispose()})),this.B(E.onDidChangeConfiguration(T=>{w.some(M=>T.affectsConfiguration(M))&&this.p.trigger(()=>this.G())})),this.j=this.N(),this.n=L.TunnelStates.uninitialized}async getTunnelStatus(){return this.n}z(r){this.n=r,this.g.fire(r)}C(r){n(this.j,r)||(this.j=r,this.O(r),this.h.fire(this.j),r.active?(this.i.info(`Session updated: ${r.session.accountLabel} (${r.session.providerId}) (service=${r.asService})`),r.session.token&&this.i.info(`Session token updated: ${r.session.accountLabel} (${r.session.providerId})`)):this.i.info("Session reset"))}getMode(){return Promise.resolve(this.j)}async initialize(r){if(this.s)return this.n;this.s=!0,this.C(r);try{await this.p.trigger(()=>this.G())}catch(a){this.i.error(a)}return this.n}F(){if(!this.r){let r;y.$j?r=this.v.appRoot:r=(0,S.$$c)((0,S.$$c)(this.v.appRoot)),this.r=(0,S.$8c)(r,"bin",`${this.u.tunnelApplicationName}${y.$i?".exe":""}`)}return this.r}async startTunnel(r){if(n(this.j,r)&&this.n.type!=="disconnected")return this.n;this.C(r);try{await this.p.trigger(()=>this.G())}catch(a){this.i.error(a)}return this.n}async stopTunnel(){if(this.k&&(this.k.cancel(),this.k=void 0),!this.j.active)return;const r=this.j.asService;this.C(L.$n7b);try{r&&this.J("uninstallService",["service","uninstall"])}catch(a){this.i.error(a)}try{await this.J("stop",["kill"])}catch(a){this.i.error(a)}this.z(L.TunnelStates.disconnected())}async G(){this.t.publicLog2("remoteTunnel.enablement",{enabled:this.j.active,service:this.j.active&&this.j.asService}),this.k&&(this.k.cancel(),this.k=void 0);let r="",a=!1;const v=(M,F)=>{F?this.i.error(M):r+=M,!this.v.isBuilt&&M.startsWith("   Compiling")&&this.z(L.TunnelStates.connecting((0,p.localize)(0,null)))},m=this.J("status",["status"],v);this.k=m;try{if(await m,this.k!==m)return;const M=JSON.parse(r.trim().split(`
`).find(F=>F.startsWith("{")));if(a=M.service_installed,this.i.info(M.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!M.tunnel&&!this.j.active){this.z(L.TunnelStates.disconnected());return}}catch(M){this.i.error(M),this.z(L.TunnelStates.disconnected());return}finally{this.k===m&&(this.k=void 0)}const l=this.j.active?this.j.session:void 0;if(l&&l.token){const M=l.token;this.z(L.TunnelStates.connecting((0,p.localize)(1,null,l.accountLabel,l.providerId)));const F=(Z,J)=>{Z=Z.replaceAll(M,"*".repeat(4)),v(Z,J)},V=this.J("login",["user","login","--provider",l.providerId,"--access-token",M,"--log",(0,R.$7i)(this.i.getLevel())],F);this.k=V;try{if(await V,this.k!==V)return}catch(Z){this.i.error(Z),this.k=void 0,this.f.fire(l),this.z(L.TunnelStates.disconnected(l));return}}const E=this.M();E?this.z(L.TunnelStates.connecting((0,p.localize)(2,null,E))):this.z(L.TunnelStates.connecting((0,p.localize)(3,null)));const D=["--accept-server-license-terms","--log",(0,R.$7i)(this.i.getLevel())];E?D.push("--name",E):D.push("--random-name");let T=!1;return this.j.active&&this.j.asService&&!a&&(T=await this.H(D)===!1),this.I(l,D,T)}async H(r){let a;try{a=await this.J("serviceInstall",["service","install",...r])}catch(v){this.i.error(v),a=1}if(a!==0){const v=(0,p.localize)(4,null);return this.i.warn(v),this.z(L.TunnelStates.connecting(v)),!1}return!0}async I(r,a,v){a.push("--parent-process-id",String(process.pid)),this.L()&&a.push("--no-sleep");let m=!1;const l=this.J("tunnel",a,(E,D)=>{D?this.i.error(E):this.i.info(E),E.includes("Connected to an existing tunnel process")&&(m=!0);const T=E.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(T){const M={link:T[1],domain:T[2],tunnelName:T[4],isAttached:m};this.z(L.TunnelStates.connected(M,v))}else E.match(/error refreshing token/)&&(l.cancel(),this.f.fire(r),this.z(L.TunnelStates.disconnected(r)))});this.k=l,l.finally(()=>{l===this.k&&(this.i.info("tunnel process terminated"),this.k=void 0,this.j=L.$n7b,this.z(L.TunnelStates.disconnected()))})}J(r,a,v=this.D){return(0,$.$ig)(m=>new Promise((l,E)=>{m.isCancellationRequested&&l(-1);let D;const T=["ignore","pipe","pipe"];if(m.onCancellationRequested(()=>{D&&(this.i.info(`${r} terminating(${D.pid})`),D.kill())}),!this.v.isBuilt)v(`Building tunnel CLI from sources and run
`,!1),v(`${r} Spawning: cargo run -- tunnel ${a.join(" ")}
`,!1),D=(0,g.spawn)("cargo",["run","--","tunnel",...a],{cwd:(0,S.$8c)(this.v.appRoot,"cli"),stdio:T});else{v(`Running tunnel CLI
`,!1);const M=this.F();v(`${r} Spawning: ${M} tunnel ${a.join(" ")}
`,!1),D=(0,g.spawn)(M,["tunnel",...a],{cwd:(0,c.homedir)(),stdio:T})}D.stdout.pipe(new b.$sS(`
`)).on("data",M=>{if(D){const F=M.toString();v(F,!1)}}),D.stderr.pipe(new b.$sS(`
`)).on("data",M=>{if(D){const F=M.toString();v(F,!0)}}),D.on("exit",M=>{D&&(v(`${r} exit(${D.pid}): + ${M} `,!1),D=void 0,l(M||0))}),D.on("error",M=>{D&&(v(`${r} error(${D.pid}): + ${M} `,!0),D=void 0,E())})}))}async getTunnelName(){return this.M()}L(){return!!this.w.getValue(L.$q7b)}M(){let r=this.w.getValue(L.$p7b)||(0,c.hostname)();return r=r.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),r||void 0}N(){try{const r=this.y.get(I,-1),a=this.y.getBoolean(t,-1,!1);if(r){const v=JSON.parse(r);if(v&&(0,f.$ie)(v.accountLabel)&&(0,f.$ie)(v.sessionId)&&(0,f.$ie)(v.providerId))return{active:!0,session:v,asService:a};this.i.error("Problems restoring session from storage, invalid format",v)}}catch(r){this.i.error("Problems restoring session from storage",r)}return L.$n7b}O(r){if(r.active){const a={providerId:r.session.providerId,sessionId:r.session.sessionId,accountLabel:r.session.accountLabel};this.y.store(I,JSON.stringify(a),-1,1),this.y.store(t,r.asService,-1,1)}else this.y.remove(I,-1),this.y.remove(t,-1)}};e.$w7b=o,e.$w7b=o=ye([K(0,O.$Vk),K(1,C.$0i),K(2,A.$xh),K(3,R.$Si),K(4,u.$u7b),K(5,d.$Vh),K(6,h.$Mo)],o);function s(i,r){return i&&r?i.sessionId===r.sessionId&&i.providerId===r.providerId&&i.token===r.token:i===r}const n=(i,r)=>i.active!==r.active?!1:i.active&&r.active?i.asService===r.asService&&s(i.session,r.session):!0}),define(ce[248],le([0,1,5,2,22,66,19,75,17]),function(ie,e,L,N,O,A,j,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B7b=void 0;class g extends j.$Oo{constructor(y,$,u,d){super(),this.X=y,this.Y=$,this.Z=u,this.$=d,this.p=this.Y.defaultProfile,this.s=this.ab(),this.P=this.Y.currentProfile,this.Q=this.B(new N.$kb),this.R=this.bb(this.P),this.S=this.X?.id,this.U=this.B(new N.$kb),this.W=this.cb(this.X)}ab(){const y=this.B(new R.$Azb(this.Z.getChannel("storage"))),$=this.B(new A.$Io(y));return this.B($.onDidChangeStorage(u=>this.n(-1,u))),$}bb(y){this.Q.clear(),this.P=y;let $;if((0,j.$Po)(y))$=this.s;else{const u=this.Q.add(new R.$Bzb(this.Z.getChannel("storage"),y));$=this.Q.add(new A.$Io(u))}return this.Q.add($.onDidChangeStorage(u=>this.n(0,u))),$}cb(y){this.U.clear(),this.S=y?.id;let $;if(y){const u=this.U.add(new R.$Czb(this.Z.getChannel("storage"),y));$=this.U.add(new A.$Io(u)),this.U.add($.onDidChangeStorage(d=>this.n(1,d)))}return $}async J(){await L.Promises.settled([this.s.init(),this.R.init(),this.W?.init()??Promise.resolve()])}L(y){switch(y){case-1:return this.s;case 0:return this.R;default:return this.W}}M(y){switch(y){case-1:return this.p.globalStorageHome.fsPath;case 0:return this.P?.globalStorageHome.fsPath;default:return this.S?`${(0,O.$9f)(this.$.workspaceStorageHome,this.S,"state.vscdb").fsPath}`:void 0}}async close(){this.m(),this.r(j.WillSaveStateReason.SHUTDOWN),await L.Promises.settled([this.s.close(),this.R.close(),this.W?.close()??Promise.resolve()])}async N(y){if(!this.H(this.P,y))return;const $=this.R,u=$.items;$!==this.s&&await $.close(),this.R=this.bb(y),await this.R.init(),this.I(u,this.R,0)}async O(y,$){const u=this.W,d=u?.items??new Map;await u?.close(),this.W=this.cb(y),await this.W.init(),this.I(d,this.W,1)}hasScope(y){return(0,S.$qk)(y)?this.P.id===y.id:this.S===y.id}}e.$B7b=g}),define(ce[249],le([0,1,3,2,17,92]),function(ie,e,L,N,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dN=e.$cN=void 0;class j{constructor(g,C){this.a=g,this.b=C}listen(g,C){const y=this.b(g);switch(C){case"onDidChangeProfiles":return L.Event.map(this.a.onDidChangeProfiles,$=>({all:$.all.map(u=>(0,A.$qm)({...u},y)),added:$.added.map(u=>(0,A.$qm)({...u},y)),removed:$.removed.map(u=>(0,A.$qm)({...u},y)),updated:$.updated.map(u=>(0,A.$qm)({...u},y))}))}throw new Error(`Invalid listen ${C}`)}async call(g,C,y){const $=this.b(g);switch(C){case"createProfile":{const u=await this.a.createProfile(y[0],y[1],y[2]);return(0,A.$qm)({...u},$)}case"updateProfile":{let u=(0,O.$sk)((0,A.$rm)(y[0],$),this.a.profilesHome.scheme);return u=await this.a.updateProfile(u,y[1]),(0,A.$qm)({...u},$)}case"removeProfile":{const u=(0,O.$sk)((0,A.$rm)(y[0],$),this.a.profilesHome.scheme);return this.a.removeProfile(u)}}throw new Error(`Invalid call ${C}`)}}e.$cN=j;class R extends N.$lb{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(g,C,y){super(),this.profilesHome=C,this.f=y,this.a=[],this.b=this.B(new L.$ec),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=g.map($=>(0,O.$sk)($,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")($=>{const u=$.added.map(c=>(0,O.$sk)(c,this.profilesHome.scheme)),d=$.removed.map(c=>(0,O.$sk)(c,this.profilesHome.scheme)),p=$.updated.map(c=>(0,O.$sk)(c,this.profilesHome.scheme));this.a=$.all.map(c=>(0,O.$sk)(c,this.profilesHome.scheme)),this.b.fire({added:u,removed:d,updated:p,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(g){this.c=g}isEnabled(){return this.c}async createNamedProfile(g,C,y){const $=await this.f.call("createNamedProfile",[g,C,y]);return(0,O.$sk)($,this.profilesHome.scheme)}async createProfile(g,C,y,$){const u=await this.f.call("createProfile",[g,C,y,$]);return(0,O.$sk)(u,this.profilesHome.scheme)}async createTransientProfile(g){const C=await this.f.call("createTransientProfile",[g]);return(0,O.$sk)(C,this.profilesHome.scheme)}async setProfileForWorkspace(g,C){await this.f.call("setProfileForWorkspace",[g,C])}removeProfile(g){return this.f.call("removeProfile",[g])}async updateProfile(g,C){const y=await this.f.call("updateProfile",[g,C]);return(0,O.$sk)(y,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$dN=R}),define(ce[58],le([0,1,2,66,4,19,3,75,17]),function(ie,e,L,N,O,A,j,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gzb=e.$Fzb=e.$Ezb=void 0,e.$Ezb=(0,O.$ph)("IUserDataProfileStorageService");let g=class extends L.$lb{constructor(u){super(),this.a=u}async readStorageData(u){return this.withProfileScopedStorageService(u,async d=>this.b(d))}async updateStorageData(u,d,p){return this.withProfileScopedStorageService(u,async c=>this.c(c,d,p))}async withProfileScopedStorageService(u,d){if(this.a.hasScope(u))return d(this.a);const p=await this.g(u),c=new y(p);try{await c.initialize();const h=await d(c);return await c.flush(),h}finally{c.dispose(),await this.f(p)}}b(u){const d=new Map,p=c=>{for(const h of u.keys(0,c))d.set(h,{value:u.get(h,0),target:c})};return p(0),p(1),d}c(u,d,p){u.storeAll(Array.from(d.entries()).map(([c,h])=>({key:c,value:h,scope:0,target:p})),!0)}async f(u){try{await u.close()}finally{(0,L.$fb)(u)&&u.dispose()}}};e.$Fzb=g,e.$Fzb=g=ye([K(0,A.$Mo)],g);class C extends g{constructor(u,d,p,c){super(p),this.i=u;const h=u.getChannel("profileStorageListener"),f=this.B(new L.$mb);this.h=this.B(new j.$ec({onWillAddFirstListener:()=>{f.value=h.listen("onDidChange")(b=>{c.trace("profile storage changes",b),this.h.fire({targetChanges:b.targetChanges.map(w=>(0,S.$sk)(w,d.profilesHome.scheme)),valueChanges:b.valueChanges.map(w=>({...w,profile:(0,S.$sk)(w.profile,d.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>f.value=void 0})),this.onDidChange=this.h.event}async g(u){const d=this.i.getChannel("storage");return(0,A.$Po)(u)?new R.$Azb(d):new R.$Bzb(d,u)}}e.$Gzb=C;class y extends A.$Oo{constructor(u){super({flushInterval:100}),this.p=this.B(new N.$Io(u))}J(){return this.p.init()}L(u){return u===0?this.p:void 0}M(){}async N(){}async O(){}hasScope(){return!1}}}),define(ce[250],le([0,1,19,7,17,71,58]),function(ie,e,L,N,O,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g7b=void 0;let R=class extends j.$Gzb{constructor(g,C,y,$){super(g,C,y,$)}};e.$g7b=R,e.$g7b=R=ye([K(0,A.$E6b),K(1,O.$rk),K(2,L.$Mo),K(3,N.$Ri)],R)}),define(ce[39],le([0,1,20,5,14,25,3,34,2,28,11,168,18,15,13,7,44,19,21,27,24,17]),function(ie,e,L,N,O,A,j,R,S,g,C,y,$,u,d,p,c,h,f,b,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xAb=e.$wAb=e.$vAb=e.$uAb=e.$tAb=e.$sAb=e.$rAb=void 0;function t(v){return!!(v&&v.ref!==void 0&&typeof v.ref=="string"&&v.ref!==""&&v.syncData!==void 0&&(v.syncData===null||o(v.syncData)))}e.$rAb=t;function o(v){return!!(v&&v.version!==void 0&&typeof v.version=="number"&&v.content!==void 0&&typeof v.content=="string"&&(Object.keys(v).length===2||Object.keys(v).length===3&&v.machineId!==void 0&&typeof v.machineId=="string"))}e.$sAb=o;function s(v,m){return`${(0,g.$ae)(v)}${m.isDefault?"":` (${m.name})`}`}e.$tAb=s;let n=class extends S.$lb{get status(){return this.k}get conflicts(){return{...this.syncResource,conflicts:this.m}}constructor(m,l,E,D,T,M,F,V,Z,J,Q,G){super(),this.syncResource=m,this.collection=l,this.C=E,this.D=D,this.F=T,this.G=M,this.H=F,this.I=V,this.J=Z,this.L=J,this.M=Q,this.c=null,this.k="idle",this.l=this.B(new j.$ec),this.onDidChangeStatus=this.l.event,this.m=[],this.n=this.B(new j.$ec),this.onDidChangeConflicts=this.n.event,this.s=new N.$sg(50),this.t=this.B(new j.$ec),this.onDidChangeLocal=this.t.event,this.v=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.w=!1,this.z={},this.resource=this.syncResource.syncResource,this.y=s(m.syncResource,m.profile),this.h=G.extUri,this.f=this.h.joinPath(D.userDataSyncHome,...(0,w.$Yfb)(m.profile.isDefault?void 0:m.profile.id,m.syncResource)),this.g=this.h.joinPath(this.f,w.$hgb),this.u=(0,w.$Zfb)(m.profile.isDefault?void 0:m.profile.id,m.syncResource,D,this.h),this.j=(0,c.$So)(D,E,T)}N(){this.s.trigger(()=>this.O())}async O(){if(this.status==="hasConflicts"){this.L.info(`${this.y}: In conflicts state and local change detected. Syncing again...`);const m=await this.c;this.c=null;const l=await this.U(m.remoteUserData,m.lastSyncUserData,!0,this.lb());this.P(l)}else{this.L.trace(`${this.y}: Checking for local changes...`);const m=await this.getLastSyncUserData();(m?await this.rb(m):!0)&&this.t.fire()}}P(m){this.k!==m&&(this.k=m,this.l.fire(m))}async sync(m,l={}){await this.Q(m,!0,this.lb(),l)}async preview(m,l,E={}){return this.Q(m,!1,l,E)}async apply(m,l={}){try{this.z={...l};const E=await this.Y(m);return this.P(E),this.c}finally{this.z={}}}async Q(m,l,E,D){try{if(this.z={...D},this.status==="hasConflicts")return this.L.info(`${this.y}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.L.info(`${this.y}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.L.trace(`${this.y}: Started synchronizing ${this.resource.toLowerCase()}...`),this.P("syncing");let T="idle";try{const M=await this.getLastSyncUserData(),F=await this.S(m,M);return T=await this.U(F,M,l,E),T==="hasConflicts"?this.L.info(`${this.y}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):T==="idle"&&this.L.trace(`${this.y}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.P(T)}}finally{this.z={}}}async replace(m){const l=this.hb(m);if(!l)return!1;await this.stop();try{this.L.trace(`${this.y}: Started resetting ${this.resource.toLowerCase()}...`),this.P("syncing");const E=await this.getLastSyncUserData(),D=await this.S(null,E),T=await this.R(D),M=await this.nb({ref:D.ref,syncData:l},E,T,this.lb(),A.CancellationToken.None),F=[];for(const V of M){const Z=await this.pb(V,V.remoteResource,void 0,A.CancellationToken.None),{remoteChange:J}=await this.pb(V,V.previewResource,V.remoteContent,A.CancellationToken.None);F.push([V,{...Z,remoteChange:J!==0?J:2}])}await this.qb(D,E,F,!1),this.L.info(`${this.y}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.P("idle")}return!0}async R(m){const l=await this.j;return!!m.syncData?.machineId&&m.syncData.machineId===l}async S(m,l){if(l){const E=m?m[this.resource]:void 0;if(l.ref===E||E===void 0&&l.syncData===null)return l}return this.getRemoteUserData(l)}async U(m,l,E,D){if(m.syncData&&m.syncData.version>this.mb)throw this.J.publicLog2("sync/incompatible",{source:this.resource}),new w.$7fb((0,y.localize)(0,null,this.resource,this.mb,m.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.W(m,l,E,D)}catch(T){if(T instanceof w.$7fb)switch(T.code){case"LocalPreconditionFailed":return this.L.info(`${this.y}: Failed to synchronize ${this.y} as there is a new local version available. Synchronizing again...`),this.U(m,l,E,D);case"Conflict":case"PreconditionFailed":return this.L.info(`${this.y}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),m=await this.getRemoteUserData(null),l=await this.getLastSyncUserData(),this.U(m,l,E,D)}throw T}}async W(m,l,E,D){try{const T=await this.R(m),M=!T&&l===null&&this.db()!==void 0,F=E&&!M;this.c||(this.c=(0,N.$ig)(Z=>this.bb(m,l,T,F,D,Z)));let V=await this.c;if(E&&M){this.L.info(`${this.y}: Accepting remote because it was synced before and the last sync data is not available.`);for(const Z of V.resourcePreviews)V=await this.accept(Z.remoteResource)||V}return this.$(V.resourcePreviews),V.resourcePreviews.some(({mergeState:Z})=>Z==="conflict")?"hasConflicts":E?await this.Y(!1):"syncing"}catch(T){throw this.c=null,T}}async merge(m){return await this.X(m,async l=>{const E=await this.ob(l,A.CancellationToken.None);await this.C.writeFile(l.previewResource,O.$Ec.fromString(E?.content||""));const D=E&&!E.hasConflicts?await this.pb(l,l.previewResource,void 0,A.CancellationToken.None):void 0;return l.acceptResult=D,l.mergeState=E.hasConflicts?"conflict":D?"accepted":"preview",l.localChange=D?D.localChange:E.localChange,l.remoteChange=D?D.remoteChange:E.remoteChange,l}),this.c}async accept(m,l){return await this.X(m,async E=>{const D=await this.pb(E,m,l,A.CancellationToken.None);return E.acceptResult=D,E.mergeState="accepted",E.localChange=D.localChange,E.remoteChange=D.remoteChange,E}),this.c}async discard(m){return await this.X(m,async l=>{const E=await this.ob(l,A.CancellationToken.None);return await this.C.writeFile(l.previewResource,O.$Ec.fromString(E.content||"")),l.acceptResult=void 0,l.mergeState="preview",l.localChange=E.localChange,l.remoteChange=E.remoteChange,l}),this.c}async X(m,l){if(!this.c)return;let E=await this.c;const D=E.resourcePreviews.findIndex(({localResource:T,remoteResource:M,previewResource:F})=>this.h.isEqual(T,m)||this.h.isEqual(M,m)||this.h.isEqual(F,m));D!==-1&&(this.c=(0,N.$ig)(async T=>{const M=[...E.resourcePreviews];return M[D]=await l(M[D]),{...E,resourcePreviews:M}}),E=await this.c,this.$(E.resourcePreviews),E.resourcePreviews.some(({mergeState:T})=>T==="conflict")?this.P("hasConflicts"):this.P("syncing"))}async Y(m){if(!this.c)return"idle";const l=await this.c;return l.resourcePreviews.some(({mergeState:E})=>E==="conflict")?"hasConflicts":l.resourcePreviews.some(({mergeState:E})=>E!=="accepted")?"syncing":(await this.qb(l.remoteUserData,l.lastSyncUserData,l.resourcePreviews.map(E=>[E,E.acceptResult]),m),this.c=null,await this.Z(),"idle")}async Z(){try{await this.C.del(this.g,{recursive:!0})}catch{}}$(m){const l=m.filter(({mergeState:E})=>E==="conflict");(0,L.$$e)(this.m,l,(E,D)=>this.h.isEqual(E.previewResource,D.previewResource))||(this.m=l,this.n.fire(this.conflicts))}async hasPreviouslySynced(){const m=await this.getLastSyncUserData();return!!m&&m.syncData!==null}async ab(m){const l=this.c?await this.c:null;if(l)for(const E of l.resourcePreviews){if(this.h.isEqual(E.acceptedResource,m))return E.acceptResult?E.acceptResult.content:null;if(this.h.isEqual(E.remoteResource,m))return E.remoteContent;if(this.h.isEqual(E.localResource,m))return E.localContent;if(this.h.isEqual(E.baseResource,m))return E.baseContent}return null}async resetLocal(){this.F.remove(this.v,-1);try{await this.C.del(this.u)}catch(m){(0,d.$9j)(m)!==1&&this.L.error(m)}}async bb(m,l,E,D,T,M){const F=await this.nb(m,l,E,T,M),V=[];for(const Z of F){const J=Z.previewResource.with({scheme:w.$ggb,authority:"accepted"});if(Z.localChange===0&&Z.remoteChange===0)V.push({...Z,acceptedResource:J,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const Q=D?await this.ob(Z,M):void 0;if(M.isCancellationRequested)break;await this.C.writeFile(Z.previewResource,O.$Ec.fromString(Q?.content||""));const G=Q&&!Q.hasConflicts?await this.pb(Z,Z.previewResource,void 0,M):void 0;V.push({...Z,acceptResult:G,mergeState:Q?.hasConflicts?"conflict":G?"accepted":"preview",localChange:G?G.localChange:Q?Q.localChange:Z.localChange,remoteChange:G?G.remoteChange:Q?Q.remoteChange:Z.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:m,lastSyncUserData:l,resourcePreviews:V,isLastSyncFromCurrentMachine:E}}async getLastSyncUserData(){let m=this.db();if(m||(m=await this.gb()),!m)return this.L.info(`${this.y}: Last sync data state does not exist.`),null;const l=JSON.parse(m),E=this.I.getResourceSyncStateVersion(this.resource);if(this.w=!!l.version&&!!E&&l.version!==E,this.w)return this.L.info(`${this.y}: Reset last sync state because last sync state version ${l.version} is not compatible with current sync state version ${E}.`),await this.resetLocal(),null;let D,T=1;for(;D===void 0&&T++<6;)try{const M=await this.eb();M&&(M.ref===l.ref?D=M.syncData:this.L.info(`${this.y}: Last sync data stored locally is not same as the last sync state.`));break}catch(M){if(M instanceof d.$ak&&M.fileOperationResult===1){this.L.info(`${this.y}: Last sync resource does not exist locally.`);break}else{if(M instanceof w.$7fb)throw M;this.L.error(M,T)}}if(D===void 0)try{const M=await this.G.resolveResourceContent(this.resource,l.ref,this.collection,this.z);D=M===null?null:this.hb(M),await this.fb({ref:l.ref,syncData:D})}catch(M){if(M instanceof w.$7fb&&M.code==="NotFound")this.L.info(`${this.y}: Last sync resource does not exist remotely.`);else throw M}return D===void 0?null:{...l,syncData:D}}async cb(m,l={}){if(l.ref||l.version)throw new Error("Cannot have core properties as additional");const E=this.I.getResourceSyncStateVersion(this.resource),D={ref:m.ref,version:E,...l};this.F.store(this.v,JSON.stringify(D),-1,1),await this.fb(m)}db(){return this.F.get(this.v,-1)}async eb(){const m=(await this.C.readFile(this.u)).value.toString();try{const l=m?JSON.parse(m):void 0;if(t(l))return l}catch(l){this.L.error(l)}}async fb(m){await this.C.writeFile(this.u,O.$Ec.fromString(JSON.stringify(m)))}async gb(){try{const m=await this.C.readFile(this.u),l=JSON.parse(m.value.toString());await this.C.del(this.u),l.ref&&l.content!==void 0?(this.F.store(this.v,JSON.stringify({...l,content:void 0}),-1,1),await this.fb({ref:l.ref,syncData:l.content===null?null:JSON.parse(l.content)})):this.L.info(`${this.y}: Migrating last sync user data. Invalid data.`,l)}catch(m){m instanceof d.$ak&&m.fileOperationResult===1?this.L.info(`${this.y}: Migrating last sync user data. Resource does not exist.`):this.L.error(m)}return this.F.get(this.v,-1)}async getRemoteUserData(m){const{ref:l,content:E}=await this.ib(m);let D=null;return E!==null&&(D=this.hb(E)),{ref:l,syncData:D}}hb(m){try{const l=JSON.parse(m);if(o(l))return l}catch(l){this.L.error(l)}throw new w.$7fb((0,y.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async ib(m){const l=m?{ref:m.ref,content:m.syncData?JSON.stringify(m.syncData):null}:null;return this.G.readResource(this.resource,l,this.collection,this.z)}async jb(m,l){const E=await this.j,D={version:this.mb,machineId:E,content:m};try{return l=await this.G.writeResource(this.resource,JSON.stringify(D),l,this.collection,this.z),{ref:l,syncData:D}}catch(T){throw T instanceof w.$7fb&&T.code==="TooLarge"&&(T=new w.$7fb(T.message,T.code,this.resource)),T}}async kb(m){const l={version:this.mb,content:m};return this.H.backup(this.syncResource.profile,this.resource,JSON.stringify(l))}async stop(){this.status!=="idle"&&(this.L.trace(`${this.y}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.$([]),await this.Z(),this.P("idle"),this.L.info(`${this.y}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}lb(){return this.M.getValue(w.$Tfb)}};e.$uAb=n,e.$uAb=n=ye([K(2,d.$Sj),K(3,u.$wh),K(4,h.$Mo),K(5,w.$2fb),K(6,w.$3fb),K(7,w.$_fb),K(8,f.$Vk),K(9,w.$egb),K(10,$.$Vh),K(11,b.$pk)],n);let i=class extends n{constructor(m,l,E,D,T,M,F,V,Z,J,Q,G,X){super(l,E,D,T,M,F,V,Z,J,Q,G,X),this.i=m,this.B(this.C.watch(this.h.dirname(m))),this.B(this.C.onDidFilesChange(W=>this.tb(W)))}async p(){try{return await this.C.readFile(this.i)}catch{return null}}async r(m,l,E){try{l?await this.C.writeFile(this.i,O.$Ec.fromString(m),E?void 0:l):await this.C.createFile(this.i,O.$Ec.fromString(m),{overwrite:E})}catch(D){throw D instanceof d.$ak&&D.fileOperationResult===1||D instanceof d.$ak&&D.fileOperationResult===3?new w.$7fb(D.message,"LocalPreconditionFailed"):D}}async sb(){try{await this.C.del(this.i)}catch(m){if(!(m instanceof d.$ak&&m.fileOperationResult===1))throw m}}tb(m){m.contains(this.i)&&this.N()}};e.$vAb=i,e.$vAb=i=ye([K(3,d.$Sj),K(4,u.$wh),K(5,h.$Mo),K(6,w.$2fb),K(7,w.$3fb),K(8,w.$_fb),K(9,f.$Vk),K(10,w.$egb),K(11,$.$Vh),K(12,b.$pk)],i);let r=class extends i{constructor(m,l,E,D,T,M,F,V,Z,J,Q,G,X,W){super(m,l,E,D,T,M,F,V,Z,J,Q,X,W),this.ub=G,this.wb=void 0}vb(m,l){const E=[],D=(0,R.$ym)(m,E,{allowEmptyContent:!0,allowTrailingComma:!0});return E.length>0||!(0,C.$pe)(D)&&l!==Array.isArray(D)}xb(){return this.wb||(this.wb=this.ub.resolveFormattingOptions(this.i)),this.wb}};e.$wAb=r,e.$wAb=r=ye([K(3,d.$Sj),K(4,u.$wh),K(5,h.$Mo),K(6,w.$2fb),K(7,w.$3fb),K(8,w.$_fb),K(9,f.$Vk),K(10,w.$egb),K(11,w.$dgb),K(12,$.$Vh),K(13,b.$pk)],r);let a=class{constructor(m,l,E,D,T,M,F){this.resource=m,this.g=l,this.h=E,this.j=D,this.k=T,this.l=M,this.d=F.extUri,this.f=(0,w.$Zfb)(void 0,this.resource,E,this.d)}async initialize({ref:m,content:l}){if(!l){this.j.info("Remote content does not exist.",this.resource);return}const E=this.m(l);if(E)try{await this.o({ref:m,syncData:E})}catch(D){this.j.error(D)}}m(m){try{const l=JSON.parse(m);if(o(l))return l}catch(l){this.j.error(l)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(m,l={}){if(l.ref||l.version)throw new Error("Cannot have core properties as additional");const E={ref:m.ref,version:void 0,...l};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(E),-1,1),await this.k.writeFile(this.f,O.$Ec.fromString(JSON.stringify(m)))}};e.$xAb=a,e.$xAb=a=ye([K(1,I.$rk),K(2,u.$wh),K(3,p.$Ri),K(4,d.$Sj),K(5,h.$Mo),K(6,b.$pk)],a)}),define(ce[115],le([0,1,5,25,8,3,41,2,28,18,15,114,29,33,80,45,13,4,70,7,19,21,27,17,39,230,111,24,58]),function(ie,e,L,N,O,A,j,R,S,g,C,y,$,u,d,p,c,h,f,b,w,I,t,o,s,n,i,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$71b=e.$61b=e.$51b=e.$41b=e.$31b=void 0;async function v(M,F){const V=JSON.parse(M.content);if(M.version===1||M.version===2){const Z=(await F.getInstalled(0)).filter(J=>J.isBuiltin);for(const J of V)M.version===1&&(J.enabled===!1&&(J.disabled=!0),delete J.enabled),M.version===2&&Z.every(Q=>!(0,u.$ho)(Q.identifier,J.identifier))&&(J.installed=!0)}return V}function m(M){return JSON.parse(M.content)}e.$31b=m;function l(M,F){return M.sort((V,Z)=>!V.identifier.uuid&&Z.identifier.uuid?-1:V.identifier.uuid&&!Z.identifier.uuid?1:(0,S.$Ed)(V.identifier.id,Z.identifier.id)),F?(0,j.$cS)(M,{}):JSON.stringify(M)}e.$41b=l;let E=class extends s.$uAb{constructor(F,V,Z,J,Q,G,X,W,q,B,_,oe,ae,Y,U,k,P){super({syncResource:"extensions",profile:F},V,J,Z,Q,G,X,oe,ae,B,_,U),this.yb=W,this.zb=q,this.Ab=P,this.mb=6,this.sb=this.h.joinPath(this.g,"extensions.json"),this.tb=this.sb.with({scheme:r.$ggb,authority:"base"}),this.ub=this.sb.with({scheme:r.$ggb,authority:"local"}),this.vb=this.sb.with({scheme:r.$ggb,authority:"remote"}),this.wb=this.sb.with({scheme:r.$ggb,authority:"accepted"}),this.xb=this.Ab.createInstance(D),this.B(A.Event.any(A.Event.filter(this.yb.onDidInstallExtensions,z=>z.some(({local:H})=>!!H)),A.Event.filter(this.yb.onDidUninstallExtension,z=>!z.error),A.Event.filter(k.onDidChange,z=>z.valueChanges.some(({profile:H,changes:ee})=>this.syncResource.profile.id===H.id&&ee.some(ne=>ne.key===$.$Un))),Y.onDidChangeExtensionStorageToSync)(()=>this.N()))}async nb(F,V){const Z=F.syncData?await v(F.syncData,this.yb):null,J=V?.skippedExtensions??[],Q=V?.builtinExtensions??null,G=V?.syncData?await v(V.syncData,this.yb):null,{localExtensions:X,ignoredExtensions:W}=await this.xb.getLocalExtensions(this.syncResource.profile);Z?this.L.trace(`${this.y}: Merging remote extensions with local extensions...`):this.L.trace(`${this.y}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:q,remote:B}=(0,n.$21b)(X,Z,G,J,W,Q),_={local:q,remote:B,content:this.Db(X,q.added,q.updated,q.removed),localChange:q.added.length>0||q.removed.length>0||q.updated.length>0?2:0,remoteChange:B!==null?2:0},oe=this.Kb(X,!1);return[{skippedExtensions:J,builtinExtensions:Q,baseResource:this.tb,baseContent:G?this.Kb(G,!1):oe,localResource:this.ub,localContent:oe,localExtensions:X,remoteResource:this.vb,remoteExtensions:Z,remoteContent:Z?this.Kb(Z,!1):null,previewResource:this.sb,previewResult:_,localChange:_.localChange,remoteChange:_.remoteChange,acceptedResource:this.wb}]}async rb(F){const V=F.syncData?await v(F.syncData,this.yb):null,{localExtensions:Z,ignoredExtensions:J}=await this.xb.getLocalExtensions(this.syncResource.profile),{remote:Q}=(0,n.$21b)(Z,V,V,F.skippedExtensions||[],J,F.builtinExtensions||[]);return Q!==null}Db(F,V,Z,J){const Q=[...V,...Z],G=new Set,X=W=>{G.add(W.id.toLowerCase()),W.uuid&&G.add(W.uuid)};Q.forEach(({identifier:W})=>X(W)),J.forEach(X);for(const W of F)G.has(W.identifier.id.toLowerCase())||W.identifier.uuid&&G.has(W.identifier.uuid)||Q.push(W);return this.Kb(Q,!1)}async ob(F,V){return{...F.previewResult,hasConflicts:!1}}async pb(F,V,Z,J){if(this.h.isEqual(V,this.ub))return this.Gb(F);if(this.h.isEqual(V,this.vb))return this.Hb(F);if(this.h.isEqual(V,this.sb))return F.previewResult;throw new Error(`Invalid Resource: ${V.toString()}`)}async Gb(F){const V=await this.yb.getInstalled(void 0,this.syncResource.profile.extensionsResource),Z=this.zb.getIgnoredExtensions(V),J=(0,n.$21b)(F.localExtensions,null,null,F.skippedExtensions,Z,F.builtinExtensions),{local:Q,remote:G}=J;return{content:F.localContent,local:Q,remote:G,localChange:Q.added.length>0||Q.removed.length>0||Q.updated.length>0?2:0,remoteChange:G!==null?2:0}}async Hb(F){const V=await this.yb.getInstalled(void 0,this.syncResource.profile.extensionsResource),Z=this.zb.getIgnoredExtensions(V),J=F.remoteContent?JSON.parse(F.remoteContent):null;if(J!==null){const Q=(0,n.$21b)(F.localExtensions,J,F.localExtensions,[],Z,F.builtinExtensions),{local:G,remote:X}=Q;return{content:F.remoteContent,local:G,remote:X,localChange:G.added.length>0||G.removed.length>0||G.updated.length>0?2:0,remoteChange:X!==null?2:0}}else return{content:F.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async qb(F,V,Z,J){let{skippedExtensions:Q,builtinExtensions:G,localExtensions:X}=Z[0][0];const{local:W,remote:q,localChange:B,remoteChange:_}=Z[0][1];if(B===0&&_===0&&this.L.info(`${this.y}: No changes found during synchronizing extensions.`),B!==0&&(await this.kb(JSON.stringify(X)),Q=await this.xb.updateLocalExtensions(W.added,W.removed,W.updated,Q,this.syncResource.profile)),q){this.L.trace(`${this.y}: Updating remote extensions...`);const oe=JSON.stringify(q.all);F=await this.jb(oe,J?null:F.ref),this.L.info(`${this.y}: Updated remote extensions.${q.added.length?` Added: ${JSON.stringify(q.added.map(ae=>ae.identifier.id))}.`:""}${q.updated.length?` Updated: ${JSON.stringify(q.updated.map(ae=>ae.identifier.id))}.`:""}${q.removed.length?` Removed: ${JSON.stringify(q.removed.map(ae=>ae.identifier.id))}.`:""}`)}V?.ref!==F.ref&&(this.L.trace(`${this.y}: Updating last synchronized extensions...`),G=this.Jb(X,G),await this.cb(F,{skippedExtensions:Q,builtinExtensions:G}),this.L.info(`${this.y}: Updated last synchronized extensions.${Q.length?` Skipped: ${JSON.stringify(Q.map(oe=>oe.identifier.id))}.`:""}`))}Jb(F,V){const Z=new Set,J=[];for(const Q of F)Z.add(Q.identifier.id.toLowerCase()),Q.installed||J.push(Q.identifier);if(V)for(const Q of V)Z.has(Q.id.toLowerCase())||J.push(Q);return J}async resolveContent(F){if(this.h.isEqual(this.vb,F)||this.h.isEqual(this.tb,F)||this.h.isEqual(this.ub,F)||this.h.isEqual(this.wb,F)){const V=await this.ab(F);return V&&this.Kb(JSON.parse(V),!0)}return null}Kb(F,V){return l(F,V)}async hasLocalData(){try{const{localExtensions:F}=await this.xb.getLocalExtensions(this.syncResource.profile);if(F.some(V=>V.installed||V.disabled))return!0}catch{}return!1}};e.$51b=E,e.$51b=E=ye([K(2,C.$wh),K(3,c.$Sj),K(4,w.$Mo),K(5,r.$2fb),K(6,r.$3fb),K(7,$.$Tn),K(8,i.$cBb),K(9,r.$egb),K(10,g.$Vh),K(11,r.$_fb),K(12,I.$Vk),K(13,d.$Iz),K(14,t.$pk),K(15,a.$Ezb),K(16,h.$oh)],E);let D=class{constructor(F,V,Z,J,Q,G){this.a=F,this.b=V,this.c=Z,this.d=J,this.f=Q,this.g=G}async getLocalExtensions(F){const V=await this.a.getInstalled(void 0,F.extensionsResource),Z=this.d.getIgnoredExtensions(V);return{localExtensions:await this.j(F,async(Q,G)=>{const X=Q.getDisabledExtensions();return V.map(W=>{const{identifier:q,isBuiltin:B,manifest:_,preRelease:oe,pinned:ae,isApplicationScoped:Y}=W,U={identifier:q,preRelease:oe,version:_.version,pinned:!!ae};Y&&!(0,p.$Ll)(_)&&(U.isApplicationScoped=Y),X.some(k=>(0,u.$ho)(k,q))&&(U.disabled=!0),B||(U.installed=!0);try{const k=G.getKeysForSync({id:q.id,version:_.version});if(k){const P=G.getExtensionState(W,!0)||{};U.state=Object.keys(P).reduce((z,H)=>(k.includes(H)&&(z[H]=P[H]),z),{})}}catch(k){this.g.info(`${(0,s.$tAb)("extensions",F)}: Error while parsing extension state`,(0,O.$9)(k))}return U})}),ignoredExtensions:Z}}async updateLocalExtensions(F,V,Z,J,Q){const G=(0,s.$tAb)("extensions",Q),X=[],W=new Map,q=[],B=[],_=await this.a.getInstalled(void 0,Q.extensionsResource);if((F.length||Z.length)&&await this.j(Q,async(Y,U)=>{await L.Promises.settled([...F,...Z].map(async k=>{const P=_.find(ee=>(0,u.$ho)(ee.identifier,k.identifier));if(P&&P.isBuiltin){k.state&&P.manifest.version===k.version&&this.h(k.state,P,P.manifest.version,U),Y.getDisabledExtensions().some(ne=>(0,u.$ho)(ne,k.identifier))!==!!k.disabled&&(k.disabled?(this.g.trace(`${G}: Disabling extension...`,k.identifier.id),await Y.disableExtension(k.identifier),this.g.info(`${G}: Disabled extension`,k.identifier.id)):(this.g.trace(`${G}: Enabling extension...`,k.identifier.id),await Y.enableExtension(k.identifier),this.g.info(`${G}: Enabled extension`,k.identifier.id))),q.push(k.identifier);return}const z=k.pinned?k.version:void 0,H=(await this.c.getExtensions([{...k.identifier,version:z,preRelease:z?void 0:k.preRelease}],N.CancellationToken.None))[0];if(k.state&&(P?P.manifest.version===k.version:H)&&this.h(k.state,P||H,P?.manifest.version,U),H)try{Y.getDisabledExtensions().some(ne=>(0,u.$ho)(ne,k.identifier))!==!!k.disabled&&(k.disabled?(this.g.trace(`${G}: Disabling extension...`,k.identifier.id,H.version),await Y.disableExtension(H.identifier),this.g.info(`${G}: Disabled extension`,k.identifier.id,H.version)):(this.g.trace(`${G}: Enabling extension...`,k.identifier.id,H.version),await Y.enableExtension(H.identifier),this.g.info(`${G}: Enabled extension`,k.identifier.id,H.version))),(!P||P.preRelease!==k.preRelease||P.pinned!==k.pinned||z&&P.manifest.version!==z)&&(await this.a.canInstall(H)?(X.push({extension:H,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:k.pinned&&!!k.version,installPreReleaseVersion:k.preRelease,profileLocation:Q.extensionsResource,isApplicationScoped:k.isApplicationScoped,context:{[$.$Hn]:!0,[$.$In]:!0}}}),W.set(H.identifier.id.toLowerCase(),k)):(this.g.info(`${G}: Skipped synchronizing extension because it cannot be installed.`,H.displayName||H.identifier.id),B.push(k)))}catch(ee){B.push(k),this.g.error(ee),this.g.info(`${G}: Skipped synchronizing extension`,H.displayName||H.identifier.id)}else B.push(k),this.g.info(`${G}: Skipped synchronizing extension because the extension is not found.`,k.identifier.id)}))}),V.length){const Y=_.filter(({identifier:U,isBuiltin:k})=>!k&&V.some(P=>(0,u.$ho)(U,P)));await L.Promises.settled(Y.map(async U=>{this.g.trace(`${G}: Uninstalling local extension...`,U.identifier.id),await this.a.uninstall(U,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:Q.extensionsResource}),this.g.info(`${G}: Uninstalled local extension.`,U.identifier.id),q.push(U.identifier)}))}const oe=await this.a.installGalleryExtensions(X);for(const{identifier:Y,local:U,error:k,source:P}of oe){const z=P;if(U)this.g.info(`${G}: Installed extension.`,Y.id,z.version),q.push(Y);else{const H=W.get(Y.id.toLowerCase());H&&(B.push(H),this.g.info(`${G}: Skipped synchronizing extension`,z.displayName||z.identifier.id)),k instanceof $.$Sn&&[$.ExtensionManagementErrorCode.Incompatible,$.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(k.code)?this.g.info(`${G}: Skipped synchronizing extension because the compatible extension is not found.`,z.displayName||z.identifier.id):k&&this.g.error(k)}}const ae=[];for(const Y of J)q.some(U=>(0,u.$ho)(U,Y.identifier))||ae.push(Y);for(const Y of B)ae.some(U=>(0,u.$ho)(U.identifier,Y.identifier))||ae.push(Y);return ae}h(F,V,Z,J){const Q=J.getExtensionState(V,!0)||{},G=Z?J.getKeysForSync({id:V.identifier.id,version:Z}):void 0;G?G.forEach(X=>{Q[X]=F[X]}):Object.keys(F).forEach(X=>Q[X]=F[X]),J.setExtensionState(V,Q,!0)}async j(F,V){return this.b.withProfileScopedStorageService(F,async Z=>{const J=new R.$kb,Q=this.f.createChild(new f.$nh([w.$Mo,Z])),G=J.add(Q.createInstance(y.$3yb)),X=J.add(Q.createInstance(d.$Jz));try{return await V(G,X)}finally{J.dispose()}})}};e.$61b=D,e.$61b=D=ye([K(0,$.$Tn),K(1,a.$Ezb),K(2,$.$Rn),K(3,i.$cBb),K(4,h.$oh),K(5,r.$egb)],D);let T=class extends s.$xAb{constructor(F,V,Z,J,Q,G,X,W){super("extensions",J,Q,G,Z,X,W),this.p=F,this.q=V}async t(F){return F.syncData?await v(F.syncData,this.p):null}u(F,V){const Z=[],J=[],Q=[];for(const G of F){if(this.q.hasToNeverSyncExtension(G.identifier.id))continue;const X=V.find(W=>(0,u.$ho)(W.identifier,G.identifier));X?(Z.push(X),G.disabled&&Q.push(G.identifier)):G.installed&&(J.push({...G.identifier,preRelease:!!G.preRelease}),G.disabled&&Q.push(G.identifier))}return{installedExtensions:Z,newExtensions:J,disabledExtensions:Q,remoteExtensions:F}}};e.$71b=T,e.$71b=T=ye([K(0,$.$Tn),K(1,i.$cBb),K(2,c.$Sj),K(3,o.$rk),K(4,C.$wh),K(5,b.$Ri),K(6,w.$Mo),K(7,t.$pk)],T)}),define(ce[116],le([0,1,14,8,3,34,41,6,32,18,15,13,7,44,19,21,27,39,77,234,24,17,58,4]),function(ie,e,L,N,O,A,j,R,S,g,C,y,$,u,d,p,c,h,f,b,w,I,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DAb=e.$CAb=e.$BAb=e.$AAb=e.$zAb=void 0;const s="globalState.argv.",n=["locale"];function i(E,D){const T=E.storage?Object.keys(E.storage).sort():[],M={};return T.forEach(F=>M[F]=E.storage[F]),E.storage=M,D?(0,j.$cS)(E,{}):JSON.stringify(E)}e.$zAb=i;const r=1;let a=class extends h.$uAb{constructor(D,T,M,F,V,Z,J,Q,G,X,W,q,B,_){super({syncResource:"globalState",profile:D},T,F,Q,q,V,Z,G,X,J,W,B),this.wb=M,this.mb=r,this.p=this.h.joinPath(this.g,"globalState.json"),this.r=this.p.with({scheme:w.$ggb,authority:"base"}),this.sb=this.p.with({scheme:w.$ggb,authority:"local"}),this.tb=this.p.with({scheme:w.$ggb,authority:"remote"}),this.ub=this.p.with({scheme:w.$ggb,authority:"accepted"}),this.vb=_.createInstance(v),this.B(F.watch(this.h.dirname(this.D.argvResource))),this.B(O.Event.any(O.Event.filter(F.onDidFilesChange,oe=>oe.contains(this.D.argvResource)),O.Event.filter(M.onDidChange,oe=>!!(oe.targetChanges.some(ae=>this.syncResource.profile.id===ae.id)||oe.valueChanges.some(({profile:ae,changes:Y})=>this.syncResource.profile.id===ae.id&&Y.some(U=>U.target===0)))))(()=>this.N()))}async nb(D,T,M){const F=D.syncData?JSON.parse(D.syncData.content):null;T=T===null&&M?D:T;const V=T&&T.syncData?JSON.parse(T.syncData.content):null,Z=await this.vb.getLocalGlobalState(this.syncResource.profile);F?this.L.trace(`${this.y}: Merging remote ui state with local ui state...`):this.L.trace(`${this.y}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const J=await this.Eb(V),{local:Q,remote:G}=(0,b.$yAb)(Z.storage,F?F.storage:null,V?V.storage:null,J,this.L),X={content:null,local:Q,remote:G,localChange:Object.keys(Q.added).length>0||Object.keys(Q.updated).length>0||Q.removed.length>0?2:0,remoteChange:G.all!==null?2:0},W=i(Z,!1);return[{baseResource:this.r,baseContent:V?i(V,!1):W,localResource:this.sb,localContent:W,localUserData:Z,remoteResource:this.tb,remoteContent:F?i(F,!1):null,previewResource:this.p,previewResult:X,localChange:X.localChange,remoteChange:X.remoteChange,acceptedResource:this.ub,storageKeys:J}]}async rb(D){const T=D.syncData?JSON.parse(D.syncData.content):null;if(T===null)return!0;const M=await this.vb.getLocalGlobalState(this.syncResource.profile),F=await this.Eb(T),{remote:V}=(0,b.$yAb)(M.storage,T.storage,T.storage,F,this.L);return V.all!==null}async ob(D,T){return{...D.previewResult,hasConflicts:!1}}async pb(D,T,M,F){if(this.h.isEqual(T,this.sb))return this.Bb(D);if(this.h.isEqual(T,this.tb))return this.Cb(D);if(this.h.isEqual(T,this.p))return D.previewResult;throw new Error(`Invalid Resource: ${T.toString()}`)}async Bb(D){return{content:D.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(D.localUserData.storage),removed:[],updated:[],all:D.localUserData.storage},localChange:0,remoteChange:2}}async Cb(D){if(D.remoteContent!==null){const T=JSON.parse(D.remoteContent),{local:M,remote:F}=(0,b.$yAb)(D.localUserData.storage,T.storage,null,D.storageKeys,this.L);return{content:D.remoteContent,local:M,remote:F,localChange:Object.keys(M.added).length>0||Object.keys(M.updated).length>0||M.removed.length>0?2:0,remoteChange:F!==null?2:0}}else return{content:D.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async qb(D,T,M,F){const{localUserData:V}=M[0][0],{local:Z,remote:J,localChange:Q,remoteChange:G}=M[0][1];if(Q===0&&G===0&&this.L.info(`${this.y}: No changes found during synchronizing ui state.`),Q!==0&&(this.L.trace(`${this.y}: Updating local ui state...`),await this.kb(JSON.stringify(V)),await this.vb.writeLocalGlobalState(Z,this.syncResource.profile),this.L.info(`${this.y}: Updated local ui state`)),G!==0){this.L.trace(`${this.y}: Updating remote ui state...`);const X=JSON.stringify({storage:J.all});D=await this.jb(X,F?null:D.ref),this.L.info(`${this.y}: Updated remote ui state.${J.added.length?` Added: ${J.added}.`:""}${J.updated.length?` Updated: ${J.updated}.`:""}${J.removed.length?` Removed: ${J.removed}.`:""}`)}T?.ref!==D.ref&&(this.L.trace(`${this.y}: Updating last synchronized ui state...`),await this.cb(D),this.L.info(`${this.y}: Updated last synchronized ui state`))}async resolveContent(D){if(this.h.isEqual(this.tb,D)||this.h.isEqual(this.r,D)||this.h.isEqual(this.sb,D)||this.h.isEqual(this.ub,D)){const T=await this.ab(D);return T&&i(JSON.parse(T),!0)}return null}async hasLocalData(){try{const{storage:D}=await this.vb.getLocalGlobalState(this.syncResource.profile);if(Object.keys(D).length>1||D[`${s}.locale`]?.value!=="en")return!0}catch{}return!1}async Eb(D){const T=await this.wb.readStorageData(this.syncResource.profile),M=[],F=[];for(const[J,Q]of T)Q.target===0?M.push(J):Q.target===1&&F.push(J);const V=[...M,...F],Z=D?.storage?Object.keys(D.storage).filter(J=>!J.startsWith(s)&&!V.includes(J)&&T.get(J)!==void 0):[];if(!R.$o){const J=[...w.$Xfb.map(Q=>(0,w.$$fb)(Q)),w.$0fb];Z.push(...J),F.push(...J)}return{user:M,machine:F,unregistered:Z}}};e.$AAb=a,e.$AAb=a=ye([K(2,t.$Ezb),K(3,y.$Sj),K(4,w.$2fb),K(5,w.$3fb),K(6,w.$egb),K(7,C.$wh),K(8,w.$_fb),K(9,p.$Vk),K(10,g.$Vh),K(11,d.$Mo),K(12,c.$pk),K(13,o.$oh)],a);let v=class{constructor(D,T,M,F){this.a=D,this.b=T,this.c=M,this.d=F}async getLocalGlobalState(D){const T={};if(D.isDefault){const F=await this.f(),V=(0,A.$ym)(F);for(const Z of n)V[Z]!==void 0&&(T[`${s}${Z}`]={version:1,value:V[Z]})}const M=await this.c.readStorageData(D);for(const[F,V]of M)V.value&&V.target===0&&(T[F]={version:1,value:V.value});return{storage:T}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const D=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),D.value.toString()}catch(D){this.d.debug((0,N.$9)(D))}return"{}"}async writeLocalGlobalState({added:D,removed:T,updated:M},F){const V=(0,h.$tAb)("globalState",F),Z={},J=new Map,Q=await this.c.readStorageData(F),G=(X,W)=>{for(const q of X){if(q.startsWith(s)){Z[q.substring(s.length)]=W?W[q].value:void 0;continue}if(W){const B=W[q];B.value!==Q.get(q)?.value&&J.set(q,B.value)}else Q.get(q)!==void 0&&J.set(q,void 0)}};if(G(Object.keys(D),D),G(Object.keys(M),M),G(T),Object.keys(Z).length){this.d.trace(`${V}: Updating locale...`);const X=await this.f();let W=X;for(const q of Object.keys(Z))W=(0,f.edit)(W,[q],Z[q],{});X!==W&&(this.d.trace(`${V}: Updating locale...`),await this.a.writeFile(this.b.argvResource,L.$Ec.fromString(W)),this.d.info(`${V}: Updated locale.`)),this.d.info(`${V}: Updated locale`)}J.size&&(this.d.trace(`${V}: Updating global state...`),await this.c.updateStorageData(F,J,0),this.d.info(`${V}: Updated global state`,[...J.keys()]))}};e.$BAb=v,e.$BAb=v=ye([K(0,y.$Sj),K(1,C.$wh),K(2,t.$Ezb),K(3,w.$egb)],v);let m=class extends h.$xAb{constructor(D,T,M,F,V,Z){super("globalState",M,F,V,T,D,Z)}async o(D){const T=D.syncData?JSON.parse(D.syncData.content):null;if(!T){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const M={},F={};for(const V of Object.keys(T.storage))V.startsWith(s)?M[V.substring(s.length)]=T.storage[V].value:this.l.get(V,0)===void 0&&(F[V]=T.storage[V].value);if(Object.keys(M).length){let V="{}";try{V=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const Z of Object.keys(M))V=(0,f.edit)(V,[Z],M[Z],{});await this.k.writeFile(this.h.argvResource,L.$Ec.fromString(V))}if(Object.keys(F).length){const V=[];for(const Z of Object.keys(F))V.push({key:Z,value:F[Z],scope:0,target:0});this.l.storeAll(V,!0)}}};e.$CAb=m,e.$CAb=m=ye([K(0,d.$Mo),K(1,y.$Sj),K(2,I.$rk),K(3,C.$wh),K(4,w.$egb),K(5,c.$pk)],m);let l=class{constructor(D,T,M,F,V){this.a=D,this.b=T,this.c=M,this.d=F,this.f=V}getSyncStoreType(D){return this.h(D)?.storage[w.$0fb]?.value}async sync(D){const T=(0,w.$6fb)((0,S.$3e)());try{return await this.g(D,T)}catch(M){if(M instanceof w.$7fb)switch(M.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(D,T)}throw M}}async g(D,T){const M=await this.a.readResource("globalState",null,void 0,T),F=this.h(M)||{storage:{}};F.storage[w.$0fb]={value:D,version:r};const V=await(0,u.$So)(this.c,this.d,this.b),Z={version:r,machineId:V,content:i(F,!1)};await this.a.writeResource("globalState",JSON.stringify(Z),M.ref,void 0,T)}h({content:D}){if(!D)return null;const T=JSON.parse(D);if((0,h.$sAb)(T))return T?JSON.parse(T.content):null;throw new Error("Invalid remote data")}};e.$DAb=l,e.$DAb=l=ye([K(1,d.$Mo),K(2,C.$wh),K(3,y.$Sj),K(4,$.$Ri)],l)}),define(ce[117],le([0,1,20,14,3,34,6,11,169,18,15,13,19,21,27,17,39,231,24]),function(ie,e,L,N,O,A,j,R,S,g,C,y,$,u,d,p,c,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$1b=e.$01b=e.$91b=void 0;function b(t,o,s){try{const n=JSON.parse(t);if(!o)return(0,R.$pe)(n.all)?null:n.all;switch(j.OS){case 2:return(0,R.$pe)(n.mac)?null:n.mac;case 3:return(0,R.$pe)(n.linux)?null:n.linux;case 1:return(0,R.$pe)(n.windows)?null:n.windows}}catch(n){return s.error(n),null}}e.$91b=b;let w=class extends c.$wAb{constructor(o,s,n,i,r,a,v,m,l,E,D,T,M){super(o.keybindingsResource,{syncResource:"keybindings",profile:o},s,m,l,E,n,i,v,T,r,D,a,M),this.mb=2,this.zb=this.h.joinPath(this.g,"keybindings.json"),this.Ab=this.zb.with({scheme:f.$ggb,authority:"base"}),this.Bb=this.zb.with({scheme:f.$ggb,authority:"local"}),this.Cb=this.zb.with({scheme:f.$ggb,authority:"remote"}),this.Db=this.zb.with({scheme:f.$ggb,authority:"accepted"}),this.B(O.Event.filter(a.onDidChangeConfiguration,F=>F.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.N()))}async nb(o,s,n,i){const r=o.syncData?b(o.syncData.content,i.keybindingsPerPlatform??this.Lb(),this.L):null;s=s===null&&n?o:s;const a=s?this.Jb(s):null,v=await this.p(),m=await this.xb();let l=null,E=!1,D=!1,T=!1;if(r){let V=v?v.value.toString():"[]";if(V=V||"[]",this.vb(V,!0))throw new f.$7fb((0,S.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==V||a!==r){this.L.trace(`${this.y}: Merging remote keybindings with local keybindings...`);const Z=await(0,h.$81b)(V,r,a,m,this.ub);Z.hasChanges&&(l=Z.mergeContent,T=Z.hasConflicts,E=T||Z.mergeContent!==V,D=T||Z.mergeContent!==r)}}else v&&(this.L.trace(`${this.y}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),l=v.value.toString(),D=!0);const M={content:T?a:l,localChange:E?v?2:1:0,remoteChange:D?2:0,hasConflicts:T},F=v?v.value.toString():null;return[{fileContent:v,baseResource:this.Ab,baseContent:a,localResource:this.Bb,localContent:F,localChange:M.localChange,remoteResource:this.Cb,remoteContent:r,remoteChange:M.remoteChange,previewResource:this.zb,previewResult:M,acceptedResource:this.Db}]}async rb(o){const s=this.Jb(o);if(s===null)return!0;const n=await this.p(),i=n?n.value.toString():"",r=await this.xb(),a=await(0,h.$81b)(i||"[]",s,s,r,this.ub);return a.hasConflicts||a.mergeContent!==s}async ob(o,s){return o.previewResult}async pb(o,s,n,i){if(this.h.isEqual(s,this.Bb))return{content:o.fileContent?o.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(s,this.Cb))return{content:o.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(s,this.zb))return n===void 0?{content:o.previewResult.content,localChange:o.previewResult.localChange,remoteChange:o.previewResult.remoteChange}:{content:n,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${s.toString()}`)}async qb(o,s,n,i){const{fileContent:r}=n[0][0];let{content:a,localChange:v,remoteChange:m}=n[0][1];if(v===0&&m===0&&this.L.info(`${this.y}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.vb(a,!0)))throw new f.$7fb((0,S.localize)(1,null),"LocalInvalidContent",this.resource);if(v!==0&&(this.L.trace(`${this.y}: Updating local keybindings...`),r&&await this.kb(this.Kb(r.value.toString())),await this.r(a||"[]",r,i),this.L.info(`${this.y}: Updated local keybindings`)),m!==0){this.L.trace(`${this.y}: Updating remote keybindings...`);const l=this.Kb(a||"[]",o.syncData?.content);o=await this.jb(l,i?null:o.ref),this.L.info(`${this.y}: Updated remote keybindings`)}try{await this.C.del(this.zb)}catch{}s?.ref!==o.ref&&(this.L.trace(`${this.y}: Updating last synchronized keybindings...`),await this.cb(o,{platformSpecific:this.Lb()}),this.L.info(`${this.y}: Updated last synchronized keybindings`))}async hasLocalData(){try{const o=await this.p();if(o){const s=(0,A.$ym)(o.value.toString());if((0,L.$nf)(s))return!0}}catch(o){if(o.fileOperationResult!==1)return!0}return!1}async resolveContent(o){return this.h.isEqual(this.Cb,o)||this.h.isEqual(this.Ab,o)||this.h.isEqual(this.Bb,o)||this.h.isEqual(this.Db,o)?this.ab(o):null}Jb(o){return!o.syncData||o.platformSpecific!==void 0&&o.platformSpecific!==this.Lb()?null:b(o.syncData.content,this.Lb(),this.L)}Kb(o,s){let n={};try{n=JSON.parse(s||"{}")}catch(i){this.L.error(i)}switch(this.Lb()?delete n.all:n.all=o,j.OS){case 2:n.mac=o;break;case 3:n.linux=o;break;case 1:n.windows=o;break}return JSON.stringify(n)}Lb(){return!!this.M.getValue(f.$Ufb)}};e.$01b=w,e.$01b=w=ye([K(2,f.$2fb),K(3,f.$3fb),K(4,f.$egb),K(5,g.$Vh),K(6,f.$_fb),K(7,y.$Sj),K(8,C.$wh),K(9,$.$Mo),K(10,f.$dgb),K(11,u.$Vk),K(12,d.$pk)],w);let I=class extends c.$xAb{constructor(o,s,n,i,r,a){super("keybindings",s,n,i,o,r,a)}async o(o){const s=o.syncData?this.p(o.syncData.content):null;if(!s){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,N.$Ec.fromString(s)),await this.n(o)}async i(){try{const o=await this.k.readFile(this.g.defaultProfile.settingsResource),s=(0,A.$ym)(o.value.toString());return!(0,L.$nf)(s)}catch(o){return o.fileOperationResult===1}}p(o){try{return b(o,!0,this.j)}catch(s){return this.j.error(s),null}}};e.$$1b=I,e.$$1b=I=ye([K(0,y.$Sj),K(1,p.$rk),K(2,C.$wh),K(3,f.$egb),K(4,$.$Mo),K(5,d.$pk)],I)}),define(ce[118],le([0,1,14,3,170,18,73,15,29,13,19,21,27,17,39,235,24]),function(ie,e,L,N,O,A,j,R,S,g,C,y,$,u,d,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b2b=e.$a2b=e.$_1b=void 0;function h(I){return I&&I.settings&&typeof I.settings=="string"&&Object.keys(I).length===1}function f(I){const t=JSON.parse(I);return h(t)?t:{settings:I}}e.$_1b=f;let b=class extends d.$wAb{constructor(t,o,s,n,i,r,a,v,m,l,E,D,T,M){super(t.settingsResource,{syncResource:"settings",profile:t},o,s,n,i,r,a,E,D,v,m,l,M),this.zb=T,this.mb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:c.$ggb,authority:"base"}),this.localResource=this.previewResource.with({scheme:c.$ggb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:c.$ggb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:c.$ggb,authority:"accepted"}),this.Jb=void 0}async getRemoteUserDataSyncConfiguration(t){const o=await this.getLastSyncUserData(),s=await this.S(t,o),n=this.Gb(s),i=new j.$en(c.$Tfb);return n?.settings&&i.parse(n.settings),i.configurationModel.getValue(c.$Tfb)||{}}async nb(t,o,s){const n=await this.p(),i=await this.xb(),r=this.Gb(t);o=o===null&&s?t:o;const a=o?this.Gb(o):null,v=await this.Kb();let m=null,l=!1,E=!1,D=!1;if(r){let V=n?n.value.toString().trim():"{}";V=V||"{}",this.Lb(V),this.L.trace(`${this.y}: Merging remote settings with local settings...`);const Z=(0,p.$lzb)(V,r.settings,a?a.settings:null,v,[],i);m=Z.localContent||Z.remoteContent,l=Z.localContent!==null,E=Z.remoteContent!==null,D=Z.hasConflicts}else n&&(this.L.trace(`${this.y}: Remote settings does not exist. Synchronizing settings for the first time.`),m=n.value.toString().trim()||"{}",this.Lb(m),E=!0);const T=n?n.value.toString():null,M=a?.settings??null,F={content:D?M:m,localChange:l?2:0,remoteChange:E?2:0,hasConflicts:D};return[{fileContent:n,baseResource:this.baseResource,baseContent:M,localResource:this.localResource,localContent:T,localChange:F.localChange,remoteResource:this.remoteResource,remoteContent:r?r.settings:null,remoteChange:F.remoteChange,previewResource:this.previewResource,previewResult:F,acceptedResource:this.acceptedResource}]}async rb(t){const o=this.Gb(t);if(o===null)return!0;const s=await this.p(),n=s?s.value.toString().trim():"",i=await this.Kb(),r=await this.xb();return(0,p.$lzb)(n||"{}",o.settings,o.settings,i,[],r).remoteContent!==null}async ob(t,o){const s=await this.xb(),n=await this.Kb();return{...t.previewResult,content:t.previewResult.content?(0,p.$kzb)(t.previewResult.content,"{}",n,s):null}}async pb(t,o,s,n){const i=await this.xb(),r=await this.Kb();if(this.h.isEqual(o,this.localResource))return{content:t.fileContent?(0,p.$kzb)(t.fileContent.value.toString(),"{}",r,i):null,localChange:0,remoteChange:2};if(this.h.isEqual(o,this.remoteResource))return{content:t.remoteContent!==null?(0,p.$kzb)(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",r,i):null,localChange:2,remoteChange:0};if(this.h.isEqual(o,this.previewResource))return s===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:s!==null?(0,p.$kzb)(s,t.fileContent?t.fileContent.value.toString():"{}",r,i):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${o.toString()}`)}async qb(t,o,s,n){const{fileContent:i}=s[0][0];let{content:r,localChange:a,remoteChange:v}=s[0][1];if(a===0&&v===0&&this.L.info(`${this.y}: No changes found during synchronizing settings.`),r=r?r.trim():"{}",r=r||"{}",this.Lb(r),a!==0&&(this.L.trace(`${this.y}: Updating local settings...`),i&&await this.kb(JSON.stringify(this.Ib(i.value.toString()))),await this.r(r,i,n),await this.M.reloadConfiguration(3),this.L.info(`${this.y}: Updated local settings`)),v!==0){const m=await this.xb(),l=this.Gb(t),E=await this.Kb(r);r=(0,p.$kzb)(r,l?l.settings:"{}",E,m),this.L.trace(`${this.y}: Updating remote settings...`),t=await this.jb(JSON.stringify(this.Ib(r)),n?null:t.ref),this.L.info(`${this.y}: Updated remote settings`)}try{await this.C.del(this.previewResource)}catch{}o?.ref!==t.ref&&(this.L.trace(`${this.y}: Updating last synchronized settings...`),await this.cb(t),this.L.info(`${this.y}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.p();if(t)return!(0,p.$mzb)(t.value.toString())}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async resolveContent(t){return this.h.isEqual(this.remoteResource,t)||this.h.isEqual(this.localResource,t)||this.h.isEqual(this.acceptedResource,t)||this.h.isEqual(this.baseResource,t)?this.ab(t):null}async ab(t){let o=await super.ab(t);if(o){const s=await this.xb(),n=await this.Kb();o=(0,p.$kzb)(o,"{}",n,s)}return o}Gb(t){return t.syncData?this.Hb(t.syncData.content):null}Hb(t){try{return f(t)}catch(o){this.L.error(o)}return null}Ib(t){return{settings:t}}async Kb(t){if(!this.Jb){this.Jb=this.ub.resolveDefaultIgnoredSettings();const s=N.Event.any(N.Event.filter(this.zb.onDidInstallExtensions,n=>n.some(({local:i})=>!!i)),N.Event.filter(this.zb.onDidUninstallExtension,n=>!n.error))(()=>{s.dispose(),this.Jb=void 0})}const o=await this.Jb;return(0,p.$izb)(o,this.M,t)}Lb(t){if(this.vb(t,!1))throw new c.$7fb((0,O.localize)(0,null),"LocalInvalidContent",this.resource)}};e.$a2b=b,e.$a2b=b=ye([K(2,g.$Sj),K(3,R.$wh),K(4,C.$Mo),K(5,c.$2fb),K(6,c.$3fb),K(7,c.$egb),K(8,c.$dgb),K(9,A.$Vh),K(10,c.$_fb),K(11,y.$Vk),K(12,S.$Tn),K(13,$.$pk)],b);let w=class extends d.$xAb{constructor(t,o,s,n,i,r){super("settings",o,s,n,t,i,r)}async o(t){const o=t.syncData?this.p(t.syncData.content):null;if(!o){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,L.$Ec.fromString(o.settings)),await this.n(t)}async i(){try{const t=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,p.$mzb)(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}p(t){try{return f(t)}catch(o){this.j.error(o)}return null}};e.$b2b=w,e.$b2b=w=ye([K(0,g.$Sj),K(1,u.$rk),K(2,R.$wh),K(3,c.$egb),K(4,C.$Mo),K(5,$.$pk)],w)}),define(ce[119],le([0,1,14,3,30,18,15,13,19,21,27,17,39,232,24]),function(ie,e,L,N,O,A,j,R,S,g,C,y,$,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g2b=e.$f2b=e.$e2b=void 0;function p(f){return JSON.parse(f.content)}e.$e2b=p;let c=class extends $.$uAb{constructor(b,w,I,t,o,s,n,i,r,a,v,m){super({syncResource:"snippets",profile:b},w,t,I,o,s,n,a,v,i,r,m),this.mb=1,this.p=b.snippetsHome,this.B(this.C.watch(I.userRoamingDataHome)),this.B(this.C.watch(this.p)),this.B(N.Event.filter(this.C.onDidFilesChange,l=>l.affects(this.p))(()=>this.N()))}async nb(b,w,I){const t=await this.Cb(),o=this.Bb(t),s=b.syncData?this.Ab(b.syncData):null;w=w===null&&I?b:w;const n=w&&w.syncData?this.Ab(w.syncData):null;s?this.L.trace(`${this.y}: Merging remote snippets with local snippets...`):this.L.trace(`${this.y}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const i=(0,u.$c2b)(o,s,n);return this.wb(i,t,s||{},n||{})}async rb(b){const w=b.syncData?this.Ab(b.syncData):null;if(w===null)return!0;const I=await this.Cb(),t=this.Bb(I),o=(0,u.$c2b)(t,w,w);return Object.keys(o.remote.added).length>0||Object.keys(o.remote.updated).length>0||o.remote.removed.length>0||o.conflicts.length>0}async ob(b,w){return b.previewResult}async pb(b,w,I,t){if(this.h.isEqualOrParent(w,this.g.with({scheme:d.$ggb,authority:"local"})))return{content:b.fileContent?b.fileContent.value.toString():null,localChange:0,remoteChange:b.fileContent?b.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(w,this.g.with({scheme:d.$ggb,authority:"remote"})))return{content:b.remoteContent,localChange:b.remoteContent!==null?b.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(w,this.g))return I===void 0?{content:b.previewResult.content,localChange:b.previewResult.localChange,remoteChange:b.previewResult.remoteChange}:{content:I,localChange:I===null?b.fileContent!==null?3:0:2,remoteChange:I===null?b.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${w.toString()}`)}async qb(b,w,I,t){const o=I.map(([s,n])=>({...s,acceptResult:n}));o.every(({localChange:s,remoteChange:n})=>s===0&&n===0)&&this.L.info(`${this.y}: No changes found during synchronizing snippets.`),o.some(({localChange:s})=>s!==0)&&(await this.xb(o),await this.yb(o,t)),o.some(({remoteChange:s})=>s!==0)&&(b=await this.zb(o,b,t)),w?.ref!==b.ref&&(this.L.trace(`${this.y}: Updating last synchronized snippets...`),await this.cb(b),this.L.info(`${this.y}: Updated last synchronized snippets`));for(const{previewResource:s}of o)try{await this.C.del(s)}catch{}}wb(b,w,I,t){const o=new Map;for(const s of Object.keys(b.local.added)){const n={content:b.local.added[s],hasConflicts:!1,localChange:1,remoteChange:0};o.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:d.$ggb,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,s).with({scheme:d.$ggb,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,s).with({scheme:d.$ggb,authority:"remote"}),remoteContent:I[s],previewResource:this.h.joinPath(this.g,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:d.$ggb,authority:"accepted"})})}for(const s of Object.keys(b.local.updated)){const n={content:b.local.updated[s],hasConflicts:!1,localChange:2,remoteChange:0},i=w[s]?w[s].value.toString():null;o.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:d.$ggb,authority:"base"}),baseContent:t[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:d.$ggb,authority:"local"}),fileContent:w[s],localContent:i,remoteResource:this.h.joinPath(this.g,s).with({scheme:d.$ggb,authority:"remote"}),remoteContent:I[s],previewResource:this.h.joinPath(this.g,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:d.$ggb,authority:"accepted"})})}for(const s of b.local.removed){const n={content:null,hasConflicts:!1,localChange:3,remoteChange:0},i=w[s]?w[s].value.toString():null;o.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:d.$ggb,authority:"base"}),baseContent:t[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:d.$ggb,authority:"local"}),fileContent:w[s],localContent:i,remoteResource:this.h.joinPath(this.g,s).with({scheme:d.$ggb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:d.$ggb,authority:"accepted"})})}for(const s of Object.keys(b.remote.added)){const n={content:b.remote.added[s],hasConflicts:!1,localChange:0,remoteChange:1},i=w[s]?w[s].value.toString():null;o.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:d.$ggb,authority:"base"}),baseContent:t[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:d.$ggb,authority:"local"}),fileContent:w[s],localContent:i,remoteResource:this.h.joinPath(this.g,s).with({scheme:d.$ggb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:d.$ggb,authority:"accepted"})})}for(const s of Object.keys(b.remote.updated)){const n={content:b.remote.updated[s],hasConflicts:!1,localChange:0,remoteChange:2},i=w[s]?w[s].value.toString():null;o.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:d.$ggb,authority:"base"}),baseContent:t[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:d.$ggb,authority:"local"}),fileContent:w[s],localContent:i,remoteResource:this.h.joinPath(this.g,s).with({scheme:d.$ggb,authority:"remote"}),remoteContent:I[s],previewResource:this.h.joinPath(this.g,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:d.$ggb,authority:"accepted"})})}for(const s of b.remote.removed){const n={content:null,hasConflicts:!1,localChange:0,remoteChange:3};o.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:d.$ggb,authority:"base"}),baseContent:t[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:d.$ggb,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,s).with({scheme:d.$ggb,authority:"remote"}),remoteContent:I[s],previewResource:this.h.joinPath(this.g,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:d.$ggb,authority:"accepted"})})}for(const s of b.conflicts){const n={content:t[s]??null,hasConflicts:!0,localChange:w[s]?2:1,remoteChange:I[s]?2:1},i=w[s]?w[s].value.toString():null;o.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:d.$ggb,authority:"base"}),baseContent:t[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:d.$ggb,authority:"local"}),fileContent:w[s]||null,localContent:i,remoteResource:this.h.joinPath(this.g,s).with({scheme:d.$ggb,authority:"remote"}),remoteContent:I[s]||null,previewResource:this.h.joinPath(this.g,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:d.$ggb,authority:"accepted"})})}for(const s of Object.keys(w))if(!o.has(s)){const n={content:w[s]?w[s].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},i=w[s]?w[s].value.toString():null;o.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:d.$ggb,authority:"base"}),baseContent:t[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:d.$ggb,authority:"local"}),fileContent:w[s]||null,localContent:i,remoteResource:this.h.joinPath(this.g,s).with({scheme:d.$ggb,authority:"remote"}),remoteContent:I[s]||null,previewResource:this.h.joinPath(this.g,s),previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:d.$ggb,authority:"accepted"})})}return[...o.values()]}async resolveContent(b){return this.h.isEqualOrParent(b,this.g.with({scheme:d.$ggb,authority:"remote"}))||this.h.isEqualOrParent(b,this.g.with({scheme:d.$ggb,authority:"local"}))||this.h.isEqualOrParent(b,this.g.with({scheme:d.$ggb,authority:"base"}))||this.h.isEqualOrParent(b,this.g.with({scheme:d.$ggb,authority:"accepted"}))?this.ab(b):null}async hasLocalData(){try{const b=await this.Cb();if(Object.keys(b).length)return!0}catch{}return!1}async xb(b){const w={};for(const I of b)I.fileContent&&(w[this.h.basename(I.localResource)]=I.fileContent);await this.kb(JSON.stringify(this.Bb(w)))}async yb(b,w){for(const{fileContent:I,acceptResult:t,localResource:o,remoteResource:s,localChange:n}of b)if(n!==0){const i=s?this.h.basename(s):this.h.basename(o),r=this.h.joinPath(this.p,i);n===3?(this.L.trace(`${this.y}: Deleting snippet...`,this.h.basename(r)),await this.C.del(r),this.L.info(`${this.y}: Deleted snippet`,this.h.basename(r))):n===1?(this.L.trace(`${this.y}: Creating snippet...`,this.h.basename(r)),await this.C.createFile(r,L.$Ec.fromString(t.content),{overwrite:w}),this.L.info(`${this.y}: Created snippet`,this.h.basename(r))):(this.L.trace(`${this.y}: Updating snippet...`,this.h.basename(r)),await this.C.writeFile(r,L.$Ec.fromString(t.content),w?void 0:I),this.L.info(`${this.y}: Updated snippet`,this.h.basename(r)))}}async zb(b,w,I){const t=w.syncData?this.Ab(w.syncData):{},o=(0,O.$Im)(t);for(const{acceptResult:s,localResource:n,remoteResource:i,remoteChange:r}of b)if(r!==0){const a=n?this.h.basename(n):this.h.basename(i);r===3?delete o[a]:o[a]=s.content}return(0,u.$d2b)(t,o)||(this.L.trace(`${this.y}: Updating remote snippets...`),w=await this.jb(JSON.stringify(o),I?null:w.ref),this.L.info(`${this.y}: Updated remote snippets`)),w}Ab(b){return p(b)}Bb(b){const w={};for(const I of Object.keys(b))w[I]=b[I].value.toString();return w}async Cb(){const b={};let w;try{w=await this.C.resolve(this.p)}catch(I){if(I instanceof R.$ak&&I.fileOperationResult===1)return b;throw I}for(const I of w.children||[]){const t=I.resource,o=this.h.extname(t);if(o===".json"||o===".code-snippets"){const s=this.h.relativePath(this.p,t),n=await this.C.readFile(t);b[s]=n}}return b}};e.$f2b=c,e.$f2b=c=ye([K(2,j.$wh),K(3,R.$Sj),K(4,S.$Mo),K(5,d.$2fb),K(6,d.$3fb),K(7,d.$egb),K(8,A.$Vh),K(9,d.$_fb),K(10,g.$Vk),K(11,C.$pk)],c);let h=class extends $.$xAb{constructor(b,w,I,t,o,s){super("snippets",w,I,t,b,o,s)}async o(b){const w=b.syncData?JSON.parse(b.syncData.content):null;if(!w){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const t of Object.keys(w)){const o=w[t];if(o){const s=this.d.joinPath(this.g.defaultProfile.snippetsHome,t);await this.k.createFile(s,L.$Ec.fromString(o)),this.j.info("Created snippet",this.d.basename(s))}}await this.n(b)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(b){return b.fileOperationResult===1}}};e.$g2b=h,e.$g2b=h=ye([K(0,R.$Sj),K(1,y.$rk),K(2,j.$wh),K(3,d.$egb),K(4,S.$Mo),K(5,C.$pk)],h)}),define(ce[120],le([0,1,14,18,15,13,19,21,27,17,39,24]),function(ie,e,L,N,O,A,j,R,S,g,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j2b=e.$i2b=e.$h2b=void 0;function $(c,h){try{return JSON.parse(c).tasks??null}catch(f){return h.error(f),null}}e.$h2b=$;let u=class extends C.$vAb{constructor(h,f,b,w,I,t,o,s,n,i,r,a){super(h.tasksResource,{syncResource:"tasks",profile:h},f,s,n,i,b,w,o,r,I,t,a),this.mb=1,this.vb=this.h.joinPath(this.g,"tasks.json"),this.wb=this.vb.with({scheme:y.$ggb,authority:"base"}),this.xb=this.vb.with({scheme:y.$ggb,authority:"local"}),this.yb=this.vb.with({scheme:y.$ggb,authority:"remote"}),this.zb=this.vb.with({scheme:y.$ggb,authority:"accepted"})}async nb(h,f,b,w){const I=h.syncData?$(h.syncData.content,this.L):null;f=f===null&&b?h:f;const t=f?.syncData?$(f.syncData.content,this.L):null,o=await this.p();let s=null,n=!1,i=!1,r=!1;if(h.syncData){const m=o?o.value.toString():null;if(!t||t!==m||t!==I){this.L.trace(`${this.y}: Merging remote tasks with local tasks...`);const l=p(m,I,t);s=l.content,r=l.hasConflicts,n=l.hasLocalChanged,i=l.hasRemoteChanged}}else o&&(this.L.trace(`${this.y}: Remote tasks does not exist. Synchronizing tasks for the first time.`),s=o.value.toString(),i=!0);const a={content:r?t:s,localChange:n?o?2:1:0,remoteChange:i?2:0,hasConflicts:r},v=o?o.value.toString():null;return[{fileContent:o,baseResource:this.wb,baseContent:t,localResource:this.xb,localContent:v,localChange:a.localChange,remoteResource:this.yb,remoteContent:I,remoteChange:a.remoteChange,previewResource:this.vb,previewResult:a,acceptedResource:this.zb}]}async rb(h){const f=h?.syncData?$(h.syncData.content,this.L):null;if(f===null)return!0;const b=await this.p(),w=b?b.value.toString():null,I=p(w,f,f);return I.hasLocalChanged||I.hasRemoteChanged}async ob(h,f){return h.previewResult}async pb(h,f,b,w){if(this.h.isEqual(f,this.xb))return{content:h.fileContent?h.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(f,this.yb))return{content:h.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(f,this.vb))return b===void 0?{content:h.previewResult.content,localChange:h.previewResult.localChange,remoteChange:h.previewResult.remoteChange}:{content:b,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${f.toString()}`)}async qb(h,f,b,w){const{fileContent:I}=b[0][0],{content:t,localChange:o,remoteChange:s}=b[0][1];if(o===0&&s===0&&this.L.info(`${this.y}: No changes found during synchronizing tasks.`),o!==0&&(this.L.trace(`${this.y}: Updating local tasks...`),I&&await this.kb(JSON.stringify(this.Fb(I.value.toString()))),t?await this.r(t,I,w):await this.sb(),this.L.info(`${this.y}: Updated local tasks`)),s!==0){this.L.trace(`${this.y}: Updating remote tasks...`);const n=JSON.stringify(this.Fb(t));h=await this.jb(n,w?null:h.ref),this.L.info(`${this.y}: Updated remote tasks`)}try{await this.C.del(this.vb)}catch{}f?.ref!==h.ref&&(this.L.trace(`${this.y}: Updating last synchronized tasks...`),await this.cb(h),this.L.info(`${this.y}: Updated last synchronized tasks`))}async hasLocalData(){return this.C.exists(this.i)}async resolveContent(h){return this.h.isEqual(this.yb,h)||this.h.isEqual(this.wb,h)||this.h.isEqual(this.xb,h)||this.h.isEqual(this.zb,h)?this.ab(h):null}Fb(h){return h?{tasks:h}:{}}};e.$i2b=u,e.$i2b=u=ye([K(2,y.$2fb),K(3,y.$3fb),K(4,y.$egb),K(5,N.$Vh),K(6,y.$_fb),K(7,A.$Sj),K(8,O.$wh),K(9,j.$Mo),K(10,R.$Vk),K(11,S.$pk)],u);let d=class extends C.$xAb{constructor(h,f,b,w,I,t){super("tasks",f,b,w,h,I,t),this.c=this.g.defaultProfile.tasksResource}async o(h){const f=h.syncData?$(h.syncData.content,this.j):null;if(!f){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,L.$Ec.fromString(f)),await this.n(h)}async p(){return this.k.exists(this.c)}};e.$j2b=d,e.$j2b=d=ye([K(0,A.$Sj),K(1,g.$rk),K(2,O.$wh),K(3,y.$egb),K(4,j.$Mo),K(5,S.$pk)],d);function p(c,h,f){if(c===null&&h===null&&f===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(c===h)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const b=f!==c,w=f!==h;return!b&&!w?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:b&&!w?{content:c,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:w&&!b?{content:h,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:c,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(ce[121],le([0,1,41,18,15,13,19,21,27,17,39,233,24]),function(ie,e,L,N,O,A,j,R,S,g,C,y,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z3b=e.$Y3b=e.$X3b=void 0;let u=class extends C.$uAb{constructor(h,f,b,w,I,t,o,s,n,i,r,a,v){super({syncResource:"profiles",profile:h},f,w,I,t,o,s,r,a,n,i,v),this.r=b,this.mb=2,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:$.$ggb,authority:"base"}),this.localResource=this.previewResource.with({scheme:$.$ggb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:$.$ggb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:$.$ggb,authority:"accepted"}),this.B(b.onDidChangeProfiles(()=>this.N()))}async getLastSyncedProfiles(){const h=await this.getLastSyncUserData();return h?.syncData?p(h.syncData):null}async getRemoteSyncedProfiles(h){const f=await this.getLastSyncUserData(),b=await this.S(h,f);return b?.syncData?p(b.syncData):null}async nb(h,f,b){if(!this.r.isEnabled())throw new $.$7fb("Cannot sync profiles because they are disabled","LocalError");const w=h.syncData?p(h.syncData):null,I=f?.syncData?p(f.syncData):null,t=this.zb(),{local:o,remote:s}=(0,y.$W3b)(t,w,I,[]),n={local:o,remote:s,content:I?this.Ab(I):null,localChange:o.added.length>0||o.removed.length>0||o.updated.length>0?2:0,remoteChange:s!==null?2:0},i=d(t,!1);return[{baseResource:this.baseResource,baseContent:I?this.Ab(I):null,localResource:this.localResource,localContent:i,remoteResource:this.remoteResource,remoteContent:w?this.Ab(w):null,remoteProfiles:w,previewResource:this.previewResource,previewResult:n,localChange:n.localChange,remoteChange:n.remoteChange,acceptedResource:this.acceptedResource}]}async rb(h){const f=h?.syncData?p(h.syncData):null,b=this.zb(),{remote:w}=(0,y.$W3b)(b,f,f,[]);return!!w?.added.length||!!w?.removed.length||!!w?.updated.length}async ob(h,f){return{...h.previewResult,hasConflicts:!1}}async pb(h,f,b,w){if(this.h.isEqual(f,this.localResource))return this.wb(h);if(this.h.isEqual(f,this.remoteResource))return this.xb(h);if(this.h.isEqual(f,this.previewResource))return h.previewResult;throw new Error(`Invalid Resource: ${f.toString()}`)}async wb(h){const f=this.zb(),b=(0,y.$W3b)(f,null,null,[]),{local:w,remote:I}=b;return{content:h.localContent,local:w,remote:I,localChange:w.added.length>0||w.removed.length>0||w.updated.length>0?2:0,remoteChange:I!==null?2:0}}async xb(h){const f=h.remoteContent?JSON.parse(h.remoteContent):null,b=[],w=[];for(const I of this.zb()){const t=f?.find(o=>o.id===I.id);t&&(b.push({id:I.id,name:I.name,collection:t.collection}),w.push(I))}if(f!==null){const I=(0,y.$W3b)(w,f,b,[]),{local:t,remote:o}=I;return{content:h.remoteContent,local:t,remote:o,localChange:t.added.length>0||t.removed.length>0||t.updated.length>0?2:0,remoteChange:o!==null?2:0}}else return{content:h.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async qb(h,f,b,w){const{local:I,remote:t,localChange:o,remoteChange:s}=b[0][1];o===0&&s===0&&this.L.info(`${this.y}: No changes found during synchronizing profiles.`);const n=b[0][0].remoteProfiles||[];if(n.length+(t?.added.length??0)-(t?.removed.length??0)>20)throw new $.$7fb("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(o!==0){await this.kb(d(this.zb(),!1));const i=[];for(const r of I.added)i.push((async()=>{this.L.trace(`${this.y}: Creating '${r.name}' profile...`),await this.r.createProfile(r.id,r.name,{shortName:r.shortName,useDefaultFlags:r.useDefaultFlags}),this.L.info(`${this.y}: Created profile '${r.name}'.`)})());for(const r of I.removed)i.push((async()=>{this.L.trace(`${this.y}: Removing '${r.name}' profile...`),await this.r.removeProfile(r),this.L.info(`${this.y}: Removed profile '${r.name}'.`)})());for(const r of I.updated){const a=this.r.profiles.find(v=>v.id===r.id);a?i.push((async()=>{this.L.trace(`${this.y}: Updating '${r.name}' profile...`),await this.r.updateProfile(a,{name:r.name,shortName:r.shortName,useDefaultFlags:r.useDefaultFlags}),this.L.info(`${this.y}: Updated profile '${r.name}'.`)})()):this.L.info(`${this.y}: Could not find profile with id '${r.id}' to update.`)}await Promise.all(i)}if(s!==0){this.L.trace(`${this.y}: Updating remote profiles...`);const i=[],r=n.length+(t?.added.length??0)<=20;if(r)for(const a of t?.added||[]){const v=await this.G.createCollection(this.z);i.push(v),n.push({id:a.id,name:a.name,collection:v,shortName:a.shortName,useDefaultFlags:a.useDefaultFlags})}else this.L.info(`${this.y}: Could not create remote profiles as there are too many profiles.`);for(const a of t?.removed||[])n.splice(n.findIndex(({id:v})=>a.id===v),1);for(const a of t?.updated||[]){const v=n.find(({id:m})=>a.id===m);v&&n.splice(n.indexOf(v),1,{...v,id:a.id,name:a.name,shortName:a.shortName,useDefaultFlags:a.useDefaultFlags})}try{h=await this.updateRemoteProfiles(n,w?null:h.ref),this.L.info(`${this.y}: Updated remote profiles.${r&&t?.added.length?` Added: ${JSON.stringify(t.added.map(a=>a.name))}.`:""}${t?.updated.length?` Updated: ${JSON.stringify(t.updated.map(a=>a.name))}.`:""}${t?.removed.length?` Removed: ${JSON.stringify(t.removed.map(a=>a.name))}.`:""}`)}catch(a){if(i.length){this.L.info(`${this.y}: Failed to update remote profiles. Cleaning up added collections...`);for(const v of i)await this.G.deleteCollection(v,this.z)}throw a}for(const a of t?.removed||[])await this.G.deleteCollection(a.collection,this.z)}f?.ref!==h.ref&&(this.L.trace(`${this.y}: Updating last synchronized profiles...`),await this.cb(h),this.L.info(`${this.y}: Updated last synchronized profiles.`))}async updateRemoteProfiles(h,f){return this.jb(this.Ab(h),f)}async hasLocalData(){return this.zb().length>0}async resolveContent(h){if(this.h.isEqual(this.remoteResource,h)||this.h.isEqual(this.baseResource,h)||this.h.isEqual(this.localResource,h)||this.h.isEqual(this.acceptedResource,h)){const f=await this.ab(h);return f&&(0,L.$cS)(JSON.parse(f),{})}return null}zb(){return this.r.profiles.filter(h=>!h.isDefault&&!h.isTransient)}Ab(h){return JSON.stringify([...h].sort((f,b)=>f.name.localeCompare(b.name)))}};e.$X3b=u,e.$X3b=u=ye([K(2,g.$rk),K(3,A.$Sj),K(4,O.$wh),K(5,j.$Mo),K(6,$.$2fb),K(7,$.$3fb),K(8,$.$egb),K(9,N.$Vh),K(10,$.$_fb),K(11,R.$Vk),K(12,S.$pk)],u);function d(c,h){const f=[...c].sort((b,w)=>b.name.localeCompare(w.name)).map(b=>({id:b.id,name:b.name}));return h?(0,L.$cS)(f,{}):JSON.stringify(f)}e.$Y3b=d;function p(c){return JSON.parse(c.content)}e.$Z3b=p}),define(ce[251],le([0,1,5,14,62,2,22,18,15,13,17,24]),function(ie,e,L,N,O,A,j,R,S,g,C,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V3b=void 0;let $=class extends A.$lb{constructor(d,p,c,h,f){super(),this.a=d,this.b=p,this.c=c,this.f=h,this.g=f,this.h()}async h(){for(const p of this.g.profiles)for(const c of y.$Xfb)try{await this.j(this.i(p,c))}catch(h){this.f.error(h)}let d;try{d=await this.b.resolve(this.a.userDataSyncHome)}catch(p){(0,g.$9j)(p)!==1&&this.f.error(p);return}if(d.children){for(const p of d.children)if(p.isDirectory&&!this.g.profiles.some(c=>c.id===p.name))try{this.f.info("Deleting non existing profile from backup",p.resource.path),await this.b.del(p.resource,{recursive:!0})}catch(c){this.f.error(c)}}}async getAllRefs(d,p){const c=this.i(d,p);try{const h=await this.b.resolve(c);if(h.children)return h.children.filter(b=>b.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(b.name)).sort().reverse().map(b=>({ref:b.name,created:this.k(b)}))}catch(h){if((0,g.$9j)(h)!==1)throw h}return[]}async resolveContent(d,p,c){const h=this.i(d,p),f=(0,j.$9f)(h,c);try{return(await this.b.readFile(f)).value.toString()}catch(b){return this.f.error(b),null}}async backup(d,p,c){const h=this.i(d,p),f=(0,j.$9f)(h,`${(0,O.$Tl)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(f,N.$Ec.fromString(c))}catch(b){this.f.error(b)}try{this.j(h)}catch{}}i(d,p){return(0,j.$9f)(this.a.userDataSyncHome,...d.isDefault?[p]:[d.id,p])}async j(d){try{try{if(!await this.b.exists(d))return}catch{return}const p=await this.b.resolve(d);if(p.children){const c=p.children.filter(w=>w.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(w.name)).sort(),h=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let f=c.filter(w=>Date.now()-this.k(w)>h);const b=c.length-f.length;b<10&&(f=f.slice(10-b)),await L.Promises.settled(f.map(async w=>{this.f.info("Deleting from backup",w.resource.path),await this.b.del(w.resource)}))}}catch(p){this.f.error(p)}}k(d){return d.ctime||new Date(parseInt(d.name.substring(0,4)),parseInt(d.name.substring(4,6))-1,parseInt(d.name.substring(6,8)),parseInt(d.name.substring(9,11)),parseInt(d.name.substring(11,13)),parseInt(d.name.substring(13,15))).getTime()}};e.$V3b=$,e.$V3b=$=ye([K(0,S.$wh),K(1,g.$Sj),K(2,R.$Vh),K(3,y.$egb),K(4,C.$rk)],$)}),define(ce[252],le([0,1,3,2,6,15,19,21,24]),function(ie,e,L,N,O,A,j,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K3b=void 0;const g="sync.enable";let C=class extends N.$lb{constructor($,u,d,p){super(),this.c=$,this.f=u,this.g=d,this.h=p,this.a=new L.$ec,this.onDidChangeEnablement=this.a.event,this.b=new L.$ec,this.onDidChangeResourceEnablement=this.b.event,this.B($.onDidChangeValue(-1,void 0,this.B(new N.$kb))(c=>this.j(c)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(g,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement($){$&&!this.canToggleEnablement()||(this.f.publicLog2(g,{enabled:$}),this.c.store(g,$,-1,1))}isResourceEnabled($){return this.c.getBoolean((0,S.$$fb)($),-1,!0)}setResourceEnablement($,u){if(this.isResourceEnabled($)!==u){const d=(0,S.$$fb)($);this.i(d,u)}}getResourceSyncStateVersion($){}i($,u){this.c.store($,u,-1,O.$o?0:1)}j($){if(g===$.key){this.a.fire(this.isEnabled());return}const u=S.$Xfb.filter(d=>(0,S.$$fb)(d)===$.key)[0];if(u){this.b.fire([u,this.isResourceEnabled(u)]);return}}};e.$K3b=C,e.$K3b=C=ye([K(0,j.$Mo),K(1,R.$Vk),K(2,A.$wh),K(3,S.$1fb)],C)}),define(ce[81],le([0,1,3,2,6,28,174,15,13,4,23,44,19,24]),function(ie,e,L,N,O,A,j,R,S,g,C,y,$,u){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$WYb=e.$VYb=e.$UYb=void 0,e.$UYb=(0,g.$ph)("IUserDataSyncMachinesService");const p="sync.currentMachineName",c="Safari",h="Chrome",f="Edge",b="Firefox",w="Android";function I(s){switch(s){case c:case h:case f:case b:case w:case(0,O.$h)(0):return!0}return!1}e.$VYb=I;function t(){return O.$F?c:O.$D?h:O.$G?f:O.$E?b:O.$H?w:(0,O.$h)(O.$o?0:O.$t)}let o=class extends N.$lb{static{d=this}static{this.a=1}static{this.b="machines"}constructor(n,i,r,a,v,m){super(),this.h=r,this.i=a,this.j=v,this.k=m,this.c=this.B(new L.$ec),this.onDidChange=this.c.event,this.g=null,this.f=(0,y.$So)(n,i,r)}async getMachines(n){const i=await this.f;return(await this.m(n)).machines.map(a=>({...a,isCurrent:a.id===i}))}async addCurrentMachine(n){const i=await this.f,r=await this.m(n);r.machines.some(({id:a})=>a===i)||(r.machines.push({id:i,name:this.l(r.machines),platform:t()}),await this.n(r))}async removeCurrentMachine(n){const i=await this.f,r=await this.m(n),a=r.machines.filter(({id:v})=>v!==i);a.length!==r.machines.length&&(r.machines=a,await this.n(r))}async renameMachine(n,i,r){const a=await this.m(r),v=a.machines.find(({id:m})=>m===n);if(v){v.name=i,await this.n(a);const m=await this.f;n===m&&this.h.store(p,i,-1,1)}}async setEnablements(n){const i=await this.m();for(const[r,a]of n){const v=i.machines.find(m=>m.id===r);v&&(v.disabled=a?void 0:!0)}await this.n(i)}l(n){const i=this.h.get(p,-1);if(i)return i;const r=`${this.k.embedderIdentifier?`${this.k.embedderIdentifier} - `:""}${t()} (${this.k.nameShort})`,a=new RegExp(`${(0,A.$pd)(r)}\\s#(\\d+)`);let v=0;for(const m of n){const l=a.exec(m.name),E=l?parseInt(l[1]):0;v=E>v?E:v}return`${r} #${v+1}`}async m(n){this.g=await this.p(n);const i=this.r(this.g);if(i.version!==d.a)throw new Error((0,j.localize)(0,null,this.k.nameLong));return i}async n(n){const i=JSON.stringify(n),r=await this.i.writeResource(d.b,i,this.g?.ref||null);this.g={ref:r,content:i},this.c.fire()}async p(n){if(this.g){const i=n&&n.latest?n.latest[d.b]:void 0;if(this.g.ref===i)return this.g;if(i===void 0&&this.g.content===null)return this.g}return this.i.readResource(d.b,this.g)}r(n){if(n.content!==null)try{return JSON.parse(n.content)}catch(i){this.j.error(i)}return{version:d.a,machines:[]}}};e.$WYb=o,e.$WYb=o=d=ye([K(0,R.$wh),K(1,S.$Sj),K(2,$.$Mo),K(3,u.$2fb),K(4,u.$egb),K(5,C.$0i)],o)}),define(ce[253],le([0,1,5,62,38,8,3,2,6,22,10,171,23,19,21,24,78,81]),function(ie,e,L,N,O,A,j,R,S,g,C,y,$,u,d,p,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$23b=void 0;const f="sync.disableMachineEventually",b="sync.sessionId",w="sync.storeUrl",I="sync.productQuality";let t=class extends R.$lb{get j(){const n=this.z.get(w,-1);return n?C.URI.parse(n):void 0}set j(n){n?this.z.store(w,n.toString(),-1,1):this.z.remove(w,-1)}get l(){return this.z.get(I,-1)}set l(n){n?this.z.store(I,n,-1,1):this.z.remove(I,-1)}constructor(n,i,r,a,v,m,l,E,D,T){super(),this.n=i,this.p=r,this.r=a,this.s=v,this.u=m,this.v=l,this.w=E,this.y=D,this.z=T,this.a=this.B(new R.$mb),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new j.$ec),this.onError=this.h.event,this.N=[],this.f=this.B(new L.$sg(this.O())),this.i=this.j,this.j=i.userDataSyncStore?.url,this.k=this.l,this.l=n.quality,this.j&&(this.u.info("Using settings sync service",this.j.toString()),this.B(i.onDidChangeUserDataSyncStore(()=>{(0,g.$2f)(this.j,i.userDataSyncStore?.url)||(this.i=this.j,this.j=i.userDataSyncStore?.url,this.j&&this.u.info("Using settings sync service",this.j.toString()))})),this.r.isEnabled()?this.u.info("Auto Sync is enabled."):this.u.info("Auto Sync is disabled."),this.C(),this.L()&&this.J(),this.B(l.onDidChangeAccount(()=>this.C())),this.B(r.onDidChangeDonotMakeRequestsUntil(()=>this.C())),this.B(v.onDidChangeLocal(M=>this.triggerSync([M],!1,!1))),this.B(j.Event.filter(this.r.onDidChangeResourceEnablement,([,M])=>M)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.n.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}C(){const{enabled:n,message:i}=this.F();n?this.a.value===void 0&&(this.a.value=new o(this.i,1e3*60*5,this.n,this.p,this.s,this.y,this.u,this.w,this.z),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(r=>this.I(r))),this.D()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(i&&this.u.info(i),this.a.clear()):i&&this.r.isEnabled()&&this.u.info(i))}D(){return!0}F(){return this.r.isEnabled()?this.v.account?this.p.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,N.$Tl)(this.p.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.M(),this.i=this.j,this.G(!0)}async turnOff(n,i,r){try{this.v.account&&!r&&await this.y.removeCurrentMachine(),this.G(!1),this.z.remove(b,-1),n?(this.w.publicLog2("sync/turnOffEveryWhere"),await this.s.reset()):await this.s.resetLocal()}catch(a){if(this.u.error(a),i)this.G(!1);else throw a}}G(n){this.r.isEnabled()!==n&&(this.r.setEnablement(n),this.C())}H(){return!!this.k&&!!this.l&&this.k!==this.l}async I(n){if(!n){this.b=0;return}const i=p.$7fb.toUserDataSyncError(n);i instanceof p.$9fb&&this.w.publicLog2("autosync/error",{code:i.code,service:this.n.userDataSyncStore.url.toString()}),i.code==="SessionExpired"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because current session is expired")):i.code==="TurnedOff"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):i.code==="LocalTooManyRequests"?(this.g=!0,this.u.info("Auto Sync: Suspended sync because of making too many requests to server"),this.C()):i.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.J(),this.u.info("Auto Sync: Turned off sync because of making too many requests to server")):i.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):i.code==="UpgradeRequired"||i.code==="Gone"?(await this.turnOff(!1,!0,!0),this.J(),this.u.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):i.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.u.info(`Auto Sync: Turned off sync because server has ${i.resource} content with newer version than of client. Requires client upgrade.`)):i.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.u.info(`Auto Sync: Turned off sync because server has ${i.resource} content with older version than of client. Requires server reset.`)):i.code==="ServiceChanged"||i.code==="DefaultServiceChanged"?S.$o&&i.code==="DefaultServiceChanged"&&!this.H()?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.u.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.u.error(i),this.b++),this.h.fire(i)}async J(){this.z.store(f,!0,-1,1),await(0,L.$vg)(1e3*60*10),this.L()&&(this.M(),!this.r.isEnabled()&&this.v.account&&await this.y.removeCurrentMachine())}L(){return this.z.getBoolean(f,-1,!1)}M(){this.z.remove(f,-1)}async triggerSync(n,i,r){if(this.a.value===void 0)return this.f.cancel();if(i&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.u.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.N.push(...n),this.f.trigger(async()=>{this.u.trace("activity sources",...this.N);const a=this.v.account?.authenticationProviderId||"";this.w.publicLog2("sync/triggered",{sources:this.N,providerId:a}),this.N=[],this.a.value&&await this.a.value.sync("Activity",r)},this.b?this.O()*1*Math.min(Math.pow(2,this.b),60):this.O())}O(){return 2e3}};e.$23b=t,e.$23b=t=ye([K(0,$.$0i),K(1,p.$1fb),K(2,p.$2fb),K(3,p.$_fb),K(4,p.$agb),K(5,p.$egb),K(6,c.$5yb),K(7,d.$Vk),K(8,h.$UYb),K(9,u.$Mo)],t);class o extends R.$lb{static{this.a="Interval"}constructor(n,i,r,a,v,m,l,E,D){super(),this.j=n,this.k=i,this.l=r,this.m=a,this.n=v,this.p=m,this.r=l,this.s=E,this.u=D,this.b=this.B(new R.$mb),this.c=this.B(new j.$ec),this.onDidStartSync=this.c.event,this.f=this.B(new j.$ec),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.v())),this.B((0,R.$jb)(()=>{this.i&&(this.i.cancel(),this.r.info("Auto sync: Cancelled sync that is in progress"),this.i=void 0),this.h?.stop(),this.r.info("Auto Sync: Stopped")})),this.sync(o.a,!1)}v(){this.b.value=(0,L.$wg)(()=>this.sync(o.a,!1),this.k)}sync(n,i){const r=(0,L.$ig)(async a=>{if(this.i)try{this.r.debug("Auto Sync: Waiting until sync is finished."),await this.i}catch(v){if((0,A.$2)(v))return}return this.z(n,i,a)});return this.i=r,this.i.finally(()=>this.i=void 0),this.i}w(){return this.j!==void 0&&!(0,g.$2f)(this.j,this.l.userDataSyncStore?.url)}async y(){const n=await this.l.getPreviousUserDataSyncStore(),i=this.l.userDataSyncStore;return!!i&&!!n&&(!(0,g.$2f)(i.defaultUrl,n.defaultUrl)||!(0,g.$2f)(i.insidersUrl,n.insidersUrl)||!(0,g.$2f)(i.stableUrl,n.stableUrl))}async z(n,i,r){this.r.info(`Auto Sync: Triggered by ${n}`),this.c.fire();let a;try{await this.C(i,r)}catch(v){if(this.r.error(v),a=v,p.$7fb.toUserDataSyncError(v).code==="MethodNotFound")try{this.r.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.n.cleanUpRemoteData(),this.r.info("Auto Sync: Retrying sync..."),await this.C(i,r),a=void 0}catch(m){this.r.error(m),a=m}}this.f.fire(a)}async C(n,i){if(this.h=await this.n.createSyncTask(this.g,n),i.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.n.hasPreviouslySynced())throw this.w()?await this.y()?new p.$9fb((0,y.localize)(0,null),"DefaultServiceChanged"):new p.$9fb((0,y.localize)(1,null),"ServiceChanged"):new p.$9fb((0,y.localize)(2,null),"TurnedOff");const r=this.u.get(b,-1);if(r&&this.g&&r!==this.g.session)throw this.w()?await this.y()?new p.$9fb((0,y.localize)(3,null),"DefaultServiceChanged"):new p.$9fb((0,y.localize)(4,null),"ServiceChanged"):new p.$9fb((0,y.localize)(5,null),"SessionExpired");const a=await this.p.getMachines(this.g||void 0);if(i.isCancellationRequested)return;const v=a.find(l=>l.isCurrent);if(v?.disabled)throw new p.$9fb((0,y.localize)(6,null),"TurnedOff");const m=new Date().getTime();if(await this.h.run(),this.s.publicLog2("settingsSync:sync",{duration:new Date().getTime()-m}),this.g===null)try{this.g=await this.m.manifest(null)}catch(l){throw new p.$9fb((0,O.$ai)(l),l instanceof p.$7fb?l.code:"Unknown")}this.g&&this.g.session!==r&&this.u.store(b,this.g.session,-1,1),!i.isCancellationRequested&&(v||await this.p.addCurrentMachine(this.g||void 0))}register(n){return super.B(n)}}}),define(ce[254],le([0,1,10,175,15,13,44,19,27,24,17,39,119,118,117,18,120,115,116,4,121,41]),function(ie,e,L,N,O,A,j,R,S,g,C,y,$,u,d,p,c,h,f,b,w,I){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$A4b=void 0;let o=class{static{t=this}static{this.a="not-existing-resource"}static{this.b="remote-backup"}static{this.c="local-backup"}constructor(n,i,r,a,v,m,l,E,D,T){this.e=n,this.f=i,this.g=r,this.h=v,this.i=m,this.j=l,this.k=E,this.l=D,this.m=T,this.d=a.extUri}async getRemoteSyncedProfiles(){const n=await this.e.readResource("profiles",null,void 0);if(n.content){const i=this.K(n.content,"profiles");return(0,w.$Z3b)(i)}return[]}async getRemoteSyncResourceHandles(n,i){return(await this.e.getAllResourceRefs(n,i?.collection)).map(({created:a,ref:v})=>({created:a,uri:this.I({remote:!0,syncResource:n,profile:i?.id??this.k.defaultProfile.id,collection:i?.collection,ref:v,node:void 0})}))}async getLocalSyncResourceHandles(n,i){return(await this.f.getAllRefs(i,n)).map(({created:a,ref:v})=>({created:a,uri:this.I({remote:!1,syncResource:n,profile:i.id,collection:void 0,ref:v,node:void 0})}))}resolveUserDataSyncResource({uri:n}){const i=this.J(n),r=i?this.k.profiles.find(a=>a.id===i.profile):void 0;return i&&r?{profile:r,syncResource:i?.syncResource}:void 0}async getAssociatedResources({uri:n}){const i=this.J(n);if(!i)return[];const r=this.k.profiles.find(a=>a.id===i.profile);switch(i.syncResource){case"settings":return this.r(n,r);case"keybindings":return this.t(n,r);case"tasks":return this.v(n,r);case"snippets":return this.x(n,r);case"globalState":return this.C(n,r);case"extensions":return this.z(n,r);case"profiles":return this.F(n,r);case"workspaceState":return[]}}async getMachineId({uri:n}){const i=this.J(n);if(i){if(i.remote){if(i.ref){const{content:r}=await this.L(i.syncResource,i.ref,i.collection);if(r)return this.K(r,i.syncResource)?.machineId}return}return(0,j.$So)(this.h,this.j,this.i)}}async resolveContent(n){const i=this.J(n);if(!i||i.node===t.a)return null;if(i.ref){const r=await this.n(i.remote,i.syncResource,i.profile,i.collection,i.ref);return i.node&&r?this.o(i.syncResource,r,i.node):r}return!i.remote&&!i.node?this.q(i.syncResource,i.profile):null}async n(n,i,r,a,v){if(n){const{content:l}=await this.L(i,v,a);return l}const m=this.k.profiles.find(l=>l.id===r);return m?this.f.resolveContent(m,i,v):null}o(n,i,r){const a=this.K(i,n);switch(n){case"settings":return this.s(a,r);case"keybindings":return this.u(a,r);case"tasks":return this.w(a,r);case"snippets":return this.y(a,r);case"globalState":return this.D(a,r);case"extensions":return this.A(a,r);case"profiles":return this.G(a,r);case"workspaceState":return null}}async q(n,i){const r=this.k.profiles.find(a=>a.id===i);if(!r)return null;switch(n){case"globalState":return this.E(r);case"extensions":return this.B(r);case"profiles":return this.H(r);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null;case"workspaceState":return null}}r(n,i){const r=this.d.joinPath(n,"settings.json"),a=i?i.settingsResource:this.d.joinPath(n,t.a);return[{resource:r,comparableResource:a}]}s(n,i){switch(i){case"settings.json":return(0,u.$_1b)(n.content).settings}return null}t(n,i){const r=this.d.joinPath(n,"keybindings.json"),a=i?i.keybindingsResource:this.d.joinPath(n,t.a);return[{resource:r,comparableResource:a}]}u(n,i){switch(i){case"keybindings.json":return(0,d.$91b)(n.content,!!this.l.getValue(g.$Ufb),this.g)}return null}v(n,i){const r=this.d.joinPath(n,"tasks.json"),a=i?i.tasksResource:this.d.joinPath(n,t.a);return[{resource:r,comparableResource:a}]}w(n,i){switch(i){case"tasks.json":return(0,c.$h2b)(n.content,this.g)}return null}async x(n,i){const r=await this.resolveContent(n);if(r){const a=this.K(r,"snippets");if(a){const v=(0,$.$e2b)(a),m=[];for(const l of Object.keys(v)){const E=this.d.joinPath(n,l),D=i?this.d.joinPath(i.snippetsHome,l):this.d.joinPath(n,t.a);m.push({resource:E,comparableResource:D})}return m}}return[]}y(n,i){return(0,$.$e2b)(n)[i]||null}z(n,i){const r=this.d.joinPath(n,"extensions.json"),a=i?this.I({remote:!1,syncResource:"extensions",profile:i.id,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(n,t.a);return[{resource:r,comparableResource:a}]}A(n,i){switch(i){case"extensions.json":return(0,h.$41b)((0,h.$31b)(n),!0)}return null}async B(n){const{localExtensions:i}=await this.m.createInstance(h.$61b).getLocalExtensions(n);return(0,h.$41b)(i,!0)}C(n,i){const r=this.d.joinPath(n,"globalState.json"),a=i?this.I({remote:!1,syncResource:"globalState",profile:i.id,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(n,t.a);return[{resource:r,comparableResource:a}]}D(n,i){switch(i){case"globalState.json":return(0,f.$zAb)(JSON.parse(n.content),!0)}return null}async E(n){const i=await this.m.createInstance(f.$BAb).getLocalGlobalState(n);return(0,f.$zAb)(i,!0)}F(n,i){const r=this.d.joinPath(n,"profiles.json"),a=this.I({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,collection:void 0,ref:void 0,node:void 0});return[{resource:r,comparableResource:a}]}G(n,i){switch(i){case"profiles.json":return(0,I.$cS)(JSON.parse(n.content),{})}return null}async H(n){return(0,w.$Y3b)(this.k.profiles.filter(i=>!i.isDefault&&!i.isTransient),!0)}I(n){const i=n.remote?t.b:t.c,r=[n.syncResource,n.profile];return n.collection&&r.push(`collection:${n.collection}`),n.ref&&r.push(`ref:${n.ref}`),n.node&&r.push(n.node),this.d.joinPath(L.URI.from({scheme:g.$ggb,authority:i,path:"/"}),...r)}J(n){if(n.scheme!==g.$ggb||n.authority!==t.c&&n.authority!==t.b)return;const i=[];for(;n.path!=="/";)i.unshift(this.d.basename(n)),n=this.d.dirname(n);if(i.length<2)return;const r=n.authority===t.b,a=i.shift(),v=i.shift();let m,l,E;for(;i.length;){const D=i.shift();D.startsWith("collection:")?m=D.substring(11):D.startsWith("ref:")?l=D.substring(4):E=D}return{remote:r,syncResource:a,profile:v,collection:m,ref:l,node:E}}K(n,i){try{const r=JSON.parse(n);if((0,y.$sAb)(r))return r}catch(r){this.g.error(r)}throw new g.$7fb((0,N.localize)(0,null),"IncompatibleRemoteContent",i)}async L(n,i,r){const a=await this.e.resolveResourceContent(n,i,r);return{ref:i,content:a}}};e.$A4b=o,e.$A4b=o=t=ye([K(0,g.$2fb),K(1,g.$3fb),K(2,g.$egb),K(3,S.$pk),K(4,O.$wh),K(5,R.$Mo),K(6,A.$Sj),K(7,C.$rk),K(8,p.$Vh),K(9,b.$oh)],o)}),define(ce[255],le([0,1,20,5,25,38,3,2,22,11,32,18,29,4,19,21,17,115,116,117,118,119,120,121,24]),function(ie,e,L,N,O,A,j,R,S,g,C,y,$,u,d,p,c,h,f,b,w,I,t,o,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$13b=void 0;const n="sync.lastSyncTime";let i=class extends R.$lb{get status(){return this.f}get conflicts(){return this.i}get lastSyncTime(){return this.m}constructor(l,E,D,T,M,F,V,Z,J){super(),this.v=l,this.w=E,this.y=D,this.z=T,this.C=M,this.D=F,this.F=V,this.G=Z,this.H=J,this.f="uninitialized",this.g=this.B(new j.$ec),this.onDidChangeStatus=this.g.event,this.h=this.B(new j.$ec),this.onDidChangeLocal=this.h.event,this.i=[],this.j=this.B(new j.$ec),this.onDidChangeConflicts=this.j.event,this.k=[],this.l=this.B(new j.$ec),this.onSyncErrors=this.l.event,this.m=void 0,this.n=this.B(new j.$ec),this.onDidChangeLastSyncTime=this.n.event,this.r=this.B(new j.$ec),this.onDidResetLocal=this.r.event,this.t=this.B(new j.$ec),this.onDidResetRemote=this.t.event,this.u=new Map,this.f=E.userDataSyncStore?"idle":"uninitialized",this.m=this.D.getNumber(n,-1,void 0),this.B((0,R.$jb)(()=>this.W()))}async createSyncTask(l,E){this.X(),this.z.info("Sync started.");const D=new Date().getTime(),T=(0,C.$3e)();try{const Z=(0,s.$6fb)(T);E&&(Z["Cache-Control"]="no-cache"),l=await this.v.manifest(l,Z)}catch(Z){const J=s.$7fb.toUserDataSyncError(Z);throw v(J,T,this.w,this.C),J}const M=!1,F=this;let V;return{manifest:l,async run(){if(M)throw new Error("Can run a task only once");V=(0,N.$ig)(Z=>F.I(l,!1,T,Z)),await V.finally(()=>V=void 0),F.z.info(`Sync done. Took ${new Date().getTime()-D}ms`),F.S()},stop(){return V?.cancel(),F.N()}}}async createManualSyncTask(){if(this.X(),this.F.isEnabled())throw new s.$7fb("Cannot start manual sync when sync is enabled","LocalError");this.z.info("Sync started.");const l=new Date().getTime(),E=(0,C.$3e)(),D=(0,s.$6fb)(E);let T;try{T=await this.v.manifest(null,D)}catch(V){const Z=s.$7fb.toUserDataSyncError(V);throw v(Z,E,this.w,this.C),Z}await this.resetLocal();const M=this,F=new O.$oc;return{id:E,async merge(){return M.I(T,!0,E,F.token)},async apply(){try{try{await M.L(T,E,F.token)}catch(V){if(s.$7fb.toUserDataSyncError(V).code==="MethodNotFound")M.z.info("Client is making invalid requests. Cleaning up data..."),await M.cleanUpRemoteData(),M.z.info("Applying manual sync again..."),await M.L(T,E,F.token);else throw V}}catch(V){throw M.z.error(V),V}M.z.info(`Sync done. Took ${new Date().getTime()-l}ms`),M.S()},async stop(){F.cancel(),await M.N(),await M.resetLocal()}}}async I(l,E,D,T){this.k=[];try{this.status!=="hasConflicts"&&this.Q("syncing");const M=this.getOrCreateActiveProfileSynchronizer(this.G.defaultProfile,void 0);this.k.push(...await this.M(M,l,E,D,T));const F=M.enabled.find(V=>V.resource==="profiles");if(F){const V=await F.getLastSyncedProfiles()||[];if(T.isCancellationRequested)return;await this.J(V,l,E,D,T)}}finally{this.l.fire(this.k)}}async J(l,E,D,T,M){for(const F of l){if(M.isCancellationRequested)return;const V=this.G.profiles.find(J=>J.id===F.id);if(!V){this.z.error(`Profile with id:${F.id} and name: ${F.name} does not exist locally to sync.`);continue}this.z.info("Syncing profile.",F.name);const Z=this.getOrCreateActiveProfileSynchronizer(V,F);this.k.push(...await this.M(Z,E,D,T,M))}for(const[F,V]of this.u.entries())this.G.profiles.some(Z=>Z.id===V[0].profile.id)||(V[1].dispose(),this.u.delete(F))}async L(l,E,D){const T=this.U();for(const J of T){if(D.isCancellationRequested)return;await J.apply(E,D)}const M=T.find(J=>J.profile.isDefault);if(!M)return;const F=M.enabled.find(J=>J.resource==="profiles");if(!F)return;const Z=(await F.getRemoteSyncedProfiles(l?.latest??null)||[]).filter(J=>T.every(Q=>Q.profile.id!==J.id));Z.length&&await this.J(Z,l,!1,E,D)}async M(l,E,D,T,M){return(await l.sync(E,D,T,M)).map(([V,Z])=>({profile:l.profile,syncResource:V,error:Z}))}async N(){this.status!=="idle"&&await Promise.allSettled(this.U().map(l=>l.stop()))}async resolveContent(l){const E=await this.H.resolveContent(l);if(E)return E;for(const D of this.U())for(const T of D.enabled){const M=await T.resolveContent(l);if(M)return M}return null}async replace(l){this.X();const E=this.H.resolveUserDataSyncResource(l);if(!E)return;const D=await this.resolveContent(l.uri);D&&await this.O(E.profile,async T=>{if(E.syncResource===T.resource)return await T.replace(D),!0})}async accept(l,E,D,T){this.X(),await this.O(l.profile,async M=>{if(l.syncResource===M.resource)return await M.accept(E,D),T&&await M.apply((0,g.$oe)(T)?!1:T.force,(0,s.$6fb)((0,C.$3e)())),!0})}getRemoteProfiles(){return this.H.getRemoteSyncedProfiles()}getRemoteSyncResourceHandles(l,E){return this.H.getRemoteSyncResourceHandles(l,E)}async getLocalSyncResourceHandles(l,E){return this.H.getLocalSyncResourceHandles(l,E??this.G.defaultProfile)}async getAssociatedResources(l){return this.H.getAssociatedResources(l)}async getMachineId(l){return this.H.getMachineId(l)}async hasLocalData(){return!!await this.O(this.G.defaultProfile,async E=>{if(E.resource!=="globalState"&&await E.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.O(this.G.defaultProfile,async E=>{if(await E.hasPreviouslySynced())return!0})}async reset(){this.X(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.X();try{await this.v.clear(),this.z.info("Cleared data on server")}catch(l){this.z.error(l)}this.t.fire()}async resetLocal(){this.X(),this.m=void 0,this.D.remove(n,-1);for(const[l]of this.u.values())try{await l.resetLocal()}catch(E){this.z.error(E)}this.W(),this.r.fire(),this.z.info("Did reset the local sync state.")}async cleanUpRemoteData(){const l=await this.H.getRemoteSyncedProfiles(),E=l.map(F=>F.collection),D=await this.v.getAllCollections(),T=D.filter(F=>!E.includes(F));T.length&&(this.z.info(`Deleting ${T.length} redundant collections on server`),await Promise.allSettled(T.map(F=>this.v.deleteCollection(F))),this.z.info("Deleted redundant collections on server"));const M=l.filter(F=>D.includes(F.collection));if(M.length!==l.length){const F=this.y.createInstance(o.$X3b,this.G.defaultProfile,void 0);try{this.z.info("Resetting the last synced state of profiles"),await F.resetLocal(),this.z.info("Did reset the last synced state of profiles"),this.z.info("Updating remote profiles with invalid collections on server"),await F.updateRemoteProfiles(M,null),this.z.info("Updated remote profiles on server")}finally{F.dispose()}}}async O(l,E){const D=new R.$kb;try{const T=this.u.get(l.id);if(T){const J=await this.P(T[0],E,D);return(0,g.$pe)(J)?null:J}if(l.isDefault){const J=D.add(this.y.createInstance(r,l,void 0)),Q=await this.P(J,E,D);return(0,g.$pe)(Q)?null:Q}if(this.G.isEnabled())return null;const M=D.add(this.y.createInstance(o.$X3b,l,void 0)),F=await this.v.manifest(null),Z=(await M.getRemoteSyncedProfiles(F?.latest??null)||[]).find(J=>J.id===l.id);if(Z){const J=D.add(this.y.createInstance(r,l,Z.collection)),Q=await this.P(J,E,D);return(0,g.$pe)(Q)?null:Q}return null}finally{D.dispose()}}async P(l,E,D){const T=[...l.enabled,...l.disabled.reduce((M,F)=>(F!=="workspaceState"&&M.push(D.add(l.createSynchronizer(F))),M),[])];for(const M of T){const F=await E(M);if(!(0,g.$pe)(F))return F}}Q(l){const E=this.f;this.f!==l&&(this.f=l,this.g.fire(l),E==="hasConflicts"&&this.S())}R(){const l=this.U().map(E=>E.conflicts).flat();(0,L.$$e)(this.i,l,(E,D)=>E.profile.id===D.profile.id&&E.syncResource===D.syncResource&&(0,L.$$e)(E.conflicts,D.conflicts,(T,M)=>(0,S.$2f)(T.previewResource,M.previewResource)))||(this.i=l,this.j.fire(l))}S(){this.status==="idle"&&(this.m=new Date().getTime(),this.D.store(n,this.m,-1,1),this.n.fire(this.m))}getOrCreateActiveProfileSynchronizer(l,E){let D=this.u.get(l.id);if(D&&D[0].collection!==E?.collection&&(this.z.error("Profile synchronizer collection does not match with the remote sync profile collection"),D[1].dispose(),D=void 0,this.u.delete(l.id)),!D){const T=new R.$kb,M=T.add(this.y.createInstance(r,l,E?.collection));T.add(M.onDidChangeStatus(F=>this.Q(F))),T.add(M.onDidChangeConflicts(F=>this.R())),T.add(M.onDidChangeLocal(F=>this.h.fire(F))),this.u.set(l.id,D=[M,T])}return D[0]}U(){const l=[];for(const[E]of this.u.values())l.push(E);return l}W(){this.u.forEach(([,l])=>l.dispose()),this.u.clear()}X(){if(!this.w.userDataSyncStore)throw new Error("Not enabled")}};e.$13b=i,e.$13b=i=ye([K(0,s.$2fb),K(1,s.$1fb),K(2,u.$oh),K(3,s.$egb),K(4,p.$Vk),K(5,d.$Mo),K(6,s.$_fb),K(7,c.$rk),K(8,s.$bgb)],i);let r=class extends R.$lb{get enabled(){return this.f.sort((l,E)=>l[1]-E[1]).map(([l])=>l)}get disabled(){return s.$Xfb.filter(l=>!this.l.isResourceEnabled(l))}get status(){return this.g}get conflicts(){return this.j}constructor(l,E,D,T,M,F,V,Z,J,Q){super(),this.profile=l,this.collection=E,this.l=D,this.m=T,this.n=M,this.r=F,this.t=V,this.u=Z,this.v=J,this.w=Q,this.f=[],this.g="idle",this.h=this.B(new j.$ec),this.onDidChangeStatus=this.h.event,this.i=this.B(new j.$ec),this.onDidChangeLocal=this.i.event,this.j=[],this.k=this.B(new j.$ec),this.onDidChangeConflicts=this.k.event,this.B(D.onDidChangeResourceEnablement(([G,X])=>this.y(G,X))),this.B((0,R.$jb)(()=>this.f.splice(0,this.f.length).forEach(([,,G])=>G.dispose())));for(const G of s.$Xfb)D.isResourceEnabled(G)&&this.z(G)}y(l,E){E?this.z(l):this.C(l)}z(l){if(this.f.some(([M])=>M.resource===l))return;if(l==="extensions"&&!this.n.isEnabled()){this.u.info("Skipping extensions sync because gallery is not configured");return}if(l==="profiles"&&(!this.profile.isDefault||!this.v.isEnabled())||l==="workspaceState")return;if(l!=="profiles"&&this.profile.useDefaultFlags?.[l]){this.u.debug(`Skipping syncing ${l} in ${this.profile.name} because it is already synced by default profile`);return}const E=new R.$kb,D=E.add(this.createSynchronizer(l));E.add(D.onDidChangeStatus(()=>this.G())),E.add(D.onDidChangeConflicts(()=>this.H())),E.add(D.onDidChangeLocal(()=>this.i.fire(l)));const T=this.I(l);this.f.push([D,T,E])}C(l){const E=this.f.findIndex(([D])=>D.resource===l);if(E!==-1){const[[D,,T]]=this.f.splice(E,1);T.dispose(),this.G(),Promise.allSettled([D.stop(),D.resetLocal()]).then(null,M=>this.u.error(M))}}createSynchronizer(l){switch(l){case"settings":return this.m.createInstance(w.$a2b,this.profile,this.collection);case"keybindings":return this.m.createInstance(b.$01b,this.profile,this.collection);case"snippets":return this.m.createInstance(I.$f2b,this.profile,this.collection);case"tasks":return this.m.createInstance(t.$i2b,this.profile,this.collection);case"globalState":return this.m.createInstance(f.$AAb,this.profile,this.collection);case"extensions":return this.m.createInstance(h.$51b,this.profile,this.collection);case"profiles":return this.m.createInstance(o.$X3b,this.profile,this.collection)}}async sync(l,E,D,T){if(T.isCancellationRequested)return[];const M=this.enabled;if(!M.length)return[];try{const F=[],V=(0,s.$6fb)(D),Z=(this.collection?l?.collections?.[this.collection]?.latest:l?.latest)??null,J=E?await this.D(Z):{};for(const Q of M){if(T.isCancellationRequested)return[];if(!this.l.isResourceEnabled(Q.resource))return[];try{if(E){const G=await Q.preview(Z,J,V);if(G)for(const X of G.resourcePreviews)(X.localChange!==0||X.remoteChange!==0)&&X.mergeState==="preview"&&await Q.merge(X.previewResource)}else await Q.sync(Z,V)}catch(G){const X=s.$7fb.toUserDataSyncError(G);if(v(X,D,this.r,this.t),a(G))throw X;this.u.error(G),this.u.error(`${Q.resource}: ${(0,A.$ai)(G)}`),F.push([Q.resource,X])}}return F}finally{this.G()}}async apply(l,E){const D=(0,s.$6fb)(l);for(const T of this.enabled){if(E.isCancellationRequested)return;try{await T.apply(!1,D)}catch(M){const F=s.$7fb.toUserDataSyncError(M);if(v(F,l,this.r,this.t),a(M))throw F;this.u.error(M),this.u.error(`${T.resource}: ${(0,A.$ai)(M)}`)}}}async stop(){for(const l of this.enabled)try{l.status!=="idle"&&await l.stop()}catch(E){this.u.error(E)}}async resetLocal(){for(const l of this.enabled)try{await l.resetLocal()}catch(E){this.u.error(`${l.resource}: ${(0,A.$ai)(E)}`),this.u.error(E)}}async D(l){if(!this.profile.isDefault)return{};const E=this.w.getValue(s.$Tfb),D=this.enabled.find(T=>T instanceof w.$a2b);if(D){const T=await D.getRemoteUserDataSyncConfiguration(l);return{...E,...T}}return E}F(l){this.g!==l&&(this.g=l,this.h.fire(l))}G(){return this.H(),this.enabled.some(l=>l.status==="hasConflicts")?this.F("hasConflicts"):this.enabled.some(l=>l.status==="syncing")?this.F("syncing"):this.F("idle")}H(){const l=this.enabled.filter(E=>E.status==="hasConflicts").filter(E=>E.conflicts.conflicts.length>0).map(E=>E.conflicts);(0,L.$$e)(this.j,l,(E,D)=>E.syncResource===D.syncResource&&(0,L.$$e)(E.conflicts,D.conflicts,(T,M)=>(0,S.$2f)(T.previewResource,M.previewResource)))||(this.j=l,this.k.fire(l))}I(l){switch(l){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6;case"workspaceState":return 7}}};r=ye([K(2,s.$_fb),K(3,u.$oh),K(4,$.$Rn),K(5,s.$1fb),K(6,p.$Vk),K(7,s.$egb),K(8,c.$rk),K(9,y.$Vh)],r);function a(m){if(m instanceof s.$7fb)switch(m.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function v(m,l,E,D){D.publicLog2("sync/error",{code:m.code,serverCode:m instanceof s.$8fb?String(m.serverCode):void 0,url:m instanceof s.$8fb?m.url:void 0,resource:m.resource,executionId:l,service:E.userDataSyncStore.url.toString()})}}),define(ce[256],le([0,1,3,2,10,17,24]),function(ie,e,L,N,O,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f7b=e.$e7b=void 0;function R($,u){return{...$,profile:(0,A.$sk)($.profile,u.profilesHome.scheme)}}function S($){return{created:$.created,uri:O.URI.revive($.uri)}}class g{constructor(u,d,p){this.c=u,this.d=d,this.f=p,this.a=new Map,this.b=new L.$ec}listen(u,d){switch(d){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`Event not found: ${d}`)}async call(u,d,p){try{return await this.g(u,d,p)}catch(c){throw this.f.error(c),c}}async g(u,d,p){switch(d){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(O.URI.revive(p[0]));case"accept":return this.c.accept(R(p[0],this.d),O.URI.revive(p[1]),p[2],p[3]);case"getRemoteProfiles":return this.c.getRemoteProfiles();case"getLocalSyncResourceHandles":return this.c.getLocalSyncResourceHandles(p[0],p[1]?(0,A.$sk)(p[1],this.d.profilesHome.scheme):void 0);case"getRemoteSyncResourceHandles":return this.c.getRemoteSyncResourceHandles(p[0],p[1]);case"replace":return this.c.replace(S(p[0]));case"getAssociatedResources":return this.c.getAssociatedResources(S(p[0]));case"getMachineId":return this.c.getMachineId(S(p[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"createManualSyncTask":return this.i()}if(d.startsWith("manualSync/")){const c=d.substring(11),h=p[0],f=this.h(h);switch(p=p.slice(1),c){case"merge":return f.merge();case"apply":return f.apply().then(()=>this.a.delete(this.j(f.id)));case"stop":return f.stop().finally(()=>this.a.delete(this.j(f.id)))}}throw new Error("Invalid call")}h(u){const d=this.a.get(this.j(u));if(!d)throw new Error(`Manual sync taks not found: ${u}`);return d}async i(){const u=await this.c.createManualSyncTask();return this.a.set(this.j(u.id),u),u.id}j(u){return`manualSyncTask-${u}`}}e.$e7b=g;let C=class extends N.$lb{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(u,d){super(),this.k=d,this.b="uninitialized",this.c=this.B(new L.$ec),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new L.$ec),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.i=this.B(new L.$ec),this.onDidChangeLastSyncTime=this.i.event,this.j=this.B(new L.$ec),this.onSyncErrors=this.j.event,this.a={call(p,c,h){return u.call(p,c,h).then(null,f=>{throw j.$7fb.toUserDataSyncError(f)})},listen(p,c){return u.listen(p,c)}},this.a.call("_getInitialData").then(([p,c,h])=>{this.l(p),this.m(c),h&&this.n(h),this.B(this.a.listen("onDidChangeStatus")(f=>this.l(f))),this.B(this.a.listen("onDidChangeLastSyncTime")(f=>this.n(f)))}),this.B(this.a.listen("onDidChangeConflicts")(p=>this.m(p))),this.B(this.a.listen("onSyncErrors")(p=>this.j.fire(p.map(c=>({...c,error:j.$7fb.toUserDataSyncError(c.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const u=await this.a.call("createManualSyncTask"),d=this;return new y(u,{async call(c,h,f){return d.a.call(`manualSync/${c}`,[u,...Array.isArray(h)?h:[h]],f)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(u,d,p,c){return this.a.call("accept",[u,d,p,c])}resolveContent(u){return this.a.call("resolveContent",[u])}getRemoteProfiles(){return this.a.call("getRemoteProfiles")}async getLocalSyncResourceHandles(u,d){return(await this.a.call("getLocalSyncResourceHandles",[u,d])).map(({created:c,uri:h})=>({created:c,uri:O.URI.revive(h)}))}async getRemoteSyncResourceHandles(u,d){return(await this.a.call("getRemoteSyncResourceHandles",[u,d])).map(({created:c,uri:h})=>({created:c,uri:O.URI.revive(h)}))}async getAssociatedResources(u){return(await this.a.call("getAssociatedResources",[u])).map(({resource:p,comparableResource:c})=>({resource:O.URI.revive(p),comparableResource:O.URI.revive(c)}))}getMachineId(u){return this.a.call("getMachineId",[u])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(u){return this.a.call("replace",[u])}async l(u){this.b=u,this.c.fire(u)}async m(u){this.f=u.map(d=>({syncResource:d.syncResource,profile:(0,A.$sk)(d.profile,this.k.profilesHome.scheme),conflicts:d.conflicts.map(p=>({...p,baseResource:O.URI.revive(p.baseResource),localResource:O.URI.revive(p.localResource),remoteResource:O.URI.revive(p.remoteResource),previewResource:O.URI.revive(p.previewResource)}))})),this.g.fire(this.f)}n(u){this.h!==u&&(this.h=u,this.i.fire(u))}};e.$f7b=C,e.$f7b=C=ye([K(1,A.$rk)],C);class y extends N.$lb{constructor(u,d){super(),this.id=u,this.a=d}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose")}}}),define(ce[257],le([0,1,5,25,8,3,2,139,6,22,11,10,32,18,15,13,23,57,44,19,24]),function(ie,e,L,N,O,A,j,R,S,g,C,y,$,u,d,p,c,h,f,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qAb=e.$pAb=e.$oAb=e.$nAb=e.$mAb=void 0;const I="configurationSync.store",t="sync.previous.store",o="sync.donot-make-requests-until",s="sync.user-session-id",n="sync.machine-session-id",i=100,r=1e3*60*5;let a=class extends j.$lb{get userDataSyncStore(){return this.b}get c(){return this.h.get(w.$0fb,-1)}set c(T){this.h.store(w.$0fb,T,-1,S.$o?0:1)}constructor(T,M,F){super(),this.f=T,this.g=M,this.h=F,this.a=this.B(new A.$ec),this.onDidChangeUserDataSyncStore=this.a.event,this.i();const V=this.B(new j.$kb);this.B(A.Event.filter(F.onDidChangeValue(-1,w.$0fb,V),()=>this.c!==this.userDataSyncStore?.type,V)(()=>this.i()))}i(){this.b=this.j(this.f[I]),this.a.fire()}j(T){if(T&&(T=S.$o&&T.web?{...T,...T.web}:T,(0,C.$ie)(T.url)&&(0,C.$ke)(T.authenticationProviders)&&Object.keys(T.authenticationProviders).every(M=>Array.isArray(T.authenticationProviders[M].scopes)))){const M=T,F=!!M.canSwitch,V=M.url===M.insidersUrl?"insiders":"stable",Z=(F?this.c:void 0)||V,J=Z==="insiders"?M.insidersUrl:Z==="stable"?M.stableUrl:M.url;return{url:y.URI.parse(J),type:Z,defaultType:V,defaultUrl:y.URI.parse(M.url),stableUrl:y.URI.parse(M.stableUrl),insidersUrl:y.URI.parse(M.insidersUrl),canSwitch:F,authenticationProviders:Object.keys(M.authenticationProviders).reduce((Q,G)=>(Q.push({id:G,scopes:M.authenticationProviders[G].scopes}),Q),[])}}}};e.$mAb=a,e.$mAb=a=ye([K(0,c.$0i),K(1,u.$Vh),K(2,b.$Mo)],a);let v=class extends a{constructor(T,M,F){super(T,M,F);const V=this.h.get(t,-1);V&&(this.k=JSON.parse(V));const Z=this.f[I];Z?this.h.store(t,JSON.stringify(Z),-1,1):this.h.remove(t,-1)}async switch(T){T!==this.c&&(this.c=T,this.i())}async getPreviousUserDataSyncStore(){return this.j(this.k)}};e.$nAb=v,e.$nAb=v=ye([K(0,c.$0i),K(1,u.$Vh),K(2,b.$Mo)],v);let m=class extends j.$lb{get donotMakeRequestsUntil(){return this.i}constructor(T,M,F,V,Z,J,Q){super(),this.k=F,this.l=V,this.m=Q,this.g=this.B(new A.$ec),this.onTokenFailed=this.g.event,this.h=this.B(new A.$ec),this.onTokenSucceed=this.h.event,this.i=void 0,this.j=this.B(new A.$ec),this.onDidChangeDonotMakeRequestsUntil=this.j.event,this.r=void 0,this.n(T),this.c=(0,f.$So)(Z,J,Q).then(G=>{const X={"X-Client-Name":`${M.applicationName}${S.$o?"-web":""}`,"X-Client-Version":M.version};return M.commit&&(X["X-Client-Commit"]=M.commit),X}),this.f=new E(i,r,this.k,this.l),this.p(),this.B((0,j.$jb)(()=>{this.r&&(this.r.cancel(),this.r=void 0)}))}setAuthToken(T,M){this.b={token:T,type:M}}n(T){this.a=T?(0,g.$9f)(T,"v1"):void 0}p(){const T=this.m.getNumber(o,-1);T&&Date.now()<T&&this.s(new Date(T))}s(T){this.i?.getTime()!==T?.getTime()&&(this.i=T,this.r&&(this.r.cancel(),this.r=void 0),this.i?(this.m.store(o,this.i.getTime(),-1,1),this.r=(0,L.$ig)(M=>(0,L.$vg)(this.i.getTime()-Date.now(),M).then(()=>this.s(void 0))),this.r.then(null,M=>null)):this.m.remove(o,-1),this.j.fire())}async getAllCollections(T={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=(0,g.$9f)(this.a,"collection").toString();T={...T},T["Content-Type"]="application/json";const F=await this.v(M,{type:"GET",headers:T},[],N.CancellationToken.None);return(await(0,h.$Fo)(F))?.map(({id:V})=>V)||[]}async createCollection(T={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=(0,g.$9f)(this.a,"collection").toString();T={...T},T["Content-Type"]=R.$yr.text;const F=await this.v(M,{type:"POST",headers:T},[],N.CancellationToken.None),V=await(0,h.$Eo)(F);if(!V)throw new w.$8fb("Server did not return the collection id",M,"NoCollection",F.res.statusCode,F.res.headers[w.$4fb]);return V}async deleteCollection(T,M={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=T?(0,g.$9f)(this.a,"collection",T).toString():(0,g.$9f)(this.a,"collection").toString();M={...M},await this.v(F,{type:"DELETE",headers:M},[],N.CancellationToken.None)}async getAllResourceRefs(T,M){if(!this.a)throw new Error("No settings sync store url configured.");const F=this.t(this.a,M,T),V={},Z=await this.v(F.toString(),{type:"GET",headers:V},[],N.CancellationToken.None);return(await(0,h.$Fo)(Z)||[]).map(({url:Q,created:G})=>({ref:(0,g.$$f)(F,F.with({path:Q})),created:G*1e3}))}async resolveResourceContent(T,M,F,V={}){if(!this.a)throw new Error("No settings sync store url configured.");const Z=(0,g.$9f)(this.t(this.a,F,T),M).toString();V={...V},V["Cache-Control"]="no-cache";const J=await this.v(Z,{type:"GET",headers:V},[],N.CancellationToken.None);return await(0,h.$Eo)(J)}async deleteResource(T,M,F){if(!this.a)throw new Error("No settings sync store url configured.");const V=M!==null?(0,g.$9f)(this.t(this.a,F,T),M).toString():this.t(this.a,F,T).toString(),Z={};await this.v(V,{type:"DELETE",headers:Z},[],N.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const T=(0,g.$9f)(this.a,"resource").toString(),M={"Content-Type":R.$yr.text};await this.v(T,{type:"DELETE",headers:M},[],N.CancellationToken.None)}async readResource(T,M,F,V={}){if(!this.a)throw new Error("No settings sync store url configured.");const Z=(0,g.$9f)(this.t(this.a,F,T),"latest").toString();V={...V},V["Cache-Control"]="no-cache",M&&(V["If-None-Match"]=M.ref);const J=await this.v(Z,{type:"GET",headers:V},[304],N.CancellationToken.None);let Q=null;if(J.res.statusCode===304&&(Q=M),Q===null){const G=J.res.headers.etag;if(!G)throw new w.$8fb("Server did not return the ref",Z,"NoRef",J.res.statusCode,J.res.headers[w.$4fb]);const X=await(0,h.$Eo)(J);if(!X&&J.res.statusCode===304)throw new w.$8fb("Empty response",Z,"EmptyResponse",J.res.statusCode,J.res.headers[w.$4fb]);Q={ref:G,content:X}}return Q}async writeResource(T,M,F,V,Z={}){if(!this.a)throw new Error("No settings sync store url configured.");const J=this.t(this.a,V,T).toString();Z={...Z},Z["Content-Type"]=R.$yr.text,F&&(Z["If-Match"]=F);const Q=await this.v(J,{type:"POST",data:M,headers:Z},[],N.CancellationToken.None),G=Q.res.headers.etag;if(!G)throw new w.$8fb("Server did not return the ref",J,"NoRef",Q.res.statusCode,Q.res.headers[w.$4fb]);return G}async manifest(T,M={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,g.$9f)(this.a,"manifest").toString();M={...M},M["Content-Type"]="application/json",T&&(M["If-None-Match"]=T.ref);const V=await this.v(F,{type:"GET",headers:M},[304],N.CancellationToken.None);let Z=null;if(V.res.statusCode===304&&(Z=T),!Z){const Q=V.res.headers.etag;if(!Q)throw new w.$8fb("Server did not return the ref",F,"NoRef",V.res.statusCode,V.res.headers[w.$4fb]);const G=await(0,h.$Eo)(V);if(!G&&V.res.statusCode===304)throw new w.$8fb("Empty response",F,"EmptyResponse",V.res.statusCode,V.res.headers[w.$4fb]);G&&(Z={...JSON.parse(G),ref:Q})}const J=this.m.get(s,-1);return J&&Z&&J!==Z.session&&this.u(),Z===null&&J&&this.u(),Z&&this.m.store(s,Z.session,-1,1),Z}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.u()}t(T,M,F){return M?(0,g.$9f)(T,"collection",M,"resource",F):(0,g.$9f)(T,"resource",F)}u(){this.m.remove(s,-1),this.m.remove(n,-1)}async v(T,M,F,V){if(!this.b)throw new w.$8fb("No Auth Token Available",T,"Unauthorized",void 0,void 0);if(this.i&&Date.now()<this.i.getTime())throw new w.$8fb(`${M.type} request '${T}' failed because of too many requests (429).`,T,"TooManyRequestsAndRetryAfter",void 0,void 0);this.s(void 0);const Z=await this.c;M.headers={...M.headers||{},...Z,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.w(M.headers),this.l.trace("Sending request to server",{url:T,type:M.type,headers:{...M.headers,authorization:void 0}});let J;try{J=await this.f.request(T,M,V)}catch(q){if(!(q instanceof w.$8fb)){let B="RequestFailed";const _=(0,O.$9)(q).toLowerCase();_.includes("xhr timeout")?B="RequestTimeout":_.includes("protocol")&&_.includes("not supported")?B="RequestProtocolNotSupported":_.includes("request path contains unescaped characters")?B="RequestPathNotEscaped":_.includes("headers must be an object")?B="RequestHeadersNotObject":(0,O.$2)(q)&&(B="RequestCanceled"),q=new w.$8fb(`Connection refused for the request '${T}'.`,T,B,void 0,void 0)}throw this.l.info("Request failed",T),q}const Q=J.res.headers[w.$4fb],G={url:T,status:J.res.statusCode,"execution-id":M.headers[w.$5fb],"operation-id":Q},X=(0,h.$Co)(J)||J.res.statusCode&&F.includes(J.res.statusCode);let W="";if(X?this.l.trace("Request succeeded",G):(W=await(0,h.$Do)(J)||"",this.l.info("Request failed",G,W)),J.res.statusCode===401||J.res.statusCode===403){if(this.b=void 0,J.res.statusCode===401)throw this.g.fire("Unauthorized"),new w.$8fb(`${M.type} request '${T}' failed because of Unauthorized (401).`,T,"Unauthorized",J.res.statusCode,Q);if(J.res.statusCode===403)throw this.g.fire("Forbidden"),new w.$8fb(`${M.type} request '${T}' failed because the access is forbidden (403).`,T,"Forbidden",J.res.statusCode,Q)}if(this.h.fire(),J.res.statusCode===404)throw new w.$8fb(`${M.type} request '${T}' failed because the requested resource is not found (404).`,T,"NotFound",J.res.statusCode,Q);if(J.res.statusCode===405)throw new w.$8fb(`${M.type} request '${T}' failed because the requested endpoint is not found (405). ${W}`,T,"MethodNotFound",J.res.statusCode,Q);if(J.res.statusCode===409)throw new w.$8fb(`${M.type} request '${T}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,T,"Conflict",J.res.statusCode,Q);if(J.res.statusCode===410)throw new w.$8fb(`${M.type} request '${T}' failed because the requested resource is not longer available (410).`,T,"Gone",J.res.statusCode,Q);if(J.res.statusCode===412)throw new w.$8fb(`${M.type} request '${T}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,T,"PreconditionFailed",J.res.statusCode,Q);if(J.res.statusCode===413)throw new w.$8fb(`${M.type} request '${T}' failed because of too large payload (413).`,T,"TooLarge",J.res.statusCode,Q);if(J.res.statusCode===426)throw new w.$8fb(`${M.type} request '${T}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,T,"UpgradeRequired",J.res.statusCode,Q);if(J.res.statusCode===429){const q=J.res.headers["retry-after"];throw q?(this.s(new Date(Date.now()+parseInt(q)*1e3)),new w.$8fb(`${M.type} request '${T}' failed because of too many requests (429).`,T,"TooManyRequestsAndRetryAfter",J.res.statusCode,Q)):new w.$8fb(`${M.type} request '${T}' failed because of too many requests (429).`,T,"RemoteTooManyRequests",J.res.statusCode,Q)}if(!X)throw new w.$8fb("Server returned "+J.res.statusCode,T,"Unknown",J.res.statusCode,Q);return J}w(T){let M=this.m.get(n,-1);M===void 0&&(M=(0,$.$3e)(),this.m.store(n,M,-1,1)),T["X-Machine-Session-Id"]=M;const F=this.m.get(s,-1);F!==void 0&&(T["X-User-Session-Id"]=F)}};e.$oAb=m,e.$oAb=m=ye([K(1,c.$0i),K(2,h.$Ao),K(3,w.$egb),K(4,d.$wh),K(5,p.$Sj),K(6,b.$Mo)],m);let l=class extends m{constructor(T,M,F,V,Z,J,Q){super(T.userDataSyncStore?.url,M,F,V,Z,J,Q),this.B(T.onDidChangeUserDataSyncStore(()=>this.n(T.userDataSyncStore?.url)))}};e.$pAb=l,e.$pAb=l=ye([K(0,w.$1fb),K(1,c.$0i),K(2,h.$Ao),K(3,w.$egb),K(4,d.$wh),K(5,p.$Sj),K(6,b.$Mo)],l);class E{constructor(T,M,F,V){this.c=T,this.d=M,this.f=F,this.g=V,this.a=[],this.b=void 0}request(T,M,F){if(this.h()&&this.i(),M.url=T,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new w.$8fb(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,T,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(T),this.f.request(M,F)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.$qAb=E}),define(ce[258],le([0,1,3,55,23,19,21,253,24,78,81]),function(ie,e,L,N,O,A,j,R,S,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z7b=void 0;let y=class extends R.$23b{constructor(u,d,p,c,h,f,b,w,I,t,o){super(u,d,p,c,h,b,w,I,t,o),this.B(L.Event.debounce(L.Event.any(L.Event.map(f.onDidFocusWindow,()=>"windowFocus"),L.Event.map(f.onDidOpenWindow,()=>"windowOpen")),(s,n)=>s?[...s,n]:[n],1e3)(s=>this.triggerSync(s,!0,!1)))}};e.$z7b=y,e.$z7b=y=ye([K(0,O.$0i),K(1,S.$1fb),K(2,S.$2fb),K(3,S.$_fb),K(4,S.$agb),K(5,N.$m5b),K(6,S.$egb),K(7,g.$5yb),K(8,j.$Vk),K(9,C.$UYb),K(10,A.$Mo)],y)}),define(ce[259],le([0,1,69,26,6,22]),function(ie,e,L,N,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$14b=e.$Z4b=e.$Y4b=e.$X4b=void 0,e.$X4b=128/4;function j(g){function C(){let y=g.scheme===N.Schemas.file?(0,A.$Wf)(g):g.toString();return O.$k||(y=y.toLowerCase()),(0,L.createHash)("md5").update(y).digest("hex")}return{id:C(),configPath:g}}e.$Y4b=j;function R(g,C){function y(){if(g.scheme!==N.Schemas.file)return(0,L.createHash)("md5").update(g.toString()).digest("hex");if(!C)return;let u;return O.$k?u=C.ino:O.$j?u=C.birthtime.getTime():O.$i&&(typeof C.birthtimeMs=="number"?u=Math.floor(C.birthtimeMs):u=C.birthtime.getTime()),(0,L.createHash)("md5").update(g.fsPath).update(u?String(u):"").digest("hex")}const $=y();if(typeof $=="string")return{id:$,uri:g}}e.$Z4b=R;function S(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.$14b=S}),define(ce[260],le([0,1,5,8,2,16,31,15,7,75,113,259,55,71]),function(ie,e,L,N,O,A,j,R,S,g,C,y,$,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$66b=void 0;let d=class extends O.$lb{constructor(c,h,f,b){super(),this.a=c,this.b=h,this.c=f,this.f=b,this.B(new L.$Gg(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const c=await j.Promises.readdir(this.a.workspaceStorageHome.fsPath),h=new g.$Dzb(this.f.getChannel("storage"));await Promise.all(c.map(async f=>{const b=(0,A.$8c)(this.a.workspaceStorageHome.fsPath,f);f.length===y.$X4b||f===C.$Bh.id||(await this.c.getWindows()).some(t=>t.workspace?.id===f)||await h.isUsed(b)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${f} as it seems to be an unused empty workspace.`),await j.Promises.rm(b))}))}catch(c){(0,N.$Y)(c)}}};e.$66b=d,e.$66b=d=ye([K(0,R.$xh),K(1,S.$Ri),K(2,$.$m5b),K(3,u.$E6b)],d)}),define(ce[82],le([0,1,52,5,16,11,31,146,271,272]),function(ie,e,L,N,O,A,j,R,S,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8o=e.$7o=e.zip=e.$5o=e.$4o=void 0,e.$4o="end of central directory record signature not found";const C=new RegExp(e.$4o);class y extends Error{constructor(o,s){let n=s.message;switch(o){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n),this.type=o,this.cause=s}}e.$5o=y;function $(t){const o=t.externalFileAttributes>>16||33188;return[448,56,7].map(s=>o&s).reduce((s,n)=>s+n,o&61440)}function u(t){if(t instanceof y)return t;let o;return C.test(t.message)&&(o="CorruptZip"),new y(o,t)}function d(t,o,s,n,i,r){const a=O.$$c(o),v=O.$8c(n,a);if(!v.startsWith(n))return Promise.reject(new Error(R.localize(0,null,o)));const m=O.$8c(n,o);let l;return r.onCancellationRequested(()=>{l?.destroy()}),Promise.resolve(j.Promises.mkdir(v,{recursive:!0})).then(()=>new Promise((E,D)=>{if(!r.isCancellationRequested)try{l=(0,L.createWriteStream)(m,{mode:s}),l.once("close",()=>E()),l.once("error",D),t.once("error",D),t.pipe(l)}catch(T){D(T)}}))}function p(t,o,s,n){let i=(0,N.$ig)(()=>Promise.resolve()),r=0;return n.onCancellationRequested(()=>{i.cancel(),t.close()}),new Promise((a,v)=>{const m=new N.$pg,l=E=>{E.isCancellationRequested||(r++,t.readEntry())};t.once("error",v),t.once("close",()=>i.then(()=>{n.isCancellationRequested||t.entryCount===r?a():v(new y("Incomplete",new Error(R.localize(1,null,r,t.entryCount))))},v)),t.readEntry(),t.on("entry",E=>{if(n.isCancellationRequested)return;if(!s.sourcePathRegex.test(E.fileName)){l(n);return}const D=E.fileName.replace(s.sourcePathRegex,"");if(/\/$/.test(D)){const F=O.$8c(o,D);i=(0,N.$ig)(V=>j.Promises.mkdir(F,{recursive:!0}).then(()=>l(V)).then(void 0,v));return}const T=h(t,E),M=$(E);i=(0,N.$ig)(F=>m.queue(()=>T.then(V=>d(V,D,M,o,s,F).then(()=>l(F)))).then(null,v))})})}function c(t,o=!1){return new Promise((s,n)=>{(0,S.open)(t,o?{lazyEntries:!0}:void 0,(i,r)=>{i?n(u(i)):s((0,A.$te)(r))})})}function h(t,o){return new Promise((s,n)=>{t.openReadStream(o,(i,r)=>{i?n(u(i)):s((0,A.$te)(r))})})}function f(t,o){return new Promise((s,n)=>{const i=new g.ZipFile;o.forEach(a=>{a.contents?i.addBuffer(typeof a.contents=="string"?Buffer.from(a.contents,"utf8"):a.contents,a.path):a.localPath&&i.addFile(a.localPath,a.path)}),i.end();const r=(0,L.createWriteStream)(t);i.outputStream.pipe(r),i.outputStream.once("error",n),r.once("error",n),r.once("finish",()=>s(t))})}e.zip=f;function b(t,o,s={},n){const i=new RegExp(s.sourcePath?`^${s.sourcePath}`:"");let r=c(t,!0);return s.overwrite&&(r=r.then(a=>j.Promises.rm(o).then(()=>a))),r.then(a=>p(a,o,{sourcePathRegex:i},n))}e.$7o=b;function w(t,o){return c(t).then(s=>new Promise((n,i)=>{s.on("entry",r=>{r.fileName===o&&h(s,r).then(a=>n(a),a=>i(a))}),s.once("close",()=>i(new Error(R.localize(2,null,o))))}))}function I(t,o){return w(t,o).then(s=>new Promise((n,i)=>{const r=[];s.once("error",i),s.on("data",a=>r.push(a)),s.on("end",()=>n(Buffer.concat(r)))}))}e.$8o=I}),define(ce[261],le([0,1,5,8,2,26,22,53,11,32,31,82,18,15,29,33,97,13,7]),function(ie,e,L,N,O,A,j,R,S,g,C,y,$,u,d,p,c,h,f){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$kp=void 0;let w=class extends O.$lb{static{b=this}static{this.c=".sigzip"}constructor(t,o,s,n,i,r){super(),this.h=o,this.i=s,this.j=n,this.k=i,this.l=r,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.t()}async download(t,o,s){await this.g;const n=(0,j.$9f)(this.extensionsDownloadDir,this.u(t));try{await this.r(t,n,r=>this.i.download(t,r,o))}catch(r){throw new d.$Sn(r.message,d.ExtensionManagementErrorCode.Download)}let i=!1;if(s&&this.m(t)){const r=await this.n(t);try{i=await this.k.verify(n.fsPath,r.fsPath,this.l.getLevel()===f.LogLevel.Trace)}catch(a){const v=a;if(i=v.code,v.output&&this.l.trace(`Extension signature verification details for ${t.identifier.id} ${t.version}:
${v.output}`),i===d.ExtensionSignaturetErrorCode.PackageIsInvalidZip||i===d.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new d.$Sn(y.$4o,d.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(r)}catch(a){this.l.error(a)}}}return i===!0?this.l.info(`Extension signature is verified: ${t.identifier.id}`):i===!1?this.l.info(`Extension signature verification is not done: ${t.identifier.id}`):this.l.warn(`Extension signature verification failed with error '${i}': ${t.identifier.id}`),{location:n,verificationStatus:i}}m(t){if(!t.isSigned)return!1;const o=this.j.getValue("extensions.verifySignature");return(0,S.$oe)(o)?o:!0}async n(t){await this.g;const o=(0,j.$9f)(this.extensionsDownloadDir,`${this.u(t)}${b.c}`);return await this.r(t,o,s=>this.i.downloadSignatureArchive(t,s)),o}async r(t,o,s){if(await this.h.exists(o))return;if(o.scheme!==A.Schemas.file){await s(o);return}const n=(0,j.$9f)(this.extensionsDownloadDir,`.${(0,g.$3e)()}`);await this.h.exists(n)||await s(n);try{await C.Promises.rename(n.fsPath,o.fsPath,2*60*1e3)}catch(i){try{await this.h.del(n)}catch{}if(i.code==="ENOTEMPTY")this.l.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,o.path);else throw this.l.info(`Rename failed because of ${(0,N.$9)(i)}. Deleted the file from downloaded location`,n.path),i}}async delete(t){await this.g,await this.h.del(t)}async t(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.l.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const o=[],s=[],n=[];for(const a of t.children)if(a.name.endsWith(b.c))n.push(a.resource);else{const v=p.$io.parse(a.name);v&&s.push([v,a])}const i=(0,p.$no)(s,([a])=>a),r=[];for(const a of i)a.sort((v,m)=>R.rcompare(v[0].version,m[0].version)),o.push(...a.slice(1).map(v=>v[1].resource)),r.push(a[0][1]);r.sort((a,v)=>a.mtime-v.mtime),o.push(...r.slice(0,Math.max(0,r.length-this.f)).map(a=>a.resource)),o.push(...n),await L.Promises.settled(o.map(a=>(this.l.trace("Deleting from cache",a.path),this.h.del(a))))}}catch(t){this.l.error(t)}}u(t){return this.f?p.$io.create(t).toString().toLowerCase():(0,g.$3e)()}};e.$kp=w,e.$kp=w=b=ye([K(0,u.$xh),K(1,h.$Sj),K(2,d.$Rn),K(3,$.$Vh),K(4,c.$Xo),K(5,f.$Ri)],w)}),define(ce[262],le([0,1,82,155]),function(ie,e,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mp=void 0;function O(A){return(0,L.$8o)(A,"extension/package.json").then(j=>{try{return JSON.parse(j.toString("utf8"))}catch{throw new Error((0,N.localize)(0,null))}})}e.$mp=O}),define(ce[122],le([0,1,5,14,25,38,8,3,51,2,35,26,16,22,53,11,10,32,31,82,154,96,15,241,29,33,50,79,261,242,262,210,221,67,13,4,7,23,21,27,17]),function(ie,e,L,N,O,A,j,R,S,g,C,y,$,u,d,p,c,h,f,b,w,I,t,o,s,n,i,r,a,v,m,l,E,D,T,M,F,V,Z,J,Q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=e.$rp=e.$qp=e.$pp=void 0,e.$pp=(0,M.$qh)(s.$Tn);const G=".vsctmp";let X=class extends o.$9o{constructor(Y,U,k,P,z,H,ee,ne,fe,x,se,te){super(Y,U,se,k,x,te),this.bb=z,this.cb=H,this.db=ee,this.eb=fe,this.ab=new Map,this.nb=new C.$oi;const ue=this.B(ne.createInstance(v.$lp));this.Y=this.B(ne.createInstance(W,we=>ue.postUninstall(we))),this.Z=this.B(new l.$np(te,fe,se,this,this.y)),this.$=this.B(ne.createInstance(a.$kp));const de=this.B(new E.$op(this,this.bb,te,H,se,fe,k));this.B(de.onDidChangeExtensionsByAnotherSource(we=>this.mb(we))),this.ob()}getTargetPlatform(){return this.fb||(this.fb=(0,n.$so)(this.eb,this.y)),this.fb}async zip(Y){this.y.trace("ExtensionManagementService#zip",Y.identifier.id);const U=await this.lb(Y),k=await(0,b.zip)((0,u.$9f)(this.$.extensionsDownloadDir,(0,h.$3e)()).fsPath,U);return c.URI.file(k)}async unzip(Y){return this.y.trace("ExtensionManagementService#unzip",Y.toString()),(await this.install(Y)).identifier}async getManifest(Y){const{location:U,cleanup:k}=await this.hb(Y),P=$.$9c(U.fsPath);try{return await(0,m.$mp)(P)}finally{await k()}}getInstalled(Y,U=this.C.defaultProfile.extensionsResource){return this.Y.scanExtensions(Y??null,U)}scanAllUserInstalledExtensions(){return this.Y.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(Y){return this.Y.scanUserExtensionAtLocation(Y)}async install(Y,U={}){this.y.trace("ExtensionManagementService#install",Y.toString());const{location:k,cleanup:P}=await this.hb(Y);try{const z=await(0,m.$mp)($.$9c(k.fsPath)),H=(0,n.$mo)(z.publisher,z.name);if(z.engines&&z.engines.vscode&&!(0,D.$zo)(z.engines.vscode,this.z.version,this.z.date))throw new Error(w.localize(0,null,H,this.z.version));const ne=(await this.D([{manifest:z,extension:k,options:U}])).find(({identifier:fe})=>(0,n.$ho)(fe,{id:H}));if(ne?.local)return ne.local;throw ne?.error?ne.error:(0,o.$$o)(new Error(`Unknown error while installing extension ${H}`))}finally{await P()}}async installFromLocation(Y,U){this.y.trace("ExtensionManagementService#installFromLocation",Y.toString());const k=await this.Y.scanUserExtensionAtLocation(Y);if(!k)throw new Error(`Cannot find a valid extension from the location ${Y.toString()}`);return await this.qb([[k,void 0]],U),this.y.info("Successfully installed extension",k.identifier.id,U.toString()),k}async installExtensionsFromProfile(Y,U,k){this.y.trace("ExtensionManagementService#installExtensionsFromProfile",Y,U.toString(),k.toString());const P=(await this.Y.scanExtensions(1,U)).filter(z=>Y.some(H=>(0,n.$ho)(H,z.identifier)));if(P.length){const z=await Promise.all(P.map(H=>this.Y.scanMetadata(H,U)));await this.qb(P.map((H,ee)=>[H,z[ee]]),k),this.y.info("Successfully installed extensions",P.map(H=>H.identifier.id),k.toString())}return P}async updateMetadata(Y,U,k=this.C.defaultProfile.extensionsResource){return this.y.trace("ExtensionManagementService#updateMetadata",Y.identifier.id),U.isPreReleaseVersion&&(U.preRelease=!0),U.isMachineScoped=U.isMachineScoped||void 0,U.isBuiltin=U.isBuiltin||void 0,U.pinned=U.pinned||void 0,Y=await this.Y.updateMetadata(Y,U,k),this.Z.invalidate(k),this.s.fire(Y),Y}async reinstallFromGallery(Y){if(this.y.trace("ExtensionManagementService#reinstallFromGallery",Y.identifier.id),!this.u.isEnabled())throw new Error(w.localize(1,null));const U=await this.getTargetPlatform(),[k]=await this.u.getExtensions([{...Y.identifier,preRelease:Y.preRelease}],{targetPlatform:U,compatible:!0},O.CancellationToken.None);if(!k)throw new Error(w.localize(2,null));await this.Y.setUninstalled(Y);try{await this.Y.removeUninstalledExtension(Y)}catch(P){throw new Error(w.localize(3,null,(0,A.$ai)(P)))}return this.installFromGallery(k)}X(Y,U,k,P){return this.Y.copyExtension(Y,U,k,P)}copyExtensions(Y,U){return this.Y.copyExtensions(Y,U)}markAsUninstalled(...Y){return this.Y.setUninstalled(...Y)}async cleanUp(){this.y.trace("ExtensionManagementService#cleanUp");try{await this.Y.cleanUp()}catch(Y){this.y.error(Y)}}async download(Y,U,k){const{location:P}=await this.$.download(Y,U,!k);return P}async hb(Y){if(Y.scheme===y.Schemas.file)return{location:Y,async cleanup(){}};this.y.trace("Downloading extension from",Y.toString());const U=(0,u.$9f)(this.$.extensionsDownloadDir,(0,h.$3e)());return await this.db.download(Y,U),this.y.info("Downloaded extension to",U.toString()),{location:U,cleanup:async()=>{try{await this.eb.del(U)}catch(P){this.y.error(P)}}}}S(){return this.C.defaultProfile.extensionsResource}U(Y,U,k){if(c.URI.isUri(U))return new _(Y,U,k,this.u,this.Y,this.w,this.C,this.bb,this.cb,this.y);const P=n.$io.create(U).toString();let z=this.ab.get(P);return z||(this.ab.set(P,z=new B(Y,U,k,this.$,this.Y,this.w,this.C,this.bb,this.cb,this.y)),z.waitUntilTaskIsFinished().finally(()=>this.ab.delete(P))),z}W(Y,U){return new oe(Y,U.profileLocation,this.cb)}async lb(Y){const U=async P=>{let z=await f.Promises.readdir(P);z=z.map(ne=>$.$8c(P,ne));const H=await Promise.all(z.map(ne=>f.Promises.stat(ne)));let ee=Promise.resolve([]);return H.forEach((ne,fe)=>{const x=z[fe];ne.isFile()&&(ee=ee.then(se=>[...se,x])),ne.isDirectory()&&(ee=ee.then(se=>U(x).then(te=>[...se,...te])))}),ee};return(await U(Y.location.fsPath)).map(P=>({path:`extension/${$.$0c(Y.location.fsPath,P)}`,localPath:P}))}async mb({added:Y,removed:U}){if(U)for(const k of U.extensions)this.y.info("Extensions removed from another source",k.id,U.profileLocation.toString()),this.p.fire({identifier:k,profileLocation:U.profileLocation});if(Y){const P=(await this.Y.scanExtensions(1,Y.profileLocation)).filter(z=>Y.extensions.some(H=>(0,n.$ho)(H,z.identifier)));this.m.fire(P.map(z=>(this.y.info("Extensions added from another source",z.identifier.id,Y.profileLocation.toString()),{identifier:z.identifier,local:z,profileLocation:Y.profileLocation,operation:1})))}}async ob(){this.B(this.Y.onExtract(U=>this.nb.add(U)));const Y=await this.eb.resolve(this.bb.userExtensionsLocation);for(const U of Y.children??[])U.isDirectory&&this.nb.add(U.resource);this.B(this.eb.watch(this.bb.userExtensionsLocation)),this.B(this.eb.onDidFilesChange(U=>this.pb(U)))}async pb(Y){if(!Y.affects(this.bb.userExtensionsLocation,1))return;const U=[];for(const k of Y.rawAdded){if(this.nb.has(k)||!this.w.extUri.isEqual(this.w.extUri.dirname(k),this.bb.userExtensionsLocation)||this.w.extUri.isEqual(k,this.w.extUri.joinPath(this.bb.userExtensionsLocation,".obsolete"))||this.w.extUri.basename(k).startsWith(".")||!(await this.eb.stat(k)).isDirectory)continue;const P=await this.Y.scanUserExtensionAtLocation(k);P&&P.installedTimestamp===void 0&&(this.nb.add(k),U.push(P))}U.length&&(await this.qb(U.map(k=>[k,void 0]),this.C.defaultProfile.extensionsResource),this.y.info("Added extensions to default profile from external source",U.map(k=>k.identifier.id)))}async qb(Y,U){const k=Y.map(P=>P[0]);await this.rb(k),await this.cb.addExtensionsToProfile(Y,U),this.m.fire(k.map(P=>({local:P,identifier:P.identifier,operation:1,profileLocation:U})))}async rb(Y){const U=await this.Y.getUninstalledExtensions();for(const k of Y){const P=n.$io.create(k);U[P.toString()]&&(this.y.trace("Removing the extension from uninstalled list:",P.id),await this.Y.setInstalled(P),this.y.info("Removed the extension from uninstalled list:",P.id))}}};e.$qp=X,e.$qp=X=ye([K(0,s.$Rn),K(1,Z.$Vk),K(2,F.$Ri),K(3,t.$xh),K(4,r.$fp),K(5,i.$bp),K(6,I.$vn),K(7,M.$oh),K(8,T.$Sj),K(9,V.$0i),K(10,J.$pk),K(11,Q.$rk)],X);let W=class extends g.$lb{constructor(Y,U,k,P,z,H){super(),this.j=Y,this.k=U,this.l=k,this.m=P,this.n=z,this.p=H,this.h=this.B(new R.$ec),this.onExtract=this.h.event,this.c=(0,u.$9f)(this.l.userExtensionsLocation,".obsolete"),this.g=new L.$Bg}async cleanUp(){await this.C(),await this.z()}async scanExtensions(Y,U){const k={includeInvalid:!0,profileLocation:U};let P=[];return Y===null||Y===0?P.push(...await this.l.scanAllExtensions({includeInvalid:!0},k,!1)):Y===1&&P.push(...await this.l.scanUserExtensions(k)),P=Y!==null?P.filter(z=>z.type===Y):P,Promise.all(P.map(z=>this.y(z)))}async scanAllUserExtensions(Y){const U=await this.l.scanUserExtensions({includeAllVersions:!Y,includeInvalid:!0});return Promise.all(U.map(k=>this.y(k)))}async scanUserExtensionAtLocation(Y){try{const U=await this.l.scanExistingExtension(Y,1,{includeInvalid:!0});if(U)return await this.y(U)}catch(U){this.p.error(U)}return null}async extractUserExtension(Y,U,k,P,z){const H=Y.toString(),ee=c.URI.file($.$8c(this.l.userExtensionsLocation.fsPath,`.${(0,h.$3e)()}`)),ne=c.URI.file($.$8c(this.l.userExtensionsLocation.fsPath,H));let fe=await this.k.exists(ne);if(fe&&P){try{await this.t(Y.id,ne,"removeExisting")}catch{throw new s.$Sn(w.localize(4,null,ne.fsPath,Y.id),s.ExtensionManagementErrorCode.Delete)}fe=!1}if(!fe)try{try{this.p.trace(`Started extracting the extension from ${U} to ${ne.fsPath}`),await(0,b.$7o)(U,ee.fsPath,{sourcePath:"extension",overwrite:!0},z),this.p.info(`Extracted extension to ${ne}:`,Y.id)}catch(x){let se=s.ExtensionManagementErrorCode.Extract;throw x instanceof b.$5o&&(x.type==="CorruptZip"?se=s.ExtensionManagementErrorCode.CorruptZip:x.type==="Incomplete"&&(se=s.ExtensionManagementErrorCode.IncompleteZip)),new s.$Sn(x.message,se)}await this.l.updateMetadata(ee,k);try{this.p.trace(`Started renaming the extension from ${ee.fsPath} to ${ne.fsPath}`),await this.v(ee.fsPath,ne.fsPath),this.p.info("Renamed to",ne.fsPath)}catch(x){if(x.code==="ENOTEMPTY")this.p.info("Rename failed because extension was installed by another source. So ignoring renaming.",Y.id);else throw this.p.info(`Rename failed because of ${(0,j.$9)(x)}. Deleted from extracted location`,ee),x}this.h.fire(ne)}catch(x){try{await this.k.del(ee,{recursive:!0})}catch{}throw x}return this.w(ne,1)}async scanMetadata(Y,U){return U?(await this.s(Y,U))?.metadata:this.l.scanMetadata(Y.location)}async s(Y,U){return(await this.m.scanProfileExtensions(U)).find(P=>(0,n.$ho)(P.identifier,Y.identifier))}async updateMetadata(Y,U,k){return k?await this.m.updateMetadata([[Y,U]],k):await this.l.updateMetadata(Y.location,U),this.w(Y.location,Y.type,k)}getUninstalledExtensions(){return this.u()}async setUninstalled(...Y){const U=Y.map(k=>n.$io.create(k));await this.u(k=>U.forEach(P=>{k[P.toString()]=!0,this.p.info("Marked extension as uninstalled",P.toString())}))}async setInstalled(Y){await this.u(U=>delete U[Y.toString()])}async removeExtension(Y,U){if(this.n.extUri.isEqualOrParent(Y.location,this.l.userExtensionsLocation))return this.t(Y.identifier.id,Y.location,U)}async removeUninstalledExtension(Y){await this.removeExtension(Y,"uninstalled"),await this.u(U=>delete U[n.$io.create(Y).toString()])}async copyExtension(Y,U,k,P){const z=await this.s(Y,U),H=await this.s(Y,k);return P={...z?.metadata,...P},H?await this.m.updateMetadata([[Y,{...H.metadata,...P}]],k):await this.m.addExtensionsToProfile([[Y,P]],k),this.w(Y.location,Y.type,k)}async copyExtensions(Y,U){const k=await this.scanExtensions(1,Y),P=await Promise.all(k.filter(z=>!z.isApplicationScoped).map(async z=>[z,await this.scanMetadata(z,Y)]));await this.m.addExtensionsToProfile(P,U)}async t(Y,U,k){this.p.trace(`Deleting ${k} extension from disk`,Y,U.fsPath);const P=this.n.extUri.joinPath(this.n.extUri.dirname(U),`${this.n.extUri.basename(U)}.${(0,S.$di)((0,h.$3e)()).toString(16)}${G}`);await this.v(U.fsPath,P.fsPath),await this.k.del(P,{recursive:!0}),this.p.info(`Deleted ${k} extension from disk`,Y,U.fsPath)}async u(Y){return this.g.queue(async()=>{let U;try{U=(await this.k.readFile(this.c,"utf8")).value.toString()}catch(P){if((0,T.$9j)(P)!==1)throw P}let k={};if(U)try{k=JSON.parse(U)}catch{}return Y&&(Y(k),Object.keys(k).length?await this.k.writeFile(this.c,N.$Ec.fromString(JSON.stringify(k))):await this.k.del(this.c)),k})}async v(Y,U){try{await f.Promises.rename(Y,U,2*60*1e3)}catch(k){throw new s.$Sn(k.message||w.localize(5,null,Y,U),k.code||s.ExtensionManagementErrorCode.Rename)}}async w(Y,U,k){if(k){const z=(await this.l.scanUserExtensions({profileLocation:k})).find(H=>this.n.extUri.isEqual(H.location,Y));if(z)return this.y(z)}else{const P=await this.l.scanExistingExtension(Y,U,{includeInvalid:!0});if(P)return this.y(P)}throw new Error(w.localize(6,null,Y.path))}async y(Y){const U=await this.k.resolve(Y.location);let k,P;return U.children&&(k=U.children.find(({name:z})=>/^readme(\.txt|\.md|)$/i.test(z))?.resource,P=U.children.find(({name:z})=>/^changelog(\.txt|\.md|)$/i.test(z))?.resource),{identifier:Y.identifier,type:Y.type,isBuiltin:Y.isBuiltin||!!Y.metadata?.isBuiltin,location:Y.location,manifest:Y.manifest,targetPlatform:Y.targetPlatform,validations:Y.validations,isValid:Y.isValid,readmeUrl:k,changelogUrl:P,publisherDisplayName:Y.metadata?.publisherDisplayName||null,publisherId:Y.metadata?.publisherId||null,isApplicationScoped:!!Y.metadata?.isApplicationScoped,isMachineScoped:!!Y.metadata?.isMachineScoped,isPreReleaseVersion:!!Y.metadata?.isPreReleaseVersion,preRelease:!!Y.metadata?.preRelease,installedTimestamp:Y.metadata?.installedTimestamp,updated:!!Y.metadata?.updated,pinned:!!Y.metadata?.pinned}}async z(){const Y=await this.getUninstalledExtensions();if(Object.keys(Y).length===0){this.p.debug("No uninstalled extensions found.");return}this.p.debug("Removing uninstalled extensions:",Object.keys(Y));const U=await this.l.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),k=new Set;for(const z of U)Y[n.$io.create(z).toString()]||k.add(z.identifier.id.toLowerCase());try{const z=(0,n.$no)(U,H=>H.identifier);await L.Promises.settled(z.map(async H=>{const ee=H.sort((ne,fe)=>d.rcompare(ne.manifest.version,fe.manifest.version))[0];k.has(ee.identifier.id.toLowerCase())||await this.j(await this.y(ee))}))}catch(z){this.p.error(z)}const P=U.filter(z=>z.metadata&&Y[n.$io.create(z).toString()]);await Promise.allSettled(P.map(z=>this.removeUninstalledExtension(z)))}async C(){this.p.trace("ExtensionManagementService#removeTempDeleteFolders");let Y;try{Y=await this.k.resolve(this.l.userExtensionsLocation)}catch(U){(0,T.$9j)(U)!==1&&this.p.error(U);return}if(Y?.children)try{await Promise.allSettled(Y.children.map(async U=>{if(!(!U.isDirectory||!U.name.endsWith(G))){this.p.trace("Deleting the temporarily deleted folder",U.resource.toString());try{await this.k.del(U.resource,{recursive:!0}),this.p.trace("Deleted the temporarily deleted folder",U.resource.toString())}catch(k){(0,T.$9j)(k)!==1&&this.p.error(k)}}}))}catch{}}};e.$rp=W,e.$rp=W=ye([K(1,T.$Sj),K(2,r.$fp),K(3,i.$bp),K(4,J.$pk),K(5,F.$Ri)],W);class q extends o.$_o{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,p.$pe)(this.options.operation)?this.l:this.options.operation}constructor(Y,U,k,P,z,H,ee,ne,fe){super(),this.identifier=Y,this.source=U,this.options=k,this.m=P,this.n=z,this.o=H,this.p=ee,this.q=ne,this.s=fe,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(Y){const[U,k]=await this.x(Y);return this.j=U.isBuiltin||U.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[U,k]],this.j),U}async u({zipPath:Y,key:U,metadata:k},P,z){let H=await this.v(U);return H||(this.s.trace("Extracting extension...",U.id),H=await this.m.extractUserExtension(U,Y,k,P,z),this.s.info("Extracting extension completed.",U.id)),H}async v(Y){return await this.w(Y)?(this.s.trace("Removing the extension from uninstalled list:",Y.id),await this.m.setInstalled(Y),this.s.info("Removed the extension from uninstalled list:",Y.id),(await this.m.scanAllUserExtensions(!0)).find(P=>n.$io.create(P).equals(Y))):void 0}async w(Y){return!!(await this.m.getUninstalledExtensions())[Y.toString()]}}class B extends q{constructor(Y,U,k,P,z,H,ee,ne,fe,x){super(U.identifier,U,k,z,H,ee,ne,fe,x),this.y=U,this.z=P}async x(Y){const k=(await this.m.scanExtensions(null,this.options.profileLocation)).find(ee=>(0,n.$ho)(ee.identifier,this.y.identifier));k&&(this.l=3);const P={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||k?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||k?.isMachineScoped,isBuiltin:this.options.isBuiltin||k?.isBuiltin,isSystem:k?.type===0?!0:void 0,updated:!!k,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0,preRelease:this.y.properties.isPreReleaseVersion||((0,p.$oe)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:k?.preRelease)};if(k?.manifest.version===this.y.version)return[await this.m.updateMetadata(k,P),P];const{location:z,verificationStatus:H}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=H,this.B(z.fsPath),[await this.u({zipPath:z.fsPath,key:n.$io.create(this.y),metadata:P},!1,Y),P]}catch(ee){try{await this.z.delete(z)}catch(ne){this.s.warn("Error while deleting the downloaded file",z.toString(),(0,j.$9)(ne))}throw ee}}async B(Y){try{await(0,m.$mp)(Y)}catch(U){throw new s.$Sn((0,o.$0o)(U).message,s.ExtensionManagementErrorCode.Invalid)}}}e.$sp=B;class _ extends q{constructor(Y,U,k,P,z,H,ee,ne,fe,x){super({id:(0,n.$mo)(Y.publisher,Y.name)},U,k,z,H,ee,ne,fe,x),this.y=Y,this.z=U,this.A=P}async h(Y){const U=await super.h(Y);return this.D(U,Y),U}async x(Y){const U=new n.$io(this.identifier,this.y.version),P=(await this.m.scanExtensions(1,this.options.profileLocation)).find(ee=>(0,n.$ho)(this.identifier,ee.identifier)),z={isApplicationScoped:this.options.isApplicationScoped||P?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||P?.isMachineScoped,isBuiltin:this.options.isBuiltin||P?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0};if(P)if(this.l=3,U.equals(new n.$io(P.identifier,P.manifest.version)))try{await this.m.removeExtension(P,"existing")}catch{throw new Error(w.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&d.gt(P.manifest.version,this.y.version)&&await this.m.setUninstalled(P);else{const ee=await this.v(U);if(ee)try{await this.m.removeExtension(ee,"existing")}catch{throw new Error(w.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:$.$9c(this.z.fsPath),key:U,metadata:z},!0,Y),z]}async D(Y,U){try{let[k]=await this.A.getExtensions([{id:Y.identifier.id,version:Y.manifest.version}],U);if(k||([k]=await this.A.getExtensions([{id:Y.identifier.id}],U)),k){const P={id:k.identifier.uuid,publisherDisplayName:k.publisherDisplayName,publisherId:k.publisherId,isPreReleaseVersion:k.properties.isPreReleaseVersion,preRelease:k.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(Y,P,this.options.profileLocation)}}catch{}}}class oe extends o.$_o{constructor(Y,U,k){super(),this.extension=Y,this.j=U,this.k=k}async h(Y){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(ce[263],le([0,1,2,29,80,220,122,7,19]),function(ie,e,L,N,O,A,j,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t7b=void 0;let g=class extends L.$lb{constructor(y,$,u,d,p,c){super(),y.cleanUp(),(0,A.$fUb)(y,$,u,d,c),O.$Jz.removeOutdatedExtensionVersions(y,p)}};e.$t7b=g,e.$t7b=g=ye([K(0,j.$pp),K(1,N.$Rn),K(2,O.$Iz),K(3,N.$Wn),K(4,S.$Mo),K(5,R.$Ri)],g)}),define(ce[123],le([0,1,69,61,36,273,14,8,3,2,16,6,32,43,65]),function(ie,e,L,N,O,A,j,R,S,g,C,y,$,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=void 0;class p{traceSocketEvent(l,E){d.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,l,E)}constructor(l,E=""){this.f=!0,this.debugLabel=E,this.socket=l,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=D=>{if(this.traceSocketEvent("error",{code:D?.code,message:D?.message}),D){if(D.code==="EPIPE")return;(0,R.$Y)(D)}},this.socket.on("error",this.a),this.b=D=>{this.traceSocketEvent("close",{hadError:D}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(l){const E=D=>{this.traceSocketEvent("read",D),l(j.$Ec.wrap(D))};return this.socket.on("data",E),{dispose:()=>this.socket.off("data",E)}}onClose(l){const E=D=>{l({type:0,hadError:D,error:void 0})};return this.socket.on("close",E),{dispose:()=>this.socket.off("close",E)}}onEnd(l){const E=()=>{l()};return this.socket.on("end",E),{dispose:()=>this.socket.off("end",E)}}write(l){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",l),this.socket.write(l.buffer,E=>{if(E){if(E.code==="EPIPE")return;(0,R.$Y)(E)}})}catch(E){if(E.code==="EPIPE")return;(0,R.$Y)(E)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((l,E)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),l();return}const D=()=>{this.socket.off("close",D),this.socket.off("end",D),this.socket.off("error",D),this.socket.off("timeout",D),this.socket.off("drain",D),this.traceSocketEvent("nodeDrainEnd"),l()};this.socket.on("close",D),this.socket.on("end",D),this.socket.on("error",D),this.socket.on("timeout",D),this.socket.on("drain",D)})}}e.$eh=p;var c;(function(m){m[m.MinHeaderByteSize=2]="MinHeaderByteSize",m[m.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(c||(c={}));var h;(function(m){m[m.PeekHeader=1]="PeekHeader",m[m.ReadHeader=2]="ReadHeader",m[m.ReadBody=3]="ReadBody",m[m.Fin=4]="Fin"})(h||(h={}));class f extends g.$lb{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(l,E){this.socket.traceSocketEvent(l,E)}constructor(l,E,D,T){super(),this.f=this.B(new S.$ec),this.g=this.B(new S.$ec),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=l,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:E,inflateBytesLength:D?.byteLength||0,recordInflateBytes:T}),this.a=this.B(new b(this,E,D,T,this.f,(M,F)=>this.k(M,F))),this.B(this.a.onError(M=>{console.error(M),(0,R.$Y)(M),this.g.fire({type:0,hadError:!0,error:M})})),this.b=new d.$_g,this.B(this.socket.onData(M=>this.l(M))),this.B(this.socket.onClose(async M=>{this.a.isProcessingReadQueue()&&await S.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(M)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(l){return this.f.event(l)}onClose(l){return this.g.event(l)}onEnd(l){return this.socket.onEnd(l)}write(l){let E=0;for(;E<l.byteLength;)this.a.writeMessage(l.slice(E,Math.min(E+262144,l.byteLength))),E+=262144}k(l,E){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",l);let D=2;l.byteLength<126?D+=0:l.byteLength<2**16?D+=2:D+=8;const T=j.$Ec.alloc(D);if(E?T.writeUInt8(194,0):T.writeUInt8(130,0),l.byteLength<126)T.writeUInt8(l.byteLength,1);else if(l.byteLength<2**16){T.writeUInt8(126,1);let M=1;T.writeUInt8(l.byteLength>>>8&255,++M),T.writeUInt8(l.byteLength>>>0&255,++M)}else{T.writeUInt8(127,1);let M=1;T.writeUInt8(0,++M),T.writeUInt8(0,++M),T.writeUInt8(0,++M),T.writeUInt8(0,++M),T.writeUInt8(l.byteLength>>>24&255,++M),T.writeUInt8(l.byteLength>>>16&255,++M),T.writeUInt8(l.byteLength>>>8&255,++M),T.writeUInt8(l.byteLength>>>0&255,++M)}this.socket.write(j.$Ec.concat([T,l]))}end(){this.h=!0,this.socket.end()}l(l){if(l.byteLength!==0){for(this.b.acceptChunk(l);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const E=this.b.peek(this.j.readLen),D=E.readUInt8(0),T=(D&128)>>>7,M=(D&64)>>>6,F=E.readUInt8(1),V=(F&128)>>>7,Z=F&127;this.j.state=2,this.j.readLen=2+(V?4:0)+(Z===126?2:0)+(Z===127?8:0),this.j.fin=T,this.j.firstFrameOfMessage&&(this.j.compressed=!!M),this.j.firstFrameOfMessage=!!T,this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const E=this.b.read(this.j.readLen),D=E.readUInt8(1),T=(D&128)>>>7;let M=D&127,F=1;M===126?M=E.readUInt8(++F)*2**8+E.readUInt8(++F):M===127&&(M=E.readUInt8(++F)*0+E.readUInt8(++F)*0+E.readUInt8(++F)*0+E.readUInt8(++F)*0+E.readUInt8(++F)*2**24+E.readUInt8(++F)*2**16+E.readUInt8(++F)*2**8+E.readUInt8(++F));let V=0;T&&(V=E.readUInt8(++F)*2**24+E.readUInt8(++F)*2**16+E.readUInt8(++F)*2**8+E.readUInt8(++F)),this.j.state=3,this.j.readLen=M,this.j.mask=V,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const E=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",E),t(E,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",E),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(E,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await S.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$fh=f;class b extends g.$lb{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:j.$Ec.alloc(0)}constructor(l,E,D,T,M,F){super(),this.l=l,this.m=M,this.n=F,this.a=this.B(new S.$ec),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new S.$ec),this.onDidFinishProcessingReadQueue=this.j.event,this.k=this.B(new S.$ec),this.onDidFinishProcessingWriteQueue=this.k.event,this.p=!1,this.t=!1,E?(this.b=this.B(new w(this.l,T,D,{windowBits:15})),this.f=this.B(new I(this.l,{windowBits:15})),this.B(this.b.onError(V=>this.a.fire(V))),this.B(this.f.onError(V=>this.a.fire(V)))):(this.b=null,this.f=null)}writeMessage(l){this.g.push(l),this.r()}async r(){if(!this.p){for(this.p=!0;this.g.length>0;){const l=this.g.shift();if(this.f){const E=await this.s(this.f,l);this.n(E,!0)}else this.n(l,!1)}this.p=!1,this.k.fire()}}isProcessingWriteQueue(){return this.p}s(l,E){return new Promise((D,T)=>{l.write(E),l.flush(M=>D(M))})}acceptFrame(l,E,D){this.h.push({data:l,isCompressed:E,isLastFrameOfMessage:D}),this.u()}async u(){if(!this.t){for(this.t=!0;this.h.length>0;){const l=this.h.shift();if(this.b&&l.isCompressed){const E=await this.w(this.b,l.data,l.isLastFrameOfMessage);this.m.fire(E)}else this.m.fire(l.data)}this.t=!1,this.j.fire()}}isProcessingReadQueue(){return this.t}w(l,E,D){return new Promise((T,M)=>{l.write(E),D&&l.write(j.$Ec.fromByteArray([0,0,255,255])),l.flush(F=>T(F))})}}class w extends g.$lb{get recordedInflateBytes(){return this.j?j.$Ec.concat(this.f):j.$Ec.alloc(0)}constructor(l,E,D,T){super(),this.h=l,this.j=E,this.a=this.B(new S.$ec),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,A.createInflateRaw)(T),this.b.on("error",M=>{this.h.traceSocketEvent("zlibInflateError",{message:M?.message,code:M?.code}),this.a.fire(M)}),this.b.on("data",M=>{this.h.traceSocketEvent("zlibInflateData",M),this.g.push(j.$Ec.wrap(M))}),D&&(this.h.traceSocketEvent("zlibInflateInitialWrite",D.buffer),this.b.write(D.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(l){this.j&&this.f.push(l.clone()),this.h.traceSocketEvent("zlibInflateWrite",l),this.b.write(l.buffer)}flush(l){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const E=j.$Ec.concat(this.g);this.g.length=0,l(E)})}}class I extends g.$lb{constructor(l,E){super(),this.g=l,this.a=this.B(new S.$ec),this.onError=this.a.event,this.f=[],this.b=(0,A.createDeflateRaw)({windowBits:15}),this.b.on("error",D=>{this.g.traceSocketEvent("zlibDeflateError",{message:D?.message,code:D?.code}),this.a.fire(D)}),this.b.on("data",D=>{this.g.traceSocketEvent("zlibDeflateData",D),this.f.push(j.$Ec.wrap(D))})}write(l){this.g.traceSocketEvent("zlibDeflateWrite",l.buffer),this.b.write(l.buffer)}flush(l){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let E=j.$Ec.concat(this.f);this.f.length=0,E=E.slice(0,E.byteLength-4),l(E)})}}function t(m,l){if(l===0)return;const E=m.byteLength>>>2;for(let Z=0;Z<E;Z++){const J=m.readUInt32BE(Z*4);m.writeUInt32BE(J^l,Z*4)}const D=E*4,T=m.byteLength-D,M=l>>>24&255,F=l>>>16&255,V=l>>>8&255;T>=1&&m.writeUInt8(m.readUInt8(D)^M,D),T>=2&&m.writeUInt8(m.readUInt8(D+1)^F,D+1),T>=3&&m.writeUInt8(m.readUInt8(D+2)^V,D+2)}e.$gh=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function s(){const m=(0,$.$3e)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${m}-sock`;const l=process.platform!=="darwin"&&e.$gh?e.$gh:(0,O.tmpdir)(),E=(0,C.$8c)(l,`vscode-ipc-${m}.sock`);return i(E),E}e.$hh=s;function n(m,l,E){const D=(0,L.createHash)("md5").update(m).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${D}-${E}-${l}-sock`;const T=E.substr(0,4),M=l.substr(0,6),F=D.substr(0,8);let V;return process.platform!=="darwin"&&e.$gh&&!process.env.VSCODE_PORTABLE?V=(0,C.$8c)(e.$gh,`vscode-${F}-${T}-${M}.sock`):V=(0,C.$8c)(m,`${T}-${M}.sock`),i(V),V}e.$ih=n;function i(m){const l=o[y.$t];typeof l=="number"&&m.length>=l&&console.warn(`WARNING: IPC handle "${m}" is longer than ${l} chars, try a shorter --user-data-dir`)}class r extends u.$6g{static b(l){const E=S.Event.fromNodeEventEmitter(l,"connection");return S.Event.map(E,D=>({protocol:new d.$ah(new p(D,"ipc-server-connection")),onDidClientDisconnect:S.Event.once(S.Event.fromNodeEventEmitter(D,"close"))}))}constructor(l){super(r.b(l)),this.d=l}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$jh=r;function a(m){return new Promise((l,E)=>{const D=(0,N.createServer)();D.on("error",E),D.listen(m,()=>{D.removeListener("error",E),l(new r(D))})})}e.$kh=a;function v(m,l){return new Promise((E,D)=>{const T=(0,N.createConnection)(m,()=>{T.removeListener("error",D),E(d.$bh.fromSocket(new p(T,`ipc-client${l}`),l))});T.once("error",D)})}e.$lh=v}),define(ce[264],le([0,1,61,123,208]),function(ie,e,L,N,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C7b=void 0,e.$C7b=new class{supports(A){return!0}connect({host:A,port:j},R,S,g){return new Promise((C,y)=>{const $=L.createConnection({host:A,port:j},()=>{$.removeListener("error",y),$.write((0,O.$Wjb)(R,S,g));const u=d=>{d.toString().indexOf(`\r
\r
`)>=0&&($.off("data",u),C(new N.$eh($,g)))};$.on("data",u)});$.setNoDelay(!0),$.once("error",y)})}}}),define(ce[265],le([0,1,61,36,132,123,5,2,6,18,7,23,211,104,106,76,14]),function(ie,e,L,N,O,A,j,R,S,g,C,y,$,u,d,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y6b=e.$x6b=e.$w6b=e.$v6b=void 0;async function h(t,o,s,n,i){let r;for(let a=3;a&&(r?.dispose(),r=await new f(t,o,s,n,i).waitForReady(),!(i&&O.$6e[i]||!O.$6e[r.tunnelLocalPort]));a--);return r}class f extends R.$lb{constructor(o,s,n,i,r){super(),this.j=s,this.k=r,this.privacy=p.TunnelPrivacyId.Private,this.i=new Map,this.a=o,this.b=L.createServer(),this.c=new j.$tg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=a=>this.l(a),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=i,this.tunnelRemoteHost=n}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.i.values()).forEach(s=>{s()})}async waitForReady(){const o=this.k??this.tunnelRemotePort,s=(0,p.$Sz)(this.j)?"0.0.0.0":"127.0.0.1";let n=await(0,O.$7e)(o,2,1e3,s),i=null;return this.b.listen(n,this.j),await this.c.wait(),i=this.b.address(),i||(n=0,this.b.listen(n,this.j),await this.c.wait(),i=this.b.address()),this.tunnelLocalPort=i.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${i.port}`,this}async l(o){o.pause();const s=(0,p.$Qz)(this.tunnelRemoteHost)||(0,p.$Sz)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,n=await(0,$.$Mk)(this.a,s,this.tunnelRemotePort),i=n.getSocket(),r=n.readEntireBuffer();n.dispose(),r.byteLength>0&&o.write(r.buffer),o.on("end",()=>{o.localAddress&&this.i.delete(o.localAddress),i.end()}),o.on("close",()=>i.end()),o.on("error",()=>{o.localAddress&&this.i.delete(o.localAddress),i instanceof A.$eh?i.socket.destroy():i.end()}),i instanceof A.$eh?this.n(o,i):this.m(o,i),o.localAddress&&this.i.set(o.localAddress,()=>{o.end(),i.end()})}m(o,s){s.onClose(()=>o.destroy()),s.onEnd(()=>o.end()),s.onData(n=>o.write(n.buffer)),o.on("data",n=>s.write(c.$Ec.wrap(n))),o.resume()}n(o,s){const n=s.socket;n.on("end",()=>o.end()),n.on("close",()=>o.end()),n.on("error",()=>{o.destroy()}),n.pipe(o),o.pipe(n)}}e.$v6b=f;let b=class extends p.$Vz{constructor(o,s,n,i,r){super(s,r),this.u=o,this.v=n,this.w=i}isPortPrivileged(o){return(0,p.$Tz)(o,this.l,S.OS,N.release())}s(o,s,n,i,r,a,v,m){const l=this.r(s,n);if(l)return++l.refcount,l.value;if((0,p.$Nz)(o))return this.t(o,s,n,r,a,v,m);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${s}:${n} on local port ${r}.`);const E={commit:this.w.commit,quality:this.w.quality,addressProvider:o,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},D=h(E,i,s,n,r);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(s,n,D),D}}};e.$w6b=b,e.$w6b=b=ye([K(0,u.$Gk),K(1,C.$Ri),K(2,d.$Jk),K(3,y.$0i),K(4,g.$Vh)],b);let w=class extends b{constructor(o,s,n,i,r){super(o,s,n,i,r)}};e.$x6b=w,e.$x6b=w=ye([K(0,u.$Gk),K(1,C.$Ri),K(2,d.$Jk),K(3,y.$0i),K(4,g.$Vh)],w);let I=class extends R.$lb{constructor(o,s,n,i,r){super(),this.b=o,this.c=s,this.f=n,this.g=i,this.h=r,this.a=new Map}async openTunnel(o,s,n,i,r,a,v,m,l){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${n}:${i} on local port ${a}.`),!this.a.has(o)){const E=new w(this.b,this.c,this.g,this.f,this.h);this.B(E),this.a.set(o,E),E.onTunnelClosed(async()=>{(await E.tunnels).length===0&&(E.dispose(),this.a.delete(o))})}return this.a.get(o).openTunnel(s,n,i,r,a,v,m,l)}};e.$y6b=I,e.$y6b=I=ye([K(0,u.$Gk),K(1,C.$Ri),K(2,y.$0i),K(3,d.$Jk),K(4,g.$Vh)],I)}),define(ce[274],le([0,1,36,38,8,2,26,10,20,3,43,145,202,203,194,195,260,185,187,18,207,95,218,96,213,15,114,245,29,97,186,122,98,13,197,198,68,4,193,70,72,223,7,199,102,23,57,19,107,21,108,109,110,46,226,80,111,24,78,251,236,237,81,252,255,256,257,58,250,239,106,217,76,265,212,227,27,228,6,229,188,205,204,79,244,17,50,201,56,249,225,240,105,254,263,9,200,101,247,243,214,182,55,258,246,71,248,104,264,180,112,238,215]),function(ie,e,L,N,O,A,j,R,S,g,C,y,$,u,d,p,c,h,f,b,w,I,t,o,s,n,i,r,a,v,m,l,E,D,T,M,F,V,Z,J,Q,G,X,W,q,B,_,oe,ae,Y,U,k,P,z,H,ee,ne,fe,x,se,te,ue,de,we,Ee,Le,je,Me,he,ge,be,Se,Pe,Ue,Oe,Fe,Te,re,$e,me,pe,ke,Re,Ce,Ie,Ae,De,Ne,Be,qe,Ve,xe,ht,pt,vt,Et,kt,ut,St,Ct,Pt,Rt,It,Lt,jt,ft,At,dt,Ot,Dt,$t,Nt,tt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Tt extends A.$lb{constructor(ve){super(),this.f=ve,this.a=this.B(new y.$JS(this)),this.b=void 0,this.c=this.B(new g.$ec),this.g()}g(){let ve=!1;const ze=()=>{ve||(ve=!0,this.b?.fireOnWillShutdown(),this.dispose())};process.once("exit",ze),(0,y.$KS)(process.parentPort,tt.$L5b.exit,ze)}async init(){const ve=await this.h();(0,fe.$Vfb)(),ve.invokeFunction(ze=>{const Ye=ze.get(X.$Ri);Ye.trace("sharedProcess configuration",JSON.stringify(this.f)),this.i(ze),this.j(Ye)}),this.B((0,A.$ib)(ve.createInstance($.$26b,this.f.codeCachePath),ve.createInstance(u.$36b),ve.createInstance(c.$66b),ve.createInstance(p.$56b),ve.createInstance(d.$46b),ve.createInstance(vt.$t7b),ve.createInstance(xe.$l7b),ve.createInstance(Nt.$F7b,this.c.event)))}async h(){const ve=new J.$nh,ze={_serviceBrand:void 0,...q.default};ve.set(B.$0i,ze);const Ye=new C.$0g(We=>We==="main"),He=new ft.$F6b(this.a,Ye);ve.set(ft.$E6b,He);const nt=this.f.policiesData?new Ne.$e6b(this.f.policiesData,He.getChannel("policy")):new Be.$Ym;ve.set(Be.$Wm,nt);const Ge=new Dt.$Yl(this.f.args,ze);ve.set(n.$xh,Ge);const Ze=new W.$Rq(void 0,this.f.logLevel,Ge.logsHome,this.f.loggers.map(We=>({...We,resource:R.URI.revive(We.resource)})),He.getChannel("logger"));ve.set(X.$Si,Ze);const st=this.B(Ze.createLogger("sharedprocess",{name:(0,Et.localize)(0,null)})),at=this.B(new X.$Zi(st.getLevel())),Je=this.B(new kt.$9M(st,[at]));ve.set(X.$Ri,Je),this.b=this.B(new ut.$v7b(Je)),ve.set(ut.$u7b,this.b);const Ke=this.B(new T.$up(Je));ve.set(D.$Sj,Ke);const ct=this.B(new M.$Tp(Je));Ke.registerProvider(j.Schemas.file,ct);const lt=this.B(new me.$D6b(j.Schemas.file,this.B(new pe.$RM(He.getChannel(pe.$QM),{pathCaseSensitive:$e.$k})),j.Schemas.vscodeUserData,Je));Ke.registerProvider(j.Schemas.vscodeUserData,lt);const Qe=this.B(new qe.$dN(this.f.profiles.all,R.URI.revive(this.f.profiles.home).with({scheme:Ge.userRoamingDataHome.scheme}),He.getChannel("userDataProfiles")));ve.set(Ae.$rk,Qe);const Xe=this.B(new w.$mn(Qe.defaultProfile.settingsResource,Ke,nt,Je));ve.set(b.$Vh,Xe);const _e=new At.$B7b(void 0,{defaultProfile:Qe.defaultProfile,currentProfile:Qe.defaultProfile},He,Ge);ve.set(oe.$Mo,_e),this.B((0,A.$jb)(()=>_e.flush())),await Promise.all([Xe.initialize(),_e.initialize()]);const Mt=new re.$gr(Ke);ve.set(Te.$pk,Mt);const mt=new Pt.$Dq(He.getChannel("request"));ve.set(_.$Ao,mt),ve.set(h.$76b,new F.$mh(f.$86b,void 0,!1)),ve.set(Re.$qF,new F.$mh(ke.$k7b,void 0,!1));const bt=C.ProxyChannel.toService(He.getChannel("nativeHost"));ve.set(It.$m5b,bt),ve.set(o.$vn,new F.$mh(s.$lN,void 0,!0));const zt=this.B(new ge.$a6b(bt)),Ft=new C.$0g(We=>zt.getActiveClientId().then(ot=>We===ot));ve.set(E.$2Tb,new Rt.$x7b(this.a.getChannel("extensionRecommendationNotification",Ft)));let rt;const et=[],wt=(0,z.$eo)(ze,Xe);if((0,z.$_n)(ze,Ge)){const We=new k.$h3b(Je,Ze,Ge,ze);if(et.push(We),ze.aiConfig?.ariaKey){const ot=new Ve.$WM(mt,wt,"monacoworkbench",null,ze.aiConfig.ariaKey);this.B((0,A.$jb)(()=>ot.flush())),et.push(ot)}rt=new P.$Hq({appenders:et,commonProperties:(0,ae.$2n)((0,L.release)(),(0,L.hostname)(),process.arch,ze.commit,ze.version,this.f.machineId,wt),sendErrorTelemetry:!0,piiPaths:(0,z.$fo)(Ge)},Xe,ze)}else{rt=z.$6n;const We=z.$0n;et.push(We)}this.a.registerChannel("telemetryAppender",new U.$Q5b(et)),ve.set(Y.$Vk,rt);const Ut=new H.$96b(Xe,rt,Je,Ze,Ge,ze);ve.set(Y.$Wk,Ut),ve.set(De.$bp,new F.$mh(Ct.$8M,void 0,!0)),ve.set(Ce.$fp,new F.$mh(Ie.$f6b,void 0,!0)),ve.set(v.$Xo,new F.$mh(v.$Yo,void 0,!0)),ve.set(l.$pp,new F.$mh(l.$qp,void 0,!0)),ve.set(a.$Rn,new F.$mh(r.$Vo,void 0,!0)),ve.set(a.$Xn,new F.$mh(jt.$A7b,void 0,!1)),ve.set(Q.$zq,new F.$mh(G.$Bq,void 0,!1)),ve.set(I.$6l,new F.$mh(t.$nr,void 0,!1)),ve.set(x.$5yb,new F.$mh(x.$6yb,void 0,!0)),ve.set(fe.$egb,new F.$mh(ue.$eBb,void 0,!0)),ve.set(fe.$dgb,new te.$_6b(this.a.getChannel("userDataSyncUtil",We=>We.ctx!=="main"))),ve.set(a.$Wn,new F.$mh(i.$3yb,void 0,!1)),ve.set(ne.$cBb,new F.$mh(ne.$dBb,void 0,!0)),ve.set(ee.$Iz,new F.$mh(ee.$Jz)),ve.set(fe.$1fb,new F.$mh(je.$nAb,void 0,!0)),ve.set(fe.$2fb,new F.$mh(je.$pAb,void 0,!0)),ve.set(de.$UYb,new F.$mh(de.$WYb,void 0,!0)),ve.set(fe.$3fb,new F.$mh(se.$V3b,void 0,!1)),ve.set(fe.$_fb,new F.$mh(we.$K3b,void 0,!0)),ve.set(fe.$agb,new F.$mh(Ee.$13b,void 0,!1)),ve.set(Me.$Ezb,new F.$mh(he.$g7b,void 0,!0)),ve.set(fe.$bgb,new F.$mh(pt.$A4b,void 0,!0)),ve.set(be.$Jk,new F.$mh(Se.$A6b,void 0,!1));const yt=new dt.$Hk;return ve.set(dt.$Gk,yt),yt.register(0,Ot.$C7b),ve.set(Pe.$Mz,new F.$mh(Ue.$y6b)),ve.set(Oe.$h7b,new F.$mh(Fe.$j7b)),ve.set(ht.$m7b,new F.$mh(St.$w7b)),ve.set($t.$D7b,new F.$mh($t.$E7b)),new Z.$Wp(ve)}i(ve){const ze=new m.$1o(ve.get(a.$Tn),()=>null);this.a.registerChannel("extensions",ze);const Ye=C.ProxyChannel.fromService(ve.get(Q.$zq));this.a.registerChannel("languagePacks",Ye);const He=C.ProxyChannel.fromService(ve.get(I.$6l));this.a.registerChannel("diagnostics",He);const nt=new m.$3o(ve.get(a.$Xn));this.a.registerChannel("extensionTipsService",nt);const Ge=C.ProxyChannel.fromService(ve.get(h.$76b));this.a.registerChannel("checksum",Ge);const Ze=C.ProxyChannel.fromService(ve.get(Re.$qF));this.a.registerChannel("v8InspectProfiling",Ze);const st=new te.$a7b(ve.get(de.$UYb));this.a.registerChannel("userDataSyncMachines",st);const at=C.ProxyChannel.fromService(ve.get(Y.$Wk));this.a.registerChannel("customEndpointTelemetry",at);const Je=new te.$b7b(ve.get(x.$5yb));this.a.registerChannel("userDataSyncAccount",Je);const Ke=new te.$c7b(ve.get(fe.$1fb));this.a.registerChannel("userDataSyncStoreManagement",Ke);const ct=new Le.$e7b(ve.get(fe.$agb),ve.get(Ae.$rk),ve.get(X.$Ri));this.a.registerChannel("userDataSync",ct);const lt=this.B(ve.get(V.$oh).createInstance(Lt.$z7b)),Qe=new te.$06b(lt);this.a.registerChannel("userDataAutoSync",Qe);const Xe=C.ProxyChannel.fromService(ve.get(Oe.$h7b));this.a.registerChannel(Oe.$i7b,Xe);const _e=C.ProxyChannel.fromService(ve.get(ht.$m7b));this.a.registerChannel("remoteTunnel",_e)}j(ve){process.on("uncaughtException",ze=>(0,O.$Y)(ze)),process.on("unhandledRejection",ze=>(0,O.$Y)(ze)),(0,O.setUnexpectedErrorHandler)(ze=>{const Ye=(0,N.$ai)(ze,!0);Ye&&ve.error(`[uncaught exception in sharedProcess]: ${Ye}`)})}handledClientConnection(ve){if(ve.data!==tt.$N5b.response)return!1;const ze=(0,S.$sf)(ve.ports);return ze?(this.c.fire(ze),!0):!1}}async function gt(it){const ve=new Tt(it);process.parentPort.postMessage(tt.$L5b.ipcReady),await ve.init(),process.parentPort.postMessage(tt.$L5b.initDone)}e.main=gt,process.parentPort.once("message",it=>{gt(it.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/abd2f3db4bdb28f9e95536dfa84d8479f1eb312d/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
