/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Pe=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/network","vs/base/common/async","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/platform/extensions/common/extensions","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/resources","vs/base/common/objects","vs/base/common/buffer","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/base/common/themables","vs/base/common/errorMessage","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/editor/common/core/range","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/base/common/process","vs/platform/telemetry/common/telemetryUtils","vs/platform/workspace/common/workspace","vs/workbench/api/common/cache","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/base/common/stopwatch","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/lazy","vs/base/common/iterator","vs/base/common/mime","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/editor/common/languages","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/base/common/collections","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatSlashCommand","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Ae=function(pe){for(var e=[],y=0,R=pe.length;y<R;y++)e[y]=Pe[pe[y]];return e};define(Pe[65],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vg=e.$Ug=e.$Tg=void 0;function y(A){return(d,k,f)=>{let P=null,D=null;if(typeof f.value=="function"?(P="value",D=f.value):typeof f.get=="function"&&(P="get",D=f.get),!D)throw new Error("not supported");f[P]=A(D,k)}}function R(A,d,k){let f=null,P=null;if(typeof k.value=="function"?(f="value",P=k.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof k.get=="function"&&(f="get",P=k.get),!P)throw new Error("not supported");const D=`$memoize$${d}`;k[f]=function(...u){return this.hasOwnProperty(D)||Object.defineProperty(this,D,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,u)}),this[D]}}e.$Tg=R;function I(A,d,k){return y((f,P)=>{const D=`$debounce$${P}`,u=`$debounce$result$${P}`;return function(...b){this[u]||(this[u]=k?k():void 0),clearTimeout(this[D]),d&&(this[u]=d(this[u],...b),b=[this[u]]),this[D]=setTimeout(()=>{f.apply(this,b),this[u]=k?k():void 0},A)}})}e.$Ug=I;function M(A,d,k){return y((f,P)=>{const D=`$throttle$timer$${P}`,u=`$throttle$result$${P}`,b=`$throttle$lastRun$${P}`,p=`$throttle$pending$${P}`;return function(...h){if(this[u]||(this[u]=k?k():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),d&&(this[u]=d(this[u],...h)),this[p])return;const t=this[b]+A;t<=Date.now()?(this[b]=Date.now(),f.apply(this,[this[u]]),this[u]=k?k():void 0):(this[p]=!0,this[D]=setTimeout(()=>{this[p]=!1,this[b]=Date.now(),f.apply(this,[this[u]]),this[u]=k?k():void 0},t-Date.now()))}})}e.$Vg=M}),define(Pe[88],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RL=e.$QL=void 0;class y{constructor(I){this.a=I,this.b=0}nextId(){return this.a+ ++this.b}}e.$QL=y,e.$RL=new y("id#")}),define(Pe[116],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=e.$Gm=e.$Fm=e.$Em=e.$Dm=e.$Cm=e.$Bm=e.$Am=e.$zm=e.$ym=e.$xm=e.$wm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var y;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(y||(e.ScanError=y={}));var R;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(R||(e.SyntaxKind=R={}));var I;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(I||(e.ParseErrorCode=I={}));var M;(function(n){n.DEFAULT={allowTrailingComma:!0}})(M||(e.ParseOptions=M={}));function A(n,a=!1){let r=0;const s=n.length;let v="",$=0,w=16,E=0;function o(j){let U=0,z=0;for(;U<j;){const ne=n.charCodeAt(r);if(ne>=48&&ne<=57)z=z*16+ne-48;else if(ne>=65&&ne<=70)z=z*16+ne-65+10;else if(ne>=97&&ne<=102)z=z*16+ne-97+10;else break;r++,U++}return U<j&&(z=-1),z}function l(j){r=j,v="",$=0,w=16,E=0}function m(){const j=r;if(n.charCodeAt(r)===48)r++;else for(r++;r<n.length&&f(n.charCodeAt(r));)r++;if(r<n.length&&n.charCodeAt(r)===46)if(r++,r<n.length&&f(n.charCodeAt(r)))for(r++;r<n.length&&f(n.charCodeAt(r));)r++;else return E=3,n.substring(j,r);let U=r;if(r<n.length&&(n.charCodeAt(r)===69||n.charCodeAt(r)===101))if(r++,(r<n.length&&n.charCodeAt(r)===43||n.charCodeAt(r)===45)&&r++,r<n.length&&f(n.charCodeAt(r))){for(r++;r<n.length&&f(n.charCodeAt(r));)r++;U=r}else E=3;return n.substring(j,U)}function F(){let j="",U=r;for(;;){if(r>=s){j+=n.substring(U,r),E=2;break}const z=n.charCodeAt(r);if(z===34){j+=n.substring(U,r),r++;break}if(z===92){if(j+=n.substring(U,r),r++,r>=s){E=2;break}switch(n.charCodeAt(r++)){case 34:j+='"';break;case 92:j+="\\";break;case 47:j+="/";break;case 98:j+="\b";break;case 102:j+="\f";break;case 110:j+=`
`;break;case 114:j+="\r";break;case 116:j+="	";break;case 117:{const Z=o(4);Z>=0?j+=String.fromCharCode(Z):E=4;break}default:E=5}U=r;continue}if(z>=0&&z<=31)if(k(z)){j+=n.substring(U,r),E=2;break}else E=6;r++}return j}function W(){if(v="",E=0,$=r,r>=s)return $=s,w=17;let j=n.charCodeAt(r);if(d(j)){do r++,v+=String.fromCharCode(j),j=n.charCodeAt(r);while(d(j));return w=15}if(k(j))return r++,v+=String.fromCharCode(j),j===13&&n.charCodeAt(r)===10&&(r++,v+=`
`),w=14;switch(j){case 123:return r++,w=1;case 125:return r++,w=2;case 91:return r++,w=3;case 93:return r++,w=4;case 58:return r++,w=6;case 44:return r++,w=5;case 34:return r++,v=F(),w=10;case 47:{const U=r-1;if(n.charCodeAt(r+1)===47){for(r+=2;r<s&&!k(n.charCodeAt(r));)r++;return v=n.substring(U,r),w=12}if(n.charCodeAt(r+1)===42){r+=2;const z=s-1;let ne=!1;for(;r<z;){if(n.charCodeAt(r)===42&&n.charCodeAt(r+1)===47){r+=2,ne=!0;break}r++}return ne||(r++,E=1),v=n.substring(U,r),w=13}return v+=String.fromCharCode(j),r++,w=16}case 45:if(v+=String.fromCharCode(j),r++,r===s||!f(n.charCodeAt(r)))return w=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return v+=m(),w=11;default:for(;r<s&&V(j);)r++,j=n.charCodeAt(r);if($!==r){switch(v=n.substring($,r),v){case"true":return w=8;case"false":return w=9;case"null":return w=7}return w=16}return v+=String.fromCharCode(j),r++,w=16}}function V(j){if(d(j)||k(j))return!1;switch(j){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function B(){let j;do j=W();while(j>=12&&j<=15);return j}return{setPosition:l,getPosition:()=>r,scan:a?B:W,getToken:()=>w,getTokenValue:()=>v,getTokenOffset:()=>$,getTokenLength:()=>r-$,getTokenError:()=>E}}e.$wm=A;function d(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function k(n){return n===10||n===13||n===8232||n===8233}function f(n){return n>=48&&n<=57}var P;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(P||(P={}));function D(n,a){const r=[],s=new Object;let v;const $={value:{},offset:0,length:0,type:"object",parent:void 0};let w=!1;function E(o,l,m,F){$.value=o,$.offset=l,$.length=m,$.type=F,$.colonOffset=void 0,v=$}try{g(n,{onObjectBegin:(o,l)=>{if(a<=o)throw s;v=void 0,w=a>o,r.push("")},onObjectProperty:(o,l,m)=>{if(a<l||(E(o,l,m,"property"),r[r.length-1]=o,a<=l+m))throw s},onObjectEnd:(o,l)=>{if(a<=o)throw s;v=void 0,r.pop()},onArrayBegin:(o,l)=>{if(a<=o)throw s;v=void 0,r.push(0)},onArrayEnd:(o,l)=>{if(a<=o)throw s;v=void 0,r.pop()},onLiteralValue:(o,l,m)=>{if(a<l||(E(o,l,m,C(o)),a<=l+m))throw s},onSeparator:(o,l,m)=>{if(a<=l)throw s;if(o===":"&&v&&v.type==="property")v.colonOffset=l,w=!1,v=void 0;else if(o===","){const F=r[r.length-1];typeof F=="number"?r[r.length-1]=F+1:(w=!0,r[r.length-1]=""),v=void 0}}})}catch(o){if(o!==s)throw o}return{path:r,previousNode:v,isAtPropertyKey:w,matches:o=>{let l=0;for(let m=0;l<o.length&&m<r.length;m++)if(o[l]===r[m]||o[l]==="*")l++;else if(o[l]!=="**")return!1;return l===o.length}}}e.$xm=D;function u(n,a=[],r=M.DEFAULT){let s=null,v=[];const $=[];function w(o){Array.isArray(v)?v.push(o):s!==null&&(v[s]=o)}return g(n,{onObjectBegin:()=>{const o={};w(o),$.push(v),v=o,s=null},onObjectProperty:o=>{s=o},onObjectEnd:()=>{v=$.pop()},onArrayBegin:()=>{const o=[];w(o),$.push(v),v=o,s=null},onArrayEnd:()=>{v=$.pop()},onLiteralValue:w,onError:(o,l,m)=>{a.push({error:o,offset:l,length:m})}},r),v[0]}e.$ym=u;function b(n,a=[],r=M.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function v(o){s.type==="property"&&(s.length=o-s.offset,s=s.parent)}function $(o){return s.children.push(o),o}g(n,{onObjectBegin:o=>{s=$({type:"object",offset:o,length:-1,parent:s,children:[]})},onObjectProperty:(o,l,m)=>{s=$({type:"property",offset:l,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:o,offset:l,length:m,parent:s})},onObjectEnd:(o,l)=>{s.length=o+l-s.offset,s=s.parent,v(o+l)},onArrayBegin:(o,l)=>{s=$({type:"array",offset:o,length:-1,parent:s,children:[]})},onArrayEnd:(o,l)=>{s.length=o+l-s.offset,s=s.parent,v(o+l)},onLiteralValue:(o,l,m)=>{$({type:C(o),offset:l,length:m,parent:s,value:o}),v(l+m)},onSeparator:(o,l,m)=>{s.type==="property"&&(o===":"?s.colonOffset=l:o===","&&v(l))},onError:(o,l,m)=>{a.push({error:o,offset:l,length:m})}},r);const E=s.children[0];return E&&delete E.parent,E}e.$zm=b;function p(n,a){if(!n)return;let r=n;for(const s of a)if(typeof s=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let v=!1;for(const $ of r.children)if(Array.isArray($.children)&&$.children[0].value===s){r=$.children[1],v=!0;break}if(!v)return}else{const v=s;if(r.type!=="array"||v<0||!Array.isArray(r.children)||v>=r.children.length)return;r=r.children[v]}return r}e.$Am=p;function h(n){if(!n.parent||!n.parent.children)return[];const a=h(n.parent);if(n.parent.type==="property"){const r=n.parent.children[0].value;a.push(r)}else if(n.parent.type==="array"){const r=n.parent.children.indexOf(n);r!==-1&&a.push(r)}return a}e.$Bm=h;function t(n){switch(n.type){case"array":return n.children.map(t);case"object":{const a=Object.create(null);for(const r of n.children){const s=r.children[1];s&&(a[r.children[0].value]=t(s))}return a}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.$Cm=t;function i(n,a,r=!1){return a>=n.offset&&a<n.offset+n.length||r&&a===n.offset+n.length}e.$Dm=i;function c(n,a,r=!1){if(i(n,a,r)){const s=n.children;if(Array.isArray(s))for(let v=0;v<s.length&&s[v].offset<=a;v++){const $=c(s[v],a,r);if($)return $}return n}}e.$Em=c;function g(n,a,r=M.DEFAULT){const s=A(n,!1);function v(Ce){return Ce?()=>Ce(s.getTokenOffset(),s.getTokenLength()):()=>!0}function $(Ce){return Ce?ae=>Ce(ae,s.getTokenOffset(),s.getTokenLength()):()=>!0}const w=v(a.onObjectBegin),E=$(a.onObjectProperty),o=v(a.onObjectEnd),l=v(a.onArrayBegin),m=v(a.onArrayEnd),F=$(a.onLiteralValue),W=$(a.onSeparator),V=v(a.onComment),B=$(a.onError),j=r&&r.disallowComments,U=r&&r.allowTrailingComma;function z(){for(;;){const Ce=s.scan();switch(s.getTokenError()){case 4:ne(14);break;case 5:ne(15);break;case 3:ne(13);break;case 1:j||ne(11);break;case 2:ne(12);break;case 6:ne(16);break}switch(Ce){case 12:case 13:j?ne(10):V();break;case 16:ne(1);break;case 15:case 14:break;default:return Ce}}}function ne(Ce,ae=[],_=[]){if(B(Ce),ae.length+_.length>0){let ue=s.getToken();for(;ue!==17;){if(ae.indexOf(ue)!==-1){z();break}else if(_.indexOf(ue)!==-1)break;ue=z()}}}function Z(Ce){const ae=s.getTokenValue();return Ce?F(ae):E(ae),z(),!0}function we(){switch(s.getToken()){case 11:{let Ce=0;try{Ce=JSON.parse(s.getTokenValue()),typeof Ce!="number"&&(ne(2),Ce=0)}catch{ne(2)}F(Ce);break}case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return z(),!0}function Ee(){return s.getToken()!==10?(ne(3,[],[2,5]),!1):(Z(!1),s.getToken()===6?(W(":"),z(),de()||ne(4,[],[2,5])):ne(5,[],[2,5]),!0)}function Re(){w(),z();let Ce=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(Ce||ne(4,[],[]),W(","),z(),s.getToken()===2&&U)break}else Ce&&ne(6,[],[]);Ee()||ne(4,[],[2,5]),Ce=!0}return o(),s.getToken()!==2?ne(7,[2],[]):z(),!0}function X(){l(),z();let Ce=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(Ce||ne(4,[],[]),W(","),z(),s.getToken()===4&&U)break}else Ce&&ne(6,[],[]);de()||ne(4,[],[4,5]),Ce=!0}return m(),s.getToken()!==4?ne(8,[4],[]):z(),!0}function de(){switch(s.getToken()){case 3:return X();case 1:return Re();case 10:return Z(!0);default:return we()}}return z(),s.getToken()===17?r.allowEmptyContent?!0:(ne(4,[],[]),!1):de()?(s.getToken()!==17&&ne(9,[],[]),!0):(ne(4,[],[]),!1)}e.$Fm=g;function S(n,a){const r=A(n),s=[];let v,$=0,w;do switch(w=r.getPosition(),v=r.scan(),v){case 12:case 13:case 17:$!==w&&s.push(n.substring($,w)),a!==void 0&&s.push(r.getTokenValue().replace(/[^\r\n]/g,a)),$=r.getPosition();break}while(v!==17);return s.join("")}e.$Gm=S;function C(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.$Hm=C}),define(Pe[28],Ae([1,0]),function(pe,e){"use strict";var y,R,I;Object.defineProperty(e,"__esModule",{value:!0}),e.$ri=e.$qi=e.$pi=e.Touch=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=void 0;function M(h,t,i){let c=h.get(t);return c===void 0&&(c=i,h.set(t,c)),c}e.$ki=M;function A(h){const t=[];return h.forEach((i,c)=>{t.push(`${c} => ${i}`)}),`Map(${h.size}) {${t.join(", ")}}`}e.$li=A;function d(h){const t=[];return h.forEach(i=>{t.push(i)}),`Set(${h.size}) {${t.join(", ")}}`}e.$mi=d;class k{constructor(t,i){this.uri=t,this.value=i}}class f{static{this.a=t=>t.toString()}constructor(t,i){this[y]="ResourceMap",t instanceof f?(this.b=new Map(t.b),this.c=i??f.a):(this.b=new Map,this.c=t??f.a)}set(t,i){return this.b.set(this.c(t),new k(t,i)),this}get(t){return this.b.get(this.c(t))?.value}has(t){return this.b.has(this.c(t))}get size(){return this.b.size}clear(){this.b.clear()}delete(t){return this.b.delete(this.c(t))}forEach(t,i){typeof i<"u"&&(t=t.bind(i));for(const[c,g]of this.b)t(g.value,g.uri,this)}*values(){for(const t of this.b.values())yield t.value}*keys(){for(const t of this.b.values())yield t.uri}*entries(){for(const t of this.b.values())yield[t.uri,t.value]}*[(y=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.b)yield[t.uri,t.value]}}e.$ni=f;class P{constructor(t,i){this[R]="ResourceSet",!t||typeof t=="function"?this.a=new f(t):(this.a=new f(i),t.forEach(this.add,this))}get size(){return this.a.size}add(t){return this.a.set(t,t),this}clear(){this.a.clear()}delete(t){return this.a.delete(t)}forEach(t,i){this.a.forEach((c,g)=>t.call(i,g,g,this))}has(t){return this.a.has(t)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$oi=P;var D;(function(h){h[h.None=0]="None",h[h.AsOld=1]="AsOld",h[h.AsNew=2]="AsNew"})(D||(e.Touch=D={}));class u{constructor(){this[I]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(t){return this.a.has(t)}get(t,i=0){const c=this.a.get(t);if(c)return i!==0&&this.j(c,i),c.value}set(t,i,c=0){let g=this.a.get(t);if(g)g.value=i,c!==0&&this.j(g,c);else{switch(g={key:t,value:i,next:void 0,previous:void 0},c){case 0:this.h(g);break;case 1:this.g(g);break;case 2:this.h(g);break;default:this.h(g);break}this.a.set(t,g),this.d++}return this}delete(t){return!!this.remove(t)}remove(t){const i=this.a.get(t);if(i)return this.a.delete(t),this.i(i),this.d--,i.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const t=this.b;return this.a.delete(t.key),this.i(t),this.d--,t.value}forEach(t,i){const c=this.e;let g=this.b;for(;g;){if(i?t.bind(i)(g.value,g.key,this):t(g.value,g.key,this),this.e!==c)throw new Error("LinkedMap got modified during iteration.");g=g.next}}keys(){const t=this,i=this.e;let c=this.b;const g={[Symbol.iterator](){return g},next(){if(t.e!==i)throw new Error("LinkedMap got modified during iteration.");if(c){const S={value:c.key,done:!1};return c=c.next,S}else return{value:void 0,done:!0}}};return g}values(){const t=this,i=this.e;let c=this.b;const g={[Symbol.iterator](){return g},next(){if(t.e!==i)throw new Error("LinkedMap got modified during iteration.");if(c){const S={value:c.value,done:!1};return c=c.next,S}else return{value:void 0,done:!0}}};return g}entries(){const t=this,i=this.e;let c=this.b;const g={[Symbol.iterator](){return g},next(){if(t.e!==i)throw new Error("LinkedMap got modified during iteration.");if(c){const S={value:[c.key,c.value],done:!1};return c=c.next,S}else return{value:void 0,done:!0}}};return g}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(t){if(t>=this.size)return;if(t===0){this.clear();return}let i=this.b,c=this.size;for(;i&&c>t;)this.a.delete(i.key),i=i.next,c--;this.b=i,this.d=c,i&&(i.previous=void 0),this.e++}g(t){if(!this.b&&!this.c)this.c=t;else if(this.b)t.next=this.b,this.b.previous=t;else throw new Error("Invalid list");this.b=t,this.e++}h(t){if(!this.b&&!this.c)this.b=t;else if(this.c)t.previous=this.c,this.c.next=t;else throw new Error("Invalid list");this.c=t,this.e++}i(t){if(t===this.b&&t===this.c)this.b=void 0,this.c=void 0;else if(t===this.b){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this.b=t.next}else if(t===this.c){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this.c=t.previous}else{const i=t.next,c=t.previous;if(!i||!c)throw new Error("Invalid list");i.previous=c,c.next=i}t.next=void 0,t.previous=void 0,this.e++}j(t,i){if(!this.b||!this.c)throw new Error("Invalid list");if(!(i!==1&&i!==2)){if(i===1){if(t===this.b)return;const c=t.next,g=t.previous;t===this.c?(g.next=void 0,this.c=g):(c.previous=g,g.next=c),t.previous=void 0,t.next=this.b,this.b.previous=t,this.b=t,this.e++}else if(i===2){if(t===this.c)return;const c=t.next,g=t.previous;t===this.b?(c.previous=void 0,this.b=c):(c.previous=g,g.next=c),t.next=void 0,t.previous=this.c,this.c.next=t,this.c=t,this.e++}}}toJSON(){const t=[];return this.forEach((i,c)=>{t.push([c,i])}),t}fromJSON(t){this.clear();for(const[i,c]of t)this.set(i,c)}}e.$pi=u;class b extends u{constructor(t,i=1){super(),this.k=t,this.l=Math.min(Math.max(0,i),1)}get limit(){return this.k}set limit(t){this.k=t,this.m()}get ratio(){return this.l}set ratio(t){this.l=Math.min(Math.max(0,t),1),this.m()}get(t,i=2){return super.get(t,i)}peek(t){return super.get(t,0)}set(t,i){return super.set(t,i,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$qi=b;class p{constructor(){this.a=new Map}add(t){return this.a.set(t,(this.a.get(t)||0)+1),this}delete(t){let i=this.a.get(t)||0;return i===0?!1:(i--,i===0?this.a.delete(t):this.a.set(t,i),!0)}has(t){return this.a.has(t)}}e.$ri=p}),function(pe,e){typeof define=="function"&&define.amd?define(Pe[117],Ae([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(pe=typeof globalThis<"u"?globalThis:pe||self,e(pe.marked={}))}(this,function(pe){"use strict";function e(ve,be){for(var ke=0;ke<be.length;ke++){var oe=be[ke];oe.enumerable=oe.enumerable||!1,oe.configurable=!0,"value"in oe&&(oe.writable=!0),Object.defineProperty(ve,oe.key,oe)}}function y(ve,be,ke){return be&&e(ve.prototype,be),ke&&e(ve,ke),Object.defineProperty(ve,"prototype",{writable:!1}),ve}function R(ve,be){if(ve){if(typeof ve=="string")return I(ve,be);var ke=Object.prototype.toString.call(ve).slice(8,-1);if(ke==="Object"&&ve.constructor&&(ke=ve.constructor.name),ke==="Map"||ke==="Set")return Array.from(ve);if(ke==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ke))return I(ve,be)}}function I(ve,be){(be==null||be>ve.length)&&(be=ve.length);for(var ke=0,oe=new Array(be);ke<be;ke++)oe[ke]=ve[ke];return oe}function M(ve,be){var ke=typeof Symbol<"u"&&ve[Symbol.iterator]||ve["@@iterator"];if(ke)return(ke=ke.call(ve)).next.bind(ke);if(Array.isArray(ve)||(ke=R(ve))||be&&ve&&typeof ve.length=="number"){ke&&(ve=ke);var oe=0;return function(){return oe>=ve.length?{done:!0}:{done:!1,value:ve[oe++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}pe.defaults=A();function d(ve){pe.defaults=ve}var k=/[&<>"']/,f=/[&<>"']/g,P=/[<>"']|&(?!#?\w+;)/,D=/[<>"']|&(?!#?\w+;)/g,u={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},b=function(be){return u[be]};function p(ve,be){if(be){if(k.test(ve))return ve.replace(f,b)}else if(P.test(ve))return ve.replace(D,b);return ve}var h=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function t(ve){return ve.replace(h,function(be,ke){return ke=ke.toLowerCase(),ke==="colon"?":":ke.charAt(0)==="#"?ke.charAt(1)==="x"?String.fromCharCode(parseInt(ke.substring(2),16)):String.fromCharCode(+ke.substring(1)):""})}var i=/(^|[^\[])\^/g;function c(ve,be){ve=typeof ve=="string"?ve:ve.source,be=be||"";var ke={replace:function(he,re){return re=re.source||re,re=re.replace(i,"$1"),ve=ve.replace(he,re),ke},getRegex:function(){return new RegExp(ve,be)}};return ke}var g=/[^\w:]/g,S=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function C(ve,be,ke){if(ve){var oe;try{oe=decodeURIComponent(t(ke)).replace(g,"").toLowerCase()}catch{return null}if(oe.indexOf("javascript:")===0||oe.indexOf("vbscript:")===0||oe.indexOf("data:")===0)return null}be&&!S.test(ke)&&(ke=v(be,ke));try{ke=encodeURI(ke).replace(/%25/g,"%")}catch{return null}return ke}var n={},a=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function v(ve,be){n[" "+ve]||(a.test(ve)?n[" "+ve]=ve+"/":n[" "+ve]=o(ve,"/",!0)),ve=n[" "+ve];var ke=ve.indexOf(":")===-1;return be.substring(0,2)==="//"?ke?be:ve.replace(r,"$1")+be:be.charAt(0)==="/"?ke?be:ve.replace(s,"$1")+be:ve+be}var $={exec:function(){}};function w(ve){for(var be=1,ke,oe;be<arguments.length;be++){ke=arguments[be];for(oe in ke)Object.prototype.hasOwnProperty.call(ke,oe)&&(ve[oe]=ke[oe])}return ve}function E(ve,be){var ke=ve.replace(/\|/g,function(re,ie,ge){for(var Se=!1,L=ie;--L>=0&&ge[L]==="\\";)Se=!Se;return Se?"|":" |"}),oe=ke.split(/ \|/),he=0;if(oe[0].trim()||oe.shift(),oe.length>0&&!oe[oe.length-1].trim()&&oe.pop(),oe.length>be)oe.splice(be);else for(;oe.length<be;)oe.push("");for(;he<oe.length;he++)oe[he]=oe[he].trim().replace(/\\\|/g,"|");return oe}function o(ve,be,ke){var oe=ve.length;if(oe===0)return"";for(var he=0;he<oe;){var re=ve.charAt(oe-he-1);if(re===be&&!ke)he++;else if(re!==be&&ke)he++;else break}return ve.slice(0,oe-he)}function l(ve,be){if(ve.indexOf(be[1])===-1)return-1;for(var ke=ve.length,oe=0,he=0;he<ke;he++)if(ve[he]==="\\")he++;else if(ve[he]===be[0])oe++;else if(ve[he]===be[1]&&(oe--,oe<0))return he;return-1}function m(ve){ve&&ve.sanitize&&!ve.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function F(ve,be){if(be<1)return"";for(var ke="";be>1;)be&1&&(ke+=ve),be>>=1,ve+=ve;return ke+ve}function W(ve,be,ke,oe){var he=be.href,re=be.title?p(be.title):null,ie=ve[1].replace(/\\([\[\]])/g,"$1");if(ve[0].charAt(0)!=="!"){oe.state.inLink=!0;var ge={type:"link",raw:ke,href:he,title:re,text:ie,tokens:oe.inlineTokens(ie)};return oe.state.inLink=!1,ge}return{type:"image",raw:ke,href:he,title:re,text:p(ie)}}function V(ve,be){var ke=ve.match(/^(\s+)(?:```)/);if(ke===null)return be;var oe=ke[1];return be.split(`
`).map(function(he){var re=he.match(/^\s+/);if(re===null)return he;var ie=re[0];return ie.length>=oe.length?he.slice(oe.length):he}).join(`
`)}var B=function(){function ve(ke){this.options=ke||pe.defaults}var be=ve.prototype;return be.space=function(oe){var he=this.rules.block.newline.exec(oe);if(he&&he[0].length>0)return{type:"space",raw:he[0]}},be.code=function(oe){var he=this.rules.block.code.exec(oe);if(he){var re=he[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:he[0],codeBlockStyle:"indented",text:this.options.pedantic?re:o(re,`
`)}}},be.fences=function(oe){var he=this.rules.block.fences.exec(oe);if(he){var re=he[0],ie=V(re,he[3]||"");return{type:"code",raw:re,lang:he[2]?he[2].trim():he[2],text:ie}}},be.heading=function(oe){var he=this.rules.block.heading.exec(oe);if(he){var re=he[2].trim();if(/#$/.test(re)){var ie=o(re,"#");(this.options.pedantic||!ie||/ $/.test(ie))&&(re=ie.trim())}return{type:"heading",raw:he[0],depth:he[1].length,text:re,tokens:this.lexer.inline(re)}}},be.hr=function(oe){var he=this.rules.block.hr.exec(oe);if(he)return{type:"hr",raw:he[0]}},be.blockquote=function(oe){var he=this.rules.block.blockquote.exec(oe);if(he){var re=he[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:he[0],tokens:this.lexer.blockTokens(re,[]),text:re}}},be.list=function(oe){var he=this.rules.block.list.exec(oe);if(he){var re,ie,ge,Se,L,q,G,Q,K,ee,ce,ze,Ue=he[1].trim(),Qe=Ue.length>1,He={type:"list",raw:"",ordered:Qe,start:Qe?+Ue.slice(0,-1):"",loose:!1,items:[]};Ue=Qe?"\\d{1,9}\\"+Ue.slice(-1):"\\"+Ue,this.options.pedantic&&(Ue=Qe?Ue:"[*+-]");for(var et=new RegExp("^( {0,3}"+Ue+")((?:[	 ][^\\n]*)?(?:\\n|$))");oe&&(ze=!1,!(!(he=et.exec(oe))||this.rules.block.hr.test(oe)));){if(re=he[0],oe=oe.substring(re.length),Q=he[2].split(`
`,1)[0],K=oe.split(`
`,1)[0],this.options.pedantic?(Se=2,ce=Q.trimLeft()):(Se=he[2].search(/[^ ]/),Se=Se>4?1:Se,ce=Q.slice(Se),Se+=he[1].length),q=!1,!Q&&/^ *$/.test(K)&&(re+=K+`
`,oe=oe.substring(K.length+1),ze=!0),!ze)for(var Xe=new RegExp("^ {0,"+Math.min(3,Se-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),xe=new RegExp("^ {0,"+Math.min(3,Se-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),it=new RegExp("^ {0,"+Math.min(3,Se-1)+"}(?:```|~~~)"),tt=new RegExp("^ {0,"+Math.min(3,Se-1)+"}#");oe&&(ee=oe.split(`
`,1)[0],Q=ee,this.options.pedantic&&(Q=Q.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(it.test(Q)||tt.test(Q)||Xe.test(Q)||xe.test(oe)));){if(Q.search(/[^ ]/)>=Se||!Q.trim())ce+=`
`+Q.slice(Se);else if(!q)ce+=`
`+Q;else break;!q&&!Q.trim()&&(q=!0),re+=ee+`
`,oe=oe.substring(ee.length+1)}He.loose||(G?He.loose=!0:/\n *\n *$/.test(re)&&(G=!0)),this.options.gfm&&(ie=/^\[[ xX]\] /.exec(ce),ie&&(ge=ie[0]!=="[ ] ",ce=ce.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:re,task:!!ie,checked:ge,loose:!1,text:ce}),He.raw+=re}He.items[He.items.length-1].raw=re.trimRight(),He.items[He.items.length-1].text=ce.trimRight(),He.raw=He.raw.trimRight();var Ne=He.items.length;for(L=0;L<Ne;L++){this.lexer.state.top=!1,He.items[L].tokens=this.lexer.blockTokens(He.items[L].text,[]);var st=He.items[L].tokens.filter(function(Y){return Y.type==="space"}),x=st.every(function(Y){for(var $e=Y.raw.split(""),je=0,Oe=M($e),Ye;!(Ye=Oe()).done;){var nt=Ye.value;if(nt===`
`&&(je+=1),je>1)return!0}return!1});!He.loose&&st.length&&x&&(He.loose=!0,He.items[L].loose=!0)}return He}},be.html=function(oe){var he=this.rules.block.html.exec(oe);if(he){var re={type:"html",raw:he[0],pre:!this.options.sanitizer&&(he[1]==="pre"||he[1]==="script"||he[1]==="style"),text:he[0]};if(this.options.sanitize){var ie=this.options.sanitizer?this.options.sanitizer(he[0]):p(he[0]);re.type="paragraph",re.text=ie,re.tokens=this.lexer.inline(ie)}return re}},be.def=function(oe){var he=this.rules.block.def.exec(oe);if(he){he[3]&&(he[3]=he[3].substring(1,he[3].length-1));var re=he[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:re,raw:he[0],href:he[2],title:he[3]}}},be.table=function(oe){var he=this.rules.block.table.exec(oe);if(he){var re={type:"table",header:E(he[1]).map(function(G){return{text:G}}),align:he[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:he[3]&&he[3].trim()?he[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(re.header.length===re.align.length){re.raw=he[0];var ie=re.align.length,ge,Se,L,q;for(ge=0;ge<ie;ge++)/^ *-+: *$/.test(re.align[ge])?re.align[ge]="right":/^ *:-+: *$/.test(re.align[ge])?re.align[ge]="center":/^ *:-+ *$/.test(re.align[ge])?re.align[ge]="left":re.align[ge]=null;for(ie=re.rows.length,ge=0;ge<ie;ge++)re.rows[ge]=E(re.rows[ge],re.header.length).map(function(G){return{text:G}});for(ie=re.header.length,Se=0;Se<ie;Se++)re.header[Se].tokens=this.lexer.inline(re.header[Se].text);for(ie=re.rows.length,Se=0;Se<ie;Se++)for(q=re.rows[Se],L=0;L<q.length;L++)q[L].tokens=this.lexer.inline(q[L].text);return re}}},be.lheading=function(oe){var he=this.rules.block.lheading.exec(oe);if(he)return{type:"heading",raw:he[0],depth:he[2].charAt(0)==="="?1:2,text:he[1],tokens:this.lexer.inline(he[1])}},be.paragraph=function(oe){var he=this.rules.block.paragraph.exec(oe);if(he){var re=he[1].charAt(he[1].length-1)===`
`?he[1].slice(0,-1):he[1];return{type:"paragraph",raw:he[0],text:re,tokens:this.lexer.inline(re)}}},be.text=function(oe){var he=this.rules.block.text.exec(oe);if(he)return{type:"text",raw:he[0],text:he[0],tokens:this.lexer.inline(he[0])}},be.escape=function(oe){var he=this.rules.inline.escape.exec(oe);if(he)return{type:"escape",raw:he[0],text:p(he[1])}},be.tag=function(oe){var he=this.rules.inline.tag.exec(oe);if(he)return!this.lexer.state.inLink&&/^<a /i.test(he[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(he[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(he[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(he[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:he[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):p(he[0]):he[0]}},be.link=function(oe){var he=this.rules.inline.link.exec(oe);if(he){var re=he[2].trim();if(!this.options.pedantic&&/^</.test(re)){if(!/>$/.test(re))return;var ie=o(re.slice(0,-1),"\\");if((re.length-ie.length)%2===0)return}else{var ge=l(he[2],"()");if(ge>-1){var Se=he[0].indexOf("!")===0?5:4,L=Se+he[1].length+ge;he[2]=he[2].substring(0,ge),he[0]=he[0].substring(0,L).trim(),he[3]=""}}var q=he[2],G="";if(this.options.pedantic){var Q=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(q);Q&&(q=Q[1],G=Q[3])}else G=he[3]?he[3].slice(1,-1):"";return q=q.trim(),/^</.test(q)&&(this.options.pedantic&&!/>$/.test(re)?q=q.slice(1):q=q.slice(1,-1)),W(he,{href:q&&q.replace(this.rules.inline._escapes,"$1"),title:G&&G.replace(this.rules.inline._escapes,"$1")},he[0],this.lexer)}},be.reflink=function(oe,he){var re;if((re=this.rules.inline.reflink.exec(oe))||(re=this.rules.inline.nolink.exec(oe))){var ie=(re[2]||re[1]).replace(/\s+/g," ");if(ie=he[ie.toLowerCase()],!ie||!ie.href){var ge=re[0].charAt(0);return{type:"text",raw:ge,text:ge}}return W(re,ie,re[0],this.lexer)}},be.emStrong=function(oe,he,re){re===void 0&&(re="");var ie=this.rules.inline.emStrong.lDelim.exec(oe);if(ie&&!(ie[3]&&re.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ge=ie[1]||ie[2]||"";if(!ge||ge&&(re===""||this.rules.inline.punctuation.exec(re))){var Se=ie[0].length-1,L,q,G=Se,Q=0,K=ie[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(K.lastIndex=0,he=he.slice(-1*oe.length+Se);(ie=K.exec(he))!=null;)if(L=ie[1]||ie[2]||ie[3]||ie[4]||ie[5]||ie[6],!!L){if(q=L.length,ie[3]||ie[4]){G+=q;continue}else if((ie[5]||ie[6])&&Se%3&&!((Se+q)%3)){Q+=q;continue}if(G-=q,!(G>0)){if(q=Math.min(q,q+G+Q),Math.min(Se,q)%2){var ee=oe.slice(1,Se+ie.index+q);return{type:"em",raw:oe.slice(0,Se+ie.index+q+1),text:ee,tokens:this.lexer.inlineTokens(ee)}}var ce=oe.slice(2,Se+ie.index+q-1);return{type:"strong",raw:oe.slice(0,Se+ie.index+q+1),text:ce,tokens:this.lexer.inlineTokens(ce)}}}}}},be.codespan=function(oe){var he=this.rules.inline.code.exec(oe);if(he){var re=he[2].replace(/\n/g," "),ie=/[^ ]/.test(re),ge=/^ /.test(re)&&/ $/.test(re);return ie&&ge&&(re=re.substring(1,re.length-1)),re=p(re,!0),{type:"codespan",raw:he[0],text:re}}},be.br=function(oe){var he=this.rules.inline.br.exec(oe);if(he)return{type:"br",raw:he[0]}},be.del=function(oe){var he=this.rules.inline.del.exec(oe);if(he)return{type:"del",raw:he[0],text:he[2],tokens:this.lexer.inlineTokens(he[2])}},be.autolink=function(oe,he){var re=this.rules.inline.autolink.exec(oe);if(re){var ie,ge;return re[2]==="@"?(ie=p(this.options.mangle?he(re[1]):re[1]),ge="mailto:"+ie):(ie=p(re[1]),ge=ie),{type:"link",raw:re[0],text:ie,href:ge,tokens:[{type:"text",raw:ie,text:ie}]}}},be.url=function(oe,he){var re;if(re=this.rules.inline.url.exec(oe)){var ie,ge;if(re[2]==="@")ie=p(this.options.mangle?he(re[0]):re[0]),ge="mailto:"+ie;else{var Se;do Se=re[0],re[0]=this.rules.inline._backpedal.exec(re[0])[0];while(Se!==re[0]);ie=p(re[0]),re[1]==="www."?ge="http://"+ie:ge=ie}return{type:"link",raw:re[0],text:ie,href:ge,tokens:[{type:"text",raw:ie,text:ie}]}}},be.inlineText=function(oe,he){var re=this.rules.inline.text.exec(oe);if(re){var ie;return this.lexer.state.inRawBlock?ie=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(re[0]):p(re[0]):re[0]:ie=p(this.options.smartypants?he(re[0]):re[0]),{type:"text",raw:re[0],text:ie}}},ve}(),j={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:$,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};j._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,j._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,j.def=c(j.def).replace("label",j._label).replace("title",j._title).getRegex(),j.bullet=/(?:[*+-]|\d{1,9}[.)])/,j.listItemStart=c(/^( *)(bull) */).replace("bull",j.bullet).getRegex(),j.list=c(j.list).replace(/bull/g,j.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+j.def.source+")").getRegex(),j._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",j._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,j.html=c(j.html,"i").replace("comment",j._comment).replace("tag",j._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),j.paragraph=c(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.blockquote=c(j.blockquote).replace("paragraph",j.paragraph).getRegex(),j.normal=w({},j),j.gfm=w({},j.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),j.gfm.table=c(j.gfm.table).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.gfm.paragraph=c(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",j.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.pedantic=w({},j.normal,{html:c(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",j._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:$,paragraph:c(j.normal._paragraph).replace("hr",j.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",j.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var U={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:$,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:$,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};U._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",U.punctuation=c(U.punctuation).replace(/punctuation/g,U._punctuation).getRegex(),U.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,U.escapedEmSt=/\\\*|\\_/g,U._comment=c(j._comment).replace("(?:-->|$)","-->").getRegex(),U.emStrong.lDelim=c(U.emStrong.lDelim).replace(/punct/g,U._punctuation).getRegex(),U.emStrong.rDelimAst=c(U.emStrong.rDelimAst,"g").replace(/punct/g,U._punctuation).getRegex(),U.emStrong.rDelimUnd=c(U.emStrong.rDelimUnd,"g").replace(/punct/g,U._punctuation).getRegex(),U._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,U._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,U._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,U.autolink=c(U.autolink).replace("scheme",U._scheme).replace("email",U._email).getRegex(),U._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,U.tag=c(U.tag).replace("comment",U._comment).replace("attribute",U._attribute).getRegex(),U._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,U._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,U._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,U.link=c(U.link).replace("label",U._label).replace("href",U._href).replace("title",U._title).getRegex(),U.reflink=c(U.reflink).replace("label",U._label).replace("ref",j._label).getRegex(),U.nolink=c(U.nolink).replace("ref",j._label).getRegex(),U.reflinkSearch=c(U.reflinkSearch,"g").replace("reflink",U.reflink).replace("nolink",U.nolink).getRegex(),U.normal=w({},U),U.pedantic=w({},U.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:c(/^!?\[(label)\]\((.*?)\)/).replace("label",U._label).getRegex(),reflink:c(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",U._label).getRegex()}),U.gfm=w({},U.normal,{escape:c(U.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),U.gfm.url=c(U.gfm.url,"i").replace("email",U.gfm._extended_email).getRegex(),U.breaks=w({},U.gfm,{br:c(U.br).replace("{2,}","*").getRegex(),text:c(U.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function z(ve){return ve.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function ne(ve){var be="",ke,oe,he=ve.length;for(ke=0;ke<he;ke++)oe=ve.charCodeAt(ke),Math.random()>.5&&(oe="x"+oe.toString(16)),be+="&#"+oe+";";return be}var Z=function(){function ve(ke){this.tokens=[],this.tokens.links=Object.create(null),this.options=ke||pe.defaults,this.options.tokenizer=this.options.tokenizer||new B,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var oe={block:j.normal,inline:U.normal};this.options.pedantic?(oe.block=j.pedantic,oe.inline=U.pedantic):this.options.gfm&&(oe.block=j.gfm,this.options.breaks?oe.inline=U.breaks:oe.inline=U.gfm),this.tokenizer.rules=oe}ve.lex=function(oe,he){var re=new ve(he);return re.lex(oe)},ve.lexInline=function(oe,he){var re=new ve(he);return re.inlineTokens(oe)};var be=ve.prototype;return be.lex=function(oe){oe=oe.replace(/\r\n|\r/g,`
`),this.blockTokens(oe,this.tokens);for(var he;he=this.inlineQueue.shift();)this.inlineTokens(he.src,he.tokens);return this.tokens},be.blockTokens=function(oe,he){var re=this;he===void 0&&(he=[]),this.options.pedantic?oe=oe.replace(/\t/g,"    ").replace(/^ +$/gm,""):oe=oe.replace(/^( *)(\t+)/gm,function(G,Q,K){return Q+"    ".repeat(K.length)});for(var ie,ge,Se,L;oe;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(G){return(ie=G.call({lexer:re},oe,he))?(oe=oe.substring(ie.raw.length),he.push(ie),!0):!1}))){if(ie=this.tokenizer.space(oe)){oe=oe.substring(ie.raw.length),ie.raw.length===1&&he.length>0?he[he.length-1].raw+=`
`:he.push(ie);continue}if(ie=this.tokenizer.code(oe)){oe=oe.substring(ie.raw.length),ge=he[he.length-1],ge&&(ge.type==="paragraph"||ge.type==="text")?(ge.raw+=`
`+ie.raw,ge.text+=`
`+ie.text,this.inlineQueue[this.inlineQueue.length-1].src=ge.text):he.push(ie);continue}if(ie=this.tokenizer.fences(oe)){oe=oe.substring(ie.raw.length),he.push(ie);continue}if(ie=this.tokenizer.heading(oe)){oe=oe.substring(ie.raw.length),he.push(ie);continue}if(ie=this.tokenizer.hr(oe)){oe=oe.substring(ie.raw.length),he.push(ie);continue}if(ie=this.tokenizer.blockquote(oe)){oe=oe.substring(ie.raw.length),he.push(ie);continue}if(ie=this.tokenizer.list(oe)){oe=oe.substring(ie.raw.length),he.push(ie);continue}if(ie=this.tokenizer.html(oe)){oe=oe.substring(ie.raw.length),he.push(ie);continue}if(ie=this.tokenizer.def(oe)){oe=oe.substring(ie.raw.length),ge=he[he.length-1],ge&&(ge.type==="paragraph"||ge.type==="text")?(ge.raw+=`
`+ie.raw,ge.text+=`
`+ie.raw,this.inlineQueue[this.inlineQueue.length-1].src=ge.text):this.tokens.links[ie.tag]||(this.tokens.links[ie.tag]={href:ie.href,title:ie.title});continue}if(ie=this.tokenizer.table(oe)){oe=oe.substring(ie.raw.length),he.push(ie);continue}if(ie=this.tokenizer.lheading(oe)){oe=oe.substring(ie.raw.length),he.push(ie);continue}if(Se=oe,this.options.extensions&&this.options.extensions.startBlock&&function(){var G=1/0,Q=oe.slice(1),K=void 0;re.options.extensions.startBlock.forEach(function(ee){K=ee.call({lexer:this},Q),typeof K=="number"&&K>=0&&(G=Math.min(G,K))}),G<1/0&&G>=0&&(Se=oe.substring(0,G+1))}(),this.state.top&&(ie=this.tokenizer.paragraph(Se))){ge=he[he.length-1],L&&ge.type==="paragraph"?(ge.raw+=`
`+ie.raw,ge.text+=`
`+ie.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ge.text):he.push(ie),L=Se.length!==oe.length,oe=oe.substring(ie.raw.length);continue}if(ie=this.tokenizer.text(oe)){oe=oe.substring(ie.raw.length),ge=he[he.length-1],ge&&ge.type==="text"?(ge.raw+=`
`+ie.raw,ge.text+=`
`+ie.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ge.text):he.push(ie);continue}if(oe){var q="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(q);break}else throw new Error(q)}}return this.state.top=!0,he},be.inline=function(oe,he){return he===void 0&&(he=[]),this.inlineQueue.push({src:oe,tokens:he}),he},be.inlineTokens=function(oe,he){var re=this;he===void 0&&(he=[]);var ie,ge,Se,L=oe,q,G,Q;if(this.tokens.links){var K=Object.keys(this.tokens.links);if(K.length>0)for(;(q=this.tokenizer.rules.inline.reflinkSearch.exec(L))!=null;)K.includes(q[0].slice(q[0].lastIndexOf("[")+1,-1))&&(L=L.slice(0,q.index)+"["+F("a",q[0].length-2)+"]"+L.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(q=this.tokenizer.rules.inline.blockSkip.exec(L))!=null;)L=L.slice(0,q.index)+"["+F("a",q[0].length-2)+"]"+L.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(q=this.tokenizer.rules.inline.escapedEmSt.exec(L))!=null;)L=L.slice(0,q.index)+"++"+L.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;oe;)if(G||(Q=""),G=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ce){return(ie=ce.call({lexer:re},oe,he))?(oe=oe.substring(ie.raw.length),he.push(ie),!0):!1}))){if(ie=this.tokenizer.escape(oe)){oe=oe.substring(ie.raw.length),he.push(ie);continue}if(ie=this.tokenizer.tag(oe)){oe=oe.substring(ie.raw.length),ge=he[he.length-1],ge&&ie.type==="text"&&ge.type==="text"?(ge.raw+=ie.raw,ge.text+=ie.text):he.push(ie);continue}if(ie=this.tokenizer.link(oe)){oe=oe.substring(ie.raw.length),he.push(ie);continue}if(ie=this.tokenizer.reflink(oe,this.tokens.links)){oe=oe.substring(ie.raw.length),ge=he[he.length-1],ge&&ie.type==="text"&&ge.type==="text"?(ge.raw+=ie.raw,ge.text+=ie.text):he.push(ie);continue}if(ie=this.tokenizer.emStrong(oe,L,Q)){oe=oe.substring(ie.raw.length),he.push(ie);continue}if(ie=this.tokenizer.codespan(oe)){oe=oe.substring(ie.raw.length),he.push(ie);continue}if(ie=this.tokenizer.br(oe)){oe=oe.substring(ie.raw.length),he.push(ie);continue}if(ie=this.tokenizer.del(oe)){oe=oe.substring(ie.raw.length),he.push(ie);continue}if(ie=this.tokenizer.autolink(oe,ne)){oe=oe.substring(ie.raw.length),he.push(ie);continue}if(!this.state.inLink&&(ie=this.tokenizer.url(oe,ne))){oe=oe.substring(ie.raw.length),he.push(ie);continue}if(Se=oe,this.options.extensions&&this.options.extensions.startInline&&function(){var ce=1/0,ze=oe.slice(1),Ue=void 0;re.options.extensions.startInline.forEach(function(Qe){Ue=Qe.call({lexer:this},ze),typeof Ue=="number"&&Ue>=0&&(ce=Math.min(ce,Ue))}),ce<1/0&&ce>=0&&(Se=oe.substring(0,ce+1))}(),ie=this.tokenizer.inlineText(Se,z)){oe=oe.substring(ie.raw.length),ie.raw.slice(-1)!=="_"&&(Q=ie.raw.slice(-1)),G=!0,ge=he[he.length-1],ge&&ge.type==="text"?(ge.raw+=ie.raw,ge.text+=ie.text):he.push(ie);continue}if(oe){var ee="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(ee);break}else throw new Error(ee)}}return he},y(ve,null,[{key:"rules",get:function(){return{block:j,inline:U}}}]),ve}(),we=function(){function ve(ke){this.options=ke||pe.defaults}var be=ve.prototype;return be.code=function(oe,he,re){var ie=(he||"").match(/\S*/)[0];if(this.options.highlight){var ge=this.options.highlight(oe,ie);ge!=null&&ge!==oe&&(re=!0,oe=ge)}return oe=oe.replace(/\n$/,"")+`
`,ie?'<pre><code class="'+this.options.langPrefix+p(ie,!0)+'">'+(re?oe:p(oe,!0))+`</code></pre>
`:"<pre><code>"+(re?oe:p(oe,!0))+`</code></pre>
`},be.blockquote=function(oe){return`<blockquote>
`+oe+`</blockquote>
`},be.html=function(oe){return oe},be.heading=function(oe,he,re,ie){if(this.options.headerIds){var ge=this.options.headerPrefix+ie.slug(re);return"<h"+he+' id="'+ge+'">'+oe+"</h"+he+`>
`}return"<h"+he+">"+oe+"</h"+he+`>
`},be.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},be.list=function(oe,he,re){var ie=he?"ol":"ul",ge=he&&re!==1?' start="'+re+'"':"";return"<"+ie+ge+`>
`+oe+"</"+ie+`>
`},be.listitem=function(oe){return"<li>"+oe+`</li>
`},be.checkbox=function(oe){return"<input "+(oe?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},be.paragraph=function(oe){return"<p>"+oe+`</p>
`},be.table=function(oe,he){return he&&(he="<tbody>"+he+"</tbody>"),`<table>
<thead>
`+oe+`</thead>
`+he+`</table>
`},be.tablerow=function(oe){return`<tr>
`+oe+`</tr>
`},be.tablecell=function(oe,he){var re=he.header?"th":"td",ie=he.align?"<"+re+' align="'+he.align+'">':"<"+re+">";return ie+oe+("</"+re+`>
`)},be.strong=function(oe){return"<strong>"+oe+"</strong>"},be.em=function(oe){return"<em>"+oe+"</em>"},be.codespan=function(oe){return"<code>"+oe+"</code>"},be.br=function(){return this.options.xhtml?"<br/>":"<br>"},be.del=function(oe){return"<del>"+oe+"</del>"},be.link=function(oe,he,re){if(oe=C(this.options.sanitize,this.options.baseUrl,oe),oe===null)return re;var ie='<a href="'+p(oe)+'"';return he&&(ie+=' title="'+he+'"'),ie+=">"+re+"</a>",ie},be.image=function(oe,he,re){if(oe=C(this.options.sanitize,this.options.baseUrl,oe),oe===null)return re;var ie='<img src="'+oe+'" alt="'+re+'"';return he&&(ie+=' title="'+he+'"'),ie+=this.options.xhtml?"/>":">",ie},be.text=function(oe){return oe},ve}(),Ee=function(){function ve(){}var be=ve.prototype;return be.strong=function(oe){return oe},be.em=function(oe){return oe},be.codespan=function(oe){return oe},be.del=function(oe){return oe},be.html=function(oe){return oe},be.text=function(oe){return oe},be.link=function(oe,he,re){return""+re},be.image=function(oe,he,re){return""+re},be.br=function(){return""},ve}(),Re=function(){function ve(){this.seen={}}var be=ve.prototype;return be.serialize=function(oe){return oe.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},be.getNextSafeSlug=function(oe,he){var re=oe,ie=0;if(this.seen.hasOwnProperty(re)){ie=this.seen[oe];do ie++,re=oe+"-"+ie;while(this.seen.hasOwnProperty(re))}return he||(this.seen[oe]=ie,this.seen[re]=0),re},be.slug=function(oe,he){he===void 0&&(he={});var re=this.serialize(oe);return this.getNextSafeSlug(re,he.dryrun)},ve}(),X=function(){function ve(ke){this.options=ke||pe.defaults,this.options.renderer=this.options.renderer||new we,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Ee,this.slugger=new Re}ve.parse=function(oe,he){var re=new ve(he);return re.parse(oe)},ve.parseInline=function(oe,he){var re=new ve(he);return re.parseInline(oe)};var be=ve.prototype;return be.parse=function(oe,he){he===void 0&&(he=!0);var re="",ie,ge,Se,L,q,G,Q,K,ee,ce,ze,Ue,Qe,He,et,Xe,xe,it,tt,Ne=oe.length;for(ie=0;ie<Ne;ie++){if(ce=oe[ie],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ce.type]&&(tt=this.options.extensions.renderers[ce.type].call({parser:this},ce),tt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ce.type))){re+=tt||"";continue}switch(ce.type){case"space":continue;case"hr":{re+=this.renderer.hr();continue}case"heading":{re+=this.renderer.heading(this.parseInline(ce.tokens),ce.depth,t(this.parseInline(ce.tokens,this.textRenderer)),this.slugger);continue}case"code":{re+=this.renderer.code(ce.text,ce.lang,ce.escaped);continue}case"table":{for(K="",Q="",L=ce.header.length,ge=0;ge<L;ge++)Q+=this.renderer.tablecell(this.parseInline(ce.header[ge].tokens),{header:!0,align:ce.align[ge]});for(K+=this.renderer.tablerow(Q),ee="",L=ce.rows.length,ge=0;ge<L;ge++){for(G=ce.rows[ge],Q="",q=G.length,Se=0;Se<q;Se++)Q+=this.renderer.tablecell(this.parseInline(G[Se].tokens),{header:!1,align:ce.align[Se]});ee+=this.renderer.tablerow(Q)}re+=this.renderer.table(K,ee);continue}case"blockquote":{ee=this.parse(ce.tokens),re+=this.renderer.blockquote(ee);continue}case"list":{for(ze=ce.ordered,Ue=ce.start,Qe=ce.loose,L=ce.items.length,ee="",ge=0;ge<L;ge++)et=ce.items[ge],Xe=et.checked,xe=et.task,He="",et.task&&(it=this.renderer.checkbox(Xe),Qe?et.tokens.length>0&&et.tokens[0].type==="paragraph"?(et.tokens[0].text=it+" "+et.tokens[0].text,et.tokens[0].tokens&&et.tokens[0].tokens.length>0&&et.tokens[0].tokens[0].type==="text"&&(et.tokens[0].tokens[0].text=it+" "+et.tokens[0].tokens[0].text)):et.tokens.unshift({type:"text",text:it}):He+=it),He+=this.parse(et.tokens,Qe),ee+=this.renderer.listitem(He,xe,Xe);re+=this.renderer.list(ee,ze,Ue);continue}case"html":{re+=this.renderer.html(ce.text);continue}case"paragraph":{re+=this.renderer.paragraph(this.parseInline(ce.tokens));continue}case"text":{for(ee=ce.tokens?this.parseInline(ce.tokens):ce.text;ie+1<Ne&&oe[ie+1].type==="text";)ce=oe[++ie],ee+=`
`+(ce.tokens?this.parseInline(ce.tokens):ce.text);re+=he?this.renderer.paragraph(ee):ee;continue}default:{var st='Token with "'+ce.type+'" type was not found.';if(this.options.silent){console.error(st);return}else throw new Error(st)}}}return re},be.parseInline=function(oe,he){he=he||this.renderer;var re="",ie,ge,Se,L=oe.length;for(ie=0;ie<L;ie++){if(ge=oe[ie],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ge.type]&&(Se=this.options.extensions.renderers[ge.type].call({parser:this},ge),Se!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(ge.type))){re+=Se||"";continue}switch(ge.type){case"escape":{re+=he.text(ge.text);break}case"html":{re+=he.html(ge.text);break}case"link":{re+=he.link(ge.href,ge.title,this.parseInline(ge.tokens,he));break}case"image":{re+=he.image(ge.href,ge.title,ge.text);break}case"strong":{re+=he.strong(this.parseInline(ge.tokens,he));break}case"em":{re+=he.em(this.parseInline(ge.tokens,he));break}case"codespan":{re+=he.codespan(ge.text);break}case"br":{re+=he.br();break}case"del":{re+=he.del(this.parseInline(ge.tokens,he));break}case"text":{re+=he.text(ge.text);break}default:{var q='Token with "'+ge.type+'" type was not found.';if(this.options.silent){console.error(q);return}else throw new Error(q)}}}return re},ve}();function de(ve,be,ke){if(typeof ve>"u"||ve===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ve!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ve)+", string expected");if(typeof be=="function"&&(ke=be,be=null),be=w({},de.defaults,be||{}),m(be),ke){var oe=be.highlight,he;try{he=Z.lex(ve,be)}catch(L){return ke(L)}var re=function(q){var G;if(!q)try{be.walkTokens&&de.walkTokens(he,be.walkTokens),G=X.parse(he,be)}catch(Q){q=Q}return be.highlight=oe,q?ke(q):ke(null,G)};if(!oe||oe.length<3||(delete be.highlight,!he.length))return re();var ie=0;de.walkTokens(he,function(L){L.type==="code"&&(ie++,setTimeout(function(){oe(L.text,L.lang,function(q,G){if(q)return re(q);G!=null&&G!==L.text&&(L.text=G,L.escaped=!0),ie--,ie===0&&re()})},0))}),ie===0&&re();return}function ge(L){if(L.message+=`
Please report this to https://github.com/markedjs/marked.`,be.silent)return"<p>An error occurred:</p><pre>"+p(L.message+"",!0)+"</pre>";throw L}try{var Se=Z.lex(ve,be);if(be.walkTokens){if(be.async)return Promise.all(de.walkTokens(Se,be.walkTokens)).then(function(){return X.parse(Se,be)}).catch(ge);de.walkTokens(Se,be.walkTokens)}return X.parse(Se,be)}catch(L){ge(L)}}de.options=de.setOptions=function(ve){return w(de.defaults,ve),d(de.defaults),de},de.getDefaults=A,de.defaults=pe.defaults,de.use=function(){for(var ve=arguments.length,be=new Array(ve),ke=0;ke<ve;ke++)be[ke]=arguments[ke];var oe=w.apply(void 0,[{}].concat(be)),he=de.defaults.extensions||{renderers:{},childTokens:{}},re;be.forEach(function(ie){if(ie.extensions&&(re=!0,ie.extensions.forEach(function(Se){if(!Se.name)throw new Error("extension name required");if(Se.renderer){var L=he.renderers?he.renderers[Se.name]:null;L?he.renderers[Se.name]=function(){for(var q=arguments.length,G=new Array(q),Q=0;Q<q;Q++)G[Q]=arguments[Q];var K=Se.renderer.apply(this,G);return K===!1&&(K=L.apply(this,G)),K}:he.renderers[Se.name]=Se.renderer}if(Se.tokenizer){if(!Se.level||Se.level!=="block"&&Se.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");he[Se.level]?he[Se.level].unshift(Se.tokenizer):he[Se.level]=[Se.tokenizer],Se.start&&(Se.level==="block"?he.startBlock?he.startBlock.push(Se.start):he.startBlock=[Se.start]:Se.level==="inline"&&(he.startInline?he.startInline.push(Se.start):he.startInline=[Se.start]))}Se.childTokens&&(he.childTokens[Se.name]=Se.childTokens)})),ie.renderer&&function(){var Se=de.defaults.renderer||new we,L=function(Q){var K=Se[Q];Se[Q]=function(){for(var ee=arguments.length,ce=new Array(ee),ze=0;ze<ee;ze++)ce[ze]=arguments[ze];var Ue=ie.renderer[Q].apply(Se,ce);return Ue===!1&&(Ue=K.apply(Se,ce)),Ue}};for(var q in ie.renderer)L(q);oe.renderer=Se}(),ie.tokenizer&&function(){var Se=de.defaults.tokenizer||new B,L=function(Q){var K=Se[Q];Se[Q]=function(){for(var ee=arguments.length,ce=new Array(ee),ze=0;ze<ee;ze++)ce[ze]=arguments[ze];var Ue=ie.tokenizer[Q].apply(Se,ce);return Ue===!1&&(Ue=K.apply(Se,ce)),Ue}};for(var q in ie.tokenizer)L(q);oe.tokenizer=Se}(),ie.walkTokens){var ge=de.defaults.walkTokens;oe.walkTokens=function(Se){var L=[];return L.push(ie.walkTokens.call(this,Se)),ge&&(L=L.concat(ge.call(this,Se))),L}}re&&(oe.extensions=he),de.setOptions(oe)})},de.walkTokens=function(ve,be){for(var ke=[],oe=function(){var ge=re.value;switch(ke=ke.concat(be.call(de,ge)),ge.type){case"table":{for(var Se=M(ge.header),L;!(L=Se()).done;){var q=L.value;ke=ke.concat(de.walkTokens(q.tokens,be))}for(var G=M(ge.rows),Q;!(Q=G()).done;)for(var K=Q.value,ee=M(K),ce;!(ce=ee()).done;){var ze=ce.value;ke=ke.concat(de.walkTokens(ze.tokens,be))}break}case"list":{ke=ke.concat(de.walkTokens(ge.items,be));break}default:de.defaults.extensions&&de.defaults.extensions.childTokens&&de.defaults.extensions.childTokens[ge.type]?de.defaults.extensions.childTokens[ge.type].forEach(function(Ue){ke=ke.concat(de.walkTokens(ge[Ue],be))}):ge.tokens&&(ke=ke.concat(de.walkTokens(ge.tokens,be)))}},he=M(ve),re;!(re=he()).done;)oe();return ke},de.parseInline=function(ve,be){if(typeof ve>"u"||ve===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ve!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ve)+", string expected");be=w({},de.defaults,be||{}),m(be);try{var ke=Z.lexInline(ve,be);return be.walkTokens&&de.walkTokens(ke,be.walkTokens),X.parseInline(ke,be)}catch(oe){if(oe.message+=`
Please report this to https://github.com/markedjs/marked.`,be.silent)return"<p>An error occurred:</p><pre>"+p(oe.message+"",!0)+"</pre>";throw oe}},de.Parser=X,de.parser=X.parse,de.Renderer=we,de.TextRenderer=Ee,de.Lexer=Z,de.lexer=Z.lex,de.Tokenizer=B,de.Slugger=Re,de.parse=de;var Ce=de.options,ae=de.setOptions,_=de.use,ue=de.walkTokens,O=de.parseInline,J=de,le=X.parse,ye=Z.lex;pe.Lexer=Z,pe.Parser=X,pe.Renderer=we,pe.Slugger=Re,pe.TextRenderer=Ee,pe.Tokenizer=B,pe.getDefaults=A,pe.lexer=ye,pe.marked=de,pe.options=Ce,pe.parse=J,pe.parseInline=O,pe.parser=le,pe.setOptions=ae,pe.use=_,pe.walkTokens=ue,Object.defineProperty(pe,"__esModule",{value:!0})}),define(Pe[118],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yl=e.$xl=e.$wl=e.rot=e.$ul=void 0;function y(d,k,f){return Math.min(Math.max(d,k),f)}e.$ul=y;function R(d,k){return(k+d%k)%k}e.rot=R;class I{constructor(){this.a=0}getNext(){return this.a++}}e.$wl=I;class M{constructor(){this.a=1,this.b=0}update(k){return this.b=this.b+(k-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$xl=M;class A{constructor(k){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(k),this.c.fill(0,0,k)}update(k){const f=this.c[this.d];return this.c[this.d]=k,this.d=(this.d+1)%this.c.length,this.e-=f,this.e+=k,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$yl=A}),function(){function pe(I){const M=[];typeof I=="number"&&M.push("code/timeOrigin",I);function A(k){M.push(k,Date.now())}function d(){const k=[];for(let f=0;f<M.length;f+=2)k.push({name:M[f],startTime:M[f+1]});return k}return{mark:A,getMarks:d}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?pe():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const A of performance.getEntriesByType("mark"))M.push({name:A.name,startTime:Math.round(I+A.startTime)});return M}};if(typeof process=="object"){const I=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return pe(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),pe()}function y(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return y(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=y(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=y(R))}(),function(pe,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var y=e();for(var R in y)(typeof exports=="object"?exports:pe)[R]=y[R]}}(typeof self<"u"?self:this,function(){return function(pe){var e={};function y(R){if(e[R])return e[R].exports;var I=e[R]={i:R,l:!1,exports:{}};return pe[R].call(I.exports,I,I.exports,y),I.l=!0,I.exports}return y.m=pe,y.c=e,y.d=function(R,I,M){y.o(R,I)||Object.defineProperty(R,I,{enumerable:!0,get:M})},y.r=function(R){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},y.t=function(R,I){if(1&I&&(R=y(R)),8&I||4&I&&typeof R=="object"&&R&&R.__esModule)return R;var M=Object.create(null);if(y.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:R}),2&I&&typeof R!="string")for(var A in R)y.d(M,A,function(d){return R[d]}.bind(null,A));return M},y.n=function(R){var I=R&&R.__esModule?function(){return R.default}:function(){return R};return y.d(I,"a",I),I},y.o=function(R,I){return Object.prototype.hasOwnProperty.call(R,I)},y.p="",y(y.s=0)}([function(pe,e,y){(function(R){var I;e=pe.exports=_,I=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var K=Array.prototype.slice.call(arguments,0);K.unshift("SEMVER"),console.log.apply(console,K)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,d=e.re=[],k=e.src=[],f=0,P=f++;k[P]="0|[1-9]\\d*";var D=f++;k[D]="[0-9]+";var u=f++;k[u]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var b=f++;k[b]="("+k[P]+")\\.("+k[P]+")\\.("+k[P]+")";var p=f++;k[p]="("+k[D]+")\\.("+k[D]+")\\.("+k[D]+")";var h=f++;k[h]="(?:"+k[P]+"|"+k[u]+")";var t=f++;k[t]="(?:"+k[D]+"|"+k[u]+")";var i=f++;k[i]="(?:-("+k[h]+"(?:\\."+k[h]+")*))";var c=f++;k[c]="(?:-?("+k[t]+"(?:\\."+k[t]+")*))";var g=f++;k[g]="[0-9A-Za-z-]+";var S=f++;k[S]="(?:\\+("+k[g]+"(?:\\."+k[g]+")*))";var C=f++,n="v?"+k[b]+k[i]+"?"+k[S]+"?";k[C]="^"+n+"$";var a="[v=\\s]*"+k[p]+k[c]+"?"+k[S]+"?",r=f++;k[r]="^"+a+"$";var s=f++;k[s]="((?:<|>)?=?)";var v=f++;k[v]=k[D]+"|x|X|\\*";var $=f++;k[$]=k[P]+"|x|X|\\*";var w=f++;k[w]="[v=\\s]*("+k[$]+")(?:\\.("+k[$]+")(?:\\.("+k[$]+")(?:"+k[i]+")?"+k[S]+"?)?)?";var E=f++;k[E]="[v=\\s]*("+k[v]+")(?:\\.("+k[v]+")(?:\\.("+k[v]+")(?:"+k[c]+")?"+k[S]+"?)?)?";var o=f++;k[o]="^"+k[s]+"\\s*"+k[w]+"$";var l=f++;k[l]="^"+k[s]+"\\s*"+k[E]+"$";var m=f++;k[m]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var F=f++;k[F]="(?:~>?)";var W=f++;k[W]="(\\s*)"+k[F]+"\\s+",d[W]=new RegExp(k[W],"g");var V=f++;k[V]="^"+k[F]+k[w]+"$";var B=f++;k[B]="^"+k[F]+k[E]+"$";var j=f++;k[j]="(?:\\^)";var U=f++;k[U]="(\\s*)"+k[j]+"\\s+",d[U]=new RegExp(k[U],"g");var z=f++;k[z]="^"+k[j]+k[w]+"$";var ne=f++;k[ne]="^"+k[j]+k[E]+"$";var Z=f++;k[Z]="^"+k[s]+"\\s*("+a+")$|^$";var we=f++;k[we]="^"+k[s]+"\\s*("+n+")$|^$";var Ee=f++;k[Ee]="(\\s*)"+k[s]+"\\s*("+a+"|"+k[w]+")",d[Ee]=new RegExp(k[Ee],"g");var Re=f++;k[Re]="^\\s*("+k[w]+")\\s+-\\s+("+k[w]+")\\s*$";var X=f++;k[X]="^\\s*("+k[E]+")\\s+-\\s+("+k[E]+")\\s*$";var de=f++;k[de]="(<|>)?=?\\s*\\*";for(var Ce=0;Ce<35;Ce++)I(Ce,k[Ce]),d[Ce]||(d[Ce]=new RegExp(k[Ce]));function ae(K,ee){if(K instanceof _)return K;if(typeof K!="string"||K.length>M||!(ee?d[r]:d[C]).test(K))return null;try{return new _(K,ee)}catch{return null}}function _(K,ee){if(K instanceof _){if(K.loose===ee)return K;K=K.version}else if(typeof K!="string")throw new TypeError("Invalid Version: "+K);if(K.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof _))return new _(K,ee);I("SemVer",K,ee),this.loose=ee;var ce=K.trim().match(ee?d[r]:d[C]);if(!ce)throw new TypeError("Invalid Version: "+K);if(this.raw=K,this.major=+ce[1],this.minor=+ce[2],this.patch=+ce[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");ce[4]?this.prerelease=ce[4].split(".").map(function(ze){if(/^[0-9]+$/.test(ze)){var Ue=+ze;if(Ue>=0&&Ue<A)return Ue}return ze}):this.prerelease=[],this.build=ce[5]?ce[5].split("."):[],this.format()}e.parse=ae,e.valid=function(K,ee){var ce=ae(K,ee);return ce?ce.version:null},e.clean=function(K,ee){var ce=ae(K.trim().replace(/^[=v]+/,""),ee);return ce?ce.version:null},e.SemVer=_,_.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},_.prototype.toString=function(){return this.version},_.prototype.compare=function(K){return I("SemVer.compare",this.version,this.loose,K),K instanceof _||(K=new _(K,this.loose)),this.compareMain(K)||this.comparePre(K)},_.prototype.compareMain=function(K){return K instanceof _||(K=new _(K,this.loose)),O(this.major,K.major)||O(this.minor,K.minor)||O(this.patch,K.patch)},_.prototype.comparePre=function(K){if(K instanceof _||(K=new _(K,this.loose)),this.prerelease.length&&!K.prerelease.length)return-1;if(!this.prerelease.length&&K.prerelease.length)return 1;if(!this.prerelease.length&&!K.prerelease.length)return 0;var ee=0;do{var ce=this.prerelease[ee],ze=K.prerelease[ee];if(I("prerelease compare",ee,ce,ze),ce===void 0&&ze===void 0)return 0;if(ze===void 0)return 1;if(ce===void 0)return-1;if(ce!==ze)return O(ce,ze)}while(++ee)},_.prototype.inc=function(K,ee){switch(K){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ee);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ee);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ee),this.inc("pre",ee);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ee),this.inc("pre",ee);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ce=this.prerelease.length;--ce>=0;)typeof this.prerelease[ce]=="number"&&(this.prerelease[ce]++,ce=-2);ce===-1&&this.prerelease.push(0)}ee&&(this.prerelease[0]===ee?isNaN(this.prerelease[1])&&(this.prerelease=[ee,0]):this.prerelease=[ee,0]);break;default:throw new Error("invalid increment argument: "+K)}return this.format(),this.raw=this.version,this},e.inc=function(K,ee,ce,ze){typeof ce=="string"&&(ze=ce,ce=void 0);try{return new _(K,ce).inc(ee,ze).version}catch{return null}},e.diff=function(K,ee){if(ve(K,ee))return null;var ce=ae(K),ze=ae(ee);if(ce.prerelease.length||ze.prerelease.length){for(var Ue in ce)if((Ue==="major"||Ue==="minor"||Ue==="patch")&&ce[Ue]!==ze[Ue])return"pre"+Ue;return"prerelease"}for(var Ue in ce)if((Ue==="major"||Ue==="minor"||Ue==="patch")&&ce[Ue]!==ze[Ue])return Ue},e.compareIdentifiers=O;var ue=/^[0-9]+$/;function O(K,ee){var ce=ue.test(K),ze=ue.test(ee);return ce&&ze&&(K=+K,ee=+ee),ce&&!ze?-1:ze&&!ce?1:K<ee?-1:K>ee?1:0}function J(K,ee,ce){return new _(K,ce).compare(new _(ee,ce))}function le(K,ee,ce){return J(K,ee,ce)>0}function ye(K,ee,ce){return J(K,ee,ce)<0}function ve(K,ee,ce){return J(K,ee,ce)===0}function be(K,ee,ce){return J(K,ee,ce)!==0}function ke(K,ee,ce){return J(K,ee,ce)>=0}function oe(K,ee,ce){return J(K,ee,ce)<=0}function he(K,ee,ce,ze){var Ue;switch(ee){case"===":typeof K=="object"&&(K=K.version),typeof ce=="object"&&(ce=ce.version),Ue=K===ce;break;case"!==":typeof K=="object"&&(K=K.version),typeof ce=="object"&&(ce=ce.version),Ue=K!==ce;break;case"":case"=":case"==":Ue=ve(K,ce,ze);break;case"!=":Ue=be(K,ce,ze);break;case">":Ue=le(K,ce,ze);break;case">=":Ue=ke(K,ce,ze);break;case"<":Ue=ye(K,ce,ze);break;case"<=":Ue=oe(K,ce,ze);break;default:throw new TypeError("Invalid operator: "+ee)}return Ue}function re(K,ee){if(K instanceof re){if(K.loose===ee)return K;K=K.value}if(!(this instanceof re))return new re(K,ee);I("comparator",K,ee),this.loose=ee,this.parse(K),this.semver===ie?this.value="":this.value=this.operator+this.semver.version,I("comp",this)}e.rcompareIdentifiers=function(K,ee){return O(ee,K)},e.major=function(K,ee){return new _(K,ee).major},e.minor=function(K,ee){return new _(K,ee).minor},e.patch=function(K,ee){return new _(K,ee).patch},e.compare=J,e.compareLoose=function(K,ee){return J(K,ee,!0)},e.rcompare=function(K,ee,ce){return J(ee,K,ce)},e.sort=function(K,ee){return K.sort(function(ce,ze){return e.compare(ce,ze,ee)})},e.rsort=function(K,ee){return K.sort(function(ce,ze){return e.rcompare(ce,ze,ee)})},e.gt=le,e.lt=ye,e.eq=ve,e.neq=be,e.gte=ke,e.lte=oe,e.cmp=he,e.Comparator=re;var ie={};function ge(K,ee){if(K instanceof ge)return K.loose===ee?K:new ge(K.raw,ee);if(K instanceof re)return new ge(K.value,ee);if(!(this instanceof ge))return new ge(K,ee);if(this.loose=ee,this.raw=K,this.set=K.split(/\s*\|\|\s*/).map(function(ce){return this.parseRange(ce.trim())},this).filter(function(ce){return ce.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+K);this.format()}function Se(K){return!K||K.toLowerCase()==="x"||K==="*"}function L(K,ee,ce,ze,Ue,Qe,He,et,Xe,xe,it,tt,Ne){return((ee=Se(ce)?"":Se(ze)?">="+ce+".0.0":Se(Ue)?">="+ce+"."+ze+".0":">="+ee)+" "+(et=Se(Xe)?"":Se(xe)?"<"+(+Xe+1)+".0.0":Se(it)?"<"+Xe+"."+(+xe+1)+".0":tt?"<="+Xe+"."+xe+"."+it+"-"+tt:"<="+et)).trim()}function q(K,ee){for(var ce=0;ce<K.length;ce++)if(!K[ce].test(ee))return!1;if(ee.prerelease.length){for(ce=0;ce<K.length;ce++)if(I(K[ce].semver),K[ce].semver!==ie&&K[ce].semver.prerelease.length>0){var ze=K[ce].semver;if(ze.major===ee.major&&ze.minor===ee.minor&&ze.patch===ee.patch)return!0}return!1}return!0}function G(K,ee,ce){try{ee=new ge(ee,ce)}catch{return!1}return ee.test(K)}function Q(K,ee,ce,ze){var Ue,Qe,He,et,Xe;switch(K=new _(K,ze),ee=new ge(ee,ze),ce){case">":Ue=le,Qe=oe,He=ye,et=">",Xe=">=";break;case"<":Ue=ye,Qe=ke,He=le,et="<",Xe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(G(K,ee,ze))return!1;for(var xe=0;xe<ee.set.length;++xe){var it=ee.set[xe],tt=null,Ne=null;if(it.forEach(function(st){st.semver===ie&&(st=new re(">=0.0.0")),tt=tt||st,Ne=Ne||st,Ue(st.semver,tt.semver,ze)?tt=st:He(st.semver,Ne.semver,ze)&&(Ne=st)}),tt.operator===et||tt.operator===Xe||(!Ne.operator||Ne.operator===et)&&Qe(K,Ne.semver)||Ne.operator===Xe&&He(K,Ne.semver))return!1}return!0}re.prototype.parse=function(K){var ee=this.loose?d[Z]:d[we],ce=K.match(ee);if(!ce)throw new TypeError("Invalid comparator: "+K);this.operator=ce[1],this.operator==="="&&(this.operator=""),ce[2]?this.semver=new _(ce[2],this.loose):this.semver=ie},re.prototype.toString=function(){return this.value},re.prototype.test=function(K){return I("Comparator.test",K,this.loose),this.semver===ie||(typeof K=="string"&&(K=new _(K,this.loose)),he(K,this.operator,this.semver,this.loose))},re.prototype.intersects=function(K,ee){if(!(K instanceof re))throw new TypeError("a Comparator is required");var ce;if(this.operator==="")return ce=new ge(K.value,ee),G(this.value,ce,ee);if(K.operator==="")return ce=new ge(this.value,ee),G(K.semver,ce,ee);var ze=!(this.operator!==">="&&this.operator!==">"||K.operator!==">="&&K.operator!==">"),Ue=!(this.operator!=="<="&&this.operator!=="<"||K.operator!=="<="&&K.operator!=="<"),Qe=this.semver.version===K.semver.version,He=!(this.operator!==">="&&this.operator!=="<="||K.operator!==">="&&K.operator!=="<="),et=he(this.semver,"<",K.semver,ee)&&(this.operator===">="||this.operator===">")&&(K.operator==="<="||K.operator==="<"),Xe=he(this.semver,">",K.semver,ee)&&(this.operator==="<="||this.operator==="<")&&(K.operator===">="||K.operator===">");return ze||Ue||Qe&&He||et||Xe},e.Range=ge,ge.prototype.format=function(){return this.range=this.set.map(function(K){return K.join(" ").trim()}).join("||").trim(),this.range},ge.prototype.toString=function(){return this.range},ge.prototype.parseRange=function(K){var ee=this.loose;K=K.trim(),I("range",K,ee);var ce=ee?d[X]:d[Re];K=K.replace(ce,L),I("hyphen replace",K),K=K.replace(d[Ee],"$1$2$3"),I("comparator trim",K,d[Ee]),K=(K=(K=K.replace(d[W],"$1~")).replace(d[U],"$1^")).split(/\s+/).join(" ");var ze=ee?d[Z]:d[we],Ue=K.split(" ").map(function(Qe){return function(He,et){return I("comp",He),He=function(Xe,xe){return Xe.trim().split(/\s+/).map(function(it){return function(tt,Ne){I("caret",tt,Ne);var st=Ne?d[ne]:d[z];return tt.replace(st,function(x,Y,$e,je,Oe){var Ye;return I("caret",tt,x,Y,$e,je,Oe),Se(Y)?Ye="":Se($e)?Ye=">="+Y+".0.0 <"+(+Y+1)+".0.0":Se(je)?Ye=Y==="0"?">="+Y+"."+$e+".0 <"+Y+"."+(+$e+1)+".0":">="+Y+"."+$e+".0 <"+(+Y+1)+".0.0":Oe?(I("replaceCaret pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Ye=Y==="0"?$e==="0"?">="+Y+"."+$e+"."+je+Oe+" <"+Y+"."+$e+"."+(+je+1):">="+Y+"."+$e+"."+je+Oe+" <"+Y+"."+(+$e+1)+".0":">="+Y+"."+$e+"."+je+Oe+" <"+(+Y+1)+".0.0"):(I("no pr"),Ye=Y==="0"?$e==="0"?">="+Y+"."+$e+"."+je+" <"+Y+"."+$e+"."+(+je+1):">="+Y+"."+$e+"."+je+" <"+Y+"."+(+$e+1)+".0":">="+Y+"."+$e+"."+je+" <"+(+Y+1)+".0.0"),I("caret return",Ye),Ye})}(it,xe)}).join(" ")}(He,et),I("caret",He),He=function(Xe,xe){return Xe.trim().split(/\s+/).map(function(it){return function(tt,Ne){var st=Ne?d[B]:d[V];return tt.replace(st,function(x,Y,$e,je,Oe){var Ye;return I("tilde",tt,x,Y,$e,je,Oe),Se(Y)?Ye="":Se($e)?Ye=">="+Y+".0.0 <"+(+Y+1)+".0.0":Se(je)?Ye=">="+Y+"."+$e+".0 <"+Y+"."+(+$e+1)+".0":Oe?(I("replaceTilde pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Ye=">="+Y+"."+$e+"."+je+Oe+" <"+Y+"."+(+$e+1)+".0"):Ye=">="+Y+"."+$e+"."+je+" <"+Y+"."+(+$e+1)+".0",I("tilde return",Ye),Ye})}(it,xe)}).join(" ")}(He,et),I("tildes",He),He=function(Xe,xe){return I("replaceXRanges",Xe,xe),Xe.split(/\s+/).map(function(it){return function(tt,Ne){tt=tt.trim();var st=Ne?d[l]:d[o];return tt.replace(st,function(x,Y,$e,je,Oe,Ye){I("xRange",tt,x,Y,$e,je,Oe,Ye);var nt=Se($e),ft=nt||Se(je),bt=ft||Se(Oe);return Y==="="&&bt&&(Y=""),nt?x=Y===">"||Y==="<"?"<0.0.0":"*":Y&&bt?(ft&&(je=0),bt&&(Oe=0),Y===">"?(Y=">=",ft?($e=+$e+1,je=0,Oe=0):bt&&(je=+je+1,Oe=0)):Y==="<="&&(Y="<",ft?$e=+$e+1:je=+je+1),x=Y+$e+"."+je+"."+Oe):ft?x=">="+$e+".0.0 <"+(+$e+1)+".0.0":bt&&(x=">="+$e+"."+je+".0 <"+$e+"."+(+je+1)+".0"),I("xRange return",x),x})}(it,xe)}).join(" ")}(He,et),I("xrange",He),He=function(Xe,xe){return I("replaceStars",Xe,xe),Xe.trim().replace(d[de],"")}(He,et),I("stars",He),He}(Qe,ee)}).join(" ").split(/\s+/);return this.loose&&(Ue=Ue.filter(function(Qe){return!!Qe.match(ze)})),Ue=Ue.map(function(Qe){return new re(Qe,ee)})},ge.prototype.intersects=function(K,ee){if(!(K instanceof ge))throw new TypeError("a Range is required");return this.set.some(function(ce){return ce.every(function(ze){return K.set.some(function(Ue){return Ue.every(function(Qe){return ze.intersects(Qe,ee)})})})})},e.toComparators=function(K,ee){return new ge(K,ee).set.map(function(ce){return ce.map(function(ze){return ze.value}).join(" ").trim().split(" ")})},ge.prototype.test=function(K){if(!K)return!1;typeof K=="string"&&(K=new _(K,this.loose));for(var ee=0;ee<this.set.length;ee++)if(q(this.set[ee],K))return!0;return!1},e.satisfies=G,e.maxSatisfying=function(K,ee,ce){var ze=null,Ue=null;try{var Qe=new ge(ee,ce)}catch{return null}return K.forEach(function(He){Qe.test(He)&&(ze&&Ue.compare(He)!==-1||(Ue=new _(ze=He,ce)))}),ze},e.minSatisfying=function(K,ee,ce){var ze=null,Ue=null;try{var Qe=new ge(ee,ce)}catch{return null}return K.forEach(function(He){Qe.test(He)&&(ze&&Ue.compare(He)!==1||(Ue=new _(ze=He,ce)))}),ze},e.validRange=function(K,ee){try{return new ge(K,ee).range||"*"}catch{return null}},e.ltr=function(K,ee,ce){return Q(K,ee,"<",ce)},e.gtr=function(K,ee,ce){return Q(K,ee,">",ce)},e.outside=Q,e.prerelease=function(K,ee){var ce=ae(K,ee);return ce&&ce.prerelease.length?ce.prerelease:null},e.intersects=function(K,ee,ce){return K=new ge(K,ce),ee=new ge(ee,ce),K.intersects(ee)},e.coerce=function(K){if(K instanceof _)return K;if(typeof K!="string")return null;var ee=K.match(d[m]);return ee==null?null:ae((ee[1]||"0")+"."+(ee[2]||"0")+"."+(ee[3]||"0"))}}).call(this,y(1))},function(pe,e){var y,R,I=pe.exports={};function M(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function d(t){if(y===setTimeout)return setTimeout(t,0);if((y===M||!y)&&setTimeout)return y=setTimeout,setTimeout(t,0);try{return y(t,0)}catch{try{return y.call(null,t,0)}catch{return y.call(this,t,0)}}}(function(){try{y=typeof setTimeout=="function"?setTimeout:M}catch{y=M}try{R=typeof clearTimeout=="function"?clearTimeout:A}catch{R=A}})();var k,f=[],P=!1,D=-1;function u(){P&&k&&(P=!1,k.length?f=k.concat(f):D=-1,f.length&&b())}function b(){if(!P){var t=d(u);P=!0;for(var i=f.length;i;){for(k=f,f=[];++D<i;)k&&k[D].run();D=-1,i=f.length}k=null,P=!1,function(c){if(R===clearTimeout)return clearTimeout(c);if((R===A||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(c);try{R(c)}catch{try{return R.call(null,c)}catch{return R.call(this,c)}}}(t)}}function p(t,i){this.fun=t,this.array=i}function h(){}I.nextTick=function(t){var i=new Array(arguments.length-1);if(arguments.length>1)for(var c=1;c<arguments.length;c++)i[c-1]=arguments[c];f.push(new p(t,i)),f.length!==1||P||d(b)},p.prototype.run=function(){this.fun.apply(null,this.array)},I.title="browser",I.browser=!0,I.env={},I.argv=[],I.version="",I.versions={},I.on=h,I.addListener=h,I.once=h,I.off=h,I.removeListener=h,I.removeAllListeners=h,I.emit=h,I.prependListener=h,I.prependOnceListener=h,I.listeners=function(t){return[]},I.binding=function(t){throw new Error("process.binding is not supported")},I.cwd=function(){return"/"},I.chdir=function(t){throw new Error("process.chdir is not supported")},I.umask=function(){return 0}}])}),define(Pe[119],Ae([1,0,9,6]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dc=e.$Cc=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=e.$wc=e.$vc=e.$uc=e.$tc=e.$sc=e.$rc=e.$qc=e.$pc=void 0;function I(S){const C=S;return C?typeof C.read=="function":!1}e.$pc=I;function M(S){const C=S;return C?[C.on,C.pause,C.resume,C.destroy].every(n=>typeof n=="function"):!1}e.$qc=M;function A(S){const C=S;return C?M(C.stream)&&Array.isArray(C.buffer)&&typeof C.ended=="boolean":!1}e.$rc=A;function d(S,C){return new k(S,C)}e.$sc=d;class k{constructor(C,n){this.e=C,this.f=n,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(C){if(!this.a.destroyed){if(this.a.flowing)this.g(C);else if(this.b.data.push(C),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(n=>this.d.push(n))}}error(C){this.a.destroyed||(this.a.flowing?this.h(C):this.b.error.push(C))}end(C){this.a.destroyed||(typeof C<"u"&&this.write(C),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(C){this.c.data.slice(0).forEach(n=>n(C))}h(C){this.c.error.length===0?(0,y.$Y)(C):this.c.error.slice(0).forEach(n=>n(C))}i(){this.c.end.slice(0).forEach(C=>C())}on(C,n){if(!this.a.destroyed)switch(C){case"data":this.c.data.push(n),this.resume();break;case"end":this.c.end.push(n),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(n),this.a.flowing&&this.k();break}}removeListener(C,n){if(this.a.destroyed)return;let a;switch(C){case"data":a=this.c.data;break;case"end":a=this.c.end;break;case"error":a=this.c.error;break}if(a){const r=a.indexOf(n);r>=0&&a.splice(r,1)}}j(){if(this.b.data.length>0){const C=this.e(this.b.data);this.g(C),this.b.data.length=0;const n=[...this.d];this.d.length=0,n.forEach(a=>a())}}k(){if(this.c.error.length>0){for(const C of this.b.error)this.h(C);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function f(S,C){const n=[];let a;for(;(a=S.read())!==null;)n.push(a);return C(n)}e.$tc=f;function P(S,C,n){const a=[];let r;for(;(r=S.read())!==null&&a.length<n;)a.push(r);return r===null&&a.length>0?C(a):{read:()=>{if(a.length>0)return a.shift();if(typeof r<"u"){const s=r;return r=void 0,s}return S.read()}}}e.$uc=P;function D(S,C){return new Promise((n,a)=>{const r=[];u(S,{onData:s=>{C&&r.push(s)},onError:s=>{C?a(s):n(void 0)},onEnd:()=>{n(C?C(r):void 0)}})})}e.$vc=D;function u(S,C,n){S.on("error",a=>{n?.isCancellationRequested||C.onError(a)}),S.on("end",()=>{n?.isCancellationRequested||C.onEnd()}),S.on("data",a=>{n?.isCancellationRequested||C.onData(a)})}e.$wc=u;function b(S,C){return new Promise((n,a)=>{const r=new R.$kb,s=[],v=E=>{if(s.push(E),s.length>C)return r.dispose(),S.pause(),n({stream:S,buffer:s,ended:!1})},$=E=>a(E),w=()=>n({stream:S,buffer:s,ended:!0});r.add((0,R.$jb)(()=>S.removeListener("error",$))),S.on("error",$),r.add((0,R.$jb)(()=>S.removeListener("end",w))),S.on("end",w),r.add((0,R.$jb)(()=>S.removeListener("data",v))),S.on("data",v)})}e.$xc=b;function p(S,C){const n=d(C);return n.end(S),n}e.$yc=p;function h(){const S=d(()=>{throw new Error("not supported")});return S.end(),S}e.$zc=h;function t(S){let C=!1;return{read:()=>C?null:(C=!0,S)}}e.$Ac=t;function i(S,C,n){const a=d(n);return u(S,{onData:r=>a.write(C.data(r)),onError:r=>a.error(C.error?C.error(r):r),onEnd:()=>a.end()}),a}e.$Bc=i;function c(S,C,n){let a=!1;return{read:()=>{const r=C.read();return a?r:(a=!0,r!==null?n([S,r]):S)}}}e.$Cc=c;function g(S,C,n){let a=!1;const r=d(n);return u(C,{onData:s=>a?r.write(s):(a=!0,r.write(n([S,s]))),onError:s=>r.error(s),onEnd:()=>{a||(a=!0,r.write(S)),r.end()}}),r}e.$Dc=g}),define(Pe[25],Ae([1,0,66,119]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=e.$Fc=e.$Ec=void 0;const I=typeof Buffer<"u",M=new y.$T(()=>new Uint8Array(256));let A,d;class k{static alloc(m){return I?new k(Buffer.allocUnsafe(m)):new k(new Uint8Array(m))}static wrap(m){return I&&!Buffer.isBuffer(m)&&(m=Buffer.from(m.buffer,m.byteOffset,m.byteLength)),new k(m)}static fromString(m,F){return!(F?.dontUseNodeBuffer||!1)&&I?new k(Buffer.from(m)):(A||(A=new TextEncoder),new k(A.encode(m)))}static fromByteArray(m){const F=k.alloc(m.length);for(let W=0,V=m.length;W<V;W++)F.buffer[W]=m[W];return F}static concat(m,F){if(typeof F>"u"){F=0;for(let B=0,j=m.length;B<j;B++)F+=m[B].byteLength}const W=k.alloc(F);let V=0;for(let B=0,j=m.length;B<j;B++){const U=m[B];W.set(U,V),V+=U.byteLength}return W}constructor(m){this.buffer=m,this.byteLength=this.buffer.byteLength}clone(){const m=k.alloc(this.byteLength);return m.set(this),m}toString(){return I?this.buffer.toString():(d||(d=new TextDecoder),d.decode(this.buffer))}slice(m,F){return new k(this.buffer.subarray(m,F))}set(m,F){if(m instanceof k)this.buffer.set(m.buffer,F);else if(m instanceof Uint8Array)this.buffer.set(m,F);else if(m instanceof ArrayBuffer)this.buffer.set(new Uint8Array(m),F);else if(ArrayBuffer.isView(m))this.buffer.set(new Uint8Array(m.buffer,m.byteOffset,m.byteLength),F);else throw new Error("Unknown argument 'array'")}readUInt32BE(m){return u(this.buffer,m)}writeUInt32BE(m,F){b(this.buffer,m,F)}readUInt32LE(m){return p(this.buffer,m)}writeUInt32LE(m,F){h(this.buffer,m,F)}readUInt8(m){return t(this.buffer,m)}writeUInt8(m,F){i(this.buffer,m,F)}indexOf(m,F=0){return f(this.buffer,m instanceof k?m.buffer:m,F)}}e.$Ec=k;function f(l,m,F=0){const W=m.byteLength,V=l.byteLength;if(W===0)return 0;if(W===1)return l.indexOf(m[0]);if(W>V-F)return-1;const B=M.value;B.fill(m.length);for(let ne=0;ne<m.length;ne++)B[m[ne]]=m.length-ne-1;let j=F+m.length-1,U=j,z=-1;for(;j<V;)if(l[j]===m[U]){if(U===0){z=j;break}j--,U--}else j+=Math.max(m.length-U,B[l[j]]),U=m.length-1;return z}e.$Fc=f;function P(l,m){return l[m+0]<<0>>>0|l[m+1]<<8>>>0}e.$Gc=P;function D(l,m,F){l[F+0]=m&255,m=m>>>8,l[F+1]=m&255}e.$Hc=D;function u(l,m){return l[m]*2**24+l[m+1]*2**16+l[m+2]*2**8+l[m+3]}e.$Ic=u;function b(l,m,F){l[F+3]=m,m=m>>>8,l[F+2]=m,m=m>>>8,l[F+1]=m,m=m>>>8,l[F]=m}e.$Jc=b;function p(l,m){return l[m+0]<<0>>>0|l[m+1]<<8>>>0|l[m+2]<<16>>>0|l[m+3]<<24>>>0}e.$Kc=p;function h(l,m,F){l[F+0]=m&255,m=m>>>8,l[F+1]=m&255,m=m>>>8,l[F+2]=m&255,m=m>>>8,l[F+3]=m&255}e.$Lc=h;function t(l,m){return l[m]}e.$Mc=t;function i(l,m,F){l[F]=m}e.$Nc=i;function c(l){return R.$tc(l,m=>k.concat(m))}e.$Oc=c;function g(l){return R.$Ac(l)}e.$Pc=g;function S(l){return R.$vc(l,m=>k.concat(m))}e.$Qc=S;async function C(l){return l.ended?k.concat(l.buffer):k.concat([...l.buffer,await S(l.stream)])}e.$Rc=C;function n(l){return R.$yc(l,m=>k.concat(m))}e.$Sc=n;function a(l){return R.$Bc(l,{data:m=>typeof m=="string"?k.fromString(m):k.wrap(m)},m=>k.concat(m))}e.$Tc=a;function r(l){return R.$sc(m=>k.concat(m),l)}e.$Uc=r;function s(l,m){return R.$Cc(l,m,F=>k.concat(F))}e.$Vc=s;function v(l,m){return R.$Dc(l,m,F=>k.concat(F))}e.$Wc=v;function $(l){let m=0,F=0,W=0;const V=new Uint8Array(Math.floor(l.length/4*3)),B=U=>{switch(F){case 3:V[W++]=m|U,F=0;break;case 2:V[W++]=m|U>>>2,m=U<<6,F=3;break;case 1:V[W++]=m|U>>>4,m=U<<4,F=2;break;default:m=U<<2,F=1}};for(let U=0;U<l.length;U++){const z=l.charCodeAt(U);if(z>=65&&z<=90)B(z-65);else if(z>=97&&z<=122)B(z-97+26);else if(z>=48&&z<=57)B(z-48+52);else if(z===43||z===45)B(62);else if(z===47||z===95)B(63);else{if(z===61)break;throw new SyntaxError(`Unexpected base64 character ${l[U]}`)}}const j=W;for(;F>0;)B(0);return k.wrap(V).slice(0,j)}e.$Xc=$;const w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",E="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function o({buffer:l},m=!0,F=!1){const W=F?E:w;let V="";const B=l.byteLength%3;let j=0;for(;j<l.byteLength-B;j+=3){const U=l[j+0],z=l[j+1],ne=l[j+2];V+=W[U>>>2],V+=W[(U<<4|z>>>4)&63],V+=W[(z<<2|ne>>>6)&63],V+=W[ne&63]}if(B===1){const U=l[j+0];V+=W[U>>>2],V+=W[U<<4&63],m&&(V+="==")}else if(B===2){const U=l[j+0],z=l[j+1];V+=W[U>>>2],V+=W[(U<<4|z>>>4)&63],V+=W[z<<2&63],m&&(V+="=")}return V}e.$Yc=o}),define(Pe[120],Ae([1,0,28,15]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zj=e.$yj=e.$xj=e.$wj=e.FuzzyScore=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.or=void 0;function I(...re){return function(ie,ge){for(let Se=0,L=re.length;Se<L;Se++){const q=re[Se](ie,ge);if(q)return q}return null}}e.or=I,e.$kj=M.bind(void 0,!1),e.$lj=M.bind(void 0,!0);function M(re,ie,ge){if(!ge||ge.length<ie.length)return null;let Se;return re?Se=R.$Md(ge,ie):Se=ge.indexOf(ie)===0,Se?ie.length>0?[{start:0,end:ie.length}]:[]:null}function A(re,ie){const ge=ie.toLowerCase().indexOf(re.toLowerCase());return ge===-1?null:[{start:ge,end:ge+re.length}]}e.$mj=A;function d(re,ie){return k(re.toLowerCase(),ie.toLowerCase(),0,0)}e.$nj=d;function k(re,ie,ge,Se){if(ge===re.length)return[];if(Se===ie.length)return null;if(re[ge]===ie[Se]){let L=null;return(L=k(re,ie,ge+1,Se+1))?i({start:Se,end:Se+1},L):null}return k(re,ie,ge,Se+1)}function f(re){return 97<=re&&re<=122}function P(re){return 65<=re&&re<=90}e.$oj=P;function D(re){return 48<=re&&re<=57}function u(re){return re===32||re===9||re===10||re===13}const b=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(re=>b.add(re.charCodeAt(0)));function p(re){return u(re)||b.has(re)}function h(re,ie){return re===ie||p(re)&&p(ie)}function t(re){return f(re)||P(re)||D(re)}function i(re,ie){return ie.length===0?ie=[re]:re.end===ie[0].start?ie[0].start=re.start:ie.unshift(re),ie}function c(re,ie){for(let ge=ie;ge<re.length;ge++){const Se=re.charCodeAt(ge);if(P(Se)||D(Se)||ge>0&&!t(re.charCodeAt(ge-1)))return ge}return re.length}function g(re,ie,ge,Se){if(ge===re.length)return[];if(Se===ie.length)return null;if(re[ge]!==ie[Se].toLowerCase())return null;{let L=null,q=Se+1;for(L=g(re,ie,ge+1,Se+1);!L&&(q=c(ie,q))<ie.length;)L=g(re,ie,ge+1,q),q++;return L===null?null:i({start:Se,end:Se+1},L)}}function S(re){let ie=0,ge=0,Se=0,L=0,q=0;for(let ce=0;ce<re.length;ce++)q=re.charCodeAt(ce),P(q)&&ie++,f(q)&&ge++,t(q)&&Se++,D(q)&&L++;const G=ie/re.length,Q=ge/re.length,K=Se/re.length,ee=L/re.length;return{upperPercent:G,lowerPercent:Q,alphaPercent:K,numericPercent:ee}}function C(re){const{upperPercent:ie,lowerPercent:ge}=re;return ge===0&&ie>.6}function n(re){const{upperPercent:ie,lowerPercent:ge,alphaPercent:Se,numericPercent:L}=re;return ge>.2&&ie<.8&&Se>.6&&L<.2}function a(re){let ie=0,ge=0,Se=0,L=0;for(let q=0;q<re.length;q++)Se=re.charCodeAt(q),P(Se)&&ie++,f(Se)&&ge++,u(Se)&&L++;return(ie===0||ge===0)&&L===0?re.length<=30:ie<=5}function r(re,ie){if(!ie||(ie=ie.trim(),ie.length===0)||!a(re)||ie.length>60)return null;const ge=S(ie);if(!n(ge)){if(!C(ge))return null;ie=ie.toLowerCase()}let Se=null,L=0;for(re=re.toLowerCase();L<ie.length&&(Se=g(re,ie,0,L))===null;)L=c(ie,L+1);return Se}e.$pj=r;function s(re,ie,ge=!1){if(!ie||ie.length===0)return null;let Se=null,L=0;for(re=re.toLowerCase(),ie=ie.toLowerCase();L<ie.length&&(Se=v(re,ie,0,L,ge))===null;)L=$(ie,L+1);return Se}e.$qj=s;function v(re,ie,ge,Se,L){if(ge===re.length)return[];if(Se===ie.length)return null;if(h(re.charCodeAt(ge),ie.charCodeAt(Se))){let q=null,G=Se+1;if(q=v(re,ie,ge+1,Se+1,L),!L)for(;!q&&(G=$(ie,G))<ie.length;)q=v(re,ie,ge+1,G,L),G++;return q?re.charCodeAt(ge)!==ie.charCodeAt(Se)?q:i({start:Se,end:Se+1},q):null}else return null}function $(re,ie){for(let ge=ie;ge<re.length;ge++)if(p(re.charCodeAt(ge))||ge>0&&p(re.charCodeAt(ge-1)))return ge;return re.length}const w=I(e.$lj,r,A),E=I(e.$lj,r,d),o=new y.$qi(1e4);function l(re,ie,ge=!1){if(typeof re!="string"||typeof ie!="string")return null;let Se=o.get(re);Se||(Se=new RegExp(R.$vd(re),"i"),o.set(re,Se));const L=Se.exec(ie);return L?[{start:L.index,end:L.index+L[0].length}]:ge?E(re,ie):w(re,ie)}e.$rj=l;function m(re,ie){const ge=le(re,re.toLowerCase(),0,ie,ie.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return ge?W(ge):null}e.$sj=m;function F(re,ie,ge,Se,L,q){const G=Math.min(13,re.length);for(;ge<G;ge++){const Q=le(re,ie,ge,Se,L,q,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Q)return Q}return[0,q]}e.$tj=F;function W(re){if(typeof re>"u")return[];const ie=[],ge=re[1];for(let Se=re.length-1;Se>1;Se--){const L=re[Se]+ge,q=ie[ie.length-1];q&&q.end===L?q.end=L+1:ie.push({start:L,end:L+1})}return ie}e.$uj=W;const V=128;function B(){const re=[],ie=[];for(let ge=0;ge<=V;ge++)ie[ge]=0;for(let ge=0;ge<=V;ge++)re.push(ie.slice(0));return re}function j(re){const ie=[];for(let ge=0;ge<=re;ge++)ie[ge]=0;return ie}const U=j(2*V),z=j(2*V),ne=B(),Z=B(),we=B(),Ee=!1;function Re(re,ie,ge,Se,L){function q(Q,K,ee=" "){for(;Q.length<K;)Q=ee+Q;return Q}let G=` |   |${Se.split("").map(Q=>q(Q,3)).join("|")}
`;for(let Q=0;Q<=ge;Q++)Q===0?G+=" |":G+=`${ie[Q-1]}|`,G+=re[Q].slice(0,L+1).map(K=>q(K.toString(),3)).join("|")+`
`;return G}function X(re,ie,ge,Se){re=re.substr(ie),ge=ge.substr(Se),console.log(Re(Z,re,re.length,ge,ge.length)),console.log(Re(we,re,re.length,ge,ge.length)),console.log(Re(ne,re,re.length,ge,ge.length))}function de(re,ie){if(ie<0||ie>=re.length)return!1;const ge=re.codePointAt(ie);switch(ge){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!R.$5d(ge)}}function Ce(re,ie){if(ie<0||ie>=re.length)return!1;switch(re.charCodeAt(ie)){case 32:case 9:return!0;default:return!1}}function ae(re,ie,ge){return ie[re]!==ge[re]}function _(re,ie,ge,Se,L,q,G=!1){for(;ie<ge&&L<q;)re[ie]===Se[L]&&(G&&(U[ie]=L),ie+=1),L+=1;return ie===ge}e.$vj=_;var ue;(function(re){re[re.Diag=1]="Diag",re[re.Left=2]="Left",re[re.LeftLeft=3]="LeftLeft"})(ue||(ue={}));var O;(function(re){re.Default=[-100,0];function ie(ge){return!ge||ge.length===2&&ge[0]===-100&&ge[1]===0}re.isDefault=ie})(O||(e.FuzzyScore=O={}));class J{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(ie,ge){this.firstMatchCanBeWeak=ie,this.boostFullMatch=ge}}e.$wj=J;function le(re,ie,ge,Se,L,q,G=J.default){const Q=re.length>V?V:re.length,K=Se.length>V?V:Se.length;if(ge>=Q||q>=K||Q-ge>K-q||!_(ie,ge,Q,L,q,K,!0))return;ye(Q,K,ge,q,ie,L);let ee=1,ce=1,ze=ge,Ue=q;const Qe=[!1];for(ee=1,ze=ge;ze<Q;ee++,ze++){const it=U[ze],tt=z[ze],Ne=ze+1<Q?z[ze+1]:K;for(ce=it-q+1,Ue=it;Ue<Ne;ce++,Ue++){let st=Number.MIN_SAFE_INTEGER,x=!1;Ue<=tt&&(st=ve(re,ie,ze,ge,Se,L,Ue,K,q,ne[ee-1][ce-1]===0,Qe));let Y=0;st!==Number.MAX_SAFE_INTEGER&&(x=!0,Y=st+Z[ee-1][ce-1]);const $e=Ue>it,je=$e?Z[ee][ce-1]+(ne[ee][ce-1]>0?-5:0):0,Oe=Ue>it+1&&ne[ee][ce-1]>0,Ye=Oe?Z[ee][ce-2]+(ne[ee][ce-2]>0?-5:0):0;if(Oe&&(!$e||Ye>=je)&&(!x||Ye>=Y))Z[ee][ce]=Ye,we[ee][ce]=3,ne[ee][ce]=0;else if($e&&(!x||je>=Y))Z[ee][ce]=je,we[ee][ce]=2,ne[ee][ce]=0;else if(x)Z[ee][ce]=Y,we[ee][ce]=1,ne[ee][ce]=ne[ee-1][ce-1]+1;else throw new Error("not possible")}}if(Ee&&X(re,ge,Se,q),!Qe[0]&&!G.firstMatchCanBeWeak)return;ee--,ce--;const He=[Z[ee][ce],q];let et=0,Xe=0;for(;ee>=1;){let it=ce;do{const tt=we[ee][it];if(tt===3)it=it-2;else if(tt===2)it=it-1;else break}while(it>=1);et>1&&ie[ge+ee-1]===L[q+ce-1]&&!ae(it+q-1,Se,L)&&et+1>ne[ee][it]&&(it=ce),it===ce?et++:et=1,Xe||(Xe=it),ee--,ce=it-1,He.push(ce)}K===Q&&G.boostFullMatch&&(He[0]+=2);const xe=Xe-Q;return He[0]-=xe,He}e.$xj=le;function ye(re,ie,ge,Se,L,q){let G=re-1,Q=ie-1;for(;G>=ge&&Q>=Se;)L[G]===q[Q]&&(z[G]=Q,G--),Q--}function ve(re,ie,ge,Se,L,q,G,Q,K,ee,ce){if(ie[ge]!==q[G])return Number.MIN_SAFE_INTEGER;let ze=1,Ue=!1;return G===ge-Se?ze=re[ge]===L[G]?7:5:ae(G,L,q)&&(G===0||!ae(G-1,L,q))?(ze=re[ge]===L[G]?7:5,Ue=!0):de(q,G)&&(G===0||!de(q,G-1))?ze=5:(de(q,G-1)||Ce(q,G-1))&&(ze=5,Ue=!0),ze>1&&ge===Se&&(ce[0]=!0),Ue||(Ue=ae(G,L,q)||de(q,G-1)||Ce(q,G-1)),ge===Se?G>K&&(ze-=Ue?3:5):ee?ze+=Ue?2:0:ze+=Ue?0:1,G+1===Q&&(ze-=Ue?3:5),ze}function be(re,ie,ge,Se,L,q,G){return oe(re,ie,ge,Se,L,q,!0,G)}e.$yj=be;function ke(re,ie,ge,Se,L,q,G){return oe(re,ie,ge,Se,L,q,!1,G)}e.$zj=ke;function oe(re,ie,ge,Se,L,q,G,Q){let K=le(re,ie,ge,Se,L,q,Q);if(K&&!G)return K;if(re.length>=3){const ee=Math.min(7,re.length-1);for(let ce=ge+1;ce<ee;ce++){const ze=he(re,ce);if(ze){const Ue=le(ze,ze.toLowerCase(),ge,Se,L,q,Q);Ue&&(Ue[0]-=3,(!K||Ue[0]>K[0])&&(K=Ue))}}}return K}function he(re,ie){if(ie+1>=re.length)return;const ge=re[ie],Se=re[ie+1];if(ge!==Se)return re.slice(0,ie)+Se+ge+re.slice(ie+2)}}),define(Pe[29],Ae([1,0,15]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(R||(R={})),function(I){const M="error",A="warning",d="warn",k="info",f="ignore";function P(u){return u?y.$Ld(M,u)?I.Error:y.$Ld(A,u)||y.$Ld(d,u)?I.Warning:y.$Ld(k,u)?I.Info:I.Ignore:I.Ignore}I.fromValue=P;function D(u){switch(u){case I.Error:return M;case I.Warning:return A;case I.Info:return k;default:return f}}I.toString=D}(R||(R={})),e.default=R}),define(Pe[121],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bc=void 0,e.$bc=Symbol("MicrotaskDelay")}),define(Pe[48],Ae([1,0,18,15]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vh=e.$uh=e.$th=e.$sh=e.$rh=void 0;class I{constructor(){this.b="",this.c=0}reset(b){return this.b=b,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(b){const p=b.charCodeAt(0),h=this.b.charCodeAt(this.c);return p-h}value(){return this.b[this.c]}}e.$rh=I;class M{constructor(b=!0){this.e=b}reset(b){return this.b=b,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let b=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(b)this.c++;else break;else b=!1;return this}cmp(b){return this.e?(0,R.$Fd)(b,this.b,0,b.length,this.c,this.d):(0,R.$Hd)(b,this.b,0,b.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$sh=M;class A{constructor(b=!0,p=!0){this.f=b,this.g=p}reset(b){this.d=0,this.e=0,this.b=b,this.c=b.length;for(let p=b.length-1;p>=0;p--,this.c--){const h=this.b.charCodeAt(p);if(!(h===47||this.f&&h===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let b=!0;for(;this.e<this.c;this.e++){const p=this.b.charCodeAt(this.e);if(p===47||this.f&&p===92)if(b)this.d++;else break;else b=!1}return this}cmp(b){return this.g?(0,R.$Fd)(b,this.b,0,b.length,this.d,this.e):(0,R.$Hd)(b,this.b,0,b.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$th=A;var d;(function(u){u[u.Scheme=1]="Scheme",u[u.Authority=2]="Authority",u[u.Path=3]="Path",u[u.Query=4]="Query",u[u.Fragment=5]="Fragment"})(d||(d={}));class k{constructor(b,p){this.f=b,this.g=p,this.d=[],this.e=0}reset(b){return this.c=b,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(b)),this.b.reset(b.path),this.b.value()&&this.d.push(3)),this.g(b)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(b){if(this.d[this.e]===1)return(0,R.$Gd)(b,this.c.scheme);if(this.d[this.e]===2)return(0,R.$Gd)(b,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(b);if(this.d[this.e]===4)return(0,R.$Ed)(b,this.c.query);if(this.d[this.e]===5)return(0,R.$Ed)(b,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$uh=k;class f{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const b=this.right;return this.right=b.left,b.left=this,this.updateHeight(),b.updateHeight(),b}rotateRight(){const b=this.left;return this.left=b.right,b.right=this,this.updateHeight(),b.updateHeight(),b}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var P;(function(u){u[u.Left=-1]="Left",u[u.Mid=0]="Mid",u[u.Right=1]="Right"})(P||(P={}));class D{static forUris(b=()=>!1,p=()=>!1){return new D(new k(b,p))}static forPaths(b=!1){return new D(new A(void 0,!b))}static forStrings(){return new D(new I)}static forConfigKeys(){return new D(new M)}constructor(b){this.b=b}clear(){this.c=void 0}fill(b,p){if(p){const h=p.slice(0);(0,y.$Bf)(h);for(const t of h)this.set(t,b)}else{const h=b.slice(0);(0,y.$Bf)(h);for(const t of h)this.set(t[0],t[1])}}set(b,p){const h=this.b.reset(b);let t;this.c||(this.c=new f,this.c.segment=h.value());const i=[];for(t=this.c;;){const g=h.cmp(t.segment);if(g>0)t.left||(t.left=new f,t.left.segment=h.value()),i.push([-1,t]),t=t.left;else if(g<0)t.right||(t.right=new f,t.right.segment=h.value()),i.push([1,t]),t=t.right;else if(h.hasNext())h.next(),t.mid||(t.mid=new f,t.mid.segment=h.value()),i.push([0,t]),t=t.mid;else break}const c=t.value;t.value=p,t.key=b;for(let g=i.length-1;g>=0;g--){const S=i[g][1];S.updateHeight();const C=S.balanceFactor();if(C<-1||C>1){const n=i[g][0],a=i[g+1][0];if(n===1&&a===1)i[g][1]=S.rotateLeft();else if(n===-1&&a===-1)i[g][1]=S.rotateRight();else if(n===1&&a===-1)S.right=i[g+1][1]=i[g+1][1].rotateRight(),i[g][1]=S.rotateLeft();else if(n===-1&&a===1)S.left=i[g+1][1]=i[g+1][1].rotateLeft(),i[g][1]=S.rotateRight();else throw new Error;if(g>0)switch(i[g-1][0]){case-1:i[g-1][1].left=i[g][1];break;case 1:i[g-1][1].right=i[g][1];break;case 0:i[g-1][1].mid=i[g][1];break}else this.c=i[0][1]}}return c}get(b){return this.d(b)?.value}d(b){const p=this.b.reset(b);let h=this.c;for(;h;){const t=p.cmp(h.segment);if(t>0)h=h.left;else if(t<0)h=h.right;else if(p.hasNext())p.next(),h=h.mid;else break}return h}has(b){const p=this.d(b);return!(p?.value===void 0&&p?.mid===void 0)}delete(b){return this.e(b,!1)}deleteSuperstr(b){return this.e(b,!0)}e(b,p){const h=this.b.reset(b),t=[];let i=this.c;for(;i;){const c=h.cmp(i.segment);if(c>0)t.push([-1,i]),i=i.left;else if(c<0)t.push([1,i]),i=i.right;else if(h.hasNext())h.next(),t.push([0,i]),i=i.mid;else break}if(i){if(p?(i.left=void 0,i.mid=void 0,i.right=void 0,i.height=1):(i.key=void 0,i.value=void 0),!i.mid&&!i.value)if(i.left&&i.right){const c=this.f(i.right);if(c.key){const{key:g,value:S,segment:C}=c;this.e(c.key,!1),i.key=g,i.value=S,i.segment=C}}else{const c=i.left??i.right;if(t.length>0){const[g,S]=t[t.length-1];switch(g){case-1:S.left=c;break;case 0:S.mid=c;break;case 1:S.right=c;break}}else this.c=c}for(let c=t.length-1;c>=0;c--){const g=t[c][1];g.updateHeight();const S=g.balanceFactor();if(S>1?(g.right.balanceFactor()>=0||(g.right=g.right.rotateRight()),t[c][1]=g.rotateLeft()):S<-1&&(g.left.balanceFactor()<=0||(g.left=g.left.rotateLeft()),t[c][1]=g.rotateRight()),c>0)switch(t[c-1][0]){case-1:t[c-1][1].left=t[c][1];break;case 1:t[c-1][1].right=t[c][1];break;case 0:t[c-1][1].mid=t[c][1];break}else this.c=t[0][1]}}}f(b){for(;b.left;)b=b.left;return b}findSubstr(b){const p=this.b.reset(b);let h=this.c,t;for(;h;){const i=p.cmp(h.segment);if(i>0)h=h.left;else if(i<0)h=h.right;else if(p.hasNext())p.next(),t=h.value||t,h=h.mid;else break}return h&&h.value||t}findSuperstr(b){return this.g(b,!1)}g(b,p){const h=this.b.reset(b);let t=this.c;for(;t;){const i=h.cmp(t.segment);if(i>0)t=t.left;else if(i<0)t=t.right;else if(h.hasNext())h.next(),t=t.mid;else return t.mid?this.h(t.mid):p?t.value:void 0}}hasElementOrSubtree(b){return this.g(b,!0)!==void 0}forEach(b){for(const[p,h]of this)b(h,p)}*[Symbol.iterator](){yield*this.h(this.c)}h(b){const p=[];return this.j(b,p),p[Symbol.iterator]()}j(b,p){b&&(b.left&&this.j(b.left,p),b.value&&p.push([b.key,b.value]),b.mid&&this.j(b.mid,p),b.right&&this.j(b.right,p))}_isBalanced(){const b=p=>{if(!p)return!0;const h=p.balanceFactor();return h<-1||h>1?!1:b(p.left)&&b(p.right)};return b(this.c)}}e.$vh=D}),define(Pe[40],Ae([1,0,89]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Dj=e.ThemeColor=void 0;var R;(function(A){function d(k){return k&&typeof k=="object"&&typeof k.id=="string"}A.isThemeColor=d})(R||(e.ThemeColor=R={}));function I(A){return{id:A}}e.$Dj=I;var M;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const d=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function k(c){const g=d.exec(c.id);if(!g)return k(y.$Cj.error);const[,S,C]=g,n=["codicon","codicon-"+S];return C&&n.push("codicon-modifier-"+C.substring(1)),n}A.asClassNameArray=k;function f(c){return k(c).join(" ")}A.asClassName=f;function P(c){return"."+k(c).join(".")}A.asCSSSelector=P;function D(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(typeof c.color>"u"||R.isThemeColor(c.color))}A.isThemeIcon=D;const u=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function b(c){const g=u.exec(c);if(!g)return;const[,S]=g;return{id:S}}A.fromString=b;function p(c){return{id:c}}A.fromId=p;function h(c,g){let S=c.id;const C=S.lastIndexOf("~");return C!==-1&&(S=S.substring(0,C)),g&&(S=`${S}~${g}`),{id:S}}A.modify=h;function t(c){const g=c.id.lastIndexOf("~");if(g!==-1)return c.id.substring(g+1)}A.getModifier=t;function i(c,g){return c.id===g.id&&c.color?.id===g.color?.id}A.isEqual=i})(M||(e.ThemeIcon=M={}))}),define(Pe[122],Ae([1,0,120,15,40]),function(pe,e,y,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=void 0;const M="$(",A=new RegExp(`\\$\\(${I.ThemeIcon.iconNameExpression}(?:${I.ThemeIcon.iconModifierExpression})?\\)`,"g"),d=new RegExp(`(\\\\)?${A.source}`,"g");function k(i){return i.replace(d,(c,g)=>g?c:`\\${c}`)}e.$Ej=k;const f=new RegExp(`\\\\${A.source}`,"g");function P(i){return i.replace(f,c=>`\\${c}`)}e.$Fj=P;const D=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function u(i){return i.indexOf(M)===-1?i:i.replace(D,(c,g,S,C)=>S?c:g||C||"")}e.$Gj=u;function b(i){return i?i.replace(/\$\((.*?)\)/g,(c,g)=>` ${g} `).trim():""}e.$Hj=b;const p=new RegExp(`\\$\\(${I.ThemeIcon.iconNameCharacter}+\\)`,"g");function h(i){p.lastIndex=0;let c="";const g=[];let S=0;for(;;){const C=p.lastIndex,n=p.exec(i),a=i.substring(C,n?.index);if(a.length>0){c+=a;for(let r=0;r<a.length;r++)g.push(S)}if(!n)break;S+=n[0].length}return{text:c,iconOffsets:g}}e.$Ij=h;function t(i,c,g=!1){const{text:S,iconOffsets:C}=c;if(!C||C.length===0)return(0,y.$rj)(i,S,g);const n=(0,R.$td)(S," "),a=S.length-n.length,r=(0,y.$rj)(i,n,g);if(r)for(const s of r){const v=C[s.start+a]+a;s.start+=v,s.end+=v}return r}e.$Jj=t}),define(Pe[36],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3e=e.$2e=void 0;const y=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(I){return y.test(I)}e.$2e=R,e.$3e=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let I;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?I=crypto.getRandomValues.bind(crypto):I=function(d){for(let k=0;k<d.length;k++)d[k]=Math.floor(Math.random()*256);return d};const M=new Uint8Array(16),A=[];for(let d=0;d<256;d++)A.push(d.toString(16).padStart(2,"0"));return function(){I(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let k=0,f="";return f+=A[M[k++]],f+=A[M[k++]],f+=A[M[k++]],f+=A[M[k++]],f+="-",f+=A[M[k++]],f+=A[M[k++]],f+="-",f+=A[M[k++]],f+=A[M[k++]],f+="-",f+=A[M[k++]],f+=A[M[k++]],f+="-",f+=A[M[k++]],f+=A[M[k++]],f+=A[M[k++]],f+=A[M[k++]],f+=A[M[k++]],f+=A[M[k++]],f}}()}),define(Pe[123],Ae([1,0,18,67,36]),function(pe,e,y,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$is=e.$hs=e.$gs=e.$fs=e.$es=void 0;function M(D){return{asString:async()=>D,asFile:()=>{},value:typeof D=="string"?D:void 0}}e.$es=M;function A(D,u,b){const p={id:(0,I.$3e)(),name:D,uri:u,data:b};return{asString:async()=>"",asFile:()=>p,value:void 0}}e.$fs=A;class d{constructor(){this.a=new Map}get size(){let u=0;for(const b of this.a)u++;return u}has(u){return this.a.has(this.b(u))}matches(u){const b=[...this.a.keys()];return R.Iterable.some(this,([p,h])=>h.asFile())&&b.push("files"),P(k(u),b)}get(u){return this.a.get(this.b(u))?.[0]}append(u,b){const p=this.a.get(u);p?p.push(b):this.a.set(this.b(u),[b])}replace(u,b){this.a.set(this.b(u),[b])}delete(u){this.a.delete(this.b(u))}*[Symbol.iterator](){for(const[u,b]of this.a)for(const p of b)yield[u,p]}b(u){return k(u)}}e.$gs=d;function k(D){return D.toLowerCase()}function f(D,u){return P(k(D),u.map(k))}e.$hs=f;function P(D,u){if(D==="*/*")return u.length>0;if(u.includes(D))return!0;const b=D.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!b)return!1;const[p,h,t]=b;return t==="*"?u.some(i=>i.startsWith(h+"/")):!1}e.$is=Object.freeze({create:D=>(0,y.$of)(D.map(u=>u.toString())).join(`\r
`),split:D=>D.split(`\r
`),parse:D=>e.$is.split(D).filter(u=>!u.startsWith("#"))})}),define(Pe[124],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lr=void 0,e.$Lr={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Pe[125],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Is=e.$Hs=e.IndentAction=void 0;var y;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(y||(e.IndentAction=y={}));class R{constructor(d){if(this.e=null,this.f=!1,this.open=d.open,this.close=d.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(d.notIn))for(let k=0,f=d.notIn.length;k<f;k++)switch(d.notIn[k]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(d){switch(d){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(d,k){if(d.getTokenCount()===0)return!0;const f=d.findTokenIndexAtOffset(k-2),P=d.getStandardTokenType(f);return this.isOK(P)}g(d,k){for(let f=d;f<=k;f++){const P=String.fromCharCode(f);if(!this.open.includes(P)&&!this.close.includes(P))return P}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$Hs=R;class I{constructor(d){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const k of d)M(this.autoClosingPairsOpenByStart,k.open.charAt(0),k),M(this.autoClosingPairsOpenByEnd,k.open.charAt(k.open.length-1),k),M(this.autoClosingPairsCloseByStart,k.close.charAt(0),k),M(this.autoClosingPairsCloseByEnd,k.close.charAt(k.close.length-1),k),k.close.length===1&&k.open.length===1&&M(this.autoClosingPairsCloseSingleChar,k.close,k)}}e.$Is=I;function M(A,d,k){A.has(d)?A.get(d).push(k):A.set(d,[k])}}),define(Pe[126],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W6=e.$V6=void 0;class y{constructor(){this.a=new Map}removeDragOperationTransfer(M){if(M&&this.a.has(M)){const A=this.a.get(M);return this.a.delete(M),A}}addDragOperationTransfer(M,A){this.a.set(M,A)}}e.$V6=y;class R{constructor(M){this.identifier=M}}e.$W6=R}),define(Pe[127],Ae([10,11]),function(pe,e){return pe.create("vs/base/common/actions",e)}),define(Pe[128],Ae([1,0,5,6,127]),function(pe,e,y,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=void 0;class M extends R.$lb{constructor(u,b="",p="",h=!0,t){super(),this.h=this.B(new y.$ec),this.onDidChange=this.h.event,this.w=!0,this.j=u,this.m=b,this.u=p,this.w=h,this.C=t}get id(){return this.j}get label(){return this.m}set label(u){this.D(u)}D(u){this.m!==u&&(this.m=u,this.h.fire({label:u}))}get tooltip(){return this.n||""}set tooltip(u){this.F(u)}F(u){this.n!==u&&(this.n=u,this.h.fire({tooltip:u}))}get class(){return this.u}set class(u){this.G(u)}G(u){this.u!==u&&(this.u=u,this.h.fire({class:u}))}get enabled(){return this.w}set enabled(u){this.H(u)}H(u){this.w!==u&&(this.w=u,this.h.fire({enabled:u}))}get checked(){return this.z}set checked(u){this.I(u)}I(u){this.z!==u&&(this.z=u,this.h.fire({checked:u}))}async run(u,b){this.C&&await this.C(u)}}e.$7h=M;class A extends R.$lb{constructor(){super(...arguments),this.f=this.B(new y.$ec),this.onWillRun=this.f.event,this.k=this.B(new y.$ec),this.onDidRun=this.k.event}async run(u,b){if(!u.enabled)return;this.f.fire({action:u});let p;try{await this.l(u,b)}catch(h){p=h}this.k.fire({action:u,error:p})}async l(u,b){await u.run(b)}}e.$8h=A;class d{constructor(){this.id=d.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...u){let b=[];for(const p of u)p.length&&(b.length?b=[...b,new d,...p]:b=p);return b}static{this.ID="vs.actions.separator"}async run(){}}e.$9h=d;class k{get actions(){return this.a}constructor(u,b,p,h){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=u,this.label=b,this.class=h,this.a=p}async run(){}}e.$0h=k;class f extends M{static{this.ID="vs.actions.empty"}constructor(){super(f.ID,I.localize(0,null),void 0,!1)}}e.$$h=f;function P(D){return{id:D.id,label:D.label,class:void 0,enabled:D.enabled??!0,checked:D.checked??!1,run:async()=>D.run(),tooltip:D.label}}e.$_h=P}),define(Pe[129],Ae([10,11]),function(pe,e){return pe.create("vs/base/common/date",e)}),define(Pe[130],Ae([1,0,129]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=e.$Sl=void 0;const R=60,I=R*60,M=I*24,A=M*7,d=M*30,k=M*365;function f(D,u,b,p){typeof D!="number"&&(D=D.getTime());const h=Math.round((new Date().getTime()-D)/1e3);if(h<-30)return(0,y.localize)(0,null,f(new Date().getTime()+h*1e3,!1));if(!p&&h<30)return(0,y.localize)(1,null);let t;return h<R?(t=h,u?t===1?b?(0,y.localize)(2,null,t):(0,y.localize)(3,null,t):b?(0,y.localize)(4,null,t):(0,y.localize)(5,null,t):t===1?b?(0,y.localize)(6,null,t):(0,y.localize)(7,null,t):b?(0,y.localize)(8,null,t):(0,y.localize)(9,null,t)):h<I?(t=Math.floor(h/R),u?t===1?b?(0,y.localize)(10,null,t):(0,y.localize)(11,null,t):b?(0,y.localize)(12,null,t):(0,y.localize)(13,null,t):t===1?b?(0,y.localize)(14,null,t):(0,y.localize)(15,null,t):b?(0,y.localize)(16,null,t):(0,y.localize)(17,null,t)):h<M?(t=Math.floor(h/I),u?t===1?b?(0,y.localize)(18,null,t):(0,y.localize)(19,null,t):b?(0,y.localize)(20,null,t):(0,y.localize)(21,null,t):t===1?b?(0,y.localize)(22,null,t):(0,y.localize)(23,null,t):b?(0,y.localize)(24,null,t):(0,y.localize)(25,null,t)):h<A?(t=Math.floor(h/M),u?t===1?(0,y.localize)(26,null,t):(0,y.localize)(27,null,t):t===1?(0,y.localize)(28,null,t):(0,y.localize)(29,null,t)):h<d?(t=Math.floor(h/A),u?t===1?b?(0,y.localize)(30,null,t):(0,y.localize)(31,null,t):b?(0,y.localize)(32,null,t):(0,y.localize)(33,null,t):t===1?b?(0,y.localize)(34,null,t):(0,y.localize)(35,null,t):b?(0,y.localize)(36,null,t):(0,y.localize)(37,null,t)):h<k?(t=Math.floor(h/d),u?t===1?b?(0,y.localize)(38,null,t):(0,y.localize)(39,null,t):b?(0,y.localize)(40,null,t):(0,y.localize)(41,null,t):t===1?b?(0,y.localize)(42,null,t):(0,y.localize)(43,null,t):b?(0,y.localize)(44,null,t):(0,y.localize)(45,null,t)):(t=Math.floor(h/k),u?t===1?b?(0,y.localize)(46,null,t):(0,y.localize)(47,null,t):b?(0,y.localize)(48,null,t):(0,y.localize)(49,null,t):t===1?b?(0,y.localize)(50,null,t):(0,y.localize)(51,null,t):b?(0,y.localize)(52,null,t):(0,y.localize)(53,null,t))}e.$Sl=f;function P(D){return D.getFullYear()+"-"+String(D.getMonth()+1).padStart(2,"0")+"-"+String(D.getDate()).padStart(2,"0")+"T"+String(D.getHours()).padStart(2,"0")+":"+String(D.getMinutes()).padStart(2,"0")+":"+String(D.getSeconds()).padStart(2,"0")+"."+(D.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$Tl=P}),define(Pe[131],Ae([10,11]),function(pe,e){return pe.create("vs/base/common/errorMessage",e)}),define(Pe[41],Ae([1,0,18,16,131]),function(pe,e,y,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ci=e.$bi=e.$ai=void 0;function M(D,u){return u&&(D.stack||D.stacktrace)?I.localize(0,null,d(D),A(D.stack)||A(D.stacktrace)):d(D)}function A(D){return Array.isArray(D)?D.join(`
`):D}function d(D){return D.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${D.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof D.code=="string"&&typeof D.errno=="number"&&typeof D.syscall=="string"?I.localize(1,null,D.message):D.message||I.localize(2,null)}function k(D=null,u=!1){if(!D)return I.localize(3,null);if(Array.isArray(D)){const b=y.$jf(D),p=k(b[0],u);return b.length>1?I.localize(4,null,p,b.length):p}if(R.$ie(D))return D;if(D.detail){const b=D.detail;if(b.error)return M(b.error,u);if(b.exception)return M(b.exception,u)}return D.stack?M(D,u):D.message?D.message:I.localize(5,null)}e.$ai=k;function f(D){const u=D;return u instanceof Error&&Array.isArray(u.actions)}e.$bi=f;function P(D,u){let b;return typeof D=="string"?b=new Error(D):b=D,b.actions=u,b}e.$ci=P}),define(Pe[132],Ae([1,0,66,19]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=e.$_p=e.$$p=e.$0p=e.$9p=e.$8p=e.$7p=e.$6p=e.$5p=e.$4p=e.$3p=e.$2p=e.$1p=void 0;const I=new y.$T(()=>{const E=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:E,collatorIsNumeric:E.resolvedOptions().numeric}}),M=new y.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new y.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function d(E,o,l=!1){const m=E||"",F=o||"",W=I.value.collator.compare(m,F);return I.value.collatorIsNumeric&&W===0&&m!==F?m<F?-1:1:W}e.$1p=d;function k(E,o){const l=M.value.collator;return E=E||"",o=o||"",S(l,E,o)}e.$2p=k;function f(E,o){const l=M.value.collator;return E=E||"",o=o||"",r(E,o)||S(l,E,o)}e.$3p=f;function P(E,o){const l=M.value.collator;return E=E||"",o=o||"",a(E,o)||S(l,E,o)}e.$4p=P;function D(E,o){return E=E||"",o=o||"",E===o?0:E<o?-1:1}e.$5p=D;function u(E,o){const[l,m]=c(E),[F,W]=c(o);let V=I.value.collator.compare(m,W);if(V===0){if(I.value.collatorIsNumeric&&m!==W)return m<W?-1:1;if(V=I.value.collator.compare(l,F),I.value.collatorIsNumeric&&V===0&&l!==F)return l<F?-1:1}return V}e.$6p=u;function b(E,o){E=E||"",o=o||"";const l=g(E),m=g(o),F=M.value.collator,W=A.value.collator;return S(W,l,m)||S(F,E,o)}e.$7p=b;function p(E,o){E=E||"",o=o||"";const l=g(E),m=g(o),F=M.value.collator,W=A.value.collator;return S(W,l,m)||r(E,o)||S(F,E,o)}e.$8p=p;function h(E,o){E=E||"",o=o||"";const l=g(E),m=g(o),F=M.value.collator,W=A.value.collator;return S(W,l,m)||a(E,o)||S(F,E,o)}e.$9p=h;function t(E,o){E=E||"",o=o||"";const l=g(E).toLowerCase(),m=g(o).toLowerCase();return l!==m?l<m?-1:1:E!==o?E<o?-1:1:0}e.$0p=t;const i=/^(.*?)(\.([^.]*))?$/;function c(E,o=!1){const l=E?i.exec(E):[];let m=[l&&l[1]||"",l&&l[3]||""];return o&&(!m[0]&&m[1]||m[0]&&m[0].charAt(0)===".")&&(m=[m[0]+"."+m[1],""]),m}function g(E){const o=E?i.exec(E):[];return o&&o[1]&&o[1].charAt(0)!=="."&&o[3]||""}function S(E,o,l){const m=E.compare(o,l);return m!==0?m:o.length!==l.length?o.length<l.length?-1:1:0}function C(E){const o=E.charAt(0);return o.toLocaleUpperCase()!==o}function n(E){const o=E.charAt(0);return o.toLocaleLowerCase()!==o}function a(E,o){return C(E)&&n(o)?-1:n(E)&&C(o)?1:0}function r(E,o){return n(E)&&C(o)?-1:C(E)&&n(o)?1:0}function s(E,o,l=!1){return l||(E=E&&E.toLowerCase(),o=o&&o.toLowerCase()),E===o?0:E<o?-1:1}function v(E,o,l=!1){const m=E.split(R.sep),F=o.split(R.sep),W=m.length-1,V=F.length-1;let B,j;for(let U=0;;U++){if(B=W===U,j=V===U,B&&j)return d(m[U],F[U],l);if(B)return-1;if(j)return 1;const z=s(m[U],F[U],l);if(z!==0)return z}}e.$$p=v;function $(E,o,l){const m=E.toLowerCase(),F=o.toLowerCase(),W=w(E,o,l);if(W)return W;const V=m.endsWith(l),B=F.endsWith(l);if(V!==B)return V?-1:1;const j=d(m,F);return j!==0?j:m.localeCompare(F)}e.$_p=$;function w(E,o,l){const m=E.toLowerCase(),F=o.toLowerCase(),W=m.startsWith(l),V=F.startsWith(l);if(W!==V)return W?-1:1;if(W&&V){if(m.length<F.length)return-1;if(m.length>F.length)return 1}return 0}e.$aq=w}),define(Pe[42],Ae([1,0,19,22,15,16]),function(pe,e,y,R,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=void 0;function A($){return $===47||$===92}e.$Ae=A;function d($){return $.replace(/[\\/]/g,y.$5c.sep)}e.$Be=d;function k($){return $.indexOf("/")===-1&&($=d($)),/^[a-zA-Z]:(\/|$)/.test($)&&($="/"+$),$}e.$Ce=k;function f($,w=y.$5c.sep){if(!$)return"";const E=$.length,o=$.charCodeAt(0);if(A(o)){if(A($.charCodeAt(1))&&!A($.charCodeAt(2))){let m=3;const F=m;for(;m<E&&!A($.charCodeAt(m));m++);if(F!==m&&!A($.charCodeAt(m+1))){for(m+=1;m<E;m++)if(A($.charCodeAt(m)))return $.slice(0,m+1).replace(/[\\/]/g,w)}}return w}else if(i(o)&&$.charCodeAt(1)===58)return A($.charCodeAt(2))?$.slice(0,2)+w:$.slice(0,2);let l=$.indexOf("://");if(l!==-1){for(l+=3;l<E;l++)if(A($.charCodeAt(l)))return $.slice(0,l+1)}return""}e.$De=f;function P($){if(!R.$i||!$||$.length<5)return!1;let w=$.charCodeAt(0);if(w!==92||(w=$.charCodeAt(1),w!==92))return!1;let E=2;const o=E;for(;E<$.length&&(w=$.charCodeAt(E),w!==92);E++);return!(o===E||(w=$.charCodeAt(E+1),isNaN(w)||w===92))}e.$Ee=P;const D=/[\\/:\*\?"<>\|]/g,u=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function p($,w=R.$i){const E=w?D:u;return!(!$||$.length===0||/^\s+$/.test($)||(E.lastIndex=0,E.test($))||w&&b.test($)||$==="."||$===".."||w&&$[$.length-1]==="."||w&&$.length!==$.trim().length||$.length>255)}e.$Fe=p;function h($,w,E){const o=$===w;return!E||o?o:!$||!w?!1:(0,I.$Ld)($,w)}e.$Ge=h;function t($,w,E,o=y.sep){if($===w)return!0;if(!$||!w||w.length>$.length)return!1;if(E){if(!(0,I.$Md)($,w))return!1;if(w.length===$.length)return!0;let m=w.length;return w.charAt(w.length-1)===o&&m--,$.charAt(m)===o}return w.charAt(w.length-1)!==o&&(w+=o),$.indexOf(w)===0}e.$He=t;function i($){return $>=65&&$<=90||$>=97&&$<=122}e.$Ie=i;function c($,w){return R.$i&&$.endsWith(":")&&($+=y.sep),(0,y.$7c)($)||($=(0,y.$8c)(w,$)),$=(0,y.$6c)($),R.$i?($=(0,I.$ud)($,y.sep),$.endsWith(":")&&($+=y.sep)):($=(0,I.$ud)($,y.sep),$||($=y.sep)),$}e.$Je=c;function g($){const w=(0,y.$6c)($);return R.$i?$.length>3?!1:S(w)&&($.length===2||w.charCodeAt(2)===92):w===y.$5c.sep}e.$Ke=g;function S($,w=R.$i){return w?i($.charCodeAt(0))&&$.charCodeAt(1)===58:!1}e.$Le=S;function C($,w=R.$i){return S($,w)?$[0]:void 0}e.$Me=C;function n($,w,E){return w.length>$.length?-1:$===w?0:(E&&($=$.toLowerCase(),w=w.toLowerCase()),$.indexOf(w))}e.$Ne=n;function a($){const w=$.split(":");let E,o,l;for(const m of w){const F=Number(m);(0,M.$me)(F)?o===void 0?o=F:l===void 0&&(l=F):E=E?[E,m].join(":"):m}if(!E)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:E,line:o!==void 0?o:void 0,column:l!==void 0?l:o!==void 0?1:void 0}}e.$Oe=a;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",s="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function v($,w,E=8){let o="";for(let m=0;m<E;m++){let F;m===0&&R.$i&&!w&&(E===3||E===4)?F=s:F=r,o+=F.charAt(Math.floor(Math.random()*F.length))}let l;return w?l=`${w}-${o}`:l=o,$?(0,y.$8c)($,l):l}e.$Pe=v}),define(Pe[68],Ae([1,0,19]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cr=e.$Br=e.$Ar=e.$zr=e.$yr=void 0,e.$yr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const R={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},I={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function M(P){const D=(0,y.$ad)(P),u=R[D.toLowerCase()];return u!==void 0?u:A(P)}e.$zr=M;function A(P){const D=(0,y.$ad)(P);return I[D.toLowerCase()]}e.$Ar=A;function d(P){for(const D in I)if(I[D]===P)return D}e.$Br=d;const k=/^(.+)\/(.+?)(;.+)?$/;function f(P,D){const u=k.exec(P);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:D?void 0:P}e.$Cr=f}),define(Pe[69],Ae([1,0,25,2]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yg=e.$Xg=e.$Wg=void 0;function I(k){return JSON.stringify(k,A)}e.$Wg=I;function M(k){let f=JSON.parse(k);return f=d(f),f}e.$Xg=M;function A(k,f){return f instanceof RegExp?{$mid:2,source:f.source,flags:f.flags}:f}function d(k,f=0){if(!k||f>200)return k;if(typeof k=="object"){switch(k.$mid){case 1:return R.URI.revive(k);case 2:return new RegExp(k.source,k.flags);case 16:return new Date(k.source)}if(k instanceof y.$Ec||k instanceof Uint8Array)return k;if(Array.isArray(k))for(let P=0;P<k.length;++P)k[P]=d(k[P],f+1);else for(const P in k)Object.hasOwnProperty.call(k,P)&&(k[P]=d(k[P],f+1))}return k}e.$Yg=d}),define(Pe[12],Ae([1,0,9,22,2]),function(pe,e,y,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.Schemas=void 0;var M;(function(f){f.inMemory="inmemory",f.vscode="vscode",f.internal="private",f.walkThrough="walkThrough",f.walkThroughSnippet="walkThroughSnippet",f.http="http",f.https="https",f.file="file",f.mailto="mailto",f.untitled="untitled",f.data="data",f.command="command",f.vscodeRemote="vscode-remote",f.vscodeRemoteResource="vscode-remote-resource",f.vscodeManagedRemoteResource="vscode-managed-remote-resource",f.vscodeUserData="vscode-userdata",f.vscodeCustomEditor="vscode-custom-editor",f.vscodeNotebookCell="vscode-notebook-cell",f.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",f.vscodeNotebookCellOutput="vscode-notebook-cell-output",f.vscodeInteractiveInput="vscode-interactive-input",f.vscodeSettings="vscode-settings",f.vscodeWorkspaceTrust="vscode-workspace-trust",f.vscodeTerminal="vscode-terminal",f.vscodeChatSesssion="vscode-chat-editor",f.webviewPanel="webview-panel",f.vscodeWebview="vscode-webview",f.extension="extension",f.vscodeFileResource="vscode-file",f.tmp="tmp",f.vsls="vsls",f.vscodeSourceControl="vscode-scm"})(M||(e.Schemas=M={})),e.$Te="vscode-tkn",e.$Ue="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${M.vscodeRemoteResource}`}setPreferredWebSchema(P){this.d=P}setDelegate(P){this.e=P}setServerRootPath(P){this.f=`${P}/${M.vscodeRemoteResource}`}set(P,D,u){this.a[P]=D,this.b[P]=u}setConnectionToken(P,D){this.c[P]=D}getPreferredWebSchema(){return this.d}rewrite(P){if(this.e)try{return this.e(P)}catch(t){return y.$Y(t),P}const D=P.authority;let u=this.a[D];u&&u.indexOf(":")!==-1&&u.indexOf("[")===-1&&(u=`[${u}]`);const b=this.b[D],p=this.c[D];let h=`path=${encodeURIComponent(P.path)}`;return typeof p=="string"&&(h+=`&${e.$Ue}=${encodeURIComponent(p)}`),I.URI.from({scheme:R.$o?this.d:M.vscodeRemoteResource,authority:`${u}:${b}`,path:this.f,query:h})}}e.$Ve=new A,e.$We="vs/../../extensions",e.$Xe="vs/../../node_modules",e.$Ye="vs/../../node_modules.asar",e.$Ze="vs/../../node_modules.asar.unpacked";class d{static{this.a="vscode-app"}asBrowserUri(P){const D=this.b(P,pe);return this.uriToBrowserUri(D)}uriToBrowserUri(P){return P.scheme===M.vscodeRemote?e.$Ve.rewrite(P):P.scheme===M.file&&(R.$m||R.$p&&R.$g.origin===`${M.vscodeFileResource}://${d.a}`)?P.with({scheme:M.vscodeFileResource,authority:P.authority||d.a,query:null,fragment:null}):P}asFileUri(P){const D=this.b(P,pe);return this.uriToFileUri(D)}uriToFileUri(P){return P.scheme===M.vscodeFileResource?P.with({scheme:M.file,authority:P.authority!==d.a?P.authority:null,query:null,fragment:null}):P}b(P,D){return I.URI.isUri(P)?P:I.URI.parse(D.toUrl(P))}}e.$1e=new d;var k;(function(f){const P=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);f.CoopAndCoep=Object.freeze(P.get("3"));const D="vscode-coi";function u(p){let h;typeof p=="string"?h=new URL(p).searchParams:p instanceof URL?h=p.searchParams:I.URI.isUri(p)&&(h=new URL(p.toString(!0)).searchParams);const t=h?.get(D);if(t)return P.get(t)}f.getHeadersFromQuery=u;function b(p,h,t){if(!globalThis.crossOriginIsolated)return;const i=h&&t?"3":t?"2":"1";p instanceof URLSearchParams?p.set(D,i):p[D]=i}f.addSearchParam=b})(k||(e.COI=k={}))}),define(Pe[23],Ae([1,0,42,12,19,22,15,2]),function(pe,e,y,R,I,M,A,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gg=e.DataUri=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=void 0;function k(b){return(0,d.$Se)(b,!0)}e.$Wf=k;class f{constructor(p){this.a=p}compare(p,h,t=!1){return p===h?0:(0,A.$Ed)(this.getComparisonKey(p,t),this.getComparisonKey(h,t))}isEqual(p,h,t=!1){return p===h?!0:!p||!h?!1:this.getComparisonKey(p,t)===this.getComparisonKey(h,t)}getComparisonKey(p,h=!1){return p.with({path:this.a(p)?p.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(p){return this.a(p)}isEqualOrParent(p,h,t=!1){if(p.scheme===h.scheme){if(p.scheme===R.Schemas.file)return y.$He(k(p),k(h),this.a(p))&&p.query===h.query&&(t||p.fragment===h.fragment);if((0,e.$bg)(p.authority,h.authority))return y.$He(p.path,h.path,this.a(p),"/")&&p.query===h.query&&(t||p.fragment===h.fragment)}return!1}joinPath(p,...h){return d.URI.joinPath(p,...h)}basenameOrAuthority(p){return(0,e.$6f)(p)||p.authority}basename(p){return I.$5c.basename(p.path)}extname(p){return I.$5c.extname(p.path)}dirname(p){if(p.path.length===0)return p;let h;return p.scheme===R.Schemas.file?h=d.URI.file(I.$$c(k(p))).path:(h=I.$5c.dirname(p.path),p.authority&&h.length&&h.charCodeAt(0)!==47&&(console.error(`dirname("${p.toString})) resulted in a relative path`),h="/")),p.with({path:h})}normalizePath(p){if(!p.path.length)return p;let h;return p.scheme===R.Schemas.file?h=d.URI.file(I.$6c(k(p))).path:h=I.$5c.normalize(p.path),p.with({path:h})}relativePath(p,h){if(p.scheme!==h.scheme||!(0,e.$bg)(p.authority,h.authority))return;if(p.scheme===R.Schemas.file){const c=I.$0c(k(p),k(h));return M.$i?y.$Be(c):c}let t=p.path||"/";const i=h.path||"/";if(this.a(p)){let c=0;for(const g=Math.min(t.length,i.length);c<g&&!(t.charCodeAt(c)!==i.charCodeAt(c)&&t.charAt(c).toLowerCase()!==i.charAt(c).toLowerCase());c++);t=i.substr(0,c)+t.substr(c)}return I.$5c.relative(t,i)}resolvePath(p,h){if(p.scheme===R.Schemas.file){const t=d.URI.file(I.$9c(k(p),h));return p.with({authority:t.authority,path:t.path})}return h=y.$Ce(h),p.with({path:I.$5c.resolve(p.path,h)})}isAbsolutePath(p){return!!p.path&&p.path[0]==="/"}isEqualAuthority(p,h){return p===h||p!==void 0&&h!==void 0&&(0,A.$Ld)(p,h)}hasTrailingPathSeparator(p,h=I.sep){if(p.scheme===R.Schemas.file){const t=k(p);return t.length>y.$De(t).length&&t[t.length-1]===h}else{const t=p.path;return t.length>1&&t.charCodeAt(t.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(p.fsPath)}}removeTrailingPathSeparator(p,h=I.sep){return(0,e.$cg)(p,h)?p.with({path:p.path.substr(0,p.path.length-1)}):p}addTrailingPathSeparator(p,h=I.sep){let t=!1;if(p.scheme===R.Schemas.file){const i=k(p);t=i!==void 0&&i.length===y.$De(i).length&&i[i.length-1]===h}else{h="/";const i=p.path;t=i.length===1&&i.charCodeAt(i.length-1)===47}return!t&&!(0,e.$cg)(p,h)?p.with({path:p.path+"/"}):p}}e.$Xf=f,e.$Yf=new f(()=>!1),e.$Zf=new f(b=>b.scheme===R.Schemas.file?!M.$k:!0),e.$1f=new f(b=>!0),e.$2f=e.$Yf.isEqual.bind(e.$Yf),e.$3f=e.$Yf.isEqualOrParent.bind(e.$Yf),e.$4f=e.$Yf.getComparisonKey.bind(e.$Yf),e.$5f=e.$Yf.basenameOrAuthority.bind(e.$Yf),e.$6f=e.$Yf.basename.bind(e.$Yf),e.$7f=e.$Yf.extname.bind(e.$Yf),e.$8f=e.$Yf.dirname.bind(e.$Yf),e.$9f=e.$Yf.joinPath.bind(e.$Yf),e.$0f=e.$Yf.normalizePath.bind(e.$Yf),e.$$f=e.$Yf.relativePath.bind(e.$Yf),e.$_f=e.$Yf.resolvePath.bind(e.$Yf),e.$ag=e.$Yf.isAbsolutePath.bind(e.$Yf),e.$bg=e.$Yf.isEqualAuthority.bind(e.$Yf),e.$cg=e.$Yf.hasTrailingPathSeparator.bind(e.$Yf),e.$dg=e.$Yf.removeTrailingPathSeparator.bind(e.$Yf),e.$eg=e.$Yf.addTrailingPathSeparator.bind(e.$Yf);function P(b,p){const h=[];for(let t=0;t<b.length;t++){const i=p(b[t]);b.some((c,g)=>g===t?!1:(0,e.$3f)(i,p(c)))||h.push(b[t])}return h}e.$fg=P;var D;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function p(h){const t=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(g=>{const[S,C]=g.split(":");S&&C&&t.set(S,C)});const c=h.path.substring(0,h.path.indexOf(";"));return c&&t.set(b.META_DATA_MIME,c),t}b.parseMetaData=p})(D||(e.DataUri=D={}));function u(b,p,h){if(p){let t=b.path;return t&&t[0]!==I.$5c.sep&&(t=I.$5c.sep+t),b.with({scheme:h,authority:p,path:t})}return b.with({scheme:h})}e.$gg=u}),define(Pe[13],Ae([1,0,21,9,5,6,23,22,121]),function(pe,e,y,R,I,M,A,d,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sg=e.$Rg=e.$Qg=e.Promises=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=void 0;function f(O){return!!O&&typeof O.then=="function"}e.$hg=f;function P(O){const J=new y.$oc,le=O(J.token),ye=new Promise((ve,be)=>{const ke=J.token.onCancellationRequested(()=>{ke.dispose(),J.dispose(),be(new R.$3)});Promise.resolve(le).then(oe=>{ke.dispose(),J.dispose(),ve(oe)},oe=>{ke.dispose(),J.dispose(),be(oe)})});return new class{cancel(){J.cancel()}then(ve,be){return ye.then(ve,be)}catch(ve){return this.then(void 0,ve)}finally(ve){return ye.finally(ve)}}}e.$ig=P;function D(O,J,le){return new Promise((ye,ve)=>{const be=J.onCancellationRequested(()=>{be.dispose(),ye(le)});O.then(ye,ve).finally(()=>be.dispose())})}e.$jg=D;function u(O,J){return new Promise((le,ye)=>{const ve=J.onCancellationRequested(()=>{ve.dispose(),ye(new R.$3)});O.then(le,ye).finally(()=>ve.dispose())})}e.$kg=u;async function b(O){let J=-1;const le=O.map((ye,ve)=>ye.then(be=>(J=ve,be)));try{return await Promise.race(le)}finally{O.forEach((ye,ve)=>{ve!==J&&ye.cancel()})}}e.$lg=b;function p(O,J,le){let ye;const ve=setTimeout(()=>{ye?.(void 0),le?.()},J);return Promise.race([O.finally(()=>clearTimeout(ve)),new Promise(be=>ye=be)])}e.$mg=p;function h(O){return new Promise((J,le)=>{const ye=O();f(ye)?ye.then(J,le):J(ye)})}e.$ng=h;class t{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(J){if(this.f)throw new Error("Throttler is disposed");if(this.a){if(this.d=J,!this.b){const le=()=>{if(this.b=null,this.f)return;const ye=this.queue(this.d);return this.d=null,ye};this.b=new Promise(ye=>{this.a.then(le,le).then(ye)})}return new Promise((le,ye)=>{this.b.then(le,ye)})}return this.a=J(),new Promise((le,ye)=>{this.a.then(ve=>{this.a=null,le(ve)},ve=>{this.a=null,ye(ve)})})}dispose(){this.f=!0}}e.$og=t;class i{constructor(){this.a=Promise.resolve(null)}queue(J){return this.a=this.a.then(()=>J(),()=>J())}}e.$pg=i;class c{constructor(){this.a=new Map}queue(J,le){const ve=(this.a.get(J)??Promise.resolve()).catch(()=>{}).then(le).finally(()=>{this.a.get(J)===ve&&this.a.delete(J)});return this.a.set(J,ve),ve}}e.$qg=c;const g=(O,J)=>{let le=!0;const ye=setTimeout(()=>{le=!1,J()},O);return{isTriggered:()=>le,dispose:()=>{clearTimeout(ye),le=!1}}},S=O=>{let J=!0;return queueMicrotask(()=>{J&&(J=!1,O())}),{isTriggered:()=>J,dispose:()=>{J=!1}}};class C{constructor(J){this.defaultDelay=J,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(J,le=this.defaultDelay){this.g=J,this.h(),this.b||(this.b=new Promise((ve,be)=>{this.d=ve,this.f=be}).then(()=>{if(this.b=null,this.d=null,this.g){const ve=this.g;return this.g=null,ve()}}));const ye=()=>{this.a=null,this.d?.(null)};return this.a=le===k.$bc?S(ye):g(le,ye),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new R.$3),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$rg=C;class n{constructor(J){this.a=new C(J),this.b=new t}trigger(J,le){return this.a.trigger(()=>this.b.queue(J),le)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$sg=n;class a{constructor(){this.a=!1,this.b=new Promise((J,le)=>{this.d=J})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$tg=a;class r extends a{constructor(J){super(),this.f=setTimeout(()=>this.open(),J)}open(){clearTimeout(this.f),super.open()}}e.$ug=r;function s(O,J){return J?new Promise((le,ye)=>{const ve=setTimeout(()=>{be.dispose(),le()},O),be=J.onCancellationRequested(()=>{clearTimeout(ve),be.dispose(),ye(new R.$3)})}):P(le=>s(O,le))}e.$vg=s;function v(O,J=0){const le=setTimeout(O,J);return(0,M.$jb)(()=>clearTimeout(le))}e.$wg=v;function $(O){const J=[];let le=0;const ye=O.length;function ve(){return le<ye?O[le++]():null}function be(ke){ke!=null&&J.push(ke);const oe=ve();return oe?oe.then(be):Promise.resolve(J)}return Promise.resolve(null).then(be)}e.$xg=$;function w(O,J=ye=>!!ye,le=null){let ye=0;const ve=O.length,be=()=>{if(ye>=ve)return Promise.resolve(le);const ke=O[ye++];return Promise.resolve(ke()).then(he=>J(he)?Promise.resolve(he):be())};return be()}e.$yg=w;function E(O,J=ye=>!!ye,le=null){if(O.length===0)return Promise.resolve(le);let ye=O.length;const ve=()=>{ye=-1;for(const be of O)be.cancel?.()};return new Promise((be,ke)=>{for(const oe of O)oe.then(he=>{--ye>=0&&J(he)?(ve(),be(he)):ye===0&&be(le)}).catch(he=>{--ye>=0&&(ve(),ke(he))})})}e.$zg=E;class o{constructor(J){this.a=0,this.d=J,this.f=[],this.b=0,this.g=new I.$ec}get onDrained(){return this.g.event}get size(){return this.a}queue(J){return this.a++,new Promise((le,ye)=>{this.f.push({factory:J,c:le,e:ye}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const J=this.f.shift();this.b++;const le=J.factory();le.then(J.c,J.e),le.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Ag=o;class l extends o{constructor(){super(1)}}e.$Bg=l;class m{constructor(){this.a=new we,this.b=0}queue(J){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,J())):this.a.run(this.b++,J())}}e.$Cg=m;class F{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const J=new X;return this.b.add(J),J.p}d(){for(const[,J]of this.a)if(J.size>0)return!1;return!0}queueFor(J,le=A.$Yf){const ye=le.getComparisonKey(J);let ve=this.a.get(ye);return ve||(ve=new l,I.Event.once(ve.onDrained)(()=>{ve?.dispose(),this.a.delete(ye),this.f()}),this.a.set(ye,ve)),ve}f(){this.d()&&this.g()}g(){for(const J of this.b)J.complete();this.b.clear()}dispose(){for(const[,J]of this.a)J.dispose();this.a.clear(),this.g()}}e.$Dg=F;class W{constructor(J,le){this.a=-1,typeof J=="function"&&typeof le=="number"&&this.setIfNotSet(J,le)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(J,le){this.cancel(),this.a=setTimeout(()=>{this.a=-1,J()},le)}setIfNotSet(J,le){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,J()},le))}}e.$Eg=W;class V{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(J,le){this.cancel(),this.a=setInterval(()=>{J()},le)}}e.$Fg=V;class B{constructor(J,le){this.b=-1,this.a=J,this.d=le,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(J=this.d){this.cancel(),this.b=setTimeout(this.f,J)}get delay(){return this.d}set delay(J){this.d=J}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Gg=B;class j{constructor(J,le){le%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${le}ms is not a multiple of 1000ms.`),this.a=J,this.b=le,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(J=this.b){J%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${J}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(J/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Hg=j;class U extends B{constructor(J,le){super(J,le),this.j=[]}work(J){this.j.push(J),this.isScheduled()||this.schedule()}h(){const J=this.j;this.j=[],this.a?.(J)}dispose(){this.j=[],super.dispose()}}e.$Ig=U;class z extends M.$lb{constructor(J,le){super(),this.g=J,this.h=le,this.a=[],this.b=this.B(new M.$mb),this.f=!1}get pending(){return this.a.length}work(J){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+J.length>this.g.maxBufferedWork)return!1}else if(this.pending+J.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const le of J)this.a.push(le);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new B(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Jg=z,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$Kg=O=>{(0,d.$A)(()=>{if(J)return;const le=Date.now()+15;O(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,le-Date.now())}}))});let J=!1;return{dispose(){J||(J=!0)}}}:e.$Kg=(O,J)=>{const le=requestIdleCallback(O,typeof J=="number"?{timeout:J}:void 0);let ye=!1;return{dispose(){ye||(ye=!0,cancelIdleCallback(le))}}}}();class ne{constructor(J){this.d=!1,this.a=()=>{try{this.f=J()}catch(le){this.g=le}finally{this.d=!0}},this.b=(0,e.$Kg)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$Lg=ne;async function Z(O,J,le){let ye;for(let ve=0;ve<le;ve++)try{return await O()}catch(be){ye=be,await s(J)}throw ye}e.$Mg=Z;class we{isRunning(J){return typeof J=="number"?this.a?.taskId===J:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(J,le,ye){return this.a={taskId:J,cancel:()=>ye?.(),promise:le},le.then(()=>this.d(J),()=>this.d(J)),le}d(J){this.a&&J===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const J=this.b;this.b=void 0,J.run().then(J.promiseResolve,J.promiseReject)}}queue(J){if(this.b)this.b.run=J;else{let le,ye;const ve=new Promise((be,ke)=>{le=be,ye=ke});this.b={run:J,promise:ve,promiseResolve:le,promiseReject:ye}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Ng=we;class Ee{constructor(J,le=()=>Date.now()){this.d=J,this.f=le,this.a=0,this.b=0}increment(){const J=this.f();return J-this.a>this.d&&(this.a=J,this.b=0),this.b++,this.b}}e.$Og=Ee;var Re;(function(O){O[O.Resolved=0]="Resolved",O[O.Rejected=1]="Rejected"})(Re||(Re={}));class X{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((J,le)=>{this.a=J,this.b=le})}complete(J){return new Promise(le=>{this.a(J),this.d={outcome:0,value:J},le()})}error(J){return new Promise(le=>{this.b(J),this.d={outcome:1,value:J},le()})}cancel(){return this.error(new R.$3)}}e.$Pg=X;var de;(function(O){async function J(ye){let ve;const be=await Promise.all(ye.map(ke=>ke.then(oe=>oe,oe=>{ve||(ve=oe)})));if(typeof ve<"u")throw ve;return be}O.settled=J;function le(ye){return new Promise(async(ve,be)=>{try{await ye(ve,be)}catch(ke){be(ke)}})}O.withAsyncBody=le})(de||(e.Promises=de={}));var Ce;(function(O){O[O.Initial=0]="Initial",O[O.DoneOK=1]="DoneOK",O[O.DoneError=2]="DoneError"})(Ce||(Ce={}));class ae{static fromArray(J){return new ae(le=>{le.emitMany(J)})}static fromPromise(J){return new ae(async le=>{le.emitMany(await J)})}static fromPromises(J){return new ae(async le=>{await Promise.all(J.map(async ye=>le.emitOne(await ye)))})}static merge(J){return new ae(async le=>{await Promise.all(J.map(async ye=>{for await(const ve of ye)le.emitOne(ve)}))})}static{this.EMPTY=ae.fromArray([])}constructor(J){this.a=0,this.b=[],this.d=null,this.f=new I.$ec,queueMicrotask(async()=>{const le={emitOne:ye=>this.g(ye),emitMany:ye=>this.h(ye),reject:ye=>this.k(ye)};try{await Promise.resolve(J(le)),this.j()}catch(ye){this.k(ye)}finally{le.emitOne=void 0,le.emitMany=void 0,le.reject=void 0}})}[Symbol.asyncIterator](){let J=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(J<this.b.length)return{done:!1,value:this.b[J++]};if(this.a===1)return{done:!0,value:void 0};await I.Event.toPromise(this.f.event)}while(!0)}}}static map(J,le){return new ae(async ye=>{for await(const ve of J)ye.emitOne(le(ve))})}map(J){return ae.map(this,J)}static filter(J,le){return new ae(async ye=>{for await(const ve of J)le(ve)&&ye.emitOne(ve)})}filter(J){return ae.filter(this,J)}static coalesce(J){return ae.filter(J,le=>!!le)}coalesce(){return ae.coalesce(this)}static async toPromise(J){const le=[];for await(const ye of J)le.push(ye);return le}toPromise(){return ae.toPromise(this)}g(J){this.a===0&&(this.b.push(J),this.f.fire())}h(J){this.a===0&&(this.b=this.b.concat(J),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(J){this.a===0&&(this.a=2,this.d=J,this.f.fire())}}e.$Qg=ae;class _ extends ae{constructor(J,le){super(le),this.l=J}cancel(){this.l.cancel()}}e.$Rg=_;function ue(O){const J=new y.$oc,le=O(J.token);return new _(J,async ye=>{const ve=J.token.onCancellationRequested(()=>{ve.dispose(),J.dispose(),ye.reject(new R.$3)});try{for await(const be of le){if(J.token.isCancellationRequested)return;ye.emitOne(be)}ve.dispose(),J.dispose()}catch(be){ve.dispose(),J.dispose(),ye.reject(be)}})}e.$Sg=ue}),define(Pe[37],Ae([1,0,18,13,42,28,19,22,15]),function(pe,e,y,R,I,M,A,d,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=void 0;function f(){return Object.create(null)}e.$_i=f,e.$aj="**",e.$bj="/";const P="[/\\\\]",D="[^/\\\\]",u=/\//g;function b(we,Ee){switch(we){case 0:return"";case 1:return`${D}*?`;default:return`(?:${P}|${D}+${P}${Ee?`|${P}${D}+`:""})*?`}}function p(we,Ee){if(!we)return[];const Re=[];let X=!1,de=!1,Ce="";for(const ae of we){switch(ae){case Ee:if(!X&&!de){Re.push(Ce),Ce="";continue}break;case"{":X=!0;break;case"}":X=!1;break;case"[":de=!0;break;case"]":de=!1;break}Ce+=ae}return Ce&&Re.push(Ce),Re}e.$cj=p;function h(we){if(!we)return"";let Ee="";const Re=p(we,e.$bj);if(Re.every(X=>X===e.$aj))Ee=".*";else{let X=!1;Re.forEach((de,Ce)=>{if(de===e.$aj){if(X)return;Ee+=b(2,Ce===Re.length-1)}else{let ae=!1,_="",ue=!1,O="";for(const J of de){if(J!=="}"&&ae){_+=J;continue}if(ue&&(J!=="]"||!O)){let le;J==="-"?le=J:(J==="^"||J==="!")&&!O?le="^":J===e.$bj?le="":le=(0,k.$pd)(J),O+=le;continue}switch(J){case"{":ae=!0;continue;case"[":ue=!0;continue;case"}":{const ye=`(?:${p(_,",").map(ve=>h(ve)).join("|")})`;Ee+=ye,ae=!1,_="";break}case"]":{Ee+="["+O+"]",ue=!1,O="";break}case"?":Ee+=D;continue;case"*":Ee+=b(1);continue;default:Ee+=(0,k.$pd)(J)}}Ce<Re.length-1&&(Re[Ce+1]!==e.$aj||Ce+2<Re.length)&&(Ee+=P)}X=de===e.$aj})}return Ee}const t=/^\*\*\/\*\.[\w\.-]+$/,i=/^\*\*\/([\w\.-]+)\/?$/,c=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,g=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,S=/^\*\*((\/[\w\.-]+)+)\/?$/,C=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new M.$qi(1e4),a=function(){return!1},r=function(){return null};function s(we,Ee){if(!we)return r;let Re;typeof we!="string"?Re=we.pattern:Re=we,Re=Re.trim();const X=`${Re}_${!!Ee.trimForExclusions}`;let de=n.get(X);if(de)return v(de,we);let Ce;return t.test(Re)?de=w(Re.substr(4),Re):(Ce=i.exec($(Re,Ee)))?de=E(Ce[1],Re):(Ee.trimForExclusions?g:c).test(Re)?de=o(Re,Ee):(Ce=S.exec($(Re,Ee)))?de=l(Ce[1].substr(1),Re,!0):(Ce=C.exec($(Re,Ee)))?de=l(Ce[1],Re,!1):de=m(Re),n.set(X,de),v(de,we)}function v(we,Ee){if(typeof Ee=="string")return we;const Re=function(X,de){return(0,I.$He)(X,Ee.base,!d.$k)?we((0,k.$td)(X.substr(Ee.base.length),A.sep),de):null};return Re.allBasenames=we.allBasenames,Re.allPaths=we.allPaths,Re.basenames=we.basenames,Re.patterns=we.patterns,Re}function $(we,Ee){return Ee.trimForExclusions&&we.endsWith("/**")?we.substr(0,we.length-2):we}function w(we,Ee){return function(Re,X){return typeof Re=="string"&&Re.endsWith(we)?Ee:null}}function E(we,Ee){const Re=`/${we}`,X=`\\${we}`,de=function(ae,_){return typeof ae!="string"?null:_?_===we?Ee:null:ae===we||ae.endsWith(Re)||ae.endsWith(X)?Ee:null},Ce=[we];return de.basenames=Ce,de.patterns=[Ee],de.allBasenames=Ce,de}function o(we,Ee){const Re=ne(we.slice(1,-1).split(",").map(_=>s(_,Ee)).filter(_=>_!==r),we),X=Re.length;if(!X)return r;if(X===1)return Re[0];const de=function(_,ue){for(let O=0,J=Re.length;O<J;O++)if(Re[O](_,ue))return we;return null},Ce=Re.find(_=>!!_.allBasenames);Ce&&(de.allBasenames=Ce.allBasenames);const ae=Re.reduce((_,ue)=>ue.allPaths?_.concat(ue.allPaths):_,[]);return ae.length&&(de.allPaths=ae),de}function l(we,Ee,Re){const X=A.sep===A.$5c.sep,de=X?we:we.replace(u,A.sep),Ce=A.sep+de,ae=A.$5c.sep+we;let _;return Re?_=function(ue,O){return typeof ue=="string"&&(ue===de||ue.endsWith(Ce)||!X&&(ue===we||ue.endsWith(ae)))?Ee:null}:_=function(ue,O){return typeof ue=="string"&&(ue===de||!X&&ue===we)?Ee:null},_.allPaths=[(Re?"*/":"./")+we],_}function m(we){try{const Ee=new RegExp(`^${h(we)}$`);return function(Re){return Ee.lastIndex=0,typeof Re=="string"&&Ee.test(Re)?we:null}}catch{return r}}function F(we,Ee,Re){return!we||typeof Ee!="string"?!1:W(we)(Ee,void 0,Re)}e.$dj=F;function W(we,Ee={}){if(!we)return a;if(typeof we=="string"||V(we)){const Re=s(we,Ee);if(Re===r)return a;const X=function(de,Ce){return!!Re(de,Ce)};return Re.allBasenames&&(X.allBasenames=Re.allBasenames),Re.allPaths&&(X.allPaths=Re.allPaths),X}return U(we,Ee)}e.$ej=W;function V(we){const Ee=we;return Ee?typeof Ee.base=="string"&&typeof Ee.pattern=="string":!1}e.$fj=V;function B(we){return we.allBasenames||[]}e.$gj=B;function j(we){return we.allPaths||[]}e.$hj=j;function U(we,Ee){const Re=ne(Object.getOwnPropertyNames(we).map(_=>z(_,we[_],Ee)).filter(_=>_!==r)),X=Re.length;if(!X)return r;if(!Re.some(_=>!!_.requiresSiblings)){if(X===1)return Re[0];const _=function(J,le){let ye;for(let ve=0,be=Re.length;ve<be;ve++){const ke=Re[ve](J,le);if(typeof ke=="string")return ke;(0,R.$hg)(ke)&&(ye||(ye=[]),ye.push(ke))}return ye?(async()=>{for(const ve of ye){const be=await ve;if(typeof be=="string")return be}return null})():null},ue=Re.find(J=>!!J.allBasenames);ue&&(_.allBasenames=ue.allBasenames);const O=Re.reduce((J,le)=>le.allPaths?J.concat(le.allPaths):J,[]);return O.length&&(_.allPaths=O),_}const de=function(_,ue,O){let J,le;for(let ye=0,ve=Re.length;ye<ve;ye++){const be=Re[ye];be.requiresSiblings&&O&&(ue||(ue=(0,A.$_c)(_)),J||(J=ue.substr(0,ue.length-(0,A.$ad)(_).length)));const ke=be(_,ue,J,O);if(typeof ke=="string")return ke;(0,R.$hg)(ke)&&(le||(le=[]),le.push(ke))}return le?(async()=>{for(const ye of le){const ve=await ye;if(typeof ve=="string")return ve}return null})():null},Ce=Re.find(_=>!!_.allBasenames);Ce&&(de.allBasenames=Ce.allBasenames);const ae=Re.reduce((_,ue)=>ue.allPaths?_.concat(ue.allPaths):_,[]);return ae.length&&(de.allPaths=ae),de}function z(we,Ee,Re){if(Ee===!1)return r;const X=s(we,Re);if(X===r)return r;if(typeof Ee=="boolean")return X;if(Ee){const de=Ee.when;if(typeof de=="string"){const Ce=(ae,_,ue,O)=>{if(!O||!X(ae,_))return null;const J=de.replace("$(basename)",()=>ue),le=O(J);return(0,R.$hg)(le)?le.then(ye=>ye?we:null):le?we:null};return Ce.requiresSiblings=!0,Ce}}return X}function ne(we,Ee){const Re=we.filter(_=>!!_.basenames);if(Re.length<2)return we;const X=Re.reduce((_,ue)=>{const O=ue.basenames;return O?_.concat(O):_},[]);let de;if(Ee){de=[];for(let _=0,ue=X.length;_<ue;_++)de.push(Ee)}else de=Re.reduce((_,ue)=>{const O=ue.patterns;return O?_.concat(O):_},[]);const Ce=function(_,ue){if(typeof _!="string")return null;if(!ue){let J;for(J=_.length;J>0;J--){const le=_.charCodeAt(J-1);if(le===47||le===92)break}ue=_.substr(J)}const O=X.indexOf(ue);return O!==-1?de[O]:null};Ce.basenames=X,Ce.patterns=de,Ce.allBasenames=X;const ae=we.filter(_=>!_.basenames);return ae.push(Ce),ae}function Z(we,Ee){return(0,y.$$e)(we,Ee,(Re,X)=>typeof Re=="string"&&typeof X=="string"?Re===X:typeof Re!="string"&&typeof X!="string"?Re.base===X.base&&Re.pattern===X.pattern:!1)}e.$ij=Z}),define(Pe[49],Ae([1,0,9,122,23,15,2]),function(pe,e,y,R,I,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.MarkdownStringTextNewlineStyle=void 0;var d;(function(t){t[t.Paragraph=0]="Paragraph",t[t.Break=1]="Break"})(d||(e.MarkdownStringTextNewlineStyle=d={}));class k{constructor(i="",c=!1){if(this.value=i,typeof this.value!="string")throw(0,y.$5)("value");typeof c=="boolean"?(this.isTrusted=c,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=c.isTrusted??void 0,this.supportThemeIcons=c.supportThemeIcons??!1,this.supportHtml=c.supportHtml??!1)}appendText(i,c=0){return this.value+=u(this.supportThemeIcons?(0,R.$Ej)(i):i).replace(/([ \t]+)/g,(g,S)=>"&nbsp;".repeat(S.length)).replace(/\>/gm,"\\>").replace(/\n/g,c===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,c){return this.value+="\n```",this.value+=i,this.value+=`
`,this.value+=c,this.value+="\n```\n",this}appendLink(i,c,g){return this.value+="[",this.value+=this.c(c,"]"),this.value+="](",this.value+=this.c(String(i),")"),g&&(this.value+=` "${this.c(this.c(g,'"'),")")}"`),this.value+=")",this}c(i,c){const g=new RegExp((0,M.$pd)(c),"g");return i.replace(g,(S,C)=>i.charAt(C-1)!=="\\"?`\\${S}`:S)}}e.$Kj=k;function f(t){return P(t)?!t.value:Array.isArray(t)?t.every(f):!0}e.$Lj=f;function P(t){return t instanceof k?!0:t&&typeof t=="object"?typeof t.value=="string"&&(typeof t.isTrusted=="boolean"||typeof t.isTrusted=="object"||t.isTrusted===void 0)&&(typeof t.supportThemeIcons=="boolean"||t.supportThemeIcons===void 0):!1}e.$Mj=P;function D(t,i){return t===i?!0:!t||!i?!1:t.value===i.value&&t.isTrusted===i.isTrusted&&t.supportThemeIcons===i.supportThemeIcons&&t.supportHtml===i.supportHtml&&(t.baseUri===i.baseUri||!!t.baseUri&&!!i.baseUri&&(0,I.$2f)(A.URI.from(t.baseUri),A.URI.from(i.baseUri)))}e.$Nj=D;function u(t){return t.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$Oj=u;function b(t){return t.replace(/"/g,"&quot;")}e.$Pj=b;function p(t){return t&&t.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$Qj=p;function h(t){const i=[],c=t.split("|").map(S=>S.trim());t=c[0];const g=c[1];if(g){const S=/height=(\d+)/.exec(g),C=/width=(\d+)/.exec(g),n=S?S[1]:"",a=C?C[1]:"",r=isFinite(parseInt(a)),s=isFinite(parseInt(n));r&&i.push(`width="${a}"`),s&&i.push(`height="${n}"`)}return{href:t,dimensions:i}}e.$Rj=h}),define(Pe[90],Ae([1,0,18,42,19,22,23,15]),function(pe,e,y,R,I,M,A,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cA=e.$bA=e.$aA=e.$_z=e.$$z=e.$0z=e.$9z=e.$8z=e.$7z=e.$6z=void 0;function k(s,v){const{os:$,tildify:w,relative:E}=v;if(E){const m=f(s,E,$);if(typeof m=="string")return m}let o=s.fsPath;if($===1&&!M.$i?o=o.replace(/\//g,"\\"):$!==1&&M.$i&&(o=o.replace(/\\/g,"/")),$!==1&&w?.userHome){const m=w.userHome.fsPath;let F;s.scheme!==w.userHome.scheme&&s.path.startsWith(I.$5c.sep)?F=w.userHome.with({path:s.path}).fsPath:F=s.fsPath,o=u(F,m,$)}return($===1?I.$4c:I.$5c).normalize(P(o,$===1))}e.$6z=k;function f(s,v,$){const w=$===1?I.$4c:I.$5c,E=$===3?A.$Yf:A.$1f,o=v.getWorkspace(),l=(0,y.$sf)(o.folders);if(!l)return;s.scheme!==l.uri.scheme&&s.path.startsWith(I.$5c.sep)&&(s=l.uri.with({path:s.path}));const m=v.getWorkspaceFolder(s);if(!m)return;let F;if(E.isEqual(m.uri,s)?F="":F=E.relativePath(m.uri,s)??"",F&&(F=w.normalize(F)),o.folders.length>1&&!v.noPrefix){const W=m.name?m.name:E.basenameOrAuthority(m.uri);F=F?`${W} \u2022 ${F}`:W}return F}function P(s,v=M.$i){return(0,R.$Le)(s,v)?s.charAt(0).toUpperCase()+s.slice(1):s}e.$7z=P;let D=Object.create(null);function u(s,v,$=M.OS){if($===1||!s||!v)return s;let w=D.original===v?D.normalized:void 0;w||(w=v,M.$i&&(w=(0,R.$Be)(w)),w=`${(0,d.$ud)(w,I.$5c.sep)}${I.$5c.sep}`,D={original:v,normalized:w});let E=s;return M.$i&&(E=(0,R.$Be)(E)),($===3?E.startsWith(w):(0,d.$Md)(E,w))?`~/${E.substr(w.length)}`:s}e.$8z=u;function b(s,v){return s.replace(/^~($|\/|\\)/,`${v}$1`)}e.$9z=b;const p="\u2026",h="\\\\",t="~";function i(s,v=I.sep){const $=new Array(s.length);let w=!1;for(let E=0;E<s.length;E++){const o=s[E];if(o===""){$[E]=`.${v}`;continue}if(!o){$[E]=o;continue}w=!0;let l="",m=o;m.indexOf(h)===0?(l=m.substr(0,m.indexOf(h)+h.length),m=m.substr(m.indexOf(h)+h.length)):m.indexOf(v)===0?(l=m.substr(0,m.indexOf(v)+v.length),m=m.substr(m.indexOf(v)+v.length)):m.indexOf(t)===0&&(l=m.substr(0,m.indexOf(t)+t.length),m=m.substr(m.indexOf(t)+t.length));const F=m.split(v);for(let W=1;w&&W<=F.length;W++)for(let V=F.length-W;w&&V>=0;V--){w=!1;let B=F.slice(V,V+W).join(v);for(let j=0;!w&&j<s.length;j++)if(j!==E&&s[j]&&s[j].indexOf(B)>-1){const U=V+W===F.length,z=V>0&&s[j].indexOf(v)>-1?v+B:B,ne=s[j].endsWith(z);w=!U||ne}if(!w){let j="";(F[0].endsWith(":")||l!=="")&&(V===1&&(V=0,W++,B=F[0]+v+B),V>0&&(j=F[0]+v),j=l+j),V>0&&(j=j+p+v),j=j+B,V+W<F.length&&(j=j+v+p),$[E]=j}}w&&($[E]=o)}return $}e.$0z=i;var c;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function g(s,v=Object.create(null)){const $=[];let w=!1,E="";for(const o of s)if(o==="$"||w&&o==="{")E&&$.push({value:E,type:c.TEXT}),E="",w=!0;else if(o==="}"&&w){const l=v[E];if(typeof l=="string")l.length&&$.push({value:l,type:c.VARIABLE});else if(l){const m=$[$.length-1];(!m||m.type!==c.SEPARATOR)&&$.push({value:l.label,type:c.SEPARATOR})}E="",w=!1}else E+=o;return E&&!w&&$.push({value:E,type:c.TEXT}),$.filter((o,l)=>{if(o.type===c.SEPARATOR){const m=$[l-1],F=$[l+1];return[m,F].every(W=>W&&(W.type===c.VARIABLE||W.type===c.TEXT)&&W.value.length>0)}return!0}).map(o=>o.value).join("")}e.$$z=g;function S(s,v){return M.$j||v?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.$j?"&":"&&"):s.replace(/&&|&/g,$=>$==="&"?"&&":"&")}e.$_z=S;function C(s,v){return M.$j||v?s.replace(/\(&&\w\)|&&/g,""):M.$i?s.replace(/&&|&/g,$=>$==="&"?"&&":"&"):s.replace(/&&/g,"_")}e.$aA=C;function n(s){return s.replace(/&/g,"&&")}e.$bA=n;function a(s){if(s.endsWith("]")){const v=s.lastIndexOf(" [",s.length-2);if(v!==-1){const $=r(s.substring(0,v));return{name:$.name,parentPath:$.parentPath+s.substring(v)}}}return r(s)}e.$cA=a;function r(s){const v=s.indexOf("/")!==-1?I.$5c:I.$4c,$=v.basename(s),w=v.dirname(s);return $.length?{name:$,parentPath:w}:{name:w,parentPath:""}}}),define(Pe[133],Ae([1,0,25,2]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=e.$rm=e.$qm=e.$pm=e.$om=void 0;function I(D){return D.toJSON()}class M{constructor(u){this.a=u}transformIncoming(u){const b=this.a.transformIncoming(u);return b===u?u:I(R.URI.from(b))}transformOutgoing(u){const b=this.a.transformOutgoing(u);return b===u?u:I(R.URI.from(b))}transformOutgoingURI(u){const b=this.a.transformOutgoing(u);return b===u?u:R.URI.from(b)}transformOutgoingScheme(u){return this.a.transformOutgoingScheme(u)}}e.$om=M,e.$pm=new class{transformIncoming(D){return D}transformOutgoing(D){return D}transformOutgoingURI(D){return D}transformOutgoingScheme(D){return D}};function A(D,u,b){if(!D||b>200)return null;if(typeof D=="object"){if(D instanceof R.URI)return u.transformOutgoing(D);for(const p in D)if(Object.hasOwnProperty.call(D,p)){const h=A(D[p],u,b+1);h!==null&&(D[p]=h)}}return null}function d(D,u){const b=A(D,u,0);return b===null?D:b}e.$qm=d;function k(D,u,b,p){if(!D||p>200)return null;if(typeof D=="object"){if(D.$mid===1)return b?R.URI.revive(u.transformIncoming(D)):u.transformIncoming(D);if(D instanceof y.$Ec)return null;for(const h in D)if(Object.hasOwnProperty.call(D,h)){const t=k(D[h],u,b,p+1);t!==null&&(D[h]=t)}}return null}function f(D,u){const b=k(D,u,!1,0);return b===null?D:b}e.$rm=f;function P(D,u){const b=k(D,u,!0,0);return b===null?D:b}e.$sm=P}),define(Pe[134],Ae([1,0,37,19]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4E=void 0;function I(M,A,d,k,f,P){if(Array.isArray(M)){let D=0;for(const u of M){const b=I(u,A,d,k,f,P);if(b===10)return b;b>D&&(D=b)}return D}else{if(typeof M=="string")return k?M==="*"?5:M===d?10:0:0;if(M){const{language:D,pattern:u,scheme:b,hasAccessToAllModels:p,notebookType:h}=M;if(!k&&!p)return 0;h&&f&&(A=f);let t=0;if(b)if(b===A.scheme)t=10;else if(b==="*")t=5;else return 0;if(D)if(D===d)t=10;else if(D==="*")t=Math.max(t,5);else return 0;if(h)if(h===P)t=10;else if(h==="*"&&P!==void 0)t=Math.max(t,5);else return 0;if(u){let i;if(typeof u=="string"?i=u:i={...u,base:(0,R.$6c)(u.base)},i===A.fsPath||(0,y.$dj)(i,A.fsPath))t=10;else return 0}return t}else return 0}}e.$4E=I}),define(Pe[91],Ae([1,0,25,22]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$59=e.$49=void 0;var I;(function(D){D[D.Full=1]="Full",D[D.Delta=2]="Delta"})(I||(I={}));function M(D){for(let u=0,b=D.length;u<b;u+=4){const p=D[u+0],h=D[u+1],t=D[u+2],i=D[u+3];D[u+0]=i,D[u+1]=t,D[u+2]=h,D[u+3]=p}}function A(D){const u=new Uint8Array(D.buffer,D.byteOffset,D.length*4);return R.$C()||M(u),y.$Ec.wrap(u)}function d(D){const u=D.buffer;if(R.$C()||M(u),u.byteOffset%4===0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const b=new Uint8Array(u.byteLength);return b.set(u),new Uint32Array(b.buffer,b.byteOffset,b.length/4)}}function k(D){const u=new Uint32Array(f(D));let b=0;if(u[b++]=D.id,D.type==="full")u[b++]=1,u[b++]=D.data.length,u.set(D.data,b),b+=D.data.length;else{u[b++]=2,u[b++]=D.deltas.length;for(const p of D.deltas)u[b++]=p.start,u[b++]=p.deleteCount,p.data?(u[b++]=p.data.length,u.set(p.data,b),b+=p.data.length):u[b++]=0}return A(u)}e.$49=k;function f(D){let u=0;if(u+=1+1,D.type==="full")u+=1+D.data.length;else{u+=1,u+=(1+1+1)*D.deltas.length;for(const b of D.deltas)b.data&&(u+=b.data.length)}return u}function P(D){const u=d(D);let b=0;const p=u[b++];if(u[b++]===1){const c=u[b++],g=u.subarray(b,b+c);return b+=c,{id:p,type:"full",data:g}}const t=u[b++],i=[];for(let c=0;c<t;c++){const g=u[b++],S=u[b++],C=u[b++];let n;C>0&&(n=u.subarray(b,b+C),b+=C),i[c]={start:g,deleteCount:S,data:n}}return{id:p,type:"delta",deltas:i}}e.$59=P}),define(Pe[135],Ae([10,11]),function(pe,e){return pe.create("vs/editor/common/config/editorOptions",e)}),define(Pe[136],Ae([1,0,18,24,22,124,137,135]),function(pe,e,y,R,I,M,A,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var k;(function(x){x[x.None=0]="None",x[x.Keep=1]="Keep",x[x.Brackets=2]="Brackets",x[x.Advanced=3]="Advanced",x[x.Full=4]="Full"})(k||(e.EditorAutoIndentStrategy=k={})),e.MINIMAP_GUTTER_WIDTH=8;class f{constructor(Y){this.c=Y}hasChanged(Y){return this.c[Y]}}e.ConfigurationChangedEvent=f;class P{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=P;class D{constructor(Y,$e,je,Oe){this.id=Y,this.name=$e,this.defaultValue=je,this.schema=Oe}applyUpdate(Y,$e){return b(Y,$e)}compute(Y,$e,je){return je}}class u{constructor(Y,$e){this.newValue=Y,this.didChange=$e}}e.ApplyUpdateResult=u;function b(x,Y){if(typeof x!="object"||typeof Y!="object"||!x||!Y)return new u(Y,x!==Y);if(Array.isArray(x)||Array.isArray(Y)){const je=Array.isArray(x)&&Array.isArray(Y)&&y.$$e(x,Y);return new u(Y,!je)}let $e=!1;for(const je in Y)if(Y.hasOwnProperty(je)){const Oe=b(x[je],Y[je]);Oe.didChange&&(x[je]=Oe.newValue,$e=!0)}return new u(x,$e)}class p{constructor(Y){this.schema=void 0,this.id=Y,this.name="_never_",this.defaultValue=void 0}applyUpdate(Y,$e){return b(Y,$e)}validate(Y){return this.defaultValue}}class h{constructor(Y,$e,je,Oe){this.id=Y,this.name=$e,this.defaultValue=je,this.schema=Oe}applyUpdate(Y,$e){return b(Y,$e)}validate(Y){return typeof Y>"u"?this.defaultValue:Y}compute(Y,$e,je){return je}}function t(x,Y){return typeof x>"u"?Y:x==="false"?!1:!!x}e.boolean=t;class i extends h{constructor(Y,$e,je,Oe=void 0){typeof Oe<"u"&&(Oe.type="boolean",Oe.default=je),super(Y,$e,je,Oe)}validate(Y){return t(Y,this.defaultValue)}}function c(x,Y,$e,je){if(typeof x>"u")return Y;let Oe=parseInt(x,10);return isNaN(Oe)?Y:(Oe=Math.max($e,Oe),Oe=Math.min(je,Oe),Oe|0)}e.clampedInt=c;class g extends h{static clampedInt(Y,$e,je,Oe){return c(Y,$e,je,Oe)}constructor(Y,$e,je,Oe,Ye,nt=void 0){typeof nt<"u"&&(nt.type="integer",nt.default=je,nt.minimum=Oe,nt.maximum=Ye),super(Y,$e,je,nt),this.minimum=Oe,this.maximum=Ye}validate(Y){return g.clampedInt(Y,this.defaultValue,this.minimum,this.maximum)}}function S(x,Y,$e,je){if(typeof x>"u")return Y;const Oe=C.float(x,Y);return C.clamp(Oe,$e,je)}e.clampedFloat=S;class C extends h{static clamp(Y,$e,je){return Y<$e?$e:Y>je?je:Y}static float(Y,$e){if(typeof Y=="number")return Y;if(typeof Y>"u")return $e;const je=parseFloat(Y);return isNaN(je)?$e:je}constructor(Y,$e,je,Oe,Ye){typeof Ye<"u"&&(Ye.type="number",Ye.default=je),super(Y,$e,je,Ye),this.validationFn=Oe}validate(Y){return this.validationFn(C.float(Y,this.defaultValue))}}class n extends h{static string(Y,$e){return typeof Y!="string"?$e:Y}constructor(Y,$e,je,Oe=void 0){typeof Oe<"u"&&(Oe.type="string",Oe.default=je),super(Y,$e,je,Oe)}validate(Y){return n.string(Y,this.defaultValue)}}function a(x,Y,$e,je){return typeof x!="string"?Y:je&&x in je?je[x]:$e.indexOf(x)===-1?Y:x}e.stringSet=a;class r extends h{constructor(Y,$e,je,Oe,Ye=void 0){typeof Ye<"u"&&(Ye.type="string",Ye.enum=Oe,Ye.default=je),super(Y,$e,je,Ye),this.c=Oe}validate(Y){return a(Y,this.defaultValue,this.c)}}class s extends D{constructor(Y,$e,je,Oe,Ye,nt,ft=void 0){typeof ft<"u"&&(ft.type="string",ft.enum=Ye,ft.default=Oe),super(Y,$e,je,ft),this.c=Ye,this.d=nt}validate(Y){return typeof Y!="string"?this.defaultValue:this.c.indexOf(Y)===-1?this.defaultValue:this.d(Y)}}function v(x){switch(x){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class $ extends D{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[d.localize(0,null),d.localize(1,null),d.localize(2,null)],default:"auto",tags:["accessibility"],description:d.localize(3,null)})}validate(Y){switch(Y){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Y,$e,je){return je===0?Y.accessibilitySupport:je}}class w extends D{constructor(){const Y={insertSpace:!0,ignoreEmptyLines:!0};super(22,"comments",Y,{"editor.comments.insertSpace":{type:"boolean",default:Y.insertSpace,description:d.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Y.ignoreEmptyLines,description:d.localize(5,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const $e=Y;return{insertSpace:t($e.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:t($e.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var E;(function(x){x[x.Hidden=0]="Hidden",x[x.Blink=1]="Blink",x[x.Smooth=2]="Smooth",x[x.Phase=3]="Phase",x[x.Expand=4]="Expand",x[x.Solid=5]="Solid"})(E||(e.TextEditorCursorBlinkingStyle=E={}));function o(x){switch(x){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var l;(function(x){x[x.Line=1]="Line",x[x.Block=2]="Block",x[x.Underline=3]="Underline",x[x.LineThin=4]="LineThin",x[x.BlockOutline=5]="BlockOutline",x[x.UnderlineThin=6]="UnderlineThin"})(l||(e.TextEditorCursorStyle=l={}));function m(x){switch(x){case l.Line:return"line";case l.Block:return"block";case l.Underline:return"underline";case l.LineThin:return"line-thin";case l.BlockOutline:return"block-outline";case l.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=m;function F(x){switch(x){case"line":return l.Line;case"block":return l.Block;case"underline":return l.Underline;case"line-thin":return l.LineThin;case"block-outline":return l.BlockOutline;case"underline-thin":return l.UnderlineThin}}class W extends p{constructor(){super(139)}compute(Y,$e,je){const Oe=["monaco-editor"];return $e.get(38)&&Oe.push($e.get(38)),Y.extraEditorClassName&&Oe.push(Y.extraEditorClassName),$e.get(72)==="default"?Oe.push("mouse-default"):$e.get(72)==="copy"&&Oe.push("mouse-copy"),$e.get(109)&&Oe.push("showUnused"),$e.get(137)&&Oe.push("showDeprecated"),Oe.join(" ")}}class V extends i{constructor(){super(36,"emptySelectionClipboard",!0,{description:d.localize(6,null)})}compute(Y,$e,je){return je&&Y.emptySelectionClipboard}}class B extends D{constructor(){const Y={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(40,"find",Y,{"editor.find.cursorMoveOnType":{type:"boolean",default:Y.cursorMoveOnType,description:d.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Y.seedSearchStringFromSelection,enumDescriptions:[d.localize(8,null),d.localize(9,null),d.localize(10,null)],description:d.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Y.autoFindInSelection,enumDescriptions:[d.localize(12,null),d.localize(13,null),d.localize(14,null)],description:d.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Y.globalFindClipboard,description:d.localize(16,null),included:I.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Y.addExtraSpaceOnTop,description:d.localize(17,null)},"editor.find.loop":{type:"boolean",default:Y.loop,description:d.localize(18,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const $e=Y;return{cursorMoveOnType:t($e.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Y.seedSearchStringFromSelection=="boolean"?Y.seedSearchStringFromSelection?"always":"never":a($e.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Y.autoFindInSelection=="boolean"?Y.autoFindInSelection?"always":"never":a($e.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:t($e.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:t($e.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:t($e.loop,this.defaultValue.loop)}}}class j extends D{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(50,"fontLigatures",j.OFF,{anyOf:[{type:"boolean",description:d.localize(19,null)},{type:"string",description:d.localize(20,null)}],description:d.localize(21,null),default:!1})}validate(Y){return typeof Y>"u"?this.defaultValue:typeof Y=="string"?Y==="false"?j.OFF:Y==="true"?j.ON:Y:Y?j.ON:j.OFF}}e.EditorFontLigatures=j;class U extends D{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(53,"fontVariations",U.OFF,{anyOf:[{type:"boolean",description:d.localize(22,null)},{type:"string",description:d.localize(23,null)}],description:d.localize(24,null),default:!1})}validate(Y){return typeof Y>"u"?this.defaultValue:typeof Y=="string"?Y==="false"?U.OFF:Y==="true"?U.TRANSLATE:Y:Y?U.TRANSLATE:U.OFF}compute(Y,$e,je){return Y.fontInfo.fontVariationSettings}}e.EditorFontVariations=U;class z extends p{constructor(){super(49)}compute(Y,$e,je){return Y.fontInfo}}class ne extends h{constructor(){super(51,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:d.localize(25,null)})}validate(Y){const $e=C.float(Y,this.defaultValue);return $e===0?e.EDITOR_FONT_DEFAULTS.fontSize:C.clamp($e,6,100)}compute(Y,$e,je){return Y.fontInfo.fontSize}}class Z extends D{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(52,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:Z.d,maximum:Z.e,errorMessage:d.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:Z.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:d.localize(27,null)})}validate(Y){return Y==="normal"||Y==="bold"?Y:String(g.clampedInt(Y,e.EDITOR_FONT_DEFAULTS.fontWeight,Z.d,Z.e))}}class we extends D{constructor(){const Y={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},$e={type:"string",enum:["peek","gotoAndPeek","goto"],default:Y.multiple,enumDescriptions:[d.localize(28,null),d.localize(29,null),d.localize(30,null)]},je=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(57,"gotoLocation",Y,{"editor.gotoLocation.multiple":{deprecationMessage:d.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:d.localize(32,null),...$e},"editor.gotoLocation.multipleTypeDefinitions":{description:d.localize(33,null),...$e},"editor.gotoLocation.multipleDeclarations":{description:d.localize(34,null),...$e},"editor.gotoLocation.multipleImplementations":{description:d.localize(35,null),...$e},"editor.gotoLocation.multipleReferences":{description:d.localize(36,null),...$e},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Y.alternativeDefinitionCommand,enum:je,description:d.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Y.alternativeTypeDefinitionCommand,enum:je,description:d.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Y.alternativeDeclarationCommand,enum:je,description:d.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Y.alternativeImplementationCommand,enum:je,description:d.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Y.alternativeReferenceCommand,enum:je,description:d.localize(41,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const $e=Y;return{multiple:a($e.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:$e.multipleDefinitions??a($e.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:$e.multipleTypeDefinitions??a($e.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:$e.multipleDeclarations??a($e.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:$e.multipleImplementations??a($e.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:$e.multipleReferences??a($e.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:n.string($e.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:n.string($e.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:n.string($e.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:n.string($e.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:n.string($e.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class Ee extends D{constructor(){const Y={enabled:!0,delay:300,sticky:!0,above:!0};super(59,"hover",Y,{"editor.hover.enabled":{type:"boolean",default:Y.enabled,description:d.localize(42,null)},"editor.hover.delay":{type:"number",default:Y.delay,minimum:0,maximum:1e4,description:d.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Y.sticky,description:d.localize(44,null)},"editor.hover.above":{type:"boolean",default:Y.above,description:d.localize(45,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const $e=Y;return{enabled:t($e.enabled,this.defaultValue.enabled),delay:g.clampedInt($e.delay,this.defaultValue.delay,0,1e4),sticky:t($e.sticky,this.defaultValue.sticky),above:t($e.above,this.defaultValue.above)}}}var Re;(function(x){x[x.None=0]="None",x[x.Text=1]="Text",x[x.Blocks=2]="Blocks"})(Re||(e.RenderMinimap=Re={}));class X extends p{constructor(){super(142)}compute(Y,$e,je){return X.computeLayout($e,{memory:Y.memory,outerWidth:Y.outerWidth,outerHeight:Y.outerHeight,isDominatedByLongLines:Y.isDominatedByLongLines,lineHeight:Y.fontInfo.lineHeight,viewLineCount:Y.viewLineCount,lineNumbersDigitCount:Y.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Y.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Y.fontInfo.maxDigitWidth,pixelRatio:Y.pixelRatio,glyphMarginDecorationLaneCount:Y.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Y){const $e=Y.height/Y.lineHeight,je=Math.floor(Y.paddingTop/Y.lineHeight);let Oe=Math.floor(Y.paddingBottom/Y.lineHeight);Y.scrollBeyondLastLine&&(Oe=Math.max(Oe,$e-1));const Ye=(je+Y.viewLineCount+Oe)/(Y.pixelRatio*Y.height),nt=Math.floor(Y.viewLineCount/Ye);return{typicalViewportLineCount:$e,extraLinesBeforeFirstLine:je,extraLinesBeyondLastLine:Oe,desiredRatio:Ye,minimapLineCount:nt}}static c(Y,$e){const je=Y.outerWidth,Oe=Y.outerHeight,Ye=Y.pixelRatio;if(!Y.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ye*Oe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Oe};const nt=$e.stableMinimapLayoutInput,ft=nt&&Y.outerHeight===nt.outerHeight&&Y.lineHeight===nt.lineHeight&&Y.typicalHalfwidthCharacterWidth===nt.typicalHalfwidthCharacterWidth&&Y.pixelRatio===nt.pixelRatio&&Y.scrollBeyondLastLine===nt.scrollBeyondLastLine&&Y.paddingTop===nt.paddingTop&&Y.paddingBottom===nt.paddingBottom&&Y.minimap.enabled===nt.minimap.enabled&&Y.minimap.side===nt.minimap.side&&Y.minimap.size===nt.minimap.size&&Y.minimap.showSlider===nt.minimap.showSlider&&Y.minimap.renderCharacters===nt.minimap.renderCharacters&&Y.minimap.maxColumn===nt.minimap.maxColumn&&Y.minimap.scale===nt.minimap.scale&&Y.verticalScrollbarWidth===nt.verticalScrollbarWidth&&Y.isViewportWrapping===nt.isViewportWrapping,bt=Y.lineHeight,Tt=Y.typicalHalfwidthCharacterWidth,Yt=Y.scrollBeyondLastLine,Vt=Y.minimap.renderCharacters;let vt=Ye>=2?Math.round(Y.minimap.scale*2):Y.minimap.scale;const Mt=Y.minimap.maxColumn,Ot=Y.minimap.size,Jt=Y.minimap.side,At=Y.verticalScrollbarWidth,Rt=Y.viewLineCount,Nt=Y.remainingWidth,jt=Y.isViewportWrapping,qt=Vt?2:3;let Bt=Math.floor(Ye*Oe);const at=Bt/Ye;let lt=!1,Ht=!1,Pt=qt*vt,kt=vt/Ye,dt=1;if(Ot==="fill"||Ot==="fit"){const{typicalViewportLineCount:me,extraLinesBeforeFirstLine:H,extraLinesBeyondLastLine:Fe,desiredRatio:Be,minimapLineCount:Ge}=X.computeContainedMinimapLineCount({viewLineCount:Rt,scrollBeyondLastLine:Yt,paddingTop:Y.paddingTop,paddingBottom:Y.paddingBottom,height:Oe,lineHeight:bt,pixelRatio:Ye});if(Rt/Ge>1)lt=!0,Ht=!0,vt=1,Pt=1,kt=vt/Ye;else{let _e=!1,$t=vt+1;if(Ot==="fit"){const Et=Math.ceil((H+Rt+Fe)*Pt);jt&&ft&&Nt<=$e.stableFitRemainingWidth?(_e=!0,$t=$e.stableFitMaxMinimapScale):_e=Et>Bt}if(Ot==="fill"||_e){lt=!0;const Et=vt;Pt=Math.min(bt*Ye,Math.max(1,Math.floor(1/Be))),jt&&ft&&Nt<=$e.stableFitRemainingWidth&&($t=$e.stableFitMaxMinimapScale),vt=Math.min($t,Math.max(1,Math.floor(Pt/qt))),vt>Et&&(dt=Math.min(2,vt/Et)),kt=vt/Ye/dt,Bt=Math.ceil(Math.max(me,H+Rt+Fe)*Pt),jt?($e.stableMinimapLayoutInput=Y,$e.stableFitRemainingWidth=Nt,$e.stableFitMaxMinimapScale=vt):($e.stableMinimapLayoutInput=null,$e.stableFitRemainingWidth=0)}}}const It=Math.floor(Mt*kt),zt=Math.min(It,Math.max(0,Math.floor((Nt-At-2)*kt/(Tt+kt)))+e.MINIMAP_GUTTER_WIDTH);let yt=Math.floor(Ye*zt);const Ve=yt/Ye;yt=Math.floor(yt*dt);const Ie=Vt?1:2,Le=Jt==="left"?0:je-zt-At;return{renderMinimap:Ie,minimapLeft:Le,minimapWidth:zt,minimapHeightIsEditorHeight:lt,minimapIsSampling:Ht,minimapScale:vt,minimapLineHeight:Pt,minimapCanvasInnerWidth:yt,minimapCanvasInnerHeight:Bt,minimapCanvasOuterWidth:Ve,minimapCanvasOuterHeight:at}}static computeLayout(Y,$e){const je=$e.outerWidth|0,Oe=$e.outerHeight|0,Ye=$e.lineHeight|0,nt=$e.lineNumbersDigitCount|0,ft=$e.typicalHalfwidthCharacterWidth,bt=$e.maxDigitWidth,Tt=$e.pixelRatio,Yt=$e.viewLineCount,Vt=Y.get(134),vt=Vt==="inherit"?Y.get(133):Vt,Mt=vt==="inherit"?Y.get(129):vt,Ot=Y.get(132),Jt=$e.isDominatedByLongLines,At=Y.get(56),Rt=Y.get(66).renderType!==0,Nt=Y.get(67),jt=Y.get(103),qt=Y.get(82),Bt=Y.get(71),at=Y.get(101),lt=at.verticalScrollbarSize,Ht=at.verticalHasArrows,Pt=at.arrowSize,kt=at.horizontalScrollbarSize,dt=Y.get(42),It=Y.get(108)!=="never";let zt=Y.get(64);dt&&It&&(zt+=16);let yt=0;if(Rt){const ct=Math.max(nt,Nt);yt=Math.round(ct*bt)}let Ve=0;At&&(Ve=Ye*$e.glyphMarginDecorationLaneCount);let Ie=0,Le=Ie+Ve,me=Le+yt,H=me+zt;const Fe=je-Ve-yt-zt;let Be=!1,Ge=!1,qe=-1;vt==="inherit"&&Jt?(Be=!0,Ge=!0):Mt==="on"||Mt==="bounded"?Ge=!0:Mt==="wordWrapColumn"&&(qe=Ot);const _e=X.c({outerWidth:je,outerHeight:Oe,lineHeight:Ye,typicalHalfwidthCharacterWidth:ft,pixelRatio:Tt,scrollBeyondLastLine:jt,paddingTop:qt.top,paddingBottom:qt.bottom,minimap:Bt,verticalScrollbarWidth:lt,viewLineCount:Yt,remainingWidth:Fe,isViewportWrapping:Ge},$e.memory||new P);_e.renderMinimap!==0&&_e.minimapLeft===0&&(Ie+=_e.minimapWidth,Le+=_e.minimapWidth,me+=_e.minimapWidth,H+=_e.minimapWidth);const $t=Fe-_e.minimapWidth,Et=Math.max(1,Math.floor(($t-lt-2)/ft)),pt=Ht?Pt:0;return Ge&&(qe=Math.max(1,Et),Mt==="bounded"&&(qe=Math.min(qe,Ot))),{width:je,height:Oe,glyphMarginLeft:Ie,glyphMarginWidth:Ve,glyphMarginDecorationLaneCount:$e.glyphMarginDecorationLaneCount,lineNumbersLeft:Le,lineNumbersWidth:yt,decorationsLeft:me,decorationsWidth:zt,contentLeft:H,contentWidth:$t,minimap:_e,viewportColumn:Et,isWordWrapMinified:Be,isViewportWrapping:Ge,wrappingColumn:qe,verticalScrollbarWidth:lt,horizontalScrollbarHeight:kt,overviewRuler:{top:pt,width:lt,height:Oe-2*pt,right:0}}}}e.EditorLayoutInfoComputer=X;class de extends D{constructor(){super(136,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[d.localize(46,null),d.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:d.localize(48,null)}})}validate(Y){return a(Y,"simple",["simple","advanced"])}compute(Y,$e,je){return $e.get(2)===2?"advanced":je}}class Ce extends D{constructor(){const Y={enabled:!0};super(63,"lightbulb",Y,{"editor.lightbulb.enabled":{type:"boolean",default:Y.enabled,description:d.localize(49,null)}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{enabled:t(Y.enabled,this.defaultValue.enabled)}}}class ae extends D{constructor(){const Y={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(113,"stickyScroll",Y,{"editor.stickyScroll.enabled":{type:"boolean",default:Y.enabled,description:d.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Y.maxLineCount,minimum:1,maximum:10,description:d.localize(51,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Y.defaultModel,description:d.localize(52,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:Y.scrollWithEditor,description:d.localize(53,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const $e=Y;return{enabled:t($e.enabled,this.defaultValue.enabled),maxLineCount:g.clampedInt($e.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:a($e.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:t($e.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class _ extends D{constructor(){const Y={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(138,"inlayHints",Y,{"editor.inlayHints.enabled":{type:"string",default:Y.enabled,description:d.localize(54,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[d.localize(55,null),d.localize(56,null,I.$j?"Ctrl+Option":"Ctrl+Alt"),d.localize(57,null,I.$j?"Ctrl+Option":"Ctrl+Alt"),d.localize(58,null)]},"editor.inlayHints.fontSize":{type:"number",default:Y.fontSize,markdownDescription:d.localize(59,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Y.fontFamily,markdownDescription:d.localize(60,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Y.padding,description:d.localize(61,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const $e=Y;return typeof $e.enabled=="boolean"&&($e.enabled=$e.enabled?"on":"off"),{enabled:a($e.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:g.clampedInt($e.fontSize,this.defaultValue.fontSize,0,100),fontFamily:n.string($e.fontFamily,this.defaultValue.fontFamily),padding:t($e.padding,this.defaultValue.padding)}}}class ue extends D{constructor(){super(64,"lineDecorationsWidth",10)}validate(Y){return typeof Y=="string"&&/^\d+(\.\d+)?ch$/.test(Y)?-parseFloat(Y.substring(0,Y.length-2)):g.clampedInt(Y,this.defaultValue,0,1e3)}compute(Y,$e,je){return je<0?g.clampedInt(-je*Y.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):je}}class O extends C{constructor(){super(65,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Y=>C.clamp(Y,0,150),{markdownDescription:d.localize(62,null)})}compute(Y,$e,je){return Y.fontInfo.lineHeight}}class J extends D{constructor(){const Y={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(71,"minimap",Y,{"editor.minimap.enabled":{type:"boolean",default:Y.enabled,description:d.localize(63,null)},"editor.minimap.autohide":{type:"boolean",default:Y.autohide,description:d.localize(64,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[d.localize(65,null),d.localize(66,null),d.localize(67,null)],default:Y.size,description:d.localize(68,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Y.side,description:d.localize(69,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Y.showSlider,description:d.localize(70,null)},"editor.minimap.scale":{type:"number",default:Y.scale,minimum:1,maximum:3,enum:[1,2,3],description:d.localize(71,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Y.renderCharacters,description:d.localize(72,null)},"editor.minimap.maxColumn":{type:"number",default:Y.maxColumn,description:d.localize(73,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const $e=Y;return{enabled:t($e.enabled,this.defaultValue.enabled),autohide:t($e.autohide,this.defaultValue.autohide),size:a($e.size,this.defaultValue.size,["proportional","fill","fit"]),side:a($e.side,this.defaultValue.side,["right","left"]),showSlider:a($e.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:t($e.renderCharacters,this.defaultValue.renderCharacters),scale:g.clampedInt($e.scale,1,1,3),maxColumn:g.clampedInt($e.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function le(x){return x==="ctrlCmd"?I.$j?"metaKey":"ctrlKey":"altKey"}class ye extends D{constructor(){super(82,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:d.localize(74,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:d.localize(75,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const $e=Y;return{top:g.clampedInt($e.top,0,0,1e3),bottom:g.clampedInt($e.bottom,0,0,1e3)}}}class ve extends D{constructor(){const Y={enabled:!0,cycle:!0};super(84,"parameterHints",Y,{"editor.parameterHints.enabled":{type:"boolean",default:Y.enabled,description:d.localize(76,null)},"editor.parameterHints.cycle":{type:"boolean",default:Y.cycle,description:d.localize(77,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const $e=Y;return{enabled:t($e.enabled,this.defaultValue.enabled),cycle:t($e.cycle,this.defaultValue.cycle)}}}class be extends p{constructor(){super(140)}compute(Y,$e,je){return Y.pixelRatio}}class ke extends D{constructor(){const Y={other:"on",comments:"off",strings:"off"},$e=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[d.localize(78,null),d.localize(79,null),d.localize(80,null)]}];super(87,"quickSuggestions",Y,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:$e,default:Y.strings,description:d.localize(81,null)},comments:{anyOf:$e,default:Y.comments,description:d.localize(82,null)},other:{anyOf:$e,default:Y.other,description:d.localize(83,null)}},default:Y,markdownDescription:d.localize(84,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Y}validate(Y){if(typeof Y=="boolean"){const Tt=Y?"on":"off";return{comments:Tt,strings:Tt,other:Tt}}if(!Y||typeof Y!="object")return this.defaultValue;const{other:$e,comments:je,strings:Oe}=Y,Ye=["on","inline","off"];let nt,ft,bt;return typeof $e=="boolean"?nt=$e?"on":"off":nt=a($e,this.defaultValue.other,Ye),typeof je=="boolean"?ft=je?"on":"off":ft=a(je,this.defaultValue.comments,Ye),typeof Oe=="boolean"?bt=Oe?"on":"off":bt=a(Oe,this.defaultValue.strings,Ye),{other:nt,comments:ft,strings:bt}}}var oe;(function(x){x[x.Off=0]="Off",x[x.On=1]="On",x[x.Relative=2]="Relative",x[x.Interval=3]="Interval",x[x.Custom=4]="Custom"})(oe||(e.RenderLineNumbersType=oe={}));class he extends D{constructor(){super(66,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[d.localize(85,null),d.localize(86,null),d.localize(87,null),d.localize(88,null)],default:"on",description:d.localize(89,null)})}validate(Y){let $e=this.defaultValue.renderType,je=this.defaultValue.renderFn;return typeof Y<"u"&&(typeof Y=="function"?($e=4,je=Y):Y==="interval"?$e=3:Y==="relative"?$e=2:Y==="on"?$e=1:$e=0),{renderType:$e,renderFn:je}}}function re(x){const Y=x.get(96);return Y==="editable"?x.get(89):Y!=="on"}e.filterValidationDecorations=re;class ie extends D{constructor(){const Y=[],$e={type:"number",description:d.localize(90,null)};super(100,"rulers",Y,{type:"array",items:{anyOf:[$e,{type:["object"],properties:{column:$e,color:{type:"string",description:d.localize(91,null),format:"color-hex"}}}]},default:Y,description:d.localize(92,null)})}validate(Y){if(Array.isArray(Y)){const $e=[];for(const je of Y)if(typeof je=="number")$e.push({column:g.clampedInt(je,0,0,1e4),color:null});else if(je&&typeof je=="object"){const Oe=je;$e.push({column:g.clampedInt(Oe.column,0,0,1e4),color:Oe.color})}return $e.sort((je,Oe)=>je.column-Oe.column),$e}return this.defaultValue}}class ge extends D{constructor(){super(90,"readOnlyMessage",void 0)}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:Y}}function Se(x,Y){if(typeof x!="string")return Y;switch(x){case"hidden":return 2;case"visible":return 3;default:return 1}}class L extends D{constructor(){const Y={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(101,"scrollbar",Y,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[d.localize(93,null),d.localize(94,null),d.localize(95,null)],default:"auto",description:d.localize(96,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[d.localize(97,null),d.localize(98,null),d.localize(99,null)],default:"auto",description:d.localize(100,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Y.verticalScrollbarSize,description:d.localize(101,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Y.horizontalScrollbarSize,description:d.localize(102,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Y.scrollByPage,description:d.localize(103,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const $e=Y,je=g.clampedInt($e.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Oe=g.clampedInt($e.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:g.clampedInt($e.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Se($e.vertical,this.defaultValue.vertical),horizontal:Se($e.horizontal,this.defaultValue.horizontal),useShadows:t($e.useShadows,this.defaultValue.useShadows),verticalHasArrows:t($e.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:t($e.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:t($e.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:t($e.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:je,horizontalSliderSize:g.clampedInt($e.horizontalSliderSize,je,0,1e3),verticalScrollbarSize:Oe,verticalSliderSize:g.clampedInt($e.verticalSliderSize,Oe,0,1e3),scrollByPage:t($e.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class q extends D{constructor(){const Y={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(123,"unicodeHighlight",Y,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.nonBasicASCII,description:d.localize(104,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Y.invisibleCharacters,description:d.localize(105,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Y.ambiguousCharacters,description:d.localize(106,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.includeComments,description:d.localize(107,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.includeStrings,description:d.localize(108,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Y.allowedCharacters,description:d.localize(109,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Y.allowedLocales,description:d.localize(110,null)}})}applyUpdate(Y,$e){let je=!1;$e.allowedCharacters&&Y&&(R.$Mm(Y.allowedCharacters,$e.allowedCharacters)||(Y={...Y,allowedCharacters:$e.allowedCharacters},je=!0)),$e.allowedLocales&&Y&&(R.$Mm(Y.allowedLocales,$e.allowedLocales)||(Y={...Y,allowedLocales:$e.allowedLocales},je=!0));const Oe=super.applyUpdate(Y,$e);return je?new u(Oe.newValue,!0):Oe}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const $e=Y;return{nonBasicASCII:ee($e.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:t($e.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:t($e.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ee($e.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ee($e.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Y.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Y.allowedLocales,this.defaultValue.allowedLocales)}}c(Y,$e){if(typeof Y!="object"||!Y)return $e;const je={};for(const[Oe,Ye]of Object.entries(Y))Ye===!0&&(je[Oe]=!0);return je}}class G extends D{constructor(){const Y={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(61,"inlineSuggest",Y,{"editor.inlineSuggest.enabled":{type:"boolean",default:Y.enabled,description:d.localize(111,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Y.showToolbar,enum:["always","onHover"],enumDescriptions:[d.localize(112,null),d.localize(113,null)],description:d.localize(114,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Y.suppressSuggestions,description:d.localize(115,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const $e=Y;return{enabled:t($e.enabled,this.defaultValue.enabled),mode:a($e.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:a($e.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:t($e.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:t($e.keepOnBlur,this.defaultValue.keepOnBlur)}}}class Q extends D{constructor(){const Y={enabled:M.$Lr.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:M.$Lr.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(14,"bracketPairColorization",Y,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Y.enabled,markdownDescription:d.localize(116,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Y.independentColorPoolPerBracketType,description:d.localize(117,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const $e=Y;return{enabled:t($e.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:t($e.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class K extends D{constructor(){const Y={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(15,"guides",Y,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[d.localize(118,null),d.localize(119,null),d.localize(120,null)],default:Y.bracketPairs,description:d.localize(121,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[d.localize(122,null),d.localize(123,null),d.localize(124,null)],default:Y.bracketPairsHorizontal,description:d.localize(125,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Y.highlightActiveBracketPair,description:d.localize(126,null)},"editor.guides.indentation":{type:"boolean",default:Y.indentation,description:d.localize(127,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[d.localize(128,null),d.localize(129,null),d.localize(130,null)],default:Y.highlightActiveIndentation,description:d.localize(131,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const $e=Y;return{bracketPairs:ee($e.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ee($e.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:t($e.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:t($e.indentation,this.defaultValue.indentation),highlightActiveIndentation:ee($e.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ee(x,Y,$e){const je=$e.indexOf(x);return je===-1?Y:$e[je]}class ce extends D{constructor(){const Y={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(116,"suggest",Y,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[d.localize(132,null),d.localize(133,null)],default:Y.insertMode,description:d.localize(134,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Y.filterGraceful,description:d.localize(135,null)},"editor.suggest.localityBonus":{type:"boolean",default:Y.localityBonus,description:d.localize(136,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Y.shareSuggestSelections,markdownDescription:d.localize(137,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[d.localize(138,null),d.localize(139,null),d.localize(140,null),d.localize(141,null)],default:Y.selectionMode,markdownDescription:d.localize(142,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Y.snippetsPreventQuickSuggestions,description:d.localize(143,null)},"editor.suggest.showIcons":{type:"boolean",default:Y.showIcons,description:d.localize(144,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Y.showStatusBar,description:d.localize(145,null)},"editor.suggest.preview":{type:"boolean",default:Y.preview,description:d.localize(146,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Y.showInlineDetails,description:d.localize(147,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:d.localize(148,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:d.localize(149,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:d.localize(150,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:d.localize(151,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:d.localize(152,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:d.localize(153,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:d.localize(154,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:d.localize(155,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:d.localize(156,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:d.localize(157,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:d.localize(158,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:d.localize(159,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:d.localize(160,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:d.localize(161,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:d.localize(162,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:d.localize(163,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:d.localize(164,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:d.localize(165,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:d.localize(166,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:d.localize(167,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:d.localize(168,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:d.localize(169,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:d.localize(170,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:d.localize(171,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:d.localize(172,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:d.localize(173,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:d.localize(174,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:d.localize(175,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:d.localize(176,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:d.localize(177,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:d.localize(178,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:d.localize(179,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const $e=Y;return{insertMode:a($e.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:t($e.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:t($e.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:t($e.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:t($e.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:a($e.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:t($e.showIcons,this.defaultValue.showIcons),showStatusBar:t($e.showStatusBar,this.defaultValue.showStatusBar),preview:t($e.preview,this.defaultValue.preview),previewMode:a($e.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:t($e.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:t($e.showMethods,this.defaultValue.showMethods),showFunctions:t($e.showFunctions,this.defaultValue.showFunctions),showConstructors:t($e.showConstructors,this.defaultValue.showConstructors),showDeprecated:t($e.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:t($e.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:t($e.showFields,this.defaultValue.showFields),showVariables:t($e.showVariables,this.defaultValue.showVariables),showClasses:t($e.showClasses,this.defaultValue.showClasses),showStructs:t($e.showStructs,this.defaultValue.showStructs),showInterfaces:t($e.showInterfaces,this.defaultValue.showInterfaces),showModules:t($e.showModules,this.defaultValue.showModules),showProperties:t($e.showProperties,this.defaultValue.showProperties),showEvents:t($e.showEvents,this.defaultValue.showEvents),showOperators:t($e.showOperators,this.defaultValue.showOperators),showUnits:t($e.showUnits,this.defaultValue.showUnits),showValues:t($e.showValues,this.defaultValue.showValues),showConstants:t($e.showConstants,this.defaultValue.showConstants),showEnums:t($e.showEnums,this.defaultValue.showEnums),showEnumMembers:t($e.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:t($e.showKeywords,this.defaultValue.showKeywords),showWords:t($e.showWords,this.defaultValue.showWords),showColors:t($e.showColors,this.defaultValue.showColors),showFiles:t($e.showFiles,this.defaultValue.showFiles),showReferences:t($e.showReferences,this.defaultValue.showReferences),showFolders:t($e.showFolders,this.defaultValue.showFolders),showTypeParameters:t($e.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:t($e.showSnippets,this.defaultValue.showSnippets),showUsers:t($e.showUsers,this.defaultValue.showUsers),showIssues:t($e.showIssues,this.defaultValue.showIssues)}}}class ze extends D{constructor(){super(111,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:d.localize(180,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:d.localize(181,null),default:!0,type:"boolean"}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:t(Y.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:t(Y.selectSubwords,this.defaultValue.selectSubwords)}}}var Ue;(function(x){x[x.None=0]="None",x[x.Same=1]="Same",x[x.Indent=2]="Indent",x[x.DeepIndent=3]="DeepIndent"})(Ue||(e.WrappingIndent=Ue={}));class Qe extends D{constructor(){super(135,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[d.localize(182,null),d.localize(183,null),d.localize(184,null),d.localize(185,null)],description:d.localize(186,null),default:"same"}})}validate(Y){switch(Y){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Y,$e,je){return $e.get(2)===2?0:je}}class He extends p{constructor(){super(143)}compute(Y,$e,je){const Oe=$e.get(142);return{isDominatedByLongLines:Y.isDominatedByLongLines,isWordWrapMinified:Oe.isWordWrapMinified,isViewportWrapping:Oe.isViewportWrapping,wrappingColumn:Oe.wrappingColumn}}}class et extends D{constructor(){const Y={enabled:!0,showDropSelector:"afterDrop"};super(35,"dropIntoEditor",Y,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Y.enabled,markdownDescription:d.localize(187,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:d.localize(188,null),enum:["afterDrop","never"],enumDescriptions:[d.localize(189,null),d.localize(190,null)],default:"afterDrop"}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const $e=Y;return{enabled:t($e.enabled,this.defaultValue.enabled),showDropSelector:a($e.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class Xe extends D{constructor(){const Y={enabled:!0,showPasteSelector:"afterPaste"};super(83,"pasteAs",Y,{"editor.pasteAs.enabled":{type:"boolean",default:Y.enabled,markdownDescription:d.localize(191,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:d.localize(192,null),enum:["afterPaste","never"],enumDescriptions:[d.localize(193,null),d.localize(194,null)],default:"afterPaste"}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const $e=Y;return{enabled:t($e.enabled,this.defaultValue.enabled),showPasteSelector:a($e.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const xe="Consolas, 'Courier New', monospace",it="Menlo, Monaco, 'Courier New', monospace",tt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:I.$j?it:I.$k?tt:xe,fontWeight:"normal",fontSize:I.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ne(x){return e.editorOptionsRegistry[x.id]=x,x}var st;(function(x){x[x.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",x[x.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",x[x.accessibilitySupport=2]="accessibilitySupport",x[x.accessibilityPageSize=3]="accessibilityPageSize",x[x.ariaLabel=4]="ariaLabel",x[x.ariaRequired=5]="ariaRequired",x[x.autoClosingBrackets=6]="autoClosingBrackets",x[x.screenReaderAnnounceInlineSuggestion=7]="screenReaderAnnounceInlineSuggestion",x[x.autoClosingDelete=8]="autoClosingDelete",x[x.autoClosingOvertype=9]="autoClosingOvertype",x[x.autoClosingQuotes=10]="autoClosingQuotes",x[x.autoIndent=11]="autoIndent",x[x.automaticLayout=12]="automaticLayout",x[x.autoSurround=13]="autoSurround",x[x.bracketPairColorization=14]="bracketPairColorization",x[x.guides=15]="guides",x[x.codeLens=16]="codeLens",x[x.codeLensFontFamily=17]="codeLensFontFamily",x[x.codeLensFontSize=18]="codeLensFontSize",x[x.colorDecorators=19]="colorDecorators",x[x.colorDecoratorsLimit=20]="colorDecoratorsLimit",x[x.columnSelection=21]="columnSelection",x[x.comments=22]="comments",x[x.contextmenu=23]="contextmenu",x[x.copyWithSyntaxHighlighting=24]="copyWithSyntaxHighlighting",x[x.cursorBlinking=25]="cursorBlinking",x[x.cursorSmoothCaretAnimation=26]="cursorSmoothCaretAnimation",x[x.cursorStyle=27]="cursorStyle",x[x.cursorSurroundingLines=28]="cursorSurroundingLines",x[x.cursorSurroundingLinesStyle=29]="cursorSurroundingLinesStyle",x[x.cursorWidth=30]="cursorWidth",x[x.disableLayerHinting=31]="disableLayerHinting",x[x.disableMonospaceOptimizations=32]="disableMonospaceOptimizations",x[x.domReadOnly=33]="domReadOnly",x[x.dragAndDrop=34]="dragAndDrop",x[x.dropIntoEditor=35]="dropIntoEditor",x[x.emptySelectionClipboard=36]="emptySelectionClipboard",x[x.experimentalWhitespaceRendering=37]="experimentalWhitespaceRendering",x[x.extraEditorClassName=38]="extraEditorClassName",x[x.fastScrollSensitivity=39]="fastScrollSensitivity",x[x.find=40]="find",x[x.fixedOverflowWidgets=41]="fixedOverflowWidgets",x[x.folding=42]="folding",x[x.foldingStrategy=43]="foldingStrategy",x[x.foldingHighlight=44]="foldingHighlight",x[x.foldingImportsByDefault=45]="foldingImportsByDefault",x[x.foldingMaximumRegions=46]="foldingMaximumRegions",x[x.unfoldOnClickAfterEndOfLine=47]="unfoldOnClickAfterEndOfLine",x[x.fontFamily=48]="fontFamily",x[x.fontInfo=49]="fontInfo",x[x.fontLigatures=50]="fontLigatures",x[x.fontSize=51]="fontSize",x[x.fontWeight=52]="fontWeight",x[x.fontVariations=53]="fontVariations",x[x.formatOnPaste=54]="formatOnPaste",x[x.formatOnType=55]="formatOnType",x[x.glyphMargin=56]="glyphMargin",x[x.gotoLocation=57]="gotoLocation",x[x.hideCursorInOverviewRuler=58]="hideCursorInOverviewRuler",x[x.hover=59]="hover",x[x.inDiffEditor=60]="inDiffEditor",x[x.inlineSuggest=61]="inlineSuggest",x[x.letterSpacing=62]="letterSpacing",x[x.lightbulb=63]="lightbulb",x[x.lineDecorationsWidth=64]="lineDecorationsWidth",x[x.lineHeight=65]="lineHeight",x[x.lineNumbers=66]="lineNumbers",x[x.lineNumbersMinChars=67]="lineNumbersMinChars",x[x.linkedEditing=68]="linkedEditing",x[x.links=69]="links",x[x.matchBrackets=70]="matchBrackets",x[x.minimap=71]="minimap",x[x.mouseStyle=72]="mouseStyle",x[x.mouseWheelScrollSensitivity=73]="mouseWheelScrollSensitivity",x[x.mouseWheelZoom=74]="mouseWheelZoom",x[x.multiCursorMergeOverlapping=75]="multiCursorMergeOverlapping",x[x.multiCursorModifier=76]="multiCursorModifier",x[x.multiCursorPaste=77]="multiCursorPaste",x[x.multiCursorLimit=78]="multiCursorLimit",x[x.occurrencesHighlight=79]="occurrencesHighlight",x[x.overviewRulerBorder=80]="overviewRulerBorder",x[x.overviewRulerLanes=81]="overviewRulerLanes",x[x.padding=82]="padding",x[x.pasteAs=83]="pasteAs",x[x.parameterHints=84]="parameterHints",x[x.peekWidgetDefaultFocus=85]="peekWidgetDefaultFocus",x[x.definitionLinkOpensInPeek=86]="definitionLinkOpensInPeek",x[x.quickSuggestions=87]="quickSuggestions",x[x.quickSuggestionsDelay=88]="quickSuggestionsDelay",x[x.readOnly=89]="readOnly",x[x.readOnlyMessage=90]="readOnlyMessage",x[x.renameOnType=91]="renameOnType",x[x.renderControlCharacters=92]="renderControlCharacters",x[x.renderFinalNewline=93]="renderFinalNewline",x[x.renderLineHighlight=94]="renderLineHighlight",x[x.renderLineHighlightOnlyWhenFocus=95]="renderLineHighlightOnlyWhenFocus",x[x.renderValidationDecorations=96]="renderValidationDecorations",x[x.renderWhitespace=97]="renderWhitespace",x[x.revealHorizontalRightPadding=98]="revealHorizontalRightPadding",x[x.roundedSelection=99]="roundedSelection",x[x.rulers=100]="rulers",x[x.scrollbar=101]="scrollbar",x[x.scrollBeyondLastColumn=102]="scrollBeyondLastColumn",x[x.scrollBeyondLastLine=103]="scrollBeyondLastLine",x[x.scrollPredominantAxis=104]="scrollPredominantAxis",x[x.selectionClipboard=105]="selectionClipboard",x[x.selectionHighlight=106]="selectionHighlight",x[x.selectOnLineNumbers=107]="selectOnLineNumbers",x[x.showFoldingControls=108]="showFoldingControls",x[x.showUnused=109]="showUnused",x[x.snippetSuggestions=110]="snippetSuggestions",x[x.smartSelect=111]="smartSelect",x[x.smoothScrolling=112]="smoothScrolling",x[x.stickyScroll=113]="stickyScroll",x[x.stickyTabStops=114]="stickyTabStops",x[x.stopRenderingLineAfter=115]="stopRenderingLineAfter",x[x.suggest=116]="suggest",x[x.suggestFontSize=117]="suggestFontSize",x[x.suggestLineHeight=118]="suggestLineHeight",x[x.suggestOnTriggerCharacters=119]="suggestOnTriggerCharacters",x[x.suggestSelection=120]="suggestSelection",x[x.tabCompletion=121]="tabCompletion",x[x.tabIndex=122]="tabIndex",x[x.unicodeHighlighting=123]="unicodeHighlighting",x[x.unusualLineTerminators=124]="unusualLineTerminators",x[x.useShadowDOM=125]="useShadowDOM",x[x.useTabStops=126]="useTabStops",x[x.wordBreak=127]="wordBreak",x[x.wordSeparators=128]="wordSeparators",x[x.wordWrap=129]="wordWrap",x[x.wordWrapBreakAfterCharacters=130]="wordWrapBreakAfterCharacters",x[x.wordWrapBreakBeforeCharacters=131]="wordWrapBreakBeforeCharacters",x[x.wordWrapColumn=132]="wordWrapColumn",x[x.wordWrapOverride1=133]="wordWrapOverride1",x[x.wordWrapOverride2=134]="wordWrapOverride2",x[x.wrappingIndent=135]="wrappingIndent",x[x.wrappingStrategy=136]="wrappingStrategy",x[x.showDeprecated=137]="showDeprecated",x[x.inlayHints=138]="inlayHints",x[x.editorClassName=139]="editorClassName",x[x.pixelRatio=140]="pixelRatio",x[x.tabFocusMode=141]="tabFocusMode",x[x.layoutInfo=142]="layoutInfo",x[x.wrappingInfo=143]="wrappingInfo",x[x.defaultColorDecorators=144]="defaultColorDecorators",x[x.colorDecoratorsActivatedOn=145]="colorDecoratorsActivatedOn",x[x.inlineCompletionsAccessibilityVerbose=146]="inlineCompletionsAccessibilityVerbose"})(st||(e.EditorOption=st={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ne(new i(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:d.localize(195,null)})),acceptSuggestionOnEnter:Ne(new r(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",d.localize(196,null),""],markdownDescription:d.localize(197,null)})),accessibilitySupport:Ne(new $),accessibilityPageSize:Ne(new g(3,"accessibilityPageSize",10,1,1073741824,{description:d.localize(198,null),tags:["accessibility"]})),ariaLabel:Ne(new n(4,"ariaLabel",d.localize(199,null))),ariaRequired:Ne(new i(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Ne(new i(7,"screenReaderAnnounceInlineSuggestion",!0,{description:d.localize(200,null),tags:["accessibility"]})),autoClosingBrackets:Ne(new r(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",d.localize(201,null),d.localize(202,null),""],description:d.localize(203,null)})),autoClosingDelete:Ne(new r(8,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",d.localize(204,null),""],description:d.localize(205,null)})),autoClosingOvertype:Ne(new r(9,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",d.localize(206,null),""],description:d.localize(207,null)})),autoClosingQuotes:Ne(new r(10,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",d.localize(208,null),d.localize(209,null),""],description:d.localize(210,null)})),autoIndent:Ne(new s(11,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],v,{enumDescriptions:[d.localize(211,null),d.localize(212,null),d.localize(213,null),d.localize(214,null),d.localize(215,null)],description:d.localize(216,null)})),automaticLayout:Ne(new i(12,"automaticLayout",!1)),autoSurround:Ne(new r(13,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[d.localize(217,null),d.localize(218,null),d.localize(219,null),""],description:d.localize(220,null)})),bracketPairColorization:Ne(new Q),bracketPairGuides:Ne(new K),stickyTabStops:Ne(new i(114,"stickyTabStops",!1,{description:d.localize(221,null)})),codeLens:Ne(new i(16,"codeLens",!0,{description:d.localize(222,null)})),codeLensFontFamily:Ne(new n(17,"codeLensFontFamily","",{description:d.localize(223,null)})),codeLensFontSize:Ne(new g(18,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:d.localize(224,null)})),colorDecorators:Ne(new i(19,"colorDecorators",!0,{description:d.localize(225,null)})),colorDecoratorActivatedOn:Ne(new r(145,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[d.localize(226,null),d.localize(227,null),d.localize(228,null)],description:d.localize(229,null)})),colorDecoratorsLimit:Ne(new g(20,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:d.localize(230,null)})),columnSelection:Ne(new i(21,"columnSelection",!1,{description:d.localize(231,null)})),comments:Ne(new w),contextmenu:Ne(new i(23,"contextmenu",!0)),copyWithSyntaxHighlighting:Ne(new i(24,"copyWithSyntaxHighlighting",!0,{description:d.localize(232,null)})),cursorBlinking:Ne(new s(25,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],o,{description:d.localize(233,null)})),cursorSmoothCaretAnimation:Ne(new r(26,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[d.localize(234,null),d.localize(235,null),d.localize(236,null)],description:d.localize(237,null)})),cursorStyle:Ne(new s(27,"cursorStyle",l.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],F,{description:d.localize(238,null)})),cursorSurroundingLines:Ne(new g(28,"cursorSurroundingLines",0,0,1073741824,{description:d.localize(239,null)})),cursorSurroundingLinesStyle:Ne(new r(29,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[d.localize(240,null),d.localize(241,null)],description:d.localize(242,null)})),cursorWidth:Ne(new g(30,"cursorWidth",0,0,1073741824,{markdownDescription:d.localize(243,null)})),disableLayerHinting:Ne(new i(31,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ne(new i(32,"disableMonospaceOptimizations",!1)),domReadOnly:Ne(new i(33,"domReadOnly",!1)),dragAndDrop:Ne(new i(34,"dragAndDrop",!0,{description:d.localize(244,null)})),emptySelectionClipboard:Ne(new V),dropIntoEditor:Ne(new et),stickyScroll:Ne(new ae),experimentalWhitespaceRendering:Ne(new r(37,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[d.localize(245,null),d.localize(246,null),d.localize(247,null)],description:d.localize(248,null)})),extraEditorClassName:Ne(new n(38,"extraEditorClassName","")),fastScrollSensitivity:Ne(new C(39,"fastScrollSensitivity",5,x=>x<=0?5:x,{markdownDescription:d.localize(249,null)})),find:Ne(new B),fixedOverflowWidgets:Ne(new i(41,"fixedOverflowWidgets",!1)),folding:Ne(new i(42,"folding",!0,{description:d.localize(250,null)})),foldingStrategy:Ne(new r(43,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[d.localize(251,null),d.localize(252,null)],description:d.localize(253,null)})),foldingHighlight:Ne(new i(44,"foldingHighlight",!0,{description:d.localize(254,null)})),foldingImportsByDefault:Ne(new i(45,"foldingImportsByDefault",!1,{description:d.localize(255,null)})),foldingMaximumRegions:Ne(new g(46,"foldingMaximumRegions",5e3,10,65e3,{description:d.localize(256,null)})),unfoldOnClickAfterEndOfLine:Ne(new i(47,"unfoldOnClickAfterEndOfLine",!1,{description:d.localize(257,null)})),fontFamily:Ne(new n(48,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:d.localize(258,null)})),fontInfo:Ne(new z),fontLigatures2:Ne(new j),fontSize:Ne(new ne),fontWeight:Ne(new Z),fontVariations:Ne(new U),formatOnPaste:Ne(new i(54,"formatOnPaste",!1,{description:d.localize(259,null)})),formatOnType:Ne(new i(55,"formatOnType",!1,{description:d.localize(260,null)})),glyphMargin:Ne(new i(56,"glyphMargin",!0,{description:d.localize(261,null)})),gotoLocation:Ne(new we),hideCursorInOverviewRuler:Ne(new i(58,"hideCursorInOverviewRuler",!1,{description:d.localize(262,null)})),hover:Ne(new Ee),inDiffEditor:Ne(new i(60,"inDiffEditor",!1)),letterSpacing:Ne(new C(62,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,x=>C.clamp(x,-5,20),{description:d.localize(263,null)})),lightbulb:Ne(new Ce),lineDecorationsWidth:Ne(new ue),lineHeight:Ne(new O),lineNumbers:Ne(new he),lineNumbersMinChars:Ne(new g(67,"lineNumbersMinChars",5,1,300)),linkedEditing:Ne(new i(68,"linkedEditing",!1,{description:d.localize(264,null)})),links:Ne(new i(69,"links",!0,{description:d.localize(265,null)})),matchBrackets:Ne(new r(70,"matchBrackets","always",["always","near","never"],{description:d.localize(266,null)})),minimap:Ne(new J),mouseStyle:Ne(new r(72,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ne(new C(73,"mouseWheelScrollSensitivity",1,x=>x===0?1:x,{markdownDescription:d.localize(267,null)})),mouseWheelZoom:Ne(new i(74,"mouseWheelZoom",!1,{markdownDescription:d.localize(268,null)})),multiCursorMergeOverlapping:Ne(new i(75,"multiCursorMergeOverlapping",!0,{description:d.localize(269,null)})),multiCursorModifier:Ne(new s(76,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],le,{markdownEnumDescriptions:[d.localize(270,null),d.localize(271,null)],markdownDescription:d.localize(272,null)})),multiCursorPaste:Ne(new r(77,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[d.localize(273,null),d.localize(274,null)],markdownDescription:d.localize(275,null)})),multiCursorLimit:Ne(new g(78,"multiCursorLimit",1e4,1,1e5,{markdownDescription:d.localize(276,null)})),occurrencesHighlight:Ne(new i(79,"occurrencesHighlight",!0,{description:d.localize(277,null)})),overviewRulerBorder:Ne(new i(80,"overviewRulerBorder",!0,{description:d.localize(278,null)})),overviewRulerLanes:Ne(new g(81,"overviewRulerLanes",3,0,3)),padding:Ne(new ye),pasteAs:Ne(new Xe),parameterHints:Ne(new ve),peekWidgetDefaultFocus:Ne(new r(85,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[d.localize(279,null),d.localize(280,null)],description:d.localize(281,null)})),definitionLinkOpensInPeek:Ne(new i(86,"definitionLinkOpensInPeek",!1,{description:d.localize(282,null)})),quickSuggestions:Ne(new ke),quickSuggestionsDelay:Ne(new g(88,"quickSuggestionsDelay",10,0,1073741824,{description:d.localize(283,null)})),readOnly:Ne(new i(89,"readOnly",!1)),readOnlyMessage:Ne(new ge),renameOnType:Ne(new i(91,"renameOnType",!1,{description:d.localize(284,null),markdownDeprecationMessage:d.localize(285,null)})),renderControlCharacters:Ne(new i(92,"renderControlCharacters",!0,{description:d.localize(286,null),restricted:!0})),renderFinalNewline:Ne(new r(93,"renderFinalNewline",I.$k?"dimmed":"on",["off","on","dimmed"],{description:d.localize(287,null)})),renderLineHighlight:Ne(new r(94,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",d.localize(288,null)],description:d.localize(289,null)})),renderLineHighlightOnlyWhenFocus:Ne(new i(95,"renderLineHighlightOnlyWhenFocus",!1,{description:d.localize(290,null)})),renderValidationDecorations:Ne(new r(96,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ne(new r(97,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",d.localize(291,null),d.localize(292,null),d.localize(293,null),""],description:d.localize(294,null)})),revealHorizontalRightPadding:Ne(new g(98,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ne(new i(99,"roundedSelection",!0,{description:d.localize(295,null)})),rulers:Ne(new ie),scrollbar:Ne(new L),scrollBeyondLastColumn:Ne(new g(102,"scrollBeyondLastColumn",4,0,1073741824,{description:d.localize(296,null)})),scrollBeyondLastLine:Ne(new i(103,"scrollBeyondLastLine",!0,{description:d.localize(297,null)})),scrollPredominantAxis:Ne(new i(104,"scrollPredominantAxis",!0,{description:d.localize(298,null)})),selectionClipboard:Ne(new i(105,"selectionClipboard",!0,{description:d.localize(299,null),included:I.$k})),selectionHighlight:Ne(new i(106,"selectionHighlight",!0,{description:d.localize(300,null)})),selectOnLineNumbers:Ne(new i(107,"selectOnLineNumbers",!0)),showFoldingControls:Ne(new r(108,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[d.localize(301,null),d.localize(302,null),d.localize(303,null)],description:d.localize(304,null)})),showUnused:Ne(new i(109,"showUnused",!0,{description:d.localize(305,null)})),showDeprecated:Ne(new i(137,"showDeprecated",!0,{description:d.localize(306,null)})),inlayHints:Ne(new _),snippetSuggestions:Ne(new r(110,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[d.localize(307,null),d.localize(308,null),d.localize(309,null),d.localize(310,null)],description:d.localize(311,null)})),smartSelect:Ne(new ze),smoothScrolling:Ne(new i(112,"smoothScrolling",!1,{description:d.localize(312,null)})),stopRenderingLineAfter:Ne(new g(115,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ne(new ce),inlineSuggest:Ne(new G),inlineCompletionsAccessibilityVerbose:Ne(new i(146,"inlineCompletionsAccessibilityVerbose",!1,{description:d.localize(313,null)})),suggestFontSize:Ne(new g(117,"suggestFontSize",0,0,1e3,{markdownDescription:d.localize(314,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ne(new g(118,"suggestLineHeight",0,0,1e3,{markdownDescription:d.localize(315,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ne(new i(119,"suggestOnTriggerCharacters",!0,{description:d.localize(316,null)})),suggestSelection:Ne(new r(120,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[d.localize(317,null),d.localize(318,null),d.localize(319,null)],description:d.localize(320,null)})),tabCompletion:Ne(new r(121,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[d.localize(321,null),d.localize(322,null),d.localize(323,null)],description:d.localize(324,null)})),tabIndex:Ne(new g(122,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ne(new q),unusualLineTerminators:Ne(new r(124,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[d.localize(325,null),d.localize(326,null),d.localize(327,null)],description:d.localize(328,null)})),useShadowDOM:Ne(new i(125,"useShadowDOM",!0)),useTabStops:Ne(new i(126,"useTabStops",!0,{description:d.localize(329,null)})),wordBreak:Ne(new r(127,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[d.localize(330,null),d.localize(331,null)],description:d.localize(332,null)})),wordSeparators:Ne(new n(128,"wordSeparators",A.$Mr,{description:d.localize(333,null)})),wordWrap:Ne(new r(129,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[d.localize(334,null),d.localize(335,null),d.localize(336,null),d.localize(337,null)],description:d.localize(338,null)})),wordWrapBreakAfterCharacters:Ne(new n(130,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ne(new n(131,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ne(new g(132,"wordWrapColumn",80,1,1073741824,{markdownDescription:d.localize(339,null)})),wordWrapOverride1:Ne(new r(133,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ne(new r(134,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ne(new W),defaultColorDecorators:Ne(new i(144,"defaultColorDecorators",!1,{markdownDescription:d.localize(340,null)})),pixelRatio:Ne(new be),tabFocusMode:Ne(new i(141,"tabFocusMode",!1,{markdownDescription:d.localize(341,null)})),layoutInfo:Ne(new X),wrappingInfo:Ne(new He),wrappingIndent:Ne(new Qe),wrappingStrategy:Ne(new de)}}),define(Pe[138],Ae([10,11]),function(pe,e){return pe.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Pe[139],Ae([10,11]),function(pe,e){return pe.create("vs/platform/contextkey/common/contextkey",e)}),define(Pe[140],Ae([10,11]),function(pe,e){return pe.create("vs/platform/contextkey/common/scanner",e)}),define(Pe[141],Ae([10,11]),function(pe,e){return pe.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Pe[142],Ae([10,11]),function(pe,e){return pe.create("vs/platform/extensions/common/extensionValidator",e)}),define(Pe[143],Ae([10,11]),function(pe,e){return pe.create("vs/platform/files/common/files",e)}),define(Pe[144],Ae([10,11]),function(pe,e){return pe.create("vs/platform/markers/common/markers",e)}),define(Pe[145],Ae([10,11]),function(pe,e){return pe.create("vs/platform/theme/common/iconRegistry",e)}),define(Pe[146],Ae([10,11]),function(pe,e){return pe.create("vs/platform/workspace/common/workspace",e)}),define(Pe[147],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostChat",e)}),define(Pe[148],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Pe[149],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Pe[150],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Pe[151],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostLogService",e)}),define(Pe[152],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostNotebook",e)}),define(Pe[153],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostProgress",e)}),define(Pe[154],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Pe[155],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Pe[156],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Pe[157],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Pe[158],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Pe[159],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Pe[160],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/common/editor",e)}),define(Pe[161],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/common/views",e)}),define(Pe[162],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Pe[163],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/contrib/debug/common/debug",e)}),define(Pe[164],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Pe[165],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Pe[166],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Pe[167],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Pe[168],Ae([10,11]),function(pe,e){return pe.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Pe[169],Ae([1,0,9,140]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$si=e.TokenType=void 0;var I;(function(f){f[f.LParen=0]="LParen",f[f.RParen=1]="RParen",f[f.Neg=2]="Neg",f[f.Eq=3]="Eq",f[f.NotEq=4]="NotEq",f[f.Lt=5]="Lt",f[f.LtEq=6]="LtEq",f[f.Gt=7]="Gt",f[f.GtEq=8]="GtEq",f[f.RegexOp=9]="RegexOp",f[f.RegexStr=10]="RegexStr",f[f.True=11]="True",f[f.False=12]="False",f[f.In=13]="In",f[f.Not=14]="Not",f[f.And=15]="And",f[f.Or=16]="Or",f[f.Str=17]="Str",f[f.QuotedStr=18]="QuotedStr",f[f.Error=19]="Error",f[f.EOF=20]="EOF"})(I||(e.TokenType=I={}));function M(...f){switch(f.length){case 1:return(0,R.localize)(0,null,f[0]);case 2:return(0,R.localize)(1,null,f[0],f[1]);case 3:return(0,R.localize)(2,null,f[0],f[1],f[2]);default:return}}const A=(0,R.localize)(3,null),d=(0,R.localize)(4,null);class k{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(P){switch(P.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return P.isTripleEq?"===":"==";case 4:return P.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return P.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return P.lexeme;case 18:return P.lexeme;case 19:return P.lexeme;case 20:return"EOF";default:throw(0,y.$6)(`unhandled token type: ${JSON.stringify(P)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(P=>P.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(P){return this.c=P,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const D=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:D})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const D=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:D})}else this.h(126)?this.k(9):this.l(M("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(M("&&"));break;case 124:this.h(124)?this.k(16):this.l(M("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(P){return this.r()||this.c.charCodeAt(this.e)!==P?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(P){this.f.push({type:P,offset:this.d})}l(P){const D=this.d,u=this.c.substring(this.d,this.e),b={type:19,offset:this.d,lexeme:u};this.g.push({offset:D,lexeme:u,additionalInfo:P}),this.f.push(b)}n(){this.m.lastIndex=this.d;const P=this.m.exec(this.c);if(P){this.e=this.d+P[0].length;const D=this.c.substring(this.d,this.e),u=k.b.get(D);u?this.k(u):this.f.push({type:17,lexeme:D,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let P=this.e,D=!1,u=!1;for(;;){if(P>=this.c.length){this.e=P,this.l(d);return}const p=this.c.charCodeAt(P);if(D)D=!1;else if(p===47&&!u){P++;break}else p===91?u=!0:p===92?D=!0:p===93&&(u=!1);P++}for(;P<this.c.length&&k.a.has(this.c.charCodeAt(P));)P++;this.e=P;const b=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:b,offset:this.d})}r(){return this.e>=this.c.length}}e.$si=k}),define(Pe[170],Ae([1,0,23,29,142,276]),function(pe,e,y,R,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,d=/^-(\d{4})(\d{2})(\d{2})$/;function k(i){return i=i.trim(),i==="*"||A.test(i)}e.$to=k;function f(i){if(!k(i))return null;if(i=i.trim(),i==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const c=i.match(A);return c?{hasCaret:c[1]==="^",hasGreaterEquals:c[1]===">=",majorBase:c[2]==="x"?0:parseInt(c[2],10),majorMustEqual:c[2]!=="x",minorBase:c[4]==="x"?0:parseInt(c[4],10),minorMustEqual:c[4]!=="x",patchBase:c[6]==="x"?0:parseInt(c[6],10),patchMustEqual:c[6]!=="x",preRelease:c[8]||null}:null}e.$uo=f;function P(i){if(!i)return null;const c=i.majorBase,g=i.majorMustEqual,S=i.minorBase;let C=i.minorMustEqual;const n=i.patchBase;let a=i.patchMustEqual;i.hasCaret&&(c===0||(C=!1),a=!1);let r=0;if(i.preRelease){const s=d.exec(i.preRelease);if(s){const[,v,$,w]=s;r=Date.UTC(Number(v),Number($)-1,Number(w))}}return{majorBase:c,majorMustEqual:g,minorBase:S,minorMustEqual:C,patchBase:n,patchMustEqual:a,isMinimum:i.hasGreaterEquals,notBefore:r}}e.$vo=P;function D(i,c,g){let S;typeof i=="string"?S=P(f(i)):S=i;let C;c instanceof Date?C=c.getTime():typeof c=="string"&&(C=new Date(c).getTime());let n;if(typeof g=="string"?n=P(f(g)):n=g,!S||!n)return!1;const a=S.majorBase,r=S.minorBase,s=S.patchBase;let v=n.majorBase,$=n.minorBase,w=n.patchBase;const E=n.notBefore;let o=n.majorMustEqual,l=n.minorMustEqual,m=n.patchMustEqual;return n.isMinimum?a>v?!0:a<v?!1:r>$?!0:r<$||C&&C<E?!1:s>=w:(a===1&&v===0&&(!o||!l||!m)&&(v=1,$=0,w=0,o=!0,l=!1,m=!1),a<v?!1:a>v?!o:r<$?!1:r>$?!l:s<w?!1:s>w?!m:!(C&&C<E))}e.$wo=D;function u(i,c,g,S,C){const n=[];if(typeof S.publisher<"u"&&typeof S.publisher!="string")return n.push([R.default.Error,I.localize(0,null)]),n;if(typeof S.name!="string")return n.push([R.default.Error,I.localize(1,null,"name")]),n;if(typeof S.version!="string")return n.push([R.default.Error,I.localize(2,null,"version")]),n;if(!S.engines)return n.push([R.default.Error,I.localize(3,null,"engines")]),n;if(typeof S.engines.vscode!="string")return n.push([R.default.Error,I.localize(4,null,"engines.vscode")]),n;if(typeof S.extensionDependencies<"u"&&!t(S.extensionDependencies))return n.push([R.default.Error,I.localize(5,null,"extensionDependencies")]),n;if(typeof S.activationEvents<"u"){if(!t(S.activationEvents))return n.push([R.default.Error,I.localize(6,null,"activationEvents")]),n;if(typeof S.main>"u"&&typeof S.browser>"u")return n.push([R.default.Error,I.localize(7,null,"activationEvents","main","browser")]),n}if(typeof S.extensionKind<"u"&&typeof S.main>"u"&&n.push([R.default.Warning,I.localize(8,null,"extensionKind")]),typeof S.main<"u"){if(typeof S.main!="string")return n.push([R.default.Error,I.localize(9,null,"main")]),n;{const s=(0,y.$9f)(g,S.main);(0,y.$3f)(s,g)||n.push([R.default.Warning,I.localize(10,null,s.path,g.path)])}}if(typeof S.browser<"u"){if(typeof S.browser!="string")return n.push([R.default.Error,I.localize(11,null,"browser")]),n;{const s=(0,y.$9f)(g,S.browser);(0,y.$3f)(s,g)||n.push([R.default.Warning,I.localize(12,null,s.path,g.path)])}}if(!M.valid(S.version))return n.push([R.default.Error,I.localize(13,null)]),n;const a=[];if(!b(i,c,S,C,a))for(const s of a)n.push([R.default.Error,s]);return n}e.$xo=u;function b(i,c,g,S,C){return S||typeof g.main>"u"&&typeof g.browser>"u"?!0:h(i,c,g.engines.vscode,C)}e.$yo=b;function p(i,c,g){return i==="*"||h(c,g,i)}e.$zo=p;function h(i,c,g,S=[]){const C=P(f(g));if(!C)return S.push(I.localize(14,null,g)),!1;if(C.majorBase===0){if(!C.majorMustEqual||!C.minorMustEqual)return S.push(I.localize(15,null,g)),!1}else if(!C.majorMustEqual)return S.push(I.localize(16,null,g)),!1;return D(i,c,C)?!0:(S.push(I.localize(17,null,i,g)),!1)}function t(i){if(!Array.isArray(i))return!1;for(let c=0,g=i.length;c<g;c++)if(typeof i[c]!="string")return!1;return!0}}),define(Pe[70],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mh=void 0;class y{constructor(I,M=[],A=!1){this.ctor=I,this.staticArguments=M,this.supportsDelayedInstantiation=A}}e.$mh=y}),define(Pe[71],Ae([1,0,70]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$er=e.$dr=e.InstantiationType=void 0;const R=[];var I;(function(d){d[d.Eager=0]="Eager",d[d.Delayed=1]="Delayed"})(I||(e.InstantiationType=I={}));function M(d,k,f){k instanceof y.$mh||(k=new y.$mh(k,[],!!f)),R.push([d,k])}e.$dr=M;function A(){return R}e.$er=A}),define(Pe[171],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vp=e.$Up=void 0;class y{constructor(M,A){this.key=M,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$Up=y;class R{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const A of this.a.values())A.outgoing.size===0&&M.push(A);return M}insertEdge(M,A){const d=this.lookupOrInsertNode(M),k=this.lookupOrInsertNode(A);d.outgoing.set(k.key,k),k.incoming.set(d.key,d)}removeNode(M){const A=this.b(M);this.a.delete(A);for(const d of this.a.values())d.outgoing.delete(A),d.incoming.delete(A)}lookupOrInsertNode(M){const A=this.b(M);let d=this.a.get(A);return d||(d=new y(A,M),this.a.set(A,d)),d}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[A,d]of this.a)M.push(`${A}
	(-> incoming)[${[...d.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...d.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,A]of this.a){const d=new Set([M]),k=this.c(A,d);if(k)return k}}c(M,A){for(const[d,k]of M.outgoing){if(A.has(d))return[...A,d].join(" -> ");A.add(d);const f=this.c(k,A);if(f)return f;A.delete(d)}}}e.$Vp=R}),define(Pe[4],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qh=e.$ph=e.$oh=e._util=void 0;var y;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function d(k){return k[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=d})(y||(e._util=y={})),e.$oh=I("instantiationService");function R(A,d,k){d[y.DI_TARGET]===d?d[y.DI_DEPENDENCIES].push({id:A,index:k}):(d[y.DI_DEPENDENCIES]=[{id:A,index:k}],d[y.DI_TARGET]=d)}function I(A){if(y.serviceIds.has(A))return y.serviceIds.get(A);const d=function(k,f,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(d,k,P)};return d.toString=()=>A,y.serviceIds.set(A,d),d}e.$ph=I;function M(A){return A}e.$qh=M}),define(Pe[43],Ae([1,0,16,2,4]),function(pe,e,y,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.ConfigurationTarget=e.$Xh=e.$Wh=e.$Vh=void 0,e.$Vh=(0,I.$ph)("configurationService");function M(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof R.URI)}e.$Wh=M;function A(i){return i&&typeof i=="object"&&(!i.overrideIdentifiers||Array.isArray(i.overrideIdentifiers))&&!i.overrideIdentifier&&(!i.resource||i.resource instanceof R.URI)}e.$Xh=A;var d;(function(i){i[i.APPLICATION=1]="APPLICATION",i[i.USER=2]="USER",i[i.USER_LOCAL=3]="USER_LOCAL",i[i.USER_REMOTE=4]="USER_REMOTE",i[i.WORKSPACE=5]="WORKSPACE",i[i.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",i[i.DEFAULT=7]="DEFAULT",i[i.MEMORY=8]="MEMORY"})(d||(e.ConfigurationTarget=d={}));function k(i){switch(i){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Yh=k;function f(i){return i.applicationValue!==void 0||i.userValue!==void 0||i.userLocalValue!==void 0||i.userRemoteValue!==void 0||i.workspaceValue!==void 0||i.workspaceFolderValue!==void 0}e.$Zh=f;function P(i,c){const g=Object.create(null);for(const S in i)D(g,S,i[S],c);return g}e.$1h=P;function D(i,c,g,S){const C=c.split("."),n=C.pop();let a=i;for(let r=0;r<C.length;r++){const s=C[r];let v=a[s];switch(typeof v){case"undefined":v=a[s]=Object.create(null);break;case"object":break;default:S(`Ignoring ${c} as ${C.slice(0,r+1).join(".")} is ${JSON.stringify(v)}`);return}a=v}if(typeof a=="object"&&a!==null)try{a[n]=g}catch{S(`Ignoring ${c} as ${C.join(".")} is ${JSON.stringify(a)}`)}else S(`Ignoring ${c} as ${C.join(".")} is ${JSON.stringify(a)}`)}e.$2h=D;function u(i,c){const g=c.split(".");b(i,g)}e.$3h=u;function b(i,c){const g=c.shift();if(c.length===0){delete i[g];return}if(Object.keys(i).indexOf(g)!==-1){const S=i[g];typeof S=="object"&&!Array.isArray(S)&&(b(S,c),Object.keys(S).length===0&&delete i[g])}}function p(i,c,g){function S(a,r){let s=a;for(const v of r){if(typeof s!="object"||s===null)return;s=s[v]}return s}const C=c.split("."),n=S(i,C);return typeof n>"u"?g:n}e.$4h=p;function h(i,c,g){Object.keys(c).forEach(S=>{S!=="__proto__"&&(S in i?y.$ke(i[S])&&y.$ke(c[S])?h(i[S],c[S],g):g&&(i[S]=c[S]):i[S]=c[S])})}e.$5h=h;function t(i){return i.replace(/[\[\]]/g,"")}e.$6h=t}),define(Pe[32],Ae([1,0,22,15,169,4,139,9]),function(pe,e,y,R,I,M,A,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.ContextKeyExprType=e.$ti=void 0;const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",y.$j),k.set("isLinux",y.$k),k.set("isWindows",y.$i),k.set("isWeb",y.$o),k.set("isMacNative",y.$j&&!y.$o),k.set("isEdge",y.$G),k.set("isFirefox",y.$E),k.set("isChrome",y.$D),k.set("isSafari",y.$F);function f(ue,O){if(k.get(ue)!==void 0)throw(0,d.$5)("contextkey.setConstant(k, v) invoked with already set constant `k`");k.set(ue,O)}e.$ti=f;const P=Object.prototype.hasOwnProperty;var D;(function(ue){ue[ue.False=0]="False",ue[ue.True=1]="True",ue[ue.Defined=2]="Defined",ue[ue.Not=3]="Not",ue[ue.Equals=4]="Equals",ue[ue.NotEquals=5]="NotEquals",ue[ue.And=6]="And",ue[ue.Regex=7]="Regex",ue[ue.NotRegex=8]="NotRegex",ue[ue.Or=9]="Or",ue[ue.In=10]="In",ue[ue.NotIn=11]="NotIn",ue[ue.Greater=12]="Greater",ue[ue.GreaterEquals=13]="GreaterEquals",ue[ue.Smaller=14]="Smaller",ue[ue.SmallerEquals=15]="SmallerEquals"})(D||(e.ContextKeyExprType=D={}));const u={regexParsingWithErrorRecovery:!0},b=(0,A.localize)(0,null),p=(0,A.localize)(1,null),h=(0,A.localize)(2,null),t=(0,A.localize)(3,null),i=(0,A.localize)(4,null),c=(0,A.localize)(5,null),g=(0,A.localize)(6,null),S=(0,A.localize)(7,null);class C{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(O=u){this.k=O,this.d=new I.$si,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(O){if(O===""){this.h.push({message:b,offset:0,lexeme:"",additionalInfo:p});return}this.f=this.d.reset(O).scan(),this.g=0,this.h=[];try{const J=this.l();if(!this.E()){const le=this.D(),ye=le.type===17?c:void 0;throw this.h.push({message:i,offset:le.offset,lexeme:I.$si.getLexeme(le),additionalInfo:ye}),C.c}return J}catch(J){if(J!==C.c)throw J;return}}l(){return this.m()}m(){const O=[this.o()];for(;this.y(16);){const J=this.o();O.push(J)}return O.length===1?O[0]:n.or(...O)}o(){const O=[this.s()];for(;this.y(15);){const J=this.s();O.push(J)}return O.length===1?O[0]:n.and(...O)}s(){if(this.y(2)){const O=this.D();switch(O.type){case 11:return this.z(),v.INSTANCE;case 12:return this.z(),$.INSTANCE;case 0:{this.z();const J=this.l();return this.A(1,t),J?.negate()}case 17:return this.z(),F.create(O.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",O)}}return this.t()}t(){const O=this.D();switch(O.type){case 11:return this.z(),n.true();case 12:return this.z(),n.false();case 0:{this.z();const J=this.l();return this.A(1,t),J}case 17:{const J=O.lexeme;if(this.z(),this.y(9)){const ye=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),ye.type!==10)throw this.B("REGEX",ye);const ve=ye.lexeme,be=ve.lastIndexOf("/"),ke=be===ve.length-1?void 0:this.w(ve.substring(be+1));let oe;try{oe=new RegExp(ve.substring(1,be),ke)}catch{throw this.B("REGEX",ye)}return z.create(J,oe)}switch(ye.type){case 10:case 19:{const ve=[ye.lexeme];this.z();let be=this.D(),ke=0;for(let ge=0;ge<ye.lexeme.length;ge++)ye.lexeme.charCodeAt(ge)===40?ke++:ye.lexeme.charCodeAt(ge)===41&&ke--;for(;!this.E()&&be.type!==15&&be.type!==16;){switch(be.type){case 0:ke++;break;case 1:ke--;break;case 10:case 18:for(let ge=0;ge<be.lexeme.length;ge++)be.lexeme.charCodeAt(ge)===40?ke++:ye.lexeme.charCodeAt(ge)===41&&ke--}if(ke<0)break;ve.push(I.$si.getLexeme(be)),this.z(),be=this.D()}const oe=ve.join(""),he=oe.lastIndexOf("/"),re=he===oe.length-1?void 0:this.w(oe.substring(he+1));let ie;try{ie=new RegExp(oe.substring(1,he),re)}catch{throw this.B("REGEX",ye)}return n.regex(J,ie)}case 18:{const ve=ye.lexeme;this.z();let be=null;if(!(0,R.$ld)(ve)){const ke=ve.indexOf("/"),oe=ve.lastIndexOf("/");if(ke!==oe&&ke>=0){const he=ve.slice(ke+1,oe),re=ve[oe+1]==="i"?"i":"";try{be=new RegExp(he,re)}catch{throw this.B("REGEX",ye)}}}if(be===null)throw this.B("REGEX",ye);return z.create(J,be)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,h);const ye=this.u();return n.notIn(J,ye)}switch(this.D().type){case 3:{this.z();const ye=this.u();if(this.x().type===18)return n.equals(J,ye);switch(ye){case"true":return n.has(J);case"false":return n.not(J);default:return n.equals(J,ye)}}case 4:{this.z();const ye=this.u();if(this.x().type===18)return n.notEquals(J,ye);switch(ye){case"true":return n.not(J);case"false":return n.has(J);default:return n.notEquals(J,ye)}}case 5:return this.z(),j.create(J,this.u());case 6:return this.z(),U.create(J,this.u());case 7:return this.z(),V.create(J,this.u());case 8:return this.z(),B.create(J,this.u());case 13:return this.z(),n.in(J,this.u());default:return n.has(J)}}case 20:throw this.h.push({message:g,offset:O.offset,lexeme:"",additionalInfo:S}),C.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const O=this.D();switch(O.type){case 17:case 18:return this.z(),O.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(O){return O.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(O){return this.C(O)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(O,J){if(this.C(O))return this.z();throw this.B(J,this.D())}B(O,J,le){const ye=(0,A.localize)(8,null,O,I.$si.getLexeme(J)),ve=J.offset,be=I.$si.getLexeme(J);return this.h.push({message:ye,offset:ve,lexeme:be,additionalInfo:le}),C.c}C(O){return this.D().type===O}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$ui=C;class n{static false(){return v.INSTANCE}static true(){return $.INSTANCE}static has(O){return w.create(O)}static equals(O,J){return E.create(O,J)}static notEquals(O,J){return m.create(O,J)}static regex(O,J){return z.create(O,J)}static in(O,J){return o.create(O,J)}static notIn(O,J){return l.create(O,J)}static not(O){return F.create(O)}static and(...O){return we.create(O,null,!0)}static or(...O){return Ee.create(O,null,!0)}static greater(O,J){return V.create(O,J)}static greaterEquals(O,J){return B.create(O,J)}static smaller(O,J){return j.create(O,J)}static smallerEquals(O,J){return U.create(O,J)}static{this.c=new C({regexParsingWithErrorRecovery:!1})}static deserialize(O){return O==null?void 0:this.c.parse(O)}}e.$vi=n;function a(ue){const O=new C({regexParsingWithErrorRecovery:!1});return ue.map(J=>(O.parse(J),O.lexingErrors.length>0?O.lexingErrors.map(le=>({errorMessage:le.additionalInfo?(0,A.localize)(9,null,le.additionalInfo):(0,A.localize)(10,null),offset:le.offset,length:le.lexeme.length})):O.parsingErrors.length>0?O.parsingErrors.map(le=>({errorMessage:le.additionalInfo?`${le.message}. ${le.additionalInfo}`:le.message,offset:le.offset,length:le.lexeme.length})):[]))}e.$wi=a;function r(ue,O){const J=ue?ue.substituteConstants():void 0,le=O?O.substituteConstants():void 0;return!J&&!le?!0:!J||!le?!1:J.equals(le)}e.$xi=r;function s(ue,O){return ue.cmp(O)}class v{static{this.INSTANCE=new v}constructor(){this.type=0}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!1}serialize(){return"false"}keys(){return[]}map(O){return this}negate(){return $.INSTANCE}}e.$yi=v;class ${static{this.INSTANCE=new $}constructor(){this.type=1}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!0}serialize(){return"true"}keys(){return[]}map(O){return this}negate(){return v.INSTANCE}}e.$zi=$;class w{static create(O,J=null){const le=k.get(O);return typeof le=="boolean"?le?$.INSTANCE:v.INSTANCE:new w(O,J)}constructor(O,J){this.key=O,this.c=J,this.type=2}cmp(O){return O.type!==this.type?this.type-O.type:X(this.key,O.key)}equals(O){return O.type===this.type?this.key===O.key:!1}substituteConstants(){const O=k.get(this.key);return typeof O=="boolean"?O?$.INSTANCE:v.INSTANCE:this}evaluate(O){return!!O.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(O){return O.mapDefined(this.key)}negate(){return this.c||(this.c=F.create(this.key,this)),this.c}}e.$Ai=w;class E{static create(O,J,le=null){if(typeof J=="boolean")return J?w.create(O,le):F.create(O,le);const ye=k.get(O);return typeof ye=="boolean"?J===(ye?"true":"false")?$.INSTANCE:v.INSTANCE:new E(O,J,le)}constructor(O,J,le){this.c=O,this.d=J,this.f=le,this.type=4}cmp(O){return O.type!==this.type?this.type-O.type:de(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=k.get(this.c);if(typeof O=="boolean"){const J=O?"true":"false";return this.d===J?$.INSTANCE:v.INSTANCE}return this}evaluate(O){return O.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(O){return O.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=m.create(this.c,this.d,this)),this.f}}e.$Bi=E;class o{static create(O,J){return new o(O,J)}constructor(O,J){this.d=O,this.f=J,this.type=10,this.c=null}cmp(O){return O.type!==this.type?this.type-O.type:de(this.d,this.f,O.d,O.f)}equals(O){return O.type===this.type?this.d===O.d&&this.f===O.f:!1}substituteConstants(){return this}evaluate(O){const J=O.getValue(this.f),le=O.getValue(this.d);return Array.isArray(J)?J.includes(le):typeof le=="string"&&typeof J=="object"&&J!==null?P.call(J,le):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(O){return O.mapIn(this.d,this.f)}negate(){return this.c||(this.c=l.create(this.d,this.f)),this.c}}e.$Ci=o;class l{static create(O,J){return new l(O,J)}constructor(O,J){this.d=O,this.f=J,this.type=11,this.c=o.create(O,J)}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(O){return O.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Di=l;class m{static create(O,J,le=null){if(typeof J=="boolean")return J?F.create(O,le):w.create(O,le);const ye=k.get(O);return typeof ye=="boolean"?J===(ye?"true":"false")?v.INSTANCE:$.INSTANCE:new m(O,J,le)}constructor(O,J,le){this.c=O,this.d=J,this.f=le,this.type=5}cmp(O){return O.type!==this.type?this.type-O.type:de(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=k.get(this.c);if(typeof O=="boolean"){const J=O?"true":"false";return this.d===J?v.INSTANCE:$.INSTANCE}return this}evaluate(O){return O.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(O){return O.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=E.create(this.c,this.d,this)),this.f}}e.$Ei=m;class F{static create(O,J=null){const le=k.get(O);return typeof le=="boolean"?le?v.INSTANCE:$.INSTANCE:new F(O,J)}constructor(O,J){this.c=O,this.d=J,this.type=3}cmp(O){return O.type!==this.type?this.type-O.type:X(this.c,O.c)}equals(O){return O.type===this.type?this.c===O.c:!1}substituteConstants(){const O=k.get(this.c);return typeof O=="boolean"?O?v.INSTANCE:$.INSTANCE:this}evaluate(O){return!O.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(O){return O.mapNot(this.c)}negate(){return this.d||(this.d=w.create(this.c,this)),this.d}}e.$Fi=F;function W(ue,O){if(typeof ue=="string"){const J=parseFloat(ue);isNaN(J)||(ue=J)}return typeof ue=="string"||typeof ue=="number"?O(ue):v.INSTANCE}class V{static create(O,J,le=null){return W(J,ye=>new V(O,ye,le))}constructor(O,J,le){this.c=O,this.d=J,this.f=le,this.type=12}cmp(O){return O.type!==this.type?this.type-O.type:de(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$Gi=V;class B{static create(O,J,le=null){return W(J,ye=>new B(O,ye,le))}constructor(O,J,le){this.c=O,this.d=J,this.f=le,this.type=13}cmp(O){return O.type!==this.type?this.type-O.type:de(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Hi=B;class j{static create(O,J,le=null){return W(J,ye=>new j(O,ye,le))}constructor(O,J,le){this.c=O,this.d=J,this.f=le,this.type=14}cmp(O){return O.type!==this.type?this.type-O.type:de(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=B.create(this.c,this.d,this)),this.f}}e.$Ii=j;class U{static create(O,J,le=null){return W(J,ye=>new U(O,ye,le))}constructor(O,J,le){this.c=O,this.d=J,this.f=le,this.type=15}cmp(O){return O.type!==this.type?this.type-O.type:de(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$Ji=U;class z{static create(O,J){return new z(O,J)}constructor(O,J){this.d=O,this.f=J,this.type=7,this.c=null}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.d<O.d)return-1;if(this.d>O.d)return 1;const J=this.f?this.f.source:"",le=O.f?O.f.source:"";return J<le?-1:J>le?1:0}equals(O){if(O.type===this.type){const J=this.f?this.f.source:"",le=O.f?O.f.source:"";return this.d===O.d&&J===le}return!1}substituteConstants(){return this}evaluate(O){const J=O.getValue(this.d);return this.f?this.f.test(J):!1}serialize(){const O=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${O}`}keys(){return[this.d]}map(O){return O.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ne.create(this)),this.c}}e.$Ki=z;class ne{static create(O){return new ne(O)}constructor(O){this.c=O,this.type=8}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(O){return new ne(this.c.map(O))}negate(){return this.c}}e.$Li=ne;function Z(ue){let O=null;for(let J=0,le=ue.length;J<le;J++){const ye=ue[J].substituteConstants();if(ue[J]!==ye&&O===null){O=[];for(let ve=0;ve<J;ve++)O[ve]=ue[ve]}O!==null&&(O[J]=ye)}return O===null?ue:O}class we{static create(O,J,le){return we.d(O,J,le)}constructor(O,J){this.expr=O,this.c=J,this.type=6}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let J=0,le=this.expr.length;J<le;J++){const ye=s(this.expr[J],O.expr[J]);if(ye!==0)return ye}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let J=0,le=this.expr.length;J<le;J++)if(!this.expr[J].equals(O.expr[J]))return!1;return!0}return!1}substituteConstants(){const O=Z(this.expr);return O===this.expr?this:we.create(O,this.c,!1)}evaluate(O){for(let J=0,le=this.expr.length;J<le;J++)if(!this.expr[J].evaluate(O))return!1;return!0}static d(O,J,le){const ye=[];let ve=!1;for(const be of O)if(be){if(be.type===1){ve=!0;continue}if(be.type===0)return v.INSTANCE;if(be.type===6){ye.push(...be.expr);continue}ye.push(be)}if(ye.length===0&&ve)return $.INSTANCE;if(ye.length!==0){if(ye.length===1)return ye[0];ye.sort(s);for(let be=1;be<ye.length;be++)ye[be-1].equals(ye[be])&&(ye.splice(be,1),be--);if(ye.length===1)return ye[0];for(;ye.length>1;){const be=ye[ye.length-1];if(be.type!==9)break;ye.pop();const ke=ye.pop(),oe=ye.length===0,he=Ee.create(be.expr.map(re=>we.create([re,ke],null,le)),null,oe);he&&(ye.push(he),ye.sort(s))}if(ye.length===1)return ye[0];if(le){for(let be=0;be<ye.length;be++)for(let ke=be+1;ke<ye.length;ke++)if(ye[be].negate().equals(ye[ke]))return v.INSTANCE;if(ye.length===1)return ye[0]}return new we(ye,J)}}serialize(){return this.expr.map(O=>O.serialize()).join(" && ")}keys(){const O=[];for(const J of this.expr)O.push(...J.keys());return O}map(O){return new we(this.expr.map(J=>J.map(O)),null)}negate(){if(!this.c){const O=[];for(const J of this.expr)O.push(J.negate());this.c=Ee.create(O,this,!0)}return this.c}}e.$Mi=we;class Ee{static create(O,J,le){return Ee.d(O,J,le)}constructor(O,J){this.expr=O,this.c=J,this.type=9}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let J=0,le=this.expr.length;J<le;J++){const ye=s(this.expr[J],O.expr[J]);if(ye!==0)return ye}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let J=0,le=this.expr.length;J<le;J++)if(!this.expr[J].equals(O.expr[J]))return!1;return!0}return!1}substituteConstants(){const O=Z(this.expr);return O===this.expr?this:Ee.create(O,this.c,!1)}evaluate(O){for(let J=0,le=this.expr.length;J<le;J++)if(this.expr[J].evaluate(O))return!0;return!1}static d(O,J,le){let ye=[],ve=!1;if(O){for(let be=0,ke=O.length;be<ke;be++){const oe=O[be];if(oe){if(oe.type===0){ve=!0;continue}if(oe.type===1)return $.INSTANCE;if(oe.type===9){ye=ye.concat(oe.expr);continue}ye.push(oe)}}if(ye.length===0&&ve)return v.INSTANCE;ye.sort(s)}if(ye.length!==0){if(ye.length===1)return ye[0];for(let be=1;be<ye.length;be++)ye[be-1].equals(ye[be])&&(ye.splice(be,1),be--);if(ye.length===1)return ye[0];if(le){for(let be=0;be<ye.length;be++)for(let ke=be+1;ke<ye.length;ke++)if(ye[be].negate().equals(ye[ke]))return $.INSTANCE;if(ye.length===1)return ye[0]}return new Ee(ye,J)}}serialize(){return this.expr.map(O=>O.serialize()).join(" || ")}keys(){const O=[];for(const J of this.expr)O.push(...J.keys());return O}map(O){return new Ee(this.expr.map(J=>J.map(O)),null)}negate(){if(!this.c){const O=[];for(const J of this.expr)O.push(J.negate());for(;O.length>1;){const J=O.shift(),le=O.shift(),ye=[];for(const ve of _(J))for(const be of _(le))ye.push(we.create([ve,be],null,!1));O.unshift(Ee.create(ye,null,!1))}this.c=Ee.create(O,this,!0)}return this.c}}e.$Ni=Ee;class Re extends w{static{this.d=[]}static all(){return Re.d.values()}constructor(O,J,le){super(O,null),this.f=J,typeof le=="object"?Re.d.push({...le,key:O}):le!==!0&&Re.d.push({key:O,description:le,type:J!=null?typeof J:void 0})}bindTo(O){return O.createKey(this.key,this.f)}getValue(O){return O.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(O){return E.create(this.key,O)}notEqualsTo(O){return m.create(this.key,O)}}e.$Oi=Re,e.$Pi=(0,M.$ph)("contextKeyService");function X(ue,O){return ue<O?-1:ue>O?1:0}function de(ue,O,J,le){return ue<J?-1:ue>J?1:O<le?-1:O>le?1:0}function Ce(ue,O){if(ue.type===0||O.type===1)return!0;if(ue.type===9)return O.type===9?ae(ue.expr,O.expr):!1;if(O.type===9){for(const J of O.expr)if(Ce(ue,J))return!0;return!1}if(ue.type===6){if(O.type===6)return ae(O.expr,ue.expr);for(const J of ue.expr)if(Ce(J,O))return!0;return!1}return ue.equals(O)}e.$Qi=Ce;function ae(ue,O){let J=0,le=0;for(;J<ue.length&&le<O.length;){const ye=ue[J].cmp(O[le]);if(ye<0)return!1;ye===0&&J++,le++}return J===ue.length}function _(ue){return ue.type===9?ue.expr:[ue]}}),define(Pe[172],Ae([1,0,4]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xh=e.$wh=void 0,e.$wh=(0,y.$ph)("environmentService"),e.$xh=(0,y.$qh)(e.$wh)}),define(Pe[92],Ae([1,0,141,4]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Rn=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=void 0,e.$En="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Fn=new RegExp(e.$En),e.$Gn="__web_extension",e.$Hn="skipWalkthrough",e.$In="extensionsSync",e.$Jn="dependecyOrPackExtensionInstall";function I(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Kn=I;function M(c){switch(c){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Ln=M;function A(c,g){switch(c){case 3:return g==="x64"?"win32-x64":g==="ia32"?"win32-ia32":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Mn=A;function d(c,g){return g==="web"&&!c.includes("web")}e.$Nn=d;function k(c,g,S){return d(g,S)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===S?!0:f(S).includes(c)}e.$On=k;function f(c){switch(c){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$Pn=f;function P(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.$Qn=P;var D;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(D||(e.SortBy=D={}));var u;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(u||(e.SortOrder=u={}));var b;(function(c){c.Install="install",c.Uninstall="uninstall"})(b||(e.StatisticType=b={}));var p;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})(p||(e.InstallOperation=p={})),e.$Rn=(0,R.$ph)("extensionGalleryService");var h;(function(c){c.Unsupported="Unsupported",c.Deprecated="Deprecated",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.ReleaseVersionNotFound="ReleaseVersionNotFound",c.Invalid="Invalid",c.Download="Download",c.Extract="Extract",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Signature="Signature",c.Internal="Internal"})(h||(e.ExtensionManagementErrorCode=h={}));var t;(function(c){c.UnknownError="UnknownError",c.PackageIsInvalidZip="PackageIsInvalidZip",c.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(t||(e.ExtensionSignaturetErrorCode=t={}));class i extends Error{constructor(g,S){super(g),this.code=S,this.name=S}}e.$Sn=i,e.$Tn=(0,R.$ph)("extensionManagementService"),e.$Un="extensionsIdentifiers/disabled",e.$Vn="extensionsIdentifiers/enabled",e.$Wn=(0,R.$ph)("IGlobalExtensionEnablementService"),e.$Xn=(0,R.$ph)("IExtensionTipsService"),e.$Yn=(0,y.localize)(0,null),e.$Zn={value:e.$Yn,original:"Extensions"},e.$1n={value:(0,y.localize)(1,null),original:"Preferences"}}),define(Pe[38],Ae([1,0,48,19,15,16,2,143,4,22,12]),function(pe,e,y,R,I,M,A,d,k,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.FileKind=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.FileOperationResult=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.FileChangeType=e.$0j=e.FileOperation=e.$9j=e.$8j=e.$7j=e.$6j=e.$5j=e.$4j=e.FileSystemProviderErrorCode=e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$Tj=e.$Sj=void 0,e.$Sj=(0,k.$ph)("fileService");function D(X){return X.create===!0}e.$Tj=D;var u;(function(X){X[X.Unknown=0]="Unknown",X[X.File=1]="File",X[X.Directory=2]="Directory",X[X.SymbolicLink=64]="SymbolicLink"})(u||(e.FileType=u={}));var b;(function(X){X[X.Readonly=1]="Readonly",X[X.Locked=2]="Locked"})(b||(e.FilePermission=b={}));var p;(function(X){X[X.None=0]="None",X[X.FileReadWrite=2]="FileReadWrite",X[X.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",X[X.FileReadStream=16]="FileReadStream",X[X.FileFolderCopy=8]="FileFolderCopy",X[X.PathCaseSensitive=1024]="PathCaseSensitive",X[X.Readonly=2048]="Readonly",X[X.Trash=4096]="Trash",X[X.FileWriteUnlock=8192]="FileWriteUnlock",X[X.FileAtomicRead=16384]="FileAtomicRead",X[X.FileAtomicWrite=32768]="FileAtomicWrite",X[X.FileAtomicDelete=65536]="FileAtomicDelete",X[X.FileClone=131072]="FileClone"})(p||(e.FileSystemProviderCapabilities=p={}));function h(X){return!!(X.capabilities&2)}e.$Uj=h;function t(X){return!!(X.capabilities&8)}e.$Vj=t;function i(X){return!!(X.capabilities&131072)}e.$Wj=i;function c(X){return!!(X.capabilities&4)}e.$Xj=c;function g(X){return!!(X.capabilities&16)}e.$Yj=g;function S(X){return h(X)?!!(X.capabilities&16384):!1}e.$Zj=S;function C(X){return h(X)?!!(X.capabilities&32768):!1}e.$1j=C;function n(X){return!!(X.capabilities&65536)}e.$2j=n;function a(X){return!!(X.capabilities&2048)}e.$3j=a;var r;(function(X){X.FileExists="EntryExists",X.FileNotFound="EntryNotFound",X.FileNotADirectory="EntryNotADirectory",X.FileIsADirectory="EntryIsADirectory",X.FileExceedsStorageQuota="EntryExceedsStorageQuota",X.FileTooLarge="EntryTooLarge",X.FileWriteLocked="EntryWriteLocked",X.NoPermissions="NoPermissions",X.Unavailable="Unavailable",X.Unknown="Unknown"})(r||(e.FileSystemProviderErrorCode=r={}));class s extends Error{static create(de,Ce){const ae=new s(de.toString(),Ce);return w(ae,Ce),ae}constructor(de,Ce){super(de),this.code=Ce}}e.$4j=s;function v(X,de){return s.create(X,de)}e.$5j=v;function $(X){return X||v((0,d.localize)(0,null),r.Unknown)}e.$6j=$;function w(X,de){return X.name=de?`${de} (FileSystemError)`:"FileSystemError",X}e.$7j=w;function E(X){if(!X)return r.Unknown;if(X instanceof s)return X.code;const de=/^(.+) \(FileSystemError\)$/.exec(X.name);if(!de)return r.Unknown;switch(de[1]){case r.FileExists:return r.FileExists;case r.FileIsADirectory:return r.FileIsADirectory;case r.FileNotADirectory:return r.FileNotADirectory;case r.FileNotFound:return r.FileNotFound;case r.FileTooLarge:return r.FileTooLarge;case r.FileWriteLocked:return r.FileWriteLocked;case r.NoPermissions:return r.NoPermissions;case r.Unavailable:return r.Unavailable}return r.Unknown}e.$8j=E;function o(X){if(X instanceof B)return X.fileOperationResult;switch(E(X)){case r.FileNotFound:return 1;case r.FileIsADirectory:return 0;case r.FileNotADirectory:return 9;case r.FileWriteLocked:return 5;case r.NoPermissions:return 6;case r.FileExists:return 4;case r.FileTooLarge:return 7;default:return 10}}e.$9j=o;var l;(function(X){X[X.CREATE=0]="CREATE",X[X.DELETE=1]="DELETE",X[X.MOVE=2]="MOVE",X[X.COPY=3]="COPY",X[X.WRITE=4]="WRITE"})(l||(e.FileOperation=l={}));class m{constructor(de,Ce,ae){this.resource=de,this.operation=Ce,this.target=ae}isOperation(de){return this.operation===de}}e.$0j=m;var F;(function(X){X[X.UPDATED=0]="UPDATED",X[X.ADDED=1]="ADDED",X[X.DELETED=2]="DELETED"})(F||(e.FileChangeType=F={}));class W{constructor(de,Ce){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ae=new Map;for(const _ of de){const ue=ae.get(_.type);switch(ue?ue.push([_.resource,_]):ae.set(_.type,[[_.resource,_]]),_.type){case 1:this.rawAdded.push(_.resource);break;case 0:this.rawUpdated.push(_.resource);break;case 2:this.rawDeleted.push(_.resource);break}}for(const[_,ue]of ae)switch(_){case 1:this.a=y.$vh.forUris(()=>Ce),this.a.fill(ue);break;case 0:this.b=y.$vh.forUris(()=>Ce),this.b.fill(ue);break;case 2:this.c=y.$vh.forUris(()=>Ce),this.c.fill(ue);break}}contains(de,...Ce){return this.d(de,{includeChildren:!1},...Ce)}affects(de,...Ce){return this.d(de,{includeChildren:!0},...Ce)}d(de,Ce,...ae){if(!de)return!1;const _=ae.length>0;return!!((!_||ae.includes(1))&&(this.a?.get(de)||Ce.includeChildren&&this.a?.findSuperstr(de))||(!_||ae.includes(0))&&(this.b?.get(de)||Ce.includeChildren&&this.b?.findSuperstr(de))||(!_||ae.includes(2))&&(this.c?.findSubstr(de)||Ce.includeChildren&&this.c?.findSuperstr(de)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.$$j=W;function V(X,de,Ce){return!X||!de||X===de||de.length>X.length?!1:(de.charAt(de.length-1)!==R.sep&&(de+=R.sep),Ce?(0,I.$Md)(X,de):X.indexOf(de)===0)}e.$_j=V;class B extends Error{constructor(de,Ce,ae){super(de),this.fileOperationResult=Ce,this.options=ae}}e.$ak=B;class j extends B{constructor(de,Ce,ae,_){super(de,Ce,_),this.fileOperationResult=Ce,this.size=ae}}e.$bk=j;class U extends B{constructor(de,Ce,ae){super(de,2,ae),this.stat=Ce}}e.$ck=U;var z;(function(X){X[X.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",X[X.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",X[X.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",X[X.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",X[X.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",X[X.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",X[X.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",X[X.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",X[X.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",X[X.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",X[X.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(z||(e.FileOperationResult=z={})),e.$dk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$ek={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$fk="files.associations",e.$gk="files.exclude",e.$hk="files.readonlyInclude",e.$ik="files.readonlyExclude",e.$jk="files.readonlyFromPermissions";var ne;(function(X){X[X.FILE=0]="FILE",X[X.FOLDER=1]="FOLDER",X[X.ROOT_FOLDER=2]="ROOT_FOLDER"})(ne||(e.FileKind=ne={})),e.$kk="";function Z(X){if(!(typeof X.size!="number"||typeof X.mtime!="number"))return X.mtime.toString(29)+X.size.toString(31)}e.$lk=Z;async function we(X,de){if(!de.hasProvider(A.URI.from({scheme:X.scheme})))return new Promise(Ce=>{const ae=de.onDidChangeFileSystemProviderRegistrations(_=>{_.scheme===X.scheme&&_.added&&(ae.dispose(),Ce())})})}e.$mk=we;class Ee{static{this.KB=1024}static{this.MB=Ee.KB*Ee.KB}static{this.GB=Ee.MB*Ee.KB}static{this.TB=Ee.GB*Ee.KB}static formatSize(de){return(0,M.$me)(de)||(de=0),de<Ee.KB?(0,d.localize)(1,null,de.toFixed(0)):de<Ee.MB?(0,d.localize)(2,null,(de/Ee.KB).toFixed(2)):de<Ee.GB?(0,d.localize)(3,null,(de/Ee.MB).toFixed(2)):de<Ee.TB?(0,d.localize)(4,null,(de/Ee.GB).toFixed(2)):(0,d.localize)(5,null,(de/Ee.TB).toFixed(2))}}e.$nk=Ee;function Re(X){const de=typeof X=="string"||X?.scheme===P.Schemas.vscodeRemote;return typeof X!="string"&&X?.scheme===P.Schemas.file?1024*Ee.MB:de?10*Ee.MB:f.$o?50*Ee.MB:1024*Ee.MB}e.$ok=Re}),define(Pe[72],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nh=void 0;class y{constructor(...I){this.a=new Map;for(const[M,A]of I)this.set(M,A)}set(I,M){const A=this.a.get(I);return this.a.set(I,M),A}has(I){return this.a.has(I)}get(I){return this.a.get(I)}}e.$nh=y}),define(Pe[173],Ae([1,0,13,9,6,70,171,4,72,174]),function(pe,e,y,R,I,M,A,d,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=e.$Wp=void 0;const P=!1;class D extends Error{constructor(t){super("cyclic dependency between services"),this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class u{constructor(t=new k.$nh,i=!1,c,g=P){this.f=t,this.g=i,this.h=c,this.i=g,this.o=new Set,this.f.set(d.$oh,this),this._globalGraph=g?c?._globalGraph??new A.$Vp(S=>S):void 0}createChild(t){return new u(t,this.g,this,this.i)}invokeFunction(t,...i){const c=p.traceInvocation(this.i,t);let g=!1;try{return t({get:C=>{if(g)throw(0,R.$6)("service accessor is only valid during the invocation of its target method");const n=this.m(C,c);if(!n)throw new Error(`[invokeFunction] unknown service '${C}'`);return n}},...i)}finally{g=!0,c.stop()}}createInstance(t,...i){let c,g;return t instanceof M.$mh?(c=p.traceCreation(this.i,t.ctor),g=this.j(t.ctor,t.staticArguments.concat(i),c)):(c=p.traceCreation(this.i,t),g=this.j(t,i,c)),c.stop(),g}j(t,i=[],c){const g=d._util.getServiceDependencies(t).sort((n,a)=>n.index-a.index),S=[];for(const n of g){const a=this.m(n.id,c);a||this.u(`[createInstance] ${t.name} depends on UNKNOWN service ${n.id}.`,!1),S.push(a)}const C=g.length>0?g[0].index:i.length;if(i.length!==C){console.trace(`[createInstance] First service dependency of ${t.name} at position ${C+1} conflicts with ${i.length} static arguments`);const n=C-i.length;n>0?i=i.concat(new Array(n)):i=i.slice(0,C)}return Reflect.construct(t,i.concat(S))}k(t,i){if(this.f.get(t)instanceof M.$mh)this.f.set(t,i);else if(this.h)this.h.k(t,i);else throw new Error("illegalState - setting UNKNOWN service instance")}l(t){const i=this.f.get(t);return!i&&this.h?this.h.l(t):i}m(t,i){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(t));const c=this.l(t);return c instanceof M.$mh?this.q(t,c,i.branch(t,!0)):(i.branch(t,!1),c)}q(t,i,c){if(this.o.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this.o.add(t);try{return this.r(t,i,c)}finally{this.o.delete(t)}}r(t,i,c){const g=new A.$Vp(n=>n.id.toString());let S=0;const C=[{id:t,desc:i,_trace:c}];for(;C.length;){const n=C.pop();if(g.lookupOrInsertNode(n),S++>1e3)throw new D(g);for(const a of d._util.getServiceDependencies(n.desc.ctor)){const r=this.l(a.id);if(r||this.u(`[createInstance] ${t} depends on ${a.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(a.id)),r instanceof M.$mh){const s={id:a.id,desc:r,_trace:n._trace.branch(a.id,!0)};g.insertEdge(n,s),C.push(s)}}}for(;;){const n=g.roots();if(n.length===0){if(!g.isEmpty())throw new D(g);break}for(const{data:a}of n){if(this.l(a.id)instanceof M.$mh){const s=this.s(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this.k(a.id,s)}g.removeNode(a)}}return this.l(t)}s(t,i,c=[],g,S){if(this.f.get(t)instanceof M.$mh)return this.t(t,i,c,g,S);if(this.h)return this.h.s(t,i,c,g,S);throw new Error(`illegalState - creating UNKNOWN service instance ${i.name}`)}t(t,i,c=[],g,S){if(g){const C=new u(void 0,this.g,this,this.i);C.c=String(t);const n=new Map,a=new y.$Lg(()=>{const r=C.j(i,c,S);for(const[s,v]of n){const $=r[s];if(typeof $=="function")for(const w of v)$.apply(r,w)}return n.clear(),r});return new Proxy(Object.create(null),{get(r,s){if(!a.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let w=n.get(s);return w||(w=new f.$ub,n.set(s,w)),(o,l,m)=>{const F=w.push([o,l,m]);return(0,I.$jb)(F)}}if(s in r)return r[s];const v=a.value;let $=v[s];return typeof $!="function"||($=$.bind(v),r[s]=$),$},set(r,s,v){return a.value[s]=v,!0},getPrototypeOf(r){return i.prototype}})}else return this.j(i,c,S)}u(t,i){if(i&&console.warn(t),this.g)throw new Error(t)}}e.$Wp=u;var b;(function(h){h[h.None=0]="None",h[h.Creation=1]="Creation",h[h.Invocation=2]="Invocation",h[h.Branch=3]="Branch"})(b||(b={}));class p{static{this.all=new Set}static{this.c=new class extends p{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(t,i){return t?new p(2,i.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p.c}static traceCreation(t,i){return t?new p(1,i.name):p.c}static{this.f=0}constructor(t,i){this.type=t,this.name=i,this.g=Date.now(),this.h=[]}branch(t,i){const c=new p(3,t.toString());return this.h.push([t,i,c]),c}stop(){const t=Date.now()-this.g;p.f+=t;let i=!1;function c(S,C){const n=[],a=new Array(S+1).join("	");for(const[r,s,v]of C.h)if(s&&v){i=!0,n.push(`${a}CREATES -> ${r}`);const $=c(S+1,v);$&&n.push($)}else n.push(`${a}uses -> ${r}`);return n.join(`
`)}const g=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${c(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${p.f.toFixed(2)}ms)`];(t>2||i)&&p.all.add(g.join(`
`))}}e.$Xp=p}),define(Pe[14],Ae([1,0,41,5,93,6,28,22,23,16,2,32,4]),function(pe,e,y,R,I,M,A,d,k,f,P,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.log=e.$Ui=e.LogLevel=e.$Ti=e.$Si=e.$Ri=void 0,e.$Ri=(0,u.$ph)("logService"),e.$Si=(0,u.$ph)("loggerService");function b(){return new Date().toISOString()}function p(o){return(0,f.$me)(o)}e.$Ti=p;var h;(function(o){o[o.Off=0]="Off",o[o.Trace=1]="Trace",o[o.Debug=2]="Debug",o[o.Info=3]="Info",o[o.Warning=4]="Warning",o[o.Error=5]="Error"})(h||(e.LogLevel=h={})),e.$Ui=h.Info;function t(o,l,m){switch(l){case h.Trace:o.trace(m);break;case h.Debug:o.debug(m);break;case h.Info:o.info(m);break;case h.Warning:o.warn(m);break;case h.Error:o.error(m);break;case h.Off:break;default:throw new Error(`Invalid log level ${l}`)}}e.log=t;function i(o,l=!1){let m="";for(let F=0;F<o.length;F++){let W=o[F];if(W instanceof Error&&(W=(0,y.$ai)(W,l)),typeof W=="object")try{W=JSON.stringify(W)}catch{}m+=(F>0?" ":"")+W}return m}class c extends M.$lb{constructor(){super(...arguments),this.b=e.$Ui,this.c=this.B(new R.$ec),this.onDidChangeLogLevel=this.c.event}setLevel(l){this.b!==l&&(this.b=l,this.c.fire(this.b))}getLevel(){return this.b}f(l){return this.b!==h.Off&&this.b<=l}}e.$Wi=c;class g extends c{constructor(l){super(),this.h=l}f(l){return this.h||super.f(l)}trace(l,...m){this.f(h.Trace)&&this.g(h.Trace,i([l,...m],!0))}debug(l,...m){this.f(h.Debug)&&this.g(h.Debug,i([l,...m]))}info(l,...m){this.f(h.Info)&&this.g(h.Info,i([l,...m]))}warn(l,...m){this.f(h.Warning)&&this.g(h.Warning,i([l,...m]))}error(l,...m){if(this.f(h.Error))if(l instanceof Error){const F=Array.prototype.slice.call(arguments);F[0]=l.stack,this.g(h.Error,i(F))}else this.g(h.Error,i([l,...m]))}flush(){}}e.$Xi=g;class S extends c{constructor(l=e.$Ui){super(),this.setLevel(l),this.g=!d.$i}trace(l,...m){this.f(h.Trace)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,l,...m):console.log(`[main ${b()}]`,l,...m))}debug(l,...m){this.f(h.Debug)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,l,...m):console.log(`[main ${b()}]`,l,...m))}info(l,...m){this.f(h.Info)&&(this.g?console.log(`\x1B[90m[main ${b()}]\x1B[0m`,l,...m):console.log(`[main ${b()}]`,l,...m))}warn(l,...m){this.f(h.Warning)&&(this.g?console.warn(`\x1B[93m[main ${b()}]\x1B[0m`,l,...m):console.warn(`[main ${b()}]`,l,...m))}error(l,...m){this.f(h.Error)&&(this.g?console.error(`\x1B[91m[main ${b()}]\x1B[0m`,l,...m):console.error(`[main ${b()}]`,l,...m))}dispose(){}flush(){}}e.$Yi=S;class C extends c{constructor(l=e.$Ui,m=!0){super(),this.g=m,this.setLevel(l)}trace(l,...m){this.f(h.Trace)&&(this.g?console.log("%cTRACE","color: #888",l,...m):console.log(l,...m))}debug(l,...m){this.f(h.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",l,...m):console.log(l,...m))}info(l,...m){this.f(h.Info)&&(this.g?console.log("%c INFO","color: #33f",l,...m):console.log(l,...m))}warn(l,...m){this.f(h.Warning)&&(this.g?console.log("%c WARN","color: #993",l,...m):console.log(l,...m))}error(l,...m){this.f(h.Error)&&(this.g?console.log("%c  ERR","color: #f33",l,...m):console.error(l,...m))}dispose(){}flush(){}}e.$Zi=C;class n extends c{constructor(l,m=e.$Ui){super(),this.g=l,this.setLevel(m)}trace(l,...m){this.f(h.Trace)&&this.g.log(h.Trace,[this.h(l),...m])}debug(l,...m){this.f(h.Debug)&&this.g.log(h.Debug,[this.h(l),...m])}info(l,...m){this.f(h.Info)&&this.g.log(h.Info,[this.h(l),...m])}warn(l,...m){this.f(h.Warning)&&this.g.log(h.Warning,[this.h(l),...m])}error(l,...m){this.f(h.Error)&&this.g.log(h.Error,[this.h(l),...m])}h(l){return typeof l=="string"?l:(0,y.$ai)(l,this.f(h.Trace))}dispose(){}flush(){}}e.$1i=n;class a extends c{constructor(l){super(),this.g=l,l.length&&this.setLevel(l[0].getLevel())}setLevel(l){for(const m of this.g)m.setLevel(l);super.setLevel(l)}trace(l,...m){for(const F of this.g)F.trace(l,...m)}debug(l,...m){for(const F of this.g)F.debug(l,...m)}info(l,...m){for(const F of this.g)F.info(l,...m)}warn(l,...m){for(const F of this.g)F.warn(l,...m)}error(l,...m){for(const F of this.g)F.error(l,...m)}flush(){for(const l of this.g)l.flush()}dispose(){for(const l of this.g)l.dispose()}}e.$2i=a;class r extends M.$lb{constructor(l,m,F){if(super(),this.h=l,this.j=m,this.b=new A.$ni,this.c=this.B(new R.$ec),this.onDidChangeLoggers=this.c.event,this.f=this.B(new R.$ec),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new R.$ec),this.onDidChangeVisibility=this.g.event,F)for(const W of F)this.b.set(W.resource,{logger:void 0,info:W})}k(l){return(0,f.$ie)(l)?[...this.b.values()].find(m=>m.info.id===l):this.b.get(l)}getLogger(l){return this.k(l)?.logger}createLogger(l,m){const F=this.l(l),W=(0,f.$ie)(l)?l:m?.id??(0,I.$di)(F.toString()).toString(16);let V=this.b.get(F)?.logger;const B=m?.logLevel==="always"?h.Trace:m?.logLevel;V||(V=this.m(F,B??this.getLogLevel(F)??this.h,{...m,id:W}));const j={logger:V,info:{resource:F,id:W,logLevel:B,name:m?.name,hidden:m?.hidden,extensionId:m?.extensionId,when:m?.when}};return this.registerLogger(j.info),this.b.set(F,j),V}l(l){return(0,f.$ie)(l)?(0,k.$9f)(this.j,`${l}.log`):l}setLogLevel(l,m){if(P.URI.isUri(l)){const F=l,W=m,V=this.b.get(F);V&&W!==V.info.logLevel&&(V.info.logLevel=W===this.h?void 0:W,V.logger?.setLevel(W),this.b.set(V.info.resource,V),this.f.fire([F,W]))}else{this.h=l;for(const[F,W]of this.b.entries())this.b.get(F)?.info.logLevel===void 0&&W.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(l,m){const F=this.k(l);F&&m!==!F.info.hidden&&(F.info.hidden=!m,this.b.set(F.info.resource,F),this.g.fire([F.info.resource,m]))}getLogLevel(l){let m;return l&&(m=this.b.get(l)?.info.logLevel),m??this.h}registerLogger(l){const m=this.b.get(l.resource);m?m.info.hidden!==l.hidden&&this.setVisibility(l.resource,!l.hidden):(this.b.set(l.resource,{info:l,logger:void 0}),this.c.fire({added:[l],removed:[]}))}deregisterLogger(l){const m=this.b.get(l);m&&(m.logger&&m.logger.dispose(),this.b.delete(l),this.c.fire({added:[],removed:[m.info]}))}*getRegisteredLoggers(){for(const l of this.b.values())yield l.info}getRegisteredLogger(l){return this.b.get(l)?.info}dispose(){this.b.forEach(l=>l.logger?.dispose()),this.b.clear(),super.dispose()}}e.$3i=r;class s{constructor(){this.onDidChangeLogLevel=new R.$ec().event}setLevel(l){}getLevel(){return h.Info}trace(l,...m){}debug(l,...m){}info(l,...m){}warn(l,...m){}error(l,...m){}critical(l,...m){}dispose(){}flush(){}}e.$4i=s;class v extends s{}e.$5i=v;function $(o){if(o.verbose)return h.Trace;if(typeof o.logLevel=="string"){const l=E(o.logLevel.toLowerCase());if(l!==void 0)return l}return e.$Ui}e.$6i=$;function w(o){switch(o){case h.Trace:return"trace";case h.Debug:return"debug";case h.Info:return"info";case h.Warning:return"warn";case h.Error:return"error";case h.Off:return"off"}}e.$7i=w;function E(o){switch(o){case"trace":return h.Trace;case"debug":return h.Debug;case"info":return h.Info;case"warn":return h.Warning;case"error":return h.Error;case"critical":return h.Error;case"off":return h.Off}}e.$8i=E,e.$9i=new D.$Oi("logLevel",w(h.Info))}),define(Pe[175],Ae([1,0,6,14]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9M=void 0;class I extends y.$lb{constructor(A,d=[]){super(),this.a=new R.$2i([A,...d]),this.B(A.onDidChangeLogLevel(k=>this.setLevel(k)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...d){this.a.trace(A,...d)}debug(A,...d){this.a.debug(A,...d)}info(A,...d){this.a.info(A,...d)}warn(A,...d){this.a.warn(A,...d)}error(A,...d){this.a.error(A,...d)}flush(){this.a.flush()}}e.$9M=I}),define(Pe[94],Ae([1,0,29,144,4]),function(pe,e,y,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rs=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var M;(function(k){k[k.Unnecessary=1]="Unnecessary",k[k.Deprecated=2]="Deprecated"})(M||(e.MarkerTag=M={}));var A;(function(k){k[k.Hint=1]="Hint",k[k.Info=2]="Info",k[k.Warning=4]="Warning",k[k.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(k){function f(p,h){return h-p}k.compare=f;const P=Object.create(null);P[k.Error]=(0,R.localize)(0,null),P[k.Warning]=(0,R.localize)(1,null),P[k.Info]=(0,R.localize)(2,null);function D(p){return P[p]||""}k.toString=D;function u(p){switch(p){case y.default.Error:return k.Error;case y.default.Warning:return k.Warning;case y.default.Info:return k.Info;case y.default.Ignore:return k.Hint}}k.fromSeverity=u;function b(p){switch(p){case k.Error:return y.default.Error;case k.Warning:return y.default.Warning;case k.Info:return y.default.Info;case k.Hint:return y.default.Ignore}}k.toSeverity=b}(A||(e.MarkerSeverity=A={}));var d;(function(k){const f="";function P(u){return D(u,!0)}k.makeKey=P;function D(u,b){const p=[f];return u.source?p.push(u.source.replace("\xA6","\\\xA6")):p.push(f),u.code?typeof u.code=="string"?p.push(u.code.replace("\xA6","\\\xA6")):p.push(u.code.value.replace("\xA6","\\\xA6")):p.push(f),u.severity!==void 0&&u.severity!==null?p.push(A.toString(u.severity)):p.push(f),u.message&&b?p.push(u.message.replace("\xA6","\\\xA6")):p.push(f),u.startLineNumber!==void 0&&u.startLineNumber!==null?p.push(u.startLineNumber.toString()):p.push(f),u.startColumn!==void 0&&u.startColumn!==null?p.push(u.startColumn.toString()):p.push(f),u.endLineNumber!==void 0&&u.endLineNumber!==null?p.push(u.endLineNumber.toString()):p.push(f),u.endColumn!==void 0&&u.endColumn!==null?p.push(u.endColumn.toString()):p.push(f),p.push(f),p.join("\xA6")}k.makeKeyOptionalMessage=D})(d||(e.IMarkerData=d={})),e.$rs=(0,I.$ph)("markerService")}),define(Pe[176],Ae([1,0,5,29,4]),function(pe,e,y,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qu=e.$Pu=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Ou=e.Severity=void 0,e.Severity=R.default,e.$Ou=(0,I.$ph)("notificationService");var M;(function(P){P[P.DEFAULT=0]="DEFAULT",P[P.SILENT=1]="SILENT",P[P.URGENT=2]="URGENT"})(M||(e.NotificationPriority=M={}));var A;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.PROFILE=1]="PROFILE",P[P.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));var d;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(d||(e.NotificationsFilter=d={}));class k{constructor(){this.progress=new f,this.onDidClose=y.Event.None,this.onDidChangeVisibility=y.Event.None}updateSeverity(D){}updateMessage(D){}updateActions(D){}close(){}}e.$Pu=k;class f{infinite(){}done(){}total(D){}worked(D){}}e.$Qu=f}),define(Pe[95],Ae([1,0,15,2,4]),function(pe,e,y,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uT=e.$tT=e.$sT=e.$rT=e.$qT=void 0,e.$qT=(0,I.$ph)("openerService");function M(f,P){return R.URI.isUri(f)?(0,y.$Ld)(f.scheme,P):(0,y.$Md)(f,P+":")}e.$rT=M;function A(f,...P){return P.some(D=>M(f,D))}e.$sT=A;function d(f,P){return f.with({fragment:`${P.startLineNumber},${P.startColumn}${P.endLineNumber?`-${P.endLineNumber}${P.endColumn?`,${P.endColumn}`:""}`:""}`})}e.$tT=d;function k(f){let P;const D=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(f.fragment);return D&&(P={startLineNumber:parseInt(D[1]),startColumn:D[2]?parseInt(D[2]):1,endLineNumber:D[4]?parseInt(D[4]):void 0,endColumn:D[4]?D[5]?parseInt(D[5]):1:void 0},f=f.with({fragment:""})),{selection:P,uri:f}}e.$uT=k}),define(Pe[177],Ae([1,0,4]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$i=e.$0i=void 0,e.$0i=(0,y.$ph)("productService"),e.$$i="vscode://schemas/vscode-product"});var Ke=this&&this.__decorate||function(pe,e,y,R){var I=arguments.length,M=I<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,y):R,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(pe,e,y,R);else for(var d=pe.length-1;d>=0;d--)(A=pe[d])&&(M=(I<3?A(M):I>3?A(e,y,M):A(e,y))||M);return I>3&&M&&Object.defineProperty(e,y,M),M},We=this&&this.__param||function(pe,e){return function(y,R){e(y,R,pe)}};define(Pe[73],Ae([1,0,13,21,6,4]),function(pe,e,y,R,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wu=e.$Vu=e.$Uu=e.$Tu=e.$Su=e.ProgressLocation=e.$Ru=void 0,e.$Ru=(0,M.$ph)("progressService");var A;(function(P){P[P.Explorer=1]="Explorer",P[P.Scm=3]="Scm",P[P.Extensions=5]="Extensions",P[P.Window=10]="Window",P[P.Notification=15]="Notification",P[P.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$Su=Object.freeze({total(){},worked(){},done(){}});class d{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(D,u){this.c=D,this.report=u?.async?this.e.bind(this):this.d.bind(this)}d(D){this.a=D,this.c(this.a)}e(D){Promise.resolve(this.b).finally(()=>{this.a=D;const u=this.c(this.a);this.b=Promise.resolve(u).finally(()=>this.b=void 0)})}}e.$Tu=d;let k=class extends I.$lb{constructor(D,u){super(),this.a=new y.$Pg,u.withProgress(D,b=>(this.b=b,this.c&&b.report(this.c),this.a.p)),this.B((0,I.$jb)(()=>this.a.complete()))}report(D){this.b?this.b.report(D):this.c=D}};e.$Uu=k,e.$Uu=k=Ke([We(1,e.$Ru)],k);class f extends I.$lb{constructor(D){super(),this.g=D,this.a=0,this.b=this.B(new I.$kb)}start(D){this.stop();const u=++this.a,b=new R.$oc;return this.f=setTimeout(()=>{u===this.a&&(this.c=this.g.show(!0))},D),this.b.add((0,I.$jb)(()=>clearTimeout(this.f))),this.b.add((0,I.$jb)(()=>b.cancel())),this.b.add((0,I.$jb)(()=>this.c?this.c.done():void 0)),{id:u,token:b.token,stop:()=>this.h(u),isCurrent:()=>this.a===u}}stop(){this.h(this.a)}h(D){this.a===D&&this.b.clear()}}e.$Vu=f,e.$Wu=(0,M.$ph)("editorProgressService")}),define(Pe[30],Ae([1,0,50,16]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=void 0;class I{constructor(){this.a=new Map}add(A,d){y.ok(R.$ie(A)),y.ok(R.$ke(d)),y.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,d)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$Um=new I}),define(Pe[74],Ae([1,0,5,30]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vm=void 0,e.$Vm={JSONContribution:"base.contributions.json"};function I(d){return d.length>0&&d.charAt(d.length-1)==="#"?d.substring(0,d.length-1):d}class M{constructor(){this.b=new y.$ec,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(k,f){this.a[I(k)]=f,this.b.fire(k)}notifySchemaChanged(k){this.b.fire(k)}getSchemaContributions(){return{schemas:this.a}}}const A=new M;R.$Um.add(e.$Vm.JSONContribution,A)}),define(Pe[96],Ae([1,0,18,5,16,138,43,74,30]),function(pe,e,y,R,I,M,A,d,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.ConfigurationScope=e.$Zm=e.EditPresentationTypes=void 0;var f;(function(C){C.Multiline="multilineText",C.Singleline="singlelineText"})(f||(e.EditPresentationTypes=f={})),e.$Zm={Configuration:"base.contributions.configuration"};var P;(function(C){C[C.APPLICATION=1]="APPLICATION",C[C.MACHINE=2]="MACHINE",C[C.WINDOW=3]="WINDOW",C[C.RESOURCE=4]="RESOURCE",C[C.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",C[C.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P||(e.ConfigurationScope=P={})),e.$1m={properties:{},patternProperties:{}},e.$2m={properties:{},patternProperties:{}},e.$3m={properties:{},patternProperties:{}},e.$4m={properties:{},patternProperties:{}},e.$5m={properties:{},patternProperties:{}},e.$6m={properties:{},patternProperties:{}},e.$7m="vscode://schemas/settings/resourceLanguage",e.$8m="vscode://schemas/settings/configurationDefaults";const D=k.$Um.as(d.$Vm.JSONContribution);class u{constructor(){this.h=new Set,this.i=new R.$ec,this.onDidSchemaChange=this.i.event,this.j=new R.$ec,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},D.registerSchema(e.$7m,this.g),this.v()}registerConfiguration(n,a=!0){this.registerConfigurations([n],a)}registerConfigurations(n,a=!0){const r=new Set;this.n(n,a,r),D.registerSchema(e.$7m,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(n){const a=new Set;this.o(n,a),D.registerSchema(e.$7m,this.g),this.i.fire(),this.j.fire({properties:a})}updateConfigurations({add:n,remove:a}){const r=new Set;this.o(a,r),this.n(n,!1,r),D.registerSchema(e.$7m,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(n){const a=new Set;this.k(n,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}k(n,a){const r=[];for(const{overrides:s,source:v}of n)for(const $ in s)if(a.add($),e.$0m.test($)){const w=this.a.get($),E=w?.valuesSources??new Map;if(v)for(const F of Object.keys(s[$]))E.set(F,v);const o={...w?.value||{},...s[$]};this.a.set($,{source:v,value:o,valuesSources:E});const l=(0,A.$6h)($),m={type:"object",default:o,description:M.localize(1,null,l),$ref:e.$7m,defaultDefaultValue:o,source:I.$ie(v)?void 0:v,defaultValueSource:v};r.push(...h($)),this.d[$]=m,this.b.properties[$]=m}else{this.a.set($,{value:s[$],source:v});const w=this.d[$];w&&(this.w($,w),this.r($,w))}this.m(r)}deregisterDefaultConfigurations(n){const a=new Set;this.l(n,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}l(n,a){for(const{overrides:r,source:s}of n)for(const v in r){const $=this.a.get(v),w=I.$ie(s)?s:s?.id,E=I.$ie($?.source)?$?.source:$?.source?.id;if(w===E)if(a.add(v),this.a.delete(v),e.$0m.test(v))delete this.d[v],delete this.b.properties[v];else{const o=this.d[v];o&&(this.w(v,o),this.r(v,o))}}this.u()}deltaConfiguration(n){let a=!1;const r=new Set;n.removedDefaults&&(this.l(n.removedDefaults,r),a=!0),n.addedDefaults&&(this.k(n.addedDefaults,r),a=!0),n.removedConfigurations&&this.o(n.removedConfigurations,r),n.addedConfigurations&&this.n(n.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:a})}notifyConfigurationSchemaUpdated(...n){this.i.fire()}registerOverrideIdentifiers(n){this.m(n),this.i.fire()}m(n){for(const a of n)this.h.add(a);this.u()}n(n,a,r){n.forEach(s=>{this.p(s,a,s.extensionInfo,s.restrictedProperties,void 0,r),this.c.push(s),this.q(s)})}o(n,a){const r=s=>{if(s.properties)for(const v in s.properties){a.add(v);const $=this.d[v];$?.policy?.name&&this.e.delete($.policy.name),delete this.d[v],this.s(v,s.properties[v])}s.allOf?.forEach(v=>r(v))};for(const s of n){r(s);const v=this.c.indexOf(s);v!==-1&&this.c.splice(v,1)}}p(n,a=!0,r,s,v=3,$){v=I.$re(n.scope)?v:n.scope;const w=n.properties;if(w)for(const o in w){const l=w[o];if(a&&g(o,l)){delete w[o];continue}if(l.source=r,l.defaultDefaultValue=w[o].default,this.w(o,l),e.$0m.test(o)?l.scope=void 0:(l.scope=I.$re(l.scope)?v:l.scope,l.restricted=I.$re(l.restricted)?!!s?.includes(o):l.restricted),w[o].hasOwnProperty("included")&&!w[o].included){this.f[o]=w[o],delete w[o];continue}else this.d[o]=w[o],w[o].policy?.name&&this.e.set(w[o].policy.name,o);!w[o].deprecationMessage&&w[o].markdownDeprecationMessage&&(w[o].deprecationMessage=w[o].markdownDeprecationMessage),$.add(o)}const E=n.allOf;if(E)for(const o of E)this.p(o,a,r,s,v,$)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(n){const a=r=>{const s=r.properties;if(s)for(const $ in s)this.r($,s[$]);r.allOf?.forEach(a)};a(n)}r(n,a){switch(e.$1m.properties[n]=a,a.scope){case 1:e.$2m.properties[n]=a;break;case 2:e.$3m.properties[n]=a;break;case 6:e.$4m.properties[n]=a;break;case 3:e.$5m.properties[n]=a;break;case 4:e.$6m.properties[n]=a;break;case 5:e.$6m.properties[n]=a,this.g.properties[n]=a;break}}s(n,a){switch(delete e.$1m.properties[n],a.scope){case 1:delete e.$2m.properties[n];break;case 2:delete e.$3m.properties[n];break;case 6:delete e.$4m.properties[n];break;case 3:delete e.$5m.properties[n];break;case 4:case 5:delete e.$6m.properties[n],delete this.g.properties[n];break}}u(){for(const n of this.h.values()){const a=`[${n}]`,r={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.$7m};this.w(a,r),e.$1m.properties[a]=r,e.$2m.properties[a]=r,e.$3m.properties[a]=r,e.$4m.properties[a]=r,e.$5m.properties[a]=r,e.$6m.properties[a]=r}}v(){const n={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.$7m};e.$1m.patternProperties[e.$9m]=n,e.$2m.patternProperties[e.$9m]=n,e.$3m.patternProperties[e.$9m]=n,e.$4m.patternProperties[e.$9m]=n,e.$5m.patternProperties[e.$9m]=n,e.$6m.patternProperties[e.$9m]=n,this.i.fire()}w(n,a){const r=this.a.get(n);let s=r?.value,v=r?.source;I.$pe(s)&&(s=a.defaultDefaultValue,v=void 0),I.$pe(s)&&(s=i(a.type)),a.default=s,a.defaultValueSource=v}}const b="\\[([^\\]]+)\\]",p=new RegExp(b,"g");e.$9m=`^(${b})+$`,e.$0m=new RegExp(e.$9m);function h(C){const n=[];if(e.$0m.test(C)){let a=p.exec(C);for(;a?.length;){const r=a[1].trim();r&&n.push(r),a=p.exec(C)}}return(0,y.$of)(n)}e.$$m=h;function t(C){return C.reduce((n,a)=>`${n}[${a}]`,"")}e.$_m=t;function i(C){switch(Array.isArray(C)?C[0]:C){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$an=i;const c=new u;k.$Um.add(e.$Zm.Configuration,c);function g(C,n){return C.trim()?e.$0m.test(C)?M.localize(7,null,C):c.getConfigurationProperties()[C]!==void 0?M.localize(8,null,C):n.policy?.name&&c.getPolicyConfigurations().get(n.policy?.name)!==void 0?M.localize(9,null,C,n.policy?.name,c.getPolicyConfigurations().get(n.policy?.name)):null:M.localize(6,null)}e.$bn=g;function S(){const C=[],n=c.getConfigurationProperties();for(const a of Object.keys(n))C.push([a,n[a].scope]);return C.push(["launch",4]),C.push(["task",4]),C}e.$cn=S}),define(Pe[178],Ae([1,0,18,5,116,6,28,24,16,2,43,96,30]),function(pe,e,y,R,I,M,A,d,k,f,P,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=void 0;function b(a){return Object.isFrozen(a)?a:d.$Jm(a)}class p{constructor(r={},s=[],v=[],$){this.b=r,this.c=s,this.d=v,this.raw=$,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const r=this.raw.map(s=>{if(s instanceof p)return s;const v=new h("");return v.parseRaw(s),v.configurationModel});this.f=r.reduce((s,v)=>v===s?v:s.merge(v),r[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,P.$4h)(this.contents,r):this.contents}inspect(r,s){const v=this.rawConfiguration.getValue(r),$=s?this.rawConfiguration.getOverrideValue(r,s):void 0,w=s?this.rawConfiguration.override(s).getValue(r):v;return{value:v,override:$,merged:w}}getOverrideValue(r,s){const v=this.i(s);return v?r?(0,P.$4h)(v,r):v:void 0}getKeysForOverrideIdentifier(r){const s=[];for(const v of this.overrides)v.identifiers.includes(r)&&s.push(...v.keys);return y.$of(s)}getAllOverrideIdentifiers(){const r=[];for(const s of this.overrides)r.push(...s.identifiers);return y.$of(r)}override(r){let s=this.a.get(r);return s||(s=this.g(r),this.a.set(r,s)),s}merge(...r){const s=d.$Im(this.contents),v=d.$Im(this.overrides),$=[...this.keys],w=this.raw?.length?[...this.raw]:[this];for(const E of r)if(w.push(...E.raw?.length?E.raw:[E]),!E.isEmpty()){this.h(s,E.contents);for(const o of E.overrides){const[l]=v.filter(m=>y.$$e(m.identifiers,o.identifiers));l?(this.h(l.contents,o.contents),l.keys.push(...o.keys),l.keys=y.$of(l.keys)):v.push(d.$Im(o))}for(const o of E.keys)$.indexOf(o)===-1&&$.push(o)}return new p(s,$,v,w.every(E=>E instanceof p)?void 0:w)}g(r){const s=this.i(r);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const v={};for(const $ of y.$of([...Object.keys(this.contents),...Object.keys(s)])){let w=this.contents[$];const E=s[$];E&&(typeof w=="object"&&typeof E=="object"?(w=d.$Im(w),this.h(w,E)):w=E),v[$]=w}return new p(v,this.keys,this.overrides)}h(r,s){for(const v of Object.keys(s)){if(v in r&&k.$ke(r[v])&&k.$ke(s[v])){this.h(r[v],s[v]);continue}r[v]=d.$Im(s[v])}}i(r){let s=null,v=null;const $=w=>{w&&(v?this.h(v,w):v=d.$Im(w))};for(const w of this.overrides)w.identifiers.length===1&&w.identifiers[0]===r?s=w.contents:w.identifiers.includes(r)&&$(w.contents);return $(s),v}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,s){this.j(r,s,!0)}setValue(r,s){this.j(r,s,!1)}removeValue(r){const s=this.keys.indexOf(r);s!==-1&&(this.keys.splice(s,1),(0,P.$3h)(this.contents,r),D.$0m.test(r)&&this.overrides.splice(this.overrides.findIndex(v=>y.$$e(v.identifiers,(0,D.$$m)(r))),1))}j(r,s,v){(0,P.$2h)(this.contents,r,s,$=>console.error($)),v=v||this.keys.indexOf(r)===-1,v&&this.keys.push(r),D.$0m.test(r)&&this.overrides.push({identifiers:(0,D.$$m)(r),keys:Object.keys(this.contents[r]),contents:(0,P.$1h)(this.contents[r],$=>console.error($))})}}e.$dn=p;class h{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new p}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,s){if(!k.$re(r)){const v=this.g(r);this.parseRaw(v,s)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,s){this.a=r;const{contents:v,keys:$,overrides:w,restricted:E,hasExcludedProperties:o}=this.h(r,s);this.b=new p(v,$,w,o?[r]:void 0),this.c=E||[]}g(r){let s={},v=null,$=[];const w=[],E=[];function o(m){Array.isArray($)?$.push(m):v!==null&&($[v]=m)}const l={onObjectBegin:()=>{const m={};o(m),w.push($),$=m,v=null},onObjectProperty:m=>{v=m},onObjectEnd:()=>{$=w.pop()},onArrayBegin:()=>{const m=[];o(m),w.push($),$=m,v=null},onArrayEnd:()=>{$=w.pop()},onLiteralValue:o,onError:(m,F,W)=>{E.push({error:m,offset:F,length:W})}};if(r)try{I.$Fm(r,l),s=$[0]||{}}catch(m){console.error(`Error while parsing settings file ${this.f}: ${m}`),this.d=[m]}return s}h(r,s){const v=u.$Um.as(D.$Zm.Configuration).getConfigurationProperties(),$=this.i(r,v,!0,s);r=$.raw;const w=(0,P.$1h)(r,l=>console.error(`Conflict in settings file ${this.f}: ${l}`)),E=Object.keys(r),o=this.j(r,l=>console.error(`Conflict in settings file ${this.f}: ${l}`));return{contents:w,keys:E,overrides:o,restricted:$.restricted,hasExcludedProperties:$.hasExcludedProperties}}i(r,s,v,$){let w=!1;if(!$?.scopes&&!$?.skipRestricted&&!$?.exclude?.length)return{raw:r,restricted:[],hasExcludedProperties:w};const E={},o=[];for(const l in r)if(D.$0m.test(l)&&v){const m=this.i(r[l],s,!1,$);E[l]=m.raw,w=w||m.hasExcludedProperties,o.push(...m.restricted)}else{const m=s[l],F=m?typeof m.scope<"u"?m.scope:3:void 0;m?.restricted&&o.push(l),!$.exclude?.includes(l)&&($.include?.includes(l)||(F===void 0||$.scopes===void 0||$.scopes.includes(F))&&!($.skipRestricted&&m?.restricted))?E[l]=r[l]:w=!0}return{raw:E,restricted:o,hasExcludedProperties:w}}j(r,s){const v=[];for(const $ of Object.keys(r))if(D.$0m.test($)){const w={};for(const E in r[$])w[E]=r[$][E];v.push({identifiers:(0,D.$$m)($),keys:Object.keys(w),contents:(0,P.$1h)(w,s)})}return v}}e.$en=h;class t extends M.$lb{constructor(r,s,v,$){super(),this.c=r,this.f=s,this.g=$,this.b=this.B(new R.$ec),this.onDidChange=this.b.event,this.a=new h(this.c.toString()),this.B(this.g.watch(v.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(R.Event.any(R.Event.filter(this.g.onDidFilesChange,w=>w.contains(this.c)),R.Event.filter(this.g.onDidRunOperation,w=>(w.isOperation(0)||w.isOperation(3)||w.isOperation(1)||w.isOperation(4))&&v.isEqual(w.resource,r)))(()=>this.b.fire()))}async loadConfiguration(){try{const r=await this.g.readFile(this.c);return this.a.parse(r.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new p}}reparse(r){return r&&(this.f=r),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$fn=t;class i{constructor(r,s,v,$,w,E,o,l,m,F,W,V,B){this.a=r,this.b=s,this.c=v,this.overrideIdentifiers=$,this.d=w,this.f=E,this.g=o,this.h=l,this.i=m,this.j=F,this.k=W,this.l=V,this.m=B}get value(){return b(this.c)}n(r,s,v){const $=r.inspect(s,v);return{get value(){return b($.value)},get override(){return b($.override)},get merged(){return b($.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class c{constructor(r,s,v,$,w=new p,E=new p,o=new A.$ni,l=new p,m=new A.$ni){this.c=r,this.d=s,this.f=v,this.g=$,this.h=w,this.i=E,this.j=o,this.l=l,this.m=m,this.a=null,this.b=new A.$ni,this.n=null}getValue(r,s,v){return this.q(r,s,v).getValue(r)}updateValue(r,s,v={}){let $;v.resource?($=this.m.get(v.resource),$||($=new p,this.m.set(v.resource,$))):$=this.l,s===void 0?$.removeValue(r):$.setValue(r,s),v.resource||(this.a=null)}inspect(r,s,v){const $=this.q(r,s,v),w=this.u(s.resource,v),E=s.resource?this.m.get(s.resource)||this.l:this.l,o=new Set;for(const l of $.overrides)for(const m of l.identifiers)$.getOverrideValue(r,m)!==void 0&&o.add(m);return new i(r,s,$.getValue(r),o.size?[...o]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,v?this.i:void 0,w||void 0,E)}keys(r){const s=this.u(void 0,r);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.i=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,s){this.j.set(r,s),this.b.delete(r)}deleteFolderConfiguration(r){this.p.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,s){const v=[];if(!s){const{added:$,updated:w,removed:E}=C(this.c,r);s=[...$,...w,...E]}for(const $ of s)for(const w of(0,D.$$m)($)){const E=this.c.getKeysForOverrideIdentifier(w),o=r.getKeysForOverrideIdentifier(w),l=[...o.filter(m=>E.indexOf(m)===-1),...E.filter(m=>o.indexOf(m)===-1),...E.filter(m=>!d.$Mm(this.c.override(w).getValue(m),r.override(w).getValue(m)))];v.push([w,l])}return this.updateDefaultConfiguration(r),{keys:s,overrides:v}}compareAndUpdatePolicyConfiguration(r){const{added:s,updated:v,removed:$}=C(this.d,r),w=[...s,...v,...$];return w.length&&this.updatePolicyConfiguration(r),{keys:w,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:s,updated:v,removed:$,overrides:w}=C(this.applicationConfiguration,r),E=[...s,...v,...$];return E.length&&this.updateApplicationConfiguration(r),{keys:E,overrides:w}}compareAndUpdateLocalUserConfiguration(r){const{added:s,updated:v,removed:$,overrides:w}=C(this.localUserConfiguration,r),E=[...s,...v,...$];return E.length&&this.updateLocalUserConfiguration(r),{keys:E,overrides:w}}compareAndUpdateRemoteUserConfiguration(r){const{added:s,updated:v,removed:$,overrides:w}=C(this.remoteUserConfiguration,r),E=[...s,...v,...$];return E.length&&this.updateRemoteUserConfiguration(r),{keys:E,overrides:w}}compareAndUpdateWorkspaceConfiguration(r){const{added:s,updated:v,removed:$,overrides:w}=C(this.workspaceConfiguration,r),E=[...s,...v,...$];return E.length&&this.updateWorkspaceConfiguration(r),{keys:E,overrides:w}}compareAndUpdateFolderConfiguration(r,s){const v=this.p.get(r),{added:$,updated:w,removed:E,overrides:o}=C(v,s),l=[...$,...w,...E];return(l.length||!v)&&this.updateFolderConfiguration(r,s),{keys:l,overrides:o}}compareAndDeleteFolderConfiguration(r){const s=this.p.get(r);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:v,updated:$,removed:w,overrides:E}=C(s,void 0);return{keys:[...v,...$,...w],overrides:E}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(r,s,v){let $=this.r(s,v);return s.overrideIdentifier&&($=$.override(s.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&($=$.merge(this.d)),$}r({resource:r},s){let v=this.s();if(s&&r){const $=s.getFolder(r);$&&(v=this.t($.uri)||v);const w=this.m.get(r);w&&(v=v.merge(w))}return v}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(r){let s=this.b.get(r);if(!s){const v=this.s(),$=this.j.get(r);$?(s=v.merge($),this.b.set(r,s)):s=v}return s}u(r,s){if(s&&r){const v=s.getFolder(r);if(v)return this.j.get(v.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((r,s)=>{const{contents:v,overrides:$,keys:w}=this.j.get(s);return r.push([s,{contents:v,overrides:$,keys:w}]),r},[])}}allKeys(){const r=new Set;return this.c.keys.forEach(s=>r.add(s)),this.userConfiguration.keys.forEach(s=>r.add(s)),this.i.keys.forEach(s=>r.add(s)),this.j.forEach(s=>s.keys.forEach(v=>r.add(v))),[...r.values()]}v(){const r=new Set;return this.c.getAllOverrideIdentifiers().forEach(s=>r.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>r.add(s)),this.i.getAllOverrideIdentifiers().forEach(s=>r.add(s)),this.j.forEach(s=>s.getAllOverrideIdentifiers().forEach(v=>r.add(v))),[...r.values()]}w(r){const s=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(v=>s.add(v)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(v=>s.add(v)),this.i.getKeysForOverrideIdentifier(r).forEach(v=>s.add(v)),this.j.forEach(v=>v.getKeysForOverrideIdentifier(r).forEach($=>s.add($))),[...s.values()]}static parse(r){const s=this.x(r.defaults),v=this.x(r.policy),$=this.x(r.application),w=this.x(r.user),E=this.x(r.workspace),o=r.folders.reduce((l,m)=>(l.set(f.URI.revive(m[0]),this.x(m[1])),l),new A.$ni);return new c(s,v,$,w,new p,E,o,new p,new A.$ni)}static x(r){return new p(r.contents,r.keys,r.overrides)}}e.$gn=c;function g(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const r=new Set,s=new Map;for(const $ of a)$.keys.forEach(w=>r.add(w)),$.overrides.forEach(([w,E])=>{const o=(0,A.$ki)(s,w,new Set);E.forEach(l=>o.add(l))});const v=[];return s.forEach(($,w)=>v.push([w,[...$.values()]])),{keys:[...r.values()],overrides:v}}e.$hn=g;class S{constructor(r,s,v,$){this.change=r,this.f=s,this.g=v,this.h=$,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const w of r.keys)this.affectedKeys.add(w);for(const[,w]of r.overrides)for(const E of w)this.affectedKeys.add(E);this.d=this.a;for(const w of this.affectedKeys)this.d+=w+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=c.parse(this.f.data)),this.i}affectsConfiguration(r,s){const v=this.a+r,$=this.d.indexOf(v);if($<0)return!1;const w=$+v.length;if(w>=this.d.length)return!1;const E=this.d.charCodeAt(w);if(E!==this.b&&E!==this.c)return!1;if(s){const o=this.previousConfiguration?this.previousConfiguration.getValue(r,s,this.f?.workspace):void 0,l=this.g.getValue(r,s,this.h);return!d.$Mm(o,l)}return!0}}e.$in=S;function C(a,r){const{added:s,removed:v,updated:$}=n(r?.rawConfiguration,a?.rawConfiguration),w=[],E=a?.getAllOverrideIdentifiers()||[],o=r?.getAllOverrideIdentifiers()||[];if(r){const l=o.filter(m=>!E.includes(m));for(const m of l)w.push([m,r.getKeysForOverrideIdentifier(m)])}if(a){const l=E.filter(m=>!o.includes(m));for(const m of l)w.push([m,a.getKeysForOverrideIdentifier(m)])}if(r&&a){for(const l of E)if(o.includes(l)){const m=n({contents:a.getOverrideValue(void 0,l)||{},keys:a.getKeysForOverrideIdentifier(l)},{contents:r.getOverrideValue(void 0,l)||{},keys:r.getKeysForOverrideIdentifier(l)});w.push([l,[...m.added,...m.removed,...m.updated]])}}return{added:s,removed:v,updated:$,overrides:w}}function n(a,r){const s=a?r?a.keys.filter(w=>r.keys.indexOf(w)===-1):[...a.keys]:[],v=r?a?r.keys.filter(w=>a.keys.indexOf(w)===-1):[...r.keys]:[],$=[];if(a&&r){for(const w of r.keys)if(a.keys.indexOf(w)!==-1){const E=(0,P.$4h)(r.contents,w),o=(0,P.$4h)(a.contents,w);d.$Mm(E,o)||$.push(w)}}return{added:s,removed:v,updated:$}}}),define(Pe[97],Ae([1,0,9,4]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ak=e.$zk=e.RemoteAuthorityResolverErrorCode=e.$yk=e.$xk=e.RemoteConnectionType=e.$wk=void 0,e.$wk=(0,R.$ph)("remoteAuthorityResolverService");var I;(function(P){P[P.WebSocket=0]="WebSocket",P[P.Managed=1]="Managed"})(I||(e.RemoteConnectionType=I={}));class M{constructor(D){this.id=D,this.type=1}toString(){return`Managed(${this.id})`}}e.$xk=M;class A{constructor(D,u){this.host=D,this.port=u,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$yk=A;var d;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound",P.InvalidAuthority="InvalidAuthority"})(d||(e.RemoteAuthorityResolverErrorCode=d={}));class k extends y.$ab{static isNotAvailable(D){return D instanceof k&&D._code===d.NotAvailable}static isTemporarilyNotAvailable(D){return D instanceof k&&D._code===d.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof k&&D._code===d.NoResolverFound}static isInvalidAuthority(D){return D instanceof k&&D._code===d.InvalidAuthority}static isHandled(D){return D instanceof k&&D.isHandled}constructor(D,u=d.Unknown,b){super(D),this._message=D,this._code=u,this._detail=b,this.isHandled=u===d.NotAvailable&&b===!0,Object.setPrototypeOf(this,k.prototype)}}e.$zk=k;function f(P){const D=P.indexOf("+");return D===-1?P:P.substring(0,D)}e.$Ak=f}),define(Pe[51],Ae([1,0,12]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.$Bk=void 0;function R(f){return f.scheme===y.Schemas.vscodeRemote?f.authority:void 0}e.$Bk=R;function I(f){if(!f)return;const P=f.indexOf("+");return P<0?f:f.substr(0,P)}e.$Ck=I;function M(f){return`/${f.quality??"oss"}-${f.commit??"dev"}`}e.$Dk=M;function A(f){const{host:P,port:D}=k(f);if(typeof D>"u")throw new Error("Remote authority doesn't contain a port!");return{host:P,port:D}}e.$Ek=A;function d(f,P){let{host:D,port:u}=k(f);return typeof u>"u"&&(u=P),{host:D,port:u}}e.$Fk=d;function k(f){const P=f.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(P)return{host:P[1],port:parseInt(P[2],10)};const D=f.match(/^(\[[0-9a-z:]+\])$/);if(D)return{host:D[1],port:void 0};const u=f.match(/(.*):(\d+)$/);return u?{host:u[1],port:parseInt(u[2],10)}:{host:f,port:void 0}}}),define(Pe[20],Ae([1,0,15,4,51]),function(pe,e,y,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=e.$Ol=e.$Nl=e.$Ml=e.$Ll=e.$Kl=e.$Jl=e.$Il=e.TargetPlatform=e.ExtensionType=e.$Hl=e.$Gl=e.$Fl=e.$El=e.$Dl=e.$Cl=void 0,e.$Cl="extensions.user.cache",e.$Dl="extensions.builtin.cache",e.$El="undefined_publisher",e.$Fl=["ui","workspace","web"];function M(h){if(typeof h=="object"&&h!==null&&h.supported!==!0)return h.description}e.$Gl=M,e.$Hl=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(h){h[h.System=0]="System",h[h.User=1]="User"})(A||(e.ExtensionType=A={}));var d;(function(h){h.WIN32_X64="win32-x64",h.WIN32_IA32="win32-ia32",h.WIN32_ARM64="win32-arm64",h.LINUX_X64="linux-x64",h.LINUX_ARM64="linux-arm64",h.LINUX_ARMHF="linux-armhf",h.ALPINE_X64="alpine-x64",h.ALPINE_ARM64="alpine-arm64",h.DARWIN_X64="darwin-x64",h.DARWIN_ARM64="darwin-arm64",h.WEB="web",h.UNIVERSAL="universal",h.UNKNOWN="unknown",h.UNDEFINED="undefined"})(d||(e.TargetPlatform=d={}));class k{constructor(t){this.value=t,this._lower=t.toLowerCase()}static equals(t,i){if(typeof t>"u"||t===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof t=="string"||typeof i=="string"){const c=typeof t=="string"?t:t.value,g=typeof i=="string"?i:i.value;return y.$Ld(c,g)}return t._lower===i._lower}static toKey(t){return typeof t=="string"?t.toLowerCase():t._lower}}e.$Il=k;class f{get size(){return this.c.size}constructor(t){if(this.c=new Set,t)for(const i of t)this.add(i)}add(t){this.c.add(k.toKey(t))}delete(t){return this.c.delete(k.toKey(t))}has(t){return this.c.has(k.toKey(t))}}e.$Jl=f;class P{constructor(){this.c=new Map}clear(){this.c.clear()}delete(t){this.c.delete(k.toKey(t))}get(t){return this.c.get(k.toKey(t))}has(t){return this.c.has(k.toKey(t))}set(t,i){this.c.set(k.toKey(t),i)}values(){return this.c.values()}forEach(t){this.c.forEach(t)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Kl=P;function D(h){return u(h)}e.$Ll=D;function u(h){return h.contributes&&h.contributes.localizations?h.contributes.localizations.length>0:!1}e.$Ml=u;function b(h){return h.contributes&&h.contributes.authentication?h.contributes.authentication.length>0:!1}e.$Nl=b;function p(h,t){if(t){const i=`onResolveRemoteAuthority:${(0,I.$Ck)(t)}`;return!!h.activationEvents?.includes(i)}return!1}e.$Ol=p,e.$Pl=(0,R.$ph)("IBuiltinExtensionsScannerService")}),define(Pe[98],Ae([1,0,9,20]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pF=e.$oF=void 0;class I{constructor(){this.a=new Map,this.b=new WeakMap}register(A,d){this.a.set(A,d)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const d=Object.create(null);for(const k of A){const f=this.readActivationEvents(k);f.length>0&&(d[R.$Il.toKey(k.identifier)]=f)}return d}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const d=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];if(!A.contributes)return d;for(const k in A.contributes){const f=this.a.get(k);if(!f)continue;const P=A.contributes[k],D=Array.isArray(P)?P:[P];try{f(D,d)}catch(u){(0,y.$Y)(u)}}return d}}e.$oF=I,e.$pF=new I}),define(Pe[179],Ae([1,0,22,52,36]),function(pe,e,y,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3n=e.$2n=void 0;function M(k){if(y.$t===2&&/^penguin(\.|$)/i.test(k))return"chromebook"}function A(k,f,P,D,u,b,p,h){const t=Object.create(null);t["common.machineId"]=b,t.sessionID=(0,I.$3e)()+Date.now(),t.commitHash=D,t.version=u,t["common.platformVersion"]=(k||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),t["common.platform"]=(0,y.$h)(y.$t),t["common.nodePlatform"]=R.$2c,t["common.nodeArch"]=P,t["common.product"]=h||"desktop",p&&(t["common.msftInternal"]=p);let i=0;const c=Date.now();Object.defineProperties(t,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-c,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),y.$l&&(t["common.snap"]="true");const g=M(f);return g&&(t["common.platformDetail"]=g),t}e.$2n=A;function d(k){const f=R.env.USERDNSDOMAIN;if(!f)return!1;const P=f.toLowerCase();return k.some(D=>P===D)}e.$3n=d}),define(Pe[180],Ae([1,0,4]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$5k=e.$4k=e.$3k=e.$2k=e.$1k=e.$Zk=e.$Yk=e.$Xk=e.$Wk=e.$Vk=void 0,e.$Vk=(0,y.$ph)("telemetryService"),e.$Wk=(0,y.$ph)("customEndpointTelemetryService"),e.$Xk="telemetry.currentSessionDate",e.$Yk="telemetry.firstSessionDate",e.$Zk="telemetry.lastSessionDate",e.$1k="telemetry.machineId",e.$2k="telemetry",e.$3k="telemetry.telemetryLevel",e.$4k="telemetry.enableCrashReporter",e.$5k="telemetry.enableTelemetry";var R;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(R||(e.TelemetryLevel=R={}));var I;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(I||(e.TelemetryConfiguration=I={}))}),define(Pe[53],Ae([1,0,24,16,5,43,51,179,180]),function(pe,e,y,R,I,M,A,d,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=void 0;class f{constructor(v){this.value=v,this.isTrustedTelemetryValue=!0}}e.$4n=f;class P{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$5n=P,e.$6n=new P;class D{async publicLog(v,$,w){}async publicLogError(v,$,w){}}e.$7n=D,e.$8n="telemetry",e.$9n="extensionTelemetryLog",e.$0n={log:()=>null,flush:()=>Promise.resolve(null)};function u(s,v){return I.Event.debounce(v.onDidChangeConfiguration,(w,E)=>{const o=w?new Set([...w.affectedKeys,...E.affectedKeys]):E.affectedKeys;return{...E,affectedKeys:o}},1e3,!0)(w=>{w.source!==7&&s.publicLog2("updateConfiguration",{configurationSource:(0,M.$Yh)(w.source),configurationKeys:Array.from(w.affectedKeys)})})}e.$$n=u;function b(s,v){return!v.isBuilt&&!v.disableTelemetry?!0:!(v.disableTelemetry||!s.enableTelemetry||v.extensionTestsLocationURI)}e.$_n=b;function p(s,v){return!(v.isBuilt||v.disableTelemetry||s.enableTelemetry&&s.aiConfig?.ariaKey)}e.$ao=p;function h(s){const v=s.getValue(k.$3k),$=s.getValue(k.$4k);if(s.getValue(k.$5k)===!1||$===!1)return 0;switch(v??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$bo=h;function t(s){const v={},$={},w={};g(s,w);for(let E in w){E=E.length>150?E.substr(E.length-149):E;const o=w[E];typeof o=="number"?$[E]=o:typeof o=="boolean"?$[E]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${E} has been trimmed to 8192, the original length is ${o.length}`),v[E]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(v[E]=o)}return{properties:v,measurements:$}}e.$co=t;const i=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function c(s){if(!s)return"none";const v=(0,A.$Ck)(s);return i.has(v)?v:"other"}e.$do=c;function g(s,v,$=0,w){if(s)for(const E of Object.getOwnPropertyNames(s)){const o=s[E],l=w?w+E:E;Array.isArray(o)?v[l]=(0,y.$Nm)(o):o instanceof Date?v[l]=o.toISOString():(0,R.$ke)(o)?$<2?g(o,v,$+1,l+"."):v[l]=(0,y.$Nm)(o):v[l]=o}}function S(s,v){const $=s.msftInternalDomains||[],w=v.getValue("telemetry.internalTesting");return(0,d.$3n)($)||w}e.$eo=S;function C(s){return[s.appRoot,s.extensionsPath,s.userHome.fsPath,s.tmpDir.fsPath,s.userDataPath]}e.$fo=C;function n(s,v){if(!s||!s.includes("/")&&!s.includes("\\"))return s;let $=s;const w=[];for(const m of v)for(;;){const F=m.exec(s);if(!F)break;w.push([F.index,m.lastIndex])}const E=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for($="";;){const m=o.exec(s);if(!m)break;const F=w.some(([W,V])=>m.index<V&&W<o.lastIndex);!E.test(m[0])&&!F&&($+=s.substring(l,m.index)+"<REDACTED: user-file-path>",l=o.lastIndex)}return l<s.length&&($+=s.substr(l)),$}function a(s){if(!s)return s;const v=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const $ of v)if($.regex.test(s))return`<REDACTED: ${$.label}>`;return s}function r(s,v){return(0,y.$Km)(s,$=>{if($ instanceof f||Object.hasOwnProperty.call($,"isTrustedTelemetryValue"))return $.value;if(typeof $=="string"){let w=$.replaceAll("%20"," ");w=n(w,v);for(const E of v)w=w.replace(E,"");return w=a(w),w}})}e.$go=r}),define(Pe[181],Ae([1,0,15,92,20,22,2,9,52,53]),function(pe,e,y,R,I,M,A,d,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=void 0;function P(r,s){return r.uuid&&s.uuid?r.uuid===s.uuid:r.id===s.id?!0:(0,y.$Gd)(r.id,s.id)===0}e.$ho=P;const D=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class u{static create(s){const v=s.manifest?s.manifest.version:s.version,$=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new u(s.identifier,v,$)}static parse(s){const v=D.exec(s);return v&&v[1]&&v[2]?new u({id:v[1]},v[2],v[4]||void 0):null}constructor(s,v,$="undefined"){this.version=v,this.targetPlatform=$,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof u?P(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.$io=u;const b=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function p(r){const s=b.exec(r);return s&&s[1]?[t(s[1]),s[2]]:[t(r),void 0]}e.$jo=p;function h(r,s){return`${r}.${s}`}e.$ko=h;function t(r){return r.toLowerCase()}e.$lo=t;function i(r,s){return t(h(r??I.$El,s))}e.$mo=i;function c(r,s){const v=[],$=w=>{for(const E of v)if(E.some(o=>P(s(o),s(w))))return E;return null};for(const w of r){const E=$(w);E?E.push(w):v.push([w])}return v}e.$no=c;function g(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.$oo=g;function S(r){return{id:new f.$4n(r.identifier.id),name:new f.$4n(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.$po=S,e.$qo=new I.$Il("pprice.better-merge");function C(r,s){const v=[],$=s.manifest.extensionDependencies?.slice(0)??[];for(;$.length;){const w=$.shift();if(w&&v.every(E=>!P(E.identifier,{id:w}))){const E=r.filter(o=>P(o.identifier,{id:w}));E.length===1&&(v.push(E[0]),$.push(...E[0].manifest.extensionDependencies?.slice(0)??[]))}}return v}e.$ro=C;async function n(r,s){if(!M.$k)return!1;let v;try{v=(await r.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{v=(await r.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(w){s.debug("Error while getting the os-release file.",(0,d.$9)(w))}}return!!v&&(v.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function a(r,s){const v=await n(r,s),$=(0,R.$Mn)(v?"alpine":M.$t,k.$3c);return s.debug("ComputeTargetPlatform:",$),$}e.$so=a}),define(Pe[182],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9q=e.$8q=e.$7q=e.$6q=e.$5q=e.$4q=void 0;function y(k){return[...k.entries()]}e.$4q=y;function R(k){return k?[...k.entries()]:[]}e.$5q=R;function I(k){return new Map(k)}e.$6q=I;function M(k){return new Map(k??[])}e.$7q=M;function A(k){return Array.from(k.entries()).map(f=>[f[0],y(f[1].map),R(f[1].descriptionMap)])}e.$8q=A;function d(k){return new Map(k.map(f=>[f[0],{map:I(f[1]),descriptionMap:M(f[2])}]))}e.$9q=d}),define(Pe[183],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dkb=void 0;class y{constructor(I){this.b=I,this.a=new Map}dispose(){for(const I of this.a.values())I.dispose()}startBuffering(I,M,A=5){const d=M(k=>{const f=typeof k=="string"?k:k.data;let P=this.a.get(I);if(P){P.data.push(f);return}const D=setTimeout(()=>this.flushBuffer(I),A);P={data:[f],timeoutId:D,dispose:()=>{clearTimeout(D),this.flushBuffer(I),d.dispose()}},this.a.set(I,P)});return d}stopBuffering(I){this.a.get(I)?.dispose()}flushBuffer(I){const M=this.a.get(I);M&&(this.a.delete(I),this.b(I,M.data.join("")))}}e.$dkb=y}),define(Pe[184],Ae([1,0,13,89,40,5,16,2,145,74,30]),function(pe,e,y,R,I,M,A,d,k,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6u=e.$5u=e.$4u=e.$3u=e.$2u=e.$1u=e.$Zu=e.$Yu=e.IconFontDefinition=e.IconContribution=e.$Xu=void 0,e.$Xu={IconContribution:"base.contributions.icons"};var D;(function(S){function C(n,a){let r=n.defaults;for(;I.ThemeIcon.isThemeIcon(r);){const s=p.getIcon(r.id);if(!s)return;r=s.defaults}return r}S.getDefinition=C})(D||(e.IconContribution=D={}));var u;(function(S){function C(a){return{weight:a.weight,style:a.style,src:a.src.map(r=>({format:r.format,location:r.location.toString()}))}}S.toJSONObject=C;function n(a){const r=s=>(0,A.$ie)(s)?s:void 0;if(a&&Array.isArray(a.src)&&a.src.every(s=>(0,A.$ie)(s.format)&&(0,A.$ie)(s.location)))return{weight:r(a.weight),style:r(a.style),src:a.src.map(s=>({format:s.format,location:d.URI.parse(s.location)}))}}S.fromJSONObject=n})(u||(e.IconFontDefinition=u={}));class b{constructor(){this.a=new M.$ec,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,k.localize)(0,null)},fontCharacter:{type:"string",description:(0,k.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${I.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(C,n,a,r){const s=this.b[C];if(s){if(a&&!s.description){s.description=a,this.d.properties[C].markdownDescription=`${a} $(${C})`;const w=this.e.enum.indexOf(C);w!==-1&&(this.e.enumDescriptions[w]=a),this.a.fire()}return s}const v={id:C,description:a,defaults:n,deprecationMessage:r};this.b[C]=v;const $={$ref:"#/definitions/icons"};return r&&($.deprecationMessage=r),a&&($.markdownDescription=`${a}: $(${C})`),this.d.properties[C]=$,this.e.enum.push(C),this.e.enumDescriptions.push(a||""),this.a.fire(),{id:C}}deregisterIcon(C){delete this.b[C],delete this.d.properties[C];const n=this.e.enum.indexOf(C);n!==-1&&(this.e.enum.splice(n,1),this.e.enumDescriptions.splice(n,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(C=>this.b[C])}getIcon(C){return this.b[C]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(C,n){const a=this.f[C];return a||(this.f[C]=n,this.a.fire(),n)}deregisterIconFont(C){delete this.f[C]}getIconFont(C){return this.f[C]}toString(){const C=(s,v)=>s.id.localeCompare(v.id),n=s=>{for(;I.ThemeIcon.isThemeIcon(s.defaults);)s=this.b[s.defaults.id];return`codicon codicon-${s?s.id:""}`},a=[];a.push("| preview     | identifier                        | default codicon ID                | description"),a.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const r=Object.keys(this.b).map(s=>this.b[s]);for(const s of r.filter(v=>!!v.description).sort(C))a.push(`|<i class="${n(s)}"></i>|${s.id}|${I.ThemeIcon.isThemeIcon(s.defaults)?s.defaults.id:s.id}|${s.description||""}|`);a.push("| preview     | identifier                        "),a.push("| ----------- | --------------------------------- |");for(const s of r.filter(v=>!I.ThemeIcon.isThemeIcon(v.defaults)).sort(C))a.push(`|<i class="${n(s)}"></i>|${s.id}|`);return a.join(`
`)}}const p=new b;P.$Um.add(e.$Xu.IconContribution,p);function h(S,C,n,a){return p.registerIcon(S,C,n,a)}e.$Yu=h;function t(){return p}e.$Zu=t;function i(){const S=(0,R.$Aj)();for(const C in S){const n="\\"+S[C].toString(16);p.registerIcon(C,{fontCharacter:n})}}i(),e.$1u="vscode://schemas/icons";const c=P.$Um.as(f.$Vm.JSONContribution);c.registerSchema(e.$1u,p.getIconSchema());const g=new y.$Gg(()=>c.notifySchemaChanged(e.$1u),200);p.onDidChange(()=>{g.isScheduled()||g.schedule()}),e.$2u=h("widget-close",R.$Cj.close,(0,k.localize)(2,null)),e.$3u=h("goto-previous-location",R.$Cj.arrowUp,(0,k.localize)(3,null)),e.$4u=h("goto-next-location",R.$Cj.arrowDown,(0,k.localize)(4,null)),e.$5u=I.ThemeIcon.modify(R.$Cj.sync,"spin"),e.$6u=I.ThemeIcon.modify(R.$Cj.loading,"spin")}),define(Pe[185],Ae([1,0,5,43,4,14]),function(pe,e,y,R,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vz=e.$Uz=e.$Tz=e.$Sz=e.$Rz=e.$Qz=e.$Pz=e.$Oz=e.ProvidedOnAutoForward=e.$Nz=e.TunnelPrivacyId=e.TunnelProtocol=e.$Mz=e.$Lz=void 0,e.$Lz=(0,I.$ph)("tunnelService"),e.$Mz=(0,I.$ph)("sharedTunnelsService");var A;(function(t){t.Http="http",t.Https="https"})(A||(e.TunnelProtocol=A={}));var d;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(d||(e.TunnelPrivacyId=d={}));function k(t){return!!t.forwardPort}e.$Nz=k;var f;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(f||(e.ProvidedOnAutoForward=f={}));function P(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(i)return{address:i[1],port:+i[2]}}e.$Oz=P,e.$Pz=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function D(t){return e.$Pz.indexOf(t)>=0}e.$Qz=D,e.$Rz=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function u(t){return e.$Rz.indexOf(t)>=0}e.$Sz=u;function b(t,i,c,g){if(c===1)return!1;if(c===2&&u(i)){const S=/(\d+)\.(\d+)\.(\d+)/g.exec(g);if(S?.length===4&&parseInt(S[1])>=18)return!1}return t<1024}e.$Tz=b;class p{constructor(i,c,g){this.remoteAddress=i,this.localAddress=c,this.b=g,this.a=new y.$ec,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Uz=p;let h=class{constructor(i,c){this.j=i,this.k=c,this.a=new y.$ec,this.onTunnelOpened=this.a.event,this.b=new y.$ec,this.onTunnelClosed=this.b.event,this.c=new y.$ec,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const i=this.k.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.h=i.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const i=[],c=Array.from(this.e.values());for(const g of c){const S=Array.from(g.values());for(const C of S){const n=await C.value;n&&typeof n!="string"&&i.push(n)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:c}of i.values())await c.then(g=>typeof g!="string"?g?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,c,g,S,C){this.p(i,c,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:c,localAddress:g,privacy:S,protocol:C,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,c){(u(i)||D(i))&&(i=e.$Pz[0]);const g=this.r(i,c);if(g)return++g.refcount,g.value}openTunnel(i,c,g,S,C,n=!1,a,r){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${g} on local port ${C}.`);const s=this.f??i;if(!s)return;if(c||(c="localhost"),S||(S=this.l),this.f&&this.i.has(g)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const v=this.s(s,c,g,S,C,n,a,r);return v?v.then($=>{if($){if(typeof $=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(c,g),$}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(c,g);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const w=this.n($);return($.tunnelRemoteHost!==c||$.tunnelRemotePort!==g)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),a&&$.privacy!==a&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(w),w}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),v)}n(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const c=this.e.get(i.tunnelRemoteHost);if(c){const g=c.get(i.tunnelRemotePort);g&&(g.refcount--,await this.o(i.tunnelRemoteHost,i.tunnelRemotePort,g))}}}}async o(i,c,g){if(g.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${c}.`);const S=g.value.then(async C=>{C&&typeof C!="string"&&(await C.dispose(!0),this.b.fire({host:C.tunnelRemoteHost,port:C.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(c),S}}async closeTunnel(i,c){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${c} `);const g=this.e.get(i);if(g&&g.has(c)){const S=g.get(c);S.refcount=0,await this.o(i,c,S)}}p(i,c,g){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(c,{refcount:1,value:g})}async q(i,c){const g=this.e.get(i);if(g){const S=g.get(c),C=S?await S.value:void 0;(!C||typeof C=="string")&&g.delete(c),g.size===0&&this.e.delete(i)}}r(i,c){const g=[i];D(i)?(g.push(...e.$Pz),g.push(...e.$Rz)):u(i)&&g.push(...e.$Rz);const S=g.map(C=>this.e.get(C));for(const C of S){const n=C?.get(c);if(n)return n}}canTunnel(i){return!!P(i)}t(i,c,g,S,C,n,a){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${g} on local port ${S}.`);const r=g;this.i.add(r);const s=S===void 0?g:S,v={elevationRequired:C?this.isPortPrivileged(s):!1},$={remoteAddress:{host:c,port:g},localAddressPort:S,privacy:n,public:n?n!==d.Private:void 0,protocol:a},w=i.forwardPort($,v);return w?(this.p(c,g,w),w.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(r)})):this.i.delete(r),w}};e.$Vz=h,e.$Vz=h=Ke([We(0,M.$Ri),We(1,R.$Vh)],h)}),define(Pe[186],Ae([1,0,4]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Wz=void 0,e.$Wz=(0,y.$ph)("editSessionIdentityService");var R;(function(I){I[I.Complete=100]="Complete",I[I.Partial=50]="Partial",I[I.None=0]="None"})(R||(e.EditSessionIdentityMatch=R={}))}),define(Pe[187],Ae([1,0,12]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=void 0;function R(k){return k.scheme!==y.Schemas.file&&k.scheme!==y.Schemas.vscodeRemote}e.$aJ=R;function I(k){if(k.folders.length)return k.folders.every(f=>R(f.uri))?k.folders[0].uri:void 0;if(k.configuration&&R(k.configuration))return k.configuration}e.$bJ=I;function M(k){return I(k)?.scheme}e.$cJ=M;function A(k){return I(k)?.authority}e.$dJ=A;function d(k){return I(k)!==void 0}e.$eJ=d}),define(Pe[54],Ae([1,0,146,19,48,23,2,4,12]),function(pe,e,y,R,I,M,A,d,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.WorkbenchState=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=void 0,e.$yh=(0,d.$ph)("contextService");function f(s){const v=s;return typeof v?.id=="string"&&A.URI.isUri(v.uri)}e.$zh=f;function P(s){return typeof s?.id=="string"&&!f(s)&&!u(s)}e.$Ah=P,e.$Bh={id:"ext-dev"},e.$Ch={id:"empty-window"};function D(s,v){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,R.$_c)(s)}:v?e.$Bh:e.$Ch;const $=s;return $.configuration?{id:$.id,configPath:$.configuration}:$.folders.length===1?{id:$.id,uri:$.folders[0].uri}:{id:$.id}}e.$Dh=D;function u(s){const v=s;return typeof v?.id=="string"&&A.URI.isUri(v.configPath)}e.$Eh=u;function b(s){const v=s;if(v?.uri)return{id:v.id,uri:A.URI.revive(v.uri)};const $=s;if($?.configPath)return{id:$.id,configPath:A.URI.revive($.configPath)};if(s?.id)return{id:s.id}}e.$Fh=b;var p;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(p||(e.WorkbenchState=p={}));function h(s){const v=s;return!!(v&&typeof v=="object"&&typeof v.id=="string"&&Array.isArray(v.folders))}e.$Gh=h;function t(s){const v=s;return!!(v&&typeof v=="object"&&A.URI.isUri(v.uri)&&typeof v.name=="string"&&typeof v.toResource=="function")}e.$Hh=t;class i{constructor(v,$,w,E,o){this.h=v,this.j=w,this.k=E,this.l=o,this.c=I.$vh.forUris(this.l,()=>!0),this.folders=$}update(v){this.h=v.id,this.k=v.configuration,this.j=v.transient,this.l=v.l,this.folders=v.folders}get folders(){return this.g}set folders(v){this.g=v,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(v){this.k=v}getFolder(v){return v&&this.c.findSubstr(v)||null}n(){this.c=I.$vh.forUris(this.l,()=>!0);for(const v of this.folders)this.c.set(v.uri,v)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ih=i;class c{constructor(v,$){this.raw=$,this.uri=v.uri,this.index=v.index,this.name=v.name}toResource(v){return(0,M.$9f)(this.uri,v)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Jh=c;function g(s){return new c({uri:s,index:0,name:(0,M.$5f)(s)},{uri:s.toString()})}e.$Kh=g,e.$Lh="code-workspace",e.$Mh=`.${e.$Lh}`,e.$Nh=[{name:(0,y.localize)(0,null),extensions:[e.$Lh]}],e.$Oh="workspace.json";function S(s,v){return M.$Zf.isEqualOrParent(s,v.untitledWorkspacesHome)}e.$Ph=S;function C(s){let v;return A.URI.isUri(s)?v=s:v=s.configuration,v?.scheme===k.Schemas.tmp}e.$Qh=C,e.$Rh="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function n(s){return s.id===e.$Rh}e.$Sh=n;function a(s,v){return!S(s,v)&&!C(s)}e.$Th=a;function r(s){return(typeof s=="string"?(0,R.$ad)(s):(0,M.$7f)(s))===e.$Mh}e.$Uh=r}),define(Pe[55],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jac=void 0;class y{static{this.a=!1}constructor(I){this.d=I,this.b=new Map,this.c=1}add(I){const M=this.c++;return this.b.set(M,I),this.e(),M}get(I,M){return this.b.has(I)?this.b.get(I)[M]:void 0}delete(I){this.b.delete(I),this.e()}e(){y.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$jac=y}),define(Pe[39],Ae([1,0,12,23,4]),function(pe,e,y,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mac=e.$lac=void 0;class M{constructor(){this.a=new Set(Object.keys(y.Schemas)),this.b=new Map,this.extUri=new R.$Xf(d=>{const k=this.b.get(d.scheme);return!(k===void 0||k&1024)})}$acceptProviderInfos(d,k){k===null?this.b.delete(d.scheme):this.b.set(d.scheme,k)}isFreeScheme(d){return!this.b.has(d)&&!this.a.has(d)}getCapabilities(d){return this.b.get(d)}}e.$lac=M,e.$mac=(0,I.$ph)("IExtHostFileSystemInfo")}),define(Pe[27],Ae([1,0,4]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2L=void 0,e.$2L=(0,y.$ph)("IExtHostInitDataService")}),define(Pe[188],Ae([1,0,151,14,175,27]),function(pe,e,y,R,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$scc=void 0;let A=class extends I.$9M{constructor(k,f,P){const D=P.remote.isRemote?"remoteexthost":k?"workerexthost":"exthost",u=P.remote.isRemote?(0,y.localize)(0,null):k?(0,y.localize)(1,null):(0,y.localize)(2,null);super(f.createLogger(D,{name:u}))}};e.$scc=A,e.$scc=A=Ke([We(1,R.$Si),We(2,M.$2L)],A)}),define(Pe[189],Ae([1,0,13]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pac=e.$Oac=void 0;class R{constructor(A,d,k){this.h=new Map,this.a=A,this.b=d,this.c=k,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(f=>(this.f=f,this)),this.g=this.c.onDidChangeStorage(f=>{f.shared===this.b&&f.key===this.a&&(this.f=f.value)}),this.i=new y.$Gg(()=>{const f=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const P of f.values())P.complete()}catch(P){for(const D of f.values())D.error(P)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,d){let k=this.f[A];return typeof k>"u"&&(k=d),k}update(A,d){this.f[A]=d;const k=this.h.get(A);if(k!==void 0)return k.p;const f=new y.$Pg;return this.h.set(A,f),this.i.isScheduled()||this.i.schedule(),f.p}dispose(){this.g.dispose()}}e.$Oac=R;class I extends R{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,d){super(A.identifier.value,!0,d),this.j=A}}e.$Pac=I}),define(Pe[190],Ae([1,0,5,2]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bcc=void 0;class I{constructor(A){this.c=A,this.a=new y.$ec,this.onDidSaveNotebookDocument=this.a.event,this.b=new y.$ec,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,d,k,f){const D=this.c.getNotebookDocument(R.URI.revive(A)).acceptModelChanged(d.value,k,f);this.b.fire(D)}$acceptDirtyStateChanged(A,d){this.c.getNotebookDocument(R.URI.revive(A)).acceptDirty(d)}$acceptModelSaved(A){const d=this.c.getNotebookDocument(R.URI.revive(A));this.a.fire(d.apiNotebook)}}e.$bcc=I}),define(Pe[17],Ae([1,0,4]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ML=e.$LL=void 0,e.$LL=(0,y.$ph)("IExtHostRpcService");class R{constructor(M){this.getProxy=M.getProxy.bind(M),this.set=M.set.bind(M),this.dispose=M.dispose.bind(M),this.assertRegistered=M.assertRegistered.bind(M),this.drain=M.drain.bind(M)}}e.$ML=R}),define(Pe[191],Ae([1,0,20,5]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1ac=void 0;class I{#e;constructor(A,d){this.b=new R.$ec,this.onDidChange=this.b.event,this.a=y.$Il.toKey(A.identifier),this.#e=d,this.#e.onDidChangePassword(k=>{k.extensionId===this.a&&this.b.fire({key:k.key})})}get(A){return this.#e.get(this.a,A)}store(A,d){return this.#e.store(this.a,A,d)}delete(A){return this.#e.delete(this.a,A)}}e.$1ac=I}),define(Pe[56],Ae([1,0,4]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xac=e.$wac=void 0,e.$wac=(0,y.$ph)("IURITransformerService");class R{constructor(M){M?(this.transformIncoming=M.transformIncoming.bind(M),this.transformOutgoing=M.transformOutgoing.bind(M),this.transformOutgoingURI=M.transformOutgoingURI.bind(M),this.transformOutgoingScheme=M.transformOutgoingScheme.bind(M)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$xac=R}),define(Pe[192],Ae([1,0,25]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ybb=e.$xbb=void 0;class R{constructor(){this.buffers=[]}add(k){let f=this.buffers.indexOf(k);return f<0&&(f=this.buffers.length,this.buffers.push(k)),f}}function I(d,k){if(k.serializeBuffersForPostMessage){const f=new R,D=JSON.stringify(d,(b,p)=>{if(p instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:f.add(p)};if(ArrayBuffer.isView(p)){const h=M(p);if(h)return{$$vscode_array_buffer_reference$$:!0,index:f.add(p.buffer),view:{type:h,byteLength:p.byteLength,byteOffset:p.byteOffset}}}return p}),u=f.buffers.map(b=>{const p=new Uint8Array(b);return y.$Ec.wrap(p)});return{message:D,buffers:u}}else return{message:JSON.stringify(d),buffers:[]}}e.$xbb=I;function M(d){switch(d.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(d,k){const f=k.map(u=>{const b=new ArrayBuffer(u.byteLength);return new Uint8Array(b).set(u.buffer),b}),P=k.length?(u,b)=>{if(b&&typeof b=="object"&&b.$$vscode_array_buffer_reference$$){const p=b,{index:h}=p,t=f[h];if(p.view)switch(p.view.type){case 1:return new Int8Array(t,p.view.byteOffset,p.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(t,p.view.byteOffset,p.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(t,p.view.byteOffset,p.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(t,p.view.byteOffset,p.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(t,p.view.byteOffset,p.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(t,p.view.byteOffset,p.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(t,p.view.byteOffset,p.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(t,p.view.byteOffset,p.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(t,p.view.byteOffset,p.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(t,p.view.byteOffset,p.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(t,p.view.byteOffset,p.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return t}return b}:void 0;return{message:JSON.parse(d,P),arrayBuffers:f}}e.$ybb=A}),define(Pe[99],Ae([1,0,160,16,2,6,4,30,38,12,41,128,29]),function(pe,e,y,R,I,M,A,d,k,f,P,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VE=e.$UE=e.$TE=e.EditorsOrder=e.$SE=e.CloseDirection=e.$RE=e.$QE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$PE=e.$OE=e.$NE=e.$ME=e.$LE=e.$KE=e.$JE=e.$IE=e.EditorInputCapabilities=e.$HE=e.SaveReason=e.Verbosity=e.$GE=e.$FE=e.$EE=e.$DE=e.$CE=e.$BE=e.$AE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$zE=e.$yE=e.$xE=e.$wE=e.$vE=void 0,e.$vE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$wE={id:"default",displayName:(0,y.localize)(0,null),providerDisplayName:(0,y.localize)(1,null)},e.$xE="workbench.editor.sidebysideEditor",e.$yE="workbench.editors.textDiffEditor",e.$zE="workbench.editors.binaryResourceDiffEditor";var b;(function(ae){ae[ae.PROGRAMMATIC=1]="PROGRAMMATIC",ae[ae.USER=2]="USER",ae[ae.EDIT=3]="EDIT",ae[ae.NAVIGATION=4]="NAVIGATION",ae[ae.JUMP=5]="JUMP"})(b||(e.EditorPaneSelectionChangeReason=b={}));var p;(function(ae){ae[ae.IDENTICAL=1]="IDENTICAL",ae[ae.SIMILAR=2]="SIMILAR",ae[ae.DIFFERENT=3]="DIFFERENT"})(p||(e.EditorPaneSelectionCompareResult=p={}));function h(ae){const _=ae;return!!_&&typeof _.getSelection=="function"&&!!_.onDidChangeSelection}e.$AE=h;function t(ae,_,ue){for(const O of ue.visibleEditorPanes)if(O.group.id===_&&ae.matches(O.input))return O.getViewState()}e.$BE=t;function i(ae){if($(ae))return!1;const _=ae;return I.URI.isUri(_?.resource)}e.$CE=i;function c(ae){if($(ae))return!1;const _=ae;return _?.original!==void 0&&_.modified!==void 0}e.$DE=c;function g(ae){if($(ae)||c(ae))return!1;const _=ae;return _?.primary!==void 0&&_.secondary!==void 0}e.$EE=g;function S(ae){if($(ae))return!1;const _=ae;return _?_.resource===void 0||_.resource.scheme===f.Schemas.untitled||_.forceUntitled===!0:!1}e.$FE=S;function C(ae){if($(ae))return!1;const _=ae;return I.URI.isUri(_?.base?.resource)&&I.URI.isUri(_?.input1?.resource)&&I.URI.isUri(_?.input2?.resource)&&I.URI.isUri(_?.result?.resource)}e.$GE=C;var n;(function(ae){ae[ae.SHORT=0]="SHORT",ae[ae.MEDIUM=1]="MEDIUM",ae[ae.LONG=2]="LONG"})(n||(e.Verbosity=n={}));var a;(function(ae){ae[ae.EXPLICIT=1]="EXPLICIT",ae[ae.AUTO=2]="AUTO",ae[ae.FOCUS_CHANGE=3]="FOCUS_CHANGE",ae[ae.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(a||(e.SaveReason=a={}));class r{constructor(){this.a=new Map}registerSource(_,ue){let O=this.a.get(_);return O||(O={source:_,label:ue},this.a.set(_,O)),O.source}getSourceLabel(_){return this.a.get(_)?.label??_}}e.$HE=new r;var s;(function(ae){ae[ae.None=0]="None",ae[ae.Readonly=2]="Readonly",ae[ae.Untitled=4]="Untitled",ae[ae.Singleton=8]="Singleton",ae[ae.RequiresTrust=16]="RequiresTrust",ae[ae.CanSplitInGroup=32]="CanSplitInGroup",ae[ae.ForceDescription=64]="ForceDescription",ae[ae.CanDropIntoEditor=128]="CanDropIntoEditor",ae[ae.MultipleEditors=256]="MultipleEditors",ae[ae.Scratchpad=512]="Scratchpad"})(s||(e.EditorInputCapabilities=s={}));class v extends M.$lb{}e.$IE=v;function $(ae){return ae instanceof v}e.$JE=$;function w(ae){const _=ae;return I.URI.isUri(_?.preferredResource)}function E(ae){const _=ae;return $(_?.primary)&&$(_?.secondary)}e.$KE=E;function o(ae){const _=ae;return $(_?.modified)&&$(_?.original)}e.$LE=o;function l(ae,_,ue,O,J){return Ce(O,[(0,D.$_h)({id:"workbench.action.openLargeFile",label:(0,y.localize)(2,null),run:()=>{const le={...ue,limits:{size:Number.MAX_VALUE}};ae.openEditor(_,le)}}),(0,D.$_h)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,y.localize)(3,null),run:()=>J.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:u.default.Warning})}e.$ME=l;function m(ae){return $(ae?.editor)}e.$NE=m;function F(ae){const _=ae;return m(ae)&&_?.group!==void 0}e.$OE=F;function W(ae){const _=ae;return typeof _?.groupId=="number"&&$(_.editor)}e.$PE=W;var V;(function(ae){ae[ae.UNKNOWN=0]="UNKNOWN",ae[ae.REPLACE=1]="REPLACE",ae[ae.MOVE=2]="MOVE",ae[ae.UNPIN=3]="UNPIN"})(V||(e.EditorCloseContext=V={}));var B;(function(ae){ae[ae.GROUP_ACTIVE=0]="GROUP_ACTIVE",ae[ae.GROUP_INDEX=1]="GROUP_INDEX",ae[ae.GROUP_LOCKED=2]="GROUP_LOCKED",ae[ae.EDITOR_OPEN=3]="EDITOR_OPEN",ae[ae.EDITOR_CLOSE=4]="EDITOR_CLOSE",ae[ae.EDITOR_MOVE=5]="EDITOR_MOVE",ae[ae.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",ae[ae.EDITOR_LABEL=7]="EDITOR_LABEL",ae[ae.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",ae[ae.EDITOR_PIN=9]="EDITOR_PIN",ae[ae.EDITOR_STICKY=10]="EDITOR_STICKY",ae[ae.EDITOR_DIRTY=11]="EDITOR_DIRTY",ae[ae.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(B||(e.GroupModelChangeKind=B={}));var j;(function(ae){ae[ae.PRIMARY=1]="PRIMARY",ae[ae.SECONDARY=2]="SECONDARY",ae[ae.BOTH=3]="BOTH",ae[ae.ANY=4]="ANY"})(j||(e.SideBySideEditor=j={}));class U{getOriginalUri(_,ue){if(!_)return;if(C(_))return e.$RE.getOriginalUri(_.result,ue);if(ue?.supportSideBySide){const{primary:J,secondary:le}=this.a(_);if(J&&le){if(ue?.supportSideBySide===j.BOTH)return{primary:this.getOriginalUri(J,{filterByScheme:ue.filterByScheme}),secondary:this.getOriginalUri(le,{filterByScheme:ue.filterByScheme})};if(ue?.supportSideBySide===j.ANY)return this.getOriginalUri(J,{filterByScheme:ue.filterByScheme})??this.getOriginalUri(le,{filterByScheme:ue.filterByScheme});_=ue.supportSideBySide===j.PRIMARY?J:le}}if(c(_)||g(_)||C(_))return;const O=w(_)?_.preferredResource:_.resource;return!O||!ue||!ue.filterByScheme?O:this.b(O,ue.filterByScheme)}a(_){return E(_)||g(_)?{primary:_.primary,secondary:_.secondary}:o(_)||c(_)?{primary:_.modified,secondary:_.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(_,ue){if(!_)return;if(C(_))return e.$RE.getCanonicalUri(_.result,ue);if(ue?.supportSideBySide){const{primary:J,secondary:le}=this.a(_);if(J&&le){if(ue?.supportSideBySide===j.BOTH)return{primary:this.getCanonicalUri(J,{filterByScheme:ue.filterByScheme}),secondary:this.getCanonicalUri(le,{filterByScheme:ue.filterByScheme})};if(ue?.supportSideBySide===j.ANY)return this.getCanonicalUri(J,{filterByScheme:ue.filterByScheme})??this.getCanonicalUri(le,{filterByScheme:ue.filterByScheme});_=ue.supportSideBySide===j.PRIMARY?J:le}}if(c(_)||g(_)||C(_))return;const O=_.resource;return!O||!ue||!ue.filterByScheme?O:this.b(O,ue.filterByScheme)}b(_,ue){if(Array.isArray(ue)){if(ue.some(O=>_.scheme===O))return _}else if(ue===_.scheme)return _}}var z;(function(ae){ae[ae.UNKNOWN=0]="UNKNOWN",ae[ae.KEYBOARD=1]="KEYBOARD",ae[ae.MOUSE=2]="MOUSE"})(z||(e.EditorCloseMethod=z={}));function ne(ae,_,ue,O){if(!ae.isSticky(_))return!1;switch(O.preventPinnedEditorClose){case"keyboardAndMouse":return ue===z.MOUSE||ue===z.KEYBOARD;case"mouse":return ue===z.MOUSE;case"keyboard":return ue===z.KEYBOARD}return!1}e.$QE=ne,e.$RE=new U;var Z;(function(ae){ae[ae.LEFT=0]="LEFT",ae[ae.RIGHT=1]="RIGHT"})(Z||(e.CloseDirection=Z={}));class we{constructor(){this.c=new Map,this.d=new Map}start(_){const ue=this.a=_.get(A.$oh);for(const[O,J]of this.c)this.e(O,J,ue);this.c.clear()}e(_,ue,O){const J=O.createInstance(ue);this.d.set(_,J)}registerFileEditorFactory(_){if(this.b)throw new Error("Can only register one file editor factory.");this.b=_}getFileEditorFactory(){return(0,R.$te)(this.b)}registerEditorSerializer(_,ue){if(this.c.has(_)||this.d.has(_))throw new Error(`A editor serializer with type ID '${_}' was already registered.`);return this.a?this.e(_,ue,this.a):this.c.set(_,ue),(0,M.$jb)(()=>{this.c.delete(_),this.d.delete(_)})}getEditorSerializer(_){return this.d.get(typeof _=="string"?_:_.typeId)}}d.$Um.add(e.$vE.EditorFactory,new we);async function Ee(ae,_,ue){return!ae||!ae.length?[]:await Promise.all(ae.map(async O=>{const J=I.URI.revive(O.fileUri);if(!J){ue.info("Cannot resolve the path because it is not valid.",O);return}if(!await _.canHandleResource(J)){ue.info("Cannot resolve the path because it cannot be handled",O);return}let ye=O.exists,ve=O.type;if(typeof ye!="boolean"||typeof ve!="number")try{ve=(await _.stat(J)).isDirectory?k.FileType.Directory:k.FileType.Unknown,ye=!0}catch(ke){ue.error(ke),ye=!1}if(!ye&&O.openOnlyIfExists){ue.info("Cannot resolve the path because it does not exist",O);return}if(ve===k.FileType.Directory){ue.info("Cannot resolve the path because it is a directory",O);return}const be={...O.options,pinned:!0};return ye?{resource:J,options:be}:{resource:J,options:be,forceUntitled:!0}}))}e.$SE=Ee;var Re;(function(ae){ae[ae.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ae[ae.SEQUENTIAL=1]="SEQUENTIAL"})(Re||(e.EditorsOrder=Re={}));function X(ae){const _=ae;if(!_)return!1;const ue=_;if(ue.modified)return X(ue.modified);const O=_;return!!(O.contributionsState&&O.viewState&&Array.isArray(O.cursorState))}e.$TE=X;function de(ae){return(0,P.$bi)(ae)}e.$UE=de;function Ce(ae,_,ue){const O=(0,P.$ci)(ae,_);return O.forceMessage=ue?.forceMessage,O.forceSeverity=ue?.forceSeverity,O.allowDialog=ue?.allowDialog,O}e.$VE=Ce}),define(Pe[193],Ae([1,0,5,161,4,6,28,30,18,100,24,89,184]),function(pe,e,y,R,I,M,A,d,k,f,P,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3E=e.$2E=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$1E=e.$ZE=e.ViewContentGroups=e.$YE=e.$XE=e.ViewContainerLocation=e.Extensions=e.$WE=void 0,e.$WE=(0,u.$Yu)("default-view-icon",D.$Cj.window,(0,R.localize)(0,null));var b;(function(r){r.ViewContainersRegistry="workbench.registry.view.containers",r.ViewsRegistry="workbench.registry.view"})(b||(e.Extensions=b={}));var p;(function(r){r[r.Sidebar=0]="Sidebar",r[r.Panel=1]="Panel",r[r.AuxiliaryBar=2]="AuxiliaryBar"})(p||(e.ViewContainerLocation=p={})),e.$XE=[0,1,2];function h(r){switch(r){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$YE=h;class t extends M.$lb{constructor(){super(...arguments),this.c=this.B(new y.$ec),this.onDidRegister=this.c.event,this.f=this.B(new y.$ec),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,k.$vf)([...this.g.values()])}registerViewContainer(s,v,$){const w=this.get(s.id);if(w)return w;const E=s;return E.openCommandActionDescriptor=$?.doNotRegisterOpenCommand?void 0:E.openCommandActionDescriptor??{id:E.id},(0,A.$ki)(this.g,v,[]).push(E),$?.isDefault&&this.h.push(E),this.c.fire({viewContainer:E,viewContainerLocation:v}),E}deregisterViewContainer(s){for(const v of this.g.keys()){const $=this.g.get(v),w=$?.indexOf(s);if(w!==-1){$?.splice(w,1),$.length===0&&this.g.delete(v),this.f.fire({viewContainer:s,viewContainerLocation:v});return}}}get(s){return this.all.filter(v=>v.id===s)[0]}getViewContainers(s){return[...this.g.get(s)||[]]}getViewContainerLocation(s){return[...this.g.keys()].filter(v=>this.getViewContainers(v).filter($=>$?.id===s.id).length>0)[0]}getDefaultViewContainer(s){return this.h.find(v=>this.getViewContainerLocation(v)===s)}}d.$Um.add(b.ViewContainersRegistry,new t);var i;(function(r){r.Open="2_open",r.Debug="4_debug",r.SCM="5_scm",r.More="9_more"})(i||(e.ViewContentGroups=i={}));function c(r,s){const v=r.group??i.More,$=s.group??i.More;return v!==$?v.localeCompare($):(r.order??5)-(s.order??5)}class g extends M.$lb{constructor(){super(...arguments),this.c=this.B(new y.$ec),this.onViewsRegistered=this.c.event,this.f=this.B(new y.$ec),this.onViewsDeregistered=this.f.event,this.g=this.B(new y.$ec),this.onDidChangeContainer=this.g.event,this.h=this.B(new y.$ec),this.onDidChangeViewWelcomeContent=this.h.event,this.i=[],this.j=new Map,this.k=new f.$L}registerViews(s,v){this.registerViews2([{views:s,viewContainer:v}])}registerViews2(s){s.forEach(({views:v,viewContainer:$})=>this.l(v,$)),this.c.fire(s)}deregisterViews(s,v){const $=this.m(s,v);$.length&&this.f.fire({views:$,viewContainer:v})}moveViews(s,v){for(const $ of this.j.keys())if($!==v){const w=this.m(s,$);w.length&&(this.l(w,v),this.g.fire({views:w,from:$,to:v}))}}getViews(s){return this.j.get(s)||[]}getView(s){for(const v of this.i){const $=(this.j.get(v)||[]).filter(w=>w.id===s)[0];if($)return $}return null}getViewContainer(s){for(const v of this.i)if((this.j.get(v)||[]).filter(w=>w.id===s)[0])return v;return null}registerViewWelcomeContent(s,v){return this.k.add(s,v),this.h.fire(s),(0,M.$jb)(()=>{this.k.delete(s,v),this.h.fire(s)})}registerViewWelcomeContent2(s,v){const $=new Map;for(const[w,E]of v)this.k.add(s,E),$.set(w,(0,M.$jb)(()=>{this.k.delete(s,E),this.h.fire(s)}));return this.h.fire(s),$}getViewWelcomeContent(s){const v=[];return this.k.forEach(s,$=>v.push($)),v.sort(c)}l(s,v){let $=this.j.get(v);$||($=[],this.j.set(v,$),this.i.push(v));for(const w of s){if(this.getView(w.id)!==null)throw new Error((0,R.localize)(1,null,w.id));$.push(w)}}m(s,v){const $=this.j.get(v);if(!$)return[];const w=[],E=[];for(const o of $)s.includes(o)?w.push(o):E.push(o);return w.length&&(E.length?this.j.set(v,E):(this.j.delete(v),this.i.splice(this.i.indexOf(v),1))),w}}d.$Um.add(b.ViewsRegistry,new g),e.$ZE=(0,I.$ph)("viewsService"),e.$1E=(0,I.$ph)("viewDescriptorService");var S;(function(r){r[r.Default=0]="Default",r[r.Expand=1]="Expand"})(S||(e.ViewVisibilityState=S={}));var C;(function(r){r[r.None=0]="None",r[r.Collapsed=1]="Collapsed",r[r.Expanded=2]="Expanded"})(C||(e.TreeItemCollapsibleState=C={}));class n{constructor(s,v){this.c=!1,this.d=!1,(0,P.$Lm)(this,s),this.d=!!v,this.resolve=async $=>{if(v&&!this.c){const w=await v($);w&&(this.tooltip=this.tooltip??w.tooltip,this.command=this.command??w.command)}$.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$2E=n;class a extends Error{constructor(s){super((0,R.localize)(2,null,s)),this.name="NoTreeViewError"}static is(s){return s.name==="NoTreeViewError"}}e.$3E=a}),define(Pe[194],Ae([1,0,5,13,162]),function(pe,e,y,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4bb=void 0;class M{constructor(){this.f=new Map,this.k=[],this.m=new y.$ec,this.n=new y.$ec,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(d){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=d}onEvent(d){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=d}onRequest(d){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=d}sendResponse(d){d.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${d.command}`)):this.s("response",d)}sendRequest(d,k,f,P){const D={command:d};if(k&&Object.keys(k).length>0&&(D.arguments=k),this.s("request",D),typeof P=="number"){const u=setTimeout(()=>{clearTimeout(u);const b=this.f.get(D.seq);if(b){this.f.delete(D.seq);const p={type:"response",seq:0,request_seq:D.seq,success:!1,command:d,message:(0,I.localize)(0,null,P,d)};b(p)}},P)}return f&&this.f.set(D.seq,f),D.seq}acceptMessage(d){this.j?this.j(d):(this.k.push(d),this.k.length===1&&this.q())}o(d,k){return d.type!=="event"||k.type!=="event"}async q(){let d;for(;this.k.length;){if((!d||this.o(this.k[0],d))&&await(0,R.$vg)(0),d=this.k.shift(),!d)return;switch(d.type){case"event":this.i?.(d);break;case"request":this.g?.(d);break;case"response":{const k=d,f=this.f.get(k.request_seq);f&&(this.f.delete(k.request_seq),f(k));break}}}}s(d,k){k.type=d,k.seq=this.d++,this.sendMessage(k)}async u(){if(this.f.size===0)return Promise.resolve();const d=new Map;this.f.forEach((k,f)=>d.set(f,k)),await(0,R.$vg)(500),d.forEach((k,f)=>{k({type:"response",seq:0,request_seq:f,success:!1,command:"canceled",message:"canceled"}),this.f.delete(f)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$4bb=M}),define(Pe[195],Ae([1,0,163,32,4]),function(pe,e,y,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$bH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$aH=e.MemoryRangeType=e.$_G=e.State=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=e.$0F=void 0,e.$0F="workbench.view.debug",e.$$F="workbench.debug.variablesView",e.$_F="workbench.debug.watchExpressionsView",e.$aG="workbench.debug.callStackView",e.$bG="workbench.debug.loadedScriptsView",e.$cG="workbench.debug.breakPointsView",e.$dG="workbench.debug.disassemblyView",e.$eG="workbench.panel.repl",e.$fG="workbench.panel.repl.view",e.$gG=new R.$Oi("debugType",void 0,{type:"string",description:y.localize(0,null)}),e.$hG=new R.$Oi("debugConfigurationType",void 0,{type:"string",description:y.localize(1,null)}),e.$iG=new R.$Oi("debugState","inactive",{type:"string",description:y.localize(2,null)}),e.$jG="debugUx",e.$kG=new R.$Oi(e.$jG,"default",{type:"string",description:y.localize(3,null)}),e.$lG=new R.$Oi("hasDebugged",!1,{type:"boolean",description:y.localize(4,null)}),e.$mG=new R.$Oi("inDebugMode",!1,{type:"boolean",description:y.localize(5,null)}),e.$nG=new R.$Oi("inDebugRepl",!1,{type:"boolean",description:y.localize(6,null)}),e.$oG=new R.$Oi("breakpointWidgetVisible",!1,{type:"boolean",description:y.localize(7,null)}),e.$pG=new R.$Oi("inBreakpointWidget",!1,{type:"boolean",description:y.localize(8,null)}),e.$qG=new R.$Oi("breakpointsFocused",!0,{type:"boolean",description:y.localize(9,null)}),e.$rG=new R.$Oi("watchExpressionsFocused",!0,{type:"boolean",description:y.localize(10,null)}),e.$sG=new R.$Oi("watchExpressionsExist",!1,{type:"boolean",description:y.localize(11,null)}),e.$tG=new R.$Oi("variablesFocused",!0,{type:"boolean",description:y.localize(12,null)}),e.$uG=new R.$Oi("expressionSelected",!1,{type:"boolean",description:y.localize(13,null)}),e.$vG=new R.$Oi("breakpointInputFocused",!1,{type:"boolean",description:y.localize(14,null)}),e.$wG=new R.$Oi("callStackItemType",void 0,{type:"string",description:y.localize(15,null)}),e.$xG=new R.$Oi("callStackSessionIsAttach",!1,{type:"boolean",description:y.localize(16,null)}),e.$yG=new R.$Oi("callStackItemStopped",!1,{type:"boolean",description:y.localize(17,null)}),e.$zG=new R.$Oi("callStackSessionHasOneThread",!1,{type:"boolean",description:y.localize(18,null)}),e.$AG=new R.$Oi("watchItemType",void 0,{type:"string",description:y.localize(19,null)}),e.$BG=new R.$Oi("canViewMemory",void 0,{type:"boolean",description:y.localize(20,null)}),e.$CG=new R.$Oi("breakpointItemType",void 0,{type:"string",description:y.localize(21,null)}),e.$DG=new R.$Oi("breakpointSupportsCondition",!1,{type:"boolean",description:y.localize(22,null)}),e.$EG=new R.$Oi("loadedScriptsSupported",!1,{type:"boolean",description:y.localize(23,null)}),e.$FG=new R.$Oi("loadedScriptsItemType",void 0,{type:"string",description:y.localize(24,null)}),e.$GG=new R.$Oi("focusedSessionIsAttach",!1,{type:"boolean",description:y.localize(25,null)}),e.$HG=new R.$Oi("stepBackSupported",!1,{type:"boolean",description:y.localize(26,null)}),e.$IG=new R.$Oi("restartFrameSupported",!1,{type:"boolean",description:y.localize(27,null)}),e.$JG=new R.$Oi("stackFrameSupportsRestart",!1,{type:"boolean",description:y.localize(28,null)}),e.$KG=new R.$Oi("jumpToCursorSupported",!1,{type:"boolean",description:y.localize(29,null)}),e.$LG=new R.$Oi("stepIntoTargetsSupported",!1,{type:"boolean",description:y.localize(30,null)}),e.$MG=new R.$Oi("breakpointsExist",!1,{type:"boolean",description:y.localize(31,null)}),e.$NG=new R.$Oi("debuggersAvailable",!1,{type:"boolean",description:y.localize(32,null)}),e.$OG=new R.$Oi("debugExtensionAvailable",!0,{type:"boolean",description:y.localize(33,null)}),e.$PG=new R.$Oi("debugProtocolVariableMenuContext",void 0,{type:"string",description:y.localize(34,null)}),e.$QG=new R.$Oi("debugSetVariableSupported",!1,{type:"boolean",description:y.localize(35,null)}),e.$RG=new R.$Oi("debugSetExpressionSupported",!1,{type:"boolean",description:y.localize(36,null)}),e.$SG=new R.$Oi("breakWhenValueChangesSupported",!1,{type:"boolean",description:y.localize(37,null)}),e.$TG=new R.$Oi("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:y.localize(38,null)}),e.$UG=new R.$Oi("breakWhenValueIsReadSupported",!1,{type:"boolean",description:y.localize(39,null)}),e.$VG=new R.$Oi("terminateDebuggeeSupported",!1,{type:"boolean",description:y.localize(40,null)}),e.$WG=new R.$Oi("suspendDebuggeeSupported",!1,{type:"boolean",description:y.localize(41,null)}),e.$XG=new R.$Oi("variableEvaluateNamePresent",!1,{type:"boolean",description:y.localize(42,null)}),e.$YG=new R.$Oi("variableIsReadonly",!1,{type:"boolean",description:y.localize(43,null)}),e.$ZG=new R.$Oi("exceptionWidgetVisible",!1,{type:"boolean",description:y.localize(44,null)}),e.$1G=new R.$Oi("multiSessionRepl",!1,{type:"boolean",description:y.localize(45,null)}),e.$2G=new R.$Oi("multiSessionDebug",!1,{type:"boolean",description:y.localize(46,null)}),e.$3G=new R.$Oi("disassembleRequestSupported",!1,{type:"boolean",description:y.localize(47,null)}),e.$4G=new R.$Oi("disassemblyViewFocus",!1,{type:"boolean",description:y.localize(48,null)}),e.$5G=new R.$Oi("languageSupportsDisassembleRequest",!1,{type:"boolean",description:y.localize(49,null)}),e.$6G=new R.$Oi("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:y.localize(50,null)});const M=u=>y.localize(51,null,u);e.$7G=M,e.$8G="editor.contrib.debug",e.$9G="editor.contrib.breakpoint",e.$0G="debug",e.$$G={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:y.localize(52,null)};var A;(function(u){u[u.Inactive=0]="Inactive",u[u.Initializing=1]="Initializing",u[u.Stopped=2]="Stopped",u[u.Running=3]="Running"})(A||(e.State=A={}));function d(u){switch(u){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$_G=d;var k;(function(u){u[u.Valid=0]="Valid",u[u.Unreadable=1]="Unreadable",u[u.Error=2]="Error"})(k||(e.MemoryRangeType=k={})),e.$aH="vscode-debug-memory";var f;(function(u){u[u.Initial=1]="Initial",u[u.Dynamic=2]="Dynamic"})(f||(e.DebugConfigurationProviderTriggerKind=f={}));var P;(function(u){u.UnverifiedBreakpoints="unverifiedBreakpoints"})(P||(e.DebuggerString=P={})),e.$bH=(0,I.$ph)("debugService");var D;(function(u){u[u.CONDITION=0]="CONDITION",u[u.HIT_COUNT=1]="HIT_COUNT",u[u.LOG_MESSAGE=2]="LOG_MESSAGE"})(D||(e.BreakpointWidgetContext=D={}))}),define(Pe[196],Ae([1,0,15,2,19,24,12,44,21,18]),function(pe,e,y,R,I,M,A,d,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iF=e.$hF=e.$gF=e.$fF=e.$eF=e.$dF=e.$cF=e.$bF=e.$aF=e.$_E=e.$$E=e.$0E=void 0;const P=/{([^}]+)}/g;function D(w,E,o){return w.replace(P,function(l,m){return E&&m.length>0&&m[0]!=="_"?l:o&&o.hasOwnProperty(m)?o[m]:l})}e.$0E=D;function u(w){const E={};for(const o of Object.keys(w))o.startsWith("!")||(E[o]=w[o]);return E}e.$$E=u;function b(w){return w.configuration.request==="attach"&&!p(w)&&(!w.parentSession||b(w.parentSession))}e.$_E=b;function p(w){let E=w.configuration.type;if(E)return E==="vslsShare"&&(E=w.configuration.adapterProxy.configuration.type),(0,y.$Ld)(E,"extensionhost")||(0,y.$Ld)(E,"pwa-extensionhost")?w:w.parentSession?p(w.parentSession):void 0}e.$aF=p;function h(w){return w.type&&(w.label||w.program||w.runtime)}e.$bF=h;function t(w,E,o){let l,m=0;const F=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let W=null;for(;W=F.exec(w);){const V=W.index+1,B=V+W[0].length;if(V<=E&&B>=o){l=W[0],m=V;break}}if(l){const V=/\w+/g;let B=null;for(;(B=V.exec(l))&&!(B.index+1+m+B[0].length>=o););B&&(l=l.substring(0,V.lastIndex))}return l?{start:m,end:m+l.length-1}:{start:0,end:0}}e.$cF=t;async function i(w,E,o,l){if(w.evaluatableExpressionProvider.has(E)){const m=w.evaluatableExpressionProvider.ordered(E),F=(0,f.$jf)(await Promise.all(m.map(async W=>{try{return await W.provideEvaluatableExpression(E,o,l??k.CancellationToken.None)}catch{return}})));if(F.length>0){let W=F[0].expression;const V=F[0].range;return W||(W=E.getLineContent(o.lineNumber).substring(V.startColumn-1,V.endColumn-1)),{range:V,matchingExpression:W}}}else{const m=E.getLineContent(o.lineNumber),{start:F,end:W}=t(m,o.column,o.column),V=m.substring(F-1,W);return{matchingExpression:V,range:new d.$Ur(o.lineNumber,F,o.lineNumber,F+V.length)}}return null}e.$dF=i;const c=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function g(w){return!!(w&&w.match(c))}e.$eF=g;function S(w){if(typeof w.path=="string"&&!(typeof w.sourceReference=="number"&&w.sourceReference>0)){if(g(w.path))return R.URI.parse(w.path);if((0,I.$7c)(w.path))return R.URI.file(w.path)}return w.path}function C(w){if(typeof w.path=="object"){const E=R.URI.revive(w.path);if(E)return E.scheme===A.Schemas.file?E.fsPath:E.toString()}return w.path}function n(w,E){const o=E?S:C,l=(0,M.$Im)(w);return r(l,(m,F)=>{m&&F&&(F.path=o(F))}),l}e.$fF=n;function a(w,E){const o=E?S:C,l=(0,M.$Im)(w);return r(l,(m,F)=>{!m&&F&&(F.path=o(F))}),l}e.$gF=a;function r(w,E){switch(w.type){case"event":{const o=w;switch(o.event){case"output":E(!1,o.body.source);break;case"loadedSource":E(!1,o.body.source);break;case"breakpoint":E(!1,o.body.breakpoint.source);break;default:break}break}case"request":{const o=w;switch(o.command){case"setBreakpoints":E(!0,o.arguments.source);break;case"breakpointLocations":E(!0,o.arguments.source);break;case"source":E(!0,o.arguments.source);break;case"gotoTargets":E(!0,o.arguments.source);break;case"launchVSCode":o.arguments.args.forEach(l=>E(!1,l));break;default:break}break}case"response":{const o=w;if(o.success&&o.body)switch(o.command){case"stackTrace":o.body.stackFrames.forEach(l=>E(!1,l.source));break;case"loadedSources":o.body.sources.forEach(l=>E(!1,l));break;case"scopes":o.body.scopes.forEach(l=>E(!1,l.source));break;case"setFunctionBreakpoints":o.body.breakpoints.forEach(l=>E(!1,l.source));break;case"setBreakpoints":o.body.breakpoints.forEach(l=>E(!1,l.source));break;case"disassemble":o.body?.instructions.forEach(m=>E(!1,m.location));break;default:break}break}}}function s(w){return w.filter(E=>!E.presentation?.hidden).sort((E,o)=>E.presentation?o.presentation?E.presentation.group?o.presentation.group?E.presentation.group!==o.presentation.group?E.presentation.group.localeCompare(o.presentation.group):v(E.presentation.order,o.presentation.order):-1:o.presentation.group?1:v(E.presentation.order,o.presentation.order):-1:o.presentation?1:0)}e.$hF=s;function v(w,E){return typeof w!="number"?typeof E!="number"?0:1:typeof E!="number"?-1:w-E}async function $(w,E){const o=w.getValue("debug.saveBeforeStart",{overrideIdentifier:E.activeTextEditorLanguageId});if(o!=="none"&&(await E.saveAll(),o==="allEditorsInActiveGroup")){const l=E.activeEditorPane;l&&l.input.resource?.scheme===A.Schemas.untitled&&await E.save({editor:l.input,groupId:l.group.id})}await w.reloadConfiguration()}e.$iF=$}),define(Pe[75],Ae([1,0,25,37,67,68,12,19,22,32]),function(pe,e,y,R,I,M,A,d,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TH=e.$SH=e.$RH=e.$QH=e.CellStatusbarAlignment=e.$PH=e.$OH=e.$NH=e.NotebookEditorPriority=e.$MH=e.$LH=e.$KH=e.$JH=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$IH=e.$HH=e.$GH=e.$FH=e.CellKind=e.$EH=e.$DH=e.$CH=void 0,e.$CH="workbench.editor.notebook",e.$DH="workbench.editor.notebookTextDiffEditor",e.$EH="workbench.editor.interactive";var P;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(P||(e.CellKind=P={})),e.$FH=["application/json","application/javascript","text/html","image/svg+xml",M.$yr.latex,M.$yr.markdown,"image/png","image/jpeg",M.$yr.text],e.$GH=[M.$yr.latex,M.$yr.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",M.$yr.text],e.$HH=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$IH="_notAvailable";var D;(function(z){z[z.Running=1]="Running",z[z.Idle=2]="Idle"})(D||(e.NotebookRunState=D={}));var u;(function(z){z[z.Unconfirmed=1]="Unconfirmed",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(u||(e.NotebookCellExecutionState=u={}));var b;(function(z){z[z.Unconfirmed=1]="Unconfirmed",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(b||(e.NotebookExecutionState=b={}));var p;(function(z){z[z.WithHardKernelDependency=0]="WithHardKernelDependency",z[z.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",z[z.Pure=2]="Pure",z[z.Never=3]="Never"})(p||(e.NotebookRendererMatch=p={}));var h;(function(z){z.Always="always",z.Never="never",z.Optional="optional"})(h||(e.RendererMessagingSpec=h={}));var t;(function(z){z[z.ModelChange=1]="ModelChange",z[z.Move=2]="Move",z[z.ChangeCellLanguage=5]="ChangeCellLanguage",z[z.Initialize=6]="Initialize",z[z.ChangeCellMetadata=7]="ChangeCellMetadata",z[z.Output=8]="Output",z[z.OutputItem=9]="OutputItem",z[z.ChangeCellContent=10]="ChangeCellContent",z[z.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",z[z.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",z[z.ChangeCellMime=13]="ChangeCellMime",z[z.Unknown=100]="Unknown"})(t||(e.NotebookCellsChangeType=t={}));var i;(function(z){z[z.Handle=0]="Handle",z[z.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var c;(function(z){z[z.Replace=1]="Replace",z[z.Output=2]="Output",z[z.Metadata=3]="Metadata",z[z.CellLanguage=4]="CellLanguage",z[z.DocumentMetadata=5]="DocumentMetadata",z[z.Move=6]="Move",z[z.OutputItems=7]="OutputItems",z[z.PartialMetadata=8]="PartialMetadata",z[z.PartialInternalMetadata=9]="PartialInternalMetadata"})(c||(e.CellEditType=c={}));var g;(function(z){z.scheme=A.Schemas.vscodeNotebookCell;const ne=["W","X","Y","Z","a","b","c","d","e","f"],Z=new RegExp(`^[${ne.join("")}]+`),we=7;function Ee(_,ue){const O=ue.toString(we),le=`${O.length<ne.length?ne[O.length-1]:"z"}${O}s${(0,y.$Yc)(y.$Ec.fromString(_.scheme),!0,!0)}`;return _.with({scheme:z.scheme,fragment:le})}z.generate=Ee;function Re(_){if(_.scheme!==z.scheme)return;const ue=_.fragment.indexOf("s");if(ue<0)return;const O=parseInt(_.fragment.substring(0,ue).replace(Z,""),we),J=(0,y.$Xc)(_.fragment.substring(ue+1)).toString();if(!isNaN(O))return{handle:O,notebook:_.with({scheme:J,fragment:null})}}z.parse=Re;function X(_,ue){return _.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${ue??""},${_.scheme!==A.Schemas.file?_.scheme:""}`})}z.generateCellOutputUri=X;function de(_){if(_.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const ue=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(_.fragment);if(!ue)return;const O=ue[1]&&ue[1]!==""?ue[1]:void 0,J=ue[2];return{outputId:O,notebook:_.with({scheme:J||A.Schemas.file,fragment:null})}}z.parseCellOutputUri=de;function Ce(_,ue,O){return z.generate(_,ue).with({scheme:O})}z.generateCellPropertyUri=Ce;function ae(_,ue){if(_.scheme===ue)return z.parse(_.with({scheme:z.scheme}))}z.parseCellPropertyUri=ae})(g||(e.CellUri=g={}));const S=z=>k.$i?z.replace(/\//g,"\\"):z;class C{constructor(ne=[],Z=e.$FH){this.e=Z,this.d=[...new Set(ne)].map(we=>({pattern:we,matches:R.$ej(S(we))}))}sort(ne){const Z=new Map(I.Iterable.map(ne,Ee=>[Ee,S(Ee)]));let we=[];for(const{matches:Ee}of this.d)for(const[Re,X]of Z)if(Ee(X)){we.push(Re),Z.delete(Re);break}return Z.size&&(we=we.concat([...Z.keys()].sort((Ee,Re)=>this.e.indexOf(Ee)-this.e.indexOf(Re)))),we}prioritize(ne,Z){const we=this.f(ne);if(we===-1){this.d.unshift({pattern:ne,matches:R.$ej(S(ne))});return}const Ee=new Set(Z.map(X=>this.f(X,we)));Ee.delete(-1);const Re=Array.from(Ee).sort();this.d.splice(we+1,0,...Re.map(X=>this.d[X]));for(let X=Re.length-1;X>=0;X--)this.d.splice(Re[X],1)}toArray(){return this.d.map(ne=>ne.pattern)}f(ne,Z=this.d.length){const we=S(ne);for(let Ee=0;Ee<Z;Ee++)if(this.d[Ee].matches(we))return Ee;return-1}}e.$JH=C;function n(z,ne,Z,we=(Ee,Re)=>Ee===Re){const Ee=[];function Re(Ce,ae,_){if(ae===0&&_.length===0)return;const ue=Ee[Ee.length-1];ue&&ue.start+ue.deleteCount===Ce?(ue.deleteCount+=ae,ue.toInsert.push(..._)):Ee.push({start:Ce,deleteCount:ae,toInsert:_})}let X=0,de=0;for(;;){if(X===z.length){Re(X,0,ne.slice(de));break}if(de===ne.length){Re(X,z.length-X,[]);break}const Ce=z[X],ae=ne[de];if(we(Ce,ae)){X+=1,de+=1;continue}Z(ae)?(Re(X,1,[]),X+=1):(Re(X,0,[ae]),de+=1)}return Ee}e.$KH=n,e.$LH=new f.$Oi("notebookEditorCursorAtBoundary","none"),e.$MH=new f.$Oi("notebookEditorCursorAtLineBoundary","none");var a;(function(z){z.default="default",z.option="option"})(a||(e.NotebookEditorPriority=a={}));function r(z){const ne=z;return!!((typeof ne.include=="string"||R.$fj(ne.include))&&(typeof ne.exclude=="string"||R.$fj(ne.exclude)))}e.$NH=r;function s(z,ne,Z){if(Array.isArray(z.viewType)&&z.viewType.indexOf(ne)>=0||z.viewType===ne)return!0;if(z.filenamePattern){const we=r(z.filenamePattern)?z.filenamePattern.include:z.filenamePattern,Ee=r(z.filenamePattern)?z.filenamePattern.exclude:void 0;if(R.$dj(we,(0,d.$_c)(Z.fsPath).toLowerCase()))return!(Ee&&R.$dj(Ee,(0,d.$_c)(Z.fsPath).toLowerCase()))}return!1}e.$OH=s,e.$PH={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave"};var v;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(v||(e.CellStatusbarAlignment=v={}));class ${static{this.d="notebook/"}static create(ne){return`${$.d}${ne}`}static parse(ne){if(ne.startsWith($.d))return ne.substring($.d.length)}}e.$QH=$;function w(z){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(z)}e.$RH=w;const E=new TextDecoder;function o(z){const ne=[];let Z=!1;for(const X of z)(ne.length===0||Z)&&(ne.push(X),Z=!0);let we=F(ne);const Ee=y.$Ec.concat(ne.map(X=>y.$Ec.wrap(X))),Re=U(Ee);return we=we||Re.byteLength!==Ee.byteLength,{data:Re,didCompression:we}}e.$SH=o,e.$TH=`${String.fromCharCode(27)}[A`;const l=e.$TH.split("").map(z=>z.charCodeAt(0)),m=10;function F(z){let ne=!1;return z.forEach((Z,we)=>{if(we===0||Z.length<e.$TH.length)return;const Ee=z[we-1],Re=Z.subarray(0,e.$TH.length);if(Re[0]===l[0]&&Re[1]===l[1]&&Re[2]===l[2]){const X=Ee.lastIndexOf(m);if(X===-1)return;ne=!0,z[we-1]=Ee.subarray(0,X),z[we]=Z.subarray(e.$TH.length)}}),ne}function W(z){let ne=z;do z=ne,ne=z.replace(/[^\n]\x08/gm,"");while(ne.length<z.length);return z}function V(z){for(z=z.replace(/\r+\n/gm,`
`);z.search(/\r[^$]/g)>-1;){const ne=z.match(/^(.*)\r+/m)[1];let Z=z.match(/\r+(.*)$/m)[1];Z=Z+ne.slice(Z.length,ne.length),z=z.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,Z)}return z}const B="\b".charCodeAt(0),j="\r".charCodeAt(0);function U(z){return!z.buffer.includes(B)&&!z.buffer.includes(j)?z:y.$Ec.fromString(V(W(E.decode(z.buffer))))}}),define(Pe[7],Ae([1,0,18,9,49,28,68,15,16,2,36,20,38,97,75]),function(pe,e,y,R,I,M,A,d,k,f,P,D,u,b,p){"use strict";var h,t,i,c,g,S,C,n,a,r,s,v,$,w,E,o,l,m;Object.defineProperty(e,"__esModule",{value:!0}),e.RelatedInformationType=e.$AL=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$zL=e.$yL=e.$xL=e.$wL=e.$vL=e.$uL=e.$tL=e.$sL=e.$rL=e.$qL=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$pL=e.$oL=e.$nL=e.$mL=e.$lL=e.$kL=e.$jL=e.$iL=e.TestRunProfileKind=e.TestResultState=e.$hL=e.$gL=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$fL=e.$eL=e.$dL=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$cL=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$bL=e.$aL=e.$_K=e.$$K=e.$0K=e.ColorThemeKind=e.$9K=e.$8K=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$7K=e.DebugConsoleMode=e.$6K=e.$5K=e.$4K=e.$3K=e.$2K=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$1K=e.$ZK=e.FileChangeType=e.$YK=e.$XK=e.$WK=e.$VK=e.InlineCompletionTriggerKind=e.$UK=e.$TK=e.$SK=e.$RK=e.$QK=e.$PK=e.$OK=e.$NK=e.$MK=e.$LK=e.$KK=e.$JK=e.$IK=e.ConfigurationTarget=e.$HK=e.$GK=e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=e.$AK=e.$zK=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$yK=e.ViewBadge=e.ProgressLocation=e.$xK=e.$wK=e.TaskScope=e.ShellQuoting=e.$vK=e.$uK=e.$tK=e.TaskPanelKind=e.TaskRevealKind=e.$sK=e.TerminalLocation=e.$rK=e.$qK=e.$pK=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$oK=e.$nK=e.$mK=e.$lK=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$kK=e.StatusBarAlignment=e.ViewColumn=e.$jK=e.$iK=e.$hK=e.$gK=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$fK=e.$eK=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$dK=e.$cK=e.$bK=e.$aK=e.$_J=e.LanguageStatusSeverity=e.$$J=e.$0J=e.$9J=e.$8J=e.$7J=e.$6J=e.$5J=e.CodeActionTriggerKind=e.$4J=e.$3J=e.SymbolTag=e.SymbolKind=e.$2J=e.DocumentHighlightKind=e.$1J=e.$ZJ=e.$YJ=e.$XJ=e.DiagnosticSeverity=e.DiagnosticTag=e.$WJ=e.$VJ=e.FileEditType=e.$UJ=e.$TJ=e.$SJ=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$RJ=e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function F(N){return Object.assign(N,{apply:function(){const se=arguments.length===1?[]:arguments[1];return Reflect.construct(N,se,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(N,[]);{const[se,...De]=arguments;return Reflect.construct(N,De,se.constructor)}}})}var W;(function(N){N[N.Top=0]="Top",N[N.Bottom=1]="Bottom"})(W||(e.TerminalOutputAnchor=W={}));var V;(function(N){N[N.TerminalCommand=0]="TerminalCommand",N[N.Opener=1]="Opener",N[N.Command=3]="Command"})(V||(e.TerminalQuickFixType=V={}));let B=h=class{static from(...T){let se=T;return new h(function(){if(se){for(const De of se)De&&typeof De.dispose=="function"&&De.dispose();se=void 0}})}#e;constructor(T){this.#e=T}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$LJ=B,e.$LJ=B=h=Ke([F],B);let j=t=class{static Min(...T){if(T.length===0)throw new TypeError;let se=T[0];for(let De=1;De<T.length;De++){const Je=T[De];Je.isBefore(se)&&(se=Je)}return se}static Max(...T){if(T.length===0)throw new TypeError;let se=T[0];for(let De=1;De<T.length;De++){const Je=T[De];Je.isAfter(se)&&(se=Je)}return se}static isPosition(T){if(!T)return!1;if(T instanceof t)return!0;const{line:se,character:De}=T;return typeof se=="number"&&typeof De=="number"}static of(T){if(T instanceof t)return T;if(this.isPosition(T))return new t(T.line,T.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(T,se){if(T<0)throw(0,R.$5)("line must be non-negative");if(se<0)throw(0,R.$5)("character must be non-negative");this.c=T,this.e=se}isBefore(T){return this.c<T.c?!0:T.c<this.c?!1:this.e<T.e}isBeforeOrEqual(T){return this.c<T.c?!0:T.c<this.c?!1:this.e<=T.e}isAfter(T){return!this.isBeforeOrEqual(T)}isAfterOrEqual(T){return!this.isBefore(T)}isEqual(T){return this.c===T.c&&this.e===T.e}compareTo(T){return this.c<T.c?-1:this.c>T.line?1:this.e<T.e?-1:this.e>T.e?1:0}translate(T,se=0){if(T===null||se===null)throw(0,R.$5)();let De;return typeof T>"u"?De=0:typeof T=="number"?De=T:(De=typeof T.lineDelta=="number"?T.lineDelta:0,se=typeof T.characterDelta=="number"?T.characterDelta:0),De===0&&se===0?this:new t(this.line+De,this.character+se)}with(T,se=this.character){if(T===null||se===null)throw(0,R.$5)();let De;return typeof T>"u"?De=this.line:typeof T=="number"?De=T:(De=typeof T.line=="number"?T.line:this.line,se=typeof T.character=="number"?T.character:this.character),De===this.line&&se===this.character?this:new t(De,se)}toJSON(){return{line:this.line,character:this.character}}};e.$MJ=j,e.$MJ=j=t=Ke([F],j);let U=i=class{static isRange(T){return T instanceof i?!0:T?j.isPosition(T.start)&&j.isPosition(T.end):!1}static of(T){if(T instanceof i)return T;if(this.isRange(T))return new i(T.start,T.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(T,se,De,Je){let Ze,ot;if(typeof T=="number"&&typeof se=="number"&&typeof De=="number"&&typeof Je=="number"?(Ze=new j(T,se),ot=new j(De,Je)):j.isPosition(T)&&j.isPosition(se)&&(Ze=j.of(T),ot=j.of(se)),!Ze||!ot)throw new Error("Invalid arguments");Ze.isBefore(ot)?(this.c=Ze,this.e=ot):(this.c=ot,this.e=Ze)}contains(T){return i.isRange(T)?this.contains(T.start)&&this.contains(T.end):j.isPosition(T)?!(j.of(T).isBefore(this.c)||this.e.isBefore(T)):!1}isEqual(T){return this.c.isEqual(T.c)&&this.e.isEqual(T.e)}intersection(T){const se=j.Max(T.start,this.c),De=j.Min(T.end,this.e);if(!se.isAfter(De))return new i(se,De)}union(T){if(this.contains(T))return this;if(T.contains(this))return T;const se=j.Min(T.start,this.c),De=j.Max(T.end,this.end);return new i(se,De)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(T,se=this.end){if(T===null||se===null)throw(0,R.$5)();let De;return T?j.isPosition(T)?De=T:(De=T.start||this.start,se=T.end||this.end):De=this.start,De.isEqual(this.c)&&se.isEqual(this.end)?this:new i(De,se)}toJSON(){return[this.start,this.end]}};e.$NJ=U,e.$NJ=U=i=Ke([F],U);let z=c=class extends U{static isSelection(T){return T instanceof c?!0:T?U.isRange(T)&&j.isPosition(T.anchor)&&j.isPosition(T.active)&&typeof T.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(T,se,De,Je){let Ze,ot;if(typeof T=="number"&&typeof se=="number"&&typeof De=="number"&&typeof Je=="number"?(Ze=new j(T,se),ot=new j(De,Je)):j.isPosition(T)&&j.isPosition(se)&&(Ze=j.of(T),ot=j.of(se)),!Ze||!ot)throw new Error("Invalid arguments");super(Ze,ot),this.f=Ze,this.g=ot}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$OJ=z,e.$OJ=z=c=Ke([F],z);const ne=N=>{if(typeof N!="string"||N.length===0||!/^[0-9A-Za-z_\-]+$/.test(N))throw(0,R.$5)("connectionToken")};class Z{static isResolvedAuthority(T){return T&&typeof T=="object"&&typeof T.host=="string"&&typeof T.port=="number"&&(T.connectionToken===void 0||typeof T.connectionToken=="string")}constructor(T,se,De){if(typeof T!="string"||T.length===0)throw(0,R.$5)("host");if(typeof se!="number"||se===0||Math.round(se)!==se)throw(0,R.$5)("port");typeof De<"u"&&ne(De),this.host=T,this.port=Math.round(se),this.connectionToken=De}}e.$PJ=Z;class we{static isManagedResolvedAuthority(T){return T&&typeof T=="object"&&typeof T.makeConnection=="function"&&(T.connectionToken===void 0||typeof T.connectionToken=="string")}constructor(T,se){this.makeConnection=T,this.connectionToken=se,typeof se<"u"&&ne(se)}}e.$QJ=we;class Ee extends Error{static NotAvailable(T,se){return new Ee(T,b.RemoteAuthorityResolverErrorCode.NotAvailable,se)}static TemporarilyNotAvailable(T){return new Ee(T,b.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(T,se=b.RemoteAuthorityResolverErrorCode.Unknown,De){super(T),this._message=T,this._code=se,this._detail=De,Object.setPrototypeOf(this,Ee.prototype)}}e.$RJ=Ee;var Re;(function(N){N[N.LF=1]="LF",N[N.CRLF=2]="CRLF"})(Re||(e.EndOfLine=Re={}));var X;(function(N){N[N.Replace=1]="Replace",N[N.Append=2]="Append",N[N.Prepend=3]="Prepend"})(X||(e.EnvironmentVariableMutatorType=X={}));let de=g=class{static isTextEdit(T){return T instanceof g?!0:T?U.isRange(T)&&typeof T.newText=="string":!1}static replace(T,se){return new g(T,se)}static insert(T,se){return g.replace(new U(T,T),se)}static delete(T){return g.replace(T,"")}static setEndOfLine(T){const se=new g(new U(new j(0,0),new j(0,0)),"");return se.newEol=T,se}get range(){return this.c}set range(T){if(T&&!U.isRange(T))throw(0,R.$5)("range");this.c=T}get newText(){return this.e||""}set newText(T){if(T&&typeof T!="string")throw(0,R.$5)("newText");this.e=T}get newEol(){return this.f}set newEol(T){if(T&&typeof T!="number")throw(0,R.$5)("newEol");this.f=T}constructor(T,se){this.c=T,this.e=se}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$SJ=de,e.$SJ=de=g=Ke([F],de);let Ce=S=class{static isNotebookCellEdit(T){return T instanceof S?!0:T?Xt.isNotebookRange(T)&&Array.isArray(T.newCells):!1}static replaceCells(T,se){return new S(T,se)}static insertCells(T,se){return new S(new Xt(T,T),se)}static deleteCells(T){return new S(T,[])}static updateCellMetadata(T,se){const De=new S(new Xt(T,T),[]);return De.newCellMetadata=se,De}static updateNotebookMetadata(T){const se=new S(new Xt(0,0),[]);return se.newNotebookMetadata=T,se}constructor(T,se){this.range=T,this.newCells=se}};e.$TJ=Ce,e.$TJ=Ce=S=Ke([F],Ce);class ae{static isSnippetTextEdit(T){return T instanceof ae?!0:T?U.isRange(T.range)&&O.isSnippetString(T.snippet):!1}static replace(T,se){return new ae(T,se)}static insert(T,se){return ae.replace(new U(T,T),se)}constructor(T,se){this.range=T,this.snippet=se}}e.$UJ=ae;var _;(function(N){N[N.File=1]="File",N[N.Text=2]="Text",N[N.Cell=3]="Cell",N[N.CellReplace=5]="CellReplace",N[N.Snippet=6]="Snippet"})(_||(e.FileEditType=_={}));let ue=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(T,se,De,Je){this.c.push({_type:1,from:T,to:se,options:De,metadata:Je})}createFile(T,se,De){this.c.push({_type:1,from:void 0,to:T,options:se,metadata:De})}deleteFile(T,se,De){this.c.push({_type:1,from:T,to:void 0,options:se,metadata:De})}e(T,se,De){this.c.push({_type:3,metadata:De,uri:T,edit:{editType:5,metadata:se},notebookMetadata:se})}f(T,se,De,Je){const Ze=se.start,ot=se.end;(Ze!==ot||De.length>0)&&this.c.push({_type:5,uri:T,index:Ze,count:ot-Ze,cells:De,metadata:Je})}g(T,se,De,Je){this.c.push({_type:3,metadata:Je,uri:T,edit:{editType:3,index:se,metadata:De}})}replace(T,se,De,Je){this.c.push({_type:2,uri:T,edit:new de(se,De),metadata:Je})}insert(T,se,De,Je){this.replace(T,new U(se,se),De,Je)}delete(T,se,De){this.replace(T,se,"",De)}has(T){return this.c.some(se=>se._type===2&&se.uri.toString()===T.toString())}set(T,se){if(se)for(const De of se){if(!De)continue;let Je,Ze;Array.isArray(De)?(Je=De[0],Ze=De[1]):Je=De,Ce.isNotebookCellEdit(Je)?Je.newCellMetadata?this.g(T,Je.range.start,Je.newCellMetadata,Ze):Je.newNotebookMetadata?this.e(T,Je.newNotebookMetadata,Ze):this.f(T,Je.range,Je.newCells,Ze):ae.isSnippetTextEdit(Je)?this.c.push({_type:6,uri:T,range:Je.range,edit:Je.snippet,metadata:Ze}):this.c.push({_type:2,uri:T,edit:Je,metadata:Ze})}else{for(let De=0;De<this.c.length;De++){const Je=this.c[De];switch(Je._type){case 2:case 6:case 3:case 5:Je.uri.toString()===T.toString()&&(this.c[De]=void 0);break}}(0,y.$kf)(this.c)}}get(T){const se=[];for(const De of this.c)De._type===2&&De.uri.toString()===T.toString()&&se.push(De.edit);return se}entries(){const T=new M.$ni;for(const se of this.c)if(se._type===2){let De=T.get(se.uri);De||(De=[se.uri,[]],T.set(se.uri,De)),De[1].push(se.edit)}return[...T.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$VJ=ue,e.$VJ=ue=Ke([F],ue);let O=C=class{static isSnippetString(T){return T instanceof C?!0:T?typeof T.value=="string":!1}static c(T){return T.replace(/\$|}|\\/g,"\\$&")}constructor(T){this.e=1,this.value=T||""}appendText(T){return this.value+=C.c(T),this}appendTabstop(T=this.e++){return this.value+="$",this.value+=T,this}appendPlaceholder(T,se=this.e++){if(typeof T=="function"){const De=new C;De.e=this.e,T(De),this.e=De.e,T=De.value}else T=C.c(T);return this.value+="${",this.value+=se,this.value+=":",this.value+=T,this.value+="}",this}appendChoice(T,se=this.e++){const De=T.map(Je=>Je.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=se,this.value+="|",this.value+=De,this.value+="|}",this}appendVariable(T,se){if(typeof se=="function"){const De=new C;De.e=this.e,se(De),this.e=De.e,se=De.value}else typeof se=="string"&&(se=se.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=T,se&&(this.value+=":",this.value+=se),this.value+="}",this}};e.$WJ=O,e.$WJ=O=C=Ke([F],O);var J;(function(N){N[N.Unnecessary=1]="Unnecessary",N[N.Deprecated=2]="Deprecated"})(J||(e.DiagnosticTag=J={}));var le;(function(N){N[N.Hint=3]="Hint",N[N.Information=2]="Information",N[N.Warning=1]="Warning",N[N.Error=0]="Error"})(le||(e.DiagnosticSeverity=le={}));let ye=n=class{static isLocation(T){return T instanceof n?!0:T?U.isRange(T.range)&&f.URI.isUri(T.uri):!1}constructor(T,se){if(this.uri=T,se)if(U.isRange(se))this.range=U.of(se);else if(j.isPosition(se))this.range=new U(se,se);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$XJ=ye,e.$XJ=ye=n=Ke([F],ye);let ve=class{static is(T){return T?typeof T.message=="string"&&T.location&&U.isRange(T.location.range)&&f.URI.isUri(T.location.uri):!1}constructor(T,se){this.location=T,this.message=se}static isEqual(T,se){return T===se?!0:!T||!se?!1:T.message===se.message&&T.location.range.isEqual(se.location.range)&&T.location.uri.toString()===se.location.uri.toString()}};e.$YJ=ve,e.$YJ=ve=Ke([F],ve);let be=class{constructor(T,se,De=le.Error){if(!U.isRange(T))throw new TypeError("range must be set");if(!se)throw new TypeError("message must be set");this.range=T,this.message=se,this.severity=De}toJSON(){return{severity:le[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(T,se){return T===se?!0:!T||!se?!1:T.message===se.message&&T.severity===se.severity&&T.code===se.code&&T.severity===se.severity&&T.source===se.source&&T.range.isEqual(se.range)&&(0,y.$$e)(T.tags,se.tags)&&(0,y.$$e)(T.relatedInformation,se.relatedInformation,ve.isEqual)}};e.$ZJ=be,e.$ZJ=be=Ke([F],be);let ke=class{constructor(T,se){if(!T)throw new Error("Illegal argument, contents must be defined");Array.isArray(T)?this.contents=T:this.contents=[T],this.range=se}};e.$1J=ke,e.$1J=ke=Ke([F],ke);var oe;(function(N){N[N.Text=0]="Text",N[N.Read=1]="Read",N[N.Write=2]="Write"})(oe||(e.DocumentHighlightKind=oe={}));let he=class{constructor(T,se=oe.Text){this.range=T,this.kind=se}toJSON(){return{range:this.range,kind:oe[this.kind]}}};e.$2J=he,e.$2J=he=Ke([F],he);var re;(function(N){N[N.File=0]="File",N[N.Module=1]="Module",N[N.Namespace=2]="Namespace",N[N.Package=3]="Package",N[N.Class=4]="Class",N[N.Method=5]="Method",N[N.Property=6]="Property",N[N.Field=7]="Field",N[N.Constructor=8]="Constructor",N[N.Enum=9]="Enum",N[N.Interface=10]="Interface",N[N.Function=11]="Function",N[N.Variable=12]="Variable",N[N.Constant=13]="Constant",N[N.String=14]="String",N[N.Number=15]="Number",N[N.Boolean=16]="Boolean",N[N.Array=17]="Array",N[N.Object=18]="Object",N[N.Key=19]="Key",N[N.Null=20]="Null",N[N.EnumMember=21]="EnumMember",N[N.Struct=22]="Struct",N[N.Event=23]="Event",N[N.Operator=24]="Operator",N[N.TypeParameter=25]="TypeParameter"})(re||(e.SymbolKind=re={}));var ie;(function(N){N[N.Deprecated=1]="Deprecated"})(ie||(e.SymbolTag=ie={}));let ge=a=class{static validate(T){if(!T.name)throw new Error("name must not be falsy")}constructor(T,se,De,Je,Ze){this.name=T,this.kind=se,this.containerName=Ze,typeof De=="string"&&(this.containerName=De),Je instanceof ye?this.location=Je:De instanceof U&&(this.location=new ye(Je,De)),a.validate(this)}toJSON(){return{name:this.name,kind:re[this.kind],location:this.location,containerName:this.containerName}}};e.$3J=ge,e.$3J=ge=a=Ke([F],ge);let Se=r=class{static validate(T){if(!T.name)throw new Error("name must not be falsy");if(!T.range.contains(T.selectionRange))throw new Error("selectionRange must be contained in fullRange");T.children?.forEach(r.validate)}constructor(T,se,De,Je,Ze){this.name=T,this.detail=se,this.kind=De,this.range=Je,this.selectionRange=Ze,this.children=[],r.validate(this)}};e.$4J=Se,e.$4J=Se=r=Ke([F],Se);var L;(function(N){N[N.Invoke=1]="Invoke",N[N.Automatic=2]="Automatic"})(L||(e.CodeActionTriggerKind=L={}));let q=class{constructor(T,se){this.title=T,this.kind=se}};e.$5J=q,e.$5J=q=Ke([F],q);let G=class{static{s=this}static{this.c="."}constructor(T){this.value=T}append(T){return new s(this.value?this.value+s.c+T:T)}intersects(T){return this.contains(T)||T.contains(this)}contains(T){return this.value===T.value||T.value.startsWith(this.value+s.c)}};e.$6J=G,e.$6J=G=s=Ke([F],G);class Q extends G{constructor(T){super(T),this.value=T}}e.$7J=Q,G.Empty=new G(""),G.QuickFix=G.Empty.append("quickfix"),G.Refactor=G.Empty.append("refactor"),G.RefactorExtract=G.Refactor.append("extract"),G.RefactorInline=G.Refactor.append("inline"),G.RefactorMove=G.Refactor.append("move"),G.RefactorRewrite=G.Refactor.append("rewrite"),G.Source=G.Empty.append("source"),G.SourceOrganizeImports=G.Source.append("organizeImports"),G.SourceFixAll=G.Source.append("fixAll"),G.Notebook=G.Empty.append("notebook");let K=class{constructor(T,se){if(this.range=T,this.parent=se,se&&!se.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$8J=K,e.$8J=K=Ke([F],K);class ee{constructor(T,se,De,Je,Ze,ot){this.kind=T,this.name=se,this.detail=De,this.uri=Je,this.range=Ze,this.selectionRange=ot}}e.$9J=ee;class ce{constructor(T,se){this.fromRanges=se,this.from=T}}e.$0J=ce;class ze{constructor(T,se){this.fromRanges=se,this.to=T}}e.$$J=ze;var Ue;(function(N){N[N.Information=0]="Information",N[N.Warning=1]="Warning",N[N.Error=2]="Error"})(Ue||(e.LanguageStatusSeverity=Ue={}));let Qe=class{constructor(T,se){this.range=T,this.command=se}get isResolved(){return!!this.command}};e.$_J=Qe,e.$_J=Qe=Ke([F],Qe);let He=v=class{#e;static isMarkdownString(T){return T instanceof v?!0:T&&T.appendCodeblock&&T.appendMarkdown&&T.appendText&&T.value!==void 0}constructor(T,se=!1){this.#e=new I.$Kj(T,{supportThemeIcons:se})}get value(){return this.#e.value}set value(T){this.#e.value=T}get isTrusted(){return this.#e.isTrusted}set isTrusted(T){this.#e.isTrusted=T}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(T){this.#e.supportThemeIcons=T}get supportHtml(){return this.#e.supportHtml}set supportHtml(T){this.#e.supportHtml=T}get baseUri(){return this.#e.baseUri}set baseUri(T){this.#e.baseUri=T}appendText(T){return this.#e.appendText(T),this}appendMarkdown(T){return this.#e.appendMarkdown(T),this}appendCodeblock(T,se){return this.#e.appendCodeblock(se??"",T),this}};e.$aK=He,e.$aK=He=v=Ke([F],He);let et=class{constructor(T,se){this.label=T,this.documentation=se}};e.$bK=et,e.$bK=et=Ke([F],et);let Xe=class{constructor(T,se){this.label=T,this.documentation=se,this.parameters=[]}};e.$cK=Xe,e.$cK=Xe=Ke([F],Xe);let xe=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$dK=xe,e.$dK=xe=Ke([F],xe);var it;(function(N){N[N.Invoke=1]="Invoke",N[N.TriggerCharacter=2]="TriggerCharacter",N[N.ContentChange=3]="ContentChange"})(it||(e.SignatureHelpTriggerKind=it={}));var tt;(function(N){N[N.Type=1]="Type",N[N.Parameter=2]="Parameter"})(tt||(e.InlayHintKind=tt={}));let Ne=class{constructor(T){this.value=T}};e.$eK=Ne,e.$eK=Ne=Ke([F],Ne);let st=class{constructor(T,se,De){this.position=T,this.label=se,this.kind=De}};e.$fK=st,e.$fK=st=Ke([F],st);var x;(function(N){N[N.Invoke=0]="Invoke",N[N.TriggerCharacter=1]="TriggerCharacter",N[N.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(x||(e.CompletionTriggerKind=x={}));var Y;(function(N){N[N.Text=0]="Text",N[N.Method=1]="Method",N[N.Function=2]="Function",N[N.Constructor=3]="Constructor",N[N.Field=4]="Field",N[N.Variable=5]="Variable",N[N.Class=6]="Class",N[N.Interface=7]="Interface",N[N.Module=8]="Module",N[N.Property=9]="Property",N[N.Unit=10]="Unit",N[N.Value=11]="Value",N[N.Enum=12]="Enum",N[N.Keyword=13]="Keyword",N[N.Snippet=14]="Snippet",N[N.Color=15]="Color",N[N.File=16]="File",N[N.Reference=17]="Reference",N[N.Folder=18]="Folder",N[N.EnumMember=19]="EnumMember",N[N.Constant=20]="Constant",N[N.Struct=21]="Struct",N[N.Event=22]="Event",N[N.Operator=23]="Operator",N[N.TypeParameter=24]="TypeParameter",N[N.User=25]="User",N[N.Issue=26]="Issue"})(Y||(e.CompletionItemKind=Y={}));var $e;(function(N){N[N.Deprecated=1]="Deprecated"})($e||(e.CompletionItemTag=$e={}));let je=class{constructor(T,se){this.label=T,this.kind=se}toJSON(){return{label:this.label,kind:this.kind&&Y[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$gK=je,e.$gK=je=Ke([F],je);let Oe=class{constructor(T=[],se=!1){this.items=T,this.isIncomplete=se}};e.$hK=Oe,e.$hK=Oe=Ke([F],Oe);let Ye=class{constructor(T,se,De){this.insertText=T,this.range=se,this.command=De}};e.$iK=Ye,e.$iK=Ye=Ke([F],Ye);let nt=class{constructor(T){this.commands=void 0,this.suppressSuggestions=void 0,this.items=T}};e.$jK=nt,e.$jK=nt=Ke([F],nt);var ft;(function(N){N[N.Active=-1]="Active",N[N.Beside=-2]="Beside",N[N.One=1]="One",N[N.Two=2]="Two",N[N.Three=3]="Three",N[N.Four=4]="Four",N[N.Five=5]="Five",N[N.Six=6]="Six",N[N.Seven=7]="Seven",N[N.Eight=8]="Eight",N[N.Nine=9]="Nine"})(ft||(e.ViewColumn=ft={}));var bt;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(bt||(e.StatusBarAlignment=bt={}));function Tt(N,T){return`${D.$Il.toKey(N)}.${T}`}e.$kK=Tt;var Yt;(function(N){N[N.Off=0]="Off",N[N.On=1]="On",N[N.Relative=2]="Relative"})(Yt||(e.TextEditorLineNumbersStyle=Yt={}));var Vt;(function(N){N[N.Manual=1]="Manual",N[N.AfterDelay=2]="AfterDelay",N[N.FocusOut=3]="FocusOut"})(Vt||(e.TextDocumentSaveReason=Vt={}));var vt;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(vt||(e.TextEditorRevealType=vt={}));var Mt;(function(N){N[N.Keyboard=1]="Keyboard",N[N.Mouse=2]="Mouse",N[N.Command=3]="Command"})(Mt||(e.TextEditorSelectionChangeKind=Mt={}));var Ot;(function(N){N[N.Undo=1]="Undo",N[N.Redo=2]="Redo"})(Ot||(e.TextDocumentChangeReason=Ot={}));var Jt;(function(N){N[N.OpenOpen=0]="OpenOpen",N[N.ClosedClosed=1]="ClosedClosed",N[N.OpenClosed=2]="OpenClosed",N[N.ClosedOpen=3]="ClosedOpen"})(Jt||(e.DecorationRangeBehavior=Jt={})),function(N){function T(se){switch(se){case"keyboard":return N.Keyboard;case"mouse":return N.Mouse;case"api":return N.Command}}N.fromValue=T}(Mt||(e.TextEditorSelectionChangeKind=Mt={}));let At=class{constructor(T,se){if(se&&!f.URI.isUri(se))throw(0,R.$5)("target");if(!U.isRange(T)||T.isEmpty)throw(0,R.$5)("range");this.range=T,this.target=se}};e.$lK=At,e.$lK=At=Ke([F],At);let Rt=class{constructor(T,se,De,Je){this.red=T,this.green=se,this.blue=De,this.alpha=Je}};e.$mK=Rt,e.$mK=Rt=Ke([F],Rt);let Nt=class{constructor(T,se){if(se&&!(se instanceof Rt))throw(0,R.$5)("color");if(!U.isRange(T)||T.isEmpty)throw(0,R.$5)("range");this.range=T,this.color=se}};e.$nK=Nt,e.$nK=Nt=Ke([F],Nt);let jt=class{constructor(T){if(!T||typeof T!="string")throw(0,R.$5)("label");this.label=T}};e.$oK=jt,e.$oK=jt=Ke([F],jt);var qt;(function(N){N[N.RGB=0]="RGB",N[N.HEX=1]="HEX",N[N.HSL=2]="HSL"})(qt||(e.ColorFormat=qt={}));var Bt;(function(N){N[N.Error=0]="Error",N[N.Warning=1]="Warning",N[N.Information=2]="Information"})(Bt||(e.SourceControlInputBoxValidationType=Bt={}));var at;(function(N){N[N.Unknown=0]="Unknown",N[N.Shutdown=1]="Shutdown",N[N.Process=2]="Process",N[N.User=3]="User",N[N.Extension=4]="Extension"})(at||(e.TerminalExitReason=at={}));class lt{constructor(T,se,De){if(this.startIndex=T,this.length=se,this.tooltip=De,typeof T!="number"||T<0)throw(0,R.$5)("startIndex");if(typeof se!="number"||se<1)throw(0,R.$5)("length");if(De!==void 0&&typeof De!="string")throw(0,R.$5)("tooltip")}}e.$pK=lt;class Ht{constructor(T){this.uri=T}}e.$qK=Ht;class Pt{constructor(T){this.terminalCommand=T}}e.$rK=Pt;var kt;(function(N){N[N.Panel=1]="Panel",N[N.Editor=2]="Editor"})(kt||(e.TerminalLocation=kt={}));class dt{constructor(T){if(this.options=T,typeof T!="object")throw(0,R.$5)("options")}}e.$sK=dt;var It;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(It||(e.TaskRevealKind=It={}));var zt;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(zt||(e.TaskPanelKind=zt={}));let yt=class{static{$=this}static{this.Clean=new $("clean","Clean")}static{this.Build=new $("build","Build")}static{this.Rebuild=new $("rebuild","Rebuild")}static{this.Test=new $("test","Test")}static from(T){switch(T){case"clean":return $.Clean;case"build":return $.Build;case"rebuild":return $.Rebuild;case"test":return $.Test;default:return}}constructor(T,se){if(this.label=se,typeof T!="string"||typeof se!="string")throw(0,R.$5)("name");this.c=T}get id(){return this.c}};e.$tK=yt,e.$tK=yt=$=Ke([F],yt);function Ve(N){let T="";for(let se=0;se<N.length;se++)T+=N[se].replace(/,/g,",,")+",";return T}let Ie=class{constructor(T,se,De){if(typeof T!="string")throw(0,R.$5)("process");this.e=[],this.c=T,se!==void 0&&(Array.isArray(se)?(this.e=se,this.f=De):this.f=se)}get process(){return this.c}set process(T){if(typeof T!="string")throw(0,R.$5)("process");this.c=T}get args(){return this.e}set args(T){Array.isArray(T)||(T=[]),this.e=T}get options(){return this.f}set options(T){this.f=T}computeId(){const T=[];if(T.push("process"),this.c!==void 0&&T.push(this.c),this.e&&this.e.length>0)for(const se of this.e)T.push(se);return Ve(T)}};e.$uK=Ie,e.$uK=Ie=Ke([F],Ie);let Le=class{constructor(T,se,De){if(this.f=[],Array.isArray(se)){if(!T)throw(0,R.$5)("command can't be undefined or null");if(typeof T!="string"&&typeof T.value!="string")throw(0,R.$5)("command");this.e=T,this.f=se,this.g=De}else{if(typeof T!="string")throw(0,R.$5)("commandLine");this.c=T,this.g=se}}get commandLine(){return this.c}set commandLine(T){if(typeof T!="string")throw(0,R.$5)("commandLine");this.c=T}get command(){return this.e?this.e:""}set command(T){if(typeof T!="string"&&typeof T.value!="string")throw(0,R.$5)("command");this.e=T}get args(){return this.f}set args(T){this.f=T||[]}get options(){return this.g}set options(T){this.g=T}computeId(){const T=[];if(T.push("shell"),this.c!==void 0&&T.push(this.c),this.e!==void 0&&T.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const se of this.f)T.push(typeof se=="string"?se:se.value);return Ve(T)}};e.$vK=Le,e.$vK=Le=Ke([F],Le);var me;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(me||(e.ShellQuoting=me={}));var H;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace"})(H||(e.TaskScope=H={}));class Fe{constructor(T){this.c=T}computeId(){return"customExecution"+(0,P.$3e)()}set callback(T){this.c=T}get callback(){return this.c}}e.$wK=Fe;let Be=class{static{w=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(T,se,De,Je,Ze,ot){this.j=!1,this.k=this.definition=T;let ht;typeof se=="string"?(this.m=this.name=se,this.t=this.source=De,this.execution=Je,ht=Ze,this.j=!0):se===H.Global||se===H.Workspace?(this.target=se,this.m=this.name=De,this.t=this.source=Je,this.execution=Ze,ht=ot):(this.target=se,this.m=this.name=De,this.t=this.source=Je,this.execution=Ze,ht=ot),typeof ht=="string"?(this.o=[ht],this.q=!0):Array.isArray(ht)?(this.o=ht,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(T){this.h=T}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof Ie?this.k={type:w.e,id:this.n.computeId()}:this.n instanceof Le?this.k={type:w.f,id:this.n.computeId()}:this.n instanceof Fe?this.k={type:w.c,id:this.n.computeId()}:this.k={type:w.g,id:(0,P.$3e)()}}get definition(){return this.k}set definition(T){if(T==null)throw(0,R.$5)("Kind can't be undefined or null");this.y(),this.k=T}get scope(){return this.l}set target(T){this.y(),this.l=T}get name(){return this.m}set name(T){if(typeof T!="string")throw(0,R.$5)("name");this.y(),this.m=T}get execution(){return this.n}set execution(T){T===null&&(T=void 0),this.y(),this.n=T;const se=this.k.type;(w.g===se||w.e===se||w.f===se||w.c===se)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(T){if(Array.isArray(T))this.y(),this.o=T,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(T){T!==!0&&T!==!1&&(T=!1),this.y(),this.r=T}get source(){return this.t}set source(T){if(typeof T!="string"||T.length===0)throw(0,R.$5)("source must be a string of length > 0");this.y(),this.t=T}get group(){return this.u}set group(T){T===null&&(T=void 0),this.y(),this.u=T}get detail(){return this.x}set detail(T){T===null&&(T=void 0),this.x=T}get presentationOptions(){return this.v}set presentationOptions(T){T==null&&(T=Object.create(null)),this.y(),this.v=T}get runOptions(){return this.w}set runOptions(T){T==null&&(T=Object.create(null)),this.y(),this.w=T}};e.$xK=Be,e.$xK=Be=w=Ke([F],Be);var Ge;(function(N){N[N.SourceControl=1]="SourceControl",N[N.Window=10]="Window",N[N.Notification=15]="Notification"})(Ge||(e.ProgressLocation=Ge={}));var qe;(function(N){function T(se){const De=se;return(0,k.$me)(De.value)?De.tooltip&&!(0,k.$ie)(De.tooltip)?(console.log("INVALID view badge, invalid tooltip",De.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",De.value),!1)}N.isViewBadge=T})(qe||(e.ViewBadge=qe={}));let _e=E=class{static isTreeItem(T,se){const De=T;if(De.checkboxState!==void 0){const Je=(0,k.$me)(De.checkboxState)?De.checkboxState:(0,k.$ke)(De.checkboxState)&&(0,k.$me)(De.checkboxState.state)?De.checkboxState.state:void 0,Ze=!(0,k.$me)(De.checkboxState)&&(0,k.$ke)(De.checkboxState)?De.checkboxState.tooltip:void 0;if(Je===void 0||Je!==Et.Checked&&Je!==Et.Unchecked||Ze!==void 0&&!(0,k.$ie)(Ze))return console.log("INVALID tree item, invalid checkboxState",De.checkboxState),!1}if(T instanceof E)return!0;if(De.label!==void 0&&!(0,k.$ie)(De.label)&&!De.label?.label)return console.log("INVALID tree item, invalid label",De.label),!1;if(De.id!==void 0&&!(0,k.$ie)(De.id))return console.log("INVALID tree item, invalid id",De.id),!1;if(De.iconPath!==void 0&&!(0,k.$ie)(De.iconPath)&&!f.URI.isUri(De.iconPath)&&(!De.iconPath||!(0,k.$ie)(De.iconPath.id))){const Je=De.iconPath;if(!Je||!(0,k.$ie)(Je.light)&&!f.URI.isUri(Je.light)&&!(0,k.$ie)(Je.dark)&&!f.URI.isUri(Je.dark))return console.log("INVALID tree item, invalid iconPath",De.iconPath),!1}return De.description!==void 0&&!(0,k.$ie)(De.description)&&typeof De.description!="boolean"?(console.log("INVALID tree item, invalid description",De.description),!1):De.resourceUri!==void 0&&!f.URI.isUri(De.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",De.resourceUri),!1):De.tooltip!==void 0&&!(0,k.$ie)(De.tooltip)&&!(De.tooltip instanceof He)?(console.log("INVALID tree item, invalid tooltip",De.tooltip),!1):De.command!==void 0&&!De.command.command?(console.log("INVALID tree item, invalid command",De.command),!1):De.collapsibleState!==void 0&&De.collapsibleState<$t.None&&De.collapsibleState>$t.Expanded?(console.log("INVALID tree item, invalid collapsibleState",De.collapsibleState),!1):De.contextValue!==void 0&&!(0,k.$ie)(De.contextValue)?(console.log("INVALID tree item, invalid contextValue",De.contextValue),!1):De.accessibilityInformation!==void 0&&!De.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",De.accessibilityInformation),!1):!0}constructor(T,se=$t.None){this.collapsibleState=se,f.URI.isUri(T)?this.resourceUri=T:this.label=T}};e.$yK=_e,e.$yK=_e=E=Ke([F],_e);var $t;(function(N){N[N.None=0]="None",N[N.Collapsed=1]="Collapsed",N[N.Expanded=2]="Expanded"})($t||(e.TreeItemCollapsibleState=$t={}));var Et;(function(N){N[N.Unchecked=0]="Unchecked",N[N.Checked=1]="Checked"})(Et||(e.TreeItemCheckboxState=Et={}));let pt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(T){this.value=T}};e.$zK=pt,e.$zK=pt=Ke([F],pt);class ct extends pt{}e.$AK=ct;class mt extends ct{#e;constructor(T){super(""),this.#e=T}asFile(){return this.#e}}e.$BK=mt;class Dt{constructor(T,se,De,Je){this.name=T,this.uri=se,this._itemId=De,this.c=Je}data(){return this.c()}}e.$CK=Dt;let gi=class{#e=new Map;constructor(T){for(const[se,De]of T??[]){const Je=this.#e.get(this.#t(se));Je?Je.push(De):this.#e.set(this.#t(se),[De])}}get(T){return this.#e.get(this.#t(T))?.[0]}set(T,se){this.#e.set(this.#t(T),[se])}forEach(T,se){for(const[De,Je]of this.#e)for(const Ze of Je)T.call(se,Ze,De,this)}*[Symbol.iterator](){for(const[T,se]of this.#e)for(const De of se)yield[T,De]}#t(T){return T.toLowerCase()}};e.$DK=gi,e.$DK=gi=Ke([F],gi);let Kt=class{constructor(T){this.insertText=T}};e.$EK=Kt,e.$EK=Kt=Ke([F],Kt);let Ei=class{constructor(T,se){this.label=se,this.insertText=T}};e.$FK=Ei,e.$FK=Ei=Ke([F],Ei);let Wt=class{constructor(T,se){this.id=T,this.color=se}static isThemeIcon(T){return typeof T.id!="string"?(console.log("INVALID ThemeIcon, invalid id",T.id),!1):!0}};e.$GK=Wt,e.$GK=Wt=Ke([F],Wt),Wt.File=new Wt("file"),Wt.Folder=new Wt("folder");let mi=class{constructor(T){this.id=T}};e.$HK=mi,e.$HK=mi=Ke([F],mi);var Ct;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.WorkspaceFolder=3]="WorkspaceFolder"})(Ct||(e.ConfigurationTarget=Ct={}));let ki=class{get base(){return this.c}set base(T){this.c=T,this.e=f.URI.file(T)}get baseUri(){return this.e}set baseUri(T){this.e=T,this.c=T.fsPath}constructor(T,se){if(typeof T!="string"&&(!T||!f.URI.isUri(T)&&!f.URI.isUri(T.uri)))throw(0,R.$5)("base");if(typeof se!="string")throw(0,R.$5)("pattern");typeof T=="string"?this.baseUri=f.URI.file(T):f.URI.isUri(T)?this.baseUri=T:this.baseUri=T.uri,this.pattern=se}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$IK=ki,e.$IK=ki=Ke([F],ki);const Vi=new WeakMap;function St(N,T){Vi.set(N,T)}e.$JK=St;let ti=class{constructor(T,se,De,Je){this.enabled=typeof T=="boolean"?T:!0,typeof se=="string"&&(this.condition=se),typeof De=="string"&&(this.hitCondition=De),typeof Je=="string"&&(this.logMessage=Je)}get id(){return this.c||(this.c=Vi.get(this)??(0,P.$3e)()),this.c}};e.$KK=ti,e.$KK=ti=Ke([F],ti);let $i=class extends ti{constructor(T,se,De,Je,Ze){if(super(se,De,Je,Ze),T===null)throw(0,R.$5)("location");this.location=T}};e.$LK=$i,e.$LK=$i=Ke([F],$i);let si=class extends ti{constructor(T,se,De,Je,Ze){super(se,De,Je,Ze),this.functionName=T}};e.$MK=si,e.$MK=si=Ke([F],si);let Di=class extends ti{constructor(T,se,De,Je,Ze,ot,ht){if(super(Je,Ze,ot,ht),!se)throw(0,R.$5)("dataId");this.label=T,this.dataId=se,this.canPersist=De}};e.$NK=Di,e.$NK=Di=Ke([F],Di);let Si=class{constructor(T,se,De){this.command=T,this.args=se||[],this.options=De}};e.$OK=Si,e.$OK=Si=Ke([F],Si);let Lt=class{constructor(T,se){this.port=T,this.host=se}};e.$PK=Lt,e.$PK=Lt=Ke([F],Lt);let pi=class{constructor(T){this.path=T}};e.$QK=pi,e.$QK=pi=Ke([F],pi);let Ii=class{constructor(T){this.implementation=T}};e.$RK=Ii,e.$RK=Ii=Ke([F],Ii);let oi=class{constructor(T,se,De){this.session=T,this.threadId=se,this.frameId=De}};e.$SK=oi,e.$SK=oi=Ke([F],oi);let ai=class{constructor(T,se){this.session=T,this.threadId=se}};e.$TK=ai,e.$TK=ai=Ke([F],ai);let ut=class{constructor(T,se){this.range=T,this.expression=se}};e.$UK=ut,e.$UK=ut=Ke([F],ut);var qi;(function(N){N[N.Invoke=0]="Invoke",N[N.Automatic=1]="Automatic"})(qi||(e.InlineCompletionTriggerKind=qi={}));let Zt=class{constructor(T,se){this.range=T,this.text=se}};e.$VK=Zt,e.$VK=Zt=Ke([F],Zt);let ii=class{constructor(T,se,De=!0){this.range=T,this.variableName=se,this.caseSensitiveLookup=De}};e.$WK=ii,e.$WK=ii=Ke([F],ii);let bi=class{constructor(T,se){this.range=T,this.expression=se}};e.$XK=bi,e.$XK=bi=Ke([F],bi);let Ci=class{constructor(T,se){this.frameId=T,this.stoppedLocation=se}};e.$YK=Ci,e.$YK=Ci=Ke([F],Ci);var Ki;(function(N){N[N.Changed=1]="Changed",N[N.Created=2]="Created",N[N.Deleted=3]="Deleted"})(Ki||(e.FileChangeType=Ki={}));let Pi=o=class extends Error{static FileExists(T){return new o(T,u.FileSystemProviderErrorCode.FileExists,o.FileExists)}static FileNotFound(T){return new o(T,u.FileSystemProviderErrorCode.FileNotFound,o.FileNotFound)}static FileNotADirectory(T){return new o(T,u.FileSystemProviderErrorCode.FileNotADirectory,o.FileNotADirectory)}static FileIsADirectory(T){return new o(T,u.FileSystemProviderErrorCode.FileIsADirectory,o.FileIsADirectory)}static NoPermissions(T){return new o(T,u.FileSystemProviderErrorCode.NoPermissions,o.NoPermissions)}static Unavailable(T){return new o(T,u.FileSystemProviderErrorCode.Unavailable,o.Unavailable)}constructor(T,se=u.FileSystemProviderErrorCode.Unknown,De){super(f.URI.isUri(T)?T.toString(!0):T),this.code=De?.name??"Unknown",(0,u.$7j)(this,se),Object.setPrototypeOf(this,o.prototype),typeof Error.captureStackTrace=="function"&&typeof De=="function"&&Error.captureStackTrace(this,De)}};e.$ZK=Pi,e.$ZK=Pi=o=Ke([F],Pi);let vi=class{constructor(T,se,De){this.start=T,this.end=se,this.kind=De}};e.$1K=vi,e.$1K=vi=Ke([F],vi);var Ji;(function(N){N[N.Comment=1]="Comment",N[N.Imports=2]="Imports",N[N.Region=3]="Region"})(Ji||(e.FoldingRangeKind=Ji={}));var Ai;(function(N){N[N.Collapsed=0]="Collapsed",N[N.Expanded=1]="Expanded"})(Ai||(e.CommentThreadCollapsibleState=Ai={}));var ci;(function(N){N[N.Editing=0]="Editing",N[N.Preview=1]="Preview"})(ci||(e.CommentMode=ci={}));var Hi;(function(N){N[N.Published=0]="Published",N[N.Draft=1]="Draft"})(Hi||(e.CommentState=Hi={}));var wi;(function(N){N[N.Unresolved=0]="Unresolved",N[N.Resolved=1]="Resolved"})(wi||(e.CommentThreadState=wi={}));class Ri{constructor(T,se=[]){this.tokenTypes=T,this.tokenModifiers=se}}e.$2K=Ri;function cn(N){return typeof N>"u"||(0,k.$je)(N)}class Li{constructor(T){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,T){this.l=!0;for(let se=0,De=T.tokenTypes.length;se<De;se++)this.j.set(T.tokenTypes[se],se);for(let se=0,De=T.tokenModifiers.length;se<De;se++)this.k.set(T.tokenModifiers[se],se)}}push(T,se,De,Je,Ze){if(typeof T=="number"&&typeof se=="number"&&typeof De=="number"&&typeof Je=="number"&&(typeof Ze=="number"||typeof Ze>"u"))return typeof Ze>"u"&&(Ze=0),this.n(T,se,De,Je,Ze);if(U.isRange(T)&&typeof se=="string"&&cn(De))return this.m(T,se,De);throw(0,R.$5)()}m(T,se,De){if(!this.l)throw new Error("Legend must be provided in constructor");if(T.start.line!==T.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(se))throw new Error("`tokenType` is not in the provided legend");const Je=T.start.line,Ze=T.start.character,ot=T.end.character-T.start.character,ht=this.j.get(se);let Ut=0;if(De)for(const Qt of De){if(!this.k.has(Qt))throw new Error("`tokenModifier` is not in the provided legend");const xt=this.k.get(Qt);Ut|=1<<xt>>>0}this.n(Je,Ze,ot,ht,Ut)}n(T,se,De,Je,Ze){if(this.f&&(T<this.c||T===this.c&&se<this.e)){this.f=!1;const Ut=this.g.length/5|0;let Qt=0,xt=0;for(let ei=0;ei<Ut;ei++){let ri=this.g[5*ei],Bi=this.g[5*ei+1];ri===0?(ri=Qt,Bi+=xt):ri+=Qt,this.g[5*ei]=ri,this.g[5*ei+1]=Bi,Qt=ri,xt=Bi}}let ot=T,ht=se;this.f&&this.h>0&&(ot-=this.c,ot===0&&(ht-=this.e)),this.g[this.h++]=ot,this.g[this.h++]=ht,this.g[this.h++]=De,this.g[this.h++]=Je,this.g[this.h++]=Ze,this.c=T,this.e=se}static o(T){const se=[],De=T.length/5|0;for(let ht=0;ht<De;ht++)se[ht]=ht;se.sort((ht,Ut)=>{const Qt=T[5*ht],xt=T[5*Ut];if(Qt===xt){const ei=T[5*ht+1],ri=T[5*Ut+1];return ei-ri}return Qt-xt});const Je=new Uint32Array(T.length);let Ze=0,ot=0;for(let ht=0;ht<De;ht++){const Ut=5*se[ht],Qt=T[Ut+0],xt=T[Ut+1],ei=T[Ut+2],ri=T[Ut+3],Bi=T[Ut+4],wn=Qt-Ze,Ln=wn===0?xt-ot:xt,Wi=5*ht;Je[Wi+0]=wn,Je[Wi+1]=Ln,Je[Wi+2]=ei,Je[Wi+3]=ri,Je[Wi+4]=Bi,Ze=Qt,ot=xt}return Je}build(T){return this.f?new ni(new Uint32Array(this.g),T):new ni(Li.o(this.g),T)}}e.$3K=Li;class ni{constructor(T,se){this.resultId=se,this.data=T}}e.$4K=ni;class un{constructor(T,se,De){this.start=T,this.deleteCount=se,this.data=De}}e.$5K=un;class ln{constructor(T,se){this.resultId=se,this.edits=T}}e.$6K=ln;var Gi;(function(N){N[N.Separate=0]="Separate",N[N.MergeWithParent=1]="MergeWithParent"})(Gi||(e.DebugConsoleMode=Gi={}));let fi=class{static{this.Back={iconPath:new Wt("arrow-left")}}constructor(){}};e.$7K=fi,e.$7K=fi=Ke([F],fi);var Qi;(function(N){N[N.Separator=-1]="Separator",N[N.Default=0]="Default"})(Qi||(e.QuickPickItemKind=Qi={}));var Yi;(function(N){N[N.Info=1]="Info",N[N.Warning=2]="Warning",N[N.Error=3]="Error"})(Yi||(e.InputBoxValidationSeverity=Yi={}));var ui;(function(N){N[N.UI=1]="UI",N[N.Workspace=2]="Workspace"})(ui||(e.ExtensionKind=ui={}));class Zi{static validate(T){if(typeof T.badge=="string"){let se=(0,d.$Vd)(T.badge,0);if(se<T.badge.length&&(se+=(0,d.$Vd)(T.badge,se)),T.badge.length>se)throw new Error("The 'badge'-property must be undefined or a short character")}else if(T.badge&&!Wt.isThemeIcon(T.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!T.color&&!T.badge&&!T.tooltip)throw new Error("The decoration is empty");return!0}constructor(T,se,De){this.badge=T,this.tooltip=se,this.color=De}}e.$8K=Zi;let Fi=class{constructor(T){this.kind=T}};e.$9K=Fi,e.$9K=Fi=Ke([F],Fi);var Xi;(function(N){N[N.Light=1]="Light",N[N.Dark=2]="Dark",N[N.HighContrast=3]="HighContrast",N[N.HighContrastLight=4]="HighContrastLight"})(Xi||(e.ColorThemeKind=Xi={}));class Xt{static isNotebookRange(T){return T instanceof Xt?!0:T?typeof T.start=="number"&&typeof T.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(T,se){if(T<0)throw(0,R.$5)("start must be positive");if(se<0)throw(0,R.$5)("end must be positive");T<=se?(this.c=T,this.e=se):(this.c=se,this.e=T)}with(T){let se=this.c,De=this.e;return T.start!==void 0&&(se=T.start),T.end!==void 0&&(De=T.end),se===this.c&&De===this.e?this:new Xt(se,De)}}e.$0K=Xt;class yi{static validate(T){if(typeof T.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof T.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof T.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(T){return Array.isArray(T)&&T.every(se=>yi.isNotebookCellData(se))}static isNotebookCellData(T){return!0}constructor(T,se,De,Je,Ze,ot,ht){this.kind=T,this.value=se,this.languageId=De,this.mime=Je,this.outputs=Ze??[],this.metadata=ot,this.executionSummary=ht,yi.validate(this)}}e.$$K=yi;class hn{constructor(T){this.cells=T}}e.$_K=hn;class Gt{static isNotebookCellOutputItem(T){return T instanceof Gt?!0:T?typeof T.mime=="string"&&T.data instanceof Uint8Array:!1}static error(T){const se={name:T.name,message:T.message,stack:T.stack};return Gt.json(se,"application/vnd.code.notebook.error")}static stdout(T){return Gt.text(T,"application/vnd.code.notebook.stdout")}static stderr(T){return Gt.text(T,"application/vnd.code.notebook.stderr")}static bytes(T,se="application/octet-stream"){return new Gt(T,se)}static#e=new TextEncoder;static text(T,se=A.$yr.text){const De=Gt.#e.encode(String(T));return new Gt(De,se)}static json(T,se="text/x-json"){const De=JSON.stringify(T,void 0,"	");return Gt.text(De,se)}constructor(T,se){this.data=T,this.mime=se;const De=(0,A.$Cr)(se,!0);if(!De)throw new Error(`INVALID mime type: ${se}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=De}}e.$aL=Gt;class li{static isNotebookCellOutput(T){return T instanceof li?!0:!T||typeof T!="object"?!1:typeof T.id=="string"&&Array.isArray(T.items)}static ensureUniqueMimeTypes(T,se=!1){const De=new Set,Je=new Set;for(let Ze=0;Ze<T.length;Ze++){const ot=T[Ze],ht=(0,A.$Cr)(ot.mime);if(!De.has(ht)||(0,p.$RH)(ht)){De.add(ht);continue}Je.add(Ze),se&&console.warn(`DUPLICATED mime type '${ot.mime}' will be dropped`)}return Je.size===0?T:T.filter((Ze,ot)=>!Je.has(ot))}constructor(T,se,De){this.items=li.ensureUniqueMimeTypes(T,!0),typeof se=="string"?(this.id=se,this.metadata=De):(this.id=(0,P.$3e)(),this.metadata=se??De)}}e.$bL=li;var Ti;(function(N){N[N.Markup=1]="Markup",N[N.Code=2]="Code"})(Ti||(e.NotebookCellKind=Ti={}));var Me;(function(N){N[N.Idle=1]="Idle",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(Me||(e.NotebookCellExecutionState=Me={}));var _t;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(_t||(e.NotebookCellStatusBarAlignment=_t={}));var Mi;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(Mi||(e.NotebookEditorRevealType=Mi={}));class gt{constructor(T,se){this.text=T,this.alignment=se}}e.$cL=gt;var _i;(function(N){N[N.Default=1]="Default",N[N.Preferred=2]="Preferred"})(_i||(e.NotebookControllerAffinity=_i={}));var xi;(function(N){N[N.Default=1]="Default",N[N.Preferred=2]="Preferred",N[N.Hidden=-1]="Hidden"})(xi||(e.NotebookControllerAffinity2=xi={}));class en{constructor(T,se=[]){this.uri=T,this.provides=(0,y.$Gf)(se)}}e.$dL=en;class dn{constructor(T){this.label=T}}e.$eL=dn;let hi=class{constructor(T,se){this.label=T,this.timestamp=se}};e.$fL=hi,e.$fL=hi=Ke([F],hi);var tn;(function(N){N[N.Production=1]="Production",N[N.Development=2]="Development",N[N.Test=3]="Test"})(tn||(e.ExtensionMode=tn={}));var nn;(function(N){N[N.Node=1]="Node",N[N.Webworker=2]="Webworker"})(nn||(e.ExtensionRuntime=nn={}));var rn;(function(N){N[N.Other=0]="Other",N[N.Comment=1]="Comment",N[N.String=2]="String",N[N.RegEx=3]="RegEx"})(rn||(e.StandardTokenType=rn={}));class sn{constructor(T,se){this.ranges=T,this.wordPattern=se}}e.$gL=sn;class fn{constructor(T){this.c=T}get autoForwardAction(){return this.c}}e.$hL=fn;var on;(function(N){N[N.Queued=1]="Queued",N[N.Running=2]="Running",N[N.Passed=3]="Passed",N[N.Failed=4]="Failed",N[N.Skipped=5]="Skipped",N[N.Errored=6]="Errored"})(on||(e.TestResultState=on={}));var an;(function(N){N[N.Run=1]="Run",N[N.Debug=2]="Debug",N[N.Coverage=3]="Coverage"})(an||(e.TestRunProfileKind=an={}));let zi=class{constructor(T=void 0,se=void 0,De=void 0,Je=!1){this.include=T,this.exclude=se,this.profile=De,this.continuous=Je}};e.$iL=zi,e.$iL=zi=Ke([F],zi);let Oi=l=class{static diff(T,se,De){const Je=new l(T);return Je.expectedOutput=se,Je.actualOutput=De,Je}constructor(T){this.message=T}};e.$jL=Oi,e.$jL=Oi=l=Ke([F],Oi);let Ni=class{constructor(T){this.id=T}};e.$kL=Ni,e.$kL=Ni=Ke([F],Ni);let di=class{constructor(T,se){this.covered=T,this.total=se}};e.$lL=di,e.$lL=di=Ke([F],di);let Ui=m=class{static fromDetails(T,se){const De=new di(0,0),Je=new di(0,0),Ze=new di(0,0);for(const ht of se)if("branches"in ht){De.total+=1,De.covered+=ht.executionCount>0?1:0;for(const Ut of ht.branches)Je.total+=1,Je.covered+=Ut.executionCount>0?1:0}else Ze.total+=1,Ze.covered+=ht.executionCount>0?1:0;const ot=new m(T,De,Je.total>0?Je:void 0,Ze.total>0?Ze:void 0);return ot.detailedCoverage=se,ot}constructor(T,se,De,Je){this.uri=T,this.statementCoverage=se,this.branchCoverage=De,this.functionCoverage=Je}};e.$mL=Ui,e.$mL=Ui=m=Ke([F],Ui);let ji=class{constructor(T,se,De=[]){this.executionCount=T,this.location=se,this.branches=De}};e.$nL=ji,e.$nL=ji=Ke([F],ji);let te=class{constructor(T,se){this.executionCount=T,this.location=se}};e.$oL=te,e.$oL=te=Ke([F],te);let fe=class{constructor(T,se){this.executionCount=T,this.location=se}};e.$pL=fe,e.$pL=fe=Ke([F],fe);var Te;(function(N){N[N.None=0]="None",N[N.Option=1]="Option",N[N.Default=2]="Default",N[N.Preferred=3]="Preferred"})(Te||(e.ExternalUriOpenerPriority=Te={}));var rt;(function(N){N[N.Untrusted=0]="Untrusted",N[N.Trusted=1]="Trusted",N[N.Unspecified=2]="Unspecified"})(rt||(e.WorkspaceTrustState=rt={}));var wt;(function(N){N[N.Notify=1]="Notify",N[N.OpenBrowser=2]="OpenBrowser",N[N.OpenPreview=3]="OpenPreview",N[N.Silent=4]="Silent",N[N.Ignore=5]="Ignore",N[N.OpenBrowserOnce=6]="OpenBrowserOnce"})(wt||(e.PortAutoForwardAction=wt={}));class Ft{constructor(T,se,De,Je,Ze,ot){this.kind=T,this.name=se,this.detail=De,this.uri=Je,this.range=Ze,this.selectionRange=ot}}e.$qL=Ft;class yn{constructor(T){this.uri=T}}e.$rL=yn;class En{constructor(T,se){this.original=T,this.modified=se}}e.$sL=En;class kn{constructor(T,se,De,Je){this.base=T,this.input1=se,this.input2=De,this.result=Je}}e.$tL=kn;class Dn{constructor(T,se){this.uri=T,this.viewType=se}}e.$uL=Dn;class Sn{constructor(T){this.viewType=T}}e.$vL=Sn;class In{constructor(T,se){this.uri=T,this.notebookType=se}}e.$wL=In;class Cn{constructor(T,se,De){this.original=T,this.modified=se,this.notebookType=De}}e.$xL=Cn;class Pn{constructor(){}}e.$yL=Pn;class An{constructor(T,se){this.uri=T,this.inputBoxUri=se}}e.$zL=An;var gn;(function(N){N[N.Up=1]="Up",N[N.Down=2]="Down"})(gn||(e.InteractiveSessionVoteDirection=gn={}));var mn;(function(N){N[N.Action=1]="Action",N[N.Toolbar=2]="Toolbar"})(mn||(e.InteractiveSessionCopyKind=mn={}));var $n;(function(N){N[N.Unhelpful=0]="Unhelpful",N[N.Helpful=1]="Helpful",N[N.Undone=2]="Undone",N[N.Accepted=3]="Accepted"})($n||(e.InteractiveEditorResponseFeedbackKind=$n={}));var pn;(function(N){N[N.System=0]="System",N[N.User=1]="User",N[N.Assistant=2]="Assistant",N[N.Function=3]="Function"})(pn||(e.ChatMessageRole=pn={}));var bn;(function(N){N[N.Short=1]="Short",N[N.Medium=2]="Medium",N[N.Full=3]="Full"})(bn||(e.ChatVariableLevel=bn={}));class Rn{constructor(T,se){this.role=T,this.content=se}}e.$AL=Rn;var vn;(function(N){N[N.SymbolInformation=1]="SymbolInformation",N[N.CommandInformation=2]="CommandInformation",N[N.SearchInformation=3]="SearchInformation",N[N.SettingInformation=4]="SettingInformation"})(vn||(e.RelatedInformationType=vn={}))}),define(Pe[101],Ae([1,0,50,12,15,277,137,7,18]),function(pe,e,y,R,I,M,A,d,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PL=e.$OL=e.$NL=void 0;const f=new Map;function P(p,h){h?f.set(p,h):f.delete(p)}e.$NL=P;function D(p){return f.get(p)}class u extends M.$Cu{constructor(h,t,i,c,g,S,C,n){super(t,i,c,g),this.c=h,this.m=S,this.q=C,this.notebook=n,this.b=!1}dispose(){(0,y.ok)(!this.b),this.b=!0,this.q=!1}equalLines(h){return(0,k.$$e)(this.f,h)}get document(){if(!this.a){const h=this;this.a={get uri(){return h.d},get fileName(){return h.d.fsPath},get isUntitled(){return h.d.scheme===R.Schemas.untitled},get languageId(){return h.m},get version(){return h.h},get isClosed(){return h.b},get isDirty(){return h.q},save(){return h.r()},getText(t){return t?h.s(t):h.getText()},get eol(){return h.g===`
`?d.EndOfLine.LF:d.EndOfLine.CRLF},get lineCount(){return h.f.length},lineAt(t){return h.t(t)},offsetAt(t){return h.u(t)},positionAt(t){return h.v(t)},validateRange(t){return h.w(t)},validatePosition(t){return h.x(t)},getWordRangeAtPosition(t,i){return h.y(t,i)}}}return Object.freeze(this.a)}_acceptLanguageId(h){(0,y.ok)(!this.b),this.m=h}_acceptIsDirty(h){(0,y.ok)(!this.b),this.q=h}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(h){const t=this.w(h);if(t.isEmpty)return"";if(t.isSingleLine)return this.f[t.start.line].substring(t.start.character,t.end.character);const i=this.g,c=t.start.line,g=t.end.line,S=[];S.push(this.f[c].substring(t.start.character));for(let C=c+1;C<g;C++)S.push(this.f[C]);return S.push(this.f[g].substring(0,t.end.character)),S.join(i)}t(h){let t;if(h instanceof d.$MJ?t=h.line:typeof h=="number"&&(t=h),typeof t!="number"||t<0||t>=this.f.length||Math.floor(t)!==t)throw new Error("Illegal value for `line`");return new b(t,this.f[t],t===this.f.length-1)}u(h){return h=this.x(h),this.l(),this.j.getPrefixSum(h.line-1)+h.character}v(h){h=Math.floor(h),h=Math.max(0,h),this.l();const t=this.j.getIndexOf(h),i=this.f[t.index].length;return new d.$MJ(t.index,Math.min(t.remainder,i))}w(h){if(!(h instanceof d.$NJ))throw new Error("Invalid argument");const t=this.x(h.start),i=this.x(h.end);return t===h.start&&i===h.end?h:new d.$NJ(t.line,t.character,i.line,i.character)}x(h){if(!(h instanceof d.$MJ))throw new Error("Invalid argument");if(this.f.length===0)return h.with(0,0);let{line:t,character:i}=h,c=!1;if(t<0)t=0,i=0,c=!0;else if(t>=this.f.length)t=this.f.length-1,i=this.f[t].length,c=!0;else{const g=this.f[t].length;i<0?(i=0,c=!0):i>g&&(i=g,c=!0)}return c?new d.$MJ(t,i):h}y(h,t){const i=this.x(h);if(!t)t=D(this.m);else if((0,I.$yd)(t))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${t.source}' because it matches the empty string.`);const c=(0,A.$Qr)(i.character+1,(0,A.$Or)(t),this.f[i.line],0);if(c)return new d.$NJ(i.line,c.startColumn-1,i.line,c.endColumn-1)}}e.$OL=u;class b{constructor(h,t,i){this.a=h,this.b=t,this.c=i}get lineNumber(){return this.a}get text(){return this.b}get range(){return new d.$NJ(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new d.$NJ(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$PL=b}),define(Pe[197],Ae([1,0,7,17,5]),function(pe,e,y,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wbc=void 0;let M=class{constructor(d){this.a=new y.$9K(y.ColorThemeKind.Dark),this.b=new I.$ec}get activeColorTheme(){return this.a}$onColorThemeChange(d){let k;switch(d){case"light":k=y.ColorThemeKind.Light;break;case"hcDark":k=y.ColorThemeKind.HighContrast;break;case"hcLight":k=y.ColorThemeKind.HighContrastLight;break;default:k=y.ColorThemeKind.Dark}this.a=new y.$9K(k),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Wbc=M,e.$Wbc=M=Ke([We(0,R.$LL)],M)}),define(Pe[198],Ae([1,0,4]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VH=e.CellExecutionUpdateType=void 0;var R;(function(I){I[I.Output=1]="Output",I[I.OutputItems=2]="OutputItems",I[I.ExecutionState=3]="ExecutionState"})(R||(e.CellExecutionUpdateType=R={})),e.$VH=(0,y.$ph)("INotebookExecutionService")}),define(Pe[45],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wI=e.TestPosition=e.TestIdPathParts=void 0;var y;(function(M){M.Delimiter="\0"})(y||(e.TestIdPathParts=y={}));var R;(function(M){M[M.IsSame=0]="IsSame",M[M.Disconnected=1]="Disconnected",M[M.IsChild=2]="IsChild",M[M.IsParent=3]="IsParent"})(R||(e.TestPosition=R={}));class I{static fromExtHostTestItem(A,d,k=A.parent){if(A._isRoot)return new I([d]);const f=[A.id];for(let P=k;P&&P.id!==d;P=P.parent)f.push(P.id);return f.push(d),new I(f.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const d=A.indexOf("\0");return d===-1?A:A.slice(0,d)}static fromString(A){return new I(A.split("\0"))}static join(A,d){return new I([...A.path,d])}static joinToString(A,d){return A.toString()+"\0"+d}static parentId(A){const d=A.lastIndexOf("\0");return d===-1?void 0:A.slice(0,d)}static localId(A){const d=A.lastIndexOf("\0");return d===-1?A:A.slice(d+1)}static isChild(A,d){return d.startsWith(A)&&d[A.length]==="\0"}static compare(A,d){return A===d?0:I.isChild(A,d)?2:I.isChild(d,A)?3:1}constructor(A,d=A.length){if(this.path=A,this.d=d,A.length===0||d<1)throw new Error("cannot create test with empty path")}get rootId(){return new I(this.path,1)}get parentId(){return this.d>1?new I(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new I(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new I(this.path,A)}compare(A){if(typeof A=="string")return I.compare(this.toString(),A);for(let d=0;d<A.d&&d<this.d;d++)if(A.path[d]!==this.path[d])return 1;return A.d>this.d?2:A.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+="\0",this.c+=this.path[A]}return this.c}}e.$wI=I}),define(Pe[57],Ae([1,0,2,44,45]),function(pe,e,y,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DI=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$CI=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$BI=e.$AI=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$zI=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$yI=e.$xI=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var M;(function(E){E[E.Unset=0]="Unset",E[E.Queued=1]="Queued",E[E.Running=2]="Running",E[E.Passed=3]="Passed",E[E.Failed=4]="Failed",E[E.Skipped=5]="Skipped",E[E.Errored=6]="Errored"})(M||(e.TestResultState=M={}));var A;(function(E){E[E.Run=1]="Run",E[E.Debug=2]="Debug",E[E.Coverage=3]="Coverage"})(A||(e.ExtTestRunProfileKind=A={}));var d;(function(E){E[E.Run=2]="Run",E[E.Debug=4]="Debug",E[E.Coverage=8]="Coverage",E[E.HasNonDefaultProfile=16]="HasNonDefaultProfile",E[E.HasConfigurable=32]="HasConfigurable",E[E.SupportsContinuousRun=64]="SupportsContinuousRun"})(d||(e.TestRunProfileBitset=d={})),e.$xI=[2,4,8,16,32,64];const k=E=>"runId"in E;e.$yI=k;var f;(function(E){E.serialize=o=>({range:o.range.toJSON(),uri:o.uri.toJSON()}),E.deserialize=o=>({range:R.$Ur.lift(o.range),uri:y.URI.revive(o.uri)})})(f||(e.IRichLocation=f={}));var P;(function(E){E[E.Error=0]="Error",E[E.Output=1]="Output"})(P||(e.TestMessageType=P={}));var D;(function(E){E.serialize=o=>({message:o.message,type:0,expected:o.expected,actual:o.actual,contextValue:o.contextValue,location:o.location&&f.serialize(o.location)}),E.deserialize=o=>({message:o.message,type:0,expected:o.expected,actual:o.actual,contextValue:o.contextValue,location:o.location&&f.deserialize(o.location)})})(D||(e.ITestErrorMessage=D={}));const u=(E,o)=>`${o?"s":"e"}${E}`;e.$zI=u;var b;(function(E){E.serialize=o=>({message:o.message,type:1,offset:o.offset,length:o.length,location:o.location&&f.serialize(o.location)}),E.deserialize=o=>({message:o.message,type:1,offset:o.offset,length:o.length,location:o.location&&f.deserialize(o.location)})})(b||(e.ITestOutputMessage=b={}));var p;(function(E){E.serialize=o=>o.type===0?D.serialize(o):b.serialize(o),E.deserialize=o=>o.type===0?D.deserialize(o):b.deserialize(o)})(p||(e.ITestMessage=p={}));var h;(function(E){E.serializeWithoutMessages=o=>({state:o.state,duration:o.duration,messages:[]}),E.serialize=o=>({state:o.state,duration:o.duration,messages:o.messages.map(p.serialize)}),E.deserialize=o=>({state:o.state,duration:o.duration,messages:o.messages.map(p.deserialize)})})(h||(e.ITestTaskState=h={}));const t="\0",i=(E,o)=>E+t+o;e.$AI=i;const c=E=>{const o=E.indexOf(t);return{ctrlId:E.slice(0,o),tagId:E.slice(o+1)}};e.$BI=c;var g;(function(E){E.serialize=o=>({extId:o.extId,label:o.label,tags:o.tags,busy:o.busy,children:void 0,uri:o.uri?.toJSON(),range:o.range?.toJSON()||null,description:o.description,error:o.error,sortText:o.sortText}),E.deserialize=o=>({extId:o.extId,label:o.label,tags:o.tags,busy:o.busy,children:void 0,uri:o.uri?y.URI.revive(o.uri):void 0,range:o.range?R.$Ur.lift(o.range):null,description:o.description,error:o.error,sortText:o.sortText})})(g||(e.ITestItem=g={}));var S;(function(E){E[E.NotExpandable=0]="NotExpandable",E[E.Expandable=1]="Expandable",E[E.BusyExpanding=2]="BusyExpanding",E[E.Expanded=3]="Expanded"})(S||(e.TestItemExpandState=S={}));var C;(function(E){E.serialize=o=>({expand:o.expand,item:g.serialize(o.item)}),E.deserialize=o=>({controllerId:I.$wI.root(o.item.extId),expand:o.expand,item:g.deserialize(o.item)})})(C||(e.InternalTestItem=C={}));var n;(function(E){E.serialize=o=>{let l;return o.item&&(l={},o.item.label!==void 0&&(l.label=o.item.label),o.item.tags!==void 0&&(l.tags=o.item.tags),o.item.busy!==void 0&&(l.busy=o.item.busy),o.item.uri!==void 0&&(l.uri=o.item.uri?.toJSON()),o.item.range!==void 0&&(l.range=o.item.range?.toJSON()),o.item.description!==void 0&&(l.description=o.item.description),o.item.error!==void 0&&(l.error=o.item.error),o.item.sortText!==void 0&&(l.sortText=o.item.sortText)),{extId:o.extId,expand:o.expand,item:l}},E.deserialize=o=>{let l;return o.item&&(l={},o.item.label!==void 0&&(l.label=o.item.label),o.item.tags!==void 0&&(l.tags=o.item.tags),o.item.busy!==void 0&&(l.busy=o.item.busy),o.item.range!==void 0&&(l.range=o.item.range?R.$Ur.lift(o.item.range):null),o.item.description!==void 0&&(l.description=o.item.description),o.item.error!==void 0&&(l.error=o.item.error),o.item.sortText!==void 0&&(l.sortText=o.item.sortText)),{extId:o.extId,expand:o.expand,item:l}}})(n||(e.ITestItemUpdate=n={}));const a=(E,o)=>{o.expand!==void 0&&(E.expand=o.expand),o.item!==void 0&&(E.item=E.item?Object.assign(E.item,o.item):o.item)};e.$CI=a;var r;(function(E){E.serializeWithoutMessages=o=>({...C.serialize(o),ownComputedState:o.ownComputedState,computedState:o.computedState,tasks:o.tasks.map(h.serializeWithoutMessages)}),E.serialize=o=>({...C.serialize(o),ownComputedState:o.ownComputedState,computedState:o.computedState,tasks:o.tasks.map(h.serialize)}),E.deserialize=o=>({...C.deserialize(o),ownComputedState:o.ownComputedState,computedState:o.computedState,tasks:o.tasks.map(h.deserialize),retired:!0})})(r||(e.TestResultItem=r={}));var s;(function(E){E[E.Function=0]="Function",E[E.Statement=1]="Statement"})(s||(e.DetailType=s={}));var v;(function(E){E[E.Add=0]="Add",E[E.Update=1]="Update",E[E.DocumentSynced=2]="DocumentSynced",E[E.Remove=3]="Remove",E[E.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",E[E.Retire=5]="Retire",E[E.AddTag=6]="AddTag",E[E.RemoveTag=7]="RemoveTag"})(v||(e.TestDiffOpType=v={}));var $;(function(E){E.deserialize=o=>o.op===0?{op:o.op,item:C.deserialize(o.item)}:o.op===1?{op:o.op,item:n.deserialize(o.item)}:o.op===2?{op:o.op,uri:y.URI.revive(o.uri),docv:o.docv}:o,E.serialize=o=>o.op===0?{op:o.op,item:C.serialize(o.item)}:o.op===1?{op:o.op,item:n.serialize(o.item)}:o})($||(e.TestsDiffOp=$={}));class w{constructor(){this.d=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.d}apply(o){const l=this.p();for(const m of o)switch(m.op){case 0:this.k(C.deserialize(m.item),l);break;case 1:this.l(n.deserialize(m.item),l);break;case 3:this.m(m.itemId,l);break;case 5:this.o(m.itemId);break;case 4:this.updatePendingRoots(m.amount);break;case 6:this.d.set(m.tag.id,m.tag);break;case 7:this.d.delete(m.id);break}l.complete?.()}k(o,l){const m=I.$wI.parentId(o.item.extId)?.toString();let F;if(!m)F=this.q(o),this.g.add(F),this.f.set(o.item.extId,F);else if(this.f.has(m)){const W=this.f.get(m);W.children.add(o.item.extId),F=this.q(o,W),this.f.set(o.item.extId,F)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(o)}`);return}return l.add?.(F),o.expand===2&&this.h++,F}l(o,l){const m=this.f.get(o.extId);if(m)return o.expand!==void 0&&(m.expand===2&&this.h--,o.expand===2&&this.h++),(0,e.$CI)(m,o),l.update?.(m),m}m(o,l){const m=this.f.get(o);if(!m)return;const F=I.$wI.parentId(m.item.extId)?.toString();F?this.f.get(F).children.delete(m.item.extId):this.g.delete(m);const W=[[o]];for(;W.length;)for(const V of W.pop()){const B=this.f.get(V);B&&(W.push(B.children),this.f.delete(V),l.remove?.(B,B!==m),B.expand===2&&this.h--)}}o(o){}updatePendingRoots(o){this.j+=o}p(){return{}}}e.$DI=w}),define(Pe[76],Ae([1,0,13,5,6,50,57,45]),function(pe,e,y,R,I,M,A,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FL=e.$EL=e.$DL=e.$CL=e.$BL=e.TestItemEventOp=void 0;var k;(function(c){c[c.Upsert=0]="Upsert",c[c.SetTags=1]="SetTags",c[c.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",c[c.RemoveChild=3]="RemoveChild",c[c.SetProp=4]="SetProp",c[c.Bulk=5]="Bulk",c[c.DocumentSynced=6]="DocumentSynced"})(k||(e.TestItemEventOp=k={}));const f=(c,g)=>c===g,D=Object.entries({range:(c,g)=>c===g?!0:!c||!g?!1:c.equalsRange(g),busy:f,label:f,description:f,error:f,sortText:f,tags:(c,g)=>!(c.length!==g.length||c.some(S=>!g.includes(S)))}),u=(c,g)=>{let S;for(const[C,n]of D)n(c[C],g[C])||(S?S[C]=g[C]:S={[C]:g[C]});return S};class b extends I.$lb{get root(){return this.m.root}constructor(g){super(),this.m=g,this.f=this.B(new y.$Gg(()=>this.flushDiff(),200)),this.g=this.B(new R.$ec),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(g){this.h=g;for(const S of this.tree.values())this.G(S)}get resolveHandler(){return this.h}collectDiff(){const g=this.k;return this.k=[],g}pushDiff(g){switch(g.op){case 2:{for(const S of this.k)if(S.op===2&&S.uri===g.uri){S.docv=g.docv;return}break}case 1:{const S=this.k[this.k.length-1];if(S){if(S.op===1&&S.item.extId===g.item.extId){(0,A.$CI)(S.item,g.item);return}if(S.op===0&&S.item.item.extId===g.item.extId){(0,A.$CI)(S.item,g.item);return}}break}}this.k.push(g),this.f.isScheduled()||this.f.schedule()}expand(g,S){const C=this.tree.get(g);if(C){if((C.expandLevels===void 0||S>C.expandLevels)&&(C.expandLevels=S),C.expand===1){const n=this.I(C);return n.isOpen()?this.H(C,S-1):n.wait().then(()=>this.H(C,S-1))}else if(C.expand===3)return C.resolveBarrier?.isOpen()===!1?C.resolveBarrier.wait().then(()=>this.H(C,S-1)):this.H(C,S-1)}}dispose(){for(const g of this.tree.values())this.m.getApiFor(g.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(g,S){switch(S.op){case 3:this.L(d.$wI.joinToString(g.fullId,S.id));break;case 0:this.u(S.item,g);break;case 5:for(const C of S.ops)this.p(g,C);break;case 1:this.w(S.new,S.old,g.fullId.toString());break;case 2:this.G(g);break;case 4:this.pushDiff({op:1,item:{extId:g.fullId.toString(),item:S.update}});break;case 6:this.s(g.actual.uri);break;default:(0,M.$wb)(S)}}s(g){g&&this.pushDiff({op:2,uri:g,docv:this.m.getDocumentVersion(g)})}u(g,S){const C=d.$wI.fromExtHostTestItem(g,this.root.id,S?.actual),n=this.m.getApiFor(g);n.parent&&n.parent!==S?.actual&&this.m.getChildren(n.parent).delete(g.id);let a=this.tree.get(C.toString());if(!a){a={fullId:C,actual:g,expandLevels:S?.expandLevels?S.expandLevels-1:void 0,expand:0},g.tags.forEach(this.y,this),this.tree.set(a.fullId.toString(),a),this.C(g,S),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:a.expand,item:this.m.toITestItem(g)}}),this.F(g,a,S);return}if(a.actual===g){this.D(g,a,S);return}if(a.actual.uri?.toString()!==g.uri?.toString())return this.L(C.toString()),this.u(g,S);const r=this.m.getChildren(a.actual),s=a.actual,v=u(this.m.toITestItem(s),this.m.toITestItem(g));this.m.getApiFor(s).listener=void 0,a.actual=g,a.expand=0,v&&(v.hasOwnProperty("tags")&&(this.w(g.tags,s.tags,C.toString()),delete v.tags),this.p(a,{op:4,update:v})),this.F(g,a,S);for(const[$,w]of r)this.m.getChildren(g).get(w.id)||this.L(d.$wI.joinToString(C,w.id));this.s(a.actual.uri)}w(g,S,C){const n=new Set(S.map(a=>a.id));for(const a of g)n.delete(a.id)||this.y(a);this.pushDiff({op:1,item:{extId:C,item:{tags:g.map(a=>(0,A.$AI)(this.m.controllerId,a.id))}}}),n.forEach(this.z,this)}y(g){const S=this.j.get(g.id);S?S.refCount++:(this.j.set(g.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.$AI)(this.m.controllerId,g.id)}}))}z(g){const S=this.j.get(g);S&&!--S.refCount&&(this.j.delete(g),this.pushDiff({op:7,id:(0,A.$AI)(this.m.controllerId,g)}))}C(g,S){this.m.getApiFor(g).parent=S&&S.actual!==this.root?S.actual:void 0}D(g,S,C){this.C(g,C);const n=this.m.getApiFor(g);n.parent=C?.actual,n.listener=a=>this.p(S,a),this.G(S)}F(g,S,C){this.D(g,S,C);for(const[n,a]of this.m.getChildren(g))this.u(a,S)}G(g){let S;this.h?g.resolveBarrier?S=g.resolveBarrier.isOpen()?3:2:S=g.actual.canResolveChildren?1:0:S=0,S!==g.expand&&(g.expand=S,this.pushDiff({op:1,item:{extId:g.fullId.toString(),expand:S}}),S===1&&g.expandLevels!==void 0&&this.I(g))}H(g,S){if(S<0)return;const C=[];for(const[n,a]of this.m.getChildren(g.actual)){const r=this.expand(d.$wI.joinToString(g.fullId,a.id),S);(0,y.$hg)(r)&&C.push(r)}if(C.length)return Promise.all(C).then(()=>{})}I(g){if(g.resolveBarrier)return g.resolveBarrier;if(!this.h){const a=new y.$tg;return a.open(),a}g.expand=2,this.J(g);const S=g.resolveBarrier=new y.$tg,C=a=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,a)};let n;try{n=this.h(g.actual===this.root?void 0:g.actual)}catch(a){C(a)}return(0,y.$hg)(n)?n.catch(C).then(()=>{S.open(),this.G(g)}):(S.open(),this.G(g)),g.resolveBarrier}J(g){this.pushDiff({op:1,item:{extId:g.fullId.toString(),expand:g.expand}})}L(g){const S=this.tree.get(g);if(!S)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:g});const C=[S];for(;C.length;){const n=C.pop();if(n){this.m.getApiFor(n.actual).listener=void 0;for(const a of n.actual.tags)this.z(a.id);this.tree.delete(n.fullId.toString());for(const[a,r]of this.m.getChildren(n.actual))C.push(this.tree.get(d.$wI.joinToString(n.fullId,r.id)))}}}flushDiff(){const g=this.collectDiff();g.length&&this.g.fire(g)}}e.$BL=b;class p extends Error{constructor(g){super(`Attempted to insert a duplicate test item ID ${g}`)}}e.$CL=p;class h extends Error{constructor(g){super(`TestItem with ID "${g}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$DL=h;class t extends Error{constructor(g,S,C){super(`TestItem with ID "${g}" is from controller "${S}" and cannot be added as a child of an item from controller "${C}".`)}}e.$EL=t;const i=(c,g,S)=>{let C=new Map;return{get size(){return C.size},forEach(n,a){for(const r of C.values())n.call(a,r,this)},[Symbol.iterator](){return C.entries()},replace(n){const a=new Map,r=new Set(C.keys()),s={op:5,ops:[]};for(const v of n){if(!(v instanceof S))throw new h(v.id);const $=g(v).controllerId;if($!==c.controllerId)throw new t(v.id,$,c.controllerId);if(a.has(v.id))throw new p(v.id);a.set(v.id,v),r.delete(v.id),s.ops.push({op:0,item:v})}for(const v of r.keys())s.ops.push({op:3,id:v});c.listener?.(s),C=a},add(n){if(!(n instanceof S))throw new h(n.id);C.set(n.id,n),c.listener?.({op:0,item:n})},delete(n){C.delete(n)&&c.listener?.({op:3,id:n})},get(n){return C.get(n)},toJSON(){return Array.from(C.values())}}};e.$FL=i}),define(Pe[102],Ae([1,0,76]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HL=e.$GL=void 0;const R=new WeakMap,I=(A,d)=>{const k={controllerId:d};return R.set(A,k),k};e.$GL=I;const M=A=>{const d=R.get(A);if(!d)throw new y.$DL(A?.id||"<unknown>");return d};e.$HL=M}),define(Pe[77],Ae([1,0,12,2]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kob=e.$job=e.$iob=e.$hob=e.$gob=void 0,e.$gob="vscode-cdn.net",e.$hob=`vscode-resource.${e.$gob}`,e.$iob=`'self' https://*.${e.$gob}`;function I(d,k){return d.scheme===y.Schemas.http||d.scheme===y.Schemas.https?d:(k&&k.authority&&k.isRemote&&d.scheme===y.Schemas.file&&(d=R.URI.from({scheme:y.Schemas.vscodeRemote,authority:k.authority,path:d.path})),R.URI.from({scheme:y.Schemas.https,authority:`${d.scheme}+${M(d.authority)}.${e.$hob}`,path:d.path,fragment:d.fragment,query:d.query}))}e.$job=I;function M(d){return d.replace(/./g,k=>{const f=k.charCodeAt(0);return f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57?k:"-"+f.toString(16).padStart(4,"0")})}function A(d){return d.replace(/-([0-9a-f]{4})/g,(k,f)=>String.fromCharCode(parseInt(f,16)))}e.$kob=A}),define(Pe[199],Ae([1,0,5,6,77]),function(pe,e,y,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ubc=void 0;class M{constructor(d,k,f){this.d=d,this.e=k,this.f=f,this.a=0,this.b=new R.$kb,this.c=new Map,this.b.add(k.onDidChangeVisibleTextEditors(()=>{const P=k.getVisibleTextEditors();for(const D of this.c.values())P.indexOf(D.editor)<0&&D.inset.dispose()}))}dispose(){this.c.forEach(d=>d.inset.dispose()),this.b.dispose()}createWebviewEditorInset(d,k,f,P,D){let u;for(const g of this.e.getVisibleTextEditors(!0))if(g.value===d){u=g;break}if(!u)throw new Error("not a visible editor");const b=this,p=this.a++,h=new y.$ec,t=new y.$ec,i=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(g){return(0,I.$job)(g,b.f)}get cspSource(){return I.$iob}set options(g){this.b=g,b.d.$setOptions(p,g)}get options(){return this.b}set html(g){this.a=g,b.d.$setHtml(p,g)}get html(){return this.a}get onDidReceiveMessage(){return h.event}postMessage(g){return b.d.$postMessage(p,g)}},c=new class{constructor(){this.editor=d,this.line=k,this.height=f,this.webview=i,this.onDidDispose=t.event}dispose(){b.c.has(p)&&(b.c.delete(p),b.d.$disposeEditorInset(p),t.fire(),t.dispose(),h.dispose())}};return this.d.$createEditorInset(p,u.id,u.value.document.uri,k+1,f,P||{},D.identifier,D.extensionLocation),this.c.set(p,{editor:d,inset:c,onDidReceiveMessage:h}),c}$onDidDispose(d){const k=this.c.get(d);k&&k.inset.dispose()}$onDidReceiveMessage(d,k){this.c.get(d)?.onDidReceiveMessage.fire(k)}}e.$ubc=M}),define(Pe[200],Ae([1,0,4]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yM=e.VariableKind=e.$xM=void 0,e.$xM=(0,y.$ph)("configurationResolverService");var R;(function(M){M.Unknown="unknown",M.Env="env",M.Config="config",M.Command="command",M.Input="input",M.ExtensionInstallFolder="extensionInstallFolder",M.WorkspaceFolder="workspaceFolder",M.Cwd="cwd",M.WorkspaceFolderBasename="workspaceFolderBasename",M.UserHome="userHome",M.LineNumber="lineNumber",M.SelectedText="selectedText",M.File="file",M.FileWorkspaceFolder="fileWorkspaceFolder",M.RelativeFile="relativeFile",M.RelativeFileDirname="relativeFileDirname",M.FileDirname="fileDirname",M.FileExtname="fileExtname",M.FileBasename="fileBasename",M.FileBasenameNoExtension="fileBasenameNoExtension",M.FileDirnameBasename="fileDirnameBasename",M.ExecPath="execPath",M.ExecInstallFolder="execInstallFolder",M.PathSeparator="pathSeparator"})(R||(e.VariableKind=R={}));class I extends Error{constructor(A,d){super(d),this.variable=A}}e.$yM=I}),define(Pe[201],Ae([1,0,19,52,16,24,22,90,166,200,15]),function(pe,e,y,R,I,M,A,d,k,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MM=void 0;class D{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(b,p,h,t){this.h=new Map,this.a=b,this.b=p,this.g=h,t&&(this.c=t.then(i=>this.i(i)))}i(b){if(A.$i){const p=Object.create(null);return Object.keys(b).forEach(h=>{p[h.toLowerCase()]=b[h]}),p}return b}resolveWithEnvironment(b,p,h){return this.l({env:this.i(b),userHome:void 0},p?p.uri:void 0,h)}async resolveAsync(b,p){const h={env:await this.c,userHome:await this.g};return this.l(h,b?b.uri:void 0,p)}async j(b,p,h,t){const i=M.$Im(p);A.$i&&i.windows?Object.keys(i.windows).forEach(g=>i[g]=i.windows[g]):A.$j&&i.osx?Object.keys(i.osx).forEach(g=>i[g]=i.osx[g]):A.$k&&i.linux&&Object.keys(i.linux).forEach(g=>i[g]=i.linux[g]),delete i.windows,delete i.osx,delete i.linux;const c={env:await this.c,userHome:await this.g};return this.l(c,b?b.uri:void 0,i,h,t)}async resolveAnyAsync(b,p,h){return this.j(b,p,h)}async resolveAnyMap(b,p,h){const t=new Map;return{newConfig:await this.j(b,p,h,t),resolvedVariables:t}}resolveWithInteractionReplace(b,p,h,t){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(b,p,h,t){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(b,p){if(this.h.has(b))throw new Error("Variable "+b+" is contributed twice.");this.h.set(b,p)}async l(b,p,h,t,i){if(I.$ie(h))return this.m(b,p,h,t,i);if(Array.isArray(h))return Promise.all(h.map(c=>this.l(b,p,c,t,i)));if(I.$ke(h)){const c=Object.create(null),g=await Promise.all(Object.keys(h).map(async S=>[await this.m(b,p,S,t,i),await this.l(b,p,h[S],t,i)]));for(const[S,C]of g)c[S]=C;return c}return h}m(b,p,h,t,i){return(0,P.$Dd)(h,D.VARIABLE_REGEXP,async(c,g)=>{if(g.includes(D.VARIABLE_LHS))return c;let S=await this.o(b,c,g,p,t);return i?.set(g,S),S!==c&&I.$ie(S)&&S.match(D.VARIABLE_REGEXP)&&(S=await this.m(b,p,S,t,i)),S})}n(b){return this.b?this.b.getUriLabel(b,{noPrefix:!0}):b.fsPath}async o(b,p,h,t,i){let c;const g=h.split(":");g.length>1&&(h=g[0],c=g[1]);const S=a=>{const r=this.a.getFilePath();if(r)return(0,d.$7z)(r);throw new f.$yM(a,(0,k.localize)(0,null,p))},C=a=>{const r=S(a);if(this.a.getWorkspaceFolderPathForFile){const s=this.a.getWorkspaceFolderPathForFile();if(s)return(0,d.$7z)(s)}throw new f.$yM(a,(0,k.localize)(1,null,p,y.$_c(r)))},n=a=>{if(c){const r=this.a.getFolderUri(c);if(r)return r;throw new f.$yM(a,(0,k.localize)(2,null,p,c))}if(t)return t;throw this.a.getWorkspaceFolderCount()>1?new f.$yM(a,(0,k.localize)(3,null,p)):new f.$yM(a,(0,k.localize)(4,null,p))};switch(h){case"env":if(c){if(b.env){const a=b.env[A.$i?c.toLowerCase():c];if(I.$ie(a))return a}return""}throw new f.$yM(f.VariableKind.Env,(0,k.localize)(5,null,p));case"config":if(c){const a=this.a.getConfigurationValue(t,c);if(I.$re(a))throw new f.$yM(f.VariableKind.Config,(0,k.localize)(6,null,p,c));if(I.$ke(a))throw new f.$yM(f.VariableKind.Config,(0,k.localize)(7,null,p,c));return a}throw new f.$yM(f.VariableKind.Config,(0,k.localize)(8,null,p));case"command":return this.p(f.VariableKind.Command,p,c,i,"command");case"input":return this.p(f.VariableKind.Input,p,c,i,"input");case"extensionInstallFolder":if(c){const a=await this.a.getExtension(c);if(!a)throw new f.$yM(f.VariableKind.ExtensionInstallFolder,(0,k.localize)(9,null,p,c));return this.n(a.extensionLocation)}throw new f.$yM(f.VariableKind.ExtensionInstallFolder,(0,k.localize)(10,null,p));default:switch(h){case"workspaceRoot":case"workspaceFolder":return(0,d.$7z)(this.n(n(f.VariableKind.WorkspaceFolder)));case"cwd":return t||c?(0,d.$7z)(this.n(n(f.VariableKind.Cwd))):R.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,d.$7z)(y.$_c(this.n(n(f.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(b.userHome)return b.userHome;throw new f.$yM(f.VariableKind.UserHome,(0,k.localize)(11,null,p))}case"lineNumber":{const a=this.a.getLineNumber();if(a)return a;throw new f.$yM(f.VariableKind.LineNumber,(0,k.localize)(12,null,p))}case"selectedText":{const a=this.a.getSelectedText();if(a)return a;throw new f.$yM(f.VariableKind.SelectedText,(0,k.localize)(13,null,p))}case"file":return S(f.VariableKind.File);case"fileWorkspaceFolder":return C(f.VariableKind.FileWorkspaceFolder);case"relativeFile":return t||c?y.$0c(this.n(n(f.VariableKind.RelativeFile)),S(f.VariableKind.RelativeFile)):S(f.VariableKind.RelativeFile);case"relativeFileDirname":{const a=y.$$c(S(f.VariableKind.RelativeFileDirname));if(t||c){const r=y.$0c(this.n(n(f.VariableKind.RelativeFileDirname)),a);return r.length===0?".":r}return a}case"fileDirname":return y.$$c(S(f.VariableKind.FileDirname));case"fileExtname":return y.$ad(S(f.VariableKind.FileExtname));case"fileBasename":return y.$_c(S(f.VariableKind.FileBasename));case"fileBasenameNoExtension":{const a=y.$_c(S(f.VariableKind.FileBasenameNoExtension));return a.slice(0,a.length-y.$ad(a).length)}case"fileDirnameBasename":return y.$_c(y.$$c(S(f.VariableKind.FileDirnameBasename)));case"execPath":{const a=this.a.getExecPath();return a||p}case"execInstallFolder":{const a=this.a.getAppRoot();return a||p}case"pathSeparator":return y.sep;default:try{const a=c?`${h}:${c}`:h;return this.p(f.VariableKind.Unknown,p,a,i,void 0)}catch{return p}}}}p(b,p,h,t,i){if(h&&t){const c=i===void 0?t[h]:t[i+":"+h];if(typeof c=="string")return c;throw new f.$yM(b,(0,k.localize)(14,null,p))}return p}}e.$MM=D}),define(Pe[103],Ae([1,0,4,99]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WC=e.$VC=e.OpenEditorContext=e.GroupsOrder=e.$UC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$TC=void 0,e.$TC=(0,y.$ph)("editorGroupsService");var I;(function(p){p[p.UP=0]="UP",p[p.DOWN=1]="DOWN",p[p.LEFT=2]="LEFT",p[p.RIGHT=3]="RIGHT"})(I||(e.GroupDirection=I={}));var M;(function(p){p[p.HORIZONTAL=0]="HORIZONTAL",p[p.VERTICAL=1]="VERTICAL"})(M||(e.GroupOrientation=M={}));var A;(function(p){p[p.FIRST=0]="FIRST",p[p.LAST=1]="LAST",p[p.NEXT=2]="NEXT",p[p.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var d;(function(p){p[p.MAXIMIZE=0]="MAXIMIZE",p[p.EVEN=1]="EVEN",p[p.TOGGLE=2]="TOGGLE"})(d||(e.GroupsArrangement=d={}));var k;(function(p){p[p.COPY_EDITORS=0]="COPY_EDITORS",p[p.MOVE_EDITORS=1]="MOVE_EDITORS"})(k||(e.MergeGroupMode=k={}));function f(p){const h=p;return(0,R.$JE)(h?.editor)&&(0,R.$JE)(h?.replacement)}e.$UC=f;var P;(function(p){p[p.CREATION_TIME=0]="CREATION_TIME",p[p.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",p[p.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(P||(e.GroupsOrder=P={}));var D;(function(p){p[p.NEW_EDITOR=1]="NEW_EDITOR",p[p.MOVE_EDITOR=2]="MOVE_EDITOR",p[p.COPY_EDITOR=3]="COPY_EDITOR"})(D||(e.OpenEditorContext=D={}));function u(p){const h=p;return!!h&&typeof h.id=="number"&&Array.isArray(h.editors)}e.$VC=u;function b(p){return p.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$WC=b}),define(Pe[202],Ae([1,0,4,103]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1C=e.$ZC=e.$YC=e.$XC=void 0,e.$XC=(0,y.$ph)("editorService"),e.$YC=-1,e.$ZC=-2;function I(M){const A=M;return typeof M=="number"||(0,R.$VC)(A)}e.$1C=I}),define(Pe[8],Ae([1,0,18,25,123,203,49,28,117,69,68,24,16,2,44,78,94,102,99,75,45,57,202,7]),function(pe,e,y,R,I,M,A,d,k,f,P,D,u,b,p,h,t,i,c,g,S,C,n,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$KL=e.$JL=e.MarkdownString=e.$IL=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var r;(function(Ie){function Le(H){const{selectionStartLineNumber:Fe,selectionStartColumn:Be,positionLineNumber:Ge,positionColumn:qe}=H,_e=new a.$MJ(Fe-1,Be-1),$t=new a.$MJ(Ge-1,qe-1);return new a.$OJ(_e,$t)}Ie.to=Le;function me(H){const{anchor:Fe,active:Be}=H;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:Be.line+1,positionColumn:Be.character+1}}Ie.from=me})(r||(e.Selection=r={}));var s;(function(Ie){function Le(H){if(!H)return;const{start:Fe,end:Be}=H;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:Be.line+1,endColumn:Be.character+1}}Ie.from=Le;function me(H){if(!H)return;const{startLineNumber:Fe,startColumn:Be,endLineNumber:Ge,endColumn:qe}=H;return new a.$NJ(Fe-1,Be-1,Ge-1,qe-1)}Ie.to=me})(s||(e.Range=s={}));var v;(function(Ie){function Le(me){switch(me){case 1:return a.StandardTokenType.Comment;case 0:return a.StandardTokenType.Other;case 3:return a.StandardTokenType.RegEx;case 2:return a.StandardTokenType.String}}Ie.to=Le})(v||(e.TokenType=v={}));var $;(function(Ie){function Le(H){return new a.$MJ(H.lineNumber-1,H.column-1)}Ie.to=Le;function me(H){return{lineNumber:H.line+1,column:H.character+1}}Ie.from=me})($||(e.Position=$={}));var w;(function(Ie){function Le(Fe,Be,Ge){return(0,y.$jf)((0,y.$Gf)(Fe).map(qe=>me(qe,Be,Ge)))}Ie.from=Le;function me(Fe,Be,Ge){if(typeof Fe=="string")return{$serialized:!0,language:Fe,isBuiltin:Ge?.isBuiltin};if(Fe)return{$serialized:!0,language:Fe.language,scheme:H(Fe.scheme,Be),pattern:st.from(Fe.pattern)??void 0,exclusive:Fe.exclusive,notebookType:Fe.notebookType,isBuiltin:Ge?.isBuiltin}}function H(Fe,Be){return Be&&typeof Fe=="string"?Be.transformOutgoingScheme(Fe):Fe}})(w||(e.DocumentSelector=w={}));var E;(function(Ie){function Le(H){switch(H){case a.DiagnosticTag.Unnecessary:return 1;case a.DiagnosticTag.Deprecated:return 2}}Ie.from=Le;function me(H){switch(H){case 1:return a.DiagnosticTag.Unnecessary;case 2:return a.DiagnosticTag.Deprecated;default:return}}Ie.to=me})(E||(e.DiagnosticTag=E={}));var o;(function(Ie){function Le(H){let Fe;return H.code&&((0,u.$ie)(H.code)||(0,u.$me)(H.code)?Fe=String(H.code):Fe={value:String(H.code.value),target:H.code.target}),{...s.from(H.range),message:H.message,source:H.source,code:Fe,severity:m.from(H.severity),relatedInformation:H.relatedInformation&&H.relatedInformation.map(l.from),tags:Array.isArray(H.tags)?(0,y.$jf)(H.tags.map(E.from)):void 0}}Ie.from=Le;function me(H){const Fe=new a.$ZJ(s.to(H),H.message,m.to(H.severity));return Fe.source=H.source,Fe.code=(0,u.$ie)(H.code)?H.code:H.code?.value,Fe.relatedInformation=H.relatedInformation&&H.relatedInformation.map(l.to),Fe.tags=H.tags&&(0,y.$jf)(H.tags.map(E.to)),Fe}Ie.to=me})(o||(e.Diagnostic=o={}));var l;(function(Ie){function Le(H){return{...s.from(H.location.range),message:H.message,resource:H.location.uri}}Ie.from=Le;function me(H){return new a.$YJ(new a.$XJ(H.resource,s.to(H)),H.message)}Ie.to=me})(l||(e.DiagnosticRelatedInformation=l={}));var m;(function(Ie){function Le(H){switch(H){case a.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case a.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case a.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case a.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}Ie.from=Le;function me(H){switch(H){case t.MarkerSeverity.Info:return a.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return a.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return a.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return a.DiagnosticSeverity.Hint;default:return a.DiagnosticSeverity.Error}}Ie.to=me})(m||(e.DiagnosticSeverity=m={}));var F;(function(Ie){function Le(H){return typeof H=="number"&&H>=a.ViewColumn.One?H-1:H===a.ViewColumn.Beside?n.$ZC:n.$YC}Ie.from=Le;function me(H){if(typeof H=="number"&&H>=0)return H+1;throw new Error("invalid 'EditorGroupColumn'")}Ie.to=me})(F||(e.ViewColumn=F={}));function W(Ie){return typeof Ie.range<"u"}function V(Ie){return Ie.length===0?!0:!!W(Ie[0])}e.$IL=V;var B;(function(Ie){function Le(qe){return qe.map(Ie.from)}Ie.fromMany=Le;function me(qe){return qe&&typeof qe=="object"&&typeof qe.language=="string"&&typeof qe.value=="string"}function H(qe){let _e;if(me(qe)){const{language:ct,value:mt}=qe;_e={value:"```"+ct+`
`+mt+"\n```\n"}}else a.$aK.isMarkdownString(qe)?_e={value:qe.value,isTrusted:qe.isTrusted,supportThemeIcons:qe.supportThemeIcons,supportHtml:qe.supportHtml,baseUri:qe.baseUri}:typeof qe=="string"?_e={value:qe}:_e={value:""};const $t=Object.create(null);_e.uris=$t;const Et=ct=>{try{let mt=b.URI.parse(ct,!0);mt=mt.with({query:Fe(mt.query,$t)}),$t[ct]=mt}catch{}return""},pt=new k.marked.Renderer;return pt.link=Et,pt.image=ct=>typeof ct=="string"?Et(A.$Rj(ct).href):"",(0,k.marked)(_e.value,{renderer:pt}),_e}Ie.from=H;function Fe(qe,_e){if(!qe)return qe;let $t;try{$t=(0,f.$Xg)(qe)}catch{}if(!$t)return qe;let Et=!1;return $t=(0,D.$Km)($t,pt=>{if(b.URI.isUri(pt)){const ct=`__uri_${Math.random().toString(16).slice(2,8)}`;return _e[ct]=pt,Et=!0,ct}else return}),Et?JSON.stringify($t):qe}function Be(qe){const _e=new a.$aK(qe.value,qe.supportThemeIcons);return _e.isTrusted=qe.isTrusted,_e.supportHtml=qe.supportHtml,_e.baseUri=qe.baseUri?b.URI.from(qe.baseUri):void 0,_e}Ie.to=Be;function Ge(qe){if(qe)return typeof qe=="string"?qe:Ie.from(qe)}Ie.fromStrict=Ge})(B||(e.MarkdownString=B={}));function j(Ie){return V(Ie)?Ie.map(Le=>({range:s.from(Le.range),hoverMessage:Array.isArray(Le.hoverMessage)?B.fromMany(Le.hoverMessage):Le.hoverMessage?B.from(Le.hoverMessage):void 0,renderOptions:Le.renderOptions})):Ie.map(Le=>({range:s.from(Le)}))}e.$JL=j;function U(Ie){return typeof Ie>"u"?Ie:typeof Ie=="string"?b.URI.file(Ie):Ie}e.$KL=U;var z;(function(Ie){function Le(me){return typeof me>"u"?me:{contentText:me.contentText,contentIconPath:me.contentIconPath?U(me.contentIconPath):void 0,border:me.border,borderColor:me.borderColor,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,color:me.color,backgroundColor:me.backgroundColor,margin:me.margin,width:me.width,height:me.height}}Ie.from=Le})(z||(e.ThemableDecorationAttachmentRenderOptions=z={}));var ne;(function(Ie){function Le(me){return typeof me>"u"?me:{backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?U(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?z.from(me.before):void 0,after:me.after?z.from(me.after):void 0}}Ie.from=Le})(ne||(e.ThemableDecorationRenderOptions=ne={}));var Z;(function(Ie){function Le(me){if(typeof me>"u")return me;switch(me){case a.DecorationRangeBehavior.OpenOpen:return 0;case a.DecorationRangeBehavior.ClosedClosed:return 1;case a.DecorationRangeBehavior.OpenClosed:return 2;case a.DecorationRangeBehavior.ClosedOpen:return 3}}Ie.from=Le})(Z||(e.DecorationRangeBehavior=Z={}));var we;(function(Ie){function Le(me){return{isWholeLine:me.isWholeLine,rangeBehavior:me.rangeBehavior?Z.from(me.rangeBehavior):void 0,overviewRulerLane:me.overviewRulerLane,light:me.light?ne.from(me.light):void 0,dark:me.dark?ne.from(me.dark):void 0,backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?U(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?z.from(me.before):void 0,after:me.after?z.from(me.after):void 0}}Ie.from=Le})(we||(e.DecorationRenderOptions=we={}));var Ee;(function(Ie){function Le(H){return{text:H.newText,eol:H.newEol&&Xe.from(H.newEol),range:s.from(H.range)}}Ie.from=Le;function me(H){const Fe=new a.$SJ(s.to(H.range),H.text);return Fe.newEol=typeof H.eol>"u"?void 0:Xe.to(H.eol),Fe}Ie.to=me})(Ee||(e.TextEdit=Ee={}));var Re;(function(Ie){function Le(H,Fe){const Be={edits:[]};if(H instanceof a.$VJ){const Ge=new d.$oi;for(const qe of H._allEntries())qe._type===1&&b.URI.isUri(qe.to)&&qe.from===void 0&&Ge.add(qe.to);for(const qe of H._allEntries())if(qe._type===1){let _e;qe.options?.contents&&(ArrayBuffer.isView(qe.options.contents)?_e={type:"base64",value:(0,R.$Yc)(R.$Ec.wrap(qe.options.contents))}:_e={type:"dataTransferItem",id:qe.options.contents._itemId}),Be.edits.push({oldResource:qe.from,newResource:qe.to,options:{...qe.options,contents:_e},metadata:qe.metadata})}else qe._type===2?Be.edits.push({resource:qe.uri,textEdit:Ee.from(qe.edit),versionId:Ge.has(qe.uri)?void 0:Fe?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===6?Be.edits.push({resource:qe.uri,textEdit:{range:s.from(qe.range),text:qe.edit.value,insertAsSnippet:!0},versionId:Ge.has(qe.uri)?void 0:Fe?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===3?Be.edits.push({metadata:qe.metadata,resource:qe.uri,cellEdit:qe.edit,notebookMetadata:qe.notebookMetadata,notebookVersionId:Fe?.getNotebookDocumentVersion(qe.uri)}):qe._type===5&&Be.edits.push({metadata:qe.metadata,resource:qe.uri,notebookVersionId:Fe?.getNotebookDocumentVersion(qe.uri),cellEdit:{editType:1,index:qe.index,count:qe.count,cells:qe.cells.map(ft.from)}})}return Be}Ie.from=Le;function me(H){const Fe=new a.$VJ,Be=new d.$ni;for(const Ge of H.edits)if(Ge.textEdit){const qe=Ge,_e=b.URI.revive(qe.resource),$t=s.to(qe.textEdit.range),Et=qe.textEdit.text,pt=qe.textEdit.insertAsSnippet;let ct;pt?ct=a.$UJ.replace($t,new a.$WJ(Et)):ct=a.$SJ.replace($t,Et);const mt=Be.get(_e);mt?mt.push(ct):Be.set(_e,[ct])}else Fe.renameFile(b.URI.revive(Ge.oldResource),b.URI.revive(Ge.newResource),Ge.options);for(const[Ge,qe]of Be)Fe.set(Ge,qe);return Fe}Ie.to=me})(Re||(e.WorkspaceEdit=Re={}));var X;(function(Ie){const Le=Object.create(null);Le[a.SymbolKind.File]=0,Le[a.SymbolKind.Module]=1,Le[a.SymbolKind.Namespace]=2,Le[a.SymbolKind.Package]=3,Le[a.SymbolKind.Class]=4,Le[a.SymbolKind.Method]=5,Le[a.SymbolKind.Property]=6,Le[a.SymbolKind.Field]=7,Le[a.SymbolKind.Constructor]=8,Le[a.SymbolKind.Enum]=9,Le[a.SymbolKind.Interface]=10,Le[a.SymbolKind.Function]=11,Le[a.SymbolKind.Variable]=12,Le[a.SymbolKind.Constant]=13,Le[a.SymbolKind.String]=14,Le[a.SymbolKind.Number]=15,Le[a.SymbolKind.Boolean]=16,Le[a.SymbolKind.Array]=17,Le[a.SymbolKind.Object]=18,Le[a.SymbolKind.Key]=19,Le[a.SymbolKind.Null]=20,Le[a.SymbolKind.EnumMember]=21,Le[a.SymbolKind.Struct]=22,Le[a.SymbolKind.Event]=23,Le[a.SymbolKind.Operator]=24,Le[a.SymbolKind.TypeParameter]=25;function me(Fe){return typeof Le[Fe]=="number"?Le[Fe]:6}Ie.from=me;function H(Fe){for(const Be in Le)if(Le[Be]===Fe)return Number(Be);return a.SymbolKind.Property}Ie.to=H})(X||(e.SymbolKind=X={}));var de;(function(Ie){function Le(H){switch(H){case a.SymbolTag.Deprecated:return 1}}Ie.from=Le;function me(H){switch(H){case 1:return a.SymbolTag.Deprecated}}Ie.to=me})(de||(e.SymbolTag=de={}));var Ce;(function(Ie){function Le(H){return{name:H.name,kind:X.from(H.kind),tags:H.tags&&H.tags.map(de.from),containerName:H.containerName,location:J.from(H.location)}}Ie.from=Le;function me(H){const Fe=new a.$3J(H.name,X.to(H.kind),H.containerName,J.to(H.location));return Fe.tags=H.tags&&H.tags.map(de.to),Fe}Ie.to=me})(Ce||(e.WorkspaceSymbol=Ce={}));var ae;(function(Ie){function Le(H){const Fe={name:H.name||"!!MISSING: name!!",detail:H.detail,range:s.from(H.range),selectionRange:s.from(H.selectionRange),kind:X.from(H.kind),tags:H.tags?.map(de.from)??[]};return H.children&&(Fe.children=H.children.map(Le)),Fe}Ie.from=Le;function me(H){const Fe=new a.$4J(H.name,H.detail,X.to(H.kind),s.to(H.range),s.to(H.selectionRange));return(0,y.$nf)(H.tags)&&(Fe.tags=H.tags.map(de.to)),H.children&&(Fe.children=H.children.map(me)),Fe}Ie.to=me})(ae||(e.DocumentSymbol=ae={}));var _;(function(Ie){function Le(H){const Fe=new a.$9J(X.to(H.kind),H.name,H.detail||"",b.URI.revive(H.uri),s.to(H.range),s.to(H.selectionRange));return Fe._sessionId=H._sessionId,Fe._itemId=H._itemId,Fe}Ie.to=Le;function me(H,Fe,Be){if(Fe=Fe??H._sessionId,Be=Be??H._itemId,Fe===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:Be,name:H.name,detail:H.detail,kind:X.from(H.kind),uri:H.uri,range:s.from(H.range),selectionRange:s.from(H.selectionRange),tags:H.tags?.map(de.from)}}Ie.from=me})(_||(e.CallHierarchyItem=_={}));var ue;(function(Ie){function Le(me){return new a.$0J(_.to(me.from),me.fromRanges.map(H=>s.to(H)))}Ie.to=Le})(ue||(e.CallHierarchyIncomingCall=ue={}));var O;(function(Ie){function Le(me){return new a.$$J(_.to(me.to),me.fromRanges.map(H=>s.to(H)))}Ie.to=Le})(O||(e.CallHierarchyOutgoingCall=O={}));var J;(function(Ie){function Le(H){return{range:H.range&&s.from(H.range),uri:H.uri}}Ie.from=Le;function me(H){return new a.$XJ(b.URI.revive(H.uri),s.to(H.range))}Ie.to=me})(J||(e.location=J={}));var le;(function(Ie){function Le(H){const Fe=H,Be=H;return{originSelectionRange:Fe.originSelectionRange?s.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:Be.uri,range:s.from(Fe.targetRange?Fe.targetRange:Be.range),targetSelectionRange:Fe.targetSelectionRange?s.from(Fe.targetSelectionRange):void 0}}Ie.from=Le;function me(H){return{targetUri:b.URI.revive(H.uri),targetRange:s.to(H.range),targetSelectionRange:H.targetSelectionRange?s.to(H.targetSelectionRange):void 0,originSelectionRange:H.originSelectionRange?s.to(H.originSelectionRange):void 0}}Ie.to=me})(le||(e.DefinitionLink=le={}));var ye;(function(Ie){function Le(H){return{range:s.from(H.range),contents:B.fromMany(H.contents)}}Ie.from=Le;function me(H){return new a.$1J(H.contents.map(B.to),s.to(H.range))}Ie.to=me})(ye||(e.Hover=ye={}));var ve;(function(Ie){function Le(H){return{range:s.from(H.range),expression:H.expression}}Ie.from=Le;function me(H){return new a.$UK(s.to(H.range),H.expression)}Ie.to=me})(ve||(e.EvaluatableExpression=ve={}));var be;(function(Ie){function Le(H){if(H instanceof a.$VK)return{type:"text",range:s.from(H.range),text:H.text};if(H instanceof a.$WK)return{type:"variable",range:s.from(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};if(H instanceof a.$XK)return{type:"expression",range:s.from(H.range),expression:H.expression};throw new Error("Unknown 'InlineValue' type")}Ie.from=Le;function me(H){switch(H.type){case"text":return{range:s.to(H.range),text:H.text};case"variable":return{range:s.to(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};case"expression":return{range:s.to(H.range),expression:H.expression}}}Ie.to=me})(be||(e.InlineValue=be={}));var ke;(function(Ie){function Le(H){return{frameId:H.frameId,stoppedLocation:s.from(H.stoppedLocation)}}Ie.from=Le;function me(H){return new a.$YK(H.frameId,s.to(H.stoppedLocation))}Ie.to=me})(ke||(e.InlineValueContext=ke={}));var oe;(function(Ie){function Le(H){return{range:s.from(H.range),kind:H.kind}}Ie.from=Le;function me(H){return new a.$2J(s.to(H.range),H.kind)}Ie.to=me})(oe||(e.DocumentHighlight=oe={}));var he;(function(Ie){function Le(me){switch(me){case 1:return a.CompletionTriggerKind.TriggerCharacter;case 2:return a.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return a.CompletionTriggerKind.Invoke}}Ie.to=Le})(he||(e.CompletionTriggerKind=he={}));var re;(function(Ie){function Le(me){return{triggerKind:he.to(me.triggerKind),triggerCharacter:me.triggerCharacter}}Ie.to=Le})(re||(e.CompletionContext=re={}));var ie;(function(Ie){function Le(H){switch(H){case a.CompletionItemTag.Deprecated:return 1}}Ie.from=Le;function me(H){switch(H){case 1:return a.CompletionItemTag.Deprecated}}Ie.to=me})(ie||(e.CompletionItemTag=ie={}));var ge;(function(Ie){const Le=new Map([[a.CompletionItemKind.Method,0],[a.CompletionItemKind.Function,1],[a.CompletionItemKind.Constructor,2],[a.CompletionItemKind.Field,3],[a.CompletionItemKind.Variable,4],[a.CompletionItemKind.Class,5],[a.CompletionItemKind.Interface,7],[a.CompletionItemKind.Struct,6],[a.CompletionItemKind.Module,8],[a.CompletionItemKind.Property,9],[a.CompletionItemKind.Unit,12],[a.CompletionItemKind.Value,13],[a.CompletionItemKind.Constant,14],[a.CompletionItemKind.Enum,15],[a.CompletionItemKind.EnumMember,16],[a.CompletionItemKind.Keyword,17],[a.CompletionItemKind.Snippet,27],[a.CompletionItemKind.Text,18],[a.CompletionItemKind.Color,19],[a.CompletionItemKind.File,20],[a.CompletionItemKind.Reference,21],[a.CompletionItemKind.Folder,23],[a.CompletionItemKind.Event,10],[a.CompletionItemKind.Operator,11],[a.CompletionItemKind.TypeParameter,24],[a.CompletionItemKind.Issue,26],[a.CompletionItemKind.User,25]]);function me(Be){return Le.get(Be)??9}Ie.from=me;const H=new Map([[0,a.CompletionItemKind.Method],[1,a.CompletionItemKind.Function],[2,a.CompletionItemKind.Constructor],[3,a.CompletionItemKind.Field],[4,a.CompletionItemKind.Variable],[5,a.CompletionItemKind.Class],[7,a.CompletionItemKind.Interface],[6,a.CompletionItemKind.Struct],[8,a.CompletionItemKind.Module],[9,a.CompletionItemKind.Property],[12,a.CompletionItemKind.Unit],[13,a.CompletionItemKind.Value],[14,a.CompletionItemKind.Constant],[15,a.CompletionItemKind.Enum],[16,a.CompletionItemKind.EnumMember],[17,a.CompletionItemKind.Keyword],[27,a.CompletionItemKind.Snippet],[18,a.CompletionItemKind.Text],[19,a.CompletionItemKind.Color],[20,a.CompletionItemKind.File],[21,a.CompletionItemKind.Reference],[23,a.CompletionItemKind.Folder],[10,a.CompletionItemKind.Event],[11,a.CompletionItemKind.Operator],[24,a.CompletionItemKind.TypeParameter],[25,a.CompletionItemKind.User],[26,a.CompletionItemKind.Issue]]);function Fe(Be){return H.get(Be)??a.CompletionItemKind.Property}Ie.to=Fe})(ge||(e.CompletionItemKind=ge={}));var Se;(function(Ie){function Le(me,H){const Fe=new a.$gK(me.label);return Fe.insertText=me.insertText,Fe.kind=ge.to(me.kind),Fe.tags=me.tags?.map(ie.to),Fe.detail=me.detail,Fe.documentation=A.$Mj(me.documentation)?B.to(me.documentation):me.documentation,Fe.sortText=me.sortText,Fe.filterText=me.filterText,Fe.preselect=me.preselect,Fe.commitCharacters=me.commitCharacters,p.$Ur.isIRange(me.range)?Fe.range=s.to(me.range):typeof me.range=="object"&&(Fe.range={inserting:s.to(me.range.insert),replacing:s.to(me.range.replace)}),Fe.keepWhitespace=typeof me.insertTextRules>"u"?!1:!!(me.insertTextRules&1),typeof me.insertTextRules<"u"&&me.insertTextRules&4?Fe.insertText=new a.$WJ(me.insertText):(Fe.insertText=me.insertText,Fe.textEdit=Fe.range instanceof a.$NJ?new a.$SJ(Fe.range,Fe.insertText):void 0),me.additionalTextEdits&&me.additionalTextEdits.length>0&&(Fe.additionalTextEdits=me.additionalTextEdits.map(Be=>Ee.to(Be))),Fe.command=H&&me.command?H.fromInternal(me.command):void 0,Fe}Ie.to=Le})(Se||(e.CompletionItem=Se={}));var L;(function(Ie){function Le(H){if(typeof H.label!="string"&&!Array.isArray(H.label))throw new TypeError("Invalid label");return{label:H.label,documentation:B.fromStrict(H.documentation)}}Ie.from=Le;function me(H){return{label:H.label,documentation:A.$Mj(H.documentation)?B.to(H.documentation):H.documentation}}Ie.to=me})(L||(e.ParameterInformation=L={}));var q;(function(Ie){function Le(H){return{label:H.label,documentation:B.fromStrict(H.documentation),parameters:Array.isArray(H.parameters)?H.parameters.map(L.from):[],activeParameter:H.activeParameter}}Ie.from=Le;function me(H){return{label:H.label,documentation:A.$Mj(H.documentation)?B.to(H.documentation):H.documentation,parameters:Array.isArray(H.parameters)?H.parameters.map(L.to):[],activeParameter:H.activeParameter}}Ie.to=me})(q||(e.SignatureInformation=q={}));var G;(function(Ie){function Le(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(q.from):[]}}Ie.from=Le;function me(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(q.to):[]}}Ie.to=me})(G||(e.SignatureHelp=G={}));var Q;(function(Ie){function Le(me,H){const Fe=new a.$fK($.to(H.position),typeof H.label=="string"?H.label:H.label.map(K.to.bind(void 0,me)),H.kind&&ee.to(H.kind));return Fe.textEdits=H.textEdits&&H.textEdits.map(Ee.to),Fe.tooltip=A.$Mj(H.tooltip)?B.to(H.tooltip):H.tooltip,Fe.paddingLeft=H.paddingLeft,Fe.paddingRight=H.paddingRight,Fe}Ie.to=Le})(Q||(e.InlayHint=Q={}));var K;(function(Ie){function Le(me,H){const Fe=new a.$eK(H.label);return Fe.tooltip=A.$Mj(H.tooltip)?B.to(H.tooltip):H.tooltip,h.Command.is(H.command)&&(Fe.command=me.fromInternal(H.command)),H.location&&(Fe.location=J.to(H.location)),Fe}Ie.to=Le})(K||(e.InlayHintLabelPart=K={}));var ee;(function(Ie){function Le(H){return H}Ie.from=Le;function me(H){return H}Ie.to=me})(ee||(e.InlayHintKind=ee={}));var ce;(function(Ie){function Le(H){return{range:s.from(H.range),url:H.target,tooltip:H.tooltip}}Ie.from=Le;function me(H){let Fe;if(H.url)try{Fe=typeof H.url=="string"?b.URI.parse(H.url,!0):b.URI.revive(H.url)}catch{}return new a.$lK(s.to(H.range),Fe)}Ie.to=me})(ce||(e.DocumentLink=ce={}));var ze;(function(Ie){function Le(H){const Fe=new a.$oK(H.label);return H.textEdit&&(Fe.textEdit=Ee.to(H.textEdit)),H.additionalTextEdits&&(Fe.additionalTextEdits=H.additionalTextEdits.map(Be=>Ee.to(Be))),Fe}Ie.to=Le;function me(H){return{label:H.label,textEdit:H.textEdit?Ee.from(H.textEdit):void 0,additionalTextEdits:H.additionalTextEdits?H.additionalTextEdits.map(Fe=>Ee.from(Fe)):void 0}}Ie.from=me})(ze||(e.ColorPresentation=ze={}));var Ue;(function(Ie){function Le(H){return new a.$mK(H[0],H[1],H[2],H[3])}Ie.to=Le;function me(H){return[H.red,H.green,H.blue,H.alpha]}Ie.from=me})(Ue||(e.Color=Ue={}));var Qe;(function(Ie){function Le(H){return{range:s.from(H.range)}}Ie.from=Le;function me(H){return new a.$8J(s.to(H.range))}Ie.to=me})(Qe||(e.SelectionRange=Qe={}));var He;(function(Ie){function Le(me){switch(me){case 2:return a.TextDocumentSaveReason.AfterDelay;case 1:return a.TextDocumentSaveReason.Manual;case 3:case 4:return a.TextDocumentSaveReason.FocusOut}}Ie.to=Le})(He||(e.TextDocumentSaveReason=He={}));var et;(function(Ie){function Le(H){switch(H){case a.TextEditorLineNumbersStyle.Off:return 0;case a.TextEditorLineNumbersStyle.Relative:return 2;case a.TextEditorLineNumbersStyle.On:default:return 1}}Ie.from=Le;function me(H){switch(H){case 0:return a.TextEditorLineNumbersStyle.Off;case 2:return a.TextEditorLineNumbersStyle.Relative;case 1:default:return a.TextEditorLineNumbersStyle.On}}Ie.to=me})(et||(e.TextEditorLineNumbersStyle=et={}));var Xe;(function(Ie){function Le(H){if(H===a.EndOfLine.CRLF)return 1;if(H===a.EndOfLine.LF)return 0}Ie.from=Le;function me(H){if(H===1)return a.EndOfLine.CRLF;if(H===0)return a.EndOfLine.LF}Ie.to=me})(Xe||(e.EndOfLine=Xe={}));var xe;(function(Ie){function Le(me){if(typeof me=="object")return me.viewId;switch(me){case a.ProgressLocation.SourceControl:return 3;case a.ProgressLocation.Window:return 10;case a.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ie.from=Le})(xe||(e.ProgressLocation=xe={}));var it;(function(Ie){function Le(H){const Fe={start:H.start+1,end:H.end+1};return H.kind&&(Fe.kind=tt.from(H.kind)),Fe}Ie.from=Le;function me(H){const Fe={start:H.start-1,end:H.end-1};return H.kind&&(Fe.kind=tt.to(H.kind)),Fe}Ie.to=me})(it||(e.FoldingRange=it={}));var tt;(function(Ie){function Le(H){if(H)switch(H){case a.FoldingRangeKind.Comment:return h.$As.Comment;case a.FoldingRangeKind.Imports:return h.$As.Imports;case a.FoldingRangeKind.Region:return h.$As.Region}}Ie.from=Le;function me(H){if(H)switch(H.value){case h.$As.Comment.value:return a.FoldingRangeKind.Comment;case h.$As.Imports.value:return a.FoldingRangeKind.Imports;case h.$As.Region.value:return a.FoldingRangeKind.Region}}Ie.to=me})(tt||(e.FoldingRangeKind=tt={}));var Ne;(function(Ie){function Le(me){if(me)return{pinned:typeof me.preview=="boolean"?!me.preview:void 0,inactive:me.background,preserveFocus:me.preserveFocus,selection:typeof me.selection=="object"?s.from(me.selection):void 0,override:typeof me.override=="boolean"?c.$wE.id:void 0}}Ie.from=Le})(Ne||(e.TextEditorOpenOptions=Ne={}));var st;(function(Ie){function Le(Be){return Be instanceof a.$IK?Be.toJSON():typeof Be=="string"?Be:me(Be)||H(Be)?new a.$IK(Be.baseUri??Be.base,Be.pattern).toJSON():Be}Ie.from=Le;function me(Be){const Ge=Be;return Ge?b.URI.isUri(Ge.baseUri)&&typeof Ge.pattern=="string":!1}function H(Be){const Ge=Be;return Ge?typeof Ge.base=="string"&&typeof Ge.pattern=="string":!1}function Fe(Be){return typeof Be=="string"?Be:new a.$IK(b.URI.revive(Be.baseUri),Be.pattern)}Ie.to=Fe})(st||(e.GlobPattern=st={}));var x;(function(Ie){function Le(me){if(me){if(Array.isArray(me))return me.map(Le);if(typeof me=="string")return me;{const H=me;return{language:H.language,scheme:H.scheme,pattern:st.from(H.pattern),exclusive:H.exclusive,notebookType:H.notebookType}}}else return}Ie.from=Le})(x||(e.LanguageSelector=x={}));var Y;(function(Ie){function Le(H){return!!H&&typeof H=="object"&&"selections"in H&&Array.isArray(H.selections)&&H.selections.every(Fe=>Fe instanceof a.$OJ)&&"related"in H&&Array.isArray(H.related)&&H.related.every(Fe=>Fe&&typeof Fe=="object"&&b.URI.isUri(Fe.uri)&&Fe.range instanceof a.$NJ)}Ie.is=Le;function me(H){return{selections:H.selections.map(Fe=>r.from(Fe)),related:H.related.map(Fe=>({uri:b.URI.from(Fe.uri),range:s.from(Fe.range)}))}}Ie.from=me})(Y||(e.MappedEditsContext=Y={}));var $e;(function(Ie){function Le(H){return{start:H.start,end:H.end}}Ie.from=Le;function me(H){return new a.$0K(H.start,H.end)}Ie.to=me})($e||(e.NotebookRange=$e={}));var je;(function(Ie){function Le(H){return{timing:typeof H.runStartTime=="number"&&typeof H.runEndTime=="number"?{startTime:H.runStartTime,endTime:H.runEndTime}:void 0,executionOrder:H.executionOrder,success:H.lastRunSuccess}}Ie.to=Le;function me(H){return{lastRunSuccess:H.success,runStartTime:H.timing?.startTime,runEndTime:H.timing?.endTime,executionOrder:H.executionOrder}}Ie.from=me})(je||(e.NotebookCellExecutionSummary=je={}));var Oe;(function(Ie){function Le(me){if(me===g.NotebookCellExecutionState.Unconfirmed)return a.NotebookCellExecutionState.Pending;if(me===g.NotebookCellExecutionState.Pending)return;if(me===g.NotebookCellExecutionState.Executing)return a.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${me}`)}Ie.to=Le})(Oe||(e.NotebookCellExecutionState=Oe={}));var Ye;(function(Ie){function Le(H){switch(H){case a.NotebookCellKind.Markup:return g.CellKind.Markup;case a.NotebookCellKind.Code:default:return g.CellKind.Code}}Ie.from=Le;function me(H){switch(H){case g.CellKind.Markup:return a.NotebookCellKind.Markup;case g.CellKind.Code:default:return a.NotebookCellKind.Code}}Ie.to=me})(Ye||(e.NotebookCellKind=Ye={}));var nt;(function(Ie){function Le(H){const Fe={metadata:H.metadata??Object.create(null),cells:[]};for(const Be of H.cells)a.$$K.validate(Be),Fe.cells.push(ft.from(Be));return Fe}Ie.from=Le;function me(H){const Fe=new a.$_K(H.cells.map(ft.to));return(0,u.$ve)(H.metadata)||(Fe.metadata=H.metadata),Fe}Ie.to=me})(nt||(e.NotebookData=nt={}));var ft;(function(Ie){function Le(H){return{cellKind:Ye.from(H.kind),language:H.languageId,mime:H.mime,source:H.value,metadata:H.metadata,internalMetadata:je.from(H.executionSummary??{}),outputs:H.outputs?H.outputs.map(Tt.from):[]}}Ie.from=Le;function me(H){return new a.$$K(Ye.to(H.cellKind),H.source,H.language,H.mime,H.outputs?H.outputs.map(Tt.to):void 0,H.metadata,H.internalMetadata?je.to(H.internalMetadata):void 0)}Ie.to=me})(ft||(e.NotebookCellData=ft={}));var bt;(function(Ie){function Le(H){return{mime:H.mime,valueBytes:R.$Ec.wrap(H.data)}}Ie.from=Le;function me(H){return new a.$aL(H.valueBytes.buffer,H.mime)}Ie.to=me})(bt||(e.NotebookCellOutputItem=bt={}));var Tt;(function(Ie){function Le(H){return{outputId:H.id,items:H.items.map(bt.from),metadata:H.metadata}}Ie.from=Le;function me(H){const Fe=H.items.map(bt.to);return new a.$bL(Fe,H.outputId,H.metadata)}Ie.to=me})(Tt||(e.NotebookCellOutput=Tt={}));var Yt;(function(Ie){function Le(Fe){return H(Fe)?{include:st.from(Fe.include)??void 0,exclude:st.from(Fe.exclude)??void 0}:st.from(Fe)??void 0}Ie.from=Le;function me(Fe){return H(Fe)?{include:st.to(Fe.include),exclude:st.to(Fe.exclude)}:st.to(Fe)}Ie.to=me;function H(Fe){const Be=Fe;return Be?!(0,u.$re)(Be.include)&&!(0,u.$re)(Be.exclude):!1}})(Yt||(e.NotebookExclusiveDocumentPattern=Yt={}));var Vt;(function(Ie){function Le(me,H,Fe){const Be=typeof me.command=="string"?{title:"",command:me.command}:me.command;return{alignment:me.alignment===a.NotebookCellStatusBarAlignment.Left?1:2,command:H.toInternal(Be,Fe),text:me.text,tooltip:me.tooltip,accessibilityInformation:me.accessibilityInformation,priority:me.priority}}Ie.from=Le})(Vt||(e.NotebookStatusBarItem=Vt={}));var vt;(function(Ie){function Le(me,H,Fe){const Be=typeof me.command=="string"?{title:"",command:me.command}:me.command;return{command:H.toInternal(Be,Fe),label:me.label,description:me.description,detail:me.detail,documentation:me.documentation}}Ie.from=Le})(vt||(e.NotebookKernelSourceAction=vt={}));var Mt;(function(Ie){function Le(me){return{transientOutputs:me?.transientOutputs??!1,transientCellMetadata:me?.transientCellMetadata??{},transientDocumentMetadata:me?.transientDocumentMetadata??{},cellContentMetadata:me?.cellContentMetadata??{}}}Ie.from=Le})(Mt||(e.NotebookDocumentContentOptions=Mt={}));var Ot;(function(Ie){function Le(H){return{uri:H.uri,provides:H.provides}}Ie.from=Le;function me(H){return new a.$dL(b.URI.revive(H.uri),H.provides)}Ie.to=me})(Ot||(e.NotebookRendererScript=Ot={}));var Jt;(function(Ie){function Le(H){return{message:B.fromStrict(H.message)||"",type:0,expected:H.expectedOutput,actual:H.actualOutput,contextValue:H.contextValue,location:H.location&&{range:s.from(H.location.range),uri:H.location.uri}}}Ie.from=Le;function me(H){const Fe=new a.$jL(typeof H.message=="string"?H.message:B.to(H.message));return Fe.actualOutput=H.actual,Fe.expectedOutput=H.expected,Fe.contextValue=H.contextValue,Fe.location=H.location?J.to(H.location):void 0,Fe}Ie.to=me})(Jt||(e.TestMessage=Jt={}));var At;(function(Ie){Ie.namespace=C.$AI,Ie.denamespace=C.$BI})(At||(e.TestTag=At={}));var Rt;(function(Ie){function Le(H){const Fe=(0,i.$HL)(H).controllerId;return{extId:S.$wI.fromExtHostTestItem(H,Fe).toString(),label:H.label,uri:b.URI.revive(H.uri),busy:H.busy,tags:H.tags.map(Be=>At.namespace(Fe,Be.id)),range:p.$Ur.lift(s.from(H.range)),description:H.description||null,sortText:H.sortText||null,error:H.error&&B.fromStrict(H.error)||null}}Ie.from=Le;function me(H){return{parent:void 0,error:void 0,id:S.$wI.fromString(H.extId).localId,label:H.label,uri:b.URI.revive(H.uri),tags:(H.tags||[]).map(Fe=>{const{tagId:Be}=At.denamespace(Fe);return new a.$kL(Be)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:s.to(H.range||void 0),canResolveChildren:!1,busy:H.busy,description:H.description||void 0,sortText:H.sortText||void 0}}Ie.toPlain=me})(Rt||(e.TestItem=Rt={})),function(Ie){function Le(H){return{id:H.id}}Ie.from=Le;function me(H){return new a.$kL(H.id)}Ie.to=me}(At||(e.TestTag=At={}));var Nt;(function(Ie){const Le=(H,Fe)=>{const Be=[];for(const[qe,_e]of Fe)S.$wI.compare(_e.item.extId,qe)===2&&(Fe.delete(qe),Be.push(_e));const Ge={...Rt.toPlain(H.item),parent:void 0,taskStates:H.tasks.map(qe=>({state:qe.state,duration:qe.duration,messages:qe.messages.filter(_e=>_e.type===0).map(Jt.to)})),children:Be.map(qe=>Le(qe,Fe))};for(const qe of Ge.children)qe.parent=Ge;return Ge};function me(H){const Fe=[],Be=new Map;for(const Ge of H.items){Be.set(Ge.item.extId,Ge);const qe=S.$wI.root(Ge.item.extId);H.request.targets.some(_e=>_e.controllerId===qe&&_e.testIds.includes(Ge.item.extId))&&Fe.push(Ge)}return{completedAt:H.completedAt,results:Fe.map(Ge=>Le(Ge,Be))}}Ie.to=me})(Nt||(e.TestResults=Nt={}));var jt;(function(Ie){function Le(Be){return{covered:Be.covered,total:Be.covered}}function me(Be){return"line"in Be?$.from(Be):s.from(Be)}function H(Be){return"branches"in Be?{count:Be.executionCount,location:me(Be.location),type:1,branches:Be.branches.length?Be.branches.map(Ge=>({count:Ge.executionCount,location:Ge.location&&me(Ge.location)})):void 0}:{type:0,count:Be.executionCount,location:me(Be.location)}}Ie.fromDetailed=H;function Fe(Be){return{uri:Be.uri,statement:Le(Be.statementCoverage),branch:Be.branchCoverage&&Le(Be.branchCoverage),function:Be.functionCoverage&&Le(Be.functionCoverage),details:Be.detailedCoverage?.map(H)}}Ie.fromFile=Fe})(jt||(e.TestCoverage=jt={}));var qt;(function(Ie){function Le(me){switch(me){case 1:return a.CodeActionTriggerKind.Invoke;case 2:return a.CodeActionTriggerKind.Automatic}}Ie.to=Le})(qt||(e.CodeActionTriggerKind=qt={}));var Bt;(function(Ie){function Le(H){const Fe=new a.$qL(X.to(H.kind),H.name,H.detail||"",b.URI.revive(H.uri),s.to(H.range),s.to(H.selectionRange));return Fe._sessionId=H._sessionId,Fe._itemId=H._itemId,Fe}Ie.to=Le;function me(H,Fe,Be){if(Fe=Fe??H._sessionId,Be=Be??H._itemId,Fe===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:Be,kind:X.from(H.kind),name:H.name,detail:H.detail??"",uri:H.uri,range:s.from(H.range),selectionRange:s.from(H.selectionRange),tags:H.tags?.map(de.from)}}Ie.from=me})(Bt||(e.TypeHierarchyItem=Bt={}));var at;(function(Ie){function Le(me){if(me)return{value:me.value,tooltip:me.tooltip}}Ie.from=Le})(at||(e.ViewBadge=at={}));var lt;(function(Ie){function Le(Be,Ge,qe){const _e=Ge.fileData;return _e?new a.$BK(new a.$CK(_e.name,b.URI.revive(_e.uri),_e.id,(0,M.$cb)(()=>qe(_e.id)))):Be===P.$yr.uriList&&Ge.uriListData?new a.$AK(Fe(Ge.uriListData)):new a.$AK(Ge.asString)}Ie.to=Le;async function me(Be,Ge){const qe=await Ge.asString();if(Be===P.$yr.uriList)return{asString:qe,fileData:void 0,uriListData:H(qe)};const _e=Ge.asFile();return{asString:qe,fileData:_e?{name:_e.name,uri:_e.uri,id:_e._itemId??_e.id}:void 0}}Ie.from=me;function H(Be){return I.$is.split(Be).map(Ge=>{if(Ge.startsWith("#"))return Ge;try{return b.URI.parse(Ge)}catch{}return Ge})}function Fe(Be){return I.$is.create(Be.map(Ge=>typeof Ge=="string"?Ge:b.URI.revive(Ge)))}})(lt||(e.DataTransferItem=lt={}));var Ht;(function(Ie){function Le(H,Fe){const Be=H.items.map(([Ge,qe])=>[Ge,lt.to(Ge,qe,Fe)]);return new a.$DK(Be)}Ie.toDataTransfer=Le;async function me(H){const Fe={items:[]},Be=[];for(const[Ge,qe]of H)Be.push((async()=>{Fe.items.push([Ge,await lt.from(Ge,qe)])})());return await Promise.all(Be),Fe}Ie.from=me})(Ht||(e.DataTransfer=Ht={}));var Pt;(function(Ie){function Le(H){return{message:H.message,metadata:H.metadata,title:H.title,tooltip:H.tooltip}}Ie.to=Le;function me(H){return{kind:"reply",message:H.message,metadata:H.metadata,title:H.title,tooltip:H.tooltip}}Ie.from=me})(Pt||(e.ChatReplyFollowup=Pt={}));var kt;(function(Ie){function Le(me){return typeof me=="string"?{title:me,message:me,kind:"reply"}:"commandId"in me?{kind:"command",title:me.title??"",commandId:me.commandId??"",when:me.when??"",args:me.args}:Pt.from(me)}Ie.from=Le})(kt||(e.ChatFollowup=kt={}));var dt;(function(Ie){function Le(H){const Fe=new a.$AL(It.to(H.role),H.content);return Fe.name=H.name,Fe}Ie.to=Le;function me(H){return{role:It.from(H.role),content:H.content,name:H.name}}Ie.from=me})(dt||(e.ChatMessage=dt={}));var It;(function(Ie){function Le(H){switch(H){case 0:return a.ChatMessageRole.System;case 1:return a.ChatMessageRole.User;case 2:return a.ChatMessageRole.Assistant;case 3:return a.ChatMessageRole.Function}}Ie.to=Le;function me(H){switch(H){case a.ChatMessageRole.System:return 0;case a.ChatMessageRole.Assistant:return 2;case a.ChatMessageRole.Function:return 3;case a.ChatMessageRole.User:default:return 1}}Ie.from=me})(It||(e.ChatMessageRole=It={}));var zt;(function(Ie){function Le(H){return{level:yt.to(H.level),value:H.value,description:H.description}}Ie.to=Le;function me(H){return{level:yt.from(H.level),value:H.value,description:H.description}}Ie.from=me})(zt||(e.ChatVariable=zt={}));var yt;(function(Ie){function Le(H){switch(H){case"short":return a.ChatVariableLevel.Short;case"medium":return a.ChatVariableLevel.Medium;case"full":default:return a.ChatVariableLevel.Full}}Ie.to=Le;function me(H){switch(H){case a.ChatVariableLevel.Short:return"short";case a.ChatVariableLevel.Medium:return"medium";case a.ChatVariableLevel.Full:default:return"full"}}Ie.from=me})(yt||(e.ChatVariableLevel=yt={}));var Ve;(function(Ie){function Le(me,H,Fe){return"terminalCommand"in me?{terminalCommand:me.terminalCommand}:"uri"in me?{uri:me.uri}:H.toInternal(me,Fe)}Ie.from=Le})(Ve||(e.TerminalQuickFix=Ve={}))}),define(Pe[204],Ae([1,0,2,9,7,8,174]),function(pe,e,y,R,I,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fac=void 0;class d{constructor(f,P,D,u={timeout:1500,errors:3}){this.c=f,this.d=P,this.f=D,this.g=u,this.a=new A.$ub,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(f){return(P,D,u)=>{const p={dispose:this.a.push([P,D,f])};return Array.isArray(u)&&u.push(p),p}}async $participateInSave(f,P){const D=y.URI.revive(f);let u=!1;const b=setTimeout(()=>u=!0,this.g.timeout),p=[];try{for(const h of[...this.a]){if(u)break;const t=this.d.getDocument(D),i=await this.h(h,{document:t,reason:M.TextDocumentSaveReason.to(P)});p.push(i)}}finally{clearTimeout(b)}return p}h([f,P,D],u){const b=this.b.get(f);return typeof b=="number"&&b>this.g.errors?Promise.resolve(!1):this.i(D,f,P,u).then(()=>!0,p=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' threw ERROR`),this.c.error(p),!(p instanceof Error)||p.message!=="concurrent_edits"){const h=this.b.get(f);this.b.set(f,h?h+1:1),typeof h=="number"&&h>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(f,P,D,u){const b=[],p=Date.now(),{document:h,reason:t}=u,{version:i}=h,c=Object.freeze({document:h,reason:t,waitUntil(g){if(Object.isFrozen(b))throw(0,R.$6)("waitUntil can not be called async");b.push(Promise.resolve(g))}});try{P.apply(D,[c])}catch(g){return Promise.reject(g)}return Object.freeze(b),new Promise((g,S)=>{const C=setTimeout(()=>S(new Error("timeout")),this.g.timeout);return Promise.all(b).then(n=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${f.identifier.value}' finished after ${Date.now()-p}ms`),clearTimeout(C),g(n)}).catch(n=>{clearTimeout(C),S(n)})}).then(g=>{const S={edits:[]};for(const C of g)if(Array.isArray(C)&&C.every(n=>n instanceof I.$SJ))for(const{newText:n,newEol:a,range:r}of C)S.edits.push({resource:h.uri,versionId:void 0,textEdit:{range:r&&M.Range.from(r),text:n,eol:a&&M.EndOfLine.from(a)}});if(S.edits.length!==0)return i===h.version?this.f.$tryApplyWorkspaceEdit(S):Promise.reject(new Error("concurrent_edits"))})}}e.$Fac=d}),define(Pe[205],Ae([1,0,12,2,8,7,75]),function(pe,e,y,R,I,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tbc=e.$Sbc=void 0;class d{constructor(D,u,b,p){this.start=D,this.deletedCount=u,this.deletedItems=b,this.items=p}asApiEvent(){return{range:new M.$0K(this.start,this.start+this.deletedCount),addedCells:this.items.map(D=>D.apiCell),removedCells:this.deletedItems}}}class k{static asModelAddData(D,u){return{EOL:u.eol,lines:u.source,languageId:u.language,uri:u.uri,isDirty:!1,versionId:1,notebook:D}}constructor(D,u,b){this.notebook=D,this.h=u,this.j=b,this.handle=b.handle,this.uri=R.URI.revive(b.uri),this.cellKind=b.cellKind,this.a=b.outputs.map(I.NotebookCellOutput.to),this.e=b.internalMetadata??{},this.b=Object.freeze(b.metadata??{}),this.d=Object.freeze(I.NotebookCellExecutionSummary.to(b.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const D=this,u=this.h.getDocument(this.uri);if(!u)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const b={get index(){return D.notebook.getCellIndex(D)},notebook:D.notebook.apiNotebook,kind:I.NotebookCellKind.to(this.j.cellKind),document:u.document,get mime(){return D.g},set mime(p){D.g=p},get outputs(){return D.a.slice(0)},get metadata(){return D.b},get executionSummary(){return D.d}};this.f=Object.freeze(b)}return this.f}setOutputs(D){this.a=D.map(I.NotebookCellOutput.to)}setOutputItems(D,u,b){const p=b.map(I.NotebookCellOutputItem.to),h=this.a.find(t=>t.id===D);if(h&&(u||(h.items.length=0),h.items.push(...p),h.items.length>1&&h.items.every(t=>A.$RH(t.mime)))){const t=new Map,i=[];h.items.forEach(c=>{let g;t.has(c.mime)?g=t.get(c.mime):(g=[],t.set(c.mime,g),i.push(c.mime)),g.push(c.data)}),h.items.length=0,i.forEach(c=>{const g=A.$SH(t.get(c));h.items.push({mime:c,data:g.data.buffer})})}}setMetadata(D){this.b=Object.freeze(D)}setInternalMetadata(D){this.e=D,this.d=Object.freeze(I.NotebookCellExecutionSummary.to(D))}setMime(D){}}e.$Sbc=k;class f{static{this.a=0}constructor(D,u,b,p,h){this.k=D,this.l=u,this.m=b,this.uri=p,this.handle=f.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=h.viewType,this.f=Object.freeze(h.metadata??Object.create(null)),this.r([[0,0,h.cells]],!0,void 0),this.g=h.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const D=this,u={get uri(){return D.uri},get version(){return D.g},get notebookType(){return D.d},get isDirty(){return D.h},get isUntitled(){return D.uri.scheme===y.Schemas.untitled},get isClosed(){return D.j},get metadata(){return D.f},get cellCount(){return D.b.length},cellAt(b){return b=D.n(b),D.b[b].apiCell},getCells(b){return(b?D.p(b):D.b).map(h=>h.apiCell)},save(){return D.q()}};this.e=Object.freeze(u)}return this.e}acceptDocumentPropertiesChanged(D){D.metadata&&(this.f=Object.freeze({...this.f,...D.metadata}))}acceptDirty(D){this.h=D}acceptModelChanged(D,u,b){this.g=D.versionId,this.h=u,this.acceptDocumentPropertiesChanged({metadata:b});const p={notebook:this.apiNotebook,metadata:b,cellChanges:[],contentChanges:[]},h=[];for(const i of D.rawEvents)i.kind===A.NotebookCellsChangeType.ModelChange?this.r(i.changes,!1,p.contentChanges):i.kind===A.NotebookCellsChangeType.Move?this.s(i.index,i.length,i.newIdx,p.contentChanges):i.kind===A.NotebookCellsChangeType.Output?(this.t(i.index,i.outputs),h.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===A.NotebookCellsChangeType.OutputItem?(this.u(i.index,i.outputId,i.append,i.outputItems),h.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(i.index,i.language),h.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document})):i.kind===A.NotebookCellsChangeType.ChangeCellContent?h.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document}):i.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(i.index,i.mime):i.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(i.index,i.metadata),h.push({cell:this.b[i.index].apiCell,metadata:this.b[i.index].apiCell.metadata})):i.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(i.index,i.internalMetadata),h.push({cell:this.b[i.index].apiCell,executionSummary:this.b[i.index].apiCell.executionSummary}));const t=new Map;for(let i=0;i<h.length;i++){const c=h[i],g=t.get(c.cell);if(g===void 0){const S=p.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...c});t.set(c.cell,S-1)}else p.cellChanges[g]={...p.cellChanges[g],...c}}return Object.freeze(p),Object.freeze(p.cellChanges),Object.freeze(p.contentChanges),p}n(D){return D=D|0,D<0?0:D>=this.b.length?this.b.length-1:D}o(D){let u=D.start|0,b=D.end|0;return u<0&&(u=0),b>this.b.length&&(b=this.b.length),D.with({start:u,end:b})}p(D){D=this.o(D);const u=[];for(let b=D.start;b<D.end;b++)u.push(this.b[b]);return u}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(D,u,b){if(this.j)return;const p=[],h=[],t=[];if(D.reverse().forEach(i=>{const g=i[2].map(n=>{const a=new k(this,this.l,n);return u||h.push(k.asModelAddData(this.apiNotebook,n)),a}),S=new d(i[0],i[1],[],g),C=this.b.splice(i[0],i[1],...g);for(const n of C)t.push(n.uri),S.deletedItems.push(n.apiCell);p.push(S)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:h,removedDocuments:t}),b)for(const i of p)b.push(i.asApiEvent())}s(D,u,b,p){const h=this.b.splice(D,u);this.b.splice(b,0,...h);const t=[new d(D,u,h.map(i=>i.apiCell),[]),new d(b,0,[],h)];for(const i of t)p.push(i.asApiEvent())}t(D,u){this.b[D].setOutputs(u)}u(D,u,b,p){this.b[D].setOutputItems(u,b,p)}v(D,u){const b=this.b[D];b.apiCell.document.languageId!==u&&this.m.$acceptModelLanguageChanged(b.uri,u)}w(D,u){const b=this.b[D];b.apiCell.mime=u}x(D,u){this.b[D].setMetadata(u)}y(D,u){this.b[D].setInternalMetadata(u)}getCellFromApiCell(D){return this.b.find(u=>u.apiCell===D)}getCellFromIndex(D){return this.b[D]}getCell(D){return this.b.find(u=>u.handle===D)}getCellIndex(D){return this.b.indexOf(D)}}e.$Tbc=f}),define(Pe[206],Ae([1,0,5,2,8,7]),function(pe,e,y,R,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hcc=void 0;class A{constructor(k,f,P,D={timeout:1500,errors:3}){this.b=k,this.c=f,this.d=P,this.f=D,this.a=new y.$gc}dispose(){}getOnWillSaveNotebookDocumentEvent(k){return(f,P,D)=>{const u=function(p){f.call(P,p)};return u.extension=k,this.a.event(u,void 0,D)}}async $participateInSave(k,f,P){const D=R.URI.revive(k),u=this.c.getNotebookDocument(D);if(!u)throw new Error("Unable to resolve notebook document");const b=[];if(await this.a.fireAsync({notebook:u.apiNotebook,reason:I.TextDocumentSaveReason.to(f)},P,async(h,t)=>{const i=Date.now(),c=await await Promise.resolve(h);Date.now()-i>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier),!P.isCancellationRequested&&c&&(c instanceof M.$VJ?b.push(c):this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier,"ignored due to invalid data"))}),P.isCancellationRequested)return!1;if(b.length===0)return!0;const p={edits:[]};for(const h of b){const{edits:t}=I.WorkspaceEdit.from(h);p.edits=p.edits.concat(t)}return this.d.$tryApplyWorkspaceEdit(p)}}e.$hcc=A}),define(Pe[104],Ae([1,0,9,8,7]),function(pe,e,y,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ubc=void 0;class M{static{this.apiEditorsToExtHost=new WeakMap}constructor(d,k,f,P,D,u){this.id=d,this.f=k,this.notebookData=f,this.a=[],this.b=[],this.d=!1,this.a=D,this.b=P,this.c=u}get apiEditor(){if(!this.e){const d=this;this.e={get notebook(){return d.notebookData.apiNotebook},get selection(){return d.a[0]},set selection(k){this.selections=[k]},get selections(){return d.a},set selections(k){if(!Array.isArray(k)||!k.every(I.$0K.isNotebookRange))throw(0,y.$5)("selections");d.a=k,d.g(k)},get visibleRanges(){return d.b},revealRange(k,f){d.f.$tryRevealRange(d.id,R.NotebookRange.from(k),f??I.NotebookEditorRevealType.Default)},get viewColumn(){return d.c}},M.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(d){this.d=d}_acceptVisibleRanges(d){this.b=d}_acceptSelections(d){this.a=d}g(d){this.f.$trySetSelections(this.id,d.map(R.NotebookRange.from))}_acceptViewColumn(d){this.c=d}}e.$Ubc=M}),define(Pe[207],Ae([1,0,9,5,14,8]),function(pe,e,y,R,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$acc=void 0;let A=class{constructor(k,f){this.c=k,this.d=f,this.a=new R.$ec({onListenerError:y.$Z}),this.b=new R.$ec({onListenerError:y.$Z}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(k,f){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",k,f);const P=this.d.getEditorById(k);f.visibleRanges&&P._acceptVisibleRanges(f.visibleRanges.ranges.map(M.NotebookRange.to)),f.selections&&P._acceptSelections(f.selections.selections.map(M.NotebookRange.to)),f.visibleRanges&&this.b.fire({notebookEditor:P.apiEditor,visibleRanges:P.apiEditor.visibleRanges}),f.selections&&this.a.fire(Object.freeze({notebookEditor:P.apiEditor,selections:P.apiEditor.selections}))}$acceptEditorViewColumns(k){for(const f in k)this.d.getEditorById(f)._acceptViewColumn(M.ViewColumn.to(k[f]))}};e.$acc=A,e.$acc=A=Ke([We(0,I.$Ri)],A)}),define(Pe[208],Ae([1,0,8,73,153,21,65,9]),function(pe,e,y,R,I,M,A,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ebc=void 0;class k{constructor(u){this.b=0,this.c=new Map,this.a=u}async withProgress(u,b,p){const h=this.b++,{title:t,location:i,cancellable:c}=b,g={label:(0,I.localize)(0,null,u.displayName||u.name),id:u.identifier.value};return this.a.$startProgress(h,{location:y.ProgressLocation.from(i),title:t,source:g,cancellable:c},u.isUnderDevelopment?void 0:u.identifier.value).catch(d.$Z),this.d(h,p,!!c)}d(u,b,p){let h;p&&(h=new M.$oc,this.c.set(u,h));const t=c=>{this.a.$progressEnd(c),this.c.delete(c),h?.dispose()};let i;try{i=b(new P(this.a,u),p&&h?h.token:M.CancellationToken.None)}catch(c){throw t(u),c}return i.then(c=>t(u),c=>t(u)),i}$acceptProgressCanceled(u){const b=this.c.get(u);b&&(b.cancel(),this.c.delete(u))}}e.$ebc=k;function f(D,u){return D.message=u.message,typeof u.increment=="number"&&(typeof D.increment=="number"?D.increment+=u.increment:D.increment=u.increment),D}class P extends R.$Tu{constructor(u,b){super(p=>this.throttledReport(p)),this.f=u,this.g=b}throttledReport(u){this.f.$progressReport(this.g,u)}}Ke([(0,A.$Vg)(100,(D,u)=>f(D,u),()=>Object.create(null))],P.prototype,"throttledReport",null)}),define(Pe[105],Ae([1,0,44,102,45,76,57,8,2]),function(pe,e,y,R,I,M,A,d,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1L=e.$ZL=e.$YL=e.$XL=void 0;const f=(g,S,C,n)=>{let a=S;return{enumerable:!0,configurable:!1,get(){return a},set(r){if(!C(a,r)){const s=a;a=r,g.listener?.(n(r,s))}}}},P=(g,S)=>g===S,D={range:(g,S)=>g===S?!0:!g||!S?!1:g.isEqual(S),label:P,description:P,sortText:P,busy:P,error:P,canResolveChildren:P,tags:(g,S)=>!(g.length!==S.length||g.some(C=>!S.find(n=>C.id===n.id)))},u=g=>S=>({op:4,update:g(S)}),b=(g,S)=>({range:(()=>{let C;const n=u(a=>({range:y.$Ur.lift(d.Range.from(a))}));return{enumerable:!0,configurable:!1,get(){return C},set(a){g.listener?.({op:6}),D.range(C,a)||(C=a,g.listener?.(n(a)))}}})(),label:f(g,S,D.label,u(C=>({label:C}))),description:f(g,void 0,D.description,u(C=>({description:C}))),sortText:f(g,void 0,D.sortText,u(C=>({sortText:C}))),canResolveChildren:f(g,!1,D.canResolveChildren,C=>({op:2,state:C})),busy:f(g,!1,D.busy,u(C=>({busy:C}))),error:f(g,void 0,D.error,u(C=>({error:d.MarkdownString.fromStrict(C)||null}))),tags:f(g,[],D.tags,(C,n)=>({op:1,new:C.map(d.TestTag.from),old:n.map(d.TestTag.from)}))}),p=g=>{const S=I.$wI.fromString(g.extId),C=new t(S.controllerId,S.localId,g.label,k.URI.revive(g.uri)||void 0);return C.range=d.Range.to(g.range||void 0),C.description=g.description||void 0,C.sortText=g.sortText||void 0,C.tags=g.tags.map(n=>d.TestTag.to({id:(0,A.$BI)(n).tagId})),C},h=g=>{let S;for(const C of g.tests){const n=p(C.item);(0,R.$HL)(n).parent=S,S=n}return S};e.$XL=h;class t{constructor(S,C,n,a){if(C.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(C)} symbol`);const r=(0,R.$GL)(this,S);Object.defineProperties(this,{id:{value:C,enumerable:!0,writable:!1},uri:{value:a,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof i?void 0:r.parent}},children:{value:(0,M.$FL)(r,R.$HL,t),enumerable:!0,writable:!1},...b(r,n)})}}e.$YL=t;class i extends t{constructor(S,C){super(S,S,C,void 0),this._isRoot=!0}}e.$ZL=i;class c extends M.$BL{constructor(S,C,n){super({controllerId:S,getDocumentVersion:a=>a&&n.getDocument(a)?.version,getApiFor:R.$HL,getChildren:a=>a.children,root:new i(S,C),toITestItem:d.TestItem.from})}}e.$1L=c}),define(Pe[106],Ae([1,0,50,9,88,8,7]),function(pe,e,y,R,I,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UL=e.$TL=e.$SL=void 0;class d{static{this.c=new I.$QL("TextEditorDecorationType")}constructor(u,b,p){const h=d.c.nextId();u.$registerTextEditorDecorationType(b.identifier,h,M.DecorationRenderOptions.from(p)),this.value=Object.freeze({key:h,dispose(){u.$removeTextEditorDecorationType(h)}})}}e.$SL=d;class k{constructor(u,b){this.g=[],this.h=void 0,this.j=!1,this.c=u,this.d=u.version,this.e=b.undoStopBefore,this.f=b.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(u,b){this.k();let p=null;if(u instanceof A.$MJ)p=new A.$NJ(u,u);else if(u instanceof A.$NJ)p=u;else throw new Error("Unrecognized location");this.l(p,b,!1)}insert(u,b){this.k(),this.l(new A.$NJ(u,u),b,!0)}delete(u){this.k();let b=null;if(u instanceof A.$NJ)b=u;else throw new Error("Unrecognized location");this.l(b,null,!0)}l(u,b,p){const h=this.c.validateRange(u);this.g.push({range:h,text:b,forceMoveMarkers:p})}setEndOfLine(u){if(this.k(),u!==A.EndOfLine.LF&&u!==A.EndOfLine.CRLF)throw(0,R.$5)("endOfLine");this.h=u}}class f{constructor(u,b,p,h){this.c=u,this.d=b,this._accept(p),this.e=h;const t=this;this.value={get tabSize(){return t.f},set tabSize(i){t.m(i)},get indentSize(){return t.g},set indentSize(i){t.o(i)},get insertSpaces(){return t.h},set insertSpaces(i){t.q(i)},get cursorStyle(){return t.j},set cursorStyle(i){t.s(i)},get lineNumbers(){return t.k},set lineNumbers(i){t.t(i)}}}_accept(u){this.f=u.tabSize,this.g=u.indentSize,this.h=u.insertSpaces,this.j=u.cursorStyle,this.k=M.TextEditorLineNumbersStyle.to(u.lineNumbers)}l(u){if(u==="auto")return"auto";if(typeof u=="number"){const b=Math.floor(u);return b>0?b:null}if(typeof u=="string"){const b=parseInt(u,10);return isNaN(b)?null:b>0?b:null}return null}m(u){const b=this.l(u);if(b!==null){if(typeof b=="number"){if(this.f===b)return;this.f=b}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:b}))}}n(u){if(u==="tabSize")return"tabSize";if(typeof u=="number"){const b=Math.floor(u);return b>0?b:null}if(typeof u=="string"){const b=parseInt(u,10);return isNaN(b)?null:b>0?b:null}return null}o(u){const b=this.n(u);if(b!==null){if(typeof b=="number"){if(this.g===b)return;this.g=b}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:b}))}}p(u){return u==="auto"?"auto":u==="false"?!1:!!u}q(u){const b=this.p(u);if(typeof b=="boolean"){if(this.h===b)return;this.h=b}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:b}))}s(u){this.j!==u&&(this.j=u,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:u})))}t(u){this.k!==u&&(this.k=u,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:M.TextEditorLineNumbersStyle.from(u)})))}assign(u){const b={};let p=!1;if(typeof u.tabSize<"u"){const h=this.l(u.tabSize);h==="auto"?(p=!0,b.tabSize=h):typeof h=="number"&&this.f!==h&&(this.f=h,p=!0,b.tabSize=h)}if(typeof u.indentSize<"u"){const h=this.n(u.indentSize);h==="tabSize"?(p=!0,b.indentSize=h):typeof h=="number"&&this.g!==h&&(this.g=h,p=!0,b.indentSize=h)}if(typeof u.insertSpaces<"u"){const h=this.p(u.insertSpaces);h==="auto"?(p=!0,b.insertSpaces=h):this.h!==h&&(this.h=h,p=!0,b.insertSpaces=h)}typeof u.cursorStyle<"u"&&this.j!==u.cursorStyle&&(this.j=u.cursorStyle,p=!0,b.cursorStyle=u.cursorStyle),typeof u.lineNumbers<"u"&&this.k!==u.lineNumbers&&(this.k=u.lineNumbers,p=!0,b.lineNumbers=M.TextEditorLineNumbersStyle.from(u.lineNumbers)),p&&this.u("setOptions",this.c.$trySetOptions(this.d,b))}u(u,b){b.catch(p=>{this.e.warn(`ExtHostTextEditorOptions '${u}' failed:'`),this.e.warn(p)})}}e.$TL=f;class P{constructor(u,b,p,h,t,i,c,g){this.id=u,this.j=b,this.k=p,this.g=!1,this.h=new Set,this.c=t,this.d=new f(this.j,this.id,i,p),this.e=c,this.f=g;const S=this;this.value=Object.freeze({get document(){return h.value},set document(C){throw(0,R.$7)("document")},get selection(){return S.c&&S.c[0]},set selection(C){if(!(C instanceof A.$OJ))throw(0,R.$5)("selection");S.c=[C],S.l()},get selections(){return S.c},set selections(C){if(!Array.isArray(C)||C.some(n=>!(n instanceof A.$OJ)))throw(0,R.$5)("selections");S.c=C,S.l()},get visibleRanges(){return S.e},set visibleRanges(C){throw(0,R.$7)("visibleRanges")},get options(){return S.d.value},set options(C){S.g||S.d.assign(C)},get viewColumn(){return S.f},set viewColumn(C){throw(0,R.$7)("viewColumn")},edit(C,n={undoStopBefore:!0,undoStopAfter:!0}){if(S.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const a=new k(h.value,n);return C(a),S.m(a)},insertSnippet(C,n,a={undoStopBefore:!0,undoStopAfter:!0}){if(S.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!n||Array.isArray(n)&&n.length===0)r=S.c.map(s=>M.Range.from(s));else if(n instanceof A.$MJ){const{lineNumber:s,column:v}=M.Position.from(n);r=[{startLineNumber:s,startColumn:v,endLineNumber:s,endColumn:v}]}else if(n instanceof A.$NJ)r=[M.Range.from(n)];else{r=[];for(const s of n)if(s instanceof A.$NJ)r.push(M.Range.from(s));else{const{lineNumber:v,column:$}=M.Position.from(s);r.push({startLineNumber:v,startColumn:$,endLineNumber:v,endColumn:$})}}return b.$tryInsertSnippet(u,h.value.version,C.value,r,a)},setDecorations(C,n){const a=n.length===0;a&&!S.h.has(C.key)||(a?S.h.delete(C.key):S.h.add(C.key),S.n(()=>{if(M.$IL(n))return b.$trySetDecorations(u,C.key,M.$JL(n));{const r=new Array(4*n.length);for(let s=0,v=n.length;s<v;s++){const $=n[s];r[4*s]=$.start.line+1,r[4*s+1]=$.start.character+1,r[4*s+2]=$.end.line+1,r[4*s+3]=$.end.character+1}return b.$trySetDecorationsFast(u,C.key,r)}}))},revealRange(C,n){S.n(()=>b.$tryRevealRange(u,M.Range.from(C),n||A.TextEditorRevealType.Default))},show(C){b.$tryShowEditor(u,M.ViewColumn.from(C))},hide(){b.$tryHideEditor(u)}})}dispose(){(0,y.ok)(!this.g),this.g=!0}_acceptOptions(u){(0,y.ok)(!this.g),this.d._accept(u)}_acceptVisibleRanges(u){(0,y.ok)(!this.g),this.e=u}_acceptViewColumn(u){(0,y.ok)(!this.g),this.f=u}_acceptSelections(u){(0,y.ok)(!this.g),this.c=u}async l(){const u=this.c.map(M.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,u)),this.value}m(u){const b=u.finalize();if(b.edits.length===0&&!b.setEndOfLine)return Promise.resolve(!0);const p=b.edits.map(t=>t.range);p.sort((t,i)=>t.end.line===i.end.line?t.end.character===i.end.character?t.start.line===i.start.line?t.start.character-i.start.character:t.start.line-i.start.line:t.end.character-i.end.character:t.end.line-i.end.line);for(let t=0,i=p.length-1;t<i;t++){const c=p[t].end;if(p[t+1].start.isBefore(c))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const h=b.edits.map(t=>({range:M.Range.from(t.range),text:t.text,forceMoveMarkers:t.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,b.documentVersionId,h,{setEndOfLine:typeof b.setEndOfLine=="number"?M.EndOfLine.from(b.setEndOfLine):void 0,undoStopBefore:b.undoStopBefore,undoStopAfter:b.undoStopAfter})}n(u){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,b=>(b instanceof Error&&b.name==="DISPOSED"||this.k.warn(b),null))}}e.$UL=P}),define(Pe[209],Ae([1,0,4,172]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1I=void 0,e.$1I=(0,y.$qh)(R.$wh)}),define(Pe[107],Ae([1,0,20,5,19,6]),function(pe,e,y,R,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S2b=e.$R2b=e.$Q2b=e.$P2b=e.$O2b=void 0;class A{constructor(t){this.removedDueToLooping=t}}e.$O2b=A;class d{static isHostExtension(t,i,c){if(i.getExtensionDescription(t))return!1;const g=c.getExtensionDescription(t);return g?!!((g.main||g.browser)&&g.api==="none"):!1}constructor(t,i){this.h=t,this.c=new R.$ec,this.onDidChange=this.c.event,this.d=i,this.j()}j(){this.d.sort(b),this.e=new y.$Kl,this.f=[],this.g=new Map;for(const t of this.d){if(this.e.has(t.identifier)){console.error("Extension `"+t.identifier.value+"` is already registered");continue}this.e.set(t.identifier,t),this.f.push(t);const i=this.h.readActivationEvents(t);if(Array.isArray(i))for(let c of i)c==="onUri"&&(c=`onUri:${y.$Il.toKey(t.identifier)}`),this.g.has(c)||this.g.set(c,[]),this.g.get(c).push(t)}}set(t){this.d=t,this.j(),this.c.fire(void 0)}deltaExtensions(t,i){this.d=p(this.d,i),this.d=this.d.concat(t);const c=d.k(this.d);return this.d=p(this.d,c.map(g=>g.identifier)),this.j(),this.c.fire(void 0),new A(c)}static k(t){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(n){this.d.has(n)||(this.d.add(n),this.e.push(n))}addArc(n,a){this.addNode(n),this.addNode(a),this.c.has(n)?this.c.get(n).push(a):this.c.set(n,[a])}getArcs(n){return this.c.has(n)?this.c.get(n):[]}hasOnlyGoodArcs(n,a){const r=i.getArcs(n);for(let s=0;s<r.length;s++)if(!a.has(r[s]))return!1;return!0}getNodes(){return this.e}},c=new y.$Kl;for(const n of t)if(c.set(n.identifier,n),n.extensionDependencies)for(const a of n.extensionDependencies)i.addArc(y.$Il.toKey(n.identifier),y.$Il.toKey(a));const g=new Set;i.getNodes().filter(n=>i.getArcs(n).length===0).forEach(n=>g.add(n));const S=i.getNodes().filter(n=>!g.has(n));let C;do{C=!1;for(let n=0;n<S.length;n++){const a=S[n];i.hasOnlyGoodArcs(a,g)&&(S.splice(n,1),n--,g.add(a),C=!0)}}while(C);return S.map(n=>c.get(n))}containsActivationEvent(t){return this.g.has(t)}containsExtension(t){return this.e.has(t)}getExtensionDescriptionsForActivationEvent(t){const i=this.g.get(t);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(t){const i=this.e.get(t);return i||void 0}getExtensionDescriptionByUUID(t){for(const i of this.f)if(i.uuid===t)return i}getExtensionDescriptionByIdOrUUID(t,i){return this.getExtensionDescription(t)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$P2b=d,e.$Q2b={readActivationEvents:h=>h.activationEvents};class k{constructor(t){this.d=new D,this.c=new d(t,[])}async acquireLock(t){const i=await this.d.acquire(t);return new f(this,i)}deltaExtensions(t,i,c){if(!t.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,c)}containsActivationEvent(t){return this.c.containsActivationEvent(t)}containsExtension(t){return this.c.containsExtension(t)}getExtensionDescriptionsForActivationEvent(t){return this.c.getExtensionDescriptionsForActivationEvent(t)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getExtensionDescription(t){return this.c.getExtensionDescription(t)}getExtensionDescriptionByUUID(t){return this.c.getExtensionDescriptionByUUID(t)}getExtensionDescriptionByIdOrUUID(t,i){return this.c.getExtensionDescriptionByIdOrUUID(t,i)}}e.$R2b=k;class f extends M.$lb{constructor(t,i){super(),this.f=t,this.c=!1,this.B(i)}isAcquiredFor(t){return!this.c&&this.f===t}}e.$S2b=f;class P{constructor(t){this.name=t,this.promise=new Promise((i,c)=>{this.c=i})}resolve(t){this.c(t)}}class D{constructor(){this.c=[],this.d=!1}async acquire(t){const i=new P(t);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const t=this.c.shift();this.d=!0;let i=!0;const c=setTimeout(()=>{i&&console.warn(`The customer named ${t.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),g=()=>{i&&(clearTimeout(c),i=!1,this.d=!1,this.e())};t.resolve((0,M.$jb)(g))}}var u;(function(h){h[h.Builtin=0]="Builtin",h[h.User=1]="User",h[h.Dev=2]="Dev"})(u||(u={}));function b(h,t){const i=h.isBuiltin?0:h.isUnderDevelopment?2:1,c=t.isBuiltin?0:t.isUnderDevelopment?2:1;if(i!==c)return i-c;const g=I.$5c.basename(h.extensionLocation.path),S=I.$5c.basename(t.extensionLocation.path);return g<S?-1:g>S?1:0}function p(h,t){const i=new y.$Jl(t);return h.filter(c=>!i.has(c.identifier))}}),define(Pe[79],Ae([1,0,25]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$Rl=e.$Ql=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var R;(function(f){f[f.Desktop=1]="Desktop",f[f.Web=2]="Web"})(R||(e.UIKind=R={}));var I;(function(f){f[f.VersionMismatch=55]="VersionMismatch",f[f.UnexpectedError=81]="UnexpectedError"})(I||(e.ExtensionHostExitCode=I={}));var M;(function(f){f[f.Initialized=0]="Initialized",f[f.Ready=1]="Ready",f[f.Terminate=2]="Terminate"})(M||(e.MessageType=M={}));function A(f){const P=y.$Ec.alloc(1);switch(f){case 0:P.writeUInt8(1,0);break;case 1:P.writeUInt8(2,0);break;case 2:P.writeUInt8(3,0);break}return P}e.$Ql=A;function d(f,P){if(f.byteLength!==1)return!1;switch(f.readUInt8(0)){case 1:return P===0;case 2:return P===1;case 3:return P===2;default:return!1}}e.$Rl=d;var k;(function(f){f.Start="START_NATIVE_LOG",f.End="END_NATIVE_LOG"})(k||(e.NativeLogMarkers=k={}))}),define(Pe[58],Ae([1,0,4,5,14,27,79,51,53,24,2,6,155]),function(pe,e,y,R,I,M,A,d,k,f,P,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6L=e.$5L=e.$4L=e.$3L=void 0;let b=class extends D.$lb{constructor(i,c){super(),this.n=i,this.p=c,this.a=this.B(new R.$ec),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new R.$ec),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.i=!1,this.m=new Map,this.j=P.URI.revive(this.n.environment.extensionTelemetryLogResource),this.i=this.n.environment.isExtensionTelemetryLoggingOnly,this.k=c.createLogger(this.j,{id:k.$9n,name:(0,u.localize)(0,null,this.i?" (Not Sent)":""),hidden:!0}),this.B(c.onDidChangeLogLevel(g=>{(0,I.$Ti)(g)&&this.r()})),this.k.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.k.info("===========================================================")}r(){this.p.setVisibility(this.j,this.g&&this.p.getLogLevel()===I.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(i,c,g){const S=this.getTelemetryDetails(),C=new p(c,g,i,this.k,this.i,this.getBuiltInCommonProperties(i),{isUsageEnabled:S.isUsageEnabled,isErrorsEnabled:S.isErrorsEnabled}),n=this.m.get(i.identifier.value)??[];return this.m.set(i.identifier.value,[...n,C]),C.apiTelemetryLogger}$initializeTelemetryLevel(i,c,g){this.f=i,this.g=c,this.c=g??{usage:!0,error:!0},this.r()}getBuiltInCommonProperties(i){const c=Object.create(null);switch(c["common.extname"]=`${i.publisher}.${i.name}`,c["common.extversion"]=i.version,c["common.vscodemachineid"]=this.n.telemetryInfo.machineId,c["common.vscodesessionid"]=this.n.telemetryInfo.sessionId,c["common.vscodeversion"]=this.n.version,c["common.isnewappinstall"]=h(this.n.telemetryInfo.firstSessionDate),c["common.product"]=this.n.environment.appHost,this.n.uiKind){case A.UIKind.Web:c["common.uikind"]="web";break;case A.UIKind.Desktop:c["common.uikind"]="desktop";break;default:c["common.uikind"]="unknown"}return c["common.remotename"]=(0,d.$Ck)((0,k.$do)(this.n.remote.authority)),c}$onDidChangeTelemetryLevel(i){this.h=this.getTelemetryConfiguration(),this.f=i;const c=this.getTelemetryDetails();this.m.forEach((g,S)=>{const C=g.filter(n=>!n.isDisposed);C.length===0?this.m.delete(S):this.m.set(S,C)}),this.m.forEach(g=>{for(const S of g)S.updateTelemetryEnablements(c.isUsageEnabled,c.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.r()}onExtensionError(i,c){const S=this.m.get(i.value)?.filter(n=>!n.isDisposed);if(!S)return this.m.delete(i.value),!1;let C=!1;for(const n of S)n.ignoreUnhandledExtHostErrors||(n.logError(c),C=!0);return C}};e.$3L=b,e.$3L=b=Ke([We(0,M.$2L),We(1,I.$Si)],b);class p{static validateSender(i){if(typeof i!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof i.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof i.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof i.flush<"u"&&typeof i.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(i,c,g,S,C,n,a){this.g=g,this.h=S,this.i=C,this.j=n,this.a=new R.$ec,this.ignoreUnhandledExtHostErrors=c?.ignoreUnhandledErrors??!1,this.b=c?.ignoreBuiltInCommonProperties??!1,this.c=c?.additionalCommonProperties,this.f=i,this.d={isUsageEnabled:a.isUsageEnabled,isErrorsEnabled:a.isErrorsEnabled}}updateTelemetryEnablements(i,c){this.e&&(this.d={isUsageEnabled:i,isErrorsEnabled:c},this.a.fire(this.e))}mixInCommonPropsAndCleanData(i){let c="properties"in i?i.properties??{}:i;return c=(0,k.$go)(c,[]),this.c&&(c=(0,f.$Lm)(c,this.c)),this.b||(c=(0,f.$Lm)(c,this.j)),"properties"in i?i.properties=c:i=c,i}k(i,c){this.f&&(this.g.publisher==="vscode"?i=this.g.name+"/"+i:i=this.g.identifier.value+"/"+i,c=this.mixInCommonPropsAndCleanData(c||{}),this.i||this.f?.sendEventData(i,c),this.h.trace(i,c))}logUsage(i,c){this.d.isUsageEnabled&&this.k(i,c)}logError(i,c){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof i=="string")this.k(i,c);else{const g={name:i.name,message:i.message,stack:i.stack,cause:i.cause},S=(0,k.$go)(g,[]),C=new Error(S.message,{cause:S.cause});C.stack=S.stack,C.name=S.name,c=this.mixInCommonPropsAndCleanData(c||{}),this.i||this.f.sendErrorData(C,c),this.h.trace("exception",c)}}get apiTelemetryLogger(){if(!this.e){const i=this,c={logUsage:i.logUsage.bind(i),get isUsageEnabled(){return i.d.isUsageEnabled},get isErrorsEnabled(){return i.d.isErrorsEnabled},logError:i.logError.bind(i),dispose:i.dispose.bind(i),onDidChangeEnableStates:i.a.event.bind(i)};this.e=Object.freeze(c)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let i=this.f;this.f=void 0,Promise.resolve(i.flush()).then(i=void 0),this.e=void 0}else this.f=void 0}}e.$4L=p;function h(t){const i=Date.now()-new Date(t).getTime();return isNaN(i)?!1:i<1e3*60*60*24}e.$5L=h,e.$6L=(0,y.$ph)("IExtHostTelemetry")}),define(Pe[26],Ae([1,0,5,2,181,98,20,4]),function(pe,e,y,R,I,M,A,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JF=e.$IF=e.$HF=e.ActivationKind=e.$GF=e.$FF=e.$EF=e.$DF=e.$CF=e.ExtensionHostStartup=e.$BF=e.$AF=e.$zF=e.$yF=void 0,e.$yF=Object.freeze({identifier:new A.$Il("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:R.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$zF="extensions.webWorker",e.$AF=(0,d.$ph)("extensionService");class k{constructor(C){this.dependency=C}}e.$BF=k;var f;(function(S){S[S.EagerAutoStart=1]="EagerAutoStart",S[S.EagerManualStart=2]="EagerManualStart",S[S.Lazy=3]="Lazy"})(f||(e.ExtensionHostStartup=f={}));class P{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,addActivationEvents:M.$pF.createActivationEventsMap(this.c),myToRemove:[],myToAdd:this.d}}set(C,n){const a=[],r=[],s=[],v=[],$=D(this.c),w=D(C),E=(W,V)=>W.extensionLocation.toString()===V.extensionLocation.toString()||W.isBuiltin===V.isBuiltin||W.isUserBuiltin===V.isUserBuiltin||W.isUnderDevelopment===V.isUnderDevelopment;for(const W of this.c){const V=w.get(W.identifier);if(!V){a.push(W.identifier),$.delete(W.identifier);continue}if(!E(W,V)){a.push(W.identifier),$.delete(W.identifier);continue}}for(const W of C){const V=$.get(W.identifier);if(!V){r.push(W);continue}if(!E(V,W)){a.push(V.identifier),$.delete(V.identifier);continue}}const o=new A.$Jl(this.d),l=new A.$Jl(n);for(const W of this.d)l.has(W)||s.push(W);for(const W of n)o.has(W)||v.push(W);const m=M.$pF.createActivationEventsMap(r),F={toRemove:a,toAdd:r,addActivationEvents:m,myToRemove:s,myToAdd:v};return this.delta(F),F}delta(C){const{toRemove:n,toAdd:a,myToRemove:r,myToAdd:s}=C,v=new A.$Jl(n),$=new A.$Jl(r);for(let w=0;w<this.c.length;w++)v.has(this.c[w].identifier)&&(this.c.splice(w,1),w--);for(let w=0;w<this.d.length;w++)$.has(this.d[w])&&(this.d.splice(w,1),w--);for(const w of a)this.c.push(w);for(const w of s)this.d.push(w)}containsExtension(C){for(const n of this.d)if(A.$Il.equals(n,C))return!0;return!1}}e.$CF=P;function D(S){const C=new A.$Kl;for(const n of S)C.set(n.identifier,n);return C}function u(S,C){return S.enabledApiProposals?S.enabledApiProposals.includes(C):!1}e.$DF=u;function b(S,C){if(!u(S,C))throw new Error(`Extension '${S.identifier.value}' CANNOT use API proposal: ${C}.
Its package.json#enabledApiProposals-property declares: ${S.enabledApiProposals?.join(", ")??"[]"} but NOT ${C}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${S.identifier.value}`)}e.$EF=b;class p{constructor(C,n,a,r){this.codeLoadingTime=C,this.activateCallTime=n,this.activateResolvedTime=a,this.activationReason=r}}e.$FF=p;class h{constructor(C,n){this.description=C,this.value=n}}e.$GF=h;var t;(function(S){S[S.Normal=0]="Normal",S[S.Immediate=1]="Immediate"})(t||(e.ActivationKind=t={}));function i(S){return{type:S.isBuiltin?0:1,isBuiltin:S.isBuiltin||S.isUserBuiltin,identifier:{id:(0,I.$mo)(S.publisher,S.name),uuid:S.uuid},manifest:S,location:S.extensionLocation,targetPlatform:S.targetPlatform,validations:[],isValid:!0}}e.$HF=i;function c(S,C){return{identifier:new A.$Il((0,I.$ko)(S.manifest.publisher,S.manifest.name)),isBuiltin:S.type===0,isUserBuiltin:S.type===1&&S.isBuiltin,isUnderDevelopment:!!C,extensionLocation:S.location,...S.manifest,uuid:S.identifier.uuid,targetPlatform:S.targetPlatform}}e.$IF=c;class g{constructor(){this.onDidRegisterExtensions=y.Event.None,this.onDidChangeExtensionsStatus=y.Event.None,this.onDidChangeExtensions=y.Event.None,this.onWillActivateByEvent=y.Event.None,this.onDidChangeResponsiveChange=y.Event.None,this.onWillStop=y.Event.None,this.extensions=[]}activateByEvent(C){return Promise.resolve(void 0)}activationEventIsDone(C){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(C){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(C,n){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(C){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$JF=g}),define(Pe[210],Ae([1,0,9,107,20,26,14,13]),function(pe,e,y,R,I,M,A,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lac=e.$Kac=e.$Jac=e.$Iac=e.$Hac=e.$Gac=void 0;class k{static{this.NONE=new k(!1,-1,-1,-1)}constructor(i,c,g,S){this.startup=i,this.codeLoadingTime=c,this.activateCallTime=g,this.activateResolvedTime=S}}e.$Gac=k;class f{constructor(i){this.a=i,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(i,c){return i===-1||c===-1?-1:c-i}build(){return new k(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Hac=f;class P{constructor(i,c,g,S,C,n){this.activationFailed=i,this.activationFailedError=c,this.activationTimes=g,this.module=S,this.exports=C,this.subscriptions=n}}e.$Iac=P;class D extends P{constructor(i){super(!1,null,i,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Jac=D;class u extends P{constructor(){super(!1,null,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Kac=u;class b extends P{constructor(i){super(!0,i,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let p=class{constructor(i,c,g,S){this.g=S,this.a=i,this.b=c,this.c=g,this.d=new I.$Kl,this.f=Object.create(null)}dispose(){for(const[i,c]of this.d)c.dispose()}async waitForActivatingExtensions(){const i=[];for(const[c,g]of this.d)i.push(g.wait());await Promise.all(i)}isActivated(i){const c=this.d.get(i);return!!(c&&c.value)}getActivatedExtension(i){const c=this.d.get(i);if(!c||!c.value)throw new Error(`Extension '${i.value}' is not known or not activated`);return c.value}async activateByEvent(i,c){if(this.f[i])return;const g=this.a.getExtensionDescriptionsForActivationEvent(i);await this.h(g.map(S=>({id:S.identifier,reason:{startup:c,extensionId:S.identifier,activationEvent:i}}))),this.f[i]=!0}activateById(i,c){const g=this.a.getExtensionDescription(i);if(!g)throw new Error(`Extension '${i}' is not known`);return this.h([{id:g.identifier,reason:c}])}async h(i){const c=i.filter(g=>!this.isActivated(g.id)).map(g=>this.j(g));await Promise.all(c.map(g=>g.wait()))}j(i){if(this.d.has(i.id))return this.d.get(i.id);if(this.l(i.id))return this.k(i,null,[],null);const c=this.a.getExtensionDescription(i.id);if(!c){const C=new Error(`Cannot activate unknown extension '${i.id.value}'`),n=this.k(i,null,[],new b(C));return this.c.onExtensionActivationError(i.id,C,new M.$BF(i.id.value)),n}const g=[],S=typeof c.extensionDependencies>"u"?[]:c.extensionDependencies;for(const C of S){if(this.m(C))continue;const n=this.d.get(C);if(n){g.push(n);continue}if(this.l(C)){g.push(this.j({id:this.b.getExtensionDescription(C).identifier,reason:i.reason}));continue}const a=this.a.getExtensionDescription(C);if(a){if(!a.main&&!a.browser)continue;g.push(this.j({id:a.identifier,reason:i.reason}));continue}const r=c.displayName||c.identifier.value,s=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${C}'`),v=this.k(i,c.displayName,[],new b(s));return this.c.onExtensionActivationError(c.identifier,s,new M.$BF(C)),v}return this.k(i,c.displayName,g,null)}k(i,c,g,S){const C=new h(i.id,c,i.reason,g,S,this.c,this.g);return this.d.set(i.id,C),C}l(i){return R.$P2b.isHostExtension(i,this.a,this.b)}m(i){const c=this.b.getExtensionDescription(i);return c?!c.main&&!c.browser:!1}};e.$Lac=p,e.$Lac=p=Ke([We(3,A.$Ri)],p);let h=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(i,c,g,S,C,n,a){this.c=i,this.d=c,this.f=g,this.g=S,this.h=C,this.j=n,this.k=a,this.a=new d.$tg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let i=0;i<this.g.length;i++){const c=this.g[i];if(c.value&&!c.value.activationFailed){this.g.splice(i,1),i--;continue}if(c.value&&c.value.activationFailed){const g=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${c.friendlyName}' failed to activate`);g.detail=c.value.activationFailedError,this.h=new b(g),this.j.onExtensionActivationError(this.c,g,null);return}}this.g.length>0&&await Promise.race(this.g.map(i=>i.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(i){const c=new Error;if(i&&i.name&&(c.name=i.name),i&&i.message?c.message=`Activating extension '${this.c.value}' failed: ${i.message}.`:c.message=`Activating extension '${this.c.value}' failed: ${i}.`,i&&i.stack&&(c.stack=i.stack),this.h=new b(c),this.b&&y.$2(i))return;this.j.onExtensionActivationError(this.c,c,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(i)}}};h=Ke([We(6,A.$Ri)],h)}),define(Pe[211],Ae([1,0,157,7,23,2,5,6,193,13,7,16,18,8,49,21,126,26]),function(pe,e,y,R,I,M,A,d,k,f,P,D,u,b,p,h,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lbc=void 0;function c(C,n){if((0,D.$ie)(C))return{label:C};if(C&&typeof C=="object"&&typeof C.label=="string"){let a;return Array.isArray(C.highlights)&&(a=C.highlights.filter(r=>r.length===2&&typeof r[0]=="number"&&typeof r[1]=="number"),a=a.length?a:void 0),{label:C.label,highlights:a}}}class g{constructor(n,a,r){this.d=n,this.e=a,this.f=r,this.a=new Map,this.b=new t.$V6;function s(v){return v&&v.$treeViewId&&(v.$treeItemHandle||v.$selectedTreeItems||v.$focusedTreeItem)}a.registerArgumentProcessor({processArgument:v=>s(v)?this.i(v):Array.isArray(v)&&v.length>0?v.map($=>s($)?this.i($):$):v})}registerTreeDataProvider(n,a,r){const s=this.createTreeView(n,{treeDataProvider:a},r);return{dispose:()=>s.dispose()}}createTreeView(n,a,r){if(!a||!a.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const s=a.dragAndDropController?.dropMimeTypes??[],v=a.dragAndDropController?.dragMimeTypes??[],$=!!a.dragAndDropController?.handleDrag,w=!!a.dragAndDropController?.handleDrop,E=this.h(n,a,r),o={showCollapseAll:!!a.showCollapseAll,canSelectMany:!!a.canSelectMany,dropMimeTypes:s,dragMimeTypes:v,hasHandleDrag:$,hasHandleDrop:w,manuallyManageCheckboxes:!!a.manageCheckboxStateManually},l=this.d.$registerTreeViewDataProvider(n,o);return{get onDidCollapseElement(){return E.onDidCollapseElement},get onDidExpandElement(){return E.onDidExpandElement},get selection(){return E.selectedElements},get onDidChangeSelection(){return E.onDidChangeSelection},get activeItem(){return(0,i.$EF)(r,"treeViewActiveItem"),E.focusedElement},get onDidChangeActiveItem(){return(0,i.$EF)(r,"treeViewActiveItem"),E.onDidChangeActiveItem},get visible(){return E.visible},get onDidChangeVisibility(){return E.onDidChangeVisibility},get onDidChangeCheckboxState(){return E.onDidChangeCheckboxState},get message(){return E.message},set message(F){(0,p.$Mj)(F)&&(0,i.$EF)(r,"treeViewMarkdownMessage"),E.message=F},get title(){return E.title},set title(F){E.title=F},get description(){return E.description},set description(F){E.description=F},get badge(){return E.badge},set badge(F){F!==void 0&&P.ViewBadge.isViewBadge(F)?E.badge={value:Math.floor(Math.abs(F.value)),tooltip:F.tooltip}:F===void 0&&(E.badge=void 0)},reveal:(F,W)=>E.reveal(F,W),dispose:async()=>{await l,this.a.delete(n),E.dispose()}}}$getChildren(n,a){const r=this.a.get(n);return r?r.getChildren(a):Promise.reject(new k.$3E(n))}async $handleDrop(n,a,r,s,v,$,w,E){const o=this.a.get(n);if(!o)return Promise.reject(new k.$3E(n));const l=b.DataTransfer.toDataTransfer(r,async m=>(await this.d.$resolveDropFileData(n,a,m)).buffer);return w===n&&E&&await this.g(l,o,E,v,$),o.onDrop(l,s,v)}async g(n,a,r,s,v){const $=this.b.removeDragOperationTransfer(v);if($)(await $)?.forEach((w,E)=>{w&&n.set(E,w)});else if(v&&a.handleDrag){const w=a.handleDrag(r,n,s);this.b.addDragOperationTransfer(v,w),await w}return n}async $handleDrag(n,a,r,s){const v=this.a.get(n);if(!v)return Promise.reject(new k.$3E(n));const $=await this.g(new R.$DK,v,a,s,r);if(!(!$||s.isCancellationRequested))return b.DataTransfer.from($)}async $hasResolve(n){const a=this.a.get(n);if(!a)throw new k.$3E(n);return a.hasResolve}$resolve(n,a,r){const s=this.a.get(n);if(!s)throw new k.$3E(n);return s.resolveTreeItem(a,r)}$setExpanded(n,a,r){const s=this.a.get(n);if(!s)throw new k.$3E(n);s.setExpanded(a,r)}$setSelectionAndFocus(n,a,r){const s=this.a.get(n);if(!s)throw new k.$3E(n);s.setSelectionAndFocus(a,r)}$setVisible(n,a){const r=this.a.get(n);if(!r){if(!a)return;throw new k.$3E(n)}r.setVisible(a)}$changeCheckboxState(n,a){const r=this.a.get(n);if(!r)throw new k.$3E(n);r.setCheckboxState(a)}h(n,a,r){const s=new S(n,a,this.d,this.e.converter,this.f,r);return this.a.set(n,s),s}i(n){const a=this.a.get(n.$treeViewId);return a&&"$treeItemHandle"in n?a.getExtensionElement(n.$treeItemHandle):a&&"$focusedTreeItem"in n&&n.$focusedTreeItem?a.focusedElement:null}}e.$lbc=g;class S extends d.$lb{static{this.a="0"}static{this.b="1"}get visible(){return this.k}get selectedElements(){return this.l.map(n=>this.getExtensionElement(n)).filter(n=>!(0,D.$re)(n))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(n,a,r,s,v,$){if(super(),this.D=n,this.F=r,this.G=s,this.H=v,this.I=$,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.r=this.B(new A.$ec),this.onDidExpandElement=this.r.event,this.s=this.B(new A.$ec),this.onDidCollapseElement=this.s.event,this.t=this.B(new A.$ec),this.onDidChangeSelection=this.t.event,this.u=this.B(new A.$ec),this.onDidChangeActiveItem=this.u.event,this.v=this.B(new A.$ec),this.onDidChangeVisibility=this.v.event,this.w=this.B(new A.$ec),this.onDidChangeCheckboxState=this.w.event,this.y=this.B(new A.$ec),this.z=Promise.resolve(),this.C=Promise.resolve(),this.J="",this.L="",this.U=new h.$oc,$.contributes&&$.contributes.views)for(const o in $.contributes.views)for(const l of $.contributes.views[o])l.id===n&&(this.L=l.name);this.f=a.treeDataProvider,this.g=a.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(o=>this.y.fire({message:!1,element:o})));let w,E;this.B(A.Event.debounce(this.y.event,(o,l)=>(o||(o={message:!1,elements:[]}),l.element!==!1&&(w||(w=new Promise(m=>E=m),this.z=this.z.then(()=>w)),Array.isArray(l.element)?o.elements.push(...l.element):o.elements.push(l.element)),l.message&&(o.message=!0),o),200,!0)(({message:o,elements:l})=>{l.length&&(this.C=this.C.then(()=>{const m=E;return w=null,this.W(l).then(()=>m())})),o&&this.F.$setMessage(this.D,b.MarkdownString.fromStrict(this.J)??"")}))}async getChildren(n){const a=n?this.getExtensionElement(n):void 0;if(n&&!a)return this.H.error(`No tree item with id '${n}' found.`),Promise.resolve([]);let r=this.R(n);return r||(r=await this.S(a)),r?r.map(s=>s.item):void 0}getExtensionElement(n){return this.i.get(n)}reveal(n,a){a=a||{select:!0,focus:!1};const r=(0,D.$re)(a.select)?!0:a.select,s=(0,D.$re)(a.focus)?!1:a.focus,v=(0,D.$re)(a.expand)?!1:a.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):n?this.z.then(()=>this.O(n)).then($=>this.Q(n,$[$.length-1]).then(w=>this.F.$reveal(this.D,{item:w.item,parentChain:$.map(E=>E.item)},{select:r,focus:s,expand:v})),$=>this.H.error($)):this.F.$reveal(this.D,void 0,{select:r,focus:s,expand:v})}get message(){return this.J}set message(n){this.J=n,this.y.fire({message:!0,element:!1})}get title(){return this.L}set title(n){this.L=n,this.F.$setTitle(this.D,n,this.M)}get description(){return this.M}set description(n){this.M=n,this.F.$setTitle(this.D,this.L,n)}get badge(){return this.N}set badge(n){this.N?.value===n?.value&&this.N?.tooltip===n?.tooltip||(this.N=b.ViewBadge.from(n),this.F.$setBadge(this.D,n))}setExpanded(n,a){const r=this.getExtensionElement(n);r&&(a?this.r.fire(Object.freeze({element:r})):this.s.fire(Object.freeze({element:r})))}setSelectionAndFocus(n,a){const r=!(0,u.$$e)(this.l,n);this.l=n;const s=this.m!==a;this.m=a,r&&this.t.fire(Object.freeze({selection:this.selectedElements})),s&&this.u.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(n){n!==this.k&&(this.k=n,this.v.fire(Object.freeze({visible:this.k})))}async setCheckboxState(n){const a=(await Promise.all(n.map(async r=>{const s=this.getExtensionElement(r.treeItemHandle);return s?{extensionItem:s,treeItem:await this.f.getTreeItem(s),newState:r.newState?P.TreeItemCheckboxState.Checked:P.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(r=>r!==void 0);a.forEach(r=>{r.treeItem.checkboxState=r.newState?P.TreeItemCheckboxState.Checked:P.TreeItemCheckboxState.Unchecked}),this.w.fire({items:a.map(r=>[r.extensionItem,r.newState])})}async handleDrag(n,a,r){const s=[];for(const v of n){const $=this.getExtensionElement(v);$&&s.push($)}if(!(!this.g?.handleDrag||s.length===0))return await this.g.handleDrag(s,a,r),a}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(n,a,r){const s=a?this.getExtensionElement(a):void 0;if(!(!s&&a||!this.g?.handleDrop))return(0,f.$ng)(()=>this.g?.handleDrop?this.g.handleDrop(s,n,r):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(n,a){if(!this.f.resolveTreeItem)return;const r=this.i.get(n);if(r){const s=this.j.get(r);if(s){const v=await this.f.resolveTreeItem(s.extensionItem,r,a)??s.extensionItem;return this.db(v),s.item.tooltip=this.ab(v.tooltip),s.item.command=this.bb(s.disposableStore,v.command),s.item}}}O(n){return this.P(n).then(a=>a?this.O(a).then(r=>this.Q(a,r[r.length-1]).then(s=>(r.push(s),r))):Promise.resolve([]))}P(n){const a=this.j.get(n);return a?Promise.resolve(a.parent?this.i.get(a.parent.item.handle):void 0):(0,f.$ng)(()=>this.f.getParent(n))}Q(n,a){const r=this.j.get(n);return r?Promise.resolve(r):(0,f.$ng)(()=>this.f.getTreeItem(n)).then(s=>this.gb(n,s,a,!0)).then(s=>this.getChildren(a?a.item.handle:void 0).then(()=>{const v=this.getExtensionElement(s);if(v){const $=this.j.get(v);if($)return Promise.resolve($)}throw new Error(`Cannot resolve tree item for element ${s} from extension ${this.I.identifier.value}`)}))}R(n){if(n){let a;if(typeof n=="string"){const r=this.getExtensionElement(n);a=r?this.j.get(r):void 0}else a=n;return a&&a.children||void 0}return this.h}async S(n){this.nb(n);const a=new h.$oc(this.U.token);try{const r=n?this.j.get(n):void 0,s=await this.f.getChildren(n);if(a.token.isCancellationRequested)return;const v=await Promise.all((0,u.$jf)(s||[]).map(async $=>{const w=await this.f.getTreeItem($);return w&&!a.token.isCancellationRequested?this.$($,w,r):null}));return a.token.isCancellationRequested?void 0:(0,u.$jf)(v)}finally{a.dispose()}}W(n){if(n.some(r=>!r))return this.U.dispose(!0),this.U=new h.$oc,this.pb(),this.F.$refresh(this.D);{const r=this.X(n);if(r.length)return this.Y(r)}return Promise.resolve(void 0)}X(n){const a=new Set,r=n.map(v=>this.j.get(v));for(const v of r)if(v&&!a.has(v.item.handle)){let $=v;for(;$&&$.parent&&r.findIndex(w=>$&&$.parent&&w&&w.item.handle===$.parent.item.handle)===-1;){const w=this.i.get($.parent.item.handle);$=w?this.j.get(w):void 0}$&&!$.parent&&a.add(v.item.handle)}const s=[];return a.forEach(v=>{const $=this.i.get(v);if($){const w=this.j.get($);w&&(!w.parent||!a.has(w.parent.item.handle))&&s.push(v)}}),s}Y(n){const a={};return Promise.all(n.map(r=>this.Z(r).then(s=>{s&&(a[r]=s.item)}))).then(()=>Object.keys(a).length?this.F.$refresh(this.D,a):void 0)}Z(n){const a=this.getExtensionElement(n);if(a){const r=this.j.get(a);if(r)return this.nb(a),(0,f.$ng)(()=>this.f.getTreeItem(a)).then(s=>{if(s){const v=this.eb(a,s,r.parent);return this.lb(a,v,r,r.parent),r.dispose(),v}return null})}return Promise.resolve(null)}$(n,a,r){const s=this.eb(n,a,r);if(a.id&&this.i.has(s.item.handle))throw new Error((0,y.localize)(0,null,a.id));return this.kb(n,s),this.mb(s,r),s}ab(n){return P.$aK.isMarkdownString(n)?b.MarkdownString.from(n):n}bb(n,a){return a?{...this.G.toInternal(a,n),originalId:a.command}:void 0}cb(n){if(n.checkboxState===void 0)return;let a,r,s;return typeof n.checkboxState=="number"?a=n.checkboxState:(a=n.checkboxState.state,r=n.checkboxState.tooltip,s=n.checkboxState.accessibilityInformation),{isChecked:a===P.TreeItemCheckboxState.Checked,tooltip:r,accessibilityInformation:s}}db(n){if(!P.$yK.isTreeItem(n,this.I))throw new Error(`Extension ${this.I.identifier.value} has provided an invalid tree item.`)}eb(n,a,r){this.db(a);const s=new d.$kb,v=this.gb(n,a,r),$=this.hb(a);return{item:{handle:v,parentHandle:r?r.item.handle:void 0,label:c(a.label,this.I),description:a.description,resourceUri:a.resourceUri,tooltip:this.ab(a.tooltip),command:this.bb(s,a.command),contextValue:a.contextValue,icon:$,iconDark:this.ib(a)||$,themeIcon:this.fb(a),collapsibleState:(0,D.$re)(a.collapsibleState)?P.TreeItemCollapsibleState.None:a.collapsibleState,accessibilityInformation:a.accessibilityInformation,checkbox:this.cb(a)},extensionItem:a,parent:r,children:void 0,disposableStore:s,dispose(){s.dispose()}}}fb(n){return n.iconPath instanceof P.$GK?n.iconPath:void 0}gb(n,{id:a,label:r,resourceUri:s},v,$){if(a)return`${S.b}/${a}`;const w=c(r,this.I),E=v?v.item.handle:S.a;let o=w?w.label:s?(0,I.$6f)(s):"";o=o.indexOf("/")!==-1?o.replace("/","//"):o;const l=this.j.has(n)?this.j.get(n).item.handle:void 0,m=this.R(v)||[];let F,W=0;do{if(F=`${E}/${W}:${o}`,$||!this.i.has(F)||l===F)break;W++}while(W<=m.length);return F}hb(n){if(n.iconPath&&!(n.iconPath instanceof P.$GK))return typeof n.iconPath=="string"||M.URI.isUri(n.iconPath)?this.jb(n.iconPath):this.jb(n.iconPath.light)}ib(n){if(n.iconPath&&!(n.iconPath instanceof P.$GK)&&n.iconPath.dark)return this.jb(n.iconPath.dark)}jb(n){return M.URI.isUri(n)?n:M.URI.file(n)}kb(n,a){this.i.set(a.item.handle,n),this.j.set(n,a)}lb(n,a,r,s){this.i.delete(a.item.handle),this.j.delete(n),a.item.handle!==r.item.handle&&this.i.delete(r.item.handle),this.kb(n,a);const v=this.R(s)||[],$=v.filter(w=>w.item.handle===r.item.handle)[0];$&&v.splice(v.indexOf($),1,a)}mb(n,a){a?(a.children||(a.children=[]),a.children.push(n)):(this.h||(this.h=[]),this.h.push(n))}nb(n){if(n){const a=this.j.get(n);if(a){if(a.children)for(const r of a.children){const s=this.i.get(r.item.handle);s&&this.ob(s)}a.children=void 0}}else this.pb()}ob(n){const a=this.j.get(n);if(a){if(a.children)for(const r of a.children){const s=this.i.get(r.item.handle);s&&this.ob(s)}this.j.delete(n),this.i.delete(a.item.handle),a.dispose()}}pb(){this.h=void 0,this.i.clear(),this.j.forEach(n=>n.dispose()),this.j.clear()}dispose(){this.U.dispose(),this.pb(),this.F.$disposeTree(this.D)}}}),define(Pe[212],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatSlashCommands:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatSlashCommands.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageConfigurationAutoClosingPairs:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageConfigurationAutoClosingPairs.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookCodeActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCodeActions.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalContextMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalContextMenu.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testMessageContextValue:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageContextValue.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Pe[213],Ae([1,0,167,9,29,92,74,30,20,212,177,98]),function(pe,e,y,R,I,M,A,d,k,f,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PF=e.$OF=e.$NF=e.$MF=e.$LF=e.$KF=void 0;const u=d.$Um.as(A.$Vm.JSONContribution);class b{constructor(C,n,a){this.a=C,this.b=n,this.c=a}d(C,n){this.a({type:C,message:n,extensionId:this.b.identifier,extensionPointId:this.c})}error(C){this.d(I.default.Error,C)}warn(C){this.d(I.default.Warning,C)}info(C){this.d(I.default.Info,C)}}e.$KF=b;class p{static a(C){const n=new k.$Jl;for(let a=0,r=C.length;a<r;a++)n.add(C[a].description.identifier);return n}static compute(C,n){if(!C||!C.length)return new p(n,[]);if(!n||!n.length)return new p([],C);const a=this.a(C),r=this.a(n),s=n.filter($=>!a.has($.description.identifier)),v=C.filter($=>!r.has($.description.identifier));return new p(s,v)}constructor(C,n){this.added=C,this.removed=n}}e.$LF=p;class h{constructor(C,n){this.name=C,this.defaultExtensionKind=n,this.a=null,this.b=null,this.c=null}setHandler(C){if(this.a!==null)throw new Error("Handler already set!");this.a=C,this.d()}acceptUsers(C){this.c=p.compute(this.b,C),this.b=C,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(C){(0,R.$Y)(C)}}}e.$MF=h;const t={type:"string",enum:["ui","workspace"],enumDescriptions:[y.localize(0,null),y.localize(1,null)]},i="vscode://schemas/vscode-extensions";e.$NF={properties:{engines:{type:"object",description:y.localize(2,null),properties:{vscode:{type:"string",description:y.localize(3,null),default:"^1.22.0"}}},publisher:{description:y.localize(4,null),type:"string"},displayName:{description:y.localize(5,null),type:"string"},categories:{description:y.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:k.$Hl},{type:"string",const:"Languages",deprecationMessage:y.localize(7,null)}]}},galleryBanner:{type:"object",description:y.localize(8,null),properties:{color:{description:y.localize(9,null),type:"string"},theme:{description:y.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:y.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:y.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:y.localize(13,null)},enabledApiProposals:{markdownDescription:y.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(f.allApiProposals),markdownEnumDescriptions:Object.values(f.allApiProposals)}},api:{markdownDescription:y.localize(15,null),type:"string",enum:["none"],enumDescriptions:[y.localize(16,null)]},activationEvents:{description:y.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:y.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:y.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:y.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:y.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:y.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:y.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:y.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:y.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:y.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:y.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:y.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:y.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:y.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:y.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:y.localize(32,null)},{label:"onUri",body:"onUri",description:y.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:y.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:y.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:y.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:y.localize(37,null)},{label:"onRenderer",description:y.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:y.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:y.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:y.localize(41,null)},{label:"*",description:y.localize(42,null),body:"*"}]}},badges:{type:"array",description:y.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:y.localize(44,null)},href:{type:"string",description:y.localize(45,null)},description:{type:"string",description:y.localize(46,null)}}}},markdown:{type:"string",description:y.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:y.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:y.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.$En}},extensionPack:{description:y.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.$En}},extensionKind:{description:y.localize(51,null),type:"array",items:t,default:["workspace"],defaultSnippets:[{body:["ui"],description:y.localize(52,null)},{body:["workspace"],description:y.localize(53,null)},{body:["ui","workspace"],description:y.localize(54,null)},{body:["workspace","ui"],description:y.localize(55,null)},{body:[],description:y.localize(56,null)}]},capabilities:{description:y.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:y.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:y.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[y.localize(60,null),y.localize(61,null),y.localize(62,null)]},description:{type:"string",markdownDescription:y.localize(63,null)}}},untrustedWorkspaces:{description:y.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:y.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[y.localize(66,null),y.localize(67,null),y.localize(68,null)]},restrictedConfigurations:{description:y.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:y.localize(70,null)}}}}},sponsor:{description:y.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:y.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:y.localize(73,null),type:"string"},"vscode:uninstall":{description:y.localize(74,null),type:"string"}}},icon:{type:"string",description:y.localize(75,null)},l10n:{type:"string",description:y.localize(76,null)},pricing:{type:"string",markdownDescription:y.localize(77,null),enum:["Free","Trial"],default:"Free"}}};class c{constructor(){this.a=new Map}registerExtensionPoint(C){if(this.a.has(C.extensionPoint))throw new Error("Duplicate extension point: "+C.extensionPoint);const n=new h(C.extensionPoint,C.defaultExtensionKind);return this.a.set(C.extensionPoint,n),C.activationEventsGenerator&&D.$pF.register(C.extensionPoint,C.activationEventsGenerator),e.$NF.properties.contributes.properties[C.extensionPoint]=C.jsonSchema,u.registerSchema(i,e.$NF),n}getExtensionPoints(){return Array.from(this.a.values())}}e.$OF=c;const g={ExtensionsRegistry:"ExtensionsRegistry"};d.$Um.add(g.ExtensionsRegistry,new c),e.$PF=d.$Um.as(g.ExtensionsRegistry),u.registerSchema(i,e.$NF),u.registerSchema(P.$$i,{properties:{extensionEnabledApiProposals:{description:y.localize(78,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(f.allApiProposals),markdownEnumDescriptions:Object.values(f.allApiProposals)}}]}}}})}),define(Pe[214],Ae([1,0,164,16,24,213,32,5]),function(pe,e,y,R,I,M,A,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YF=void 0;const k={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:y.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:y.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:y.localize(2,null),default:""}}};var f;(function(u){function b(p,h,t){if(!p)return;const i=R.$ie(p.type)?p.type:void 0;if(!i||i.length===0){t.error(y.localize(3,null));return}const c=[];if(Array.isArray(p.required))for(const g of p.required)R.$ie(g)&&c.push(g);return{extensionId:h.value,taskType:i,required:c,properties:p.properties?I.$Im(p.properties):{},when:p.when?A.$vi.deserialize(p.when):void 0}}u.from=b})(f||(f={}));const P=M.$PF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(u,b)=>{for(const p of u)p.type&&b.push(`onTaskType:${p.type}`)},jsonSchema:{description:y.localize(4,null),type:"array",items:k}});class D{constructor(){this.d=new d.$ec,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((b,p)=>{P.setHandler((h,t)=>{this.c=void 0;try{for(const i of t.removed){const c=i.value;for(const g of c)this.a&&g.type&&this.a[g.type]&&delete this.a[g.type]}for(const i of t.added){const c=i.value;for(const g of c){const S=f.from(g,i.description.identifier,i.collector);S&&(this.a[S.taskType]=S)}}(t.removed.length>0||t.added.length>0)&&this.d.fire()}catch{}b(void 0)})})}onReady(){return this.b}get(b){return this.a[b]}all(){return Object.keys(this.a).map(b=>this.a[b])}getJsonSchema(){if(this.c===void 0){const b=[];for(const p of this.all()){const h={type:"object",additionalProperties:!1};p.required.length>0&&(h.required=p.required.slice(0)),p.properties!==void 0?h.properties=I.$Im(p.properties):h.properties=Object.create(null),h.properties.type={type:"string",enum:[p.taskType]},b.push(h)}this.c={oneOf:b}}return this.c}}e.$YF=new D}),define(Pe[215],Ae([1,0,165,16,23,24,32,214]),function(pe,e,y,R,I,M,A,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$9F=e.JsonSchemaVersion=e.ExecutionEngine=e.$8F=e.$7F=e.$6F=e.$5F=e.$4F=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$3F=e.ShellQuoting=e.$2F=e.$1F=e.$ZF=void 0,e.$ZF="settings",e.$1F=new A.$Oi("taskRunning",!1,y.localize(0,null)),e.$2F={value:y.localize(1,null),original:"Tasks"};var k;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(k||(e.ShellQuoting=k={})),e.$3F="$customized",function(U){function z(ne){if(!ne)return U.Strong;switch(ne.toLowerCase()){case"escape":return U.Escape;case"strong":return U.Strong;case"weak":return U.Weak;default:return U.Strong}}U.from=z}(k||(e.ShellQuoting=k={}));var f;(function(U){U.defaults={cwd:"${workspaceFolder}"}})(f||(e.CommandOptions=f={}));var P;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(P||(e.RevealKind=P={})),function(U){function z(ne){switch(ne.toLowerCase()){case"always":return U.Always;case"silent":return U.Silent;case"never":return U.Never;default:return U.Always}}U.fromString=z}(P||(e.RevealKind=P={}));var D;(function(U){U[U.Never=1]="Never",U[U.OnProblem=2]="OnProblem",U[U.Always=3]="Always"})(D||(e.RevealProblemKind=D={})),function(U){function z(ne){switch(ne.toLowerCase()){case"always":return U.Always;case"never":return U.Never;case"onproblem":return U.OnProblem;default:return U.OnProblem}}U.fromString=z}(D||(e.RevealProblemKind=D={}));var u;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(u||(e.PanelKind=u={})),function(U){function z(ne){switch(ne.toLowerCase()){case"shared":return U.Shared;case"dedicated":return U.Dedicated;case"new":return U.New;default:return U.Shared}}U.fromString=z}(u||(e.PanelKind=u={}));var b;(function(U){U.defaults={echo:!0,reveal:P.Always,revealProblems:D.Never,focus:!1,panel:u.Shared,showReuseMessage:!0,clear:!1}})(b||(e.PresentationOptions=b={}));var p;(function(U){U[U.Shell=1]="Shell",U[U.Process=2]="Process",U[U.CustomExecution=3]="CustomExecution"})(p||(e.RuntimeType=p={})),function(U){function z(Z){switch(Z.toLowerCase()){case"shell":return U.Shell;case"process":return U.Process;case"customExecution":return U.CustomExecution;default:return U.Process}}U.fromString=z;function ne(Z){switch(Z){case U.Shell:return"shell";case U.Process:return"process";case U.CustomExecution:return"customExecution";default:return"process"}}U.toString=ne}(p||(e.RuntimeType=p={}));var h;(function(U){function z(ne){return R.$ie(ne)?ne:ne.value}U.value=z})(h||(e.CommandString=h={}));var t;(function(U){U.Clean={_id:"clean",isDefault:!1},U.Build={_id:"build",isDefault:!1},U.Rebuild={_id:"rebuild",isDefault:!1},U.Test={_id:"test",isDefault:!1};function z(Z){return Z===U.Clean._id||Z===U.Build._id||Z===U.Rebuild._id||Z===U.Test._id}U.is=z;function ne(Z){if(Z!==void 0)return R.$ie(Z)?z(Z)?{_id:Z,isDefault:!1}:void 0:Z}U.from=ne})(t||(e.TaskGroup=t={}));var i;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.Folder=3]="Folder"})(i||(e.TaskScope=i={}));var c;(function(U){U.Workspace="workspace",U.Extension="extension",U.InMemory="inMemory",U.WorkspaceFile="workspaceFile",U.User="user";function z(ne){switch(ne){case U.User:return 2;case U.WorkspaceFile:return 5;default:return 6}}U.toConfigurationTarget=z})(c||(e.TaskSourceKind=c={}));var g;(function(U){U.parallel="parallel",U.sequence="sequence"})(g||(e.DependsOrder=g={}));var S;(function(U){U[U.default=1]="default",U[U.folderOpen=2]="folderOpen"})(S||(e.RunOnOptions=S={}));var C;(function(U){U.defaults={reevaluateOnRerun:!0,runOn:S.default,instanceLimit:1}})(C||(e.RunOptions=C={}));class n{constructor(z,ne,Z,we,Ee,Re){this._label="",this._id=z,ne&&(this._label=ne),Z&&(this.type=Z),this.runOptions=we,this.configurationProperties=Ee,this._source=Re}getDefinition(z){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const z={folder:this.d(),id:this._id};return JSON.stringify(z)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(z,ne=!1){if(z===void 0)return!1;if(R.$ie(z))return z===this._label||z===this.configurationProperties.identifier||ne&&z===this._id;const Z=this.getDefinition(!0);return Z!==void 0&&Z._key===z._key}getQualifiedLabel(){const z=this.getWorkspaceFolder();return z?`${this._label} (${z.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(z){this.c===void 0&&(this.c=[]),z&&(this.c=this.c.concat(z))}get taskLoadMessages(){return this.c}}e.$4F=n;class a extends n{constructor(z,ne,Z,we,Ee,Re,X,de){super(z,Z,void 0,X,de,ne),this.command={},this._source=ne,this.hasDefinedMatchers=Re,Ee&&(this.command=Ee)}clone(){return new a(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(z=!1){if(z&&this._source.customizes!==void 0)return this._source.customizes;{let ne;switch(this.command?this.command.runtime:void 0){case p.Shell:ne="shell";break;case p.Process:ne="process";break;case p.CustomExecution:ne="customExecution";break;case void 0:ne="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:ne,_key:this._id,id:this._id}}}static is(z){return z instanceof a}getMapKey(){const z=this._source.config.workspaceFolder;return z?`${z.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===c.User?e.$ZF:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const z=this.d();if(!z)return;let ne=this.configurationProperties.identifier;this._source.kind!==c.Workspace&&(ne+=this._source.kind);const Z={type:e.$3F,folder:z,id:ne};return JSON.stringify(Z)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.$6f(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(z){return new a(z._id,z._source,z._label,z.type,z.command,z.hasDefinedMatchers,z.runOptions,z.configurationProperties)}}e.$5F=a;class r extends n{constructor(z,ne,Z,we,Ee,Re,X){super(z,Z,we,Re,X,ne),this._source=ne,this.configures=Ee}static is(z){return z instanceof r}f(z){return z}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.$6f(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===c.User?e.$ZF:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const z=this.d();if(!z)return;let ne=this.configurationProperties.identifier;this._source.kind!==c.Workspace&&(ne+=this._source.kind);const Z={type:e.$3F,folder:z,id:ne};return JSON.stringify(Z)}}e.$6F=r;class s extends n{constructor(z,ne,Z,we,Ee,Re,X,de,Ce){super(z,Z,we,de,Ce,ne),this.defines=Ee,this.hasDefinedMatchers=X,this.command=Re,this.icon=Ce.icon,this.hide=Ce.hide}clone(){return new s(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(z){return z instanceof s}getMapKey(){const z=this._source.workspaceFolder;return z?`${this._source.scope.toString()}|${z.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const z={type:"contributed",scope:this._source.scope,id:this._id};return z.folder=this.d(),JSON.stringify(z)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(z){return new s(z._id,z._source,z._label,z.type,z.defines,z.command,z.hasDefinedMatchers,z.runOptions,z.configurationProperties)}}e.$7F=s;class v extends n{constructor(z,ne,Z,we,Ee,Re){super(z,Z,we,Ee,Re,ne),this._source=ne}clone(){return new v(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(z){return z instanceof v}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(z){return new v(z._id,z._source,z._label,z.type,z.runOptions,z.configurationProperties)}}e.$8F=v;var $;(function(U){U[U.Process=1]="Process",U[U.Terminal=2]="Terminal"})($||(e.ExecutionEngine=$={})),function(U){U._default=U.Terminal}($||(e.ExecutionEngine=$={}));var w;(function(U){U[U.V0_1_0=1]="V0_1_0",U[U.V2_0_0=2]="V2_0_0"})(w||(e.JsonSchemaVersion=w={}));class E{constructor(z){this.c=new Map;for(let ne=0;ne<z.length;ne++)this.c.set(z[ne].uri.toString(),ne)}compare(z,ne){const Z=z.getWorkspaceFolder(),we=ne.getWorkspaceFolder();if(Z&&we){let Ee=this.c.get(Z.uri.toString());Ee=Ee===void 0?0:Ee+1;let Re=this.c.get(we.uri.toString());return Re=Re===void 0?0:Re+1,Ee===Re?z._label.localeCompare(ne._label):Ee-Re}else return!Z&&we?-1:Z&&!we?1:0}}e.$9F=E;var o;(function(U){U.DependsOnStarted="dependsOnStarted",U.AcquiredInput="acquiredInput",U.Start="start",U.ProcessStarted="processStarted",U.Active="active",U.Inactive="inactive",U.Changed="changed",U.Terminated="terminated",U.ProcessEnded="processEnded",U.End="end"})(o||(e.TaskEventKind=o={}));var l;(function(U){U.SingleRun="singleRun",U.Background="background"})(l||(e.TaskRunType=l={}));var m;(function(U){U[U.System=0]="System",U[U.User=1]="User",U[U.FolderOpen=2]="FolderOpen",U[U.ConfigurationChange=3]="ConfigurationChange",U[U.Reconnect=4]="Reconnect"})(m||(e.TaskRunSource=m={}));var F;(function(U){function z(ne,Z,we,Ee){if(Z){const Re={kind:ne,taskId:Z._id,taskName:Z.configurationProperties.name,runType:Z.configurationProperties.isBackground?"background":"singleRun",group:Z.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:we,__task:Z};return ne==="start"?Re.resolvedVariables=Ee:ne==="processStarted"?Re.processId=Ee:ne==="processEnded"&&(Re.exitCode=Ee),Object.freeze(Re)}else return Object.freeze({kind:"changed"})}U.create=z})(F||(e.TaskEvent=F={}));var W;(function(U){function z(Z){const we=Object.keys(Z).sort();let Ee="";for(const Re of we){let X=Z[Re];X instanceof Object?X=z(X):typeof X=="string"&&(X=X.replace(/,/g,",,")),Ee+=Re+","+X+","}return Ee}function ne(Z){const Ee={_key:z(Z),type:Z.taskType};return Object.assign(Ee,Z),Ee}U.create=ne})(W||(e.KeyedTaskIdentifier=W={}));var V;(function(U){U.AutoDetect="task.autoDetect",U.SaveBeforeRun="task.saveBeforeRun",U.ShowDecorations="task.showDecorations",U.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",U.SlowProviderWarning="task.slowProviderWarning",U.QuickOpenHistory="task.quickOpen.history",U.QuickOpenDetail="task.quickOpen.detail",U.QuickOpenSkip="task.quickOpen.skip",U.QuickOpenShowAll="task.quickOpen.showAll",U.AllowAutomaticTasks="task.allowAutomaticTasks",U.Reconnection="task.reconnection"})(V||(e.TaskSettingId=V={}));var B;(function(U){U.Tasks="tasks",U.SuppressTaskName="tasks.suppressTaskName",U.Windows="tasks.windows",U.Osx="tasks.osx",U.Linux="tasks.linux",U.ShowOutput="tasks.showOutput",U.IsShellCommand="tasks.isShellCommand",U.ServiceTestSetting="tasks.service.testSetting"})(B||(e.TasksSchemaProperties=B={}));var j;(function(U){function z(ne,Z){const we=d.$YF.get(ne.type);if(we===void 0){const de=M.$Im(ne);return delete de._key,W.create(de)}const Ee=Object.create(null);Ee.type=we.taskType;const Re=new Set;we.required.forEach(de=>Re.add(de));const X=we.properties;for(const de of Object.keys(X)){const Ce=ne[de];if(Ce!=null)Ee[de]=Ce;else if(Re.has(de)){const ae=X[de];if(ae.default!==void 0)Ee[de]=M.$Im(ae.default);else switch(ae.type){case"boolean":Ee[de]=!1;break;case"number":case"integer":Ee[de]=0;break;case"string":Ee[de]="";break;default:Z.error(y.localize(2,null,JSON.stringify(ne,void 0,0),de));return}}}return W.create(Ee)}U.createTaskIdentifier=z})(j||(e.TaskDefinition=j={}))}),define(Pe[216],Ae([1,0,9]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U2b=e.$T2b=void 0;class R{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,d)=>{this.b=A,this.d=d,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,y.$Y)(A))}then(A,d){return this.j().then(A,d)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$T2b=R;class I extends R{constructor(){super(),this.h=!0,this.i=new y.$3}}e.$U2b=I}),define(Pe[46],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5z=e.$4z=e.$3z=e.$2z=void 0;class y{static{this.count=0}constructor(k){this._proxyIdentifierBrand=void 0,this.sid=k,this.nid=++y.count}}e.$2z=y;const R=[];function I(d){const k=new y(d);return R[k.nid]=k,k}e.$3z=I;function M(d){return R[d].sid}e.$4z=M;class A{constructor(k){this.value=k}}e.$5z=A}),define(Pe[3],Ae([1,0,46]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KJ=e.$JJ=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$IJ=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var R;(function(h){h[h.Default=0]="Default",h[h.InCenter=1]="InCenter",h[h.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",h[h.AtTop=3]="AtTop"})(R||(e.TextEditorRevealType=R={}));var I;(function(h){h[h.UnknownInput=0]="UnknownInput",h[h.TextInput=1]="TextInput",h[h.TextDiffInput=2]="TextDiffInput",h[h.TextMergeInput=3]="TextMergeInput",h[h.NotebookInput=4]="NotebookInput",h[h.NotebookDiffInput=5]="NotebookDiffInput",h[h.CustomEditorInput=6]="CustomEditorInput",h[h.WebviewEditorInput=7]="WebviewEditorInput",h[h.TerminalEditorInput=8]="TerminalEditorInput",h[h.InteractiveEditorInput=9]="InteractiveEditorInput"})(I||(e.TabInputKind=I={}));var M;(function(h){h[h.TAB_OPEN=0]="TAB_OPEN",h[h.TAB_CLOSE=1]="TAB_CLOSE",h[h.TAB_UPDATE=2]="TAB_UPDATE",h[h.TAB_MOVE=3]="TAB_MOVE"})(M||(e.TabModelOperationKind=M={}));var A;(function(h){h[h.Editable=0]="Editable",h[h.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var d;(function(h){h[h.Int8Array=1]="Int8Array",h[h.Uint8Array=2]="Uint8Array",h[h.Uint8ClampedArray=3]="Uint8ClampedArray",h[h.Int16Array=4]="Int16Array",h[h.Uint16Array=5]="Uint16Array",h[h.Int32Array=6]="Int32Array",h[h.Uint32Array=7]="Uint32Array",h[h.Float32Array=8]="Float32Array",h[h.Float64Array=9]="Float64Array",h[h.BigInt64Array=10]="BigInt64Array",h[h.BigUint64Array=11]="BigUint64Array"})(d||(e.WebviewMessageArrayBufferViewType=d={}));var k;(function(h){h[h.Text=1]="Text",h[h.Error=2]="Error",h[h.Rich=3]="Rich"})(k||(e.CellOutputKind=k={}));var f;(function(h){h[h.Default=0]="Default",h[h.InCenter=1]="InCenter",h[h.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",h[h.AtTop=3]="AtTop"})(f||(e.NotebookEditorRevealType=f={}));var P;(function(h){h[h.None=0]="None",h[h.Process=1]="Process",h[h.Output=2]="Output"})(P||(e.CandidatePortSource=P={}));class D{static{this.a=0}static mixin(t){return t._id=D.a++,t}}e.$IJ=D;var u;(function(h){h.label="a",h.kind="b",h.detail="c",h.documentation="d",h.sortText="e",h.filterText="f",h.preselect="g",h.insertText="h",h.insertTextRules="i",h.range="j",h.commitCharacters="k",h.additionalTextEdits="l",h.kindModifier="m",h.commandIdent="n",h.commandId="o",h.commandArguments="p"})(u||(e.ISuggestDataDtoField=u={}));var b;(function(h){h.defaultRanges="a",h.completions="b",h.isIncomplete="c",h.duration="d"})(b||(e.ISuggestResultDtoField=b={}));var p;(function(h){h[h.Workspace=0]="Workspace",h[h.TextDocument=1]="TextDocument"})(p||(e.ExtHostTestingResource=p={})),e.$JJ={MainThreadAuthentication:(0,y.$3z)("MainThreadAuthentication"),MainThreadBulkEdits:(0,y.$3z)("MainThreadBulkEdits"),MainThreadChatProvider:(0,y.$3z)("MainThreadChatProvider"),MainThreadChatSlashCommands:(0,y.$3z)("MainThreadChatSlashCommands"),MainThreadChatVariables:(0,y.$3z)("MainThreadChatVariables"),MainThreadClipboard:(0,y.$3z)("MainThreadClipboard"),MainThreadCommands:(0,y.$3z)("MainThreadCommands"),MainThreadComments:(0,y.$3z)("MainThreadComments"),MainThreadConfiguration:(0,y.$3z)("MainThreadConfiguration"),MainThreadConsole:(0,y.$3z)("MainThreadConsole"),MainThreadDebugService:(0,y.$3z)("MainThreadDebugService"),MainThreadDecorations:(0,y.$3z)("MainThreadDecorations"),MainThreadDiagnostics:(0,y.$3z)("MainThreadDiagnostics"),MainThreadDialogs:(0,y.$3z)("MainThreadDiaglogs"),MainThreadDocuments:(0,y.$3z)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,y.$3z)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,y.$3z)("MainThreadTextEditors"),MainThreadEditorInsets:(0,y.$3z)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,y.$3z)("MainThreadEditorTabs"),MainThreadErrors:(0,y.$3z)("MainThreadErrors"),MainThreadTreeViews:(0,y.$3z)("MainThreadTreeViews"),MainThreadDownloadService:(0,y.$3z)("MainThreadDownloadService"),MainThreadKeytar:(0,y.$3z)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,y.$3z)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,y.$3z)("MainThreadLanguages"),MainThreadLogger:(0,y.$3z)("MainThreadLogger"),MainThreadMessageService:(0,y.$3z)("MainThreadMessageService"),MainThreadOutputService:(0,y.$3z)("MainThreadOutputService"),MainThreadProgress:(0,y.$3z)("MainThreadProgress"),MainThreadQuickDiff:(0,y.$3z)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,y.$3z)("MainThreadQuickOpen"),MainThreadStatusBar:(0,y.$3z)("MainThreadStatusBar"),MainThreadSecretState:(0,y.$3z)("MainThreadSecretState"),MainThreadStorage:(0,y.$3z)("MainThreadStorage"),MainThreadTelemetry:(0,y.$3z)("MainThreadTelemetry"),MainThreadTerminalService:(0,y.$3z)("MainThreadTerminalService"),MainThreadWebviews:(0,y.$3z)("MainThreadWebviews"),MainThreadWebviewPanels:(0,y.$3z)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,y.$3z)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,y.$3z)("MainThreadCustomEditors"),MainThreadUrls:(0,y.$3z)("MainThreadUrls"),MainThreadUriOpeners:(0,y.$3z)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,y.$3z)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,y.$3z)("MainThreadWorkspace"),MainThreadFileSystem:(0,y.$3z)("MainThreadFileSystem"),MainThreadExtensionService:(0,y.$3z)("MainThreadExtensionService"),MainThreadSCM:(0,y.$3z)("MainThreadSCM"),MainThreadSearch:(0,y.$3z)("MainThreadSearch"),MainThreadShare:(0,y.$3z)("MainThreadShare"),MainThreadTask:(0,y.$3z)("MainThreadTask"),MainThreadWindow:(0,y.$3z)("MainThreadWindow"),MainThreadLabelService:(0,y.$3z)("MainThreadLabelService"),MainThreadNotebook:(0,y.$3z)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,y.$3z)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,y.$3z)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,y.$3z)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,y.$3z)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,y.$3z)("MainThreadInteractive"),MainThreadChat:(0,y.$3z)("MainThreadChat"),MainThreadInlineChat:(0,y.$3z)("MainThreadInlineChatShape"),MainThreadTheming:(0,y.$3z)("MainThreadTheming"),MainThreadTunnelService:(0,y.$3z)("MainThreadTunnelService"),MainThreadManagedSockets:(0,y.$3z)("MainThreadManagedSockets"),MainThreadTimeline:(0,y.$3z)("MainThreadTimeline"),MainThreadTesting:(0,y.$3z)("MainThreadTesting"),MainThreadLocalization:(0,y.$3z)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,y.$3z)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,y.$3z)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,y.$3z)("MainThreadIssueReporter")},e.$KJ={ExtHostCommands:(0,y.$3z)("ExtHostCommands"),ExtHostConfiguration:(0,y.$3z)("ExtHostConfiguration"),ExtHostDiagnostics:(0,y.$3z)("ExtHostDiagnostics"),ExtHostDebugService:(0,y.$3z)("ExtHostDebugService"),ExtHostDecorations:(0,y.$3z)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,y.$3z)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,y.$3z)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,y.$3z)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,y.$3z)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,y.$3z)("ExtHostEditors"),ExtHostTreeViews:(0,y.$3z)("ExtHostTreeViews"),ExtHostFileSystem:(0,y.$3z)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,y.$3z)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,y.$3z)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,y.$3z)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,y.$3z)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,y.$3z)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,y.$3z)("ExtHostQuickDiff"),ExtHostStatusBar:(0,y.$3z)("ExtHostStatusBar"),ExtHostShare:(0,y.$3z)("ExtHostShare"),ExtHostExtensionService:(0,y.$3z)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,y.$3z)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,y.$3z)("ExtHostTerminalService"),ExtHostSCM:(0,y.$3z)("ExtHostSCM"),ExtHostSearch:(0,y.$3z)("ExtHostSearch"),ExtHostTask:(0,y.$3z)("ExtHostTask"),ExtHostWorkspace:(0,y.$3z)("ExtHostWorkspace"),ExtHostWindow:(0,y.$3z)("ExtHostWindow"),ExtHostWebviews:(0,y.$3z)("ExtHostWebviews"),ExtHostWebviewPanels:(0,y.$3z)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,y.$3z)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,y.$3z)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,y.$3z)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,y.$3z)("ExtHostEditorTabs"),ExtHostProgress:(0,y.$3z)("ExtHostProgress"),ExtHostComments:(0,y.$3z)("ExtHostComments"),ExtHostSecretState:(0,y.$3z)("ExtHostSecretState"),ExtHostStorage:(0,y.$3z)("ExtHostStorage"),ExtHostUrls:(0,y.$3z)("ExtHostUrls"),ExtHostUriOpeners:(0,y.$3z)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,y.$3z)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,y.$3z)("ExtHostOutputService"),ExtHosLabelService:(0,y.$3z)("ExtHostLabelService"),ExtHostNotebook:(0,y.$3z)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,y.$3z)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,y.$3z)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,y.$3z)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,y.$3z)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,y.$3z)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,y.$3z)("ExtHostInteractive"),ExtHostInlineChat:(0,y.$3z)("ExtHostInlineChatShape"),ExtHostChat:(0,y.$3z)("ExtHostChat"),ExtHostChatSlashCommands:(0,y.$3z)("ExtHostChatSlashCommands"),ExtHostChatVariables:(0,y.$3z)("ExtHostChatVariables"),ExtHostChatProvider:(0,y.$3z)("ExtHostChatProvider"),ExtHostAiRelatedInformation:(0,y.$3z)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,y.$3z)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,y.$3z)("ExtHostTheming"),ExtHostTunnelService:(0,y.$3z)("ExtHostTunnelService"),ExtHostManagedSockets:(0,y.$3z)("ExtHostManagedSockets"),ExtHostAuthentication:(0,y.$3z)("ExtHostAuthentication"),ExtHostTimeline:(0,y.$3z)("ExtHostTimeline"),ExtHostTesting:(0,y.$3z)("ExtHostTesting"),ExtHostTelemetry:(0,y.$3z)("ExtHostTelemetry"),ExtHostLocalization:(0,y.$3z)("ExtHostLocalization"),ExtHostIssueReporter:(0,y.$3z)("ExtHostIssueReporter")}}),define(Pe[217],Ae([1,0,3,7]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ncc=void 0;class I{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(y.$JJ.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,d,k){if(this.a.size===0)throw new Error("No related information providers registered");const f=this.a.get(A);if(!f)throw new Error("related information provider not found");return await f.provideRelatedInformation(d,k)??[]}getRelatedInformation(A,d,k){return this.c.$getAiRelatedInformation(d,k)}registerRelatedInformationProvider(A,d,k){const f=this.b;return this.b++,this.a.set(f,k),this.c.$registerAiRelatedInformationProvider(f,d),new R.$LJ(()=>{this.c.$unregisterAiRelatedInformationProvider(f),this.a.delete(f)})}}e.$ncc=I}),define(Pe[80],Ae([1,0,4,14,3,17]),function(pe,e,y,R,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rac=e.$qac=e.$pac=void 0,e.$pac=(0,y.$ph)("IExtHostApiDeprecationService");let A=class{constructor(k,f){this.c=f,this.a=new Set,this.b=k.getProxy(I.$JJ.MainThreadTelemetry)}report(k,f,P){const D=this.d(k,f);this.a.has(D)||(this.a.add(D),f.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${k}' is deprecated. ${P}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:f.identifier.value,apiId:k}))}d(k,f){return`${k}-${f.identifier.value}`}};e.$qac=A,e.$qac=A=Ke([We(0,M.$LL),We(1,R.$Ri)],A),e.$rac=Object.freeze(new class{report(d,k,f){}})}),define(Pe[218],Ae([1,0,5,3,7,20]),function(pe,e,y,R,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xbc=void 0;class A{constructor(f){this.b=new Map,this.c=[],this.d=new y.$ec,this.onDidChangeSessions=this.d.event,this.f=new d,this.g=new d,this.a=f.getProxy(R.$JJ.MainThreadAuthentication)}$setProviders(f){return this.c=f,Promise.resolve()}async getSession(f,P,D,u={}){const b=M.$Il.toKey(f.identifier),p=[...D].sort().join(" ");return await this.f.getOrCreate(`${b} ${P} ${p}`,async()=>{await this.a.$ensureProvider(P);const h=f.displayName||f.name;return this.a.$getSession(P,D,b,h,u)})}async getSessions(f,P,D){const u=M.$Il.toKey(f.identifier),b=[...D].sort().join(" ");return await this.g.getOrCreate(`${u} ${b}`,async()=>{await this.a.$ensureProvider(P);const p=f.displayName||f.name;return this.a.$getSessions(P,D,u,p)})}async removeSession(f,P){const D=this.b.get(f);return D?D.provider.removeSession(P):this.a.$removeSession(f,P)}registerAuthenticationProvider(f,P,D,u){if(this.b.get(f))throw new Error(`An authentication provider with id '${f}' is already registered.`);this.b.set(f,{label:P,provider:D,options:u??{supportsMultipleAccounts:!1}}),this.c.find(p=>p.id===f)||this.c.push({id:f,label:P});const b=D.onDidChangeSessions(p=>{this.a.$sendDidChangeSessions(f,{added:p.added??[],changed:p.changed??[],removed:p.removed??[]})});return this.a.$registerAuthenticationProvider(f,P,u?.supportsMultipleAccounts??!1),new I.$LJ(()=>{b.dispose(),this.b.delete(f);const p=this.c.findIndex(h=>h.id===f);p>-1&&this.c.splice(p),this.a.$unregisterAuthenticationProvider(f)})}$createSession(f,P,D){const u=this.b.get(f);if(u)return Promise.resolve(u.provider.createSession(P,D));throw new Error(`Unable to find authentication provider with handle: ${f}`)}$removeSession(f,P){const D=this.b.get(f);if(D)return Promise.resolve(D.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${f}`)}$getSessions(f,P){const D=this.b.get(f);if(D)return Promise.resolve(D.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${f}`)}$onDidChangeAuthenticationSessions(f,P){return this.d.fire({provider:{id:f,label:P}}),Promise.resolve()}}e.$Xbc=A;class d{constructor(){this.a=new Map}getOrCreate(f,P){const D=this.a.get(f);if(D)return D;const u=P().finally(()=>this.a.delete(f));return this.a.set(f,u),u}}}),define(Pe[219],Ae([1,0,3,17,8]),function(pe,e,y,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4bc=void 0;let M=class{constructor(d,k){this.a=d.getProxy(y.$JJ.MainThreadBulkEdits),this.b={getTextDocumentVersion:f=>k.getDocument(f)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(d,k,f){const P=I.WorkspaceEdit.from(d,this.b);return this.a.$tryApplyWorkspaceEdit(P,void 0,f?.isRefactoring??!1)}};e.$4bc=M,e.$4bc=M=Ke([We(0,R.$LL)],M)}),define(Pe[220],Ae([1,0,13,5,67,6,59,147,3,8]),function(pe,e,y,R,I,M,A,d,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fcc=void 0;class P{static{this.a=0}constructor(b,p){this.extension=b,this.provider=p,this.handle=P.a++}}class D{static{this.a=0}constructor(b,p){this.h=p,this.b=new Map,this.d=new Map,this.e=new R.$ec,this.onDidPerformUserAction=this.e.event,this.g=b.getProxy(k.$JJ.MainThreadChat)}registerChatProvider(b,p,h){const t=new P(b,h);return this.b.set(t.handle,t),this.g.$registerChatProvider(t.handle,p),(0,M.$jb)(()=>{this.g.$unregisterChatProvider(t.handle),this.b.delete(t.handle)})}transferChatSession(b,p){const h=I.Iterable.find(this.d.keys(),t=>this.d.get(t)===b)??0;typeof h=="number"&&this.g.$transferChatSession(h,p)}addChatRequest(b){this.g.$addRequest(b)}sendInteractiveRequestToProvider(b,p){this.g.$sendRequestToProvider(b,p)}async $prepareChat(b,p,h){const t=this.b.get(b);if(!t)return;const i=await t.provider.prepareSession(p,h);if(!i)return;const c=D.a++;return this.d.set(c,i),{id:c,requesterUsername:i.requester?.name,requesterAvatarIconUri:i.requester?.icon,responderUsername:i.responder?.name,responderAvatarIconUri:i.responder?.icon,inputPlaceholder:i.inputPlaceholder}}async $resolveRequest(b,p,h,t){const i=this.b.get(b);if(!i)return;const c=this.d.get(p);if(!c||!i.provider.resolveRequest)return;const g=await i.provider.resolveRequest(c,h,t);if(g)return{message:typeof g.message=="string"?g.message:f.ChatReplyFollowup.from(g.message)}}async $provideWelcomeMessage(b,p){const h=this.b.get(b);if(!h||!h.provider.provideWelcomeMessage)return;const t=await h.provider.provideWelcomeMessage(p);if(t)return t.map(i=>typeof i=="string"?i:i.map(c=>f.ChatReplyFollowup.from(c)))}async $provideFollowups(b,p,h){const t=this.b.get(b);if(!t)return;const i=this.d.get(p);return!i||!t.provider.provideFollowups?void 0:(await t.provider.provideFollowups(i,h))?.map(g=>f.ChatFollowup.from(g))}$removeRequest(b,p,h){const t=this.b.get(b);if(!t)return;const i=this.d.get(p);i&&t.provider.removeRequest&&t.provider.removeRequest(i,h)}async $provideReply(b,p,h,t){const i=this.b.get(b);if(!i)return;const c=this.d.get(p);if(!c)return;const g={session:c,message:typeof h.message=="string"?h.message:f.ChatReplyFollowup.to(h.message),variables:{}};if(h.variables)for(const s of Object.keys(h.variables))g.variables[s]=h.variables[s].map(f.ChatVariable.to);const S=A.$ac.create(!1);let C;const n={report:s=>{if(!t.isCancellationRequested)if(typeof C>"u"&&(C=S.elapsed()),"responseId"in s)this.g.$acceptResponseProgress(b,p,{requestId:s.responseId});else if("placeholder"in s&&"resolvedContent"in s){const v=Promise.all([this.g.$acceptResponseProgress(b,p,{placeholder:s.placeholder}),s.resolvedContent]);(0,y.$jg)(v,t).then($=>{if(!$)return;const[w,E]=$;this.g.$acceptResponseProgress(b,p,E,w??void 0)})}else"content"in s?this.g.$acceptResponseProgress(b,p,{content:typeof s.content=="string"?s.content:f.MarkdownString.from(s.content)}):this.g.$acceptResponseProgress(b,p,s)}};let a;try{a=await i.provider.provideResponseWithProgress(g,n,t),a||(a={errorDetails:{message:(0,d.localize)(0,null)}})}catch(s){a={errorDetails:{message:(0,d.localize)(1,null,s.message),responseIsIncomplete:!0}},this.h.error(s)}try{if(c.saveState&&this.d.has(p)){const s=c.saveState();this.g.$acceptChatState(p,s)}}catch(s){this.h.warn(s)}const r={firstProgress:C??0,totalElapsed:S.elapsed()};return{errorDetails:a.errorDetails,timings:r}}async $provideSlashCommands(b,p,h){const t=this.b.get(b);if(!t)return;const i=this.d.get(p);return!i||!t.provider.provideSlashCommands?void 0:(await t.provider.provideSlashCommands(i,h))?.map(g=>({...g,kind:f.CompletionItemKind.from(g.kind)}))}$releaseSession(b){this.d.delete(b)}async $onDidPerformUserAction(b){this.e.fire(b)}}e.$fcc=D}),define(Pe[221],Ae([1,0,6,3,8,73,20]),function(pe,e,y,R,I,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kcc=void 0;class d{static{this.a=1}constructor(f,P){this.d=P,this.c=new Map,this.e=new Map,this.f=new A.$Kl,this.b=f.getProxy(R.$JJ.MainThreadChatProvider)}registerProvider(f,P,D,u){const b=d.a++;return this.c.set(b,{extension:f,provider:D}),this.b.$registerProvider(b,P,{extension:f,displayName:u.name??f.value}),(0,y.$jb)(()=>{this.b.$unregisterProvider(b),this.c.delete(b)})}async $provideChatResponse(f,P,D,u,b){const p=this.c.get(f);if(!p)return;const h=new M.$Tu(async t=>{if(b.isCancellationRequested){this.d.warn(`[CHAT](${p.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}await this.b.$handleProgressChunk(P,{index:t.index,part:t.part})},{async:!0});return p.provider.provideChatResponse(D.map(I.ChatMessage.to),u,h,b)}allowListExtensionWhile(f,P){this.f.set(f,P),P.finally(()=>this.f.delete(f))}async requestChatResponseProvider(f,P){if(!this.f.has(f))throw new Error("Extension is NOT allowed to make chat requests");const D=this;return{get isRevoked(){return!D.f.has(f)},async makeRequest(u,b,p,h){if(!D.f.has(f))throw new Error("Access to chat has been revoked");const t=Math.random()*1e6|0;D.e.set(t,p);try{await D.b.$fetchResponse(f,P,t,u.map(I.ChatMessage.from),b,h)}finally{D.e.delete(t)}}}}async $handleResponseFragment(f,P){this.e.get(f)?.report(P)}}e.$kcc=d}),define(Pe[222],Ae([1,0,6,3,7,8,73,13]),function(pe,e,y,R,I,M,A,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lcc=void 0;class k{static{this.a=0}constructor(P,D,u){this.d=D,this.e=u,this.b=new Map,this.c=P.getProxy(R.$JJ.MainThreadChatSlashCommands)}registerCommand(P,D,u,b){const p=k.a++;return this.b.set(p,{extension:P,command:u}),this.c.$registerCommand(p,D,b.description),(0,y.$jb)(()=>{this.c.$unregisterCommand(p),this.b.delete(p)})}async $executeCommand(P,D,u,b,p){const h=this.b.get(P);if(!h){this.e.warn(`[CHAT](${P}) CANNOT execute command because the command is not registered`);return}let t=!1;function i(){if(t)throw new Error("Only valid while executing the command")}const c=new d.$Pg;p.onCancellationRequested(()=>c.complete()),setTimeout(()=>c.complete(),3*1e3),this.d.allowListExtensionWhile(h.extension,c.p);const g=h.command({role:I.ChatMessageRole.User,content:u},{history:b.history.map(M.ChatMessage.to)},new A.$Tu(S=>{i(),this.c.$handleProgressChunk(D,{content:S.message.value})}),p);try{await(0,d.$jg)(Promise.resolve(g),p)}finally{t=!0,c.complete()}}}e.$lcc=k}),define(Pe[223],Ae([1,0,6,3,9,8]),function(pe,e,y,R,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mcc=void 0;class A{static{this.a=0}constructor(k){this.b=new Map,this.c=k.getProxy(R.$JJ.MainThreadChatVariables)}async $resolveVariable(k,f,P){const D=this.b.get(k);if(D)try{const u=await D.resolver.resolve(D.data.name,{message:f},P);if(u)return u.map(M.ChatVariable.from)}catch(u){(0,I.$Z)(u)}}registerVariableResolver(k,f,P,D){const u=A.a++;return this.b.set(u,{extension:k.identifier,data:{name:f,description:P},resolver:D}),this.c.$registerVariable(u,{name:f,description:P}),(0,y.$jb)(()=>{this.b.delete(u),this.c.$unregisterVariable(u)})}}e.$mcc=A}),define(Pe[224],Ae([1,0,3]),function(pe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uac=void 0;class R{constructor(M){const A=M.getProxy(y.$JJ.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(d){return A.$writeText(d)}})}}e.$uac=R}),define(Pe[31],Ae([1,0,16,7,8,24,3,18,14,69,44,278,2,6,4,17,105,25,46,41,59,53,58]),function(pe,e,y,R,I,M,A,d,k,f,P,D,u,b,p,h,t,i,c,g,S,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_L=e.$$L=e.$0L=e.$9L=e.$8L=e.$7L=void 0;let a=class{#e;#t;#i;constructor(E,o,l){this.b=new Map,this.c=new Map,this.#e=E.getProxy(A.$JJ.MainThreadCommands),this.d=o,this.#i=l,this.#t=E.getProxy(A.$JJ.MainThreadTelemetry),this.converter=new r(this,m=>{const F=this.c.get(m);return F?.result===v.Void?F:void 0},o),this.f=[{processArgument(m){return(0,f.$Yg)(m)}},{processArgument(m){return(0,M.$Km)(m,function(F){if(P.$Ur.isIRange(F))return I.Range.to(F);if(D.$Tr.isIPosition(F))return I.Position.to(F);if(P.$Ur.isIRange(F.range)&&u.URI.isUri(F.uri))return I.location.to(F);if(F instanceof i.$Ec)return F.buffer.buffer;if(!Array.isArray(F))return F})}}]}registerArgumentProcessor(E){this.f.push(E)}registerApiCommand(E){const o=this.registerCommand(!1,E.id,async(...l)=>{const m=E.args.map((W,V)=>{if(!W.validate(l[V]))throw new Error(`Invalid argument '${W.name}' when running '${E.id}', received: ${l[V]}`);return W.convert(l[V])}),F=await this.executeCommand(E.internalId,...m);return E.result.convert(F,l,this.converter)},void 0,{description:E.description,args:E.args,returns:E.result.description});return this.c.set(E.id,E),new R.$LJ(()=>{o.dispose(),this.c.delete(E.id)})}registerCommand(E,o,l,m,F,W){if(this.d.trace("ExtHostCommands#registerCommand",o),!o.trim().length)throw new Error("invalid id");if(this.b.has(o))throw new Error(`command '${o}' already exists`);return this.b.set(o,{callback:l,thisArg:m,description:F,extension:W}),E&&this.#e.$registerCommand(o),new R.$LJ(()=>{this.b.delete(o)&&E&&this.#e.$unregisterCommand(o)})}executeCommand(E,...o){return this.d.trace("ExtHostCommands#executeCommand",E),this.g(E,o,!0)}async g(E,o,l){if(this.b.has(E))return this.#e.$fireCommandActivationEvent(E),this.h(E,o,!1);{let m=!1;const F=(0,M.$Km)(o,function(W){if(W instanceof R.$MJ)return I.Position.from(W);if(W instanceof R.$NJ)return I.Range.from(W);if(W instanceof R.$XJ)return I.location.from(W);if(R.$0K.isNotebookRange(W))return I.NotebookRange.from(W);if(W instanceof ArrayBuffer)return m=!0,i.$Ec.wrap(new Uint8Array(W));if(W instanceof Uint8Array)return m=!0,i.$Ec.wrap(W);if(W instanceof i.$Ec)return m=!0,W;if(!Array.isArray(W))return W});try{const W=await this.#e.$executeCommand(E,m?new c.$5z(F):F,l);return(0,f.$Yg)(W)}catch(W){if(W instanceof Error&&W.message==="$executeCommand:retry")return this.g(E,o,!1);throw W}}}async h(E,o,l){const m=this.b.get(E);if(!m)throw new Error("Unknown command");const{callback:F,thisArg:W,description:V}=m;if(V)for(let j=0;j<V.args.length;j++)try{(0,y.$ze)(o[j],V.args[j].constraint)}catch{throw new Error(`Running the contributed command: '${E}' failed. Illegal argument '${V.args[j].name}' - ${V.args[j].description}`)}const B=S.$ac.create();try{return await F.apply(W,o)}catch(j){if(E===this.converter.delegatingCommandId){const U=this.converter.getActualCommand(...o);U&&(E=U.command)}if(this.d.error(j,E,m.extension?.identifier),!l)throw j;if(m.extension?.identifier){const U=this.#i.onExtensionError(m.extension.identifier,j);this.d.trace("forwarded error to extension?",U,m.extension?.identifier)}throw new class extends Error{constructor(){super((0,g.$ai)(j)),this.id=E,this.source=m.extension?.displayName??m.extension?.name}}}finally{this.j(m,E,B.elapsed())}}j(E,o,l){E.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:E.extension.identifier.value,id:new C.$4n(o),duration:l})}$executeContributedCommand(E,...o){this.d.trace("ExtHostCommands#$executeContributedCommand",E);const l=this.b.get(E);return l?(o=o.map(m=>this.f.reduce((F,W)=>W.processArgument(F,l.extension?.identifier),m)),this.h(E,o,!0)):Promise.reject(new Error(`Contributed command '${E}' does not exist.`))}getCommands(E=!1){return this.d.trace("ExtHostCommands#getCommands",E),this.#e.$getCommands().then(o=>(E&&(o=o.filter(l=>l[0]!=="_")),o))}$getContributedCommandHandlerDescriptions(){const E=Object.create(null);for(const[o,l]of this.b){const{description:m}=l;m&&(E[o]=m)}return Promise.resolve(E)}};e.$7L=a,e.$7L=a=Ke([We(0,h.$LL),We(1,k.$Ri),We(2,n.$6L)],a),e.$8L=(0,p.$ph)("IExtHostCommands");class r{constructor(E,o,l){this.d=E,this.f=o,this.g=l,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(E,o){if(!E)return;const l={$ident:void 0,id:E.command,title:E.title,tooltip:E.tooltip};if(!E.command)return l;const m=this.f(E.command);if(m)l.id=m.internalId,l.arguments=m.args.map((F,W)=>F.convert(E.arguments&&E.arguments[W]));else if((0,d.$nf)(E.arguments)){const F=`${E.command}/${++this.c}`;this.b.set(F,E),o.add((0,b.$jb)(()=>{this.b.delete(F),this.g.trace("CommandsConverter#DISPOSE",F)})),l.$ident=F,l.id=this.delegatingCommandId,l.arguments=[F],this.g.trace("CommandsConverter#CREATE",E.command,F)}return l}fromInternal(E){return typeof E.$ident=="string"?this.b.get(E.$ident):{command:E.id,title:E.title,arguments:E.arguments}}getActualCommand(...E){return this.b.get(E[0])}h(...E){const o=this.getActualCommand(...E);return this.g.trace("CommandsConverter#EXECUTE",E[0],o?o.command:"MISSING"),o?this.d.executeCommand(o.command,...o.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${E[0]}`)}}e.$9L=r;class s{static{this.Uri=new s("uri","Uri of a text document",E=>u.URI.isUri(E),E=>E)}static{this.Position=new s("position","A position in a text document",E=>R.$MJ.isPosition(E),I.Position.from)}static{this.Range=new s("range","A range in a text document",E=>R.$NJ.isRange(E),I.Range.from)}static{this.Selection=new s("selection","A selection in a text document",E=>R.$OJ.isSelection(E),I.Selection.from)}static{this.Number=new s("number","",E=>typeof E=="number",E=>E)}static{this.String=new s("string","",E=>typeof E=="string",E=>E)}static{this.StringArray=s.Arr(s.String)}static Arr(E){return new s(`${E.name}_array`,`Array of ${E.name}, ${E.description}`,o=>Array.isArray(o)&&o.every(l=>E.validate(l)),o=>o.map(l=>E.convert(l)))}static{this.CallHierarchyItem=new s("item","A call hierarchy item",E=>E instanceof R.$9J,I.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new s("item","A type hierarchy item",E=>E instanceof R.$qL,I.TypeHierarchyItem.from)}static{this.TestItem=new s("testItem","A VS Code TestItem",E=>E instanceof t.$YL,I.TestItem.from)}constructor(E,o,l,m){this.name=E,this.description=o,this.validate=l,this.convert=m}optional(){return new s(this.name,`(optional) ${this.description}`,E=>E==null||this.validate(E),E=>E===void 0?void 0:E===null?null:this.convert(E))}with(E,o){return new s(E??this.name,o??this.description,this.validate,this.convert)}}e.$0L=s;class v{static{this.Void=new v("no result",E=>E)}constructor(E,o){this.description=E,this.convert=o}}e.$$L=v;class ${constructor(E,o,l,m,F){this.id=E,this.internalId=o,this.description=l,this.args=m,this.result=F}}e.$_L=$}),define(Pe[225],Ae([1,0,18,12,2,78,91,32,95,31,8,7]),function(pe,e,y,R,I,M,A,d,k,f,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tac=void 0;const u=[new f.$_L("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[f.$0L.Uri,f.$0L.Position],new f.$$L("A promise that resolves to an array of DocumentHighlight-instances.",p(P.DocumentHighlight.to))),new f.$_L("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[f.$0L.Uri],new f.$$L("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(t,i)=>{if((0,y.$mf)(t))return;class c extends D.$3J{static to(S){const C=new c(S.name,P.SymbolKind.to(S.kind),S.containerName||"",new D.$XJ(i[0],P.Range.to(S.range)));return C.detail=S.detail,C.range=C.location.range,C.selectionRange=P.Range.to(S.selectionRange),C.children=S.children?S.children.map(c.to):[],C}}return t.map(c.to)})),new f.$_L("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[f.$0L.Uri,new f.$0L("options","Formatting options",t=>!0,t=>t)],new f.$$L("A promise that resolves to an array of TextEdits.",p(P.TextEdit.to))),new f.$_L("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[f.$0L.Uri,f.$0L.Range,new f.$0L("options","Formatting options",t=>!0,t=>t)],new f.$$L("A promise that resolves to an array of TextEdits.",p(P.TextEdit.to))),new f.$_L("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[f.$0L.Uri,f.$0L.Position,new f.$0L("ch","Trigger character",t=>typeof t=="string",t=>t),new f.$0L("options","Formatting options",t=>!0,t=>t)],new f.$$L("A promise that resolves to an array of TextEdits.",p(P.TextEdit.to))),new f.$_L("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[f.$0L.Uri,f.$0L.Position],new f.$$L("A promise that resolves to an array of Location or LocationLink instances.",h)),new f.$_L("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[f.$0L.Uri,f.$0L.Position],new f.$$L("A promise that resolves to an array of Location or LocationLink instances.",h)),new f.$_L("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[f.$0L.Uri,f.$0L.Position],new f.$$L("A promise that resolves to an array of Location or LocationLink instances.",h)),new f.$_L("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[f.$0L.Uri,f.$0L.Position],new f.$$L("A promise that resolves to an array of Location or LocationLink instances.",h)),new f.$_L("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[f.$0L.Uri,f.$0L.Position],new f.$$L("A promise that resolves to an array of Location-instances.",p(P.location.to))),new f.$_L("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[f.$0L.Uri,f.$0L.Position],new f.$$L("A promise that resolves to an array of Hover-instances.",p(P.Hover.to))),new f.$_L("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[f.$0L.Uri,new f.$0L("position","A position in a text document",t=>Array.isArray(t)&&t.every(i=>D.$MJ.isPosition(i)),t=>t.map(P.Position.from))],new f.$$L("A promise that resolves to an array of ranges.",t=>t.map(i=>{let c;for(const g of i.reverse())c=new D.$8J(P.Range.to(g),c);return c}))),new f.$_L("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[f.$0L.String.with("query","Search string")],new f.$$L("A promise that resolves to an array of SymbolInformation-instances.",t=>t.map(P.WorkspaceSymbol.to))),new f.$_L("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[f.$0L.Uri,f.$0L.Position],new f.$$L("A promise that resolves to an array of CallHierarchyItem-instances",t=>t.map(P.CallHierarchyItem.to))),new f.$_L("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[f.$0L.CallHierarchyItem],new f.$$L("A promise that resolves to an array of CallHierarchyIncomingCall-instances",t=>t.map(P.CallHierarchyIncomingCall.to))),new f.$_L("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[f.$0L.CallHierarchyItem],new f.$$L("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",t=>t.map(P.CallHierarchyOutgoingCall.to))),new f.$_L("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[f.$0L.Uri,f.$0L.Position],new f.$$L("A promise that resolves to a range and placeholder text.",t=>{if(t)return{range:P.Range.to(t.range),placeholder:t.text}})),new f.$_L("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[f.$0L.Uri,f.$0L.Position,f.$0L.String.with("newName","The new symbol name")],new f.$$L("A promise that resolves to a WorkspaceEdit.",t=>{if(t){if(t.rejectReason)throw new Error(t.rejectReason);return P.WorkspaceEdit.to(t)}})),new f.$_L("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[f.$0L.Uri,f.$0L.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new f.$$L("A promise that resolves to an array of DocumentLink-instances.",t=>t.map(P.DocumentLink.to))),new f.$_L("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[f.$0L.Uri],new f.$$L("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new D.$2K(t.tokenTypes,t.tokenModifiers)})),new f.$_L("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[f.$0L.Uri],new f.$$L("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const i=(0,A.$59)(t);if(i.type==="full")return new D.$4K(i.data,void 0)})),new f.$_L("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[f.$0L.Uri,f.$0L.Range.optional()],new f.$$L("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new D.$2K(t.tokenTypes,t.tokenModifiers)})),new f.$_L("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[f.$0L.Uri,f.$0L.Range],new f.$$L("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const i=(0,A.$59)(t);if(i.type==="full")return new D.$4K(i.data,void 0)})),new f.$_L("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[f.$0L.Uri,f.$0L.Position,f.$0L.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),f.$0L.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new f.$$L("A promise that resolves to a CompletionList-instance.",(t,i,c)=>{if(!t)return new D.$hK([]);const g=t.suggestions.map(S=>P.CompletionItem.to(S,c));return new D.$hK(g,t.incomplete)})),new f.$_L("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[f.$0L.Uri,f.$0L.Position,f.$0L.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new f.$$L("A promise that resolves to SignatureHelp.",t=>{if(t)return P.SignatureHelp.to(t)})),new f.$_L("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[f.$0L.Uri,f.$0L.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new f.$$L("A promise that resolves to an array of CodeLens-instances.",(t,i,c)=>p(g=>new D.$_J(P.Range.to(g.range),g.command&&c.fromInternal(g.command)))(t))),new f.$_L("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[f.$0L.Uri,new f.$0L("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",t=>D.$NJ.isRange(t),t=>D.$OJ.isSelection(t)?P.Selection.from(t):P.Range.from(t)),f.$0L.String.with("kind","Code action kind to return code actions for").optional(),f.$0L.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new f.$$L("A promise that resolves to an array of Command-instances.",(t,i,c)=>p(g=>{if(g._isSynthetic){if(!g.command)throw new Error("Synthetic code actions must have a command");return c.fromInternal(g.command)}else{const S=new D.$5J(g.title,g.kind?new D.$6J(g.kind):void 0);return g.edit&&(S.edit=P.WorkspaceEdit.to(g.edit)),g.command&&(S.command=c.fromInternal(g.command)),S.isPreferred=g.isPreferred,S}})(t))),new f.$_L("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[f.$0L.Uri],new f.$$L("A promise that resolves to an array of ColorInformation objects.",t=>t?t.map(i=>new D.$nK(P.Range.to(i.range),P.Color.to(i.color))):[])),new f.$_L("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new f.$0L("color","The color to show and insert",t=>t instanceof D.$mK,P.Color.from),new f.$0L("context","Context object with uri and range",t=>!0,t=>({uri:t.uri,range:P.Range.from(t.range)}))],new f.$$L("A promise that resolves to an array of ColorPresentation objects.",t=>t?t.map(P.ColorPresentation.to):[])),new f.$_L("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[f.$0L.Uri,f.$0L.Range],new f.$$L("A promise that resolves to an array of Inlay objects",(t,i,c)=>t.map(P.InlayHint.to.bind(void 0,c)))),new f.$_L("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[f.$0L.Uri],new f.$$L("A promise that resolves to an array of FoldingRange objects",(t,i)=>{if(t)return t.map(P.FoldingRange.to)})),new f.$_L("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new f.$$L("A promise that resolves to an array of NotebookContentProvider static info objects.",p(t=>({viewType:t.viewType,displayName:t.displayName,options:{transientOutputs:t.options.transientOutputs,transientCellMetadata:t.options.transientCellMetadata,transientDocumentMetadata:t.options.transientDocumentMetadata},filenamePattern:t.filenamePattern.map(i=>P.NotebookExclusiveDocumentPattern.to(i))})))),new f.$_L("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[f.$0L.Uri,f.$0L.Range],new f.$$L("A promise that resolves to an array of InlineValue objects",t=>t.map(P.InlineValue.to))),new f.$_L("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new f.$0L("uriOrString","Uri-instance or string (only http/https)",t=>I.URI.isUri(t)||typeof t=="string"&&(0,k.$sT)(t,R.Schemas.http,R.Schemas.https),t=>t),new f.$0L("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[P.ViewColumn.from(t),void 0]:[P.ViewColumn.from(t.viewColumn),P.TextEditorOpenOptions.from(t)])).optional(),f.$0L.String.with("label","").optional()],f.$$L.Void),new f.$_L("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[f.$0L.Uri.with("resource","Resource to open"),f.$0L.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new f.$0L("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[P.ViewColumn.from(t),void 0]:[P.ViewColumn.from(t.viewColumn),P.TextEditorOpenOptions.from(t)])).optional()],f.$$L.Void),new f.$_L("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[f.$0L.Uri.with("left","Left-hand side resource of the diff editor"),f.$0L.Uri.with("right","Right-hand side resource of the diff editor"),f.$0L.String.with("title","Human readable title for the diff editor").optional(),new f.$0L("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="object",t=>t&&[P.ViewColumn.from(t.viewColumn),P.TextEditorOpenOptions.from(t)]).optional()],f.$$L.Void),new f.$_L("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[f.$0L.Uri,f.$0L.Position],new f.$$L("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(P.TypeHierarchyItem.to))),new f.$_L("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[f.$0L.TypeHierarchyItem],new f.$$L("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(P.TypeHierarchyItem.to))),new f.$_L("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[f.$0L.TypeHierarchyItem],new f.$$L("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(P.TypeHierarchyItem.to))),new f.$_L("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[f.$0L.TestItem],f.$$L.Void),new f.$_L("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[f.$0L.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],f.$$L.Void),new f.$_L("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[f.$0L.String.with("name","The context key name"),new f.$0L("value","The context key value",()=>!0,t=>t)],f.$$L.Void),new f.$_L("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[f.$0L.Uri,f.$0L.StringArray,new f.$0L("MappedEditsContext","Mapped Edits Context",t=>P.MappedEditsContext.is(t),t=>P.MappedEditsContext.from(t))],new f.$$L("A promise that resolves to a workspace edit or null",t=>t?P.WorkspaceEdit.to(t):null))];class b{static register(i){u.forEach(i.registerApiCommand,i),this.a(i)}static a(i){i.registerCommand(!1,"_validateWhenClauses",d.$wi)}}e.$tac=b;function p(t){return i=>{if(Array.isArray(i))return i.map(t)}}function h(t){if(!Array.isArray(t))return;const i=[];for(const c of t)M.$ws(c)?i.push(P.DefinitionLink.to(c)):i.push(P.location.to(c));return i}}),define(Pe[226],Ae([1,0,13,65,5,6,2,78,20,8,7,3,26]),function(pe,e,y,R,I,M,A,d,k,f,P,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vac=void 0;function b(p,h,t){const i=p.getProxy(D.$JJ.MainThreadComments);class c{static{this.a=0}constructor(){this.b=new Map,this.c=new k.$Kl,h.registerArgumentProcessor({processArgument:$=>{if($&&$.$mid===6){const w=this.b.get($.handle);return w?w.value:$}else if($&&$.$mid===7){const w=this.b.get($.commentControlHandle);if(!w)return $;const E=w.getCommentThread($.commentThreadHandle);return E?E.value:$}else if($&&($.$mid===9||$.$mid===8)){const w=this.b.get($.thread.commentControlHandle);if(!w)return $;const E=w.getCommentThread($.thread.commentThreadHandle);return E?$.$mid===8?E.value:{thread:E.value,text:$.text}:$}else if($&&$.$mid===10){const w=this.b.get($.thread.commentControlHandle);if(!w)return $;const E=w.getCommentThread($.thread.commentThreadHandle);if(!E)return $;const o=$.commentUniqueId,l=E.getCommentByUniqueId(o);return l||$}else if($&&$.$mid===11){const w=this.b.get($.thread.commentControlHandle);if(!w)return $;const E=w.getCommentThread($.thread.commentThreadHandle);if(!E)return $;const o=$.text,l=$.commentUniqueId,m=E.getCommentByUniqueId(l);return m?(typeof m.body=="string"?m.body=o:m.body=new P.$aK(o),m):$}return $}})}createCommentController($,w,E){const o=c.a++,l=new S($,o,w,E);this.b.set(l.handle,l);const m=this.c.get($.identifier)||[];return m.push(l),this.c.set($.identifier,m),l.value}$createCommentThreadTemplate($,w,E){const o=this.b.get($);o&&o.$createCommentThreadTemplate(w,E)}async $updateCommentThreadTemplate($,w,E){const o=this.b.get($);o&&o.$updateCommentThreadTemplate(w,E)}$deleteCommentThread($,w){this.b.get($)?.$deleteCommentThread(w)}$provideCommentingRanges($,w,E){const o=this.b.get($);if(!o||!o.commentingRangeProvider)return Promise.resolve(void 0);const l=t.getDocument(A.URI.revive(w));return(0,y.$ng)(async()=>{const m=await o.commentingRangeProvider.provideCommentingRanges(l,E);let F;return Array.isArray(m)?F={ranges:m,fileComments:!1}:m?F={ranges:m.ranges||[],fileComments:m.fileComments||!1}:F=m??void 0,F}).then(m=>{let F;return m&&(F={ranges:m.ranges.map(W=>f.Range.from(W)),fileComments:m.fileComments}),F})}$toggleReaction($,w,E,o,l){const m=this.b.get($);return!m||!m.reactionHandler?Promise.resolve(void 0):(0,y.$ng)(()=>{const F=m.getCommentThread(w);if(F){const W=F.getCommentByUniqueId(o.uniqueIdInThread);if(m!==void 0&&W&&m.reactionHandler)return m.reactionHandler(W,a(l))}return Promise.resolve(void 0)})}}class g{static{this.a=0}set threadId($){this.n=$}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range($){($===void 0!=(this.p===void 0)||!$||!this.p||!$.isEqual(this.p))&&(this.p=$,this.b.range=$,this.c.fire())}get range(){return this.p}set canReply($){this.d!==$&&(this.d=$,this.b.canReply=$,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label($){this.e=$,this.b.label=$,this.c.fire()}get contextValue(){return this.f}set contextValue($){this.f=$,this.b.contextValue=$,this.c.fire()}get comments(){return this.q}set comments($){this.q=$,this.b.comments=$,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState($){this.g=$,this.b.collapsibleState=$,this.c.fire()}get state(){return this.h}set state($){this.h=$,this.b.state=$,this.c.fire()}get isDisposed(){return this.j}constructor($,w,E,o,l,m,F,W){this.m=w,this.n=E,this.o=o,this.p=l,this.q=m,this.extensionDescription=F,this.r=W,this.handle=g.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new I.$ec,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new M.$mb,this.l.value=new M.$kb,this.n===void 0&&(this.n=`${$}.${this.handle}`),i.$createCommentThread(w,this.handle,this.n,this.o,f.Range.from(this.p),F.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=m,this.i.push({dispose:()=>{i.$deleteCommentThread(w,this.handle)}});const V=this;this.value={get uri(){return V.uri},get range(){return V.range},set range(B){V.range=B},get comments(){return V.comments},set comments(B){V.comments=B},get collapsibleState(){return V.collapsibleState},set collapsibleState(B){V.collapsibleState=B},get canReply(){return V.canReply},set canReply(B){V.canReply=B},get contextValue(){return V.contextValue},set contextValue(B){V.contextValue=B},get label(){return V.label},set label(B){V.label=B},get state(){return V.state},set state(B){V.state=B},dispose:()=>{V.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new M.$kb);const $=E=>Object.prototype.hasOwnProperty.call(this.b,E),w={};$("range")&&(w.range=f.Range.from(this.p)),$("label")&&(w.label=this.label),$("contextValue")&&(w.contextValue=this.contextValue??null),$("comments")&&(w.comments=this.q.map(E=>C(this,E,this.k,this.extensionDescription))),$("collapsibleState")&&(w.collapseState=r(this.g)),$("canReply")&&(w.canReply=this.canReply),$("state")&&(w.state=s(this.h)),$("isTemplate")&&(w.isTemplate=this.r),this.b={},i.$updateCommentThread(this.m,this.handle,this.n,this.o,w)}getCommentByUniqueId($){for(const w of this.k){const E=w[0],o=w[1];if($===o)return E}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach($=>$.dispose())}}Ke([(0,R.$Ug)(100)],g.prototype,"eventuallyUpdateCommentThread",null);class S{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider($){this.b=$,i.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler($){this.c=$,i.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!$})}get options(){return this.d}set options($){this.d=$,i.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor($,w,E,o){this.f=$,this.g=w,this.h=E,this.i=o,this.a=new Map,i.$registerCommentController(this.handle,E,o);const l=this;this.value=Object.freeze({id:l.id,label:l.label,get options(){return l.options},set options(m){l.options=m},get commentingRangeProvider(){return l.commentingRangeProvider},set commentingRangeProvider(m){l.commentingRangeProvider=m},get reactionHandler(){return l.reactionHandler},set reactionHandler(m){l.reactionHandler=m},createCommentThread(m,F,W){return l.createCommentThread(m,F,W).value},dispose:()=>{l.dispose()}}),this.e=[],this.e.push({dispose:()=>{i.$unregisterCommentController(this.handle)}})}createCommentThread($,w,E){w===void 0&&(0,u.$EF)(this.f,"fileComments");const o=new g(this.id,this.handle,void 0,$,w,E,this.f,!1);return this.a.set(o.handle,o),o}$createCommentThreadTemplate($,w){const E=new g(this.id,this.handle,void 0,A.URI.revive($),f.Range.to(w),[],this.f,!0);return E.collapsibleState=d.CommentThreadCollapsibleState.Expanded,this.a.set(E.handle,E),E}$updateCommentThreadTemplate($,w){const E=this.a.get($);E&&(E.range=f.Range.to(w))}$deleteCommentThread($){this.a.get($)?.dispose(),this.a.delete($)}getCommentThread($){return this.a.get($)}dispose(){this.a.forEach($=>{$.dispose()}),this.e.forEach($=>$.dispose())}}function C(v,$,w,E){let o=w.get($);return o||(o=++v.commentHandle,w.set($,o)),$.state!==void 0&&(0,u.$EF)(E,"commentsDraftState"),{mode:$.mode,contextValue:$.contextValue,uniqueIdInThread:o,body:typeof $.body=="string"?$.body:f.MarkdownString.from($.body),userName:$.author.name,userIconPath:$.author.iconPath,label:$.label,commentReactions:$.reactions?$.reactions.map(l=>n(l)):void 0,state:$.state,timestamp:$.timestamp?.toJSON()}}function n(v){return{label:v.label,iconPath:v.iconPath?f.$KL(v.iconPath):void 0,count:v.count,hasReacted:v.authorHasReacted}}function a(v){return{label:v.label||"",count:v.count||0,iconPath:v.iconPath?A.URI.revive(v.iconPath):"",authorHasReacted:v.hasReacted||!1}}function r(v){if(v!==void 0)switch(v){case P.CommentThreadCollapsibleState.Expanded:return d.CommentThreadCollapsibleState.Expanded;case P.CommentThreadCollapsibleState.Collapsed:return d.CommentThreadCollapsibleState.Collapsed}return d.CommentThreadCollapsibleState.Collapsed}function s(v){if(v!==void 0)switch(v){case P.CommentThreadState.Unresolved:return d.CommentThreadState.Unresolved;case P.CommentThreadState.Resolved:return d.CommentThreadState.Resolved}return d.CommentThreadState.Unresolved}return new c}e.$vac=b}),define(Pe[227],Ae([1,0,24,3,27,17]),function(pe,e,y,R,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rcc=void 0;let A=class{constructor(P,D){this.a=P.getProxy(R.$JJ.MainThreadConsole),this.b=D.consoleForward.includeStack,this.c=D.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(P,D){const u=this,b=console[P];Object.defineProperty(console,P,{set:()=>{},get:()=>function(){u.e(P,D,b,arguments)}})}e(P,D,u,b){this.a.$logExtensionHostMessage({type:"__$console",severity:D,arguments:k(b,this.b)}),this.c&&this.f(P,u,b)}};e.$rcc=A,e.$rcc=A=Ke([We(0,M.$LL),We(1,I.$2L)],A);const d=1e5;function k(f,P){const D=[];if(f.length)for(let u=0;u<f.length;u++){let b=f[u];if(typeof b>"u")b="undefined";else if(b instanceof Error){const p=b;p.stack?b=p.stack:b=p.toString()}D.push(b)}if(P){const u=new Error().stack;u&&D.push({__$stack:u.split(`
`).slice(3).join(`
`)})}try{const u=(0,y.$Nm)(D);return u.length>d?"Output omitted for a large object that exceeds the limits":u}catch(u){return`Output omitted for an object that cannot be inspected ('${u.toString()}')`}}}),define(Pe[108],Ae([1,0,2,3,7,4,17,14,18,15,19,26]),function(pe,e,y,R,I,M,A,d,k,f,P,D){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$xbc=e.$wbc=void 0;let b=class{static{u=this}static{this.c=0}static{this.d=250}constructor(h,t){this.h=t,this.f=new Map,this.g=h.getProxy(R.$JJ.MainThreadDecorations)}registerFileDecorationProvider(h,t){const i=u.c++;this.f.set(i,{provider:h,extensionDescription:t}),this.g.$registerDecorationProvider(i,t.identifier.value);const c=h.onDidChangeFileDecorations&&h.onDidChangeFileDecorations(g=>{if(!g){this.g.$onDidChange(i,null);return}const S=(0,k.$Gf)(g);if(S.length<=u.d){this.g.$onDidChange(i,S);return}this.h.warn("[Decorations] CAPPING events from decorations provider",t.identifier.value,S.length);const C=S.map(r=>({uri:r,rank:(0,f.$qd)(r.path,"/")})),n=(0,k.$ef)(C,(r,s)=>r.rank-s.rank||(0,f.$Ed)(r.uri.path,s.uri.path)),a=[];e:for(const r of n){let s;for(const v of r){const $=(0,P.$$c)(v.uri.path);if(s!==$&&(s=$,a.push(v.uri)>=u.d))break e}}this.g.$onDidChange(i,a)});return new I.$LJ(()=>{c?.dispose(),this.g.$unregisterDecorationProvider(i),this.f.delete(i)})}async $provideDecorations(h,t,i){if(!this.f.has(h))return Object.create(null);const c=Object.create(null),{provider:g,extensionDescription:S}=this.f.get(h);return await Promise.all(t.map(async C=>{try{const{uri:n,id:a}=C,r=await Promise.resolve(g.provideFileDecoration(y.URI.revive(n),i));if(!r)return;try{I.$8K.validate(r),r.badge&&typeof r.badge!="string"&&(0,D.$EF)(S,"codiconDecoration"),c[a]=[r.propagate,r.tooltip,r.badge,r.color]}catch(s){this.h.warn(`INVALID decoration from extension '${S.identifier.value}': ${s}`)}}catch(n){this.h.error(n)}})),c}};e.$wbc=b,e.$wbc=b=u=Ke([We(0,A.$LL),We(1,d.$Ri)],b),e.$xbc=(0,M.$ph)("IExtHostDecorations")}),define(Pe[228],Ae([1,0,148,94,2,3,7,8,5,14,28,39]),function(pe,e,y,R,I,M,A,d,k,f,P,D){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$oac=e.$nac=void 0;class b{#e;#t;#i;constructor(t,i,c,g,S,C,n,a){this.d=t,this.e=i,this.f=c,this.g=g,this.h=S,this.c=!1,this.f=Math.max(g,c),this.#i=new P.$ni(r=>C.getComparisonKey(r)),this.#e=n,this.#t=a}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(t,i){if(!t){this.clear();return}this.j();let c=[];if(I.URI.isUri(t)){if(!i){this.delete(t);return}this.#i.set(t,i.slice()),c=[t]}else if(Array.isArray(t)){c=[];let C;t=[...t].sort(b.k);for(const n of t){const[a,r]=n;if((!C||a.toString()!==C.toString())&&(C&&this.#i.get(C).length===0&&this.#i.delete(C),C=a,c.push(a),this.#i.set(a,[])),r)this.#i.get(a)?.push(...r);else{const s=this.#i.get(a);s&&(s.length=0)}}}if(this.#t.fire(c),!this.#e)return;const g=[];let S=0;for(const C of c){let n=[];const a=this.#i.get(C);if(a)if(a.length>this.g){n=[];const r=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let s=0;s<4;s++)for(const v of a)if(v.severity===r[s]&&n.push({...d.Diagnostic.from(v),modelVersionId:this.h(C)})===this.g)break e;n.push({severity:R.MarkerSeverity.Info,message:(0,y.localize)(0,null,a.length-this.g),startLineNumber:n[n.length-1].startLineNumber,startColumn:n[n.length-1].startColumn,endLineNumber:n[n.length-1].endLineNumber,endColumn:n[n.length-1].endColumn})}else n=a.map(r=>({...d.Diagnostic.from(r),modelVersionId:this.h(C)}));if(g.push([C,n]),S+=n.length,S>this.f)break}this.#e.$changeMany(this.e,g)}delete(t){this.j(),this.#t.fire([t]),this.#i.delete(t),this.#e?.$changeMany(this.e,[[t,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(t,i){this.j();for(const[c,g]of this)t.call(i,c,g,this)}*[Symbol.iterator](){this.j();for(const t of this.#i.keys())yield[t,this.get(t)]}get(t){this.j();const i=this.#i.get(t);return Array.isArray(i)?Object.freeze(i.slice(0)):[]}has(t){return this.j(),Array.isArray(this.#i.get(t))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(t,i){return t[0].toString()<i[0].toString()?-1:t[0].toString()>i[0].toString()?1:0}}e.$nac=b;let p=class{static{u=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*u.d}static _mapper(t){const i=new P.$ni;for(const c of t)i.set(c,c);return{uris:Object.freeze(Array.from(i.values()))}}constructor(t,i,c,g){this.j=i,this.k=c,this.l=g,this.g=new Map,this.h=new k.$ic({merge:S=>S.flat(),delay:50}),this.onDidChangeDiagnostics=k.Event.map(this.h.event,u._mapper),this.f=t.getProxy(M.$JJ.MainThreadDiagnostics)}createDiagnosticCollection(t,i){const{g:c,f:g,h:S,j:C,k:n,l:a}=this,r=new class{$changeMany($,w){g.$changeMany($,w),C.trace("[DiagnosticCollection] change many (extension, owner, uris)",t.value,$,w.length===0?"CLEARING":w)}$clear($){g.$clear($),C.trace("[DiagnosticCollection] remove all (extension, owner)",t.value,$)}dispose(){g.dispose()}};let s;if(!i)i="_generated_diagnostic_collection_name_#"+u.c++,s=i;else if(!c.has(i))s=i;else{this.j.warn(`DiagnosticCollection with name '${i}' does already exist.`);do s=i+u.c++;while(c.has(s))}return new class extends b{constructor(){super(i,s,u.e,u.d,$=>a.getDocument($)?.version,n.extUri,r,S),c.set(s,this)}dispose(){super.dispose(),c.delete(s)}}}getDiagnostics(t){if(t)return this.m(t);{const i=new Map,c=[];for(const g of this.g.values())g.forEach((S,C)=>{let n=i.get(S.toString());typeof n>"u"&&(n=c.length,i.set(S.toString(),n),c.push([S,[]])),c[n][1]=c[n][1].concat(...C)});return c}}m(t){let i=[];for(const c of this.g.values())c.has(t)&&(i=i.concat(c.get(t)));return i}$acceptMarkersChange(t){if(!this.n){const i="_generated_mirror",c=new b(i,i,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,g=>{},this.k.extUri,void 0,this.h);this.g.set(i,c),this.n=c}for(const[i,c]of t)this.n.set(I.URI.revive(i),c.map(d.Diagnostic.to))}};e.$oac=p,e.$oac=p=u=Ke([We(1,f.$Ri),We(2,D.$mac)],p)}),define(Pe[229],Ae([1,0,2,3,26]),function(pe,e,y,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dac=void 0;class M{constructor(d){this.a=d.getProxy(R.$JJ.MainThreadDialogs)}showOpenDialog(d,k){return k?.allowUIResources&&(0,I.$EF)(d,"showLocal"),this.a.$showOpenDialog(k).then(f=>f?f.map(P=>y.URI.revive(P)):void 0)}showSaveDialog(d){return this.a.$showSaveDialog(d).then(k=>k?y.URI.revive(k):void 0)}}e.$Dac=M}),define(Pe[230],Ae([1,0,9,2,7,3,12,21,15]),function(pe,e,y,R,I,M,A,d,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eac=void 0;class f{static{this.a=0}constructor(D,u,b){this.d=u,this.e=b,this.b=new Map,this.c=D.getProxy(M.$JJ.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(D,u){if(Object.keys(A.Schemas).indexOf(D)>=0)throw new Error(`scheme '${D}' already registered`);const b=f.a++;this.b.set(b,u),this.c.$registerTextContentProvider(b,D);let p;return typeof u.onDidChange=="function"&&(p=u.onDidChange(h=>{if(h.scheme!==D){this.e.warn(`Provider for scheme '${D}' is firing event for schema '${h.scheme}' which will be IGNORED`);return}this.d.getDocument(h)&&this.$provideTextDocumentContent(b,h).then(t=>{if(!t&&typeof t!="string")return;const i=this.d.getDocument(h);if(!i)return;const c=(0,k.$zd)(t);if(!i.equalLines(c))return this.c.$onVirtualDocumentChange(h,t)},y.$Y)})),new I.$LJ(()=>{this.b.delete(b)&&this.c.$unregisterTextContentProvider(b),p&&(p.dispose(),p=void 0)})}$provideTextDocumentContent(D,u){const b=this.b.get(D);return b?Promise.resolve(b.provideTextDocumentContent(R.URI.revive(u),d.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.$Eac=f}),define(Pe[231],Ae([1,0,5,6,2,3,101,8,16,24,7,9]),function(pe,e,y,R,I,M,A,d,k,f,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kac=void 0;class u{constructor(p,h){this.a=new y.$ec({onListenerError:D.$Z}),this.b=new y.$ec({onListenerError:D.$Z}),this.c=new y.$ec({onListenerError:D.$Z}),this.d=new y.$ec({onListenerError:D.$Z}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new R.$kb,this.h=new Map,this.f=p.getProxy(M.$JJ.MainThreadDocuments),this.g=h,this.g.onDidRemoveDocuments(t=>{for(const i of t)this.b.fire(i.document)},void 0,this.e),this.g.onDidAddDocuments(t=>{for(const i of t)this.a.fire(i.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(p){if(!p)return;const h=this.g.getDocument(p);if(h)return h}getDocument(p){const h=this.getDocumentData(p);if(!h?.document)throw new Error(`Unable to retrieve document from URI '${p}'`);return h.document}ensureDocumentData(p){const h=this.g.getDocument(p);if(h)return Promise.resolve(h);let t=this.h.get(p.toString());return t||(t=this.f.$tryOpenDocument(p).then(i=>{this.h.delete(p.toString());const c=I.URI.revive(i);return(0,k.$te)(this.g.getDocument(c))},i=>(this.h.delete(p.toString()),Promise.reject(i))),this.h.set(p.toString(),t)),t}createDocumentData(p){return this.f.$tryCreateDocument(p).then(h=>I.URI.revive(h))}$acceptModelLanguageChanged(p,h){const t=I.URI.revive(p),i=this.g.getDocument(t);if(!i)throw new Error("unknown document");this.b.fire(i.document),i._acceptLanguageId(h),this.a.fire(i.document)}$acceptModelSaved(p){const h=I.URI.revive(p),t=this.g.getDocument(h);if(!t)throw new Error("unknown document");this.$acceptDirtyStateChanged(p,!1),this.d.fire(t.document)}$acceptDirtyStateChanged(p,h){const t=I.URI.revive(p),i=this.g.getDocument(t);if(!i)throw new Error("unknown document");i._acceptIsDirty(h),this.c.fire({document:i.document,contentChanges:[],reason:void 0})}$acceptModelChanged(p,h,t){const i=I.URI.revive(p),c=this.g.getDocument(i);if(!c)throw new Error("unknown document");c._acceptIsDirty(t),c.onEvents(h);let g;h.isUndoing?g=P.TextDocumentChangeReason.Undo:h.isRedoing&&(g=P.TextDocumentChangeReason.Redo),this.c.fire((0,f.$Jm)({document:c.document,contentChanges:h.changes.map(S=>({range:d.Range.to(S.range),rangeOffset:S.rangeOffset,rangeLength:S.rangeLength,text:S.text})),reason:g}))}setWordDefinitionFor(p,h){(0,A.$NL)(p,h)}}e.$kac=u}),define(Pe[60],Ae([1,0,50,5,6,2,4,3,101,17,106,8,14,28,12,67,66]),function(pe,e,y,R,I,M,A,d,k,f,P,D,u,b,p,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WL=e.$VL=void 0;class i{constructor(S){this.value=S,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let c=class{constructor(S,C){this.h=S,this.i=C,this.a=null,this.b=new Map,this.c=new b.$ni,this.d=new R.$ec,this.e=new R.$ec,this.f=new R.$ec,this.g=new R.$ec,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(S){this.acceptDocumentsAndEditorsDelta(S)}acceptDocumentsAndEditorsDelta(S){const C=[],n=[],a=[];if(S.removedDocuments)for(const r of S.removedDocuments){const s=M.URI.revive(r),v=this.c.get(s);v?.unref()&&(this.c.delete(s),C.push(v.value))}if(S.addedDocuments)for(const r of S.addedDocuments){const s=M.URI.revive(r.uri);let v=this.c.get(s);if(v&&s.scheme!==p.Schemas.vscodeNotebookCell&&s.scheme!==p.Schemas.vscodeInteractiveInput)throw new Error(`document '${s} already exists!'`);v||(v=new i(new k.$OL(this.h.getProxy(d.$JJ.MainThreadDocuments),s,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this.c.set(s,v),n.push(v.value)),v.ref()}if(S.removedEditors)for(const r of S.removedEditors){const s=this.b.get(r);this.b.delete(r),s&&a.push(s)}if(S.addedEditors)for(const r of S.addedEditors){const s=M.URI.revive(r.documentUri);y.ok(this.c.has(s),`document '${s}' does not exist`),y.ok(!this.b.has(r.id),`editor '${r.id}' already exists!`);const v=this.c.get(s).value,$=new P.$UL(r.id,this.h.getProxy(d.$JJ.MainThreadTextEditors),this.i,new t.$T(()=>v.document),r.selections.map(D.Selection.to),r.options,r.visibleRanges.map(w=>D.Range.to(w)),typeof r.editorPosition=="number"?D.ViewColumn.to(r.editorPosition):void 0);this.b.set(r.id,$)}S.newActiveEditor!==void 0&&(y.ok(S.newActiveEditor===null||this.b.has(S.newActiveEditor),`active editor '${S.newActiveEditor}' does not exist`),this.a=S.newActiveEditor),(0,I.$gb)(C),(0,I.$gb)(a),S.removedDocuments&&this.e.fire(C),S.addedDocuments&&this.d.fire(n),(S.removedEditors||S.addedEditors)&&this.f.fire(this.allEditors().map(r=>r.value)),S.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(S){return this.c.get(S)?.value}allDocuments(){return h.Iterable.map(this.c.values(),S=>S.value)}getEditor(S){return this.b.get(S)}activeEditor(S){if(!this.a)return;const C=this.b.get(this.a);return S?C:C?.value}allEditors(){return[...this.b.values()]}};e.$VL=c,e.$VL=c=Ke([We(0,f.$LL),We(1,u.$Ri)],c),e.$WL=(0,A.$ph)("IExtHostDocumentsAndEditors")}),define(Pe[61],Ae([1,0,8,3,2,5,4,7,17,16,100]),function(pe,e,y,R,I,M,A,d,k,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cbc=e.$Bbc=void 0,e.$Bbc=(0,A.$ph)("IExtHostEditorTabs");class D{constructor(t,i,c){this.e=c,this.d=i,this.acceptDtoUpdate(t)}get apiObject(){if(!this.a){const t=this,i={get isActive(){return t.b.id===t.e()},get label(){return t.b.label},get input(){return t.c},get isDirty(){return t.b.isDirty},get isPinned(){return t.b.isPinned},get isPreview(){return t.b.isPreview},get group(){return t.d.apiObject}};this.a=Object.freeze(i)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(t){this.b=t,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new d.$rL(I.URI.revive(this.b.input.uri));case 2:return new d.$sL(I.URI.revive(this.b.input.original),I.URI.revive(this.b.input.modified));case 3:return new d.$tL(I.URI.revive(this.b.input.base),I.URI.revive(this.b.input.input1),I.URI.revive(this.b.input.input2),I.URI.revive(this.b.input.result));case 6:return new d.$uL(I.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new d.$vL(this.b.input.viewType);case 4:return new d.$wL(I.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new d.$xL(I.URI.revive(this.b.input.original),I.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new d.$yL;case 9:return new d.$zL(I.URI.revive(this.b.input.uri),I.URI.revive(this.b.input.inputBoxUri));default:return}}}class u{constructor(t,i){this.c=[],this.d="",this.b=t,this.e=i;for(const c of t.tabs)c.isActive&&(this.d=c.id),this.c.push(new D(c,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const t=this,i={get isActive(){return t.b.groupId===t.e()},get viewColumn(){return y.ViewColumn.to(t.b.viewColumn)},get activeTab(){return t.c.find(c=>c.tabId===t.d)?.apiObject},get tabs(){return Object.freeze(t.c.map(c=>c.apiObject))}};this.a=Object.freeze(i)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(t){this.b=t}acceptTabOperation(t){if(t.kind===0){const c=new D(t.tabDto,this,()=>this.activeTabId());return this.c.splice(t.index,0,c),t.tabDto.isActive&&(this.d=c.tabId),c}else if(t.kind===1){const c=this.c.splice(t.index,1)[0];if(!c)throw new Error(`Tab close updated received for index ${t.index} which does not exist`);return c.tabId===this.d&&(this.d=""),c}else if(t.kind===3){if(t.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const c=this.c.splice(t.oldIndex,1)[0];if(!c)throw new Error(`Tab move updated received for index ${t.oldIndex} which does not exist`);return this.c.splice(t.index,0,c),c}const i=this.c.find(c=>c.tabId===t.tabDto.id);if(!i)throw new Error("INVALID tab");return t.tabDto.isActive?this.d=t.tabDto.id:this.d===t.tabDto.id&&!t.tabDto.isActive&&(this.d=""),i.acceptDtoUpdate(t.tabDto),i}activeTabId(){return this.d}}let b=class{constructor(t){this.b=new M.$ec,this.c=new M.$ec,this.e=[],this.a=t.getProxy(R.$JJ.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const t=this,i={onDidChangeTabGroups:t.c.event,onDidChangeTabs:t.b.event,get all(){return Object.freeze(t.e.map(c=>c.apiObject))},get activeTabGroup(){const c=t.d;return(0,f.$te)(t.e.find(S=>S.groupId===c)?.apiObject)},close:async(c,g)=>{const S=Array.isArray(c)?c:[c];return S.length?p(S[0])?this.j(S,g):this.i(S,g):!0}};this.f=Object.freeze(i)}return this.f}$acceptEditorTabModel(t){const i=new Set(this.e.map(r=>r.groupId)),c=new Set(t.map(r=>r.groupId)),g=(0,P.$J)(i,c),S=this.e.filter(r=>g.removed.includes(r.groupId)).map(r=>r.apiObject),C=[],n=[];this.e=t.map(r=>{const s=new u(r,()=>this.d);return g.added.includes(s.groupId)?C.push(s.apiObject):n.push(s.apiObject),s});const a=(0,f.$te)(t.find(r=>r.isActive===!0)?.groupId);a!==void 0&&this.d!==a&&(this.d=a),this.c.fire(Object.freeze({opened:C,closed:S,changed:n}))}$acceptTabGroupUpdate(t){const i=this.e.find(c=>c.groupId===t.groupId);if(!i)throw new Error("Update Group IPC call received before group creation.");i.acceptGroupDtoUpdate(t),t.isActive&&(this.d=t.groupId),this.c.fire(Object.freeze({changed:[i.apiObject],opened:[],closed:[]}))}$acceptTabOperation(t){const i=this.e.find(g=>g.groupId===t.groupId);if(!i)throw new Error("Update Tabs IPC call received before group creation.");const c=i.acceptTabOperation(t);switch(t.kind){case 0:this.b.fire(Object.freeze({opened:[c.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[c.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[c.apiObject]}));return}}g(t){for(const i of this.e)for(const c of i.tabs)if(c.apiObject===t)return c}h(t){return this.e.find(i=>i.apiObject===t)}async i(t,i){const c=[];for(const g of t){const S=this.g(g);if(!S)throw new Error("Tab close: Invalid tab not found!");c.push(S.tabId)}return this.a.$closeTab(c,i)}async j(t,i){const c=[];for(const g of t){const S=this.h(g);if(!S)throw new Error("Group close: Invalid group not found!");c.push(S.groupId)}return this.a.$closeGroup(c,i)}};e.$Cbc=b,e.$Cbc=b=Ke([We(0,k.$LL)],b);function p(h){return h.tabs!==void 0}}),define(Pe[232],Ae([1,0,3,7]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$occ=void 0;class I{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(y.$JJ.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,d,k){if(this.a.size===0)throw new Error("No embedding vector providers registered");const f=this.a.get(A);if(!f)throw new Error("Embedding vector provider not found");const P=await f.provideEmbeddingVector(d,k);if(!P)throw new Error("Embedding vector provider returned undefined");return P}registerEmbeddingVectorProvider(A,d,k){const f=this.b;return this.b++,this.a.set(f,k),this.c.$registerAiEmbeddingVectorProvider(d,f),new R.$LJ(()=>{this.c.$unregisterAiEmbeddingVectorProvider(f),this.a.delete(f)})}}e.$occ=I}),define(Pe[233],Ae([1,0,2,3,6,7,8,279,15,25,26,49]),function(pe,e,y,R,I,M,A,d,k,f,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$ac=void 0;class u{constructor(){this.a=[]}add(h){this.b=void 0,this.a.push(h)}delete(h){const t=this.a.indexOf(h);t>=0&&(this.a.splice(t,1),this.b=void 0)}c(){if(!this.b){const h=this.a.sort(),t=[];let i,c,g=14,S=14;for(const C of h){let n=i?(0,k.$Nd)(i,C):0;for(n===0?c=1:c=S;n<C.length;n++)n+1===C.length?(g=S,S=9):S+=1,t.push([c,C.toUpperCase().charCodeAt(n),S]),t.push([c,C.toLowerCase().charCodeAt(n),S]),c=S;i=C,S=g}t.push([9,58,10]),t.push([10,47,12]),this.b=new d.$qY(t)}}provideDocumentLinks(h){this.c();const t=[],i=d.$rY.computeLinks({getLineContent(c){return h.lineAt(c-1).text},getLineCount(){return h.lineCount}},this.b);for(const c of i){const g=A.DocumentLink.to(c);g.target&&t.push(g)}return t}}class b{constructor(h,t){this.i=t,this.b=new u,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=h.getProxy(R.$JJ.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(h,t,i,c={}){if(b.j(i),this.d.has(t))throw new Error(`a provider for the scheme '${t}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(h,"*",this.b));const g=this.h++;this.b.add(t),this.d.add(t),this.c.set(g,i);let S=2;c.isCaseSensitive&&(S+=1024),c.isReadonly&&(S+=2048),typeof i.copy=="function"&&(S+=8),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,P.$EF)(h,"fsChunks"),S+=4);let C;c.isReadonly&&(0,D.$Mj)(c.isReadonly)&&((0,P.$EF)(h,"readonlyMessage"),C={value:c.isReadonly.value,isTrusted:c.isReadonly.isTrusted,supportThemeIcons:c.isReadonly.supportThemeIcons,supportHtml:c.isReadonly.supportHtml,baseUri:c.isReadonly.baseUri,uris:c.isReadonly.uris}),this.a.$registerFileSystemProvider(g,t,S,C).catch(a=>{console.error(`FAILED to register filesystem provider of ${h.identifier.value}-extension for the scheme ${t}`),console.error(a)});const n=i.onDidChangeFile(a=>{const r=[];for(const s of a){const{uri:v,type:$}=s;if(v.scheme!==t)continue;let w;switch($){case M.FileChangeType.Changed:w=0;break;case M.FileChangeType.Created:w=1;break;case M.FileChangeType.Deleted:w=2;break;default:throw new Error("Unknown FileChangeType")}r.push({resource:v,type:w})}this.a.$onFileSystemChange(g,r)});return(0,I.$jb)(()=>{n.dispose(),this.b.delete(t),this.d.delete(t),this.c.delete(g),this.a.$unregisterProvider(g)})}static j(h){if(!h)throw new Error("MISSING provider");if(typeof h.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof h.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof h.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof h.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof h.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof h.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof h.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof h.rename!="function")throw new Error("Provider does NOT implement rename")}static k(h){const{type:t,ctime:i,mtime:c,size:g,permissions:S}=h;return{type:t,ctime:i,mtime:c,size:g,permissions:S}}$stat(h,t){return Promise.resolve(this.l(h).stat(y.URI.revive(t))).then(i=>b.k(i))}$readdir(h,t){return Promise.resolve(this.l(h).readDirectory(y.URI.revive(t)))}$readFile(h,t){return Promise.resolve(this.l(h).readFile(y.URI.revive(t))).then(i=>f.$Ec.wrap(i))}$writeFile(h,t,i,c){return Promise.resolve(this.l(h).writeFile(y.URI.revive(t),i.buffer,c))}$delete(h,t,i){return Promise.resolve(this.l(h).delete(y.URI.revive(t),i))}$rename(h,t,i,c){return Promise.resolve(this.l(h).rename(y.URI.revive(t),y.URI.revive(i),c))}$copy(h,t,i,c){const g=this.l(h);if(!g.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(g.copy(y.URI.revive(t),y.URI.revive(i),c))}$mkdir(h,t){return Promise.resolve(this.l(h).createDirectory(y.URI.revive(t)))}$watch(h,t,i,c){const g=this.l(h).watch(y.URI.revive(i),c);this.f.set(t,g)}$unwatch(h,t){const i=this.f.get(t);i&&(i.dispose(),this.f.delete(t))}$open(h,t,i){const c=this.l(h);if(!c.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(c.open(y.URI.revive(t),i))}$close(h,t){const i=this.l(h);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(t))}$read(h,t,i,c){const g=this.l(h);if(!g.read)throw new Error('FileSystemProvider does not implement "read"');const S=f.$Ec.alloc(c);return Promise.resolve(g.read(t,i,S.buffer,0,c)).then(C=>S.slice(0,C))}$write(h,t,i,c){const g=this.l(h);if(!g.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(g.write(t,i,c.buffer,0,c.byteLength))}l(h){const t=this.c.get(h);if(!t){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return t}}e.$$ac=b}),define(Pe[62],Ae([1,0,3,38,7,25,4,17,39,6,13,23,12]),function(pe,e,y,R,I,M,A,d,k,f,P,D,u){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$Rac=e.$Qac=void 0;let p=b=class{constructor(t,i){this.b=new Map,this.c=new P.$Dg,this.a=t.getProxy(y.$JJ.MainThreadFileSystem);const c=this;this.value=Object.freeze({async stat(g){try{let S;const C=c.b.get(g.scheme);return C?(await c.a.$ensureActivation(g.scheme),S=await C.impl.stat(g)):S=await c.a.$stat(g),{type:S.type,ctime:S.ctime,mtime:S.mtime,size:S.size,permissions:S.permissions===R.FilePermission.Readonly?1:void 0}}catch(S){b.e(S)}},async readDirectory(g){try{const S=c.b.get(g.scheme);return S?(await c.a.$ensureActivation(g.scheme),(await S.impl.readDirectory(g)).slice()):await c.a.$readdir(g)}catch(S){return b.e(S)}},async createDirectory(g){try{const S=c.b.get(g.scheme);return S&&!S.isReadonly?(await c.a.$ensureActivation(g.scheme),await c.d(S.impl,S.extUri,g)):await c.a.$mkdir(g)}catch(S){return b.e(S)}},async readFile(g){try{const S=c.b.get(g.scheme);return S?(await c.a.$ensureActivation(g.scheme),(await S.impl.readFile(g)).slice()):(await c.a.$readFile(g)).buffer}catch(S){return b.e(S)}},async writeFile(g,S){try{const C=c.b.get(g.scheme);return C&&!C.isReadonly?(await c.a.$ensureActivation(g.scheme),await c.d(C.impl,C.extUri,C.extUri.dirname(g)),await c.c.queueFor(g).queue(()=>Promise.resolve(C.impl.writeFile(g,S,{create:!0,overwrite:!0})))):await c.a.$writeFile(g,M.$Ec.wrap(S))}catch(C){return b.e(C)}},async delete(g,S){try{const C=c.b.get(g.scheme);return C&&!C.isReadonly?(await c.a.$ensureActivation(g.scheme),await C.impl.delete(g,{recursive:!1,...S})):await c.a.$delete(g,{recursive:!1,useTrash:!1,atomic:!1,...S})}catch(C){return b.e(C)}},async rename(g,S,C){try{return await c.a.$rename(g,S,{overwrite:!1,...C})}catch(n){return b.e(n)}},async copy(g,S,C){try{return await c.a.$copy(g,S,{overwrite:!1,...C})}catch(n){return b.e(n)}},isWritableFileSystem(g){const S=i.getCapabilities(g);if(typeof S=="number")return!(S&2048)}})}async d(t,i,c){const g=[];for(;!i.isEqual(c,i.dirname(c));)try{if(!((await t.stat(c)).type&R.FileType.Directory))throw I.$ZK.FileExists(`Unable to create folder '${c.scheme===u.Schemas.file?c.fsPath:c.toString(!0)}' that already exists but is not a directory`);break}catch(S){if(R.$8j(S)!==R.FileSystemProviderErrorCode.FileNotFound)throw S;g.push(i.basename(c)),c=i.dirname(c)}for(let S=g.length-1;S>=0;S--){c=i.joinPath(c,g[S]);try{await t.createDirectory(c)}catch(C){if(R.$8j(C)!==R.FileSystemProviderErrorCode.FileExists)throw C}}}static e(t){if(t instanceof I.$ZK)throw t;if(t instanceof R.$4j)switch(t.code){case R.FileSystemProviderErrorCode.FileExists:throw I.$ZK.FileExists(t.message);case R.FileSystemProviderErrorCode.FileNotFound:throw I.$ZK.FileNotFound(t.message);case R.FileSystemProviderErrorCode.FileNotADirectory:throw I.$ZK.FileNotADirectory(t.message);case R.FileSystemProviderErrorCode.FileIsADirectory:throw I.$ZK.FileIsADirectory(t.message);case R.FileSystemProviderErrorCode.NoPermissions:throw I.$ZK.NoPermissions(t.message);case R.FileSystemProviderErrorCode.Unavailable:throw I.$ZK.Unavailable(t.message);default:throw new I.$ZK(t.message,t.name)}if(!(t instanceof Error))throw new I.$ZK(String(t));if(t.name==="ENOPRO"||t.message.includes("ENOPRO"))throw I.$ZK.Unavailable(t.message);switch(t.name){case R.FileSystemProviderErrorCode.FileExists:throw I.$ZK.FileExists(t.message);case R.FileSystemProviderErrorCode.FileNotFound:throw I.$ZK.FileNotFound(t.message);case R.FileSystemProviderErrorCode.FileNotADirectory:throw I.$ZK.FileNotADirectory(t.message);case R.FileSystemProviderErrorCode.FileIsADirectory:throw I.$ZK.FileIsADirectory(t.message);case R.FileSystemProviderErrorCode.NoPermissions:throw I.$ZK.NoPermissions(t.message);case R.FileSystemProviderErrorCode.Unavailable:throw I.$ZK.Unavailable(t.message);default:throw new I.$ZK(t.message,t.name)}}addFileSystemProvider(t,i,c){return this.b.set(t,{impl:i,extUri:c?.isCaseSensitive?D.$Yf:D.$1f,isReadonly:!!c?.isReadonly}),(0,f.$jb)(()=>this.b.delete(t))}getFileSystemProviderExtUri(t){return this.b.get(t)?.extUri??D.$Yf}};e.$Qac=p,e.$Qac=p=b=Ke([We(0,d.$LL),We(1,k.$mac)],p),e.$Rac=(0,A.$ph)("IExtHostConsumerFileSystem")}),define(Pe[234],Ae([1,0,5,37,2,3,8,7]),function(pe,e,y,R,I,M,A,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_ac=void 0;class k{get ignoreCreateEvents(){return!!(this.g&1)}get ignoreChangeEvents(){return!!(this.g&2)}get ignoreDeleteEvents(){return!!(this.g&4)}constructor(D,u,b,p,h,t,i,c){this.a=new y.$ec,this.b=new y.$ec,this.c=new y.$ec;const g=this.h(D,b,h);this.g=0,t&&(this.g+=1),i&&(this.g+=2),c&&(this.g+=4);const S=(0,R.$ej)(h),C=typeof h=="string",n=p(a=>{if(!t)for(const r of a.created){const s=I.URI.revive(r);S(s.fsPath)&&(!C||u.getWorkspaceFolder(s))&&this.a.fire(s)}if(!i)for(const r of a.changed){const s=I.URI.revive(r);S(s.fsPath)&&(!C||u.getWorkspaceFolder(s))&&this.b.fire(s)}if(!c)for(const r of a.deleted){const s=I.URI.revive(r);S(s.fsPath)&&(!C||u.getWorkspaceFolder(s))&&this.c.fire(s)}});this.d=d.$LJ.from(g,this.a,this.b,this.c,n)}h(D,u,b){const p=d.$LJ.from();if(typeof b=="string")return p;const h=D.getProxy(M.$JJ.MainThreadFileSystem);let t=!1;(b.pattern.includes(R.$aj)||b.pattern.includes(R.$bj))&&(t=!0);const i=Math.random();return h.$watch(u.identifier.value,i,b.baseUri,{recursive:t,excludes:[]}),d.$LJ.from({dispose:()=>h.$unwatch(i)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class f{constructor(D,u,b){this.j=D,this.k=u,this.l=b,this.a=new y.$ec,this.b=new y.$ec,this.c=new y.$ec,this.d=new y.$ec,this.g=new y.$gc,this.h=new y.$gc,this.i=new y.$gc,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(D,u,b,p,h,t){return new k(this.j,D,u,this.a.event,A.GlobPattern.from(b),p,h,t)}$onFileEvent(D){this.a.fire(D)}$onDidRunFileOperation(D,u){switch(D){case 2:this.b.fire(Object.freeze({files:u.map(b=>({oldUri:I.URI.revive(b.source),newUri:I.URI.revive(b.target)}))}));break;case 1:this.d.fire(Object.freeze({files:u.map(b=>I.URI.revive(b.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:u.map(b=>I.URI.revive(b.target))}));break;default:}}getOnWillRenameFileEvent(D){return this.m(D,this.g)}getOnWillCreateFileEvent(D){return this.m(D,this.h)}getOnWillDeleteFileEvent(D){return this.m(D,this.i)}m(D,u){return(b,p,h)=>{const t=function(c){b.call(p,c)};return t.extension=D,u.event(t,void 0,h)}}async $onWillRunFileOperation(D,u,b,p){switch(D){case 2:return await this.n(this.g,{files:u.map(h=>({oldUri:I.URI.revive(h.source),newUri:I.URI.revive(h.target)}))},b,p);case 1:return await this.n(this.i,{files:u.map(h=>I.URI.revive(h.target))},b,p);case 0:case 3:return await this.n(this.h,{files:u.map(h=>I.URI.revive(h.target))},b,p)}}async n(D,u,b,p){const h=new Set,t=[];if(await D.fireAsync(u,p,async(c,g)=>{const S=Date.now(),C=await Promise.resolve(c);C instanceof d.$VJ&&(t.push([g.extension,C]),h.add(g.extension.displayName??g.extension.identifier.value)),Date.now()-S>b&&this.k.warn("SLOW file-participant",g.extension.identifier)}),p.isCancellationRequested||t.length===0)return;const i={edits:[]};for(const[,c]of t){const{edits:g}=A.WorkspaceEdit.from(c,{getTextDocumentVersion:S=>this.l.getDocument(S)?.version,getNotebookDocumentVersion:()=>{}});i.edits=i.edits.concat(g)}return{edit:i,extensionNames:Array.from(h)}}}e.$_ac=f}),define(Pe[235],Ae([1,0,6,2,3,8,7,31]),function(pe,e,y,R,I,M,A,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gcc=void 0;class k{static{this.a=0}constructor(u,b){this.extension=u,this.provider=b,this.handle=k.a++}}class f{constructor(u){this.session=u,this.responses=[]}}class P{static{this.a=0}constructor(u,b,p,h){this.f=p,this.g=h,this.b=new Map,this.d=new Map,this.e=u.getProxy(I.$JJ.MainThreadInlineChat),b.registerApiCommand(new d.$_L("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new d.$0L("Run arguments","",t=>!0,t=>{if(t)return{initialRange:t.initialRange?M.Range.from(t.initialRange):void 0,initialSelection:t.initialSelection?M.Selection.from(t.initialSelection):void 0,message:t.message,autoSend:t.autoSend,position:t.position?M.Position.from(t.position):void 0}})],d.$$L.Void))}registerProvider(u,b){const p=new k(u,b);return this.b.set(p.handle,p),this.e.$registerInteractiveEditorProvider(p.handle,b.label,u.identifier.value,typeof b.handleInteractiveEditorResponseFeedback=="function"),(0,y.$jb)(()=>{this.e.$unregisterInteractiveEditorProvider(p.handle),this.b.delete(p.handle)})}async $prepareSession(u,b,p,h){const t=this.b.get(u);if(!t){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const i=this.f.getDocument(R.URI.revive(b)),c=M.Selection.to(p),g=await t.provider.prepareInteractiveEditorSession({document:i,selection:c},h);if(!g)return;if(g.wholeRange&&!g.wholeRange.contains(c))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const S=P.a++;return this.d.set(S,new f(g)),{id:S,placeholder:g.placeholder,slashCommands:g.slashCommands?.map(C=>({command:C.command,detail:C.detail,refer:C.refer,executeImmediately:C.executeImmediately})),wholeRange:M.Range.from(g.wholeRange),message:g.message}}async $provideResponse(u,b,p,h){const t=this.b.get(u);if(!t)return;const i=this.d.get(b.id);if(!i)return;const c={session:i.session,prompt:p.prompt,selection:M.Selection.to(p.selection),wholeRange:M.Range.to(p.wholeRange),attempt:p.attempt,live:p.live};let g=!1;const S={report:a=>{if(!p.live)throw new Error("Progress reporting is only supported for live sessions");g||h.isCancellationRequested||!a.message&&!a.edits||this.e.$handleProgressChunk(p.requestId,{message:a.message,edits:a.edits?.map(M.TextEdit.from)})}},C=typeof t.provider.provideInteractiveEditorResponse2=="function"?t.provider.provideInteractiveEditorResponse2(c,S,h):t.provider.provideInteractiveEditorResponse(c,h);Promise.resolve(C).finally(()=>g=!0);const n=await C;if(n){const a=i.responses.push(n)-1,r={wholeRange:M.Range.from(n.wholeRange),placeholder:n.placeholder};if(P.h(n))return{...r,id:a,type:"message",message:M.MarkdownString.from(n.contents)};const{edits:s}=n;if(s instanceof A.$VJ)return{...r,id:a,type:"bulkEdit",edits:M.WorkspaceEdit.from(s)};if(Array.isArray(s))return{...r,id:a,type:"editorEdit",edits:s.map(M.TextEdit.from)}}}$handleFeedback(u,b,p,h){const t=this.b.get(u),i=this.d.get(b),c=i?.responses[p];if(t&&c){let g;switch(h){case 1:g=A.InteractiveEditorResponseFeedbackKind.Helpful;break;case 0:g=A.InteractiveEditorResponseFeedbackKind.Unhelpful;break;case 2:g=A.InteractiveEditorResponseFeedbackKind.Undone;break;case 3:g=A.InteractiveEditorResponseFeedbackKind.Accepted;break}t.provider.handleInteractiveEditorResponseFeedback?.(i.session,c,g)}}$releaseSession(u,b){const p=this.d.get(b),h=this.b.get(u);p&&h&&h.provider.releaseInteractiveEditorSession?.(p.session),this.d.delete(b)}static h(u){return typeof u=="object"&&typeof u.contents=="object"}}e.$gcc=P}),define(Pe[236],Ae([1,0,2,31]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ccc=void 0;class I{constructor(A,d,k,f,P){this.a=d,this.b=k,this.c=f;const D=new R.$_L("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new R.$0L("showOptions","Show Options",u=>!0,u=>u),new R.$0L("resource","Interactive resource Uri",u=>!0,u=>u),new R.$0L("controllerId","Notebook controller Id",u=>!0,u=>u),new R.$0L("title","Interactive editor title",u=>!0,u=>u)],new R.$$L("Notebook and input URI",u=>{if(P.debug("[ExtHostInteractive] open iw with notebook editor id",u.notebookEditorId),u.notebookEditorId!==void 0){const b=this.a.getEditorById(u.notebookEditorId);return P.debug("[ExtHostInteractive] notebook editor found",b.id),{notebookUri:y.URI.revive(u.notebookUri),inputUri:y.URI.revive(u.inputUri),notebookEditor:b.apiEditor}}return P.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",u.notebookUri,u.inputUri),{notebookUri:y.URI.revive(u.notebookUri),inputUri:y.URI.revive(u.inputUri)}}));this.c.registerApiCommand(D)}$willAddInteractiveDocument(A,d,k,f){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:d,lines:[""],languageId:k,uri:A,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(y.URI.revive(f))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,d){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$ccc=I}),define(Pe[237],Ae([1,0,3,7]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$icc=void 0;class I{constructor(A){this.a=new Map,this.b=A.getProxy(y.$JJ.MainThreadIssueReporter)}async $getIssueReporterUri(A,d){if(this.a.size===0)throw new Error("No issue request handlers registered");const k=this.a.get(A);if(!k)throw new Error("Issue request handler not found");const f=await k.handleIssueUrlRequest();if(!f)throw new Error("Issue request handler returned no result");return f}registerIssueUriRequestHandler(A,d){const k=A.identifier.value;return this.a.set(k,d),this.b.$registerIssueUriRequestHandler(k),new R.$LJ(()=>{this.b.$unregisterIssueUriRequestHandler(k),this.a.delete(k)})}}e.$icc=I}),define(Pe[238],Ae([1,0,6,3]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vbc=void 0;class I{constructor(A){this.b=0,this.a=A.getProxy(R.$JJ.MainThreadLabelService)}$registerResourceLabelFormatter(A){const d=this.b++;return this.a.$registerResourceLabelFormatter(d,A),(0,y.$jb)(()=>{this.a.$unregisterResourceLabelFormatter(d)})}}e.$vbc=I}),define(Pe[239],Ae([1,0,2,24,8,7,78,3,15,44,18,16,280,21,20,6,91,88,55,59,9,13,26,150]),function(pe,e,y,R,I,M,A,d,k,f,P,D,u,b,p,h,t,i,c,g,S,C,n,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sac=void 0;class r{constructor(L,q){this.d=L,this.e=q}async provideDocumentSymbols(L,q){const G=this.d.getDocument(L),Q=await this.e.provideDocumentSymbols(G,q);if(!(0,P.$mf)(Q))return Q[0]instanceof M.$4J?Q.map(I.DocumentSymbol.from):r.f(Q)}static f(L){L=L.slice(0).sort((Q,K)=>{let ee=Q.location.range.start.compareTo(K.location.range.start);return ee===0&&(ee=K.location.range.end.compareTo(Q.location.range.end)),ee});const q=[],G=[];for(const Q of L){const K={name:Q.name||"!!MISSING: name!!",kind:I.SymbolKind.from(Q.kind),tags:Q.tags?.map(I.SymbolTag.from)||[],detail:"",containerName:Q.containerName,range:I.Range.from(Q.location.range),selectionRange:I.Range.from(Q.location.range),children:[]};for(;;){if(G.length===0){G.push(K),q.push(K);break}const ee=G[G.length-1];if(f.$Ur.containsRange(ee.range,K.range)&&!f.$Ur.equalsRange(ee.range,K.range)){ee.children?.push(K),G.push(K);break}G.pop()}}return q}}class s{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(L,q,G){this.g=L,this.h=q,this.j=G,this.e=new c.$jac("CodeLens"),this.f=new Map}async provideCodeLenses(L,q){const G=this.g.getDocument(L),Q=await this.j.provideCodeLenses(G,q);if(!Q||q.isCancellationRequested)return;const K=this.e.add(Q),ee=new h.$kb;this.f.set(K,ee);const ce={cacheId:K,lenses:[]};for(let ze=0;ze<Q.length;ze++)ce.lenses.push({cacheId:[K,ze],range:I.Range.from(Q[ze].range),command:this.h.toInternal(Q[ze].command,ee)});return ce}async resolveCodeLens(L,q){const G=L.cacheId&&this.e.get(...L.cacheId);if(!G)return;let Q;if(typeof this.j.resolveCodeLens!="function"||G.isResolved?Q=G:Q=await this.j.resolveCodeLens(G,q),Q||(Q=G),q.isCancellationRequested)return;const K=L.cacheId&&this.f.get(L.cacheId[0]);if(K)return L.command=this.h.toInternal(Q.command??s.d,K),L}releaseCodeLenses(L){this.f.get(L)?.dispose(),this.f.delete(L),this.e.delete(L)}}function v(Se){return Array.isArray(Se)?Se.map(I.DefinitionLink.from):Se?[I.DefinitionLink.from(Se)]:[]}class ${constructor(L,q){this.d=L,this.e=q}async provideDefinition(L,q,G){const Q=this.d.getDocument(L),K=I.Position.to(q),ee=await this.e.provideDefinition(Q,K,G);return v(ee)}}class w{constructor(L,q){this.d=L,this.e=q}async provideDeclaration(L,q,G){const Q=this.d.getDocument(L),K=I.Position.to(q),ee=await this.e.provideDeclaration(Q,K,G);return v(ee)}}class E{constructor(L,q){this.d=L,this.e=q}async provideImplementation(L,q,G){const Q=this.d.getDocument(L),K=I.Position.to(q),ee=await this.e.provideImplementation(Q,K,G);return v(ee)}}class o{constructor(L,q){this.d=L,this.e=q}async provideTypeDefinition(L,q,G){const Q=this.d.getDocument(L),K=I.Position.to(q),ee=await this.e.provideTypeDefinition(Q,K,G);return v(ee)}}class l{constructor(L,q){this.d=L,this.e=q}async provideHover(L,q,G){const Q=this.d.getDocument(L),K=I.Position.to(q),ee=await this.e.provideHover(Q,K,G);if(!(!ee||(0,P.$mf)(ee.contents)))return ee.range||(ee.range=Q.getWordRangeAtPosition(K)),ee.range||(ee.range=new M.$NJ(K,K)),I.Hover.from(ee)}}class m{constructor(L,q){this.d=L,this.e=q}async provideEvaluatableExpression(L,q,G){const Q=this.d.getDocument(L),K=I.Position.to(q),ee=await this.e.provideEvaluatableExpression(Q,K,G);if(ee)return I.EvaluatableExpression.from(ee)}}class F{constructor(L,q){this.d=L,this.e=q}async provideInlineValues(L,q,G,Q){const K=this.d.getDocument(L),ee=await this.e.provideInlineValues(K,I.Range.to(q),I.InlineValueContext.to(G),Q);if(Array.isArray(ee))return ee.map(ce=>I.InlineValue.from(ce))}}class W{constructor(L,q){this.d=L,this.e=q}async provideDocumentHighlights(L,q,G){const Q=this.d.getDocument(L),K=I.Position.to(q),ee=await this.e.provideDocumentHighlights(Q,K,G);if(Array.isArray(ee))return ee.map(I.DocumentHighlight.from)}}class V{constructor(L,q){this.d=L,this.e=q}async provideLinkedEditingRanges(L,q,G){const Q=this.d.getDocument(L),K=I.Position.to(q),ee=await this.e.provideLinkedEditingRanges(Q,K,G);if(ee&&Array.isArray(ee.ranges))return{ranges:(0,P.$jf)(ee.ranges.map(I.Range.from)),wordPattern:ee.wordPattern}}}class B{constructor(L,q){this.d=L,this.e=q}async provideReferences(L,q,G,Q){const K=this.d.getDocument(L),ee=I.Position.to(q),ce=await this.e.provideReferences(K,ee,G,Q);if(Array.isArray(ce))return ce.map(I.location.from)}}class j{static{this.d=1e3}constructor(L,q,G,Q,K,ee,ce){this.h=L,this.j=q,this.k=G,this.l=Q,this.m=K,this.n=ee,this.o=ce,this.e=new c.$jac("CodeAction"),this.f=new Map,this.g=new M.$6J("notebook")}async provideCodeActions(L,q,G,Q){const K=this.h.getDocument(L),ee=u.$3r.isISelection(q)?I.Selection.to(q):I.Range.to(q),ce=[];for(const Xe of this.k.getDiagnostics(L))if(ee.intersection(Xe.range)&&ce.push(Xe)>j.d)break;const ze={diagnostics:ce,only:G.only?new M.$6J(G.only):void 0,triggerKind:I.CodeActionTriggerKind.to(G.trigger)},Ue=await this.l.provideCodeActions(K,ee,ze,Q);if(!(0,P.$nf)(Ue)||Q.isCancellationRequested)return;const Qe=this.e.add(Ue),He=new h.$kb;this.f.set(Qe,He);const et=[];for(let Xe=0;Xe<Ue.length;Xe++){const xe=Ue[Xe];if(xe)if(j.p(xe))this.o.report("CodeActionProvider.provideCodeActions - return commands",this.n,"Return 'CodeAction' instances instead."),et.push({_isSynthetic:!0,title:xe.title,command:this.j.toInternal(xe,He)});else{if(ze.triggerKind!==M.CodeActionTriggerKind.Invoke&&xe.kind&&this.g.contains(xe.kind))continue;ze.only&&(xe.kind?ze.only.contains(xe.kind)||this.m.warn(`${this.n.identifier.value} - Code actions of kind '${ze.only.value} 'requested but returned code action is of kind '${xe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.m.warn(`${this.n.identifier.value} - Code actions of kind '${ze.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),et.push({cacheId:[Qe,Xe],title:xe.title,command:xe.command&&this.j.toInternal(xe.command,He),diagnostics:xe.diagnostics&&xe.diagnostics.map(I.Diagnostic.from),edit:xe.edit&&I.WorkspaceEdit.from(xe.edit,void 0),kind:xe.kind&&xe.kind.value,isPreferred:xe.isPreferred,disabled:xe.disabled?.reason})}}return{cacheId:Qe,actions:et}}async resolveCodeAction(L,q){const[G,Q]=L,K=this.e.get(G,Q);if(!K||j.p(K))return{};if(!this.l.resolveCodeAction)return{};const ee=await this.l.resolveCodeAction(K,q)??K;let ce;ee.edit&&(ce=I.WorkspaceEdit.from(ee.edit,void 0));let ze;if(ee.command){const Ue=this.f.get(G);Ue&&(ze=this.j.toInternal(ee.command,Ue))}return{edit:ce,command:ze}}releaseCodeActions(L){this.f.get(L)?.dispose(),this.f.delete(L),this.e.delete(L)}static p(L){return typeof L.command=="string"&&typeof L.title=="string"}}class U{static toInternalProviderId(L,q){return L+"."+q}constructor(L,q,G,Q,K){this.d=L,this.e=q,this.f=G,this.g=Q,this.h=K}async prepareDocumentPaste(L,q,G,Q){if(!this.f.prepareDocumentPaste)return;const K=this.e.getDocument(L),ee=q.map(Ue=>I.Range.to(Ue)),ce=I.DataTransfer.toDataTransfer(G,()=>{throw new S.$0});if(await this.f.prepareDocumentPaste(K,ee,ce,Q),Q.isCancellationRequested)return;const ze=Array.from(ce).filter(([,Ue])=>!(Ue instanceof M.$AK));return I.DataTransfer.from(ze)}async providePasteEdits(L,q,G,Q,K){if(!this.f.provideDocumentPasteEdits)return;const ee=this.e.getDocument(q),ce=G.map(Qe=>I.Range.to(Qe)),ze=I.DataTransfer.toDataTransfer(Q,async Qe=>(await this.d.$resolvePasteFileData(this.g,L,Qe)).buffer),Ue=await this.f.provideDocumentPasteEdits(ee,ce,ze,K);if(Ue)return{label:Ue.label??(0,a.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:Ue.yieldTo?.map(Qe=>"mimeType"in Qe?Qe:{providerId:U.toInternalProviderId(Qe.extensionId,Qe.providerId)}),insertText:typeof Ue.insertText=="string"?Ue.insertText:{snippet:Ue.insertText.value},additionalEdit:Ue.additionalEdit?I.WorkspaceEdit.from(Ue.additionalEdit,void 0):void 0}}}class z{constructor(L,q){this.d=L,this.e=q}async provideDocumentFormattingEdits(L,q,G){const Q=this.d.getDocument(L),K=await this.e.provideDocumentFormattingEdits(Q,q,G);if(Array.isArray(K))return K.map(I.TextEdit.from)}}class ne{constructor(L,q){this.d=L,this.e=q}async provideDocumentRangeFormattingEdits(L,q,G,Q){const K=this.d.getDocument(L),ee=I.Range.to(q),ce=await this.e.provideDocumentRangeFormattingEdits(K,ee,G,Q);if(Array.isArray(ce))return ce.map(I.TextEdit.from)}async provideDocumentRangesFormattingEdits(L,q,G,Q){(0,D.$se)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const K=this.d.getDocument(L),ee=q.map(I.Range.to),ce=await this.e.provideDocumentRangesFormattingEdits(K,ee,G,Q);if(Array.isArray(ce))return ce.map(I.TextEdit.from)}}class Z{constructor(L,q){this.d=L,this.e=q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(L,q,G,Q,K){const ee=this.d.getDocument(L),ce=I.Position.to(q),ze=await this.e.provideOnTypeFormattingEdits(ee,ce,G,Q,K);if(Array.isArray(ze))return ze.map(I.TextEdit.from)}}class we{constructor(L,q){this.e=L,this.f=q,this.d=new c.$jac("WorkspaceSymbols")}async provideWorkspaceSymbols(L,q){const G=await this.e.provideWorkspaceSymbols(L,q);if(!(0,P.$nf)(G))return{symbols:[]};const Q=this.d.add(G),K={cacheId:Q,symbols:[]};for(let ee=0;ee<G.length;ee++){const ce=G[ee];if(!ce||!ce.name){this.f.warn("INVALID SymbolInformation",ce);continue}K.symbols.push({...I.WorkspaceSymbol.from(ce),cacheId:[Q,ee]})}return K}async resolveWorkspaceSymbol(L,q){if(typeof this.e.resolveWorkspaceSymbol!="function"||!L.cacheId)return L;const G=this.d.get(...L.cacheId);if(G){const Q=await this.e.resolveWorkspaceSymbol(G,q);return Q&&(0,R.$Lm)(L,I.WorkspaceSymbol.from(Q),!0)}}releaseWorkspaceSymbols(L){this.d.delete(L)}}class Ee{static supportsResolving(L){return typeof L.prepareRename=="function"}constructor(L,q,G){this.d=L,this.e=q,this.f=G}async provideRenameEdits(L,q,G,Q){const K=this.d.getDocument(L),ee=I.Position.to(q);try{const ce=await this.e.provideRenameEdits(K,ee,G,Q);return ce?I.WorkspaceEdit.from(ce):void 0}catch(ce){const ze=Ee.g(ce);return ze?{rejectReason:ze,edits:void 0}:Promise.reject(ce)}}async resolveRenameLocation(L,q,G){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const Q=this.d.getDocument(L),K=I.Position.to(q);try{const ee=await this.e.prepareRename(Q,K,G);let ce,ze;if(M.$NJ.isRange(ee)?(ce=ee,ze=Q.getText(ee)):(0,D.$ke)(ee)&&(ce=ee.range,ze=ee.placeholder),!ce||!ze)return;if(ce.start.line>K.line||ce.end.line<K.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:I.Range.from(ce),text:ze}}catch(ee){const ce=Ee.g(ee);return ce?{rejectReason:ce,range:void 0,text:void 0}:Promise.reject(ee)}}static g(L){return typeof L=="string"?L:L instanceof Error&&typeof L.message=="string"?L.message:void 0}}class Re{constructor(L,q){this.resultId=L,this.tokens=q}}class X{constructor(L,q){this.f=L,this.g=q,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(L,q,G){const Q=this.f.getDocument(L),K=q!==0?this.d.get(q):null;let ee=typeof K?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(Q,K.resultId,G):await this.g.provideDocumentSemanticTokens(Q,G);return K&&this.d.delete(q),ee?(ee=X.h(ee),this.o(X.n(K,ee),ee)):null}async releaseDocumentSemanticColoring(L){this.d.delete(L)}static h(L){return X.j(L)?X.k(L)?L:new M.$4K(new Uint32Array(L.data),L.resultId):X.l(L)?X.m(L)?L:new M.$6K(L.edits.map(q=>new M.$5K(q.start,q.deleteCount,q.data?new Uint32Array(q.data):q.data)),L.resultId):L}static j(L){return L&&!!L.data}static k(L){return L.data instanceof Uint32Array}static l(L){return L&&Array.isArray(L.edits)}static m(L){for(const q of L.edits)if(!(q.data instanceof Uint32Array))return!1;return!0}static n(L,q){if(!X.j(q)||!L||!L.tokens)return q;const G=L.tokens,Q=G.length,K=q.data,ee=K.length;let ce=0;const ze=Math.min(Q,ee);for(;ce<ze&&G[ce]===K[ce];)ce++;if(ce===Q&&ce===ee)return new M.$6K([],q.resultId);let Ue=0;const Qe=ze-ce;for(;Ue<Qe&&G[Q-Ue-1]===K[ee-Ue-1];)Ue++;return new M.$6K([{start:ce,deleteCount:Q-ce-Ue,data:K.subarray(ce,ee-Ue)}],q.resultId)}o(L,q){if(X.j(L)){const G=this.e++;return this.d.set(G,new Re(L.resultId,L.data)),(0,t.$49)({id:G,type:"full",data:L.data})}if(X.l(L)){const G=this.e++;return X.j(q)?this.d.set(G,new Re(q.resultId,q.data)):this.d.set(G,new Re(L.resultId)),(0,t.$49)({id:G,type:"delta",deltas:(L.edits||[]).map(Q=>({start:Q.start,deleteCount:Q.deleteCount,data:Q.data}))})}return null}}class de{constructor(L,q){this.d=L,this.e=q}async provideDocumentRangeSemanticTokens(L,q,G){const Q=this.d.getDocument(L),K=await this.e.provideDocumentRangeSemanticTokens(Q,I.Range.to(q),G);return K?this.f(K):null}f(L){return(0,t.$49)({id:0,type:"full",data:L.data})}}class Ce{static supportsResolving(L){return typeof L.resolveCompletionItem=="function"}constructor(L,q,G,Q,K){this.f=L,this.g=q,this.h=G,this.j=Q,this.k=K,this.d=new c.$jac("CompletionItem"),this.e=new Map}async provideCompletionItems(L,q,G,Q){const K=this.f.getDocument(L),ee=I.Position.to(q),ce=K.getWordRangeAtPosition(ee)||new M.$NJ(ee,ee),ze=ce.with({end:ee}),Ue=new g.$ac,Qe=await this.h.provideCompletionItems(K,ee,Q,I.CompletionContext.to(G));if(!Qe||Q.isCancellationRequested)return;const He=Array.isArray(Qe)?new M.$hK(Qe):Qe,et=Ce.supportsResolving(this.h)?this.d.add(He.items):this.d.add([]),Xe=new h.$kb;this.e.set(et,Xe);const xe=[],it={x:et,b:xe,a:{replace:I.Range.from(ce),insert:I.Range.from(ze)},c:He.isIncomplete||void 0,d:Ue.elapsed()};for(let tt=0;tt<He.items.length;tt++){const Ne=He.items[tt],st=this.l(Ne,[et,tt],ze,ce);xe.push(st)}return it}async resolveCompletionItem(L,q){if(typeof this.h.resolveCompletionItem!="function")return;const G=this.d.get(...L);if(!G)return;const Q=this.l(G,L),K=await this.h.resolveCompletionItem(G,q);if(!K)return;const ee=this.l(K,L);return(Q.h!==ee.h||Q.i!==ee.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(Q.n!==ee.n||Q.o!==ee.o||!(0,R.$Mm)(Q.p,ee.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...Q,d:ee.d,c:ee.c,l:ee.l,h:ee.h,i:ee.i,n:ee.n,o:ee.o,p:ee.p}}releaseCompletionItems(L){this.e.get(L)?.dispose(),this.e.delete(L),this.d.delete(L)}l(L,q,G,Q){const K=this.e.get(q[0]);if(!K)throw Error("DisposableStore is missing...");const ee=this.g.toInternal(L.command,K),ce={x:q,a:L.label,b:L.kind!==void 0?I.CompletionItemKind.from(L.kind):void 0,m:L.tags&&L.tags.map(I.CompletionItemTag.from),c:L.detail,d:typeof L.documentation>"u"?void 0:I.MarkdownString.fromStrict(L.documentation),e:L.sortText!==L.label?L.sortText:void 0,f:L.filterText!==L.label?L.filterText:void 0,g:L.preselect||void 0,i:L.keepWhitespace?1:0,k:L.commitCharacters?.join(""),l:L.additionalTextEdits&&L.additionalTextEdits.map(I.TextEdit.from),n:ee?.$ident,o:ee?.id,p:ee?.$ident?void 0:ee?.arguments};L.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ce.h=L.textEdit.newText):typeof L.insertText=="string"?ce.h=L.insertText:L.insertText instanceof M.$WJ&&(ce.h=L.insertText.value,ce.i|=4);let ze;return L.textEdit?ze=L.textEdit.range:L.range&&(ze=L.range),M.$NJ.isRange(ze)?ce.j=I.Range.from(ze):ze&&(!G?.isEqual(ze.inserting)||!Q?.isEqual(ze.replacing))&&(ce.j={insert:I.Range.from(ze.inserting),replace:I.Range.from(ze.replacing)}),ce}}class ae{async provideInlineCompletions(L,q,G,Q){}disposeCompletions(L){}handleDidShowCompletionItem(L,q,G){}handlePartialAccept(L,q,G){}}class _ extends ae{constructor(L,q,G,Q){super(),this.f=L,this.g=q,this.h=G,this.j=Q,this.d=new ue,this.e=(0,n.$DF)(this.f,"inlineCompletionsAdditions"),this.k={[A.InlineCompletionTriggerKind.Automatic]:M.InlineCompletionTriggerKind.Automatic,[A.InlineCompletionTriggerKind.Explicit]:M.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,n.$DF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(L,q,G,Q){const K=this.g.getDocument(L),ee=I.Position.to(q),ce=await this.h.provideInlineCompletionItems(K,ee,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:I.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[G.triggerKind]},Q);if(!ce||Q.isCancellationRequested)return;const ze=Array.isArray(ce)?ce:ce.items,Ue=this.e?Array.isArray(ce)?[]:ce.commands||[]:[],Qe=this.e&&!Array.isArray(ce)?ce.enableForwardStability:void 0;let He;return{pid:this.d.createReferenceId({dispose(){He?.dispose()},items:ze}),items:ze.map((Xe,xe)=>{let it;Xe.command&&(He||(He=new h.$kb),it=this.j.toInternal(Xe.command,He));const tt=Xe.insertText;return{insertText:typeof tt=="string"?tt:{snippet:tt.value},filterText:Xe.filterText,range:Xe.range?I.Range.from(Xe.range):void 0,command:it,idx:xe,completeBracketPairs:this.e?Xe.completeBracketPairs:!1}}),commands:Ue.map(Xe=>(He||(He=new h.$kb),this.j.toInternal(Xe,He))),suppressSuggestions:!1,enableForwardStability:Qe}}disposeCompletions(L){this.d.disposeReferenceId(L)?.dispose()}handleDidShowCompletionItem(L,q,G){const Q=this.d.get(L)?.items[q];Q&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(Q,G)}handlePartialAccept(L,q,G){const Q=this.d.get(L)?.items[q];Q&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(Q,G)}}class ue{constructor(){this.d=new Map,this.e=1}createReferenceId(L){const q=this.e++;return this.d.set(q,L),q}disposeReferenceId(L){const q=this.d.get(L);return this.d.delete(L),q}get(L){return this.d.get(L)}}class O{constructor(L,q){this.e=L,this.f=q,this.d=new c.$jac("SignatureHelp")}async provideSignatureHelp(L,q,G,Q){const K=this.e.getDocument(L),ee=I.Position.to(q),ce=this.g(G),ze=await this.f.provideSignatureHelp(K,ee,Q,ce);if(ze){const Ue=this.d.add([ze]);return{...I.SignatureHelp.from(ze),id:Ue}}}g(L){let q;if(L.activeSignatureHelp){const G=I.SignatureHelp.to(L.activeSignatureHelp),Q=this.d.get(L.activeSignatureHelp.id,0);Q?(q=Q,q.activeSignature=G.activeSignature,q.activeParameter=G.activeParameter):q=G}return{...L,activeSignatureHelp:q}}releaseSignatureHelp(L){this.d.delete(L)}}class J{constructor(L,q,G,Q,K){this.f=L,this.g=q,this.h=G,this.j=Q,this.k=K,this.d=new c.$jac("InlayHints"),this.e=new Map}async provideInlayHints(L,q,G){const Q=this.f.getDocument(L),K=I.Range.to(q),ee=await this.h.provideInlayHints(Q,K,G);if(!Array.isArray(ee)||ee.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${q}`);return}if(G.isCancellationRequested)return;const ce=this.d.add(ee);this.e.set(ce,new h.$kb);const ze={hints:[],cacheId:ce};for(let Ue=0;Ue<ee.length;Ue++)this.l(ee[Ue],K)&&ze.hints.push(this.m(ee[Ue],[ce,Ue]));return this.j.trace(`[InlayHints] ${ze.hints.length} inlay hints from '${this.k.identifier.value}' for ${q}`),ze}async resolveInlayHint(L,q){if(typeof this.h.resolveInlayHint!="function")return;const G=this.d.get(...L);if(!G)return;const Q=await this.h.resolveInlayHint(G,q);if(Q&&this.l(Q))return this.m(Q,L)}releaseHints(L){this.e.get(L)?.dispose(),this.e.delete(L),this.d.delete(L)}l(L,q){return L.label.length===0||Array.isArray(L.label)&&L.label.every(G=>G.value.length===0)?(console.log("INVALID inlay hint, empty label",L),!1):!(q&&!q.contains(L.position))}m(L,q){const G=this.e.get(q[0]);if(!G)throw Error("DisposableStore is missing...");const Q={label:"",cacheId:q,tooltip:I.MarkdownString.fromStrict(L.tooltip),position:I.Position.from(L.position),textEdits:L.textEdits&&L.textEdits.map(I.TextEdit.from),kind:L.kind&&I.InlayHintKind.from(L.kind),paddingLeft:L.paddingLeft,paddingRight:L.paddingRight};return typeof L.label=="string"?Q.label=L.label:Q.label=L.label.map(K=>{const ee={label:K.value};return ee.tooltip=I.MarkdownString.fromStrict(K.tooltip),M.$XJ.isLocation(K.location)&&(ee.location=I.location.from(K.location)),K.command&&(ee.command=this.g.toInternal(K.command,G)),ee}),Q}}class le{constructor(L,q){this.e=L,this.f=q,this.d=new c.$jac("DocumentLink")}async provideLinks(L,q){const G=this.e.getDocument(L),Q=await this.f.provideDocumentLinks(G,q);if(!(!Array.isArray(Q)||Q.length===0)&&!q.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:Q.filter(le.g).map(I.DocumentLink.from)};{const K=this.d.add(Q),ee={links:[],cacheId:K};for(let ce=0;ce<Q.length;ce++){if(!le.g(Q[ce]))continue;const ze=I.DocumentLink.from(Q[ce]);ze.cacheId=[K,ce],ee.links.push(ze)}return ee}}}static g(L){return L.target&&L.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(L,q){if(typeof this.f.resolveDocumentLink!="function")return;const G=this.d.get(...L);if(!G)return;const Q=await this.f.resolveDocumentLink(G,q);if(!(!Q||!le.g(Q)))return I.DocumentLink.from(Q)}releaseLinks(L){this.d.delete(L)}}class ye{constructor(L,q){this.d=L,this.e=q}async provideColors(L,q){const G=this.d.getDocument(L),Q=await this.e.provideDocumentColors(G,q);return Array.isArray(Q)?Q.map(ee=>({color:I.Color.from(ee.color),range:I.Range.from(ee.range)})):[]}async provideColorPresentations(L,q,G){const Q=this.d.getDocument(L),K=I.Range.to(q.range),ee=I.Color.to(q.color),ce=await this.e.provideColorPresentations(ee,{document:Q,range:K},G);if(Array.isArray(ce))return ce.map(I.ColorPresentation.from)}}class ve{constructor(L,q){this.d=L,this.e=q}async provideFoldingRanges(L,q,G){const Q=this.d.getDocument(L),K=await this.e.provideFoldingRanges(Q,q,G);if(Array.isArray(K))return K.map(I.FoldingRange.from)}}class be{constructor(L,q,G){this.d=L,this.e=q,this.f=G}async provideSelectionRanges(L,q,G){const Q=this.d.getDocument(L),K=q.map(I.Position.to),ee=await this.e.provideSelectionRanges(Q,K,G);if(!(0,P.$nf)(ee))return[];if(ee.length!==K.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ce=[];for(let ze=0;ze<K.length;ze++){const Ue=[];ce.push(Ue);let Qe=K[ze],He=ee[ze];for(;;){if(!He.range.contains(Qe))throw new Error("INVALID selection range, must contain the previous range");if(Ue.push(I.SelectionRange.from(He)),!He.parent)break;Qe=He.range,He=He.parent}}return ce}}class ke{constructor(L,q){this.f=L,this.g=q,this.d=new i.$QL(""),this.e=new Map}async prepareSession(L,q,G){const Q=this.f.getDocument(L),K=I.Position.to(q),ee=await this.g.prepareCallHierarchy(Q,K,G);if(!ee)return;const ce=this.d.nextId();return this.e.set(ce,new Map),Array.isArray(ee)?ee.map(ze=>this.h(ce,ze)):[this.h(ce,ee)]}async provideCallsTo(L,q,G){const Q=this.j(L,q);if(!Q)throw new Error("missing call hierarchy item");const K=await this.g.provideCallHierarchyIncomingCalls(Q,G);if(K)return K.map(ee=>({from:this.h(L,ee.from),fromRanges:ee.fromRanges.map(ce=>I.Range.from(ce))}))}async provideCallsFrom(L,q,G){const Q=this.j(L,q);if(!Q)throw new Error("missing call hierarchy item");const K=await this.g.provideCallHierarchyOutgoingCalls(Q,G);if(K)return K.map(ee=>({to:this.h(L,ee.to),fromRanges:ee.fromRanges.map(ce=>I.Range.from(ce))}))}releaseSession(L){this.e.delete(L)}h(L,q){const G=this.e.get(L),Q=I.CallHierarchyItem.from(q,L,G.size.toString(36));return G.set(Q._itemId,q),Q}j(L,q){return this.e.get(L)?.get(q)}}class oe{constructor(L,q){this.f=L,this.g=q,this.d=new i.$QL(""),this.e=new Map}async prepareSession(L,q,G){const Q=this.f.getDocument(L),K=I.Position.to(q),ee=await this.g.prepareTypeHierarchy(Q,K,G);if(!ee)return;const ce=this.d.nextId();return this.e.set(ce,new Map),Array.isArray(ee)?ee.map(ze=>this.h(ce,ze)):[this.h(ce,ee)]}async provideSupertypes(L,q,G){const Q=this.j(L,q);if(!Q)throw new Error("missing type hierarchy item");const K=await this.g.provideTypeHierarchySupertypes(Q,G);if(K)return K.map(ee=>this.h(L,ee))}async provideSubtypes(L,q,G){const Q=this.j(L,q);if(!Q)throw new Error("missing type hierarchy item");const K=await this.g.provideTypeHierarchySubtypes(Q,G);if(K)return K.map(ee=>this.h(L,ee))}releaseSession(L){this.e.delete(L)}h(L,q){const G=this.e.get(L),Q=I.TypeHierarchyItem.from(q,L,G.size.toString(36));return G.set(Q._itemId,q),Q}j(L,q){return this.e.get(L)?.get(q)}}class he{static toInternalProviderId(L,q){return L+"."+q}constructor(L,q,G,Q,K){this.d=L,this.e=q,this.f=G,this.g=Q,this.h=K}async provideDocumentOnDropEdits(L,q,G,Q,K){const ee=this.e.getDocument(q),ce=I.Position.to(G),ze=I.DataTransfer.toDataTransfer(Q,async Qe=>(await this.d.$resolveDocumentOnDropFileData(this.g,L,Qe)).buffer),Ue=await this.f.provideDocumentDropEdits(ee,ce,ze,K);if(Ue)return{label:Ue.label??(0,a.localize)(1,null,this.h.displayName||this.h.name),yieldTo:Ue.yieldTo?.map(Qe=>"mimeType"in Qe?Qe:{providerId:he.toInternalProviderId(Qe.extensionId,Qe.providerId)}),insertText:typeof Ue.insertText=="string"?Ue.insertText:{snippet:Ue.insertText.value},additionalEdit:Ue.additionalEdit?I.WorkspaceEdit.from(Ue.additionalEdit,void 0):void 0}}}class re{constructor(L,q){this.d=L,this.e=q}async provideMappedEdits(L,q,G,Q){const K=y.URI.revive(L),ee=this.d.getDocument(K),ce={selections:G.selections.map(Ue=>I.Selection.to(Ue)),related:G.related.map(Ue=>({uri:y.URI.revive(Ue.uri),range:I.Range.to(Ue.range)}))},ze=await this.e.provideMappedEdits(ee,q,ce,Q);return ze?I.WorkspaceEdit.from(ze):null}}class ie{constructor(L,q){this.adapter=L,this.extension=q}}class ge{static{this.d=0}constructor(L,q,G,Q,K,ee,ce,ze){this.g=q,this.h=G,this.j=Q,this.k=K,this.l=ee,this.m=ce,this.n=ze,this.f=new Map,this.e=L.getProxy(d.$JJ.MainThreadLanguageFeatures)}o(L,q){return I.DocumentSelector.from(L,this.g,q)}p(L){return new M.$LJ(()=>{this.f.delete(L),this.e.$unregister(L)})}q(){return ge.d++}async t(L,q,G,Q,K,ee=!1){const ce=this.f.get(L);if(!ce||!(ce.adapter instanceof q))return Q;const ze=Date.now();ee||this.l.trace(`[${ce.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const Ue=G(ce.adapter,ce.extension);return Promise.resolve(Ue).catch(Qe=>{(0,S.$2)(Qe)||(this.l.error(`[${ce.extension.identifier.value}] provider FAILED`),this.l.error(Qe),this.n.onExtensionError(ce.extension.identifier,Qe))}).finally(()=>{ee||this.l.trace(`[${ce.extension.identifier.value}] provider DONE after ${Date.now()-ze}ms`)}),b.CancellationToken.isCancellationToken(K)?(0,C.$kg)(Ue,K):Ue}u(L,q){const G=this.q();return this.f.set(G,new ie(L,q)),G}static w(L){return L.displayName||L.name}registerDocumentSymbolProvider(L,q,G,Q){const K=this.u(new r(this.h,G),L),ee=Q&&Q.label||ge.w(L);return this.e.$registerDocumentSymbolProvider(K,this.o(q,L),ee),this.p(K)}$provideDocumentSymbols(L,q,G){return this.t(L,r,Q=>Q.provideDocumentSymbols(y.URI.revive(q),G),void 0,G)}registerCodeLensProvider(L,q,G){const Q=this.q(),K=typeof G.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(Q,new ie(new s(this.h,this.j.converter,G),L)),this.e.$registerCodeLensSupport(Q,this.o(q,L),K);let ee=this.p(Q);if(K!==void 0){const ce=G.onDidChangeCodeLenses(ze=>this.e.$emitCodeLensEvent(K));ee=M.$LJ.from(ee,ce)}return ee}$provideCodeLenses(L,q,G){return this.t(L,s,Q=>Q.provideCodeLenses(y.URI.revive(q),G),void 0,G)}$resolveCodeLens(L,q,G){return this.t(L,s,Q=>Q.resolveCodeLens(q,G),void 0,void 0)}$releaseCodeLenses(L,q){this.t(L,s,G=>Promise.resolve(G.releaseCodeLenses(q)),void 0,void 0)}registerDefinitionProvider(L,q,G){const Q=this.u(new $(this.h,G),L);return this.e.$registerDefinitionSupport(Q,this.o(q,L)),this.p(Q)}$provideDefinition(L,q,G,Q){return this.t(L,$,K=>K.provideDefinition(y.URI.revive(q),G,Q),[],Q)}registerDeclarationProvider(L,q,G){const Q=this.u(new w(this.h,G),L);return this.e.$registerDeclarationSupport(Q,this.o(q,L)),this.p(Q)}$provideDeclaration(L,q,G,Q){return this.t(L,w,K=>K.provideDeclaration(y.URI.revive(q),G,Q),[],Q)}registerImplementationProvider(L,q,G){const Q=this.u(new E(this.h,G),L);return this.e.$registerImplementationSupport(Q,this.o(q,L)),this.p(Q)}$provideImplementation(L,q,G,Q){return this.t(L,E,K=>K.provideImplementation(y.URI.revive(q),G,Q),[],Q)}registerTypeDefinitionProvider(L,q,G){const Q=this.u(new o(this.h,G),L);return this.e.$registerTypeDefinitionSupport(Q,this.o(q,L)),this.p(Q)}$provideTypeDefinition(L,q,G,Q){return this.t(L,o,K=>K.provideTypeDefinition(y.URI.revive(q),G,Q),[],Q)}registerHoverProvider(L,q,G,Q){const K=this.u(new l(this.h,G),L);return this.e.$registerHoverProvider(K,this.o(q,L)),this.p(K)}$provideHover(L,q,G,Q){return this.t(L,l,K=>K.provideHover(y.URI.revive(q),G,Q),void 0,Q)}registerEvaluatableExpressionProvider(L,q,G,Q){const K=this.u(new m(this.h,G),L);return this.e.$registerEvaluatableExpressionProvider(K,this.o(q,L)),this.p(K)}$provideEvaluatableExpression(L,q,G,Q){return this.t(L,m,K=>K.provideEvaluatableExpression(y.URI.revive(q),G,Q),void 0,Q)}registerInlineValuesProvider(L,q,G,Q){const K=typeof G.onDidChangeInlineValues=="function"?this.q():void 0,ee=this.u(new F(this.h,G),L);this.e.$registerInlineValuesProvider(ee,this.o(q,L),K);let ce=this.p(ee);if(K!==void 0){const ze=G.onDidChangeInlineValues(Ue=>this.e.$emitInlineValuesEvent(K));ce=M.$LJ.from(ce,ze)}return ce}$provideInlineValues(L,q,G,Q,K){return this.t(L,F,ee=>ee.provideInlineValues(y.URI.revive(q),G,Q,K),void 0,K)}registerDocumentHighlightProvider(L,q,G){const Q=this.u(new W(this.h,G),L);return this.e.$registerDocumentHighlightProvider(Q,this.o(q,L)),this.p(Q)}$provideDocumentHighlights(L,q,G,Q){return this.t(L,W,K=>K.provideDocumentHighlights(y.URI.revive(q),G,Q),void 0,Q)}registerLinkedEditingRangeProvider(L,q,G){const Q=this.u(new V(this.h,G),L);return this.e.$registerLinkedEditingRangeProvider(Q,this.o(q,L)),this.p(Q)}$provideLinkedEditingRanges(L,q,G,Q){return this.t(L,V,async K=>{const ee=await K.provideLinkedEditingRanges(y.URI.revive(q),G,Q);if(ee)return{ranges:ee.ranges,wordPattern:ee.wordPattern?ge.y(ee.wordPattern):void 0}},void 0,Q)}registerReferenceProvider(L,q,G){const Q=this.u(new B(this.h,G),L);return this.e.$registerReferenceSupport(Q,this.o(q,L)),this.p(Q)}$provideReferences(L,q,G,Q,K){return this.t(L,B,ee=>ee.provideReferences(y.URI.revive(q),G,Q,K),void 0,K)}registerCodeActionProvider(L,q,G,Q){const K=new h.$kb,ee=this.u(new j(this.h,this.j.converter,this.k,G,this.l,L,this.m),L);return this.e.$registerQuickFixSupport(ee,this.o(q,L),{providedKinds:Q?.providedCodeActionKinds?.map(ce=>ce.value),documentation:Q?.documentation?.map(ce=>({kind:ce.kind.value,command:this.j.converter.toInternal(ce.command,K)}))},ge.w(L),!!G.resolveCodeAction),K.add(this.p(ee)),K}$provideCodeActions(L,q,G,Q,K){return this.t(L,j,ee=>ee.provideCodeActions(y.URI.revive(q),G,Q,K),void 0,K)}$resolveCodeAction(L,q,G){return this.t(L,j,Q=>Q.resolveCodeAction(q,G),{},void 0)}$releaseCodeActions(L,q){this.t(L,j,G=>Promise.resolve(G.releaseCodeActions(q)),void 0,void 0)}registerDocumentFormattingEditProvider(L,q,G){const Q=this.u(new z(this.h,G),L);return this.e.$registerDocumentFormattingSupport(Q,this.o(q,L),L.identifier,L.displayName||L.name),this.p(Q)}$provideDocumentFormattingEdits(L,q,G,Q){return this.t(L,z,K=>K.provideDocumentFormattingEdits(y.URI.revive(q),G,Q),void 0,Q)}registerDocumentRangeFormattingEditProvider(L,q,G){const Q=typeof G.provideDocumentRangesFormattingEdits=="function",K=this.u(new ne(this.h,G),L);return this.e.$registerRangeFormattingSupport(K,this.o(q,L),L.identifier,L.displayName||L.name,Q),this.p(K)}$provideDocumentRangeFormattingEdits(L,q,G,Q,K){return this.t(L,ne,ee=>ee.provideDocumentRangeFormattingEdits(y.URI.revive(q),G,Q,K),void 0,K)}$provideDocumentRangesFormattingEdits(L,q,G,Q,K){return this.t(L,ne,ee=>ee.provideDocumentRangesFormattingEdits(y.URI.revive(q),G,Q,K),void 0,K)}registerOnTypeFormattingEditProvider(L,q,G,Q){const K=this.u(new Z(this.h,G),L);return this.e.$registerOnTypeFormattingSupport(K,this.o(q,L),Q,L.identifier),this.p(K)}$provideOnTypeFormattingEdits(L,q,G,Q,K,ee){return this.t(L,Z,ce=>ce.provideOnTypeFormattingEdits(y.URI.revive(q),G,Q,K,ee),void 0,ee)}registerWorkspaceSymbolProvider(L,q){const G=this.u(new we(q,this.l),L);return this.e.$registerNavigateTypeSupport(G,typeof q.resolveWorkspaceSymbol=="function"),this.p(G)}$provideWorkspaceSymbols(L,q,G){return this.t(L,we,Q=>Q.provideWorkspaceSymbols(q,G),{symbols:[]},G)}$resolveWorkspaceSymbol(L,q,G){return this.t(L,we,Q=>Q.resolveWorkspaceSymbol(q,G),void 0,void 0)}$releaseWorkspaceSymbols(L,q){this.t(L,we,G=>G.releaseWorkspaceSymbols(q),void 0,void 0)}registerRenameProvider(L,q,G){const Q=this.u(new Ee(this.h,G,this.l),L);return this.e.$registerRenameSupport(Q,this.o(q,L),Ee.supportsResolving(G)),this.p(Q)}$provideRenameEdits(L,q,G,Q,K){return this.t(L,Ee,ee=>ee.provideRenameEdits(y.URI.revive(q),G,Q,K),void 0,K)}$resolveRenameLocation(L,q,G,Q){return this.t(L,Ee,K=>K.resolveRenameLocation(y.URI.revive(q),G,Q),void 0,Q)}registerDocumentSemanticTokensProvider(L,q,G,Q){const K=this.u(new X(this.h,G),L),ee=typeof G.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(K,this.o(q,L),Q,ee);let ce=this.p(K);if(ee){const ze=G.onDidChangeSemanticTokens(Ue=>this.e.$emitDocumentSemanticTokensEvent(ee));ce=M.$LJ.from(ce,ze)}return ce}$provideDocumentSemanticTokens(L,q,G,Q){return this.t(L,X,K=>K.provideDocumentSemanticTokens(y.URI.revive(q),G,Q),null,Q)}$releaseDocumentSemanticTokens(L,q){this.t(L,X,G=>G.releaseDocumentSemanticColoring(q),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(L,q,G,Q){const K=this.u(new de(this.h,G),L);return this.e.$registerDocumentRangeSemanticTokensProvider(K,this.o(q,L),Q),this.p(K)}$provideDocumentRangeSemanticTokens(L,q,G,Q){return this.t(L,de,K=>K.provideDocumentRangeSemanticTokens(y.URI.revive(q),G,Q),null,Q)}registerCompletionItemProvider(L,q,G,Q){const K=this.u(new Ce(this.h,this.j.converter,G,this.m,L),L);return this.e.$registerCompletionsProvider(K,this.o(q,L),Q,Ce.supportsResolving(G),L.identifier),this.p(K)}$provideCompletionItems(L,q,G,Q,K){return this.t(L,Ce,ee=>ee.provideCompletionItems(y.URI.revive(q),G,Q,K),void 0,K)}$resolveCompletionItem(L,q,G){return this.t(L,Ce,Q=>Q.resolveCompletionItem(q,G),void 0,G)}$releaseCompletionItems(L,q){this.t(L,Ce,G=>G.releaseCompletionItems(q),void 0,void 0)}registerInlineCompletionsProvider(L,q,G,Q){const K=new _(L,this.h,G,this.j.converter),ee=this.u(K,L);return this.e.$registerInlineCompletionsSupport(ee,this.o(q,L),K.supportsHandleEvents,p.$Il.toKey(L.identifier.value),Q?.yieldTo?.map(ce=>p.$Il.toKey(ce))||[]),this.p(ee)}$provideInlineCompletions(L,q,G,Q,K){return this.t(L,ae,ee=>ee.provideInlineCompletions(y.URI.revive(q),G,Q,K),void 0,K)}$handleInlineCompletionDidShow(L,q,G,Q){this.t(L,ae,async K=>{K.handleDidShowCompletionItem(q,G,Q)},void 0,void 0)}$handleInlineCompletionPartialAccept(L,q,G,Q){this.t(L,ae,async K=>{K.handlePartialAccept(q,G,Q)},void 0,void 0)}$freeInlineCompletionsList(L,q){this.t(L,ae,async G=>{G.disposeCompletions(q)},void 0,void 0)}registerSignatureHelpProvider(L,q,G,Q){const K=Array.isArray(Q)?{triggerCharacters:Q,retriggerCharacters:[]}:Q,ee=this.u(new O(this.h,G),L);return this.e.$registerSignatureHelpProvider(ee,this.o(q,L),K),this.p(ee)}$provideSignatureHelp(L,q,G,Q,K){return this.t(L,O,ee=>ee.provideSignatureHelp(y.URI.revive(q),G,Q,K),void 0,K)}$releaseSignatureHelp(L,q){this.t(L,O,G=>G.releaseSignatureHelp(q),void 0,void 0)}registerInlayHintsProvider(L,q,G){const Q=typeof G.onDidChangeInlayHints=="function"?this.q():void 0,K=this.u(new J(this.h,this.j.converter,G,this.l,L),L);this.e.$registerInlayHintsProvider(K,this.o(q,L),typeof G.resolveInlayHint=="function",Q,ge.w(L));let ee=this.p(K);if(Q!==void 0){const ce=G.onDidChangeInlayHints(ze=>this.e.$emitInlayHintsEvent(Q));ee=M.$LJ.from(ee,ce)}return ee}$provideInlayHints(L,q,G,Q){return this.t(L,J,K=>K.provideInlayHints(y.URI.revive(q),G,Q),void 0,Q)}$resolveInlayHint(L,q,G){return this.t(L,J,Q=>Q.resolveInlayHint(q,G),void 0,G)}$releaseInlayHints(L,q){this.t(L,J,G=>G.releaseHints(q),void 0,void 0)}registerDocumentLinkProvider(L,q,G){const Q=this.u(new le(this.h,G),L);return this.e.$registerDocumentLinkProvider(Q,this.o(q,L),typeof G.resolveDocumentLink=="function"),this.p(Q)}$provideDocumentLinks(L,q,G){return this.t(L,le,Q=>Q.provideLinks(y.URI.revive(q),G),void 0,G,q.scheme==="output")}$resolveDocumentLink(L,q,G){return this.t(L,le,Q=>Q.resolveLink(q,G),void 0,void 0,!0)}$releaseDocumentLinks(L,q){this.t(L,le,G=>G.releaseLinks(q),void 0,void 0,!0)}registerColorProvider(L,q,G){const Q=this.u(new ye(this.h,G),L);return this.e.$registerDocumentColorProvider(Q,this.o(q,L)),this.p(Q)}$provideDocumentColors(L,q,G){return this.t(L,ye,Q=>Q.provideColors(y.URI.revive(q),G),[],G)}$provideColorPresentations(L,q,G,Q){return this.t(L,ye,K=>K.provideColorPresentations(y.URI.revive(q),G,Q),void 0,Q)}registerFoldingRangeProvider(L,q,G){const Q=this.q(),K=typeof G.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(Q,new ie(new ve(this.h,G),L)),this.e.$registerFoldingRangeProvider(Q,this.o(q,L),L.identifier,K);let ee=this.p(Q);if(K!==void 0){const ce=G.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(K));ee=M.$LJ.from(ee,ce)}return ee}$provideFoldingRanges(L,q,G,Q){return this.t(L,ve,K=>K.provideFoldingRanges(y.URI.revive(q),G,Q),void 0,Q)}registerSelectionRangeProvider(L,q,G){const Q=this.u(new be(this.h,G,this.l),L);return this.e.$registerSelectionRangeProvider(Q,this.o(q,L)),this.p(Q)}$provideSelectionRanges(L,q,G,Q){return this.t(L,be,K=>K.provideSelectionRanges(y.URI.revive(q),G,Q),[],Q)}registerCallHierarchyProvider(L,q,G){const Q=this.u(new ke(this.h,G),L);return this.e.$registerCallHierarchyProvider(Q,this.o(q,L)),this.p(Q)}$prepareCallHierarchy(L,q,G,Q){return this.t(L,ke,K=>Promise.resolve(K.prepareSession(y.URI.revive(q),G,Q)),void 0,Q)}$provideCallHierarchyIncomingCalls(L,q,G,Q){return this.t(L,ke,K=>K.provideCallsTo(q,G,Q),void 0,Q)}$provideCallHierarchyOutgoingCalls(L,q,G,Q){return this.t(L,ke,K=>K.provideCallsFrom(q,G,Q),void 0,Q)}$releaseCallHierarchy(L,q){this.t(L,ke,G=>Promise.resolve(G.releaseSession(q)),void 0,void 0)}registerTypeHierarchyProvider(L,q,G){const Q=this.u(new oe(this.h,G),L);return this.e.$registerTypeHierarchyProvider(Q,this.o(q,L)),this.p(Q)}$prepareTypeHierarchy(L,q,G,Q){return this.t(L,oe,K=>Promise.resolve(K.prepareSession(y.URI.revive(q),G,Q)),void 0,Q)}$provideTypeHierarchySupertypes(L,q,G,Q){return this.t(L,oe,K=>K.provideSupertypes(q,G,Q),void 0,Q)}$provideTypeHierarchySubtypes(L,q,G,Q){return this.t(L,oe,K=>K.provideSubtypes(q,G,Q),void 0,Q)}$releaseTypeHierarchy(L,q){this.t(L,oe,G=>Promise.resolve(G.releaseSession(q)),void 0,void 0)}registerDocumentOnDropEditProvider(L,q,G,Q){const K=this.q();this.f.set(K,new ie(new he(this.e,this.h,G,K,L),L));const ee=(0,n.$DF)(L,"dropMetadata")&&Q?he.toInternalProviderId(L.identifier.value,Q.id):void 0;return this.e.$registerDocumentOnDropEditProvider(K,this.o(q,L),ee,(0,n.$DF)(L,"dropMetadata")?Q:void 0),this.p(K)}$provideDocumentOnDropEdits(L,q,G,Q,K,ee){return this.t(L,he,ce=>Promise.resolve(ce.provideDocumentOnDropEdits(q,y.URI.revive(G),Q,K,ee)),void 0,void 0)}registerMappedEditsProvider(L,q,G){const Q=this.u(new re(this.h,G),L);return this.e.$registerMappedEditsProvider(Q,this.o(q,L)),this.p(Q)}$provideMappedEdits(L,q,G,Q,K){return this.t(L,re,ee=>Promise.resolve(ee.provideMappedEdits(q,G,Q,K)),null,K)}registerDocumentPasteEditProvider(L,q,G,Q){const K=this.q();this.f.set(K,new ie(new U(this.e,this.h,G,K,L),L));const ee=U.toInternalProviderId(L.identifier.value,Q.id);return this.e.$registerPasteEditProvider(K,this.o(q,L),ee,{supportsCopy:!!G.prepareDocumentPaste,supportsPaste:!!G.provideDocumentPasteEdits,copyMimeTypes:Q.copyMimeTypes,pasteMimeTypes:Q.pasteMimeTypes}),this.p(K)}$prepareDocumentPaste(L,q,G,Q,K){return this.t(L,U,ee=>ee.prepareDocumentPaste(y.URI.revive(q),G,Q,K),void 0,K)}$providePasteEdits(L,q,G,Q,K,ee){return this.t(L,U,ce=>ce.providePasteEdits(q,y.URI.revive(G),Q,K,ee),void 0,ee)}static y(L){return{pattern:L.source,flags:L.flags}}static z(L){return{decreaseIndentPattern:ge.y(L.decreaseIndentPattern),increaseIndentPattern:ge.y(L.increaseIndentPattern),indentNextLinePattern:L.indentNextLinePattern?ge.y(L.indentNextLinePattern):void 0,unIndentedLinePattern:L.unIndentedLinePattern?ge.y(L.unIndentedLinePattern):void 0}}static B(L){return{beforeText:ge.y(L.beforeText),afterText:L.afterText?ge.y(L.afterText):void 0,previousLineText:L.previousLineText?ge.y(L.previousLineText):void 0,action:L.action}}static C(L){return L.map(ge.B)}setLanguageConfiguration(L,q,G){const{wordPattern:Q}=G;if(Q&&(0,k.$yd)(Q))throw new Error(`Invalid language configuration: wordPattern '${Q}' is not allowed to match the empty string.`);Q?this.h.setWordDefinitionFor(q,Q):this.h.setWordDefinitionFor(q,void 0),G.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",L,"Do not use."),G.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",L,"Do not use."),G.autoClosingPairs&&(0,n.$EF)(L,"languageConfigurationAutoClosingPairs");const K=this.q(),ee={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?ge.y(G.wordPattern):void 0,indentationRules:G.indentationRules?ge.z(G.indentationRules):void 0,onEnterRules:G.onEnterRules?ge.C(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport,autoClosingPairs:G.autoClosingPairs};return this.e.$setLanguageConfiguration(K,q,ee),this.p(K)}$setWordDefinitions(L){for(const q of L)this.h.setWordDefinitionFor(q.languageId,new RegExp(q.regexSource,q.regexFlags))}}e.$sac=ge}),define(Pe[240],Ae([1,0,3,8,7,29,13,6]),function(pe,e,y,R,I,M,A,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$abc=void 0;class k{constructor(P,D,u,b){this.c=D,this.d=u,this.e=b,this.b=[],this.f=0,this.g=new Set,this.a=P.getProxy(y.$JJ.MainThreadLanguages)}$acceptLanguageIds(P){this.b=P}async getLanguages(){return this.b.slice(0)}async changeLanguage(P,D){await this.a.$changeLanguage(P,D);const u=this.c.getDocumentData(P);if(!u)throw new Error(`document '${P.toString()}' NOT found`);return u.document}async tokenAtPosition(P,D){const u=P.version,b=R.Position.from(D),p=await this.a.$tokensAtPosition(P.uri,b),h={type:I.StandardTokenType.Other,range:P.getWordRangeAtPosition(D)??new I.$NJ(D.line,D.character,D.line,D.character)};if(!p)return h;const t={range:R.Range.to(p.range),type:R.TokenType.to(p.type)};return!t.range.contains(D)||u!==P.version?h:t}createLanguageStatusItem(P,D,u){const b=this.f++,p=this.a,h=this.g,t=`${P.identifier.value}/${D}`;if(h.has(t))throw new Error(`LanguageStatusItem with id '${D}' ALREADY exists`);h.add(t);const i={selector:u,id:D,name:P.displayName??P.name,severity:I.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let c;const g=new d.$kb,S=()=>{if(c?.dispose(),!h.has(t)){console.warn(`LanguageStatusItem (${D}) from ${P.identifier.value} has been disposed and CANNOT be updated anymore`);return}c=(0,A.$wg)(()=>{g.clear(),this.a.$setLanguageStatus(b,{id:t,name:i.name??P.displayName??P.name,source:P.displayName??P.name,selector:R.DocumentSelector.from(i.selector,this.e),label:i.text,detail:i.detail??"",severity:i.severity===I.LanguageStatusSeverity.Error?M.default.Error:i.severity===I.LanguageStatusSeverity.Warning?M.default.Warning:M.default.Info,command:i.command&&this.d.toInternal(i.command,g),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},C={dispose(){g.dispose(),c?.dispose(),p.$removeLanguageStatus(b),h.delete(t)},get id(){return i.id},get name(){return i.name},set name(n){i.name=n,S()},get selector(){return i.selector},set selector(n){i.selector=n,S()},get text(){return i.text},set text(n){i.text=n,S()},get detail(){return i.detail},set detail(n){i.detail=n,S()},get severity(){return i.severity},set severity(n){i.severity=n,S()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(n){i.accessibilityInformation=n,S()},get command(){return i.command},set command(n){i.command=n,S()},get busy(){return i.busy},set busy(n){i.busy=n,S()}};return S(),C}}e.$abc=k}),define(Pe[81],Ae([1,0,22,15,2,4,14,3,27,17]),function(pe,e,y,R,I,M,A,d,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3ac=e.$2ac=void 0;let P=class{constructor(u,b,p){this.f=p,this.d=new Map,this.a=b.getProxy(d.$JJ.MainThreadLocalization),this.b=u.environment.appLanguage,this.c=this.b===y.$f}getMessage(u,b){const{message:p,args:h,comment:t}=b;if(this.c)return(0,R.$nd)(p,h??{});let i=p;t&&t.length>0&&(i+=`/${Array.isArray(t)?t.join(""):t}`);const c=this.d.get(u)?.contents[i];return c||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${i}`),(0,R.$nd)(c??p,h??{})}getBundle(u){return this.d.get(u)?.contents}getBundleUri(u){return this.d.get(u)?.uri}async initializeLocalizedMessages(u){if(this.c||!u.l10n&&!u.isBuiltin||this.d.has(u.identifier.value))return;let b;const p=await this.g(u);if(!p){this.f.error(`No bundle location found for extension ${u.identifier.value}`);return}try{const h=await this.a.$fetchBundleContents(p),t=JSON.parse(h);b=u.isBuiltin?t.contents?.bundle:t}catch(h){this.f.error(`Failed to load translations for ${u.identifier.value} from ${p}: ${h.message}`);return}b&&this.d.set(u.identifier.value,{contents:b,uri:p})}async g(u){if(u.isBuiltin){const b=await this.a.$fetchBuiltInBundleUri(u.identifier.value,this.b);return I.URI.revive(b)}return u.l10n?I.URI.joinPath(u.extensionLocation,u.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$2ac=P,e.$2ac=P=Ke([We(0,k.$2L),We(1,f.$LL),We(2,A.$Ri)],P),e.$3ac=(0,M.$ph)("IExtHostLocalizationService")}),define(Pe[241],Ae([1,0,14,3,27,17,2,69]),function(pe,e,y,R,I,M,A,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qcc=void 0;let k=class extends y.$3i{constructor(D,u){super(u.logLevel,u.logsLocation,u.loggers.map(b=>(0,d.$Yg)(b))),this.n=D.getProxy(R.$JJ.MainThreadLogger)}$setLogLevel(D,u){u?this.setLogLevel(A.URI.revive(u),D):this.setLogLevel(D)}setVisibility(D,u){super.setVisibility(D,u),this.n.$setVisibility(D,u)}m(D,u,b){return new f(this.n,D,u,b)}};e.$qcc=k,e.$qcc=k=Ke([We(0,M.$LL),We(1,I.$2L)],k);class f extends y.$Xi{constructor(D,u,b,p){super(p?.logLevel==="always"),this.m=D,this.n=u,this.k=!1,this.l=[],this.setLevel(b),this.m.$createLogger(u,p).then(()=>{this.r(this.l),this.k=!0})}g(D,u){const b=[[D,u]];this.k?this.r(b):this.l.push(...b)}r(D){this.m.$log(this.n,D)}flush(){this.m.$flush(this.n)}}}),define(Pe[82],Ae([1,0,3,4,6,17,25]),function(pe,e,y,R,I,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ac=e.$4ac=void 0,e.$4ac=(0,R.$ph)("IExtHostManagedSockets");let d=class{constructor(D){this.b=0,this.c=null,this.d=new Map,this.a=D.getProxy(y.$JJ.MainThreadManagedSockets)}setFactory(D,u){for(const b of this.d.values())b.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new k(D,u),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(D){if(!this.c||this.c.socketFactoryId!==D)throw new Error(`No socket factory with id ${D}`);const u=++this.b,b=await this.c.makeConnection(),p=new I.$kb;return this.d.set(u,new f(u,b,p)),p.add((0,I.$jb)(()=>this.d.delete(u))),p.add(b.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(u),p.dispose()})),p.add(b.onDidClose(h=>{this.a.$onDidManagedSocketClose(u,h?.stack??h?.message),p.dispose()})),p.add(b.onDidReceiveMessage(h=>this.a.$onDidManagedSocketHaveData(u,A.$Ec.wrap(h)))),u}$remoteSocketWrite(D,u){this.d.get(D)?.actual.send(u.buffer)}$remoteSocketEnd(D){const u=this.d.get(D);u&&(u.actual.end(),u.dispose())}async $remoteSocketDrain(D){await this.d.get(D)?.actual.drain?.()}};e.$5ac=d,e.$5ac=d=Ke([We(0,M.$LL)],d);class k{constructor(D,u){this.socketFactoryId=D,this.makeConnection=u}}class f extends I.$lb{constructor(D,u,b){super(),this.socketId=D,this.actual=u,this.B(b)}}}),define(Pe[242],Ae([1,0,3,14,26]),function(pe,e,y,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bbc=void 0;function M(d){return d&&d.title}let A=class{constructor(k,f){this.b=f,this.a=k.getProxy(y.$JJ.MainThreadMessageService)}showMessage(k,f,P,D,u){const b={source:{identifier:k.identifier,label:k.displayName||k.name}};let p;typeof D=="string"||M(D)?p=[D,...u]:(b.modal=D?.modal,b.useCustom=D?.useCustom,b.detail=D?.detail,p=u),b.useCustom&&(0,I.$EF)(k,"resolvers");const h=[];for(let t=0;t<p.length;t++){const i=p[t];if(typeof i=="string")h.push({title:i,handle:t,isCloseAffordance:!1});else if(typeof i=="object"){const{title:c,isCloseAffordance:g}=i;h.push({title:c,isCloseAffordance:!!g,handle:t})}else this.b.warn("Invalid message item:",i)}return this.a.$showMessage(f,P,b,h).then(t=>{if(typeof t=="number")return p[t]})}};e.$bbc=A,e.$bbc=A=Ke([We(1,R.$Ri)],A)}),define(Pe[243],Ae([1,0,152,25,5,6,28,15,16,2,38,55,3,31,8,7,46,205,104,9,24,12]),function(pe,e,y,R,I,M,A,d,k,f,P,D,u,b,p,h,t,i,c,g,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vbc=void 0;class n{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(r=>r.apiEditor)}constructor(r,s,v,$,w){this.q=v,this.r=$,this.s=w,this.f=new Map,this.g=new A.$ni,this.h=new Map,this.j=new I.$ec({onListenerError:g.$Z}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new I.$ec({onListenerError:g.$Z}),this.onDidOpenNotebookDocument=this.m.event,this.n=new I.$ec({onListenerError:g.$Z}),this.onDidCloseNotebookDocument=this.n.event,this.o=new I.$ec({onListenerError:g.$Z}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new D.$jac("NotebookCellStatusBarCache"),this.u=0,this.w=new Map,this.b=r.getProxy(u.$JJ.MainThreadNotebook),this.c=r.getProxy(u.$JJ.MainThreadNotebookDocuments),this.d=r.getProxy(u.$JJ.MainThreadNotebookEditors),this.i=s.converter,s.registerArgumentProcessor({processArgument:E=>{if(E&&E.$mid===13){const o=E.notebookEditor?.notebookUri,l=E.cell.handle,F=this.g.get(o)?.getCell(l);if(F)return F.apiCell}if(E&&E.$mid===14){const o=E.uri,l=this.g.get(o);if(l)return l.apiNotebook}return E}}),n.A(s)}getEditorById(r){const s=this.h.get(r);if(!s)throw new Error(`unknown text editor: ${r}. known editors: ${[...this.h.keys()]} `);return s}getIdByEditor(r){for(const[s,v]of this.h)if(v.apiEditor===r)return s}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(r,s){const v=this.g.get(r);if(!v&&!s)throw new Error(`NO notebook document for '${r}'`);return v}static t(r,s){if(!s)return;const v=s.filenamePattern.map($=>p.NotebookExclusiveDocumentPattern.from($)).filter($=>$!==void 0);if(s.filenamePattern&&!v){console.warn(`Notebook content provider view options file name pattern is invalid ${s.filenamePattern}`);return}return{extension:r.identifier,providerDisplayName:r.displayName||r.name,displayName:s.displayName,filenamePattern:v,exclusive:s.exclusive||!1}}registerNotebookCellStatusBarItemProvider(r,s,v){const $=n.a++,w=typeof v.onDidChangeCellStatusBarItems=="function"?n.a++:void 0;this.f.set($,v),this.b.$registerNotebookCellStatusBarItemProvider($,w,s);let E;return w!==void 0&&(E=v.onDidChangeCellStatusBarItems(o=>this.b.$emitCellStatusBarEvent(w))),new h.$LJ(()=>{this.f.delete($),this.b.$unregisterNotebookCellStatusBarItemProvider($,w),E?.dispose()})}async createNotebookDocument(r){const s=await this.c.$tryCreateNotebook({viewType:r.viewType,content:r.content&&p.NotebookData.from(r.content)});return f.URI.revive(s)}async openNotebookDocument(r){const s=this.g.get(r);if(s)return s.apiNotebook;const v=await this.c.$tryOpenNotebook(r),$=this.g.get(f.URI.revive(v));return(0,k.$te)($?.apiNotebook)}async showNotebookDocument(r,s){f.URI.isUri(r)&&(r=await this.openNotebookDocument(r));let v;typeof s=="object"?v={position:p.ViewColumn.from(s.viewColumn),preserveFocus:s.preserveFocus,selections:s.selections&&s.selections.map(p.NotebookRange.from),pinned:typeof s.preview=="boolean"?!s.preview:void 0}:v={preserveFocus:!1};const $=await this.d.$tryShowNotebookDocument(r.uri,r.notebookType,v),w=$&&this.h.get($)?.apiEditor;if(w)return w;throw $?new Error(`Could NOT open editor for "${r.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${r.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(r,s,v,$){const w=this.f.get(r),E=f.URI.revive(s),o=this.g.get(E);if(!o||!w)return;const l=o.getCellFromIndex(v);if(!l)return;const m=await w.provideCellStatusBarItems(l.apiCell,$);if(!m)return;const F=new M.$kb,W=this.p.add([F]),B=(Array.isArray(m)?m:[m]).map(j=>p.NotebookStatusBarItem.from(j,this.i,F));return{cacheId:W,items:B}}$releaseNotebookCellStatusBarItems(r){this.p.delete(r)}registerNotebookSerializer(r,s,v,$,w){if((0,d.$ld)(s))throw new Error("viewType cannot be empty or just whitespace");const E=this.u++;return this.w.set(E,{viewType:s,serializer:v,options:$}),this.b.$registerNotebookSerializer(E,{id:r.identifier,location:r.extensionLocation},s,p.NotebookDocumentContentOptions.from($),n.t(r,w)),(0,M.$jb)(()=>{this.b.$unregisterNotebookSerializer(E)})}async $dataToNotebook(r,s,v){const $=this.w.get(r);if(!$)throw new Error("NO serializer found");const w=await $.serializer.deserializeNotebook(s.buffer,v);return new t.$5z(p.NotebookData.from(w))}async $notebookToData(r,s,v){const $=this.w.get(r);if(!$)throw new Error("NO serializer found");const w=await $.serializer.serializeNotebook(p.NotebookData.to(s.value),v);return R.$Ec.wrap(w)}async $saveNotebook(r,s,v,$,w){const E=f.URI.revive(s),o=this.w.get(r);if(!o)throw new Error("NO serializer found");const l=this.g.get(E);if(!l)throw new Error("Document NOT found");if(l.versionId!==v)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(E.scheme))throw new P.$ak((0,y.localize)(0,null,this.y(E)),6);await this.x(E,$);const m={metadata:(0,S.$Qm)(l.apiNotebook.metadata,j=>!(o.options?.transientDocumentMetadata??{})[j]),cells:[]};for(const j of l.apiNotebook.getCells()){const U=new h.$$K(j.kind,j.document.getText(),j.document.languageId,j.mime,o.options?.transientOutputs?[]:[...j.outputs],j.metadata,j.executionSummary);U.metadata=(0,S.$Qm)(j.metadata,z=>!(o.options?.transientCellMetadata??{})[z]),m.cells.push(U)}const F=await o.serializer.serializeNotebook(m,w);await this.s.value.writeFile(E,F);const W=this.s.getFileSystemProviderExtUri(E.scheme),V=await this.s.value.stat(E);return{name:W.basename(E),isFile:(V.type&P.FileType.File)!==0,isDirectory:(V.type&P.FileType.Directory)!==0,isSymbolicLink:(V.type&P.FileType.SymbolicLink)!==0,mtime:V.mtime,ctime:V.ctime,size:V.size,readonly:!!((V.permissions??0)&P.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(E.scheme),locked:!!((V.permissions??0)&P.FilePermission.Locked),etag:P.$lk({mtime:V.mtime,size:V.size}),children:void 0}}async x(r,s){const v=await this.s.value.stat(r);if(typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==P.$kk&&typeof v.mtime=="number"&&typeof v.size=="number"&&s.mtime<v.mtime&&s.etag!==P.$lk({mtime:s.mtime,size:v.size}))throw new P.$ak((0,y.localize)(1,null),3,s)}y(r){return r.scheme===C.Schemas.file?r.fsPath:r.toString()}z(r,s,v){if(this.h.has(s))throw new Error(`editor with id ALREADY EXSIST: ${s}`);const $=new c.$Ubc(s,this.d,r,v.visibleRanges.map(p.NotebookRange.to),v.selections.map(p.NotebookRange.to),typeof v.viewColumn=="number"?p.ViewColumn.to(v.viewColumn):void 0);this.h.set(s,$)}$acceptDocumentAndEditorsDelta(r){if(r.value.removedDocuments)for(const v of r.value.removedDocuments){const $=f.URI.revive(v),w=this.g.get($);w&&(w.dispose(),this.g.delete($),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:w.apiNotebook.getCells().map(E=>E.document.uri)}),this.n.fire(w.apiNotebook));for(const E of this.h.values())E.notebookData.uri.toString()===$.toString()&&this.h.delete(E.id)}if(r.value.addedDocuments){const v=[];for(const $ of r.value.addedDocuments){const w=f.URI.revive($.uri);if(this.g.has(w))throw new Error(`adding EXISTING notebook ${w} `);const E=new i.$Tbc(this.c,this.q,this.r,w,$);v.push(...$.cells.map(o=>i.$Sbc.asModelAddData(E.apiNotebook,o))),this.g.get(w)?.dispose(),this.g.set(w,E),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:v}),this.m.fire(E.apiNotebook)}}if(r.value.addedEditors)for(const v of r.value.addedEditors){if(this.h.has(v.id))return;const $=f.URI.revive(v.documentUri),w=this.g.get($);w&&this.z(w,v.id,v)}const s=[];if(r.value.removedEditors)for(const v of r.value.removedEditors){const $=this.h.get(v);$&&(this.h.delete(v),this.k?.id===$.id&&(this.k=void 0),s.push($))}if(r.value.visibleEditors){this.l=r.value.visibleEditors.map($=>this.h.get($)).filter($=>!!$);const v=new Set;this.l.forEach($=>v.add($.id));for(const $ of this.h.values()){const w=v.has($.id);$._acceptVisibility(w)}this.l=[...this.h.values()].map($=>$).filter($=>$.visible),this.o.fire(this.visibleNotebookEditors)}r.value.newActiveEditor===null?this.k=void 0:r.value.newActiveEditor&&(this.h.get(r.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${r.value.newActiveEditor}`),this.k=this.h.get(r.value.newActiveEditor)),r.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static A(r){const s=b.$0L.String.with("notebookType","A notebook type"),v=new b.$_L("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[s,new b.$0L("data","Bytes to convert to data",w=>w instanceof Uint8Array,w=>R.$Ec.wrap(w))],new b.$$L("Notebook Data",w=>p.NotebookData.to(w.value))),$=new b.$_L("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[s,new b.$0L("NotebookData","Notebook data to convert to bytes",w=>!0,w=>new t.$5z(p.NotebookData.from(w)))],new b.$$L("Bytes",w=>w.buffer));r.registerApiCommand(v),r.registerApiCommand($)}}e.$Vbc=n}),define(Pe[244],Ae([1,0,18,13,21,5,6,28,2,20,14,55,3,31,8,7,77,198,26,46]),function(pe,e,y,R,I,M,A,d,k,f,P,D,u,b,p,h,t,i,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$bc=e.$0bc=void 0;let S=class{constructor(w,E,o,l,m){this.m=E,this.n=o,this.o=l,this.q=m,this.b=new d.$ni,this.c=new d.$ni,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new D.$jac("NotebookKernelSourceActionProviderCache"),this.j=new Map,this.k=0,this.l=new M.$ec,this.onDidChangeNotebookCellExecutionState=this.l.event,this.a=w.getProxy(u.$JJ.MainThreadNotebookKernels);const F=new b.$_L("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new b.$0L("options","Select kernel options",W=>!0,W=>{if(W&&"notebookEditor"in W&&"id"in W){const V=this.n.getIdByEditor(W.notebookEditor);return{id:W.id,extension:W.extension,notebookEditorId:V}}else if(W&&"notebookEditor"in W){const V=this.n.getIdByEditor(W.notebookEditor);if(V===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${W.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:V}}return W})],b.$$L.Void);this.o.registerApiCommand(F)}createNotebookController(w,E,o,l,m,F){for(const ae of this.j.values())if(ae.controller.id===E&&f.$Il.equals(w.identifier,ae.extensionId))throw new Error(`notebook controller with id '${E}' ALREADY exist`);const W=this.k++,V=this;this.q.trace(`NotebookController[${W}], CREATED by ${w.identifier.value}, ${E}`);const B=()=>console.warn(`NO execute handler from notebook controller '${Z.id}' of extension: '${w.identifier}'`);let j=!1;const U=new A.$kb,z=new M.$ec,ne=new M.$ec,Z={id:v(w.identifier,E),notebookType:o,extensionId:w.identifier,extensionLocation:w.extensionLocation,label:l||w.identifier.value,preloads:F?F.map(p.NotebookRendererScript.from):[]};let we=m??B,Ee;this.a.$addKernel(W,Z).catch(ae=>{console.log(ae),j=!0});let Re=0;const X=()=>{if(j)return;const ae=++Re;Promise.resolve().then(()=>{ae===Re&&this.a.$updateKernel(W,Z)})},de=new d.$ni,Ce={get id(){return E},get notebookType(){return Z.notebookType},onDidChangeSelectedNotebooks:z.event,get label(){return Z.label},set label(ae){Z.label=ae??w.displayName??w.name,X()},get detail(){return Z.detail??""},set detail(ae){Z.detail=ae,X()},get description(){return Z.description??""},set description(ae){Z.description=ae,X()},get supportedLanguages(){return Z.supportedLanguages},set supportedLanguages(ae){Z.supportedLanguages=ae,X()},get supportsExecutionOrder(){return Z.supportsExecutionOrder??!1},set supportsExecutionOrder(ae){Z.supportsExecutionOrder=ae,X()},get rendererScripts(){return Z.preloads?Z.preloads.map(p.NotebookRendererScript.to):[]},get executeHandler(){return we},set executeHandler(ae){we=ae??B},get interruptHandler(){return Ee},set interruptHandler(ae){Ee=ae,Z.supportsInterrupt=!!ae,X()},createNotebookCellExecution(ae){if(j)throw new Error("notebook controller is DISPOSED");if(!de.has(ae.notebook.uri))throw V.q.trace(`NotebookController[${W}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(de.keys()).map(_=>_.toString())),new Error(`notebook controller is NOT associated to notebook: ${ae.notebook.uri.toString()}`);return V._createNotebookCellExecution(ae,v(w.identifier,this.id))},createNotebookExecution(ae){if((0,c.$EF)(w,"notebookExecution"),j)throw new Error("notebook controller is DISPOSED");if(!de.has(ae.uri))throw V.q.trace(`NotebookController[${W}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(de.keys()).map(_=>_.toString())),new Error(`notebook controller is NOT associated to notebook: ${ae.uri.toString()}`);return V._createNotebookExecution(ae,v(w.identifier,this.id))},dispose:()=>{j||(this.q.trace(`NotebookController[${W}], DISPOSED`),j=!0,this.j.delete(W),U.dispose(),z.dispose(),ne.dispose(),this.a.$removeKernel(W))},updateNotebookAffinity(ae,_){_===h.NotebookControllerAffinity2.Hidden&&(0,c.$EF)(w,"notebookControllerAffinityHidden"),V.a.$updateNotebookPriority(W,ae.uri,_)},onDidReceiveMessage:ne.event,postMessage(ae,_){return(0,c.$EF)(w,"notebookMessaging"),V.a.$postMessage(W,_&&V.n.getIdByEditor(_),ae)},asWebviewUri(ae){return(0,c.$EF)(w,"notebookMessaging"),(0,t.$job)(ae,V.m.remote)}};return this.j.set(W,{extensionId:w.identifier,controller:Ce,onDidReceiveMessage:ne,onDidChangeSelection:z,associatedNotebooks:de}),Ce}getIdByController(w){for(const[E,o]of this.j)if(o.controller===w)return v(o.extensionId,w.id);return null}createNotebookControllerDetectionTask(w,E){const o=this.f++,l=this;this.q.trace(`NotebookControllerDetectionTask[${o}], CREATED by ${w.identifier.value}`),this.a.$addKernelDetectionTask(o,E);const m={dispose:()=>{this.e.delete(o),l.a.$removeKernelDetectionTask(o)}};return this.e.set(o,m),m}registerKernelSourceActionProvider(w,E,o){const l=this.h++,m=typeof o.onDidChangeNotebookKernelSourceActions=="function"?l:void 0,F=this;this.g.set(l,o),this.q.trace(`NotebookKernelSourceActionProvider[${l}], CREATED by ${w.identifier.value}`),this.a.$addKernelSourceActionProvider(l,l,E);let W;return m!==void 0&&(W=o.onDidChangeNotebookKernelSourceActions(V=>this.a.$emitNotebookKernelSourceActionsChangeEvent(m))),{dispose:()=>{this.g.delete(l),F.a.$removeKernelSourceActionProvider(l,l),W?.dispose()}}}async $provideKernelSourceActions(w,E){const o=this.g.get(w);if(o){const l=new A.$kb;return this.i.add([l]),(await o.provideNotebookKernelSourceActions(E)??[]).map(F=>p.NotebookKernelSourceAction.from(F,this.o.converter,l))}return[]}$acceptNotebookAssociation(w,E,o){const l=this.j.get(w);if(l){const m=this.n.getNotebookDocument(k.URI.revive(E));o?l.associatedNotebooks.set(m.uri,!0):l.associatedNotebooks.delete(m.uri),this.q.trace(`NotebookController[${w}] ASSOCIATE notebook`,m.uri.toString(),o),l.onDidChangeSelection.fire({selected:o,notebook:m.apiNotebook})}}async $executeCells(w,E,o){const l=this.j.get(w);if(!l)return;const m=this.n.getNotebookDocument(k.URI.revive(E)),F=[];for(const W of o){const V=m.getCell(W);V&&F.push(V.apiCell)}try{this.q.trace(`NotebookController[${w}] EXECUTE cells`,m.uri.toString(),F.length),await l.controller.executeHandler.call(l.controller,F,m.apiNotebook,l.controller)}catch(W){this.q.error(`NotebookController[${w}] execute cells FAILED`,W),console.error(W)}}async $cancelCells(w,E,o){const l=this.j.get(w);if(!l)return;const m=this.n.getNotebookDocument(k.URI.revive(E));if(l.controller.interruptHandler)await l.controller.interruptHandler.call(l.controller,m.apiNotebook);else for(const F of o){const W=m.getCell(F);W&&this.b.get(W.uri)?.cancel()}if(l.controller.interruptHandler){const F=this.c.get(m.uri);o.length&&Array.isArray(F)&&F.length&&F.forEach(W=>W.dispose())}}$acceptKernelMessageFromRenderer(w,E,o){const l=this.j.get(w);if(!l)return;const m=this.n.getEditorById(E);l.onDidReceiveMessage.fire(Object.freeze({editor:m.apiEditor,message:o}))}$cellExecutionChanged(w,E,o){const m=this.n.getNotebookDocument(k.URI.revive(w)).getCell(E);if(m){const F=o?p.NotebookCellExecutionState.to(o):h.NotebookCellExecutionState.Idle;F!==void 0&&this.l.fire({cell:m.apiCell,state:F})}}_createNotebookCellExecution(w,E){if(w.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const l=this.n.getNotebookDocument(w.notebook.uri).getCellFromApiCell(w);if(!l)throw new Error("invalid cell");if(this.b.has(l.uri))throw new Error(`duplicate execution for ${l.uri}`);const m=new n(E,l,this.a);this.b.set(l.uri,m);const F=m.onDidChangeState(()=>{m.state===C.Resolved&&(m.dispose(),F.dispose(),this.b.delete(l.uri))});return m.asApiObject()}_createNotebookExecution(w,E){const o=this.n.getNotebookDocument(w.uri),l=w.getCells().find(W=>{const V=o.getCellFromApiCell(W);return V&&this.b.has(V.uri)});if(l)throw new Error(`duplicate cell execution for ${l.document.uri}`);if(this.c.has(o.uri))throw new Error(`duplicate notebook execution for ${o.uri}`);const m=new r(E,o,this.a),F=m.onDidChangeState(()=>{m.state===a.Resolved&&(m.dispose(),F.dispose(),this.c.delete(o.uri))});return this.c.set(o.uri,[m,F]),m.asApiObject()}};e.$0bc=S,e.$0bc=S=Ke([We(4,P.$Ri)],S);var C;(function($){$[$.Init=0]="Init",$[$.Started=1]="Started",$[$.Resolved=2]="Resolved"})(C||(C={}));class n extends A.$lb{static{this.a=0}get state(){return this.f}constructor(w,E,o){super(),this.j=E,this.k=o,this.b=n.a++,this.c=new M.$ec,this.onDidChangeState=this.c.event,this.f=C.Init,this.g=this.B(new I.$oc),this.h=new s(10,l=>this.m(l)),this.i=E.internalMetadata.executionOrder,this.k.$createExecution(this.b,w,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(w){await this.h.addItem(w)}async m(w){const E=Array.isArray(w)?w:[w];return this.k.$updateExecution(this.b,new g.$5z(E))}n(){if(this.f===C.Init)throw new Error("Must call start before modifying cell output");if(this.f===C.Resolved)throw new Error("Cannot modify cell output after calling resolve")}r(w){let E=this.j;if(w&&(E=this.j.notebook.getCellFromApiCell(w)),!E)throw new Error("INVALID cell");return E.handle}s(w){return w.map(E=>{const o=h.$bL.ensureUniqueMimeTypes(E.items,!0);return o===E.items?p.NotebookCellOutput.from(E):p.NotebookCellOutput.from({items:o,id:E.id,metadata:E.metadata})})}async t(w,E,o){const l=this.r(E),m=this.s((0,y.$Gf)(w));return this.l({editType:i.CellExecutionUpdateType.Output,cellHandle:l,append:o,outputs:m})}async w(w,E,o){return w=h.$bL.ensureUniqueMimeTypes((0,y.$Gf)(w),!0),this.l({editType:i.CellExecutionUpdateType.OutputItems,items:w.map(p.NotebookCellOutputItem.from),outputId:E.id,append:o})}asApiObject(){const w=this;return Object.freeze({get token(){return w.g.token},get cell(){return w.j.apiCell},get executionOrder(){return w.i},set executionOrder(o){w.i=o,w.m([{editType:i.CellExecutionUpdateType.ExecutionState,executionOrder:w.i}])},start(o){if(w.f===C.Resolved||w.f===C.Started)throw new Error("Cannot call start again");w.f=C.Started,w.c.fire(),w.m({editType:i.CellExecutionUpdateType.ExecutionState,runStartTime:o})},end(o,l){if(w.f===C.Resolved)throw new Error("Cannot call resolve twice");w.f=C.Resolved,w.c.fire(),w.h.flush(),w.k.$completeExecution(w.b,new g.$5z({runEndTime:l,lastRunSuccess:o}))},clearOutput(o){return w.n(),w.t([],o,!1)},appendOutput(o,l){return w.n(),w.t(o,l,!0)},replaceOutput(o,l){return w.n(),w.t(o,l,!1)},appendOutputItems(o,l){return w.n(),w.w(o,l,!0)},replaceOutputItems(o,l){return w.n(),w.w(o,l,!1)}})}}var a;(function($){$[$.Init=0]="Init",$[$.Started=1]="Started",$[$.Resolved=2]="Resolved"})(a||(a={}));class r extends A.$lb{static{this.a=0}get state(){return this.f}constructor(w,E,o){super(),this.h=E,this.i=o,this.b=r.a++,this.c=new M.$ec,this.onDidChangeState=this.c.event,this.f=a.Init,this.g=this.B(new I.$oc),this.i.$createNotebookExecution(this.b,w,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===a.Resolved||this.f===a.Started)throw new Error("Cannot call start again");this.f=a.Started,this.c.fire(),this.i.$beginNotebookExecution(this.b)},end:()=>{if(this.f===a.Resolved)throw new Error("Cannot call resolve twice");this.f=a.Resolved,this.c.fire(),this.i.$completeNotebookExecution(this.b)}})}}class s{constructor(w,E){this.e=w,this.f=E,this.a=[],this.b=Date.now()}addItem(w){return this.a.push(w),this.c||(this.c=new R.$Pg,this.b=Date.now(),(0,R.$vg)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const w=this.c;this.c=void 0;const E=this.a;return this.a=[],this.f(E).finally(()=>w.complete())}}function v($,w){return`${$.value}/${w}`}e.$$bc=v}),define(Pe[245],Ae([1,0,5,3,104]),function(pe,e,y,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_bc=void 0;class M{constructor(d,k){this.c=k,this.a=new Map,this.b=d.getProxy(R.$JJ.MainThreadNotebookRenderers)}$postRendererMessage(d,k,f){const P=this.c.getEditorById(d);this.a.get(k)?.fire({editor:P.apiEditor,message:f})}createRendererMessaging(d,k){if(!d.contributes?.notebookRenderer?.some(P=>P.id===k))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${k})`);return{onDidReceiveMessage:(P,D,u)=>this.d(k).event(P,D,u),postMessage:(P,D)=>{I.$Ubc.apiEditorsToExtHost.has(P)&&([P,D]=[D,P]);const u=D&&I.$Ubc.apiEditorsToExtHost.get(D);return this.b.$postMessage(u?.id,k,P)}}}d(d){let k=this.a.get(d);return k||(k=new y.$ec({onDidRemoveLastListener:()=>{k?.dispose(),this.a.delete(d)}}),this.a.set(d,k),k)}}e.$_bc=M}),define(Pe[246],Ae([1,0,6,16,2,26,3]),function(pe,e,y,R,I,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dcc=void 0;class d{constructor(f){this.b=new Map,this.a=f.getProxy(A.$JJ.MainThreadProfileContentHandlers)}registrProfileContentHandler(f,P,D){if((0,M.$EF)(f,"profileContentHandlers"),this.b.has(P))throw new Error(`Handler with id '${P}' already registered`);return this.b.set(P,D),this.a.$registerProfileContentHandler(P,D.name,D.description,f.identifier.value),(0,y.$jb)(()=>{this.b.delete(P),this.a.$unregisterProfileContentHandler(P)})}async $saveProfile(f,P,D,u){const b=this.b.get(f);if(!b)throw new Error(`Unknown handler with id: ${f}`);return b.saveProfile(P,D,u)}async $readProfile(f,P,D){const u=this.b.get(f);if(!u)throw new Error(`Unknown handler with id: ${f}`);return u.readProfile((0,R.$ie)(P)?P:I.URI.revive(P),D)}}e.$dcc=d}),define(Pe[247],Ae([1,0,2,3,13,8]),function(pe,e,y,R,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ecc=void 0;class A{static{this.a=0}constructor(k,f){this.d=f,this.c=new Map,this.b=k.getProxy(R.$JJ.MainThreadQuickDiff)}$provideOriginalResource(k,f,P){const D=y.URI.revive(f),u=this.c.get(k);return u?(0,I.$ng)(()=>u.provideOriginalResource(D,P)).then(b=>b||null):Promise.resolve(null)}registerQuickDiffProvider(k,f,P,D){const u=A.a++;return this.c.set(u,f),this.b.$registerQuickDiffProvider(u,M.DocumentSelector.from(k,this.d),P,D),{dispose:()=>{this.b.$unregisterQuickDiffProvider(u),this.c.delete(u)}}}}e.$ecc=A}),define(Pe[248],Ae([1,0,21,5,6,3,2,7,9,18,29,40,26,8]),function(pe,e,y,R,I,M,A,d,k,f,P,D,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fbc=void 0;function p(h,t,i){const c=h.getProxy(M.$JJ.MainThreadQuickOpen);class g{constructor(w,E){this.e=new Map,this.f=0,this.a=w,this.b=E}showQuickPick(w,E,o,l=y.CancellationToken.None){this.c=void 0;const m=Promise.resolve(E),F=++this.f,W=c.$show(F,{title:o?.title,placeHolder:o?.placeHolder,matchOnDescription:o?.matchOnDescription,matchOnDetail:o?.matchOnDetail,ignoreFocusLost:o?.ignoreFocusOut,canPickMany:o?.canPickMany},l),V={},B=W.then(()=>V);return Promise.race([B,m]).then(j=>{if(j===V)return;const U=(0,u.$DF)(w,"quickPickItemTooltip");return m.then(z=>{const ne=[];for(let Z=0;Z<z.length;Z++){const we=z[Z];if(typeof we=="string")ne.push({label:we,handle:Z});else if(we.kind===d.QuickPickItemKind.Separator)ne.push({type:"separator",label:we.label});else{we.tooltip&&!U&&console.warn(`Extension '${w.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${w.identifier.value}`);const Ee=we.iconPath?r(we.iconPath):void 0;ne.push({label:we.label,iconPath:Ee?.iconPath,iconClass:Ee?.iconClass,description:we.description,detail:we.detail,picked:we.picked,alwaysShow:we.alwaysShow,tooltip:U?b.MarkdownString.fromStrict(we.tooltip):void 0,handle:Z})}}return o&&typeof o.onDidSelectItem=="function"&&(this.c=Z=>{o.onDidSelectItem(z[Z])}),c.$setItems(F,ne),W.then(Z=>{if(typeof Z=="number")return z[Z];if(Array.isArray(Z))return Z.map(we=>z[we])})})}).then(void 0,j=>{if(!(0,k.$2)(j))return c.$setError(F,j),Promise.reject(j)})}$onItemSelected(w){this.c?.(w)}showInput(w,E=y.CancellationToken.None){return this.d=w?.validateInput,c.$input(w,typeof this.d=="function",E).then(void 0,o=>{if(!(0,k.$2)(o))return Promise.reject(o)})}async $validateInput(w){if(!this.d)return;const E=await this.d(w);if(!E||typeof E=="string")return E;let o;switch(E.severity){case d.InputBoxValidationSeverity.Info:o=P.default.Info;break;case d.InputBoxValidationSeverity.Warning:o=P.default.Warning;break;case d.InputBoxValidationSeverity.Error:o=P.default.Error;break;default:o=E.message?P.default.Error:P.default.Ignore;break}return{content:E.message,severity:o}}async showWorkspaceFolderPick(w,E=y.CancellationToken.None){const o=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[w]);if(!o)return;const l=await this.a.getWorkspaceFolders2();if(l)return l.find(m=>m.uri.toString()===o.uri.toString())}createQuickPick(w){const E=new s(w,()=>this.e.delete(E._id));return this.e.set(E._id,E),E}createInputBox(w){const E=new v(w,()=>this.e.delete(E._id));return this.e.set(E._id,E),E}$onDidChangeValue(w,E){this.e.get(w)?._fireDidChangeValue(E)}$onDidAccept(w){this.e.get(w)?._fireDidAccept()}$onDidChangeActive(w,E){const o=this.e.get(w);o instanceof s&&o._fireDidChangeActive(E)}$onDidChangeSelection(w,E){const o=this.e.get(w);o instanceof s&&o._fireDidChangeSelection(E)}$onDidTriggerButton(w,E){this.e.get(w)?._fireDidTriggerButton(E)}$onDidTriggerItemButton(w,E,o){const l=this.e.get(w);l instanceof s&&l._fireDidTriggerItemButton(E,o)}$onDidHide(w){this.e.get(w)?._fireDidHide()}}class S{static{this.a=1}constructor(w,E){this.x=w,this.y=E,this._id=s.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new R.$ec,this.q=new R.$ec,this.r=new R.$ec,this.s=new R.$ec,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(w){this.b=w,this.z({title:w})}get step(){return this.c}set step(w){this.c=w,this.z({step:w})}get totalSteps(){return this.d}set totalSteps(w){this.d=w,this.z({totalSteps:w})}get enabled(){return this.g}set enabled(w){this.g=w,this.z({enabled:w})}get busy(){return this.j}set busy(w){this.j=w,this.z({busy:w})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(w){this.k=w,this.z({ignoreFocusOut:w})}get value(){return this.l}set value(w){this.l=w,this.z({value:w})}get placeholder(){return this.m}set placeholder(w){this.m=w,this.z({placeholder:w})}get buttons(){return this.n}set buttons(w){this.n=w.slice(),this.o.clear(),w.forEach((E,o)=>{const l=E===d.$7K.Back?-1:o;this.o.set(l,E)}),this.z({buttons:w.map((E,o)=>({...r(E.iconPath),tooltip:E.tooltip,handle:E===d.$7K.Back?-1:o}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(w){this.l=w,this.q.fire(w)}_fireDidTriggerButton(w){const E=this.o.get(w);E&&this.r.fire(E)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,I.$gb)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),c.$dispose(this._id))}z(w){if(!this.v){for(const E of Object.keys(w)){const o=w[E];this.u[E]=o===void 0?null:o}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){c.$createOrUpdate(this.u),this.u={id:this._id}}}function C($){if($ instanceof d.$GK)return{id:$.id};const w=a($),E=n($);return{dark:typeof w=="string"?A.URI.file(w):w,light:typeof E=="string"?A.URI.file(E):E}}function n($){return typeof $=="object"&&"light"in $?$.light:$}function a($){return typeof $=="object"&&"dark"in $?$.dark:$}function r($){const w=C($);let E,o;return"id"in w?o=D.ThemeIcon.asClassName(w):E=w,{iconPath:E,iconClass:o}}class s extends S{constructor(w,E){super(w.identifier,E),this.O=w,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new R.$ec,this.L=[],this.M=new R.$ec,this.N=new R.$ec,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(w){this.B=w.slice(),this.C.clear(),this.D.clear(),w.forEach((l,m)=>{this.C.set(m,l),this.D.set(l,m)});const E=(0,u.$DF)(this.O,"quickPickItemTooltip"),o=[];for(let l=0;l<w.length;l++){const m=w[l];if(m.kind===d.QuickPickItemKind.Separator)o.push({type:"separator",label:m.label});else{m.tooltip&&!E&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const F=m.iconPath?r(m.iconPath):void 0;o.push({handle:l,label:m.label,iconPath:F?.iconPath,iconClass:F?.iconClass,description:m.description,detail:m.detail,picked:m.picked,alwaysShow:m.alwaysShow,tooltip:E?b.MarkdownString.fromStrict(m.tooltip):void 0,buttons:m.buttons?.map((W,V)=>({...r(W.iconPath),tooltip:W.tooltip,handle:V}))})}}this.z({items:o})}get canSelectMany(){return this.E}set canSelectMany(w){this.E=w,this.z({canSelectMany:w})}get matchOnDescription(){return this.F}set matchOnDescription(w){this.F=w,this.z({matchOnDescription:w})}get matchOnDetail(){return this.G}set matchOnDetail(w){this.G=w,this.z({matchOnDetail:w})}get sortByLabel(){return this.H}set sortByLabel(w){this.H=w,this.z({sortByLabel:w})}get keepScrollPosition(){return this.I}set keepScrollPosition(w){this.I=w,this.z({keepScrollPosition:w})}get activeItems(){return this.J}set activeItems(w){this.J=w.filter(E=>this.D.has(E)),this.z({activeItems:this.J.map(E=>this.D.get(E))})}get selectedItems(){return this.L}set selectedItems(w){this.L=w.filter(E=>this.D.has(E)),this.z({selectedItems:this.L.map(E=>this.D.get(E))})}_fireDidChangeActive(w){const E=(0,f.$jf)(w.map(o=>this.C.get(o)));this.J=E,this.K.fire(E)}_fireDidChangeSelection(w){const E=(0,f.$jf)(w.map(o=>this.C.get(o)));this.L=E,this.M.fire(E)}_fireDidTriggerItemButton(w,E){const o=this.C.get(w);if(!o||!o.buttons||!o.buttons.length)return;const l=o.buttons[E];l&&this.N.fire({button:l,item:o})}}class v extends S{constructor(w,E){super(w.identifier,E),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(w){this.B=w,this.z({password:w})}get prompt(){return this.C}set prompt(w){this.C=w,this.z({prompt:w})}get valueSelection(){return this.D}set valueSelection(w){this.D=w,this.z({valueSelection:w})}get validationMessage(){return this.E}set validationMessage(w){this.E=w,w?typeof w=="string"?this.z({validationMessage:w,severity:P.default.Error}):this.z({validationMessage:w.message,severity:w.severity??P.default.Error}):this.z({validationMessage:void 0,severity:P.default.Ignore})}}return new g(t,i)}e.$fbc=p}),define(Pe[249],Ae([1,0,2,5,65,6,13,3,18,132,14,20,40,8,26,12]),function(pe,e,y,R,I,M,A,d,k,f,P,D,u,b,p,h){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$hbc=e.$gbc=void 0;function i(E){if(E)return typeof E.iconPath=="string"?y.URI.file(E.iconPath):y.URI.isUri(E.iconPath)||u.ThemeIcon.isThemeIcon(E.iconPath)?E.iconPath:void 0}function c(E,o){if(!E.iconPath&&!o.iconPath)return 0;if(E.iconPath){if(!o.iconPath)return 1}else return-1;const l=typeof E.iconPath=="string"?E.iconPath:y.URI.isUri(E.iconPath)?E.iconPath.fsPath:E.iconPath.id,m=typeof o.iconPath=="string"?o.iconPath:y.URI.isUri(o.iconPath)?o.iconPath.fsPath:o.iconPath.id;return(0,f.$$p)(l,m)}function g(E,o){let l=0;if(E.strikeThrough!==o.strikeThrough)return E.strikeThrough?1:-1;if(E.faded!==o.faded)return E.faded?1:-1;if(E.tooltip!==o.tooltip)return(E.tooltip||"").localeCompare(o.tooltip||"");if(l=c(E,o),l!==0)return l;if(E.light&&o.light)l=c(E.light,o.light);else{if(E.light)return 1;if(o.light)return-1}if(l!==0)return l;if(E.dark&&o.dark)l=c(E.dark,o.dark);else{if(E.dark)return 1;if(o.dark)return-1}return l}function S(E,o){if(E.command!==o.command)return E.command<o.command?-1:1;if(E.title!==o.title)return E.title<o.title?-1:1;if(E.tooltip!==o.tooltip){if(E.tooltip!==void 0&&o.tooltip!==void 0)return E.tooltip<o.tooltip?-1:1;if(E.tooltip!==void 0)return 1;if(o.tooltip!==void 0)return-1}if(E.arguments===o.arguments)return 0;if(E.arguments)if(o.arguments){if(E.arguments.length!==o.arguments.length)return E.arguments.length-o.arguments.length}else return 1;else return-1;for(let l=0;l<E.arguments.length;l++){const m=E.arguments[l],F=o.arguments[l];if(m!==F)return m<F?-1:1}return 0}function C(E,o){let l=(0,f.$$p)(E.resourceUri.fsPath,o.resourceUri.fsPath,!0);if(l!==0)return l;if(E.command&&o.command)l=S(E.command,o.command);else{if(E.command)return 1;if(o.command)return-1}if(l!==0)return l;if(E.decorations&&o.decorations)l=g(E.decorations,o.decorations);else{if(E.decorations)return 1;if(o.decorations)return-1}return l}function n(E,o){for(let l=0;l<E.length;l++)if(E[l]!==o[l])return!1;return!0}function a(E,o){return E.command===o.command&&E.title===o.title&&E.tooltip===o.tooltip&&(E.arguments&&o.arguments?n(E.arguments,o.arguments):E.arguments===o.arguments)}function r(E,o){return(0,k.$$e)(E,o,a)}class s{#e;#t;get value(){return this.d}set value(o){o=o??"",this.#e.$setInputBoxValue(this.l,o),this.n(o)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(o){this.#e.$setInputBoxPlaceholder(this.l,o),this.f=o}get validateInput(){return(0,p.$EF)(this.k,"scmValidation"),this.g}set validateInput(o){if((0,p.$EF)(this.k,"scmValidation"),o&&typeof o!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=o,this.#e.$setValidationProviderIsEnabled(this.l,!!o)}get enabled(){return this.h}set enabled(o){o=!!o,this.h!==o&&(this.h=o,this.#e.$setInputBoxEnablement(this.l,o))}get visible(){return this.j}set visible(o){o=!!o,this.j!==o&&(this.j=o,this.#e.$setInputBoxVisibility(this.l,o))}get document(){return(0,p.$EF)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(o,l,m,F,W){this.k=o,this.l=F,this.m=W,this.d="",this.e=new R.$ec,this.f="",this.h=!0,this.j=!0,this.#t=l,this.#e=m}showValidationMessage(o,l){(0,p.$EF)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,o,l)}$onInputBoxValueChange(o){this.n(o)}n(o){this.d=o,this.e.fire(o)}}e.$gbc=s;class v{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(o){this.v=o,this.q.$updateGroupLabel(this.t,this.handle,o)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(o){this.p=o,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(o){this.f=[...o],this.k.fire()}constructor(o,l,m,F,W){this.q=o,this.s=l,this.t=m,this.u=F,this.v=W,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new R.$ec,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new R.$ec,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=v.d++}getResourceState(o){return this.g.get(o)}$executeResourceCommand(o,l){const m=this.h.get(o);return m?(0,A.$ng)(()=>this.s.executeCommand(m.command,...m.arguments||[],l)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const o=[...this.f].sort(C),m=(0,k.$ff)(this.o,o,C).map(V=>{const B=V.toInsert.map(j=>{const U=this.e++;this.g.set(U,j);const z=j.resourceUri;let ne;if(j.command)if(j.command.command==="vscode.open"||j.command.command==="vscode.diff"){const ue=new M.$kb;ne=this.s.converter.toInternal(j.command,ue),this.j.set(U,ue)}else this.h.set(U,j.command);const Z=i(j.decorations),we=j.decorations&&i(j.decorations.light)||Z,Ee=j.decorations&&i(j.decorations.dark)||Z,Re=[we,Ee],X=j.decorations&&j.decorations.tooltip||"",de=j.decorations&&!!j.decorations.strikeThrough,Ce=j.decorations&&!!j.decorations.faded,ae=j.contextValue||"";return{rawResource:[U,z,Re,X,de,Ce,ae,ne],handle:U}});return{start:V.start,deleteCount:V.deleteCount,toInsert:B}}),F=m.map(({start:V,deleteCount:B,toInsert:j})=>[V,B,j.map(U=>U.rawResource)]),W=m.reverse();for(const{start:V,deleteCount:B,toInsert:j}of W){const U=j.map(ne=>ne.handle),z=this.n.splice(V,B,...U);for(const ne of z)this.g.delete(ne),this.h.delete(ne),this.j.get(ne)?.dispose(),this.j.delete(ne)}return this.o=o,F}dispose(){this.l=!0,this.m.fire()}}class ${static{this.d=0}#e;get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(o){this.g!==o&&(this.g=o,this.#e.$updateSourceControl(this.t,{count:o}))}get quickDiffProvider(){return this.h}set quickDiffProvider(o){this.h=o;let l;(0,p.$DF)(this.u,"quickDiffProvider")&&(l=o?.label),this.#e.$updateSourceControl(this.t,{hasQuickDiffProvider:!!o,quickDiffLabel:l})}get commitTemplate(){return this.j}set commitTemplate(o){o!==this.j&&(this.j=o,this.#e.$updateSourceControl(this.t,{commitTemplate:o}))}get acceptInputCommand(){return this.l}set acceptInputCommand(o){this.k.value=new M.$kb,this.l=o;const l=this.v.converter.toInternal(o,this.k.value);this.#e.$updateSourceControl(this.t,{acceptInputCommand:l})}get actionButton(){return(0,p.$EF)(this.u,"scmActionButton"),this.n}set actionButton(o){(0,p.$EF)(this.u,"scmActionButton"),this.m.value=new M.$kb,this.n=o;const l=o!==void 0?{command:this.v.converter.toInternal(o.command,this.m.value),secondaryCommands:o.secondaryCommands?.map(m=>m.map(F=>this.v.converter.toInternal(F,this.m.value))),description:o.description,enabled:o.enabled}:void 0;this.#e.$updateSourceControl(this.t,{actionButton:l??null})}get statusBarCommands(){return this.p}set statusBarCommands(o){if(this.p&&o&&r(this.p,o))return;this.o.value=new M.$kb,this.p=o;const l=(o||[]).map(m=>this.v.converter.toInternal(m,this.o.value));this.#e.$updateSourceControl(this.t,{statusBarCommands:l})}get selected(){return this.q}constructor(o,l,m,F,W,V,B){this.u=o,this.v=F,this.w=W,this.x=V,this.y=B,this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new M.$mb,this.l=void 0,this.m=new M.$mb,this.o=new M.$mb,this.p=void 0,this.q=!1,this.s=new R.$ec,this.onDidChangeSelection=this.s.event,this.t=$.d++,this.z=new Map,this.A=new Set,this.#e=m;const j=y.URI.from({scheme:h.Schemas.vscodeSourceControl,path:`${W}/scm${this.t}/input`,query:B?`rootUri=${encodeURIComponent(B.toString())}`:void 0});this.f=new s(o,l,this.#e,this.t,j),this.#e.$registerSourceControl(this.t,W,V,B,j)}createResourceGroup(o,l){const m=new v(this.#e,this.v,this.t,o,l),F=R.Event.once(m.onDidDispose)(()=>this.z.delete(m));return this.z.set(m,F),this.eventuallyAddResourceGroups(),m}eventuallyAddResourceGroups(){const o=[],l=[];for(const[m,F]of this.z){F.dispose();const W=m.onDidUpdateResourceStates(()=>{this.A.add(m),this.eventuallyUpdateResourceStates()});R.Event.once(m.onDidDispose)(()=>{this.A.delete(m),W.dispose(),this.e.delete(m.handle),this.#e.$unregisterGroup(this.t,m.handle)}),o.push([m.handle,m.id,m.label,m.features]);const V=m._takeResourceStateSnapshot();V.length>0&&l.push([m.handle,V]),this.e.set(m.handle,m)}this.#e.$registerGroups(this.t,o,l),this.z.clear()}eventuallyUpdateResourceStates(){const o=[];this.A.forEach(l=>{const m=l._takeResourceStateSnapshot();m.length!==0&&o.push([l.handle,m])}),o.length>0&&this.#e.$spliceResourceStates(this.t,o),this.A.clear()}getResourceGroup(o){return this.e.get(o)}setSelectionState(o){this.q=o,this.s.fire(o)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(o=>o.dispose()),this.#e.$unregisterSourceControl(this.t)}}Ke([(0,I.$Ug)(100)],$.prototype,"eventuallyAddResourceGroups",null),Ke([(0,I.$Ug)(100)],$.prototype,"eventuallyUpdateResourceStates",null);let w=class{static{t=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(o,l,m,F){this.l=l,this.m=m,this.n=F,this.g=new Map,this.h=new D.$Kl,this.j=new R.$ec,this.e=o.getProxy(d.$JJ.MainThreadSCM),this.f=o.getProxy(d.$JJ.MainThreadTelemetry),l.registerArgumentProcessor({processArgument:W=>{if(W&&W.$mid===3){const V=this.g.get(W.sourceControlHandle);if(!V)return W;const B=V.getResourceGroup(W.groupHandle);return B?B.getResourceState(W.handle):W}else if(W&&W.$mid===4){const V=this.g.get(W.sourceControlHandle);return V?V.getResourceGroup(W.groupHandle):W}else if(W&&W.$mid===5){const V=this.g.get(W.handle);return V||W}return W}})}createSourceControl(o,l,m,F){this.n.trace("ExtHostSCM#createSourceControl",o.identifier.value,l,m,F),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:o.identifier.value});const W=t.d++,V=new $(o,this.m,this.e,this.l,l,m,F);this.g.set(W,V);const B=this.h.get(o.identifier)||[];return B.push(V),this.h.set(o.identifier,B),V}getLastInputBox(o){this.n.trace("ExtHostSCM#getLastInputBox",o.identifier.value);const l=this.h.get(o.identifier),m=l&&l[l.length-1];return m&&m.inputBox}$provideOriginalResource(o,l,m){const F=y.URI.revive(l);this.n.trace("ExtHostSCM#$provideOriginalResource",o,F.toString());const W=this.g.get(o);return!W||!W.quickDiffProvider||!W.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$ng)(()=>W.quickDiffProvider.provideOriginalResource(F,m)).then(V=>V||null)}$onInputBoxValueChange(o,l){this.n.trace("ExtHostSCM#$onInputBoxValueChange",o);const m=this.g.get(o);return m&&m.inputBox.$onInputBoxValueChange(l),Promise.resolve(void 0)}$executeResourceCommand(o,l,m,F){this.n.trace("ExtHostSCM#$executeResourceCommand",o,l,m);const W=this.g.get(o);if(!W)return Promise.resolve(void 0);const V=W.getResourceGroup(l);return V?V.$executeResourceCommand(m,F):Promise.resolve(void 0)}$validateInput(o,l,m){this.n.trace("ExtHostSCM#$validateInput",o);const F=this.g.get(o);return!F||!F.inputBox.validateInput?Promise.resolve(void 0):(0,A.$ng)(()=>F.inputBox.validateInput(l,m)).then(W=>{if(!W)return Promise.resolve(void 0);const V=b.MarkdownString.fromStrict(W.message);return V?Promise.resolve([V,W.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(o){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",o),o!==void 0&&this.g.get(o)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=o,Promise.resolve(void 0)}};e.$hbc=w,e.$hbc=w=t=Ke([We(3,P.$Ri)],w)}),define(Pe[83],Ae([1,0,3,5,4]),function(pe,e,y,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zac=e.$Yac=void 0;class M{constructor(d){this.b=new R.$ec,this.onDidChangePassword=this.b.event,this.a=d.getProxy(y.$JJ.MainThreadSecretState)}async $onDidChangePassword(d){this.b.fire(d)}get(d,k){return this.a.$getPassword(d,k)}store(d,k,f){return this.a.$setPassword(d,k,f)}delete(d,k){return this.a.$deletePassword(d,k)}}e.$Yac=M,e.$Zac=(0,I.$ph)("IExtHostSecretState")}),define(Pe[250],Ae([1,0,3,8,2]),function(pe,e,y,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jcc=void 0;class M{static{this.a=0}constructor(d,k){this.d=k,this.c=new Map,this.b=d.getProxy(y.$JJ.MainThreadShare)}async $provideShare(d,k,f){return await this.c.get(d)?.provideShare({selection:R.Range.to(k.selection),resourceUri:I.URI.revive(k.resourceUri)},f)??void 0}registerShareProvider(d,k){const f=M.a++;return this.c.set(f,k),this.b.$registerShareProvider(f,R.DocumentSelector.from(d,this.d),k.id,k.label,k.priority),{dispose:()=>{this.b.$unregisterShareProvider(f),this.c.delete(f)}}}}e.$jcc=M}),define(Pe[251],Ae([1,0,7,3,154,6,8,16]),function(pe,e,y,R,I,M,A,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jbc=e.$ibc=void 0;class k{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new y.$HK("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new y.$HK("statusBarItem.warningForeground")]])}#e;#t;constructor(u,b,p,h,t,i=y.StatusBarAlignment.Left,c){if(this.i=!1,this.k="",this.q=new M.$kb,this.#e=u,this.#t=b,t&&h){this.c=(0,y.$kK)(h.identifier,t);const g=p.get(this.c);g&&(i=g.alignLeft?y.StatusBarAlignment.Left:y.StatusBarAlignment.Right,c=g.priority,this.j=!0,this.name=g.name,this.text=g.text,this.tooltip=g.tooltip,this.command=g.command,this.accessibilityInformation=g.accessibilityInformation)}else this.c=String(k.a++);this.e=h,this.f=t,this.g=i,this.h=this.u(c)}u(u){if((0,d.$me)(u))return u===Number.POSITIVE_INFINITY?Number.MAX_VALUE:u===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:u}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(u){this.k=u,this.v()}set name(u){this.m=u,this.v()}set tooltip(u){this.l=u,this.v()}set color(u){this.n=u,this.v()}set backgroundColor(u){u&&!k.b.has(u.id)&&(u=void 0),this.o=u,this.v()}set command(u){this.r?.fromApi!==u&&(this.p&&this.q.add(this.p),this.p=new M.$kb,typeof u=="string"?this.r={fromApi:u,internal:this.#t.toInternal({title:"",command:u},this.p)}:u?this.r={fromApi:u,internal:this.#t.toInternal(u,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(u){this.t=u,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let u;this.e?this.f?u=`${this.e.identifier.value}.${this.f}`:u=this.e.identifier.value:u=this.f;let b;this.m?b=this.m:b=(0,I.localize)(0,null,this.e.displayName||this.e.name);let p=this.n;this.o&&(p=k.b.get(this.o.id));const h=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,u,this.e?.identifier.value,b,this.k,h,this.r?.internal,p,this.o,this.g===y.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$ibc=k;class f{constructor(u){this.b=[],this.a=u.createStatusBarEntry(void 0,"status.extensionMessage",y.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,I.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(u){const b={message:u};return this.b.unshift(b),this.c(),new y.$LJ(()=>{const p=this.b.indexOf(b);p>=0&&(this.b.splice(p,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class P{constructor(u,b){this.e=new Map,this.a=u.getProxy(R.$JJ.MainThreadStatusBar),this.b=b,this.c=new f(this)}$acceptStaticEntries(u){for(const b of u)this.e.set(b.entryId,b)}createStatusBarEntry(u,b,p,h){return new k(this.a,this.b,this.e,u,b,p,h)}setStatusBarMessage(u,b){const p=this.c.setMessage(u);let h;return typeof b=="number"?h=setTimeout(()=>p.dispose(),b):typeof b<"u"&&b.then(()=>p.dispose(),()=>p.dispose()),new y.$LJ(()=>{p.dispose(),clearTimeout(h)})}}e.$jbc=P}),define(Pe[84],Ae([1,0,3,5,4]),function(pe,e,y,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nac=e.$Mac=void 0;class M{constructor(d,k){this.c=k,this.b=new R.$ec,this.onDidChangeStorage=this.b.event,this.a=d.getProxy(y.$JJ.MainThreadStorage)}registerExtensionStorageKeysToSync(d,k){this.a.$registerExtensionStorageKeysToSync(d,k)}async initializeExtensionStorage(d,k,f){const P=await this.a.$initializeExtensionStorage(d,k);let D;return P&&(D=this.d(d,k,P)),D||f}setValue(d,k,f){return this.a.$setValue(d,k,f)}$acceptValue(d,k,f){const P=this.d(d,k,f);P&&this.b.fire({shared:d,key:k,value:P})}d(d,k,f){try{return JSON.parse(f)}catch(P){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${k}, global: ${d}): ${P}`)}}}e.$Mac=M,e.$Nac=(0,I.$ph)("IExtHostStorage")}),define(Pe[85],Ae([1,0,4,27,14,62,2]),function(pe,e,y,R,I,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tac=e.$Sac=void 0,e.$Sac=(0,y.$ph)("IExtensionStoragePaths");let d=class{constructor(f,P,D){this.d=P,this.f=D,this.a=f.workspace??void 0,this.b=f.environment,this.whenReady=this.h().then(u=>this.c=u)}async g(f){return A.URI.joinPath(this.b.workspaceStorageHome,f)}async h(){if(!this.a)return Promise.resolve(void 0);const f=this.a.id,P=await this.g(f);try{return await this.f.value.stat(P),this.d.trace("[ExtHostStorage] storage dir already exists",P),P}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",P),await this.f.value.createDirectory(P),await this.f.value.writeFile(A.URI.joinPath(P,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),P}catch(D){this.d.error("[ExtHostStorage]",D);return}}workspaceValue(f){if(this.c)return A.URI.joinPath(this.c,f.identifier.value)}globalValue(f){return A.URI.joinPath(this.b.globalStorageHome,f.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Tac=d,e.$Tac=d=Ke([We(0,R.$2L),We(1,I.$Ri),We(2,M.$Rac)],d)}),define(Pe[63],Ae([1,0,5,3,4,2,17,6,7,156,9,182,21,36,183,40,13,8,31]),function(pe,e,y,R,I,M,A,d,k,f,P,D,u,b,p,h,t,i,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xac=e.$Wac=e.$Vac=e.$Uac=void 0,e.$Uac=(0,I.$ph)("IExtHostTerminalService");class g{constructor(o,l,m,F){this.k=o,this._id=l,this.l=m,this.m=F,this.a=!1,this.i={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(V=>this.f=V);const W=this;this.value={get name(){return W.m||""},get processId(){return W.b},get creationOptions(){return W.l},get exitStatus(){return W.h},get state(){return W.i},get selection(){return W.j},sendText(V,B=!0){W.o(),W.k.$sendText(W._id,V,B)},show(V){W.o(),W.k.$show(W._id,V)},hide(){W.o(),W.k.$hide(W._id)},dispose(){W.a||(W.a=!0,W.k.$dispose(W._id))},get dimensions(){if(!(W.d===void 0||W.g===void 0))return{columns:W.d,rows:W.g}}}}async create(o,l){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:o.name,shellPath:o.shellPath??void 0,shellArgs:o.shellArgs??void 0,cwd:o.cwd??void 0,env:o.env??void 0,icon:v(o.iconPath)??void 0,color:h.ThemeColor.isThemeColor(o.color)?o.color.id:void 0,initialText:o.message??void 0,strictEnv:o.strictEnv??void 0,hideFromUser:o.hideFromUser??void 0,isFeatureTerminal:l?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:l?.useShellEnvironment??void 0,location:l?.location||this.n(o.location,l?.resolvedExtHostIdentifier),isTransient:o.isTransient??void 0})}async createExtensionTerminal(o,l,m,F){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:m,color:h.ThemeColor.isThemeColor(F)?F.id:void 0,location:this.n(o,l),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(o,l){return typeof o=="object"?"parentTerminal"in o&&o.parentTerminal&&l?{parentTerminal:l}:"viewColumn"in o?{viewColumn:i.ViewColumn.from(o.viewColumn),preserveFocus:o.preserveFocus}:void 0:o}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(o){this.m=o}setExitStatus(o,l){this.h=Object.freeze({code:o,reason:l})}setDimensions(o,l){return o===this.d&&l===this.g||o===0||l===0?!1:(this.d=o,this.g=l,!0)}setInteractedWith(){return this.i.isInteractedWith?!1:(this.i={isInteractedWith:!0},!0)}setSelection(o){this.j=o}_setProcessId(o){this.f?(this.f(o),this.f=void 0):this.b.then(l=>{l!==o&&(this.b=Promise.resolve(o))})}}e.$Vac=g;class S{get onProcessReady(){return this.b.event}constructor(o){this.g=o,this.id=0,this.shouldPersist=!1,this.a=new y.$ec,this.onProcessData=this.a.event,this.b=new y.$ec,this.d=new y.$ec,this.onDidChangeProperty=this.d.event,this.f=new y.$ec,this.onProcessExit=this.f.event}refreshProperty(o){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${o}`)}updateProperty(o,l){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${o}, value: ${l}`)}async start(){}shutdown(){this.g.close()}input(o){this.g.handleInput?.(o)}resize(o,l){this.g.setDimensions?.({columns:o,rows:l})}clearBuffer(){}async processBinary(o){}acknowledgeDataEvent(o){}async setUnicodeVersion(o){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(o){this.g.onDidWrite(l=>this.a.fire(l)),this.g.onDidClose?.((l=void 0)=>{this.f.fire(l===void 0?void 0:l)}),this.g.onDidOverrideDimensions?.(l=>{l&&this.d.fire({type:"overrideDimensions",value:{cols:l.columns,rows:l.rows}})}),this.g.onDidChangeName?.(l=>{this.d.fire({type:"title",value:l})}),this.g.open(o||void 0),o&&this.g.setDimensions?.(o),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let C=1,n=class extends d.$lb{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(o=>o.value)}constructor(o,l,m){super(),this.M=l,this.f=[],this.g=new Map,this.h={},this.i={},this.j={},this.k=new Map,this.n=this.B(new d.$mb),this.u=new Set,this.v=new Map,this.w=new Map,this.y=new Map,this.z=new Map,this.C=new y.$ec,this.onDidCloseTerminal=this.C.event,this.D=new y.$ec,this.onDidOpenTerminal=this.D.event,this.F=new y.$ec,this.onDidChangeActiveTerminal=this.F.event,this.G=new y.$ec,this.onDidChangeTerminalDimensions=this.G.event,this.H=new y.$ec,this.onDidChangeTerminalState=this.H.event,this.I=new y.$ec,this.onDidChangeShell=this.I.event,this.J=new y.$ec({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.J.event,this.L=new y.$ec({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.L.event,this.a=m.getProxy(R.$JJ.MainThreadTerminalService),this.s=new p.$dkb(this.a.$sendProcessData),this.a.$registerProcessSupport(o),this.B({dispose:()=>{for(const[F,W]of this.g)W.shutdown(!0)}})}getDefaultShell(o){return(o?this.m:this.l)?.path||""}getDefaultShellArgs(o){return(o?this.m:this.l)?.args||[]}createExtensionTerminal(o,l){const m=new g(this.a,(0,b.$3e)(),o,o.name),F=new S(o.pty);return m.createExtensionTerminal(o.location,this.N(o,l).resolvedExtHostIdentifier,v(o.iconPath),$(o.color)).then(W=>{const V=this.O(W,F);this.h[W]=V}),this.f.push(m),m.value}N(o,l){if(l=l||{},o.location&&typeof o.location=="object"&&"parentTerminal"in o.location){const m=o.location.parentTerminal;if(m){const F=this.f.find(W=>W.value===m);F&&(l.resolvedExtHostIdentifier=F._id)}}else o.location&&typeof o.location!="object"?l.location=o.location:l.location&&typeof l.location=="object"&&"splitActiveTerminal"in l.location&&(l.location={splitActiveTerminal:!0});return l}attachPtyToTerminal(o,l){if(!this.Q(o))throw new Error(`Cannot resolve terminal with id ${o} for virtual process`);const F=new S(l),W=this.O(o,F);this.h[o]=W}async $acceptActiveTerminalChanged(o){const l=this.b;if(o===null){this.b=void 0,l!==this.b&&this.F.fire(this.b);return}const m=this.Q(o);m&&(this.b=m,l!==this.b&&this.F.fire(this.b.value))}async $acceptTerminalProcessData(o,l){const m=this.Q(o);m&&this.J.fire({terminal:m.value,data:l})}async $acceptTerminalDimensions(o,l,m){const F=this.Q(o);F&&F.setDimensions(l,m)&&this.G.fire({terminal:F.value,dimensions:F.value.dimensions})}async $acceptDidExecuteCommand(o,l){const m=this.Q(o);m&&this.L.fire({terminal:m.value,...l})}async $acceptTerminalMaximumDimensions(o,l,m){this.g.get(o)?.resize(l,m)}async $acceptTerminalTitleChange(o,l){const m=this.Q(o);m&&(m.name=l)}async $acceptTerminalClosed(o,l,m){const F=this.S(this.f,o);if(F!==null){const W=this.f.splice(F,1)[0];W.setExitStatus(l,m),this.C.fire(W.value)}}$acceptTerminalOpened(o,l,m,F){if(l){const B=this.S(this.f,l);if(B!==null){this.f[B]._id=o,this.D.fire(this.terminals[B]),this.f[B].isOpen=!0;return}}const W={name:F.name,shellPath:F.executable,shellArgs:F.args,cwd:typeof F.cwd=="string"?F.cwd:M.URI.revive(F.cwd),env:F.env,hideFromUser:F.hideFromUser},V=new g(this.a,o,W,m);this.f.push(V),this.D.fire(V.value),V.isOpen=!0}async $acceptTerminalProcessId(o,l){this.Q(o)?._setProcessId(l)}async $startExtensionTerminal(o,l){const m=this.Q(o);if(!m)return{message:(0,f.localize)(0,null,o)};m.isOpen||await new Promise(W=>{const V=this.onDidOpenTerminal(async B=>{B===m.value&&(V.dispose(),W())})});const F=this.g.get(o);F?F.startSendingEvents(l):this.i[o]={initialDimensions:l}}O(o,l){const m=new d.$kb;m.add(l.onProcessReady(W=>this.a.$sendProcessReady(o,W.pid,W.cwd,W.windowsPty))),m.add(l.onDidChangeProperty(W=>this.a.$sendProcessProperty(o,W))),this.s.startBuffering(o,l.onProcessData),m.add(l.onProcessExit(W=>this.P(o,W))),this.g.set(o,l);const F=this.i[o];return F&&l instanceof S&&(l.startSendingEvents(F.initialDimensions),delete this.i[o]),m}$acceptProcessAckDataEvent(o,l){this.g.get(o)?.acknowledgeDataEvent(l)}$acceptProcessInput(o,l){this.g.get(o)?.input(l)}$acceptTerminalInteraction(o){const l=this.Q(o);l?.setInteractedWith()&&this.H.fire(l.value)}$acceptTerminalSelection(o,l){this.Q(o)?.setSelection(l)}$acceptProcessResize(o,l,m){try{this.g.get(o)?.resize(l,m)}catch(F){if(F.code!=="EPIPE"&&F.code!=="ERR_IPC_CHANNEL_CLOSED")throw F}}$acceptProcessShutdown(o,l){this.g.get(o)?.shutdown(l)}$acceptProcessRequestInitialCwd(o){this.g.get(o)?.getInitialCwd().then(l=>this.a.$sendProcessProperty(o,{type:"initialCwd",value:l}))}$acceptProcessRequestCwd(o){this.g.get(o)?.getCwd().then(l=>this.a.$sendProcessProperty(o,{type:"cwd",value:l}))}$acceptProcessRequestLatency(o){return Promise.resolve(o)}registerLinkProvider(o){return this.u.add(o),this.u.size===1&&this.a.$startLinkProvider(),new k.$LJ(()=>{this.u.delete(o),this.u.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(o,l,m){if(this.v.has(l))throw new Error(`Terminal profile provider "${l}" already registered`);return this.v.set(l,m),this.a.$registerProfileProvider(l,o.identifier.value),new k.$LJ(()=>{this.v.delete(l),this.a.$unregisterProfileProvider(l)})}registerTerminalQuickFixProvider(o,l,m){if(this.w.has(o))throw new Error(`Terminal quick fix provider "${o}" is already registered`);return this.w.set(o,m),this.a.$registerQuickFixProvider(o,l),new k.$LJ(()=>{this.w.delete(o),this.a.$unregisterQuickFixProvider(o)})}async $provideTerminalQuickFixes(o,l){const m=new u.$oc().token;if(m.isCancellationRequested)return;const F=this.w.get(o);if(!F)return;const W=await F.provideTerminalQuickFixes(l,m);if(W===null||Array.isArray(W)&&W.length===0)return;const V=new d.$kb;if(this.n.value=V,!Array.isArray(W))return W?i.TerminalQuickFix.from(W,this.M.converter,V):void 0;const B=[];for(const j of W){const U=i.TerminalQuickFix.from(j,this.M.converter,V);U&&B.push(U)}return B}async $createContributedProfileTerminal(o,l){const m=new u.$oc().token;let F=await this.v.get(o)?.provideTerminalProfile(m);if(!m.isCancellationRequested){if(F&&!("options"in F)&&(F={options:F}),!F||!("options"in F))throw new Error(`No terminal profile options provided for id "${o}"`);if("pty"in F.options){this.createExtensionTerminal(F.options,l);return}this.createTerminalFromOptions(F.options,l)}}async $provideLinks(o,l){const m=this.Q(o);if(!m)return[];this.y.delete(o),this.z.get(o)?.dispose(!0);const W=new u.$oc;this.z.set(o,W);const V=[],B={terminal:m.value,line:l},j=[];for(const ne of this.u)j.push(t.Promises.withAsyncBody(async Z=>{W.token.onCancellationRequested(()=>Z({provider:ne,links:[]}));const we=await ne.provideTerminalLinks(B,W.token)||[];W.token.isCancellationRequested||Z({provider:ne,links:we})}));const U=await Promise.all(j);if(W.token.isCancellationRequested)return[];const z=new Map;for(const ne of U)ne&&ne.links.length>0&&V.push(...ne.links.map(Z=>{const we={id:C++,startIndex:Z.startIndex,length:Z.length,label:Z.tooltip};return z.set(we.id,{provider:ne.provider,link:Z}),we}));return this.y.set(o,z),V}$activateLink(o,l){const m=this.y.get(o)?.get(l);m&&m.provider.handleTerminalLink(m.link)}P(o,l){this.s.stopBuffering(o),this.g.delete(o),delete this.i[o];const m=this.h[o];m&&(m.dispose(),delete this.h[o]),this.a.$sendProcessExit(o,l)}Q(o){return this.R(this.f,o)}R(o,l){const m=this.S(o,l);return m!==null?o[m]:null}S(o,l){const m=o.findIndex(F=>F._id===l);return m===-1?null:m}getEnvironmentVariableCollection(o){let l=this.k.get(o.identifier.value);return l||(l=new a,this.W(o.identifier.value,l)),l.getScopedEnvironmentVariableCollection(void 0)}U(o,l){const m=(0,D.$4q)(l.map),F=(0,D.$5q)(l.descriptionMap);this.a.$setEnvironmentVariableCollection(o,l.persistent,m.length===0?void 0:m,F)}$initEnvironmentVariableCollections(o){o.forEach(l=>{const m=l[0],F=new a(l[1]);this.W(m,F)})}$acceptDefaultProfile(o,l){const m=this.l;this.l=o,this.m=l,m?.path!==o.path&&this.I.fire(o.path)}W(o,l){this.k.set(o,l),l.onDidChangeCollection(()=>{this.U(o,l)})}};e.$Wac=n,e.$Wac=n=Ke([We(1,c.$8L),We(2,A.$LL)],n);class a{get persistent(){return this.b}set persistent(o){this.b=o,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(o){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new y.$ec,this.map=new Map(o)}getScopedEnvironmentVariableCollection(o){const l=this.h(o);let m=this.a.get(l);return m||(m=new r(this,o),this.a.set(l,m),m.onDidChangeCollection(()=>this.d.fire())),m}replace(o,l,m,F){this.f(o,{value:l,type:k.EnvironmentVariableMutatorType.Replace,options:m??{applyAtProcessCreation:!0},scope:F})}append(o,l,m,F){this.f(o,{value:l,type:k.EnvironmentVariableMutatorType.Append,options:m??{applyAtProcessCreation:!0},scope:F})}prepend(o,l,m,F){this.f(o,{value:l,type:k.EnvironmentVariableMutatorType.Prepend,options:m??{applyAtProcessCreation:!0},scope:F})}f(o,l){if(l.options&&l.options.applyAtProcessCreation===!1&&!l.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const m=this.g(o,l.scope),F=this.map.get(m),W=l.options?{applyAtProcessCreation:l.options.applyAtProcessCreation??!1,applyAtShellIntegration:l.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!F||F.value!==l.value||F.type!==l.type||F.options?.applyAtProcessCreation!==W.applyAtProcessCreation||F.options?.applyAtShellIntegration!==W.applyAtShellIntegration||F.scope?.workspaceFolder?.index!==l.scope?.workspaceFolder?.index){const V=this.g(o,l.scope),B={variable:o,...l,options:W};this.map.set(V,B),this.d.fire()}}get(o,l){const m=this.g(o,l),F=this.map.get(m);return F?w(F):void 0}g(o,l){const m=this.h(l);return m.length?`${o}:::${m}`:o}h(o){return this.i(o?.workspaceFolder)??""}i(o){return o?o.uri.toString():void 0}getVariableMap(o){const l=new Map;for(const[m,F]of this.map)this.h(F.scope)===this.h(o)&&l.set(F.variable,w(F));return l}delete(o,l){const m=this.g(o,l);this.map.delete(m),this.d.fire()}clear(o){if(o?.workspaceFolder){for(const[l,m]of this.map)m.scope?.workspaceFolder?.index===o.workspaceFolder.index&&this.map.delete(l);this.j(o)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(o,l){const m=this.h(l),F=this.descriptionMap.get(m);if(!F||F.description!==o){let W;typeof o=="string"?W=o:W=o?.value.split(`

`)[0];const V={description:W,scope:l};this.descriptionMap.set(m,V),this.d.fire()}}getDescription(o){const l=this.h(o);return this.descriptionMap.get(l)?.description}j(o){const l=this.h(o);this.descriptionMap.delete(l)}}class r{get persistent(){return this.b.persistent}set persistent(o){this.b.persistent=o}get onDidChangeCollection(){return this.a&&this.a.event}constructor(o,l){this.b=o,this.d=l,this.a=new y.$ec}getScoped(o){return this.b.getScopedEnvironmentVariableCollection(o)}replace(o,l,m){this.b.replace(o,l,m,this.d)}append(o,l,m){this.b.append(o,l,m,this.d)}prepend(o,l,m){this.b.prepend(o,l,m,this.d)}get(o){return this.b.get(o,this.d)}forEach(o,l){this.b.getVariableMap(this.d).forEach((m,F)=>o.call(l,F,m,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(o){this.b.delete(o,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(o){this.b.setDescription(o,this.d)}get description(){return this.b.getDescription(this.d)}}let s=class extends n{constructor(o,l){super(!1,o,l)}createTerminal(o,l,m){throw new P.$$}createTerminalFromOptions(o,l){throw new P.$$}};e.$Xac=s,e.$Xac=s=Ke([We(0,c.$8L),We(1,A.$LL)],s);function v(E){if(!(!E||typeof E=="string"))return"id"in E?{id:E.id,color:E.color}:E}function $(E){return h.ThemeColor.isThemeColor(E)?E:void 0}function w(E){const o={...E};return delete o.scope,o.options=o.options??void 0,delete o.variable,o}}),define(Pe[252],Ae([1,0,18,13,25,21,5,203,93,6,24,16,36,3,17,105,8,7,45,76,57,26]),function(pe,e,y,R,I,M,A,d,k,f,P,D,u,b,p,h,t,i,c,g,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8bc=e.$7bc=e.$6bc=e.$5bc=void 0;let n=class{constructor(B,j,U){this.k=U,this.d=new A.$ec,this.f=new Map,this.onResultsChanged=this.d.event,this.results=[],this.g=B.getProxy(b.$JJ.MainThreadTesting),this.j=new m(this.g),this.h=new v(this.g),j.registerArgumentProcessor({processArgument:z=>{switch(z?.$mid){case 15:{const ne=z,Z=ne.tests[ne.tests.length-1].item.extId;return this.f.get(c.$wI.root(Z))?.collection.tree.get(Z)?.actual??(0,h.$XL)(z)}case 17:{const{extId:ne,message:Z}=z;return{test:this.f.get(c.$wI.root(ne))?.collection.tree.get(ne)?.actual,message:t.TestMessage.to(Z)}}default:return z}}}),j.registerCommand(!1,"testing.getExplorerSelection",async()=>{const z=await j.executeCommand("_testing.getExplorerSelection"),ne=Z=>{const we=this.f.get(c.$wI.root(Z));if(we)return c.$wI.isRoot(Z)?we.controller:we.collection.tree.get(Z)?.actual};return{include:z?.include.map(ne).filter(D.$qe)||[],exclude:z?.exclude.map(ne).filter(D.$qe)||[]}})}createTestController(B,j,U,z){if(this.f.has(j))throw new Error(`Attempt to insert a duplicate controller with ID "${j}"`);const ne=new f.$kb,Z=ne.add(new h.$1L(j,U,this.k));Z.root.label=U;const we=new Map,Ee=this.g,Re={items:Z.root.children,get label(){return U},set label(de){U=de,Z.root.label=de,Ee.$updateController(j,{label:U})},get refreshHandler(){return z},set refreshHandler(de){z=de,Ee.$updateController(j,{canRefresh:!!de})},get id(){return j},createRunProfile:(de,Ce,ae,_,ue,O)=>{let J=(0,k.$di)(de);for(;we.has(J);)J++;return new F(this.g,we,j,J,de,Ce,ae,_,ue,O)},createTestItem(de,Ce,ae){return new h.$YL(j,de,Ce,ae)},createTestRun:(de,Ce,ae=!0)=>this.h.createTestRun(B,j,Z,de,Ce,ae),invalidateTestResults:de=>{if(de===void 0)this.g.$markTestRetired(void 0);else{const Ce=de instanceof Array?de:[de];this.g.$markTestRetired(Ce.map(ae=>c.$wI.fromExtHostTestItem(ae,j).toString()))}},set resolveHandler(de){Z.resolveHandler=de},get resolveHandler(){return Z.resolveHandler},dispose:()=>{ne.dispose()}};Ee.$registerTestController(j,U,!!z),ne.add((0,f.$jb)(()=>Ee.$unregisterTestController(j)));const X={controller:Re,collection:Z,profiles:we,extension:B};return this.f.set(j,X),ne.add((0,f.$jb)(()=>this.f.delete(j))),ne.add(Z.onDidGenerateDiff(de=>Ee.$publishDiff(j,de.map(S.TestsDiffOp.serialize)))),Re}createTestObserver(){return this.j.checkout()}async runTests(B,j=M.CancellationToken.None){const U=$(B);if(!U)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const z=this.f.get(U.controllerId);if(!z)throw new Error("Controller not found");await this.g.$runTests({isUiTriggered:!1,targets:[{testIds:B.include?.map(ne=>c.$wI.fromExtHostTestItem(ne,z.collection.root.id).toString())??[z.collection.root.id],profileGroup:W[U.kind],profileId:U.profileId,controllerId:U.controllerId}],exclude:B.exclude?.map(ne=>ne.id)},j)}$syncTests(){for(const{collection:B}of this.f.values())B.flushDiff();return Promise.resolve()}$provideFileCoverage(B,j,U){return(0,y.$If)(this.h.trackers,ne=>ne.id===B?ne.getCoverage(j):void 0)?.provideFileCoverage(U)??Promise.resolve([])}$resolveFileCoverage(B,j,U,z){return(0,y.$If)(this.h.trackers,Z=>Z.id===B?Z.getCoverage(j):void 0)?.resolveFileCoverage(U,z)??Promise.resolve([])}$configureRunProfile(B,j){this.f.get(B)?.profiles.get(j)?.configureHandler?.()}async $refreshTests(B,j){await this.f.get(B)?.controller.refreshHandler?.(j)}$publishTestResults(B){this.results=Object.freeze(B.map(j=>(0,P.$Jm)(t.TestResults.to(j))).concat(this.results).sort((j,U)=>U.completedAt-j.completedAt).slice(0,32)),this.d.fire()}async $expandTest(B,j){const U=this.f.get(c.$wI.fromString(B).controllerId)?.collection;U&&(await U.expand(B,j<0?1/0:j),U.flushDiff())}$acceptDiff(B){this.j.applyDiff(B.map(S.TestsDiffOp.deserialize))}async $runControllerTests(B,j){return Promise.all(B.map(U=>this.l(U,!1,j)))}async $startContinuousRun(B,j){const U=new M.$oc(j),z=await Promise.all(B.map(ne=>this.l(ne,!0,U.token)));return!j.isCancellationRequested&&!z.some(ne=>ne.error)&&await new Promise(ne=>j.onCancellationRequested(ne)),U.dispose(!0),z}async l(B,j,U){const z=this.f.get(B.controllerId);if(!z)return{};const{collection:ne,profiles:Z,extension:we}=z,Ee=Z.get(B.profileId);if(!Ee)return{};const Re=B.testIds.map(ae=>ne.tree.get(ae)).filter(D.$qe),X=B.excludeExtIds.map(ae=>z.collection.tree.get(ae)).filter(D.$qe).filter(ae=>Re.some(_=>_.fullId.compare(ae.fullId)===2));if(!Re.length)return{};const de=new i.$iL(Re.some(ae=>ae.actual instanceof h.$ZL)?void 0:Re.map(ae=>ae.actual),X.map(ae=>ae.actual),Ee,j),Ce=(0,S.$yI)(B)&&this.h.prepareForMainThreadTestRun(de,w.fromInternal(B,z.collection),we,U);try{return await Ee.runHandler(de,U),{}}catch(ae){return{error:String(ae)}}finally{Ce&&(Ce.hasRunningTasks&&!U.isCancellationRequested&&await A.Event.toPromise(Ce.onEnd),Ce.dispose())}}$cancelExtensionTestRun(B){B===void 0?this.h.cancelAllRuns():this.h.cancelRunById(B)}};e.$5bc=n,e.$5bc=n=Ke([We(0,p.$LL)],n);const a=1e4;var r;(function(V){V[V.Running=0]="Running",V[V.Cancelling=1]="Cancelling",V[V.Ended=2]="Ended"})(r||(r={}));class s extends f.$lb{get hasRunningTasks(){return this.g.size>0}get id(){return this.l.id}constructor(B,j,U,z){super(),this.l=B,this.m=j,this.p=U,this.f=0,this.g=new Map,this.h=new Set,this.k=this.B(new A.$ec),this.onEnd=this.k.event,this.j=this.B(new M.$oc(z));const ne=this.B(new R.$Gg(()=>this.s(),a));this.B(this.j.token.onCancellationRequested(()=>ne.schedule()))}cancel(){this.f===0?(this.j.cancel(),this.f=1):this.f===1&&this.s()}getCoverage(B){return this.g.get(B)?.coverage}createRun(B){const j=this.l.id,U=this.l.controllerId,z=(0,u.$3e)(),ne=new E(this.m,j,z),Z=X=>(de,...Ce)=>{if(Ee){console.warn(`Setting the state of test "${de.id}" is a no-op after the run ends.`);return}this.l.isIncluded(de)&&(this.v(de),X(de,...Ce))},we=(X,de)=>{const Ce=de instanceof Array?de.map(t.TestMessage.from):[t.TestMessage.from(de)];if(Ce.some(ae=>ae.contextValue!==void 0)&&(0,C.$EF)(this.p,"testMessageContextValue"),X.uri&&X.range){const ae={range:t.Range.from(X.range),uri:X.uri};for(const _ of Ce)_.location=_.location||ae}this.m.$appendTestMessagesInRun(j,z,c.$wI.fromExtHostTestItem(X,U).toString(),Ce)};let Ee=!1;const Re={isPersisted:this.l.isPersisted,token:this.j.token,name:B,get coverageProvider(){return ne.coverageProvider},set coverageProvider(X){ne.coverageProvider=X},enqueued:Z(X=>{this.m.$updateTestStateInRun(j,z,c.$wI.fromExtHostTestItem(X,U).toString(),1)}),skipped:Z(X=>{this.m.$updateTestStateInRun(j,z,c.$wI.fromExtHostTestItem(X,U).toString(),5)}),started:Z(X=>{this.m.$updateTestStateInRun(j,z,c.$wI.fromExtHostTestItem(X,U).toString(),2)}),errored:Z((X,de,Ce)=>{we(X,de),this.m.$updateTestStateInRun(j,z,c.$wI.fromExtHostTestItem(X,U).toString(),6,Ce)}),failed:Z((X,de,Ce)=>{we(X,de),this.m.$updateTestStateInRun(j,z,c.$wI.fromExtHostTestItem(X,U).toString(),4,Ce)}),passed:Z((X,de)=>{this.m.$updateTestStateInRun(j,z,c.$wI.fromExtHostTestItem(X,this.l.controllerId).toString(),3,de)}),appendOutput:(X,de,Ce)=>{Ee||(Ce&&(this.l.isIncluded(Ce)?this.v(Ce):Ce=void 0),this.m.$appendOutputToRun(j,z,I.$Ec.fromString(X),de&&t.location.from(de),Ce&&c.$wI.fromExtHostTestItem(Ce,U).toString()))},end:()=>{Ee||(Ee=!0,this.m.$finishedTestRunTask(j,z),this.g.delete(z),this.g.size||this.u())}};return this.g.set(z,{run:Re,coverage:ne}),this.m.$startedTestRunTask(j,{id:z,name:B,running:!0}),Re}s(){for(const{run:B}of this.g.values())B.end()}u(){this.f!==2&&(this.f=2,this.k.fire())}v(B){if(!(B instanceof h.$YL))throw new g.$DL(B.id);if(this.h.has(c.$wI.fromExtHostTestItem(B,this.l.controllerId).toString()))return;const j=[],U=this.l.colllection.root;for(;;){const z=t.TestItem.from(B);if(j.unshift(z),this.h.has(z.extId)||(this.h.add(z.extId),B===U))break;B=B.parent||U}this.m.$addTestsToRun(this.l.controllerId,this.l.id,j)}}class v{get trackers(){return this.d.values()}constructor(B){this.f=B,this.d=new Map}prepareForMainThreadTestRun(B,j,U,z){return this.g(B,j,U,z)}cancelRunById(B){for(const j of this.d.values())if(j.id===B){j.cancel();return}}cancelAllRuns(){for(const B of this.d.values())B.cancel()}createTestRun(B,j,U,z,ne,Z){const we=this.d.get(z);if(we)return we.createRun(ne);const Ee=w.fromPublic(j,U,z,Z),Re=$(z);this.f.$startedExtensionTestRun({controllerId:j,continuous:!!z.continuous,profile:Re&&{group:W[Re.kind],id:Re.profileId},exclude:z.exclude?.map(de=>c.$wI.fromExtHostTestItem(de,U.root.id).toString())??[],id:Ee.id,include:z.include?.map(de=>c.$wI.fromExtHostTestItem(de,U.root.id).toString())??[U.root.id],persist:Z});const X=this.g(z,Ee,B);return X.onEnd(()=>{this.f.$finishedExtensionTestRun(Ee.id),X.dispose()}),X.createRun(ne)}g(B,j,U,z){const ne=new s(j,this.f,U,z);return this.d.set(B,ne),ne.onEnd(()=>this.d.delete(B)),ne}}e.$6bc=v;const $=V=>{if(V.profile){if(!(V.profile instanceof F))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return V.profile}};class w{static fromPublic(B,j,U,z){return new w(B,(0,u.$3e)(),U.include?.map(ne=>c.$wI.fromExtHostTestItem(ne,B).toString())??[B],U.exclude?.map(ne=>c.$wI.fromExtHostTestItem(ne,B).toString())??[],z,j)}static fromInternal(B,j){return new w(B.controllerId,B.runId,B.testIds,B.excludeExtIds,!0,j)}constructor(B,j,U,z,ne,Z){this.controllerId=B,this.id=j,this.isPersisted=ne,this.colllection=Z,this.d=U.map(we=>we+"\0"),this.f=z.map(we=>we+"\0")}isIncluded(B){const j=c.$wI.fromExtHostTestItem(B,this.controllerId).toString()+"\0";for(const U of this.f)if(j===U||j.startsWith(U))return!1;for(const U of this.d)if(j===U||j.startsWith(U))return!0;return!1}}e.$7bc=w;class E{set coverageProvider(B){if(this.d)throw new Error("The TestCoverageProvider cannot be replaced after being provided");B&&(this.d=B,this.g.$signalCoverageAvailable(this.h,this.j))}get coverageProvider(){return this.d}constructor(B,j,U){this.g=B,this.h=j,this.j=U}async provideFileCoverage(B){if(!this.d)return[];this.f||(this.f=(async()=>this.d.provideFileCoverage(B))());try{return(await this.f)?.map(t.TestCoverage.fromFile)??[]}catch(j){throw this.f=void 0,j}}async resolveFileCoverage(B,j){const U=await this.f;let z=U?.[B];return!this.d||!U||!z?[]:(z.detailedCoverage||(z=U[B]=await this.d.resolveFileCoverage?.(z,j)??z),z.detailedCoverage?.map(t.TestCoverage.fromDetailed)??[])}}class o{get isEmpty(){return this.d.size===0&&this.g.size===0&&this.f.size===0}constructor(B){this.j=B,this.d=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(B){this.d.add(B)}update(B){Object.assign(B.revived,t.TestItem.toPlain(B.item)),this.d.has(B)||this.f.add(B)}remove(B){if(this.d.has(B)){this.d.delete(B);return}this.f.delete(B);const j=c.$wI.parentId(B.item.extId);if(j&&this.h.has(j.toString())){this.h.add(B.item.extId);return}this.g.add(B)}getChangeEvent(){const{d:B,f:j,g:U}=this;return{get added(){return[...B].map(z=>z.revived)},get updated(){return[...j].map(z=>z.revived)},get removed(){return[...U].map(z=>z.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class l extends S.$DI{constructor(){super(...arguments),this.s=new A.$ec,this.onDidChangeTests=this.s.event}get rootTests(){return super.g}getMirroredTestDataById(B){return this.f.get(B)}getMirroredTestDataByReference(B){return this.f.get(B.id)}q(B,j){return{...B,revived:t.TestItem.toPlain(B.item),depth:j?j.depth+1:0,children:new Set}}p(){return new o(this.s)}}class m{constructor(B){this.f=B}checkout(){this.d||(this.d=this.g());const B=this.d;return B.observers++,{onDidChangeTest:B.tests.onDidChangeTests,get tests(){return[...B.tests.rootTests].map(j=>j.revived)},dispose:(0,d.$cb)(()=>{--B.observers===0&&(this.f.$unsubscribeFromDiffs(),this.d=void 0)})}}getMirroredTestDataByReference(B){return this.d?.tests.getMirroredTestDataByReference(B)}applyDiff(B){this.d?.tests.apply(B)}g(){const B=new l;return this.f.$subscribeToDiffs(),{observers:0,tests:B}}}class F{#e;#t;get label(){return this.f}set label(B){B!==this.f&&(this.f=B,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:B}))}get supportsContinuousRun(){return this.h}set supportsContinuousRun(B){B!==this.h&&(this.h=B,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:B}))}get isDefault(){return this.g}set isDefault(B){B!==this.g&&(this.g=B,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:B}))}get tag(){return this._tag}set tag(B){B?.id!==this._tag?.id&&(this._tag=B,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:B?t.TestTag.namespace(this.controllerId,B.id):null}))}get configureHandler(){return this.d}set configureHandler(B){B!==this.d&&(this.d=B,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!B}))}constructor(B,j,U,z,ne,Z,we,Ee=!1,Re=void 0,X=!1){this.controllerId=U,this.profileId=z,this.f=ne,this.kind=Z,this.runHandler=we,this.g=Ee,this._tag=Re,this.h=X,this.#e=B,this.#t=j,j.set(z,this);const de=W[Z];if(typeof de!="number")throw new Error(`Unknown TestRunProfile.group ${Z}`);this.#e.$publishTestRunProfile({profileId:z,controllerId:U,tag:Re?t.TestTag.namespace(this.controllerId,Re.id):null,label:ne,group:de,isDefault:Ee,hasConfigurationHandler:!1,supportsContinuousRun:X})}dispose(){this.#t?.delete(this.profileId)&&(this.#t=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$8bc=F;const W={[i.TestRunProfileKind.Coverage]:8,[i.TestRunProfileKind.Debug]:4,[i.TestRunProfileKind.Run]:2}}),define(Pe[253],Ae([1,0,18,9,5,3,106,8,7]),function(pe,e,y,R,I,M,A,d,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kbc=void 0;class f{constructor(D,u){this.i=u,this.a=new I.$ec({onListenerError:R.$Z}),this.b=new I.$ec({onListenerError:R.$Z}),this.c=new I.$ec({onListenerError:R.$Z}),this.d=new I.$ec({onListenerError:R.$Z}),this.f=new I.$ec({onListenerError:R.$Z}),this.g=new I.$ec({onListenerError:R.$Z}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=D.getProxy(M.$JJ.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(b=>this.g.fire(b)),this.i.onDidChangeActiveTextEditor(b=>this.f.fire(b))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(D){const u=this.i.allEditors();return D?u:u.map(b=>b.value)}async showTextDocument(D,u,b){let p;typeof u=="number"?p={position:d.ViewColumn.from(u),preserveFocus:b}:typeof u=="object"?p={position:d.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus,selection:typeof u.selection=="object"?d.Range.from(u.selection):void 0,pinned:typeof u.preview=="boolean"?!u.preview:void 0}:p={preserveFocus:!1};const h=await this.h.$tryShowTextDocument(D.uri,p),t=h&&this.i.getEditor(h);if(t)return t.value;throw h?new Error(`Could NOT open editor for "${D.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${D.uri.toString()}".`)}createTextEditorDecorationType(D,u){return new A.$SL(this.h,D,u).value}$acceptEditorPropertiesChanged(D,u){const b=this.i.getEditor(D);if(!b)throw new Error("unknown text editor");if(u.options&&b._acceptOptions(u.options),u.selections){const p=u.selections.selections.map(d.Selection.to);b._acceptSelections(p)}if(u.visibleRanges){const p=y.$jf(u.visibleRanges.map(d.Range.to));b._acceptVisibleRanges(p)}if(u.options&&this.b.fire({textEditor:b.value,options:{...u.options,lineNumbers:d.TextEditorLineNumbersStyle.to(u.options.lineNumbers)}}),u.selections){const p=k.TextEditorSelectionChangeKind.fromValue(u.selections.source),h=u.selections.selections.map(d.Selection.to);this.a.fire({textEditor:b.value,selections:h,kind:p})}if(u.visibleRanges){const p=y.$jf(u.visibleRanges.map(d.Range.to));this.c.fire({textEditor:b.value,visibleRanges:p})}}$acceptEditorPositionData(D){for(const u in D){const b=this.i.getEditor(u);if(!b)throw new Error("Unknown text editor");const p=d.ViewColumn.to(D[u]);b.value.viewColumn!==p&&(b._acceptViewColumn(p),this.d.fire({textEditor:b.value,viewColumn:p}))}}getDiffInformation(D){return Promise.resolve(this.h.$getDiffInformation(D))}}e.$kbc=f}),define(Pe[254],Ae([1,0,2,4,3,6,7,8,20,16]),function(pe,e,y,R,I,M,A,d,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zbc=e.$Ybc=void 0,e.$Ybc=(0,R.$ph)("IExtHostTimeline");class P{constructor(b,p){this.b=new Map,this.c=new Map,this.a=b.getProxy(I.$JJ.MainThreadTimeline),p.registerArgumentProcessor({processArgument:(h,t)=>{if(h&&h.$mid===12)if(this.b.get(h.source)&&k.$Il.equals(t,this.b.get(h.source)?.extension)){const i=h.uri===void 0?void 0:y.URI.revive(h.uri);return this.c.get(h.source)?.get(D(i))?.get(h.handle)}else return;return h}})}async $getTimeline(b,p,h,t){return this.b.get(b)?.provider.provideTimeline(y.URI.revive(p),h,t)}registerTimelineProvider(b,p,h,t){const i=new M.$kb,c=this.d(p.id,t,i).bind(this);let g;p.onDidChange&&(g=p.onDidChange(C=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...C,id:p.id}),this));const S=this.c;return this.f({...p,scheme:b,onDidChange:void 0,async provideTimeline(C,n,a){n?.resetCache&&(i.clear(),S.get(p.id)?.clear());const r=await p.provideTimeline(C,n,a);if(r==null)return;const s=c(C,n);return{...r,source:p.id,items:r.items.map(s)}},dispose(){for(const C of S.values())C.get(p.id)?.clear();g?.dispose(),i.dispose()}},h)}d(b,p,h){return(t,i)=>{let c;if(i?.cacheResults){let g=this.c.get(b);g===void 0&&(g=new Map,this.c.set(b,g));const S=D(t);c=g.get(S),c===void 0&&(c=new Map,g.set(S,c))}return g=>{const{iconPath:S,...C}=g,n=`${b}|${g.id??g.timestamp}`;c?.set(n,g);let a,r,s;g.iconPath&&(S instanceof A.$GK?s={id:S.id,color:S.color}:y.URI.isUri(S)?(a=S,r=S):{light:a,dark:r}=S);let v;return A.$aK.isMarkdownString(C.tooltip)?v=d.MarkdownString.from(C.tooltip):(0,f.$ie)(C.tooltip)?v=C.tooltip:A.$aK.isMarkdownString(C.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),v=d.MarkdownString.from(C.detail)):(0,f.$ie)(C.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),v=C.detail),{...C,id:C.id??void 0,handle:n,source:b,command:g.command?p.toInternal(g.command,h):void 0,icon:a,iconDark:r,themeIcon:s,tooltip:v,accessibilityInformation:g.accessibilityInformation}}}}f(b,p){if(this.b.get(b.id))throw new Error(`Timeline Provider ${b.id} already exists.`);return this.a.$registerTimelineProvider({id:b.id,label:b.label,scheme:b.scheme}),this.b.set(b.id,{provider:b,extension:p}),(0,M.$jb)(()=>{for(const t of this.c.values())t.get(b.id)?.clear();this.b.delete(b.id),this.a.$unregisterTimelineProvider(b.id),b.dispose()})}}e.$Zbc=P;function D(u){return u?.toString()}}),define(Pe[86],Ae([1,0,21,5,6,158,4,14,185,3,27,17,7]),function(pe,e,y,R,I,M,A,d,k,f,P,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mrb=e.$Lrb=e.TunnelDtoConverter=void 0;class b extends k.$Uz{}var p;(function(t){function i(g){return{remoteAddress:g.remoteAddress,localAddress:g.localAddress,public:!!g.public,privacy:g.privacy??(g.public?k.TunnelPrivacyId.Public:k.TunnelPrivacyId.Private),protocol:g.protocol}}t.fromApiTunnel=i;function c(g){return{remoteAddress:{host:g.tunnelRemoteHost,port:g.tunnelRemotePort},localAddress:g.localAddress,public:g.privacy!==k.TunnelPrivacyId.ConstantPrivate&&g.privacy!==k.TunnelPrivacyId.ConstantPrivate,privacy:g.privacy,protocol:g.protocol}}t.fromServiceTunnel=c})(p||(e.TunnelDtoConverter=p={})),e.$Lrb=(0,A.$ph)("IExtHostTunnelService");let h=class extends I.$lb{constructor(i,c,g){super(),this.n=g,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new R.$ec,this.onDidChangeTunnels=this.h.event,this.k=0,this.l=new Map,this.a=i.getProxy(f.$JJ.MainThreadTunnelService)}async openTunnel(i,c){this.n.trace(`ForwardedPorts: (ExtHostTunnelService) ${i.identifier.value} called openTunnel API for ${c.remoteAddress.host}:${c.remoteAddress.port}.`);const g=await this.a.$openTunnel(c,i.displayName);if(g){const S=new b(g.remoteAddress,g.localAddress,()=>this.a.$closeTunnel(g.remoteAddress));return this.B(S),S}}async getTunnels(){return this.a.$getTunnels()}p(){return this.k++}registerPortsAttributesProvider(i,c){const g=this.p();return this.l.set(g,{selector:i,provider:c}),this.a.$registerPortsAttributesProvider(i,g),new u.$LJ(()=>{this.l.delete(g),this.a.$unregisterPortsAttributesProvider(g)})}async $providePortAttributes(i,c,g,S,C){const n=[];for(const r of i){const s=this.l.get(r);if(!s)return[];n.push(...await Promise.all(c.map(async v=>{let $;try{$=await s.provider.providePortAttributes({port:v,pid:g,commandLine:S},C)}catch{$=await s.provider.providePortAttributes(v,g,S,C)}return{providedAttributes:$,port:v}})))}const a=n.filter(r=>!!r.providedAttributes);return a.length>0?a.map(r=>({autoForwardAction:r.providedAttributes.autoForwardAction,port:r.port})):[]}async $registerCandidateFinder(i){}registerTunnelProvider(i,c){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(S,C)=>await i.provideTunnel(S,C,new y.$oc().token)??void 0;const g=c.tunnelFeatures?{elevation:!!c.tunnelFeatures?.elevation,privacyOptions:c.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(g),Promise.resolve((0,I.$jb)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(i,c){if(i){i.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(i.candidatePortSource),i.showCandidatePort&&(this.f=i.showCandidatePort,this.a.$setCandidateFilter());const g=i.tunnelFactory??(c?this.r(c):void 0);if(g){this.b=g;let S=i.tunnelFeatures?.privacyOptions??[];i.tunnelFeatures?.public&&S.length===0&&(S=[{id:"private",label:M.localize(0,null),themeIcon:"lock"},{id:"public",label:M.localize(1,null),themeIcon:"eye"}]);const C=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,public:!!i.tunnelFeatures?.public,privacyOptions:S}:void 0;this.a.$setTunnelProvider(C)}}else this.b=void 0;return(0,I.$jb)(()=>{this.b=void 0})}r(i){}async $closeTunnel(i,c){if(this.g.has(i.host)){const g=this.g.get(i.host);g.has(i.port)&&(c&&g.get(i.port).disposeListener.dispose(),await g.get(i.port).tunnel.dispose(),g.delete(i.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(i,c){if(this.b)try{this.n.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const g=this.b(i,c);if(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),g!==void 0){const S=await g;if(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),S===void 0){this.n.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(i.remoteAddress.host)||this.g.set(i.remoteAddress.host,new Map);const C=this.B(S.onDidDispose(()=>(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(S.remoteAddress))));return this.g.get(i.remoteAddress.host).set(i.remoteAddress.port,{tunnel:S,disposeListener:C}),p.fromApiTunnel(S)}else this.n.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(g){if(this.n.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),g instanceof Error)return g.message}}async $applyCandidateFilter(i){const c=await Promise.all(i.map(S=>this.f(S.host,S.port,S.detail??""))),g=i.filter((S,C)=>c[C]);return this.n.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${i.map(S=>S.port).join(", ")} to ${g.map(S=>S.port).join(", ")}`),g}};e.$Mrb=h,e.$Mrb=h=Ke([We(0,D.$LL),We(1,P.$2L),We(2,d.$Ri)],h)}),define(Pe[255],Ae([1,0,6,12,2,3]),function(pe,e,y,R,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9bc=void 0;class A{static{this.a=new Set([R.Schemas.http,R.Schemas.https])}constructor(k){this.c=new Map,this.b=k.getProxy(M.$JJ.MainThreadUriOpeners)}registerExternalUriOpener(k,f,P,D){if(this.c.has(f))throw new Error(`Opener with id '${f}' already registered`);const u=D.schemes.find(b=>!A.a.has(b));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this.c.set(f,P),this.b.$registerUriOpener(f,D.schemes,k,D.label),(0,y.$jb)(()=>{this.c.delete(f),this.b.$unregisterUriOpener(f)})}async $canOpenUri(k,f,P){const D=this.c.get(k);if(!D)throw new Error(`Unknown opener with id: ${k}`);const u=I.URI.revive(f);return D.canOpenExternalUri(u,P)}async $openUri(k,f,P){const D=this.c.get(k);if(!D)throw new Error(`Unknown opener id: '${k}'`);return D.openExternalUri(I.URI.revive(f.resolvedUri),{sourceUri:I.URI.revive(f.sourceUri)},P)}}e.$9bc=A}),define(Pe[256],Ae([1,0,3,2,6,9,20]),function(pe,e,y,R,I,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mbc=void 0;class d{static{this.a=0}constructor(f){this.c=new A.$Jl,this.d=new Map,this.b=f.getProxy(y.$JJ.MainThreadUrls)}registerUriHandler(f,P){const D=f.identifier;if(this.c.has(D))throw new Error(`Protocol handler already registered for extension ${D}`);const u=d.a++;return this.c.add(D),this.d.set(u,P),this.b.$registerUriHandler(u,D,f.displayName||f.name),(0,I.$jb)(()=>{this.c.delete(D),this.d.delete(u),this.b.$unregisterUriHandler(u)})}$handleExternalUri(f,P){const D=this.d.get(f);if(!D)return Promise.resolve(void 0);try{D.handleUri(R.URI.revive(P))}catch(u){(0,M.$Y)(u)}return Promise.resolve(void 0)}async createAppUri(f){return R.URI.revive(await this.b.$createAppUri(f))}}e.$mbc=d}),define(Pe[64],Ae([1,0,5,12,24,2,170,192,77,3]),function(pe,e,y,R,I,M,A,d,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rbc=e.$qbc=e.$pbc=e.$obc=e.$nbc=void 0;class P{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;constructor(g,S,C,n,a,r,s){this.#s="",this.#o=!1,this.#a=!1,this._onMessageEmitter=new y.$ec,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new y.$ec,this._onDidDispose=this.#h.event,this.#e=g,this.#t=S,this.#r=C,this.#l=n,this.#u=a,this.#n=r,this.#c=D(r),this.#d=u(r),this.#i=s}#h;dispose(){this.#o=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(g){return this.#a=!0,(0,k.$job)(g,this.#l)}get cspSource(){const g=this.#n.extensionLocation;if(g.scheme===R.Schemas.https||g.scheme===R.Schemas.http){let S=g.toString();return S.endsWith("/")||(S+="/"),S+" "+k.$iob}return k.$iob}get html(){return this.a(),this.#s}set html(g){this.a(),this.#s!==g&&(this.#s=g,this.#d&&!this.#a&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(g)&&(this.#a=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(g)))}get options(){return this.a(),this.#r}set options(g){this.a(),I.$Mm(this.#r,g)||this.#t.$setOptions(this.#e,h(this.#n,this.#u,g)),this.#r=g}async postMessage(g){if(this.#o)return!1;const S=(0,d.$xbb)(g,{serializeBuffersForPostMessage:this.#c});return this.#t.$postMessage(this.#e,S.message,...S.buffers)}a(){if(this.#o)throw new Error("Webview is disposed")}b(g){if(!this.#d)return g;const S=this.#n.extensionLocation?.scheme===R.Schemas.vscodeRemote,C=this.#n.extensionLocation.scheme===R.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return g.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(n,a,r,s,v,$)=>{const w=M.URI.from({scheme:s||"file",path:decodeURIComponent(v)}),E=(0,k.$job)(w,{isRemote:S,authority:C}).toString();return`${a}${E}${$}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(n,a,r,s,v,$)=>{const w=M.URI.from({scheme:s||"file",path:decodeURIComponent(v)}),E=(0,k.$job)(w,{isRemote:S,authority:C}).toString();return`${a}${E}${$}`})}}e.$nbc=P;function D(c){try{const g=(0,A.$vo)((0,A.$uo)(c.engines.vscode));return!!g&&g.majorBase>=1&&g.minorBase>=57}catch{return!1}}e.$obc=D;function u(c){try{const g=(0,A.$vo)((0,A.$uo)(c.engines.vscode));return g?g.majorBase<1||g.majorBase===1&&g.minorBase<60:!1}catch{return!1}}class b{constructor(g,S,C,n,a){this.c=S,this.d=C,this.e=n,this.f=a,this.b=new Map,this.a=g.getProxy(f.$JJ.MainThreadWebviews)}$onMessage(g,S,C){const n=this.g(g);if(n){const{message:a}=(0,d.$ybb)(S,C.value);n._onMessageEmitter.fire(a)}}$onMissingCsp(g,S){this.e.warn(`${S} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(g,S,C){const n=new P(g,this.a,t(S),this.c,this.d,C,this.f);return this.b.set(g,n),n._onDidDispose(()=>{this.b.delete(g)}),n}deleteWebview(g){this.b.delete(g)}g(g){return this.b.get(g)}}e.$pbc=b;function p(c){return{id:c.identifier,location:c.extensionLocation}}e.$qbc=p;function h(c,g,S){return{enableCommandUris:S.enableCommandUris,enableScripts:S.enableScripts,enableForms:S.enableForms,portMapping:S.portMapping,localResourceRoots:S.localResourceRoots||i(c,g)}}e.$rbc=h;function t(c){return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,enableForms:c.enableForms,portMapping:c.portMapping,localResourceRoots:c.localResourceRoots?.map(g=>M.URI.from(g))}}function i(c,g){return[...(g?.getWorkspaceFolders()||[]).map(S=>S.uri),c.extensionLocation]}}),define(Pe[257],Ae([1,0,21,93,6,12,23,2,8,64,55,3,7]),function(pe,e,y,R,I,M,A,d,k,f,P,D,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3bc=void 0;class b{constructor(a,r){this.document=a,this.b=r,this.a=1,this.c=new P.$jac("custom documents")}addEdit(a){return this.c.add([a])}async undo(a,r){await this.f(a).undo(),r||this.disposeBackup()}async redo(a,r){await this.f(a).redo(),r||this.disposeBackup()}disposeEdits(a){for(const r of a)this.c.delete(r)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const a=C(this.document.uri)+this.a++;return(0,A.$9f)(this.b,a)}updateBackup(a){this.d?.delete(),this.d=a}disposeBackup(){this.d?.delete(),this.d=void 0}f(a){const r=this.c.get(a,0);if(!r)throw new Error("No edit found");return r}}class p{constructor(){this.a=new Map}get(a,r){return this.a.get(this.b(a,r))}add(a,r,s){const v=this.b(a,r.uri);if(this.a.has(v))throw new Error(`Document already exists for viewType:${a} resource:${r.uri}`);const $=new b(r,s);return this.a.set(v,$),$}delete(a,r){const s=this.b(a,r.uri);this.a.delete(s)}b(a,r){return`${a}@@@${r}`}}var h;(function(n){n[n.Text=0]="Text",n[n.Custom=1]="Custom"})(h||(h={}));class t{constructor(){this.a=new Map}addTextProvider(a,r,s){return this.b(0,a,r,s)}addCustomProvider(a,r,s){return this.b(1,a,r,s)}get(a){return this.a.get(a)}b(a,r,s,v){if(this.a.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this.a.set(r,{type:a,extension:s,provider:v}),new u.$LJ(()=>this.a.delete(r))}}class i{constructor(a,r,s,v,$){this.d=r,this.f=s,this.g=v,this.h=$,this.b=new t,this.c=new p,this.a=a.getProxy(D.$JJ.MainThreadCustomEditors)}registerCustomEditorProvider(a,r,s,v){const $=new I.$kb;return g(s)?($.add(this.b.addTextProvider(r,a,s)),this.a.$registerTextEditorProvider((0,f.$qbc)(a),r,v.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor},(0,f.$obc)(a))):($.add(this.b.addCustomProvider(r,a,s)),c(s)&&$.add(s.onDidChangeCustomDocument(w=>{const E=this.i(r,w.document.uri);if(S(w)){const o=E.addEdit(w);this.a.$onDidEdit(w.document.uri,r,o,w.label)}else this.a.$onContentChange(w.document.uri,r)})),this.a.$registerCustomEditorProvider((0,f.$qbc)(a),r,v.webviewOptions||{},!!v.supportsMultipleEditorsPerDocument,(0,f.$obc)(a))),u.$LJ.from($,new u.$LJ(()=>{this.a.$unregisterEditorProvider(r)}))}async $createCustomDocument(a,r,s,v,$){const w=this.b.get(r);if(!w)throw new Error(`No provider found for '${r}'`);if(w.type!==1)throw new Error(`Invalid provide type for '${r}'`);const E=d.URI.revive(a),o=await w.provider.openCustomDocument(E,{backupId:s,untitledDocumentData:v?.buffer},$);let l;return c(w.provider)&&this.f&&(l=this.f.workspaceValue(w.extension)??this.f.globalValue(w.extension)),this.c.add(r,o,l),{editable:c(w.provider)}}async $disposeCustomDocument(a,r){const s=this.b.get(r);if(!s)throw new Error(`No provider found for '${r}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${r}'`);const v=d.URI.revive(a),{document:$}=this.i(r,v);this.c.delete(r,$),$.dispose()}async $resolveCustomEditor(a,r,s,v,$,w){const E=this.b.get(s);if(!E)throw new Error(`No provider found for '${s}'`);const o=k.ViewColumn.to($),l=this.g.createNewWebview(r,v.contentOptions,E.extension),m=this.h.createNewWebviewPanel(r,s,v.title,o,v.options,l,v.active),F=d.URI.revive(a);switch(E.type){case 1:{const{document:W}=this.i(s,F);return E.provider.resolveCustomEditor(W,m,w)}case 0:{const W=this.d.getDocument(F);return E.provider.resolveCustomTextEditor(W,m,w)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(a,r,s){this.i(r,a).disposeEdits(s)}async $onMoveCustomEditor(a,r,s){const v=this.b.get(s);if(!v)throw new Error(`No provider found for '${s}'`);if(!v.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const $=this.h.getWebviewPanel(a);if(!$)throw new Error("No webview found");const w=d.URI.revive(r),E=this.d.getDocument(w);await v.provider.moveCustomTextEditor(E,$,y.CancellationToken.None)}async $undo(a,r,s,v){return this.i(r,a).undo(s,v)}async $redo(a,r,s,v){return this.i(r,a).redo(s,v)}async $revert(a,r,s){const v=this.i(r,a);await this.j(r).revertCustomDocument(v.document,s),v.disposeBackup()}async $onSave(a,r,s){const v=this.i(r,a);await this.j(r).saveCustomDocument(v.document,s),v.disposeBackup()}async $onSaveAs(a,r,s,v){const $=this.i(r,a);return this.j(r).saveCustomDocumentAs($.document,d.URI.revive(s),v)}async $backup(a,r,s){const v=this.i(r,a),w=await this.j(r).backupCustomDocument(v.document,{destination:v.getNewBackupUri()},s);return v.updateBackup(w),w.id}i(a,r){const s=this.c.get(a,d.URI.revive(r));if(!s)throw new Error("No custom document found");return s}j(a){const s=this.b.get(a)?.provider;if(!s||!c(s))throw new Error("Custom document is not editable");return s}}e.$3bc=i;function c(n){return!!n.onDidChangeCustomDocument}function g(n){return typeof n.resolveCustomTextEditor=="function"}function S(n){return typeof n.undo=="function"&&typeof n.redo=="function"}function C(n){const a=n.scheme===M.Schemas.file||n.scheme===M.Schemas.untitled?n.fsPath:n.toString();return(0,R.$di)(a)+""}}),define(Pe[258],Ae([1,0,5,6,2,36,8,64,3,7]),function(pe,e,y,R,I,M,A,d,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2bc=void 0;class P extends R.$lb{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;#h;constructor(p,h,t,i){super(),this.#r=void 0,this.#o=!0,this.#c=!1,this.#d=this.B(new y.$ec),this.onDidDispose=this.#d.event,this.#h=this.B(new y.$ec),this.onDidChangeViewState=this.#h.event,this.#e=p,this.#t=h,this.#l=t,this.#i=i.viewType,this.#u=i.panelOptions,this.#r=i.viewColumn,this.#n=i.title,this.#a=i.active}dispose(){this.#c||(this.#c=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#l.dispose(),super.dispose())}get webview(){return this.c(),this.#l}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title(p){this.c(),this.#n!==p&&(this.#n=p,this.#t.$setTitle(this.#e,p))}get iconPath(){return this.c(),this.#s}set iconPath(p){this.c(),this.#s!==p&&(this.#s=p,this.#t.$setIconPath(this.#e,I.URI.isUri(p)?{light:p,dark:p}:p))}get options(){return this.#u}get viewColumn(){if(this.c(),!(typeof this.#r=="number"&&this.#r<0))return this.#r}get active(){return this.c(),this.#a}get visible(){return this.c(),this.#o}_updateViewState(p){this.#c||(this.active!==p.active||this.visible!==p.visible||this.viewColumn!==p.viewColumn)&&(this.#a=p.active,this.#o=p.visible,this.#r=p.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(p,h){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof p>"u"?void 0:A.ViewColumn.from(p),preserveFocus:!!h})}c(){if(this.#c)throw new Error("Webview is disposed")}}class D{static c(){return(0,M.$3e)()}constructor(p,h,t){this.g=h,this.h=t,this.e=new Map,this.f=new Map,this.d=p.getProxy(k.$JJ.MainThreadWebviewPanels)}createWebviewPanel(p,h,t,i,c={}){const g=typeof i=="object"?i.viewColumn:i,S={viewColumn:A.ViewColumn.from(g),preserveFocus:typeof i=="object"&&!!i.preserveFocus},C=(0,d.$obc)(p),n=D.c();this.d.$createWebviewPanel((0,d.$qbc)(p),n,h,{title:t,panelOptions:u(c),webviewOptions:(0,d.$rbc)(p,this.h,c),serializeBuffersForPostMessage:C},S);const a=this.g.createNewWebview(n,c,p);return this.createNewWebviewPanel(n,h,t,g,c,a,!0)}$onDidChangeWebviewPanelViewStates(p){const h=Object.keys(p);h.sort((t,i)=>{const c=p[t],g=p[i];return c.active?1:g.active?-1:+c.visible-+g.visible});for(const t of h){const i=this.getWebviewPanel(t);if(!i)continue;const c=p[t];i._updateViewState({active:c.active,visible:c.visible,viewColumn:A.ViewColumn.to(c.position)})}}async $onDidDisposeWebviewPanel(p){this.getWebviewPanel(p)?.dispose(),this.e.delete(p),this.g.deleteWebview(p)}registerWebviewPanelSerializer(p,h,t){if(this.f.has(h))throw new Error(`Serializer for '${h}' already registered`);return this.f.set(h,{serializer:t,extension:p}),this.d.$registerSerializer(h,{serializeBuffersForPostMessage:(0,d.$obc)(p)}),new f.$LJ(()=>{this.f.delete(h),this.d.$unregisterSerializer(h)})}async $deserializeWebviewPanel(p,h,t,i){const c=this.f.get(h);if(!c)throw new Error(`No serializer found for '${h}'`);const{serializer:g,extension:S}=c,C=this.g.createNewWebview(p,t.webviewOptions,S),n=this.createNewWebviewPanel(p,h,t.title,i,t.panelOptions,C,t.active);await g.deserializeWebviewPanel(n,t.state)}createNewWebviewPanel(p,h,t,i,c,g,S){const C=new P(p,this.d,g,{viewType:h,title:t,viewColumn:i,panelOptions:c,active:S});return this.e.set(p,C),C}getWebviewPanel(p){return this.e.get(p)}}e.$2bc=D;function u(b){return{enableFindWidget:b.enableFindWidget,retainContextWhenHidden:b.retainContextWhenHidden}}}),define(Pe[259],Ae([1,0,5,6,64,8,3,7]),function(pe,e,y,R,I,M,A,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1bc=void 0;class k extends R.$lb{#e;#t;#i;#l;#u;#n;#s;#r;#o;constructor(D,u,b,p,h,t){super(),this.#u=!1,this.#a=this.B(new y.$ec),this.onDidChangeVisibility=this.#a.event,this.#c=this.B(new y.$ec),this.onDidDispose=this.#c.event,this.#i=b,this.#s=p,this.#e=D,this.#t=u,this.#l=h,this.#n=t}dispose(){this.#u||(this.#u=!0,this.#c.fire(),this.#l.dispose(),super.dispose())}#a;#c;get title(){return this.a(),this.#s}set title(D){this.a(),this.#s!==D&&(this.#s=D,this.#t.$setWebviewViewTitle(this.#e,D))}get description(){return this.a(),this.#r}set description(D){this.a(),this.#r!==D&&(this.#r=D,this.#t.$setWebviewViewDescription(this.#e,D))}get visible(){return this.#n}get webview(){return this.#l}get viewType(){return this.#i}_setVisible(D){D===this.#n||this.#u||(this.#n=D,this.#a.fire())}get badge(){return this.a(),this.#o}set badge(D){this.a(),!(D?.value===this.#o?.value&&D?.tooltip===this.#o?.tooltip)&&(this.#o=M.ViewBadge.from(D),this.#t.$setWebviewViewBadge(this.#e,D))}show(D){this.a(),this.#t.$show(this.#e,!!D)}a(){if(this.#u)throw new Error("Webview is disposed")}}class f{constructor(D,u){this.d=u,this.b=new Map,this.c=new Map,this.a=D.getProxy(A.$JJ.MainThreadWebviewViews)}registerWebviewViewProvider(D,u,b,p){if(this.b.has(u))throw new Error(`View provider for '${u}' already registered`);return this.b.set(u,{provider:b,extension:D}),this.a.$registerWebviewViewProvider((0,I.$qbc)(D),u,{retainContextWhenHidden:p?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,I.$obc)(D)}),new d.$LJ(()=>{this.b.delete(u),this.a.$unregisterWebviewViewProvider(u)})}async $resolveWebviewView(D,u,b,p,h){const t=this.b.get(u);if(!t)throw new Error(`No view provider found for '${u}'`);const{provider:i,extension:c}=t,g=this.d.createNewWebview(D,{},c),S=new k(D,this.a,u,b,g,!0);this.c.set(D,S),await i.resolveWebviewView(S,{state:p},h)}async $onDidChangeWebviewViewVisibility(D,u){this.e(D)._setVisible(u)}async $disposeWebviewView(D){const u=this.e(D);this.c.delete(D),u.dispose(),this.d.deleteWebview(D)}e(D){const u=this.c.get(D);if(!u)throw new Error("No webview found");return u}}e.$1bc=f}),define(Pe[109],Ae([1,0,5,3,2,12,15,4,17,26]),function(pe,e,y,R,I,M,A,d,k,f){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$tbc=e.$sbc=void 0;let D=class{static{P=this}static{this.a={focused:!0,active:!0}}getState(b){const p=this.d;return{get focused(){return p.focused},get active(){return(0,f.$EF)(b,"windowActivity"),p.active}}}constructor(b){this.c=new y.$ec,this.onDidChangeWindowState=this.c.event,this.d=P.a,this.b=b.getProxy(R.$JJ.MainThreadWindow),this.b.$getInitialState().then(({isFocused:p,isActive:h})=>{this.onDidChangeWindowProperty("focused",p),this.onDidChangeWindowProperty("active",h)})}$onDidChangeWindowFocus(b){this.onDidChangeWindowProperty("focused",b)}$onDidChangeWindowActive(b){this.onDidChangeWindowProperty("active",b)}onDidChangeWindowProperty(b,p){p!==this.d[b]&&(this.d={...this.d,[b]:p},this.c.fire(this.d))}openUri(b,p){let h;if(typeof b=="string"){h=b;try{b=I.URI.parse(b)}catch{return Promise.reject(`Invalid uri - '${b}'`)}}return(0,A.$ld)(b.scheme)?Promise.reject("Invalid scheme - cannot be empty"):b.scheme===M.Schemas.command?Promise.reject(`Invalid scheme '${b.scheme}'`):this.b.$openUri(b,h,p)}async asExternalUri(b,p){if((0,A.$ld)(b.scheme))return Promise.reject("Invalid scheme - cannot be empty");const h=await this.b.$asExternalUri(b,p);return I.URI.from(h)}};e.$sbc=D,e.$sbc=D=P=Ke([We(0,k.$LL)],D),e.$tbc=(0,d.$ph)("IExtHostWindow")}),define(Pe[260],Ae([1,0,227,27,17]),function(pe,e,y,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xec=void 0;let M=class extends y.$rcc{constructor(d,k){super(d,k)}f(d,k,f){k.apply(console,f)}};e.$xec=M,e.$xec=M=Ke([We(0,I.$LL),We(1,R.$2L)],M)}),define(Pe[261],Ae([1,0,13,25,21,9,5,6,133,216,46]),function(pe,e,y,R,I,M,A,d,k,f,P){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$X2b=e.ResponsiveState=e.RequestInitiator=e.$W2b=e.$V2b=void 0;function u(l,m){try{return JSON.stringify(l,m)}catch{return"null"}}const b="$$ref$$",p={[b]:-1};class h{constructor(m,F){this.jsonString=m,this.referencedBuffers=F}}function t(l,m=null,F=!1){const W=[];return{jsonString:(F?u:JSON.stringify)(l,(B,j)=>{if(typeof j>"u")return p;if(typeof j=="object"){if(j instanceof R.$Ec){const U=W.push(j)-1;return{[b]:U}}if(m)return m(B,j)}return j}),referencedBuffers:W}}e.$V2b=t;function i(l,m,F){return JSON.parse(l,(W,V)=>{if(V){const B=V[b];if(typeof B=="number")return m[B];if(F&&V.$mid===1)return F.transformIncoming(V)}return V})}e.$W2b=i;function c(l,m){return JSON.stringify(l,m)}function g(l){return l?(m,F)=>F&&F.$mid===1?l.transformOutgoing(F):F:null}var S;(function(l){l[l.LocalSide=0]="LocalSide",l[l.OtherSide=1]="OtherSide"})(S||(e.RequestInitiator=S={}));var C;(function(l){l[l.Responsive=0]="Responsive",l[l.Unresponsive=1]="Unresponsive"})(C||(e.ResponsiveState=C={}));const n=()=>{},a=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class s extends d.$lb{static{D=a}static{this.a=3*1e3}constructor(m,F=null,W=null){super(),this[D]=!0,this.b=this.B(new A.$ec),this.onDidChangeResponsiveState=this.b.event,this.c=m,this.f=F,this.g=W,this.h=g(this.g),this.j=!1,this.k=[],this.l=[];for(let V=0,B=P.$2z.count;V<B;V++)this.k[V]=null,this.l[V]=null;this.m=0,this.p=Object.create(null),this.s={},this.t=0,this.u=0,this.v=0,this.w=this.B(new y.$Gg(()=>this.C(),1e3)),this.c.onMessage(V=>this.G(V))}dispose(){this.j=!0,Object.keys(this.s).forEach(m=>{this.s[m].resolveErr(M.$4())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}y(m){this.u===0&&(this.v=Date.now()+s.a),this.u++,this.w.isScheduled()||this.w.schedule()}z(m){this.v=Date.now()+s.a,this.u--,this.u===0&&this.w.cancel(),this.D(0)}C(){this.u!==0&&(Date.now()>this.v?this.D(1):this.w.schedule())}D(m){this.t!==m&&(this.t=m,this.b.fire(this.t))}get responsiveState(){return this.t}transformIncomingURIs(m){return this.g?(0,k.$rm)(m,this.g):m}getProxy(m){const{nid:F,sid:W}=m;return this.l[F]||(this.l[F]=this.F(F,W)),this.l[F]}F(m,F){const W={get:(V,B)=>(typeof B=="string"&&!V[B]&&B.charCodeAt(0)===36&&(V[B]=(...j)=>this.O(m,B,j)),B===r?F:V[B])};return new Proxy(Object.create(null),W)}set(m,F){return this.k[m.nid]=F,F}assertRegistered(m){for(let F=0,W=m.length;F<W;F++){const V=m[F];if(!this.k[V.nid])throw new Error(`Missing proxy instance ${V.sid}`)}}G(m){if(this.j)return;const F=m.byteLength,W=v.read(m,0),V=W.readUInt8(),B=W.readUInt32();switch(V){case 1:case 2:{let{rpcId:j,method:U,args:z}=w.deserializeRequestJSONArgs(W);this.g&&(z=(0,k.$rm)(z,this.g)),this.H(F,B,j,U,z,V===2);break}case 3:case 4:{let{rpcId:j,method:U,args:z}=w.deserializeRequestMixedArgs(W);this.g&&(z=(0,k.$rm)(z,this.g)),this.H(F,B,j,U,z,V===4);break}case 5:{this.f?.logIncoming(F,B,0,"ack"),this.z(B);break}case 6:{this.I(F,B);break}case 7:{this.J(F,B,void 0);break}case 9:{let j=w.deserializeReplyOKJSON(W);this.g&&(j=(0,k.$rm)(j,this.g)),this.J(F,B,j);break}case 10:{const j=w.deserializeReplyOKJSONWithBuffers(W,this.g);this.J(F,B,j);break}case 8:{const j=w.deserializeReplyOKVSBuffer(W);this.J(F,B,j);break}case 11:{let j=w.deserializeReplyErrError(W);this.g&&(j=(0,k.$rm)(j,this.g)),this.L(F,B,j);break}case 12:{this.L(F,B,void 0);break}default:console.error("received unexpected message"),console.error(m)}}H(m,F,W,V,B,j){this.f?.logIncoming(m,F,1,`receiveRequest ${(0,P.$4z)(W)}.${V}(`,B);const U=String(F);let z,ne;if(j){const we=new I.$oc;B.push(we.token),z=this.M(W,V,B),ne=()=>we.cancel()}else z=this.M(W,V,B),ne=n;this.p[U]=ne;const Z=w.serializeAcknowledged(F);this.f?.logOutgoing(Z.byteLength,F,1,"ack"),this.c.send(Z),z.then(we=>{delete this.p[U];const Ee=w.serializeReplyOK(F,we,this.h);this.f?.logOutgoing(Ee.byteLength,F,1,"reply:",we),this.c.send(Ee)},we=>{delete this.p[U];const Ee=w.serializeReplyErr(F,we);this.f?.logOutgoing(Ee.byteLength,F,1,"replyErr:",we),this.c.send(Ee)})}I(m,F){this.f?.logIncoming(m,F,1,"receiveCancel");const W=String(F);this.p[W]?.()}J(m,F,W){this.f?.logIncoming(m,F,0,"receiveReply:",W);const V=String(F);if(!this.s.hasOwnProperty(V))return;const B=this.s[V];delete this.s[V],B.resolveOk(W)}L(m,F,W){this.f?.logIncoming(m,F,0,"receiveReplyErr:",W);const V=String(F);if(!this.s.hasOwnProperty(V))return;const B=this.s[V];delete this.s[V];let j;W&&(W.$isError?(j=new Error,j.name=W.name,j.message=W.message,j.stack=W.stack):j=W),B.resolveErr(j)}M(m,F,W){try{return Promise.resolve(this.N(m,F,W))}catch(V){return Promise.reject(V)}}N(m,F,W){const V=this.k[m];if(!V)throw new Error("Unknown actor "+(0,P.$4z)(m));const B=V[F];if(typeof B!="function")throw new Error("Unknown method "+F+" on actor "+(0,P.$4z)(m));return B.apply(V,W)}O(m,F,W){if(this.j)return new f.$U2b;let V=null;if(W.length>0&&I.CancellationToken.isCancellationToken(W[W.length-1])&&(V=W.pop()),V&&V.isCancellationRequested)return Promise.reject(M.$4());const B=w.serializeRequestArguments(W,this.h),j=++this.m,U=String(j),z=new f.$T2b;V&&V.onCancellationRequested(()=>{const Z=w.serializeCancel(j);this.f?.logOutgoing(Z.byteLength,j,0,"cancel"),this.c.send(w.serializeCancel(j))}),this.s[U]=z,this.y(j);const ne=w.serializeRequest(j,m,F,B,!!V);return this.f?.logOutgoing(ne.byteLength,j,0,`request: ${(0,P.$4z)(m)}.${F}(`,W),this.c.send(ne),z}}e.$X2b=s;class v{static alloc(m,F,W){const V=new v(R.$Ec.alloc(W+1+4),0);return V.writeUInt8(m),V.writeUInt32(F),V}static read(m,F){return new v(m,F)}get buffer(){return this.a}constructor(m,F){this.a=m,this.b=F}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(m){this.a.writeUInt8(m,this.b),this.b+=1}readUInt8(){const m=this.a.readUInt8(this.b);return this.b+=1,m}writeUInt32(m){this.a.writeUInt32BE(m,this.b),this.b+=4}readUInt32(){const m=this.a.readUInt32BE(this.b);return this.b+=4,m}static sizeShortString(m){return 1+m.byteLength}writeShortString(m){this.a.writeUInt8(m.byteLength,this.b),this.b+=1,this.a.set(m,this.b),this.b+=m.byteLength}readShortString(){const m=this.a.readUInt8(this.b);this.b+=1;const W=this.a.slice(this.b,this.b+m).toString();return this.b+=m,W}static sizeLongString(m){return 4+m.byteLength}writeLongString(m){this.a.writeUInt32BE(m.byteLength,this.b),this.b+=4,this.a.set(m,this.b),this.b+=m.byteLength}readLongString(){const m=this.a.readUInt32BE(this.b);this.b+=4;const W=this.a.slice(this.b,this.b+m).toString();return this.b+=m,W}writeBuffer(m){this.a.writeUInt32BE(m.byteLength,this.b),this.b+=4,this.a.set(m,this.b),this.b+=m.byteLength}static sizeVSBuffer(m){return 4+m.byteLength}writeVSBuffer(m){this.a.writeUInt32BE(m.byteLength,this.b),this.b+=4,this.a.set(m,this.b),this.b+=m.byteLength}readVSBuffer(){const m=this.a.readUInt32BE(this.b);this.b+=4;const F=this.a.slice(this.b,this.b+m);return this.b+=m,F}static sizeMixedArray(m){let F=0;F+=1;for(let W=0,V=m.length;W<V;W++){const B=m[W];switch(F+=1,B.type){case 1:F+=this.sizeLongString(B.value);break;case 2:F+=this.sizeVSBuffer(B.value);break;case 3:F+=this.sizeUInt32,F+=this.sizeLongString(B.value);for(let j=0;j<B.buffers.length;++j)F+=this.sizeVSBuffer(B.buffers[j]);break;case 4:break}}return F}writeMixedArray(m){this.a.writeUInt8(m.length,this.b),this.b+=1;for(let F=0,W=m.length;F<W;F++){const V=m[F];switch(V.type){case 1:this.writeUInt8(1),this.writeLongString(V.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(V.value);break;case 3:this.writeUInt8(3),this.writeUInt32(V.buffers.length),this.writeLongString(V.value);for(let B=0;B<V.buffers.length;++B)this.writeBuffer(V.buffers[B]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const m=this.a.readUInt8(this.b);this.b+=1;const F=new Array(m);for(let W=0;W<m;W++)switch(this.readUInt8()){case 1:F[W]=this.readLongString();break;case 2:F[W]=this.readVSBuffer();break;case 3:{const B=this.readUInt32(),j=this.readLongString(),U=[];for(let z=0;z<B;++z)U.push(this.readVSBuffer());F[W]=new P.$5z(i(j,U,null));break}case 4:F[W]=void 0;break}return F}}var $;(function(l){l[l.Simple=0]="Simple",l[l.Mixed=1]="Mixed"})($||($={}));class w{static a(m){for(let F=0,W=m.length;F<W;F++)if(m[F]instanceof R.$Ec||m[F]instanceof P.$5z||typeof m[F]>"u")return!0;return!1}static serializeRequestArguments(m,F){if(this.a(m)){const W=[];for(let V=0,B=m.length;V<B;V++){const j=m[V];if(j instanceof R.$Ec)W[V]={type:2,value:j};else if(typeof j>"u")W[V]={type:4};else if(j instanceof P.$5z){const{jsonString:U,referencedBuffers:z}=t(j.value,F);W[V]={type:3,value:R.$Ec.fromString(U),buffers:z}}else W[V]={type:1,value:R.$Ec.fromString(c(j,F))}}return{type:1,args:W}}return{type:0,args:c(m,F)}}static serializeRequest(m,F,W,V,B){switch(V.type){case 0:return this.b(m,F,W,V.args,B);case 1:return this.c(m,F,W,V.args,B)}}static b(m,F,W,V,B){const j=R.$Ec.fromString(W),U=R.$Ec.fromString(V);let z=0;z+=v.sizeUInt8(),z+=v.sizeShortString(j),z+=v.sizeLongString(U);const ne=v.alloc(B?2:1,m,z);return ne.writeUInt8(F),ne.writeShortString(j),ne.writeLongString(U),ne.buffer}static deserializeRequestJSONArgs(m){const F=m.readUInt8(),W=m.readShortString(),V=m.readLongString();return{rpcId:F,method:W,args:JSON.parse(V)}}static c(m,F,W,V,B){const j=R.$Ec.fromString(W);let U=0;U+=v.sizeUInt8(),U+=v.sizeShortString(j),U+=v.sizeMixedArray(V);const z=v.alloc(B?4:3,m,U);return z.writeUInt8(F),z.writeShortString(j),z.writeMixedArray(V),z.buffer}static deserializeRequestMixedArgs(m){const F=m.readUInt8(),W=m.readShortString(),V=m.readMixedArray(),B=new Array(V.length);for(let j=0,U=V.length;j<U;j++){const z=V[j];typeof z=="string"?B[j]=JSON.parse(z):B[j]=z}return{rpcId:F,method:W,args:B}}static serializeAcknowledged(m){return v.alloc(5,m,0).buffer}static serializeCancel(m){return v.alloc(6,m,0).buffer}static serializeReplyOK(m,F,W){if(typeof F>"u")return this.d(m);if(F instanceof R.$Ec)return this.e(m,F);if(F instanceof P.$5z){const{jsonString:V,referencedBuffers:B}=t(F.value,W,!0);return this.g(m,V,B)}else return this.f(m,u(F,W))}static d(m){return v.alloc(7,m,0).buffer}static e(m,F){let W=0;W+=v.sizeVSBuffer(F);const V=v.alloc(8,m,W);return V.writeVSBuffer(F),V.buffer}static deserializeReplyOKVSBuffer(m){return m.readVSBuffer()}static f(m,F){const W=R.$Ec.fromString(F);let V=0;V+=v.sizeLongString(W);const B=v.alloc(9,m,V);return B.writeLongString(W),B.buffer}static g(m,F,W){const V=R.$Ec.fromString(F);let B=0;B+=v.sizeUInt32,B+=v.sizeLongString(V);for(const U of W)B+=v.sizeVSBuffer(U);const j=v.alloc(10,m,B);j.writeUInt32(W.length),j.writeLongString(V);for(const U of W)j.writeBuffer(U);return j.buffer}static deserializeReplyOKJSON(m){const F=m.readLongString();return JSON.parse(F)}static deserializeReplyOKJSONWithBuffers(m,F){const W=m.readUInt32(),V=m.readLongString(),B=[];for(let j=0;j<W;++j)B.push(m.readVSBuffer());return new P.$5z(i(V,B,F))}static serializeReplyErr(m,F){const W=F?u(M.$1(F),null):void 0;if(typeof W!="string")return this.h(m);const V=R.$Ec.fromString(W);let B=0;B+=v.sizeLongString(V);const j=v.alloc(11,m,B);return j.writeLongString(V),j.buffer}static deserializeReplyErrError(m){const F=m.readLongString();return JSON.parse(F)}static h(m){return v.alloc(12,m,0).buffer}}var E;(function(l){l[l.RequestJSONArgs=1]="RequestJSONArgs",l[l.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",l[l.RequestMixedArgs=3]="RequestMixedArgs",l[l.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",l[l.Acknowledged=5]="Acknowledged",l[l.Cancel=6]="Cancel",l[l.ReplyOKEmpty=7]="ReplyOKEmpty",l[l.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",l[l.ReplyOKJSON=9]="ReplyOKJSON",l[l.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",l[l.ReplyErrError=11]="ReplyErrError",l[l.ReplyErrEmpty=12]="ReplyErrEmpty"})(E||(E={}));var o;(function(l){l[l.String=1]="String",l[l.VSBuffer=2]="VSBuffer",l[l.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",l[l.Undefined=4]="Undefined"})(o||(o={}))}),define(Pe[262],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zec=void 0;const y=function(M){const A=d=>{globalThis.removeEventListener("message",A);const k=d.data;Object.defineProperties(globalThis,{postMessage:{value(f,P){k.postMessage(f,P)}},onmessage:{get(){return k.onmessage},set(f){k.onmessage=f}}}),k.addEventListener("message",f=>{globalThis.dispatchEvent(new MessageEvent("message",{data:f.data,ports:f.ports?[...f.ports]:void 0}))}),k.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(M)};globalThis.addEventListener("message",A)}.toString();class R extends EventTarget{constructor(M,A,d){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const k=`((${y})('${A}'))`,f=new Blob([k],{type:"application/javascript"}),P=URL.createObjectURL(f),D=new MessageChannel,u=P,b={type:"_newWorker",id:u,port:D.port2,url:P,options:d};M(b,[D.port2]),this.postMessage=D.port1.postMessage.bind(D.port1),this.terminate=()=>{M({type:"_terminateWorker",id:u}),URL.revokeObjectURL(P),D.port1.close(),D.port2.close()},Object.defineProperties(this,{onmessage:{get(){return D.port1.onmessage},set(p){D.port1.onmessage=p}},onmessageerror:{get(){return D.port1.onmessageerror},set(p){D.port1.onmessageerror=p}}}),D.port1.addEventListener("messageerror",p=>{const h=new MessageEvent("messageerror",{data:p.data});this.dispatchEvent(h)}),D.port1.addEventListener("message",p=>{const h=new MessageEvent("message",{data:p.data});this.dispatchEvent(h)}),D.port1.start()}}e.$zec=R}),define(Pe[263],Ae([1,0,5,30,32,4]),function(pe,e,y,R,I,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZI=e.$YI=e.OutputChannelUpdateMode=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=void 0,e.$NI="text/x-code-output",e.$OI="output",e.$PI="Log",e.$QI="text/x-code-log-output",e.$RI="log",e.$SI="log",e.$TI="workbench.panel.output",e.$UI=new I.$Oi("inOutput",!1),e.$VI=new I.$Oi("activeLogOutput",!1),e.$WI=new I.$Oi("outputView.scrollLock",!1),e.$XI=(0,M.$ph)("outputService");var A;(function(k){k[k.Append=1]="Append",k[k.Replace=2]="Replace",k[k.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$YI={OutputChannels:"workbench.contributions.outputChannels"};class d{constructor(){this.a=new Map,this.b=new y.$ec,this.onDidRegisterChannel=this.b.event,this.c=new y.$ec,this.onDidRemoveChannel=this.c.event}registerChannel(f){this.a.has(f.id)||(this.a.set(f.id,f),this.b.fire(f.id))}getChannels(){const f=[];return this.a.forEach(P=>f.push(P)),f}getChannel(f){return this.a.get(f)}removeChannel(f){this.a.delete(f),this.c.fire(f)}}R.$Um.add(e.$YI.OutputChannels,new d),e.$ZI=new I.$Oi("activeOutputChannel","")}),define(Pe[110],Ae([1,0,3,4,17,20,14,263,62,27,39,130,25,16,38,5,6]),function(pe,e,y,R,I,M,A,d,k,f,P,D,u,b,p,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dbc=e.$cbc=void 0;class i extends A.$Xi{get disposed(){return this.l}constructor(C,n,a,r,s){super(),this.id=C,this.name=n,this.m=a,this.n=r,this.extension=s,this.k=0,this.l=!1,this.visible=!1,this.setLevel(a.getLevel()),this.B(a.onDidChangeLogLevel(v=>this.setLevel(v)))}get logLevel(){return this.getLevel()}appendLine(C){this.append(C+`
`)}append(C){this.info(C)}clear(){const C=this.k;this.m.flush(),this.n.$update(this.id,d.OutputChannelUpdateMode.Clear,C)}replace(C){const n=this.k;this.info(C),this.n.$update(this.id,d.OutputChannelUpdateMode.Replace,n),this.visible&&this.m.flush()}show(C,n){this.m.flush(),this.n.$reveal(this.id,!!(typeof C=="boolean"?C:n))}hide(){this.n.$close(this.id)}g(C,n){this.k+=u.$Ec.fromString(n).byteLength,(0,A.log)(this.m,C,n),this.visible&&(this.m.flush(),this.n.$update(this.id,d.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.l||(this.n.$dispose(this.id),this.l=!0)}}class c extends i{appendLine(C){this.append(C)}}let g=class{constructor(C,n,a,r,s,v){this.i=n,this.j=a,this.k=r,this.l=s,this.m=v,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=C.getProxy(y.$JJ.MainThreadOutputService),this.b=this.k.extUri.joinPath(n.logsLocation,`output_logging_${(0,D.$Tl)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(C){this.h=C;for(const[n,a]of this.g)a.visible=n===this.h}createOutputChannel(C,n,a){if(C=C.trim(),!C)throw new Error("illegal argument `name`. must not be falsy");const r=typeof n=="object"&&n.log,s=(0,b.$ie)(n)?n:void 0;if((0,b.$ie)(s)&&!s.trim())throw new Error("illegal argument `languageId`. must not be empty");let v;const $=this.i.environment.extensionLogLevel?.find(([E])=>M.$Il.equals(a.identifier,E))?.[1];$&&(v=(0,A.$8i)($));const w=r?this.o(C,v,a):this.n(C,s,a);return w.then(E=>{this.g.set(E.id,E),E.visible=E.id===this.h}),r?this.r(C,v??this.m.getLevel(),w):this.q(C,w)}async n(C,n,a){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const r=await this.c,s=this.k.extUri.joinPath(r,`${this.f++}-${C.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),v=this.l.createLogger(s,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),$=await this.a.$register(C,s,n,a.identifier.value);return new i($,C,v,this.a,a)}async o(C,n,a){const r=await this.p(a),s=C.replace(/[\\/:\*\?"<>\|]/g,""),v=this.k.extUri.joinPath(r,`${s}.log`),$=`${a.identifier.value}.${s}`,w=this.l.createLogger(v,{id:$,name:C,logLevel:n,extensionId:a.identifier.value});return new c($,C,w,this.a,a)}p(C){let n=this.d.get(C.identifier.value);if(!n){const a=this.k.extUri.joinPath(this.i.logsLocation,C.identifier.value);this.d.set(C.identifier.value,n=(async()=>{try{await this.j.value.createDirectory(a)}catch(r){if((0,p.$8j)(r)!==p.FileSystemProviderErrorCode.FileExists)throw r}return a})())}return n}q(C,n){let a=!1;const r=()=>{if(a)throw new Error("Channel has been closed")};return{get name(){return C},append(s){r(),n.then(v=>v.append(s))},appendLine(s){r(),n.then(v=>v.appendLine(s))},clear(){r(),n.then(s=>s.clear())},replace(s){r(),n.then(v=>v.replace(s))},show(s,v){r(),n.then($=>$.show(s,v))},hide(){r(),n.then(s=>s.hide())},dispose(){a=!0,n.then(s=>s.dispose())}}}r(C,n,a){const r=new t.$kb,s=()=>{if(r.isDisposed)throw new Error("Channel has been closed")},v=r.add(new h.$ec);function $(w){n=w,v.fire(w)}return a.then(w=>{r.add(w),w.logLevel!==n&&$(w.logLevel),r.add(w.onDidChangeLogLevel(E=>$(E)))}),{...this.q(C,a),get logLevel(){return n},onDidChangeLogLevel:v.event,trace(w,...E){s(),a.then(o=>o.trace(w,...E))},debug(w,...E){s(),a.then(o=>o.debug(w,...E))},info(w,...E){s(),a.then(o=>o.info(w,...E))},warn(w,...E){s(),a.then(o=>o.warn(w,...E))},error(w,...E){s(),a.then(o=>o.error(w,...E))},dispose(){r.dispose()}}}};e.$cbc=g,e.$cbc=g=Ke([We(0,I.$LL),We(1,f.$2L),We(2,k.$Rac),We(3,P.$mac),We(4,A.$Si),We(5,A.$Ri)],g),e.$dbc=(0,R.$ph)("IExtHostOutputService")}),define(Pe[264],Ae([1,0,4,13]),function(pe,e,y,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0l=e.$9l=void 0,e.$9l=(0,y.$ph)("remoteAgentService"),e.$0l=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(I){let M=1/0;for(let d=0;d<this.maxSampleCount;d++){const k=await I.getRoundTripTime();if(k===void 0)return;M=Math.min(M,k/2),await(0,R.$vg)(this.sampleDelay)}this.average.push(M),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(M):A=this.initial.reduce((d,k)=>d+k,0)/this.initial.length,this.lastMeasurement={initial:A,current:M,average:this.average.reduce((d,k)=>d+k,0)/this.average.length,high:(()=>typeof A>"u"?!1:M>this.highLatencyMaxThreshold||M>this.highLatencyMinThreshold&&M>A*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Pe[265],Ae([1,0,42,12,19,22,23,2,4,187,54,209,264]),function(pe,e,y,R,I,M,A,d,k,f,P,D,u){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$gJ=e.$fJ=void 0,e.$fJ=(0,k.$ph)("pathService");let p=b=class{constructor(t,i,c,g){this.d=t,this.e=i,this.f=c,this.g=g,this.a=(async()=>(await this.e.getEnvironment())?.os||M.OS)(),this.b=(async()=>{const S=await this.e.getEnvironment();return this.c=S?.userHome??t})()}hasValidBasename(t,i,c){return typeof i=="string"||typeof i>"u"?this.a.then(g=>this.h(t,g,i)):this.h(t,i,c)}h(t,i,c){return t.scheme===R.Schemas.file||t.scheme===R.Schemas.vscodeRemote?(0,y.$Fe)(c??(0,A.$6f)(t),i===1):!0}get defaultUriScheme(){return b.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(t,i){if(t.remoteAuthority)return R.Schemas.vscodeRemote;const c=(0,f.$cJ)(i.getWorkspace());if(c)return c;const g=i.getWorkspace().folders[0];if(g)return g.uri.scheme;const S=i.getWorkspace().configuration;return S?S.scheme:R.Schemas.file}userHome(t){return t?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(t=>t===1?I.$4c:I.$5c)}async fileURI(t){let i="";if(await this.a===1&&(t=t.replace(/\\/g,"/")),t[0]==="/"&&t[1]==="/"){const g=t.indexOf("/",2);g===-1?(i=t.substring(2),t="/"):(i=t.substring(2,g),t=t.substring(g)||"/")}return d.URI.from({scheme:R.Schemas.file,authority:i,path:t,query:"",fragment:""})}};e.$gJ=p,e.$gJ=p=b=Ke([We(1,u.$9l),We(2,D.$1I),We(3,P.$yh)],p)}),define(Pe[111],Ae([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$3H=e.$2H=void 0;class y{constructor(A,d){this.line=A,this.character=d}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,d){return new y(0,0)}with(A){return new y(0,0)}}e.$2H=y;class R{constructor(A,d,k,f){this.isEmpty=!1,this.isSingleLine=!1,this.start=new y(A,d),this.end=new y(k,f)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new R(0,0,0,0)}with(A){return new R(0,0,0,0)}}e.$3H=R;var I;(function(M){M[M.Information=1]="Information",M[M.Warning=2]="Warning"})(I||(e.TextSearchCompleteMessageType=I={}))}),define(Pe[47],Ae([1,0,18,37,24,42,15,4,19,9,111,13]),function(pe,e,y,R,I,M,A,d,k,f,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qI=e.$pI=e.$oI=e.$nI=e.$mI=e.$lI=e.$kI=e.$jI=e.$iI=e.$hI=e.$gI=e.$fI=e.SearchErrorCode=e.$eI=e.$dI=e.SearchSortOrder=e.ViewMode=e.$cI=e.$bI=e.$aI=e.$_H=e.SearchCompletionExitCode=e.$$H=e.$0H=e.$9H=e.QueryType=e.SearchProviderType=e.$8H=e.$7H=e.$6H=e.$5H=e.$4H=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return P.TextSearchCompleteMessageType}}),e.$4H="workbench.view.search",e.$5H="workbench.panel.search",e.$6H="workbench.view.search",e.$7H="search.exclude";const u="\u27EA ",b=" characters skipped \u27EB",p=(u.length+b.length+5)*2;e.$8H=(0,d.$ph)("searchService");var h;(function(X){X[X.file=0]="file",X[X.text=1]="text"})(h||(e.SearchProviderType=h={}));var t;(function(X){X[X.File=1]="File",X[X.Text=2]="Text"})(t||(e.QueryType=t={}));function i(X){return!!X.preview}e.$9H=i;function c(X){return!!X.resource}e.$0H=c;function g(X){return!!X.message}e.$$H=g;var S;(function(X){X[X.Normal=0]="Normal",X[X.NewSearchStarted=1]="NewSearchStarted"})(S||(e.SearchCompletionExitCode=S={}));class C{constructor(de){this.resource=de,this.results=[]}}e.$_H=C;class n{constructor(de,Ce,ae,_){this.ranges=Ce,this.webviewIndex=_;const ue=Array.isArray(Ce)?Ce:[Ce];if(ae&&ae.matchLines===1&&a(ue)){de=(0,A.$be)(de,ae.matchLines);let O="",J=0,le=0;const ye=Math.floor(ae.charsPerLine/5),ve=[];for(const be of ue){const ke=Math.max(be.startColumn-ye,0),oe=be.startColumn+ae.charsPerLine;if(ke>le+ye+p){const he=u+(ke-le)+b;O+=he+de.slice(ke,oe),J+=ke-(le+he.length)}else O+=de.slice(le,oe);ve.push(new s(0,be.startColumn-J,be.endColumn-J)),le=oe}this.preview={text:O,matches:Array.isArray(this.ranges)?ve:ve[0]}}else{const O=Array.isArray(Ce)?Ce[0].startLineNumber:Ce.startLineNumber;this.preview={text:de,matches:(0,y.$Ff)(Ce,J=>new r(J.startLineNumber-O,J.startColumn,J.endLineNumber-O,J.endColumn))}}}}e.$aI=n;function a(X){const de=X[0].startLineNumber;for(const Ce of X)if(Ce.startLineNumber!==de||Ce.endLineNumber!==de)return!1;return!0}class r{constructor(de,Ce,ae,_){this.startLineNumber=de,this.startColumn=Ce,this.endLineNumber=ae,this.endColumn=_}}e.$bI=r;class s extends r{constructor(de,Ce,ae){super(de,Ce,de,ae)}}e.$cI=s;var v;(function(X){X.List="list",X.Tree="tree"})(v||(e.ViewMode=v={}));var $;(function(X){X.Default="default",X.FileNames="fileNames",X.Type="type",X.Modified="modified",X.CountDescending="countDescending",X.CountAscending="countAscending"})($||(e.SearchSortOrder=$={}));function w(X,de=!0){const Ce=X&&X.files&&X.files.exclude,ae=de&&X&&X.search&&X.search.exclude;if(!Ce&&!ae)return;if(!Ce||!ae)return Ce||ae;let _=Object.create(null);return _=I.$Lm(_,I.$Im(Ce)),_=I.$Lm(_,I.$Im(ae),!0),_}e.$dI=w;function E(X,de){return X.excludePattern&&R.$dj(X.excludePattern,de)?!1:X.includePattern||X.usingSearchPaths?X.includePattern&&R.$dj(X.includePattern,de)?!0:X.usingSearchPaths?!!X.folderQueries&&X.folderQueries.some(Ce=>{const ae=Ce.folder.fsPath;if(M.$He(de,ae)){const _=k.$0c(ae,de);return!Ce.includePattern||!!R.$dj(Ce.includePattern,_)}else return!1}):!1:!0}e.$eI=E;var o;(function(X){X[X.unknownEncoding=1]="unknownEncoding",X[X.regexParseError=2]="regexParseError",X[X.globParseError=3]="globParseError",X[X.invalidLiteral=4]="invalidLiteral",X[X.rgProcessError=5]="rgProcessError",X[X.other=6]="other",X[X.canceled=7]="canceled"})(o||(e.SearchErrorCode=o={}));class l extends Error{constructor(de,Ce){super(de),this.code=Ce}}e.$fI=l;function m(X){const de=X.message;if((0,f.$2)(X))return new l(de,o.canceled);try{const Ce=JSON.parse(de);return new l(Ce.message,Ce.code)}catch{return new l(de,o.other)}}e.$gI=m;function F(X){const de={message:X.message,code:X.code};return new Error(JSON.stringify(de))}e.$hI=F;function W(X){return X.type==="error"?!0:X.type==="success"}e.$iI=W;function V(X){return X.type==="success"}e.$jI=V;function B(X){return!!X.path}e.$kI=B;function j(X,de){const Ce=X.searchPath?X.searchPath:X.relativePath;return(0,A.$$d)(Ce,de)}e.$lI=j;class U{constructor(de){this.path=de,this.results=[]}addMatch(de){this.results.push(de)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$mI=U;function z(X,de){const Ce={...X||{},...de||{}};return Object.keys(Ce).filter(ae=>{const _=Ce[ae];return typeof _=="boolean"&&_})}e.$nI=z;class ne{constructor(de,Ce){this.c=null,this.a={...de.excludePattern||{},...Ce.excludePattern||{}},this.b=R.$ej(this.a);let ae=de.includePattern;Ce.includePattern&&(ae?ae={...ae,...Ce.includePattern}:ae=Ce.includePattern),ae&&(this.c=R.$ej(ae))}matchesExcludesSync(de,Ce,ae){return!!(this.b&&this.b(de,Ce,ae))}includedInQuerySync(de,Ce,ae){return!(this.b&&this.b(de,Ce,ae)||this.c&&!this.c(de,Ce,ae))}includedInQuery(de,Ce,ae){const _=this.b(de,Ce,ae),ue=()=>this.c?!!this.c(de,Ce,ae):!0;return(0,D.$hg)(_)?_.then(O=>O?!1:ue()):ue()}hasSiblingExcludeClauses(){return Z(this.a)}}e.$oI=ne;function Z(X){for(const de in X)if(typeof X[de]!="boolean")return!0;return!1}function we(X){if(!X)return;let de;return Ce=>(de||(de=(X()||Promise.resolve([])).then(ae=>ae?Re(ae):{})),de.then(ae=>!!ae[Ce]))}e.$pI=we;function Ee(X){if(!X)return;let de;return Ce=>{if(!de){const ae=X();de=ae?Re(ae):{}}return!!de[Ce]}}e.$qI=Ee;function Re(X){const de={};for(const Ce of X)de[Ce]=!0;return de}}),define(Pe[33],Ae([1,0,18,13,21,5,6,48,12,118,23,15,2,159,4,14,176,54,39,27,17,8,7,56,47,3]),function(pe,e,y,R,I,M,A,d,k,f,P,D,u,b,p,h,t,i,c,g,S,C,n,a,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zac=e.$yac=void 0;function v(W,V,B){return new P.$Xf(j=>o(j,B)).isEqual(W,V)}function $(W,V,B){return v(W.uri,V.uri,B)?0:(0,D.$Ed)(W.uri.toString(),V.uri.toString())}function w(W,V,B){return W.index!==V.index?W.index<V.index?-1:1:v(W.uri,V.uri,B)?(0,D.$Ed)(W.name,V.name):(0,D.$Ed)(W.uri.toString(),V.uri.toString())}function E(W,V,B,j){const U=W.slice(0).sort((ne,Z)=>B(ne,Z,j)),z=V.slice(0).sort((ne,Z)=>B(ne,Z,j));return(0,y.$gf)(U,z,(ne,Z)=>B(ne,Z,j))}function o(W,V){const B=V.getCapabilities(W.scheme);return!(B&&B&1024)}class l extends i.$Ih{static toExtHostWorkspace(V,B,j,U){if(!V)return{workspace:null,added:[],removed:[]};const{id:z,name:ne,folders:Z,configuration:we,transient:Ee,isUntitled:Re}=V,X=[],de=B;B?Z.forEach((ue,O)=>{const J=u.URI.revive(ue.uri),le=l.o(j||B,J,U);le?(le.name=ue.name,le.index=ue.index,X.push(le)):X.push({uri:J,name:ue.name,index:O})}):X.push(...Z.map(({uri:ue,name:O,index:J})=>({uri:u.URI.revive(ue),name:O,index:J}))),X.sort((ue,O)=>ue.index<O.index?-1:1);const Ce=new l(z,ne,X,!!Ee,we?u.URI.revive(we):null,!!Re,ue=>o(ue,U)),{added:ae,removed:_}=E(de?de.workspaceFolders:[],Ce.workspaceFolders,$,U);return{workspace:Ce,added:ae,removed:_}}static o(V,B,j){for(let U=0;U<V.folders.length;U++){const z=V.workspaceFolders[U];if(v(z.uri,B,j))return z}}constructor(V,B,j,U,z,ne,Z){super(V,j.map(we=>new i.$Jh(we)),U,z,Z),this.t=B,this.u=ne,this.q=[],this.s=d.$vh.forUris(Z),j.forEach(we=>{this.q.push(we),this.s.set(we.uri,we)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(V,B){return B&&this.s.get(V)&&(V=(0,P.$8f)(V)),this.s.findSubstr(V)}resolveWorkspaceFolder(V){return this.s.get(V)}}let m=class{constructor(V,B,j,U,z){this.c=new M.$ec,this.onDidChangeWorkspace=this.c.event,this.g=new M.$ec,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new M.$gc,this.B=new Map,this.h=U,this.s=j,this.t=z,this.j=new f.$wl,this.k=new R.$tg,this.o=V.getProxy(s.$JJ.MainThreadWorkspace),this.q=V.getProxy(s.$JJ.MainThreadMessageService);const ne=B.workspace;this.l=ne?new l(ne.id,ne.name,[],!!ne.transient,ne.configuration?u.URI.revive(ne.configuration):null,!!ne.isUntitled,Z=>o(Z,j)):void 0}$initializeWorkspace(V,B){this.v=B,this.$acceptWorkspaceData(V),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?u.URI.from({scheme:k.Schemas.untitled,path:(0,P.$6f)((0,P.$8f)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(V,B,j,...U){const z=[];if(Array.isArray(U)&&U.forEach(Re=>{u.URI.isUri(Re.uri)&&!z.some(X=>v(X.uri,Re.uri,this.s))&&z.push({uri:Re.uri,name:Re.name||(0,P.$5f)(Re.uri)})}),this.n||[B,j].some(Re=>typeof Re!="number"||Re<0)||j===0&&z.length===0)return!1;const ne=this.x?this.x.workspaceFolders:[];if(B+j>ne.length)return!1;const Z=ne.slice(0);Z.splice(B,j,...z.map(Re=>({uri:Re.uri,name:Re.name||(0,P.$5f)(Re.uri),index:void 0})));for(let Re=0;Re<Z.length;Re++){const X=Z[Re];if(Z.some((de,Ce)=>Ce!==Re&&v(X.uri,de.uri,this.s)))return!1}Z.forEach((Re,X)=>Re.index=X);const{added:we,removed:Ee}=E(ne,Z,w,this.s);if(we.length===0&&Ee.length===0)return!1;if(this.o){const Re=V.displayName||V.name;this.o.$updateWorkspaceFolders(Re,B,j,z).then(void 0,X=>{this.n=void 0;const de={source:{identifier:V.identifier,label:V.displayName||V.name}};this.q.$showMessage(t.Severity.Error,(0,b.localize)(0,null,Re,X.toString()),de,[])})}return this.y(Z),!0}getWorkspaceFolder(V,B){if(this.x)return this.x.getWorkspaceFolder(V,B)}async getWorkspaceFolder2(V,B){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(V,B)}async resolveWorkspaceFolder(V){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(V)}getPath(){if(!this.x)return;const{folders:V}=this.x;if(V.length!==0)return V[0].uri.fsPath}getRelativePath(V,B){let j,U="";if(typeof V=="string"?(j=u.URI.file(V),U=V):typeof V<"u"&&(j=V,U=V.fsPath),!j)return U;const z=this.getWorkspaceFolder(j,!0);if(!z)return U;typeof B>"u"&&this.x&&(B=this.x.folders.length>1);let ne=(0,P.$$f)(z.uri,j);return B&&z.name&&(ne=`${z.name}/${ne}`),ne}y(V){this.x&&(this.n=l.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:V,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(V){const{workspace:B,added:j,removed:U}=l.toExtHostWorkspace(V,this.l,this.n,this.s);this.l=B||void 0,this.n=void 0,this.c.fire(Object.freeze({added:j,removed:U}))}findFiles(V,B,j,U,z=I.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${U.value}, entryPoint: findFiles`);let ne;if(B===null?ne=!1:B&&(typeof B=="string"?ne=B:ne=B.pattern),z&&z.isCancellationRequested)return Promise.resolve([]);const{includePattern:Z,folder:we}=F(C.GlobPattern.from(V));return this.o.$startFileSearch(Z??null,we??null,ne??null,j??null,z).then(Ee=>Array.isArray(Ee)?Ee.map(Re=>u.URI.revive(Re)):[])}async findTextInFiles(V,B,j,U,z=I.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${U.value}, entryPoint: findTextInFiles`);const ne=this.j.getNext(),Z=typeof B.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:B.previewOptions,{includePattern:we,folder:Ee}=F(C.GlobPattern.from(B.include)),Re=typeof B.exclude=="string"?B.exclude:B.exclude?B.exclude.pattern:void 0,X={ignoreSymlinks:typeof B.followSymlinks=="boolean"?!B.followSymlinks:void 0,disregardIgnoreFiles:typeof B.useIgnoreFiles=="boolean"?!B.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof B.useGlobalIgnoreFiles=="boolean"?!B.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof B.useParentIgnoreFiles=="boolean"?!B.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof B.useDefaultExcludes=="boolean"?!B.useDefaultExcludes:!0,fileEncoding:B.encoding,maxResults:B.maxResults,previewOptions:Z,afterContext:B.afterContext,beforeContext:B.beforeContext,includePattern:we,excludePattern:Re},de=!1;if(this.u[ne]=Ce=>{if(de)return;const ae=u.URI.revive(Ce.resource);Ce.results.forEach(_=>{(0,r.$9H)(_)?j({uri:ae,preview:{text:_.preview.text,matches:(0,y.$Ff)(_.preview.matches,ue=>new n.$NJ(ue.startLineNumber,ue.startColumn,ue.endLineNumber,ue.endColumn))},ranges:(0,y.$Ff)(_.ranges,ue=>new n.$NJ(ue.startLineNumber,ue.startColumn,ue.endLineNumber,ue.endColumn))}):j({uri:ae,text:_.text,lineNumber:_.lineNumber})})},z.isCancellationRequested)return{};try{const Ce=await this.o.$startTextSearch(V,Ee??null,X,ne,z);return delete this.u[ne],Ce||{}}catch(Ce){throw delete this.u[ne],Ce}}$handleTextSearchResult(V,B){this.u[B]?.(V)}async save(V){const B=await this.o.$save(V,{saveAs:!1});return u.URI.revive(B)}async saveAs(V){const B=await this.o.$save(V,{saveAs:!0});return u.URI.revive(B)}saveAll(V){return this.o.$saveAll(V)}resolveProxy(V){return this.o.$resolveProxy(V)}get trusted(){return this.v}requestWorkspaceTrust(V){return this.o.$requestWorkspaceTrust(V)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(V,B){if(this.w.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.w.set(V,B);const j=this.t.transformOutgoingScheme(V),U=this.z++;return this.o.$registerEditSessionIdentityProvider(U,j),(0,A.$jb)(()=>{this.w.delete(V),this.o.$unregisterEditSessionIdentityProvider(U)})}async $getEditSessionIdentifier(V,B){this.h.info("Getting edit session identifier for workspaceFolder",V);const j=await this.resolveWorkspaceFolder(u.URI.revive(V));if(!j){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",j);const U=this.w.get(j.uri.scheme);if(this.h.info(`Provider for scheme ${j.uri.scheme} is defined: `,!!U),!U)return;const z=await U.provideEditSessionIdentity(j,B);if(this.h.info("Provider returned edit session identifier: ",z),!!z)return z}async $provideEditSessionIdentityMatch(V,B,j,U){this.h.info("Getting edit session identifier for workspaceFolder",V);const z=await this.resolveWorkspaceFolder(u.URI.revive(V));if(!z){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",z);const ne=this.w.get(z.uri.scheme);if(this.h.info(`Provider for scheme ${z.uri.scheme} is defined: `,!!ne),!ne)return;const Z=await ne.provideEditSessionIdentityMatch?.(B,j,U);if(this.h.info("Provider returned edit session identifier match result: ",Z),!!Z)return Z}getOnWillCreateEditSessionIdentityEvent(V){return(B,j,U)=>{const z=function(Z){B.call(j,Z)};return z.extension=V,this.A.event(z,void 0,U)}}async $onWillCreateEditSessionIdentity(V,B,j){const U=await this.resolveWorkspaceFolder(u.URI.revive(V));if(U===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:U},B,async(z,ne)=>{const Z=Date.now();await Promise.resolve(z),Date.now()-Z>j&&this.h.warn("SLOW edit session create-participant",ne.extension.identifier)}),B.isCancellationRequested}registerCanonicalUriProvider(V,B){if(this.B.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.B.set(V,B);const j=this.t.transformOutgoingScheme(V),U=this.z++;return this.o.$registerCanonicalUriProvider(U,j),(0,A.$jb)(()=>{this.B.delete(V),this.o.$unregisterCanonicalUriProvider(U)})}async provideCanonicalUri(V,B,j){const U=this.B.get(V.scheme);if(!U)return;const z=await U.provideCanonicalUri?.(u.URI.revive(V),B,j);if(z)return z}async $provideCanonicalUri(V,B,j){return this.provideCanonicalUri(u.URI.revive(V),{targetScheme:B},j)}};e.$yac=m,e.$yac=m=Ke([We(0,S.$LL),We(1,g.$2L),We(2,c.$mac),We(3,h.$Ri),We(4,a.$wac)],m),e.$zac=(0,p.$ph)("IExtHostWorkspace");function F(W){let V,B;return W&&(typeof W=="string"?V=W:(V=W.pattern,B=u.URI.revive(W.baseUri))),{includePattern:V,folder:B}}}),define(Pe[34],Ae([1,0,24,5,33,3,7,178,96,16,13,4,17,14,2]),function(pe,e,y,R,I,M,A,d,k,f,P,D,u,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cac=e.$Bac=e.$Aac=void 0;function h(a,r){if(r){const s=r.split(".");let v=a;for(let $=0;v&&$<s.length;$++)v=v[s[$]];return v}}function t(a){return a instanceof p.URI}function i(a){return a&&a.uri instanceof p.URI&&a.languageId&&typeof a.languageId=="string"}function c(a){return a&&!a.uri&&a.languageId&&typeof a.languageId=="string"}function g(a){return a&&a.uri instanceof p.URI&&(!a.name||typeof a.name=="string")&&(!a.index||typeof a.index=="number")}function S(a){if(t(a))return{resource:a};if(i(a))return{resource:a.uri,overrideIdentifier:a.languageId};if(c(a))return{overrideIdentifier:a.languageId};if(g(a))return{resource:a.uri};if(a===null)return{resource:null}}let C=class{constructor(r,s,v){this.a=r.getProxy(M.$JJ.MainThreadConfiguration),this.c=s,this.b=v,this.d=new P.$tg,this.e=null}getConfigProvider(){return this.d.wait().then(r=>this.e)}$initializeConfiguration(r){this.e=new n(this.a,this.c,r,this.b),this.d.open()}$acceptConfigurationChanged(r,s){this.getConfigProvider().then(v=>v.$acceptConfigurationChanged(r,s))}};e.$Aac=C,e.$Aac=C=Ke([We(0,u.$LL),We(1,I.$zac),We(2,b.$Ri)],C);class n{constructor(r,s,v,$){this.a=new R.$ec,this.b=r,this.f=$,this.c=s,this.e=d.$gn.parse(v),this.d=this.k(v.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(r,s){const v={data:this.e.toData(),workspace:this.c.workspace};this.e=d.$gn.parse(r),this.d=this.k(r.configurationScopes),this.a.fire(this.j(s,v))}getConfiguration(r,s,v){const $=S(s)||{},w=this.g(r?h(this.e.getValue(void 0,$,this.c.workspace),r):this.e.getValue(void 0,$,this.c.workspace));r&&this.h(r,$,v?.identifier);function E(l){if(l==null)return null;if(typeof l=="boolean")return l?2:5;switch(l){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const o={has(l){return typeof h(w,l)<"u"},get:(l,m)=>{this.h(r?`${r}.${l}`:l,$,v?.identifier);let F=h(w,l);if(typeof F>"u")F=m;else{let W;const V=(B,j)=>{if((0,f.$ke)(B)){let U;const z=()=>{W=W||(0,y.$Im)(w),U=U||h(W,j)};return new Proxy(B,{get:(ne,Z)=>{if(typeof Z=="string"&&Z.toLowerCase()==="tojson")return z(),()=>U;if(W)return U=U||h(W,j),U[Z];const we=ne[Z];return typeof Z=="string"?V(we,`${j}.${Z}`):we},set:(ne,Z,we)=>(z(),U&&(U[Z]=we),!0),deleteProperty:(ne,Z)=>(z(),U&&delete U[Z],!0),defineProperty:(ne,Z,we)=>(z(),U&&Object.defineProperty(U,Z,we),!0)})}return Array.isArray(B)?(0,y.$Im)(B):B};F=V(F,l)}return F},update:(l,m,F,W)=>{l=r?`${r}.${l}`:l;const V=E(F);return m!==void 0?this.b.$updateConfigurationOption(V,l,m,$,W):this.b.$removeConfigurationOption(V,l,$,W)},inspect:l=>{l=r?`${r}.${l}`:l;const m=this.e.inspect(l,$,this.c.workspace);if(m)return{key:l,defaultValue:(0,y.$Im)(m.policy?.value??m.default?.value),globalValue:(0,y.$Im)(m.user?.value??m.application?.value),workspaceValue:(0,y.$Im)(m.workspace?.value),workspaceFolderValue:(0,y.$Im)(m.workspaceFolder?.value),defaultLanguageValue:(0,y.$Im)(m.default?.override),globalLanguageValue:(0,y.$Im)(m.user?.override??m.application?.override),workspaceLanguageValue:(0,y.$Im)(m.workspace?.override),workspaceFolderLanguageValue:(0,y.$Im)(m.workspaceFolder?.override),languageIds:(0,y.$Im)(m.overrideIdentifiers)}}};return typeof w=="object"&&(0,y.$Lm)(o,w,!1),Object.freeze(o)}g(r){const s=v=>(0,f.$ke)(v)?new Proxy(v,{get:($,w)=>s($[w]),set:($,w,E)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(w)}' of object`)},deleteProperty:($,w)=>{throw new Error(`TypeError: Cannot delete read only property '${String(w)}' of object`)},defineProperty:($,w)=>{throw new Error(`TypeError: Cannot define property '${String(w)}' for a readonly object`)},setPrototypeOf:$=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):v;return s(r)}h(r,s,v){const $=k.$0m.test(r)?4:this.d.get(r),w=v?`[${v.value}] `:"";if($===4){typeof s?.resource>"u"&&this.f.warn(`${w}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if($===3){s?.resource&&this.f.warn(`${w}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(r,s){const v=new d.$in(r,s,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:($,w)=>v.affectsConfiguration($,S(w))})}k(r){return r.reduce((s,v)=>(s.set(v[0],v[1]),s),new Map)}}e.$Bac=n,e.$Cac=(0,D.$ph)("IExtHostConfiguration")}),define(Pe[112],Ae([1,0,2,13,5,3,7,33,60,34,21,63,17,27,4,12,22,14,80,215,9]),function(pe,e,y,R,I,M,A,d,k,f,P,D,u,b,p,h,t,i,c,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Abc=e.$zbc=e.$ybc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var C;(function(V){function B(U){if(U!=null)return U}V.from=B;function j(U){if(U!=null)return U}V.to=j})(C||(C={}));var n;(function(V){function B(U){if(U!=null)return U}V.from=B;function j(U){if(U!=null)return U}V.to=j})(n||(n={}));var a;(function(V){function B(U){if(U!=null)return U}V.from=B;function j(U){if(U!=null)return U}V.to=j})(a||(a={}));var r;(function(V){function B(z){if(z){const ne=z;return ne&&!!ne.process}else return!1}V.is=B;function j(z){if(z==null)return;const ne={process:z.process,args:z.args};return z.options&&(ne.options=a.from(z.options)),ne}V.from=j;function U(z){if(z!=null)return new A.$uK(z.process,z.args,z.options)}V.to=U})(r||(r={}));var s;(function(V){function B(U){if(U!=null)return U}V.from=B;function j(U){if(U!=null)return U}V.to=j})(s||(s={}));var v;(function(V){function B(z){if(z){const ne=z;return ne&&(!!ne.commandLine||!!ne.command)}else return!1}V.is=B;function j(z){if(z==null)return;const ne={};return z.commandLine!==void 0?ne.commandLine=z.commandLine:(ne.command=z.command,ne.args=z.args),z.options&&(ne.options=s.from(z.options)),ne}V.from=j;function U(z){if(!(z==null||z.command===void 0&&z.commandLine===void 0))return z.commandLine?new A.$vK(z.commandLine,z.options):new A.$vK(z.command,z.args?z.args:[],z.options)}V.to=U})(v||(v={}));var $;(function(V){function B(z){if(z){const ne=z;return ne&&ne.customExecution==="customExecution"}else return!1}V.is=B;function j(z){return{customExecution:"customExecution"}}V.from=j;function U(z,ne){return ne.get(z)}V.to=U})($||(e.CustomExecutionDTO=$={}));var w;(function(V){function B(j,U){let z;return j.scope!==void 0&&typeof j.scope!="number"?z=j.scope.uri:j.scope!==void 0&&typeof j.scope=="number"&&(j.scope===A.TaskScope.Workspace&&U&&U.workspaceFile?z=U.workspaceFile:z=g.$ZF),{id:j._id,workspaceFolder:z}}V.from=B})(w||(e.TaskHandleDTO=w={}));var E;(function(V){function B(j){if(j!=null)return{_id:j.id,isDefault:j.isDefault}}V.from=B})(E||(E={}));var o;(function(V){function B(z,ne){if(z==null)return[];const Z=[];for(const we of z){const Ee=j(we,ne);Ee&&Z.push(Ee)}return Z}V.fromMany=B;function j(z,ne){if(z==null)return;let Z;z.execution instanceof A.$uK?Z=r.from(z.execution):z.execution instanceof A.$vK?Z=v.from(z.execution):z.execution&&z.execution instanceof A.$wK&&(Z=$.from(z.execution));const we=C.from(z.definition);let Ee;return z.scope?typeof z.scope=="number"?Ee=z.scope:Ee=z.scope.uri:Ee=A.TaskScope.Workspace,!we||!Ee?void 0:{_id:z._id,definition:we,name:z.name,source:{extensionId:ne.identifier.value,label:z.source,scope:Ee},execution:Z,isBackground:z.isBackground,group:E.from(z.group),presentationOptions:n.from(z.presentationOptions),problemMatchers:z.problemMatchers,hasDefinedMatchers:z.hasDefinedMatchers,runOptions:z.runOptions?z.runOptions:{reevaluateOnRerun:!0},detail:z.detail}}V.from=j;async function U(z,ne,Z){if(z==null)return;let we;r.is(z.execution)?we=r.to(z.execution):v.is(z.execution)?we=v.to(z.execution):$.is(z.execution)&&(we=$.to(z._id,Z));const Ee=C.to(z.definition);let Re;if(z.source&&(z.source.scope!==void 0?typeof z.source.scope=="number"?Re=z.source.scope:Re=await ne.resolveWorkspaceFolder(y.URI.revive(z.source.scope)):Re=A.TaskScope.Workspace),!Ee||!Re)return;const X=new A.$xK(Ee,Re,z.name,z.source.label,we,z.problemMatchers);return z.isBackground!==void 0&&(X.isBackground=z.isBackground),z.group!==void 0&&(X.group=A.$tK.from(z.group._id),X.group&&z.group.isDefault&&(X.group=new A.$tK(X.group.id,X.group.label),z.group.isDefault===!0&&(X.group.isDefault=z.group.isDefault))),z.presentationOptions&&(X.presentationOptions=n.to(z.presentationOptions)),z._id&&(X._id=z._id),z.detail&&(X.detail=z.detail),X}V.to=U})(o||(e.TaskDTO=o={}));var l;(function(V){function B(U){return U}V.from=B;function j(U){if(U)return Object.assign(Object.create(null),U)}V.to=j})(l||(l={}));class m{#e;constructor(B,j,U){this._id=j,this.a=U,this.#e=B}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(B){}fireDidEndProcess(B){}}let F=class{constructor(B,j,U,z,ne,Z,we,Ee){this.q=new I.$ec,this.r=new I.$ec,this.s=new I.$ec,this.t=new I.$ec,this.a=B.getProxy(M.$JJ.MainThreadTask),this.b=U,this.c=z,this.d=ne,this.e=Z,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=we,this.g=Ee,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(B,j,U){if(!U)return new A.$LJ(()=>{});const z=this.w();return this.j.set(z,{type:j,provider:U,extension:B}),this.a.$registerTaskProvider(z,j),new A.$LJ(()=>{this.j.delete(z),this.a.$unregisterTaskProvider(z)})}registerTaskSystem(B,j){this.a.$registerTaskSystem(B,j)}fetchTasks(B){return this.a.$fetchTasks(l.from(B)).then(async j=>{const U=[];for(const z of j){const ne=await o.to(z,this.b,this.m);ne&&U.push(ne)}return U})}get taskExecutions(){const B=[];return this.k.forEach(j=>B.push(j)),B}terminateTask(B){if(!(B instanceof m))throw new Error("No valid task execution provided");return this.a.$terminateTask(B._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(B,j,U){const z=this.m.get(B.id);z&&(this.o.set(B.id,z),this.e.attachPtyToTerminal(j,await z.callback(U))),this.p=B.id,this.q.fire({execution:await this.y(B)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(B){const j=await this.y(B);this.l.delete(B.id),this.k.delete(B.id),this.A(B),this.r.fire({execution:j})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(B){const j=await this.y(B.id);this.s.fire({execution:j,processId:B.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(B){const j=await this.y(B.id);this.t.fire({execution:j,exitCode:B.exitCode})}$provideTasks(B,j){const U=this.j.get(B);if(!U)return Promise.reject(new Error("no handler found"));const z=[],ne=(0,R.$ng)(()=>U.provider.provideTasks(P.CancellationToken.None)).then(Z=>this.u(j,z,U,Z));return new Promise(Z=>{ne.then(we=>{Promise.all(z).then(()=>{Z(we)})})})}async $resolveTask(B,j){const U=this.j.get(B);if(!U)return Promise.reject(new Error("no handler found"));if(j.definition.type!==U.type)throw new Error(`Unexpected: Task of type [${j.definition.type}] cannot be resolved by provider of type [${U.type}].`);const z=await o.to(j,this.b,this.m);if(!z)throw new Error("Unexpected: Task cannot be resolved.");const ne=await U.provider.resolveTask(z,P.CancellationToken.None);if(!ne)return;this.z(ne,U);const Z=o.from(ne,U.extension);if(!Z)throw new Error("Unexpected: Task cannot be resolved.");if(ne.definition!==z.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return $.is(Z.execution)&&await this.x(Z,ne,!0),await this.v(Z)}w(){return this.h++}async x(B,j,U){const z=await this.a.$createTaskId(B);!U&&!this.m.has(z)&&(this.n.add(z),this.o.set(z,j.execution)),this.m.set(z,j.execution)}async y(B,j){if(typeof B=="string"){const ne=this.l.get(B);if(!ne)throw new S.$ab("Unexpected: The specified task is missing an execution");return ne}const U=this.l.get(B.id);if(U)return U;const z=new Promise((ne,Z)=>{function we(Ee,Re,X){X?ne(new m(Ee,Re.id,X)):Z("Unexpected: Task does not exist.")}j?we(this,B,j):o.to(B.task,this.b,this.m).then(Ee=>we(this,B,Ee))});return this.l.set(B.id,z),z.then(ne=>(this.k.set(B.id,ne),ne),ne=>Promise.reject(ne))}z(B,j){B._deprecated&&this.g.report("Task.constructor",j.extension,"Use the Task constructor that takes a `scope` instead.")}A(B){this.o.get(B.id)&&this.o.delete(B.id),this.n.has(B.id)&&this.p!==B.id&&(this.m.delete(B.id),this.n.delete(B.id));const U=this.n.values();let z=U.next();for(;!z.done;)!this.o.has(z.value)&&this.p!==z.value&&(this.m.delete(z.value),this.n.delete(z.value)),z=U.next()}};e.$ybc=F,e.$ybc=F=Ke([We(0,u.$LL),We(1,b.$2L),We(2,d.$zac),We(3,k.$WL),We(4,f.$Cac),We(5,D.$Uac),We(6,i.$Ri),We(7,c.$pac)],F);let W=class extends F{constructor(B,j,U,z,ne,Z,we,Ee){super(B,j,U,z,ne,Z,we,Ee),this.registerTaskSystem(h.Schemas.vscodeRemote,{scheme:h.Schemas.vscodeRemote,authority:"",platform:t.$h(0)})}async executeTask(B,j){if(!j.execution)throw new Error("Tasks to execute must include an execution");const U=o.from(j,B);if(U===void 0)throw new Error("Task is not valid");if($.is(U.execution))await this.x(U,j,!1);else throw new S.$$;const z=await this.y(await this.a.$getTaskExecution(U),j);return this.a.$executeTask(U).catch(ne=>{throw new Error(ne)}),z}u(B,j,U,z){const ne=[];if(z)for(const Z of z){this.z(Z,U),(!Z.definition||!B[Z.definition.type])&&this.f.warn(`The task [${Z.source}, ${Z.name}] uses an undefined task type. The task will be ignored in the future.`);const we=o.from(Z,U.extension);we&&$.is(we.execution)?(ne.push(we),j.push(this.x(we,Z,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:ne,extension:U.extension}}async v(B){if($.is(B.execution))return B;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(B,j){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(B,j,U){}};e.$zbc=W,e.$zbc=W=Ke([We(0,u.$LL),We(1,b.$2L),We(2,d.$zac),We(3,k.$WL),We(4,f.$Cac),We(5,D.$Uac),We(6,i.$Ri),We(7,c.$pac)],W),e.$Abc=(0,p.$ph)("IExtHostTask")}),define(Pe[266],Ae([1,0,19,21,41,37,23,59,47]),function(pe,e,y,R,I,M,A,d,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kbc=void 0;class f{constructor(u,b,p){this.k=u,this.l=b,this.o=p,this.e=!1,this.f=0,this.g=!1,this.a=u.filePattern,this.b=u.includePattern&&M.$ej(u.includePattern),this.c=u.maxResults||void 0,this.d=u.exists,this.h=new Set,this.j=u.excludePattern&&M.$ej(u.excludePattern)}cancel(){this.g=!0,this.h.forEach(u=>u.cancel()),this.h=new Set}search(u){const b=this.k.folderQueries||[];return new Promise((p,h)=>{const t=i=>{this.f++,u(i)};if(this.g)return p({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(i=>{const c=i.toString(),g=y.$_c(c);this.j&&this.j(c,g)||this.v(t,{base:i,basename:g})}),Promise.all(b.map(i=>this.p(i,t))).then(i=>{p({limitHit:this.e,stats:i[0]||void 0})},i=>{h(new Error((0,I.$ai)(i)))})})}async p(u,b){const p=new R.$oc,h=this.q(u),t=this.r(),i=new k.$oI(this.k,u),c=!i.hasSiblingExcludeClauses();let g;try{this.h.add(p),g=d.$ac.create();const S=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},h,p.token),C=g.elapsed(),n=d.$ac.create();return this.g&&!this.e||(S&&S.forEach(a=>{const r=y.$5c.relative(u.folder.path,a.path);if(c){const s=y.$_c(a.path);this.v(b,{base:u.folder,relativePath:r,basename:s});return}this.s(t,u.folder,r,b)}),this.g&&!this.e)?null:(this.u(t,i,b),{providerTime:C,postProcessTime:n.elapsed()})}finally{p.dispose(),this.h.delete(p)}}q(u){const b=(0,k.$nI)(this.k.includePattern,u.includePattern),p=(0,k.$nI)(this.k.excludePattern,u.excludePattern);return{folder:u.folder,excludes:p,includes:b,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!u.disregardParentIgnoreFiles,followSymlinks:!u.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}s({pathToEntries:u},b,p,h){if(p===this.a){const i=y.$_c(this.a);this.v(h,{base:b,relativePath:this.a,basename:i})}function t(i){const c=y.$_c(i),g=y.$$c(i);let S=u[g];S||(S=u[g]=[],t(g)),S.push({base:b,relativePath:i,basename:c})}t(p)}u({rootEntries:u,pathToEntries:b},p,h){const t=this,i=this.a;function c(g){const S=(0,k.$qI)(()=>g.map(C=>C.basename));for(let C=0,n=g.length;C<n;C++){const a=g[C],{relativePath:r,basename:s}=a;if(p.matchesExcludesSync(r,s,i!==s?S:void 0))continue;const v=b[r];if(v)c(v);else{if(r===i)continue;t.v(h,a)}if(t.e)break}}c(u)}v(u,b){(!this.b||b.relativePath&&this.b(b.relativePath,b.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||u(b))}}class P{constructor(){this.b=new Map}static{this.a=512}fileSearch(u,b,p,h){const t=this.c(u.cacheKey),i=new f(u,b,t&&t.token);let c=0;const g=S=>{c+=S.length,p(S.map(C=>this.d(C)))};return this.e(i,P.a,g,h).then(S=>({limitHit:S.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:c,detailStats:S.stats}}))}clearCache(u){this.c(u)?.cancel()}c(u){if(u)return this.b.has(u)||this.b.set(u,new R.$oc),this.b.get(u)}d(u){return u.relativePath?{resource:A.$9f(u.base,u.relativePath)}:{resource:u.base}}e(u,b,p,h){h.onCancellationRequested(()=>{u.cancel()});const t=c=>{c&&(i.push(c),b>0&&i.length>=b&&(p(i),i=[]))};let i=[];return u.search(t).then(c=>(i.length&&p(i),c),c=>(i.length&&p(i),Promise.reject(c)))}}e.$Kbc=P}),define(Pe[267],Ae([1,0,18,100,37,90,28,12,19,23,15,16,2,281,168,43,14,54,103,265,47]),function(pe,e,y,R,I,M,A,d,k,f,P,D,u,b,p,h,t,i,c,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iJ=e.$hJ=void 0;let C=class{constructor(l,m,F,W,V){this.a=l,this.b=m,this.c=F,this.d=W,this.e=V}text(l,m,F={}){l=this.f(l,F);const W=this.a.getValue(),V=m&&m.some(j=>!this.a.getValue({resource:j}).search.useRipgrep);return{...this.h(m?.map(i.$Kh),F),type:2,contentPattern:l,previewOptions:F.previewOptions,maxFileSize:F.maxFileSize,usePCRE2:W.search.usePCRE2||V||!1,beforeContext:F.beforeContext,afterContext:F.afterContext,userDisabledExcludesAndIgnoreFiles:F.disregardExcludeSettings&&F.disregardIgnoreFiles}}f(l,m){const F=this.a.getValue();l.isRegExp&&(l.pattern=l.pattern.replace(/\r?\n/g,"\\n"));const W={...l,wordSeparators:F.editor.wordSeparators};return this.j(l,m)&&(W.isCaseSensitive=!0),this.k(l)&&(W.isMultiline=!0),m.notebookSearchConfig?.includeMarkupInput&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookMarkdownInput=m.notebookSearchConfig.includeMarkupInput),m.notebookSearchConfig?.includeMarkupPreview&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookMarkdownPreview=m.notebookSearchConfig.includeMarkupPreview),m.notebookSearchConfig?.includeCodeInput&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookCellInput=m.notebookSearchConfig.includeCodeInput),m.notebookSearchConfig?.includeOutput&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookCellOutput=m.notebookSearchConfig.includeOutput),W}file(l,m={}){return{...this.h(l,m),type:1,filePattern:m.filePattern?m.filePattern.trim():m.filePattern,exists:m.exists,sortByScore:m.sortByScore,cacheKey:m.cacheKey}}g(l,m){return l?(l=Array.isArray(l)?l.map(v):v(l),m?this.parseSearchPaths(l):{pattern:a(...Array.isArray(l)?l:[l])}):{}}h(l=[],m={}){const F=this.g(m.includePattern,m.expandPatterns),W=this.g(m.excludePattern,m.expandPatterns),V=l.length>1,B=(F.searchPaths&&F.searchPaths.length?F.searchPaths.map(z=>this.q(z,m,W)):l.map(z=>this.r(z,m,W,V))).filter(z=>!!z),j={_reason:m._reason,folderQueries:B,usingSearchPaths:!!(F.searchPaths&&F.searchPaths.length),extraFileResources:m.extraFileResources,excludePattern:W.pattern,includePattern:F.pattern,onlyOpenEditors:m.onlyOpenEditors,maxResults:m.maxResults};if(m.onlyOpenEditors){const z=y.$jf(y.$vf(this.c.groups.map(we=>we.editors.map(Ee=>Ee.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(z));const ne=z.filter(we=>(0,S.$eI)(j,we.fsPath)),Z=this.i(ne);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(Z)),{...j,...Z}}const U=m.extraFileResources&&m.extraFileResources.filter(z=>(0,S.$eI)(j,z.fsPath));return j.extraFileResources=U&&U.length?U:void 0,j}i(l){const m=[],F=new A.$ni,W={};let V=!1;return l.forEach(B=>{if(B.scheme===d.Schemas.walkThrough)return;if((0,f.$ag)(B)){const U=this.b.getWorkspaceFolder(B)?.uri??B.with({path:k.$$c(B.fsPath)});let z=F.get(U);z||(V=!0,z={folder:U,includePattern:{}},m.push(z),F.set(U,z));const ne=k.$0c(U.fsPath,B.fsPath);(0,D.$te)(z.includePattern)[ne.replace(/\\/g,"/")]=!0}else B.fsPath&&(V=!0,W[B.fsPath]=!0)}),{folderQueries:m,includePattern:W,usingSearchPaths:!0,excludePattern:V?void 0:{"**/*":!0}}}j(l,m){if(m.isSmartCase){if(l.isRegExp){if(P.$_d(l.pattern,!0))return!0}else if(P.$_d(l.pattern))return!0}return!!l.isCaseSensitive}k(l){return l.isMultiline||l.isRegExp&&(0,b.$0B)(l.pattern)||l.pattern.indexOf(`
`)>=0?!0:!!l.isMultiline}parseSearchPaths(l){const m=Z=>k.$7c(Z)||/^\.\.?([\/\\]|$)/.test(Z),W=(Array.isArray(l)?l:r(l)).map(Z=>{const we=this.e.resolvedUserHome;return we?(0,M.$9z)(Z,we.scheme===d.Schemas.file?we.fsPath:we.path):Z}),V=R.$I(W,Z=>m(Z)?"searchPaths":"exprSegments"),B=(V.exprSegments||[]).map(Z=>P.$ud(Z,"/")).map(Z=>P.$ud(Z,"\\")).map(Z=>(Z[0]==="."&&(Z="*"+Z),s(Z))),j={},U=this.m(V.searchPaths||[]);U&&U.length&&(j.searchPaths=U);const z=y.$vf(B),ne=a(...z);return ne&&(j.pattern=ne),j}l(l,m){return m.disregardExcludeSettings?void 0:(0,S.$dI)(l,!m.disregardSearchExcludeSettings)}m(l){if(!l||!l.length)return[];const m=l.flatMap(W=>{let{pathPortion:V,globPortion:B}=n(W);return B&&(B=$(B)),this.n(V).flatMap(U=>this.o(U,B))}),F=new Map;return m.forEach(W=>{const V=W.searchPath.toString(),B=F.get(V);B?W.pattern&&(B.pattern=B.pattern||{},B.pattern[W.pattern]=!0):F.set(V,{searchPath:W.searchPath,pattern:W.pattern?a(W.pattern):void 0})}),Array.from(F.values())}n(l){if(k.$7c(l)){const m=this.b.getWorkspace().folders;return m[0]&&m[0].uri.scheme!==d.Schemas.file?[{searchPath:m[0].uri.with({path:l})}]:[{searchPath:u.URI.file(k.$6c(l))}]}if(this.b.getWorkbenchState()===2){const m=this.b.getWorkspace().folders[0].uri;if(l=v(l),l.startsWith("../")||l===".."){const W=k.$5c.resolve(m.path,l);return[{searchPath:m.with({path:W})}]}const F=$(l);return[{searchPath:m,pattern:F}]}else{if(l==="./"||l===".\\")return[];{const m=l.replace(/^\.[\/\\]/,""),W=this.b.getWorkspace().folders.map(V=>{const B=m.match(new RegExp(`^${P.$pd(V.name)}(?:/(.*)|$)`));return B?{match:B,folder:V}:null}).filter(D.$qe);if(W.length)return W.map(V=>{const B=V.match[1];return{searchPath:V.folder.uri,pattern:B&&$(B)}});{const V=l.match(/\.[\/\\](.+)[\/\\]?/),B=V?V[1]:l,j=p.localize(0,null,B);throw new Error(j)}}}}o(l,m){const F=l.pattern&&m?`${l.pattern}/${m}`:l.pattern||m,W=[{searchPath:l.searchPath,pattern:F}];return F&&!F.endsWith("**")&&W.push({searchPath:l.searchPath,pattern:F+"/**"}),W}q(l,m,F){const W=this.r((0,i.$Kh)(l.searchPath),m,F,!1);return W?{...W,includePattern:l.pattern}:null}r(l,m,F,W){let V;const B=u.URI.isUri(l)?l:l.uri;if(F.searchPaths){const Z=F.searchPaths.filter(we=>(0,f.$2f)(we.searchPath,B))[0];if(Z&&!Z.pattern)return null;Z&&(V=Z.pattern)}const j=this.a.getValue({resource:B}),z={...this.l(j,m)||{},...V||{}},ne=u.URI.isUri(l)?(0,f.$6f)(l):l.name;return{folder:B,folderName:W?ne:void 0,excludePattern:Object.keys(z).length>0?z:void 0,fileEncoding:j.files&&j.files.encoding,disregardIgnoreFiles:typeof m.disregardIgnoreFiles=="boolean"?m.disregardIgnoreFiles:!j.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof m.disregardGlobalIgnoreFiles=="boolean"?m.disregardGlobalIgnoreFiles:!j.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof m.disregardParentIgnoreFiles=="boolean"?m.disregardParentIgnoreFiles:!j.search.useParentIgnoreFiles,ignoreSymlinks:typeof m.ignoreSymlinks=="boolean"?m.ignoreSymlinks:!j.search.followSymlinks}}};e.$hJ=C,e.$hJ=C=Ke([We(0,h.$Vh),We(1,i.$yh),We(2,c.$TC),We(3,t.$Ri),We(4,g.$fJ)],C);function n(o){const l=o.match(/[\*\{\}\(\)\[\]\?]/);if(l){const m=l.index,F=o.substr(0,m).match(/[/|\\][^/\\]*$/);if(F){let W=o.substr(0,F.index);return W.match(/[/\\]/)||(W+="/"),{pathPortion:W,globPortion:o.substr((F.index||0)+1)}}}return{pathPortion:o}}function a(...o){return o.length?o.reduce((l,m)=>(l[m]=!0,l),Object.create(null)):void 0}function r(o){return I.$cj(o,",").map(l=>l.trim()).filter(l=>!!l.length)}function s(o){return[`**/${o}/**`,`**/${o}`].map(m=>m.replace(/\*\*\/\*\*/g,"**"))}function v(o){return o.replace(/\\/g,"/")}function $(o){return v(o).replace(/^\.\//,"").replace(/\/+$/g,"")}function w(o){return o.replace(/([?*[\]])/g,"[$1]")}function E(o,l){o=y.$of(o,W=>W.toString());const m=[],F=l.getWorkspace();return o&&o.forEach(W=>{let V;if(l.getWorkbenchState()===2)V=(0,f.$$f)(F.folders[0].uri,W),V&&V!=="."&&(V="./"+V);else{const B=l.getWorkspaceFolder(W);if(B){const j=B.name;if(F.folders.filter(z=>z.name===j).length===1){const z=(0,f.$$f)(B.uri,W);z===""?V=`./${B.name}`:V=`./${B.name}/${z}`}else V=W.fsPath}}V&&m.push(w(V))}),m}e.$iJ=E}),define(Pe[268],Ae([1,0,23,2,21,9,4,267,47,54]),function(pe,e,y,R,I,M,A,d,k,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xkb=e.$Wkb=void 0;const P=7e3;function D(h,t){const i=t.activationEvents;if(!i)return Promise.resolve(void 0);const c=[],g=[];for(const s of i)if(/^workspaceContains:/.test(s)){const v=s.substr(18);v.indexOf("*")>=0||v.indexOf("?")>=0||h.forceUsingSearch?g.push(v):c.push(v)}if(c.length===0&&g.length===0)return Promise.resolve(void 0);let S;const C=new Promise((s,v)=>{S=s}),n=s=>S({activationEvent:s}),a=Promise.all(c.map(s=>u(h,s,n))).then(()=>{}),r=b(h,t.identifier,g,n);return Promise.all([a,r]).then(()=>{S(void 0)}),C}e.$Wkb=D;async function u(h,t,i){for(const c of h.folders)if(await h.exists(y.$9f(R.URI.revive(c),t))){i(`workspaceContains:${t}`);return}}async function b(h,t,i,c){if(i.length===0)return Promise.resolve(void 0);const g=new I.$oc,S=h.checkExists(h.folders,i,g.token),C=setTimeout(async()=>{g.cancel(),h.logService.info(`Not activating extension '${t.value}': Timed out while searching for 'workspaceContains' pattern ${i.join(",")}`)},P);let n=!1;try{n=await S}catch(a){M.$2(a)||M.$Y(a)}g.dispose(),clearTimeout(C),n&&c(`workspaceContains:${i.join(",")}`)}function p(h,t,i,c){const g=h.get(A.$oh),S=h.get(k.$8H),n=g.createInstance(d.$hJ).file(t.map(a=>(0,f.$Kh)(R.URI.revive(a))),{_reason:"checkExists",includePattern:i,exists:!0});return S.fileSearch(n,c).then(a=>!!a.limitHit,a=>M.$2(a)?!1:Promise.reject(a))}e.$Xkb=p}),define(Pe[35],Ae([1,0,149,19,87,23,13,6,48,2,14,3,34,210,84,33,26,107,9,20,25,189,7,97,4,27,85,17,72,86,63,5,268,83,191,12,81,59,22,82]),function(pe,e,y,R,I,M,A,d,k,f,P,D,u,b,p,h,t,i,c,g,S,C,n,a,r,s,v,$,w,E,o,l,m,F,W,V,B,j,U,z){"use strict";var ne;Object.defineProperty(e,"__esModule",{value:!0}),e.$0ac=e.$9ac=e.$8ac=e.$7ac=e.$6ac=void 0,e.$6ac=(0,r.$ph)("IHostUtils");let Z=ne=class extends d.$lb{constructor(_,ue,O,J,le,ye,ve,be,ke,oe,he,re){super(),this.R=re,this.a=this.B(new l.$ec),this.onDidChangeRemoteConnectionData=this.a.event,this.P=!1,this.c=ue,this.g=O,this.f=ve,this.j=J,this.k=le,this.l=ye,this.m=ke,this.p=oe,this.s=he,this.t=this.g.getProxy(D.$JJ.MainThreadWorkspace),this.u=this.g.getProxy(D.$JJ.MainThreadTelemetry),this.v=this.g.getProxy(D.$JJ.MainThreadExtensionService),this.w=new A.$tg,this.y=new A.$tg,this.z=new A.$tg,this.C=new A.$tg,this.D=new Ce(this.f.activationEvents),this.G=new i.$P2b(this.D,this.f.allExtensions);const ie=new g.$Jl(this.f.myExtensions);this.F=new i.$P2b(this.D,X(this.G,ie)),this.H=new p.$Mac(this.g,this.l),this.I=new F.$Yac(this.g),this.J=be,this.h=_.createChild(new w.$nh([p.$Nac,this.H],[F.$Zac,this.I])),this.L=this.B(new b.$Lac(this.F,this.G,{onExtensionActivationError:(ge,Se,L)=>{this.v.$onExtensionActivationError(ge,c.$1(Se),L)},actualActivateExtension:async(ge,Se)=>{if(i.$P2b.isHostExtension(ge,this.F,this.G))return await this.v.$activateExtension(ge,Se),new b.$Kac;const L=this.F.getExtensionDescription(ge);return this.$(L,Se)}},this.l)),this.M=null,this.N=Object.create(null),this.O=!1,this.Q=this.f.remote.connectionData}getRemoteConnectionData(){return this.Q}async initialize(){try{await this.pb(),this.w.open(),await this.j.waitForInitializeCall(),I.mark("code/extHost/ready"),this.y.open(),this.f.autoStart&&this.nb()}catch(_){c.$Y(_)}}async S(){this.J.onWillDeactivateAll();let _=[];try{_=this.F.getAllExtensionDescriptions().map(le=>le.identifier).filter(le=>this.isActivated(le)).map(le=>this.Z(le))}catch{}await Promise.all(_)}terminate(_,ue=0){if(this.P)return;this.P=!0,this.l.info(`Extension host terminating: ${_}`),this.l.flush(),this.p.dispose(),this.L.dispose(),c.setUnexpectedErrorHandler(J=>{this.l.error(J)}),this.g.dispose();const O=this.S();Promise.race([(0,A.$vg)(5e3),O]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${ue}`):this.l.info(`Extension host exiting with code ${ue}`),this.l.flush(),this.l.dispose(),this.c.exit(ue)})}isActivated(_){return this.z.isOpen()?this.L.isActivated(_):!1}async getExtension(_){const ue=await this.v.$getExtension(_);return ue&&{...ue,identifier:new g.$Il(ue.identifier.value),extensionLocation:f.URI.revive(ue.extensionLocation)}}U(_,ue){return this.L.activateByEvent(_,ue)}W(_,ue){return this.L.activateById(_,ue)}activateByIdWithErrors(_,ue){return this.W(_,ue).then(()=>{const O=this.L.getActivatedExtension(_);if(O.activationFailed)return Promise.reject(O.activationFailedError)})}getExtensionRegistry(){return this.z.wait().then(_=>this.F)}getExtensionExports(_){if(this.z.isOpen())return this.L.getActivatedExtension(_).exports;try{return this.L.getActivatedExtension(_).exports}catch{return null}}async X(_){if(_.scheme===V.Schemas.file&&this.c.fsRealpath){const ue=await this.c.fsRealpath(_.fsPath);return f.URI.file(ue)}return _}async getExtensionPathIndex(){return this.M||(this.M=this.Y(this.F.getAllExtensionDescriptions()).then(_=>new de(_))),this.M}async Y(_){const ue=k.$vh.forUris(O=>M.$Zf.ignorePathCasing(O));return await Promise.all(_.map(async O=>{if(this.qb(O)){const J=await this.X(O.extensionLocation);ue.set(J,O)}})),ue}Z(_){let ue=Promise.resolve(void 0);if(!this.z.isOpen()||!this.L.isActivated(_))return ue;const O=this.L.getActivatedExtension(_);if(!O)return ue;try{typeof O.module.deactivate=="function"&&(ue=Promise.resolve(O.module.deactivate()).then(void 0,J=>(this.l.error(J),Promise.resolve(void 0))))}catch(J){this.l.error(`An error occurred when deactivating the extension '${_.value}':`),this.l.error(J)}try{(0,d.$gb)(O.subscriptions)}catch(J){this.l.error(`An error occurred when deactivating the subscriptions for extension '${_.value}':`),this.l.error(J)}return ue}async $(_,ue){return this.f.remote.isRemote?this.v.$onWillActivateExtension(_.identifier):await this.v.$onWillActivateExtension(_.identifier),this.bb(_,ue).then(O=>{const J=O.activationTimes;return this.v.$onDidActivateExtension(_.identifier,J.codeLoadingTime,J.activateCallTime,J.activateResolvedTime,ue),this.ab(_,ue,"success",J),O},O=>{throw this.ab(_,ue,"failure"),O})}ab(_,ue,O,J){const le=Ee(_,ue);this.u.$publicLog2("extensionActivationTimes",{...le,...J||{},outcome:O})}bb(_,ue){const O=Ee(_,ue);this.u.$publicLog2("activatePlugin",O);const J=this.qb(_);if(!J)return Promise.resolve(new b.$Jac(b.$Gac.NONE));this.l.info(`ExtensionService#_doActivateExtension ${_.identifier.value}, startup: ${ue.startup}, activationEvent: '${ue.activationEvent}'${_.identifier.value!==ue.extensionId.value?`, root cause: ${ue.extensionId.value}`:""}`),this.l.flush();const le=new b.$Hac(ue.startup);return Promise.all([this.rb(_,(0,M.$9f)(_.extensionLocation,J),le),this.cb(_)]).then(ye=>(I.mark(`code/extHost/willActivateExtension/${_.identifier.value}`),ne.db(this.l,_.identifier,ye[0],ye[1],le))).then(ye=>(I.mark(`code/extHost/didActivateExtension/${_.identifier.value}`),ye))}cb(_){const ue=new C.$Pac(_,this.H),O=new C.$Oac(_.identifier.value,!1,this.H),J=new W.$1ac(_,this.I),le=_.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?n.ExtensionMode.Test:n.ExtensionMode.Development:n.ExtensionMode.Production,ye=this.f.remote.isRemote?n.ExtensionKind.Workspace:n.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${_.identifier.value}`),Promise.all([ue.whenReady,O.whenReady,this.J.whenReady]).then(()=>{const ve=this;let be,ke;const oe=(0,t.$DF)(_,"ipc")?this.f.messagePorts?.get(g.$Il.toKey(_.identifier)):void 0;return Object.freeze({globalState:ue,workspaceState:O,secrets:J,subscriptions:[],get extensionUri(){return _.extensionLocation},get extensionPath(){return _.extensionLocation.fsPath},asAbsolutePath(he){return R.$8c(_.extensionLocation.fsPath,he)},get storagePath(){return ve.J.workspaceValue(_)?.fsPath},get globalStoragePath(){return ve.J.globalValue(_).fsPath},get logPath(){return R.$8c(ve.f.logsLocation.fsPath,_.identifier.value)},get logUri(){return f.URI.joinPath(ve.f.logsLocation,_.identifier.value)},get storageUri(){return ve.J.workspaceValue(_)},get globalStorageUri(){return ve.J.globalValue(_)},get extensionMode(){return le},get extension(){return be===void 0&&(be=new Re(ve,_.identifier,_,ye,!1)),be},get extensionRuntime(){return(0,t.$EF)(_,"extensionRuntime"),ve.extensionRuntime},get environmentVariableCollection(){return ve.p.getEnvironmentVariableCollection(_)},get messagePassingProtocol(){if(!ke){if(!oe)return;const he=l.Event.buffer(l.Event.fromDOMEventEmitter(oe,"message",re=>re.data));oe.start(),ke={onDidReceiveMessage:he,postMessage:oe.postMessage.bind(oe)}}return ke}})})}static db(_,ue,O,J,le){return O=O||{activate:void 0,deactivate:void 0},this.eb(_,ue,O,J,le).then(ye=>new b.$Iac(!1,null,le.build(),O,ye,J.subscriptions))}static eb(_,ue,O,J,le){if(typeof O.activate=="function")try{le.activateCallStart(),_.trace(`ExtensionService#_callActivateOptional ${ue.value}`);const ye=typeof global=="object"?global:self,ve=O.activate.apply(ye,[J]);return le.activateCallStop(),le.activateResolveStart(),Promise.resolve(ve).then(be=>(le.activateResolveStop(),be))}catch(ye){return Promise.reject(ye)}else return Promise.resolve(O)}fb(_,ue){this.W(_.identifier,{startup:!1,extensionId:_.identifier,activationEvent:ue}).then(void 0,O=>{this.l.error(O)})}gb(_,ue=0){const J=Date.now();(0,U.$A)(()=>{for(let le=ue;le<_.length;le+=1){const ye=_[le];for(const ve of ye.activationEvents??[])if(ve==="onStartupFinished")if(Date.now()-J>50){this.gb(_,le);break}else this.fb(ye,ve)}})}hb(){this.v.$setPerformanceMarks(I.getMarks()),this.k.getConfigProvider().then(_=>{const ue=_.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),O=this.F.getAllExtensionDescriptions();if(ue)this.gb(O);else for(const J of O)if(J.activationEvents)for(const le of J.activationEvents)le==="onStartupFinished"&&this.fb(J,le)})}ib(){const _=this.U("*",!0).then(void 0,ye=>{this.l.error(ye)});this.B(this.j.onDidChangeWorkspace(ye=>this.jb(ye.added)));const ue=this.j.workspace?this.j.workspace.folders:[],O=this.jb(ue),J=this.lb(),le=Promise.all([J,_,O]).then(()=>{});return Promise.race([le,(0,A.$vg)(1e4)]).then(()=>{this.hb()}),le}jb(_){return _.length===0?Promise.resolve(void 0):Promise.all(this.F.getAllExtensionDescriptions().map(ue=>this.kb(_,ue))).then(()=>{})}async kb(_,ue){if(this.isActivated(ue.identifier))return;const O=!this.f.remote.isRemote&&!!this.f.remote.authority,J={logService:this.l,folders:_.map(ye=>ye.uri),forceUsingSearch:O||!this.c.fsExists,exists:ye=>this.c.fsExists(ye.fsPath),checkExists:(ye,ve,be)=>this.t.$checkExists(ye,ve,be)},le=await(0,m.$Wkb)(J,ue);if(le)return this.W(ue.identifier,{startup:!0,extensionId:ue.identifier,activationEvent:le.activationEvent}).then(void 0,ye=>this.l.error(ye))}async lb(){if(this.f.remote.authority)return this.U(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.C.wait();try{return await this.mb()}catch(_){throw console.error(_),_}}async mb(){const{extensionDevelopmentLocationURI:_,extensionTestsLocationURI:ue}=this.f.environment;if(!_||!ue)throw new Error(y.localize(0,null));const O=await this.rb(null,ue,new b.$Hac(!1));if(!O||typeof O.run!="function")throw new Error(y.localize(1,null,ue.toString()));return new Promise((J,le)=>{const ye=(ke,oe)=>{ke?le(ke):J(typeof oe=="number"&&oe>0?1:0)},ve=(0,M.$Wf)(ue),be=O.run(ve,ye);be&&be.then&&be.then(()=>{J(0)}).catch(ke=>{le(ke instanceof Error&&ke.stack?ke.stack:String(ke))})})}nb(){if(this.O)throw new Error("Extension host is already started!");return this.O=!0,this.y.wait().then(()=>this.z.open()).then(()=>Promise.race([this.L.waitForActivatingExtensions(),(0,A.$vg)(1e3)])).then(()=>this.ib()).then(()=>{this.C.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(_,ue){return this.N[_]=ue,(0,d.$jb)(()=>{delete this.N[_]})}async getRemoteExecServer(_){const{resolver:ue}=await this.ob(_);return ue?.resolveExecServer?.(_,{resolveAttempt:0})}async ob(_){const ue=_.indexOf("+");if(ue===-1)throw new n.$RJ("Not an authority that can be resolved!",a.RemoteAuthorityResolverErrorCode.InvalidAuthority);const O=_.substr(0,ue);return await this.w.wait(),await this.U(`onResolveRemoteAuthority:${O}`,!1),{authorityPrefix:O,resolver:this.N[O]}}async $resolveAuthority(_,ue){const O=j.$ac.create(!1),J=()=>`[resolveAuthority(${(0,a.$Ak)(_)},${ue})][${O.elapsed()}ms] `,le=G=>this.l.info(`${J()}${G}`),ye=G=>this.l.warn(`${J()}${G}`),ve=(G,Q=void 0)=>this.l.error(`${J()}${G}`,Q),be=G=>{if(G instanceof n.$RJ)return{type:"error",error:{code:G._code,message:G._message,detail:G._detail}};throw G},ke=async G=>{le(`activating resolver for ${G}...`);const{resolver:Q,authorityPrefix:K}=await this.ob(G);if(!Q)throw ve(`no resolver for ${K}`),new n.$RJ(`No remote extension installed to resolve ${K}.`,a.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:Q,authorityPrefix:K,remoteAuthority:G}},oe=_.split(/@|%40/g).reverse();le(`activating remote resolvers ${oe.join(" -> ")}`);let he;try{he=await Promise.all(oe.map(ke)).catch(async G=>{if(!(G instanceof n.$RJ)||G._code!==a.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw G;return ye(`resolving nested authorities failed: ${G.message}`),[await ke(_)]})}catch(G){return be(G)}const re=new A.$Fg;re.cancelAndSet(()=>le("waiting..."),1e3);let ie,ge;for(const[G,{authorityPrefix:Q,resolver:K,remoteAuthority:ee}]of he.entries())try{if(G===he.length-1)le("invoking final resolve()..."),I.mark(`code/extHost/willResolveAuthority/${Q}`),ie=await K.resolve(ee,{resolveAttempt:ue,execServer:ge}),I.mark(`code/extHost/didResolveAuthorityOK/${Q}`),le("setting tunnel factory..."),this.B(await this.m.setTunnelFactory(K,n.$QJ.isManagedResolvedAuthority(ie)?ie:void 0));else{if(le(`invoking resolveExecServer() for ${ee}`),I.mark(`code/extHost/willResolveExecServer/${Q}`),ge=await K.resolveExecServer?.(ee,{resolveAttempt:ue,execServer:ge}),!ge)throw new n.$RJ(`Exec server was not available for ${ee}`,a.RemoteAuthorityResolverErrorCode.NoResolverFound);I.mark(`code/extHost/didResolveExecServerOK/${Q}`)}}catch(ce){return I.mark(`code/extHost/didResolveAuthorityError/${Q}`),ve("returned an error",ce),re.dispose(),be(ce)}re.dispose();const Se={environmentTunnels:ie.environmentTunnels,features:ie.tunnelFeatures},L={extensionHostEnv:ie.extensionHostEnv,isTrusted:ie.isTrusted,authenticationSession:ie.authenticationSessionForInitializingExtensions?{id:ie.authenticationSessionForInitializingExtensions.id,providerId:ie.authenticationSessionForInitializingExtensions.providerId}:void 0};le(`returned ${n.$QJ.isManagedResolvedAuthority(ie)?"managed authority":`${ie.host}:${ie.port}`}`);let q;if(n.$QJ.isManagedResolvedAuthority(ie)){const G=ue;this.R.setFactory(G,ie.makeConnection),q={authority:_,connectTo:new a.$xk(G),connectionToken:ie.connectionToken}}else q={authority:_,connectTo:new a.$yk(ie.host,ie.port),connectionToken:ie.connectionToken};return{type:"ok",value:{authority:q,options:L,tunnelInformation:Se}}}async $getCanonicalURI(_,ue){this.l.info(`$getCanonicalURI invoked for authority (${(0,a.$Ak)(_)})`);const{resolver:O}=await this.ob(_);if(!O)return null;const J=f.URI.revive(ue);if(typeof O.getCanonicalURI>"u")return J;const le=await(0,A.$ng)(()=>O.getCanonicalURI(J));return le||J}$startExtensionHost(_){_.toAdd.forEach(J=>J.extensionLocation=f.URI.revive(J.extensionLocation));const{globalRegistry:ue,myExtensions:O}=we(this.D,this.G,this.F,_);return this.G.set(ue.getAllExtensionDescriptions()),this.F.set(O),this.nb()}$activateByEvent(_,ue){return ue===1?this.w.wait().then(O=>this.U(_,!1)):this.z.wait().then(O=>this.U(_,!1))}async $activate(_,ue){return await this.z.wait(),this.F.getExtensionDescription(_)?(await this.W(_,ue),!0):!1}async $deltaExtensions(_){_.toAdd.forEach(ye=>ye.extensionLocation=f.URI.revive(ye.extensionLocation));const{globalRegistry:ue,myExtensions:O}=we(this.D,this.G,this.F,_),J=await this.Y(O);return(await this.getExtensionPathIndex()).setSearchTree(J),this.G.set(ue.getAllExtensionDescriptions()),this.F.set(O),Promise.resolve(void 0)}async $test_latency(_){return _}async $test_up(_){return _.byteLength}async $test_down(_){const ue=S.$Ec.alloc(_),O=Math.random()%256;for(let J=0;J<_;J++)ue.writeUInt8(O,J);return ue}async $updateRemoteConnectionData(_){this.Q=_,this.a.fire()}};e.$7ac=Z,e.$7ac=Z=ne=Ke([We(0,r.$oh),We(1,e.$6ac),We(2,$.$LL),We(3,h.$zac),We(4,u.$Cac),We(5,P.$Ri),We(6,s.$2L),We(7,v.$Sac),We(8,E.$Lrb),We(9,o.$Uac),We(10,B.$3ac),We(11,z.$4ac)],Z);function we(ae,_,ue,O){ae.addActivationEvents(O.addActivationEvents);const J=new i.$P2b(ae,_.getAllExtensionDescriptions());J.deltaExtensions(O.toAdd,O.toRemove);const le=new g.$Jl(ue.getAllExtensionDescriptions().map(ve=>ve.identifier));for(const ve of O.myToRemove)le.delete(ve);for(const ve of O.myToAdd)le.add(ve);const ye=X(J,le);return{globalRegistry:J,myExtensions:ye}}function Ee(ae,_){return{id:ae.identifier.value,name:ae.name,extensionVersion:ae.version,publisherDisplayName:ae.publisher,activationEvents:ae.activationEvents?ae.activationEvents.join(","):null,isBuiltin:ae.isBuiltin,reason:_.activationEvent,reasonId:_.extensionId.value}}e.$8ac=(0,r.$ph)("IExtHostExtensionService");class Re{#e;#t;#i;constructor(_,ue,O,J,le){this.#e=_,this.#t=ue,this.#i=O.identifier,this.id=O.identifier.value,this.extensionUri=O.extensionLocation,this.extensionPath=R.$6c((0,M.$Wf)(O.extensionLocation)),this.packageJSON=O,this.extensionKind=J,this.isFromDifferentExtensionHost=le}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$9ac=Re;function X(ae,_){return ae.getAllExtensionDescriptions().filter(ue=>_.has(ue.identifier))}class de{constructor(_){this.a=_}setSearchTree(_){this.a=_}findSubstr(_){return this.a.findSubstr(_)}forEach(_){return this.a.forEach(_)}}e.$0ac=de;class Ce{constructor(_){this.a=new g.$Kl,this.addActivationEvents(_)}readActivationEvents(_){return this.a.get(_.identifier)}addActivationEvents(_){for(const ue of Object.keys(_))this.a.set(ue,_[ue])}}}),define(Pe[269],Ae([1,0,87,2,3,34,26,20,17,27,4,35,52,14,15]),function(pe,e,y,R,I,M,A,d,k,f,P,D,u,b,p){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$tcc=void 0;let t=class{constructor(n,a,r,s,v,$,w){this.c=n,this.d=a,this.e=r,this.f=s,this.g=v,this.h=$,this.i=w,this.a=new Map,this.b=[]}async install(){this.j(),y.mark("code/extHost/willWaitForConfig");const n=await this.f.getConfigProvider();y.mark("code/extHost/didWaitForConfig");const a=await this.g.getExtensionPathIndex();this.register(new c(this.c,a,this.d,n,this.i)),this.register(this.e.createInstance(g,a)),this.register(this.e.createInstance(i)),this.h.remote.isRemote&&this.register(this.e.createInstance(S,a,this.h.environment.appUriScheme))}register(n){if("nodeModuleName"in n)if(Array.isArray(n.nodeModuleName))for(const a of n.nodeModuleName)this.a.set(a,n);else this.a.set(n.nodeModuleName,n);typeof n.alternativeModuleName=="function"&&this.b.push(a=>n.alternativeModuleName(a))}};e.$tcc=t,e.$tcc=t=Ke([We(2,P.$oh),We(3,M.$Cac),We(4,D.$8ac),We(5,f.$2L),We(6,b.$Ri)],t);let i=class{static{h=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(n){if(n.environment.appRoot&&h.a.size){const a=(0,p.$pd)(this.c(n.environment.appRoot.fsPath)),r="[a-z0-9_.-]",s=`@${r}+\\/${r}+|${r}+`,v="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${a}/${v}\\/)(${s})(.*)$`,"i")}}alternativeModuleName(n){if(!this.b)return;const a=this.b.exec(this.c(n));if(!a)return;const[,r,s,v]=a,$=h.a.get(s);if($!==void 0)return console.warn(`${s} as been renamed to ${$}, please update your imports`),r+$+v}c(n){return n.replace(/\\/g,"/")}};i=h=Ke([We(0,f.$2L)],i);class c{constructor(n,a,r,s,v){this.c=n,this.d=a,this.e=r,this.f=s,this.g=v,this.nodeModuleName="vscode",this.a=new d.$Kl}load(n,a){const r=this.d.findSubstr(a);if(r){let s=this.a.get(r.identifier);return s||(s=this.c(r,this.e,this.f),this.a.set(r.identifier,s)),s}if(!this.b){let s="";this.d.forEach((v,$)=>s+=`	${$} -> ${v.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${a}. These are the extension path mappings: 
${s}`),this.b=this.c(A.$yF,this.e,this.f)}return this.b}}let g=class{constructor(n,a,r){this.d=n,this.nodeModuleName="keytar",this.a=a.getProxy(I.$JJ.MainThreadTelemetry);const{environment:s}=r,v=a.getProxy(I.$JJ.MainThreadKeytar);if(s.appRoot){let $=s.appRoot.fsPath;u.$2c==="win32"&&($=$.replace(/\\/g,"/")),$[$.length-1]==="/"&&($=$.substr(0,$.length-1)),this.b=new Set,this.b.add(`${$}/node_modules.asar/keytar`),this.b.add(`${$}/node_modules/keytar`)}this.c={getPassword:($,w)=>v.$getPassword($,w),setPassword:($,w,E)=>v.$setPassword($,w,E),deletePassword:($,w)=>v.$deletePassword($,w),findPassword:$=>v.$findPassword($),findCredentials($){return v.$findCredentials($)}}}load(n,a){const r=this.d.findSubstr(a);return this.a.$publicLog2("shimming.keytar",{extension:r?.identifier.value??"unknown_extension"}),this.c}alternativeModuleName(n){const a=n.length;if(a<=7||!this.b)return;const r=a-7;if((n.charAt(r)==="/"||n.charAt(r)==="\\")&&n.endsWith("keytar")&&(n=n.replace(/\\/g,"/"),this.b.has(n)))return"keytar"}};g=Ke([We(1,k.$LL),We(2,f.$2L)],g);let S=class{constructor(n,a,r){this.e=n,this.f=a,this.nodeModuleName=["open","opn"],this.d=r.getProxy(I.$JJ.MainThreadTelemetry);const s=r.getProxy(I.$JJ.MainThreadWindow);this.c=(v,$)=>{const w=R.URI.parse(v);return $?this.g(v,$):w.scheme==="http"||w.scheme==="https"?s.$openUri(w,v,{allowTunneling:!0}):w.scheme==="mailto"||w.scheme===this.f?s.$openUri(w,v,{}):this.g(v,$)}}load(n,a,r){const s=this.e.findSubstr(a);return s&&(this.a=s.identifier.value,this.h()),this.b=r(n),this.c}g(n,a){return this.i(),this.b(n,a)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};S=Ke([We(2,k.$LL)],S)}),define(Pe[113],Ae([1,0,66,6,19,52,4,60,61,35,7,33,201,34]),function(pe,e,y,R,I,M,A,d,k,f,P,D,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ebc=e.$Dbc=void 0,e.$Dbc=(0,A.$ph)("IExtHostVariableResolverProvider");class p extends u.$MM{constructor(i,c,g,S,C,n,a){function r(){if(g){const s=g.activeEditor();if(s)return s.document.uri;const v=S.tabGroups.all.find($=>$.isActive)?.activeTab;if(v!==void 0){if(v.input instanceof P.$sL||v.input instanceof P.$xL)return v.input.modified;if(v.input instanceof P.$rL||v.input instanceof P.$wL||v.input instanceof P.$uL)return v.input.uri}}}super({getFolderUri:s=>{const v=n.folders.filter($=>$.name===s);if(v&&v.length>0)return v[0].uri},getWorkspaceFolderCount:()=>n.folders.length,getConfigurationValue:(s,v)=>C.getConfiguration(void 0,s).get(v),getAppRoot:()=>M.cwd(),getExecPath:()=>M.env.VSCODE_EXEC_PATH,getFilePath:()=>{const s=r();if(s)return I.$6c(s.fsPath)},getWorkspaceFolderPathForFile:()=>{if(c){const s=r();if(s){const v=c.getWorkspaceFolder(s);if(v)return I.$6c(v.uri.fsPath)}}},getSelectedText:()=>{if(g){const s=g.activeEditor();if(s&&!s.selection.isEmpty)return s.document.getText(s.selection)}},getLineNumber:()=>{if(g){const s=g.activeEditor();if(s)return String(s.selection.end.line+1)}},getExtension:s=>i.getExtension(s)},void 0,a?Promise.resolve(a):void 0,Promise.resolve(M.env))}}let h=class extends R.$lb{constructor(i,c,g,S,C){super(),this.b=i,this.c=c,this.g=g,this.h=S,this.i=C,this.a=new y.$T(async()=>{const n=await this.h.getConfigProvider(),r={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async s=>{r.folders=await this.c.getWorkspaceFolders2()||[]})),new p(this.b,this.c,this.g,this.i,n,r,this.j())})}getResolver(){return this.a.value}j(){}};e.$Ebc=h,e.$Ebc=h=Ke([We(0,f.$8ac),We(1,D.$zac),We(2,d.$WL),We(3,b.$Cac),We(4,k.$Bbc)],h)}),define(Pe[114],Ae([1,0,13,5,2,4,3,61,35,17,7,33,194,196,34,113]),function(pe,e,y,R,I,M,A,d,k,f,P,D,u,b,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jbc=e.$Ibc=e.$Hbc=e.$Gbc=e.$Fbc=void 0,e.$Fbc=(0,M.$ph)("IExtHostDebugService");let t=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(a,r,s,v,$,w){this.E=r,this.F=s,this.G=v,this.H=$,this.I=w,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new R.$ec,this.n=new R.$ec,this.o=new R.$ec,this.u=new R.$ec,this.k=a.getProxy(A.$JJ.MainThreadDebugService),this.y=new R.$ec,this.A=new R.$ec,this.v=new c(this.k),this.w=new Map,this.F.getExtensionRegistry().then(E=>{E.onDidChange(o=>{this.J(E)}),this.J(E)})}asDebugSourceUri(a,r){const s=a;if(typeof s.sourceReference=="number"&&s.sourceReference>0){let v=`debug:${encodeURIComponent(s.path||"")}`,$="?";return r&&(v+=`${$}session=${encodeURIComponent(r.id)}`,$="&"),v+=`${$}ref=${s.sourceReference}`,I.URI.parse(v)}else{if(s.path)return I.URI.file(s.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(a){const r=[];for(const s of a.getAllExtensionDescriptions())if(s.contributes){const v=s.contributes.debuggers;if(v&&v.length>0)for(const $ of v)(0,b.$bF)($)&&r.push($.type)}this.k.$registerDebugTypes(r)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const a=[];return this.w.forEach(r=>a.push(r)),a}addBreakpoints(a){const r=a.filter($=>{const w=$.id;return this.w.has(w)?!1:(this.w.set(w,$),!0)});this.U(r,[],[]);const s=[],v=new Map;for(const $ of r)if($ instanceof P.$LK){let w=v.get($.location.uri.toString());w||(w={type:"sourceMulti",uri:$.location.uri,lines:[]},v.set($.location.uri.toString(),w),s.push(w)),w.lines.push({id:$.id,enabled:$.enabled,condition:$.condition,hitCondition:$.hitCondition,logMessage:$.logMessage,line:$.location.range.start.line,character:$.location.range.start.character})}else $ instanceof P.$MK&&s.push({type:"function",id:$.id,enabled:$.enabled,hitCondition:$.hitCondition,logMessage:$.logMessage,condition:$.condition,functionName:$.functionName});return this.k.$registerBreakpoints(s)}removeBreakpoints(a){const r=a.filter(w=>this.w.delete(w.id));this.U([],r,[]);const s=r.filter(w=>w instanceof P.$LK).map(w=>w.id),v=r.filter(w=>w instanceof P.$MK).map(w=>w.id),$=r.filter(w=>w instanceof P.$NK).map(w=>w.id);return this.k.$unregisterBreakpoints(s,v,$)}startDebugging(a,r,s){return this.k.$startDebugging(a?a.uri:void 0,r,{parentSessionID:s.parentSession?s.parentSession.id:void 0,lifecycleManagedByParent:s.lifecycleManagedByParent,repl:s.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:s.noDebug,compact:s.compact,suppressSaveBeforeStart:s.suppressSaveBeforeStart,suppressDebugStatusbar:s.suppressDebugStatusbar??s.debugUI?.simple,suppressDebugToolbar:s.suppressDebugToolbar??s.debugUI?.simple,suppressDebugView:s.suppressDebugView??s.debugUI?.simple})}stopDebugging(a){return this.k.$stopDebugging(a?a.id:void 0)}registerDebugConfigurationProvider(a,r,s){if(!r)return new P.$LJ(()=>{});const v=this.d++;return this.f.push({type:a,handle:v,provider:r}),this.k.$registerDebugConfigurationProvider(a,s,!!r.provideDebugConfigurations,!!r.resolveDebugConfiguration,!!r.resolveDebugConfigurationWithSubstitutedVariables,v),new P.$LJ(()=>{this.f=this.f.filter($=>$.provider!==r),this.k.$unregisterDebugConfigurationProvider(v)})}registerDebugAdapterDescriptorFactory(a,r,s){if(!s)return new P.$LJ(()=>{});if(!this.Q(a,r))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${r}' debugger.`);if(this.N(r))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const v=this.g++;return this.h.push({type:r,handle:v,factory:s}),this.k.$registerDebugAdapterDescriptorFactory(r,v),new P.$LJ(()=>{this.h=this.h.filter($=>$.factory!==s),this.k.$unregisterDebugAdapterDescriptorFactory(v)})}registerDebugAdapterTrackerFactory(a,r){if(!r)return new P.$LJ(()=>{});const s=this.i++;return this.j.push({type:a,handle:s,factory:r}),new P.$LJ(()=>{this.j=this.j.filter(v=>v.factory!==r)})}async $runInTerminal(a,r){return Promise.resolve(void 0)}async $substituteVariables(a,r){let s;const v=await this.W(a);return v&&(s={uri:v.uri,name:v.name,index:v.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(s,r)}K(a,r){if(a.type==="implementation")return new S(a.implementation)}L(){}async $startDASession(a,r){const s=this,v=await this.V(r);return this.S(this.N(v.type),v).then($=>{if(!$)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${v.type}' (extension might have failed to activate)`);const w=this.M($),E=this.K(w,v);if(!E)throw new Error(`Couldn't create a debug adapter for type '${v.type}'.`);const o=E;return this.B.set(a,o),this.R(v).then(l=>(l&&this.C.set(a,l),o.onMessage(async m=>{if(m.type==="request"&&m.command==="handshake"){const F=m,W={type:"response",seq:0,command:F.command,request_seq:F.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const V=await this.D.sign(F.arguments.value);W.body={signature:V},o.sendResponse(W)}else throw new Error("no signer")}catch(V){W.success=!1,W.message=V.message,o.sendResponse(W)}}else l&&l.onDidSendMessage&&l.onDidSendMessage(m),m=(0,b.$gF)(m,!0),s.k.$acceptDAMessage(a,m)}),o.onError(m=>{l&&l.onError&&l.onError(m),this.k.$acceptDAError(a,m.name,m.message,m.stack)}),o.onExit(m=>{l&&l.onExit&&l.onExit(m??void 0,void 0),this.k.$acceptDAExit(a,m??void 0,void 0)}),l&&l.onWillStartSession&&l.onWillStartSession(),o.startSession()))})}$sendDAMessage(a,r){r=(0,b.$fF)(r,!1);const s=this.C.get(a);s&&s.onWillReceiveMessage&&s.onWillReceiveMessage(r),this.B.get(a)?.sendMessage(r)}$stopDASession(a){const r=this.C.get(a);this.C.delete(a),r&&r.onWillStopSession&&r.onWillStopSession();const s=this.B.get(a);return this.B.delete(a),s?s.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(a){const r=[],s=[],v=[];if(a.added)for(const $ of a.added){const w=$.id;if(w&&!this.w.has(w)){let E;if($.type==="function")E=new P.$MK($.functionName,$.enabled,$.condition,$.hitCondition,$.logMessage);else if($.type==="data")E=new P.$NK($.label,$.dataId,$.canPersist,$.enabled,$.hitCondition,$.condition,$.logMessage);else{const o=I.URI.revive($.uri);E=new P.$LK(new P.$XJ(o,new P.$MJ($.line,$.character)),$.enabled,$.condition,$.hitCondition,$.logMessage)}(0,P.$JK)(E,w),this.w.set(w,E),r.push(E)}}if(a.removed)for(const $ of a.removed){const w=this.w.get($);w&&(this.w.delete($),s.push(w))}if(a.changed){for(const $ of a.changed)if($.id){const w=this.w.get($.id);if(w){if(w instanceof P.$MK&&$.type==="function"){const E=w;E.enabled=$.enabled,E.condition=$.condition,E.hitCondition=$.hitCondition,E.logMessage=$.logMessage,E.functionName=$.functionName}else if(w instanceof P.$LK&&$.type==="source"){const E=w;E.enabled=$.enabled,E.condition=$.condition,E.hitCondition=$.hitCondition,E.logMessage=$.logMessage,E.location=new P.$XJ(I.URI.revive($.uri),new P.$MJ($.line,$.character))}v.push(w)}}}this.U(r,s,v)}async $acceptStackFrameFocus(a){let r;const s=a.sessionId?await this.V(a.sessionId):void 0;if(!s)throw new Error("no DebugSession found for debug focus context");a.kind==="thread"?r=new P.$TK(s,a.threadId):r=new P.$SK(s,a.threadId,a.frameId),this.z=r,this.A.fire(this.z)}$provideDebugConfigurations(a,r,s){return(0,y.$ng)(async()=>{const v=this.P(a);if(!v)throw new Error("no DebugConfigurationProvider found");if(!v.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const $=await this.W(r);return v.provideDebugConfigurations($,s)}).then(v=>{if(!v)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return v})}$resolveDebugConfiguration(a,r,s,v){return(0,y.$ng)(async()=>{const $=this.P(a);if(!$)throw new Error("no DebugConfigurationProvider found");if(!$.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const w=await this.W(r);return $.resolveDebugConfiguration(w,s,v)})}$resolveDebugConfigurationWithSubstitutedVariables(a,r,s,v){return(0,y.$ng)(async()=>{const $=this.P(a);if(!$)throw new Error("no DebugConfigurationProvider found");if(!$.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const w=await this.W(r);return $.resolveDebugConfigurationWithSubstitutedVariables(w,s,v)})}async $provideDebugAdapter(a,r){const s=this.O(a);if(!s)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const v=await this.V(r);return this.S(s,v).then($=>{if(!$)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${v.type}'`);return this.M($)})}async $acceptDebugSessionStarted(a){const r=await this.V(a);this.m.fire(r)}async $acceptDebugSessionTerminated(a){const r=await this.V(a);r&&(this.n.fire(r),this.l.delete(r.id))}async $acceptDebugSessionActiveChanged(a){this.q=a?await this.V(a):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(a,r){(await this.V(a))?._acceptNameChanged(r)}async $acceptDebugSessionCustomEvent(a,r){const v={session:await this.V(a),event:r.event,body:r.body};this.u.fire(v)}M(a){if(a instanceof P.$OK)return{type:"executable",command:a.command,args:a.args,options:a.options};if(a instanceof P.$PK)return{type:"server",port:a.port,host:a.host};if(a instanceof P.$QK)return{type:"pipeServer",path:a.path};if(a instanceof P.$RK)return{type:"implementation",implementation:a.implementation};throw new Error("convertToDto unexpected type")}N(a){const r=this.h.filter(s=>s.type===a);if(r.length>0)return r[0].factory}O(a){const r=this.h.filter(s=>s.handle===a);if(r.length>0)return r[0].factory}P(a){const r=this.f.filter(s=>s.handle===a);if(r.length>0)return r[0].provider}Q(a,r){if(a.contributes){const s=a.contributes.debuggers;if(s&&s.length>0){for(const v of s)if(v.label&&v.type&&v.type===r)return!0}}return!1}R(a){const s=a.configuration.type,v=this.j.filter($=>$.type===s||$.type==="*").map($=>(0,y.$ng)(()=>$.factory.createDebugAdapterTracker(a)).then(w=>w,w=>null));return Promise.race([Promise.all(v).then($=>{const w=$.filter(E=>!!E);if(w.length>0)return new g(w)}),new Promise($=>setTimeout(()=>$(void 0),1e3))]).catch($=>{})}async S(a,r){const s=r.configuration.debugServer;if(typeof s=="number")return Promise.resolve(new P.$PK(s));if(a){const $=await this.F.getExtensionRegistry();return(0,y.$ng)(()=>a.createDebugAdapterDescriptor(r,this.T(r,$))).then(w=>{if(w)return w})}const v=await this.F.getExtensionRegistry();return Promise.resolve(this.T(r,v))}T(a,r){}U(a,r,s){(a.length>0||r.length>0||s.length>0)&&this.y.fire(Object.freeze({added:a,removed:r,changed:s}))}async V(a){if(a)if(typeof a=="string"){const r=this.l.get(a);if(r)return r}else{let r=this.l.get(a.id);if(!r){const s=await this.W(a.folderUri),v=a.parent?this.l.get(a.parent):void 0;r=new i(this.k,a.id,a.type,a.name,s,a.configuration,v),this.l.set(r.id,r),this.k.$sessionCached(r.id)}return r}throw new Error("cannot find session")}W(a){if(a){const r=I.URI.revive(a);return this.E.resolveWorkspaceFolder(r)}return Promise.resolve(void 0)}};e.$Gbc=t,e.$Gbc=t=Ke([We(0,f.$LL),We(1,D.$zac),We(2,k.$8ac),We(3,p.$Cac),We(4,d.$Bbc),We(5,h.$Dbc)],t);class i{constructor(a,r,s,v,$,w,E){this.d=a,this.f=r,this.g=s,this.h=v,this.i=$,this.j=w,this.k=E}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(a){this.h=a,this.d.$setDebugSessionName(this.f,a)}get parentSession(){return this.k}_acceptNameChanged(a){this.h=a}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(a,r){return this.d.$customDebugAdapterRequest(this.f,a,r)}getDebugProtocolBreakpoint(a){return this.d.$getDebugProtocolBreakpoint(this.f,a.id)}}e.$Hbc=i;class c{constructor(a){this.value=Object.freeze({append(r){a.$appendDebugConsole(r)},appendLine(r){this.append(r+`
`)}})}}e.$Ibc=c;class g{constructor(a){this.d=a}onWillStartSession(){this.d.forEach(a=>a.onWillStartSession?a.onWillStartSession():void 0)}onWillReceiveMessage(a){this.d.forEach(r=>r.onWillReceiveMessage?r.onWillReceiveMessage(a):void 0)}onDidSendMessage(a){this.d.forEach(r=>r.onDidSendMessage?r.onDidSendMessage(a):void 0)}onWillStopSession(){this.d.forEach(a=>a.onWillStopSession?a.onWillStopSession():void 0)}onError(a){this.d.forEach(r=>r.onError?r.onError(a):void 0)}onExit(a,r){this.d.forEach(s=>s.onExit?s.onExit(a,r):void 0)}}class S extends u.$4bb{constructor(a){super(),this.h=a,a.onDidSendMessage(r=>{this.acceptMessage(r)})}startSession(){return Promise.resolve(void 0)}sendMessage(a){this.h.handleMessage(a)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let C=class extends t{constructor(a,r,s,v,$,w){super(a,r,s,v,$,w)}};e.$Jbc=C,e.$Jbc=C=Ke([We(0,f.$LL),We(1,D.$zac),We(2,k.$8ac),We(3,p.$Cac),We(4,d.$Bbc),We(5,h.$Dbc)],C)}),define(Pe[270],Ae([1,0,9,87,2,3,261,14,71,72,27,173,17,56,35,58]),function(pe,e,y,R,I,M,A,d,k,f,P,D,u,b,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vcc=e.$ucc=void 0;class t{static async installEarlyHandler(g){Error.stackTraceLimit=100;const S=g.get(d.$Ri),n=g.get(u.$LL).getProxy(M.$JJ.MainThreadErrors);y.setUnexpectedErrorHandler(a=>{S.error(a);const r=y.$1(a);n.$onUnexpectedError(r)})}static async installFullHandler(g){const S=g.get(d.$Ri),C=g.get(u.$LL),n=g.get(p.$8ac),a=g.get(h.$6L),r=C.getProxy(M.$JJ.MainThreadExtensionService),s=C.getProxy(M.$JJ.MainThreadErrors),v=await n.getExtensionPathIndex(),$=new WeakMap;function w(l,m){if($.has(l))return $.get(l).stack;let F="",W,V;for(const j of m)F+=`
	at ${j.toString()}`,V=j.getFileName(),!W&&V&&(W=v.findSubstr(I.URI.file(V)));const B=`${l.name||"Error"}: ${l.message||""}${F}`;return $.set(l,{extensionIdentifier:W?.identifier,stack:B}),B}const E=Symbol("prepareStackTrace wrapped");let o=w;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return o},set(l){if(l===w||!l||l[E]){o=l||w;return}o=function(m,F){return w(m,F),l.call(Error,m,F)},Object.assign(o,{[E]:!0})}}),y.setUnexpectedErrorHandler(l=>{S.error(l);const m=y.$1(l),F=$.get(l);if(!F?.extensionIdentifier){s.$onUnexpectedError(m);return}r.$onExtensionRuntimeError(F.extensionIdentifier,m);const W=a.onExtensionError(F.extensionIdentifier,l);S.trace("forwarded error to extension?",W,F)})}}e.$ucc=t;class i{constructor(g,S,C,n,a){this.a=C,this.b=new A.$X2b(g,null,n),S=i.e(S,this.b);const r=new f.$nh(...(0,k.$er)());r.set(P.$2L,{_serviceBrand:void 0,...S,messagePorts:a}),r.set(u.$LL,new u.$ML(this.b)),r.set(b.$wac,new b.$xac(n)),r.set(p.$6ac,C);const s=new D.$Wp(r,!0);s.invokeFunction(t.installEarlyHandler),this.d=s.invokeFunction(v=>v.get(d.$Ri)),R.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",S),this.c=s.invokeFunction(v=>v.get(p.$8ac)),this.c.initialize(),s.invokeFunction(t.installFullHandler)}async asBrowserUri(g){const S=this.b.getProxy(M.$JJ.MainThreadExtensionService);return I.URI.revive(await S.$asBrowserUri(g))}terminate(g){this.c.terminate(g)}static e(g,S){g.allExtensions.forEach(n=>{n.extensionLocation=I.URI.revive(S.transformIncomingURIs(n.extensionLocation))}),g.environment.appRoot=I.URI.revive(S.transformIncomingURIs(g.environment.appRoot));const C=g.environment.extensionDevelopmentLocationURI;return C&&(g.environment.extensionDevelopmentLocationURI=C.map(n=>I.URI.revive(S.transformIncomingURIs(n)))),g.environment.extensionTestsLocationURI=I.URI.revive(S.transformIncomingURIs(g.environment.extensionTestsLocationURI)),g.environment.globalStorageHome=I.URI.revive(S.transformIncomingURIs(g.environment.globalStorageHome)),g.environment.workspaceStorageHome=I.URI.revive(S.transformIncomingURIs(g.environment.workspaceStorageHome)),g.environment.extensionTelemetryLogResource=I.URI.revive(S.transformIncomingURIs(g.environment.extensionTelemetryLogResource)),g.nlsBaseUrl=I.URI.revive(S.transformIncomingURIs(g.nlsBaseUrl)),g.logsLocation=I.URI.revive(S.transformIncomingURIs(g.logsLocation)),g.workspace=S.transformIncomingURIs(g.workspace),g}}e.$vcc=i}),define(Pe[271],Ae([1,0,18,13,21,41,12,19,23,2,47]),function(pe,e,y,R,I,M,A,d,k,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Obc=e.$Nbc=e.$Mbc=e.$Lbc=void 0;class D{constructor(c,g,S,C){this.d=c,this.e=g,this.f=S,this.g=C,this.a=null,this.b=!1,this.c=0}search(c,g){const S=this.d.folderQueries||[],C=new I.$oc;return g.onCancellationRequested(()=>C.cancel()),new Promise((n,a)=>{this.a=new b(c);let r=!1;const s=(v,$)=>{if(!r&&!this.b){const w=this.h(v);h(v)&&typeof this.d.maxResults=="number"&&this.c+w>this.d.maxResults&&(this.b=!0,r=!0,C.cancel(),v=this.j(v,this.d.maxResults-this.c));const E=this.h(v);this.c+=E,(E>0||!h(v))&&this.a.add(v,$)}};Promise.all(S.map((v,$)=>this.k(v,w=>s(w,$),C.token))).then(v=>{C.dispose(),this.a.flush();const $=v.some(w=>!!w&&!!w.limitHit);n({limitHit:this.b||$,messages:(0,y.$vf)(v.map(w=>w?.message?Array.isArray(w.message)?w.message:[w.message]:[])),stats:{type:this.g}})},v=>{C.dispose();const $=(0,M.$ai)(v);a(new Error($))})})}h(c){return h(c)?Array.isArray(c.ranges)?c.ranges.length:1:0}j(c,g){const S=Array.isArray(c.ranges)?c.ranges:[c.ranges],C=Array.isArray(c.preview.matches)?c.preview.matches:[c.preview.matches];return{ranges:S.slice(0,g),preview:{matches:C.slice(0,g),text:c.preview.text},uri:c.uri}}async k(c,g,S){const C=new P.$oI(this.d,c),n=[],a={report:v=>{if(!this.l(v))return;const $=c.folder.scheme===A.Schemas.file?(0,P.$pI)(()=>this.f.readdir(k.$8f(v.uri))):void 0,w=k.$$f(c.folder,v.uri);if(w){const E=C.includedInQuery(w,d.$_c(w),$);(0,R.$hg)(E)?n.push(E.then(o=>{o&&g(v)})):E&&g(v)}}},r=this.n(c),s=await this.e.provideTextSearchResults(u(this.d.contentPattern),r,a,S);return n.length&&await Promise.all(n),s}l(c){if(h(c)){if(Array.isArray(c.ranges)){if(!Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(c.preview.matches.length!==c.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(c){const g=(0,P.$nI)(this.d.includePattern,c.includePattern),S=(0,P.$nI)(this.d.excludePattern,c.excludePattern),C={folder:f.URI.from(c.folder),excludes:S,includes:g,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!c.disregardParentIgnoreFiles,followSymlinks:!c.ignoreSymlinks,encoding:c.fileEncoding&&this.f.toCanonicalName(c.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return C.usePCRE2=this.d.usePCRE2,C}}e.$Lbc=D;function u(i){return{isCaseSensitive:i.isCaseSensitive||!1,isRegExp:i.isRegExp||!1,isWordMatch:i.isWordMatch||!1,isMultiline:i.isMultiline||!1,pattern:i.pattern}}class b{constructor(c){this.e=c,this.b=-1,this.d=null,this.a=new t(512,g=>this.g(g))}add(c,g){this.d&&(this.b!==g||!k.$2f(this.c,c.uri))&&(this.f(),this.d=null),this.d||(this.b=g,this.d={resource:c.uri,results:[]}),this.d.results.push(p(c))}f(){const c=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,c)}flush(){this.f(),this.a.flush()}g(c){this.e(c)}}e.$Mbc=b;function p(i){return h(i)?{preview:{matches:(0,y.$Ff)(i.preview.matches,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character})),text:i.preview.text},ranges:(0,y.$Ff)(i.ranges,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character}))}:{text:i.text,lineNumber:i.lineNumber}}function h(i){return!!i.preview}e.$Nbc=h;class t{static{this.a=4e3}static{this.b=50}constructor(c,g){this.g=c,this.h=g,this.c=0,this.d=[],this.e=0}addItem(c,g){c&&this.j(c,g)}addItems(c,g){c&&this.k(c,g)}j(c,g){this.d.push(c),this.e+=g,this.l()}k(c,g){this.d=this.d.concat(c),this.e+=g,this.l()}l(){this.c<t.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},t.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Obc=t}),define(Pe[115],Ae([1,0,6,3,4,266,17,56,14,2,271]),function(pe,e,y,R,I,M,A,d,k,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rbc=e.$Qbc=e.$Pbc=void 0,e.$Pbc=(0,I.$ph)("IExtHostSearch");let D=class{constructor(h,t,i){this.k=h,this.l=t,this.n=i,this.c=this.k.getProxy(R.$JJ.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new M.$Kbc}o(h){return this.l.transformOutgoingScheme(h)}registerTextSearchProvider(h,t){if(this.g.has(h))throw new Error(`a text search provider for the scheme '${h}' is already registered`);this.g.add(h);const i=this.d++;return this.e.set(i,t),this.c.$registerTextSearchProvider(i,this.o(h)),(0,y.$jb)(()=>{this.g.delete(h),this.e.delete(i),this.c.$unregisterProvider(i)})}registerFileSearchProvider(h,t){if(this.i.has(h))throw new Error(`a file search provider for the scheme '${h}' is already registered`);this.i.add(h);const i=this.d++;return this.h.set(i,t),this.c.$registerFileSearchProvider(i,this.o(h)),(0,y.$jb)(()=>{this.i.delete(h),this.h.delete(i),this.c.$unregisterProvider(i)})}$provideFileSearchResults(h,t,i,c){const g=u(i),S=this.h.get(h);if(S)return this.j.fileSearch(g,S,C=>{this.c.$handleFileMatch(h,t,C.map(n=>n.resource))},c);throw new Error("unknown provider: "+h)}$clearCache(h){return this.j.clearCache(h),Promise.resolve(void 0)}$provideTextSearchResults(h,t,i,c){const g=this.e.get(h);if(!g||!g.provideTextSearchResults)throw new Error(`Unknown provider ${h}`);const S=u(i);return this.q(S,g).search(n=>this.c.$handleTextMatch(h,t,n),c)}$enableExtensionHostSearch(){}q(h,t){return new P.$Lbc(h,t,{readdir:i=>Promise.resolve([]),toCanonicalName:i=>i},"textSearchProvider")}};e.$Qbc=D,e.$Qbc=D=Ke([We(0,A.$LL),We(1,d.$wac),We(2,k.$Ri)],D);function u(p){return{...p,folderQueries:p.folderQueries&&p.folderQueries.map(b),extraFileResources:p.extraFileResources&&p.extraFileResources.map(h=>f.URI.revive(h))}}e.$Rbc=u;function b(p){return{...p,folder:f.URI.revive(p.folder)}}}),define(Pe[272],Ae([1,0,21,9,5,29,2,136,282,125,134,38,3,79,225,224,31,226,34,228,229,230,204,231,60,35,233,234,239,240,242,110,208,248,249,251,84,63,253,211,8,7,53,256,64,109,33,20,199,238,51,108,112,114,115,14,56,17,27,243,197,86,80,218,254,85,62,259,257,258,219,39,252,255,83,61,58,244,111,245,12,95,207,190,236,6,26,195,81,186,246,247,220,235,206,237,82,250,221,222,223,217,232]),function(pe,e,y,R,I,M,A,d,k,f,P,D,u,b,p,h,t,i,c,g,S,C,n,a,r,s,v,$,w,E,o,l,m,F,W,V,B,j,U,z,ne,Z,we,Ee,Re,X,de,Ce,ae,_,ue,O,J,le,ye,ve,be,ke,oe,he,re,ie,ge,Se,L,q,G,Q,K,ee,ce,ze,Ue,Qe,He,et,Xe,xe,it,tt,Ne,st,x,Y,$e,je,Oe,Ye,nt,ft,bt,Tt,Yt,Vt,vt,Mt,Ot,Jt,At,Rt,Nt,jt,qt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pcc=void 0;function Bt(at){const lt=at.get(oe.$2L),Ht=at.get(ze.$mac),Pt=at.get(G.$Rac),kt=at.get(s.$8ac),dt=at.get(de.$zac),It=at.get(Xe.$6L),zt=at.get(c.$Cac),yt=at.get(be.$wac),Ve=at.get(ke.$LL),Ie=at.get(B.$Nac),Le=at.get(q.$Sac),me=at.get(ve.$Si),H=at.get(ve.$Ri),Fe=at.get(ie.$Lrb),Be=at.get(ge.$pac),Ge=at.get(X.$tbc),qe=at.get(He.$Zac),_e=at.get(et.$Bbc),$t=at.get(Ot.$4ac);Ve.set(u.$KJ.ExtHostFileSystemInfo,Ht),Ve.set(u.$KJ.ExtHostLogLevelServiceShape,me),Ve.set(u.$KJ.ExtHostWorkspace,dt),Ve.set(u.$KJ.ExtHostConfiguration,zt),Ve.set(u.$KJ.ExtHostExtensionService,kt),Ve.set(u.$KJ.ExtHostStorage,Ie),Ve.set(u.$KJ.ExtHostTunnelService,Fe),Ve.set(u.$KJ.ExtHostWindow,Ge),Ve.set(u.$KJ.ExtHostSecretState,qe),Ve.set(u.$KJ.ExtHostTelemetry,It),Ve.set(u.$KJ.ExtHostEditorTabs,_e),Ve.set(u.$KJ.ExtHostManagedSockets,$t);const Et=Ve.set(u.$KJ.ExtHostDecorations,at.get(O.$xbc)),pt=Ve.set(u.$KJ.ExtHostDocumentsAndEditors,at.get(r.$WL)),ct=Ve.set(u.$KJ.ExtHostCommands,at.get(t.$8L)),mt=Ve.set(u.$KJ.ExtHostTerminalService,at.get(j.$Uac)),Dt=Ve.set(u.$KJ.ExtHostDebugService,at.get(le.$Fbc)),gi=Ve.set(u.$KJ.ExtHostSearch,at.get(ye.$Pbc)),Kt=Ve.set(u.$KJ.ExtHostTask,at.get(J.$Abc)),Ei=Ve.set(u.$KJ.ExtHostOutputService,at.get(l.$dbc)),Wt=Ve.set(u.$KJ.ExtHostLocalization,at.get(nt.$3ac)),mi=Ve.set(u.$KJ.ExtHostUrls,new Ee.$mbc(Ve)),Ct=Ve.set(u.$KJ.ExtHostDocuments,new a.$kac(Ve,pt)),ki=Ve.set(u.$KJ.ExtHostDocumentContentProviders,new C.$Eac(Ve,pt,H)),Vi=Ve.set(u.$KJ.ExtHostDocumentSaveParticipant,new n.$Fac(H,Ct,Ve.getProxy(u.$JJ.MainThreadBulkEdits))),St=Ve.set(u.$KJ.ExtHostNotebook,new he.$Vbc(Ve,ct,pt,Ct,Pt)),ti=Ve.set(u.$KJ.ExtHostNotebookDocuments,new Y.$bcc(St)),$i=Ve.set(u.$KJ.ExtHostNotebookEditors,new x.$acc(H,St)),si=Ve.set(u.$KJ.ExtHostNotebookKernels,new xe.$0bc(Ve,lt,St,ct,H)),Di=Ve.set(u.$KJ.ExtHostNotebookRenderers,new tt.$_bc(Ve,St)),Si=Ve.set(u.$KJ.ExtHostNotebookDocumentSaveParticipant,new vt.$hcc(H,St,Ve.getProxy(u.$JJ.MainThreadBulkEdits))),Lt=Ve.set(u.$KJ.ExtHostEditors,new U.$kbc(Ve,pt)),pi=Ve.set(u.$KJ.ExtHostTreeViews,new z.$lbc(Ve.getProxy(u.$JJ.MainThreadTreeViews),ct,H)),Ii=Ve.set(u.$KJ.ExtHostEditorInsets,new ae.$ubc(Ve.getProxy(u.$JJ.MainThreadEditorInsets),Lt,lt.remote)),oi=Ve.set(u.$KJ.ExtHostDiagnostics,new g.$oac(Ve,H,Ht,pt)),ai=Ve.set(u.$KJ.ExtHostLanguages,new E.$abc(Ve,Ct,ct.converter,yt)),ut=Ve.set(u.$KJ.ExtHostLanguageFeatures,new w.$sac(Ve,yt,Ct,ct,oi,H,Be,It)),qi=Ve.set(u.$KJ.ExtHostFileSystem,new v.$$ac(Ve,ut)),Zt=Ve.set(u.$KJ.ExtHostFileSystemEventService,new $.$_ac(Ve,H,pt)),ii=Ve.set(u.$KJ.ExtHostQuickOpen,(0,F.$fbc)(Ve,dt,ct)),bi=Ve.set(u.$KJ.ExtHostSCM,new W.$hbc(Ve,ct,Ct,H)),Ci=Ve.set(u.$KJ.ExtHostQuickDiff,new Tt.$ecc(Ve,yt)),Ki=Ve.set(u.$KJ.ExtHostShare,new Jt.$jcc(Ve,yt)),Pi=Ve.set(u.$KJ.ExtHostComments,(0,i.$vac)(Ve,ct,Ct)),vi=Ve.set(u.$KJ.ExtHostProgress,new m.$ebc(Ve.getProxy(u.$JJ.MainThreadProgress))),Ji=Ve.set(u.$KJ.ExtHosLabelService,new _.$vbc(Ve)),Ai=Ve.set(u.$KJ.ExtHostTheming,new re.$Wbc(Ve)),ci=Ve.set(u.$KJ.ExtHostAuthentication,new Se.$Xbc(Ve)),Hi=Ve.set(u.$KJ.ExtHostTimeline,new L.$Zbc(Ve,ct)),wi=Ve.set(u.$KJ.ExtHostWebviews,new Re.$pbc(Ve,lt.remote,dt,H,Be)),Ri=Ve.set(u.$KJ.ExtHostWebviewPanels,new ee.$2bc(Ve,wi,dt)),cn=Ve.set(u.$KJ.ExtHostCustomEditors,new K.$3bc(Ve,Ct,Le,wi,Ri)),Li=Ve.set(u.$KJ.ExtHostWebviewViews,new Q.$1bc(Ve,wi)),ni=Ve.set(u.$KJ.ExtHostTesting,new Ue.$5bc(Ve,ct,pt)),un=Ve.set(u.$KJ.ExtHostUriOpeners,new Qe.$9bc(Ve)),ln=Ve.set(u.$KJ.ExtHostProfileContentHandlers,new bt.$dcc(Ve));Ve.set(u.$KJ.ExtHostInteractive,new $e.$ccc(Ve,St,pt,ct,H));const Gi=Ve.set(u.$KJ.ExtHostInlineChat,new Vt.$gcc(Ve,ct,Ct,H)),fi=Ve.set(u.$KJ.ExtHostChatProvider,new At.$kcc(Ve,H)),Qi=Ve.set(u.$KJ.ExtHostChatSlashCommands,new Rt.$lcc(Ve,fi,H)),Yi=Ve.set(u.$KJ.ExtHostChatVariables,new Nt.$mcc(Ve)),ui=Ve.set(u.$KJ.ExtHostChat,new Yt.$fcc(Ve,H)),Zi=Ve.set(u.$KJ.ExtHostAiRelatedInformation,new jt.$ncc(Ve)),Fi=Ve.set(u.$KJ.ExtHostAiEmbeddingVector,new qt.$occ(Ve)),Xi=Ve.set(u.$KJ.ExtHostIssueReporter,new Mt.$icc(Ve)),Xt=Ve.set(u.$KJ.ExtHostStatusBar,new V.$jbc(Ve,ct.converter)),yi=Object.values(u.$KJ);Ve.assertRegistered(yi);const hn=new ce.$4bc(Ve,pt),Gt=new h.$uac(Ve),li=new o.$bbc(Ve,H),Ti=new S.$Dac(Ve);return p.$tac.register(ct),function(Me,_t,Mi){const gt=function(){let te=!Me.isUnderDevelopment;function fe(){te||(H.info(`Extension '${Me.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),te=!0)}return function Te(rt){if(Array.isArray(rt))rt.forEach(Te);else if(typeof rt=="string")fe();else{const wt=rt;typeof wt.scheme>"u"&&fe(),typeof wt.exclusive=="boolean"&&(0,Oe.$EF)(Me,"documentFiltersExclusive")}return rt}}(),_i={getSession(te,fe,Te){return ci.getSession(Me,te,fe,Te)},getSessions(te,fe){return(0,Oe.$EF)(Me,"authGetSessions"),ci.getSessions(Me,te,fe)},async hasSession(te,fe){return(0,Oe.$EF)(Me,"authSession"),!!await ci.getSession(Me,te,fe,{silent:!0})},get onDidChangeSessions(){return ci.onDidChangeSessions},registerAuthenticationProvider(te,fe,Te,rt){return ci.registerAuthenticationProvider(te,fe,Te,rt)}},xi={registerCommand(te,fe,Te){return ct.registerCommand(!0,te,fe,Te,void 0,Me)},registerTextEditorCommand(te,fe,Te){return ct.registerCommand(!0,te,(...rt)=>{const wt=Lt.getActiveTextEditor();if(!wt){H.warn("Cannot execute "+te+" because there is no active text editor.");return}return wt.edit(Ft=>{fe.apply(Te,[wt,Ft,...rt])}).then(Ft=>{Ft||H.warn("Edits from command "+te+" were not applied.")},Ft=>{H.warn("An error occurred while running command "+te,Ft)})},void 0,void 0,Me)},registerDiffInformationCommand:(te,fe,Te)=>((0,Oe.$EF)(Me,"diffCommand"),ct.registerCommand(!0,te,async(...rt)=>{const wt=pt.activeEditor(!0);if(!wt){H.warn("Cannot execute "+te+" because there is no active text editor.");return}const Ft=await Lt.getDiffInformation(wt.id);fe.apply(Te,[Ft,...rt])},void 0,void 0,Me)),executeCommand(te,...fe){return ct.executeCommand(te,...fe)},getCommands(te=!1){return ct.getCommands(te)}},en={get machineId(){return lt.telemetryInfo.machineId},get sessionId(){return lt.telemetryInfo.sessionId},get language(){return lt.environment.appLanguage},get appName(){return lt.environment.appName},get appRoot(){return lt.environment.appRoot?.fsPath??""},get appHost(){return lt.environment.appHost},get uriScheme(){return lt.environment.appUriScheme},get clipboard(){return Gt.value},get shell(){return mt.getDefaultShell(!1)},get onDidChangeShell(){return(0,Oe.$EF)(Me,"envShellEvent"),mt.onDidChangeShell},get isTelemetryEnabled(){return It.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return It.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Oe.$EF)(Me,"telemetry"),It.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Oe.$EF)(Me,"telemetry"),It.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,Xe.$5L)(lt.telemetryInfo.firstSessionDate)},createTelemetryLogger(te,fe){return Xe.$4L.validateSender(te),It.instantiateLogger(Me,te,fe)},openExternal(te,fe){return Ge.openUri(te,{allowTunneling:!!lt.remote.authority,allowContributedOpeners:fe?.allowContributedOpeners})},async asExternalUri(te){if(te.scheme===lt.environment.appUriScheme)return mi.createAppUri(te);try{return await Ge.asExternalUri(te,{allowTunneling:!!lt.remote.authority})}catch(fe){if((0,st.$rT)(te,Ne.Schemas.http)||(0,st.$rT)(te,Ne.Schemas.https))return te;throw fe}},get remoteName(){return(0,ue.$Ck)(lt.remote.authority)},get remoteAuthority(){return(0,Oe.$EF)(Me,"resolvers"),lt.remote.authority},get uiKind(){return lt.uiKind},get logLevel(){return H.getLevel()},get onDidChangeLogLevel(){return H.onDidChangeLogLevel},registerIssueUriRequestHandler(te){return(0,Oe.$EF)(Me,"handleIssueUri"),Xi.registerIssueUriRequestHandler(Me,te)},get appQuality(){return(0,Oe.$EF)(Me,"resolvers"),lt.quality},get appCommit(){return(0,Oe.$EF)(Me,"resolvers"),lt.commit}};lt.environment.extensionTestsLocationURI||Object.freeze(en);const dn={createTestController(te,fe,Te){return ni.createTestController(Me,te,fe,Te)},createTestObserver(){return(0,Oe.$EF)(Me,"testObserver"),ni.createTestObserver()},runTests(te){return(0,Oe.$EF)(Me,"testObserver"),ni.runTests(te)},get onDidChangeTestResults(){return(0,Oe.$EF)(Me,"testObserver"),ni.onResultsChanged},get testResults(){return(0,Oe.$EF)(Me,"testObserver"),ni.results}},hi=lt.remote.isRemote?Z.ExtensionKind.Workspace:Z.ExtensionKind.UI,tn={getExtension(te,fe){(0,Oe.$DF)(Me,"extensionsAny")||(fe=!1);const Te=_t.mine.getExtensionDescription(te);if(Te)return new s.$9ac(kt,Me.identifier,Te,hi,!1);if(fe){const rt=_t.all.getExtensionDescription(te);if(rt)return new s.$9ac(kt,Me.identifier,rt,hi,!0)}},get all(){const te=[];for(const fe of _t.mine.getAllExtensionDescriptions())te.push(new s.$9ac(kt,Me.identifier,fe,hi,!1));return te},get allAcrossExtensionHosts(){(0,Oe.$EF)(Me,"extensionsAny");const te=new Ce.$Jl(_t.mine.getAllExtensionDescriptions().map(Te=>Te.identifier)),fe=[];for(const Te of _t.all.getAllExtensionDescriptions()){const rt=!te.has(Te.identifier);fe.push(new s.$9ac(kt,Me.identifier,Te,hi,rt))}return fe},get onDidChange(){return(0,Oe.$DF)(Me,"extensionsAny")?I.Event.any(_t.mine.onDidChange,_t.all.onDidChange):_t.mine.onDidChange}},nn={createDiagnosticCollection(te){return oi.createDiagnosticCollection(Me.identifier,te)},get onDidChangeDiagnostics(){return oi.onDidChangeDiagnostics},getDiagnostics:te=>oi.getDiagnostics(te),getLanguages(){return ai.getLanguages()},setTextDocumentLanguage(te,fe){return ai.changeLanguage(te.uri,fe)},match(te,fe){const Te=Ct.getDocumentData(fe.uri)?.notebook;return(0,P.$4E)(ne.LanguageSelector.from(te),fe.uri,fe.languageId,!0,Te?.uri,Te?.notebookType)},registerCodeActionsProvider(te,fe,Te){return ut.registerCodeActionProvider(Me,gt(te),fe,Te)},registerDocumentPasteEditProvider(te,fe,Te){return(0,Oe.$EF)(Me,"documentPaste"),ut.registerDocumentPasteEditProvider(Me,gt(te),fe,Te)},registerCodeLensProvider(te,fe){return ut.registerCodeLensProvider(Me,gt(te),fe)},registerDefinitionProvider(te,fe){return ut.registerDefinitionProvider(Me,gt(te),fe)},registerDeclarationProvider(te,fe){return ut.registerDeclarationProvider(Me,gt(te),fe)},registerImplementationProvider(te,fe){return ut.registerImplementationProvider(Me,gt(te),fe)},registerTypeDefinitionProvider(te,fe){return ut.registerTypeDefinitionProvider(Me,gt(te),fe)},registerHoverProvider(te,fe){return ut.registerHoverProvider(Me,gt(te),fe,Me.identifier)},registerEvaluatableExpressionProvider(te,fe){return ut.registerEvaluatableExpressionProvider(Me,gt(te),fe,Me.identifier)},registerInlineValuesProvider(te,fe){return ut.registerInlineValuesProvider(Me,gt(te),fe,Me.identifier)},registerDocumentHighlightProvider(te,fe){return ut.registerDocumentHighlightProvider(Me,gt(te),fe)},registerLinkedEditingRangeProvider(te,fe){return ut.registerLinkedEditingRangeProvider(Me,gt(te),fe)},registerReferenceProvider(te,fe){return ut.registerReferenceProvider(Me,gt(te),fe)},registerRenameProvider(te,fe){return ut.registerRenameProvider(Me,gt(te),fe)},registerDocumentSymbolProvider(te,fe,Te){return ut.registerDocumentSymbolProvider(Me,gt(te),fe,Te)},registerWorkspaceSymbolProvider(te){return ut.registerWorkspaceSymbolProvider(Me,te)},registerDocumentFormattingEditProvider(te,fe){return ut.registerDocumentFormattingEditProvider(Me,gt(te),fe)},registerDocumentRangeFormattingEditProvider(te,fe){return ut.registerDocumentRangeFormattingEditProvider(Me,gt(te),fe)},registerOnTypeFormattingEditProvider(te,fe,Te,...rt){return ut.registerOnTypeFormattingEditProvider(Me,gt(te),fe,[Te].concat(rt))},registerDocumentSemanticTokensProvider(te,fe,Te){return ut.registerDocumentSemanticTokensProvider(Me,gt(te),fe,Te)},registerDocumentRangeSemanticTokensProvider(te,fe,Te){return ut.registerDocumentRangeSemanticTokensProvider(Me,gt(te),fe,Te)},registerSignatureHelpProvider(te,fe,Te,...rt){return typeof Te=="object"?ut.registerSignatureHelpProvider(Me,gt(te),fe,Te):ut.registerSignatureHelpProvider(Me,gt(te),fe,typeof Te>"u"?[]:[Te,...rt])},registerCompletionItemProvider(te,fe,...Te){return ut.registerCompletionItemProvider(Me,gt(te),fe,Te)},registerInlineCompletionItemProvider(te,fe,Te){return fe.handleDidShowCompletionItem&&(0,Oe.$EF)(Me,"inlineCompletionsAdditions"),fe.handleDidPartiallyAcceptCompletionItem&&(0,Oe.$EF)(Me,"inlineCompletionsAdditions"),Te&&(0,Oe.$EF)(Me,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(Me,gt(te),fe,Te)},registerDocumentLinkProvider(te,fe){return ut.registerDocumentLinkProvider(Me,gt(te),fe)},registerColorProvider(te,fe){return ut.registerColorProvider(Me,gt(te),fe)},registerFoldingRangeProvider(te,fe){return ut.registerFoldingRangeProvider(Me,gt(te),fe)},registerSelectionRangeProvider(te,fe){return ut.registerSelectionRangeProvider(Me,te,fe)},registerCallHierarchyProvider(te,fe){return ut.registerCallHierarchyProvider(Me,te,fe)},registerTypeHierarchyProvider(te,fe){return ut.registerTypeHierarchyProvider(Me,te,fe)},setLanguageConfiguration:(te,fe)=>ut.setLanguageConfiguration(Me,te,fe),getTokenInformationAtPosition(te,fe){return(0,Oe.$EF)(Me,"tokenInformation"),ai.tokenAtPosition(te,fe)},registerInlayHintsProvider(te,fe){return ut.registerInlayHintsProvider(Me,te,fe)},createLanguageStatusItem(te,fe){return ai.createLanguageStatusItem(Me,te,fe)},registerDocumentDropEditProvider(te,fe,Te){return ut.registerDocumentOnDropEditProvider(Me,te,fe,(0,Oe.$DF)(Me,"dropMetadata")?Te:void 0)}},rn={get activeTextEditor(){return Lt.getActiveTextEditor()},get visibleTextEditors(){return Lt.getVisibleTextEditors()},get activeTerminal(){return mt.activeTerminal},get terminals(){return mt.terminals},async showTextDocument(te,fe,Te){const rt=await(A.URI.isUri(te)?Promise.resolve(sn.openTextDocument(te)):Promise.resolve(te));return Lt.showTextDocument(rt,fe,Te)},createTextEditorDecorationType(te){return Lt.createTextEditorDecorationType(Me,te)},onDidChangeActiveTextEditor(te,fe,Te){return Lt.onDidChangeActiveTextEditor(te,fe,Te)},onDidChangeVisibleTextEditors(te,fe,Te){return Lt.onDidChangeVisibleTextEditors(te,fe,Te)},onDidChangeTextEditorSelection(te,fe,Te){return Lt.onDidChangeTextEditorSelection(te,fe,Te)},onDidChangeTextEditorOptions(te,fe,Te){return Lt.onDidChangeTextEditorOptions(te,fe,Te)},onDidChangeTextEditorVisibleRanges(te,fe,Te){return Lt.onDidChangeTextEditorVisibleRanges(te,fe,Te)},onDidChangeTextEditorViewColumn(te,fe,Te){return Lt.onDidChangeTextEditorViewColumn(te,fe,Te)},onDidCloseTerminal(te,fe,Te){return mt.onDidCloseTerminal(te,fe,Te)},onDidOpenTerminal(te,fe,Te){return mt.onDidOpenTerminal(te,fe,Te)},onDidChangeActiveTerminal(te,fe,Te){return mt.onDidChangeActiveTerminal(te,fe,Te)},onDidChangeTerminalDimensions(te,fe,Te){return(0,Oe.$EF)(Me,"terminalDimensions"),mt.onDidChangeTerminalDimensions(te,fe,Te)},onDidChangeTerminalState(te,fe,Te){return mt.onDidChangeTerminalState(te,fe,Te)},onDidWriteTerminalData(te,fe,Te){return(0,Oe.$EF)(Me,"terminalDataWriteEvent"),mt.onDidWriteTerminalData(te,fe,Te)},onDidExecuteTerminalCommand(te,fe,Te){return(0,Oe.$EF)(Me,"terminalExecuteCommandEvent"),mt.onDidExecuteTerminalCommand(te,fe,Te)},get state(){return Ge.getState(Me)},onDidChangeWindowState(te,fe,Te){return Ge.onDidChangeWindowState(te,fe,Te)},showInformationMessage(te,...fe){return li.showMessage(Me,M.default.Info,te,fe[0],fe.slice(1))},showWarningMessage(te,...fe){return li.showMessage(Me,M.default.Warning,te,fe[0],fe.slice(1))},showErrorMessage(te,...fe){return li.showMessage(Me,M.default.Error,te,fe[0],fe.slice(1))},showQuickPick(te,fe,Te){return ii.showQuickPick(Me,te,fe,Te)},showWorkspaceFolderPick(te){return ii.showWorkspaceFolderPick(te)},showInputBox(te,fe){return ii.showInput(te,fe)},showOpenDialog(te){return Ti.showOpenDialog(Me,te)},showSaveDialog(te){return Ti.showSaveDialog(te)},createStatusBarItem(te,fe,Te){let rt,wt,Ft;return typeof te=="string"?(rt=te,wt=fe,Ft=Te):(wt=te,Ft=fe),Xt.createStatusBarEntry(Me,rt,wt,Ft)},setStatusBarMessage(te,fe){return Xt.setStatusBarMessage(te,fe)},withScmProgress(te){return Be.report("window.withScmProgress",Me,"Use 'withProgress' instead."),vi.withProgress(Me,{location:Z.ProgressLocation.SourceControl},(fe,Te)=>te({report(rt){}}))},withProgress(te,fe){return vi.withProgress(Me,te,fe)},createOutputChannel(te,fe){return Ei.createOutputChannel(te,fe,Me)},createWebviewPanel(te,fe,Te,rt){return Ri.createWebviewPanel(Me,te,fe,Te,rt)},createWebviewTextEditorInset(te,fe,Te,rt){return(0,Oe.$EF)(Me,"editorInsets"),Ii.createWebviewEditorInset(te,fe,Te,rt,Me)},createTerminal(te,fe,Te){return typeof te=="object"?"pty"in te?mt.createExtensionTerminal(te):mt.createTerminalFromOptions(te):mt.createTerminal(te,fe,Te)},registerTerminalLinkProvider(te){return mt.registerLinkProvider(te)},registerTerminalProfileProvider(te,fe){return mt.registerProfileProvider(Me,te,fe)},registerTerminalQuickFixProvider(te,fe){return(0,Oe.$EF)(Me,"terminalQuickFixProvider"),mt.registerTerminalQuickFixProvider(te,Me.identifier.value,fe)},registerTreeDataProvider(te,fe){return pi.registerTreeDataProvider(te,fe,Me)},createTreeView(te,fe){return pi.createTreeView(te,fe,Me)},registerWebviewPanelSerializer:(te,fe)=>Ri.registerWebviewPanelSerializer(Me,te,fe),registerCustomEditorProvider:(te,fe,Te={})=>cn.registerCustomEditorProvider(Me,te,fe,Te),registerFileDecorationProvider(te){return Et.registerFileDecorationProvider(te,Me)},registerUriHandler(te){return mi.registerUriHandler(Me,te)},createQuickPick(){return ii.createQuickPick(Me)},createInputBox(){return ii.createInputBox(Me)},get activeColorTheme(){return Ai.activeColorTheme},onDidChangeActiveColorTheme(te,fe,Te){return Ai.onDidChangeActiveColorTheme(te,fe,Te)},registerWebviewViewProvider(te,fe,Te){return Li.registerWebviewViewProvider(Me,te,fe,Te?.webviewOptions)},get activeNotebookEditor(){return St.activeNotebookEditor},onDidChangeActiveNotebookEditor(te,fe,Te){return St.onDidChangeActiveNotebookEditor(te,fe,Te)},get visibleNotebookEditors(){return St.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return St.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(te,fe,Te){return $i.onDidChangeNotebookEditorSelection(te,fe,Te)},onDidChangeNotebookEditorVisibleRanges(te,fe,Te){return $i.onDidChangeNotebookEditorVisibleRanges(te,fe,Te)},showNotebookDocument(te,fe){return St.showNotebookDocument(te,fe)},registerExternalUriOpener(te,fe,Te){return(0,Oe.$EF)(Me,"externalUriOpener"),un.registerExternalUriOpener(Me.identifier,te,fe,Te)},registerProfileContentHandler(te,fe){return(0,Oe.$EF)(Me,"profileContentHandlers"),ln.registrProfileContentHandler(Me,te,fe)},registerQuickDiffProvider(te,fe,Te,rt){return(0,Oe.$EF)(Me,"quickDiffProvider"),Ci.registerQuickDiffProvider(gt(te),fe,Te,rt)},get tabGroups(){return _e.tabGroups},registerShareProvider(te,fe){return(0,Oe.$EF)(Me,"shareProvider"),Ki.registerShareProvider(gt(te),fe)}},sn={get rootPath(){return Be.report("workspace.rootPath",Me,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),dt.getPath()},set rootPath(te){throw R.$7()},getWorkspaceFolder(te){return dt.getWorkspaceFolder(te)},get workspaceFolders(){return dt.getWorkspaceFolders()},get name(){return dt.name},set name(te){throw R.$7()},get workspaceFile(){return dt.workspaceFile},set workspaceFile(te){throw R.$7()},updateWorkspaceFolders:(te,fe,...Te)=>dt.updateWorkspaceFolders(Me,te,fe||0,...Te),onDidChangeWorkspaceFolders:function(te,fe,Te){return dt.onDidChangeWorkspace(te,fe,Te)},asRelativePath:(te,fe)=>dt.getRelativePath(te,fe),findFiles:(te,fe,Te,rt)=>dt.findFiles(te,fe,Te,Me.identifier,rt),findTextInFiles:(te,fe,Te,rt)=>{(0,Oe.$EF)(Me,"findTextInFiles");let wt,Ft;return typeof fe=="object"?(wt=fe,Ft=Te):(wt={},Ft=fe,rt=Te),dt.findTextInFiles(te,wt||{},Ft,Me.identifier,rt)},save:te=>((0,Oe.$EF)(Me,"saveEditor"),dt.save(te)),saveAs:te=>((0,Oe.$EF)(Me,"saveEditor"),dt.saveAs(te)),saveAll:te=>dt.saveAll(te),applyEdit(te,fe){return hn.applyWorkspaceEdit(te,Me,fe)},createFileSystemWatcher:(te,fe,Te,rt)=>Zt.createFileSystemWatcher(dt,Me,te,fe,Te,rt),get textDocuments(){return Ct.getAllDocumentData().map(te=>te.document)},set textDocuments(te){throw R.$7()},openTextDocument(te){let fe;const Te=te;if(typeof te=="string")fe=Promise.resolve(A.URI.file(te));else if(A.URI.isUri(te))fe=Promise.resolve(te);else if(!Te||typeof Te=="object")fe=Ct.createDocumentData(Te);else throw new Error("illegal argument - uriOrFileNameOrOptions");return fe.then(rt=>Ct.ensureDocumentData(rt).then(wt=>wt.document))},onDidOpenTextDocument:(te,fe,Te)=>Ct.onDidAddDocument(te,fe,Te),onDidCloseTextDocument:(te,fe,Te)=>Ct.onDidRemoveDocument(te,fe,Te),onDidChangeTextDocument:(te,fe,Te)=>Ct.onDidChangeDocument(te,fe,Te),onDidSaveTextDocument:(te,fe,Te)=>Ct.onDidSaveDocument(te,fe,Te),onWillSaveTextDocument:(te,fe,Te)=>Vi.getOnWillSaveTextDocumentEvent(Me)(te,fe,Te),get notebookDocuments(){return St.notebookDocuments.map(te=>te.apiNotebook)},async openNotebookDocument(te,fe){let Te;if(A.URI.isUri(te))Te=te,await St.openNotebookDocument(te);else if(typeof te=="string")Te=A.URI.revive(await St.createNotebookDocument({viewType:te,content:fe}));else throw new Error("Invalid arguments");return St.getNotebookDocument(Te).apiNotebook},onDidSaveNotebookDocument(te,fe,Te){return ti.onDidSaveNotebookDocument(te,fe,Te)},onDidChangeNotebookDocument(te,fe,Te){return ti.onDidChangeNotebookDocument(te,fe,Te)},onWillSaveNotebookDocument(te,fe,Te){return Si.getOnWillSaveNotebookDocumentEvent(Me)(te,fe,Te)},get onDidOpenNotebookDocument(){return St.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return St.onDidCloseNotebookDocument},registerNotebookSerializer(te,fe,Te,rt){return St.registerNotebookSerializer(Me,te,fe,Te,(0,Oe.$DF)(Me,"notebookLiveShare")?rt:void 0)},onDidChangeConfiguration:(te,fe,Te)=>Mi.onDidChangeConfiguration(te,fe,Te),getConfiguration(te,fe){return fe=arguments.length===1?void 0:fe,Mi.getConfiguration(te,fe,Me)},registerTextDocumentContentProvider(te,fe){return ki.registerTextDocumentContentProvider(te,fe)},registerTaskProvider:(te,fe)=>(Be.report("window.registerTaskProvider",Me,"Use the corresponding function on the 'tasks' namespace instead"),Kt.registerTaskProvider(Me,te,fe)),registerFileSystemProvider(te,fe,Te){return(0,je.$ib)(qi.registerFileSystemProvider(Me,te,fe,Te),Pt.addFileSystemProvider(te,fe,Te))},get fs(){return Pt.value},registerFileSearchProvider:(te,fe)=>((0,Oe.$EF)(Me,"fileSearchProvider"),gi.registerFileSearchProvider(te,fe)),registerTextSearchProvider:(te,fe)=>((0,Oe.$EF)(Me,"textSearchProvider"),gi.registerTextSearchProvider(te,fe)),registerRemoteAuthorityResolver:(te,fe)=>((0,Oe.$EF)(Me,"resolvers"),kt.registerRemoteAuthorityResolver(te,fe)),registerResourceLabelFormatter:te=>((0,Oe.$EF)(Me,"resolvers"),Ji.$registerResourceLabelFormatter(te)),getRemoteExecServer:te=>((0,Oe.$EF)(Me,"resolvers"),kt.getRemoteExecServer(te)),onDidCreateFiles:(te,fe,Te)=>Zt.onDidCreateFile(te,fe,Te),onDidDeleteFiles:(te,fe,Te)=>Zt.onDidDeleteFile(te,fe,Te),onDidRenameFiles:(te,fe,Te)=>Zt.onDidRenameFile(te,fe,Te),onWillCreateFiles:(te,fe,Te)=>Zt.getOnWillCreateFileEvent(Me)(te,fe,Te),onWillDeleteFiles:(te,fe,Te)=>Zt.getOnWillDeleteFileEvent(Me)(te,fe,Te),onWillRenameFiles:(te,fe,Te)=>Zt.getOnWillRenameFileEvent(Me)(te,fe,Te),openTunnel:te=>((0,Oe.$EF)(Me,"tunnels"),Fe.openTunnel(Me,te).then(fe=>{if(!fe)throw new Error("cannot open tunnel");return fe})),get tunnels(){return(0,Oe.$EF)(Me,"tunnels"),Fe.getTunnels()},onDidChangeTunnels:(te,fe,Te)=>((0,Oe.$EF)(Me,"tunnels"),Fe.onDidChangeTunnels(te,fe,Te)),registerPortAttributesProvider:(te,fe)=>((0,Oe.$EF)(Me,"portsAttributes"),Fe.registerPortsAttributesProvider(te,fe)),registerTunnelProvider:(te,fe)=>((0,Oe.$EF)(Me,"tunnelFactory"),Fe.registerTunnelProvider(te,fe)),registerTimelineProvider:(te,fe)=>((0,Oe.$EF)(Me,"timeline"),Hi.registerTimelineProvider(te,fe,Me.identifier,ct.converter)),get isTrusted(){return dt.trusted},requestWorkspaceTrust:te=>((0,Oe.$EF)(Me,"workspaceTrust"),dt.requestWorkspaceTrust(te)),onDidGrantWorkspaceTrust:(te,fe,Te)=>dt.onDidGrantWorkspaceTrust(te,fe,Te),registerEditSessionIdentityProvider:(te,fe)=>((0,Oe.$EF)(Me,"editSessionIdentityProvider"),dt.registerEditSessionIdentityProvider(te,fe)),onWillCreateEditSessionIdentity:(te,fe,Te)=>((0,Oe.$EF)(Me,"editSessionIdentityProvider"),dt.getOnWillCreateEditSessionIdentityEvent(Me)(te,fe,Te)),registerCanonicalUriProvider:(te,fe)=>((0,Oe.$EF)(Me,"canonicalUriProvider"),dt.registerCanonicalUriProvider(te,fe)),getCanonicalUri:(te,fe,Te)=>((0,Oe.$EF)(Me,"canonicalUriProvider"),dt.provideCanonicalUri(te,fe,Te))},fn={get inputBox(){return Be.report("scm.inputBox",Me,"Use 'SourceControl.inputBox' instead"),bi.getLastInputBox(Me)},createSourceControl(te,fe,Te){return bi.createSourceControl(Me,te,fe,Te)}},on={createCommentController(te,fe){return Pi.createCommentController(Me,te,fe)}},an={get activeDebugSession(){return Dt.activeDebugSession},get activeDebugConsole(){return Dt.activeDebugConsole},get breakpoints(){return Dt.breakpoints},get stackFrameFocus(){return Dt.stackFrameFocus},onDidStartDebugSession(te,fe,Te){return Dt.onDidStartDebugSession(te,fe,Te)},onDidTerminateDebugSession(te,fe,Te){return Dt.onDidTerminateDebugSession(te,fe,Te)},onDidChangeActiveDebugSession(te,fe,Te){return Dt.onDidChangeActiveDebugSession(te,fe,Te)},onDidReceiveDebugSessionCustomEvent(te,fe,Te){return Dt.onDidReceiveDebugSessionCustomEvent(te,fe,Te)},onDidChangeBreakpoints(te,fe,Te){return Dt.onDidChangeBreakpoints(te,fe,Te)},onDidChangeStackFrameFocus(te,fe,Te){return(0,Oe.$EF)(Me,"debugFocus"),Dt.onDidChangeStackFrameFocus(te,fe,Te)},registerDebugConfigurationProvider(te,fe,Te){return Dt.registerDebugConfigurationProvider(te,fe,Te||Ye.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(te,fe){return Dt.registerDebugAdapterDescriptorFactory(Me,te,fe)},registerDebugAdapterTrackerFactory(te,fe){return Dt.registerDebugAdapterTrackerFactory(te,fe)},startDebugging(te,fe,Te){return!Te||typeof Te=="object"&&"configuration"in Te?Dt.startDebugging(te,fe,{parentSession:Te}):Dt.startDebugging(te,fe,Te||{})},stopDebugging(te){return Dt.stopDebugging(te)},addBreakpoints(te){return Dt.addBreakpoints(te)},removeBreakpoints(te){return Dt.removeBreakpoints(te)},asDebugSourceUri(te,fe){return Dt.asDebugSourceUri(te,fe)}},zi={registerTaskProvider:(te,fe)=>Kt.registerTaskProvider(Me,te,fe),fetchTasks:te=>Kt.fetchTasks(te),executeTask:te=>Kt.executeTask(Me,te),get taskExecutions(){return Kt.taskExecutions},onDidStartTask:(te,fe,Te)=>Kt.onDidStartTask(te,fe,Te),onDidEndTask:(te,fe,Te)=>Kt.onDidEndTask(te,fe,Te),onDidStartTaskProcess:(te,fe,Te)=>Kt.onDidStartTaskProcess(te,fe,Te),onDidEndTaskProcess:(te,fe,Te)=>Kt.onDidEndTaskProcess(te,fe,Te)},Oi={createNotebookController(te,fe,Te,rt,wt){return si.createNotebookController(Me,te,fe,Te,rt,(0,Oe.$DF)(Me,"notebookMessaging")?wt:void 0)},registerNotebookCellStatusBarItemProvider:(te,fe)=>St.registerNotebookCellStatusBarItemProvider(Me,te,fe),createRendererMessaging(te){return Di.createRendererMessaging(Me,te)},createNotebookControllerDetectionTask(te){return(0,Oe.$EF)(Me,"notebookKernelSource"),si.createNotebookControllerDetectionTask(Me,te)},registerKernelSourceActionProvider(te,fe){return(0,Oe.$EF)(Me,"notebookKernelSource"),si.registerKernelSourceActionProvider(Me,te,fe)},onDidChangeNotebookCellExecutionState(te,fe,Te){return(0,Oe.$EF)(Me,"notebookCellExecutionState"),si.onDidChangeNotebookCellExecutionState(te,fe,Te)}},Ni={t(...te){if(typeof te[0]=="string"){const fe=te.shift(),Te=!te||typeof te[0]!="object"?te:te[0];return Wt.getMessage(Me.identifier.value,{message:fe,args:Te})}return Wt.getMessage(Me.identifier.value,te[0])},get bundle(){return Wt.getBundle(Me.identifier.value)},get uri(){return Wt.getBundleUri(Me.identifier.value)}},di={_version:1,registerInteractiveEditorSessionProvider(te){return(0,Oe.$EF)(Me,"interactive"),Gi.registerProvider(Me,te)},registerInteractiveSessionProvider(te,fe){return(0,Oe.$EF)(Me,"interactive"),ui.registerChatProvider(Me,te,fe)},addInteractiveRequest(te){return(0,Oe.$EF)(Me,"interactive"),ui.addChatRequest(te)},sendInteractiveRequestToProvider(te,fe){return(0,Oe.$EF)(Me,"interactive"),ui.sendInteractiveRequestToProvider(te,fe)},get onDidPerformUserAction(){return(0,Oe.$EF)(Me,"interactiveUserActions"),ui.onDidPerformUserAction},transferChatSession(te,fe){return(0,Oe.$EF)(Me,"interactive"),ui.transferChatSession(te,fe)}},Ui={getRelatedInformation(te,fe){return(0,Oe.$EF)(Me,"aiRelatedInformation"),Zi.getRelatedInformation(Me,te,fe)},registerRelatedInformationProvider(te,fe){return(0,Oe.$EF)(Me,"aiRelatedInformation"),Zi.registerRelatedInformationProvider(Me,te,fe)},registerEmbeddingVectorProvider(te,fe){return(0,Oe.$EF)(Me,"aiRelatedInformation"),Fi.registerEmbeddingVectorProvider(Me,te,fe)}},ji={registerChatResponseProvider(te,fe,Te){return(0,Oe.$EF)(Me,"chatProvider"),fi.registerProvider(Me.identifier,te,fe,Te)},registerSlashCommand(te,fe,Te){return(0,Oe.$EF)(Me,"chatSlashCommands"),Qi.registerCommand(Me.identifier,te,fe,Te??{description:""})},requestChatAccess(te){return(0,Oe.$EF)(Me,"chatRequestAccess"),fi.requestChatResponseProvider(Me.identifier,te)},registerVariable(te,fe,Te){return(0,Oe.$EF)(Me,"chatVariables"),Yi.registerVariableResolver(Me,te,fe,Te)},registerMappedEditsProvider(te,fe){return(0,Oe.$EF)(Me,"mappedEditsProvider"),ut.registerMappedEditsProvider(Me,te,fe)}};return{version:lt.version,ai:Ui,authentication:_i,commands:xi,comments:on,chat:ji,debug:an,env:en,extensions:tn,interactive:di,l10n:Ni,languages:nn,notebooks:Oi,scm:fn,tasks:zi,tests:dn,window:rn,workspace:sn,Breakpoint:Z.$KK,TerminalOutputAnchor:Z.TerminalOutputAnchor,ChatMessage:Z.$AL,ChatMessageRole:Z.ChatMessageRole,ChatVariableLevel:Z.ChatVariableLevel,CallHierarchyIncomingCall:Z.$0J,CallHierarchyItem:Z.$9J,CallHierarchyOutgoingCall:Z.$$J,CancellationError:R.$3,CancellationTokenSource:y.$oc,CandidatePortSource:u.CandidatePortSource,CodeAction:Z.$5J,CodeActionKind:Z.$6J,CodeActionTriggerKind:Z.CodeActionTriggerKind,CodeLens:Z.$_J,Color:Z.$mK,ColorInformation:Z.$nK,ColorPresentation:Z.$oK,ColorThemeKind:Z.ColorThemeKind,CommentMode:Z.CommentMode,CommentState:Z.CommentState,CommentThreadCollapsibleState:Z.CommentThreadCollapsibleState,CommentThreadState:Z.CommentThreadState,CompletionItem:Z.$gK,CompletionItemKind:Z.CompletionItemKind,CompletionItemTag:Z.CompletionItemTag,CompletionList:Z.$hK,CompletionTriggerKind:Z.CompletionTriggerKind,ConfigurationTarget:Z.ConfigurationTarget,CustomExecution:Z.$wK,DebugAdapterExecutable:Z.$OK,DebugAdapterInlineImplementation:Z.$RK,DebugAdapterNamedPipeServer:Z.$QK,DebugAdapterServer:Z.$PK,DebugConfigurationProviderTriggerKind:Ye.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Z.DebugConsoleMode,DecorationRangeBehavior:Z.DecorationRangeBehavior,Diagnostic:Z.$ZJ,DiagnosticRelatedInformation:Z.$YJ,DiagnosticSeverity:Z.DiagnosticSeverity,DiagnosticTag:Z.DiagnosticTag,Disposable:Z.$LJ,DocumentHighlight:Z.$2J,DocumentHighlightKind:Z.DocumentHighlightKind,DocumentLink:Z.$lK,DocumentSymbol:Z.$4J,EndOfLine:Z.EndOfLine,EnvironmentVariableMutatorType:Z.EnvironmentVariableMutatorType,EvaluatableExpression:Z.$UK,InlineValueText:Z.$VK,InlineValueVariableLookup:Z.$WK,InlineValueEvaluatableExpression:Z.$XK,InlineCompletionTriggerKind:Z.InlineCompletionTriggerKind,EventEmitter:I.$ec,ExtensionKind:Z.ExtensionKind,ExtensionMode:Z.ExtensionMode,ExternalUriOpenerPriority:Z.ExternalUriOpenerPriority,FileChangeType:Z.FileChangeType,FileDecoration:Z.$8K,FileDecoration2:Z.$8K,FileSystemError:Z.$ZK,FileType:D.FileType,FilePermission:D.FilePermission,FoldingRange:Z.$1K,FoldingRangeKind:Z.FoldingRangeKind,FunctionBreakpoint:Z.$MK,InlineCompletionItem:Z.$iK,InlineCompletionList:Z.$jK,Hover:Z.$1J,IndentAction:f.IndentAction,Location:Z.$XJ,MarkdownString:Z.$aK,OverviewRulerLane:k.OverviewRulerLane,ParameterInformation:Z.$bK,PortAutoForwardAction:Z.PortAutoForwardAction,Position:Z.$MJ,ProcessExecution:Z.$uK,ProgressLocation:Z.ProgressLocation,QuickInputButtons:Z.$7K,Range:Z.$NJ,RelativePattern:Z.$IK,Selection:Z.$OJ,SelectionRange:Z.$8J,SemanticTokens:Z.$4K,SemanticTokensBuilder:Z.$3K,SemanticTokensEdit:Z.$5K,SemanticTokensEdits:Z.$6K,SemanticTokensLegend:Z.$2K,ShellExecution:Z.$vK,ShellQuoting:Z.ShellQuoting,SignatureHelp:Z.$dK,SignatureHelpTriggerKind:Z.SignatureHelpTriggerKind,SignatureInformation:Z.$cK,SnippetString:Z.$WJ,SourceBreakpoint:Z.$LK,StandardTokenType:Z.StandardTokenType,StatusBarAlignment:Z.StatusBarAlignment,SymbolInformation:Z.$3J,SymbolKind:Z.SymbolKind,SymbolTag:Z.SymbolTag,Task:Z.$xK,TaskGroup:Z.$tK,TaskPanelKind:Z.TaskPanelKind,TaskRevealKind:Z.TaskRevealKind,TaskScope:Z.TaskScope,TerminalLink:Z.$pK,TerminalQuickFixExecuteTerminalCommand:Z.$rK,TerminalQuickFixOpener:Z.$qK,TerminalLocation:Z.TerminalLocation,TerminalProfile:Z.$sK,TerminalExitReason:Z.TerminalExitReason,TextDocumentSaveReason:Z.TextDocumentSaveReason,TextEdit:Z.$SJ,SnippetTextEdit:Z.$UJ,TextEditorCursorStyle:d.TextEditorCursorStyle,TextEditorLineNumbersStyle:Z.TextEditorLineNumbersStyle,TextEditorRevealType:Z.TextEditorRevealType,TextEditorSelectionChangeKind:Z.TextEditorSelectionChangeKind,TextDocumentChangeReason:Z.TextDocumentChangeReason,ThemeColor:Z.$HK,ThemeIcon:Z.$GK,TreeItem:Z.$yK,TreeItemCheckboxState:Z.TreeItemCheckboxState,TreeItemCollapsibleState:Z.TreeItemCollapsibleState,TypeHierarchyItem:Z.$qL,UIKind:b.UIKind,Uri:A.URI,ViewColumn:Z.ViewColumn,WorkspaceEdit:Z.$VJ,DocumentDropEdit:Z.$EK,DocumentPasteEdit:Z.$FK,InlayHint:Z.$fK,InlayHintLabelPart:Z.$eK,InlayHintKind:Z.InlayHintKind,RemoteAuthorityResolverError:Z.$RJ,ResolvedAuthority:Z.$PJ,ManagedResolvedAuthority:Z.$QJ,SourceControlInputBoxValidationType:Z.SourceControlInputBoxValidationType,ExtensionRuntime:Z.ExtensionRuntime,TimelineItem:Z.$fL,NotebookRange:Z.$0K,NotebookCellKind:Z.NotebookCellKind,NotebookCellExecutionState:Z.NotebookCellExecutionState,NotebookCellData:Z.$$K,NotebookData:Z.$_K,NotebookRendererScript:Z.$dL,NotebookCellStatusBarAlignment:Z.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Z.NotebookEditorRevealType,NotebookCellOutput:Z.$bL,NotebookCellOutputItem:Z.$aL,NotebookCellStatusBarItem:Z.$cL,NotebookControllerAffinity:Z.NotebookControllerAffinity,NotebookControllerAffinity2:Z.NotebookControllerAffinity2,NotebookEdit:Z.$TJ,NotebookKernelSourceAction:Z.$eL,PortAttributes:Z.$hL,LinkedEditingRanges:Z.$gL,TestResultState:Z.TestResultState,TestRunRequest:Z.$iL,TestMessage:Z.$jL,TestMessage2:Z.$jL,TestTag:Z.$kL,TestRunProfileKind:Z.TestRunProfileKind,TextSearchCompleteMessageType:it.TextSearchCompleteMessageType,DataTransfer:Z.$DK,DataTransferItem:Z.$zK,CoveredCount:Z.$lL,FileCoverage:Z.$mL,StatementCoverage:Z.$nL,BranchCoverage:Z.$oL,FunctionCoverage:Z.$pL,WorkspaceTrustState:Z.WorkspaceTrustState,LanguageStatusSeverity:Z.LanguageStatusSeverity,QuickPickItemKind:Z.QuickPickItemKind,InputBoxValidationSeverity:Z.InputBoxValidationSeverity,TabInputText:Z.$rL,TabInputTextDiff:Z.$sL,TabInputTextMerge:Z.$tL,TabInputCustom:Z.$uL,TabInputNotebook:Z.$wL,TabInputNotebookDiff:Z.$xL,TabInputWebview:Z.$vL,TabInputTerminal:Z.$yL,TabInputInteractiveWindow:Z.$zL,TelemetryTrustedValue:we.$4n,LogLevel:ve.LogLevel,EditSessionIdentityMatch:ft.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Z.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:Z.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:Z.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Z.$SK,ThreadFocus:Z.$TK,NotebookCodeActionKind:Z.$7J,RelatedInformationType:Z.RelatedInformationType}}}e.$pcc=Bt}),define(Pe[273],Ae([1,0,71,110,33,108,34,31,60,63,112,114,115,84,86,80,109,62,39,83,58,61,241,14,113,81,82]),function(pe,e,y,R,I,M,A,d,k,f,P,D,u,b,p,h,t,i,c,g,S,C,n,a,r,s,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,y.$dr)(s.$3ac,s.$2ac,1),(0,y.$dr)(a.$Si,n.$qcc,1),(0,y.$dr)(h.$pac,h.$qac,1),(0,y.$dr)(d.$8L,d.$7L,0),(0,y.$dr)(A.$Cac,A.$Aac,0),(0,y.$dr)(i.$Rac,i.$Qac,0),(0,y.$dr)(D.$Fbc,D.$Jbc,0),(0,y.$dr)(M.$xbc,M.$wbc,0),(0,y.$dr)(k.$WL,k.$VL,0),(0,y.$dr)(v.$4ac,v.$5ac,0),(0,y.$dr)(c.$mac,c.$lac,0),(0,y.$dr)(R.$dbc,R.$cbc,1),(0,y.$dr)(u.$Pbc,u.$Qbc,0),(0,y.$dr)(b.$Nac,b.$Mac,0),(0,y.$dr)(P.$Abc,P.$zbc,0),(0,y.$dr)(f.$Uac,f.$Xac,0),(0,y.$dr)(p.$Lrb,p.$Mrb,0),(0,y.$dr)(t.$tbc,t.$sbc,0),(0,y.$dr)(I.$zac,I.$yac,0),(0,y.$dr)(g.$Zac,g.$Yac,0),(0,y.$dr)(S.$6L,S.$3L,0),(0,y.$dr)(C.$Bbc,C.$Cbc,0),(0,y.$dr)(r.$Dbc,r.$Ebc,0)}),define(Pe[274],Ae([1,0,272,35,2,269,7,13,260]),function(pe,e,y,R,I,M,A,d,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yec=void 0;class f extends M.$tcc{j(){}getModule(b,p){for(const h of this.b){const t=h(b);if(t){b=t;break}}if(this.a.has(b))return this.a.get(b).load(b,p,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class P extends R.$7ac{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Webworker}async pb(){this.h.createInstance(k.$xec);const b=this.h.invokeFunction(y.$pcc);this.r=this.h.createInstance(f,b,{mine:this.F,all:this.G}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.vb()}qb(b){return b.browser}async rb(b,p,h){p=p.with({path:D(p.path,".js")});const t=b?.identifier.value;t&&performance.mark(`code/extHost/willFetchExtensionCode/${t}`);const i=I.URI.revive(await this.v.$asBrowserUri(p)),c=await fetch(i.toString(!0));if(t&&performance.mark(`code/extHost/didFetchExtensionCode/${t}`),c.status!==200)throw new Error(c.statusText);const g=await c.text(),S=`${p.toString(!0)}#vscode-extension`,C=`${g}
//# sourceURL=${S}`;let n;try{n=new Function("module","exports","require",C)}catch(v){throw console.error(t?`Loading code for extension ${t} failed: ${v.message}`:`Loading code failed: ${v.message}`),console.error(`${p.toString(!0)}${typeof v.line=="number"?` line ${v.line}`:""}${typeof v.column=="number"?` column ${v.column}`:""}`),console.error(v),v}b&&await this.s.initializeLocalizedMessages(b);const a={},r={exports:a},s=v=>{const $=this.r.getModule(v,p);if($===void 0)throw new Error(`Cannot load module '${v}'`);return $};try{return h.codeLoadingStart(),t&&performance.mark(`code/extHost/willLoadExtensionCode/${t}`),n(r,a,s),r.exports!==a?r.exports:a}finally{t&&performance.mark(`code/extHost/didLoadExtensionCode/${t}`),h.codeLoadingStop()}}async $setRemoteEnvironment(b){}async vb(b=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const p=Date.now()+b;for(;Date.now()<p&&!("__jsDebugIsReady"in globalThis);)await(0,d.$vg)(10)}}e.$yec=P;function D(u,b){return u.endsWith(b)?u:u+b}}),define(Pe[275],Ae([1,0,70,71,14,35,188,85,274]),function(pe,e,y,R,I,M,A,d,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,R.$dr)(I.$Ri,new y.$mh(A.$scc,[!0],!0)),(0,R.$dr)(M.$8ac,k.$yec,0),(0,R.$dr)(d.$Sac,d.$Tac,0)}),define(Pe[283],Ae([1,0,25,5,79,270,262,19,87,12,2,273,275]),function(pe,e,y,R,I,M,A,d,k,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const D=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const u=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function b(n){return/^(file|vscode-remote):/i.test(n)}const p=fetch.bind(self);function h(n){self.fetch=async function(a,r){return a instanceof Request||b(String(a))&&(a=(await n(P.URI.parse(String(a)))).toString(!0)),p(a,r)},self.XMLHttpRequest=class extends XMLHttpRequest{open(a,r,s,v,$){(async()=>(b(r.toString())&&(r=(await n(P.URI.parse(r.toString()))).toString(!0)),super.open(a,r,s??!0,v,$)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const n=self.Worker;Worker=function(a,r){if(/^file:/i.test(a.toString()))a=f.$1e.uriToBrowserUri(P.URI.parse(a.toString())).toString(!0);else if(/^vscode-remote:/i.test(a.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const v=`(${function(o){function l(W){return typeof W=="string"||W instanceof URL?String(W).replace(/^file:\/\//i,"vscode-file://vscode-app"):W}const m=fetch.bind(self);self.fetch=function(W,V){return W instanceof Request?m(W,V):m(l(W),V)},self.XMLHttpRequest=class extends XMLHttpRequest{open(W,V,B,j,U){return super.open(W,l(V),B??!0,j,U)}};const F=importScripts.bind(self);self.importScripts=(...W)=>{F(...W.map(l))},F(o)}.toString()}('${a}'))`;r=r||{},r.name=r.name||d.$_c(a.toString());const $=new Blob([v],{type:"application/javascript"}),w=URL.createObjectURL($);return new n(w,r)}}else self.Worker=class extends A.$zec{constructor(n,a){super(u,n,{name:d.$_c(n.toString()),...a})}};const t=new class{constructor(){this.pid=void 0}exit(n){D()}};class i{constructor(){const a=new MessageChannel,r=new R.$ec;let s=!1;u(a.port2,[a.port2]),a.port1.onmessage=v=>{const{data:$}=v;if(!($ instanceof ArrayBuffer)){console.warn("UNKNOWN data received",$);return}const w=y.$Ec.wrap(new Uint8Array($,0,$.byteLength));if((0,I.$Rl)(w,2)){s=!0,g("received terminate message from renderer");return}r.fire(w)},this.protocol={onMessage:r.event,send:v=>{if(!s){const $=v.buffer.buffer.slice(v.buffer.byteOffset,v.buffer.byteOffset+v.buffer.byteLength);a.port1.postMessage($,[$])}}}}}function c(n){return new Promise(a=>{const r=n.onMessage(s=>{r.dispose();const v=JSON.parse(s.toString());n.send((0,I.$Ql)(0)),a({protocol:n,initData:v})});n.send((0,I.$Ql)(1))})}let g=n=>D();function S(n){return!!n&&typeof n=="object"&&n.type==="vscode.init"&&n.data instanceof Map}function C(){k.mark("code/extHost/willConnectToRenderer");const n=new i;return{onmessage(a){S(a)&&c(n.protocol).then(r=>{k.mark("code/extHost/didWaitForInitData");const s=new M.$vcc(r.protocol,r.initData,t,null,a.data);h(v=>s.asBrowserUri(v)),g=v=>s.terminate(v)})}}}e.create=C})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/abd2f3db4bdb28f9e95536dfa84d8479f1eb312d/core/vs/workbench/api/worker/extensionHostWorker.js.map
